* SUBROUTINE EAFU06             ALL SYSTEMS                 91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF TEST FUNCTIONS FOR NONLINEAR APPROXIMATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  FA  VALUE OF THE APPROXIMATED FUNCTION AT THE
*          SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAFU06(N,KA,X,FA,NEXT)
      INTEGER N,KA,NEXT
      $FLOAT X(N),FA
      $FLOAT T,X1,X2,X3,X4,X5,X6,X7,X8
      COMPLEX*16 CA(4),CB(4),C1,C2,C3
      $FLOAT XA(3),XB(3),XC(3),BETA
      INTEGER I,J
      $FLOAT Y(123),PI
      COMMON /EMPR06/ Y
      PARAMETER (PI=3.14159265358979323846$P 0)
      GOTO(10,190,180,80,20,170,120,90,230,210,140,150,200,30,130,100,
     & 40,110,50,60,70,220,160,240,250),NEXT
   10 X1=X(1)*X(1)
      X2=X(2)*X(2)
      X3=X(1)+X(1)
      X4=X(2)+X(2)
      GO TO (11,12,13),KA
   11 FA=X1+X2*X2
      RETURN
   12 FA=8.0$P 0-4.0$P 0*(X(1)+X(2))+X1+X2
      RETURN
   13 FA=2.0$P 0*EXP(X(2)-X(1))
      RETURN
  190 X1=1.0$P 1*X(1)/(X(1)+1.0$P-1)
      X2=2.0$P 0*X(2)**2
      IF (KA.EQ.1) THEN
      FA=0.5$P 0*( X(1)+X1+X2)
      ELSE IF (KA.EQ.2) THEN
      FA=0.5$P 0*(-X(1)+X1+X2)
      ELSE IF (KA.EQ.3) THEN
      FA=0.5$P 0*( X(1)-X1+X2)
      ENDIF
      RETURN
  180 X1=X(1)**2+X(2)**2
      X2=SQRT(X1)
      IF (KA.EQ.1) THEN
      FA=(X(1)-X2*COS(X2))**2+5.0D-3*X1
      ELSE IF (KA.EQ.2) THEN
      FA=(X(2)-X2*SIN(X2))**2+5.0D-3*X1
      ENDIF
      RETURN
   80 GO TO (81,82,83,84,85,86),KA
   81 FA=X(1)**2+X(2)**2+X(3)**2-1.0$P 0
      RETURN
   82 FA=X(1)**2+X(2)**2+(X(3)-2.0$P 0)**2
      RETURN
   83 FA=X(1)+X(2)+X(3)-1.0$P 0
      RETURN
   84 FA=X(1)+X(2)-X(3)+1.0$P 0
      RETURN
   85 FA=2.0$P 0*(X(1)**3+3.0$P 0*X(2)**2+(5.0$P 0*X(3)-X(1)+1.0$P 0)**2)
      RETURN
   86 FA=X(1)**2-9.0$P 0*X(3)
      RETURN
   20 X1=X(1)*X(1)
      X2=X(2)*X(2)
      X3=X(3)*X(3)
      X4=X(4)*X(4)
      X5=X(1)+X(1)
      X6=X(2)+X(2)
      X7=X(3)+X(3)
      X8=X(4)+X(4)
      FA=X1+X2+X3+X3+X4-5.0$P 0*(X(1)+X(2))-2.1$P 1*X(3)+7.0$P 0*X(4)
      GO TO (31,22,23,24),KA
   22 FA=FA+1.0$P 1*(X1+X2+X3+X4+X(1)-X(2)+X(3)-X(4)-8.0$P 0)
      RETURN
   23 FA=FA+1.0$P 1*(X1+X2+X2+X3+X4+X4-X(1)-X(4)-1.0$P 1)
      RETURN
   24 FA=FA+1.0$P 1*(X1+X2+X3+X5-X(2)-X(4)-5.0$P 0)
      RETURN
  170 X1=X(1)-(X(4)+1.0$P 0)**4
      X2=X1*X1
      X3=X(2)-X2*X2
      X4=X3*X3
      FA=X2+X4+2.0$P 0*X(3)**2+X(4)**2-5.0$P 0*(X1+X3)-2.1$P 1*X(3)+
     * 7.0$P 0*X(4)
      GO TO (171,172,173,174),KA
  171 CONTINUE
      RETURN
  172 FA=FA+1.0$P 1*(X2+X4+X(3)**2+X(4)**2+X1-X3+X(3)-X(4)-8.0$P 0)
      RETURN
  173 FA=FA+1.0$P 1*(X2+2.0$P 0*X4+X(3)**2+2.0$P 0*X(4)**2-X1-X(4)-
     * 1.0$P 1)
      RETURN
  174 FA=FA+1.0$P 1*(X2+X4+X(3)**2+2.0$P 0*X1-X3-X(4)-5.0$P 0)
      RETURN
  120 T=Y(KA)
      FA=(X(3)/X(2))*EXP(-X(1)*T)*SIN(X(2)*T)-Y(KA+21)
      RETURN
   90 FA=Y(KA)-X(1)-$DBLE(KA)/($DBLE(16-KA)*X(2)+$DBLE(MIN(KA,16-KA))*
     & X(3))
      RETURN
  230 T=Y(KA+11)
      FA=Y(KA)-X(1)*T*(T+X(2))/((T+X(3))*T+X(4))
      RETURN
  210 T=0.2$P 0*$DBLE(KA)
      FA=(X(1)+X(2)*T-EXP(T))**2+(X(3)+X(4)*SIN(T)-COS(T))**2
      RETURN
  140 T=Y(KA)
      FA=X(4)-((X(1)*T+X(2))*T+X(3))**2-Y(KA+21)
      RETURN
  150 T=Y(KA)
      FA=X(1)*EXP(X(3)*T)+X(2)*EXP(X(4)*T)-Y(KA+21)
      RETURN
  200 T=Y(KA)
      FA=X(1)*ABS((T+X(2)+1.0$P 0/(X(3)*T+X(4)))/((T+1.0$P 0)*Y(61+KA)))
     & **(T+5.0$P-1)-1.0$P 0
      RETURN
   30 T=0.1$P 0*$DBLE(KA-1)-1.0$P 0
      X1=X(1)+T*X(2)
      X2=1.0$P 0/(1.0$P 0+T*(X(3)+T*(X(4)+T*X(5))))
      X3=X1*X2-EXP(T)
      FA=X3
   31 RETURN
  130 T=Y(KA)
      FA=(X(1)+T*(X(2)+T*X(3)))/(1.0D 0+T*(X(4)+T*X(5)))-Y(KA+30)
      RETURN
  100 T=0.1$P 0*$DBLE(KA-1)
      FA=X(1)*EXP(-X(2)*T)*COS(X(3)*T+X(4))+X(5)*EXP(-X(6)*T)-Y(KA)
      RETURN
   40 BETA=0.5$P 0*PI*Y(KA)
      DO 41 I=1,3
      J=I+I
      XA(I)=X(J-1)
      XB(I)=X(J)
   41 CONTINUE
      CA(4)=CMPLX(1.0$P 0,0.0$P 0)
      CB(4)=1.0$P 1*CA(4)
      DO 42 J=1,3
      I=4-J
      XC(I)=BETA*XA(I)
      T=XC(I)
      X1=COS(T)
      X2=SIN(T)
      C1=CMPLX(X1,0.0$P 0)
      C2=CMPLX(0.0$P 0,(X2*XB(I)))
      C3=CMPLX(0.0$P 0,(X2/XB(I)))
      CB(I)=C1*CB(I+1)+C2*CA(I+1)
      CA(I)=C3*CB(I+1)+C1*CA(I+1)
   42 CONTINUE
      C1=-CA(1)
      C2=CB(1)-C1
      C3=1.0$P 0+2.0$P 0*C1/C2
      FA=ABS(C3)
      RETURN
  110 T=Y(41+KA)
      BETA=Y(82+KA)
      X1=(X(1)+(1$P 0+X(2))*T)**2+((1$P 0-X(2))*BETA)**2
      X2=(X(3)+(1$P 0+X(4))*T)**2+((1$P 0-X(4))*BETA)**2
      X3=(X(5)+(1$P 0+X(6))*T)**2+((1$P 0-X(6))*BETA)**2
      X4=(X(7)+(1$P 0+X(8))*T)**2+((1$P 0-X(8))*BETA)**2
      IF(X2.EQ.0$P 0)X2=1$P-30
      IF(X4.EQ.0$P 0)X4=1$P-30
      FA=X(9)*SQRT(X1/X2)*SQRT(X3/X4)-ABS(1$P 0-2$P 0*Y(KA))
      RETURN
   50 FA=(X(1)-1.0$P 1)**2+5.0$P 0*(X(2)-1.2$P 1)**2+X(3)**4+3.0$P 0*
     &(X(4)-1.1$P 1)**2+1.0$P 1*X(5)**6+7.0$P 0*X(6)**2+X(7)**4-4.0$P 0*
     &X(6)*X(7)-1.0$P 1*X(6)-8.0$P 0*X(7)
      GO TO (31,52,53,54,55),KA
   52 FA=FA+1.0$P 1*(2.0$P 0*X(1)**2+3.0$P 0*X(2)**4+X(3)+
     &4.0$P 0*X(4)**2+5.0$P 0*X(5)-1.27$P 2)
      RETURN
   53 FA=FA+1.0$P 1*(7.0$P 0*X(1)+3.0$P 0*X(2)+1.0$P 1*X(3)**2+X(4)-
     &X(5)-2.82$P 2)
      RETURN
   54 FA=FA+1.0$P 1*(2.3$P 1*X(1)+X(2)**2+6.0$P 0*X(6)**2-8.0$P 0*X(7)-
     &1.96$P 2)
      RETURN
   55 FA=FA+1.0$P 1*(4.0$P 0*X(1)**2+X(2)**2-3.0$P 0*X(1)*X(2)+2.0$P 0*
     &X(3)**2+5.0$P 0*X(6)-1.1$P 1*X(7))
      RETURN
   60 FA=X(1)**2+X(2)**2+X(1)*X(2)-1.4$P 1*X(1)-1.6$P 1*X(2)+
     &(X(3)-1.0$P 1)**2+4.0$P 0*(X(4)-5.0$P 0)**2+(X(5)-3.0$P 0)**2+
     &2.0$P 0*(X(6)-1.0$P 0)**2+5.0$P 0*X(7)**2+7.0$P 0*(X(8)-
     &1.1$P 1)**2+2.0$P 0*(X(9)-1.0$P 1)**2+(X(10)-7.0$P 0)**2+4.5$P 1
      GO TO (31,62,63,64,65,66,67,68,69),KA
   62 FA=FA+1.0$P 1*(3.0$P 0*(X(1)-2.0$P 0)**2+4.0$P 0*(X(2)-
     &3.0$P 0)**2+2.0$P 0*X(3)**2-7.0$P 0*X(4)-1.2$P 2)
      RETURN
   63 FA=FA+1.0$P 1*(5.0$P 0*X(1)**2+8.0$P 0*X(2)+(X(3)-6.0$P 0)**2-
     &2.0$P 0*X(4)-4.0$P 1)
      RETURN
   64 FA=FA+1.0$P 1*(0.5$P 0*(X(1)-8.0$P 0)**2+2.0$P 0*(X(2)-
     &4.0$P 0)**2+3.0$P 0*X(5)**2-X(6)-3.0$P 1)
      RETURN
   65 FA=FA+1.0$P 1*(X(1)**2+2.0$P 0*(X(2)-2.0$P 0)**2-
     &2.0$P 0*X(1)*X(2)+1.4$P 1*X(5)-6.0$P 0*X(6))
      RETURN
   66 FA=FA+1.0$P 1*(4.0$P 0*X(1)+5.0$P 0*X(2)-3.0$P 0*X(7)+
     &9.0$P 0*X(8)-1.05$P 2)
      RETURN
   67 FA=FA+1.0$P 1*(1.0$P 1*X(1)-8.0$P 0*X(2)-1.7$P 1*X(7)+
     &2.0$P 0*X(8))
      RETURN
   68 FA=FA+1.0$P 1*(6.0$P 0*X(2)-3.0$P 0*X(1)+1.2$P 1*(X(9)-
     &8.0$P 0)**2-7.0$P 0*X(10))
      RETURN
   69 FA=FA+1.0$P 1*(2.0$P 0*X(2)-8.0$P 0*X(1)+5.0$P 0*X(9)-
     &2.0$P 0*X(10)-1.2$P 1)
      RETURN
   70 FA=X(1)**2+X(2)**2+X(1)*X(2)-1.4$P 1*X(1)-1.6$P 1*X(2)+(X(3)-
     &1.0$P 1)**2+4.0$P 0*(X(4)-5.0$P 0)**2+(X(5)-3.0$P 0)**2+2.0$P 0*
     &(X(6)-1.0$P 0)**2+5.0$P 0*X(7)**2+7.0$P 0*(X(8)-1.1$P 1)**2+
     &2.0$P 0*(X(9)-1.0$P 1)**2+(X(10)-7.0$P 0)**2+(X(11)-9.0$P 0)**2+
     &1.0$P 1*(X(12)-1.0$P 0)**2+5.0$P 0*(X(13)-7.0$P 0)**2+4.0$P 0*
     &(X(14)-1.4$P 1)**2+2.7$P 1*(X(15)-1.0$P 0)**2+X(16)**4+(X(17)-
     &2.0$P 0)**2+1.3$P 1*(X(18)-2.0$P 0)**2+(X(19)-3.$P 0)**2+X(20)**2+
     &9.5$P 1
      GO TO (31,62,63,64,65,66,67,68,69,72,73,74,75,76,77,78,79,89),KA
   72 FA=FA+1.0$P 1*(X(1)+X(2)+4.0$P 0*X(11)-2.1$P 1*X(12))
      RETURN
   73 FA=FA+1.0$P 1*(X(1)**2+1.5$P 1*X(11)-8.0$P 0*X(12)-2.8$P 1)
      RETURN
   74 FA=FA+1.0$P 1*(4.0$P 0*X(1)+9.0$P 0*X(2)+5.0$P 0*X(13)**2-9.0$P 0*
     &X(14)-8.7$P 1)
      RETURN
   75 FA=FA+1.0$P 1*(3.0$P 0*X(1)+4.0$P 0*X(2)+3.0$P 0*(X(13)-
     16.0$P 0)**2-1.4$P 1*X(14)-1.0$P 1)
      RETURN
   76 FA=FA+1.0$P 1*(1.4$P 1*X(1)**2+3.5$P 1*X(15)-7.9$P 1*X(16)-
     &9.2$P 1)
      RETURN
   77 FA=FA+1.0$P 1*(1.5$P 1*X(2)**2+1.1$P 1*X(15)-6.1$P 1*X(16)-
     &5.4$P 1)
      RETURN
   78 FA=FA+1.0$P 1*(5.0$P 0*X(1)**2+2.0$P 0*X(2)+9.0$P 0*X(17)**4-
     &X(18)-6.8$P 1)
      RETURN
   79 FA=FA+1.0$P 1*(X(1)**2-X(2)+1.9$P 1*X(19)-2.0$P 1*X(20)+1.9$P 1)
      RETURN
   89 FA=FA+1.0$P 1*(7.0$P 0*X(1)**2+5.0$P 0*X(2)**2+X(19)**2-3.0$P 1*
     &X(20))
      RETURN
  220 X1=0.0$P 0
      DO 221 I=1,N
      X3=1.0$P 0
      X4=X(I)
      IF (I.EQ.1) X3=1.0$P-8
      IF (I.EQ.4) X3=4.0$P 0
      IF (I.EQ.2.AND.KA.EQ.1) X4=X(I)+2.0$P 0
      IF (I.EQ.2.AND.KA.EQ.2) X4=X(I)-2.0$P 0
      X1=X1+X3*X4**2
  221 CONTINUE
      FA=EXP(X1)
      RETURN
  160 FA=0.0$P 0
      DO 161 I=1,N
      X1=1.0$P 0*$DBLE(I+KA-1)
      X2=X(I)-SIN($DBLE(2*I+KA-3))
      FA=FA+X1*EXP(X2**2)
  161 CONTINUE
      RETURN
  240 IF (KA.EQ.1) THEN
      FA=X(1)
      ELSE IF (KA.EQ.2) THEN
      FA=X(2)-X(1)**2-1.0$P 0
      ELSE
      T=$DBLE(KA-2)/2.9$P 1
      X1=0.0$P 0
      X2=X(1)
      DO 241 I=2,N
      X1=X1+$DBLE(I-1)*X(I)*T**(I-2)
      X2=X2+X(I)*T**(I-1)
  241 CONTINUE
      FA=X1-X2**2-1.0$P 0
      ENDIF
      RETURN
  250 T=1.0$P-1*$DBLE(KA-1)
      FA=Y(KA)-X(1)*EXP(-X(5)*T)-X(2)*EXP(-X(6)*(T-X(9))**2)-
     & X(3)*EXP(-X(7)*(T-X(10))**2)-X(4)*EXP(-X(8)*(T-X(11))**2)
      RETURN
      END
