* SUBROUTINE EAFU18             ALL SYSTEMS                 92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF TEST FUNCTIONS FOR NONLINEAR EQUATIONS.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  FA  VALUE OF THE APPROXIMATED FUNCTION AT THE
*          SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAFU18(N,KA,X,FA,NEXT)
      INTEGER N,KA,NEXT
      $FLOAT X(N),FA
      INTEGER I,J,K,L,M,I1,I2,J1,J2,N1,ND,LA
      $FLOAT A,B,A1,A2,A3,A4,AL,AL1,AL2,FF,H,PAR,PI,BE,BE1,BE2,CA,CB,
     & GA,H2,S,S1,S2,S3,T,U
      COMMON /EMPR18/ PAR,M
      PI=3.14159265358979323846D 0
      GOTO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     & 170,180,190,200,210,220,230,240,250,260,270,280,290,300,320,
     & 310,420,430,440,450,470,480,490,500,520,530,540,550),
     & NEXT
   10 A2=0.5$P 0
      IF (KA.EQ.1) THEN
      FA=A2-(1.0$P 0-A2)*X(3)-X(1)*(1.0$P 0+4.0$P 0*X(2))
      ELSEIF(KA.EQ.2) THEN
      FA=-(2.0$P 0-A2)*X(4)-X(2)*(1.0$P 0+4.0$P 0*X(1))
      ELSEIF(KA.EQ.N-1) THEN
      FA=A2*X(N-3)-X(N-1)*(1.0$P 0+4.0$P 0*X(N))
      ELSEIF (KA.EQ.N) THEN
      FA=A2*X(N-2)-(2.0$P 0-A2)-X(N)*(1.0$P 0+4.0$P 0*X(N-1))
      ELSEIF (MOD(KA,2).EQ.1) THEN
      FA=A2*X(KA-2)-(1.0$P 0-A2)*X(KA+2)-
     & X(KA)*(1.0$P 0+4.0$P 0*X(KA+1))
      ELSE
      FA=A2*X(KA-2)-(2.0$P 0-A2)*X(KA+2)-
     & X(KA)*(1.0$P 0+4.0$P 0*X(KA-1))
      ENDIF
      RETURN
   20 A1=0.414214$P 0
      IF (KA.EQ.1) THEN
      FA=X(1)-(1.0$P 0-X(1))*X(3)-A1*(1.0$P 0+4.0$P 0*X(2))
      ELSEIF (KA.EQ.2) THEN
      FA=-(1.0$P 0-X(1))*X(4)-A1*(1.0$P 0+4.0$P 0*X(2))
      ELSEIF (KA.EQ.3) THEN
      FA=A1*X(1)-(1.0$P 0-X(1))*X(5)-X(3)*(1.0$P 0+4.0$P 0*X(2))
      ELSEIF (KA.LE.N-2) THEN
      FA=X(1)*X(KA-2)-(1.0$P 0-X(1))*X(KA+2)-
     & X(KA)*(1.0$P 0+4.0$P 0*X(KA-1))
      ELSEIF (KA.EQ.N-1) THEN
      FA=X(1)*X(N-3)-X(N-1)*(1.0$P 0+4.0$P 0*X(N-2))
      ELSE
      FA=X(1)*X(N-2)-(1.0$P 0-X(1))-X(N)*(1.0$P 0+4.0$P 0*X(N-1))
      ENDIF
      RETURN
   30 J=(KA-1)/5
      FA=5.0$P 0-$DBLE(J+1)*(1.0$P 0-COS(X(KA)))-SIN(X(KA))
      J=J*5
      DO 31 I=J+1,J+5
      FA=FA-COS(X(I))
   31 CONTINUE
      RETURN
   40 IF (KA.LT.2) THEN
      FA=3.0$P 0*X(KA)**3+2.0$P 0*X(KA+1)-5.0$P 0+
     & SIN(X(KA)-X(KA+1))*SIN(X(KA)+X(KA+1))
      ELSEIF (KA.LT.N) THEN
      FA=3.0$P 0*X(KA)**3+2.0$P 0*X(KA+1)-5.0$P 0+
     & SIN(X(KA)-X(KA+1))*SIN(X(KA)+X(KA+1))+4.0$P 0*X(KA)-
     & X(KA-1)*EXP(X(KA-1)-X(KA))-3.0$P 0
      ELSE
      FA=4.0$P 0*X(KA)-X(KA-1)*EXP(X(KA-1)-X(KA))-3.0$P 0
      ENDIF
      RETURN
   50 IF (MOD(KA,2).EQ.1) THEN
      FA=0.0$P 0
      IF (KA.NE.1) FA=FA-6.0$P 0*(X(KA-2)-X(KA))**3+1.0$P 1-
     & 4.0$P 0*X(KA-1)-2.0$P 0*SIN(X(KA-2)-X(KA-1)-X(KA))*
     & SIN(X(KA-2)+X(KA-1)-X(KA))
      IF (KA.NE.N) FA=FA+3.0$P 0*(X(KA)-X(KA+2))**3-5.0$P 0+
     & 2.0$P 0*X(KA+1)+SIN(X(KA)-X(KA+1)-X(KA+2))*
     & SIN(X(KA)+X(KA+1)-X(KA+2))
      ELSE
      FA=4.0$P 0*X(KA)-(X(KA-1)-X(KA+1))*EXP(X(KA-1)-X(KA)-X(KA+1))-
     & 3.0$P 0
      ENDIF
      RETURN
   60 H=2.0$P 0
      IF (KA.EQ.1) THEN
      FA=((3.0$P 0-H*X(1))*X(1)-2.0$P 0*X(2)+1.0$P 0)**2
      ELSEIF (KA.LE.N-1) THEN
      FA=((3.0$P 0-H*X(KA))*X(KA)-X(KA-1)-2.0$P 0*X(KA+1)+1.0$P 0)**2
      ELSE
      FA=((3.0$P 0-H*X(N))*X(N)-X(N-1)+1.0$P 0)**2
      ENDIF
      RETURN
   70 IF (KA.LT.2) THEN
      FA=4.0$P 0*(X(KA)-X(KA+1)**2)
      ELSEIF (KA.LT.N) THEN
      FA=8.0$P 0*X(KA)*(X(KA)**2-X(KA-1))-2.0$P 0*(1.0$P 0-X(KA))+
     & 4.0$P 0*(X(KA)-X(KA+1)**2)
      ELSE
      FA=8.0$P 0*X(KA)*(X(KA)**2-X(KA-1))-2.0$P 0*(1.0$P 0-X(KA))
      ENDIF
      RETURN
   80 IF (KA.LT.2) THEN
      FA=4.0$P 0*(X(KA)-X(KA+1)**2)+X(KA+1)-X(KA+2)**2
      ELSEIF (KA.LT.3) THEN
      FA=8.0$P 0*X(KA)*(X(KA)**2-X(KA-1))-2.0$P 0*(1.0$P 0-X(KA))+
     & 4.0$P 0*(X(KA)-X(KA+1)**2)+X(KA+1)-X(KA+2)**2
      ELSEIF (KA.LT.N-1) THEN
      FA=8.0$P 0*X(KA)*(X(KA)**2-X(KA-1))-2.0$P 0*(1.0$P 0-X(KA))+
     & 4.0$P 0*(X(KA)-X(KA+1)**2)+X(KA-1)**2-X(KA-2)+X(KA+1)-
     & X(KA+2)**2
      ELSEIF (KA.LT.N) THEN
      FA=8.0$P 0*X(KA)*(X(KA)**2-X(KA-1))-2.0$P 0*(1.0$P 0-X(KA))+
     & 4.0$P 0*(X(KA)-X(KA+1)**2)+X(KA-1)**2-X(KA-2)
      ELSE
      FA=8.0$P 0*X(KA)*(X(KA)**2-X(KA-1))-2.0$P 0*(1.0$P 0-X(KA))
     & +X(KA-1)**2-X(KA-2)
      ENDIF
      RETURN
   90 IF (KA.LT.2) THEN
      FA=4.0$P 0*(X(KA)-X(KA+1)**2)+X(KA+1)-X(KA+2)**2+
     & X(KA+2)-X(KA+3)**2
      ELSEIF (KA.LT.3) THEN
      FA=8.0$P 0*X(KA)*(X(KA)**2-X(KA-1))-2.0$P 0*(1.0$P 0-X(KA))+
     & 4.0$P 0*(X(KA)-X(KA+1)**2)+X(KA-1)**2+X(KA+1)-X(KA+2)**2+
     & X(KA+2)-X(KA+3)**2
      ELSEIF (KA.LT.4) THEN
      FA=8.0$P 0*X(KA)*(X(KA)**2-X(KA-1))-2.0$P 0*(1.0$P 0-X(KA))+
     & 4.0$P 0*(X(KA)-X(KA+1)**2)+X(KA-1)**2-X(KA-2)+
     & X(KA+1)-X(KA+2)**2+X(KA-2)**2+X(KA+2)-X(KA+3)**2
      ELSEIF (KA.LT.N-2) THEN
      FA=8.0$P 0*X(KA)*(X(KA)**2-X(KA-1))-2.0$P 0*(1.0$P 0-X(KA))+
     & 4.0$P 0*(X(KA)-X(KA+1)**2)+X(KA-1)**2-X(KA-2)+
     & X(KA+1)-X(KA+2)**2+X(KA-2)**2-X(KA-3)+X(KA+2)-X(KA+3)**2
      ELSEIF (KA.LT.N-1) THEN
      FA=8.0$P 0*X(KA)*(X(KA)**2-X(KA-1))-2.0$P 0*(1.0$P 0-X(KA))+
     & 4.0$P 0*(X(KA)-X(KA+1)**2)+X(KA-1)**2-X(KA-2)+
     & X(KA+1)-X(KA+2)**2+X(KA-2)**2-X(KA-3)+X(KA+2)
      ELSEIF (KA.LT.N) THEN
      FA=8.0$P 0*X(KA)*(X(KA)**2-X(KA-1))-2.0$P 0*(1.0$P 0-X(KA))+
     & 4.0$P 0*(X(KA)-X(KA+1)**2)+X(KA-1)**2-X(KA-2)+
     & X(KA+1)+X(KA-2)**2-X(KA-3)
      ELSE
      FA=8.0$P 0*X(KA)*(X(KA)**2-X(KA-1))-2.0$P 0*(1.0$P 0-X(KA))
     & +X(KA-1)**2-X(KA-2)+X(KA-2)**2-X(KA-3)
      ENDIF
      RETURN
  100 IF (KA.EQ.1) THEN
      FA=-2.0$P 0*X(KA)**2+3.0$P 0*X(KA)-2.0$P 0*X(KA+1)+
     & 3.0$P 0*X(N-4)-X(N-3)-X(N-2)+0.5$P 0*X(N-1)-X(N)+1.0$P 0
      ELSEIF (KA.LE.N-1) THEN
      FA=-2.0$P 0*X(KA)**2+3.0$P 0*X(KA)-X(KA-1)-2.0$P 0*X(KA+1)+
     & 3.0$P 0*X(N-4)-X(N-3)-X(N-2)+0.5$P 0*X(N-1)-X(N)+1.0$P 0
      ELSE
      FA=-2.0$P 0*X(N)**2+3.0$P 0*X(N)-X(N-1)+
     & 3.0$P 0*X(N-4)-X(N-3)-X(N-2)+0.5$P 0*X(N-1)-X(N)+1.0$P 0
      ENDIF
      RETURN
  110 IF(MOD(KA,2).EQ.1) THEN
      FA=X(KA)+((5.0$P 0-X(KA+1))*X(KA+1)-2.0$P 0)*X(KA+1)-1.3$P 1
      ELSE
      FA=X(KA-1)+((X(KA)+1.0$P 0)*X(KA)-1.4$P 1)*X(KA)-2.9$P 1
      ENDIF
      RETURN
  120 IF(MOD(KA,4).EQ.1) THEN
      FA=X(KA)+1.0$P 1*X(KA+1)
      ELSEIF(MOD(KA,4).EQ.2) THEN
      FA=2.23606797749979$P 0*(X(KA+1)-X(KA+2))
      ELSEIF(MOD(KA,4).EQ.3) THEN
      FA=(X(KA-1)-2.0$P 0*X(KA))**2
      ELSE
      FA=3.16227766016838$P 0*(X(KA-3)-X(KA))**2
      ENDIF
      RETURN
  130 IF(MOD(KA,4).EQ.1) THEN
      FA=(EXP(X(KA))-X(KA+1))**2
      ELSEIF (MOD(KA,4).EQ.2) THEN
      FA=1.0$P 1*(X(KA)-X(KA+1))**3
      ELSEIF (MOD(KA,4).EQ.3) THEN
      FA=X(KA)-X(KA+1)
      FA=(SIN(FA)/COS(FA))**2
      ELSE
      FA=X(KA)-1.0$P 0
      ENDIF
      RETURN
  140 IF(KA.LT.2) THEN
      FA=X(KA)*(0.5$P 0*X(KA)-3.0$P 0)-1.0$P 0+2.0$P 0*X(KA+1)
      ELSEIF (KA.LT.N) THEN
      FA=X(KA-1)+X(KA)*(0.5$P 0*X(KA)-3.0$P 0)-1.0$P 0+2.0$P 0*X(KA+1)
      ELSE
      FA=X(KA-1)+X(KA)*(0.5$P 0*X(KA)-3.0$P 0)-1.0$P 0
      ENDIF
      RETURN
  150 FA=(2.0$P 0+5.0$P 0*X(KA)**2)*X(KA)+1.0$P 0
      DO 151 I=MAX(1,KA-5),MIN(N,KA+1)
      FA=FA+X(I)*(1.0$P 0+X(I))
  151 CONTINUE
      RETURN
  160 IF(MOD(KA,2).EQ.1) THEN
      FA=1.0$P 4*X(KA)*X(KA+1)-1.0$P 0
      ELSE
      FA=EXP(-X(KA-1))+EXP(-X(KA))-1.0001$P 0
      ENDIF
      RETURN
  170 IF(MOD(KA,4).EQ.1) THEN
      FA=-2.0$P 2*X(KA)*(X(KA+1)-X(KA)**2)-(1.0$P 0-X(KA))
      ELSEIF(MOD(KA,4).EQ.2) THEN
      FA=2.0$P 2*(X(KA)-X(KA-1)**2)+2.02$P 1*(X(KA)-1.0$P 0)+
     &  1.98$P 1*(X(KA+2)-1.0$P 0)
      ELSEIF(MOD(KA,4).EQ.3) THEN
      FA=-1.8$P 2*X(KA)*(X(KA+1)-X(KA)**2)-(1.0$P 0-X(KA))
      ELSE
      FA=1.8$P 2*(X(KA)-X(KA-1)**2)+2.02$P 1*(X(KA)-1.0$P 0)+
     & 1.98$P 1*(X(KA-2)-1.0$P 0)
      ENDIF
      RETURN
  180 IF (KA.LT.2) THEN
      FA=X(KA)-EXP(COS($DBLE(KA)*(X(KA)+X(KA+1))))
      ELSEIF (KA.LT.N) THEN
      FA=X(KA)-EXP(COS($DBLE(KA)*(X(KA-1)+X(KA)+X(KA+1))))
      ELSE
      FA=X(KA)-EXP(COS($DBLE(KA)*(X(KA-1)+X(KA))))
      ENDIF
      RETURN
  190 A3=1.0$P 0/$DBLE(N+1)
      A4=$DBLE(KA)*A3
      FA=2.0$P 0*X(KA)+0.5$P 0*A3*A3*(X(KA)+A4+1.0$P 0)**3
      IF(KA.GT.1) FA=FA-X(KA-1)
      IF(KA.LT.N) FA=FA-X(KA+1)
      RETURN
  200 IF(KA.EQ.1) THEN
      FA=3.0$P 0*X(KA)*(X(KA+1)-2.0$P 0*X(KA))+0.25$P 0*X(KA+1)**2
      ELSEIF(KA.EQ.N) THEN
      FA=3.0$P 0*X(KA)*(2.0$P 1-2.0$P 0*X(KA)+X(KA-1))+
     & 0.25$P 0*(2.0$P 1-X(KA-1))**2
      ELSE
      FA=3.0$P 0*X(KA)*(X(KA+1)-2.0$P 0*X(KA)+X(KA-1))+
     & 0.25$P 0*(X(KA+1)-X(KA-1))**2
      ENDIF
      RETURN
  210 H=1.0$P 0/$DBLE(N+1)
      IF (KA.LT.2) THEN
      FA=2.0$P 0*X(KA)+PAR*H**2*SINH(PAR*X(KA))-X(KA+1)
      ELSE IF (KA.LT.N) THEN
      FA=2.0$P 0*X(KA)+PAR*H**2*SINH(PAR*X(KA))-X(KA-1)-X(KA+1)
      ELSE
      FA=2.0$P 0*X(KA)+PAR*H**2*SINH(PAR*X(KA))-X(KA-1)-1.0$P 0
      ENDIF
      RETURN
  220 FA=6.0$P 0*X(KA)
      A1=0.0$P 0
      A2=0.0$P 0
      A3=0.0$P 0
      IF (KA.GT.1) THEN
      FA=FA-4.0$P 0*X(KA-1)
      A1=A1-X(KA-1)
      A2=A2+X(KA-1)
      A3=A3+2.0$P 0*X(KA-1)
      ENDIF
      IF (KA.GT.2) THEN
      FA=FA+X(KA-2)
      A3=A3-X(KA-2)
      ENDIF
      IF (KA.LT.N-1) THEN
      FA=FA+X(KA+2)
      A3=A3+X(KA+2)
      ENDIF
      IF (KA.LT.N) THEN
      FA=FA-4.0$P 0*X(KA+1)
      A1=A1+X(KA+1)
      A2=A2+X(KA+1)
      A3=A3-2.0$P 0*X(KA+1)
      ENDIF
      IF (KA.GE.N-1) THEN
      FA=FA+1.0$P 0
      A3=A3+1.0$P 0
      ENDIF
      IF (KA.GE.N) THEN
      FA=FA-4.0$P 0
      A1=A1+1.0$P 0
      A2=A2+1.0$P 0
      A3=A3-2.0$P 0
      ENDIF
      FA=FA-0.5$P 0*PAR*(A1*A2-X(KA)*A3)
      RETURN
  230 H=1.0$P 0/$DBLE(M+1)
      IF(KA.LE.M) THEN
      J=KA+M
      FA=6.0$P 0*X(KA)
      A1=0.0$P 0
      A2=0.0$P 0
      IF (KA.EQ.1) THEN
      A1=A1+1.0$P 0
      ENDIF
      IF (KA.GT.1) THEN
      FA=FA-4.0$P 0*X(KA-1)
      A1=A1-X(J-1)
      A2=A2+2.0$P 0*X(KA-1)
      ENDIF
      IF (KA.GT.2) THEN
      FA=FA+X(KA-2)
      A2=A2-X(KA-2)
      ENDIF
      IF (KA.LT.M-1) THEN
      FA=FA+X(KA+2)
      A2=A2+X(KA+2)
      ENDIF
      IF (KA.LT.M) THEN
      FA=FA-4.0$P 0*X(KA+1)
      A1=A1+X(J+1)
      A2=A2-2.0$P 0*X(KA+1)
      ENDIF
      IF (KA.EQ.M) THEN
      A1=A1+1.0$P 0
      ENDIF
      FA=FA+0.5$P 0*PAR*H*(X(KA)*A2+X(J)*A1*H**2)
      ELSE
      J=KA-M
      FA=-2.0$P 0*X(KA)
      A1=0.0$P 0
      A2=0.0$P 0
      IF (J.EQ.1) THEN
      A2=A2+1.0$P 0
      ENDIF
      IF (J.GT.1) THEN
      FA=FA+X(KA-1)
      A1=A1-X(J-1)
      A2=A2-X(KA-1)
      ENDIF
      IF (J.LT.M) THEN
      FA=FA+X(KA+1)
      A1=A1+X(J+1)
      A2=A2+X(KA+1)
      ENDIF
      IF (J.EQ.M) THEN
      A2=A2+1.0$P 0
      ENDIF
      FA=FA+0.5$P 0*PAR*H*(X(KA)*A1+X(J)*A2)
      ENDIF
      RETURN
  240 FA=4.0$P 0*X(KA)-PAR*EXP(X(KA))
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      IF(I.GT.1) FA=FA-X(KA-1)
      IF(I.LT.M) FA=FA-X(KA+1)
      IF(J.GT.1) FA=FA-X(KA-M)
      IF(J.LT.M) FA=FA-X(KA+M)
      RETURN
  250 FA=4.0$P 0*X(KA)
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      FA=FA+PAR*X(KA)**3/(1.0$P 0+PAR*$DBLE(I)**2+
     & PAR*$DBLE(J)**2)
      IF(I.EQ.1) FA=FA-1.0$P 0
      IF(I.GT.1) FA=FA-X(KA-1)
      IF(I.LT.M) FA=FA-X(KA+1)
      IF(I.EQ.M) FA=FA-2.0$P 0+EXP($DBLE(J)/$DBLE(M+1))
      IF(J.EQ.1) FA=FA-1.0$P 0
      IF(J.GT.1) FA=FA-X(KA-M)
      IF(J.LT.M) FA=FA-X(KA+M)
      IF(J.EQ.M) FA=FA-2.0$P 0+EXP($DBLE(I)/$DBLE(M+1))
      RETURN
  260 FA=4.0$P 0*X(KA)-PAR*SIN(2.0$P 0*PI*X(KA))
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      A1=DBLE(I)/DBLE(M+1)
      A2=DBLE(J)/DBLE(M+1)
      FA=FA-1.0$P 4*((A1-0.25$P 0)**2+(A2-0.75$P 0)**2)*PAR
      IF(I.EQ.1) FA=FA-X(KA+1)-PAR*SIN(PI*X(KA+1)*DBLE(M+1))
      IF(I.GT.1.AND.I.LT.M) FA=FA-X(KA+1)-X(KA-1)-
     & PAR*SIN(PI*(X(KA+1)-X(KA-1))*DBLE(M+1))
      IF(I.EQ.M) FA=FA-X(KA-1)+PAR*SIN(PI*X(KA-1)*DBLE(M+1))
      IF(J.EQ.1) FA=FA-X(KA+M)-PAR*SIN(PI*X(KA+M)*DBLE(M+1))
      IF(J.GT.1.AND.J.LT.M) FA=FA-X(KA+M)-X(KA-M)-
     & PAR*SIN(PI*(X(KA+M)-X(KA-M))*DBLE(M+1))
      IF(J.EQ.M) FA=FA-X(KA-M)+PAR*SIN(PI*X(KA-M)*DBLE(M+1))
      RETURN
  270 FA=8.0$P 0*X(KA)**2
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      IF(I.EQ.1) FA=FA-2.0$P 0*X(KA)*(X(KA+1)+1.0$P 0)-
     & 0.5$P 0*(X(KA+1)-1.0$P 0)**2-
     & 1.5$P 0*X(KA)**2*(X(KA+1)-1.0$P 0)*PAR
      IF(I.GT.1.AND.I.LT.M) FA=FA-2.0$P 0*X(KA)*(X(KA+1)+X(KA-1))-
     & 0.5$P 0*(X(KA+1)-X(KA-1))**2-
     & 1.5$P 0*X(KA)**2*(X(KA+1)-X(KA-1))*PAR
      IF(I.EQ.M) FA=FA-2.0$P 0*X(KA)*X(KA-1)-
     & 0.5$P 0*X(KA-1)**2+
     & 1.5$P 0*X(KA)**2*X(KA-1)*PAR
      IF(J.EQ.1) FA=FA-2.0$P 0*X(KA)*(X(KA+M)+1.0$P 0)-
     & 0.5$P 0*(X(KA+M)-1.0$P 0)**2
      IF(J.GT.1.AND.J.LT.M) FA=FA-2.0$P 0*X(KA)*(X(KA+M)+X(KA-M))-
     & 0.5$P 0*(X(KA+M)-X(KA-M))**2
      IF(J.EQ.M) FA=FA-2.0$P 0*X(KA)*X(KA-M)-
     & 0.5$P 0*X(KA-M)**2
      IF (I.EQ.1.AND.J.EQ.1) FA=FA-PAR/$DBLE(M+1)
      RETURN
  280 FA=4.0$P 0*X(KA)
      A3=0.0$P 0
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      A1=PAR*DBLE(I)
      A2=PAR*DBLE(J)
      FA=FA-2.0$P 3*A1*A2*(1.0$P 0-A1)*(1.0$P 0-A2)*PAR**2
      IF(I.GT.1) THEN
      FA=FA-X(KA-1)
      A3=A3-X(KA-1)
      ENDIF
      IF(I.LT.M) THEN
      FA=FA-X(KA+1)
      A3=A3+X(KA+1)
      ENDIF
      IF(J.GT.1) THEN
      FA=FA-X(KA-M)
      A3=A3-X(KA-M)
      ENDIF
      IF(J.LT.M) THEN
      FA=FA-X(KA+M)
      A3=A3+X(KA+M)
      ENDIF
      FA=FA+2.0$P 1*PAR*A3*X(KA)
      RETURN
  290 FA=2.0$P 1*X(KA)-PAR*MAX(0.0$P 0,X(KA))
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      FA=FA-SIGN(PAR,(DBLE(I)/DBLE(M+2)-0.5$P 0))
      IF (J.GT.2) THEN
        FA=FA+X(KA-M-M)
      ENDIF
      IF (J.GT.1) THEN
        IF (I.GT.1) THEN
          FA=FA+2.0$P 0*X(KA-M-1)
        ENDIF
        FA=FA-8.0$P 0*X(KA-M)
        IF (I.LT.M) THEN
          FA=FA+2.0$P 0*X(KA-M+1)
        ENDIF
      ENDIF
      IF (I.GT.1) THEN
        IF (I.GT.2) THEN
          FA=FA+X(KA-2)
        ENDIF
        FA=FA-8.0$P 0*X(KA-1)
      ENDIF
      IF (I.LT.M) THEN
        FA=FA-8.0$P 0*X(KA+1)
        IF (I.LT.M-1) THEN
          FA=FA+X(KA+2)
        ENDIF
      ENDIF
      IF (J.LT.M) THEN
        IF (I.GT.1) THEN
          FA=FA+2.0$P 0*X(KA+M-1)
        ENDIF
        FA=FA-8.0$P 0*X(KA+M)
        IF (I.LT.M) THEN
          FA=FA+2.0$P 0*X(KA+M+1)
        ENDIF
      ENDIF
      IF (J.LT.M-1) THEN
        FA=FA+X(KA+M+M)
      ENDIF
      RETURN
  300 H=0.5$P 0/$DBLE(M+2)
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      FA=2.0$P 1*X(KA)
      A1=0.0$P 0
      A2=0.0$P 0
      A3=0.0$P 0
      A4=0.0$P 0
      IF (J.GT.2) THEN
        FA=FA+X(KA-M-M)
        A4=A4+X(KA-M-M)
      ENDIF
      IF (J.GT.1) THEN
        IF (I.GT.1) THEN
          FA=FA+2.0$P 0*X(KA-M-1)
          A3=A3+X(KA-M-1)
          A4=A4+X(KA-M-1)
        ENDIF
        FA=FA-8.0$P 0*X(KA-M)
        A1=A1-X(KA-M)
        A4=A4-4.0$P 0*X(KA-M)
        IF (I.LT.M) THEN
          FA=FA+2.0$P 0*X(KA-M+1)
          A3=A3-X(KA-M+1)
          A4=A4+X(KA-M+1)
        ENDIF
      ENDIF
      IF (I.GT.1) THEN
        IF (I.GT.2) THEN
          FA=FA+X(KA-2)
          A3=A3+X(KA-2)
        ENDIF
        FA=FA-8.0$P 0*X(KA-1)
        A2=A2-X(KA-1)
        A3=A3-4.0$P 0*X(KA-1)
      ENDIF
      IF (I.LT.M) THEN
        FA=FA-8.0$P 0*X(KA+1)
        A2=A2+X(KA+1)
        A3=A3+4.0$P 0*X(KA+1)
        IF (I.LT.M-1) THEN
          FA=FA+X(KA+2)
          A3=A3-X(KA+2)
        ENDIF
      ENDIF
      IF (J.LT.M) THEN
        IF (I.GT.1) THEN
          FA=FA+2.0$P 0*X(KA+M-1)
          A3=A3+X(KA+M-1)
          A4=A4-X(KA+M-1)
        ENDIF
        FA=FA-8.0$P 0*X(KA+M)
        A1=A1+X(KA+M)
        A4=A4+4.0$P 0*X(KA+M)
        IF (I.LT.M) THEN
          FA=FA+2.0$P 0*X(KA+M+1)
          A3=A3-X(KA+M+1)
          A4=A4-X(KA+M+1)
        ENDIF
      ENDIF
      IF (J.LT.M-1) THEN
        FA=FA+X(KA+M+M)
        A4=A4-X(KA+M+M)
      ENDIF
      IF (J.EQ.M) THEN
        IF (I.GT.1) THEN
          FA=FA-H-H
          A3=A3-H
          A4=A4+H
        ENDIF
        FA=FA+8.0$P 0*H
        A1=A1-H
        A4=A4-4.0$P 0*H
        IF (I.LT.M) THEN
          FA=FA-2.0$P 0*H
          A3=A3+H
          A4=A4+H
        ENDIF
        FA=FA+H
        A4=A4-H
      ENDIF
      IF (J.EQ.M-1) THEN
        FA=FA-H
        A4=A4+H
      ENDIF
      FA=FA+0.25$P 0*PAR*(A1*A3-A2*A4)
      RETURN
  310 H=1.0$P 0/$DBLE(N+1)
      A1=$DBLE(KA)*H
      A2=(A1-0.5$P 0)**2
      IF (A1.GE.0.5$P 0) THEN
      A3= 1.0$P 6
      ELSE
      A3=-1.0$P 6
      ENDIF
      IF (KA.LT.2) THEN
      FA=2.0$P 0*X(KA)-X(KA+1)+H**2*(X(KA)**3*EXP(X(KA))+
     & 5.0$P 8*EXP(-1.0$P 4*A2)*SQRT(ABS(A1-0.5$P 0))*X(KA+1)+A3)
      ELSEIF (KA.LT.N) THEN
      FA=2.0$P 0*X(KA)-X(KA+1)-X(KA-1)+H**2*(X(KA)**3*EXP(X(KA))+
     & 5.0$P 8*EXP(-1.0$P 4*A2)*SQRT(ABS(A1-0.5$P 0))*(X(KA+1)-X(KA-1))+
     & A3)
      ELSE
      FA=2.0$P 0*X(KA)-X(KA-1)+H**2*(X(KA)**3*EXP(X(KA))-
     & 5.0$P 8*EXP(-1.0$P 4*A2)*SQRT(ABS(A1-0.5$P 0))*X(KA-1)-A3)
      ENDIF
      RETURN
  320 H=1.0$P 0/$DBLE(N+1)
      A1=$DBLE(KA)*H
      A2=(A1-0.5$P 0)**2
      IF (KA.LT.2) THEN
      FA=2.0$P 0*X(KA)-X(KA+1)+H**2*(X(KA)**3+
     & 2.0$P-4*(2.0$P-4*A2-1.0$P 0)*X(KA)-1.0$P 9*EXP(-3.0$P 4*A2))
      ELSEIF (KA.LT.N) THEN
      FA=2.0$P 0*X(KA)-X(KA+1)-X(KA-1)+H**2*(X(KA)**3+
     & 2.0$P-4*(2.0$P-4*A2-1.0$P 0)*X(KA)-1.0$P 9*EXP(-3.0$P 4*A2))
      ELSE
      FA=2.0$P 0*X(KA)-X(KA-1)+H**2*(X(KA)**3+
     & 2.0$P-4*(2.0$P-4*A2-1.0$P 0)*X(KA)-1.0$P 9*EXP(-3.0$P 4*A2))
      ENDIF
      RETURN
  410 IF (KA.EQ.1) THEN
      FA=1.0D 0-X(1)
      ELSE
      FA=10.0D 0*DBLE(KA-1)*(X(KA)-X(KA-1))**2
      ENDIF
      RETURN
  420 IF (KA.EQ.N) THEN
      FA=X(KA)-0.1D 0*X(1)**2
      ELSE
      FA=X(KA)-0.1D 0*X(KA+1)**2
      ENDIF
      RETURN
  430 S=(1.0D 0/DBLE(N+1))**2*EXP(X(KA))
      IF (N.EQ.1) THEN
      FA=-2.0D 0*X(KA)-S
      ELSE IF (KA.EQ.1) THEN
      FA=-2.0D 0*X(KA)+X(KA+1)-S
      ELSE IF (KA.EQ.N) THEN
      FA=X(KA-1)-2.0D 0*X(KA)-S
      ELSE
      FA=X(KA-1)-2.0D 0*X(KA)+X(KA+1)-S
      ENDIF
      RETURN
  440 S=0.1D 0
      IF (N.EQ.1) THEN
      FA=(3.0D 0-S*X(KA))*X(KA)+1.0D 0
      ELSE IF (KA.EQ.1) THEN
      FA=(3.0D 0-S*X(KA))*X(KA)+1.0D 0-2.0D 0*X(KA+1)
      ELSE IF (KA.EQ.N) THEN
      FA=(3.0D 0-S*X(KA))*X(KA)+1.0D 0-X(KA-1)
      ELSE
      FA=(3.0D 0-S*X(KA))*X(KA)+1.0D 0-X(KA-1)-2.0D 0*X(KA+1)
      ENDIF
      RETURN
  450 S1=1.0D 0
      S2=1.0D 0
      S3=1.0D 0
      J1=3
      J2=3
      IF (KA-J1.GT.1) THEN
      I1=KA-J1
      ELSE
      I1=1
      ENDIF
      IF (KA+J2.LT.N) THEN
      I2=KA+J2
      ELSE
      I2=N
      ENDIF
      S=0.0D 0
      DO 451 J=I1,I2
      IF(J.NE.KA) S=S+X(J)+X(J)**2
  451 CONTINUE
      FA=(S1+S2*X(KA)**2)*X(KA)+1.D 0-S3*S
      RETURN
  460 IF (KA.EQ.1) THEN
      FA=X(1)**2-1.0D 0
      ELSE
      FA=X(KA-1)**2+LOG(X(KA))-1.0D 0
      ENDIF
      RETURN
  470 IF(KA.EQ.1) THEN
      FA=X(1)
      ELSE
      FA=COS(X(KA-1))+X(KA)-1.0D 0
      ENDIF
      RETURN
  480 S=(1.0D 0/DBLE(N+1))**2
      IF (N.EQ.1) THEN
      FA=2.0D 0*X(KA)-1.0D 0+S*(X(KA)+SIN(X(KA)))
      ELSE IF (KA.EQ.1) THEN
      FA=2.0D 0*X(KA)-X(KA+1)+S*(X(KA)+SIN(X(KA)))
      ELSE IF (KA.EQ.N) THEN
      FA=-X(KA-1)+2.0D 0*X(KA)-1.0D 0+S*(X(KA)+SIN(X(KA)))
      ELSE
      FA=-X(KA-1)+2.0D 0*X(KA)-X(KA+1)+S*(X(KA)+SIN(X(KA)))
      ENDIF
      RETURN
  490 IF (KA-5.GT.1) THEN
      I1=KA-5
      ELSE
      I1=1
      ENDIF
      IF (KA+1.LT.N) THEN
      I2=KA+1
      ELSE
      I2=N
      ENDIF
      S=0.0D 0
      DO 491 J=I1,I2
      IF (J.NE.KA) S=S+X(J)*(1.0D 0+X(J))
  491 CONTINUE
      FA=X(KA)*(2.0D 0+5.0D 0*X(KA)**2)+1.0D 0-S
      RETURN
  500 H=1.0D 0/DBLE(N+1)
      T=2.0D 0*H**2
      IF (KA.EQ.1) THEN
      FA=2.0D 0*X(KA)-X(KA+1)-T*X(KA)**2-H*X(KA+1)
      ELSE IF (1.LT.KA.AND.KA.LT.N) THEN
      FA=-X(KA-1)+2.0D 0*X(KA)-X(KA+1)-T*X(KA)**2-H*(X(KA+1)-X(KA-1))
      ELSE IF (KA.EQ.N) THEN
      FA=-X(KA-1)+2.0D 0*X(KA)-0.5D 0-T*X(KA)**2-H*(0.5D 0-X(KA-1))
      ENDIF
      RETURN
  520 A=-9.0D-3
      B=1.0D-3
      AL=0.0D 0
      BE=25.0D 0
      GA=20.0D 0
      CA=0.3D 0
      CB=0.3D 0
      H=(B-A)/DBLE(N+1)
      T=A+DBLE(KA)*H
      H=H**2
      S=DBLE(KA)/DBLE(N+1)
      U=AL*(1.0D 0-S)+BE*S+X(KA)
      FF=CB*EXP(GA*(U-BE))-CA*EXP(GA*(AL-U))
      IF (T.LE.0) THEN
      FF=FF+CA
      ELSE
      FF=FF-CB
      ENDIF
      IF (N.EQ.1) THEN
      FA=-AL+2.0D 0*X(KA)-BE+H*FF
      ELSE IF (KA.EQ.1) THEN
      FA=-AL+2.0D 0*X(KA)-X(KA+1)+H*FF
      ELSE IF (KA.LT.N) THEN
      FA=-X(KA-1)+2.0D 0*X(KA)-X(KA+1)+H*FF
      ELSE
      FA=-X(KA-1)+2.0D 0*X(KA)-BE+H*FF
      ENDIF
      RETURN
  530 AL1=0.0D 0
      AL2=0.0D 0
      BE1=0.0D 0
      BE2=0.0D 0
      N1=N/2
      H=1.0D 0/DBLE(N1+1)
      T=DBLE(KA)*H
      IF (KA.EQ.1) THEN
      S1=2.0D 0*X(KA)-X(KA+1)
      B=AL1
      ELSE IF (KA.EQ.N1+1) THEN
      S1=2.0D 0*X(KA)-X(KA+1)
      B=AL2
      ELSE IF ( KA.EQ.N1) THEN
      S1=-X(KA-1)+2.0D 0*X(KA)
      B=BE1
      ELSE IF (KA.EQ.N) THEN
      S1=-X(KA-1)+2.0D 0*X(KA)
      B=BE2
      ELSE
      S1=-X(KA-1)+2.0D 0*X(KA)-X(KA+1)
      B=0.0D 0
      ENDIF
      IF (KA.LE.N1) THEN
      S2=X(KA)**2+X(KA)+0.1D 0*X(N1+KA)**2-1.2D 0
      ELSE
      S2=0.2D 0*X(KA-N1)**2+X(KA)**2+2.0D 0*X(KA)-0.6D 0
      ENDIF
      FA=S1+H**2*S2-B
      RETURN
  540 ND=INT(SQRT(DBLE(N)))
      L=MOD(KA,ND)
      IF (L.EQ.0) THEN
      K=KA/ND
      L=ND
      ELSE
      K=INT(KA/ND)+1
      ENDIF
      LA=1.0D 0
      H=1.0D 0/DBLE(ND+1)
      H2=LA*H*H
      IF (L.EQ.1.AND.K.EQ.1) THEN
      FA=4.0D 0*X(1)-X(2)-X(ND+1)+H2*EXP(X(1))
      ENDIF
      IF (1.LT.L.AND.L.LT.ND.AND.K.EQ.1) THEN
      FA=4.0D 0*X(L)-X(L-1)-X(L+1)-X(L+ND)+H2*EXP(X(L))
      ENDIF
      IF (L.EQ.ND.AND.K.EQ.1) THEN
      FA=4.0D 0*X(ND)-X(ND-1)-X(ND+ND)+H2*EXP(X(ND))
      ENDIF
      IF (L.EQ.1.AND.1.LT.K.AND.K.LT.ND) THEN
      FA=4.0D 0*X(KA)-X(KA+1)-X(KA-ND)-X(KA+ND)+H2*EXP(X(KA))
      ENDIF
      IF (L.EQ.ND.AND.1.LT.K.AND.K.LT.ND) THEN
      FA=4.0D 0*X(KA)-X(KA-ND)-X(KA-1)-X(KA+ND)+H2*EXP(X(KA))
      ENDIF
      IF (L.EQ.1.AND.K.EQ.ND) THEN
      FA=4.0D 0*X(KA)-X(KA+1)-X(KA-ND)+H2*EXP(X(KA))
      ENDIF
      IF (1.LT.L.AND.L.LT.ND.AND.K.EQ.ND) THEN
      FA=4.0D 0*X(KA)-X(KA-1)-X(KA+1)-X(KA-ND)+H2*EXP(X(KA))
      ENDIF
      IF (L.EQ.ND.AND.K.EQ.ND) THEN
      FA=4.0D 0*X(KA)-X(KA-1)-X(KA-ND)+H2*EXP(X(KA))
      ENDIF
      IF (1.LT.L.AND.L.LT.ND.AND.1.LT.K.AND.K.LT.ND) THEN
      FA=4.0D 0*X(KA)-X(KA-1)-X(KA+1)-X(KA-ND)-X(KA+ND)+H2*EXP(X(KA))
      ENDIF
      RETURN
  550 ND=INT(SQRT(DBLE(N)))
      L=MOD(KA,ND)
      IF (L.EQ.0) THEN
      K=KA/ND
      L=ND
      ELSE
      K=INT(KA/ND)+1
      ENDIF
      H=1.0D 0/DBLE(ND+1)
      H2=H*H
      IF (L.EQ.1.AND.K.EQ.1) THEN
      FA=4.0D 0*X(1)-X(2)-X(ND+1)+H2*X(1)**2-24.0D 0/(H+1.0D 0)**2
      ENDIF
      IF (1.LT.L.AND.L.LT.ND.AND.K.EQ.1) THEN
      FA=4.0D 0*X(L)-X(L-1)-X(L+1)-X(L+ND)+H2*X(L)**2
     & -12.0D 0/(DBLE(L)*H+1.0D 0)**2
      ENDIF
      IF (L.EQ.ND.AND.K.EQ.1) THEN
      FA=4.0D 0*X(ND)-X(ND-1)-X(ND+ND)+H2*X(ND)**2
     & -12.0D 0/(DBLE(ND)*H+1.0D 0)**2-12.0D 0/(H+2.0D 0)**2
      ENDIF
      IF (L.EQ.1.AND.1.LT.K.AND.K.LT.ND) THEN
      FA=4.0D 0*X(KA)-X(KA+1)-X(KA-ND)-X(KA+ND)+H2*X(KA)**2
     & -12.0D 0/(DBLE(K)*H+1.0D 0)**2
      ENDIF
      IF (L.EQ.ND.AND.1.LT.K.AND.K.LT.ND) THEN
      FA=4.0D 0*X(KA)-X(KA-ND)-X(KA-1)-X(KA+ND)+H2*X(KA)**2
     & -12.0D 0/(DBLE(K)*H+2.0D 0)**2
      ENDIF
      IF (L.EQ.1.AND.K.EQ.ND) THEN
      FA=4.0D 0*X(KA)-X(KA+1)-X(KA-ND)+H2*X(KA)**2
     & -12.0D 0/(DBLE(ND)*H+1.0D 0)**2-12.0D 0/(H+2.0D 0)**2
      ENDIF
      IF (1.LT.L.AND.L.LT.ND.AND.K.EQ.ND) THEN
      FA=4.0D 0*X(KA)-X(KA-1)-X(KA+1)-X(KA-ND)+H2*X(KA)**2
     & -12.0D 0/(DBLE(L)*H+2.0D 0)**2
      ENDIF
      IF (L.EQ.ND.AND.K.EQ.ND) THEN
      FA=4.0D 0*X(KA)-X(KA-1)-X(KA-ND)+H2*X(KA)**2
     & -24.0D 0/(DBLE(ND)*H+2.0D 0)**2
      ENDIF
      IF (1.LT.L.AND.L.LT.ND.AND.1.LT.K.AND.K.LT.ND) THEN
      FA=4.0D 0*X(KA)-X(KA-1)-X(KA+1)-X(KA-ND)-X(KA+ND)+H2*X(KA)**2
      ENDIF
      RETURN
      END
