* SUBROUTINE EAGU16             ALL SYSTEMS                 99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENTS OF TEST FUNCTIONS FOR NONLINEAR EQUATIONS.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  I  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  G(N)  GRADIENT OF THE APPROXIMATED FUNCTION AT THE
*          SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAGU16(N,I,X,G,NEXT)
      INTEGER N,I,NEXT
      $FLOAT X(N),G(N)
      $FLOAT BROW(1000),T,S,S1,S2,S3,T1,T2,C,H,H2,LA,A,B,AL,BE
      $FLOAT GA,CA,CB,U,FF,TI,TIM1,TIM2,SI,SIM1,SIM2,V
      INTEGER J,K,I1,I2,J1,J2,L,ALF,BET,N1,ND
      GOTO (201,202,203,204,205,206,207,208,209,210,211,212,213,214,
     & 215,216,217,218,219,220,221,222,223,224,225,226,227,228,
     & 229,230,231,232),NEXT
201   IF(I.EQ.1) THEN
      G(1)=-1.0$P 0
      DO 3010 J=2,N
        G(J)=0.0$P 0
3010  CONTINUE
      ELSE
      S=20.0$P 0*$DBLE(I-1)*(X(I)-X(I-1))
      DO 3020 J=1,N
        IF(J.EQ.I) THEN
           G(J)=S
        ELSE IF(J.EQ.I-1) THEN
           G(J)=-S
        ELSE
          G(J)=0.0$P 0
        ENDIF
3020  CONTINUE
      ENDIF
      RETURN
202   IF(I.EQ.N) THEN
        G(1)=-0.20$P 0*X(1)
        N1=N-1
        DO 3030 J=2,N1
           G(J)=0.0$P 0
3030    CONTINUE
        G(N)=1.0$P 0
      ELSE
        DO 3050 J=1,N
           IF(J.EQ.I) THEN
              G(J)=1.0$P 0
           ELSE IF(J.EQ.I+1) THEN
              G(J)=-0.2$P 0*X(I+1)
           ELSE
              G(J)=0.0$P 0
           ENDIF
3050    CONTINUE
      ENDIF
      RETURN
203   IF(I.EQ.N) THEN
        DO 3070 J=1,N
           T=1.0$P 0
           DO 3060 K=1,N
              IF(K.NE.J) T=T*X(K)
3060       CONTINUE
        G(J)=T
3070    CONTINUE
      ELSE
        DO 3080 J=1,N
           IF(J.EQ.I) THEN
              G(J)=2.0$P 0
           ELSE
              G(J)=1.0$P 0
           ENDIF
3080    CONTINUE
      ENDIF
      RETURN
204   DO 3090 J=1,N
        IF(J.EQ.I.AND.I/2*2.EQ.I) THEN
           G(J)=10.0$P 0
        ELSE IF(J.EQ.I) THEN
          G(J)=-1.0$P 0
        ELSE IF(J.EQ.I-1.AND.I/2*2.EQ.I) THEN
           G(J)=-20.0$P 0*X(I-1)
        ELSE
           G(J)=0.0$P 0
        ENDIF
3090  CONTINUE
      RETURN
205   DO 4000 J=1,N
        IF(J.EQ.I) THEN
           G(J)=1.0$P 0-3.0$P 0*X(I)**2/(2.0$P 0*$DBLE(N))
        ELSE
           G(J)=-3.0$P 0*X(J)**2/(2.0$P 0*$DBLE(N))
        ENDIF
4000  CONTINUE
      RETURN
206   DO 4010 J=1,N
        IF(J.EQ.I) THEN
           G(J)=-2.0$P 0-1.0$P 0/$DBLE(N+1)**2*EXP(X(I))
        ELSE IF(J.EQ.I-1.OR.J.EQ.I+1) THEN
           G(J)=1.0$P 0
        ELSE
           G(J)=0.0$P 0
        ENDIF
4010  CONTINUE
      RETURN
207   S=0.1$P 0
      DO 4020 J=1,N
        IF(J.EQ.I-1) THEN
           G(J)=-1.0$P 0
        ELSE IF(J.EQ.I) THEN
           G(J)=3.0$P 0-2.0$P 0*S*X(I)
        ELSE IF(J.EQ.I+1) THEN
           G(J)=-2.0$P 0
        ELSE
           G(J)=0.0$P 0
        ENDIF
4020  CONTINUE
      RETURN
208   S1=1.0$P 0
      S2=1.0$P 0
      S3=1.0$P 0
      J1=3
      J2=3
      IF(I-J1.GT.1) THEN
        I1=I-J1
      ELSE
        I1=1
      ENDIF
      IF(I+J2.LT.N) THEN
        I2=I+J2
      ELSE
        I2=N
      ENDIF
      DO 4030 J=1,N
        IF(J.EQ.I) THEN
           G(J)=S1+3.0$P 0*S2*X(I)**2
        ELSE IF(J.GE.I1.AND.J.LE.I2) THEN
           G(J)=-S3*(1.0$P 0+2.0$P 0*X(J))
        ELSE
           G(J)=0.0$P 0
        ENDIF
4030  CONTINUE
      RETURN
209   DO 4040 J=1,N
        IF(I.EQ.1.AND.J.EQ.1) THEN
           G(J)=2.0$P 0*X(1)
        ELSE IF(I.EQ.1) THEN
           G(J)=0.0$P 0
        ELSE IF(J.EQ.I-1) THEN
           G(J)=2.0$P 0*X(I-1)
        ELSE IF(J.EQ.I) THEN
           G(J)=1.0$P 0/X(I)
        ELSE
           G(J)=0.0$P 0
        ENDIF
4040  CONTINUE
      RETURN
210   S1=0.0$P 0
      DO 4050 J=1,N
        S1=S1+X(J)
4050  CONTINUE
      DO 4060 J=1,N
        S2=$DBLE(I)
        S3=S2*S1
        G(J)=-S2*SIN(S3)*EXP(COS(S3))
4060  CONTINUE
      RETURN
211   DO 4070 J=1,N
        G(J)=3.0$P 0*X(J)**2/($DBLE(N)*2.0$P 0)
4070  CONTINUE
      RETURN
212   DO 4080 J=1,N
        IF(J.EQ.I) THEN
           G(J)=1.0$P 0
        ELSE IF(J.EQ.I-1) THEN
           G(J)=-SIN(X(I-1))
        ELSE
           G(J)=0.0$P 0
        ENDIF
4080  CONTINUE
      RETURN
213   S=(1.0$P 0/$DBLE(N+1))**2
      DO 4090 J=1,N
        IF(J.EQ.I-1.OR.J.EQ.I+1) THEN
           G(J)=-1.0$P 0
        ELSE IF(J.EQ.I) THEN
           G(J)=2.0$P 0+S*(1.0$P 0+COS(X(J)))
        ELSE
           G(J)=0.0$P 0
        ENDIF
4090  CONTINUE
      RETURN
214   IF(I-5.GT.1) THEN
        I1=I-5
      ELSE
        I1=1
      ENDIF
      IF(I+1.LT.N) THEN
        I2=I+1
      ELSE
        I2=N
      ENDIF
      DO 5000 J=1,N
        IF(J.EQ.I) THEN
           G(J)=2.0$P 0+15.0$P 0*X(J)**2
        ELSE IF(J.GE.I1.AND.J.LE.I2) THEN
           G(J)=-1.0$P 0-2.0$P 0*X(J)
        ELSE
           G(J)=0.0$P 0
        ENDIF
5000  CONTINUE
      RETURN
215   DO 5010 J=1,N
        S3=0.0$P 0
        DO 5011 K=1,29
           S1=0.0$P 0
           T1=0.$P 0
           S=$DBLE(K)/29.0$P 0
           DO 5012 L=1,N
              S1=S1+S**(L-1)*X(L)
5012       CONTINUE
           DO 5013 L=2,N
              T1=T1+S**(L-2)*(L-1)*X(L)
5013       CONTINUE
         S3=S3+S**(I+J-2)*(($DBLE(29*(I-1))/$DBLE(K)-2.0$P 0*S1)*
     +   ($DBLE(29*(J - 1))/$DBLE(K)-2.0$P 0*S1)-
     +   2.0$P 0*(T1-S1*S1-1.0$P 0))
         IF ((I.EQ.1).AND.(J.EQ.1)) THEN
             G(J)=S3+6.0$P 0*X(1)*X(1)-2.0$P 0*X(2)+3.0$P 0
         ELSE IF (((I.EQ.1).AND.(J.EQ.2)).OR.((I.EQ.2)
     +    .AND.(J.EQ.1))) THEN
            G(J)=S3-2.0$P 0*X(1)
         ELSE IF ((I.EQ.2).AND.(J.EQ.2)) THEN
           G(J)=S3+1.0$P 0
         ELSE
           G(J)=S3
         ENDIF
5011   CONTINUE
5010  CONTINUE
      RETURN
216   DO 5020 J=1,N
            SI=2.$P 0*X(J)-1.$P 0
            V=2.$P 0*SI
            TIM1=2.$P 0
            TI=2.$P 0
            TIM2=0.$P 0
            SIM1=1.$P 0
            DO 5021 L=2,I
              TI=4.$P 0*SI+V*TIM1-TIM2
              TIM2=TIM1
              TIM1=TI
              SIM2=SIM1
              SIM1=SI
              SI=V*SIM1-SIM2
5021    CONTINUE
      G(J)=TI/$DBLE(N)
5020  CONTINUE
      RETURN
217   IF(I.EQ.1) THEN
        S1=0.0$P 0
      ELSE
        S1=X(I-1)
      ENDIF
      IF(I.EQ.N) THEN
        S2=20.0$P 0
      ELSE
        S2=X(I+1)
      ENDIF
      DO 5030 J=1,N
        IF(J.EQ.I) THEN
           G(J)=3.0$P 0*(S2-4.$P 0*X(I)+S1)
        ELSE IF(J.EQ.I-1) THEN
           G(J)=3.0$P 0*X(I)-(S2-S1)/2.0$P 0
        ELSE IF(J.EQ.I+1) THEN
           G(J)=3.0$P 0*X(I)+(S2-S1)/2.0$P 0
        ELSE
           G(J)=0.0$P 0
        ENDIF
5030  CONTINUE
      RETURN
218   S=1.0$P 0/$DBLE(N+1)
      DO 5040 J=1,N
        IF(J.EQ.I-1.OR.J.EQ.I+1) THEN
           G(J)=-1.0$P 0
        ELSE IF(J.EQ.I) THEN
          G(J)=2.0$P 0+3.0$P 0*S*S*(1.0$P 0+$DBLE(I)*S+X(I))**2/2.0$P 0
       ELSE
          G(J)=0.0$P 0
       ENDIF
5040  CONTINUE
      RETURN
219   S=1.0$P 0/$DBLE(N+1)
      S1=3.0$P 0*S/2.0$P 0
      T1=$DBLE(I)*S
      DO 5050 J=1,N
        T2=$DBLE(J)*S
        IF(J.LT.I) THEN
           G(J)=S1*(1.0$P 0-T1)*T2*(X(J)+T2+1.0$P 0)**2
        ELSE IF(J.EQ.I) THEN
           G(J)=1.0$P 0+S1*(1.0$P 0-T1)*T2*(X(J)+T2+1.0$P 0)**2
        ELSE
           G(J)=S1*(1.0$P 0-T2)*T1*(X(J)+T2+1.0$P 0)**2
        ENDIF
5050  CONTINUE
      RETURN
220   DO 5060 J=1,N
        S=SIN(X(J))
        IF(J.EQ.I) THEN
           G(J)=S+$DBLE(I)*S-COS(X(J))
        ELSE
           G(J)=S
        ENDIF
5060  CONTINUE
      RETURN
221   S=0.0$P 0
      DO 5070 J=1,N
        S=S+$DBLE(J)*(X(J)-1.0$P 0)
5070  CONTINUE
      DO 5080 J=1,N
        IF(J.NE.I) THEN
           G(J)=$DBLE(I*J)*(1.0$P 0+6.0$P 0*S*S)
        ELSE
           G(J)=1.0$P 0+$DBLE(I*I)*(1.0$P 0+6.0$P 0*S*S)
        ENDIF
5080  CONTINUE
      RETURN
222   DO 5090 J=1,N
        IF(J.EQ.I-1) THEN
           G(J)=-1.0$P 0
        ELSE IF(J.EQ.I)THEN
           G(J)=3.$P 0-4.$P 0*X(I)
        ELSE IF(J.EQ.I+1) THEN
           G(J)=-2.0$P 0
        ELSE
           G(J)=0.0$P 0
        ENDIF
5090  CONTINUE
      RETURN
223   ALF=5
      BET=14
      DO 6000 J=1,N
        IF(J.NE.I) THEN
        T=SQRT(X(J)**2+$DBLE(I)/$DBLE(J))
        S1=LOG(T)
        G(J)=X(J)*(SIN(S1)**ALF+COS(S1)**ALF+
     +     ALF*SIN(S1)**(ALF-1)*COS(S1)-
     +     ALF*SIN(S1)*COS(S1)**(ALF-1))/T
        ELSE
          G(J)=$DBLE(BET*N)
        ENDIF
6000  CONTINUE
      RETURN
224   C=0.5$P 0
      H=1.0$P 0/$DBLE(N)
      DO 6008 J=1,N
        BROW(J)=C*H*$DBLE(I)/$DBLE(2*(I+J))
6008  CONTINUE
      BROW(N)=0.5$P 0*BROW(N)
      DO 6010 J=1,N
        IF(I.NE.J) THEN
           G(J)=-BROW(J)*X(I)
        ELSE
           T=1.0$P 0-C*H/4.0$P 0
           DO 6011 L=1,N
             IF(L.EQ.I) THEN
               T=T-2.0$P 0*BROW(I)*X(I)
             ELSE
               T=T-BROW(L)*X(L)
             ENDIF
6011       CONTINUE
           G(J)=T
        ENDIF
6010  CONTINUE
      RETURN
225   DO 6020 J=1,N
        IF(I.EQ.1.AND.J.EQ.1) THEN
        G(J)=9.0$P 0*X(I)**2+COS(X(I)-X(I+1))*SIN(X(I)+X(I+1))+
     +     SIN(X(I)-X(I+1))*COS(X(I)+X(I+1))
        ELSE IF(I.EQ.1.AND.J.EQ.2) THEN
           G(J)=2.0$P 0-COS(X(I)-X(I+1))*SIN(X(I)+X(I+1))+
     +     SIN(X(I)-X(I+1))*COS(X(I)+X(I+1))
        ELSE IF(I.LT.N.AND.J.EQ.I) THEN
           G(J)=9.0$P 0*X(I)**2+COS(X(I)-X(I+1))*SIN(X(I)+X(I+1))+
     +     SIN(X(I)-X(I+1))*COS(X(I)+X(I+1))+
     +     4.0$P 0+X(I-1)*EXP(X(I-1)-X(I))
        ELSE IF(I.LT.N.AND.J.EQ.I+1) THEN
           G(J)=2.0$P 0-COS(X(I)-X(I+1))*SIN(X(I)+X(I+1))+
     +     SIN(X(I)-X(I+1))*COS(X(I)+X(I+1))
        ELSE IF(J.EQ.I-1) THEN
           G(J)=-EXP(X(I-1)-X(I))-X(I-1)*EXP(X(I-1)-X(I))
        ELSE IF(I.EQ.N.AND.J.EQ.N) THEN
           G(J)=4.0$P 0+X(I-1)*EXP(X(I-1)-X(I))
        ELSE
           G(J)=0.0$P 0
        ENDIF
6020  CONTINUE
      RETURN
226   T=10.0$P 0
      H=(T/$DBLE(N+1))**2
      S=T*X(I)
      DO 6030 J=1,N
        IF(J.EQ.I-1.OR.J.EQ.I+1) THEN
           G(J)=-1.0$P 0
        ELSEIF(J.EQ.I) THEN
           G(J)=2.0$P 0+H*(EXP(S)+EXP(-S))/2.$P 0
        ELSE
           G(J)=0.0$P 0
        ENDIF
6030  CONTINUE
      RETURN
227   S=0.5$P 0
      H=1.0$P 0/$DBLE(N+1)
      DO 6040 J=1,N
        IF(J.EQ.I-1) THEN
           G(J)=-1.0$P 0+H/(2.0$P 0*S)
        ELSEIF(J.EQ.I+1) THEN
           G(J)=-1.0$P 0-H/(2.0$P 0*S)
        ELSEIF(J.EQ.I) THEN
           G(J)=2.0$P 0*(1.0$P 0-H**2*X(I)/S)
        ELSE
           G(J)=0.0$P 0
        ENDIF
6040  CONTINUE
      RETURN
228   S=0.5$P 0
      H=1.0$P 0/$DBLE(N+1)
      T1=2.0$P 0*H
      S1=H**2/S
      S2=1.0$P 0-$DBLE(I)*H
      DO 6050 J=1,I
        BROW(J)=$DBLE(J)*S2
6050  CONTINUE
      IF(I.EQ.N) GOTO 6055
      DO 6051 J=I+1,N
        BROW(J)=$DBLE(I)*(1.0$P 0-$DBLE(J)*H)
6051  CONTINUE
6055  G(1)=-S1*(BROW(1)*2.0$P 0*X(1)-BROW(2)/T1)
      G(N)=-S1*(BROW(N-1)/T1+BROW(N)*2.0$P 0*X(N))
      DO 6052 J=2,N-1
        G(J)=-S1*((BROW(J-1)-BROW(J+1))/T1+BROW(J)*2.0$P 0*X(J))
6052  CONTINUE
      G(I)=1.0$P 0+G(I)
      RETURN
229   A=-9.0$P-3
      B=1.0$P-3
      AL=0.0$P 0
      BE=25.0$P 0
      GA=20.0$P 0
      CA=0.3$P 0
      CB=0.3$P 0
      H=(B-A)/$DBLE(N+1)
      S=$DBLE(I)/$DBLE(N+1)
      H=H**2
      U=AL*(1.0$P 0-S)+BE*S+X(I)
      FF=GA*(CB*EXP(GA*(U-BE))+CA*EXP(GA*(AL-U)))
      DO 6060 J=1,N
        IF(J.EQ.I-1.OR.J.EQ.I+1) THEN
           G(J)=-1.0$P 0
        ELSEIF(J.EQ.I) THEN
           G(J)=2.0$P 0+H*FF
        ELSE
           G(J)=0.0$P 0
        ENDIF
6060  CONTINUE
      RETURN
230   N1=N/2
      DO 6070 J=1,N
        G(J)=0.0$P 0
6070  CONTINUE
      H=1.0$P 0/$DBLE(N1+1)**2
      IF(I.EQ.1) THEN
        G(I)=2.0$P 0+H*(2.0$P 0*X(I)+1.0$P 0)
        G(I+1)=-1.0$P 0
        G(N1+1)=H*0.2$P 0*X(N1+I)
      ELSE IF(I.EQ.N1+1) THEN
        G(1)=H*0.4$P 0*X(1)
        G(I)=2.0$P 0+H*(2.0$P 0*X(I)+2.0$P 0)
        G(I+1)=-1.0$P 0
      ELSE IF(I.EQ.N1) THEN
        G(I-1)=-1.0$P 0
        G(I)=2.0$P 0+H*(2.0$P 0*X(I)+1.0$P 0)
        G(N1+I)=H*0.2$P 0*X(N1+I)
      ELSE IF(I.EQ.N) THEN
        G(N1)=H*0.4$P 0*X(N1)
        G(I-1)=-1.0$P 0
        G(I)=2.0$P 0+H*(2.0$P 0*X(I)+2.0$P 0)
      ELSE IF(I.LT.N1) THEN
        G(I-1)=-1.0$P 0
        G(I)=2.0$P 0+H*(2.0$P 0*X(I)+1.0$P 0)
        G(I+1)=-1.0$P 0
        G(N1+I)=H*0.2$P 0*X(N1+I)
      ELSE
         G(I-N1)=H*0.4$P 0*X(I-N1)
         G(I-1)=-1.0$P 0
         G(I)=2.0$P 0+H*(2.0$P 0*X(I)+2.0$P 0)
         G(I+1)=-1.0$P 0
      ENDIF
      RETURN
231   ND=INT(SQRT($DBLE(N)))
      L=MOD(I,ND)
      IF(L.EQ.0) THEN
         K=I/ND
         L=ND
      ELSE
         K=INT(I/ND)+1
      ENDIF
      LA=1.0$P 0
      H=1.0$P 0/$DBLE(ND+1)
      H2=LA*H*H
      DO 2010 J=1,N
        G(J)=0.0$P 0
2010  CONTINUE
      IF(L.EQ.1.AND.K.EQ.1) THEN
         G(1)=4.0$P 0+H2*EXP(X(1))
         G(2)=-1.0$P 0
         G(ND+1)=-1.0$P 0
      ENDIF
      IF(1.LT.L.AND.L.LT.ND.AND.K.EQ.1) THEN
         G(L)=4.0$P 0+H2*EXP(X(L))
         G(L-1)=-1.0$P 0
         G(L+1)=-1.0$P 0
         G(L+ND)=-1.0$P 0
      ENDIF
      IF(L.EQ.ND.AND.K.EQ.1) THEN
         G(ND)=4.0$P 0+H2*EXP(X(ND))
         G(ND-1)=-1.0$P 0
         G(ND+ND)=-1.0$P 0
      ENDIF
      IF(L.EQ.1.AND.1.LT.K.AND.K.LT.ND) THEN
         G(I)=4.0$P 0+H2*EXP(X(I))
         G(I-ND)=-1.0$P 0
         G(I+1)=-1.0$P 0
         G(I+ND)=-1.0$P 0
      ENDIF
      IF(L.EQ.ND.AND.1.LT.K.AND.K.LT.ND) THEN
         G(I)=4.0$P 0+H2*EXP(X(I))
         G(I-ND)=-1.0$P 0
         G(I-1)=-1.0$P 0
         G(I+ND)=-1.0$P 0
      ENDIF
      IF(L.EQ.1.AND.K.EQ.ND) THEN
         G(I)=4.0$P 0+H2*EXP(X(I))
         G(I-ND)=-1.0$P 0
         G(I+1)=-1.0$P 0
      ENDIF
      IF(1.LT.L.AND.L.LT.ND.AND.K.EQ.ND) THEN
         G(I)=4.0$P 0+H2*EXP(X(I))
         G(I-ND)=-1.0$P 0
         G(I-1)=-1.0$P 0
         G(I+1)=-1.0$P 0
      ENDIF
      IF(L.EQ.ND.AND.K.EQ.ND) THEN
         G(I)=4.0$P 0+H2*EXP(X(I))
         G(I-ND)=-1.0$P 0
         G(I-1)=-1.0$P 0
      ENDIF
      IF(1.LT.L.AND.L.LT.ND.AND.1.LT.K.AND.K.LT.ND) THEN
         G(I)=4.0$P 0+H2*EXP(X(I))
         G(I-ND)=-1.0$P 0
         G(I-1)=-1.0$P 0
         G(I+1)=-1.0$P 0
         G(I+ND)=-1.0$P 0
      ENDIF
      RETURN
232   ND=INT(SQRT($DBLE(N)))
      L=MOD(I,ND)
      IF(L.EQ.0) THEN
         K=I/ND
         L=ND
      ELSE
         K=INT(I/ND)+1
      ENDIF
      H=1.0$P 0/$DBLE(ND+1)
      H2=H*H
      DO 2020 J=1,N
        G(J)=0.0$P 0
2020  CONTINUE
      IF(L.EQ.1.AND.K.EQ.1) THEN
         G(1)=4.0$P 0+H2*X(1)*2.0$P 0
         G(2)=-1.0$P 0
         G(ND+1)=-1.0$P 0
      ENDIF
      IF(1.LT.L.AND.L.LT.ND.AND.K.EQ.1) THEN
         G(L)=4.0$P 0+H2*X(L)*2.0$P 0
         G(L-1)=-1.0$P 0
         G(L+1)=-1.0$P 0
         G(L+ND)=-1.0$P 0
      ENDIF
      IF(L.EQ.ND.AND.K.EQ.1) THEN
         G(ND)=4.0$P 0+H2*X(ND)*2.0$P 0
         G(ND-1)=-1.0$P 0
         G(ND+ND)=-1.0$P 0
      ENDIF
      IF(L.EQ.1.AND.1.LT.K.AND.K.LT.ND) THEN
         G(I)=4.0$P 0+H2*X(I)*2.0$P 0
         G(I-ND)=-1.0$P 0
         G(I+1)=-1.0$P 0
         G(I+ND)=-1.0$P 0
      ENDIF
      IF(L.EQ.ND.AND.1.LT.K.AND.K.LT.ND) THEN
         G(I)=4.0$P 0+H2*X(I)*2.0$P 0
         G(I-ND)=-1.0$P 0
         G(I-1)=-1.0$P 0
         G(I+ND)=-1.0$P 0
      ENDIF
      IF(L.EQ.1.AND.K.EQ.ND) THEN
         G(I)=4.0$P 0+H2*X(I)*2.0$P 0
         G(I-ND)=-1.0$P 0
         G(I+1)=-1.0$P 0
      ENDIF
      IF(1.LT.L.AND.L.LT.ND.AND.K.EQ.ND) THEN
         G(I)=4.0$P 0+H2*X(I)*2.0$P 0
         G(I-ND)=-1.0$P 0
         G(I-1)=-1.0$P 0
         G(I+1)=-1.0$P 0
      ENDIF
      IF(L.EQ.ND.AND.K.EQ.ND) THEN
         G(I)=4.0$P 0+H2*X(I)*2.0$P 0
         G(I-ND)=-1.0$P 0
         G(I-1)=-1.0$P 0
      ENDIF
      IF(1.LT.L.AND.L.LT.ND.AND.1.LT.K.AND.K.LT.ND) THEN
         G(I)=4.0$P 0+H2*X(I)*2.0$P 0
         G(I-ND)=-1.0$P 0
         G(I-1)=-1.0$P 0
         G(I+1)=-1.0$P 0
         G(I+ND)=-1.0$P 0
      ENDIF
      RETURN
      END

