* SUBROUTINE EAGU37             ALL SYSTEMS                 99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF TEST FUNCTIONS FOR NONLINEAR EQUATIONS.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  GA  GRADIENT OF THE APPROXIMATED FUNCTION AT THE
*          SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAGU37(N,KA,X,GA,NEXT)
      INTEGER N,KA,NEXT
      $FLOAT X(N),GA(N)
      INTEGER I,J,K,L,M,I1,I2,I3,I4,I5,J1,J2,N1,ND,LA,ALF,BET
      $FLOAT A,B,C,A1,A2,A3,A4,AL,FF,PAR,PI,BE,CA,CB,D1S,D2S,H,H2,QA,
     & S,S1,S2,S3,T,T1,T2,U,V,W,EX,ALFA
      $FLOAT GA1(2),GA2(2),GA3(6),GA4(6),BROW(1000)
      COMMON /EMPR18/ PAR,M
      PI=3.14159265358979323846$P 0
      IF (NEXT.LE.32.OR.NEXT.GE.58) THEN
      CALL UXVSET(N,0.0$P 0,GA)
      ENDIF
      GOTO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     & 170,180,190,200,210,220,230,240,250,260,270,280,290,300,320,
     & 310,401,402,403,404,405,406,407,408,409,412,413,414,419,420,
     & 421,422,423,424,426,427,428,429,430,431,432,560,590,600,670,
     & 690,710,720),NEXT
   10 ALFA=0.5$P 0
      IF (KA.EQ.1) THEN
      GA(1)=-1.0$P 0-4.0$P 0*X(2)
      GA(2)=-4.0$P 0*X(1)
      GA(3)=ALFA-1.0$P 0
      ELSEIF(KA.EQ.2) THEN
      GA(1)=-4.0$P 0*X(2)
      GA(2)=-1.0$P 0-4.0$P 0*X(1)
      GA(4)=-2.0$P 0+ALFA
      ELSEIF(KA.EQ.N-1) THEN
      GA(N-3)=ALFA
      GA(N-1)=-1.0$P 0-4.0$P 0*X(N)
      GA(N)=-4.0$P 0*X(N-1)
      ELSEIF (KA.EQ.N) THEN
      GA(N-2)=ALFA
      GA(N-1)=-4.0$P 0*X(N)
      GA(N)=-1.0$P 0-4.0$P 0*X(N-1)
      ELSEIF (MOD(KA,2).EQ.1) THEN
      GA(KA-2)=ALFA
      GA(KA)=-1.0$P 0-4.0$P 0*X(KA+1)
      GA(KA+1)=-4.0$P 0*X(KA)
      GA(KA+2)=-1.0$P 0+ALFA
      ELSE
      GA(KA-2)=ALFA
      GA(KA-1)=-4.0$P 0*X(KA)
      GA(KA)=-1.0$P 0-4.0$P 0*X(KA-1)
      GA(KA+2)=-2.0$P 0+ALFA
      ENDIF
      RETURN
   20 A1=0.414214$P 0
      IF (KA.EQ.1) THEN
      GA(1)=1.0$P 0+X(3)
      GA(2)=-4.0$P 0*A1
      GA(3)=-1.0$P 0+X(1)
      ELSEIF (KA.EQ.2) THEN
      GA(1)=X(4)
      GA(2)=-4.0$P 0*A1
      GA(4)=-1.0$P 0+X(1)
      ELSEIF (KA.EQ.3) THEN
      GA(1)=A1+X(5)
      GA(2)=-4.0$P 0*X(3)
      GA(3)=-1.0$P 0-4.0$P 0*X(2)
      GA(5)=-1.0$P 0+X(1)
      ELSEIF (KA.LE.N-2) THEN
      GA(1)= X(KA-2)+X(KA+2)
      GA(KA-2)=X(1)
      GA(KA-1)=-4.0$P 0*X(KA)
      GA(KA)=-1.0$P 0-4.0$P 0*X(KA-1)
      GA(KA+2)=-1.0$P 0+X(1)
      ELSEIF (KA.EQ.N-1) THEN
      GA(1)= X(N-3)
      GA(N-3)=X(1)
      GA(N-2)=-4.0$P 0*X(N-1)
      GA(N-1)=-1.0$P 0-4.0$P 0*X(N-2)
      ELSE
      GA(1)= X(N-2)+1.0$P 0
      GA(N-2)=X(1)
      GA(N-1)=-4.0$P 0*X(N)
      GA(N)=-1.0$P 0-4.0$P 0*X(N-1)
      ENDIF
      RETURN
   30 J=(KA-1)/5
      GA(KA)=-$DBLE(J+1)*SIN(X(KA))-COS(X(KA))
      J=J*5
      DO 31 I=J+1,J+5
      IF (I.EQ.KA) THEN
      GA(I)=GA(I)+SIN(X(I))
      ELSE
      GA(I)=SIN(X(I))
      ENDIF
   31 CONTINUE
      RETURN
   40 IF (KA.LT.2) THEN
      D1S=COS(X(KA)-X(KA+1))*SIN(X(KA)+X(KA+1))
      D2S=SIN(X(KA)-X(KA+1))*COS(X(KA)+X(KA+1))
      GA(KA)=9.0$P 0*X(KA)**2+D1S+D2S
      GA(KA+1)=2.0$P 0-D1S+D2S
      ELSE IF (KA.LT.N) THEN
      D1S=COS(X(KA)-X(KA+1))*SIN(X(KA)+X(KA+1))
      D2S=SIN(X(KA)-X(KA+1))*COS(X(KA)+X(KA+1))
      EX=EXP(X(KA-1)-X(KA))
      GA(KA-1)=-EX-X(KA-1)*EX
      GA(KA)=9.0$P 0*X(KA)**2+D1S+D2S+4.0$P 0+X(KA-1)*EX
      GA(KA+1)=2.0$P 0-D1S+D2S
      ELSE
      EX=EXP(X(KA-1)-X(KA))
      GA(KA-1)=-EX-X(KA-1)*EX
      GA(KA)=4.0$P 0+X(KA-1)*EX
      ENDIF
      RETURN
   50 IF (MOD(KA,2).EQ.1) THEN
      GA(KA)=0.0$P 0
      IF (KA.NE.1) THEN
      D1S=COS(X(KA-2)-X(KA-1)-X(KA))*SIN(X(KA-2)+X(KA-1)-X(KA))
      D2S=SIN(X(KA-2)-X(KA-1)-X(KA))*COS(X(KA-2)+X(KA-1)-X(KA))
      GA(KA-2)=-18.0$P 0*(X(KA-2)-X(KA))**2-2.0$P 0*(D1S+D2S)
      GA(KA-1)=-4.0$P 0+2.0$P 0*(D1S-D2S)
      GA(KA)=GA(KA)+18.0$P 0*(X(KA-2)-X(KA))**2+2.0$P 0*(D1S+D2S)
      ENDIF
      IF (KA.NE.N) THEN
      D1S=COS(X(KA)-X(KA+1)-X(KA+2))*SIN(X(KA)+X(KA+1)-X(KA+2))
      D2S=SIN(X(KA)-X(KA+1)-X(KA+2))*COS(X(KA)+X(KA+1)-X(KA+2))
      GA(KA)=GA(KA)+9.0$P 0*(X(KA)-X(KA+2))**2+D1S+D2S
      GA(KA+1)=2.0$P 0-D1S+D2S
      GA(KA+2)=-9.0$P 0*(X(KA)-X(KA+2))**2-D1S-D2S
      ENDIF
      ELSE
      EX=EXP(X(KA-1)-X(KA)-X(KA+1))
      W=X(KA-1)-X(KA+1)
      GA(KA-1)=-EX-W*EX
      GA(KA)=4.0$P 0+W*EX
      GA(KA+1)=EX+W*EX
      ENDIF
      RETURN
   60 H=2.0$P 0
      IF (KA.EQ.1) THEN
      GA(1)=2.0$P 0*((3.0$P 0-H*X(1))*X(1)-2.0$P 0*X(2)+1.0$P 0)*
     & (3.0$P 0-2.0$P 0*H*X(1))
      GA(2)=-4.0$P 0*((3.0$P 0-H*X(1))*X(1)-2.0$P 0*X(2)+1.0$P 0)
      ELSE IF (KA.LE.N-1) THEN
      GA(KA-1)=-2.0$P 0*
     & ((3.0$P 0-H*X(KA))*X(KA)-X(KA-1)-2.0$P 0*X(KA+1)+1.0$P 0)
      GA(KA)=2.0$P 0*
     & ((3.0$P 0-H*X(KA))*X(KA)-X(KA-1)-2.0$P 0*X(KA+1)+1.0$P 0)*
     & (3.0$P 0-2.0$P 0*H*X(KA))
      GA(KA+1)=-4.0$P 0*
     & ((3.0$P 0-H*X(KA))*X(KA)-X(KA-1)-2.0$P 0*X(KA+1)+1.0$P 0)
      ELSE
      GA(N-1)=-2.0$P 0*((3.0$P 0-H*X(N))*X(N)-X(N-1)+1.0$P 0)
      GA(N)=2.0$P 0*
     & ((3.0$P 0-H*X(N))*X(N)-X(N-1)+1.0$P 0)*
     & (3.0$P 0-2.0$P 0*H*X(N))
      ENDIF
      RETURN
   70 IF (KA.LT.2) THEN
      GA(KA)=4.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)
      ELSE IF (KA.LT.N) THEN
      GA(KA-1)=-8.0$P 0*X(KA)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)
      ELSE
      GA(KA-1)=-8.0$P 0*X(KA)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+2.0$P 0
      ENDIF
      RETURN
   80 IF (KA.LT.2) THEN
      GA(KA)=4.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)
      ELSE IF (KA.LT.3) THEN
      GA(KA-1)=-8.0$P 0*X(KA)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)
      ELSE IF (KA.LT.N-1) THEN
      GA(KA-2)=-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)
      ELSE IF (KA.LT.N) THEN
      GA(KA-2)=-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)
      ELSE
      GA(KA-2)=-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+2.0$P 0
      ENDIF
      RETURN
   90 IF (KA.LT.2) THEN
      GA(KA)=4.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)+1.0$P 0
      GA(KA+3)=-2.0$P 0*X(KA+3)
      ELSE IF (KA.LT.3) THEN
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)+1.0$P 0
      GA(KA+3)=-2.0$P 0*X(KA+3)
      ELSE IF (KA.LT.4) THEN
      GA(KA-2)=2.0$P 0*X(KA-2)-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)+1.0$P 0
      GA(KA+3)=-2.0$P 0*X(KA+3)
      ELSE IF (KA.LT.N-2) THEN
      GA(KA-3)=-1.0$P 0
      GA(KA-2)=2.0$P 0*X(KA-2)-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)+1.0$P 0
      GA(KA+3)=-2.0$P 0*X(KA+3)
      ELSE IF (KA.LT.N-1) THEN
      GA(KA-3)=-1.0$P 0
      GA(KA-2)=2.0$P 0*X(KA-2)-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)+1.0$P 0
      ELSE IF (KA.LT.N) THEN
      GA(KA-3)=-1.0$P 0
      GA(KA-2)=2.0$P 0*X(KA-2)-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      ELSE
      GA(KA-3)=-1.0$P 0
      GA(KA-2)=2.0$P 0*X(KA-2)-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+2.0$P 0
      ENDIF
      RETURN
  100 IF (KA.EQ.1) THEN
      GA(N-4)=3.0$P 0
      GA(N-3)=-1.0$P 0
      GA(N-2)=-1.0$P 0
      GA(N-1)=0.50$P 0
      GA(N)=-1.0$P 0
      GA(KA)=-4.0$P 0*X(KA)+3.0$P 0
      GA(KA+1)=-2.0$P 0
      ELSEIF (KA.LE.N-1) THEN
      GA(KA-1)=0.0$P 0
      GA(KA)=0.0$P 0
      GA(KA+1)=0.0$P 0
      GA(N-4)=3.0$P 0
      GA(N-3)=-1.0$P 0
      GA(N-2)=-1.0$P 0
      GA(N-1)=0.50$P 0
      GA(N)=-1.0$P 0
      GA(KA-1)=GA(KA-1)-1.0$P 0
      GA(KA)=GA(KA)-4.0$P 0*X(KA)+3.0$P 0
      GA(KA+1)=GA(KA+1)-2.0$P 0
      ELSE
      GA(N-4)=3.0$P 0
      GA(N-3)=-1.0$P 0
      GA(N-2)=-1.0$P 0
      GA(N-1)=-0.5$P 0
      GA(N)=-4.0$P 0*X(N)+2.0$P 0
      ENDIF
      RETURN
  110 IF(MOD(KA,2).EQ.1) THEN
      GA(KA)=1.0$P 0
      GA(KA+1)=10.0$P 0*X(KA+1)-3.0$P 0*X(KA+1)**2-2.0$P 0
      ELSE
      GA(KA-1)=1.0$P 0
      GA(KA)=3.0$P 0*X(KA)**2+2.0$P 0*X(KA)-1.4$P 1
      ENDIF
      RETURN
  120 IF(MOD(KA,4).EQ.1) THEN
      GA(KA)=1.0$P 0
      GA(KA+1)=1.0$P 1
      ELSE IF(MOD(KA,4).EQ.2) THEN
      GA(KA+1)=2.23606797749979$P 0
      GA(KA+2)=-GA(KA+1)
      ELSE IF(MOD(KA,4).EQ.3) THEN
      GA(KA-1)=2.0$P 0*(X(KA-1)-2.0$P 0*X(KA))
      GA(KA)= -4.0$P 0*(X(KA-1)-2.0$P 0*X(KA))
      ELSE
      GA(KA-3)=3.16227766016838$P 0*2.0$P 0*(X(KA-3)-X(KA))
      GA(KA)= -3.16227766016838$P 0*2.0$P 0*(X(KA-3)-X(KA))
      ENDIF
      RETURN
  130 IF (MOD(KA,4).EQ.1) THEN
      GA(KA)=2.0$P 0*(EXP(X(KA))-X(KA+1))*EXP(X(KA))
      GA(KA+1)=-2.0$P 0*(EXP(X(KA))-X(KA+1))
      ELSE IF (MOD(KA,4).EQ.2) THEN
      GA(KA)=3.0$P 1*(X(KA)-X(KA+1))**2
      GA(KA+1)=-GA(KA)
      ELSE IF (MOD(KA,4).EQ.3) THEN
      GA(KA)=2.0$P 0*SIN(X(KA)-X(KA+1))/(COS(X(KA)-X(KA+1)))**3
      GA(KA+1)=-GA(KA)
      ELSE
      GA(KA)=1.0$P 0
      ENDIF
      RETURN
  140 IF (KA.LT.2) THEN
      GA(KA)=X(KA)-3.0$P 0
      GA(KA+1)=2.0$P 0
      ELSE IF (KA.LT.N) THEN
      GA(KA-1)=1.0$P 0
      GA(KA)=X(KA)-3.0$P 0
      GA(KA+1)=2.0$P 0
      ELSE
      GA(KA-1)=1.0$P 0
      GA(KA)=X(KA)-3.0$P 0
      ENDIF
      RETURN
  150 DO 151 J=MAX(1,KA-5),MIN(N,KA+1)
      GA(J)=1.0$P 0+2.0$P 0*X(J)
  151 CONTINUE
      GA(KA)=GA(KA)+2.0$P 0+15.0$P 0*X(KA)**2
      RETURN
  160 IF(MOD(KA,2).EQ.1) THEN
      GA(KA)=1.0$P 4*X(KA+1)
      GA(KA+1)=1.0$P 4*X(KA)
      ELSE
      GA(KA-1)=-EXP(-X(KA-1))
      GA(KA)=-EXP(-X(KA))
      ENDIF
      RETURN
  170 IF(MOD(KA,4).EQ.1) THEN
      GA(KA)=-2.0$P 2*(X(KA+1)-3.0$P 0*X(KA)**2)+1.0$P 0
      GA(KA+1)=-2.0$P 2*X(KA)
      ELSE IF(MOD(KA,4).EQ.2) THEN
      GA(KA-1)=-4.0$P 2*X(KA-1)
      GA(KA)=2.202$P 2
      GA(KA+2)=1.98$P 1
      ELSE IF(MOD(KA,4).EQ.3) THEN
      GA(KA)=-1.8$P 2*(X(KA+1)-3.0$P 0*X(KA)**2)+1.0$P 0
      GA(KA+1)=-1.8$P 2*X(KA)
      ELSE
      GA(KA-2)=1.98$P 1
      GA(KA-1)=-3.6$P 2*X(KA-1)
      GA(KA)=2.002$P 2
      ENDIF
      RETURN
  180 IF (KA.LT.2) THEN
      GA(KA+1)=EXP(COS($DBLE(KA)*(X(KA)+X(KA+1))))*
     & $DBLE(KA)*SIN($DBLE(KA)*(X(KA)+X(KA+1)))
      GA(KA)=GA(KA+1)+1.0$P 0
      ELSEIF (KA.LT.N) THEN
      GA(KA-1)=EXP(COS($DBLE(KA)*(X(KA-1)+X(KA)+X(KA+1))))*
     & SIN($DBLE(KA)*(X(KA-1)+X(KA)+X(KA+1)))*$DBLE(KA)
      GA(KA+1)=GA(KA-1)
      GA(KA)=1.0$P 0+GA(KA-1)
      ELSE
      GA(KA-1)=EXP(COS($DBLE(KA)*(X(KA-1)+X(KA))))*
     & SIN($DBLE(KA)*(X(KA-1)+X(KA)))*$DBLE(KA)
      GA(KA)=1.0$P 0+GA(KA-1)
      ENDIF
      RETURN
  190 U=1.0$P 0/$DBLE(N+1)
      V=$DBLE(KA)*U
      GA(KA)=2.0$P 0+1.5$P 0*U**2*(X(KA)+V+1.0$P 0)**2
      IF(KA.GT.1) GA(KA-1)=-1.0$P 0
      IF(KA.LT.N) GA(KA+1)=-1.0$P 0
      RETURN
  200 IF(KA.EQ.1) THEN
      GA(KA)=3.0$P 0*(X(KA+1)-4.0$P 0*X(KA))
      GA(KA+1)=3.0$P 0*X(KA)+0.5$P 0*X(KA+1)
      ELSEIF(KA.EQ.N) THEN
      GA(KA-1)=3.0$P 0*X(KA)-0.5$P 0*(2.0$P 1-X(KA-1))
      GA(KA)=3.0$P 0*(2.0$P 1-4.0$P 0*X(KA)+X(KA-1))
      ELSE
      GA(KA-1)=3.0$P 0*X(KA)-0.5$P 0*(X(KA+1)-X(KA-1))
      GA(KA)=3.0$P 0*(X(KA+1)-4.0$P 0*X(KA)+X(KA-1))
      GA(KA+1)=3.0$P 0*X(KA)+0.5$P 0*(X(KA+1)-X(KA-1))
      ENDIF
      RETURN
  210 H=1.0$P 0/$DBLE(N+1)
      IF (KA.LT.2) THEN
      GA(KA)=2.0$P 0+PAR**2*H**2*COSH(PAR*X(KA))
      GA(KA+1)=-1.0$P 0
      ELSE IF (KA.LT.N) THEN
      GA(KA-1)=-1.0$P 0
      GA(KA)=2.0$P 0+PAR**2*H**2*COSH(PAR*X(KA))
      GA(KA+1)=-1.0$P 0
      ELSE
      GA(KA)=2.0$P 0+PAR**2*H**2*COSH(PAR*X(KA))
      GA(KA-1)=-1.0$P 0
      ENDIF
      RETURN
  220 GA(KA)=6.0$P 0
C      FA=6.0$P 0*X(KA)
      A1=0.0$P 0
      A2=0.0$P 0
      A3=0.0$P 0
      GA1(1)=0.0$P 0
      GA1(2)=0.0$P 0
      GA2(1)=0.0$P 0
      GA2(2)=0.0$P 0
      IF (KA.GT.1) THEN
      GA(KA-1)=-4.0$P 0+PAR*X(KA)
      A1=A1-X(KA-1)
      A2=A2+X(KA-1)
      A3=A3+2.0$P 0*X(KA-1)
      GA1(1)=-1.0$P 0
      GA2(1)= 1.0$P 0
      ENDIF
      IF (KA.GT.2) THEN
      GA(KA-2)=1.0$P 0-0.5$P 0*PAR*X(KA)
      A3=A3-X(KA-2)
      ENDIF
      IF (KA.LT.N-1) THEN
      GA(KA+2)=1.0$P 0+0.5$P 0*PAR*X(KA)
      A3=A3+X(KA+2)
      ENDIF
      IF (KA.LT.N) THEN
      GA(KA+1)=-4.0$P 0-PAR*X(KA)
      A1=A1+X(KA+1)
      A2=A2+X(KA+1)
      A3=A3-2.0$P 0*X(KA+1)
      GA1(2)= 1.0$P 0
      GA2(2)= 1.0$P 0
      ENDIF
      IF (KA.GE.N-1) THEN
      A3=A3+1.0$P 0
      ENDIF
      IF (KA.GE.N) THEN
      A1=A1+1.0$P 0
      A2=A2+1.0$P 0
      A3=A3-2.0$P 0
      ENDIF
      GA(KA)=GA(KA)+0.5$P 0*PAR*A3
      IF (KA.GT.1)
     & GA(KA-1)=GA(KA-1)-0.5$P 0*PAR*(GA1(1)*A2+A1*GA2(1))
      IF (KA.LT.N)
     & GA(KA+1)=GA(KA+1)-0.5$P 0*PAR*(GA1(2)*A2+A1*GA2(2))
      RETURN
  230 H=1.0$P 0/(M+1)
      IF(KA.LE.M) THEN
      J=KA+M
      GA(KA)=6.0$P 0
      GA(J)=0.0$P 0
      A1=0.0$P 0
      A2=0.0$P 0
      IF (KA.EQ.1) THEN
      A1=A1+1.0$P 0
      ENDIF
      IF (KA.GT.1) THEN
      A1=A1-X(J-1)
      A2=A2+2.0$P 0*X(KA-1)
      GA(KA-1)=-4.0$P 0+PAR*H*X(KA)
      GA(J-1)=-0.5$P 0*PAR*H**3*X(J)
      ENDIF
      IF (KA.GT.2) THEN
      A2=A2-X(KA-2)
      GA(KA-2)=1.0$P 0-0.5$P 0*PAR*H*X(KA)
      ENDIF
      IF (KA.LT.M-1) THEN
      A2=A2+X(KA+2)
      GA(KA+2)=1.0$P 0+0.5$P 0*PAR*H*X(KA)
      ENDIF
      IF (KA.LT.M) THEN
      A1=A1+X(J+1)
      A2=A2-2.0$P 0*X(KA+1)
      GA(KA+1)=-4.0$P 0-PAR*H*X(KA)
      GA(J+1)= 0.5$P 0*PAR*H**3*X(J)
      ENDIF
      IF (KA.EQ.M) THEN
      A1=A1+1.0$P 0
      ENDIF
      GA(KA)=GA(KA)+0.5$P 0*PAR*H*A2
      GA(J)=GA(J)+0.5$P 0*PAR*H**3*A1
      ELSE
      J=KA-M
      GA(KA)=-2.0$P 0
      GA(J)=0.0$P 0
      A1=0.0$P 0
      A2=0.0$P 0
      IF (J.EQ.1) THEN
      A2=A2+1.0$P 0
      ENDIF
      IF (J.GT.1) THEN
      A1=A1-X(J-1)
      A2=A2-X(KA-1)
      GA(KA-1)=1.0$P 0-0.5$P 0*PAR*H*X(J)
      GA(J-1)=-0.5$P 0*PAR*H*X(KA)
      ENDIF
      IF (J.LT.M) THEN
      A1=A1+X(J+1)
      A2=A2+X(KA+1)
      GA(KA+1)=1.0$P 0+0.5$P 0*PAR*H*X(J)
      GA(J+1)= 0.5$P 0*PAR*H*X(KA)
      ENDIF
      IF (J.EQ.M) THEN
      A2=A2+1.0$P 0
      ENDIF
      GA(KA)=GA(KA)+0.5$P 0*PAR*H*A1
      GA(J)=GA(J)+0.5$P 0*PAR*H*A2
      ENDIF
      RETURN
  240 GA(KA)=4.0$P 0-PAR*EXP(X(KA))
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      IF(J.GT.1) GA(KA-M)=-1.0$P 0
      IF(I.GT.1) GA(KA-1)=-1.0$P 0
      IF(I.LT.M) GA(KA+1)=-1.0$P 0
      IF(J.LT.M) GA(KA+M)=-1.0$P 0
      RETURN
  250 GA(KA)=4.0$P 0
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      GA(KA)=GA(KA)+3.0$P 0*PAR*X(KA)**2/(1.0$P 0+PAR*$DBLE(I)**2+
     & PAR*$DBLE(J)**2)
      IF(I.GT.1) GA(KA-1)=-1.0$P 0
      IF(I.LT.M) GA(KA+1)=-1.0$P 0
      IF(J.GT.1) GA(KA-M)=-1.0$P 0
      IF(J.LT.M) GA(KA+M)=-1.0$P 0
      RETURN
  260 GA(KA)=4.0$P 0-2.0$P 0*PI*PAR*COS(2.0$P 0*PI*X(KA))
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      A1=DBLE(I)/DBLE(M+1)
      A2=DBLE(J)/DBLE(M+1)
      IF(I.EQ.1) GA(KA+1)=-1.0$P 0-PI*DBLE(M+1)*PAR*COS(PI*X(KA+1)*
     & DBLE(M+1))
      IF(I.GT.1.AND.I.LT.M) THEN
      GA(KA-1)=-1.0$P 0+PI*DBLE(M+1)*PAR*COS(PI*(X(KA+1)-X(KA-1))*
     & DBLE(M+1))
      GA(KA+1)=-1.0$P 0-PI*DBLE(M+1)*PAR*COS(PI*(X(KA+1)-X(KA-1))*
     & DBLE(M+1))
      ENDIF
      IF(I.EQ.M) GA(KA-1)=-1.0$P 0+PI*DBLE(M+1)*PAR*COS(PI*X(KA-1)*
     & DBLE(M+1))
      IF(J.EQ.1) GA(KA+M)=-1.0$P 0-PI*DBLE(M+1)*PAR*COS(PI*X(KA+M)*
     & DBLE(M+1))
      IF(J.GT.1.AND.J.LT.M) THEN
      GA(KA-M)=-1.0$P 0+PI*DBLE(M+1)*PAR*COS(PI*(X(KA+M)-X(KA-M))*
     & DBLE(M+1))
      GA(KA+M)=-1.0$P 0-PI*DBLE(M+1)*PAR*COS(PI*(X(KA+M)-X(KA-M))*
     & DBLE(M+1))
      ENDIF
      IF(J.EQ.M) GA(KA-M)=-1.0$P 0+PI*DBLE(M+1)*PAR*COS(PI*X(KA-M)*
     & DBLE(M+1))
      RETURN
  270 GA(KA)=1.6$P 1*X(KA)
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      IF(I.EQ.1) THEN
      GA(KA)=GA(KA)-2.0$P 0*(X(KA+1)+1.0$P 0)-3.0$P 0*X(KA)*
     & (X(KA+1)-1.0$P 0)*PAR
      GA(KA+1)=-2.0$P 0*X(KA)-(X(KA+1)-1.0$P 0)-1.5$P 0*X(KA)**2*PAR
      ENDIF
      IF(I.GT.1.AND.I.LT.M) THEN
      GA(KA)=GA(KA)-2.0$P 0*(X(KA+1)+X(KA-1))-3.0$P 0*X(KA)*
     & (X(KA+1)-X(KA-1))*PAR
      GA(KA-1)=-2.0$P 0*X(KA)+(X(KA+1)-X(KA-1))+1.5$P 0*X(KA)**2*PAR
      GA(KA+1)=-2.0$P 0*X(KA)-(X(KA+1)-X(KA-1))-1.5$P 0*X(KA)**2*PAR
      ENDIF
      IF(I.EQ.M) THEN
      GA(KA)=GA(KA)-2.0$P 0*X(KA-1)+3.0$P 0*X(KA)*X(KA-1)*PAR
      GA(KA-1)=-2.0$P 0*X(KA)-X(KA-1)+1.5$P 0*X(KA)**2*PAR
      ENDIF
      IF(J.EQ.1) THEN
      GA(KA)=GA(KA)-2.0$P 0*(X(KA+M)+1.0$P 0)
      GA(KA+M)=-2.0$P 0*X(KA)-(X(KA+M)-1.0$P 0)
      ENDIF
      IF(J.GT.1.AND.J.LT.M) THEN
      GA(KA)=GA(KA)-2.0$P 0*(X(KA+M)+X(KA-M))
      GA(KA-M)=-2.0$P 0*X(KA)+(X(KA+M)-X(KA-M))
      GA(KA+M)=-2.0$P 0*X(KA)-(X(KA+M)-X(KA-M))
      ENDIF
      IF(J.EQ.M) THEN
      GA(KA)=GA(KA)-2.0$P 0*X(KA-M)
      GA(KA-M)=-2.0$P 0*X(KA)-X(KA-M)
      ENDIF
      RETURN
  280 GA(KA)=4.0$P 0
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      A1=PAR*DBLE(I)
      A2=PAR*DBLE(J)
      A3=0.0$P 0
      IF(I.GT.1) THEN
      GA(KA-1)=-1.0$P 0-2.0$P 1*PAR*X(KA)
      A3=A3-X(KA-1)
      ENDIF
      IF(I.LT.M) THEN
      GA(KA+1)=-1.0$P 0+2.0$P 1*PAR*X(KA)
      A3=A3+X(KA+1)
      ENDIF
      IF(J.GT.1) THEN
      GA(KA-M)=-1.0$P 0-2.0$P 1*PAR*X(KA)
      A3=A3-X(KA-M)
      ENDIF
      IF(J.LT.M) THEN
      GA(KA+M)=-1.0$P 0+2.0$P 1*PAR*X(KA)
      A3=A3+X(KA+M)
      ENDIF
      GA(KA)=GA(KA)+2.0$P 1*PAR*A3
      RETURN
  290 GA(KA)=2.0$P 1-PAR
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      IF (J.GT.2) THEN
        GA(KA-M-M)=1.0$P 0
      ENDIF
      IF (J.GT.1) THEN
        IF (I.GT.1) THEN
          GA(KA-M-1)=2.0$P 0
        ENDIF
        GA(KA-M)=-8.0$P 0
        IF (I.LT.M) THEN
          GA(KA-M+1)=2.0$P 0
        ENDIF
      ENDIF
      IF (I.GT.1) THEN
        IF (I.GT.2) THEN
          GA(KA-2)=1.0$P 0
        ENDIF
        GA(KA-1)=-8.0$P 0
      ENDIF
      IF (I.LT.M) THEN
        GA(KA+1)=-8.0$P 0
        IF (I.LT.M-1) THEN
          GA(KA+2)=1.0$P 0
        ENDIF
      ENDIF
      IF (J.LT.M) THEN
        IF (I.GT.1) THEN
          GA(KA+M-1)=2.0$P 0
        ENDIF
        GA(KA+M)=-8.0$P 0
        IF (I.LT.M) THEN
          GA(KA+M+1)=2.0$P 0
        ENDIF
      ENDIF
      IF (J.LT.M-1) THEN
        GA(KA+M+M)=1.0$P 0
      ENDIF
      RETURN
  300 H=0.5$P 0/$DBLE(M+2)
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      GA(KA)=2.0$P 1
      A1=0.0$P 0
      A2=0.0$P 0
      A3=0.0$P 0
      A4=0.0$P 0
      GA1(1)=0.0$P 0
      GA1(2)=0.0$P 0
      GA2(1)=0.0$P 0
      GA2(2)=0.0$P 0
      DO 301 K=1,6
      GA3(K)=0.0$P 0
      GA4(K)=0.0$P 0
  301 CONTINUE
      IF (J.GT.2) THEN
        GA(KA-M-M)=1.0$P 0
        GA4(1)=GA4(1)+1.0$P 0
        A4=A4+X(KA-M-M)
      ENDIF
      IF (J.GT.1) THEN
        IF (I.GT.1) THEN
          GA(KA-M-1)=2.0$P 0
          GA3(1)=GA3(1)+1.0$P 0
          GA4(2)=GA4(2)+1.0$P 0
          A3=A3+X(KA-M-1)
          A4=A4+X(KA-M-1)
        ENDIF
        GA(KA-M)=-8.0$P 0
        GA1(1)=GA1(1)-1.0$P 0
        A1=A1-X(KA-M)
        IF (I.LT.M) THEN
          GA(KA-M+1)=2.0$P 0
          GA3(2)=GA3(2)-1.0$P 0
          GA4(3)=GA4(3)+1.0$P 0
          A3=A3-X(KA-M+1)
          A4=A4+X(KA-M+1)
        ENDIF
      ENDIF
      IF (I.GT.1) THEN
        IF (I.GT.2) THEN
          GA(KA-2)=1.0$P 0
          GA3(3)=GA3(3)+1.0$P 0
          A3=A3+X(KA-2)
        ENDIF
        GA(KA-1)=-8.0$P 0
        GA2(1)=GA2(1)-1.0$P 0
        A2=A2-X(KA-1)
      ENDIF
      IF (I.LT.M) THEN
        GA(KA+1)=-8.0$P 0
        GA2(2)=GA2(2)+1.0$P 0
        A2=A2+X(KA+1)
        IF (I.LT.M-1) THEN
          GA(KA+2)=1.0$P 0
          GA3(4)=GA3(4)-1.0$P 0
          A3=A3-X(KA+2)
        ENDIF
      ENDIF
      IF (J.LT.M) THEN
        IF (I.GT.1) THEN
          GA(KA+M-1)=2.0$P 0
          GA3(5)=GA3(5)+1.0$P 0
          GA4(4)=GA4(4)-1.0$P 0
          A3=A3+X(KA+M-1)
          A4=A4-X(KA+M-1)
        ENDIF
        GA(KA+M)=-8.0$P 0
        GA1(2)=GA1(2)+1.0$P 0
        A1=A1+X(KA+M)
        IF (I.LT.M) THEN
          GA(KA+M+1)=2.0$P 0
          GA3(6)=GA3(6)-1.0$P 0
          GA4(5)=GA4(5)-1.0$P 0
          A3=A3-X(KA+M+1)
          A4=A4-X(KA+M+1)
        ENDIF
      ENDIF
      IF (J.LT.M-1) THEN
        GA(KA+M+M)=1.0$P 0
        GA4(6)=GA4(6)-1.0$P 0
        A4=A4-X(KA+M+M)
      ENDIF
      IF (J.EQ.M) THEN
        IF (I.GT.1) THEN
          A3=A3-H
          A4=A4+H
        ENDIF
        A1=A1-H
        IF (I.LT.M) THEN
          A3=A3+H
          A4=A4+H
        ENDIF
        A4=A4-H
      ENDIF
      IF (J.EQ.M-1) THEN
        A4=A4+H
      ENDIF
      IF (KA.GT.M+M)
     & GA(KA-M-M)=GA(KA-M-M)+0.25$P 0*PAR*(-A2*GA4(1))
      IF (KA.GT.M+1)
     & GA(KA-M-1)=GA(KA-M-1)+0.25$P 0*PAR*(+A1*GA3(1)-A2*GA4(2))
      IF (KA.GT.M)
     & GA(KA-M)=GA(KA-M)+0.25$P 0*PAR*(GA1(1)*A3)
      IF (KA.GT.M-1)
     & GA(KA-M+1)=GA(KA-M+1)+0.25$P 0*PAR*(+A1*GA3(2)-A2*GA4(3))
      IF (KA.GT.2)
     & GA(KA-2)=GA(KA-2)+0.25$P 0*PAR*(+A1*GA3(3))
      IF (KA.GT.1)
     & GA(KA-1)=GA(KA-1)+0.25$P 0*PAR*(-GA2(1)*A4)
      IF (KA.LE.N-1)
     & GA(KA+1)=GA(KA+1)+0.25$P 0*PAR*(-GA2(2)*A4)
      IF (KA.LE.N-2)
     & GA(KA+2)=GA(KA+2)+0.25$P 0*PAR*(+A1*GA3(4))
      IF (KA.LE.N-M+1)
     & GA(KA+M-1)=GA(KA+M-1)+0.25$P 0*PAR*(+A1*GA3(5)-A2*GA4(4))
      IF (KA.LE.N-M)
     & GA(KA+M)=GA(KA+M)+0.25$P 0*PAR*(GA1(2)*A3)
      IF (KA.LE.N-M-1)
     & GA(KA+M+1)=GA(KA+M+1)+0.25$P 0*PAR*(+A1*GA3(6)-A2*GA4(5))
      IF (KA.LE.N-M-M)
     & GA(KA+M+M)=GA(KA+M+M)+0.25$P 0*PAR*(-A2*GA4(6))
      RETURN
  310 H=1.0$P 0/$DBLE(N+1)
      A1=$DBLE(KA)*H
      A2=(A1-0.5$P 0)**2
      IF (A1.GE.0.5$P 0) THEN
      A3= 1.0$P 6
      ELSE
      A3=-1.0$P 6
      ENDIF
      IF (KA.LT.2) THEN
      GA(KA)=2.0$P 0+
     & H**2*(3.0$P 0*X(KA)**2*EXP(X(KA))+X(KA)**3*EXP(X(KA)))
      GA(KA+1)=-1.0$P 0+
     & H**2*5.0$P 8*EXP(-1.0$P 4*A2)*SQRT(ABS(A1-0.5$P 0))
      ELSEIF (KA.LT.N) THEN
      GA(KA-1)=-1.0$P 0-
     & H**2*5.0$P 8*EXP(-1.0$P 4*A2)*SQRT(ABS(A1-0.5$P 0))
      GA(KA)=2.0$P 0+
     & H**2*(3.0$P 0*X(KA)**2*EXP(X(KA))+X(KA)**3*EXP(X(KA)))
      GA(KA+1)=-1.0$P 0+
     & H**2*5.0$P 8*EXP(-1.0$P 4*A2)*SQRT(ABS(A1-0.5$P 0))
      ELSE
      GA(KA-1)=-1.0$P 0+
     & H**2*5.0$P 8*EXP(-1.0$P 4*A2)*SQRT(ABS(A1-0.5$P 0))
      GA(KA)=2.0$P 0+
     & H**2*(3.0$P 0*X(KA)**2*EXP(X(KA))+X(KA)**3*EXP(X(KA)))
      ENDIF
      RETURN
  320 H=1.0$P 0/DBLE(N+1)
      A1=DBLE(KA)*H
      A2=(A1-0.5$P 0)**2
      IF (KA.LT.2) THEN
      GA(KA+1)=-1.0$P 0
      GA(KA)=2.0$P 0+H**2*(3*X(KA)**2+2.0$P-4*(2.0$P-4*A2-1.0$P 0))
      ELSEIF (KA.LT.N) THEN
      GA(KA-1)=-1.0$P 0
      GA(KA)=2.0$P 0+H**2*(3*X(KA)**2+2.0$P-4*(2.0$P-4*A2-1.0$P 0))
      GA(KA+1)=-1.0$P 0
      ELSE
      GA(KA-1)=-1.0$P 0
      GA(KA)=2.0$P 0+H**2*(3*X(KA)**2+2.0$P-4*(2.0$P-4*A2-1.0$P 0))
      ENDIF
      RETURN
       GOTO (401,402,403,404,405,406,407,408,409,412,413,414,
     & 419,420,421,422,423,424,426,427,428,429,430,431,432),NEXT
401   IF(KA.EQ.1) THEN
      GA(1)=-1.0$P 0
      DO 3010 J=2,N
        GA(J)=0.0$P 0
3010  CONTINUE
      ELSE
      S=20.0$P 0*$DBLE(KA-1)*(X(KA)-X(KA-1))
      DO 3020 J=1,N
        IF(J.EQ.KA) THEN
           GA(J)=S
        ELSE IF(J.EQ.KA-1) THEN
           GA(J)=-S
        ELSE
          GA(J)=0.0$P 0
        ENDIF
3020  CONTINUE
      ENDIF
      RETURN
402   IF(KA.EQ.N) THEN
        GA(1)=-0.20$P 0*X(1)
        N1=N-1
        DO 3030 J=2,N1
           GA(J)=0.0$P 0
3030    CONTINUE
        GA(N)=1.0$P 0
      ELSE
        DO 3050 J=1,N
           IF(J.EQ.KA) THEN
              GA(J)=1.0$P 0
           ELSE IF(J.EQ.KA+1) THEN
              GA(J)=-0.2$P 0*X(KA+1)
           ELSE
              GA(J)=0.0$P 0
           ENDIF
3050    CONTINUE
      ENDIF
      RETURN
403   IF(KA.EQ.N) THEN
        DO 3070 J=1,N
           T=1.0$P 0
           DO 3060 K=1,N
              IF(K.NE.J) T=T*X(K)
3060       CONTINUE
        GA(J)=T
3070    CONTINUE
      ELSE
        DO 3080 J=1,N
           IF(J.EQ.KA) THEN
              GA(J)=2.0$P 0
           ELSE
              GA(J)=1.0$P 0
           ENDIF
3080    CONTINUE
      ENDIF
      RETURN
404   DO 3090 J=1,N
        IF(J.EQ.KA.AND.KA/2*2.EQ.KA) THEN
           GA(J)=10.0$P 0
        ELSE IF(J.EQ.KA) THEN
          GA(J)=-1.0$P 0
        ELSE IF(J.EQ.KA-1.AND.KA/2*2.EQ.KA) THEN
           GA(J)=-20.0$P 0*X(KA-1)
        ELSE
           GA(J)=0.0$P 0
        ENDIF
3090  CONTINUE
      RETURN
405   DO 4000 J=1,N
        IF(J.EQ.KA) THEN
           GA(J)=1.0$P 0-3.0$P 0*X(KA)**2/(2.0$P 0*$DBLE(N))
        ELSE
           GA(J)=-3.0$P 0*X(J)**2/(2.0$P 0*$DBLE(N))
        ENDIF
4000  CONTINUE
      RETURN
406   DO 4010 J=1,N
        IF(J.EQ.KA) THEN
           GA(J)=-2.0$P 0-1.0$P 0/$DBLE(N+1)**2*EXP(X(KA))
        ELSE IF(J.EQ.KA-1.OR.J.EQ.KA+1) THEN
           GA(J)=1.0$P 0
        ELSE
           GA(J)=0.0$P 0
        ENDIF
4010  CONTINUE
      RETURN
407   S=0.1$P 0
      DO 4020 J=1,N
        IF(J.EQ.KA-1) THEN
           GA(J)=-1.0$P 0
        ELSE IF(J.EQ.KA) THEN
           GA(J)=3.0$P 0-2.0$P 0*S*X(KA)
        ELSE IF(J.EQ.KA+1) THEN
           GA(J)=-2.0$P 0
        ELSE
           GA(J)=0.0$P 0
        ENDIF
4020  CONTINUE
      RETURN
408   S1=1.0$P 0
      S2=1.0$P 0
      S3=1.0$P 0
      J1=3
      J2=3
      IF(KA-J1.GT.1) THEN
        I1=KA-J1
      ELSE
        I1=1
      ENDIF
      IF(KA+J2.LT.N) THEN
        I2=KA+J2
      ELSE
        I2=N
      ENDIF
      DO 4030 J=1,N
        IF(J.EQ.KA) THEN
           GA(J)=S1+3.0$P 0*S2*X(KA)**2
        ELSE IF(J.GE.I1.AND.J.LE.I2) THEN
           GA(J)=-S3*(1.0$P 0+2.0$P 0*X(J))
        ELSE
           GA(J)=0.0$P 0
        ENDIF
4030  CONTINUE
      RETURN
409   DO 4040 J=1,N
        IF(KA.EQ.1.AND.J.EQ.1) THEN
           GA(J)=2.0$P 0*X(1)
        ELSE IF(KA.EQ.1) THEN
           GA(J)=0.0$P 0
        ELSE IF(J.EQ.KA-1) THEN
           GA(J)=2.0$P 0*X(KA-1)
        ELSE IF(J.EQ.KA) THEN
           GA(J)=1.0$P 0/X(KA)
        ELSE
           GA(J)=0.0$P 0
        ENDIF
4040  CONTINUE
      RETURN
412   DO 4080 J=1,N
        IF(J.EQ.KA) THEN
           GA(J)=1.0$P 0
        ELSE IF(J.EQ.KA-1) THEN
           GA(J)=-SIN(X(KA-1))
        ELSE
           GA(J)=0.0$P 0
        ENDIF
4080  CONTINUE
      RETURN
413   S=(1.0$P 0/$DBLE(N+1))**2
      DO 4090 J=1,N
        IF(J.EQ.KA-1.OR.J.EQ.KA+1) THEN
           GA(J)=-1.0$P 0
        ELSE IF(J.EQ.KA) THEN
           GA(J)=2.0$P 0+S*(1.0$P 0+COS(X(J)))
        ELSE
           GA(J)=0.0$P 0
        ENDIF
4090  CONTINUE
      RETURN
414   IF(KA-5.GT.1) THEN
        I1=KA-5
      ELSE
        I1=1
      ENDIF
      IF(KA+1.LT.N) THEN
        I2=KA+1
      ELSE
        I2=N
      ENDIF
      DO 5000 J=1,N
        IF(J.EQ.KA) THEN
           GA(J)=2.0$P 0+15.0$P 0*X(J)**2
        ELSE IF(J.GE.I1.AND.J.LE.I2) THEN
           GA(J)=-1.0$P 0-2.0$P 0*X(J)
        ELSE
           GA(J)=0.0$P 0
        ENDIF
5000  CONTINUE
      RETURN
419   S=1.0$P 0/$DBLE(N+1)
      S1=3.0$P 0*S/2.0$P 0
      T1=$DBLE(KA)*S
      DO 5050 J=1,N
        T2=$DBLE(J)*S
        IF(J.LT.KA) THEN
           GA(J)=S1*(1.0$P 0-T1)*T2*(X(J)+T2+1.0$P 0)**2
        ELSE IF(J.EQ.KA) THEN
           GA(J)=1.0$P 0+S1*(1.0$P 0-T1)*T2*(X(J)+T2+1.0$P 0)**2
        ELSE
           GA(J)=S1*(1.0$P 0-T2)*T1*(X(J)+T2+1.0$P 0)**2
        ENDIF
5050  CONTINUE
      RETURN
420   DO 5060 J=1,N
        S=SIN(X(J))
        IF(J.EQ.KA) THEN
           GA(J)=S+$DBLE(KA)*S-COS(X(J))
        ELSE
           GA(J)=S
        ENDIF
5060  CONTINUE
      RETURN
421   S=0.0$P 0
      DO 5070 J=1,N
        S=S+$DBLE(J)*(X(J)-1.0$P 0)
5070  CONTINUE
      DO 5080 J=1,N
        IF(J.NE.KA) THEN
           GA(J)=$DBLE(KA*J)*(1.0$P 0+6.0$P 0*S*S)
        ELSE
           GA(J)=1.0$P 0+$DBLE(KA*KA)*(1.0$P 0+6.0$P 0*S*S)
        ENDIF
5080  CONTINUE
      RETURN
422   DO 5090 J=1,N
        IF(J.EQ.KA-1) THEN
           GA(J)=-1.0$P 0
        ELSE IF(J.EQ.KA)THEN
           GA(J)=3.$P 0-4.$P 0*X(KA)
        ELSE IF(J.EQ.KA+1) THEN
           GA(J)=-2.0$P 0
        ELSE
           GA(J)=0.0$P 0
        ENDIF
5090  CONTINUE
      RETURN
423   ALF=5
      BET=14
      DO 6000 J=1,N
        IF(J.NE.KA) THEN
        T=SQRT(X(J)**2+$DBLE(KA)/$DBLE(J))
        S1=LOG(T)
        GA(J)=X(J)*(SIN(S1)**ALF+COS(S1)**ALF+
     +     ALF*SIN(S1)**(ALF-1)*COS(S1)-
     +     ALF*SIN(S1)*COS(S1)**(ALF-1))/T
        ELSE
          GA(J)=$DBLE(BET*N)
        ENDIF
6000  CONTINUE
      RETURN
424   C=0.5$P 0
      H=1.0$P 0/$DBLE(N)
      DO 6008 J=1,N
        BROW(J)=C*H*$DBLE(KA)/$DBLE(2*(KA+J))
6008  CONTINUE
      BROW(N)=0.5$P 0*BROW(N)
      DO 6010 J=1,N
        IF(KA.NE.J) THEN
           GA(J)=-BROW(J)*X(KA)
        ELSE
           T=1.0$P 0-C*H/4.0$P 0
           DO 6011 L=1,N
             IF(L.EQ.KA) THEN
               T=T-2.0$P 0*BROW(KA)*X(KA)
             ELSE
               T=T-BROW(L)*X(L)
             ENDIF
6011       CONTINUE
           GA(J)=T
        ENDIF
6010  CONTINUE
      RETURN
426   T=10.0$P 0
      H=(T/$DBLE(N+1))**2
      S=T*X(KA)
      DO 6030 J=1,N
        IF(J.EQ.KA-1.OR.J.EQ.KA+1) THEN
           GA(J)=-1.0$P 0
        ELSEIF(J.EQ.KA) THEN
           GA(J)=2.0$P 0+H*(EXP(S)+EXP(-S))/2.$P 0
        ELSE
           GA(J)=0.0$P 0
        ENDIF
6030  CONTINUE
      RETURN
427   S=0.5$P 0
      H=1.0$P 0/$DBLE(N+1)
      DO 6040 J=1,N
        IF(J.EQ.KA-1) THEN
           GA(J)=-1.0$P 0+H/(2.0$P 0*S)
        ELSEIF(J.EQ.KA+1) THEN
           GA(J)=-1.0$P 0-H/(2.0$P 0*S)
        ELSEIF(J.EQ.KA) THEN
           GA(J)=2.0$P 0*(1.0$P 0-H**2*X(KA)/S)
        ELSE
           GA(J)=0.0$P 0
        ENDIF
6040  CONTINUE
      RETURN
428   S=0.5$P 0
      H=1.0$P 0/$DBLE(N+1)
      T1=2.0$P 0*H
      S1=H**2/S
      S2=1.0$P 0-$DBLE(KA)*H
      DO 6050 J=1,KA
        BROW(J)=$DBLE(J)*S2
6050  CONTINUE
      IF(KA.EQ.N) GOTO 6055
      DO 6051 J=KA+1,N
        BROW(J)=$DBLE(KA)*(1.0$P 0-$DBLE(J)*H)
6051  CONTINUE
6055  GA(1)=-S1*(BROW(1)*2.0$P 0*X(1)-BROW(2)/T1)
      GA(N)=-S1*(BROW(N-1)/T1+BROW(N)*2.0$P 0*X(N))
      DO 6052 J=2,N-1
        GA(J)=-S1*((BROW(J-1)-BROW(J+1))/T1+BROW(J)*2.0$P 0*X(J))
6052  CONTINUE
      GA(KA)=1.0$P 0+GA(KA)
      RETURN
429   A=-9.0$P-3
      B=1.0$P-3
      AL=0.0$P 0
      BE=25.0$P 0
      QA=20.0$P 0
      CA=0.3$P 0
      CB=0.3$P 0
      H=(B-A)/$DBLE(N+1)
      S=$DBLE(KA)/$DBLE(N+1)
      H=H**2
      U=AL*(1.0$P 0-S)+BE*S+X(KA)
      FF=QA*(CB*EXP(QA*(U-BE))+CA*EXP(QA*(AL-U)))
      DO 6060 J=1,N
        IF(J.EQ.KA-1.OR.J.EQ.KA+1) THEN
           GA(J)=-1.0$P 0
        ELSEIF(J.EQ.KA) THEN
           GA(J)=2.0$P 0+H*FF
        ELSE
           GA(J)=0.0$P 0
        ENDIF
6060  CONTINUE
      RETURN
430   N1=N/2
      DO 6070 J=1,N
        GA(J)=0.0$P 0
6070  CONTINUE
      H=1.0$P 0/$DBLE(N1+1)**2
      IF(KA.EQ.1) THEN
        GA(KA)=2.0$P 0+H*(2.0$P 0*X(KA)+1.0$P 0)
        GA(KA+1)=-1.0$P 0
        GA(N1+1)=H*0.2$P 0*X(N1+KA)
      ELSE IF(KA.EQ.N1+1) THEN
        GA(1)=H*0.4$P 0*X(1)
        GA(KA)=2.0$P 0+H*(2.0$P 0*X(KA)+2.0$P 0)
        GA(KA+1)=-1.0$P 0
      ELSE IF(KA.EQ.N1) THEN
        GA(KA-1)=-1.0$P 0
        GA(KA)=2.0$P 0+H*(2.0$P 0*X(KA)+1.0$P 0)
        GA(N1+KA)=H*0.2$P 0*X(N1+KA)
      ELSE IF(KA.EQ.N) THEN
        GA(N1)=H*0.4$P 0*X(N1)
        GA(KA-1)=-1.0$P 0
        GA(KA)=2.0$P 0+H*(2.0$P 0*X(KA)+2.0$P 0)
      ELSE IF(KA.LT.N1) THEN
        GA(KA-1)=-1.0$P 0
        GA(KA)=2.0$P 0+H*(2.0$P 0*X(KA)+1.0$P 0)
        GA(KA+1)=-1.0$P 0
        GA(N1+KA)=H*0.2$P 0*X(N1+KA)
      ELSE
         GA(KA-N1)=H*0.4$P 0*X(KA-N1)
         GA(KA-1)=-1.0$P 0
         GA(KA)=2.0$P 0+H*(2.0$P 0*X(KA)+2.0$P 0)
         GA(KA+1)=-1.0$P 0
      ENDIF
      RETURN
431   ND=INT(SQRT($DBLE(N)))
      L=MOD(KA,ND)
      IF(L.EQ.0) THEN
         K=KA/ND
         L=ND
      ELSE
         K=INT(KA/ND)+1
      ENDIF
      LA=1.0$P 0
      H=1.0$P 0/$DBLE(ND+1)
      H2=LA*H*H
      DO 2010 J=1,N
        GA(J)=0.0$P 0
2010  CONTINUE
      IF(L.EQ.1.AND.K.EQ.1) THEN
         GA(1)=4.0$P 0+H2*EXP(X(1))
         GA(2)=-1.0$P 0
         GA(ND+1)=-1.0$P 0
      ENDIF
      IF(1.LT.L.AND.L.LT.ND.AND.K.EQ.1) THEN
         GA(L)=4.0$P 0+H2*EXP(X(L))
         GA(L-1)=-1.0$P 0
         GA(L+1)=-1.0$P 0
         GA(L+ND)=-1.0$P 0
      ENDIF
      IF(L.EQ.ND.AND.K.EQ.1) THEN
         GA(ND)=4.0$P 0+H2*EXP(X(ND))
         GA(ND-1)=-1.0$P 0
         GA(ND+ND)=-1.0$P 0
      ENDIF
      IF(L.EQ.1.AND.1.LT.K.AND.K.LT.ND) THEN
         GA(KA)=4.0$P 0+H2*EXP(X(KA))
         GA(KA-ND)=-1.0$P 0
         GA(KA+1)=-1.0$P 0
         GA(KA+ND)=-1.0$P 0
      ENDIF
      IF(L.EQ.ND.AND.1.LT.K.AND.K.LT.ND) THEN
         GA(KA)=4.0$P 0+H2*EXP(X(KA))
         GA(KA-ND)=-1.0$P 0
         GA(KA-1)=-1.0$P 0
         GA(KA+ND)=-1.0$P 0
      ENDIF
      IF(L.EQ.1.AND.K.EQ.ND) THEN
         GA(KA)=4.0$P 0+H2*EXP(X(KA))
         GA(KA-ND)=-1.0$P 0
         GA(KA+1)=-1.0$P 0
      ENDIF
      IF(1.LT.L.AND.L.LT.ND.AND.K.EQ.ND) THEN
         GA(KA)=4.0$P 0+H2*EXP(X(KA))
         GA(KA-ND)=-1.0$P 0
         GA(KA-1)=-1.0$P 0
         GA(KA+1)=-1.0$P 0
      ENDIF
      IF(L.EQ.ND.AND.K.EQ.ND) THEN
         GA(KA)=4.0$P 0+H2*EXP(X(KA))
         GA(KA-ND)=-1.0$P 0
         GA(KA-1)=-1.0$P 0
      ENDIF
      IF(1.LT.L.AND.L.LT.ND.AND.1.LT.K.AND.K.LT.ND) THEN
         GA(KA)=4.0$P 0+H2*EXP(X(KA))
         GA(KA-ND)=-1.0$P 0
         GA(KA-1)=-1.0$P 0
         GA(KA+1)=-1.0$P 0
         GA(KA+ND)=-1.0$P 0
      ENDIF
      RETURN
432   ND=INT(SQRT($DBLE(N)))
      L=MOD(KA,ND)
      IF(L.EQ.0) THEN
         K=KA/ND
         L=ND
      ELSE
         K=INT(KA/ND)+1
      ENDIF
      H=1.0$P 0/$DBLE(ND+1)
      H2=H*H
      DO 2020 J=1,N
        GA(J)=0.0$P 0
2020  CONTINUE
      IF(L.EQ.1.AND.K.EQ.1) THEN
         GA(1)=4.0$P 0+H2*X(1)*2.0$P 0
         GA(2)=-1.0$P 0
         GA(ND+1)=-1.0$P 0
      ENDIF
      IF(1.LT.L.AND.L.LT.ND.AND.K.EQ.1) THEN
         GA(L)=4.0$P 0+H2*X(L)*2.0$P 0
         GA(L-1)=-1.0$P 0
         GA(L+1)=-1.0$P 0
         GA(L+ND)=-1.0$P 0
      ENDIF
      IF(L.EQ.ND.AND.K.EQ.1) THEN
         GA(ND)=4.0$P 0+H2*X(ND)*2.0$P 0
         GA(ND-1)=-1.0$P 0
         GA(ND+ND)=-1.0$P 0
      ENDIF
      IF(L.EQ.1.AND.1.LT.K.AND.K.LT.ND) THEN
         GA(KA)=4.0$P 0+H2*X(KA)*2.0$P 0
         GA(KA-ND)=-1.0$P 0
         GA(KA+1)=-1.0$P 0
         GA(KA+ND)=-1.0$P 0
      ENDIF
      IF(L.EQ.ND.AND.1.LT.K.AND.K.LT.ND) THEN
         GA(KA)=4.0$P 0+H2*X(KA)*2.0$P 0
         GA(KA-ND)=-1.0$P 0
         GA(KA-1)=-1.0$P 0
         GA(KA+ND)=-1.0$P 0
      ENDIF
      IF(L.EQ.1.AND.K.EQ.ND) THEN
         GA(KA)=4.0$P 0+H2*X(KA)*2.0$P 0
         GA(KA-ND)=-1.0$P 0
         GA(KA+1)=-1.0$P 0
      ENDIF
      IF(1.LT.L.AND.L.LT.ND.AND.K.EQ.ND) THEN
         GA(KA)=4.0$P 0+H2*X(KA)*2.0$P 0
         GA(KA-ND)=-1.0$P 0
         GA(KA-1)=-1.0$P 0
         GA(KA+1)=-1.0$P 0
      ENDIF
      IF(L.EQ.ND.AND.K.EQ.ND) THEN
         GA(KA)=4.0$P 0+H2*X(KA)*2.0$P 0
         GA(KA-ND)=-1.0$P 0
         GA(KA-1)=-1.0$P 0
      ENDIF
      IF(1.LT.L.AND.L.LT.ND.AND.1.LT.K.AND.K.LT.ND) THEN
         GA(KA)=4.0$P 0+H2*X(KA)*2.0$P 0
         GA(KA-ND)=-1.0$P 0
         GA(KA-1)=-1.0$P 0
         GA(KA+1)=-1.0$P 0
         GA(KA+ND)=-1.0$P 0
      ENDIF
      RETURN
  550 IF (MOD(KA,2).EQ.1) THEN
      GA(KA)=0.0$P 0
      IF (KA.NE.1) THEN
      D1S=COS(X(KA-2)-X(KA-1)-X(KA))*SIN(X(KA-2)+X(KA-1)-X(KA))
      D2S=SIN(X(KA-2)-X(KA-1)-X(KA))*COS(X(KA-2)+X(KA-1)-X(KA))
      GA(KA-2)=-18.0$P 0*(X(KA-2)-X(KA))**2-2.0$P 0*(D1S+D2S)
      GA(KA-1)=-4.0$P 0+2.0$P 0*(D1S-D2S)
      GA(KA)=GA(KA)+18.0$P 0*(X(KA-2)-X(KA))**2+2.0$P 0*(D1S+D2S)
      ENDIF
      IF (KA.NE.N) THEN
      D1S=COS(X(KA)-X(KA+1)-X(KA+2))*SIN(X(KA)+X(KA+1)-X(KA+2))
      D2S=SIN(X(KA)-X(KA+1)-X(KA+2))*COS(X(KA)+X(KA+1)-X(KA+2))
      GA(KA)=GA(KA)+9.0$P 0*(X(KA)-X(KA+2))**2+D1S+D2S
      GA(KA+1)=2.0$P 0-D1S+D2S
      GA(KA+2)=-9.0$P 0*(X(KA)-X(KA+2))**2-D1S-D2S
      ENDIF
      ELSE
      EX=EXP(X(KA-1)-X(KA)-X(KA+1))
      W=X(KA-1)-X(KA+1)
      GA(KA-1)=-EX-W*EX
      GA(KA)=4.0$P 0+W*EX
      GA(KA+1)=EX+W*EX
      ENDIF
      RETURN
  560 W=0.0$P 0
      DO 561 I=1,N-1
      W=W+($DBLE(KA)/$DBLE(KA+I))*X(I)
  561 CONTINUE
      W=W+0.5$P 0+0.5$P 0*$DBLE(KA)/$DBLE(KA+N)*X(N)
      DO 562 I=1,N
      GA(I)=-0.4$P 0/$DBLE(N)*X(KA)*$DBLE(KA)/$DBLE(KA+I)
  562 CONTINUE
      GA(N)=0.5$P 0*GA(N)
      GA(KA)=GA(KA)+1.0$P 0-0.4$P 0*W/$DBLE(N)
      RETURN
  590 IF (KA.LT.2) THEN
      GA(KA)=4.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)+1.0$P 0
      GA(KA+3)=-2.0$P 0*X(KA+3)
      ELSE IF (KA.LT.3) THEN
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)+1.0$P 0
      GA(KA+3)=-2.0$P 0*X(KA+3)
      ELSE IF (KA.LT.4) THEN
      GA(KA-2)=2.0$P 0*X(KA-2)-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)+1.0$P 0
      GA(KA+3)=-2.0$P 0*X(KA+3)
      ELSE IF (KA.LT.N-2) THEN
      GA(KA-3)=-1.0$P 0
      GA(KA-2)=2.0$P 0*X(KA-2)-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)+1.0$P 0
      GA(KA+3)=-2.0$P 0*X(KA+3)
      ELSE IF (KA.LT.N-1) THEN
      GA(KA-3)=-1.0$P 0
      GA(KA-2)=2.0$P 0*X(KA-2)-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      GA(KA+2)=-2.0$P 0*X(KA+2)+1.0$P 0
      ELSE IF (KA.LT.N) THEN
      GA(KA-3)=-1.0$P 0
      GA(KA-2)=2.0$P 0*X(KA-2)-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+6.0$P 0
      GA(KA+1)=-8.0$P 0*X(KA+1)+1.0$P 0
      ELSE
      GA(KA-3)=-1.0$P 0
      GA(KA-2)=2.0$P 0*X(KA-2)-1.0$P 0
      GA(KA-1)=-8.0$P 0*X(KA)+2.0$P 0*X(KA-1)
      GA(KA)=24.0$P 0*X(KA)**2-8.0$P 0*X(KA-1)+2.0$P 0
      ENDIF
      RETURN
  600 IF (KA.LE.N-2) THEN
      B=X(1)
      W=$DBLE(KA)/$DBLE(N-2)
      DO 602 J=2,N
      B=B+X(J)*W**(J-1)
  602 CONTINUE
      DO 603 J=2,N
      GA(J)=$DBLE(J-1)*W**(J-2)-2.0$P 0*B*W**(J-1)
  603 CONTINUE
      GA(1)=-2.0$P 0*B
      ELSE IF (KA.EQ.N-1) THEN
      GA(1)=1.0$P 0
      ELSE IF (KA.EQ.N) THEN
      GA(1)=-2.0$P 0*X(1)
      GA(2)=1.0$P 0
      ENDIF
      RETURN
  610 IF(MOD(KA,2).EQ.1) THEN
      GA(KA)=-2.0$P 1*X(KA)
      GA(KA+1)=10.$P 0
      ELSE
      GA(KA-1)=-1.0$P 0
      ENDIF
      RETURN
  670 GA(1)=0.0$P 0
      GA(KA)=16.0$P 0*(X(KA)**2-X(1))*X(KA)-2.0$P 0*(X(KA)-1.0$P 0)
      GA(1)=GA(1)-8.0$P 0*(X(KA)**2-X(1)) 
      RETURN
  690 U=1.0$P 0/$DBLE(N+1)
      V=$DBLE(KA)*U
      DO 691 J=1,N
      W=$DBLE(J)*U
      A=(X(J)+W+1.0$P 0)**2
      IF(J.LE.KA) THEN
      GA(J)=1.5$P 0*U*(1.0$P 0-V)*W*A
      ELSE
      GA(J)=1.5$P 0*U*(1.0$P 0-W)*V*A
      ENDIF
  691 CONTINUE
      GA(KA)=GA(KA)+1.0$P 0
      RETURN
  710 A=2.0$P 0*SQRT($DBLE(KA))
      I1=MOD(2*KA-1,N)+1
      I2=MOD(3*KA-1,N)+1
      I3=MOD(5*KA-1,N)+1
      I4=MOD(7*KA-1,N)+1
      I5=MOD(11*KA-1,N)+1
      GA(KA)=GA(KA)+A*X(KA)
      GA(I1)=GA(I1)+A*X(I1)      
      GA(I2)=GA(I2)+A*X(I2)
      GA(I3)=GA(I3)+A*X(I3)
      GA(I4)=GA(I4)+A*X(I4)
      GA(I5)=GA(I5)+A*X(I5)
      RETURN
  720 A=SQRT($DBLE(KA)) 
      I1=MOD(2*KA-1,N)+1
      I2=MOD(3*KA-1,N)+1
      I3=MOD(5*KA-1,N)+1
      I4=MOD(7*KA-1,N)+1
      I5=MOD(11*KA-1,N)+1
      GA(KA)=GA(KA)+A*COS(X(KA))
      GA(I1)=GA(I1)+A*COS(X(I1))      
      GA(I2)=GA(I2)+A*COS(X(I2))
      GA(I3)=GA(I3)+A*COS(X(I3))
      GA(I4)=GA(I4)+A*COS(X(I4))
      GA(I5)=GA(I5)+A*COS(X(I5))
      RETURN
      END
