* SUBROUTINE EAHB15             ALL SYSTEMS                04/10/01
C PORTABILITY : ALL SYSTEMS
C 04/10/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  HESSIAN MATRICES OF TEST FUNCTIONS FOR NONLINEAR APPROXIMATION.
*  SPARSE VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  II  MHA  NUMBER OF NONZERO ELEMENTS IN HESSIAN MATRIX.
*  RO  HA(MHA) HESSIAN MATRIX OF THE APPROXIMATED FUNCTION
*          AT THE SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAHB15(N,MHA,KA,X,HA,NEXT)
      INTEGER N,MHA,KA,NEXT
      INTEGER WD,I,J,K,L,M,IA,IB,IC
      $FLOAT X(N),HA(MHA)
      $FLOAT A,B,C,D,E,S,Q
      $FLOAT Y(20)
      COMMON /EMPR15/ Y
C      GOTO(10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
C     & 170,180,190,200,210,220,260,270),NEXT
      GOTO(10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     & 170,180,190,200,210,220),NEXT
   10 I=(KA+1)/2
      IF (MOD(KA,2).EQ.1) THEN
        HA(1)=2.0$P 1
        HA(2)=0.0$P 0
        HA(3)=0.0$P 0
      ELSE
        HA(1)=0.0$P 0
      ENDIF
      RETURN
   20 I=2*((KA+5)/6)
      A=SQRT(9.0$P 1)
      IF (MOD(KA,6).EQ.1) THEN
        HA(1)=2.0$P 1
        HA(2)=0.0$P 0
        HA(3)=0.0$P 0
      ELSEIF (MOD(KA,6).EQ.2) THEN
        HA(1)=0.0$P 0
      ELSEIF (MOD(KA,6).EQ.3) THEN
        HA(1)=2.0$P 0*A
        HA(2)=0.0$P 0
        HA(3)=0.0$P 0
      ELSEIF (MOD(KA,6).EQ.4) THEN
        HA(1)=0.0$P 0
      ELSEIF (MOD(KA,6).EQ.5) THEN
        HA(1)=0.0$P 0
        HA(2)=0.0$P 0
        HA(3)=0.0$P 0
      ELSE
        HA(1)=0.0$P 0
        HA(2)=0.0$P 0
        HA(3)=0.0$P 0
      ENDIF
      RETURN
   30 I=2*((KA+3)/4)      
      IF (MOD(KA,4).EQ.1) THEN
        HA(1)=0.0$P 0
        HA(2)=0.0$P 0
        HA(3)=0.0$P 0
      ELSEIF (MOD(KA,4).EQ.2) THEN
        HA(1)=0.0$P 0
        HA(2)=0.0$P 0
        HA(3)=0.0$P 0
      ELSEIF (MOD(KA,4).EQ.3) THEN
        HA(1)=2.0$P 0
        HA(2)=-4.0$P 0
        HA(3)=8.0$P 0
      ELSE
        A=2.0$P 0*SQRT(1.0$P 1)
        HA(1)=A
        HA(2)=-A
        HA(3)=A
      ENDIF
      RETURN
   40 I=2*((KA+4)/5)
      IF (MOD(KA,5).EQ.1) THEN
        A=EXP(X(I-1))
        HA(1)=(4.0$P 0*A-2.0$P 0*X(I))*A
        HA(2)=-2.0$P 0*A
        HA(3)=2.0$P 0
      ELSEIF (MOD(KA,5).EQ.2) THEN
        A=6.0$P 1*(X(I)-X(I+1))
        HA(1)=A
        HA(2)=-A
        HA(3)=A
      ELSEIF (MOD(KA,5).EQ.3) THEN
        A=X(I+1)-X(I+2)
        S=SIN(A)
        C=COS(A)
        Q=2.0$P 0*(C**2+3.0$P 0*S**2)/C**4
        HA(1)=Q
        HA(2)=-Q
        HA(3)=Q
      ELSEIF (MOD(KA,5).EQ.4) THEN
        HA(1)=1.2$P 1*X(I-1)**2
      ELSE
        HA(1)=0.0$P 0
      ENDIF
      RETURN
   50 I=KA
      IF (I.EQ.1) THEN
        HA(1)=-4.0$P 0
        HA(2)=0.0$P 0
        HA(3)=0.0$P 0
      ELSE
        HA(1)=0.0$P 0
        HA(2)=0.0$P 0
        HA(3)=-4.0$P 0
        IF (I.LT.N) THEN
          HA(4)=0.0$P 0
          HA(5)=0.0$P 0
          HA(6)=0.0$P 0
        ENDIF
      ENDIF
      RETURN    
   60 I=KA
      WD=MIN(N,I+1)-MAX(1,I-5)+1
      WD=ABS(WD*(WD+1)/2.0$P 0)      
      DO 61 J=1,WD
        HA(J)=0.0$P 0
   61 CONTINUE
      IF (I.EQ.1) THEN
        HA(1)=2.0$P 0+3.0$P 1*X(I)
        IF (KA.LT.N) HA(3)=2.0$P 0
      ELSEIF (I.EQ.2) THEN
        HA(1)=2.0$P 0
        HA(3)=2.0$P 0+3.0$P 1*X(I)
        IF (KA.LT.N) HA(6)=2.0$P 0
      ELSEIF (I.EQ.3) THEN
        HA(1)=2.0$P 0
        HA(3)=2.0$P 0
        HA(6)=2.0$P 0+3.0$P 1*X(I)
        IF (KA.LT.N) HA(10)=2.0$P 0
      ELSEIF (I.EQ.4) THEN
        HA(1)=2.0$P 0
        HA(3)=2.0$P 0
        HA(6)=2.0$P 0
        HA(10)=2.0$P 0+3.0$P 1*X(I)
        IF (I.LT.N) HA(15)=2.0$P 0
      ELSEIF (I.EQ.5) THEN
        HA(1)=2.0$P 0
        HA(3)=2.0$P 0
        HA(6)=2.0$P 0
        HA(10)=2.0$P 0
        HA(15)=2.0$P 0+3.0$P 1*X(I)
        IF (I.LT.N) HA(21)=2.0$P 0
      ELSE
        HA(1)=2.0$P 0
        HA(3)=2.0$P 0
        HA(6)=2.0$P 0
        HA(10)=2.0$P 0
        HA(15)=2.0$P 0
        HA(21)=2.0$P 0+3.0$P 1*X(I)
        IF (KA.LT.N) HA(28)=2.0$P 0
      ENDIF
      RETURN
   70 I=(KA+1)/2
      A=6.0$P 0*X(I+1) 
      HA(1)=0.0$P 0
      HA(2)=0.0$P 0
      IF (MOD(KA,2).EQ.1) THEN
        HA(3)=1.0$P 1-A
      ELSE
        HA(3)=2.0$P 0+A
      ENDIF
      RETURN
   80 I=MOD(KA,N/2)+1
      J=I+N/2
      M=5*N
      IF (KA.LE.M/2) THEN
      IA=1
      ELSE
      IA=2
      ENDIF
      IB=5-KA/(M/4)
      IC=MOD(KA,5)+1
      A=$DBLE(IA)
      B=$DBLE(IB)
      C=$DBLE(IC)
      D=X(I)**IA-X(J)**IB
      IF (D.EQ.0.0$P 0.AND.IC.LE.2) THEN
        HA(1)=0.0$P 0
        HA(2)=0.0$P 0
        HA(3)=0.0$P 0
      ELSE
        E=C*D**(IC-2)
        IF (X(I).EQ.0.0$P 0.AND.IA.LE.2) THEN
          HA(1)=0.0$P 0
        ELSE
          HA(1)=A*E*X(I)**(IA-2)*(A*(C-1.0$P 0)*X(I)**IA+(A-1.0$P 0)*D)
        ENDIF
        IF (X(I).EQ.0.0$P 0.AND.IA.LE.1.OR.X(J).EQ.0.0$P 0.AND.IB.LE.1)
     &  THEN
          HA(2)=0.0$P 0
        ELSE
          HA(2)=-A*B*(C-1.0$P 0)*E*X(I)**(IA-1)*X(J)**(IB-1)  
        ENDIF
        IF (X(J).EQ.0.0$P 0.AND.IB.LE.2) THEN
          HA(3)=0.0$P 0
        ELSE
          HA(3)=B*E*X(J)**(IB-2)*(B*(C-1.0$P 0)*X(J)**IB-(B-1.0$P 0)*D)
        ENDIF
      ENDIF
      RETURN
   90 I=2*((KA+5)/6)-1
      IF (MOD(KA,6).EQ.1) THEN
        HA(1)=0.0$P 0
        HA(2)=0.0$P 0
        HA(3)=0.0$P 0
        HA(4)=0.0$P 0
        HA(5)=3.0$P 0
        HA(6)=0.0$P 0
        HA(7)=0.0$P 0
        HA(8)=0.0$P 0
        HA(9)=0.0$P 0
        HA(10)=2.0$P 0
      ELSEIF (MOD(KA,6).EQ.2) THEN
        HA(1)=2.0$P 0
        HA(2)=2.0$P 0
        HA(3)=2.0$P 0
        HA(4)=0.0$P 0
        HA(5)=0.0$P 0
        HA(6)=2.0$P 0
        HA(7)=0.0$P 0
        HA(8)=0.0$P 0
        HA(9)=0.0$P 0
        HA(10)=0.0$P 0
      ELSEIF (MOD(KA,6).EQ.3) THEN
        HA(1)=0.0$P 0
        HA(2)=1.0$P 0
        HA(3)=0.0$P 0
        HA(4)=0.0$P 0
        HA(5)=0.0$P 0
        HA(6)=0.0$P 0
        HA(7)=0.0$P 0
        HA(8)=0.0$P 0
        HA(9)=-1.0$P 0
        HA(10)=0.0$P 0
      ELSEIF (MOD(KA,6).EQ.4) THEN
        HA(1)=0.0$P 0
        HA(2)=0.0$P 0
        HA(3)=0.0$P 0
        HA(4)=2.0$P 0
        HA(5)=0.0$P 0
        HA(6)=0.0$P 0
        HA(7)=0.0$P 0
        HA(8)=1.0$P 0
        HA(9)=0.0$P 0
        HA(10)=0.0$P 0
      ELSEIF (MOD(KA,6).EQ.5) THEN
        HA(1)=4.0$P 0
        HA(2)=2.0$P 0
        HA(3)=2.0$P 0
        HA(4)=2.0$P 0
        HA(5)=2.0$P 0
        HA(6)=2.0$P 0
        HA(7)=2.0$P 0
        HA(8)=2.0$P 0
        HA(9)=2.0$P 0
        HA(10)=2.0$P 0
      ELSE
        HA(1)=0.0$P 0
        HA(2)=X(I+2)*X(I+3)
        HA(3)=0.0$P 0
        HA(4)=X(I+1)*X(I+3)
        HA(5)=X(I)*X(I+3)
        HA(6)=0.0$P 0
        HA(7)=X(I+1)*X(I+2)
        HA(8)=X(I)*X(I+2)
        HA(9)=X(I)*X(I+1)
        HA(10)=2.0$P 0
      ENDIF
      RETURN
  100 IF (N.GE.2) THEN
      I=(KA+1)/2
      J=MOD(KA,2)
      IF (J.EQ.0) THEN
        HA(1)=-4.0$P 0*EXP(2.0$P 0*X(I))
        HA(2)=0.0$P 0
        HA(3)=-4.0$P 0*EXP(2.0$P 0*X(I+1))
      ELSEIF (I.EQ.1) THEN
        HA(1)=-EXP(X(I))
        HA(2)=0.0$P 0
        HA(3)=-EXP(X(I+1))
      ELSEIF (I.EQ.N) THEN
        HA(1)=-9.0$P 0*EXP(3.0$P 0*X(I-1))
        HA(2)=0.0$P 0
        HA(3)=-9.0$P 0*EXP(3.0$P 0*X(I))
      ELSE
        HA(1)=-9.0$P 0*EXP(3.0$P 0*X(I-1))
        HA(2)=0.0$P 0
        HA(3)=-9.0$P 0*EXP(3.0$P 0*X(I))-EXP(X(I))
        HA(4)=0.0$P 0
        HA(5)=0.0$P 0
        HA(6)=-EXP(X(I+1))
      ENDIF
      ENDIF
      RETURN
  110 I=(KA+1)/2
      IF (MOD(KA,2).EQ.1) THEN
        HA(1)=4.0$P 1*X(I)*(X(I)**2-3.0$P 0)/(1.0$P 0+X(I)**2)**3
        HA(2)=0.0$P 0
        HA(3)=0.0$P 0
      ELSE
        HA(1)=0.0$P 0
      ENDIF
      RETURN
  120 I=3*((KA+5)/6)-2
      IF (MOD(KA,6).EQ.1) THEN
        HA(1)=2.0$P 1
        HA(2)=0.0$P 0
        HA(3)=0.0$P 0
      ELSEIF (MOD(KA,6).EQ.2) THEN
        HA(1)=0.0$P 0
      ELSEIF (MOD(KA,6).EQ.3) THEN
        HA(1)=2.0$P 0
      ELSEIF (MOD(KA,6).EQ.4) THEN
        HA(1)=6.0$P 0*(X(I+4)-1.0$P 0)
      ELSEIF (MOD(KA,6).EQ.5) THEN
        A=SIN(X(I+3)-X(I+4))
        HA(1)=2.0$P 0*X(I+3)
        HA(2)=2.0$P 0*X(I)
        HA(3)=-A
        HA(4)=0.0$P 0
        HA(5)=A
        HA(6)=-A
      ELSE
        HA(1)=0.0$P 0
        HA(2)=0.0$P 0
        HA(3)=1.2$P 1*(X(I+2)*X(I+3))**2
        HA(4)=0.0$P 0
        HA(5)=8.0$P 0*X(I+2)**3*X(I+3)
        HA(6)=2.0$P 0*X(I+2)**4
      ENDIF
      RETURN
  130 I=3*((KA+6)/7)-2
      IF (MOD(KA,7).EQ.1) THEN
        HA(1)=2.0$P 1
        HA(2)=0.0$P 0
        HA(3)=0.0$P 0
      ELSEIF (MOD(KA,7).EQ.2) THEN
        HA(1)=2.0$P 1
        HA(2)=0.0$P 0
        HA(3)=0.0$P 0
      ELSEIF (MOD(KA,7).EQ.3) THEN
        HA(1)=2.0$P 0
        HA(2)=-2.0$P 0
        HA(3)=2.0$P 0
      ELSEIF (MOD(KA,7).EQ.4) THEN
        HA(1)=2.0$P 0
        HA(2)=-2.0$P 0
        HA(3)=2.0$P 0
      ELSEIF (MOD(KA,7).EQ.5) THEN
        HA(1)=0.0$P 0
        HA(2)=0.0$P 0
        HA(3)=2.0$P 0
        HA(4)=0.0$P 0
        HA(5)=0.0$P 0
        HA(6)=0.0$P 0
      ELSEIF (MOD(KA,7).EQ.6) THEN
        HA(1)=0.0$P 0
        HA(2)=0.0$P 0
        HA(3)=-2.0$P 0
        HA(4)=0.0$P 0
        HA(5)=0.0$P 0
        HA(6)=0.0$P 0
      ELSE
        HA(1)=0.0$P 0
        HA(2)=1.0$P 0
        HA(3)=0.0$P 0
      ENDIF
      RETURN
  140 I=2*((KA+3)/4)-2
      L=MOD((KA-1),4)+1
      DO 141 J=1,10
        HA(J)=0.0$P 0
  141 CONTINUE
      DO 144 K=1,3
        A=$DBLE(K*K)/$DBLE(L)
        DO 142 J=1,4
          A=A*SIGN(1.0$P 0,X(I+J))*ABS(X(I+J))**($DBLE(J)/$DBLE(K*L))
  142   CONTINUE
        HA(1)=HA(1)+
     & ($DBLE(1)/$DBLE(K*L))*($DBLE(1)/$DBLE(K*L)-1.0$P 0)*A/X(I+1)**2
        HA(2)=HA(2)+
     & ($DBLE(1)/$DBLE(K*L))*($DBLE(2)/$DBLE(K*L))*A/(X(I+1)*X(I+2))
        HA(3)=HA(3)+
     & ($DBLE(2)/$DBLE(K*L))*($DBLE(2)/$DBLE(K*L)-1.0$P 0)*A/X(I+2)**2
        HA(4)=HA(4)+
     & ($DBLE(1)/$DBLE(K*L))*($DBLE(3)/$DBLE(K*L))*A/(X(I+1)*X(I+3))
        HA(5)=HA(5)+
     & ($DBLE(2)/$DBLE(K*L))*($DBLE(3)/$DBLE(K*L))*A/(X(I+2)*X(I+3))
        HA(6)=HA(6)+
     & ($DBLE(3)/$DBLE(K*L))*($DBLE(3)/$DBLE(K*L)-1.0$P 0)*A/X(I+3)**2
        HA(7)=HA(7)+
     & ($DBLE(1)/$DBLE(K*L))*($DBLE(4)/$DBLE(K*L))*A/(X(I+1)*X(I+4))
        HA(8)=HA(8)+
     & ($DBLE(2)/$DBLE(K*L))*($DBLE(4)/$DBLE(K*L))*A/(X(I+2)*X(I+4))
        HA(9)=HA(9)+
     & ($DBLE(3)/$DBLE(K*L))*($DBLE(4)/$DBLE(K*L))*A/(X(I+3)*X(I+4))
        HA(10)=HA(10)+
     & ($DBLE(4)/$DBLE(K*L))*($DBLE(4)/$DBLE(K*L)-1.0$P 0)*A/X(I+4)**2
  144 CONTINUE
      RETURN
  150 I=2*((KA+3)/4)-2
      L=MOD((KA-1),4)+1
      DO 151 J=1,10
        HA(J)=0.0$P 0
  151 CONTINUE
      DO 154 K=1,3
        A=0.0$P 0
        DO 152 J=1,4
          A=A+X(I+J)*($DBLE(J)/$DBLE(K*L))
  152   CONTINUE
        A=EXP(A)*$DBLE(K*K)/$DBLE(L)
        HA(1)=HA(1)+A*($DBLE(1)/$DBLE(K*L))**2
        HA(2)=HA(2)+A*($DBLE(1)/$DBLE(K*L))*($DBLE(2)/$DBLE(K*L))
        HA(3)=HA(3)+A*($DBLE(2)/$DBLE(K*L))**2
        HA(4)=HA(4)+A*($DBLE(1)/$DBLE(K*L))*($DBLE(3)/$DBLE(K*L))
        HA(5)=HA(5)+A*($DBLE(2)/$DBLE(K*L))*($DBLE(3)/$DBLE(K*L))
        HA(6)=HA(6)+A*($DBLE(3)/$DBLE(K*L))**2
        HA(7)=HA(7)+A*($DBLE(1)/$DBLE(K*L))*($DBLE(4)/$DBLE(K*L))
        HA(8)=HA(8)+A*($DBLE(2)/$DBLE(K*L))*($DBLE(4)/$DBLE(K*L))
        HA(9)=HA(9)+A*($DBLE(3)/$DBLE(K*L))*($DBLE(4)/$DBLE(K*L))
        HA(10)=HA(10)+A*($DBLE(4)/$DBLE(K*L))**2
  154 CONTINUE
      RETURN
  160 I=2*((KA+3)/4)-2
      L=MOD((KA-1),4)+1
      DO 161 J=1,10
        HA(J)=0.0$P 0
  161 CONTINUE
      HA(1)=-$DBLE((1-2*MOD(1,2))*L*1*1)*SIN(X(I+1))-
     & $DBLE(L*L*1)*COS(X(I+1))
      HA(3)=-$DBLE((1-2*MOD(2,2))*L*2*2)*SIN(X(I+2))-
     & $DBLE(L*L*2)*COS(X(I+2))
      HA(6)=-$DBLE((1-2*MOD(3,2))*L*3*3)*SIN(X(I+3))-
     & $DBLE(L*L*3)*COS(X(I+3))
      HA(10)=-$DBLE((1-2*MOD(4,2))*L*4*4)*SIN(X(I+4))-
     & $DBLE(L*L*4)*COS(X(I+4))
      RETURN
  170 DO 171 J=1,10
        HA(J)=0.0$P 0
  171 CONTINUE      
      IF (KA.EQ.1.OR.KA.EQ.2) THEN
        HA(2)=-4.0$P 0
      ELSE
        HA(5)=-4.0$P 0
      ENDIF
      RETURN
  180 IF (KA.EQ.1) THEN
        HA(1)=0.0$P 0
        HA(2)=0.0$P 0
        HA(3)=-8.0$P 0      
      ELSE 
        HA(1)=0.0$P 0
        HA(2)=-8.0$P 0
        HA(3)=4.8$P 1*X(KA)
        IF (KA.LT.N) THEN
          HA(4)=0.0$P 0
          HA(5)=0.0$P 0
          HA(6)=-8.0$P 0
        ENDIF  
      ENDIF
      RETURN
  190 DO 191 J=1,36
        HA(J)=0.0$P 0
  191 CONTINUE
      IF (KA.EQ.1) THEN
        HA(1)=-4.0$P 0
      ELSEIF (N-KA.GT.2) THEN
        HA(3)=-4.0$P 0
      ELSEIF (N-KA.EQ.2) THEN
        HA(6)=-4.0$P 0
      ELSEIF (N-KA.EQ.1) THEN
        HA(10)=-4.0$P 0
      ELSE
        HA(15)=-4.0$P 0
      ENDIF
      RETURN
  200 A=1.0$P 0/$DBLE(N+1)
      B=$DBLE(KA)*A
      DO 201 J=1,6
        HA(J)=0.0$P 0
  201 CONTINUE
      IF (KA.EQ.1) THEN
        HA(1)=3.0$P 0*A**2*(X(KA)+B+1.0$P 0)
      ELSE
        HA(3)=3.0$P 0*A**2*(X(KA)+B+1.0$P 0)
      ENDIF
      RETURN
  210 I=3*((KA+6)/7)-2
      DO 211 J=1,6
        HA(J)=0.0$P 0
  211 CONTINUE
      IF (MOD(KA,7).EQ.1.OR.MOD(KA,7).EQ.0) HA(1)=2.0$P 1
      RETURN
  220 I=KA/2
      IF (KA.EQ.1) THEN
        HA(1)=0.0$P 0
      ELSEIF (MOD(KA,2).EQ.0) THEN
        HA(1)=2.0$P 1
        HA(2)=0.0$P 0
        HA(3)=0.0$P 0
      ELSE
        A=(X(I)-X(I+1))**2
        B=4.0$P 0*(1.0$P 0-2.0$P 0*A)*EXP(-A)
        C=(X(I+1)-X(I+2))**2
        D=4.0$P 0*(1.0$P 0-4.0$P 0*C)*EXP(-2.0$P 0*C)
        HA(1)=-B
        HA(2)=B
        HA(3)=-B-D
        HA(4)=0.0$P 0
        HA(5)=D
        HA(6)=-D
      ENDIF
      RETURN
      END