* SUBROUTINE ECGU20             ALL SYSTEMS                 94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENTS OF TEST FUNCTIONS FOR NONLINEAR EQUATIONS.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  GC(N)  GRADIENT OF THE APPROXIMATED FUNCTION AT THE
*          SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE ECGU20(N,KC,X,GC,NEXT)
      INTEGER I,N,K,KC,NEXT
      $FLOAT X(N),GC(N)
      $FLOAT U,V,W,EX,D1S,D2S
      GOTO (40,60,45,70,80,50,85,180,90,200,110,120,130,140,150,160,
     & 160,160,100),NEXT
   40 K=KC+1
      D1S=COS(X(K)-X(K+1))*SIN(X(K)+X(K+1))
      D2S=SIN(X(K)-X(K+1))*COS(X(K)+X(K+1))
      EX=EXP(X(K-1)-X(K))
      GC(K-1)=-EX-X(K-1)*EX
      GC(K)=9.0$P 0*X(K)**2+D1S+D2S+4.0$P 0+X(K-1)*EX
      GC(K+1)=2.0$P 0-D1S+D2S
      RETURN
   45 IF (KC.EQ.1) THEN
      K=1
      D1S=COS(X(K)-X(K+1))*SIN(X(K)+X(K+1))
      D2S=SIN(X(K)-X(K+1))*COS(X(K)+X(K+1))
      GC(K)=9.0$P 0*X(K)**2+D1S+D2S
      GC(K+1)=2.0$P 0-D1S+D2S
      ELSE
      K=N
      EX=EXP(X(K-1)-X(K))
      GC(K-1)=-EX-X(K-1)*EX
      GC(K)=4.0$P 0+X(K-1)*EX
      ENDIF
      RETURN
   50 K=2*KC
      EX=EXP(X(K-1)-X(K)-X(K+1))
      W=X(K-1)-X(K+1)
      GC(K-1)=-EX-W*EX
      GC(K)=4.0$P 0+W*EX
      GC(K+1)=EX+W*EX
      RETURN
   60 K=KC+5
      DO 61 I=K-5,K+1
      GC(I)=1.0D 0+2.0D 0*X(I)
   61 CONTINUE
      GC(K)=GC(K)+2.0D 0+15.0D 0*X(K)**2
      RETURN
   70 K=KC+1
      GC(K-1)=-8.0$P 0*X(K)
      GC(K)=24.0$P 0*X(K)**2-8.0$P 0*X(K-1)+6.0$P 0
      GC(K+1)=-8.0$P 0*X(K+1)
      RETURN
   80 K=KC+2
      GC(K-2)=-1.0$P 0
      GC(K-1)=-8.0$P 0*X(K)+2.0$P 0*X(K-1)
      GC(K)=24.0$P 0*X(K)**2-8.0$P 0*X(K-1)+6.0$P 0
      GC(K+1)=-8.0$P 0*X(K+1)+1.0$P 0
      GC(K+2)=-2.0$P 0*X(K+2)
      RETURN
   85 IF (KC.EQ.1) THEN
      K=1
      GC(K)=4.0$P 0
      GC(K+1)=-8.0$P 0*X(K+1)+1.0$P 0
      GC(K+2)=-2.0$P 0*X(K+2)
      ELSE IF (KC.EQ.2) THEN
      K=2
      GC(K-1)=-8.0$P 0*X(K)
      GC(K)=24.0$P 0*X(K)**2-8.0$P 0*X(K-1)+6.0$P 0
      GC(K+1)=-8.0$P 0*X(K+1)+1.0$P 0
      GC(K+2)=-2.0$P 0*X(K+2)
      ELSE IF (KC.EQ.3) THEN
      K=N-1
      GC(K-2)=-1.0$P 0
      GC(K-1)=-8.0$P 0*X(K)+2.0$P 0*X(K-1)
      GC(K)=24.0$P 0*X(K)**2-8.0$P 0*X(K-1)+6.0$P 0
      GC(K+1)=-8.0$P 0*X(K+1)
      ELSE
      K=N
      GC(K-2)=-1.0$P 0
      GC(K-1)=-8.0$P 0*X(K)+2.0$P 0*X(K-1)
      GC(K)=24.0$P 0*X(K)**2-8.0$P 0*X(K-1)+2.0$P 0
      ENDIF
      RETURN
   90 IF (KC.EQ.1) THEN
      K=1
      GC(K)=4.0$P 0
      GC(K+1)=-8.0$P 0*X(K+1)+1.0$P 0
      GC(K+2)=-2.0$P 0*X(K+2)+1.0$P 0
      GC(K+3)=-2.0$P 0*X(K+3)
      ELSE IF (KC.EQ.2) THEN
      K=2
      GC(K-1)=-8.0$P 0*X(K)+2.0$P 0*X(K-1)
      GC(K)=24.0$P 0*X(K)**2-8.0$P 0*X(K-1)+6.0$P 0
      GC(K+1)=-8.0$P 0*X(K+1)+1.0$P 0
      GC(K+2)=-2.0$P 0*X(K+2)+1.0$P 0
      GC(K+3)=-2.0$P 0*X(K+3)
      ELSE IF (KC.EQ.3) THEN
      K=3
      GC(K-2)=2.0$P 0*X(K-2)-1.0$P 0
      GC(K-1)=-8.0$P 0*X(K)+2.0$P 0*X(K-1)
      GC(K)=24.0$P 0*X(K)**2-8.0$P 0*X(K-1)+6.0$P 0
      GC(K+1)=-8.0$P 0*X(K+1)+1.0$P 0
      GC(K+2)=-2.0$P 0*X(K+2)+1.0$P 0
      GC(K+3)=-2.0$P 0*X(K+3)
      ELSE IF (KC.EQ.4) THEN
      K=N-2
      GC(K-3)=-1.0$P 0
      GC(K-2)=2.0$P 0*X(K-2)-1.0$P 0
      GC(K-1)=-8.0$P 0*X(K)+2.0$P 0*X(K-1)
      GC(K)=24.0$P 0*X(K)**2-8.0$P 0*X(K-1)+6.0$P 0
      GC(K+1)=-8.0$P 0*X(K+1)+1.0$P 0
      GC(K+2)=-2.0$P 0*X(K+2)+1.0$P 0
      ELSE IF (KC.EQ.5) THEN
      K=N-1
      GC(K-3)=-1.0$P 0
      GC(K-2)=2.0$P 0*X(K-2)-1.0$P 0
      GC(K-1)=-8.0$P 0*X(K)+2.0$P 0*X(K-1)
      GC(K)=24.0$P 0*X(K)**2-8.0$P 0*X(K-1)+6.0$P 0
      GC(K+1)=-8.0$P 0*X(K+1)+1.0$P 0
      ELSE
      K=N
      GC(K-3)=-1.0$P 0
      GC(K-2)=2.0$P 0*X(K-2)-1.0$P 0
      GC(K-1)=-8.0$P 0*X(K)+2.0$P 0*X(K-1)
      GC(K)=24.0$P 0*X(K)**2-8.0$P 0*X(K-1)+2.0$P 0
      ENDIF
      RETURN
  180 U=1.0$P 0/$DBLE(N+1)
      K=KC+1
      V=$DBLE(K)*U
      GC(K)=2.0$P 0+1.5$P 0*U**2*(X(K)+V+1.0$P 0)**2
      GC(K-1)=-1.0$P 0
      GC(K+1)=-1.0$P 0
      RETURN
  200 K=KC+1
      GC(K)=3.0$P 0-4.0$P 0*X(K)
      GC(K-1)=-1.0$P 0
      GC(K+1)=-2.0$P 0
      RETURN
  110 K=(KC-1)/2*3
      IF (MOD(KC,2).EQ.1) THEN
      GC(K+1)=2.0$P 0*X(K+1)*X(K+4)
      GC(K+4)=X(K+1)**2+COS(X(K+4)-X(K+5))
      GC(K+5)=-COS(X(K+4)-X(K+5))
      ELSE
      GC(K+2)=1.0$P 0
      GC(K+3)=4.0$P 0*X(K+3)**3*X(K+4)**2
      GC(K+4)=2.0$P 0*X(K+3)**4*X(K+4)
      ENDIF
      RETURN
  120 K=(KC-1)/3*4
      IF (MOD(KC,3).EQ.1) THEN
      GC(K+1)=1.0$P 0
      GC(K+2)=2.0$P 0*X(K+2)
      GC(K+3)=3.0$P 0*X(K+3)**2
      ELSE IF (MOD(KC,3).EQ.2) THEN
      GC(K+2)=1.0$P 0
      GC(K+3)=-2.0$P 0*X(K+3)
      GC(K+4)=1.0$P 0
      ELSE
      GC(K+1)=X(K+5)
      GC(K+5)=X(K+1)
      ENDIF
      RETURN
  130 K=(KC-1)/2*3
      IF (MOD(KC,2).EQ.1) THEN
      GC(K+1)=1.0$P 0
      GC(K+2)=2.0$P 0*X(K+2)
      GC(K+3)=1.0$P 0
      GC(K+4)=1.0$P 0
      GC(K+5)=1.0$P 0
      ELSE
      GC(K+3)=2.0$P 0*X(K+3)
      GC(K+4)=-2.0$P 0
      GC(K+5)=-2.0$P 0
      ENDIF
      RETURN
  140 K=(KC-1)/2*3
      IF (MOD(KC,2).EQ.1) THEN
      GC(K+1)=2.0$P 0*X(K+1)
      GC(K+2)=1.0$P 0
      GC(K+3)=1.0$P 0
      GC(K+4)=4.0$P 0
      ELSE
      GC(K+3)=2.0$P 0*X(K+3)
      GC(K+5)=5.0$P 0
      ENDIF
      RETURN
  150 K=(KC-1)/3*4
      IF (MOD(KC,3).EQ.1) THEN
      GC(K+1)=2.0$P 0*X(K+1)
      GC(K+2)=2.0$P 0
      GC(K+3)=3.0$P 0
      ELSE IF (MOD(KC,3).EQ.2) THEN
      GC(K+2)=2.0$P 0*X(K+2)
      GC(K+3)=2.0$P 0
      GC(K+4)=3.0$P 0
      ELSE
      GC(K+3)=2.0$P 0*X(K+3)
      GC(K+4)=2.0$P 0
      GC(K+5)=3.0$P 0
      ENDIF
      RETURN
  160 K=(KC-1)/3*4
      IF (MOD(KC,3).EQ.1) THEN
      GC(K+1)=2.0$P 0*X(K+1)
      GC(K+2)=3.0$P 0
      ELSE IF (MOD(KC,3).EQ.2) THEN
      GC(K+3)=2.0$P 0*X(K+3)
      GC(K+4)=1.0$P 0
      GC(K+5)=-2.0$P 0
      ELSE
      GC(K+2)=2.0$P 0*X(K+2)
      GC(K+5)=-1.0$P 0
      ENDIF
      RETURN
  100 K=KC+1
      GC(K-1)=-1.0$P 0
      GC(K)=-4.0$P 0*X(K)+3.0$P 0
      GC(K+1)=-2.0$P 0
      GC(N-4)=3.0$P 0
      GC(N-3)=-1.0$P 0
      GC(N-2)=-1.0$P 0
      GC(N-1)=0.50$P 0
      GC(N)=-1.0$P 0
      RETURN
      END
