* SUBROUTINE EFFU11                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENTS OF MODEL FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  F  VALUE OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EFFU11(N,X,F,NEXT)
      INTEGER N,NEXT
      $FLOAT X(N),F
      INTEGER I,I1,I2,I3,I4,I5,J,K,L,M
      $FLOAT A,B,C,D,E,P,Q,U,V,H,PI
      $FLOAT RPAR(10000)
      INTEGER IPAR(10),MM
      COMMON /EMPR11/ RPAR,IPAR,MM
      PI=3.14159265358979323846$P 0
      F=0.0$P 0
      GO TO (10,20,30,40,50,60,70,80,90,100,110,110,110,110,110,110,
     &  110,110,110,110,110,110,230,240,250,260,270,280,290,300,310,
     &  320,330,340,350,360,370,380,390,400,410,420,430,440,450,460,
     &  470,480,490,500,510,520,530,540,550,560,570,580),NEXT
   10 DO 11 I=1,N-1
      A=X(I)**2+X(N)**2
      F=F+A**2-4.0$P 0*X(I)+3.0$P 0
   11 CONTINUE
      RETURN
   20 DO 21 I=1,N-4
      A=3.0$P 0-4.0$P 0*X(I)
      B=X(I)**2+2.0$P 0*X(I+1)**2+3.0D0*X(I+2)**2+4.0$P 0*X(I+3)**2+
     & 5.0$P 0*X(N)**2
      F=F+A**2+B**2
   21 CONTINUE
      RETURN
   30 P=7.0$P 0/3.0$P 0
      K=N/2
      DO 31 J=1,N
      A=(3.0$P 0-2.0$P 0*X(J))*X(J)+1.0$P 0
      IF (J.GT.1) A=A-X(J-1)
      IF (J.LT.N) A=A-2.0$P 0*X(J+1)
      F=F+ABS(A)**P
      IF (J.LE.K) THEN
      F=F+ABS(X(J)+X(J+K))**P
      ENDIF
   31 CONTINUE
      RETURN
   40 DO 43 I=1,N
      A=(2.0$P 0+5.0$P 0*X(I)**2)*X(I)+1.0$P 0
      DO 41 J=MAX(1,I-5),MIN(N,I+1)
      IF (J.NE.I) A=A-X(J)*(1.0$P 0+X(J))
   41 CONTINUE
      F=F+A*A
   43 CONTINUE
      RETURN
   50 F=1.0$P 0
      DO 51 J=2,N-2,2
      A=X(J-1)**2-X(J)
      B=X(J-1)-1.0$P 0
      C=X(J+1)**2-X(J+2)
      D=X(J+1)-1.0$P 0
      U=X(J)+X(J+2)-2.0$P 0
      V=X(J)-X(J+2)
      F=F+1.0$P 2*A**2+B**2+9.0$P 1*C**2+D**2+1.0$P 1*U**2+0.1$P 0*V**2
   51 CONTINUE
      RETURN
   60 DO 61 I=1,N-1
      A=X(I)**2-0.5$P 0*X(I+1)
      F=F+COS(A)
   61 CONTINUE
      RETURN
   70 DO 71 J=2,N-2,2
      A=EXP(X(J-1))
      B=A-X(J)
      D=X(J)-X(J+1)
      P=X(J+1)-X(J+2)
      C=COS(P)
      Q=SIN(P)/C
      U=X(J-1)
      V=X(J+2)-1.0$P 0
      F=F+B**4+1.0$P 2*D**6+(Q+P)**4+U**8+V**2
   71 CONTINUE
      RETURN
   80 K=10
      GO TO 101
   90 K=20
      GO TO 101
  100 K=30
  101 DO 104 I=1,N
      A=0.0$P 0
      DO 102 J=I,MIN(I+K,N)
      A=A+X(J)
  102 CONTINUE
      F=F+A*(A*(A**2-2.0$P 1)-1.0$P-1)
  104 CONTINUE
      RETURN
  110 M=N/3
      F=1.0$P 0
      DO 111 I=1,N
      A=RPAR(1)*($DBLE(I)/$DBLE(N))**IPAR(1)
      F=F+A*X(I)**2
  111 CONTINUE
      DO 112 I=1,N-1
      A=RPAR(2)*($DBLE(I)/$DBLE(N))**IPAR(2)
      B=X(I+1)+X(I+1)**2
      F=F+A*X(I)**2*B**2
  112 CONTINUE
      DO 113 I=1,2*M
      A=RPAR(3)*($DBLE(I)/$DBLE(N))**IPAR(3)
      F=F+A*X(I)**2*X(I+M)**4
  113 CONTINUE
      DO 114 I=1,M
      A=RPAR(4)*($DBLE(I)/$DBLE(N))**IPAR(4)
      F=F+A*X(I)*X(I+2*M)
  114 CONTINUE
      RETURN
  230 DO 231 I=1,N
      F=F+(X(I)-$DBLE(I))**4
  231 CONTINUE
      RETURN
  240 F=1.6$P 1
      DO 241 I=1,N-1
      A=X(I)*X(I+1)-2.0D0*X(I+1)
      F=F+(X(I)-2.0$P 0)**4+A**2+(X(I+1)+1.0$P 0)**2
  241 CONTINUE
      RETURN
  250 DO 251 I=1,N-1
      A=X(1)+X(I)**2-1.0$P 0
      F=F+SIN(A)
  251 CONTINUE
      F=F+0.5D0*SIN(X(N)**2)
      RETURN
  260 DO 261 I=1,N-1
      A=X(I)**2+X(I+1)**2
      F=F+A**2+3.0$P 0-4.0$P 0*X(I)
  261 CONTINUE
      RETURN
  270 DO 271 I=2,N
      A=1.6$P 1*(1.5$P 0+SIN($DBLE(I)))**2
      B=X(I-1)-X(I)**2
      F=F+A*B**2+(X(I)-1.0$P 0)**2
  271 CONTINUE
      RETURN
  280 DO 281 I=2,N
      A=1.6$P 1*(1.5$P 0+SIN($DBLE(I)))**2
      B=X(I-1)-A*X(I)**2
      F=F+B**2+(X(I)-1.0$P 0)**2
  281 CONTINUE
      RETURN
  290 F=(X(1)-1.0$P 0)**2
      DO 291 I=2,N
      A=X(I)-X(I-1)**2
      F=F+1.0$P 2*A**2
  291 CONTINUE
      RETURN
  300 H=1.0$P 0/$DBLE(N+1)**2
      P=1.0$P 0/RPAR(2)
      F=0.5$P 0*P*X(1)**2+0.5$P 0*P*X(N)**2
      DO 301 I=1,N-1
      A=X(I)-X(I+1)
      F=F+0.5$P 0*P*A**2
  301 CONTINUE
      A=1.0$P 0+2.0$P 0/H
      DO 302 I=1,N
      F=F-P*(A*1.0$P 2*SIN(X(I)/1.0$P 2)+RPAR(1)*COS(X(I))/H)
  302 CONTINUE
      RETURN
  310 H=1.0$P 0/$DBLE(N+1)**2
      F=0.5$P 0*X(1)**2+0.5$P 0*X(N)**2
      DO 311 I=1,N-1
      A=X(I)-X(I+1)
      F=F+0.5$P 0*A**2
  311 CONTINUE
      A=2.0$P 0*H
      DO 312 I=1,N-1
      F=F-A*X(I)-RPAR(1)*COS(X(I))*H
  312 CONTINUE
      A=1.0$P 0+2.0$P 0*H
      F=F-A*X(N)-RPAR(1)*COS(X(N))*H
      RETURN
  320 DO 321 I=1,N-1
      A=X(I)*(X(I)+1.0$P 0)-X(I+1)-1.0$P 0
      F=F+1.0$P 2*A**2
  321 CONTINUE
      RETURN
  330 P=$DBLE(MM-1)**2
      L=0
      DO 332 I=1,MM-1
      DO 331 J=1,MM-1
      A=X(L+J)-X(L+MM+J+1)
      B=X(L+MM+J)-X(L+J+1)
      C=0.5$P 0*P*(A**2+B**2)+1.0$P 0
      F=F+SQRT(C)/P
  331 CONTINUE
      L=L+MM
  332 CONTINUE
      L=MM*(MM-1)/2
      F=F+X(L)**2/$DBLE(MM**2)
      RETURN
  340 DO 341 I=1,N-1
      A=X(I)+((5.0$P 0-X(I+1))*X(I+1)-2.0$P 0)*X(I+1)-1.3$P 1
      F=F+A**2
      A=X(I)+((X(I+1)+1.0$P 0)*X(I+1)-1.4$P 1)*X(I+1)-2.9$P 1
      F=F+A**2
  341 CONTINUE
      RETURN
  350 P=RPAR(1)
      DO 351 I=1,N-1
      A=SIN(P*X(I))
      B=SIN(P*X(I+1))
      F=F+A**2*B**2+5.0$P-2*(X(I)**2+X(I+1)**2)
  351 CONTINUE
      RETURN
  360 F=1.0$P 0
      DO 361 I=2,N
      A=X(I)-X(I-1)**2
      F=F+1.0$P 2*A**2+(X(I)-1.0$P 0)**2
  361 CONTINUE
      RETURN
  370 DO 371 I=1,N
      F=F+1.0$P 2*SIN(X(I)/1.0$P 2)
  371 CONTINUE
      DO 372 I=2,N-1
      A=2.0$P 0*X(I)-X(N)-X(1)
      F=F+RPAR(1)*COS(A)
  372 CONTINUE
      RETURN
  380 DO 381 I=1,N
      A=X(I)**2-X(1)
      F=F+4.0$P 0*A**2+(X(I)-1.0$P 0)**2
  381 CONTINUE
      RETURN
  390 P=1.0$P 0/$DBLE(N+1)
      Q=0.5$P 0*P**2
      DO 391 I=1,N
      A=2.0$P 0*X(I)+Q*(X(I)+$DBLE(I)*P+1.0$P 0)**3
      IF (I.GT.1) A=A-X(I-1)
      IF (I.LT.N) A=A-X(I+1)
      F=F+A**2
  391 CONTINUE
      RETURN
  400 L=IPAR(1)
      M=IPAR(2)
      F=2.0$P 0
      DO 403 I=1,N-L-M
      C=1.0$P 1/$DBLE(I)
      D=0.0$P 0
      DO 401 J=1,L
      A=X(I+J-1)
      B=1.0$P 0+A*A
      D=D+A/B
      F=F+RPAR(2)*A
  401 CONTINUE
      F=F+C*D*D
  403 CONTINUE
      DO 404 I=1,N-M
      F=F+X(I)**4+2.0$P 0
  404 CONTINUE
      DO 405 I=1,M
      F=F+RPAR(1)*(X(I)*X(I+M)*X(I+N-M)+2.0$P 0*X(I+N-M)**2)
  405 CONTINUE
      RETURN
  410 L=IPAR(1)
      DO 413 I=1,N-L+1
      C=1.0$P 1/$DBLE(I)
      D=0.0$P 0
      DO 411 J=1,L
      A=X(I+J-1)
      B=1.0$P 0+A*A
      D=D+A/B
      F=F+RPAR(2)*A
  411 CONTINUE
      F=F+C*D*D
  413 CONTINUE
      DO 414 I=1,N
      F=F+RPAR(1)*X(I)**4+2.0$P 0
  414 CONTINUE
      RETURN
  420 DO 421 I=1,N
      K=MOD(2*I-1,N)
      L=MOD(3*I-1,N)
      A=X(I)+X(K+1)+X(L+1)
      F=F+A**2+4.0$P 0*COS(A)
  421 CONTINUE
      RETURN
  430 DO 431 I=1,N
      K=MOD(3*I-2,N)
      L=MOD(7*I-3,N)
      A=X(I)+X(K+1)+X(L+1)
      F=F+A**2+4.0$P 0*COS(A)
  431 CONTINUE
      RETURN
  440 F=(X(1)-1.0$P 0)**2
      DO 441 I=2,N
      A=X(1)-X(I-1)**2
      F=F+1.0$P 2*A**2
  441 CONTINUE
      RETURN
  450 A=X(1)-X(2)
      B=X(N-1)-X(N)
      F=A**2+B**2
      DO 451 I=1,N-2
      A=X(I)+X(I+1)+X(N)
      F=F+A**4
  451 CONTINUE
      RETURN
  460 A=1.0$P 0
      B=0.0$P 0
      C=0.0$P 0
      D=0.0$P 0
      F=0.0$P 0
      U=EXP(X(N))
      V=EXP(X(N-1))
      DO 461 J=1,N
      IF (J.LE.N/2) F=F+(X(J)-1.0$P 0)**2
      IF (J.LE.N-2) THEN
      B=B+(X(J)+2.0$P 0*X(J+1)+1.0$P 1*X(J+2)-1.0$P 0)**2
      C=C+(2.0$P 0*X(J)+X(J+1)-3.0$P 0)**2
      ENDIF
      D=D+X(J)**2-$DBLE(N)
  461 CONTINUE
      F=F+A*(1.0$P 0+U*B+B*C+V*C)+D**2
      RETURN
  470 DO 471 J=1,N-3,4
      A=X(J)+1.0D 1*X(J+1)
      B=X(J+2)-X(J+3)
      C=X(J+1)-2.0D 0*X(J+2)
      D=X(J)-X(J+3)
      F=F+A**2+5.0D 0*B**2+C**4+1.0D 1*D**4
  471 CONTINUE
      RETURN
  480 DO 483 I=1,N
      P=RPAR(I)
      A=(2.0$P 0+5.0$P 0*(P*X(I))**2)*P*X(I)+1.0$P 0
      DO 481 J=MAX(1,I-5),MIN(N,I+1)
      IF (J.NE.I) THEN
      Q=RPAR(J)
      A=A-Q*X(J)*(1.0$P 0+Q*X(J))
      ENDIF
  481 CONTINUE
      F=F+A*A
  483 CONTINUE
      RETURN
  490 DO 491 I=1,N-2
      A=X(I)-X(I+1)
      B=0.5$P 0*(PI*X(I+1)+X(I+2))
      D=X(I)+X(I+2)
      E=D/X(I+1)-2.0$P 0
      U=EXP(-E**2)
      V=1.0$P 0+A**2
      F=F-1.0$P 0/V-SIN(B)-U
  491 CONTINUE
      RETURN
  500 DO 501 I=1,N-1
      P=RPAR(I)
      Q=RPAR(I+1)
      A=(P*X(I))**2-0.5$P 0*Q*X(I+1)
      F=F+COS(A)
  501 CONTINUE
      RETURN
  510 A=X(1)-1.0$P 0
      B=X(N)**2-X(1)**2
      F=A**4+B**2
      DO 511 I=2,N-1
      A=X(I)-X(N)
      B=SIN(A)+X(I)**2-X(1)**2
      F=F+B**2
  511 CONTINUE
      RETURN
  520 DO 521 I=1,N
      I1=MOD(2*I-1,N)+1
      I2=MOD(3*I-1,N)+1
      I3=MOD(5*I-1,N)+1
      I4=MOD(7*I-1,N)+1
      I5=MOD(11*I-1,N)+1
      A=SIN(X(I))+SIN(X(I1))+SIN(X(I2))+SIN(X(I3))+SIN(X(I4))+SIN(X(I5))
      F=F+$DBLE(I)*A*A
  521 CONTINUE
      F=5.0$P-1*F
      RETURN
  530 DO 531 I=1,N
      I1=MOD(2*I-1,N)+1
      I2=MOD(3*I-1,N)+1
      I3=MOD(5*I-1,N)+1
      I4=MOD(7*I-1,N)+1
      I5=MOD(11*I-1,N)+1
      A=5.0$P-1*(X(I)**2+X(I1)**2+X(I2)**2+X(I3)**2+X(I4)**2+X(I5)**2)
      F=F+$DBLE(I)*A*A
  531 CONTINUE
      F=5.0$P-1*F
      RETURN
  540 M=(N+2)/3
      DO 542 I=1,M
      J=3*(I-1)+1
      DO 541 K=1,5
      IF (MOD(K,5).EQ.1) THEN
      IF (I.GT.2) THEN
      A=X(J-4)*X(J-1)-RPAR(J-4)*RPAR(J-1)
      F=F+A*A
      ENDIF
      ELSE IF(MOD(K,5).EQ.2) THEN
      IF (I.GT.1) THEN
      A=X(J-3)*X(J-1)+X(J-1)*X(J)-RPAR(J-3)*RPAR(J-1)-RPAR(J-1)*RPAR(J)
      F=F+A*A
      ENDIF
      ELSE IF(MOD(K,5).EQ.3) THEN
      IF (I.GT.1) THEN
      A=X(J-2)*X(J-1)-RPAR(J-2)*RPAR(J-1)
      F=F+A*A
      ENDIF
      A=X(J)*X(J)-RPAR(J)*RPAR(J)
      F=F+A*A
      IF (I.LT.M) THEN
      A=X(J+2)*X(J+1)-RPAR(J+2)*RPAR(J+1)
      F=F+A*A
      ENDIF
      ELSE IF(MOD(K,5).EQ.4) THEN
      IF (I.LT.M) THEN
      A=X(J+3)*X(J+1)+X(J+1)*X(J)-RPAR(J+3)*RPAR(J+1)-RPAR(J+1)*RPAR(J)
      F=F+A*A
      ENDIF
      ELSE
      IF (I.LT.M-1) THEN
      A=X(J+4)*X(J+1)-RPAR(J+4)*RPAR(J+1)
      F=F+A*A
      ENDIF
      ENDIF
  541 CONTINUE
  542 CONTINUE
      RETURN
  550 DO 551 I=2,N,2
      A=X(I)-X(I-1)**2
      F=F+1.0$P 2*A**2+(X(I-1)-1.0$P 0)**2
  551 CONTINUE
      RETURN
  560 DO 561 I=1,N-2
      A=1.0$P 1/$DBLE(N+2)+X(I+2)**2
      B=X(I)-X(I+1)
      C=1.0$P-1+X(I+2)**2
      D=-B**2/C
      E=EXP(D)
      F=F+A*(2.0$P 0-E)
  561 CONTINUE
      RETURN
  570 A=X(1)-1.0$P 0
      F=A**2
      DO 571 I=1,N-1
      A=X(1)**2-X(I+1)**2
      F=F+A**2
  571 CONTINUE
      RETURN
  580 DO 581 J=2,N-2,4
      A=X(J-1)**2-X(J)
      B=X(J-1)-1.0$P 0
      C=X(J+1)**2-X(J+2)
      D=X(J)+X(J+2)-2.0$P 0
      E=X(J)-X(J+2)
      U=X(J+1)-1.0$P 0
      F=F+1.0$P 2*A**2+B**2+9.0$P 1*C**2+1.0$P 1*D**2+1.0$P-1*E**2+U**2
  581 CONTINUE
      RETURN
      END
