* SUBROUTINE EFFU29                ALL SYSTEMS                00/12/01
C PORTABILITY : ALL SYSTEMS
C 00/12/01 VL : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF MODEL FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  F  VALUE OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EFFU29(N,X,F,NEXT)
      INTEGER N,NEXT
      $FLOAT X(N),F
      $FLOAT Y(20),A,A1,A2,C,ETA9,FA,H,P,PAR,U,V
      INTEGER I,IA,IB,IC,J,K,KA,L,M
      COMMON /EMPR15/ Y
      COMMON /EMPR18/ PAR,M
      PARAMETER (ETA9=1.0$P 60)
C     PI=3.14159265358979323846D 0
      F=0.0$P 0
      GO TO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     & 170,180,190,200,210,220,230,240,250,260,270,280,290,300,310),NEXT
   10 F=X(1)**2
      DO 11 I=2,N
      FA=X(I)**2
      F=MAX(F,FA)
   11 CONTINUE
      RETURN
   20 F=ABS(X(1))
      DO 21 I=2,N
      FA=ABS(X(I))
      F=MAX(F,FA)
   21 CONTINUE
      RETURN
   30 A=0.0$P 0
      F=-ETA9
      DO 31 I=1,N
      FA=X(I)
      A=A+FA
      F=MAX(F,FA)
   31 CONTINUE
      F=F-A/N
      RETURN
   40 DO 41 J=1,N
      F=F+X(J)/$DBLE(J)
   41 CONTINUE
      F=ABS(F)
      DO 43 I=2,N
      FA=0.0$P 0
      DO 42 J=1,N
      FA=FA+X(J)/$DBLE(I+J-1)
   42 CONTINUE
      FA=ABS(FA)
      F=MAX(FA,F)
   43 CONTINUE
      RETURN
   50 DO 52 J=1,N
      FA=0.0$P 0
      DO 51 I=1,N
      FA=FA+X(I)/$DBLE(I+J-1)
   51 CONTINUE
      F=F+ABS(FA)
   52 CONTINUE
      RETURN
   60 DO 61 I=1,N
      FA=(3.0D 0-2.0D 0*X(I))*X(I)+1.0D 0
      IF (I.GT.1) FA=FA-X(I-1)
      IF (I.LT.N) FA=FA-X(I+1)
      F=MAX(F,ABS(FA))
   61 CONTINUE
      RETURN
   70 DO 72 I=1,N
      FA=(2.0D 0+5.0D 0*X(I)**2)*X(I)+1.0D 0
      DO 71 J=MAX(1,I-5),MIN(N,I+1)
      FA=FA+X(J)*(1.0D 0+X(J))
   71 CONTINUE
      F=MAX(F,ABS(FA))
   72 CONTINUE
      RETURN
   80 DO 81 KA=1,2*N-2
      I=(KA+1)/2
      IF (MOD(KA,2).EQ.1) THEN
      FA=X(I)+X(I+1)*((5.0D 0-X(I+1))*X(I+1)-2.0D 0)-1.3D 1
      ELSE
      FA=X(I)+X(I+1)*((1.0D 0+X(I+1))*X(I+1)-1.4D 1)-2.9D 1
      ENDIF
      F=MAX(F,ABS(FA))
   81 CONTINUE
      RETURN
   90 DO 91 I=1,N
      FA=(3.0D 0-2.0D 0*X(I))*X(I)+1.0D 0
      IF (I.GT.1) FA=FA-X(I-1)
      IF (I.LT.N) FA=FA-X(I+1)
      F=F+ABS(FA)
   91 CONTINUE
      RETURN
  100 DO 102 I=1,N
      FA=(2.0D 0+5.0D 0*X(I)**2)*X(I)+1.0D 0
      DO 101 J=MAX(1,I-5),MIN(N,I+1)
      FA=FA+X(J)*(1.0D 0+X(J))
  101 CONTINUE
      F=F+ABS(FA)
  102 CONTINUE
      RETURN
  110 DO 111 KA=1,2*N-2
      I=(KA+1)/2
      IF (MOD(KA,2).EQ.1) THEN
      FA=X(I)+X(I+1)*((5.0D 0-X(I+1))*X(I+1)-2.0D 0)-1.3D 1
      ELSE
      FA=X(I)+X(I+1)*((1.0D 0+X(I+1))*X(I+1)-1.4D 1)-2.9D 1
      ENDIF
      F=F+ABS(FA)
  111 CONTINUE
      RETURN
  120 A=SQRT(1.0D 1)
      C=SQRT(5.0D 0)
      DO 121 KA=1,2*N-4
      I=2*((KA+3)/4)
      IF (MOD(KA,4).EQ.1) THEN
      FA=X(I-1)+1.0D 1*X(I)
      ELSEIF (MOD(KA,4).EQ.2) THEN
      FA=C*(X(I+1)-X(I+2))
      ELSEIF (MOD(KA,4).EQ.3) THEN
      FA=(X(I)-2.0D 0*X(I+1))**2
      ELSE
      FA=A*(X(I-1)-X(I+2))**2
      ENDIF
      F=F+ABS(FA)
  121 CONTINUE
      RETURN
  130 DO 133 KA=1,2*N-4
      I=2*((KA+3)/4)-2
      L=MOD((KA-1),4)+1
      FA=-Y(L)
      DO 132 K=1,3
      A=DBLE(K*K)/DBLE(L)
      DO 131 J=1,4
      IF (X(I+J).EQ.0) X(I+J)=1.0D-16
      A=A*SIGN(1.0D 0,X(I+J))*ABS(X(I+J))**(DBLE(J)/DBLE(K*L))
  131 CONTINUE
      FA=FA+A
  132 CONTINUE
      F=F+ABS(FA)
  133 CONTINUE
      RETURN
  140 DO 143 KA=1,2*N-4
      I=2*((KA+3)/4)-2
      L=MOD((KA-1),4)+1
      FA=-Y(L)
      DO 142 K=1,3
      A=0.0D 0
      DO 141 J=1,4
      A=A+X(I+J)*(DBLE(J)/DBLE(K*L))
  141 CONTINUE
      FA=FA+EXP(A)*DBLE(K*K)/DBLE(L)
  142 CONTINUE
      F=F+ABS(FA)
  143 CONTINUE
      RETURN
  150 M=5*N
      DO 151 KA=1,N*5
      I=MOD(KA,N/2)+1
      J=I+N/2
      IF (KA.LE.M/2) THEN
      IA=1
      ELSE
      IA=2
      ENDIF
      IB=5-KA/(M/4)
      IC=MOD(KA,5)+1
      FA=(X(I)**IA-X(J)**IB)**IC
      F=F+ABS(FA)
  151 CONTINUE
      RETURN
  160 U=1.0D 0/DBLE(N+1)
      DO 161 KA=1,N
      V=DBLE(KA)*U
      FA=2.0D 0*X(KA)+0.5D 0*U*U*(X(KA)+V+1.0D 0)**3+1.0D 0
      IF(KA.GT.1) FA=FA-X(KA-1)
      IF(KA.LT.N) FA=FA-X(KA+1)
      F=F+ABS(FA)
  161 CONTINUE
      RETURN
  170 DO 172 KA=1,N
      J=(KA-1)/5
      FA=5.0D 0-DBLE(J+1)*(1.0D 0-COS(X(KA)))-SIN(X(KA))
      J=J*5
      DO 171 I=J+1,J+5
      FA=FA-COS(X(I))
  171 CONTINUE
      F=MAX(F,ABS(FA))
  172 CONTINUE
      RETURN
  180 DO 181 KA=1,N
      IF (KA.LT.2) THEN
      FA=3.0D 0*X(KA)**3+2.0D 0*X(KA+1)-5.0D 0+
     & SIN(X(KA)-X(KA+1))*SIN(X(KA)+X(KA+1))
      ELSEIF (KA.LT.N) THEN
      FA=3.0D 0*X(KA)**3+2.0D 0*X(KA+1)-5.0D 0+
     & SIN(X(KA)-X(KA+1))*SIN(X(KA)+X(KA+1))+4.0D 0*X(KA)-
     & X(KA-1)*EXP(X(KA-1)-X(KA))-3.0D 0
      ELSE
      FA=4.0D 0*X(KA)-X(KA-1)*EXP(X(KA-1)-X(KA))-3.0D 0
      ENDIF
      F=MAX(F,ABS(FA))
  181 CONTINUE
      RETURN
  190 H=2.0D 0
      DO 191 KA=1,N
      IF (KA.EQ.1) THEN
      FA=((3.0D 0-H*X(1))*X(1)-2.0D 0*X(2)+1.0D 0)**2
      ELSEIF (KA.LE.N-1) THEN
      FA=((3.0D 0-H*X(KA))*X(KA)-X(KA-1)-2.0D 0*X(KA+1)+1.0D 0)**2
      ELSE
      FA=((3.0D 0-H*X(N))*X(N)-X(N-1)+1.0D 0)**2
      ENDIF
      F=MAX(F,ABS(FA))
  191 CONTINUE
      RETURN
  200 DO 201 KA=1,N
      IF(KA.LT.2) THEN
      FA=X(KA)*(0.5D 0*X(KA)-3.0D 0)-1.0D 0+2.0D 0*X(KA+1)
      ELSEIF (KA.LT.N) THEN
      FA=X(KA-1)+X(KA)*(0.5D 0*X(KA)-3.0D 0)-1.0D 0+2.0D 0*X(KA+1)
      ELSE
      FA=X(KA-1)+X(KA)*(0.5D 0*X(KA)-3.0D 0)-1.0D 0
      ENDIF
      F=MAX(F,ABS(FA))
  201 CONTINUE
      RETURN
  210 DO 211 KA=1,N
      IF (KA.EQ.1) THEN
      FA=-2.0D 0*X(KA)**2+3.0D 0*X(KA)-2.0D 0*X(KA+1)+
     & 3.0D 0*X(N-4)-X(N-3)-X(N-2)+0.5D 0*X(N-1)-X(N)+1.0D 0
      ELSEIF (KA.LE.N-1) THEN
      FA=-2.0D 0*X(KA)**2+3.0D 0*X(KA)-X(KA-1)-2.0D 0*X(KA+1)+
     & 3.0D 0*X(N-4)-X(N-3)-X(N-2)+0.5D 0*X(N-1)-X(N)+1.0D 0
      ELSE
      FA=-2.0D 0*X(N)**2+3.0D 0*X(N)-X(N-1)+
     & 3.0D 0*X(N-4)-X(N-3)-X(N-2)+0.5D 0*X(N-1)-X(N)+1.0D 0
      ENDIF
      F=F+ABS(FA)
  211 CONTINUE
      RETURN
  220 U=1.0D 0/DBLE(N+1)
      DO 221 KA=1,N
      V=DBLE(KA)*U
      FA=2.0D 0*X(KA)+0.5D 0*U*U*(X(KA)+V+1.0D 0)**3
      IF(KA.GT.1) FA=FA-X(KA-1)
      IF(KA.LT.N) FA=FA-X(KA+1)
      F=MAX(F,ABS(FA))
  221 CONTINUE
      RETURN
  230 DO 231 KA=1,N
      IF(KA.EQ.1) THEN
      FA=3.0D 0*X(KA)*(X(KA+1)-2.0D 0*X(KA))+0.25D 0*X(KA+1)**2
      ELSEIF(KA.EQ.N) THEN
      FA=3.0D 0*X(KA)*(2.0D 1-2.0D 0*X(KA)+X(KA-1))+
     & 0.25D 0*(2.0D 1-X(KA-1))**2
      ELSE
      FA=3.0D 0*X(KA)*(X(KA+1)-2.0D 0*X(KA)+X(KA-1))+
     & 0.25D 0*(X(KA+1)-X(KA-1))**2
      ENDIF
      F=MAX(F,ABS(FA))
  231 CONTINUE
      RETURN
  240 H=1.0D 0/DBLE(N+1)
      DO 241 KA=1,N
      IF (KA.LT.2) THEN
      FA=2.0D 0*X(KA)+PAR*H**2*SINH(PAR*X(KA))-X(KA+1)
      ELSE IF (KA.LT.N) THEN
      FA=2.0D 0*X(KA)+PAR*H**2*SINH(PAR*X(KA))-X(KA-1)-X(KA+1)
      ELSE
      FA=2.0D 0*X(KA)+PAR*H**2*SINH(PAR*X(KA))-X(KA-1)-1.0D 0
      ENDIF
      F=MAX(F,ABS(FA))
  241 CONTINUE
      RETURN
  250 DO 251 KA=1,N
      FA=8.0D 0*X(KA)**2
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      IF(I.EQ.1) FA=FA-2.0D 0*X(KA)*(X(KA+1)+1.0D 0)-
     & 0.5D 0*(X(KA+1)-1.0D 0)**2-
     & 1.5D 0*X(KA)**2*(X(KA+1)-1.0D 0)*PAR
      IF(I.GT.1.AND.I.LT.M) FA=FA-2.0D 0*X(KA)*(X(KA+1)+X(KA-1))-
     & 0.5D 0*(X(KA+1)-X(KA-1))**2-
     & 1.5D 0*X(KA)**2*(X(KA+1)-X(KA-1))*PAR
      IF(I.EQ.M) FA=FA-2.0D 0*X(KA)*X(KA-1)-
     & 0.5D 0*X(KA-1)**2+
     & 1.5D 0*X(KA)**2*X(KA-1)*PAR
      IF(J.EQ.1) FA=FA-2.0D 0*X(KA)*(X(KA+M)+1.0D 0)-
     & 0.5D 0*(X(KA+M)-1.0D 0)**2
      IF(J.GT.1.AND.J.LT.M) FA=FA-2.0D 0*X(KA)*(X(KA+M)+X(KA-M))-
     & 0.5D 0*(X(KA+M)-X(KA-M))**2
      IF(J.EQ.M) FA=FA-2.0D 0*X(KA)*X(KA-M)-
     & 0.5D 0*X(KA-M)**2
      IF (I.EQ.1.AND.J.EQ.1) FA=FA-PAR/DBLE(M+1)
      F=MAX(F,ABS(FA))
  251 CONTINUE
      RETURN
  260 A2=0.5D 0
      DO 261 KA=1,N
      IF (KA.EQ.1) THEN
      FA=A2-(1.0D 0-A2)*X(3)-X(1)*(1.0D 0+4.0D 0*X(2))
      ELSEIF(KA.EQ.2) THEN
      FA=-(2.0D 0-A2)*X(4)-X(2)*(1.0D 0+4.0D 0*X(1))
      ELSEIF(KA.EQ.N-1) THEN
      FA=A2*X(N-3)-X(N-1)*(1.0D 0+4.0D 0*X(N))
      ELSEIF (KA.EQ.N) THEN
      FA=A2*X(N-2)-(2.0D 0-A2)-X(N)*(1.0D 0+4.0D 0*X(N-1))
      ELSEIF (MOD(KA,2).EQ.1) THEN
      FA=A2*X(KA-2)-(1.0D 0-A2)*X(KA+2)-
     & X(KA)*(1.0D 0+4.0D 0*X(KA+1))
      ELSE
      FA=A2*X(KA-2)-(2.0D 0-A2)*X(KA+2)-
     & X(KA)*(1.0D 0+4.0D 0*X(KA-1))
      ENDIF
      F=F+ABS(FA)
  261 CONTINUE
      RETURN
  270 A1=0.414214D 0
      DO 271 KA=1,N
      IF (KA.EQ.1) THEN
      FA=X(1)-(1.0D 0-X(1))*X(3)-A1*(1.0D 0+4.0D 0*X(2))
      ELSEIF (KA.EQ.2) THEN
      FA=-(1.0D 0-X(1))*X(4)-A1*(1.0D 0+4.0D 0*X(2))
      ELSEIF (KA.EQ.3) THEN
      FA=A1*X(1)-(1.0D 0-X(1))*X(5)-X(3)*(1.0D 0+4.0D 0*X(2))
      ELSEIF (KA.LE.N-2) THEN
      FA=X(1)*X(KA-2)-(1.0D 0-X(1))*X(KA+2)-
     & X(KA)*(1.0D 0+4.0D 0*X(KA-1))
      ELSEIF (KA.EQ.N-1) THEN
      FA=X(1)*X(N-3)-X(N-1)*(1.0D 0+4.0D 0*X(N-2))
      ELSE
      FA=X(1)*X(N-2)-(1.0D 0-X(1))-X(N)*(1.0D 0+4.0D 0*X(N-1))
      ENDIF
      F=MAX(F,ABS(FA))
  271 CONTINUE
      RETURN
  280 DO 281 KA=1,N
      IF (KA.LT.2) THEN
      FA=X(KA)-EXP(COS(DBLE(KA)*(X(KA)+X(KA+1))))
      ELSEIF (KA.LT.N) THEN
      FA=X(KA)-EXP(COS(DBLE(KA)*(X(KA-1)+X(KA)+X(KA+1))))
      ELSE
      FA=X(KA)-EXP(COS(DBLE(KA)*(X(KA-1)+X(KA))))
      ENDIF
      F=MAX(F,ABS(FA))
  281 CONTINUE
      RETURN
  290 DO 291 KA=1,N
      FA=4.0D 0*X(KA)
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      FA=FA+PAR*X(KA)**3/(1.0D 0+PAR*DBLE(I)**2+
     & PAR*DBLE(J)**2)
      IF(I.EQ.1) FA=FA-1.0D 0
      IF(I.GT.1) FA=FA-X(KA-1)
      IF(I.LT.M) FA=FA-X(KA+1)
      IF(I.EQ.M) FA=FA-2.0D 0+EXP(DBLE(J)/DBLE(M+1))
      IF(J.EQ.1) FA=FA-1.0D 0
      IF(J.GT.1) FA=FA-X(KA-M)
      IF(J.LT.M) FA=FA-X(KA+M)
      IF(J.EQ.M) FA=FA-2.0D 0+EXP(DBLE(I)/DBLE(M+1))
      F=MAX(F,ABS(FA))
  291 CONTINUE
      RETURN
  300 DO 301 KA=1,5*N/2-5
      I=2*((KA+4)/5)
      IF (MOD(KA,5).EQ.1) THEN
      FA=(EXP(X(I-1))-X(I))**2
      ELSEIF (MOD(KA,5).EQ.2) THEN
      FA=1.0D 1*(X(I)-X(I+1))**3
      ELSEIF (MOD(KA,5).EQ.3) THEN
      P=X(I+1)-X(I+2)
      FA=(SIN(P)/COS(P))**2
      ELSEIF (MOD(KA,5).EQ.4) THEN
      FA=X(I-1)**4
      ELSE
      FA=X(I+2)-1.0D 0
      ENDIF
      F=F+ABS(FA)
  301 CONTINUE
      RETURN
  310 DO 311 KA=1,2*N-2
      I=(KA+1)/2
      J=MOD(KA,2)
      IF (J.EQ.0) THEN
      FA=6.0D 0-EXP(2.0D 0*X(I))-EXP(2.0D 0*X(I+1))
      ELSEIF (I.EQ.1) THEN
      FA=4.0D 0-EXP(X(I))-EXP(X(I+1))
      ELSEIF (I.EQ.N) THEN
      FA=8.0D 0-EXP(3.0D 0*X(I-1))-EXP(3.0D 0*X(I))
      ELSE
      FA=8.0D 0-EXP(3.0D 0*X(I-1))-EXP(3.0D 0*X(I))+
     & 4.0D 0-EXP(X(I))-EXP(X(I+1))
      ENDIF
      F=F+ABS(FA)
  311 CONTINUE
      RETURN
      END
