* SUBROUTINE EFGU19                ALL SYSTEMS                94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 VL : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENTS OF MODEL FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  G(N)  GRADIENT OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EFGU19(N,X,G,NEXT)
      INTEGER N,NEXT,I,J,K,KK,L
      $FLOAT X(N),G(N),AI,AJ,ETA9,F1,F2,F3,F4,F,T,Y(2700)
      COMMON /EMPR19/ Y
      PARAMETER (ETA9=1.0$P 60)
      DO 1 I=1,N
      G(I)=0.0$P 0
    1 CONTINUE
      GO TO (10,20,30,30,50,60,70,80,90,180,100,110,230,240,170,120,
     & 210,220,130,140,150,160,190,200,250), NEXT
   10 G(2)=200.0$P 0*(X(2)-X(1)**2)
      G(1)=2.0$P 0*X(1)*(1.0$P 0-G(2))-2.0$P 0
      RETURN
   20 T=X(1)**2+(X(2)-1.0$P 0)**2-1.0$P 0
      F=SIGN(2.0$P 0,T)
      G(1)=F*X(1)
      G(2)=F*(X(2)-1.0$P 0)+1.0$P 0
      RETURN
   30 I=NEXT-2
      J=5-NEXT
      F1=X(I)**2+X(J)**4
      F2=(2.0$P 0-X(1))**2+(2.0$P 0-X(2))**2
      F3=2.0$P 0*EXP(-X(1)+X(2))
      IF ((F1.GE.F2).AND.(F1.GE.F3)) THEN
        G(I)=2.0$P 0*X(I)
        G(J)=4.0$P 0*X(J)**3
      ELSEIF ((F2.GE.F1).AND.(F2.GE.F3)) THEN
        G(1)=-2.0$P 0*(2.0$P 0-X(1))
        G(2)=-2.0$P 0*(2.0$P 0-X(2))
      ELSE
        G(2)=2.0$P 0*EXP(-X(1)+X(2))
        G(1)=-G(2)
      ENDIF
      RETURN
   50 F1=5.0$P 0*X(1)+X(2)
      F2=-5.0$P 0*X(1)+X(2)
      F3=X(1)**2+X(2)**2+4.0$P 0*X(2)
      G(2)=1.0$P 0
      IF ((F1.GE.F2).AND.(F1.GE.F3)) THEN
        G(1)=5.0$P 0
      ELSEIF ((F2.GE.F1).AND.(F2.GE.F3)) THEN
        G(1)=-5.0$P 0
      ELSE
        G(1)=2.0$P 0*X(1)
        G(2)=2.0$P 0*X(2)+4.0$P 0
      ENDIF
      RETURN
   60 F1=X(1)**2+X(2)**2
      F2=F1+10.0$P 0*(-4.0$P 0*X(1)-X(2)+4.0$P 0)
      F3=F1+10.0$P 0*(-X(1)-2.0$P 0*X(2)+6.0$P 0)
      G(1)=2.0$P 0*X(1)
      G(2)=2.0$P 0*X(2)
      IF ((F1.GE.F2).AND.(F1.GE.F3)) THEN
      ELSEIF ((F2.GE.F1).AND.(F2.GE.F3)) THEN
        G(1)=G(1)-40.0$P 0
        G(2)=G(2)-10.0$P 0
      ELSE
        G(1)=G(1)-10.0$P 0
        G(2)=G(2)-20.0$P 0
      ENDIF
      RETURN
   70 F1=-X(1)-X(2)
      F2=F1+(X(1)**2+X(2)**2-1.0$P 0)
      IF (F1.GE.F2) THEN
        G(1)=-1.0$P 0
        G(2)=-1.0$P 0
      ELSE
        G(1)=-1.0$P 0+2.0$P 0*X(1)
        G(2)=-1.0$P 0+2.0$P 0*X(2)
      ENDIF
      RETURN
   80 F1=X(1)**2+X(2)**2-1.0$P 0
      G(1)=-1.0$P 0
      IF (F1.GE.0.0$P 0) THEN
        G(1)=40.0$P 0*X(1)-1.0$P 0
        G(2)=40.0$P 0*X(2)
      ENDIF
      RETURN
   90 F1=SIGN(3.5$P 0,X(1)**2+X(2)**2-1.0$P 0)+4.0$P 0
      G(1)=F1*X(1)-1.0$P 0
      G(2)=F1*X(2)
      RETURN
  180 IF (X(1).GT.ABS(X(2))) THEN
        G(1)=45.0$P 0*X(1)/SQRT(9.0$P 0*X(1)**2+16.0$P 0*X(2)**2)
        G(2)=80.0$P 0*X(2)/SQRT(9.0$P 0*X(1)**2+16.0$P 0*X(2)**2)
      ELSE
        G(1)=9.0$P 0
        IF (X(1).LT.0.0$P 0) G(1)=9.0$P 0-9.0$P 0*X(1)**8
        G(2)=SIGN(16.0$P 0,X(2))
      ENDIF
      RETURN
  100 F=X(1)**2+X(2)**2+X(3)**2
      F2=F+X(4)**2+X(1)-X(2)+X(3)-X(4)-8.0$P 0
      F3=F+X(2)**2+2.0$P 0*X(4)**2-X(1)-X(4)-10.0$P 0
      F4=F+2.0$P 0*X(1)-X(2)-X(4)-5.0$P 0
      L=1
      IF (F2.GT.0.0$P 0) L=2
      IF (F3.GT.MAX(F2,0.0$P 0)) L=3
      IF (F4.GT.MAX(F2,F3,0.0$P 0)) L=4
      GO TO (101,102,103,104),L
  101 G(1)=2.0$P 0*X(1)-5.0$P 0
      G(2)=2.0$P 0*X(2)-5.0$P 0
      G(3)=4.0$P 0*X(3)-21.0$P 0
      G(4)=2.0$P 0*X(4)+7.0$P 0
      RETURN
  102 G(1)=22.0$P 0*X(1)+5.0$P 0
      G(2)=22.0$P 0*X(2)-15.0$P 0
      G(3)=24.0$P 0*X(3)-11.0$P 0
      G(4)=22.0$P 0*X(4)-3.0$P 0
      RETURN
  103 G(1)=22.0$P 0*X(1)-15.0$P 0
      G(2)=42.0$P 0*X(2)-5.0$P 0
      G(4)=42.0$P 0*X(4)-3.0$P 0
      GO TO 105
  104 G(1)=22.0$P 0*X(1)+15.0$P 0
      G(2)=22.0$P 0*X(2)-15.0$P 0
      G(4)=2.0$P 0*X(4)-3.0$P 0
  105 G(3)=24.0$P 0*X(3)-21.0$P 0
      RETURN
  110 F=-ETA9
      DO 112 I=1,10
      F1=0.0$P 0
      DO 113 J=1,5
      F1=F1+(X(J)-Y(5*(I-1)+J))**2
  113 CONTINUE
      F1=F1*Y(50+I)
      IF (F.LT.F1) K=I
      F=MAX(F,F1)
  112 CONTINUE
      DO 114 J=1,5
      G(J)=2.0$P 0*Y(50+K)*(X(J)-Y(5*(K-1)+J))
  114 CONTINUE
      RETURN
  230 F1=0.0$P 0
      DO 231 I=1,10
      T=Y(50+I)
      DO 232 J=1,5
      T=T-Y(I+J*10-10)*X(J)
  232 CONTINUE
      IF (T.GT.F1) K=I
      F1=MAX(F1,T)
  231 CONTINUE
      DO 234 J=1,5
      T=0.0$P 0
      DO 233 I=1,5
      T=T+Y(55+I+J*5)*X(I)
  233 CONTINUE
      G(J)=3.0$P 0*Y(85+J)*X(J)*X(J)+T+T+Y(90+J)
      IF (F1.GT.0.0$P 0) G(J)=G(J)-5.0$P 1*Y(K+J*10-10)
  234 CONTINUE
      RETURN
  240 G(1)=X(2)*X(3)*X(4)*X(5)
      G(2)=X(1)*X(3)*X(4)*X(5)
      G(3)=X(1)*X(2)*X(4)*X(5)
      G(4)=X(1)*X(2)*X(3)*X(5)
      G(5)=X(1)*X(2)*X(3)*X(4)
      F1=X(1)**2+X(2)**2+X(3)**2+X(4)**2+X(5)**2-1.0$P 1
      F4=1.0$P 0
      IF (F1.LT.0.0$P 0) F4=-F4
      DO 241 I=1,5
      G(I)=G(I)+2.0$P 1*F4*X(I)
  241 CONTINUE
      F2=X(2)*X(3)-5.0$P 0*X(4)*X(5)
      F4=1.0$P 0
      IF (F2.LT.0.0$P 0) F4=-F4
      G(2)=G(2)+1.0$P 1*F4*X(3)
      G(3)=G(3)+1.0$P 1*F4*X(2)
      G(4)=G(4)-5.0$P 1*F4*X(5)
      G(5)=G(5)-5.0$P 1*F4*X(4)
      F3=X(1)**3+X(2)**3+1.0$P 0
      F4=1.0$P 0
      IF (F3.LT.0.0$P 0) F4=-F4
      G(1)=G(1)+3.0$P 1*F4*X(1)**2
      G(2)=G(2)+3.0$P 1*F4*X(2)**2
      RETURN
  170 DO 172 I=1,51
      T=$DBLE(I-1)/10.0$P 0
      F=0.5$P 0*EXP(-T)-EXP(-T*2.0$P 0)+0.5$P 0*EXP(-T*3.0$P 0)+
     & 1.5$P 0*EXP(-T*1.5$P 0)*SIN(7.0$P 0*T)+
     & EXP(-T*2.5$P 0)*SIN(5.0$P 0*T)
      F1=EXP(-X(2)*T)
      F2=EXP(-X(6)*T)
      F3=COS(X(3)*T+X(4))
      F4=SIN(X(3)*T+X(4))
      AI=SIGN(1.0$P 0,X(1)*F1*F3+X(5)*F2-F)
      G(1)=G(1)+AI*F1*F3
      G(2)=G(2)-AI*F1*F3*X(1)*T
      G(3)=G(3)-AI*F1*F4*X(1)*T
      G(4)=G(4)-AI*F1*F4*X(1)
      G(5)=G(5)+AI*F2
      G(6)=G(6)-AI*F2*X(5)*T
  172 CONTINUE
      RETURN
  120 F=-ETA9
      L=1
      KK=0
      DO 123 K=1,5
      F1=0.0$P 0
      DO 122 I=1,N
      F1=F1-Y(KK+100+I)*X(I)
      DO 122 J=1,N
      F1=F1+Y(KK+(I-1)*N+J)*X(I)*X(J)
  122 CONTINUE
      IF (F.LT.F1) L=K
      F=MAX(F,F1)
      KK=KK+110
  123 CONTINUE
      DO 126 I=1,N
      G(I)=-Y((L-1)*110+100+I)
      DO 126 J=1,N
      G(I)=G(I)+2.0$P 0*Y((L-1)*110+(I-1)*N+J)*X(J)
  126 CONTINUE
      RETURN
  210 F1=0.0$P 0
      DO 211 I=1,10
      F1=F1+X(I)**2
  211 CONTINUE
      F4=F1-0.25$P 0
      F1=1.0$P -3*F4*F4
      DO 212 I=1,10
      F1=F1+(X(I)-1.0$P 0)**2
  212 CONTINUE
      F2=0.0$P 0
      DO 215 I=2,30
      AI=$DBLE(I-1)/29$P 0
      F=0.0$P 0
      DO 213 J=1,10
      F=F+X(J)*AI**(J-1)
  213 CONTINUE
      F=-F*F-1.0$P 0
      DO 214 J=2,10
      AJ=$DBLE(J-1)
      F=F+X(J)*AJ*AI**(J-2)
  214 CONTINUE
      F2=F2+F*F
  215 CONTINUE
      F2=F2+X(1)**2+(X(2)-X(1)**2-1.0$P 0)**2
      F3=0.0$P 0
      DO 216 I=2,10
      F3=F3+100.0$P 0*(X(I)-X(I-1)**2)**2+(1.0$P 0-X(I))**2
  216 CONTINUE
      IF ((F1.GE.F2).AND.(F1.GE.F3)) THEN
        DO 218 I=1,10
        G(I)=2.0$P 0*X(I)-2.0$P 0+4.0$P -3*X(I)*F4
  218   CONTINUE
      ELSEIF ((F2.GE.F1).AND.(F2.GE.F3)) THEN
        DO 2185 J=1,10
        DO 2185 I=2,30
        AI=$DBLE(I-1)/29$P 0
        F=0.0$P 0
        DO 2183 K=1,10
        F=F-X(K)*AI**(K-1)
 2183   CONTINUE
        T=2.0$P 0*F*AI**(J-1)
        IF (J.GE.2) T=T+(J-1)*AI**(J-2)
        F=-F*F-1.0$P 0
        DO 2184 K=2,10
        F=F+X(K)*(K-1)*AI**(K-2)
 2184   CONTINUE
        G(J)=G(J)+2.0$P 0*F*T
 2185   CONTINUE
        G(1)=G(1)+2.0$P 0*X(1)-4.0$P 0*X(1)*(X(2)-X(1)**2-1.0$P 0)
        G(2)=G(2)+2.0$P 0*(X(2)-X(1)**2-1.0$P 0)
      ELSE
        DO 219 I=1,10
        G(I)=0.0$P 0
        IF (I.GE.2) G(I)=G(I)+2.0$P 2*(X(I)-X(I-1)**2)-
     &                        2.0$P 0*(1.0$P 0-X(I))
        IF (I.LE.9) G(I)=G(I)-4.0$P 2*X(I)*(X(I+1)-X(I)**2)
  219   CONTINUE
      ENDIF
      RETURN
  220 G(1)=X(1)/SQRT(X(1)**2+X(7)**2)
      G(7)=X(7)/SQRT(X(1)**2+X(7)**2)
      T=SQRT((5.5$P 0-X(6))**2+(1.0$P 0+X(12))**2)
      G(6)=-(5.5$P 0-X(6))/T
      G(12)=(1.0$P 0+X(12))/T
      DO 223 J=1,6
      T=SQRT((Y(J)-X(J))**2+(Y(6+J)-X(6+J))**2)
      G(J)=G(J)-Y(12+J)*(Y(J)-X(J))/T
      G(6+J)=G(6+J)-Y(12+J)*(Y(J+6)-X(J+6))/T
  223 CONTINUE
      DO 224 J=1,5
      T=SQRT((X(J)-X(J+1))**2+(X(J+6)-X(J+7))**2)
      G(J)=G(J)+Y(18+J)*(X(J)-X(J+1))/T
      G(J+1)=G(J+1)-Y(18+J)*(X(J)-X(J+1))/T
      G(J+6)=G(J+6)+Y(18+J)*(X(J+6)-X(J+7))/T
      G(J+7)=G(J+7)-Y(18+J)*(X(J+6)-X(J+7))/T
  224 CONTINUE
      RETURN
  130 F=X(1)**2
      K=1
      DO 131 I=2,20
      F1=X(I)**2
      IF (F.LT.F1) K=I
      F=MAX(F,F1)
  131 CONTINUE
      G(K)=2.0$P 0*X(K)
      RETURN
  140 F=ABS(X(1))
      K=1
      DO 141 I=2,20
      F1=ABS(X(I))
      IF (F.LT.F1) K=I
      F=MAX(F,F1)
  141 CONTINUE
      G(K)=SIGN(1.0$P 0,X(K))
      RETURN
  150 KK=N*N
      DO 151 I=1,N
      G(I)=-Y(KK+N+I)
  151 CONTINUE
      DO 152 J=1,N
      F=ETA9
      DO 153 I=1,N
      T=Y((I-1)*N+J)-X(I)
      IF (T.GE.F) GO TO 153
      F=T
      K=I
  153 CONTINUE
      G(K)=G(K)+Y(KK+J)
  152 CONTINUE
      RETURN
  160 F=-ETA9
      DO 162 I=1,50
      F2=X(I)
      IF (F.LT.F2) K=I
      F=MAX(F,F2)
      G(I)=-1.0$P 0
  162 CONTINUE
      G(K)=G(K)+5$P 1
      RETURN
  190 F1=-ETA9
      DO 192 I=1,N
      F=0.0$P 0
      DO 191 J=1,N
      F=F+X(J)/$DBLE(I+J-1)
  191 CONTINUE
      IF (F1.GE.ABS(F)) GO TO 192
      K=I
      AI=SIGN(1$P 0,F)
      F1=ABS(F)
  192 CONTINUE
      DO 194 J=1,N
      G(J)=AI/$DBLE(K+J-1)
  194 CONTINUE
      RETURN
  200 DO 204 J=1,N
      F1=0.0$P 0
      DO 203 I=1,N
      F1=F1+X(I)/$DBLE(I+J-1)
  203 CONTINUE
      AJ=SIGN(1.0$P 0,F1)
      DO 204 I=1,N
      G(I)=G(I)+AJ/$DBLE(I+J-1)
  204 CONTINUE
      RETURN
  250 F1=0.0$P 0
      DO 251 J=1,5
      F1=F1+Y(85+J)*X(J)**3
  251 CONTINUE
      DO 253 J=1,5
      T=0.0$P 0
      DO 252 I=1,5
      T=T+Y(55+I+J*5)*X(I)
  252 CONTINUE
      G(J)=SIGN(6$P 0,F1)*Y(85+J)*X(J)*X(J)+T+T
  253 CONTINUE
      DO 254 J=6,15
      G(J)=-Y(45+J)
  254 CONTINUE
      DO 257 J=1,5
      T=-3.0$P 0*Y(85+J)*X(J)*X(J)-Y(90+J)
      DO 255 I=1,15
      IF (I.LE.5) T=T-2.0$P 0*Y(55+I+J*5)*X(I)
      IF (I.GT.5) T=T+Y(I+J*10-15)*X(I)
  255 CONTINUE
      IF (T.LE.0.0$P 0) GO TO 257
      G(J)=G(J)-6.0$P 2*Y(85+J)*X(J)
      DO 256 I=1,15
      IF (I.LE.5) G(I)=G(I)-2.0$P 2*Y(55+I+J*5)
      IF (I.GT.5) G(I)=G(I)+1.0$P 2*Y(I+J*10-15)
  256 CONTINUE
  257 CONTINUE
      DO 258 I=1,15
      IF (X(I).LT.0.0$P 0) G(I)=G(I)-1.0$P 2
  258 CONTINUE
      RETURN
      END
