* SUBROUTINE EILD03                ALL SYSTEMS                92/11/01
C PORTABILITY : ALL SYSTEMS
C 92/11/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES FOR CONSTRAINED MINIMIZATION.
*  LINEARLY CONSTRAINED AND DENSE VERSION.
*
* PARAMETERS :
*  IO  NF  NUMBER OF VARIABLES.
*  IO  NC  NUMBER OF CONSTRAINTS.
*  II  NCL  NUMBER OF LINEAR CONSTRAINTS.
*  RO  X(NF)  VECTOR OF VARIABLES.
*  IO  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RO  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RO  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  IO  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RO  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RO  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RO  CG(NF*NC) MATRIX WHOSE COLUMNS ARE NORMALS OF THE LINEAR
*         CONSTRAINTS.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EILD03(NF,NC,NCL,X,IX,XL,XU,IC,CL,CU,CG,FMIN,XMAX,
     * NEXT,IEXT,IERR)
      INTEGER NF,NC,NCL,IX(NF),IC(NC),NEXT,IEXT,IERR
      $FLOAT X(NF),XL(NF),XU(NF),CL(NC),CU(NC),CG(NF*NC),FMIN,XMAX
      INTEGER I,J
      $FLOAT Y(235)
      COMMON /EMPR03/ Y
      $FLOAT ETA9
      PARAMETER (ETA9=1.0$P 60)
      FMIN=0.0$P 0
      XMAX=1.0$P 3
      IEXT=0
      IERR=0
      GO TO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150) NEXT
   10 NF=2
      NC=1
      NCL=1
      X(1)=0.0$P 0
      X(2)=0.0$P 0
      IX(1)=0
      IX(2)=0
      IC(1)=5
      CL(1)=0.0$P 0
      CU(1)=0.0$P 0
      CG(1)=4.0$P 0
      CG(2)=-3.0$P 0
      FMIN=-ETA9
      RETURN
   20 NF=2
      NC=2
      NCL=2
      X(1)=1.0$P 0
      X(2)=0.5$P 0
      IX(1)=1
      IX(2)=1
      XL(1)=0.0$P 0
      XL(2)=0.0$P 0
      IC(1)=1
      IC(2)=3
      CL(1)=0.0$P 0
      CL(2)=0.0$P 0
      CU(2)=6.0$P 0
      CG(1)=1.0$P 0/SQRT(3.0$P 0)
      CG(2)=-1.0$P 0
      CG(3)=1.0$P 0
      CG(4)=SQRT(3.0$P 0)
      FMIN=-ETA9
      RETURN
   30 NF=3
      NC=1
      NCL=1
      X(1)=0.7$P 0
      X(2)=0.2$P 0
      X(3)=0.1$P 0
      DO 31 I=1,NF
      IX(I)=3
      XL(I)=0.0$P 0
      XU(I)=1.0$P 0
      CG(I)=1.0$P 0
   31 CONTINUE
      IC(1)=5
      CL(1)=1.0$P 0
      CU(1)=1.0$P 0
      FMIN=-ETA9
      RETURN
   40 NF=3
      NC=1
      NCL=1
      DO 41 I=1,NF
      X(I)=1.0$P 1
      IX(I)=3
      XL(I)=0.0$P 0
      XU(I)=4.2$P 1
   41 CONTINUE
      IC(1)=3
      CL(1)=0.0$P 0
      CU(1)=7.2$P 1
      CG(1)=1.0$P 0
      CG(2)=2.0$P 0
      CG(3)=2.0$P 0
      FMIN=-ETA9
      RETURN
   50 NF=4
      NC=1
      NCL=1
      DO 51 I=1,NF
      X(I)=2.0$P 0
      IX(I)=3
      XL(I)=0.0$P 0
      XU(I)=1.0$P 0
   51 CONTINUE
      XU(4)=2.0$P 0
      IC(1)=5
      CL(1)=0.0$P 0
      CU(1)=0.0$P 0
      CG(1)=1.0$P 0
      CG(2)=2.0$P 0
      CG(3)=2.0$P 0
      CG(4)=-1.0$P 0
      RETURN
   60 NF=4
      NC=1
      NCL=1
      X(1)=3.0$P 0
      X(2)=-1.0$P 0
      X(3)=0.0$P 0
      X(4)=1.0$P 0
      DO 61 I=1,NF
      IX(I)=2
      XU(I)=2.0$P 1
      CG(I)=1.0$P 0
   61 CONTINUE
      IC(1)=1
      CL(1)=1.0$P 0
      RETURN
   70 NF=5
      NC=2
      NCL=2
      X(1)=1.0$P 1
      X(2)=7.0$P 0
      X(3)=2.0$P 0
      X(4)=-3.0$P 0
      X(5)=0.8$P 0
      DO 71 I=1,NF
      IX(I)=0
      CG(I)=1.0$P 0
      CG(I+NF)=0.0$P 0
   71 CONTINUE
      IC(1)=5
      IC(2)=5
      CL(1)=7.0$P 0
      CU(1)=7.0$P 0
      CL(2)=6.0$P 0
      CU(2)=6.0$P 0
      CG(4)=4.0$P 0
      CG(5)=0.0$P 0
      CG(8)=1.0$P 0
      CG(10)=5.0$P 0
      RETURN
   80 NF=5
      NC=3
      NCL=3
      X(1)=3.5$P 1
      X(2)=-3.1$P 1
      X(3)=1.1$P 1
      X(4)=5.0$P 0
      X(5)=-5.0$P 0
      DO 82 I=1,NF
      IX(I)=0
      DO 81 J=1,NC
      CG((J-1)*NF+I)=0.0$P 0
   81 CONTINUE
   82 CONTINUE
      DO 83 J=1,NC
      IC(J)=5
      CL(J)=6.0$P 0
      CU(J)=6.0$P 0
      CG((J-1)*NF+J)=1.0$P 0
      CG((J-1)*NF+J+1)=2.0$P 0
      CG((J-1)*NF+J+2)=3.0$P 0
   83 CONTINUE
      RETURN
   90 NF=5
      NC=3
      NCL=3
      DO 91 J=1,5
      X(J)=2.0$P 0
      IX(J)=0
   91 CONTINUE
      DO 92 J=1,3
      IC(J)=5
   92 CONTINUE
      DO 93 J=1,3
      CL(J)=0.0$P 0
      CU(J)=0.0$P 0
   93 CONTINUE
      DO 94 J=1,15
      CG(J)=0.0$P 0
   94 CONTINUE
      CG(1)=1.0$P 0
      CG(2)=3.0$P 0
      CG(8)=1.0$P 0
      CG(9)=1.0$P 0
      CG(10)=-2.0$P 0
      CG(12)=1.0$P 0
      CG(15)=-1.0$P 0
      RETURN
  100 NF=5
      NC=10
      NCL=10
      DO 101 J=1,5
      X(J)=0.0$P 0
      IX(J)=1
      XL(J)=0.0$P 0
  101 CONTINUE
      X(5)=1.0$P 0
      DO 102 J=1,10
      IC(J)=1
  102 CONTINUE
      DO 103 J=1,50
      CG(J)=0.0$P 0
  103 CONTINUE
      CG(1)=-16.0$P 0
      CG(2)=2.0$P 0
      CG(4)=1.0$P 0
      CG(7)=-2.0$P 0
      CG(9)=4.0$P 0
      CG(10)=2.0$P 0
      CG(11)=-3.5$P 0
      CG(13)=2.0$P 0
      CG(17)=-2.0$P 0
      CG(19)=-4.0$P 0
      CG(20)=-1.0$P 0
      CG(22)=-9.0$P 0
      CG(23)=-2.0$P 0
      CG(24)=1.0$P 0
      CG(25)=-2.8$P 0
      CG(26)=2.0$P 0
      CG(28)=-4.0$P 0
      DO 104 J=1,5
      CG(30+J)=-1.0$P 0
  104 CONTINUE
      CG(36)=-1.0$P 0
      CG(37)=-2.0$P 0
      CG(38)=-3.0$P 0
      CG(39)=-2.0$P 0
      CG(40)=-1.0$P 0
      CG(41)=1.0$P 0
      CG(42)=2.0$P 0
      CG(43)=3.0$P 0
      CG(44)=4.0$P 0
      CG(45)=5.0$P 0
      DO 105 J=1,5
      CG(45+J)=1.0$P 0
  105 CONTINUE
      CL(1)=-40.0$P 0
      CL(2)=-2.0$P 0
      CL(3)=-0.25$P 0
      CL(4)=-4.0$P 0
      CL(5)=-4.0$P 0
      CL(6)=-1.0$P 0
      CL(7)=-40.0$P 0
      CL(8)=-60.0$P 0
      CL(9)=5.0$P 0
      CL(10)=1.0$P 0
      FMIN=-ETA9
      RETURN
  110 NF=6
      NC=1
      NCL=1
      X(1)=6.0$P 3
      X(2)=1.5$P 0
      X(3)=4.0$P 6
      X(4)=2.0$P 0
      X(5)=3.0$P-3
      X(6)=5.0$P 7
      DO 111 J=1,6
      IX(J)=3
  111 CONTINUE
      DO 112 J=1,6
      XL(J)=0.0$P 0
  112 CONTINUE
      XL(2)=-10.0$P 0
      XL(5)=-1.0$P 0
      XU(1)=2.0$P 4
      XU(2)=10.0$P 0
      XU(3)=1.0$P 7
      XU(4)=20.0$P 0
      XU(5)=1.0$P 0
      XU(6)=2.0$P 8
      IC(1)=5
      CL(1)=1.76$P 4
      CU(1)=CL(1)
      DO 113 J=1,6
      CG(J)=0.0$P 0
  113 CONTINUE
      CG(1)=1.0$P 0
      CG(2)=4.0$P 3
      FMIN=-ETA9
      RETURN
  120 NF=6
      NC=6
      NCL=6
      DO 121 J=1,6
      X(J)=0.0$P 0
      IX(J)=1
      XL(J)=0.0$P 0
  121 CONTINUE
      IX(1)=3
      IX(4)=3
      XU(1)=1.0$P 0
      XU(4)=1.0$P 0
      X(1)=1.0$P 0
      X(2)=2.0$P 0
      X(6)=2.0$P 0
      DO 122 J=1,6
      IC(J)=5
  122 CONTINUE
      CL(1)=6.0$P 0
      CL(2)=3.0$P 0
      CL(3)=2.0$P 0
      CL(4)=1.0$P 0
      CL(5)=2.0$P 0
      CL(6)=2.0$P 0
      DO 123 J=1,6
      CU(J)=CL(J)
  123 CONTINUE
      DO 124 J=1,36
      CG(J)=0.0$P 0
  124 CONTINUE
      CG(1)=1.0$P 0
      CG(2)=2.0$P 0
      CG(5)=5.0$P 0
      CG(7)=1.0$P 0
      CG(8)=1.0$P 0
      CG(9)=1.0$P 0
      CG(16)=1.0$P 0
      CG(17)=1.0$P 0
      CG(18)=1.0$P 0
      CG(19)=1.0$P 0
      CG(22)=1.0$P 0
      CG(26)=1.0$P 0
      CG(29)=1.0$P 0
      CG(33)=1.0$P 0
      CG(36)=1.0$P 0
      RETURN
  130 NF=8
      NC=1
      NCL=1
      X(1)=0.1$P 0
      X(2)=0.2$P 0
      X(3)=100.0$P 0
      X(4)=125.0$P 0
      X(5)=175.0$P 0
      X(6)=11.2$P 0
      X(7)=13.2$P 0
      X(8)=15.8$P 0
      DO 131 J=1,8
      IX(J)=3
  131 CONTINUE
      XL(1)=0.001$P 0
      XU(1)=0.499$P 0
      XL(2)=XL(1)
      XU(2)=XU(1)
      XL(3)=100.0$P 0
      XU(3)=180.0$P 0
      XL(4)=130.0$P 0
      XU(4)=210.0$P 0
      XL(5)=170.0$P 0
      XU(5)=240.0$P 0
      DO 132 J=6,8
      XL(J)=5.0$P 0
      XU(J)=25.0$P 0
  132 CONTINUE
      IC(1)=2
      CU(1)=1.0$P 0
      DO 133 J=3,8
      CG(J)=0.0$P 0
  133 CONTINUE
      CG(1)=1.0$P 0
      CG(2)=1.0$P 0
      Y(1)=95.0$P 0
      Y(2)=105.0$P 0
      DO 1301  J=3,6
      Y(J)=110.0$P 0
 1301 CONTINUE
      DO 1302 J=7,10
      Y(J)=115.0$P 0
 1302 CONTINUE
      DO 1303 J=11,25
      Y(J)=120.0$P 0
 1303 CONTINUE
      DO 1304 J=26,40
      Y(J)=125.0$P 0
 1304 CONTINUE
      DO 1305 J=41,55
      Y(J)=130.0$P 0
 1305 CONTINUE
      DO 1306 J=56,68
 1306 Y(J)=135.0$P 0
      CONTINUE
      DO 1307 J=69,89
      Y(J)=140.0$P 0
 1307 CONTINUE
      DO 1308 J=90,101
      Y(J)=145.0$P 0
 1308 CONTINUE
      DO 1309 J=102,118
      Y(J)=150.0$P 0
 1309 CONTINUE
      DO 1310 J=119,122
      Y(J)=155.0$P 0
 1310 CONTINUE
      DO 1311 J=123,142
      Y(J)=160.0$P 0
 1311 CONTINUE
      DO 1312 J=143,150
      Y(J)=165.0$P 0
 1312 CONTINUE
      DO 1313 J=151,167
      Y(J)=170.0$P 0
 1313 CONTINUE
      DO 1314 J=168,175
      Y(J)=175.0$P 0
 1314 CONTINUE
      DO 1315 J=176,181
      Y(J)=180.0$P 0
 1315 CONTINUE
      DO 1316 J=182,187
      Y(J)=185.0$P 0
 1316 CONTINUE
      DO 1317 J=188,194
      Y(J)=190.0$P 0
 1317 CONTINUE
      DO 1318 J=195,198
      Y(J)=195.0$P 0
 1318 CONTINUE
      DO 1319 J=199,201
      Y(J)=200.0$P 0
 1319 CONTINUE
      DO 1320 J=202,204
      Y(J)=205.0$P 0
 1320 CONTINUE
      DO 1321 J=205,212
      Y(J)=210.0$P 0
 1321 CONTINUE
      Y(213)=215.0$P 0
      DO 1322 J=214,219
      Y(J)=220.0$P 0
 1322 CONTINUE
      DO 1323 J=220,224
      Y(J)=230.0$P 0
 1323 CONTINUE
      Y(225)=235.0$P 0
      DO 1324 J=226,232
      Y(J)=240.0$P 0
 1324 CONTINUE
      Y(233)=245.0$P 0
      DO 1325 J=234,235
      Y(J)=250.0$P 0
 1325 CONTINUE
      RETURN
  140 NF=10
      NC=3
      NCL=3
      DO 141 J=1,10
      X(J)=0.1$P 0
      IX(J)=1
      XL(J)=1.0$P -6
  141 CONTINUE
      IC(1)=5
      IC(2)=5
      IC(3)=5
      CL(1)=2.0$P 0
      CL(2)=1.0$P 0
      CL(3)=1.0$P 0
      DO 142 J=1,3
      CU(J)=CL(J)
  142 CONTINUE
      DO 143 J=1,30
      CG(J)=0.0$P 0
  143 CONTINUE
      CG(1)=1.0$P 0
      CG(2)=2.0$P 0
      CG(3)=2.0$P 0
      CG(6)=1.0$P 0
      CG(10)=1.0$P 0
      CG(14)=1.0$P 0
      CG(15)=2.0$P 0
      CG(16)=1.0$P 0
      CG(17)=1.0$P 0
      CG(23)=1.0$P 0
      CG(27)=1.0$P 0
      CG(28)=1.0$P 0
      CG(29)=2.0$P 0
      CG(30)=1.0$P 0
      FMIN=-ETA9
      RETURN
  150 NF=16
      NC=8
      NCL=8
      DO 151 J=1,16
      X(J)=10.0$P 0
      IX(J)=3
      XL(J)=0.0$P 0
      XU(J)=5.0$P 0
  151 CONTINUE
      DO 152 J=1,8
      IC(J)=5
  152 CONTINUE
      DO 153 J=1,128
      CG(J)=0.0$P 0
  153 CONTINUE
      CG(1)=0.22$P 0
      CG(2)=0.20$P 0
      CG(3)=0.19$P 0
      CG(4)=0.25$P 0
      CG(5)=0.15$P 0
      CG(6)=0.11$P 0
      CG(7)=0.12$P 0
      CG(8)=0.13$P 0
      CG(9)=1.0$P 0
      CG(17)=-1.46$P 0
      CG(19)=-1.30$P 0
      CG(20)=1.82$P 0
      CG(21)=-1.15$P 0
      CG(23)=0.80$P 0
      CG(26)=1.0$P 0
      CG(33)=1.29$P 0
      CG(34)=-0.89$P 0
      CG(37)=-1.16$P 0
      CG(38)=-0.96$P 0
      CG(40)=-0.49$P 0
      CG(43)=1.0$P 0
      CG(49)=-1.10$P 0
      CG(50)=-1.06$P 0
      CG(51)=0.95$P 0
      CG(52)=-0.54$P 0
      CG(54)=-1.78$P 0
      CG(55)=-0.41$P 0
      CG(60)=1.0$P 0
      CG(68)=-1.43$P 0
      CG(69)=1.51$P 0
      CG(70)=0.59$P 0
      CG(71)=-0.33$P 0
      CG(72)=-0.43$P 0
      CG(77)=1.0$P 0
      CG(82)=-1.72$P 0
      CG(83)=-0.33$P 0
      CG(85)=1.62$P 0
      CG(86)=1.24$P 0
      CG(87)=0.21$P 0
      CG(88)=-0.26$P 0
      CG(94)=1.0$P 0
      CG(97)=1.12$P 0
      CG(100)=0.31$P 0
      CG(103)=1.12$P 0
      CG(105)=-0.36$P 0
      CG(111)=1.0$P 0
      CG(114)=0.45$P 0
      CG(115)=0.26$P 0
      CG(116)=-1.10$P 0
      CG(117)=0.58$P 0
      CG(119)=-1.03$P 0
      CG(120)=0.10$P 0
      CG(128)=1.0$P 0
      CL(1)=2.5$P 0
      CL(2)=1.1$P 0
      CL(3)=-3.1$P 0
      CL(4)=-3.5$P 0
      CL(5)=1.3$P 0
      CL(6)=2.1$P 0
      CL(7)=2.3$P 0
      CL(8)=-1.5$P 0
      DO 154 J=1,8
      CU(J)=CL(J)
  154 CONTINUE
      RETURN
      END
