* SUBROUTINE EILD22             ALL SYSTEMS                 94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES FOR NONLINEAR APPROXIMATION.
*  UNCONSTRAINED AND DENSE VERSION.
*
* PARAMETERS :
*  IO  N  NUMBER OF VARIABLES.
*  IO  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  IO  NAL NUMBER OF LINEAR APPROXIMATED FUNCTIONS.
*  RO  X(N)  VECTOR OF VARIABLES.
*  RO  FMIN  LOWER BOUND FOR VALUE OF THE OBJECTIVE FUNCTION.
*  RO  XMAX  MAXIMUM STEPSIZE.
*  IO  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EILD22(N,NA,NAL,NC,NCL,X,IX,XL,XU,IC,CL,CU,CG,
     & FMIN,XMAX,NEXT,IEXT,IERR)
      INTEGER N,NA,NAL,NC,NCL,IX(N),IC(NC),NEXT,IEXT,IERR
      $FLOAT X(N),XL(N),XU(N),CL(NC),CU(NC),CG(N*NC),FMIN,XMAX
      INTEGER I,J,K,L
      $FLOAT A
      $FLOAT Y(163),PI
      COMMON /EMPR22/ Y
      PARAMETER (PI=3.14159265358979323846$P 0)
      NAL=0
      FMIN=-1.0$P 60
      XMAX= 1.0$P 3
      IEXT=-1
      IERR= 0
      GOTO (10,20,30,40,80,50,100,190,200,60,70,90,130,150,170,120,140,
     & 160,180,110),NEXT
   10 IF (N.GE.2.AND.NA.GE.3) THEN
      N=2
      NA=3
      NC=1
      NCL=1
      X(1)=1.0$P 0
      X(2)=2.0$P 0
      IC(1)=1
      CL(1)=0.5$P 0
      CG(1)=1.0$P 0
      CG(2)=1.0$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   20 IF (N.GE.2.AND.NA.GE.3) THEN
      N=2
      NA=3
      NC=1
      NCL=1
      X(1)=-2.0$P 0
      X(2)=-1.0$P 0
      IC(1)=2
      CU(1)=-2.5$P 0
      CG(1)= 3.0$P 0
      CG(2)= 1.0$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   30 IF (N.GE.2.AND.NA.GE.3) THEN
      N=2
      NA=3
      NC=1
      NCL=1
      X(1)=-1.0$P 0
      X(2)= 1.0$P-2
      IX(1)=0
      IX(2)=1
      XL(2)=1.0$P-2
      IC(1)=1
      CL(1)=-5.0$P-1
      CG(1)= 5.0$P-2
      CG(2)=-1.0$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   40 IF (N.GE.2.AND.NA.GE.3) THEN
      N=2
      NA=3
      NC=1
      NCL=1
      X(1)=-1.0$P 0
      X(2)= 3.0$P 0
      IX(1)=0
      IX(2)=1
      XL(2)=1.0$P-2
      IC(1)=1
      CL(1)= 1.0$P 0
      CG(1)=-9.0$P-1
      CG(2)= 1.0$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   80 IF (N.GE.6.AND.NA.GE.3) THEN
      N=6
      NA=3
      X(1)=-1.0$P 0
      X(2)= 0.0$P 0
      X(3)= 0.0$P 0
      X(4)=-1.0$P 0
      X(5)= 1.0$P 0
      X(6)= 1.0$P 0
      NC=5*NA
      NCL=5*NA
      DO 82 I=1,NC
      CU(I)=1.0$P 0
      IC(I)=2
   82 CONTINUE
      DO 83 I=1,N*NC
      CG(I)=0.0$P 0
   83 CONTINUE
      K=1
      DO 85 I=1,NA
      L=2*(I-1)
      DO 84 J=1,5
      CG(K+L)=SIN(2.0$P 0*PI*$DBLE(J-1)/5.0$P 0)
      CG(K+L+1)=COS(2.0$P 0*PI*$DBLE(J-1)/5.0$P 0)
      K=K+N
   84 CONTINUE
   85 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
   50 IF (N.GE.7.AND.NA.GE.163) THEN
      N=7
      NA=163
      DO 51 I=1,N
      X(I)=$DBLE(I)*0.5$P 0
      IX(I)=0
   51 CONTINUE
      XL(1)=0.4$P 0
      IX(1)=1
      IX(7)=5
      DO 52 I=1,NA
      Y(I)=2.0$P 0*PI*SIN(PI*(8.5$P 0+$DBLE(I)*0.5$P 0)/180.0$P 0)
   52 CONTINUE
      NC=7
      NCL=7
      DO 53 I=1,6
      CL(I)=0.4$P 0
      IC(I)=1
   53 CONTINUE
      CL(7)=1.0$P 0
      CU(7)=1.0$P 0
      IC(7)=5
      DO 54 I=1,N*NC
      CG(I)=0.0$P 0
   54 CONTINUE
      K=0
      DO 55 I=1,6
      CG(K+I)= -1.0$P 0
      CG(K+I+1)=1.0$P 0
      K=K+N
   55 CONTINUE
      CG(46)=-1.0$P 0
      CG(48)= 1.0$P 0
      IEXT=0
      FMIN=0.0$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  100 IF (N.GE.8.AND.NA.GE.8) THEN
      N=8
      NA=8
      DO 101 I=1,N
      X(I)=0.125$P 0
      XL(I)= 1.0$P-8
      IX(I)=1
  101 CONTINUE
      DO 102 I=1,40
      Y(I)=1.0$P 0
      Y(I+40)=0.1$P 0
  102 CONTINUE
      Y(9)= 2.0$P 0
      Y(10)=0.8$P 0
      Y(12)=0.5$P 0
      Y(18)=1.2$P 0
      Y(19)=0.8$P 0
      Y(20)=1.2$P 0
      Y(21)=1.6$P 0
      Y(22)=2.0$P 0
      Y(23)=0.6$P 0
      Y(24)=0.1$P 0
      Y(25)=2.0$P 0
      Y(26)=0.1$P 0
      Y(27)=0.6$P 0
      Y(28)=2.0$P 0
      Y(32)=2.0$P 0
      Y(33)=1.2$P 0
      Y(34)=1.2$P 0
      Y(35)=0.8$P 0
      Y(37)=1.2$P 0
      Y(38)=0.1$P 0
      Y(39)=3.0$P 0
      Y(40)=4.0$P 0
      Y(41)=3.0$P 0
      Y(42)=1.0$P 0
      Y(45)=5.0$P 0
      Y(48)=6.0$P 0
      Y(50)=1.0$P 1
      Y(53)=5.0$P 0
      Y(58)=9.0$P 0
      Y(59)=1.0$P 1
      Y(61)=4.0$P 0
      Y(63)=7.0$P 0
      Y(68)=1.0$P 1
      Y(70)=3.0$P 0
      Y(80)=1.1$P 1
      Y(81)=0.5$P 0
      Y(82)=1.2$P 0
      Y(83)=0.8$P 0
      Y(84)=2.0$P 0
      Y(85)=1.5$P 0
      NC=1
      NCL=1
      CL(1)=1.0$P 0
      CU(1)=1.0$P 0
      IC(1)=5
      DO 103 I=1,N
      CG(I)=1.0$P 0
  103 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  190 IF (N.GE.10.AND.NA.GE.6) THEN
      N=10
      NA=6
      X(1)= 2.0$P 0
      X(2)= 3.0$P 0
      X(3)= 5.0$P 0
      X(4)= 5.0$P 0
      X(5)= 1.0$P 0
      X(6)= 2.0$P 0
      X(7)= 7.0$P 0
      X(8)= 3.0$P 0
      X(9)= 6.0$P 0
      X(10)=1.0$P 1
      NC=3
      NCL=3
      CU(1)=1.05$P 2
      CU(2)=0.00$P 0
      CU(3)=1.20$P 1
      IC(1)=2
      IC(2)=2
      IC(3)=2
      DO 191 I=1,N*NC
      CG(I)=0.0$P 0
  191 CONTINUE
      CG(1)=  4.0$P 0
      CG(2)=  5.0$P 0
      CG(7)= -3.0$P 0
      CG(8)=  9.0$P 0
      CG(11)= 1.0$P 1
      CG(12)=-8.0$P 0
      CG(17)=-1.7$P 1
      CG(18)= 2.0$P 0
      CG(21)=-8.0$P 0
      CG(22)= 2.0$P 0
      CG(29)= 5.0$P 0
      CG(30)=-2.0$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  200 IF (N.GE.20.AND.NA.GE.14) THEN
      N=20
      NA=14
      X(1)= 2.0$P 0
      X(2)= 3.0$P 0
      X(3)= 5.0$P 0
      X(4)= 5.0$P 0
      X(5)= 1.0$P 0
      X(6)= 2.0$P 0
      X(7)= 7.0$P 0
      X(8)= 3.0$P 0
      X(9)= 6.0$P 0
      X(10)=1.0$P 1
      X(11)=2.0$P 0
      X(12)=2.0$P 0
      X(13)=6.0$P 0
      X(14)=1.5$P 1
      X(15)=1.0$P 0
      X(16)=2.0$P 0
      X(17)=1.0$P 0
      X(18)=2.0$P 0
      X(19)=1.0$P 0
      X(20)=3.0$P 0
      NC=4
      NCL=4
      CU(1)=1.05$P 2
      CU(2)=0.00$P 0
      CU(3)=1.20$P 1
      CU(4)=0.00$P 0
      IC(1)=2
      IC(2)=2
      IC(3)=2
      IC(4)=2
      DO 201 I=1,N*NC
      CG(I)=0.0$P 0
  201 CONTINUE
      CG(1)=  4.0$P 0
      CG(2)=  5.0$P 0
      CG(7)= -3.0$P 0
      CG(8)=  9.0$P 0
      CG(21)= 1.0$P 1
      CG(22)=-8.0$P 0
      CG(27)=-1.7$P 1
      CG(28)= 2.0$P 0
      CG(41)=-8.0$P 0
      CG(42)= 2.0$P 0
      CG(49)= 5.0$P 0
      CG(50)=-2.0$P 0
      CG(61)= 1.0$P 0
      CG(62)= 1.0$P 0
      CG(71)= 4.0$P 0
      CG(72)=-2.1$P 1
      ELSE
      IERR=1
      ENDIF
      RETURN
   60 IF (N.GE.20.AND.NA.GE.38) THEN
      N=20
      NA=38
      DO 61 I=1,N
      X(I)=1.0$P 2
      IX(I)=0
      IF (I.LE.10) IX(I)=1
      XL(I)=0.5$P 0
   61 CONTINUE
      NC=0
      NCL=0
      IEXT=0
      FMIN=0.0$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   70 IF (N.GE.9.AND.NA.GE.124) THEN
      N=9
      NA=124
      K=(N-1)/2
C      X(1)=1.8$P-2
C      X(2)=1.9$P-2
C      X(3)=2.0$P-2
C      X(4)=2.1$P-2
C      X(5)=0.8$P 0
C      X(6)=0.9$P 0
C      X(7)=1.0$P 0
C      X(8)=1.1$P 0
C      X(9)=-1.4$P 1
      X(1)= 0.398D-1
      X(2)= 0.968D-4
      X(3)= 0.103D-3
      X(4)= 0.389D-1
      X(5)= 0.101D 1
      X(6)= 0.968D 0
      X(7)= 0.103D 1
      X(8)= 0.988D 0
      X(9)=-0.116D 2
      DO 71 I=1,N-1
      XL(I)=0.0$P 0
      IX(I)=1
   71 CONTINUE
      IX(N)=0
      L=(NA-2)/2
      A=(1.012577$P 0-0.987423$P 0)/$DBLE(L-1)
      Y(1)=0.967320$P 0
      DO 72 I=2,L+1
      Y(I)=0.987423$P 0+$DBLE(I-2)*A
      Y(I+L)=Y(I)
   72 CONTINUE
      Y(NA)=1.032680$P 0
      NC=K
      NCL=K
      DO 73 I=1,N*NC
      CG(I)=0.0$P 0
   73 CONTINUE
      L=0
      DO 74 I=1,NC
      CG(L+I)=1.0$P 4
      CG(L+I+K)=-1.0$P 0
      CL(I)=0.0$P 0
      IC(I)=1
      L=L+N
   74 CONTINUE
      IEXT=0
      FMIN=0.0$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   90 IF (N.GE.10.AND.NA.GE.9) THEN
      N=10
      NA=9
      X(1)=1745.0$P 0
      X(2)=1200.0$P 1
      X(3)=1100.0$P-1
      X(4)=3048.0$P 0
      X(5)=1974.0$P 0
      X(6)=8920.0$P-2
      X(7)=9280.0$P-2
      X(8)=8000.0$P-3
      X(9)=3600.0$P-3
      X(10)=145.0$P 0
      XL(1)= 1.0$P-5
      XL(2)= 1.0$P-5
      XL(3)= 1.0$P-5
      XL(4)= 1.0$P-5
      XL(5)= 1.0$P-5
      XL(6)= 8.5$P 1
      XL(7)= 9.0$P 1
      XL(8)= 3.0$P 0
      XL(9)= 1.2$P 0
      XL(10)=1.4$P 2
      XU(1)= 2.0$P 3
      XU(2)= 1.6$P 4
      XU(3)= 1.2$P 2
      XU(4)= 5.0$P 3
      XU(5)= 2.0$P 3
      XU(6)= 9.3$P 1
      XU(7)= 9.5$P 1
      XU(8)= 1.2$P 1
      XU(9)= 4.0$P 0
      XU(10)=1.6$P 2
      DO 91 I=1,N
      IX(I)=3
   91 CONTINUE
      NC=5
      NCL=5
      CU(1)=35.82$P 0
      CL(2)=35.82$P 0
      CL(3)=133.0$P 0
      CU(4)=133.0$P 0
      CL(5)=0.0$P 0
      CU(5)=0.0$P 0
      IC(1)=2
      IC(2)=1
      IC(3)=1
      IC(4)=2
      IC(5)=5
      DO 92 I=1,N*NC
      CG(I)=0.0$P 0
   92 CONTINUE
      CG(9)=  0.90$P 0
      CG(10)= 2.22$P-1
      CG(19)= 1.00$P 0/0.90$P 0
      CG(20)= 2.22$P-1
      CG(27)= 3.00$P 0
      CG(30)=-0.99$P 0
      CG(37)= 3.00$P 0
      CG(40)=-1.00$P 0/0.99$P 0
      CG(41)=-1.00$P 0
      CG(44)= 1.22$P 0
      CG(45)=-1.00$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  130 IF (N.GE.7.AND.NA.GE.15) THEN
      N=7
      NA=13
      X(1)=17.45$P 2
      X(2)= 1.10$P 2
      X(3)=30.48$P 2
      X(4)= 8.90$P 1
      X(5)= 9.20$P 1
      X(6)= 8.00$P 0
      X(7)=14.50$P 1
      XL(1)=1.00$P 0
      XL(2)=1.00$P 0
      XL(3)=1.00$P 0
      XL(4)=8.50$P 1
      XL(5)=9.00$P 1
      XL(6)=3.00$P 0
      XL(7)=1.45$P 2
      XU(1)=2.00$P 3
      XU(2)=1.20$P 2
      XU(3)=5.00$P 3
      XU(4)=9.30$P 1
      XU(5)=9.50$P 1
      XU(6)=1.20$P 1
      XU(7)=1.62$P 2
      DO 131 I=1,N
      IX(I)=3
  131 CONTINUE
      Y(1)=  1.71500000$P 0
      Y(2)=  0.03500000$P 0
      Y(3)=  4.05650000$P 0
      Y(4)=  10.0000000$P 0
      Y(5)=  3000.00000$P 0
      Y(6)= -0.06300000$P 0
      Y(7)=  0.59553571$P-2
      Y(8)=  0.88392857$P 0
      Y(9)= -0.11756250$P 0
      Y(10)= 1.10880000$P 0
      Y(11)= 0.13035330$P 0
      Y(12)=-0.00660330$P 0
      Y(13)= 0.66173269$P-3
      Y(14)= 0.17239878$P-1
      Y(15)=-0.56595559$P-2
      Y(16)=-0.19120592$P-1
      Y(17)= 0.56850750$P 2
      Y(18)= 1.08702000$P 0
      Y(19)= 0.32175000$P 0
      Y(20)=-0.03762000$P 0
      Y(21)= 0.00619800$P 0
      Y(22)= 0.24623121$P 4
      Y(23)=-0.25125634$P 2
      Y(24)= 0.16118996$P 3
      Y(25)= 5000.00000$P 0
      Y(26)=-0.48951000$P 6
      Y(27)= 0.44333333$P 2
      Y(28)= 0.33000000$P 0
      Y(29)= 0.02255600$P 0
      Y(30)=-0.00759500$P 0
      Y(31)= 0.00061000$P 0
      Y(32)=-0.00050000$P 0
      Y(33)= 0.81967200$P 0
      Y(34)= 0.81967200$P 0
      Y(35)= 24500.0000$P 0
      Y(36)=-250.000000$P 0
      Y(37)= 0.10204082$P-1
      Y(38)= 0.12244898$P-4
      Y(39)= 0.00006250$P 0
      Y(40)= 0.00006250$P 0
      Y(41)=-0.00007625$P 0
      Y(42)= 1.22000000$P 0
      Y(43)= 1.00000000$P 0
      Y(44)=-1.00000000$P 0
      NC=2
      NCL=2
      L=0
      DO 133 I=1,NC
      CU(I)=1.0$P 0
      IC(I)=2
      DO 132 J=1,N
      CG(L+J)=0.0$P 0
  132 CONTINUE
      L=L+N
  133 CONTINUE
      CG(5)= Y(29)
      CG(7)= Y(30)
      CG(8)= Y(32)
      CG(10)=Y(31)
      ELSE
      IERR=1
      ENDIF
      RETURN
  150 IF (N.GE.8.AND.NA.GE.7) THEN
      N=8
      NA=4
      X(1)=5.00$P 3
      X(2)=5.00$P 3
      X(3)=5.00$P 3
      X(4)=2.00$P 2
      X(5)=3.50$P 2
      X(6)=1.50$P 2
      X(7)=2.25$P 2
      X(8)=4.25$P 2
      DO 151 I=1,N
      XL(I)=1.0$P 1
      XU(I)=1.0$P 3
      IX(I)=3
  151 CONTINUE
      XL(1)=1.0$P 2
      XL(2)=1.0$P 3
      XL(3)=1.0$P 3
      XU(1)=1.0$P 4
      XU(2)=1.0$P 4
      XU(3)=1.0$P 4
      NC=3
      NCL=3
      L=0
      DO 153 I=1,NC
      CU(I)=1.0$P 0
      IC(I)=2
      DO 152 J=1,N
      CG(L+J)=0.0$P 0
  152 CONTINUE
      L=L+N
  153 CONTINUE
      CG(4)=  2.5$P-3
      CG(6)=  2.5$P-3
      CG(12)=-2.5$P-3
      CG(13)= 2.5$P-3
      CG(15)= 2.5$P-3
      CG(21)=-1.0$P-2
      CG(24)= 1.0$P-2
      ELSE
      IERR=1
      ENDIF
      RETURN
  170 IF (N.GE.16.AND.NA.GE.20) THEN
      N=16
      NA=19
      X(1)= 0.80$P 0
      X(2)= 0.83$P 0
      X(3)= 0.85$P 0
      X(4)= 0.87$P 0
      X(5)= 0.90$P 0
      X(6)= 0.10$P 0
      X(7)= 0.12$P 0
      X(8)= 0.19$P 0
      X(9)= 0.25$P 0
      X(10)=0.29$P 0
      X(11)=5.12$P 2
      X(12)=1.31$P 1
      X(13)=7.18$P 1
      X(14)=6.40$P 2
      X(15)=6.50$P 2
      X(16)=5.70$P 0
      XL(1)= 1.0$P-1
      XL(2)= 1.0$P-1
      XL(3)= 1.0$P-1
      XL(4)= 1.0$P-1
      XL(5)= 9.0$P-1
      XL(6)= 1.0$P-4
      XL(7)= 1.0$P-1
      XL(8)= 1.0$P-1
      XL(9)= 1.0$P-1
      XL(10)=1.0$P-1
      XL(11)=1.0$P 0
      XL(12)=1.0$P-6
      XL(13)=1.0$P 0
      XL(14)=5.0$P 2
      XL(15)=5.0$P 2
      XL(16)=1.0$P-6
      XU(1)= 9.0$P-1
      XU(2)= 9.0$P-1
      XU(3)= 9.0$P-1
      XU(4)= 9.0$P-1
      XU(5)= 1.0$P 0
      XU(6)= 1.0$P-1
      XU(7)= 9.0$P-1
      XU(8)= 9.0$P-1
      XU(9)= 9.0$P-1
      XU(10)=9.0$P-1
      XU(11)=1.0$P 4
      XU(12)=5.0$P 3
      XU(13)=5.0$P 3
      XU(14)=1.0$P 4
      XU(15)=1.0$P 4
      XU(16)=5.0$P 3
      DO 171 I=1,N
      IX(I)=3
  171 CONTINUE
      NC=1
      NCL=1
      CU(1)=1.0$P 0
      IC(1)=2
      DO 172 I=1,N
      CG(I)=0.0$P 0
  172 CONTINUE
      CG(11)= 2.0$P-3
      CG(12)=-2.0$P-3
      ELSE
      IERR=1
      ENDIF
      RETURN
  120 IF (N.GE.5.AND.NA.GE.7) THEN
      N=5
      NA=7
      X(1)=78.62$P 0
      X(2)=33.44$P 0
      X(3)=31.07$P 0
      X(4)=44.18$P 0
      X(5)=35.22$P 0
      DO 121 I=1,N
      XL(I)=2.7$P 1
      XU(I)=4.5$P 1
      IX(I)=3
  121 CONTINUE
      XL(1)=7.8$P 1
      XL(2)=3.3$P 1
      XU(1)=1.1$P 2
      Y(1)=  5.35785470$P 0
      Y(2)=  0.83568910$P 0
      Y(3)=  37.2392390$P 0
      Y(4)= -40792.1410$P 0
      Y(5)=  0.00002584$P 0
      Y(6)= -0.00006663$P 0
      Y(7)= -0.00000734$P 0
      Y(8)=  0.00853007$P-1
      Y(9)=  0.00009395$P 0
      Y(10)=-0.00033085$P 0
      Y(11)= 1330.32937$P 0
      Y(12)=-0.42002610$P 0
      Y(13)=-0.30585975$P 0
      Y(14)= 0.00024186$P 0
      Y(15)= 0.00010159$P 0
      Y(16)= 0.00007379$P 0
      Y(17)=2275.132693$P 0
      Y(18)=-0.26680980$P 0
      Y(19)=-0.40583930$P 0
      Y(20)= 0.00029955$P 0
      Y(21)= 0.00007992$P 0
      Y(22)= 0.00012157$P 0
      NC=0
      NCL=0
      ELSE
      IERR=1
      ENDIF
      RETURN
  140 IF (N.GE.8.AND.NA.GE.5) THEN
      N=8
      NA=5
      X(1)=6.0$P 0
      X(2)=3.0$P 0
      X(3)=0.4$P 0
      X(4)=0.2$P 0
      X(5)=6.0$P 0
      X(6)=6.0$P 0
      X(7)=1.0$P 0
      X(8)=0.5$P 0
      DO 141 I=1,N
      XL(I)=1.0$P-1
      XU(I)=1.0$P 1
      IX(I)=3
  141 CONTINUE
      NC=0
      NCL=0
      ELSE
      IERR=1
      ENDIF
      RETURN
  160 IF (N.GE.13.AND.NA.GE.14) THEN
      N=13
      NA=13
      X(1)= 0.50$P 0
      X(2)= 0.80$P 0
      X(3)= 0.90$P 0
      X(4)= 0.10$P 0
      X(5)= 0.14$P 0
      X(6)= 0.50$P 0
      X(7)= 4.89$P 2
      X(8)= 0.80$P 2
      X(9)= 6.50$P 2
      X(10)=4.50$P 2
      X(11)=1.50$P 2
      X(12)=1.50$P 2
      X(13)=1.50$P 2
      XL(1)= 1.0$P-1
      XL(2)= 1.0$P-1
      XL(3)= 9.0$P-1
      XL(4)= 1.0$P-4
      XL(5)= 1.0$P-1
      XL(6)= 1.0$P-1
      XL(7)= 1.0$P-1
      XL(8)= 1.0$P-1
      XL(9)= 5.0$P 2
      XL(10)=1.0$P-1
      XL(11)=1.0$P 0
      XL(12)=1.0$P-4
      XL(13)=1.0$P-4
      XU(1)= 1.0$P 0
      XU(2)= 1.0$P 0
      XU(3)= 1.0$P 0
      XU(4)= 1.0$P-1
      XU(5)= 9.0$P-1
      XU(6)= 9.0$P-1
      XU(7)= 1.0$P 3
      XU(8)= 1.0$P 3
      XU(9)= 1.0$P 3
      XU(10)=5.0$P 2
      XU(11)=1.5$P 2
      XU(12)=1.5$P 2
      XU(13)=1.5$P 2
      DO 161 I=1,N
      IX(I)=3
  161 CONTINUE
      NC=1
      NCL=1
      CU(1)=1.0$P 0
      IC(1)=2
      DO 162 I=1,N
      CG(I)=0.0$P 0
  162 CONTINUE
      CG(7)= 2.0$P-3
      CG(8)=-2.0$P-3
      ELSE
      IERR=1
      ENDIF
      RETURN
  180 IF (N.GE.7.AND.NA.GE.5) THEN
      N=8
      NA=5
      DO 181 I=1,N
      X(I)=6.0$P 0
      XL(I)=1.0$P-1
      XU(I)=1.0$P 1
      IX(I)=3
  181 CONTINUE
      XL(7)=1.0$P-2
      ELSE
      IERR=1
      ENDIF
      RETURN
  110 IF (N.GE.12.AND.NA.GE.4) THEN
      N=12
      NA=4
      DO 111 I=1,N
      X(I)= 4.0$P 0
      XL(I)=1.0$P-1
      XU(I)=1.0$P 2
      IX(I)=3
  111 CONTINUE
      Y(1)= 5.3673730$P-2
      Y(2)= 2.1863746$P-2
      Y(3)= 9.7733533$P-2
      Y(4)= 6.6940803$P-3
      Y(5)= 1.0$P-6
      Y(6)= 1.0$P-5
      Y(7)= 1.0$P-6
      Y(8)= 1.0$P-10
      Y(9)= 1.0$P-8
      Y(10)=1.0$P-2
      Y(11)=1.0$P-4
      Y(12)=1.0898645$P-1
      Y(13)=1.6108052$P-4
      Y(14)=1.0$P-23
      Y(15)=1.9304541$P-6
      Y(16)=1.0$P-3
      Y(17)=1.0$P-6
      Y(18)=1.0$P-5
      Y(19)=1.0$P-6
      Y(20)=1.0$P-9
      Y(21)=1.0$P-9
      Y(22)=1.0$P-3
      Y(23)=1.0$P-3
      Y(24)=1.0898645$P-1
      Y(25)=1.6108052$P-5
      Y(26)=1.0$P-23
      Y(27)=1.9304541$P-8
      Y(28)=1.0$P-5
      Y(29)=1.1184059$P-4
      Y(30)=1.0$P-4
      Y(31)=-1.331720$P-3
      Y(32)=-2.270927$P-3
      Y(33)=-2.485460$P-3
      Y(34)=-4.670000$P 0
      Y(35)=-4.671973$P 0
      Y(36)=-8.140000$P-3
      Y(37)=-8.092000$P-3
      Y(38)=-5.000000$P-3
      Y(39)=-0.909000$P-3
      Y(40)=-0.880000$P-3
      Y(41)=-1.190000$P-3
      NC=0
      NCL=0
      ELSE
      IERR=1
      ENDIF
      RETURN
      END
