* SUBROUTINE EIND20                ALL SYSTEMS                94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES AND STRUCTURE OF THE SPARSE HESSIAN
*  MATRIX FOR UNCONSTRAINED MINIMIZATION.
*  SPARSE VERSION WITH CHANGED TESTS 7-10, 12.
*  CHANGED FOR THE TESTS.
*
* PARAMETERS :
*  IU  N  NUMBER OF VARIABLES.
*  IU  M  NUMBER OF ELEMENTS OF THE SPARSE HESSIAN MATRIX.
*  RO  X(N)  VECTOR OF VARIABLES.
*  IO  IH(N+1)  POINTERS OF THE DIAGONAL ELEMENTS OF THE HESSIAN MATRIX.
*  IO  JH(M)  INDICES OF THE NONZERO ELEMENTS OF THE HESSIAN MATRIX IN
*             THE PACKED ROW.
*  RO  FMIN  LOWER BOUND FOR THE OBJECTIVE FUNCTION.
*  RO  XMAX  MAXIMUM STEPSIZE.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IEXT  TYPE OF EXTREMUM (IEXT=0 - MINIMUM, IEXT-1 - MAXIMUM)
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIND20(N,NC,NCL,X,FMIN,XMAX,NEXT,IEXT,IERR)
      INTEGER N,NC,NCL,NEXT,IEXT,IERR
      $FLOAT X(N),FMIN,XMAX
      INTEGER I
      FMIN=0.0$P 0
      XMAX=1.0$P 3
      IEXT=0
      IERR=0
      NCL=0
      GOTO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,170,
     & 170,80), NEXT
   10 IF(N.GE.2) THEN
      N=N-MOD(N,2)
      DO 11 I=1,N
      IF(MOD(I,2).EQ.1) THEN
      X(I)=-1.2$P 0
      ELSE
      X(I)=1.0$P 0
      ENDIF
   11 CONTINUE
      NC=N-2
      ELSE
      IERR=1
      ENDIF
      RETURN
   20 IF(N.GE.4) THEN
      N=N-MOD(N,2)
      DO 21 I=1,N
      IF(MOD(I,2).EQ.1) THEN
      X(I)=-2.0$P 0
      IF(I.LE.4) X(I)=-3.0$P 0
      ELSE
      X(I)=0.0$P 0
      IF(I.LE.4) X(I)=-1.0$P 0
      ENDIF
   21 CONTINUE
      NC=N-2
      ELSE
      IERR=1
      ENDIF
      RETURN
   30 IF(N.GE.4) THEN
      N=N-MOD(N,2)
      DO 31 I=1,N
      IF(MOD(I,4).EQ.1) THEN
      X(I)=3.0$P 0
      ELSEIF(MOD(I,4).EQ.2) THEN
      X(I)=-1.0$P 0
      ELSEIF(MOD(I,4).EQ.3) THEN
      X(I)=0.0$P 0
      ELSE
      X(I)=1.0$P 0
      ENDIF
   31 CONTINUE
      NC=N-2
      ELSE
      IERR=1
      ENDIF
      RETURN
   40 IF(N.GE.4) THEN
      N=N-MOD(N,2)
      DO 41 I=1,N
      X(I)=2.0$P 0
   41 CONTINUE
      X(1)=1.0$P 0
      NC=N-2
      ELSE
      IERR=1
      ENDIF
      RETURN
   50 IF (N.GE.3) THEN
      DO 51 I=1,N
      X(I)=-1.0$P 0
   51 CONTINUE
      NC=N-4
      ELSE
      IERR=1
      ENDIF
      RETURN
   60 IF (N.GE.7) THEN
      N=N-1+MOD(N,2)
      DO 61 I=1,N
      X(I)=-1.0$P 0
   61 CONTINUE
      NC=N/2
      ELSE
      IERR=1
      ENDIF
      RETURN
   70 IF(N.GE.2) THEN
      DO 71 I=1,N
      X(I)=1.0$P 0
   71 CONTINUE
      NC=4
      ELSE
      IERR=1
      ENDIF
      RETURN
   80 IF(N.GE.5) THEN
      N=N-MOD(N,5)
      DO  81 I=0,N-5,5
      X(I+1)=-1.0$P 0
      X(I+2)=-1.0$P 0
      X(I+3)=2.0$P 0
      X(I+4)=-1.0$P 0
      X(I+5)=-1.0$P 0
   81 CONTINUE
      X(1)=-2.0$P 0
      X(2)=2.0$P 0
      XMAX=1.0$P 0
      NC=N-2
      ELSE
      IERR=1
      ENDIF
      RETURN
   90 IF(N.GE.2) THEN
      N=N-MOD(N,2)
      DO 91 I=2,N,2
      X(I-1)=0.0$P 0
      X(I)=-1.0$P 0
   91 CONTINUE
      XMAX=1.0$P 1
      NC=6
      ELSE
      IERR=1
      ENDIF
      RETURN
  100 IF(N.GE.2) THEN
      N=N-MOD(N,2)
      DO 101 I=2,N,2
      X(I-1)=-1.0$P 0
      X(I)=1.0$P 0
  101 CONTINUE
      XMAX=0.2$P 0
      NC=N-2
      ELSE
      IERR=1
      ENDIF
      RETURN
  110 IF (N.GE.5) THEN
      N=N-MOD(N-2,3)
      DO 111 I=1,N
      IF (MOD(I,3).EQ.1) X(I)=2.0$P 0
      IF (MOD(I,3).EQ.2) X(I)=1.5$P 0
      IF (MOD(I,3).EQ.0) X(I)=0.5$P 0
  111 CONTINUE
      NC=2*(N-2)/3
      ELSE
      IERR=1
      ENDIF
      RETURN
  120 IF (N.GE.5) THEN
      N=N-MOD(N-1,4)
      DO 121 I=1,N
      IF (MOD(I,4).EQ.1) X(I)= 2.0$P 0
      IF (MOD(I,4).EQ.2) X(I)= 1.5$P 0
      IF (MOD(I,4).EQ.3) X(I)=-1.0$P 0
      IF (MOD(I,4).EQ.0) X(I)= 0.5$P 0
  121 CONTINUE
      NC=3*(N-1)/4
      ELSE
      IERR=1
      ENDIF
      RETURN
  130 IF (N.GE.5) THEN
      N=N-MOD(N-2,3)
      DO 131 I=1,N
      IF (MOD(I,3).EQ.1) X(I)= 3.0$P 0
      IF (MOD(I,3).EQ.2) X(I)= 5.0$P 0
      IF (MOD(I,3).EQ.0) X(I)=-3.0$P 0
  131 CONTINUE
      NC=2*(N-2)/3
      ELSE
      IERR=1
      ENDIF
      RETURN
  140 IF (N.GE.5) THEN
      N=N-MOD(N-2,3)
      DO 141 I=1,N
      IF (MOD(I,3).EQ.1) X(I)= 1.0$P 1
      IF (MOD(I,3).EQ.2) X(I)= 7.0$P 0
      IF (MOD(I,3).EQ.0) X(I)=-3.0$P 0
  141 CONTINUE
      NC=2*(N-2)/3
      ELSE
      IERR=1
      ENDIF
      RETURN
  150 IF (N.GE.5) THEN
      N=N-MOD(N-1,4)
      DO 151 I=1,N
      IF (MOD(I,4).EQ.1) X(I)= 3.5$P 1
      IF (MOD(I,4).EQ.2) X(I)=-3.1$P 1
      IF (MOD(I,4).EQ.3) X(I)= 1.1$P 1
      IF (MOD(I,4).EQ.0) X(I)=-5.0$P 0
  151 CONTINUE
      NC=3*(N-1)/4
      ELSE
      IERR=1
      ENDIF
      RETURN
  160 IF (N.GE.5) THEN
      N=N-MOD(N-1,4)
      DO 161 I=1,N
      IF (MOD(I,4).EQ.1) X(I)= 2.5$P 0
      IF (MOD(I,4).EQ.2) X(I)= 0.5$P 0
      IF (MOD(I,4).EQ.3) X(I)= 2.0$P 0
      IF (MOD(I,4).EQ.0) X(I)=-1.0$P 0
  161 CONTINUE
      NC=3*(N-1)/4
      ELSE
      IERR=1
      ENDIF
      RETURN
  170 IF (N.GE.5) THEN
      N=N-MOD(N-1,4)
      DO 171 I=1,N
      X(I)=2.0$P 0
  171 CONTINUE
      NC=3*(N-1)/4
      ELSE
      IERR=1
      ENDIF
      RETURN
      END
