* SUBROUTINE EINS99                ALL SYSTEMS                11/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  STRUCTURE OF CONSTRAINTS, COMPLEMENTARITIES AND THE SPARSE JACOBIAN
*  MATRIX FOR COMPLEMENTARITY PROBLEMS.
*
* PARAMETERS :
*  IU  NC  NUMBER OF GENERAL CONSTRAINTS.
*  IU  NCC  NUMBER OF COMPLEMENTARITY CONSTRAINTS.
*  IO  IC(NC)  VECTOR CONTAINING TYPES OF GENERAL CONSTRAINTS.
*  IO  CL(NC)  LOWER BOUNDS FOR CONSTRAINTS.
*  IO  CU(NC)  UPPER BOUNDS FOR CONSTRAINTS.
*  IO  ICC(2*NCC) INDICES OF COMPLEMENTARITY FUNCTIONS.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EINS99(NC,MC,NCC,IC,CL,CU,ICC,ICG,JCG,NEXT)
      INTEGER NC,MC,NCC,IC(NC),ICC(2*NCC),ICG(NC+1),JCG(MC),NEXT
      INTEGER I
      $FLOAT CL(NC),CU(NC)
      GOTO (10,20,30,40,40,40,40,40,40,40,40,40,40,140,140,140,140,140,
     &140,140,140,140,140,240,250,260,270,280,290), NEXT
C
C     DESILVA QQR-AY-NCP-6-2-2
C
   10 NC=4
      NCC=2
      IC(1)=5
      CL(1)=0.0$P 0
      IC(2)=5
      CL(2)=0.0$P 0
      IC(3)=1
      CL(3)=0.0$P 0
      IC(4)=1
      CL(4)=0.0$P 0
      ICC(1)=3
      ICC(2)=4
      ICC(3)=-3
      ICC(4)=-4
      MC=8
      ICG(1)=1
      ICG(2)=4
      ICG(3)=7
      ICG(4)=8
      ICG(5)=9
      JCG(1)=1
      JCG(2)=3
      JCG(3)=5
      JCG(4)=2
      JCG(5)=4
      JCG(6)=6
      JCG(7)=5
      JCG(8)=6
      RETURN
C
C     DF1 QQR-AY-NCP-2-2-1
C
   20 NC=2
      NCC=1
      IC(1)=2
      CU(1)=3.0$P 0
      IC(2)=1
      CL(2)=0.0$P 0
      ICC(1)=-2
      ICC(2)=2
      MC=4
      ICG(1)=1
      ICG(2)=3
      ICG(3)=5
      JCG(1)=1
      JCG(2)=2
      JCG(3)=1
      JCG(4)=2
      RETURN
C
C     DEMPE QQR-AY-LCP-4-2-2
C
   30 NC=2
      NCC=1
      IC(1)=5
      CL(1)=3.0$P 0
      IC(2)=2
      CL(2)=0.0$P 0
      ICC(1)=-1
      ICC(2)=2
      MC=4
      ICG(1)=1
      ICG(2)=3
      ICG(3)=5
      JCG(1)=1
      JCG(2)=3
      JCG(3)=2
      JCG(4)=3
      RETURN
C
C     GNASH10 OOR-AY-LCP-13-4-8
C     GNASH11 OOR-AY-LCP-13-4-8
C     GNASH12 OOR-AY-LCP-13-4-8
C     GNASH13 OOR-AY-LCP-13-4-8
C     GNASH14 OOR-AY-LCP-13-4-8
C     GNASH15 OOR-AY-LCP-13-4-8
C     GNASH16 OOR-AY-LCP-13-4-8
C     GNASH17 OOR-AY-LCP-13-4-8
C     GNASH18 OOR-AY-LCP-13-4-8
C     GNASH19 OOR-AY-LCP-13-4-8
C
   40 NC=8
      NCC=8
      DO 41 I=1,4
        IC(I)=5
        IC(I+4)=1
        CL(I)=0.0$P 0
        CL(I+4)=0.0$P 0
   41 CONTINUE
      DO 42 I=1,8
        ICC(I)=-(I+5)
   42 CONTINUE
      ICC(9)=-2
      ICC(10)=5
      ICC(11)=-3
      ICC(12)=6
      ICC(13)=-4
      ICC(14)=7
      ICC(15)=-5
      ICC(16)=8
      MC=32
      ICG(1)=1
      DO 43 I=2,5
        ICG(I)=ICG(I-1)+7
   43 CONTINUE
      DO 44 I=6,9
        ICG(I)=ICG(I-1)+1
   44 CONTINUE
      DO 45 I=1,7
        JCG(I)=I
   45 CONTINUE
      DO 46 I=1,5
        JCG(7+I)=I
   46 CONTINUE
      JCG(13)=8
      JCG(14)=9
      DO 47 I=1,5
        JCG(14+I)=I
   47 CONTINUE
      JCG(20)=10
      JCG(21)=11
      DO 48 I=1,5
        JCG(21+I)=I
   48 CONTINUE
      JCG(27)=12
      JCG(28)=13
      DO 49 I=1,4
        JCG(28+I)=I+1
   49 CONTINUE
      RETURN
C
C     GNASH10M OOR-AY-LCP-9-8-8   MODIFIED
C     GNASH11M OOR-AY-LCP-9-8-8   MODIFIED
C     GNASH12M OOR-AY-LCP-9-8-8   MODIFIED
C     GNASH13M OOR-AY-LCP-9-8-8   MODIFIED
C     GNASH14M OOR-AY-LCP-9-8-8   MODIFIED
C     GNASH15M OOR-AY-LCP-9-8-8   MODIFIED
C     GNASH16M OOR-AY-LCP-9-8-8   MODIFIED
C     GNASH17M OOR-AY-LCP-9-8-8   MODIFIED
C     GNASH18M OOR-AY-LCP-9-8-8   MODIFIED
C     GNASH19M OOR-AY-LCP-9-8-8   MODIFIED
C
  140 NC=8
      NCC=8
      DO 141 I=1,4
        IC(I)=5
        IC(I+4)=1
        CL(I)=0.0$P 0
        CL(I+4)=0.0$P 0
  141 CONTINUE
      DO 142 I=1,4
        ICC(I)=-(I+1)
        ICC(I+4)=I+4
        ICC(I+8)=-(I+5)
        ICC(I+12)=-(I+5)
  142 CONTINUE
      MC=28
      ICG(1)=1
      DO 143 I=2,5
        ICG(I)=ICG(I-1)+6
  143 CONTINUE
      DO 144 I=6,9
        ICG(I)=ICG(I-1)+1
  144 CONTINUE
      DO 145 I=1,6
        JCG(I)=I
  145 CONTINUE
      DO 146 I=1,5
        JCG(6+I)=I
  146 CONTINUE
      JCG(12)=7
      DO 147 I=1,5
        JCG(12+I)=I
  147 CONTINUE
      JCG(18)=8
      DO 148 I=1,5
        JCG(18+I)=I
  148 CONTINUE
      JCG(24)=9
      DO 149 I=1,4
        JCG(24+I)=I+1
  149 CONTINUE
      RETURN
C
C     DESIGN-CENT-1 QOR-AY-NLP-12-9-3
C
  240 NC=11
      NCC=3
      IC(1)=2
      CL(1)=0.0$P 0
      IC(2)=2
      CL(2)=3.0$P 0
      DO 241 I=3,8
        IC(I)=5
  241 CONTINUE
      CL(3)=-1.0$P 0
      CL(4)=0.0$P 0
      CL(5)=2.5$P-1
      CL(6)=1.0$P 0
      CL(7)=0.0$P 0
      CL(8)=-1.0$P 0
      DO 242 I=9,11
        IC(I)=2
        CL(I)=0.0$P 0
  242 CONTINUE
      ICC(1)=-10
      ICC(2)=-11
      ICC(3)=-12
      ICC(4)=9
      ICC(5)=10
      ICC(6)=11
      ICG(1)=1
      ICG(2)=3
      ICG(3)=5
      DO 243 I=4,9
        ICG(I)=ICG(I-1)+3
  243 CONTINUE
      DO 244 I=10,12
        ICG(I)=ICG(I-1)+5
  244 CONTINUE
      MC=ICG(12)-1
      JCG(1)=4
      JCG(2)=7
      JCG(3)=5
      JCG(4)=8
      JCG(5)=1
      JCG(6)=4
      JCG(7)=10
      JCG(8)=2
      JCG(9)=7
      JCG(10)=10
      JCG(11)=1
      JCG(12)=5
      JCG(13)=11
      JCG(14)=2
      JCG(15)=8
      JCG(16)=11
      JCG(17)=1
      JCG(18)=6
      JCG(19)=12
      JCG(20)=2
      JCG(21)=9
      JCG(22)=12
      JCG(23)=1
      JCG(24)=2
      JCG(25)=3
      JCG(26)=4
      JCG(27)=7
      JCG(28)=1
      JCG(29)=2
      JCG(30)=3
      JCG(31)=5
      JCG(32)=8
      JCG(33)=1
      JCG(34)=2
      JCG(35)=3
      JCG(36)=6
      JCG(37)=9
      RETURN
C
C     DESIGN-CENT-2 QOR-MY-NLP-13-13-3
C
  250 DO 252 I=9,11
        IC(I)=2
        CU(I)=1.0$P 0
  252 CONTINUE
  251 NC=15
      NCC=3
      IC(1)=2
      CU(1)=0.0$P 0
      IC(2)=2
      CU(2)=3.0$P 0
      DO 253 I=3,8
        IC(I)=5
  253 CONTINUE
      CL(3)=-1.0$P 0
      CL(4)=0.0$P 0
      CL(5)=2.5$P-1
      CL(6)=1.0$P 0
      CL(7)=0.0$P 0
      CL(8)=-1.0$P 0
      IC(12)=2
      CU(12)=0.0$P 0
      IC(13)=1
      CU(13)=0.0$P 0
      IC(14)=1
      CU(14)=0.0$P 0
      IC(15)=2
      CU(15)=0.0$P 0
      ICC(1)=-10
      ICC(2)=-11
      ICC(3)=-12
      ICC(4)=9
      ICC(5)=10
      ICC(6)=11
      ICG(1)=1
      ICG(2)=3
      ICG(3)=5
      DO 254 I=4,9
        ICG(I)=ICG(I-1)+4
  254 CONTINUE
      DO 255 I=10,12
        ICG(I)=ICG(I-1)+6
  255 CONTINUE
      DO 256 I=13,16
        ICG(I)=ICG(I-1)+2
  256 CONTINUE
      MC=ICG(16)-1
      JCG(1)=4
      JCG(2)=7
      JCG(3)=5
      JCG(4)=8
      JCG(5)=1
      JCG(6)=3
      JCG(7)=4
      JCG(8)=10
      JCG(9)=2
      JCG(10)=7
      JCG(11)=10
      JCG(12)=13
      JCG(13)=1
      JCG(14)=3
      JCG(15)=5
      JCG(16)=11
      JCG(17)=2
      JCG(18)=8
      JCG(19)=11
      JCG(20)=13
      JCG(21)=1
      JCG(22)=3
      JCG(23)=6
      JCG(24)=12
      JCG(25)=2
      JCG(26)=9
      JCG(27)=12
      JCG(28)=13
      JCG(29)=1
      JCG(30)=2
      JCG(31)=3
      JCG(32)=4
      JCG(33)=7
      JCG(34)=13
      JCG(35)=1
      JCG(36)=2
      JCG(37)=3
      JCG(38)=5
      JCG(39)=8
      JCG(40)=13
      JCG(41)=1
      JCG(42)=2
      JCG(43)=3
      JCG(44)=6
      JCG(45)=9
      JCG(46)=13
      JCG(47)=1
      JCG(48)=4
      JCG(49)=1
      JCG(50)=5
      JCG(51)=2
      JCG(52)=8
      JCG(53)=2
      JCG(54)=9
      RETURN
C
C     DESIGN-CENT-21 QOR-MY-NLP-13-13-3
C
  260 DO 261 I=9,11
        IC(I)=2
        CU(I)=0.0$P 0
  261 CONTINUE
      GOTO 251
C
C     DESIGN-CENT-3 QOR-MY-NLP-15-9-3
C
  270 NC=11
      NCC=3
      IC(1)=2
      CU(1)=0.0$P 0
      IC(2)=2
      CU(2)=3.0$P 0
      DO 272 I=3,8
        IC(I)=5
  272 CONTINUE
      CL(3)=-1.0$P 0
      CL(4)=0.0$P 0
      CL(5)=2.5$P-1
      CL(6)=1.0$P 0
      CL(7)=0.0$P 0
      CL(8)=-1.0$P 0
      DO 273 I=9,11
        IC(I)=2
        CU(I)=1.0$P 0
  273 CONTINUE
  271 ICC(1)=-13
      ICC(2)=-14
      ICC(3)=-15
      ICC(4)=9
      ICC(5)=10
      ICC(6)=11
      ICG(1)=1
      ICG(2)=3
      ICG(3)=5
      DO 274 I=4,9
        ICG(I)=ICG(I-1)+9
  274 CONTINUE
      DO 275 I=10,12
        ICG(I)=ICG(I-1)+8
  275 CONTINUE
      MC=ICG(12)-1
      JCG(1)=7
      JCG(2)=10
      JCG(3)=8
      JCG(4)=11
      DO 276 I=1,6
        JCG(4+I)=I
  276 CONTINUE
      JCG(11)=7
      JCG(12)=10
      JCG(13)=13
      DO 277 I=1,6
        JCG(13+I)=I
  277 CONTINUE
      JCG(20)=7
      JCG(21)=10
      JCG(22)=13
      DO 278 I=1,6
        JCG(22+I)=I
  278 CONTINUE
      JCG(29)=8
      JCG(30)=11
      JCG(31)=14
      DO 279 I=1,6
        JCG(31+I)=I
  279 CONTINUE
      JCG(38)=8
      JCG(39)=11
      JCG(40)=14
      DO 2791 I=1,6
        JCG(40+I)=I
 2791 CONTINUE
      JCG(47)=9
      JCG(48)=12
      JCG(49)=15
      DO 2792 I=1,6
        JCG(49+I)=I
 2792 CONTINUE
      JCG(56)=9
      JCG(57)=12
      JCG(58)=15
      DO 2793 I=1,6
        JCG(58+I)=I
 2793 CONTINUE
      JCG(65)=7
      JCG(66)=10
      DO 2794 I=1,6
        JCG(66+I)=I
 2794 CONTINUE
      JCG(73)=8
      JCG(74)=11
      DO 2795 I=1,6
        JCG(74+I)=I
 2795 CONTINUE
      JCG(81)=9
      JCG(82)=12
      RETURN
C
C     DESIGN-CENT-31 QOR-MY-NLP-15-9-3
C
  280 NC=11
      NCC=3
      IC(1)=2
      CU(1)=0.0$P 0
      IC(2)=2
      CU(2)=3.0$P 0
      DO 282 I=3,8
        IC(I)=5
        CL(I)=0.0$P 0
  282 CONTINUE
      DO 283 I=9,11
        IC(I)=2
        CU(I)=0.0$P 0
  283 CONTINUE
      GOTO 271
C
C	DESIGN-CENT-4 QOR-AY-NLP-22-9-12
C
  290 NC=20
      NCC=12
      IC(1)=2
      CU(1)=0.0$P 0
      IC(2)=2
      CU(2)=3.0$P 0
      DO 291 I=3,8
        IC(I)=5
  291 CONTINUE
      CL(3)=-1.0$P 0
      CL(4)=0.0$P 0
      CL(5)=2.5$P-1
      CL(6)=1.0$P 0
      CL(7)=0.0$P 0
      CL(8)=-1.0$P 0
      DO 292 I=9,20
        IC(I)=2
        CU(I)=0.0$P 0
  292 CONTINUE
      DO 293 I=1,12
        ICC(I)=-(I+10)
        ICC(12+I)=8+I
  293 CONTINUE
      ICG(1)=1
      DO 294 I=1,3
        ICG(I+1)=ICG(I)+2
  294 CONTINUE
      ICG(5)=ICG(4)+3
      DO 295 I=5,NC
        ICG(I+1)=ICG(I)+2
  295 CONTINUE
      MC=ICG(NC+1)-1
      JCG(1)=5
      JCG(2)=8
      JCG(3)=6
      JCG(4)=9
      JCG(5)=11
      JCG(6)=17
      JCG(7)=8
      JCG(8)=14
      JCG(9)=20
      JCG(10)=12
      JCG(11)=18
      JCG(12)=15
      JCG(13)=21
      JCG(14)=13
      JCG(15)=19
      JCG(16)=16
      JCG(17)=22
      JCG(18)=1
      JCG(20)=1
      JCG(22)=1
      JCG(24)=2
      JCG(26)=2
      JCG(28)=2
      JCG(30)=3
      JCG(32)=3
      JCG(34)=3
      JCG(36)=4
      JCG(38)=4
      JCG(40)=4
      DO 296 I=5,10
        JCG(2*I+9)=I
  296 CONTINUE
      DO 297 I=5,10
        JCG(2*I+21)=I
  297 CONTINUE
      RETURN


      END
