* SUBROUTINE EIUD02             ALL SYSTEMS                 91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES FOR NONLINEAR APPROXIMATION.
*  UNCONSTRAINED AND DENSE VERSION.
*
* PARAMETERS :
*  IO  N  NUMBER OF VARIABLES.
*  IO  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  IO  NAL NUMBER OF LINEAR APPROXIMATED FUNCTIONS.
*  RO  X(N)  VECTOR OF VARIABLES.
*  RO  FMIN  LOWER BOUND FOR VALUE OF THE OBJECTIVE FUNCTION.
*  RO  XMAX  MAXIMUM STEPSIZE.
*  IO  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIUD02(N,NA,NAL,X,FMIN,XMAX,NEXT,IEXT,IERR)
      INTEGER I,N,NA,NAL,NEXT,IEXT,IERR
      $FLOAT X(N),FMIN,XMAX
      $FLOAT Y(65),W
      COMMON /EMPR02/ Y
      NAL=0
      FMIN=0.0$P 0
      XMAX=1.0$P 3
      IEXT=0
      IERR=0
      GOTO(10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     &    170,180,190,200,210,220,230,240,250,260,270,280,290,300),NEXT
   10 IF(N.GE.2.AND.NA.GE.2) THEN
      N=2
      NA=2
      X(1)=-1.2$P 0
      X(2)=1.0$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   20 IF(N.GE.2.AND.NA.GE.2) THEN
      N=2
      NA=2
      X(1)=0.5$P 0
      X(2)=-2.0$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   30 IF(N.GE.2.AND.NA.GE.2) THEN
      N=2
      NA=2
      X(1)=0.0$P 0
      X(2)=1.0$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   40 IF(N.GE.2.AND.NA.GE.3) THEN
      N=2
      NA=3
      X(1)=1.0$P 0
      X(2)=1.0$P 0
      XMAX=1.0$P 6
      ELSE
      IERR=1
      ENDIF
      RETURN
   50 IF(N.GE.2.AND.NA.GE.3) THEN
      N=2
      NA=3
      X(1)=1.0$P 0
      X(2)=1.0$P 0
      Y(1)=1.5$P 0
      Y(2)=2.25$P 0
      Y(3)=2.625$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   60 IF(N.GE.2.AND.NA.GE.2) THEN
      N=2
      NA=MIN(NA,10)
      X(1)=0.3$P 0
      X(2)=0.4$P 0
      XMAX=1.0$P 1
      ELSE
      IERR=1
      ENDIF
      RETURN
   70 IF(N.GE.3.AND.NA.GE.3) THEN
      N=3
      NA=3
      X(1)=-1.0$P 0
      X(2)=0.0$P 0
      X(3)=0.0$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   80 IF(N.GE.3.AND.NA.GE.15) THEN
      N=3
      NA=15
      X(1)=1.0$P 0
      X(2)=1.0$P 0
      X(3)=1.0$P 0
      Y(1)=0.14$P 0
      Y(2)=0.18$P 0
      Y(3)=0.22$P 0
      Y(4)=0.25$P 0
      Y(5)=0.29$P 0
      Y(6)=0.32$P 0
      Y(7)=0.35$P 0
      Y(8)=0.39$P 0
      Y(9)=0.37$P 0
      Y(10)=0.58$P 0
      Y(11)=0.73$P 0
      Y(12)=0.96$P 0
      Y(13)=1.34$P 0
      Y(14)=2.10$P 0
      Y(15)=4.39$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   90 IF(N.GE.3.AND.NA.GE.15) THEN
      N=3
      NA=15
      X(1)=0.4$P 0
      X(2)=1.0$P 0
      X(3)=0.0$P 0
      Y(1)=0.0009$P 0
      Y(2)=0.0044$P 0
      Y(3)=0.0175$P 0
      Y(4)=0.0540$P 0
      Y(5)=0.1295$P 0
      Y(6)=0.2420$P 0
      Y(7)=0.3521$P 0
      Y(8)=0.3989$P 0
      Y(9)=0.3521$P 0
      Y(10)=0.2420$P 0
      Y(11)=0.1295$P 0
      Y(12)=0.0540$P 0
      Y(13)=0.0175$P 0
      Y(14)=0.0044$P 0
      Y(15)=0.0009$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  100 IF(N.GE.3.AND.NA.GE.16) THEN
      N=3
      NA=16
      X(1)=0.02$P 0
      X(2)=4.0$P 3
      X(3)=2.5$P 2
      Y(1)=3478$P 1
      Y(2)=2861$P 1
      Y(3)=2365$P 1
      Y(4)=1963$P 1
      Y(5)=1637$P 1
      Y(6)=1372$P 1
      Y(7)=1154$P 1
      Y(8)=9744$P 0
      Y(9)=8261$P 0
      Y(10)=7030$P 0
      Y(11)=6005$P 0
      Y(12)=5147$P 0
      Y(13)=4427$P 0
      Y(14)=3820$P 0
      Y(15)=3307$P 0
      Y(16)=2872$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  110 IF(N.GE.3.AND.NA.GE.3) THEN
      N=3
      NA=MIN(NA,20)
      X(1)=5.0$P 0
      X(2)=2.5$P 0
      X(3)=0.15$P 0
      DO 111 I=1,NA
      Y(I)=2.5$P 1+(-5.0$P 1*LOG(1.0$P-2*$DBLE(I)))**(2.0$P 0/3.0$P 0)
C     Y(I)=Y(I)*$DBLE(NA*I)
  111 CONTINUE
      XMAX=1.0$P 1
      ELSE
      IERR=1
      ENDIF
      RETURN
  120 IF(N.GE.3.AND.NA.GE.3) THEN
      N=3
      NA=MIN(NA,20)
      X(1)=0.0$P 0
      X(2)=1.0$P 1
      X(3)=2.0$P 1
      ELSE
      IERR=1
      ENDIF
      RETURN
  130 IF(N.GE.4.AND.NA.GE.4) THEN
      N=4
      NA=4
      X(1)=3.0$P 0
      X(2)=-1.0$P 0
      X(3)=0.0$P 0
      X(4)=1.0$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  140 IF(N.GE.4.AND.NA.GE.6) THEN
      N=4
      NA=6
      X(1)=-3.0$P 0
      X(2)=-1.0$P 0
      X(3)=-3.0$P 0
      X(4)=-1.0$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  150 IF(N.GE.4.AND.NA.GE.11) THEN
      N=4
      NA=11
      X(1)=0.25$P 0
      X(2)=0.39$P 0
      X(3)=0.41$P 0
      X(4)=0.39$P 0
      Y(1)=4.00$P 0
      Y(2)=2.00$P 0
      Y(3)=1.00$P 0
      Y(4)=0.50$P 0
      Y(5)=0.250$P 0
      Y(6)=0.167$P 0
      Y(7)=0.125$P 0
      Y(8)=0.100$P 0
      Y(9)=0.833$P-1
      Y(10)=0.714$P-1
      Y(11)=0.625$P-1
      Y(21)=0.1957$P 0
      Y(22)=0.1947$P 0
      Y(23)=0.1735$P 0
      Y(24)=0.1600$P 0
      Y(25)=0.0844$P 0
      Y(26)=0.0627$P 0
      Y(27)=0.0456$P 0
      Y(28)=0.0342$P 0
      Y(29)=0.0323$P 0
      Y(30)=0.0235$P 0
      Y(31)=0.0246$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  160 IF(N.GE.4.AND.NA.GE.N) THEN
      N=4
      NA=MIN(NA,20)
      X(1)=2.5$P 1
      X(2)=5.0$P 0
      X(3)=-5.0$P 0
      X(4)=-1.0$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  170 IF(N.GE.5.AND.NA.GE.33) THEN
      N=5
      NA=33
      X(1)=0.5$P 0
      X(2)=1.5$P 0
      X(3)=-1.0$P 0
      X(4)=0.1$P-1
      X(5)=0.2$P-1
      Y(1)=0.844$P 0
      Y(2)=0.908$P 0
      Y(3)=0.932$P 0
      Y(4)=0.936$P 0
      Y(5)=0.925$P 0
      Y(6)=0.908$P 0
      Y(7)=0.881$P 0
      Y(8)=0.850$P 0
      Y(9)=0.818$P 0
      Y(10)=0.784$P 0
      Y(11)=0.751$P 0
      Y(12)=0.718$P 0
      Y(13)=0.685$P 0
      Y(14)=0.658$P 0
      Y(15)=0.628$P 0
      Y(16)=0.603$P 0
      Y(17)=0.580$P 0
      Y(18)=0.558$P 0
      Y(19)=0.538$P 0
      Y(20)=0.522$P 0
      Y(21)=0.506$P 0
      Y(22)=0.490$P 0
      Y(23)=0.478$P 0
      Y(24)=0.467$P 0
      Y(25)=0.457$P 0
      Y(26)=0.448$P 0
      Y(27)=0.438$P 0
      Y(28)=0.431$P 0
      Y(29)=0.424$P 0
      Y(30)=0.420$P 0
      Y(31)=0.414$P 0
      Y(32)=0.411$P 0
      Y(33)=0.406$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  180 IF(N.GE.6.AND.NA.GE.13) THEN
      N=6
      NA=MIN(NA,13)
      DO 181 I=1,N
      X(I)=1.0$P 0
  181 CONTINUE
      X(2)=2.0$P 0
      DO 182 I=1,NA
      W=0.1$P 0*$DBLE(I)
      Y(I)=EXP(-W)-5.0$P 0*EXP(-1.0$P 1*W)+3.0$P 0*EXP(-4.0$P 0*W)
  182 CONTINUE
      XMAX=1.0$P 2
      ELSE
      IERR=1
      ENDIF
      RETURN
  190 IF(N.GE.11.AND.NA.GE.65) THEN
      N=11
      NA=65
      X(1)=1.3$P 0
      X(2)=0.65$P 0
      X(3)=0.65$P 0
      X(4)=0.7$P 0
      X(5)=0.6$P 0
      X(6)=3.0$P 0
      X(7)=5.0$P 0
      X(8)=7.0$P 0
      X(9)=2.0$P 0
      X(10)=4.5$P 0
      X(11)=5.5$P 0
      Y(1)=1.366$P 0
      Y(2)=1.191$P 0
      Y(3)=1.112$P 0
      Y(4)=1.013$P 0
      Y(5)=0.991$P 0
      Y(6)=0.885$P 0
      Y(7)=0.831$P 0
      Y(8)=0.847$P 0
      Y(9)=0.786$P 0
      Y(10)=0.725$P 0
      Y(11)=0.746$P 0
      Y(12)=0.679$P 0
      Y(13)=0.608$P 0
      Y(14)=0.665$P 0
      Y(15)=0.616$P 0
      Y(16)=0.606$P 0
      Y(17)=0.602$P 0
      Y(18)=0.626$P 0
      Y(19)=0.651$P 0
      Y(20)=0.724$P 0
      Y(21)=0.649$P 0
      Y(22)=0.649$P 0
      Y(23)=0.694$P 0
      Y(24)=0.644$P 0
      Y(25)=0.624$P 0
      Y(26)=0.661$P 0
      Y(27)=0.612$P 0
      Y(28)=0.558$P 0
      Y(29)=0.533$P 0
      Y(30)=0.495$P 0
      Y(31)=0.500$P 0
      Y(32)=0.423$P 0
      Y(33)=0.395$P 0
      Y(34)=0.375$P 0
      Y(35)=0.372$P 0
      Y(36)=0.391$P 0
      Y(37)=0.396$P 0
      Y(38)=0.405$P 0
      Y(39)=0.428$P 0
      Y(40)=0.429$P 0
      Y(41)=0.523$P 0
      Y(42)=0.562$P 0
      Y(43)=0.607$P 0
      Y(44)=0.653$P 0
      Y(45)=0.672$P 0
      Y(46)=0.708$P 0
      Y(47)=0.633$P 0
      Y(48)=0.668$P 0
      Y(49)=0.645$P 0
      Y(50)=0.632$P 0
      Y(51)=0.591$P 0
      Y(52)=0.559$P 0
      Y(53)=0.597$P 0
      Y(54)=0.625$P 0
      Y(55)=0.739$P 0
      Y(56)=0.710$P 0
      Y(57)=0.729$P 0
      Y(58)=0.720$P 0
      Y(59)=0.729$P 0
      Y(60)=0.581$P 0
      Y(61)=0.428$P 0
      Y(62)=0.292$P 0
      Y(63)=0.162$P 0
      Y(64)=0.098$P 0
      Y(65)=0.054$P 0
      XMAX=1.0$P 2
      ELSE
      IERR=1
      ENDIF
      RETURN
  200 IF(N.GE.2.AND.NA.GE.31) THEN
      N=MIN(N,31)
      NA=31
      DO 201 I=1,N
      X(I)=0.0$P 0
  201 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  210 IF(N.GE.2.AND.NA.GE.N) THEN
      N=N-MOD(N,2)
      NA=N
      DO 211 I=1,N
      IF(MOD(I,2).EQ.1) THEN
      X(I)=-1.2$P 0
      ELSE
      X(I)=1.0$P 0
      ENDIF
  211 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  220 IF(N.GE.4.AND.NA.GE.N) THEN
      N=N-MOD(N,4)
      NA=N
      DO 221 I=1,N
      IF (MOD(I,4).EQ.1) THEN
      X(I)=3.0$P 0
      ELSE IF(MOD(I,4).EQ.2) THEN
      X(I)=-1.0$P 0
      ELSEIF(MOD(I,4).EQ.3) THEN
      X(I)=0.0$P 0
      ELSE
      X(I)=1.0$P 0
      ENDIF
  221 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  230 IF(N.GE.2.AND.NA.GE.N+1) THEN
      NA=N+1
      DO 231 I=1,N
      X(I)=$DBLE(I)
  231 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  240 IF(N.GE.2.AND.NA.GE.2*N) THEN
      NA=2*N
      DO 241 I=1,N
      X(I)=0.5$P 0
  241 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  250 IF(N.GE.2.AND.NA.GE.N+2) THEN
      NA=N+2
      DO 251 I=1,N
      X(I)=1.0$P 0-$DBLE(I)/$DBLE(N)
  251 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  260 IF(N.GE.2.AND.NA.GE.N) THEN
      NA=N
      DO 261 I=1,N
      X(I)=1.0$P 0/$DBLE(N)
  261 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  270 IF(N.GE.2.AND.NA.GE.N) THEN
      NA=N
      DO 271 I=1,N
      X(I)=0.5$P 0
  271 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  280 IF(N.GE.2.AND.NA.GE.N) THEN
      NA=N
      DO 281 I=1,N
      X(I)=$DBLE(I)/$DBLE(N+1)
      X(I)=X(I)*(X(I)-1.0$P 0)
  281 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  290 GOTO 280
  300 IF(N.GE.2.AND.NA.GE.N) THEN
      NA=N
      DO 301 I=1,N
      X(I)=-1.0$P 0
  301 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
      END
