* SUBROUTINE EIUD06             ALL SYSTEMS                 90/12/01
C PORTABILITY : ALL SYSTEMS
C 90/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES FOR NONLINEAR APPROXIMATION.
*  UNCONSTRAINED AND DENSE VERSION.
*
* PARAMETERS :
*  IO  N  NUMBER OF VARIABLES.
*  IO  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  IO  NAL NUMBER OF LINEAR APPROXIMATED FUNCTIONS.
*  RO  X(N)  VECTOR OF VARIABLES.
*  RO  FMIN  LOWER BOUND FOR VALUE OF THE OBJECTIVE FUNCTION.
*  RO  XMAX  MAXIMUM STEPSIZE.
*  IO  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIUD06(N,NA,NAL,X,FMIN,XMAX,NEXT,IEXT,IERR)
      INTEGER I,N,NA,NAL,NEXT,IEXT,IERR
      $FLOAT X(N),FMIN,XMAX
      $FLOAT Y(123),T
      COMMON /EMPR06/ Y
      NAL=0
      FMIN=-1.0$P 60
      XMAX=1.0$P 3
      IEXT=-1
      IERR=0
      GOTO(10,190,180,80,20,170,120,90,230,210,140,150,200,30,130,100,
     & 40,110,50,60,70,220,160,240,250),NEXT
   10 IF(N.GE.2.AND.NA.GE.3) THEN
      N=2
      NA=3
      X(1)=2.0$P 0
      X(2)=2.0$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  190 IF(N.GE.2.AND.NA.GE.3) THEN
      N=2
      NA=3
      X(1)=3.0$P 0
      X(2)=1.0$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  180 IF(N.GE.2.AND.NA.GE.2) THEN
      N=2
      NA=2
      X(1)= 1.41831$P 0
      X(2)=-4.79462$P 0
      XMAX= 1.0$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   80 IF(N.GE.3.AND.NA.GE.6) THEN
      N=3
      NA=6
      X(1)=1.0$P 0
      X(2)=1.0$P 0
      X(3)=1.0$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   20 IF(N.GE.4.AND.NA.GE.4) THEN
      N=4
      NA=4
      DO 21 I=1,N
      X(I)=0.0$P 0
   21 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  170 IF(N.GE.4.AND.NA.GE.4) THEN
      N=4
      NA=4
      DO 171 I=1,N
      X(I)=0.0$P 0
  171 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  120 IF(N.GE.3.AND.NA.GE.21) THEN
      N=3
      NA=21
      DO 121 I=1,N
      X(I)=1.0$P 0
  121 CONTINUE
      DO 122 I=1,NA
      T=1.0$P 1*$DBLE(I-1)/$DBLE(NA-1)
      Y(I)=T
      Y(NA+I)=(3.0$P 0/2.0$P 1)*EXP(-T)+
     & (1.0$P 0/5.2$P 1)*EXP(-5.0$P 0*T)-
     & (1.0$P 0/6.5$P 1)*EXP(-2.0$P 0*T)*(3.0$P 0*SIN(2.0$P 0*T)+
     & 1.1$P 1*COS(2.0$P 0*T))
  122 CONTINUE
      IEXT=0
      ELSE
      IERR=1
      ENDIF
      RETURN
   90 IF(N.GE.3.AND.NA.GE.15) THEN
      N=3
      NA=15
      X(1)=1.0$P 0
      X(2)=1.0$P 0
      X(3)=1.0$P 0
      Y(1)=0.14$P 0
      Y(2)=0.18$P 0
      Y(3)=0.22$P 0
      Y(4)=0.25$P 0
      Y(5)=0.29$P 0
      Y(6)=0.32$P 0
      Y(7)=0.35$P 0
      Y(8)=0.39$P 0
      Y(9)=0.37$P 0
      Y(10)=0.58$P 0
      Y(11)=0.73$P 0
      Y(12)=0.96$P 0
      Y(13)=1.34$P 0
      Y(14)=2.10$P 0
      Y(15)=4.39$P 0
      IEXT=0
      ELSE
      IERR=1
      ENDIF
      RETURN
  230 IF(N.GE.4.AND.NA.GE.11) THEN
      N=4
      NA=11
      X(1)= 0.25$P 0
      X(2)= 0.39$P 0
      X(3)= 4.15$P-1
      X(4)= 0.39$P 0
      Y(1)= 0.1957$P 0
      Y(2)= 0.1947$P 0
      Y(3)= 0.1735$P 0
      Y(4)= 0.1600$P 0
      Y(5)= 0.0844$P 0
      Y(6)= 0.0627$P 0
      Y(7)= 0.0456$P 0
      Y(8)= 0.0342$P 0
      Y(9)= 0.0323$P 0
      Y(10)=0.0235$P 0
      Y(11)=0.0246$P 0
      Y(12)=4.0000$P 0
      Y(13)=2.0000$P 0
      Y(14)=1.0000$P 0
      Y(15)=0.5000$P 0
      Y(16)=0.2500$P 0
      Y(17)=0.1670$P 0
      Y(18)=0.1250$P 0
      Y(19)=0.1000$P 0
      Y(20)=0.0833$P 0
      Y(21)=0.0714$P 0
      Y(22)=0.0625$P 0
      IEXT=0
      ELSE
      IERR=1
      ENDIF
      RETURN
  210 IF(N.GE.4.AND.NA.GE.20) THEN
      N=4
      NA=20
      X(1)= 2.5$P 1
      X(2)= 5.0$P 0
      X(3)=-5.0$P 0
      X(4)=-1.0$P 0
      IEXT=0
      ELSE
      IERR=1
      ENDIF
      RETURN
  140 IF(N.GE.4.AND.NA.GE.21) THEN
      N=4
      NA=21
      DO 141 I=1,N
      X(I)=1.0$P 0
  141 CONTINUE
      DO 142 I=1,NA
      Y(I)=0.25$P 0+0.75$P 0*$DBLE(I-1)/$DBLE(NA-1)
      Y(NA+I)=SQRT(Y(I))
  142 CONTINUE
      IEXT=0
      ELSE
      IERR=1
      ENDIF
      RETURN
  150 IF(N.GE.4.AND.NA.GE.21) THEN
      N=4
      NA=21
      X(1)= 1.0$P 0
      X(2)= 1.0$P 0
      X(3)=-3.0$P 0
      X(4)=-1.0$P 0
      DO 151 I=1,NA
      Y(I)=-0.5$P 0+$DBLE(I-1)/$DBLE(NA-1)
      Y(NA+I)=1.0$P 0/(1.0$P 0+Y(I))
  151 CONTINUE
      XMAX=1.0$P-1
      IEXT=0
      ELSE
      IERR=1
      ENDIF
      RETURN
  200 IF(N.GE.4.AND.NA.GE.61) THEN
      N=4
      NA=61
      IEXT=0
      DO 201 I=1,N
      X(I)=1.0$P 0
  201 CONTINUE
      X(3)=1.0$P 1
      Y(1)=1.0$P 0
      Y(2)=1.01$P 0
      Y(3)=1.02$P 0
      Y(4)=1.03$P 0
      Y(5)=1.05$P 0
      Y(6)=1.075$P 0
      Y(7)=1.1$P 0
      Y(8)=1.125$P 0
      Y(9)=1.15$P 0
      Y(10)=1.2$P 0
      Y(11)=1.25$P 0
      Y(12)=1.3$P 0
      Y(13)=1.35$P 0
      Y(14)=1.4$P 0
      Y(15)=1.5$P 0
      Y(16)=1.6$P 0
      Y(17)=1.7$P 0
      Y(18)=1.8$P 0
      Y(19)=1.9$P 0
      Y(20)=2.0$P 0
      Y(21)=2.1$P 0
      Y(22)=2.2$P 0
      Y(23)=2.3$P 0
      Y(24)=2.5$P 0
      Y(25)=2.75$P 0
      Y(26)=3.0$P 0
      Y(27)=3.25$P 0
      Y(28)=3.5$P 0
      Y(29)=4.0$P 0
      Y(30)=4.5$P 0
      Y(31)=5.0$P 0
      Y(32)=5.5$P 0
      Y(33)=6.0$P 0
      Y(34)=6.5$P 0
      Y(35)=7.0$P 0
      Y(36)=7.5$P 0
      Y(37)=8.0$P 0
      Y(38)=8.5$P 0
      Y(39)=9.0$P 0
      Y(40)=10.0$P 0
      Y(41)=11.0$P 0
      Y(42)=12.0$P 0
      Y(43)=13.0$P 0
      Y(44)=15.0$P 0
      Y(45)=17.5$P 0
      Y(46)=20.0$P 0
      Y(47)=22.5$P 0
      Y(48)=25.0$P 0
      Y(49)=30.0$P 0
      Y(50)=35.0$P 0
      Y(51)=40.0$P 0
      Y(52)=50.0$P 0
      Y(53)=60.0$P 0
      Y(54)=70.0$P 0
      Y(55)=80.0$P 0
      Y(56)=100.0$P 0
      Y(57)=150.0$P 0
      Y(58)=200.0$P 0
      Y(59)=300.0$P 0
      Y(60)=500.0$P 0
      Y(61)=1.0$P 5
      Y(61+1)= 0.97386702052733792831$P 0
      Y(61+2)= 0.97390711665677071911$P 0
      Y(61+3)= 0.97394794566286525039$P 0
      Y(61+4)= 0.97398947529386626621$P 0
      Y(61+5)= 0.97407451325974368215$P 0
      Y(61+6)= 0.97418422166965892644$P 0
      Y(61+7)= 0.97429732692565188272$P 0
      Y(61+8)= 0.97441344289222034304$P 0
      Y(61+9)= 0.97453221704823108216$P 0
      Y(61+10)=0.97477647977277153145$P 0
      Y(61+11)=0.97502785781178233026$P 0
      Y(61+12)=0.97528446418205610067$P 0
      Y(61+13)=0.97554472005909873148$P 0
      Y(61+14)=0.97580730389916439626$P 0
      Y(61+15)=0.97633521198091785788$P 0
      Y(61+16)=0.97686134356195586299$P 0
      Y(61+17)=0.97738094095418268249$P 0
      Y(61+18)=0.97789073928751194169$P 0
      Y(61+19)=0.97838854811088140808$P 0
      Y(61+20)=0.97887295363155439576$P 0
      Y(61+21)=0.97934310478576951385$P 0
      Y(61+22)=0.97979855827226762515$P 0
      Y(61+23)=0.98023916551033862691$P 0
      Y(61+24)=0.98107624468416045728$P 0
      Y(61+25)=0.98204290774765289406$P 0
      Y(61+26)=0.98292719363632655668$P 0
      Y(61+27)=0.98373656564197279264$P 0
      Y(61+28)=0.98447846610682328991$P 0
      Y(61+29)=0.98578713114264981186$P 0
      Y(61+30)=0.98690124654380846379$P 0
      Y(61+31)=0.98785879054855173380$P 0
      Y(61+32)=0.98868928566806726978$P 0
      Y(61+33)=0.98941568049711884384$P 0
      Y(61+34)=0.99005592865089067038$P 0
      Y(61+35)=0.99062420259214811899$P 0
      Y(61+36)=0.99113180018738487730$P 0
      Y(61+37)=0.99158781685339306121$P 0
      Y(61+38)=0.99199964493176098231$P 0
      Y(61+39)=0.99237334707422899195$P 0
      Y(61+40)=0.99302559755582945576$P 0
      Y(61+41)=0.99357562712206729735$P 0
      Y(61+42)=0.99404560031581354300$P 0
      Y(61+43)=0.99445173790980305195$P 0
      Y(61+44)=0.99511816085114882367$P 0
      Y(61+45)=0.99575584307408838284$P 0
      Y(61+46)=0.99624640327264396775$P 0
      Y(61+47)=0.99663543022201287399$P 0
      Y(61+48)=0.99695146031888813172$P 0
      Y(61+49)=0.99743367936799001685$P 0
      Y(61+50)=0.99778424120023198554$P 0
      Y(61+51)=0.99805056960591223604$P 0
      Y(61+52)=0.99842841443786596919$P 0
      Y(61+53)=0.99868358857261655169$P 0
      Y(61+54)=0.99886748198687248566$P 0
      Y(61+55)=0.99900629944600342584$P 0
      Y(61+56)=0.99920194660435455419$P 0
      Y(61+57)=0.99946519560889341627$P 0
      Y(61+58)=0.99959785208794891934$P 0
      Y(61+59)=0.99973120214935885075$P 0
      Y(61+60)=0.99983838442420395745$P 0
      Y(61+61)=0.999999189398046846077$P 0
      ELSE
        IERR=1
      ENDIF
      RETURN
   30 IF(N.GE.5.AND.NA.GE.21) THEN
      N=5
      NA=21
      DO 31 I=1,N
      X(I)=0.0$P 0
   31 CONTINUE
      X(1)=0.5$P 0
      IEXT=0
      ELSE
      IERR=1
      ENDIF
      RETURN
  130 IF(N.GE.5.AND.NA.GE.30) THEN
      N=5
      NA=30
      X(1)= 0.0$P 0
      X(2)=-1.0$P 0
      X(3)= 1.0$P 1
      X(4)= 1.0$P 0
      X(5)= 1.0$P 1
      DO 132 I=1,NA
      Y(I)=-1.0$P 0+2.0$P 0*$DBLE(I-1)/$DBLE(NA-1)
      T=8.0$P 0*Y(I)
      Y(NA+I)=SQRT((T-1.0$P 0)**2+1.0$P 0)*ATAN(T)/T
  132 CONTINUE
      IEXT=0
      ELSE
      IERR=1
      ENDIF
      RETURN
  100 IF(N.GE.6.AND.NA.GE.51) THEN
      N=6
      NA=51
      X(1)= 2.0$P 0
      X(2)= 2.0$P 0
      X(3)= 7.0$P 0
      X(4)= 0.0$P 0
      X(5)=-2.0$P 0
      X(6)= 1.0$P 0
      DO 101 I=1,NA
      T=0.1$P 0*$DBLE(I-1)
      Y(I)=0.5$P 0*EXP(-T)-EXP(-2.0$P 0*T)+0.5$P 0*EXP(-3.0$P 0*T)+
     & 1.5$P 0*EXP(-1.5$P 0*T)*SIN(7.0$P 0*T)+
     & EXP(-2.5$P 0*T)*SIN(5.0$P 0*T)
  101 CONTINUE
      IEXT=0
      ELSE
      IERR=1
      ENDIF
      RETURN
   40 IF(N.GE.6.AND.NA.GE.11) THEN
      N=6
      NA=11
      X(1)=0.8$P 0
      X(2)=1.5$P 0
      X(3)=1.2$P 0
      X(4)=3.0$P 0
      X(5)=0.8$P 0
      X(6)=6.0$P 0
      Y(1)=0.5$P 0
      Y(2)=0.6$P 0
      Y(3)=0.7$P 0
      Y(4)=0.77$P 0
      Y(5)=0.9$P 0
      Y(6)=1.0$P 0
      Y(7)=1.1$P 0
      Y(8)=1.23$P 0
      Y(9)=1.3$P 0
      Y(10)=1.4$P 0
      Y(11)=1.5$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  110 IF(N.GE.9.AND.NA.GE.41) THEN
      N=9
      NA=41
      X(1)=0$P 0
      X(2)=1$P 0
      X(3)=0$P 0
      X(4)=-1.5$P-1
      X(5)=0$P 0
      X(6)=-6.8$P-1
      X(7)=0$P 0
      X(8)=-7.2$P-1
      X(9)=3.7$P-1
      DO 111 I=1,6
  111 Y(I)=1.0$P-2*(I-1)
      DO 112 I=7,20
  112 Y(I)=3.0$P-2*(I-7)+7.0$P-2
      Y(21)=5.0$P-1
      DO 113 I=22,35
  113 Y(I)=3.0$P-2*(I-22)+54.0$P-2
      DO 114 I=36,41
  114 Y(I)=1.0$P-2*(I-36)+95.0$P-2
      DO 115 I=1,41
      Y(41+I)=COS(Y(I)*3.14159265358979324$P 0)
  115 Y(82+I)=SIN(Y(I)*3.14159265358979324$P 0)
      IEXT=0
      ELSE
        IERR=1
      ENDIF
      RETURN
   50 IF(N.GE.7.AND.NA.GE.5) THEN
      N=7
      NA=5
      X(1)=1.0$P 0
      X(2)=2.0$P 0
      X(3)=0.0$P 0
      X(4)=4.0$P 0
      X(5)=0.0$P 0
      X(6)=1.0$P 0
      X(7)=1.0$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   60 IF(N.GE.10.AND.NA.GE.9) THEN
      N=10
      NA=9
      X(1)=2.0$P 0
      X(2)=3.0$P 0
      X(3)=5.0$P 0
      X(4)=5.0$P 0
      X(5)=1.0$P 0
      X(6)=2.0$P 0
      X(7)=7.0$P 0
      X(8)=3.0$P 0
      X(9)=6.0$P 0
      X(10)=1.0$P 1
      ELSE
      IERR=1
      ENDIF
      RETURN
   70 IF(N.GE.20.AND.NA.GE.18) THEN
      N=20
      NA=18
      X(1)=2.0$P 0
      X(2)=3.0$P 0
      X(3)=5.0$P 0
      X(4)=5.0$P 0
      X(5)=1.0$P 0
      X(6)=2.0$P 0
      X(7)=7.0$P 0
      X(8)=3.0$P 0
      X(9)=6.0$P 0
      X(10)=1.0$P 1
      X(11)=2.0$P 0
      X(12)=2.0$P 0
      X(13)=6.0$P 0
      X(14)=1.5$P 1
      X(15)=1.0$P 0
      X(16)=2.0$P 0
      X(17)=1.0$P 0
      X(18)=2.0$P 0
      X(19)=1.0$P 0
      X(20)=3.0$P 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  220 IF(N.GE.10.AND.NA.GE.2) THEN
      N=10
      NA=2
      DO 221 I=1,N
      X(I)=0.1$P 0
  221 CONTINUE
      X(1)=1.0$P 2
      XMAX=1.0$P 1
      ELSE
      IERR=1
      ENDIF
      RETURN
  160 IF(N.GE.11.AND.NA.GE.10) THEN
      N=11
      NA=10
      DO 161 I=1,N
      X(I)=1.0$P 0
  161 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  240 IF(N.GE.20.AND.NA.GE.31) THEN
      N=20
      NA=31
      DO 241 I=1,N
      X(I)=0.0$P 0
  241 CONTINUE
      IEXT=0
      ELSE
      IERR=1
      ENDIF
      RETURN
  250 IF(N.GE.11.AND.NA.GE.65) THEN
      N=11
      NA=65
      X(1)= 1.3$P 0
      X(2)= 6.5$P-1
      X(3)= 6.5$P-1
      X(4)= 0.7$P 0
      X(5)= 0.6$P 0
      X(6)= 3.0$P 0
      X(7)= 5.0$P 0
      X(8)= 7.0$P 0
      X(9)= 2.0$P 0
      X(10)=4.5$P 0
      X(11)=5.5$P 0
      Y(1)= 1.366$P 0
      Y(2)= 1.191$P 0
      Y(3)= 1.112$P 0
      Y(4)= 1.013$P 0
      Y(5)= 0.991$P 0
      Y(6)= 0.885$P 0
      Y(7)= 0.831$P 0
      Y(8)= 0.847$P 0
      Y(9)= 0.786$P 0
      Y(10)=0.725$P 0
      Y(11)=0.746$P 0
      Y(12)=0.679$P 0
      Y(13)=0.608$P 0
      Y(14)=0.655$P 0
      Y(15)=0.616$P 0
      Y(16)=0.606$P 0
      Y(17)=0.602$P 0
      Y(18)=0.626$P 0
      Y(19)=0.651$P 0
      Y(20)=0.724$P 0
      Y(21)=0.649$P 0
      Y(22)=0.649$P 0
      Y(23)=0.694$P 0
      Y(24)=0.644$P 0
      Y(25)=0.624$P 0
      Y(26)=0.661$P 0
      Y(27)=0.612$P 0
      Y(28)=0.558$P 0
      Y(29)=0.553$P 0
      Y(30)=0.495$P 0
      Y(31)=0.500$P 0
      Y(32)=0.423$P 0
      Y(33)=0.395$P 0
      Y(34)=0.375$P 0
      Y(35)=0.372$P 0
      Y(36)=0.391$P 0
      Y(37)=0.396$P 0
      Y(38)=0.405$P 0
      Y(39)=0.428$P 0
      Y(40)=0.429$P 0
      Y(41)=0.523$P 0
      Y(42)=0.562$P 0
      Y(43)=0.607$P 0
      Y(44)=0.653$P 0
      Y(45)=0.672$P 0
      Y(46)=0.708$P 0
      Y(47)=0.633$P 0
      Y(48)=0.668$P 0
      Y(49)=0.645$P 0
      Y(50)=0.632$P 0
      Y(51)=0.591$P 0
      Y(52)=0.559$P 0
      Y(53)=0.597$P 0
      Y(54)=0.625$P 0
      Y(55)=0.739$P 0
      Y(56)=0.710$P 0
      Y(57)=0.729$P 0
      Y(58)=0.720$P 0
      Y(59)=0.636$P 0
      Y(60)=0.581$P 0
      Y(61)=0.428$P 0
      Y(62)=0.292$P 0
      Y(63)=0.162$P 0
      Y(64)=0.098$P 0
      Y(65)=0.054$P 0
      XMAX=1.0$P 1
      IEXT=0
      ELSE
      IERR=1
      ENDIF
      RETURN
      END
