* SUBROUTINE EIUD25                ALL SYSTEMS                07/12/01
C PORTABILITY : ALL SYSTEMS
C 07/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF VARIABLES FOR DENSE UNCONSTRAINED MINIMIZATION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RO  X(N)  VECTOR OF VARIABLES.
*  RO  FMIN  LOWER BOUND FOR THE OBJECTIVE FUNCTION.
*  RO  XMAX  MAXIMUM STEPSIZE.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIUD25(N,X,FMIN,XMAX,NEXT,IEXT,IERR)
      INTEGER N,NA,NEXT,IEXT,IERR
      $FLOAT X(N),FMIN,XMAX
      $FLOAT P,Q,S,T
      INTEGER I,J,K,MM,N1
      $FLOAT Y(20),PAR
      COMMON /EMPR15/ Y
      COMMON /EMPR18/ PAR,MM
      COMMON /EMPR25/ NA
      $FLOAT ETA9
      PARAMETER (ETA9=1.0$P 120)
      FMIN=0.0$P 0
      XMAX=1.0$P 3
      IEXT=0
      IERR=0
      NA=N
      GO TO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     &  170,180,190,200,210,220,
     &  410,420,430,260,450,460,470,480,490,500,510,520,530,540,550,560,
     &  570,580,590,600,610,620,
     &  720,730,740,750,760,780,790,810,830,840,860,870,880,900,910,920,
     &  930,940,950,960,970,980,990,660,670,680,
     &  270,280,290,300,320,330,340,350,360,370,380,390),NEXT
   10 IF (N.LT.2) GO TO 999
      N=N-MOD(N,2)
      DO 11 I=1,N
      IF (MOD(I,2).EQ.1) THEN
      X(I)=-1.2$P 0
      ELSE
      X(I)=1.0$P 0
      ENDIF
   11 CONTINUE
      RETURN
   20 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 21 I=1,N
      IF (MOD(I,2).EQ.1) THEN
      X(I)=-2.0$P 0
      IF (I.LE.4) X(I)=-3.0$P 0
      ELSE
      X(I)=0.0$P 0
      IF (I.LE.4) X(I)=-1.0$P 0
      ENDIF
   21 CONTINUE
      RETURN
   30 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 31 I=1,N
      IF (MOD(I,4).EQ.1) THEN
      X(I)=3.0$P 0
      ELSE IF (MOD(I,4).EQ.2) THEN
      X(I)=-1.0$P 0
      ELSE IF (MOD(I,4).EQ.3) THEN
      X(I)=0.0$P 0
      ELSE
      X(I)=1.0$P 0
      ENDIF
   31 CONTINUE
      RETURN
   40 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 41 I=1,N
      X(I)=2.0$P 0
   41 CONTINUE
      X(1)=1.0$P 0
      RETURN
   50 IF (N.LT.3) GO TO 999
      DO 51 I=1,N
      X(I)=-1.0$P 0
   51 CONTINUE
      RETURN
   60 IF (N.LT.7) GO TO 999
      DO 61 I=1,N
      X(I)=-1.0$P 0
   61 CONTINUE
      RETURN
   70 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 71 I=1,N
      X(I)=-1.0$P 0
   71 CONTINUE
      RETURN
   80 IF (N.LT.6) GO TO 999
      DO 81 I=1,N
      X(I)=1.0$P 0/$DBLE(N)
   81 CONTINUE
      RETURN
   90 IF (N.LT.6) GO TO 999
      DO 91 I=1,N
      X(I)=1.0$P 0/$DBLE(N)
   91 CONTINUE
      FMIN=-ETA9
      RETURN
  100 IF (N.LT.6) GO TO 999
      DO 101 I=1,N
      X(I)=1.0$P 0
  101 CONTINUE
      FMIN=-ETA9
      RETURN
  110 IF (N.LT.5) GO TO 999
      N=N-MOD(N,5)
      DO 111 I=0,N-5,5
      X(I+1)=-1.0$P 0
      X(I+2)=-1.0$P 0
      X(I+3)=2.0$P 0
      X(I+4)=-1.0$P 0
      X(I+5)=-1.0$P 0
  111 CONTINUE
      X(1)=-2.0$P 0
      X(2)=2.0$P 0
      XMAX=1.0$P 0
      RETURN
  120 IF (N.LT.2) GO TO 999
      N=N-MOD(N,2)
      DO 121 I=2,N,2
      X(I-1)=0.0$P 0
      X(I)=-1.0$P 0
  121 CONTINUE
      XMAX=1.0$P 1
      RETURN
  130 IF (N.LT.2) GO TO 999
      N=N-MOD(N,2)
      DO 131 I=2,N,2
      X(I-1)=-1.0$P 0
      X(I)=1.0$P 0
  131 CONTINUE
      XMAX=1.0$P 1
      RETURN
  140 IF (N.LT.3) GO TO 999
      P=1.0$P 0/$DBLE(N+1)
      DO 141 I=1,N
      Q=P*$DBLE(I)
      X(I)=Q*(1.0$P 0-Q)
  141 CONTINUE
      RETURN
  150 IF (N.LT.3) GO TO 999
      P=1.0$P 0/$DBLE(N+1)
      DO 151 I=1,N
      X(I)=$DBLE(I)*$DBLE(N+1-I)*P**2
  151 CONTINUE
      FMIN=-ETA9
      RETURN
  160 IF (N.LT.3) GO TO 999
      DO 161 I=1,N
      X(I)=1.0$P 0
  161 CONTINUE
      FMIN=-ETA9
      RETURN
  170 IF (N.LT.3) GO TO 999
      P=1.0$P 0/$DBLE(N+1)
      DO 171 I=1,N
      X(I)=$DBLE(I)*$DBLE(N+1-I)*P**2
  171 CONTINUE
      FMIN=-ETA9
      RETURN
  180 IF (N.LT.3) GO TO 999
      P=1.0$P 0/$DBLE(N+1)
      DO 181 I=1,N
      X(I)=$DBLE(I)*$DBLE(N+1-I)*P**2
  181 CONTINUE
      FMIN=-ETA9
      RETURN
  190 IF (N.LT.3) GO TO 999
      P=EXP(2.0$P 0)/$DBLE(N+1)
      DO 191 I=1,N
      X(I)=(P*$DBLE(I)+1.0$P 0)/3.0$P 0
  191 CONTINUE
      FMIN=-ETA9
      RETURN
  200 IF (N.LT.3) GO TO 999
      P=1.0$P 0/$DBLE(N+1)
      DO 201 I=1,N
      X(I)=P*$DBLE(I)
  201 CONTINUE
      FMIN=-ETA9
      RETURN
  210 IF (N.LT.3) GO TO 999
      P=1.0$P 0/$DBLE(N+1)
      DO 211 I=1,N
      X(I)=P*$DBLE(I)+1.0$P 0
  211 CONTINUE
      FMIN=-ETA9
      RETURN
  220 IF (N.LT.3) GO TO 999
      P=1.0$P 0/$DBLE(N+1)
      DO 221 I=1,N
      X(I)=$DBLE(I)*$DBLE(N+1-I)*P**2
  221 CONTINUE
      FMIN=-ETA9
      RETURN
  410 IF (N.LT.2) GO TO 999
      N=N-MOD(N,2)
      NA=N
      DO 411 I=1,N
      IF (MOD(I,2).EQ.1) THEN
      X(I)=-1.2$P 0
      ELSE
      X(I)=1.0$P 0
      ENDIF
  411 CONTINUE
      RETURN
  420 IF (N.LT.4) GO TO 999
      N=N-MOD(N,4)
      NA=N
      DO 421 I=1,N
      IF (MOD(I,4).EQ.1) THEN
      X(I)=3.0$P 0
      ELSE IF (MOD(I,4).EQ.2) THEN
      X(I)=-1.0$P 0
      ELSE IF (MOD(I,4).EQ.3) THEN
      X(I)=0.0$P 0
      ELSE
      X(I)=1.0$P 0
      ENDIF
  421 CONTINUE
      RETURN
  430 IF (N.LT.2) GO TO 999
      DO 431 I=1,N
      X(I)=-1.0$P 0
  431 CONTINUE
      RETURN
  440 IF (N.LT.4) GO TO 999
      N=N-MOD(N,4)
      DO 441 I=1,N
      IF (MOD(I,4).EQ.1) THEN
      X(I)=3.0$P 0
      ELSE IF (MOD(I,4).EQ.2) THEN
      X(I)=-1.0$P 0
      ELSE IF (MOD(I,4).EQ.3) THEN
      X(I)=0.0$P 0
      ELSE
      X(I)=1.0$P 0
      ENDIF
  441 CONTINUE
      NA=N
      XMAX=1.0$P 0
      RETURN
  450 IF (N.LT.3) GO TO 999
      DO 451 I=1,N
      X(I)=-1.0$P 0
  451 CONTINUE
      RETURN
  460 IF (N.LT.6) GO TO 999
      DO 461 I=1,N
      X(I)=-1.0$P 0
  461 CONTINUE
      RETURN
  470 IF (N.LT.2) GO TO 999
      DO 471 I=1,N-1
      X(I)=0.5$P 0
  471 CONTINUE
      X(N)=-2.0$P 0
      NA=2*(N-1)
      RETURN
  480 IF (N.LT.4) GO TO 999
      N=N-MOD(N,4)
      DO 481 I=1,N
      X(I)=SIN($DBLE(I))**2
  481 CONTINUE
      NA=5*N
      RETURN
  490 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 491 I=1,N
      X(I)=5.0$P 0
  491 CONTINUE
      NA=3*(N-2)
      RETURN
  500 IF (N.LT.2) GO TO 999
      DO 501 I=1,N
      X(I)=0.2$P 0
  501 CONTINUE
      NA=2*(N-1)
      RETURN
  510 CONTINUE
      IF (N.LT.2) GO TO 999
      N=N-MOD(N,2)
      DO 511 I=1,N
      IF (MOD(I,2).EQ.1) THEN
      X(I)=-0.8$P 0
      ELSE
      X(I)=-0.8$P 0
      ENDIF
  511 CONTINUE
      NA=2*(N-1)
      RETURN
  520 CONTINUE
      IF (N.LT.5) GO TO 999
      IF (MOD(N-5,3).NE.0) N=N-MOD(N-5,3)
      DO 521 I=1,N
      X(I)=-1.0$P 0
  521 CONTINUE
      NA=6*((N-5)/3+1)
      RETURN
  530 CONTINUE
      IF (N.LT.5) GO TO 999
      IF (MOD(N-5,3).NE.0) N=N-MOD(N-5,3)
      DO 531 I=1,N
      X(I)=-1.0$P 0
  531 CONTINUE
      NA=7*((N-5)/3+1)
      RETURN
  540 CONTINUE
      IF (N.LT.4) GO TO 999
      DO 541 I=1,N
      IF (MOD(I,4).EQ.1) THEN
      X(I)=-0.8$P 0
      ELSE IF (MOD(I,4).EQ.2) THEN
      X(I)= 1.2$P 0
      ELSE IF (MOD(I,4).EQ.3) THEN
      X(I)=-1.2$P 0
      ELSE
      X(I)= 0.8$P 0
      ENDIF
  541 CONTINUE
      Y(1)=14.4$P 0
      Y(2)=6.8$P 0
      Y(3)=4.2$P 0
      Y(4)=3.2$P 0
  542 IF (MOD(N-4,2).NE.0) N=N-MOD(N-4,2)
      NA=4*((N-4)/2+1)
      RETURN
  550 CONTINUE
      IF (N.LT.4) GO TO 999
      DO 551 I=1,N
      IF (MOD(I,4).EQ.1) THEN
      X(I)=-0.8$P 0
      ELSE IF (MOD(I,4).EQ.2) THEN
      X(I)= 1.2$P 0
      ELSE IF (MOD(I,4).EQ.3) THEN
      X(I)=-1.2$P 0
      ELSE
      X(I)= 0.8$P 0
      ENDIF
  551 CONTINUE
      Y(1)=35.8$P 0
      Y(2)=11.2$P 0
      Y(3)=6.2$P 0
      Y(4)=4.4$P 0
      GO TO 542
  560 CONTINUE
      IF (N.LT.4) GO TO 999
      DO 561 I=1,N
      IF (MOD(I,4).EQ.1) THEN
      X(I)=-0.8$P 0
      ELSE IF (MOD(I,4).EQ.2) THEN
      X(I)= 1.2$P 0
      ELSE IF (MOD(I,4).EQ.3) THEN
      X(I)=-1.2$P 0
      ELSE
      X(I)= 0.8$P 0
      ENDIF
  561 CONTINUE
      Y(1)=30.6$P 0
      Y(2)=72.2$P 0
      Y(3)=124.4$P 0
      Y(4)=187.4$P 0
      GO TO 542
  570 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      NA=N
      DO 571 I=1,N
      IF (MOD(I,8).EQ.1) X(I)=1.0$P-1
      IF (MOD(I,8).EQ.2.OR.MOD(I,8).EQ.0) X(I)=2.0$P-1
      IF (MOD(I,8).EQ.3.OR.MOD(I,8).EQ.7) X(I)=3.0$P-1
      IF (MOD(I,8).EQ.4.OR.MOD(I,8).EQ.6) X(I)=4.0$P-1
      IF (MOD(I,8).EQ.5) X(I)=5.0$P-1
  571 CONTINUE
      NA=N
      RETURN
  580 IF (N.LT.3) GO TO 999
      DO 581 I=1,N
      X(I)=1.2$P 1
  581 CONTINUE
      RETURN
  590 IF (N.LT.7) GO TO 999
      DO 591 I=1,N
      X(I)=-1.0$P 0
  591 CONTINUE
      RETURN
  600 IF (N.LT.3) GO TO 999
      DO 601 I=1,N
      X(I)=$DBLE(I)/$DBLE(N+1)
      X(I)=X(I)*(X(I)-1.0$P 0)
  601 CONTINUE
      RETURN
  610 CONTINUE
      IF (N.LT.5) GO TO 999
      IF (MOD(N-5,3).NE.0) N=N-MOD(N-5,3)
      DO 611 I=1,N
      X(I)=-1.0$P 0
  611 CONTINUE
      NA=7*((N-5)/3+1)
      RETURN
  620 IF (N.LT.3) GO TO 999
      DO 621 I=1,N
      IF (MOD(I,2).EQ.1) THEN
      X(I)=-1.2$P 0
      ELSE
      X(I)= 1.0$P 0
      ENDIF
  621 CONTINUE
      NA=2*(N-1)
      RETURN
  720 IF (N.LT.5) GO TO 999
      N=N-MOD(N,2)
      DO 721 I=1,N
      IF (MOD(I,8).EQ.1) X(I)=1.0$P-1
      IF (MOD(I,8).EQ.2.OR.MOD(I,8).EQ.0) X(I)=2.0$P-1
      IF (MOD(I,8).EQ.3.OR.MOD(I,8).EQ.7) X(I)=3.0$P-1
      IF (MOD(I,8).EQ.4.OR.MOD(I,8).EQ.6) X(I)=4.0$P-1
      IF (MOD(I,8).EQ.5) X(I)=5.0$P-1
  721 CONTINUE
      NA=N
      RETURN
  730 IF (N.LT.5) GO TO 999
      N=N-MOD(N,5)
      DO 731 I=1,N
      X(I)=1.0$P 0/$DBLE(N)
  731 CONTINUE
      NA=N
      RETURN
  740 IF (N.LT.3) GO TO 999
      DO 741 I=1,N
      X(I)=0.0$P 0
  741 CONTINUE
      RETURN
  750 IF (N.LT.3) GO TO 999
      IF (MOD(N,2).NE.1) N=N-1
      DO 751 I=1,N
      X(I)=1.0$P 0
  751 CONTINUE
      NA=N
      RETURN
  760 IF (N.LT.3) GO TO 999
      DO 761 I=1,N
      X(I)=-1.0$P 0
  761 CONTINUE
      RETURN
  780 IF (N.LT.5) GO TO 999
      DO 781 I=1,N
      X(I)=-2.0$P 0
  781 CONTINUE
      RETURN
  790 IF (N.LT.7) GO TO 999
      DO 791 I=1,N
      X(I)=-3.0$P 0
  791 CONTINUE
      XMAX=1.0$P 1
      RETURN
  810 IF (N.LT.2) GO TO 999
      N=N-MOD(N,2)
      DO 811 I=1,N
      IF (MOD(I,2).EQ.1) THEN
      X(I)=9.0$P 1
      ELSE
      X(I)=6.0$P 1
      ENDIF
  811 CONTINUE
      NA=N
      RETURN
  830 IF (N.LT.4) GO TO 999
      N=N-MOD(N,4)
      DO 831 I=1,N
      IF (MOD(I,4).EQ.1) THEN
      X(I)=1.0$P 0
      ELSE IF (MOD(I,4).EQ.2) THEN
      X(I)=2.0$P 0
      ELSE IF (MOD(I,4).EQ.3) THEN
      X(I)=2.0$P 0
      ELSE
      X(I)=2.0$P 0
      ENDIF
  831 CONTINUE
      NA=N
      XMAX=1.0$P 1
      RETURN
  840 IF (N.LT.3) GO TO 999
      DO 841 I=1,N
      X(I)=-1.0$P 0
  841 CONTINUE
      RETURN
  860 IF (N.LT.2) GO TO 999
      N=N-MOD(N,2)
      DO 861 I=1,N
      IF (MOD(I,2).EQ.1) THEN
      X(I)=0.0$P 0
      ELSE
      X(I)=1.0$P 0
      ENDIF
  861 CONTINUE
      NA=N
      RETURN
  870 IF (N.LT.4) GO TO 999
      N=N-MOD(N,4)
      DO 871 I=2,N,2
      X(I-1)=-3.0$P 0
      X(I)=-1.0$P 0
  871 CONTINUE
      NA=N
      RETURN
  880 IF (N.LT.3) GO TO 999
      DO 881 I=1,N
      X(I)=1.5$P 0
  881 CONTINUE
      XMAX=1.0$P 0
      RETURN
  900 IF (N.LT.3) GO TO 999
      DO 901 I=1,N
      X(I)=1.0$P 1
  901 CONTINUE
      RETURN
  910 IF (N.LT.3) GO TO 999
      DO 911 I=1,N
      X(I)=1.0$P 0
  911 CONTINUE
      PAR=1.0$P 1
      RETURN
  920 IF (N.LT.5) GO TO 999
      PAR=5.0$P 2/$DBLE(N+2)
      DO 921 I=1,N
      X(I)=(($DBLE(I)+0.5$P 0)/$DBLE(N+2)-0.5$P 0)**2
  921 CONTINUE
      RETURN
  930 IF (N.LT.10) GO TO 999
      N=N-MOD(N,2)
      MM=N/2
      PAR=5.0$P 2
      DO 931 I=1,MM
      X(I)=($DBLE(I)/$DBLE(MM+1)-0.5$P 0)**2
  931 CONTINUE
      DO 932 I=MM+1,N
      K=I-MM
      X(I)=$DBLE(K)/$DBLE(MM+1)-0.5$P 0
  932 CONTINUE
      NA=N
      RETURN
  940 IF (N.LT.16) GO TO 999
      MM=INT(SQRT($DBLE(N)))
      PAR=6.8$P 0/$DBLE(MM+1)**2
      N=MM*MM
      K=0
      DO 942 J=1,MM
      DO 941 I=1,MM
      K=K+1
      X(K)=1.0$P 0
  941 CONTINUE
  942 CONTINUE
      NA=N
      RETURN
  950 IF (N.LT.16) GO TO 999
      MM=INT(SQRT($DBLE(N)))
      PAR=1.0$P 0/$DBLE(MM+1)**2
      N=MM*MM
      K=0
      DO 952 J=1,MM
      DO 951 I=1,MM
      K=K+1
      X(K)=-1.0$P 0
  951 CONTINUE
  952 CONTINUE
      NA=N
      RETURN
  960 IF (N.LT.16) GO TO 999
      MM=INT(SQRT($DBLE(N)))
      PAR=1.0$P 0/$DBLE(MM+1)**2
      N=MM*MM
      K=0
      DO 962 J=1,MM
      DO 961 I=1,MM
      K=K+1
      X(K)=0.0$P 0
  961 CONTINUE
  962 CONTINUE
      NA=N
      RETURN
  970 IF (N.LT.16) GO TO 999
      MM=INT(SQRT($DBLE(N)))
      PAR=5.0$P 1/$DBLE(MM+1)
      N=MM*MM
      K=0
      DO 972 J=1,MM
      DO 971 I=1,MM
      K=K+1
      X(K)=1.0$P 0-$DBLE(I)*$DBLE(J)/$DBLE(MM+1)**2
  971 CONTINUE
  972 CONTINUE
      NA=N
      RETURN
  980 IF (N.LT.16) GO TO 999
      MM=INT(SQRT($DBLE(N)))
      PAR=1.0$P 0/$DBLE(MM+1)
      N=MM*MM
      K=0
      DO 982 J=1,MM
      DO 981 I=1,MM
      K=K+1
      X(K)=0.0$P 0
  981 CONTINUE
  982 CONTINUE
      NA=N
      RETURN
  990 IF (N.LT.16) GO TO 999
      MM=INT(SQRT($DBLE(N)))
      N=MM*MM
      PAR=500.0$P 0/$DBLE(MM+2)**4
      K=0
      DO 992 J=1,MM
      DO 991 I=1,MM
      K=K+1
      X(K)=0.0$P 0
  991 CONTINUE
  992 CONTINUE
      NA=N
      RETURN
  660 IF (N.LT.16) GO TO 999
      MM=INT(SQRT($DBLE(N)))
      N=MM*MM
      PAR=500.0$P 0
      K=0
      DO 662 J=1,MM
      DO 661 I=1,MM
      K=K+1
      X(K)=0.0$P 0
  661 CONTINUE
  662 CONTINUE
      NA=N
      RETURN
  670 IF (N.LT.3) GO TO 999
      DO 671 I=1,N
      X(I)=5.0$P 0*MIN($DBLE(I)/$DBLE(N+1),1.0$P 0-$DBLE(I)/$DBLE(N+1))
  671 CONTINUE
      XMAX=1.0$P 4
      RETURN
  680 IF (N.LT.3) GO TO 999
      DO 681 I=1,N
      X(I)=5.0$P 0*MIN($DBLE(I)/$DBLE(N+1),1.0$P 0-$DBLE(I)/$DBLE(N+1))
  681 CONTINUE
      RETURN
  260 N1=N-1
      DO 261 I=1,N1
      X(I)=-1.2$P 0
  261 CONTINUE
      X(N)=-1.0$P 0
      RETURN
  270 DO 271 I=1,N
      X(I)=2.0$P 0
  271 CONTINUE
      RETURN
  280 DO 281 I=1,N
      X(I)=1.0$P 0
  281 CONTINUE
      RETURN
  290 DO 291 I=1,N
      X(I)=-1.0$P 0
  291 CONTINUE
      RETURN
  300 DO 301 I=1,N
      X(I)=-1.0$P 0
  301 CONTINUE
      RETURN
  310 DO 311 I=1,N
      X(I)=0.5$P 0
  311 CONTINUE
      RETURN
  320 DO 321 I=1,N
      X(I)=0.5$P 0
  321 CONTINUE
      RETURN
  330 DO 331 I=1,N
      X(I)=1.0$P 0
  331 CONTINUE
      RETURN
  340 DO 341 I=1,N
      X(I)=-1.0$P 0
  341 CONTINUE
      RETURN
  350 DO 351 I=1,N
      X(I)=1.0$P 0
  351 CONTINUE
      RETURN
  360 DO 361 I=1,N
      X(I)=1.0$P 0
  361 CONTINUE
      RETURN
  370 IF (N.LT.10) GO TO 999
      N=N-MOD(N,2)
      MM=N/2
      T=$DBLE(2)/$DBLE(N+2)
      DO 371 I=1,MM
      S=$DBLE(I)*T
      X(I)=S*(1.0$P 0-S)
      X(MM+I)=X(I)
  371 CONTINUE
      NA=N
      RETURN
  380 IF (N.LT.16) GO TO 999
      MM=INT(SQRT($DBLE(N)))
      N=MM*MM
      DO 381 I=1,N
      X(I)=1.0$P 0
  381 CONTINUE
      NA=N
      RETURN
  390 IF (N.LT.16) GO TO 999
      MM=INT(SQRT($DBLE(N)))
      N=MM*MM
      DO 391 I=1,N
      X(I)=1.0$P 0
  391 CONTINUE
      NA=N
      RETURN
  999 IERR=1
      RETURN
      END
