* SUBROUTINE EIUS10                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES AND STRUCTURE OF THE SPARSE HESSIAN
*  MATRIX FOR UNCONSTRAINED MINIMIZATION.
*  SPARSE VERSION WITH CHANGED TESTS 7-10, 12.
*  CHANGED FOR THE TESTS.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  M  NUMBER OF ELEMENTS OF THE SPARSE MATRIX.
*  RO  X(N)  VECTOR OF VARIABLES.
*  IO  IH(N+1)  POINTERS OF THE DIAGONAL ELEMENTS OF THE HESSIAN MATRIX.
*  IO  JH(M)  INDICES OF THE NONZERO ELEMENTS OF THE HESSIAN MATRIX IN
*             THE PACKED ROW.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIUS10(N,M,X,IH,JH,FMIN,XMAX,NEXT,IEXT,IERR)
      INTEGER N,M,NEXT,IEXT,IERR
      INTEGER IH(N+1),JH(*)
      $FLOAT X(N),FMIN,XMAX
      $FLOAT P,Q
      INTEGER I,J,K,L,K1,K2,M1
      $FLOAT ETA9
      PARAMETER (ETA9=1.0$P 60)
      FMIN=0.0$P 0
      XMAX=1.0$P 3
      IEXT=0
      IERR=0
      GOTO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150), NEXT
   10 IF(N.GE.2) THEN
        N=N-MOD(N,2)
        DO 11 I=1,N
          IF(MOD(I,2).EQ.1) THEN
            X(I)=-1.2$P 0
          ELSE
            X(I)=1.0$P 0
          ENDIF
   11   CONTINUE
        DO 12 I=1,N-1
          J=2*(I-1)+1
          IH(I)=J
          JH(J)=I
          JH(J+1)=I+1
   12   CONTINUE
        J=2*(N-1)+1
        IH(N)=J
        JH(J)=N
        IH(N+1)=2*N
        M=2*N-1
      ELSE
        IERR=1
      ENDIF
      RETURN
   20 IF(N.GE.4) THEN
        N=N-MOD(N,2)
        DO 21 I=1,N
          IF(MOD(I,2).EQ.1) THEN
            X(I)=-2.0$P 0
            IF(I.LE.4) X(I)=-3.0$P 0
          ELSE
            X(I)=0.0$P 0
            IF(I.LE.4) X(I)=-1.0$P 0
          ENDIF
   21   CONTINUE
        DO 22 I=1,N-1
        J=2*I-1
        IH(I)=J
        JH(J)=I
        JH(J+1)=I+1
        IF(MOD(I,2).EQ.0) JH(J+1)=JH(J+1)+1
   22   CONTINUE
        J=2*N-1
        IH(N)=J
        JH(J)=N
        M=J
        IH(N+1)=J+1
      ELSE
        IERR=1
      ENDIF
      RETURN
   30 IF(N.GE.4) THEN
        N=N-MOD(N,2)
        DO 31 I=1,N
          IF(MOD(I,4).EQ.1) THEN
            X(I)=3.0$P 0
          ELSEIF(MOD(I,4).EQ.2) THEN
            X(I)=-1.0$P 0
          ELSEIF(MOD(I,4).EQ.3) THEN
            X(I)=0.0$P 0
          ELSE
            X(I)=1.0$P 0
          ENDIF
   31   CONTINUE
        IH(1)=1
        IH(2)=4
        JH(1)=1
        JH(2)=2
        JH(3)=4
        JH(4)=2
        JH(5)=3
        K=5
        DO 33 I=3,N-3,2
        IH(I)=IH(I-2)+5
        J=IH(I)
        DO 32 L=J,J+4
        JH(L)=JH(L-5)+2
        K=K+1
   32   CONTINUE
        IH(I+1)=IH(I-1)+5
   33   CONTINUE
        IH(N-1)=IH(N-3)+5
        IH(N)=IH(N-2)+4
        IH(N+1)=IH(N)+1
        JH(K+1)=JH(K)
        JH(K+2)=JH(K)+1
        JH(K+3)=JH(K+2)
        M=IH(N)
      ELSE
        IERR=1
      ENDIF
      RETURN
   40 IF(N.GE.4) THEN
        N=N-MOD(N,2)
        DO 41 I=1,N
          X(I)=2.0$P 0
   41   CONTINUE
        X(1)=1.0$P 0
        DO 42 I=1,N-1
          IH(I)=2*I-1
          J=IH(I)
          JH(J)=I
          JH(J+1)=I+1
   42   CONTINUE
        IH(N)=2*N-1
        JH(J+2)=JH(J+1)
        IH(N+1)=2*N
        M=IH(N)
      ELSE
        IERR=1
      ENDIF
      RETURN
   50 IF (N.GE.3) THEN
        DO 51 I=1,N
          X(I)=-1.0$P 0
   51   CONTINUE
        DO 52 I=1,N-2
          J=1+3*(I-1)
          IH(I)=J
          JH(J)=I
          JH(J+1)=I+1
          JH(J+2)=I+2
   52   CONTINUE
        J=3*(N-2)+1
        IH(N-1)=J
        JH(J)=N-1
        JH(J+1)=N
        J=IH(N-1)+2
        IH(N)=J
        JH(J)=N
        IH(N+1)=IH(N)+1
        M=3*N-3
      ELSE
        IERR=1
      ENDIF
      RETURN
   60 IF (N.GE.7) THEN
        DO 61 I=1,N
          X(I)=-1.0$P 0
   61   CONTINUE
        DO 62 I=1,N-6
          J=7*(I-1)+1
          IH(I)=J
          JH(J)=I
          JH(J+1)=I+1
          JH(J+2)=I+2
          JH(J+3)=I+3
          JH(J+4)=I+4
          JH(J+5)=I+5
          JH(J+6)=I+6
   62   CONTINUE
        J=7*(N-6)+1
        IH(N-5)=J
        JH(J)=N-5
        JH(J+1)=N-4
        JH(J+2)=N-3
        JH(J+3)=N-2
        JH(J+4)=N-1
        JH(J+5)=N
        IH(N-4)=J+6
        JH(J+6)=N-4
        JH(J+7)=N-3
        JH(J+8)=N-2
        JH(J+9)=N-1
        JH(J+10)=N
        IH(N-3)=J+11
        JH(J+11)=N-3
        JH(J+12)=N-2
        JH(J+13)=N-1
        JH(J+14)=N
        IH(N-2)=J+15
        JH(J+15)=N-2
        JH(J+16)=N-1
        JH(J+17)=N
        IH(N-1)=J+18
        JH(J+18)=N-1
        JH(J+19)=N
        IH(N)=J+20
        JH(J+20)=N
        IH(N+1)=J+21
        M=J+20
      ELSE
        IERR=1
      ENDIF
      RETURN
   70 IF(N.GE.4) THEN
        N=N-MOD(N,2)
        DO 71 I=1,N
          X(I)=-1.0$P 0
   71   CONTINUE
        DO 72 I=1,N-2
          J=1+3*(I-1)
          IH(I)=J
          JH(J)=I
          JH(J+1)=I+1
          JH(J+2)=I+2
   72   CONTINUE
        J=3*(N-2)+1
        IH(N-1)=J
        JH(J)=N-1
        JH(J+1)=N
        J=IH(N-1)+2
        IH(N)=J
        JH(J)=N
        IH(N+1)=IH(N)+1
        M=3*N-3
      ELSE
        IERR=1
      ENDIF
      RETURN
   80 IF(N.GE.5) THEN
        DO 81 I=1,N
          X(I)=1.0$P 0/$DBLE(N)
   81   CONTINUE
        DO 82 I=1,N
          IH(I)=I
          JH(I)=I
   82   CONTINUE
        IH(N+1)=N+1
        M=N
      ELSE
        IERR=1
      ENDIF
      RETURN
   90 IF(N.GE.2) THEN
        DO 91 I=1,N
          X(I)=1.0$P 0
   91   CONTINUE
        DO 92 I=1,N
          IH(I)=I
          JH(I)=I
   92   CONTINUE
        IH(N+1)=N+1
        M=N
      ELSE
        IERR=1
      ENDIF
      RETURN
  100 IF(N.GE.2) THEN
        DO 101 I=1,N
          X(I)=1.0$P 0
  101   CONTINUE
        DO 102 I=1,N
          IH(I)=I
          JH(I)=I
  102   CONTINUE
        IH(N+1)=N+1
        M=N
      ELSE
        IERR=1
      ENDIF
      RETURN
  110 IF(N.GE.5) THEN
        N=N-MOD(N,5)
        DO 111 I=0,N-5,5
          X(I+1)=-1.0$P 0
          X(I+2)=-1.0$P 0
          X(I+3)=2.0$P 0
          X(I+4)=-1.0$P 0
          X(I+5)=-1.0$P 0
  111   CONTINUE
        X(1)=-2.0$P 0
        X(2)=2.0$P 0
        IH(1)=1
        K=1
        DO 113 I=1,N,5
          M1=I
          K1=I
          K2=I+4
          DO 114 M=1,5
          DO 115 J=K1,K2
          JH(K)=J
          K=K+1
  115     CONTINUE
          K1=K1+1
          M1=M1+1
          IH(M1)=6-M+IH(M1-1)
  114     CONTINUE
  113     CONTINUE
        M=IH(N)
        XMAX=1.0$P 0
      ELSE
        IERR=1
      ENDIF
      RETURN
  120 IF(N.GE.2) THEN
        N=N-MOD(N,2)
        DO 121 I=2,N,2
          X(I-1)=0.0$P 0
          X(I)=-1.0$P 0
  121   CONTINUE
        J=0
        DO 122 I=1,N-1,2
        IH(I)=J+1
        IH(I+1)=J+3
        JH(J+1)=I
        JH(J+2)=I+1
        JH(J+3)=I+1
        J=J+3
  122   CONTINUE
        M=J
        IH(N+1)=M+1
C        XMAX=1.0$P 0
      ELSE
        IERR=1
      ENDIF
      RETURN
  130 IF(N.GE.2) THEN
        N=N-MOD(N,2)
        DO 131 I=2,N,2
          X(I-1)=-1.0$P 0
          X(I)=1.0$P 0
  131   CONTINUE
        J=0
        DO 132 I=1,N-1,2
        IH(I)=J+1
        IH(I+1)=J+3
        JH(J+1)=I
        JH(J+2)=I+1
        JH(J+3)=I+1
        J=J+3
  132   CONTINUE
        M=J
        IH(N+1)=M+1
        XMAX=0.2$P 0
      ELSE
        IERR=1
      ENDIF
      RETURN
  140 IF(N.GE.3) THEN
        P=1.0$P 0/$DBLE(N+1)
        DO 141 I=1,N
          Q=P*$DBLE(I)
          X(I)=Q*(Q-1.0$P 0)
  141   CONTINUE
        DO 142 I=1,N-2
          J=1+3*(I-1)
          IH(I)=J
          JH(J)=I
          JH(J+1)=I+1
          JH(J+2)=I+2
  142   CONTINUE
        J=3*(N-2)+1
        IH(N-1)=J
        JH(J)=N-1
        JH(J+1)=N
        J=IH(N-1)+2
        IH(N)=J
        JH(J)=N
        IH(N+1)=IH(N)+1
        M=3*N-3
      ELSE
        IERR=1
      ENDIF
      RETURN
  150 IF (N.GE.3) THEN
        P=1.0$P 0/$DBLE(N+1)
        DO 151 I=1,N
          Q=P*$DBLE(I)
          X(I)=0.1$P 0*Q*$DBLE(N+1-I)
  151   CONTINUE
        DO 152 I=1,N-1
          J=2*(I-1)+1
          IH(I)=J
          JH(J)=I
          JH(J+1)=I+1
  152   CONTINUE
        J=2*(N-1)+1
        IH(N)=J
        JH(J)=N
        IH(N+1)=2*N
        M=2*N-1
        FMIN=-ETA9
        XMAX=1.0$P 1
      ELSE
        IERR=1
      ENDIF
      RETURN
      END
