* SUBROUTINE EIUS39                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES AND STRUCTURE OF THE SPARSE HESSIAN
*  MATRIX FOR COMPLEMENTARITY PROBLEMS.
*
* PARAMETERS :
*  IU  N  NUMBER OF VARIABLES.
*  IU  NA NUMBER OF APPROXIMATED FUNCTIONS.
*  IU  M  NUMBER OF ELEMENTS OF THE SPARSE HESSIAN MATRIX.
*  RO  X(N)  VECTOR OF VARIABLES.
*  IO  IH(N+1)  POINTERS OF THE DIAGONAL ELEMENTS OF THE HESSIAN MATRIX.
*  IO  JH(M)  INDICES OF THE NONZERO ELEMENTS OF THE HESSIAN MATRIX IN
*             THE PACKED ROW.
*  RO  XMAX  MAXIMUM STEPSIZE.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EIUS39(N,NA,M,X,IH,JH,FMIN,XMAX,NEXT)
      INTEGER N,NA,M,IH(N+1),JH(*),NEXT,I,J,IERR
      $FLOAT X(N),FMIN,XMAX
      $FLOAT HEIGHTNET(8),DEMANDNET(6),SUPPLYNET(2)
      $FLOAT HEIGHTFL(28),DEMANDFL(19),SUPPLYFL(9)
      $FLOAT DMIN,DMAX,DAVG,HL(28),RR,TEMP
      INTEGER T(33),B(33)
C
      DATA (T(I),I=1,33) / 5,6,3,9,9,4,2,8,6,7,4,8,2,4,3,6,8,6,
     &                     2,5,3,5,4,3,2,7,8,5,3,9,7,5,6 /
      DATA (B(I),I=1,33)
     & / 12,18,35,35,20,11,11,26,33,32,26,30,19,36,25,24,39,43,
     &   22,43,32,52,41,35,21,36,42,31,23,26,37,26,42 /
      DATA (HEIGHTNET(I),I=1,8)
     & / 6.5,3.25,3.02,5.16,4.2,1.5,0.0,6.3 /
      DATA (DEMANDNET(I),I=1,6)
     & / 1.212,0.452,0.245,0.652,0.252,0.456 /
      DATA (SUPPLYNET(I),I=1,2) / 2.5,6.0 /
      DATA (HEIGHTFL(I),I=1,28) / 8.0,3.9,5.5,4.5,4.1,6.5,4.4,8.1,5.2,
     & 7.1,5.1,1.5,2.1,7.2,3.2,6.4,2.4,3.2,3.0,5.6,5.0,3.6,7.2,3.1,7.1,
     & 5.9,4.3,6.2 /
      DATA (DEMANDFL(I),I=1,19) / 0.0386,1.1519,1.0493,0.2785,0.1060,
     & 0.8372,0.8256,0.0473,0.0491,0.5702,0.7608,0.1727,1.1027,0.8944,
     & 1.1529,1.0780,0.2522,1.3631,1.3255 /
      DATA (SUPPLYFL(I),I=1,9)
     & / 9.88,5.82,6.23,5.15,5.33,4.32,4.25,5.79,7.60 /
C
      FMIN=0.0D0
      XMAX=1.0D3
      IERR=0
      GOTO (10,20,30,40), NEXT
   10 N=90
      NA=18
      DO I=1,18
        X(I)=B(I)
        X(18+I)=1.0D0
        X(36+I)=T(I)
        X(54+I)=0.0D0
        X(54+I)=1.0D-3
        X(72+I)=0.0D0
        X(72+I)=1.0D-3
      ENDDO
      DO I=1,90
        IH(I)=I
        JH(I)=I
      ENDDO
      IH(91)=91
      M=90
      RETURN
   20 N=210
      NA=33
      DO I=1,33
        X(I)=B(I)
        X(33+I)=1.0D0
        X(111+I)=0.0D0
        X(111+I)=1.0D-3
        X(144+I)=0.0D0
        X(144+I)=1.0D-3
        X(177+I)=0.0D0
        X(177+I)=1.0D-3
      ENDDO
      DO I=67,111
        X(I)=T(I-66)
      ENDDO
      DO I=1,210
        IH(I)=I
        JH(I)=I
      ENDDO
      IH(211)=211
      M=210
      RETURN
   30 N=52
      NA=32
      DMIN=1.5D-1
      DMAX=2.0D0
      DAVG=SQRT(DMIN*DMAX)
      HL(1)=HEIGHTNET(1)
      HL(2)=HEIGHTNET(2)
      RR=0.0D0
      DO I=1,8
        RR=RR+DEMANDNET(I)
      ENDDO
      RR=RR/(SUPPLYNET(1)+SUPPLYNET(2))
      DO I=3,8
        HL(I)=HEIGHTNET(I)+7.5D0+5*DEMANDNET(I-2)
      ENDDO
      DO I=1,14
        X(I)=0.0D0
        X(I+14)=0.0D0
        X(I+28)=DAVG
      ENDDO
      DO I=1,8
        X(I+42)=HL(I)+5.0D0
      ENDDO
      DO I=1,2
        X(I+50)=RR*SUPPLYNET(I)
      ENDDO
      DO I=1,42
        IH(I)=I
        JH(I)=I
      ENDDO
      IH(43)=43
      JH(43)=43
      JH(44)=51
      IH(44)=45
      JH(45)=44
      JH(46)=52
      IH(45)=46
      DO I=45,52
        JH(I+2)=I
        IH(I+1)=IH(I)+1
      ENDDO
      M=54
      RETURN
   40 N=52
      NA=32
      DMIN=1.5D-1
      DMAX=2.0D0
      DAVG=SQRT(DMIN*DMAX)
      DO I=1,9
        HL(I)=HEIGHTFL(I)
      ENDDO
      RR=0.0D0
      DO I=1,19
        RR=RR+DEMANDFL(I)
      ENDDO
      TEMP=0.0D0
      DO I=1,9
        TEMP=TEMP+SUPPLYFL(I)
      ENDDO
      RR=RR/TEMP
      DO I=10,28
        HL(I)=HEIGHTFL(I)+7.5D0+5*DEMANDFL(I-9)
      ENDDO
      DO I=1,44
        X(I)=0.0D0
        X(I+44)=0.0D0
        X(I+88)=DAVG
      ENDDO
      DO I=1,28
        X(I+132)=HL(I)+5.0D0
      ENDDO
      DO I=1,9
        X(I+160)=RR*SUPPLYFL(I)
      ENDDO
      DO I=1,132
        IH(I)=I
        JH(I)=I
      ENDDO
      IH(133)=133
      DO I=1,9
        J=2*(I-1)
        JH(133+J)=132+I
        JH(133+J+1)=160+I
        IH(133+I)=IH(132+I)+2
      ENDDO
      DO I=142,169
        JH(I+9)=I
        IH(I+1)=IH(I)+1
      ENDDO
      M=178
      RETURN
      END
