* SUBROUTINE EAFU16             ALL SYSTEMS                 99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF TEST FUNCTIONS FOR NONLINEAR EQUATIONS.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  I  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  F  VALUE OF THE APPROXIMATED FUNCTION AT THE
*          SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAFU16(N,I,X,F,NEXT)
      INTEGER N,I,NEXT
      REAL*8 X(N),F
      REAL*8 S,T,S1,S2,S3,T1,C,H,AL1,AL2,BE1,BE2
      REAL*8 AL,BE,A,B,GA,CA,CB,FF,U,LA,H2
      INTEGER J,N1,I1,I2,J1,J2,K,ALF,BET,GAM,L,ND
      GOTO (201,202,203,204,205,206,207,208,209,210,211,212,213,214,
     & 215,216,217,218,219,220,221,222,223,224,225,226,227,228,
     & 229,230,231,232),NEXT
201   IF(I.EQ.1) THEN
        F=1.0D 0-X(1)
      ELSE
        F=10.0D 0*DBLE(I-1)*(X(I)-X(I-1))**2
      ENDIF
      RETURN
202   IF(I.EQ.N) THEN
        F=X(I)-0.1D 0*X(1)**2
      ELSE
        F=X(I)-0.1D 0*X(I+1)**2
      ENDIF
      RETURN
203   T=-1.0D 0
      IF(I.LT.N) THEN
        T=T+X(I)
        DO 3010 J=1,N
           T=T+X(J)
3010    CONTINUE
        F=T-DBLE(N)
      ELSE
        S=1.0D 0
        DO 3020 J=1,N
           S=S*X(J)
3020    CONTINUE
        F=T+S
      ENDIF
      RETURN
204   IF(I/2*2.LT.I) THEN
        F=1.D 0-X(I)
      ELSE
        F=10.0D 0*(X(I)-X(I-1)**2)
      ENDIF
      RETURN
205   S=0.0D 0
      DO 3030 J=1,N
        S=S+X(J)**3
3030  CONTINUE
      F=X(I)-1.0D 0/DBLE(2*N)*(S+DBLE(I))
      RETURN
206   S=1.0D 0/DBLE(N+1)
      IF(N.EQ.1) THEN
        F=-2.0D 0*X(I)-S**2*EXP(X(I))
      ELSE IF(I.EQ.1) THEN
        F=-2.0D 0*X(I)+X(I+1)-S**2*EXP(X(I))
      ELSE IF(I.EQ.N) THEN
        F=X(I-1)-2.0D 0*X(I)-S**2*EXP(X(I))
      ELSE
        F=X(I-1)-2.0D 0*X(I)+X(I+1)-S**2*EXP(X(I))
      ENDIF
      RETURN
207   S=0.1D 0
      IF(N.EQ.1) THEN
        F=(3.0D 0-S*X(I))*X(I)+1.0D 0
      ELSE IF(I.EQ.1) THEN
        F=(3.0D 0-S*X(I))*X(I)+1.0D 0-2.0D 0*X(I+1)
      ELSE IF(I.EQ.N) THEN
        F=(3.0D 0-S*X(I))*X(I)+1.0D 0-X(I-1)
      ELSE
        F=(3.0D 0-S*X(I))*X(I)+1.0D 0-X(I-1)-2.0D 0*X(I+1)
      ENDIF
      RETURN
208   S1=1.0D 0
      S2=1.0D 0
      S3=1.0D 0
      J1=3
      J2=3
      IF(I-J1.GT.1) THEN
        I1=I-J1
      ELSE
        I1=1
      ENDIF
      IF(I+J2.LT.N) THEN
        I2=I+J2
      ELSE
        I2=N
      ENDIF
      S=0.0D 0
      DO 3040 J=I1,I2
        IF(J.NE.I) S=S+X(J)+X(J)**2
3040  CONTINUE
      F=(S1+S2*X(I)**2)*X(I)+1.D 0-S3*S
      RETURN
209   IF(I.EQ.1) THEN
        F=X(1)**2-1.0D 0
      ELSE
        F=X(I-1)**2+LOG(X(I))-1.0D 0
      ENDIF
      RETURN
210   S=0.0D 0
      DO 3050 J=1,N
        S=S+X(J)
3050  CONTINUE
      F=EXP(COS(DBLE(I)*S))
      RETURN
211   S=0.0D 0
      DO 3060 J=1,N
        S=S+X(J)**3
3060  CONTINUE
      F=1.0D 0/DBLE(2*N)*(S+DBLE(I))
      RETURN
212   IF(I.EQ.1) THEN
        F=X(1)
      ELSE
        F=COS(X(I-1))+X(I)-1.0D 0
      ENDIF
      RETURN
213   S=(1.0D 0/DBLE(N+1))**2
      IF(N.EQ.1) THEN
        F=2.0D 0*X(1)-1.D 0+S*(X(1)+SIN(X(1)))
      ELSE IF(I.EQ.1) THEN
        F=2.0D 0*X(1)-X(I+1)+S*(X(1)+SIN(X(1)))
      ELSE IF(I.EQ.N) THEN
        F=-X(I-1)+2.0D 0*X(I)-1.D 0+S*(X(I)+SIN(X(I)))
      ELSE
        F=-X(I-1)+2.0D 0*X(I)-X(I+1)+S*(X(I)+SIN(X(I)))
      ENDIF
      RETURN
214   IF(I-5.GT.1) THEN
        I1=I-5
      ELSE
        I1=1
      ENDIF
      IF(I+1.LT.N) THEN
        I2=I+1
      ELSE
        I2=N
      ENDIF
      S=0.D 0
      DO 3070 J=I1,I2
        IF(J.NE.I) S=S+X(J)*(1.0D 0+X(J))
3070  CONTINUE
      F=X(I)*(2.0D 0+5.0D 0*X(I)**2)+1.0D 0-S
      RETURN
215   S3=0.0D 0
      DO 4000 K=1,29
        S1=0.0D 0
        S=DBLE(K)/DBLE(29)
        DO 3080 J=1,N
           S1=S1+S**(J-1)*X(J)
3080    CONTINUE
        T1=0.0D 0
        DO 3090 J=2,N
           T1=T1+(J-1)*S**(J-2)*X(J)
3090    CONTINUE
        S3=S3+S**(I-2)*((I-1.0D 0-2.0D 0*S*S1)*(T1-S1**2-1.0D 0))
4000  CONTINUE
      IF (I.EQ.1) THEN
         F=S3+X(1)*(1.0D 0-2*(X(2)-X(1)*X(1)-1.0D 0))
      ELSE IF(I.EQ.2) THEN
        F=S3+X(2)-X(1)*X(1)-1.0D 0
      ELSE
        F=S3
      ENDIF
      RETURN
216   S=0.D 0
      DO 4020 J=1,N
        S1=2.D 0*X(J)-1.D 0
        T1=S1
        IF(I.GT.1) S2=2.D 0*S1**2-1.D 0
        IF(I.EQ.1) THEN
           S=S+S1
        ELSE IF(I.EQ.2) THEN
           S=S+S2
        ELSE
           DO 4010 K=3,I
              S3=2*T1*S2-S1
              S1=S2
              S2=S3
4010       CONTINUE
           S=S+S3
        ENDIF
4020  CONTINUE
      IF( I/2*2.EQ.I) THEN
         F=S/DBLE(N)+1.0D 0/DBLE(I**2-1)
      ELSE
        F=S/DBLE(N)
      ENDIF
      RETURN
217   IF(N.EQ.1) THEN
        F=3.D 0*X(1)*(20.D 0-2.D 0*X(1))+100.D 0
      ELSE IF(I.EQ.1) THEN
        F=3.D 0*X(I)*(X(I+1)-2.D 0*X(I))+(X(I+1))**2/4.0D 0
      ELSE IF(I.EQ.N) THEN
        F=3.D 0*X(I)*(20.0D 0-2.D 0*X(I)+X(I-1))+
     &   (20.0D 0-X(I-1))**2/4.0D 0
      ELSE
        F=3.D 0*X(I)*(X(I+1)-2.D 0*X(I)+X(I-1))+
     &   (X(I+1)-X(I-1))**2/4.0D 0
      ENDIF
      RETURN
218   S=1.0D 0/DBLE(N+1)
      IF(N.EQ.1) THEN
        F=2.D 0*X(1)+S**2/2.0D 0*(X(1)+S+1.0D 0)**3
      ELSE IF(I.EQ.1) THEN
       F=2.D 0*X(1)-X(I+1)+S**2/2.0D 0*(X(1)+DBLE(I)*S+1.0D 0)**3
      ELSE IF(I.EQ.N) THEN
        F=2.D 0*X(I)-X(I-1)+S**2/2.0D 0*(X(I)+DBLE(I)*S+1.0D 0)**3
      ELSE
        F=2.D 0*X(I)-X(I-1)-X(I+1)+S**2/2.0D 0*(X(I)+
     +  DBLE(I)*S+1.0D 0)**3
      ENDIF
      RETURN
219   S1=1.0D 0/(DBLE(N)+1.0D 0)
      S2=0.0D 0
      S3=0.0D 0
      DO 4030 J=1,I
        S2=S2+DBLE(J)*S1*(X(J)+DBLE(J)*S1+1.0D 0)**3
4030  CONTINUE
      DO 4040 J=I+1,N
        S3=S3+(1.0D 0-DBLE(J)*S1)*(X(J)+DBLE(J)*S1+1.0D 0)**3
4040  CONTINUE
      F=X(I)+S1/2.0D 0*((1.0D 0-DBLE(I)*S1)*S2+DBLE(I)*S1*S3)
      RETURN
220   S=0.0D 0
      DO 4050 J=1,N
        S=S+COS(X(J))
4050  CONTINUE
      F=DBLE(N)-S+DBLE(I)*(1.0D 0-COS(X(I)))-SIN(X(I))
      RETURN
221   S=0.0D 0
      DO 4060 J=1,N
        S=S+DBLE(J)*(X(J)-1.0D 0)
4060  CONTINUE
      F=X(I)-1.0D 0+DBLE(I)*S*(1.0D 0+2.0D 0*S*S)
      RETURN
222   IF(I.EQ.1.AND.N.GT.1) THEN
        F=(3.D 0-2.D 0*X(I))*X(I)-2.D 0*X(I+1)+1.D 0
      ELSE IF(I.EQ.N.AND.N.GT.1) THEN
        F=(3.D 0-2.D 0*X(I))*X(I)-X(I-1)+1.D 0
      ELSE IF(N.GT.1) THEN
        F=(3.D 0-2.D 0*X(I))*X(I)-X(I-1)-2.D 0*X(I+1)+1.D 0
      ELSE
        F=(3.D 0-2.D 0*X(I))*X(I)+1.D 0
      ENDIF
      RETURN
223   ALF=5
      BET=14
      GAM=3
      F=DBLE(BET*N)*X(I)+(DBLE(I)-DBLE(N)/2.0D 0)**GAM
      DO 4070 J=1,N
        IF(J.NE.I) THEN
        T=SQRT(X(J)**2+DBLE(I)/DBLE(J))
        S1=LOG(T)
        F=F+T*(SIN(S1)**ALF+COS(S1)**ALF)
      ENDIF
4070  CONTINUE
      RETURN
224   C=0.5D 0
      H=1.0D 0/DBLE(N)
      F=(1.0D 0-C*H/4.0D 0)
      DO 4080 J=1,N
        S=C*H*DBLE(I)/DBLE(2*(I+J))
        IF(J.EQ.N) S=S/2.0D 0
        F=F-S*X(J)
4080  CONTINUE
      F=-1.0D 0+X(I)*F
      RETURN
225   IF(I.EQ.1) THEN
        F=3.0D 0*X(I)**3+2.0D 0*X(I+1)-5.0D 0+
     +  SIN(X(I)-X(I+1))*SIN(X(I)+X(I+1))
      ELSE IF(I.NE.N) THEN
        F=3.0D 0*X(I)**3+2.0D 0*X(I+1)-5.0D 0+
     +  SIN(X(I)-X(I+1))*SIN(X(I)+X(I+1))+
     +  4.0D 0*X(I)-3.0D 0-X(I-1)*EXP(X(I-1)-X(I))
      ELSE
        F= 4.0D 0*X(I)-3.0D 0-X(I-1)*EXP(X(I-1)-X(I))
      ENDIF
      RETURN
226   T=10.0D 0
      H=T/DBLE(N+1)**2
      S=T*X(I)
      IF(I.EQ.1) THEN
        F=2.0D 0*X(I)-X(I+1)+H*(EXP(S)-EXP(-S))/2.D 0
      endif
      IF(1.LT.I.AND.I.LT.N) THEN
        F=-X(I-1)+2.0D 0*X(I)-X(I+1)+H*(EXP(S)-EXP(-S))/2.D 0
      endif
      IF(I.EQ.N) THEN
        F=-X(I-1)+2.0D 0*X(I)-1.0D 0+H*(EXP(S)-EXP(-S))/2.D 0
      ENDIF
      RETURN
227   S=0.5D 0
      H=1.0D 0/DBLE(N+1)
      T=H**2/S
      H=2.0D 0*H
      IF(I.EQ.1) THEN
        F=2.0D 0*X(I)-X(I+1)-T*(X(I)**2+X(I+1)/H)
      ENDIF
      IF(1.LT.I.AND.I.LT.N) THEN
        F=-X(I-1)+2.0D 0*X(I)-X(I+1)-T*(X(I)**2+(X(I+1)-X(I-1))/H)
      ENDIF
      IF(I.EQ.N) THEN
        F=-X(I-1)+2.0D 0*X(I)-0.5D 0-T*(X(I)**2+(0.5D 0-X(I-1))/H)
      ENDIF
      RETURN
228   S=0.5D 0
      H=1.0D 0/DBLE(N+1)
      T=H**2/S
      T1=2.0D 0*H
      AL=0.0D 0
      BE=0.5D 0
      S1=0.0D 0
      DO 4090 J=1,I
        IF(J.EQ.1) THEN
           S1=S1+DBLE(J)*(X(J)**2+(X(J+1)-AL)/T1)
        ENDIF
        IF(1.LT.J.AND.J.LT.N) THEN
           S1=S1+DBLE(J)*(X(J)**2+(X(J+1)-X(J-1))/T1)
        ENDIF
        IF(J.EQ.N) THEN
           S1=S1+DBLE(J)*(X(J)**2+(BE-X(J-1))/T1)
        ENDIF
4090  CONTINUE
      S1=(1.0D 0-DBLE(I)*H)*S1
      IF(I.EQ.N) GO TO 5010
      S2=0.0D 0
      DO 5000 J=I+1,N
        IF(J.LT.N) THEN
           S2=S2+(1.0D 0-DBLE(J)*H)*(X(J)**2+(X(J+1)-X(J-1))/T1)
        ELSE
           S2=S2+(1.0D 0-DBLE(J)*H)*(X(J)**2+(BE-X(J-1))/T1)
        ENDIF
5000  CONTINUE
      S1=S1+DBLE(I)*S2
5010  F=X(I)-0.5D 0*DBLE(I)*H-T*S1
      RETURN
229   A=-9.0D-3
      B=1.0D-3
      AL=0.0D 0
      BE=25.0D 0
      GA=20.0D 0
      CA=0.3D 0
      CB=0.3D 0
      H=(B-A)/DBLE(N+1)
      T=A+DBLE(I)*H
      H=H**2
      S=DBLE(I)/DBLE(N+1)
      U=AL*(1.0D 0-S)+BE*S+X(I)
      FF=CB*EXP(GA*(U-BE))-CA*EXP(GA*(AL-U))
      IF(T.LE.0) THEN
        FF=FF+CA
      ELSE
        FF=FF-CB
      ENDIF
      IF(N.EQ.1) THEN
        F=-AL+2.0D 0*X(I)-BE+H*FF
      ELSEIF(I.EQ.1) THEN
        F=-AL+2.0D 0*X(I)-X(I+1)+H*FF
      ELSEIF(I.LT.N) THEN
        F=-X(I-1)+2.0D 0*X(I)-X(I+1)+H*FF
      ELSE
        F=-X(I-1)+2.0D 0*X(I)-BE+H*FF
      ENDIF
      RETURN
230   AL1=0.0D 0
      AL2=0.0D 0
      BE1=0.0D 0
      BE2=0.0D 0
      N1=N/2
      H=1.0D 0/DBLE(N1+1)
      T=DBLE(I)*H
      IF(I.EQ.1) THEN
        S1=2.0D 0*X(I)-X(I+1)
        B=AL1
      ELSE IF(I.EQ.N1+1) THEN
        S1=2.0D 0*X(I)-X(I+1)
        B=AL2
      ELSE IF(I.EQ.N1) THEN
        S1=-X(I-1)+2.0D 0*X(I)
        B=BE1
      ELSE IF(I.EQ.N) THEN
        S1=-X(I-1)+2.0D 0*X(I)
        B=BE2
      ELSE
        S1=-X(I-1)+2.0D 0*X(I)-X(I+1)
        B=0.0D 0
      ENDIF
      IF(I.LE.N1) THEN
        S2=X(I)**2+X(I)+0.1D 0*X(N1+I)**2-1.2D 0
      ELSE
        S2=0.2D 0*X(I-N1)**2+X(I)**2+2.0D 0*X(I)-0.6D 0
      ENDIF
      F=S1+H**2*S2-B
      RETURN
231   ND=INT(SQRT(DBLE(N)))
      L=MOD(I,ND)
      IF(L.EQ.0) THEN
         K=I/ND
         L=ND
      ELSE
         K=INT(I/ND)+1
      ENDIF
      LA=1.0D 0
      H=1.0D 0/DBLE(ND+1)
      H2=LA*H*H
      IF(L.EQ.1.AND.K.EQ.1) THEN
         F=4.0D 0*X(1)-X(2)-X(ND+1)+H2*EXP(X(1))
      ENDIF
      IF(1.LT.L.AND.L.LT.ND.AND.K.EQ.1) THEN
         F=4.0D 0*X(L)-X(L-1)-X(L+1)-X(L+ND)+H2*EXP(X(L))
      ENDIF
      IF(L.EQ.ND.AND.K.EQ.1) THEN
         F=4.0D 0*X(ND)-X(ND-1)-X(ND+ND)+H2*EXP(X(ND))
      ENDIF
      IF(L.EQ.1.AND.1.LT.K.AND.K.LT.ND) THEN
         F=4.0D 0*X(I)-X(I+1)-X(I-ND)-X(I+ND)+H2*EXP(X(I))
      ENDIF
      IF(L.EQ.ND.AND.1.LT.K.AND.K.LT.ND) THEN
         F=4.0D 0*X(I)-X(I-ND)-X(I-1)-X(I+ND)+H2*EXP(X(I))
      ENDIF
      IF(L.EQ.1.AND.K.EQ.ND) THEN
         F=4.0D 0*X(I)-X(I+1)-X(I-ND)+H2*EXP(X(I))
      ENDIF
      IF(1.LT.L.AND.L.LT.ND.AND.K.EQ.ND) THEN
         F=4.0D 0*X(I)-X(I-1)-X(I+1)-X(I-ND)+H2*EXP(X(I))
      ENDIF
      IF(L.EQ.ND.AND.K.EQ.ND) THEN
        F=4.0D 0*X(I)-X(I-1)-X(I-ND)+H2*EXP(X(I))
      ENDIF
      IF(1.LT.L.AND.L.LT.ND.AND.1.LT.K.AND.K.LT.ND) THEN
         F=4.0D 0*X(I)-X(I-1)-X(I+1)-X(I-ND)-X(I+ND)+H2*EXP(X(I))
      ENDIF
      RETURN
232   ND=INT(SQRT(DBLE(N)))
      L=MOD(I,ND)
      IF(L.EQ.0) THEN
         K=I/ND
         L=ND
      ELSE
         K=INT(I/ND)+1
      ENDIF
      H=1.0D 0/DBLE(ND+1)
      H2=H*H
      IF(L.EQ.1.AND.K.EQ.1) THEN
         F=4.0D 0*X(1)-X(2)-X(ND+1)+H2*X(1)**2-24.0D 0/(H+1.0D 0)**2
      ENDIF
      IF(1.LT.L.AND.L.LT.ND.AND.K.EQ.1) THEN
         F=4.0D 0*X(L)-X(L-1)-X(L+1)-X(L+ND)+H2*X(L)**2
     *-12.0D 0/(DBLE(L)*H+1.0D 0)**2
      ENDIF
      IF(L.EQ.ND.AND.K.EQ.1) THEN
         F=4.0D 0*X(ND)-X(ND-1)-X(ND+ND)+H2*X(ND)**2
     *-12.0D 0/(DBLE(ND)*H+1.0D 0)**2-12.0D 0/(H+2.0D 0)**2
      ENDIF
      IF(L.EQ.1.AND.1.LT.K.AND.K.LT.ND) THEN
         F=4.0D 0*X(I)-X(I+1)-X(I-ND)-X(I+ND)+H2*X(I)**2
     *-12.0D 0/(DBLE(K)*H+1.0D 0)**2
      ENDIF
      IF(L.EQ.ND.AND.1.LT.K.AND.K.LT.ND) THEN
         F=4.0D 0*X(I)-X(I-ND)-X(I-1)-X(I+ND)+H2*X(I)**2
     *-12.0D 0/(DBLE(K)*H+2.0D 0)**2
      ENDIF
      IF(L.EQ.1.AND.K.EQ.ND) THEN
         F=4.0D 0*X(I)-X(I+1)-X(I-ND)+H2*X(I)**2
     *-12.0D 0/(DBLE(ND)*H+1.0D 0)**2-12.0D 0/(H+2.0D 0)**2
      ENDIF
      IF(1.LT.L.AND.L.LT.ND.AND.K.EQ.ND) THEN
         F=4.0D 0*X(I)-X(I-1)-X(I+1)-X(I-ND)+H2*X(I)**2
     *-12.0D 0/(DBLE(L)*H+2.0D 0)**2
      ENDIF
      IF(L.EQ.ND.AND.K.EQ.ND) THEN
        F=4.0D 0*X(I)-X(I-1)-X(I-ND)+H2*X(I)**2
     *-24.0D 0/(DBLE(ND)*H+2.0D 0)**2
      ENDIF
      IF(1.LT.L.AND.L.LT.ND.AND.1.LT.K.AND.K.LT.ND) THEN
         F=4.0D 0*X(I)-X(I-1)-X(I+1)-X(I-ND)-X(I+ND)+H2*X(I)**2
      ENDIF
      RETURN
      END
