* SUBROUTINE EAFU25                ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF MODEL FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  FA  VALUE OF THE APPROXIMATED FUNCTION AT THE
*          SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAFU25(N,KA,X,FA,NEXT)
      INTEGER N,KA,NEXT
      REAL*8 X(N),FA
      INTEGER IND(100)
      COMMON /INDEX/ IND
      IF (NEXT.LE.22) THEN
      CALL EAFU14(N,KA,X,FA,NEXT)
      ELSE IF (NEXT.EQ.23) THEN
      IF (MOD(KA,2).EQ.1) THEN
      FA=1.0D 1*(X(KA+1)-X(KA)**2)
      ELSE
      FA=1.0D 0-X(KA-1)
      ENDIF
      FA=0.5D 0*FA**2
      ELSE IF (NEXT.EQ.24) THEN
      IF (MOD(KA,4).EQ.1) THEN
      FA=X(KA)+1.0D 1*X(KA+1)
      ELSE IF (MOD(KA,4).EQ.2) THEN
      FA=2.23606797749979D 0*(X(KA+1)-X(KA+2))
      ELSE IF (MOD(KA,4).EQ.3) THEN
      FA=(X(KA-1)-2.0D 0*X(KA))**2
      ELSE
      FA=3.16227766016838D 0*(X(KA-3)-X(KA))**2
      ENDIF
      FA=0.5D 0*FA**2
      ELSE IF (NEXT.EQ.25) THEN
      FA=(3.0D 0-2.0D 0*X(KA))*X(KA)+1.0D 0
      IF (KA.GT.1) FA=FA-X(KA-1)
      IF (KA.LT.N) FA=FA-2.0D 0*X(KA+1)
      FA=0.5D 0*FA**2
      ELSE IF (NEXT.EQ.26) THEN
      IF (KA.EQ.1) THEN
      FA=1.0D 0-X(1)
      ELSE
      FA=10.0D 0*DBLE(KA-1)*(X(KA)-X(KA-1))**2
      ENDIF
      FA=0.5D 0*FA**2
      ELSE IF (NEXT.LE.44) THEN
      CALL EAFU15(N,KA,X,FA,NEXT-22)
      FA=0.5D 0*FA**2
      ELSE IF (NEXT.LE.82) THEN
      CALL EAFU18(N,KA,X,FA,IND(NEXT)-44)
      FA=0.5D 0*FA**2
      ENDIF
      RETURN
      END
