* SUBROUTINE EAGU20                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 RA : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENTS OF MODEL FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  SPARSE VERSION - LU VERSION WITH MODIFIED TESTS NO 7-10,12.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  G(N)  GRADIENT OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAGU20(N,KA,X,GA,NEXT)
      INTEGER N,NEXT
      REAL*8 X(N),GA(N)
      REAL*8 A,B,C,D,P,Q,R,U,V
      INTEGER I,J,KA
      GOTO (10,20,30,40,50,60,70,80,90,100,110,120,130,110,120,160,170,
     & 160,80), NEXT
   10   A=X(KA)**2-X(KA+1)
        B=X(KA)-1.0D 0
        GA(KA)=4.0D 2*X(KA)*A+2.0D 0*B
        GA(KA+1)=-2.0D 2*A
      RETURN
   20   I=2*KA-1
        A=X(I)**2-X(I+1)
        B=X(I)-1.0D 0
        C=X(I+2)**2-X(I+3)
        D=X(I+2)-1.0D 0
        U=X(I+1)+X(I+3)-2.0D 0
        V=X(I+1)-X(I+3)
        GA(I)=4.0D 2*X(I)*A+2.0D 0*B
        GA(I+1)=-2.0D 2*A+2.0D 1*U+0.2D 0*V
        GA(I+2)=3.6D 2*X(I+2)*C+2.0D 0*D
        GA(I+3)=-1.8D 2*C+2.0D 1*U-0.2D 0*V
      RETURN
   30   I=2*KA-1
        A=X(I)+1.0D 1*X(I+1)
        B=X(I+2)-X(I+3)
        C=X(I+1)-2.0D 0*X(I+2)
        D=X(I)-X(I+3)
        GA(I)=2.0D 0*A+4.0D 1*D**3
        GA(I+1)=2.0D 1*A+4.0D 0*C**3
        GA(I+2)=-8.0D 0*C**3+1.0D 1*B
        GA(I+3)=-4.0D 1*D**3-1.0D 1*B
      RETURN
   40   I=2*KA-1
        A=EXP(X(I))
        B=A-X(I+1)
        B=4.0D 0*B**3
        D=X(I+1)-X(I+2)
        D=6.0D 2*D**5
        P=X(I+2)-X(I+3)
        C=COS(P)
        Q=SIN(P)/COS(P)
        Q=4.0D 0*Q**3/C**2
        U=X(I)
        V=X(I+3)-1.0D 0
        GA(I)=A*B+8.0D 0*U**7
        GA(I+1)=D-B
        GA(I+2)=Q-D
        GA(I+3)=2.0D 0*V-Q
      RETURN
   50 P=7.0D 0/3.0D 0
        A=(3.0D 0-2.0D 0*X(KA))*X(KA)+1.0D 0
        IF (KA.GT.1) A=A-X(KA-1)
        IF (KA.LT.N) A=A-X(KA+1)
        B=P*ABS(A)**(P-1.0D 0)*SIGN(1.0D 0,A)
        GA(KA)=B*(3.0D 0-4.0D 0*X(KA))
        IF (KA.GT.1) GA(KA-1)=-B
        IF (KA.LT.N) GA(KA+1)=-B
      RETURN
   60 P=7.0D 0/3.0D 0
        A=(2.0D 0+5.0D 0*X(KA)**2)*X(KA)+1.0D 0
        DO 61 I=MAX(1,KA-5),MIN(N,KA+1)
        A=A+X(I)*(1.0D 0+X(I))
   61   CONTINUE
        B=P*ABS(A)**(P-1.0D 0)*SIGN(1.0D 0,A)
        DO 62 I=MAX(1,KA-5),MIN(N,KA+1)
          GA(I)=B*(1.0D 0+2.0D 0*X(I))
   62   CONTINUE
        GA(KA)=GA(KA)+B*(2.0D 0+1.5D 1*X(KA)**2)
      RETURN
   70   A=DBLE(KA)*SIN(X(KA))
        GA(KA)=A
        IF(KA.GT.1) GA(KA-1)=+DBLE(KA)*COS(X(KA-1))
        IF(KA.LT.N) GA(KA+1)=-DBLE(KA)*COS(X(KA+1))
      RETURN
   80 P=-0.2008D-2
      Q=-0.1900D-2
      R=-0.0261D-2
      I=5*(KA-1)
      A=1.0D 0
      B=0.0D 0
      DO 81 J=1,5
      A=A*X(I+J)
      B=B+X(I+J)**2
   81 CONTINUE
      A=A*EXP(A)
      B=B-1.0D 1-P
      C=X(I+2)*X(I+3)-5.0D 0*X(I+4)*X(I+5)-Q
      D=X(I+1)**3+X(I+2)**3+1.0D 0-R
      GA(I+1)=A/X(I+1)+2.0D 1*(2.0D 0*B*X(I+1)
     &       +3.0D 0*D*X(I+1)**2)
      GA(I+2)=A/X(I+2)+2.0D 1*(2.0D 0*B*X(I+2)
     &       +C*X(I+3)+3.0D 0*D*X(I+2)**2)
      GA(I+3)=A/X(I+3)+2.0D 1*(2.0D 0*B*X(I+3)+C*X(I+2))
      GA(I+4)=A/X(I+4)+2.0D 1*(2.0D 0*B*X(I+4)
     &       -5.0D 0*C*X(I+5))
      GA(I+5)=A/X(I+5)+2.0D 1*(2.0D 0*B*X(I+5)-5.0D 0*C*X(I+4))
      RETURN
   90 I=2*KA-1
      A=X(I)-3.0D 0
      B=X(I)-X(I+1)
      GA(I)=2.0D-4*A-1.0D 0+2.0D 1*EXP(2.0D 1*B)
      GA(I+1)=1.0D 0-2.0D 1*EXP(2.0D 1*B)
      RETURN
  100 I=2*KA-1
      A=X(I+1)**2
      B=X(I)**2
      C=A+1.0D 0
      D=B+1.0D 0
      P=0.0D 0
      IF (A.GT.P) P=LOG(A)
      Q=0.0D 0
      IF (B.GT.Q) Q=LOG(B)
      GA(I)=2.0D 0*X(I)*(C*B**A+P*A**D)
      GA(I+1)=2.0D 0*X(I+1)*(D*A**B+Q*B**C)
      RETURN
  110 I=(KA-1)/4
      J=I*3
      GO TO (111,112,113,114),MOD(KA,4)+1
  111 GA(J+5)=6.0D 0*(X(J+5)-1.0D 0)**5
      RETURN
  112 GA(J+1)=2.0D 0*(X(J+1)-X(J+2))
      GA(J+2)=-GA(J+1)
      RETURN
  113 GA(J+3)=2.0D 0*(X(J+3)-1.0D 0)
      RETURN
  114 GA(J+4)=4.0D 0*(X(J+4)-1.0D 0)**3
      RETURN
  120 I=(KA-1)/4
      J=I*4
      GO TO (121,122,123,124),MOD(KA,4)+1
  121 GA(J+4)=4.0D 0*(X(J+4)-X(J+5))**3
      GA(J+5)=-GA(J+4)
      RETURN
  122 GA(J+1)=2.0D 0*(X(J+1)-X(J+2))
      GA(J+2)=-GA(J+1)
      RETURN
  123 GA(J+2)=2.0D 0*(X(J+2)-X(J+3))
      GA(J+3)=-GA(J+2)
      RETURN
  124 GA(J+3)=4.0D 0*(X(J+3)-X(J+4))**3
      GA(J+4)=-GA(J+3)
      RETURN
  130 I=(KA-1)/3
      J=I*3
      GO TO (131,132,133),MOD(KA,3)+1
  131 GA(J+4)=4.0D 0*(X(J+4)-X(J+5))**3
      GA(J+5)=-GA(J+4)
      RETURN
  132 GA(J+1)=2.0D 0*(X(J+1)-1.0D 0)
      RETURN
  133 GA(J+2)=2.0D 0*(X(J+2)-X(J+3))
      GA(J+3)=-GA(J+2)
      RETURN
  160 I=(KA-1)/4
      J=I*4
      GO TO (161,162,163,164),MOD(KA,4)+1
  161 GA(J+5)=2.0D 0*(X(J+5)-1.0D 0)
      RETURN
  162 GA(J+1)= 4.0D 0*(X(J+1)-X(J+2))**3
      GA(J+2)=-GA(J+1)
      RETURN
  163 GA(J+2)=2.0D 0*(X(J+2)+X(J+3)-2.0D 0)
      GA(J+3)= GA(J+2)
      RETURN
  164 GA(J+4)=2.0D 0*(X(J+4)-1.0D 0)
      RETURN
  170 I=(KA-1)/4
      J=I*4
      GO TO (171,172,173,174),MOD(KA,4)+1
  171 GA(J+5)=2.0D 0*(X(J+5)-1.0D 0)
      RETURN
  172 GA(J+1)= 8.0D 0*(4.0D 0*X(J+1)-X(J+2))
      GA(J+2)=-2.0D 0*(4.0D 0*X(J+1)-X(J+2))
      RETURN
  173 GA(J+2)=4.0D 0*(X(J+2)+X(J+3)-2.0D 0)**3
      GA(J+3)=GA(J+2)
      RETURN
  174 GA(J+4)=2.0D 0*(X(J+4)-1.0D 0)
      RETURN
      END
