* SUBROUTINE EAGU34                ALL SYSTEMS                04/12/01
C PORTABILITY : ALL SYSTEMS
C 04/12/01 RA : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENTS OF MODEL FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  SPARSE VERSION - LU VERSION WITH MODIFIED TESTS NO 7-10,12.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  G(N)  GRADIENT OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAGU34(N,KA,X,GA,NEXT)
      INTEGER N,KA,NEXT
      REAL*8 X(N),GA(N)
      REAL*8 A,B,C,D,Q,R,E,ALFA,U,V
      INTEGER I,J,K,L,M,IA,IB,IC
      REAL*8 Y(20)
      COMMON /EMPR15/ Y
      GOTO(10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     & 170,180,190,200,210,220,260,270),NEXT
   10 I=(KA+1)/2
      IF (MOD(KA,2).EQ.1) THEN
      GA(I)=2.0D 1*X(I)
      GA(I+1)=-1.0D 1
      ELSE
      GA(I)=1.0D 0
      ENDIF
      RETURN
   20 I=2*((KA+5)/6)
      A=SQRT(9.0D 1)
      B=SQRT(1.0D 1)
      IF (MOD(KA,6).EQ.1) THEN
      GA(I-1)=2.0D 1 *X(I-1)
      GA(I)=-1.0D 1
      ELSEIF (MOD(KA,6).EQ.2) THEN
      GA(I-1)=1.0D 0
      ELSEIF (MOD(KA,6).EQ.3) THEN
      GA(I+1)=2.0D 0*A*X(I+1)
      GA(I+2)=-A
      ELSEIF (MOD(KA,6).EQ.4) THEN
      GA(I+1)=1.0D 0
      ELSEIF (MOD(KA,6).EQ.5) THEN
      GA(I)=B
      GA(I+2)=B
      ELSE
      GA(I)=1.0D 0/B
      GA(I+2)=-1.0D 0/B
      ENDIF
      RETURN
   30 I=2*((KA+3)/4)
      A=SQRT(5.0D 0)
      B=SQRT(1.0D 1)
      IF (MOD(KA,4).EQ.1) THEN
      GA(I-1)=1.0D 0
      GA(I)=1.0D 1
      ELSEIF (MOD(KA,4).EQ.2) THEN
      GA(I+1)=A
      GA(I+2)=-A
      ELSEIF (MOD(KA,4).EQ.3) THEN
      C=X(I)-2.0D 0*X(I+1)
      GA(I)=2.0D 0*C
      GA(I+1)=-4.0D 0*C
      ELSE
      C=X(I-1)-X(I+2)
      D=2.0D 0*B*C
      GA(I-1)=D
      GA(I+2)=-D
      ENDIF
      RETURN
   40 I=2*((KA+4)/5)
      IF (MOD(KA,5).EQ.1) THEN
      A=EXP(X(I-1))
      B=A-X(I)
      C=2.0D 0*B
      GA(I-1)=C*A
      GA(I)=-C
      ELSEIF (MOD(KA,5).EQ.2) THEN
      A=X(I)-X(I+1)
      B=3.0D 1*A**2
      GA(I)=B
      GA(I+1)=-B
      ELSEIF (MOD(KA,5).EQ.3) THEN
      C=X(I+1)-X(I+2)
      Q=SIN(C)/COS(C)
      R=COS(C)
      D=2.0D 0*Q/R**2
      GA(I+1)=D
      GA(I+2)=-D
      ELSEIF (MOD(KA,5).EQ.4) THEN
      GA(I-1)=4.0D 0*X(I-1)**3
      ELSE
      GA(I+2)=1.0D 0
      ENDIF
      RETURN
   50 I=KA
      GA(I)=3.0D 0-4.0D 0*X(I)
      IF (I.GT.1) GA(I-1)=-1.0D 0
      IF (I.LT.N) GA(I+1)=-1.0D 0
      RETURN
   60 I=KA
      DO 61 J=MAX(1,I-5),MIN(N,I+1)
      GA(J)=1.0D 0+2.0D 0*X(J)
   61 CONTINUE
      GA(I)=GA(I)+2.0D 0+1.5D 1*X(I)**2
      RETURN
   70 I=(KA+1)/2
      IF (MOD(KA,2).EQ.1) THEN
      GA(I)=1.0D 0
      GA(I+1)=1.0D 1*X(I+1)-3.0D 0*X(I+1)**2-2.0D 0
      ELSE
      GA(I)=1.0D 0
      GA(I+1)=2.0D 0*X(I+1)+3.0D 0*X(I+1)**2-1.4D 1
      ENDIF
      RETURN
   80 I=MOD(KA,N/2)+1
      J=I+N/2
      M=5*N
      IF (KA.LE.M/2) THEN
      IA=1
      ELSE
      IA=2
      ENDIF
      IB=5-KA/(M/4)
      IC=MOD(KA,5)+1
      A=DBLE(IA)
      B=DBLE(IB)
      C=DBLE(IC)
      D=X(I)**IA-X(J)**IB
      IF (D.EQ.0.0D 0) THEN
      GA(I)=0.0D 0
      GA(J)=0.0D 0
      ELSE
      E=C*D**(IC-1)
      IF (X(I).EQ.0.0D 0.AND.IA.LE.1) THEN
      GA(I)=0.0D 0
      ELSE
      GA(I)= E*A*X(I)**(IA-1)
      ENDIF
      IF (X(J).EQ.0.0D 0.AND.IB.LE.1) THEN
      GA(J)=0.0D 0
      ELSE
      GA(J)=-E*B*X(J)**(IB-1)
      ENDIF
      ENDIF
      RETURN
   90 I=2*((KA+5)/6)-1
      IF (MOD(KA,6).EQ.1) THEN
      GA(I)=1.0D 0
      GA(I+1)=3.0D 0*(X(I+2)-1.0D 0)
      GA(I+2)=3.0D 0*X(I+1)
      GA(I+3)=2.0D 0*X(I+3)
      ELSEIF (MOD(KA,6).EQ.2) THEN
      GA(I)=2.0D 0*(X(I)+X(I+1))
      GA(I+1)=2.0D 0*(X(I)+X(I+1))
      GA(I+2)=2.0D 0*(X(I+2)-1.0D 0)
      GA(I+3)=-1.0D 0
      ELSEIF (MOD(KA,6).EQ.3) THEN
      GA(I)=X(I+1)
      GA(I+1)=X(I)
      GA(I+2)=-X(I+3)
      GA(I+3)=-X(I+2)
      ELSEIF (MOD(KA,6).EQ.4) THEN
      GA(I)=2.0D 0*X(I+2)
      GA(I+1)=X(I+3)
      GA(I+2)=2.0D 0*X(I)
      GA(I+3)=X(I+1)
      ELSEIF (MOD(KA,6).EQ.5) THEN
      GA(I)=2.0D 0*(X(I)+X(I+1)+X(I+2)+X(I+3))+2.0D 0*(X(I)-1.0D 0)
      GA(I+1)=2.0D 0*(X(I)+X(I+1)+X(I+2)+X(I+3))
      GA(I+2)=2.0D 0*(X(I)+X(I+1)+X(I+2)+X(I+3))
      GA(I+3)=2.0D 0*(X(I)+X(I+1)+X(I+2)+X(I+3))
      ELSE
      GA(I)=X(I+1)*X(I+2)*X(I+3)
      GA(I+1)=X(I)*X(I+2)*X(I+3)
      GA(I+2)=X(I)*X(I+1)*X(I+3)
      GA(I+3)=X(I)*X(I+1)*X(I+2)+2.0D 0*(X(I+3)-1.0D 0)
      ENDIF
      RETURN
  100 IF (N.GE.2) THEN
      I=(KA+1)/2
      J=MOD(KA,2)
      IF (J.EQ.0) THEN
      GA(I)=-2.0D 0*EXP(2.0D 0*X(I))
      GA(I+1)=-2.0D 0*EXP(2.0D 0*X(I+1))
      ELSEIF (I.EQ.1) THEN
      GA(I)=-EXP(X(I))
      GA(I+1)=-EXP(X(I+1))
      ELSEIF (I.EQ.N) THEN
      GA(I-1)=-3.0D 0*EXP(3.0D 0*X(I-1))
      GA(I)=-3.0D 0*EXP(3.0D 0*X(I))
      ELSE
      GA(I-1)=-3.0D 0*EXP(3.0D 0*X(I-1))
      GA(I)=-3.0D 0*EXP(3.0D 0*X(I))-EXP(X(I))
      GA(I+1)=-EXP(X(I+1))
      ENDIF
      ENDIF
      RETURN
  110 I=(KA+1)/2
      IF (MOD(KA,2).EQ.1) THEN
      GA(I)=2.0D 1*(1.0D 0-X(I)**2)/(1.0D 0+X(I)**2)**2
      GA(I+1)=-1.0D 1
      ELSE
      GA(I)=1.0D 0
      ENDIF
      RETURN
  120 I=3*((KA+5)/6)-2
      IF (MOD(KA,6).EQ.1) THEN
      GA(I)=2.0D 1*X(I)
      GA(I+1)=-1.0D 1
      ELSEIF (MOD(KA,6).EQ.2) THEN
      GA(I+2)=1.0D 0
      ELSEIF (MOD(KA,6).EQ.3) THEN
      GA(I+3)=2.0D 0*(X(I+3)-1.0D 0)
      ELSEIF (MOD(KA,6).EQ.4) THEN
      GA(I+4)=3.0D 0*(X(I+4)-1.0D 0)**2
      ELSEIF (MOD(KA,6).EQ.5) THEN
      GA(I)=2.0D 0*X(I)*X(I+3)
      GA(I+3)=X(I)**2+COS(X(I+3)-X(I+4))
      GA(I+4)=-COS(X(I+3)-X(I+4))
      ELSE
      GA(I+1)=1.0D 0
      GA(I+2)=4.0D 0*X(I+2)*(X(I+2)*X(I+3))**2
      GA(I+3)=2.0D 0*X(I+2)**4*X(I+3)
      ENDIF
      RETURN
  130 I=3*((KA+6)/7)-2
      IF (MOD(KA,7).EQ.1) THEN
      GA(I)=2.0D 1*X(I)
      GA(I+1)=-1.0D 1
      ELSEIF (MOD(KA,7).EQ.2) THEN
      GA(I+1)=2.0D 1*X(I+1)
      GA(I+2)=-1.0D 1
      ELSEIF (MOD(KA,7).EQ.3) THEN
      GA(I+2)= 2.0D 0*(X(I+2)-X(I+3))
      GA(I+3)=-2.0D 0*(X(I+2)-X(I+3))
      ELSEIF (MOD(KA,7).EQ.4) THEN
      GA(I+3)= 2.0D 0*(X(I+3)-X(I+4))
      GA(I+4)=-2.0D 0*(X(I+3)-X(I+4))
      ELSEIF (MOD(KA,7).EQ.5) THEN
      GA(I)=1.0D 0
      GA(I+1)=2.0D 0*X(I+1)
      GA(I+2)=1.0D 0
      ELSEIF (MOD(KA,7).EQ.6) THEN
      GA(I+1)=1.0D 0
      GA(I+2)=-2.0D 0*X(I+2)
      GA(I+3)=1.0D 0
      ELSE
      GA(I)=X(I+4)
      GA(I+4)=X(I)
      ENDIF
      RETURN
  140 I=2*((KA+3)/4)-2
      L=MOD((KA-1),4)+1
      DO 141 J=1,4
      GA(I+J)=0.0D 0
  141 CONTINUE
      DO 144 K=1,3
      A=DBLE(K*K)/DBLE(L)
      DO 142 J=1,4
      A=A*SIGN(1.0D 0,X(I+J))*ABS(X(I+J))**(DBLE(J)/DBLE(K*L))
  142 CONTINUE
      DO 143 J=1,4
      GA(I+J)=GA(I+J)+(DBLE(J)/DBLE(K*L))*A/X(I+J)
  143 CONTINUE
  144 CONTINUE
      RETURN
  150 I=2*((KA+3)/4)-2
      L=MOD((KA-1),4)+1
      DO 151 J=1,4
      GA(I+J)=0.0D 0
  151 CONTINUE
      DO 154 K=1,3
      A=0.0D 0
      DO 152 J=1,4
      A=A+X(I+J)*(DBLE(J)/DBLE(K*L))
  152 CONTINUE
      A=EXP(A)*DBLE(K*K)/DBLE(L)
      DO 153 J=1,4
      GA(I+J)=GA(I+J)+A*(DBLE(J)/DBLE(K*L))
  153 CONTINUE
  154 CONTINUE
      RETURN
  160 I=2*((KA+3)/4)-2
      L=MOD((KA-1),4)+1
      DO 161 J=1,4
      GA(I+J)=DBLE((1-2*MOD(J,2))*L*J*J)*COS(X(I+J))-
     & DBLE(L*L*J)*SIN(X(I+J))
  161 CONTINUE
      RETURN
  170 ALFA=0.5D 0
      IF (KA.EQ.1) THEN
      GA(1)=-1.0D 0-4.0D 0*X(2)
      GA(2)=-4.0D 0*X(1)
      GA(3)=ALFA-1.0D 0
      ELSEIF(KA.EQ.2) THEN
      GA(1)=-4.0D 0*X(2)
      GA(2)=-1.0D 0-4.0D 0*X(1)
      GA(4)=-2.0D 0+ALFA
      ELSEIF(KA.EQ.N-1) THEN
      GA(N-3)=ALFA
      GA(N-1)=-1.0D 0-4.0D 0*X(N)
      GA(N)=-4.0D 0*X(N-1)
      ELSEIF (KA.EQ.N) THEN
      GA(N-2)=ALFA
      GA(N-1)=-4.0D 0*X(N)
      GA(N)=-1.0D 0-4.0D 0*X(N-1)
      ELSEIF (MOD(KA,2).EQ.1) THEN
      GA(KA-2)=ALFA
      GA(KA)=-1.0D 0-4.0D 0*X(KA+1)
      GA(KA+1)=-4.0D 0*X(KA)
      GA(KA+2)=-1.0D 0+ALFA
      ELSE
      GA(KA-2)=ALFA
      GA(KA-1)=-4.0D 0*X(KA)
      GA(KA)=-1.0D 0-4.0D 0*X(KA-1)
      GA(KA+2)=-2.0D 0+ALFA
      ENDIF
      RETURN
  180 IF (KA.LT.2) THEN
      GA(KA)=4.0D 0
      GA(KA+1)=-8.0D 0*X(KA+1)
      ELSE IF (KA.LT.N) THEN
      GA(KA-1)=-8.0D 0*X(KA)
      GA(KA)=24.0D 0*X(KA)**2-8.0D 0*X(KA-1)+6.0D 0
      GA(KA+1)=-8.0D 0*X(KA+1)
      ELSE
      GA(KA-1)=-8.0D 0*X(KA)
      GA(KA)=24.0D 0*X(KA)**2-8.0D 0*X(KA-1)+2.0D 0
      ENDIF
      RETURN
  190 IF (KA.EQ.1) THEN
      GA(N-4)=3.0D 0
      GA(N-3)=-1.0D 0
      GA(N-2)=-1.0D 0
      GA(N-1)=0.50D 0
      GA(N)=-1.0D 0
      GA(KA)=-4.0D 0*X(KA)+3.0D 0
      GA(KA+1)=-2.0D 0
      ELSEIF (KA.LE.N-1) THEN
      GA(KA-1)=0.0D 0
      GA(KA)=0.0D 0
      GA(KA+1)=0.0D 0
      GA(N-4)=3.0D 0
      GA(N-3)=-1.0D 0
      GA(N-2)=-1.0D 0
      GA(N-1)=0.50D 0
      GA(N)=-1.0D 0
      GA(KA-1)=GA(KA-1)-1.0D 0
      GA(KA)=GA(KA)-4.0D 0*X(KA)+3.0D 0
      GA(KA+1)=GA(KA+1)-2.0D 0
      ELSE
      GA(N-4)=3.0D 0
      GA(N-3)=-1.0D 0
      GA(N-2)=-1.0D 0
      GA(N-1)=0.50D 0
      GA(N)=-4.0D 0*X(N)+2.0D 0
      ENDIF
      RETURN
  200 U=1.0D 0/DBLE(N+1)
      V=DBLE(KA)*U
      GA(KA)=2.0D 0+1.5D 0*U**2*(X(KA)+V+1.0D 0)**2
      IF(KA.GT.1) GA(KA-1)=-1.0D 0
      IF(KA.LT.N) GA(KA+1)=-1.0D 0
      RETURN
  210 I=3*((KA+6)/7)-2
      IF (MOD(KA,7).EQ.1) THEN
      GA(I)=2.0D 1*X(I)
      GA(I+1)=-1.0D 1
      ELSEIF (MOD(KA,7).EQ.2) THEN
      GA(I+1)=1.0D 0
      GA(I+2)=1.0D 0
      ELSEIF (MOD(KA,7).EQ.3) THEN
      GA(I+3)=1.0D 0
      ELSEIF (MOD(KA,7).EQ.4) THEN
      GA(I+4)=1.0D 0
      ELSEIF (MOD(KA,7).EQ.5) THEN
      GA(I)=1.0D 0
      GA(I+1)=3.0D 0
      ELSEIF (MOD(KA,7).EQ.6) THEN
      GA(I+2)=1.0D 0
      GA(I+3)=1.0D 0
      GA(I+4)=-2.0D 0
      ELSE
      GA(I+1)=2.0D 1*X(I+1)
      GA(I+4)=-1.0D 1
      ENDIF
      RETURN
  220 I=KA/2
      IF (KA.EQ.1) THEN
      GA(KA)=1.0D 0
      ELSE IF (MOD(KA,2).EQ.0) THEN
      GA(I)=2.0D 1*X(I)
      GA(I+1)=-1.0D 1
      ELSE
      A=2.0D 0*EXP(-(X(I)-X(I+1))**2)
      B=EXP(-2.0D 0*(X(I+1)-X(I+2))**2)
      GA(I)= -2.0D 0*(X(I)-X(I+1))*A
      GA(I+1)=2.0D 0*(X(I)-X(I+1))*A-4.0D 0*(X(I+1)-X(I+2))*B
      GA(I+2)=4.0D 0*(X(I+1)-X(I+2))*B
      ENDIF
      RETURN
  260 I=MOD(KA,N/2)+1
      J=I+N/2
      M=5*N
      IA=KA/(M/4)+1
      A=DBLE(IA)
      B=DBLE(KA/(M/5)+1)
      GA(I)=A*X(I)**(IA-1)*EXP(B*X(J))
      GA(J)=B*X(I)**IA*EXP(B*X(J))+1.0D 0
      RETURN
  270 IA=MIN(MAX(MOD(KA,13)-2,1),7)
      IB=(KA+12)/13
      I=IA+IB-1
      IF (IA.EQ.7) THEN
      J=IB
      ELSE
      J=IA+IB
      ENDIF
      C=3.0D 0*DBLE(IA)/1.0D 1
      A=COS(C)
      B=EXP(SIN(C*X(J)))
      GA(I)=-COS(X(I))*(1.0D 0+A)+5.0D 0*B
      GA(J)=(1.0D 0+A)+5.0D 0*(X(I)-2.0D 0)*C*COS(C*X(J))*B
      DO 271 L=0,6
      IF (IB+L.NE.I.AND.IB+L.NE.J) GA(IB+L)=0.5D 0*COS(X(IB+L))
  271 CONTINUE
      RETURN
      END
