* SUBROUTINE EAHB14             ALL SYSTEMS                04/10/01
C PORTABILITY : ALL SYSTEMS
C 04/10/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  HESSIAN MATRICES OF TEST FUNCTIONS FOR NONLINEAR APPROXIMATION.
*  SPARSE VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  II  MHA  DECLARED NUMBER OF NONZERO ELEMENTS IN THE HESSIAN MATRIX.
*  RO  HA(MHA) HESSIAN MATRIX OF THE APPROXIMATED FUNCTION
*          AT THE SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAHB14(N,MHA,KA,X,HA,NEXT)
      INTEGER N,MHA,KA,NEXT
      INTEGER I,II,J,K,L,WL,WR,WD
      REAL*8 X(N),HA(MHA)
      REAL*8 A,B,C,D,P,S,Q,U,Z,R
      GO TO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     &  170,180,190,200,210,220),NEXT
   10 A=X(KA)**2-X(KA+1)
      HA(1)=8.0D 2*X(KA)**2+4.0D 2*A+2.0D 0
      HA(2)=-4.0D 2*X(KA)
      HA(3)=2.0D 2
      RETURN
   20 I=2*KA-1
      A=X(I)**2-X(I+1)
      C=X(I+2)**2-X(I+3)
      HA(1)=8.0D 2*X(I)**2+4.0D 2*A+2.0D 0
      HA(2)=-4.0D 2*X(I)
      HA(3)=2.202D 2
      HA(4)=0.0D 0
      HA(5)=0.0D 0
      HA(6)=7.2D 2*X(I+2)**2+3.6D 2*C+2.0D 0
      HA(7)=0.0D 0
      HA(8)=1.98D 1
      HA(9)=-3.6D 2*X(I+2)
      HA(10)=2.002D 2
      RETURN
   30 I=2*KA-1
      A=X(I)+1.0D 1*X(I+1)
      B=X(I+2)-X(I+3)
      C=X(I+1)-2.0D 0*X(I+2)
      D=X(I)-X(I+3)
      HA(1)=1.2D 2*D**2+2.0D 0
      HA(2)=2.0D 1
      HA(3)=1.2D 1*C**2+2.0D 2
      HA(4)=0.0D 0
      HA(5)=-2.4D 1*C**2
      HA(6)=4.8D 1*C**2+1.0D 1
      HA(7)=-1.2D 2*D**2
      HA(8)=0.0D 0
      HA(9)=-1.0D 1
      HA(10)=1.2D 2*D**2+1.0D 1
      RETURN
   40 I=2*KA-1
      A=EXP(X(I))
      B=A-X(I+1)
      D=X(I+1)-X(I+2)
      D=3.0D 3*D**4
      P=X(I+2)-X(I+3)
      U=X(I)
      C=COS(P)
      S=SIN(P)
      Q=(1.2D 1*S**2*C**2+2.0D 1*S**4)/C**6
      HA(1)=1.2D 1*A**2*B**2+4.0D 0*A*B**3+5.6D 1*U**6
      HA(2)=-1.2D 1*A*B**2
      HA(3)=1.2D 1*B**2+D
      HA(4)=0.0D 0
      HA(5)=-D
      HA(6)=D+Q
      HA(7)=0.0D 0
      HA(8)=0.0D 0
      HA(9)=-Q
      HA(10)=Q+2.0D 0
      RETURN
   50 A=(3.0D 0-2.0D 0*X(KA))*X(KA)+1.0D 0
      D=3.0D 0-4.0D 0*X(KA)
      IF (KA.GT.1) A=A-X(KA-1)
      IF (KA.LT.N) A=A-X(KA+1)
      B=(2.8D 1/9.0D 0)*ABS(A)**(1.0D 0/3.0D 0)
      C=(2.8D 1/3.0D 0)*SIGN(1.0D 0,A)*ABS(A)**(4.0D 0/3.0D 0)
      IF (KA.EQ.1) THEN
        HA(1)=B*D**2-C
        HA(2)=-B*D
        HA(3)=B
      ELSEIF (KA.EQ.N) THEN
        HA(1)=B
        HA(2)=-B*D
        HA(3)=B*D**2-C
      ELSE
        HA(1)=B
        HA(2)=-B*D
        HA(3)=B*D**2-C
        HA(4)=B
        HA(5)=-B*D
        HA(6)=B
      ENDIF
      RETURN
   60 A=(2.0D 0+5.0D 0*X(KA)**2)*X(KA)+1.0D 0
      DO 61 I=MAX(1,KA-5),MIN(N,KA+1)
        A=A+X(I)*(1.0D 0+X(I))
   61 CONTINUE
      B=(2.8D 1/9.0D 0)*ABS(A)**(1.0D 0/3.0D 0)
      P=3.0D 0+2.0D 0*X(KA)+1.5D 1*X(KA)**2
      C=B*P
      D=(1.4D 1/3.0D 0)*ABS(A)**(4.0D 0/3.0D 0)*SIGN(1.0D 0,A)
      S=C*P+D*(1.0D 0+1.5D 1*X(KA))
      IF (KA.EQ.1) THEN
        HA(1)=S
        IF (KA.LT.N) THEN
          HA(2)=C*(1.0D 0+2.0D 0*X(KA+1))
          HA(3)=B*(1.0D 0+2.0D 0*X(KA+1))**2+D
        ENDIF
      ELSEIF (KA.EQ.2) THEN
        HA(1)=B*(1.0D 0+2.0D 0*X(KA-1))**2+D
        HA(2)=C*(1.0D 0+2.0D 0*X(KA-1))
        HA(3)=S
        IF (KA.LT.N) THEN
          HA(4)=B*(1.0D 0+2.0D 0*X(KA-1))*(1.0D 0+2.0D 0*X(KA+1))
          HA(5)=C*(1.0D 0+2.0D 0*X(KA+1))
          HA(6)=B*(1.0D 0+2.0D 0*X(KA+1))**2+D
        ENDIF
      ELSEIF (KA.EQ.3) THEN
        HA(1)=B*(1.0D 0+2.0D 0*X(KA-2))**2+D
        HA(2)=B*(1.0D 0+2.0D 0*X(KA-2))*(1.0D 0+2.0D 0*X(KA-1))
        HA(3)=B*(1.0D 0+2.0D 0*X(KA-1))**2+D
        HA(4)=C*(1.0D 0+2.0D 0*X(KA-2))
        HA(5)=C*(1.0D 0+2.0D 0*X(KA-1))
        HA(6)=S
        IF (KA.LT.N) THEN
          HA(7)=B*(1.0D 0+2.0D 0*X(KA+1))*(1.0D 0+2.0D 0*X(KA-2))
          HA(8)=B*(1.0D 0+2.0D 0*X(KA+1))*(1.0D 0+2.0D 0*X(KA-1))
          HA(9)=C*(1.0D 0+2.0D 0*X(KA+1))
          HA(10)=B*(1.0D 0+2.0D 0*X(KA+1))**2+D
        ENDIF
      ELSEIF (KA.EQ.4) THEN
        HA(1)=B*(1.0D 0+2.0D 0*X(KA-3))**2+D
        HA(2)=B*(1.0D 0+2.0D 0*X(KA-3))*(1.0D 0+2.0D 0*X(KA-2))
        HA(3)=B*(1.0D 0+2.0D 0*X(KA-2))**2+D
        HA(4)=B*(1.0D 0+2.0D 0*X(KA-3))*(1.0D 0+2.0D 0*X(KA-1))
        HA(5)=B*(1.0D 0+2.0D 0*X(KA-2))*(1.0D 0+2.0D 0*X(KA-1))
        HA(6)=B*(1.0D 0+2.0D 0*X(KA-1))**2+D
        HA(7)=C*(1.0D 0+2.0D 0*X(KA-3))
        HA(8)=C*(1.0D 0+2.0D 0*X(KA-2))
        HA(9)=C*(1.0D 0+2.0D 0*X(KA-1))
        HA(10)=S
        IF (KA.LT.N) THEN
          HA(11)=B*(1.0D 0+2.0D 0*X(KA-3))*(1.0D 0+2.0D 0*X(KA+1))
          HA(12)=B*(1.0D 0+2.0D 0*X(KA-2))*(1.0D 0+2.0D 0*X(KA+1))
          HA(13)=B*(1.0D 0+2.0D 0*X(KA-1))*(1.0D 0+2.0D 0*X(KA+1))
          HA(14)=C*(1.0D 0+2.0D 0*X(KA+1))
          HA(15)=B*(1.0D 0+2.0D 0*X(KA+1))**2+D
        ENDIF
      ELSEIF (KA.EQ.5) THEN
        HA(1)=B*(1.0D 0+2.0D 0*X(KA-4))**2+D
        HA(2)=B*(1.0D 0+2.0D 0*X(KA-4))*(1.0D 0+2.0D 0*X(KA-3))
        HA(3)=B*(1.0D 0+2.0D 0*X(KA-3))**2+D
        HA(4)=B*(1.0D 0+2.0D 0*X(KA-4))*(1.0D 0+2.0D 0*X(KA-2))
        HA(5)=B*(1.0D 0+2.0D 0*X(KA-3))*(1.0D 0+2.0D 0*X(KA-2))
        HA(6)=B*(1.0D 0+2.0D 0*X(KA-2))**2+D
        HA(7)=B*(1.0D 0+2.0D 0*X(KA-4))*(1.0D 0+2.0D 0*X(KA-1))
        HA(8)=B*(1.0D 0+2.0D 0*X(KA-3))*(1.0D 0+2.0D 0*X(KA-1))
        HA(9)=B*(1.0D 0+2.0D 0*X(KA-2))*(1.0D 0+2.0D 0*X(KA-1))
        HA(10)=B*(1.0D 0+2.0D 0*X(KA-1))**2+D
        HA(11)=C*(1.0D 0+2.0D 0*X(KA-4))
        HA(12)=C*(1.0D 0+2.0D 0*X(KA-3))
        HA(13)=C*(1.0D 0+2.0D 0*X(KA-2))
        HA(14)=C*(1.0D 0+2.0D 0*X(KA-1))
        HA(15)=S
        IF (KA.LT.N) THEN
          HA(16)=B*(1.0D 0+2.0D 0*X(KA-4))*(1.0D 0+2.0D 0*X(KA+1))
          HA(17)=B*(1.0D 0+2.0D 0*X(KA-3))*(1.0D 0+2.0D 0*X(KA+1))
          HA(18)=B*(1.0D 0+2.0D 0*X(KA-2))*(1.0D 0+2.0D 0*X(KA+1))
          HA(19)=B*(1.0D 0+2.0D 0*X(KA-1))*(1.0D 0+2.0D 0*X(KA+1))
          HA(20)=C*(1.0D 0+2.0D 0*X(KA+1))
          HA(21)=B*(1.0D 0+2.0D 0*X(KA+1))**2+D
        ENDIF
      ELSE
        HA(1)=B*(1.0D 0+2.0D 0*X(KA-5))**2+D
        HA(2)=B*(1.0D 0+2.0D 0*X(KA-5))*(1.0D 0+2.0D 0*X(KA-4))
        HA(3)=B*(1.0D 0+2.0D 0*X(KA-4))**2+D
        HA(4)=B*(1.0D 0+2.0D 0*X(KA-5))*(1.0D 0+2.0D 0*X(KA-3))
        HA(5)=B*(1.0D 0+2.0D 0*X(KA-4))*(1.0D 0+2.0D 0*X(KA-3))
        HA(6)=B*(1.0D 0+2.0D 0*X(KA-3))**2+D
        HA(7)=B*(1.0D 0+2.0D 0*X(KA-5))*(1.0D 0+2.0D 0*X(KA-2))
        HA(8)=B*(1.0D 0+2.0D 0*X(KA-4))*(1.0D 0+2.0D 0*X(KA-2))
        HA(9)=B*(1.0D 0+2.0D 0*X(KA-3))*(1.0D 0+2.0D 0*X(KA-2))
        HA(10)=B*(1.0D 0+2.0D 0*X(KA-2))**2+D
        HA(11)=B*(1.0D 0+2.0D 0*X(KA-5))*(1.0D 0+2.0D 0*X(KA-1))
        HA(12)=B*(1.0D 0+2.0D 0*X(KA-4))*(1.0D 0+2.0D 0*X(KA-1))
        HA(13)=B*(1.0D 0+2.0D 0*X(KA-3))*(1.0D 0+2.0D 0*X(KA-1))
        HA(14)=B*(1.0D 0+2.0D 0*X(KA-2))*(1.0D 0+2.0D 0*X(KA-1))
        HA(15)=B*(1.0D 0+2.0D 0*X(KA-1))**2+D
        HA(16)=C*(1.0D 0+2.0D 0*X(KA-5))
        HA(17)=C*(1.0D 0+2.0D 0*X(KA-4))
        HA(18)=C*(1.0D 0+2.0D 0*X(KA-3))
        HA(19)=C*(1.0D 0+2.0D 0*X(KA-2))
        HA(20)=C*(1.0D 0+2.0D 0*X(KA-1))
        HA(21)=S
        IF (KA.LT.N) THEN
          HA(22)=B*(1.0D 0+2.0D 0*X(KA-5))*(1.0D 0+2.0D 0*X(KA+1))
          HA(23)=B*(1.0D 0+2.0D 0*X(KA-4))*(1.0D 0+2.0D 0*X(KA+1))
          HA(24)=B*(1.0D 0+2.0D 0*X(KA-3))*(1.0D 0+2.0D 0*X(KA+1))
          HA(25)=B*(1.0D 0+2.0D 0*X(KA-2))*(1.0D 0+2.0D 0*X(KA+1))
          HA(26)=B*(1.0D 0+2.0D 0*X(KA-1))*(1.0D 0+2.0D 0*X(KA+1))
          HA(27)=C*(1.0D 0+2.0D 0*X(KA+1))
          HA(28)=B*(1.0D 0+2.0D 0*X(KA+1))**2+D
        ENDIF
      ENDIF
      RETURN
   70 IF (KA.LE.N) THEN
        A=(3.0D 0-2.0D 0*X(KA))*X(KA)+1.0D 0
        D=3.0D 0-4.0D 0*X(KA)
        IF (KA.GT.1) A=A-X(KA-1)
        IF (KA.LT.N) A=A-X(KA+1)
        B=(2.8D 1/9.0D 0)*ABS(A)**(1.0D 0/3.0D 0)
        C=(2.8D 1/3.0D 0)*SIGN(1.0D 0,A)*ABS(A)**(4.0D 0/3.0D 0)
        IF (KA.EQ.1) THEN
          HA(1)=B*D**2-C
          HA(2)=-B*D
          HA(3)=B
        ELSEIF (KA.EQ.N) THEN
          HA(1)=B
          HA(2)=-B*D
          HA(3)=B*D**2-C
        ELSE
          HA(1)=B
          HA(2)=-B*D
          HA(3)=B*D**2-C
          HA(4)=B
          HA(5)=-B*D
          HA(6)=B
        ENDIF
      ELSE
        I=KA-N
        A=X(I)+X(I+N/2)
        B=(2.8D 1/9.0D 0)*ABS(A)**(1.0D 0/3.0D 0)
        HA(1)=B
        HA(2)=B
        HA(3)=B
      ENDIF
      RETURN
   80 K=N/2
      P=0.0D 0
      DO 81 I=KA-2,KA+2
        IF (I.LT.1.OR.I.GT.N) GO TO 81
        A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
        B=DBLE(I+KA)/1.0D 1
        P=P+A*SIN(X(I))+B*COS(X(I))
   81 CONTINUE
      IF (KA.GT.K) I=KA-K
      IF (KA.LE.K) I=KA+K
      A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
      B=DBLE(I+KA)/1.0D 1
      P=P+A*SIN(X(I))+B*COS(X(I))
      P=DBLE(N+KA)-P
      D=2.0D 0/DBLE(N)
      WD=1
      IF (KA.LE.K) THEN
        DO 82 I=KA-2,KA+2
          IF (I.LT.1) GO TO 82
          DO 83 J=KA-2,I
            IF (J.LT.1) GO TO 83
            IF (J.EQ.I) THEN
              A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
              B=DBLE(I+KA)/1.0D 1
              C=COS(X(I))
              S=SIN(X(I))
              HA(WD)=D*((A*C-B*S)**2+P*(A*S+B*C))
            ELSE
              A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
              B=DBLE(I+KA)/1.0D 1
              Q=A*COS(X(I))-B*SIN(X(I))
              A=5.0D 0*(1.0D 0+MOD(J,5)+MOD(KA,5))
              B=DBLE(J+KA)/1.0D 1
              Q=Q*(A*COS(X(J))-B*SIN(X(J)))
              HA(WD)=D*Q
            ENDIF
            WD=WD+1
   83     CONTINUE
   82   CONTINUE
        I=KA+K
        DO 84 J=KA-2,KA+2
          IF (J.LT.1) GO TO 84
          A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
          B=DBLE(I+KA)/1.0D 1
          Q=A*COS(X(I))-B*SIN(X(I))
          A=5.0D 0*(1.0D 0+MOD(J,5)+MOD(KA,5))
          B=DBLE(J+KA)/1.0D 1
          Q=Q*(A*COS(X(J))-B*SIN(X(J)))
          HA(WD)=D*Q
          WD=WD+1
   84   CONTINUE
        A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
        B=DBLE(I+KA)/1.0D 1
        C=COS(X(I))
        S=SIN(X(I))
        HA(WD)=D*((A*C-B*S)**2+P*(A*S+B*C))
      ELSE
        II=KA-K
        A=5.0D 0*(1.0D 0+MOD(II,5)+MOD(KA,5))
        B=DBLE(II+KA)/1.0D 1
        C=COS(X(II))
        S=SIN(X(II))
        HA(WD)=D*((A*C-B*S)**2+P*(A*S+B*C))
        WD=WD+1
        DO 85 I=KA-2,KA+2
          IF (I.GT.N) GO TO 85
          A=5.0D 0*(1.0D 0+MOD(II,5)+MOD(KA,5))
          B=DBLE(II+KA)/1.0D 1
          Q=A*COS(X(II))-B*SIN(X(II))
          A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
          B=DBLE(I+KA)/1.0D 1
          Q=Q*(A*COS(X(I))-B*SIN(X(I)))
          HA(WD)=D*Q
          WD=WD+1
          DO 86 J=KA-2,I
            IF (J.EQ.I) THEN
              A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
              B=DBLE(I+KA)/1.0D 1
              C=COS(X(I))
              S=SIN(X(I))
              HA(WD)=D*((A*C-B*S)**2+P*(A*S+B*C))
            ELSE
              A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
              B=DBLE(I+KA)/1.0D 1
              Q=A*COS(X(I))-B*SIN(X(I))
              A=5.0D 0*(1.0D 0+MOD(J,5)+MOD(KA,5))
              B=DBLE(J+KA)/1.0D 1
              Q=Q*(A*COS(X(J))-B*SIN(X(J)))
              HA(WD)=D*Q
            ENDIF
            WD=WD+1
   86     CONTINUE
   85   CONTINUE
      ENDIF
      RETURN
   90 J=MIN(N,KA+2)-MAX(1,KA-2)+2
      WD=ABS(J*(J+1)/2.0D 0)
      DO 91 I=1,WD
        HA(I)=0.0D 0
   91 CONTINUE
      K=N/2
      P=1.0D 0/DBLE(N)
      J=1
      IF (KA.LE.K) THEN
        DO 92 I=KA-2,KA+2
          IF (I.LT.1) GO TO 92
          A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
          B=DBLE(I+KA)/1.0D 1
          WD=ABS(J*(J+1)/2.0D 0)
          HA(WD)=-P*(A*SIN(X(I))+B*COS(X(I)))
          IF (I.EQ.KA) HA(WD)=HA(WD)+P*DBLE(KA)*COS(X(KA))
          J=J+1
   92   CONTINUE
        I=KA+K
        A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
        B=DBLE(I+KA)/1.0D 1
        WD=ABS(J*(J+1)/2.0D 0)
        HA(WD)=-P*(A*SIN(X(I))+B*COS(X(I)))
      ELSE
        I=KA-K
        A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
        B=DBLE(I+KA)/1.0D 1
        WD=ABS(J*(J+1)/2.0D 0)
        HA(WD)=-P*(A*SIN(X(I))+B*COS(X(I)))
        J=J+1
        DO 93 I=KA-2,KA+2
          IF (I.GT.N) GO TO 93
          A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
          B=DBLE(I+KA)/1.0D 1
          WD=ABS(J*(J+1)/2.0D 0)
          HA(WD)=-P*(A*SIN(X(I))+B*COS(X(I)))
          IF (I.EQ.KA) HA(WD)=HA(WD)+P*DBLE(KA)*COS(X(KA))
          J=J+1
   93   CONTINUE
      ENDIF
      RETURN
  100 J=MIN(N,KA+2)-MAX(1,KA-2)+2
      WD=ABS(J*(J+1)/2.0D 0)
      DO 101 I=1,WD
        HA(I)=0.0D 0
  101 CONTINUE
      K=N/2
      J=1
      Q=1.0D 0+DBLE(KA)/1.0D 1
      Z=0.0D 0
      WL=0
      IF (KA.LE.K) THEN
        DO 102 I=KA-2,KA+2
          IF (I.LT.1) GO TO 102
          WR=ABS(J*(J+1)/2.0D 0)
          A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
          B=1.0D 0+DBLE(I)/1.0D 1
          C=DBLE(I+KA)/1.0D 1
          P=-A*SIN(Q*X(KA)+B*X(I)+C)/DBLE(N)
          Z=Z+P*Q**2
          IF (I.LT.KA) THEN
            HA(WR)=P*B**2
          ELSEIF (I.EQ.KA) THEN
            II=WR
            Z=Z+3.0D 0*P*B**2
            DO 103 L=1,WR-WL-1
              A=5.0D 0*(1.0D 0+MOD(I-L,5)+MOD(KA,5))
              B=1.0D 0+DBLE(I-L)/1.0D 1
              C=DBLE(I-L+KA)/1.0D 1
              P=-A*SIN(Q*X(KA)+B*X(I-L)+C)/DBLE(N)
              HA(WR-L)=P*B*Q
  103       CONTINUE
          ELSE
            HA(WR)=P*B**2
            A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
            B=1.0D 0+DBLE(I)/1.0D 1
            C=DBLE(I+KA)/1.0D 1
            P=-A*SIN(Q*X(KA)+B*X(I)+C)/DBLE(N)
            HA(WR-I+KA)=P*B*Q
          ENDIF
          WL=WR
          J=J+1
  102   CONTINUE
        I=KA+K
        A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
        B=1.0D 0+DBLE(I)/1.0D 1
        C=DBLE(I+KA)/1.0D 1
        P=-A*SIN(Q*X(KA)+B*X(I)+C)/DBLE(N)
        Z=Z+P*Q**2
        HA(WD)=P*B**2
        HA(WD-3)=P*B*Q
        HA(II)=Z
      ELSE
        I=KA-K
        A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
        B=1.0D 0+DBLE(I)/1.0D 1
        C=DBLE(I+KA)/1.0D 1
        P=-A*SIN(Q*X(KA)+B*X(I)+C)/DBLE(N)
        Z=Z+P*Q**2
        HA(1)=P*B**2
        HA(7)=P*B*Q
        DO 104 I=KA-2,KA+2
         IF (I.GT.N) GO TO 104
         J=J+1
         WR=ABS(J*(J+1)/2.0D 0)
          A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
          B=1.0D 0+DBLE(I)/1.0D 1
          C=DBLE(I+KA)/1.0D 1
          P=-A*SIN(Q*X(KA)+B*X(I)+C)/DBLE(N)
          Z=Z+P*Q**2
          IF (I.LT.KA) THEN
            HA(WR)=P*B**2
          ELSEIF (I.EQ.KA) THEN
            Z=Z+3.0D 0*P*B**2
            DO 105 L=1,2
              A=5.0D 0*(1.0D 0+MOD(I-L,5)+MOD(KA,5))
              B=1.0D 0+DBLE(I-L)/1.0D 1
              C=DBLE(I-L+KA)/1.0D 1
              P=-A*SIN(Q*X(KA)+B*X(I-L)+C)/DBLE(N)
              HA(10-L)=P*B*Q
  105       CONTINUE
          ELSE
            HA(WR)=P*B**2
            A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
            B=1.0D 0+DBLE(I)/1.0D 1
            C=DBLE(I+KA)/1.0D 1
            P=-A*SIN(Q*X(KA)+B*X(I)+C)/DBLE(N)
            HA(WR-I+KA)=P*B*Q
          ENDIF
  104   CONTINUE
       HA(10)=Z
      ENDIF
      RETURN
  110 P=-0.2008D-2
      Q=-0.1900D-2
      R=-0.0261D-2
      I=5*(KA-1)
      A=1.0D 0
      B=0.0D 0
      DO 111 J=1,5
        A=A*X(I+J)
        B=B+X(I+J)**2
  111 CONTINUE
      S=A**2*EXP(A)
      U=(1.0D 0+A)*EXP(A)
      B=B-1.0D 1-P
      C=X(I+2)*X(I+3)-5.0D 0*X(I+4)*X(I+5)-Q
      D=X(I+1)**3+X(I+2)**3+1.0D 0-R
      HA(1)=S/X(I+1)**2+2.0D 1*(2.0D 0*B+4.0D 0*X(I+1)**2
     &     +6.0D 0*D*X(I+1)+9.0D 0*X(I+1)**4)
      HA(2)=U*X(I+3)*X(I+4)*X(I+5)+2.0D 1*(4.0D 0*X(I+1)*X(I+2)
     &     +9.0D 0*(X(I+1)*X(I+2))**2)
      HA(3)=S/X(I+2)**2+2.0D 1*(2.0D 0*B+4.0D 0*X(I+2)**2
     &     +X(I+3)**2+6.0D 0*D*X(I+2)+9.0D 0*X(I+2)**4)
      HA(4)=U*X(I+2)*X(I+4)*X(I+5)+8.0D 1*X(I+1)*X(I+3)
      HA(5)=U*X(I+1)*X(I+4)*X(I+5)+2.0D 1*(C+5.0D 0*X(I+2)*X(I+3))
      HA(6)=S/X(I+3)**2+2.0D 1*(2.0D 0*B+X(I+2)**2+4.0D 0*X(I+3)**2)
      HA(7)=U*X(I+2)*X(I+3)*X(I+5)+8.0D 1*X(I+1)*X(I+4)
      HA(8)=U*X(I+1)*X(I+3)*X(I+5)+2.0D 1*(4.0D 0*X(I+2)*X(I+4)
     &     -5.0D 0*X(I+3)*X(I+5))
      HA(9)=U*X(I+1)*X(I+2)*X(I+5)+2.0D 1*(4.0D 0*X(I+3)*X(I+4)
     &     -5.0D 0*X(I+2)*X(I+5))
      HA(10)=S/X(I+4)**2+2.0D 1*(2.0D 0*B+4.0D 0*X(I+4)**2
     &      +2.5D 1*X(I+5)**2)
      HA(11)=U*X(I+2)*X(I+3)*X(I+4)+8.0D 1*X(I+1)*X(I+5)
      HA(12)=U*X(I+1)*X(I+3)*X(I+4)+2.0D 1*(4.0D 0*X(I+2)*X(I+5)
     &      -5.0D 0*X(I+3)*X(I+4))
      HA(13)=U*X(I+1)*X(I+2)*X(I+4)+2.0D 1*(4.0D 0*X(I+3)*X(I+5)
     &      -5.0D 0*X(I+2)*X(I+4))
      HA(14)=U*X(I+1)*X(I+2)*X(I+3)+2.0D 1*(2.9D 1*X(I+4)*X(I+5)
     &      -5.0D 0*C)
      HA(15)=S/X(I+5)**2+2.0D 1*(2.0D 0*B+2.5D 1*X(I+4)**2
     &      +4.0D 0*X(I+5)**2)
      RETURN
  120 C=4.0D 2*EXP(2.0D 1*(X(KA)-X(KA+1)))
      HA(1)=C+4.0D 0
      HA(2)=-C-2.0D 0
      HA(3)=C+2.0D 0
      RETURN
  130 A=X(KA+1)**2
      B=X(KA)**2
      C=A+1.0D 0
      D=B+1.0D 0
      S=A-1.0D 0
      U=B-1.0D 0
      P=0.0D 0
      IF (A.GT.P) P=LOG(A)
      Q=0.0D 0
      IF (B.GT.Q) Q=LOG(B)
      HA(1)=2.0D 0*(C*B**A+P*A**D)+4.0D 0*B*(A*C*B**S+P**2*A**D)
      HA(2)=4.0D 0*X(KA)*X(KA+1)*(B**A+Q*C*B**A+P*D*A**B+A**B)
      HA(3)=2.0D 0*(D*A**B+Q*B**C)+4.0D 0*A*(D*B*A**U+Q**2*B**C)
      RETURN
  140 P=1.0D 0/DBLE(N+1)
      Q=0.5D 0*P**2
      U=X(KA)+DBLE(KA)*P+1.0D 0
      A=2.0D 0*X(KA)+Q*U**3
      IF(KA.GT.1) A=A-X(KA-1)
      IF(KA.LT.N) A=A-X(KA+1)
      B=2.0D 0+3.0D 0*Q*U**2
      C=1.2D 1*Q*U
      IF (KA.EQ.1) THEN
        HA(1)=A*C+2.0D 0*B**2
        HA(2)=-2.0D 0*B
        HA(3)=2.0D 0
      ELSE
        HA(1)=2.0D 0
        HA(2)=-2.0D 0*B
        HA(3)=A*C+2.0D 0*B**2
        IF (KA.LT.N) THEN
          HA(4)=2.0D 0
          HA(5)=-2.0D 0*B
          HA(6)=2.0D 0
        ENDIF
      ENDIF
      RETURN
  150 P=1.0D 0/DBLE(N+1)
      Q=2.0D 0/P
      R=2.0D 0*P
      A=X(KA)-X(KA+1)
      C=EXP(X(KA))
      D=EXP(X(KA+1))
      HA(1)=2.0D 0*Q
      HA(2)=-Q
      IF (ABS(A).LE.1.0D-6) THEN
        HA(1)=HA(1)+R*D*(1.0D 0/3.0D 0+A/4.0D 0)
        HA(2)=HA(2)+R*D*(1.0D 0/6.0D 0+A/1.2D 1)
        HA(3)=R*D*(1.0D 0/3.0D 0+A/1.2D 1)
      ELSE
        B=C-D
        HA(1)=HA(1)+R*(C*A*(A-2.0D 0)+2.0D 0*B)/A**3
        HA(2)=HA(2)-R*(B*(A+2.0D 0)-2.0D 0*C*A)/A**3
        HA(3)=-R*(D*A*(A+2.0D 0)-2.0D 0*B)/A**3
      ENDIF
      IF (KA.EQ.1) HA(1)=HA(1)
     &  +R*(C*(X(1)**2-2.0D 0*X(1)+2.0D 0)-2.0D 0)/X(1)**3
      IF (KA.EQ.N-1) HA(3)=HA(3)+2.0D 0*Q
     &  +R*(D*(X(N)**2-2.0D 0*X(N)+2.0D 0)-2.0D 0)/X(N)**3
      RETURN
  160 DO 161 I=1,6
        HA(I)=0.0D 0
  161 CONTINUE
      IF (KA.EQ.1) THEN
        HA(1)=DBLE(KA)*COS(X(KA))
        HA(3)=DBLE(KA)*SIN(X(KA+1))
      ELSE
        HA(1)=-DBLE(KA)*SIN(X(KA-1))
        HA(3)=DBLE(KA)*COS(X(KA))
        IF (KA.LT.N) HA(6)=DBLE(KA)*SIN(X(KA+1))
      ENDIF
      RETURN
  170 P=1.0D 0/DBLE(N+1)
      Q=2.5D-1/P
      R=P*EXP(X(KA))
      IF (KA.EQ.1) THEN
        HA(1)=2.0D 0*Q+R
        HA(2)=0.0D 0
        HA(3)=Q
      ELSEIF (KA.EQ.N) THEN
        HA(1)=Q
        HA(2)=0.0D 0
        HA(3)=2.0D 0*Q+R
      ELSE
        HA(1)=Q
        HA(2)=0.0D 0
        HA(3)=R
        HA(4)=-Q
        HA(5)=0.0D 0
        HA(6)=Q
      ENDIF
      RETURN
  180 P=1.0D 0/DBLE(N+1)
      Q=2.0D 0*P
      R=1.0D 0/Q
      IF (KA.EQ.1) THEN
        HA(1)=1.0D 0/P-Q
        HA(2)=0.0D 0
        HA(3)=R
      ELSEIF (KA.EQ.N) THEN
        HA(1)=R
        HA(2)=0.0D 0
        HA(3)=1.0D 0/P-Q
      ELSE
        HA(1)=R
        HA(2)=0.0D 0
        HA(3)=-Q
        HA(4)=-R
        HA(5)=0.0D 0
        HA(6)=R
      ENDIF
      RETURN
  190 P=1.0D 0/DBLE(N+1)
      Q=2.0D 0*P
      R=1.0D 0/Q
      IF (KA.EQ.1) THEN
        HA(1)=1.0D 0/P+Q
        HA(2)=0.0D 0
        HA(3)=R
      ELSEIF (KA.EQ.N) THEN
        HA(1)=R
        HA(2)=0.0D 0
        HA(3)=1.0D 0/P+Q
      ELSE
        HA(1)=R
        HA(2)=0.0D 0
        HA(3)=Q
        HA(4)=-R
        HA(5)=0.0D 0
        HA(6)=R
      ENDIF
      RETURN
  200 P=1.0D 0/DBLE(N+1)
      Q=1.0D 0/P
      A=EXP(-2.0D 0*X(KA)**2)/P
      B=4.0D 0*X(KA)**2-1.0D 0
      C=4.0D 0*B*P**2
      IF (KA.EQ.1) THEN
        HA(1)=Q+A*(B*X(KA+1)**2-C)
        HA(2)=-2.0D 0*A*X(KA)*X(KA+1)
        HA(3)=5.0D-1*A
      ELSEIF (KA.EQ.N) THEN
        HA(1)=5.0D-1*A
        HA(2)=-2.0D 0*A*X(KA)*X(KA-1)
        HA(3)=Q*EXP(-2.0D 0)+A*(B*X(KA-1)**2-C)
      ELSE
        D=X(KA+1)-X(KA-1)
        HA(1)=5.0D-1*A
        HA(2)=2.0D 0*A*D*X(KA)
        HA(3)=A*(B*D**2-C)
        HA(4)=-5.0D-1*A
        HA(5)=-2.0D 0*A*D*X(KA)
        HA(6)=5.0D-1*A
      ENDIF
      RETURN
  210 P=1.0D 0/DBLE(N+1)
      Q=2.0D 0*P
      IF (KA.EQ.1) THEN
        A=0.5D 0*(X(KA+1)-1.0D 0)/P
        B=(X(KA)-1.0D 0)/P
        C=5.0D-1*1.0D 0/(Q*(1.0D 0+A**2))
        D=5.0D-1*1.0D 0/(P*(1.0D 0+B**2))
        HA(1)=Q+D
        HA(2)=0.0D 0
        HA(3)=C
      ELSEIF (KA.EQ.N) THEN
        A=0.5D 0*(2.0D 0-X(KA-1))/P
        B=(2.0D 0-X(KA))/P
        C=5.0D-1*1.0D 0/(Q*(1.0D 0+A**2))
        D=5.0D-1*1.0D 0/(P*(1.0D 0+B**2))
        HA(1)=C
        HA(2)=0.0D 0
        HA(3)=Q+D
      ELSE
        A=0.5D 0*(X(KA+1)-X(KA-1))/P
        C=5.0D-1*1.0D 0/(Q*(1.0D 0+A**2))
        HA(1)=C
        HA(2)=0.0D 0
        HA(3)=Q
        HA(4)=-C
        HA(5)=0.0D 0
        HA(6)=C
      ENDIF
      RETURN
  220 P=1.0D 0/DBLE(N+1)
      IF (KA.EQ.1) THEN
        A= 0.5D 0*X(KA+1)/P
        B= X(KA)/P
        HA(1)=2.0D 2*P+(6.0D 2*B**2+1.0D 0)/P
        HA(2)=-2.0D 2*A
        HA(3)=(3.0D 2*A**2-1.0D 2*X(KA)+5.0D-1)/P
      ELSE IF (KA.EQ.N) THEN
        A=-0.5D 0*X(KA-1)/P
        B=-X(KA)/P
        HA(1)=(3.0D 2*A**2-1.0D 2*X(KA)+5.0D-1)/P
        HA(2)=2.0D 2*A
        HA(3)=2.0D 2*P+(6.0D 2*B**2+1.0D 0)/P
      ELSE
        A=0.5D 0*(X(KA+1)-X(KA-1))/P
        B=2.0D 2*A
        C=(3.0D 2*A**2-1.0D 2*X(KA)+5.0D-1)/P
        HA(1)=C
        HA(2)=B
        HA(3)=2.0D 2*P
        HA(4)=-C
        HA(5)=-B
        HA(6)=C
      ENDIF
      RETURN
      END
