* SUBROUTINE EAHD06             ALL SYSTEMS                 95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF TEST FUNCTIONS FOR NONLINEAR APPROXIMATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  FA  VALUE OF THE APPROXIMATED FUNCTION AT THE
*          SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EAHD06(N,KA,X,HA,NEXT)
      INTEGER N,KA,NEXT
      REAL*8 X(N),HA(N*(N+1)/2)
      REAL*8 T,X1,X2,X3,X4,X5,X6,X7,X8
      COMPLEX*16 CA(4),CB(4),CC(6),DD(6),C1,C2,C3,CI,S1,S2,S3,S4
      REAL*8 GA(8),CT(3),ST(3),XA(3),XB(3),XC(3),BETA,FA
      INTEGER I,J,L
      REAL*8 Y(123),PI
      COMMON /EMPR06/ Y
      PARAMETER (PI=3.14159265358979323846D 0)
      GOTO(10,190,180,80,20,170,120,90,230,210,140,150,200,30,130,100,
     & 40,110,50,60,70,220,160,240,250),NEXT
   10 HA(1)=2.0D 0
      HA(2)=0.0D 0
      HA(3)=2.0D 0
      IF(KA.EQ.1) HA(3)=12.0D 0*X(2)*X(2)
      IF(KA.EQ.3) THEN
      HA(1)=2.0D 0*EXP(X(2)-X(1))
      HA(2)=-HA(1)
      HA(3)= HA(1)
      ENDIF
      RETURN
  190 CONTINUE
      HA(2)=0.0D 0
      HA(3)=2.0D 0
      X1=1.0D 0/(X(1)+1.0D-1)**3
      IF (KA.EQ.3) THEN
      HA(1)= X1
      ELSE
      HA(1)=-X1
      ENDIF
      RETURN
  180 X1=X(1)**2+X(2)**2
      X2=SQRT(X1)
      X3=COS(X2)
      X4=SIN(X2)
      IF (KA.EQ.1) THEN
      X5=X(1)-X2*X3
      X6=-(X3/X2-X4)
      X7=X2+1.0D 0/X2
      X7=(X7*X3+X4)/X2**2
      X1=1.0D 0+X6*X(1)
      X2=X6*X(2)
      HA(1)=2.0D 0*(X1**2+X5*(X6+X7*X(1)**2))+1.0D-2
      HA(2)=2.0D 0*X(2)*(X6*X1+X5*X7*X(1))
      HA(3)=2.0D 0*(X2**2+X5*(X6+X7*X(2)**2))+1.0D-2
      ELSE IF (KA.EQ.2) THEN
      X5=X(2)-X2*X4
      X6=-(X4/X2+X3)
      X7=X2+1.0D 0/X2
      X7=(X7*X4-X3)/X2**2
      X1=X6*X(1)
      X2=1.0D 0+X6*X(2)
      HA(1)=2.0D 0*(X1**2+X5*(X6+X7*X(1)**2))+1.0D-2
      HA(2)=2.0D 0*X(1)*(X6*X2+X5*X7*X(2))
      HA(3)=2.0D 0*(X2**2+X5*(X6+X7*X(2)**2))+1.0D-2
      ENDIF
      RETURN
   80 DO 81 I=1,N*(N+1)/2
      HA(I)=0.0D 0
   81 CONTINUE
      GO TO (82,82,83,83,85,86),KA
   82 HA(1)= 2.0D 0
      HA(3)= 2.0D 0
      HA(6)= 2.0D 0
      RETURN
   83 RETURN
   85 HA(1)= 1.6D 0
      HA(3)= 1.2D 1
      HA(4)=-2.0D 1
      HA(6)= 1.0D 2
      RETURN
   86 HA(1)= 2.0D 0
      RETURN
   20 DO 21 I=1,N*(N+1)/2
      HA(I)=0.0D 0
   21 CONTINUE
      HA(1)=2.0D 0
      HA(3)=2.0D 0
      HA(6)=4.0D 0
      HA(10)=2.0D 0
      IF (KA.GT.1) THEN
      HA(1)=HA(1)+2.0D 1
      HA(3)=HA(3)+2.0D 1
      HA(6)=HA(6)+2.0D 1
      HA(10)=HA(10)+2.0D 1
      GO TO (24,22,23),KA-1
   22 HA(3)=HA(3)+2.0D 1
      HA(10)=HA(10)+2.0D 1
      GO TO 24
   23 HA(10)=HA(10)-2.0D 1
   24 CONTINUE
      ENDIF
      RETURN
  170 X1=X(1)-(X(4)+1.0D 0)**4
      X2=X1*X1
      X3=X(2)-X2*X2
      X4=X3*X3
      X5=-4.0D 0*(X(4)+1.0D 0)**3
      X6=-1.2D 1*(X(4)+1.0D 0)**2
      X7=X1*X6+X5*X5
      X8=X3-4.0D 0*X1*X1
      HA(1)=2.0D 0-8.0D 0*X8+2.0D 1
      HA(2)=-8.0D 0*X1
      HA(3)=2.0D 0
      HA(4)=0.0D 0
      HA(5)=0.0D 0
      HA(6)=4.0D 0
      HA(7)=2.0D 0*X5-8.0D 0*X5*X8+2.0D 1*X5
      HA(8)=-8.0D 0*X1*X5
      HA(9)=0.0D 0
      HA(10)=2.0D 0*X7-8.0D 0*(X5*X5*X8+X1*X3*X6)-
     & 5.0D 0*(X6-4.0D 0*X7)+2.0D 0
      GO TO (171,172,173,174),KA
  171 CONTINUE
      RETURN
  172 CONTINUE
      HA(1)=HA(1)+1.0D 1*(2.0D 0-8.0D 0*X8+4.0D 0)
      HA(2)=HA(2)-8.0D 1*X1
      HA(3)=HA(3)+2.0D 1
      HA(6)=HA(6)+2.0D 1
      HA(7)=HA(7)+1.0D 1*(2.0D 0*X5-8.0D 0*X5*X8+4.0D 0*X5)
      HA(8)=HA(8)-8.0D 1*X1*X5
      HA(10)=HA(10)+1.0D 1*(2.0D 0*X7-8.0D 0*(X5*X5*X8+X1*X3*X6)+
     & X6+4.0D 0*X7+2.0D 0)
      RETURN
  173 CONTINUE
      HA(1)=HA(1)+1.0D 1*(2.0D 0-1.6D 1*X8)
      HA(2)=HA(2)-1.6D 2*X1
      HA(3)=HA(3)+4.0D 1
      HA(6)=HA(6)+2.0D 1
      HA(7)=HA(7)+1.0D 1*(2.0D 0*X5-1.6D 1*X5*X8)
      HA(8)=HA(8)-1.6D 2*X1*X5
      HA(10)=HA(10)+1.0D 1*(2.0D 0*X7-1.6D 1*(X5*X5*X8+X1*X3*X6)-
     & X6+4.0D 0)
      RETURN
  174 CONTINUE
      HA(1)=HA(1)+1.0D 1*(2.0D 0-8.0D 0*X8+4.0D 0)
      HA(2)=HA(2)-8.0D 1*X1
      HA(3)=HA(3)+2.0D 1
      HA(6)=HA(6)+2.0D 1
      HA(7)=HA(7)+1.0D 1*(2.0D 0*X5-8.0D 0*X5*X8+4.0D 0*X5)
      HA(8)=HA(8)-8.0D 1*X1*X5
      HA(10)=HA(10)+1.0D 1*(2.0D 0*X7-8.0D 0*(X5*X5*X8+X1*X3*X6)+
     & 2.0D 0*X6+4.0D 0*X7)
      RETURN
  120 T=Y(KA)
      X1=EXP(-X(1)*T)/X(2)
      X2=SIN( X(2)*T)
      X3=COS( X(2)*T)
      X4=T*X3-X2/X(2)
      HA(1)= X(3)*X1*X2*T**2
      HA(2)=-X(3)*X1*X4*T
      HA(3)=-X(3)*X1*(T**2*X2+2.0D 0*T*X3/X(2)-2.0D 0*X2/X(2)**2)
      HA(4)=-X1*X2*T
      HA(5)= X1*X4*T
      HA(6)= 0.0D 0
      RETURN
   90 DO 91 I=1,N*(N+1)/2
      HA(I)=0.0D 0
   91 CONTINUE
      C1=DBLE(16-KA)
      C2=DBLE(MIN(KA,16-KA))
      C3=-2.0D 0*DBLE(KA)/(C1*X(2)+C2*X(3))**3
      HA(3)=C1*C1*C3
      HA(5)=C1*C2*C3
      HA(6)=C2*C2*C3
      RETURN
  230 T=Y(KA+11)
      X1= X(1)*T*(T+X(2))
      X2= ((T+X(3))*T+X(4))
      X3= 1.0D 0/X2**2
      X4= T*(T+X(2))*X3
      X5=-2.0D 0*X1*X3/X2
      HA(1)= 0.0D 0
      HA(2)=-T/X2
      HA(3)= 0.0D 0
      HA(7)= X4
      HA(4)= T*X4
      HA(8)= T*X(1)*X3
      HA(5)= T*HA(8)
      HA(10)=X5
      HA(9)= T*X5
      HA(6)= T*HA(9)
      RETURN
  210 T=0.2D 0*DBLE(KA)
      HA(1)= 2.0D 0
      HA(2)= 2.0D 0*T
      HA(3)= 2.0D 0*T*T
      HA(4)= 0.0D 0
      HA(5)= 0.0D 0
      HA(6)= 2.0D 0
      HA(7)= 0.0D 0
      HA(8)= 0.0D 0
      HA(9)= 2.0D 0*SIN(T)
      HA(10)=2.0D 0*SIN(T)**2
      RETURN
  140 T=Y(KA)
      DO 141 I=7,10
      HA(I)=0.0D 0
  141 CONTINUE
      HA(6)=-2.0D 0
      HA(5)= HA(6)*T
      HA(4)= HA(5)*T
      HA(3)= HA(4)
      HA(2)= HA(3)*T
      HA(1)= HA(2)*T
      RETURN
  150 T=Y(KA)
      DO 151 I=1,10
      HA(I)=0.0D 0
  151 CONTINUE
      X1=EXP(X(3)*T)
      X2=EXP(X(4)*T)
      HA(4)= X1*T
      HA(8)= X2*T
      HA(6)= X(1)*X1*T**2
      HA(10)=X(2)*X2*T**2
      RETURN
  200 T=Y(KA)
      X1=T+X(2)+1.0D 0/(X(3)*T+X(4))
      IF (X1.EQ.0D 0) X1=1D-30
      X2=X1/((T+1.0D 0)*Y(61+KA))
      X3=X(3)*T+X(4)
      IF (X3.EQ.0D 0) X3=1D-30
      HA(1)= 0.0D 0
      HA(2)= ABS(X2)**(T+5.0D-1)*(T+5.0D-1)/X1
      BETA=X(1)*HA(2)/X1
      HA(3)= BETA*(T-5.0D-1)
      HA(7)=-HA(2)/(X3*X3)
      HA(4)= HA(7)*T
      HA(8)=-HA(3)/(X3*X3)
      HA(5)= HA(8)*T
      HA(10)=BETA*(T+1.5D 0+(X3+X3)*(T+X(2)))/X3**4
      HA(6)= HA(10)*T*T
      HA(9)= HA(10)*T
      RETURN
   30 T=0.1D 0*DBLE(KA-1)-1.0D 0
      HA(1)=0.0D 0
      HA(2)=0.0D 0
      HA(3)=0.0D 0
      X1=X(1)+T*X(2)
      X2=1.0D 0/(1.0D 0+T*(X(3)+T*(X(4)+T*X(5))))
      X3=-T*X2*X2
      X4=-2.0D 0*T*X1*X2*X3
      HA(4)=X3
      HA(5)=HA(4)*T
      HA(7)=HA(5)
      HA(8)=HA(7)*T
      HA(11)=HA(8)
      HA(12)=HA(11)*T
      HA(6)=X4
      HA(9)=HA(6)*T
      HA(10)=HA(9)*T
      HA(13)=HA(10)
      HA(14)=HA(13)*T
      HA(15)=HA(14)*T
      RETURN
  130 T=Y(KA)
      DO 131 I=1,6
      HA(I)=0.0D 0
  131 CONTINUE
      X1=1.0D 0/(1.0D 0-T*(X(4)-T*X(5)))
      X2=X(1)+T*(X(2)+T*X(3))
      X3=X1*X1
      HA(7)=-T*X3
      HA(8)=HA(7)*T
      HA(9)=HA(8)*T
      HA(10)= 2.0D 0*T*T*X1*X2*X3
      HA(11)= HA(8)
      HA(12)= HA(11)*T
      HA(13)= HA(12)*T
      HA(14)= HA(10)*T
      HA(15)= HA(14)*T
      RETURN
  100 T=0.1D 0*DBLE(KA-1)
      DO 101 I=1,N*(N+1)/2
      HA(I)=0.0D 0
  101 CONTINUE
      X1=EXP(-X(2)*T)
      X2=COS(X(3)*T+X(4))
      X3=SIN(X(3)*T+X(4))
      X4=EXP(-X(6)*T)
      HA(2)= -X1*X2*T
      HA(10)=-X1*X2*X(1)
      HA(9)=  HA(10)*T
      HA(3)= -HA(9)*T
      HA(7)= -X1*X3
      HA(4)=  HA(7)*T
      HA(8)=  X1*X3*X(1)*T
      HA(5)=  HA(8)*T
      HA(6)= -HA(3)
      HA(20)=-X4*T
      HA(21)=-HA(20)*X(5)*T
      RETURN
   40 BETA=0.5D 0*PI*Y(KA)
      DO 41 I=1,3
      J=I+I
      XA(I)=X(J-1)
      XB(I)=X(J)
   41 CONTINUE
      CA(4)=CMPLX(1.0D 0,0.0D 0)
      CB(4)=1.0D 1*CA(4)
      DO 42 J=1,3
      I=4-J
      XC(I)=BETA*XA(I)
      T=XC(I)
      X1=COS(T)
      X2=SIN(T)
      C1=CMPLX(X1,0.0D 0)
      C2=CMPLX(0.0D 0,(X2*XB(I)))
      C3=CMPLX(0.0D 0,(X2/XB(I)))
      CB(I)=C1*CB(I+1)+C2*CA(I+1)
      CA(I)=C3*CB(I+1)+C1*CA(I+1)
   42 CONTINUE
      C1=-CA(1)
      C2=CB(1)-C1
      C3=1.0D 0+2.0D 0*C1/C2
      FA=ABS(C3)
      C3=CONJG(C3)
      C1=2.0D 0/(C2*C2)
      T=BETA
      DO 43 I=1,3
      ST(I)=SIN(XC(I))
      CT(I)=COS(XC(I))
      CC(I+I)=(CB(I)*CA(I)-CB(I+1)*CA(I+1))/XB(I)
      CC(I+I-1)=(CB(I)*CA(I+1)-CB(I+1)*CA(I))*T/ST(I)
   43 CONTINUE
      DO 44 I=1,6
      GA(I)=DBLE(C3*C1*CC(I))/FA
   44 CONTINUE
      CI=CMPLX(0D 0,1D 0)
      X2=X(2)
      X4=X(4)
      X3=X(6)
      C2=-(C1+C1)/C2
      S1=CMPLX(-ST(1)*X2,CT(1))
      S2=CMPLX(ST(1)/X2,-CT(1))
      S3=S1*CT(2)-CI*S2*ST(2)*X4
      S4=S2*CT(2)-CI*S1*ST(2)/X4
      DD(1)=C2*( T*CI*(CB(1)/X2+CA(1)*X2))
      DD(2)=C2*(-ST(1)*CI*(CB(2)/(X2*X2)-CA(2)))
      DD(3)=C2*( T*(CB(2)*S1/X4-CA(2)*S2*X4))
      DD(4)=C2*(-ST(2)*(CB(3)*S1/(X4*X4)+CA(3)*S2))
      DD(5)=C2*( T*(CB(3)*S3/X3-CA(3)*S4*X3))
      DD(6)=C2*(-ST(3)*(1D 1*S3/(X3*X3)+S4))
      L=0
      DO 45 I=1,6
      L=L+I-1
      DO 45 J=1,I
      HA(L+J)=(DBLE(CC(I)*(C3*DD(J)+C1*CONJG(C1*CC(J))))-GA(I)*GA(J))/
     & FA
   45 CONTINUE
      DO 46 I=1,3
      J=I*(I+I+1)
      HA(J-1)=HA(J-1)+DBLE(C3*C1*CI*T*(CA(I)*CA(I)+(CB(I)/XB(I))**2))/
     & FA
      HA(J)=HA(J)+DBLE(C3*C1/XB(I)*(CI*ST(I)*(CA(I)*CA(I+1)-
     & CB(I)*CB(I+1)/(XB(I)*XB(I)))-CC(I+I)))/FA
   46 CONTINUE
      RETURN
  110 T=Y(41+KA)
      BETA=Y(82+KA)
      X1=(X(1)+(1.0D 0+X(2))*T)**2+((1.0D 0-X(2))*BETA)**2
      X2=(X(3)+(1.0D 0+X(4))*T)**2+((1.0D 0-X(4))*BETA)**2
      X3=(X(5)+(1.0D 0+X(6))*T)**2+((1.0D 0-X(6))*BETA)**2
      X4=(X(7)+(1.0D 0+X(8))*T)**2+((1.0D 0-X(8))*BETA)**2
      IF (X1.EQ.0.0D 0) X1=1.0D-30
      IF (X2.EQ.0.0D 0) X2=1.0D-30
      IF (X3.EQ.0.0D 0) X3=1.0D-30
      IF (X4.EQ.0.0D 0) X4=1.0D-30
      FA=SQRT(X1/X2)*SQRT(X3/X4)
      HA(37)= FA/X1*(X(1)+T*(1.0D 0+X(2)))
      HA(38)= FA/X1*(X(2)+2.0D 0*T*T-1.0D 0+X(1)*T)
      HA(39)=-FA/X2*(X(3)+T*(1.0D 0+X(4)))
      HA(40)=-FA/X2*(X(4)+2.0D 0*T*T-1.0D 0+X(3)*T)
      HA(41)= FA/X3*(X(5)+T*(1.0D 0+X(6)))
      HA(42)= FA/X3*(X(6)+2.0D 0*T*T-1.0D 0+X(5)*T)
      HA(43)=-FA/X4*(X(7)+T*(1.0D 0+X(8)))
      HA(44)=-FA/X4*(X(8)+2.0D 0*T*T-1.0D 0+X(7)*T)
      HA(45)= 0.0D0
      FA=X(9)*FA
      DO111 I=1,8
  111 GA(I)=HA(36+I)*X(9)
      DO112 J=1,8
      DO112 I=1,J
  112 HA((J-1)*J/2+I)=GA(I)*GA(J)/FA
      HA(1)= FA/X1-HA(1)
      HA(2)= FA*T/X1-HA(2)
      HA(3)= FA/X1-HA(3)
      HA(6)= 3.0D 0*HA(6) -FA/X2
      HA(9)= 3.0D 0*HA(9) -FA*T/X2
      HA(10)=3.0D 0*HA(10)-FA/X2
      HA(15)=FA/X3-HA(15)
      HA(20)=FA*T/X3-HA(20)
      HA(21)=FA/X3-HA(21)
      HA(28)=3.0D 0*HA(28)-FA/X4
      HA(35)=3.0D 0*HA(35)-FA*T/X4
      HA(36)=3.0D 0*HA(36)-FA/X4
      RETURN
   50 DO 51 I=1,N*(N+1)/2
      HA(I)=0.0D 0
   51 CONTINUE
      HA(1)=2.0D 0
      HA(3)=1.0D 1
      HA(6)=1.2D 1*X(3)**2
      HA(10)=6.0D 0
      HA(15)=3.0D 2*X(5)**4
      HA(21)=1.4D 1
      HA(27)=-4.0D 0
      HA(28)=1.2D 1*X(7)**2
      GO TO (56,52,53,54,55),KA
   52 HA(1)=HA(1)+4.0D 1
      HA(3)=HA(3)+3.6D 2*X(2)**2
      HA(10)=HA(10)+8.0D 1
      RETURN
   53 HA(6)=HA(6)+2.0D 2
      RETURN
   54 HA(3)=HA(3)+2.0D 1
      HA(21)=HA(21)+1.2D 2
      RETURN
   55 HA(1)=HA(1)+8.0D 1
      HA(2)=HA(2)-3.0D 1
      HA(3)=HA(3)+2.0D 1
      HA(6)=HA(6)+4.0D 1
   56 RETURN
   60 DO 61 I=1,N*(N+1)/2
      HA(I)=0.0D 0
   61 CONTINUE
      HA(1)=2.0D 0
      HA(2)=1.0D 0
      HA(3)=2.0D 0
      HA(6)=2.0D 0
      HA(10)=8.0D 0
      HA(15)=2.0D 0
      HA(21)=4.0D 0
      HA(28)=1.0D 1
      HA(36)=1.4D 1
      HA(45)=4.0D 0
      HA(55)=2.0D 0
      GO TO (69,62,63,64,65,69,69,68,69),KA
   62 HA(1)=HA(1)+6.0D 1
      HA(3)=HA(3)+8.0D 1
      HA(6)=HA(6)+4.0D 1
      RETURN
   63 HA(1)=HA(1)+1.0D 2
      HA(6)=HA(6)+2.0D 1
      RETURN
   64 HA(1)=HA(1)+1.0D 1
      HA(3)=HA(3)+4.0D 1
      HA(15)=HA(15)+6.0D 1
      RETURN
   65 HA(1)=HA(1)+1.0D 1
      HA(2)=HA(2)-2.0D 1
      HA(3)=HA(3)+4.0D 1
      RETURN
   68 HA(45)=HA(45)+2.4D 2
   69 RETURN
   70 DO 71 I=1,N*(N+1)/2
      HA(I)=0.0D 0
   71 CONTINUE
      HA(1)=2.0D 0
      HA(2)=1.0D 0
      HA(3)=2.0D 0
      HA(6)=2.0D 0
      HA(10)=8.0D 0
      HA(15)=2.0D 0
      HA(21)=4.0D 0
      HA(28)=1.0D 1
      HA(36)=1.4D 1
      HA(45)=4.0D 0
      HA(55)=2.0D 0
      HA(66)=2.0D 0
      HA(78)=2.0D 1
      HA(91)=1.0D 1
      HA(105)=8.0D 0
      HA(120)=5.4D 1
      HA(136)=1.2D 1*X(16)**2
      HA(153)=2.0D 0
      HA(171)=2.6D 1
      HA(190)=2.0D 0
      HA(210)=2.0D 0
      GO TO (69,62,63,64,65,69,69,68,69,69,72,73,74,75,76,77,78,79),KA
   72 HA(1)=HA(1)+2.0D 1
      RETURN
   73 HA(91)=HA(91)+1.0D 2
      RETURN
   74 HA(91)=HA(91)+6.0D 1
      RETURN
   75 HA(1)=HA(1)+2.8D 2
      RETURN
   76 HA(3)=HA(3)+3.0D 2
      RETURN
   77 HA(1)=HA(1)+1.0D 2
      HA(153)=HA(153)+10.8D 2*X(17)**2
      RETURN
   78 HA(1)=HA(1)+2.0D 1
      RETURN
   79 HA(1)=HA(1)+1.4D 2
      HA(3)=HA(3)+1.0D 2
      HA(190)=HA(190)+2.0D 1
      RETURN
  220 X1=0.0D 0
      DO 221 I=1,N
      X3=1.0D 0
      X4=X(I)
      IF (I.EQ.1) X3=1.0D-8
      IF (I.EQ.4) X3=4.0D 0
      IF (I.EQ.2.AND.KA.EQ.1) X4=X(I)+2.0D 0
      IF (I.EQ.2.AND.KA.EQ.2) X4=X(I)-2.0D 0
      X1=X1+X3*X4**2
  221 CONTINUE
      X2=EXP(X1)
      L=0
      DO 223 I=1,N
      X3=2.0D 0
      X4=X(I)
      IF (I.EQ.1) X3=2.0D-8
      IF (I.EQ.4) X3=8.0D 0
      IF (I.EQ.2.AND.KA.EQ.1) X4=X(I)+2.0D 0
      IF (I.EQ.2.AND.KA.EQ.2) X4=X(I)-2.0D 0
      DO 222 J=1,I
      L=L+1
      X5=2.0D 0
      X6=X(J)
      IF (J.EQ.1) X5=2.0D-8
      IF (J.EQ.4) X5=8.0D 0
      IF (J.EQ.2.AND.KA.EQ.1) X6=X(J)+2.0D 0
      IF (J.EQ.2.AND.KA.EQ.2) X6=X(J)-2.0D 0
      HA(L)=X2*X3*X4*X5*X6
  222 CONTINUE
      HA(L)=HA(L)+X2*X3
  223 CONTINUE
      RETURN
  160 DO 161 I=1,N*(N+1)/2
      HA(I)=0.0D 0
  161 CONTINUE
      L=0
      DO 162 I=1,N
      L=L+I
      X1=1.0D 0*DBLE(I+KA-1)
      X2=(X(I)-SIN(DBLE(2*I+KA-3)))**2
      HA(L)=2.0D 0*X1*EXP(X2)*(1.0D 0+2.0D 0*X2)
  162 CONTINUE
      RETURN
  240 IF (KA.LE.2) THEN
      DO 241 I=1,N*(N+1)/2
      HA(I)=0.0D 0
  241 CONTINUE
      IF (KA.EQ.1) THEN
      ELSE IF (KA.EQ.2) THEN
      HA(1)=-2.0D 0
      ENDIF
      ELSE
      T=DBLE(KA-2)/2.9D 1
      L=0
      DO 243 I=1,N
      DO 242 J=1,I
      L=L+1
      HA(L)=-2.0D 0*T**(I+J-2)
  242 CONTINUE
  243 CONTINUE
      ENDIF
      RETURN
  250 T=1.0D-1*DBLE(KA-1)
      DO 251 I=1,N*(N+1)/2
      HA(I)=0.0D 0
  251 CONTINUE
      X1=EXP(-X(5)*T)
      X2=EXP(-X(6)*(T-X( 9))**2)
      X3=EXP(-X(7)*(T-X(10))**2)
      X4=EXP(-X(8)*(T-X(11))**2)
      HA(11)= X1*T
      HA(15)=-X1*X(1)*T**2
      HA(17)= X2*(T-X( 9))**2
      HA(21)=-HA(17)*X(2)*(T-X( 9))**2
      HA(24)= X3*(T-X(10))**2
      HA(28)=-HA(24)*X(3)*(T-X(10))**2
      HA(32)= X4*(T-X(11))**2
      HA(36)=-HA(32)*X(4)*(T-X(11))**2
      HA(38)=-2.0D 0*X2*X(6)*(T-X( 9))
      HA(42)=-2.0D 0*X2*X(2)*(T-X( 9))+
     & 2.0D 0*X2*X(2)*X(6)*(T-X( 9))**3
      HA(45)= 2.0D 0*X2*X(2)*X(6)-
     & 4.0D 0*X2*X(2)*(X(6)*(T-X( 9)))**2
      HA(48)=-2.0D 0*X3*X(7)*(T-X(10))
      HA(52)=-2.0D 0*X3*X(3)*(T-X(10))+
     & 2.0D 0*X3*X(3)*X(7)*(T-X(10))**3
      HA(55)= 2.0D 0*X3*X(3)*X(7)-
     & 4.0D 0*X3*X(3)*(X(7)*(T-X(10)))**2
      HA(59)=-2.0D 0*X4*X(8)*(T-X(11))
      HA(63)=-2.0D 0*X4*X(4)*(T-X(11))+
     & 2.0D 0*X4*X(4)*X(8)*(T-X(11))**3
      HA(66)= 2.0D 0*X4*X(4)*X(8)-
     & 4.0D 0*X4*X(4)*(X(8)*(T-X(11)))**2
      RETURN
      END
