* SUBROUTINE EBFU14             ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 RA : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF MODEL FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  SPARSE VERSION - LU VERSION WITH MODIFIED TESTS NO 7-10,12.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(LA)  VECTOR OF VARIABLES.
*  RO  FA  VALUE OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EBFU14(N,KA,LA,X,FA,NEXT)
      INTEGER N,KA,LA,NEXT
      REAL*8 X(LA),FA
      REAL*8 A,B,C,D,P,Q,R,U,V
      INTEGER I,J,K,L,M
      GO TO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     & 170,180,190,200,210,220),NEXT
   10 A=X(1)**2-X(2)
      B=X(1)-1.0D 0
      FA=1.0D 2*A**2+B**2
      RETURN
   20 A=X(1)**2-X(2)
      B=X(1)-1.0D 0
      C=X(3)**2-X(4)
      D=X(3)-1.0D 0
      U=X(2)+X(4)-2.0D 0
      V=X(2)-X(4)
      FA=1.0D 2*A**2+B**2+9.0D 1*C**2+D**2+
     &   1.0D 1*U**2+0.1D 0*V**2
      RETURN
   30 A=X(1)+1.0D 1*X(2)
      B=X(3)-X(4)
      C=X(2)-2.0D 0*X(3)
      D=X(1)-X(4)
      FA=A**2+5.0D 0*B**2+C**4+1.0D 1*D**4
      RETURN
   40 A=EXP(X(1))
      B=A-X(2)
      D=X(2)-X(3)
      P=X(3)-X(4)
      Q=SIN(P)/COS(P)
      U=X(1)
      V=X(4)-1.0D 0
      FA=B**4+1.0D 2*D**6+Q**4+U**8+V**2
      RETURN
   50 P=7.0D 0/3.0D 0
      IF (KA.EQ.1) THEN
        A=(3.0D 0-2.0D 0*X(1))*X(1)-X(2)+1.0D 0
      ELSE
        A=(3.0D 0-2.0D 0*X(2))*X(2)-X(1)+1.0D 0
        IF (KA.LT.N) A=A-X(3)
      ENDIF
      FA=ABS(A)**P
      RETURN
   60 P=7.0D 0/3.0D 0
      A=1.0D 0
      DO I=1,MIN(KA+1,6)
        A=A+X(I)*(X(I)+1.0D 0)
      ENDDO
      IF (KA.GT.5.AND.KA.LT.N) A=A+X(7)*(X(7)+1.0D 0)
      IF (KA.LE.5) THEN
        A=A+(2.0D 0+5.0D 0*X(KA)**2)*X(KA)
      ELSE
        A=A+(2.0D 0+5.0D 0*X(6)**2)*X(6)
      ENDIF
      FA=ABS(A)**P
      RETURN
   70 P=7.0D 0/3.0D 0
      IF (KA.LE.N) THEN
        IF (KA.EQ.1) THEN
          A=(3.0D 0-2.0D 0*X(1))*X(1)-X(2)+1.0D 0
        ELSE
          A=(3.0D 0-2.0D 0*X(2))*X(2)-X(1)+1.0D 0
          IF (KA.LT.N) A=A-X(3)
        ENDIF
      ELSE
        A=X(1)+X(2)
      ENDIF
      FA=ABS(A)**P
      RETURN
   80 P=0.0D 0
      K=MAX(1,KA-2)
      L=MIN(N,KA+2)
      IF (KA.LE.N/2) THEN
        DO I=K,L
          A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
          B=DBLE(I+KA)/1.0D 1
          IF (KA.LE.2) THEN
            P=P+A*SIN(X(I))+B*COS(X(I))
          ELSE
            J=I+3-KA
            P=P+A*SIN(X(J))+B*COS(X(J))
          ENDIF
        ENDDO
        IF (KA.LE.2) J=KA+2
        I=N/2+KA
        A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
        B=DBLE(I+KA)/1.0D 1
        P=P+A*SIN(X(J+1))+B*COS(X(J+1))
      ELSE
        I=KA-N/2
        A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
        B=DBLE(I+KA)/1.0D 1
        P=P+A*SIN(X(1))+B*COS(X(1))
        DO I=K,L
          J=I+4-KA
          A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
          B=DBLE(I+KA)/1.0D 1
          P=P+A*SIN(X(J))+B*COS(X(J))
        ENDDO
      ENDIF
      FA=(DBLE(N+KA)-P)**2/DBLE(N)
      RETURN
   90 P=0.0D 0
      K=MAX(1,KA-2)
      L=MIN(N,KA+2)
      IF (KA.LE.N/2) THEN
        DO I=K,L
          A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
          B=DBLE(I+KA)/1.0D 1
          IF (KA.LE.2) THEN
            P=P+A*SIN(X(I))+B*COS(X(I))
          ELSE
            J=I+3-KA
            P=P+A*SIN(X(J))+B*COS(X(J))
          ENDIF
        ENDDO
        IF (KA.LE.2) J=KA+2
        I=N/2+KA
        A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
        B=DBLE(I+KA)/1.0D 1
        P=P+A*SIN(X(J+1))+B*COS(X(J+1))
      ELSE
        I=KA-N/2
        A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
        B=DBLE(I+KA)/1.0D 1
        P=P+A*SIN(X(1))+B*COS(X(1))
        DO I=K,L
          J=I+4-KA
          A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
          B=DBLE(I+KA)/1.0D 1
          P=P+A*SIN(X(J))+B*COS(X(J))
        ENDDO
      ENDIF
      IF (KA.LE.2) J=KA
      IF (KA.GE.3.AND.KA.LE.N/2) J=3
      IF (KA.GT.N/2) J=4
      FA=(DBLE(KA)*(1.0D 0-COS(X(J)))+P)/DBLE(N)
      RETURN
  100 FA=0.0D 0
      IF (KA.LE.2) M=KA
      IF (KA.GE.3.AND.KA.LE.N/2) M=3
      IF (KA.GT.N/2) M=4
      K=MAX(1,KA-2)
      L=MIN(N,KA+2)
      C=1.0D 0+DBLE(KA)/1.0D 1
      Q=C*X(M)
      IF (KA.LE.N/2) THEN
        DO I=K,L
          A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
          B=DBLE(I+KA)/1.0D 1
          D=1.0D 0+DBLE(I)/1.0D 1
          IF (KA.LE.2) THEN
            FA=FA+A*SIN(B+Q+D*X(I))
          ELSE
            J=I+3-KA
            FA=FA+A*SIN(B+Q+D*X(J))
          ENDIF
        ENDDO
        IF (KA.LE.2) J=KA+2
        I=N/2+KA
        A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
        B=DBLE(I+KA)/1.0D 1
        D=1.0D 0+DBLE(I)/1.0D 1
        FA=FA+A*SIN(B+Q+D*X(J+1))
      ELSE
        I=KA-N/2
        A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
        B=DBLE(I+KA)/1.0D 1
        D=1.0D 0+DBLE(I)/1.0D 1
        FA=FA+A*SIN(B+Q+D*X(1))
        DO I=K,L
          J=I+4-KA
          A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(KA,5))
          B=DBLE(I+KA)/1.0D 1
          D=1.0D 0+DBLE(I)/1.0D 1
          FA=FA+A*SIN(B+Q+D*X(J))
        ENDDO
      ENDIF
      FA=FA/DBLE(N)
      RETURN
  110 P=-0.2008D-2
      Q=-0.1900D-2
      R=-0.0261D-2
      A=1.0D 0
      B=0.0D 0
      DO J=1,5
        A=A*X(J)
        B=B+X(J)**2
      ENDDO
      A=EXP(A)
      B=B-1.0D 1-P
      C=X(2)*X(3)-5.0D 0*X(4)*X(5)-Q
      D=X(1)**3+X(2)**3+1.0D 0-R
      FA=A+1.0D 1*(B**2+C**2+D**2)
      RETURN
  120 A=X(1)-3.0D 0
      B=X(1)-X(2)
      FA=A**2+B**2+EXP(2.0D 1*B)
      RETURN
  130 A=X(2)**2
      B=X(1)**2
      C=A+1.0D 0
      D=B+1.0D 0
      FA=B**C+A**D
      RETURN
  140 P=1.0D 0/DBLE(N+1)
      Q=0.5D 0*P**2
      IF (KA.EQ.1) THEN
        A=2.0D 0*X(1)-X(2)+Q*(X(1)+DBLE(KA)*P+1.0D 0)**3
      ELSE
        A=2.0D 0*X(2)-X(1)+Q*(X(2)+DBLE(KA)*P+1.0D 0)**3
        IF (KA.LT.N) A=A-X(3)
      ENDIF
      FA=A**2
      RETURN
  150 P=1.0D 0/DBLE(N+1)
      Q=2.0D 0/P
      R=2.0D 0*P
      A=X(1)-X(2)
      FA=Q*X(1)*A
      IF (ABS(A).LE.1.0D-6) THEN
        FA=FA+R*EXP(X(2))*
     &  (1.0D 0+A/2.0D 0*(1.0D 0+A/3.0D 0*(1.0D 0+A/4.0D 0)))
      ELSE
        B=EXP(X(1))-EXP(X(2))
        FA=FA+R*B/A
      ENDIF
      IF (KA.EQ.1) THEN
        FA=FA+R*(EXP(X(1))-1.0D 0)/X(1)
      ELSEIF (KA.EQ.N-1) THEN
        FA=FA+Q*X(2)**2+R*(EXP(X(2))-1.0D 0)/X(2)
      ENDIF
      RETURN
  160 IF (KA.EQ.1) THEN
        A=1.0D 0-COS(X(1))-SIN(X(2))
      ELSE
        A=1.0D 0-COS(X(2))+SIN(X(1))
        IF (KA.LT.N) A=A-SIN(X(3))
      ENDIF
      FA=DBLE(KA)*A
      RETURN
  170 P=1.0D 0/DBLE(N+1)
      IF (KA.EQ.1) THEN
      FA=0.25D 0*X(1)**2/P+1.25D-1*X(2)**2/P+
     &   P*(EXP(X(1))-1.0D 0)
      ELSE IF (KA.EQ.N) THEN
      FA=0.25D 0*X(2)**2/P+1.25D-1*X(1)**2/P+
     &   P*(EXP(X(2))-1.0D 0)
      ELSE
      FA=1.25D-1*(X(3)-X(1))**2/P+P*(EXP(X(2))-1.0D 0)
      ENDIF
      RETURN
  180 P=1.0D 0/DBLE(N+1)
      Q=DBLE(KA)*P
      IF (KA.EQ.1) THEN
      FA=0.5D 0*X(1)**2/P+0.25D 0*X(2)**2/P-
     &   P*(X(1)**2+2.0D 0*X(1)*Q)
      ELSE IF (KA.EQ.N) THEN
      FA=0.5D 0*X(2)**2/P+0.25D 0*X(1)**2/P-
     &   P*(X(2)**2+2.0D 0*X(2)*Q)
      ELSE
      FA=2.5D-1*(X(3)-X(1))**2/P-P*(X(2)**2+2.0D 0*X(2)*Q)
      ENDIF
      RETURN
  190 P=1.0D 0/DBLE(N+1)
      Q=EXP(2.0D 0*DBLE(KA)*P)
      IF (KA.EQ.1) THEN
      R=1.0D 0/3.0D 0
      FA=0.5D 0*(X(1)-R)**2/P+7.0D 0*R**2+
     &   2.5D-1*(X(2)-R)**2/P+P*(X(1)**2+2.0D 0*X(1)*Q)
      ELSE IF (KA.EQ.N) THEN
      R=EXP(2.0D 0)/3.0D 0
      FA=0.5D 0*(X(2)-R)**2/P+7.0D 0*R**2+
     &   2.5D-1*(X(1)-R)**2/P+P*(X(2)**2+2.0D 0*X(2)*Q)
      ELSE
      FA=2.5D-1*(X(3)-X(1))**2/P+P*(X(2)**2+2.0D 0*X(2)*Q)
      ENDIF
      RETURN
  200 P=1.0D 0/DBLE(N+1)
      IF (KA.EQ.1) THEN
      FA=(0.5D 0*X(1)**2/P-P)+
     &   (2.5D-1*X(2)**2/P-P)*EXP(-2.0D 0*X(1)**2)
      ELSE IF (KA.EQ.N) THEN
      FA=(0.5D 0*X(2)**2/P-P)*EXP(-2.0D 0)+
     &   (2.5D-1*X(1)**2/P-P)*EXP(-2.0D 0*X(2)**2)
      ELSE
      FA=(2.5D-1*(X(3)-X(1))**2/P-P)*EXP(-2.0D 0*X(2)**2)
      ENDIF
      RETURN
  210 P=1.0D 0/DBLE(N+1)
      IF (KA.EQ.1) THEN
      A=0.5D 0*(X(2)-1.0D 0)/P
      B=(X(1)-1.0D 0)/P
      FA=P*(X(1)**2+A*ATAN(A)-LOG(SQRT(1.0D 0+A**2)))+
     &   0.5D 0*P*(1.0D 0+B*ATAN(B)-LOG(SQRT(1.0D 0+B**2)))
      ELSE IF (KA.EQ.N) THEN
      A=0.5D 0*(2.0D 0-X(1))/P
      B=(2.0D 0-X(2))/P
      FA=P*(X(2)**2+A*ATAN(A)-LOG(SQRT(1.0D 0+A**2)))+
     &   0.5D 0*P*(4.0D 0+B*ATAN(B)-LOG(SQRT(1.0D 0+B**2)))
      ELSE
      A=0.5D 0*(X(3)-X(1))/P
      FA=P*(X(2)**2+A*ATAN(A)-LOG(SQRT(1.0D 0+A**2)))
      ENDIF
      RETURN
  220 P=1.0D 0/DBLE(N+1)
      IF (KA.EQ.1) THEN
      A= 0.5D 0*X(2)/P
      B= X(1)/P
      FA=P*(1.0D 2*(X(1)-A**2)**2+(1.0D 0-A)**2)+
     &   0.5D 0*P*(1.0D 2*B**4+(1.0D 0-B)**2)
      ELSE IF (KA.EQ.N) THEN
      A=-0.5D 0*X(1)/P
      B=-X(2)/P
      FA=P*(1.0D 2*(X(2)-A**2)**2+(1.0D 0-A)**2)+
     &   0.5D 0*P*(1.0D 2*B**4+(1.0D 0-B)**2)
      ELSE
      A=0.5D 0*(X(3)-X(1))/P
      FA=P*(1.0D 2*(X(2)-A**2)**2+(1.0D 0-A)**2)
      ENDIF
      RETURN
      END
