* SUBROUTINE ECGU08             ALL SYSTEMS                 91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENTS OF TEST FUNCTIONS FOR NONLINEAR PROGRAMMING.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KC  INDEX OF THE CONSTRAINT.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  GC GRADIENT OF THE CONSTRAINT AT THE SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE ECGU08(N,KC,X,GC,NEXT)
      INTEGER N,KC,NEXT
      INTEGER I,J
      REAL*8 X(N),GC(N)
      REAL*8 X1,X2,X3,X4,X5,DERFUN
      REAL*8 Y(20)
      COMMON /EMPR08/ Y
      GOTO(10,10,30,40,50,60,70,80,70,100,110,120,130,140,150,160,170,
     * 180,190,190,210,220,230,240,250,240,250,250,290,300,310),NEXT
   10 GC(1)=2.0D 0*X(1)
      GC(2)=2.0D 0*X(2)
      RETURN
   30 GC(1)= 2.0D 0*X(1)-4.0D 0
      GC(2)=-2.0D 0
      RETURN
   40 GC(1)=-20.0D 0*X(1)
      GC(2)= 10.0D 0
      RETURN
   50 GC(1)=4.0D 0*(1.0D 0+X(1)**2)*X(1)
      GC(2)=2.0D 0*X(2)
      RETURN
   60 GO TO (61,62),KC
   61 GC(1)=-3.0D 0*X(1)**2
      GC(2)=1.0D 0
      RETURN
   62 GC(1)=2.0D 0*X(1)
      GC(2)=-1.0D 0
      RETURN
   70 GC(1)=1.0D 0+X(2)**2
      GC(2)=2.0D 0*X(1)*X(2)
      GC(3)=4.0D 0*X(3)**3
      RETURN
   80 GC(1)=1.0D 0
      GC(2)=0.0D 0
      GC(3)=2.0D 0*X(3)
      RETURN
  100 GO TO (101,102),KC
  101 GC(1)=2.0D 0*X(1)
      GC(2)=2.0D 0*X(2)
      GC(3)=2.0D 0*X(3)
      RETURN
  102 GC(1)=1.0D 0
      GC(2)=1.0D 0
      GC(3)=1.0D 0
      RETURN
  110 GO TO (111,112),KC
  111 GC(1)=3.0D 0
      GC(2)=-4.0D 0*X(2)
      GC(3)=0.0D 0
      RETURN
  112 GC(1)=4.0D 0
      GC(2)=0.0D 0
      GC(3)=-2.0D 0*X(3)
      RETURN
  120 GO TO (121,101),KC
  121 GC(1)=8.0D 0
      GC(2)=14.0D 0
      GC(3)=7.0D 0
      RETURN
  130 GO TO (131,132),KC
  131 GC(1)=200.0D 1*X(1)
      GC(2)=200.0D 0*X(2)
      GC(3)=-1.0D 0
      RETURN
  132 GC(1)=200.0D 0*X(1)
      GC(2)=800.0D 0*X(2)
      GC(3)= 1.0D 0
      RETURN
  140 GO TO (141,142),KC
  141 GC(1)=-3.0D 0*X(1)**2
      GC(2)= 1.0D 0
      GC(3)=-2.0D 0*X(3)
      GC(4)=0.0D 0
      RETURN
  142 GC(1)= 2.0D 0*X(1)
      GC(2)=-1.0D 0
      GC(3)= 0.0D 0
      GC(4)=-2.0D 0*X(4)
      RETURN
  150 GO TO (151,152),KC
  151 GC(1)=1.0D 0
      GC(2)= 0.0D 0
      GC(3)= 0.0D 0
      GC(4)= 0.0D 0
      RETURN
  152 GC(1)= 0.0D 0
      GC(2)= 0.0D 0
      GC(3)=2.0D 0*X(3)
      GC(4)=2.0D 0*X(4)
      RETURN
  160 GO TO (161,162),KC
  161 GC(1)=0.0D 0
      GC(2)=2.0D 0*DERFUN(-X(2))
      GC(3)=1.0D 0
      GC(4)=0.0D 0
      RETURN
  162 X2=SQRT(24.0D 0)
      GC(1)=0.0D 0
      GC(2)=DERFUN(X2-X(2))+DERFUN(-X2-X(2))
      GC(3)=0.0D 0
      GC(4)=1.0D 0
      RETURN
  170 GC(1)= 2.0D 0*(X(1)-2.0D 0*X(2))+2.0D 0*X(1)
      GC(2)=-4.0D 0*(X(1)-2.0D 0*X(2))+2.0D 0*(X(2)-3.0D 0*X(3))
      GC(3)=-6.0D 0*(X(2)-3.0D 0*X(3))+2.0D 0*(X(3)-4.0D 0*X(4))
      GC(4)=-8.0D 0*(X(3)-4.0D 0*X(4))
      GC(5)=-2.0D 0*X(5)
      RETURN
  180 GO TO (181,182),KC
  181 GC(1)=1.0D 0
      GC(2)=0.0D 0
      GC(3)=0.0D 0
      GC(4)=2.0D 0*X(4)
      GC(5)=0.0D 0
      RETURN
  182 GC(1)= 2.0D 0*X(1)
      GC(1)= 2.0D 0*X(1)
      GC(3)= 0.0D 0
      GC(4)= 0.0D 0
      GC(5)=-2.0D 0*X(5)
      RETURN
  190 GO TO (191,192),KC
  191 GC(1)= 2.0D 0*X(1)*X(4)
      GC(2)= 0.0D 0
      GC(3)= 0.0D 0
      GC(4)= X(1)**2+COS(X(4)-X(5))
      GC(5)=-COS(X(4)-X(5))
      RETURN
  192 GC(1)=0.0D 0
      GC(2)=1.0D 0
      GC(3)=4.0D 0*X(3)**3*X(4)**2
      GC(4)=2.0D 0*X(4)*X(3)**4
      GC(5)=0.0D 0
      RETURN
  210 GO TO (211,212,213),KC
  211 GC(1)=2.0D 0*X(1)
      GC(2)=3.0D 0
      GC(3)=0.0D 0
      GC(4)=0.0D 0
      GC(5)=0.0D 0
      RETURN
  212 GC(1)= 0.0D 0
      GC(2)= 0.0D 0
      GC(3)= 2.0D 0*X(3)
      GC(4)= 1.0D 0
      GC(5)=-2.0D 0
      RETURN
  213 GC(1)= 0.0D 0
      GC(2)= 2.0D 0*X(2)
      GC(3)= 0.0D 0
      GC(4)= 0.0D 0
      GC(5)=-1.0D 0
      RETURN
  220 GO TO (221,222,223),KC
  221 GC(1)= X(2)
      GC(2)= X(1)
      GC(3)=-2.0D 0*X(3)
      GC(4)= 0.0D 0
      GC(5)= 0.0D 0
      RETURN
  222 GC(1)= 1.0D 0
      GC(2)= 2.0D 0*X(2)
      GC(3)= 0.0D 0
      GC(4)=-2.0D 0*X(4)
      GC(5)= 0.0D 0
      RETURN
  223 GC(1)= 1.0D 0
      GC(2)= 0.0D 0
      GC(3)= 0.0D 0
      GC(4)= 0.0D 0
      GC(5)= 2.0D 0*X(5)
      RETURN
  230 GO TO (231,232,233),KC
  231 GC(1)= 1.0D 0
      GC(2)= 1.0D 0
      GC(3)=-2.0D 0*X(3)
      GC(4)= 0.0D 0
      GC(5)= 0.0D 0
      RETURN
  232 GC(1)= 2.0D 0*X(1)
      GC(2)= 2.0D 0*X(2)
      GC(3)= 0.0D 0
      GC(4)=-2.0D 0*X(4)
      GC(5)= 0.0D 0
      RETURN
  233 GC(1)= 1.0D 0
      GC(2)= 0.0D 0
      GC(3)= 0.0D 0
      GC(4)= 0.0D 0
      GC(5)=-2.0D 0*X(5)
      RETURN
  240 GO TO (241,242,243),KC
  241 GC(1)=1.0D 0
      GC(2)=2.0D 0*X(2)
      GC(3)=3.0D 0*X(3)**2
      GC(4)=0.0D 0
      GC(5)=0.0D 0
      RETURN
  242 GC(1)= 0.0D 0
      GC(2)= 1.0D 0
      GC(3)=-2.0D 0*X(3)
      GC(4)= 1.0D 0
      GC(5)= 0.0D 0
      RETURN
  243 GC(1)=X(5)
      GC(2)=0.0D 0
      GC(3)=0.0D 0
      GC(4)=0.0D 0
      GC(5)=X(1)
      RETURN
  250 GO TO (251,252,253),KC
  251 GC(1)=2.0D 0*X(1)
      GC(2)=2.0D 0*X(2)
      GC(3)=2.0D 0*X(3)
      GC(4)=2.0D 0*X(4)
      GC(5)=2.0D 0*X(5)
      RETURN
  252 GC(1)=0.0D 0
      GC(2)=X(3)
      GC(3)=X(2)
      GC(4)=-5.0D 0*X(5)
      GC(5)=-5.0D 0*X(4)
      RETURN
  253 GC(1)=3.0D 0*X(1)**2
      GC(2)=3.0D 0*X(2)**2
      GC(3)=0.0D 0
      GC(4)=0.0D 0
      GC(5)=0.0D 0
      RETURN
  290 X1=131.078D 0
      X2=1.48577D 0
      X3=0.90798D 0/X1
      X4=COS(1.47588D 0)
      X5=SIN(1.47588D 0)
      GO TO (291,292,293,294),KC
  291 GC(1)=-1.0D 0
      GC(2)= 0.0D 0
      GC(3)=-X(4)*COS(X2-X(6))/X1+2.0D 0*X3*X4*X(3)
      GC(4)=-X(3)*COS(X2-X(6))/X1
      GC(5)= 0.0D 0
      GC(6)=-X(3)*X(4)*SIN(X2-X(6))/X1
      RETURN
  292 GC(1)= 0.0D 0
      GC(2)=-1.0D 0
      GC(3)=-X(4)*COS(X2+X(6))/X1
      GC(4)=-X(3)*COS(X2+X(6))/X1+2.0D 0*X3*X4*X(4)
      GC(5)= 0.0D 0
      GC(6)= X(3)*X(4)*SIN(X2+X(6))/X1
      RETURN
  293 GC(1)= 0.0D 0
      GC(2)= 0.0D 0
      GC(3)=-X(4)*SIN(X2+X(6))/X1
      GC(4)=-X(3)*SIN(X2+X(6))/X1+2.0D 0*X3*X5*X(4)
      GC(5)=-1.0D 0
      GC(6)=-X(3)*X(4)*COS(X2+X(6))/X1
      RETURN
  294 GC(1)= 0.0D 0
      GC(2)= 0.0D 0
      GC(3)=-X(4)*SIN(X2-X(6))/X1+2.0D 0*X3*X5*X(3)
      GC(4)=-X(3)*SIN(X2-X(6))/X1
      GC(5)= 0.0D 0
      GC(6)= X(3)*X(4)*COS(X2-X(6))/X1
      RETURN
  300 GO TO (301,304),KC
  301 DO 303 I=1,7
      X1=0.5D 0*Y(I+7)
      DO 302 J=I+1,7
      X1=X1+Y(J+7)
  302 CONTINUE
      GC(I)=X1*Y(I)*Y(I+7)*COS(X(I))
  303 CONTINUE
      RETURN
  304 DO 305 I=1,7
      GC(I)=Y(I)*Y(I+7)*COS(X(I))
  305 CONTINUE
      RETURN
  310 GO TO (311,312,313),KC
  311 GC(1)=EXP(X(1))
      GC(2)=2.0D 0*EXP(X(2))
      GC(3)=2.0D 0*EXP(X(3))
      GC(4)=0.0D 0
      GC(5)=0.0D 0
      GC(6)=EXP(X(6))
      GC(7)=0.0D 0
      GC(8)=0.0D 0
      GC(9)=0.0D 0
      GC(10)=EXP(X(10))
      RETURN
  312 GC(1)=0.0D 0
      GC(2)=0.0D 0
      GC(3)=0.0D 0
      GC(4)=EXP(X(4))
      GC(5)=2.0D 0*EXP(X(5))
      GC(6)=EXP(X(6))
      GC(7)=EXP(X(7))
      GC(8)=0.0D 0
      GC(9)=0.0D 0
      GC(10)=0.0D 0
      RETURN
  313 GC(1)=0.0D 0
      GC(2)=0.0D 0
      GC(3)=EXP(X(3))
      GC(4)=0.0D 0
      GC(5)=0.0D 0
      GC(6)=0.0D 0
      GC(7)=EXP(X(7))
      GC(8)=EXP(X(8))
      GC(9)=2.0D 0*EXP(X(9))
      GC(10)=EXP(X(10))
      RETURN
      END
      FUNCTION DERFUN(X)
      REAL*8 X,X1,DERFUN,P,A1,A2,A3,A4,A5,U,T,Y
      P=0.3275911D 0
      A1=0.254829592D 0
      A2=-0.284496736D 0
      A3=1.421413741D 0
      A4=-1.453152027D 0
      A5=1.061405429D 0
      X1=SQRT(2.0D 0)
      Y=ABS(X)/X1
      U=Y**2
      T=1.0D 0/(1.0D 0+P*Y)
      DERFUN=(((((5.0D 0*A5*T+4.0D 0*A4)*T+3.0D 0*A3)*T+2.0D 0*A2)*T+
     * A1)*T*P/SIGN(X1,X)+((((A5*T+A4)*T+A3)*T+A2)*T+A1)*X)*T*EXP(-U)
      DERFUN=0.5D 0*ABS(DERFUN)
      RETURN
      END
