* SUBROUTINE ECGU99             ALL SYSTEMS                 94/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENTS OF CONSTRAINT FUNCTIONS FOR COMPLEMENTARITY PROBLEMS.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  KC  INDEX OF THE APPROXIMATED FUNCTION.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  GC(N)  GRADIENT OF THE APPROXIMATED FUNCTION AT THE
*          SELECTED POINT.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE ECGU99(N,KC,X,GC,NEXT)
      INTEGER N,KC,NEXT
      REAL*8 X(N),GC(N)
      REAL*8 WBB,WG,WGG,WX,WXX,WDET,WRA,WRB,WRC,WRD,WRE,WRF
      GOTO (10,20,30,40,50,60,70,80,40,50,60,70,80,140,150,160,170,180,
     &140,150,160,170,180,240,250,260,270,280,290), NEXT
   10 IF (KC.EQ.1) THEN
        GC(1)=-2.0D 0
        GC(5)=2.0D 0+2.0D 0*X(3)
        GC(3)=2.0D 0*(X(5)-1.0D 0)
      ELSEIF (KC.EQ.2) THEN
        GC(2)=-2.0D 0
        GC(6)=2.0D 0+2.0D 0*X(4)
        GC(4)=2.0D 0*(X(6)-1.0D 0)
      ELSEIF (KC.EQ.3) THEN
        GC(5)=-2.0D 0*(X(5)-1.0D 0)
      ELSEIF (KC.EQ.4) THEN
        GC(6)=-2.0D 0*(X(6)-1.0D 0)
      ENDIF
      RETURN
   20 IF (KC.EQ.1) THEN
        GC(1)=2.0D 0*(X(1)-1.0D 0)
        GC(2)=2.0D 0*(X(2)-1.0D 0)
      ELSEIF (KC.EQ.2) THEN
        GC(1)=-2.0D 0*X(1)
        GC(2)=1.0D 0
      ENDIF
      RETURN
   30 IF (KC.EQ.1) THEN
        GC(1)=2.0D 0*X(3)
        GC(3)=2.0D 0*X(1)+1.0D 0
      ELSEIF (KC.EQ.2) THEN
        GC(2)=-1.0D 0
        GC(3)=2.0D 0*X(3)
      ENDIF
      RETURN
   40 WG=1.0D 0
   41 WGG=1.0D 0/WG
      WX=X(1)+X(2)+X(3)+X(4)+X(5)
      WXX=WGG*5.0D 3**WGG/WX**(WGG+1)
      IF (KC.LE.4) THEN
        WBB=-1.0D 0/(1.2D 0-1.0D-1*DBLE(KC))
        GC(1)=WXX-X(KC+1)*(1.0D 0+WGG)*WXX/WX
        GC(2)=GC(1)
        GC(3)=GC(1)
        GC(4)=GC(1)
        GC(5)=GC(1)
        GC(KC+1)=GC(KC+1)+WXX+5.0D 0**WBB
        GC(2*KC+4)=-1.0D 0
        GC(2*KC+5)=1.0D 0
      ELSEIF (KC.LE.8) THEN
        GC(KC-3)=-1.0D 0
      ENDIF
      RETURN
   50 WG=1.1D 0
      GOTO 41
   60 WG=1.3D 0
      GOTO 41
   70 WG=1.5D 0
      GOTO 41
   80 WG=1.7D 0
      GOTO 41
  140 WG=1.0D 0
  141 WGG=1.0D 0/WG
      WX=X(1)+X(2)+X(3)+X(4)+X(5)
      WXX=WGG*5.0D 3**WGG/WX**(WGG+1)
      IF (KC.LE.4) THEN
        WBB=-1.0D 0/(1.2D 0-1.0D-1*DBLE(KC))
        GC(1)=WXX-X(KC+1)*(1.0D 0+WGG)*WXX/WX
        GC(2)=GC(1)
        GC(3)=GC(1)
        GC(4)=GC(1)
        GC(5)=GC(1)
        GC(KC+1)=GC(KC+1)+WXX+5.0D 0**WBB
        GC(KC+5)=-1.0D 0
      ELSEIF (KC.LE.8) THEN
        GC(KC-3)=-1.0D 0
      ENDIF
      RETURN
  150 WG=1.1D 0
      GOTO 141
  160 WG=1.3D 0
      GOTO 141
  170 WG=1.5D 0
      GOTO 141
  180 WG=1.7D 0
      GOTO 141
  240 IF (KC.EQ.1) THEN
        GC(4)=-1.0D 0
        GC(7)=-2.0D 0*X(7)
      ELSEIF (KC.EQ.2) THEN
        GC(5)=1.0D 0
        GC(8)=4.0D 0
      ELSEIF (KC.EQ.3) THEN
        GC(1)=-2.0D 0*X(10)
        GC(4)=2.0D 0*X(10)
        GC(10)=2.0D 0*(X(4)-X(1))
      ELSEIF (KC.EQ.4) THEN
        GC(2)=-2.0D 0*X(10)
        GC(7)=2.0D 0+2.0D 0*X(10)
        GC(10)=2.0D 0*(X(7)-X(2))
      ELSEIF (KC.EQ.5) THEN
        GC(1)=-2.0D 0*X(11)
        GC(5)=2.0D 0*X(11)
        GC(11)=2.0D 0*(X(5)-X(1))
      ELSEIF (KC.EQ.6) THEN
        GC(2)=-2.0D 0*X(11)
        GC(8)=2.0D 0*X(11)
        GC(11)=2.0D 0*(X(8)-X(2))
      ELSEIF (KC.EQ.7) THEN
        GC(1)=-2.0D 0*X(12)
        GC(6)=2.0D 0*X(12)
        GC(12)=2.0D 0*(X(6)-X(1))
      ELSEIF (KC.EQ.8) THEN
        GC(2)=-2.0D 0*X(12)
        GC(9)=2.0D 0*X(12)
        GC(12)=2.0D 0*(X(9)-X(2))
      ELSEIF (KC.EQ.9) THEN
        GC(1)=-2.0D 0*(X(4)-X(1))
        GC(2)=-2.0D 0*(X(7)-X(2))
        GC(3)=-2.0D 0*X(3)
        GC(4)=2.0D 0*(X(4)-X(1))
        GC(7)=2.0D 0*(X(7)-X(2))
      ELSEIF (KC.EQ.10) THEN
        GC(1)=-2.0D 0*(X(5)-X(1))
        GC(2)=-2.0D 0*(X(8)-X(2))
        GC(3)=-2.0D 0*X(3)
        GC(5)=2.0D 0*(X(5)-X(1))
        GC(8)=2.0D 0*(X(8)-X(2))
      ELSEIF (KC.EQ.11) THEN
        GC(1)=-2.0D 0*(X(6)-X(1))
        GC(2)=-2.0D 0*(X(9)-X(2))
        GC(3)=-2.0D 0*X(3)
        GC(6)=2.0D 0*(X(6)-X(1))
        GC(9)=2.0D 0*(X(9)-X(2))
      ENDIF
      RETURN
  250 IF (KC.EQ.9) THEN
        GC(1)=-2.0D 0*(X(4)-X(1))/X(3)**2
        GC(2)=-2.0D 0*(X(7)-X(2))/X(13)**2
        GC(3)=-2.0D 0*(X(4)-X(1))**2/X(3)**3
        GC(4)=2.0D 0*(X(4)-X(1))/X(3)**2
        GC(7)=2.0D 0*(X(7)-X(2))/X(13)**2
        GC(13)=-2.0D 0*(X(7)-X(2))**2/X(13)**3
      ELSEIF (KC.EQ.10) THEN
        GC(1)=-2.0D 0*(X(5)-X(1))/X(3)**2
        GC(2)=-2.0D 0*(X(8)-X(2))/X(13)**2
        GC(3)=-2.0D 0*(X(5)-X(1))**2/X(3)**3
        GC(5)=2.0D 0*(X(5)-X(1))/X(3)**2
        GC(8)=2.0D 0*(X(8)-X(2))/X(13)**2
        GC(13)=-2.0D 0*(X(8)-X(2))**2/X(13)**3
      ELSEIF (KC.EQ.11) THEN
        GC(1)=-2.0D 0*(X(6)-X(1))/X(3)**2
        GC(2)=-2.0D 0*(X(9)-X(2))/X(13)**2
        GC(3)=-2.0D 0*(X(6)-X(1))**2/X(3)**3
        GC(6)=2.0D 0*(X(6)-X(1))/X(3)**2
        GC(9)=2.0D 0*(X(9)-X(2))/X(13)**2
        GC(13)=-2.0D 0*(X(9)-X(2))**2/X(13)**3
      ENDIF
  251 IF (KC.EQ.1) THEN
        GC(4)=-1.0D 0
        GC(7)=-2.0D 0*X(7)
      ELSEIF (KC.EQ.2) THEN
        GC(5)=1.0D 0
        GC(8)=4.0D 0
      ELSEIF (KC.EQ.3) THEN
        GC(1)=-2.0D 0*X(10)/X(3)**2
        GC(3)=-4.0D 0*(X(4)-X(1))*X(10)/X(3)**3
        GC(4)=2.0D 0*X(10)/X(3)**2
        GC(10)=2.0D 0*(X(4)-X(1))/X(3)**2
      ELSEIF (KC.EQ.4) THEN
        GC(2)=-2.0D 0*X(10)/X(13)**2
        GC(7)=2.0D 0+2.0D 0*X(10)/X(13)**2
        GC(10)=2.0D 0*(X(7)-X(2))/X(13)**2
        GC(13)=-4.0D 0*(X(7)-X(2))*X(10)/X(13)**3
      ELSEIF (KC.EQ.5) THEN
        GC(1)=-2.0D 0*X(11)/X(3)**2
        GC(3)=-4.0D 0*(X(5)-X(1))*X(11)/X(3)**3
        GC(5)=2.0D 0*X(11)/X(3)**2
        GC(11)=2.0D 0*(X(5)-X(1))/X(3)**2
      ELSEIF (KC.EQ.6) THEN
        GC(2)=-2.0D 0*X(11)/X(13)**2
        GC(8)=2.0D 0*X(11)/X(13)**2
        GC(11)=2.0D 0*(X(8)-X(2))/X(13)**2
        GC(13)=-4.0D 0*(X(8)-X(2))*X(11)/X(13)**3
      ELSEIF (KC.EQ.7) THEN
        GC(1)=-2.0D 0*X(12)/X(3)**2
        GC(3)=-4.0D 0*(X(6)-X(1))*X(12)/X(3)**3
        GC(6)=2.0D 0*X(12)/X(3)**2
        GC(12)=2.0D 0*(X(6)-X(1))/X(3)**2
      ELSEIF (KC.EQ.8) THEN
        GC(2)=-2.0D 0*X(12)/X(13)**2
        GC(9)=2.0D 0*X(12)/X(13)**2
        GC(12)=2.0D 0*(X(9)-X(2))/X(13)**2
        GC(13)=-4.0D 0*(X(9)-X(2))*X(12)/X(13)**3
      ELSEIF (KC.EQ.12) THEN
        GC(1)=-1.0D 0
        GC(4)=1.0D 0
      ELSEIF (KC.EQ.13) THEN
        GC(1)=-1.0D 0
        GC(5)=1.0D 0
      ELSEIF (KC.EQ.14) THEN
        GC(2)=-1.0D 0
        GC(8)=1.0D 0
      ELSEIF (KC.EQ.15) THEN
        GC(2)=-1.0D 0
        GC(9)=1.0D 0
      ENDIF
      RETURN
  260 IF (KC.EQ.9) THEN
        GC(1)=-2.0D 0*(X(4)-X(1))*X(13)**2
        GC(2)=-2.0D 0*(X(7)-X(2))*X(3)**2
        GC(3)=2.0D 0*(X(7)-X(2))**2*X(3)-2.0D 0*X(3)*X(13)**2
        GC(4)=2.0D 0*(X(4)-X(1))*X(13)**2
        GC(7)=2.0D 0*(X(7)-X(2))*X(3)**2
        GC(13)=2.0D 0*(X(4)-X(1))**2*X(13)-2.0D 0*X(13)*X(3)**2
      ELSEIF (KC.EQ.10) THEN
        GC(1)=-2.0D 0*(X(5)-X(1))*X(13)**2
        GC(2)=-2.0D 0*(X(8)-X(2))*X(3)**2
        GC(3)=2.0D 0*(X(8)-X(2))**2*X(3)-2.0D 0*X(3)*X(13)**2
        GC(5)=2.0D 0*(X(5)-X(1))*X(13)**2
        GC(8)=2.0D 0*(X(8)-X(2))*X(3)**2
        GC(13)=2.0D 0*(X(5)-X(1))**2*X(13)-2.0D 0*X(13)*X(3)**2
      ELSEIF (KC.EQ.11) THEN
        GC(1)=-2.0D 0*(X(6)-X(1))*X(13)**2
        GC(2)=-2.0D 0*(X(9)-X(2))*X(3)**2
        GC(3)=2.0D 0*(X(9)-X(2))**2*X(3)-2.0D 0*X(3)*X(13)**2
        GC(6)=2.0D 0*(X(6)-X(1))*X(13)**2
        GC(9)=2.0D 0*(X(9)-X(2))*X(3)**2
        GC(13)=2.0D 0*(X(6)-X(1))**2*X(13)-2.0D 0*X(13)*X(3)**2
      ENDIF
      GOTO 251
  270 IF (KC.EQ.1) THEN
        GC(7)=-1.0D 0
        GC(10)=-2.0D 0*X(10)
      ELSEIF (KC.EQ.2) THEN
        X(8)=1.0D 0
        X(11)=4.0D 0
      ELSEIF (KC.EQ.3) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRA=2.0D 0*(X(5)**2+X(6)**2)/WDET
        WRB=-2.0D 0*(X(3)*X(5)+X(4)*X(6))/WDET
        WRD=-4.0D 0*(X(5)**2+X(6)**2)/WDET**2
        WRE=4.0D 0*(X(3)*X(5)+X(4)*X(6))/WDET**2
        GC(1)=-WRA*X(13)
        GC(2)=-WRB*X(13)
        GC(3)=X(13)*((X(7)-X(1))*WRD*(X(3)*X(6)**2-X(4)*X(5)*X(6))+
     &               (X(10)-X(2))*(WRE*(X(3)*X(6)**2-X(4)*X(5)*X(6))-
     &                2.0D 0*X(5)/WDET))
        GC(4)=X(13)*((X(7)-X(1))*WRD*(X(4)*X(5)**2-X(3)*X(5)*X(6))+
     &               (X(10)-X(2))*(WRE*(X(4)*X(5)**2-X(3)*X(5)*X(6))-
     &                2.0D 0*X(6)/WDET))
        GC(5)=X(13)*((X(7)-X(1))*(WRD*(X(5)*X(4)**2-X(3)*X(4)*X(6))+
     &                4.0D 0*X(5)/WDET)+
     &               (X(10)-X(2))*(WRE*(X(5)*X(4)**2-X(3)*X(4)*X(6))-
     &                2.0D 0*X(3)/WDET))
        GC(6)=X(13)*((X(7)-X(1))*(WRD*(X(6)*X(3)**2-X(3)*X(4)*X(5))+
     &                4.0D 0*X(6)/WDET)+
     &               (X(10)-X(2))*(WRE*(X(6)*X(3)**2-X(3)*X(4)*X(5))-
     &                2.0D 0*X(4)/WDET))
        GC(7)=WRA*X(13)
        GC(10)=WRB*X(13)
        GC(13)=WRA*(X(7)-X(1))+WRB*(X(10)-X(2))
      ELSEIF (KC.EQ.4) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRB=-2.0D 0*(X(3)*X(5)+X(4)*X(6))/WDET
        WRC=2.0D 0*(X(3)**2+X(4)**2)/WDET
        WRE=4.0D 0*(X(3)*X(5)+X(4)*X(6))/WDET**2
        WRF=-4.0D 0*(X(3)**2+X(4)**2)/WDET**2
        GC(1)=-WRB*X(13)
        GC(2)=-WRC*X(13)
        GC(3)=X(13)*((X(10)-X(2))*(WRF*(X(3)*X(6)**2-X(4)*X(5)*X(6))+
     &                4.0D 0*X(3)/WDET)+
     &               (X(7)-X(1))*(WRE*(X(3)*X(6)**2-X(4)*X(5)*X(6))-
     &                2.0D 0*X(5)/WDET))
        GC(4)=X(13)*((X(10)-X(2))*(WRF*(X(4)*X(5)**2-X(3)*X(5)*X(6))+
     &                4.0D 0*X(4)/WDET)+
     &               (X(7)-X(1))*(WRE*(X(4)*X(5)**2-X(3)*X(5)*X(6))-
     &                2.0D 0*X(6)/WDET))
        GC(5)=X(13)*((X(10)-X(2))*WRF*(X(5)*X(4)**2-X(3)*X(4)*X(6))+
     &               (X(7)-X(1))*(WRE*(X(5)*X(4)**2-X(3)*X(4)*X(6))-
     &                2.0D 0*X(3)/WDET))
        GC(6)=X(13)*((X(10)-X(2))*WRF*(X(6)*X(3)**2-X(3)*X(4)*X(5))+
     &               (X(7)-X(1))*(WRE*(X(6)*X(3)**2-X(3)*X(4)*X(5))-
     &                2.0D 0*X(4)/WDET))
        GC(7)=WRB*X(13)
        GC(10)=WRC*X(13)+2.0D 0
        GC(13)=WRC*(X(10)-X(2))+WRB*(X(7)-X(1))
      ELSEIF (KC.EQ.5) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRA=2.0D 0*(X(5)**2+X(6)**2)/WDET
        WRB=-2.0D 0*(X(3)*X(5)+X(4)*X(6))/WDET
        WRD=-4.0D 0*(X(5)**2+X(6)**2)/WDET**2
        WRE=4.0D 0*(X(3)*X(5)+X(4)*X(6))/WDET**2
        GC(1)=-WRA*X(14)
        GC(2)=-WRB*X(14)
        GC(3)=X(14)*((X(8)-X(1))*WRD*(X(3)*X(6)**2-X(4)*X(5)*X(6))+
     &               (X(11)-X(2))*(WRE*(X(3)*X(6)**2-X(4)*X(5)*X(6))-
     &                2.0D 0*X(5)/WDET))
        GC(4)=X(14)*((X(8)-X(1))*WRD*(X(4)*X(5)**2-X(3)*X(5)*X(6))+
     &               (X(11)-X(2))*(WRE*(X(4)*X(5)**2-X(3)*X(5)*X(6))-
     &                2.0D 0*X(6)/WDET))
        GC(5)=X(14)*((X(8)-X(1))*(WRD*(X(5)*X(4)**2-X(3)*X(4)*X(6))+
     &                4.0D 0*X(5)/WDET)+
     &               (X(11)-X(2))*(WRE*(X(5)*X(4)**2-X(3)*X(4)*X(6))-
     &                2.0D 0*X(3)/WDET))
        GC(6)=X(14)*((X(8)-X(1))*(WRD*(X(6)*X(3)**2-X(3)*X(4)*X(5))+
     &                4.0D 0*X(6)/WDET)+
     &               (X(11)-X(2))*(WRE*(X(6)*X(3)**2-X(3)*X(4)*X(5))-
     &                2.0D 0*X(4)/WDET))
        GC(8)=WRA*X(14)
        GC(11)=WRB*X(14)
        GC(14)=WRA*(X(8)-X(1))+WRB*(X(11)-X(2))
      ELSEIF (KC.EQ.6) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRB=-2.0D 0*(X(3)*X(5)+X(4)*X(6))/WDET
        WRC=2.0D 0*(X(3)**2+X(4)**2)/WDET
        WRE=4.0D 0*(X(3)*X(5)+X(4)*X(6))/WDET**2
        WRF=-4.0D 0*(X(3)**2+X(4)**2)/WDET**2
        GC(1)=-WRB*X(14)
        GC(2)=-WRC*X(14)
        GC(3)=X(14)*((X(11)-X(2))*(WRF*(X(3)*X(6)**2-X(4)*X(5)*X(6))+
     &                4.0D 0*X(3)/WDET)+
     &               (X(8)-X(1))*(WRE*(X(3)*X(6)**2-X(4)*X(5)*X(6))-
     &                2.0D 0*X(5)/WDET))
        GC(4)=X(14)*((X(11)-X(2))*(WRF*(X(4)*X(5)**2-X(3)*X(5)*X(6))+
     &                4.0D 0*X(4)/WDET)+
     &               (X(8)-X(1))*(WRE*(X(4)*X(5)**2-X(3)*X(5)*X(6))-
     &                2.0D 0*X(6)/WDET))
        GC(5)=X(14)*((X(11)-X(2))*WRF*(X(5)*X(4)**2-X(3)*X(4)*X(6))+
     &               (X(8)-X(1))*(WRE*(X(5)*X(4)**2-X(3)*X(4)*X(6))-
     &                2.0D 0*X(3)/WDET))
        GC(6)=X(14)*((X(11)-X(2))*WRF*(X(6)*X(3)**2-X(3)*X(4)*X(5))+
     &               (X(8)-X(1))*(WRE*(X(6)*X(3)**2-X(3)*X(4)*X(5))-
     &                2.0D 0*X(4)/WDET))
        GC(8)=WRB*X(14)
        GC(11)=WRC*X(14)
        GC(14)=WRC*(X(11)-X(2))+WRB*(X(8)-X(1))
      ELSEIF (KC.EQ.7) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRA=2.0D 0*(X(5)**2+X(6)**2)/WDET
        WRB=-2.0D 0*(X(3)*X(5)+X(4)*X(6))/WDET
        WRD=-4.0D 0*(X(5)**2+X(6)**2)/WDET**2
        WRE=4.0D 0*(X(3)*X(5)+X(4)*X(6))/WDET**2
        GC(1)=-WRA*X(15)
        GC(2)=-WRB*X(15)
        GC(3)=X(15)*((X(9)-X(1))*WRD*(X(3)*X(6)**2-X(4)*X(5)*X(6))+
     &               (X(12)-X(2))*(WRE*(X(3)*X(6)**2-X(4)*X(5)*X(6))-
     &                2.0D 0*X(5)/WDET))
        GC(4)=X(15)*((X(9)-X(1))*WRD*(X(4)*X(5)**2-X(3)*X(5)*X(6))+
     &               (X(12)-X(2))*(WRE*(X(4)*X(5)**2-X(3)*X(5)*X(6))-
     &                2.0D 0*X(6)/WDET))
        GC(5)=X(15)*((X(9)-X(1))*(WRD*(X(5)*X(4)**2-X(3)*X(4)*X(6))+
     &                4.0D 0*X(5)/WDET)+
     &               (X(12)-X(2))*(WRE*(X(5)*X(4)**2-X(3)*X(4)*X(6))-
     &                2.0D 0*X(3)/WDET))
        GC(6)=X(15)*((X(9)-X(1))*(WRD*(X(6)*X(3)**2-X(3)*X(4)*X(5))+
     &                4.0D 0*X(6)/WDET)+
     &               (X(12)-X(2))*(WRE*(X(6)*X(3)**2-X(3)*X(4)*X(5))-
     &                2.0D 0*X(4)/WDET))
        GC(9)=WRA*X(15)
        GC(12)=WRB*X(15)
        GC(15)=WRA*(X(9)-X(1))+WRB*(X(12)-X(2))
      ELSEIF (KC.EQ.8) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRB=-2.0D 0*(X(3)*X(5)+X(4)*X(6))/WDET
        WRC=2.0D 0*(X(3)**2+X(4)**2)/WDET
        WRE=4.0D 0*(X(3)*X(5)+X(4)*X(6))/WDET**2
        WRF=-4.0D 0*(X(3)**2+X(4)**2)/WDET**2
        GC(1)=-WRB*X(15)
        GC(2)=-WRC*X(15)
        GC(3)=X(15)*((X(12)-X(2))*(WRF*(X(3)*X(6)**2-X(4)*X(5)*X(6))+
     &                4.0D 0*X(3)/WDET)+
     &               (X(9)-X(1))*(WRE*(X(3)*X(6)**2-X(4)*X(5)*X(6))-
     &                2.0D 0*X(5)/WDET))
        GC(4)=X(15)*((X(12)-X(2))*(WRF*(X(4)*X(5)**2-X(3)*X(5)*X(6))+
     &                4.0D 0*X(4)/WDET)+
     &               (X(9)-X(1))*(WRE*(X(4)*X(5)**2-X(3)*X(5)*X(6))-
     &                2.0D 0*X(6)/WDET))
        GC(5)=X(15)*((X(12)-X(2))*WRF*(X(5)*X(4)**2-X(3)*X(4)*X(6))+
     &               (X(9)-X(1))*(WRE*(X(5)*X(4)**2-X(3)*X(4)*X(6))-
     &                2.0D 0*X(3)/WDET))
        GC(6)=X(15)*((X(12)-X(2))*WRF*(X(6)*X(3)**2-X(3)*X(4)*X(5))+
     &               (X(9)-X(1))*(WRE*(X(6)*X(3)**2-X(3)*X(4)*X(5))-
     &                2.0D 0*X(4)/WDET))
        GC(9)=WRB*X(15)
        GC(12)=WRC*X(15)
        GC(15)=WRC*(X(12)-X(2))+WRB*(X(9)-X(1))
      ELSEIF (KC.EQ.9) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRA=2.0D 0*(X(5)**2+X(6)**2)/WDET
        WRB=-2.0D 0*(X(3)*X(5)+X(4)*X(6))/WDET
        WRC=2.0D 0*(X(3)**2+X(4)**2)/WDET
        WRD=-2.0D 0*(X(5)**2+X(6)**2)/WDET**2
        WRE=4.0D 0*(X(3)*X(5)+X(4)*X(6))/WDET**2
        WRF=-2.0D 0*(X(3)**2+X(4)**2)/WDET**2
        GC(1)=-WRA*(X(7)-X(1))-WRB*(X(10)-X(2))
        GC(2)=-WRB*(X(7)-X(1))-WRC*(X(10)-X(2))
        GC(3)=(X(7)-X(1))**2*WRD*(X(3)*X(6)**2-X(4)*X(5)*X(6))+
     &        (X(7)-X(1))*(X(10)-X(2))*
     &        (WRE*(X(3)*X(6)**2-X(4)*X(5)*X(6))-2.0D 0*X(5)/WDET)+
     &        (X(10)-X(2))**2*(WRF*(X(3)*X(6)**2-X(4)*X(5)*X(6))+
     &         2.0D 0*X(3)/WDET)
        GC(4)=(X(7)-X(1))**2*WRD*(X(4)*X(5)**2-X(3)*X(5)*X(6))+
     &        (X(7)-X(1))*(X(10)-X(2))*
     &        (WRE*(X(4)*X(5)**2-X(3)*X(5)*X(6))-2.0D 0*X(6)/WDET)+
     &        (X(10)-X(2))**2*(WRF*(X(4)*X(5)**2-X(3)*X(5)*X(6))+
     &         2.0D 0*X(4)/WDET)
        GC(5)=(X(7)-X(1))**2*(WRD*(X(5)*X(4)**2-X(3)*X(4)*X(6))+
     &         2.0D 0*X(5)/WDET)+
     &        (X(7)-X(1))*(X(10)-X(2))*
     &        (WRE*(X(5)*X(4)**2-X(3)*X(4)*X(6))-2.0D 0*X(3)/WDET)+
     &        (X(10)-X(2))**2*WRF*(X(5)*X(4)**2-X(3)*X(4)*X(6))
        GC(6)=(X(7)-X(1))**2*(WRD*(X(6)*X(3)**2-X(3)*X(4)*X(5))+
     &         2.0D 0*X(6)/WDET)+
     &        (X(7)-X(1))*(X(10)-X(2))*
     &        (WRE*(X(6)*X(3)**2-X(3)*X(4)*X(5))-2.0D 0*X(4)/WDET)+
     &        (X(10)-X(2))**2*WRF*(X(6)*X(3)**2-X(3)*X(4)*X(5))
        GC(7)=WRA*(X(7)-X(1))+WRB*(X(10)-X(2))
        GC(10)=WRB*(X(7)-X(1))+WRC*(X(10)-X(2))
      ELSEIF (KC.EQ.10) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRA=2.0D 0*(X(5)**2+X(6)**2)/WDET
        WRB=-2.0D 0*(X(3)*X(5)+X(4)*X(6))/WDET
        WRC=2.0D 0*(X(3)**2+X(4)**2)/WDET
        WRD=-2.0D 0*(X(5)**2+X(6)**2)/WDET**2
        WRE=4.0D 0*(X(3)*X(5)+X(4)*X(6))/WDET**2
        WRF=-2.0D 0*(X(3)**2+X(4)**2)/WDET**2
        GC(1)=-WRA*(X(8)-X(1))-WRB*(X(11)-X(2))
        GC(2)=-WRB*(X(8)-X(1))-WRC*(X(11)-X(2))
        GC(3)=(X(8)-X(1))**2*WRD*(X(3)*X(6)**2-X(4)*X(5)*X(6))+
     &        (X(8)-X(1))*(X(11)-X(2))*
     &        (WRE*(X(3)*X(6)**2-X(4)*X(5)*X(6))-2.0D 0*X(5)/WDET)+
     &        (X(11)-X(2))**2*(WRF*(X(3)*X(6)**2-X(4)*X(5)*X(6))+
     &         2.0D 0*X(3)/WDET)
        GC(4)=(X(8)-X(1))**2*WRD*(X(4)*X(5)**2-X(3)*X(5)*X(6))+
     &        (X(8)-X(1))*(X(11)-X(2))*
     &        (WRE*(X(4)*X(5)**2-X(3)*X(5)*X(6))-2.0D 0*X(6)/WDET)+
     &        (X(11)-X(2))**2*(WRF*(X(4)*X(5)**2-X(3)*X(5)*X(6))+
     &         2.0D 0*X(4)/WDET)
        GC(5)=(X(8)-X(1))**2*(WRD*(X(5)*X(4)**2-X(3)*X(4)*X(6))+
     &         2.0D 0*X(5)/WDET)+
     &        (X(8)-X(1))*(X(11)-X(2))*
     &        (WRE*(X(5)*X(4)**2-X(3)*X(4)*X(6))-2.0D 0*X(3)/WDET)+
     &        (X(11)-X(2))**2*WRF*(X(5)*X(4)**2-X(3)*X(4)*X(6))
        GC(6)=(X(8)-X(1))**2*(WRD*(X(6)*X(3)**2-X(3)*X(4)*X(5))+
     &         2.0D 0*X(6)/WDET)+
     &        (X(8)-X(1))*(X(11)-X(2))*
     &        (WRE*(X(6)*X(3)**2-X(3)*X(4)*X(5))-2.0D 0*X(4)/WDET)+
     &        (X(11)-X(2))**2*WRF*(X(6)*X(3)**2-X(3)*X(4)*X(5))
        GC(8)=WRA*(X(8)-X(1))+WRB*(X(11)-X(2))
        GC(11)=WRB*(X(8)-X(1))+WRC*(X(11)-X(2))
      ELSEIF (KC.EQ.11) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRA=2.0D 0*(X(5)**2+X(6)**2)/WDET
        WRB=-2.0D 0*(X(3)*X(5)+X(4)*X(6))/WDET
        WRC=2.0D 0*(X(3)**2+X(4)**2)/WDET
        WRD=-2.0D 0*(X(5)**2+X(6)**2)/WDET**2
        WRE=4.0D 0*(X(3)*X(5)+X(4)*X(6))/WDET**2
        WRF=-2.0D 0*(X(3)**2+X(4)**2)/WDET**2
        GC(1)=-WRA*(X(9)-X(1))-WRB*(X(12)-X(2))
        GC(2)=-WRB*(X(9)-X(1))-WRC*(X(12)-X(2))
        GC(3)=(X(9)-X(1))**2*WRD*(X(3)*X(6)**2-X(4)*X(5)*X(6))+
     &        (X(9)-X(1))*(X(12)-X(2))*
     &        (WRE*(X(3)*X(6)**2-X(4)*X(5)*X(6))-2.0D 0*X(5)/WDET)+
     &        (X(12)-X(2))**2*(WRF*(X(3)*X(6)**2-X(4)*X(5)*X(6))+
     &         2.0D 0*X(3)/WDET)
        GC(4)=(X(9)-X(1))**2*WRD*(X(4)*X(5)**2-X(3)*X(5)*X(6))+
     &        (X(9)-X(1))*(X(12)-X(2))*
     &        (WRE*(X(4)*X(5)**2-X(3)*X(5)*X(6))-2.0D 0*X(6)/WDET)+
     &        (X(12)-X(2))**2*(WRF*(X(4)*X(5)**2-X(3)*X(5)*X(6))+
     &         2.0D 0*X(4)/WDET)
        GC(5)=(X(9)-X(1))**2*(WRD*(X(5)*X(4)**2-X(3)*X(4)*X(6))+
     &         2.0D 0*X(5)/WDET)+
     &        (X(9)-X(1))*(X(12)-X(2))*
     &        (WRE*(X(5)*X(4)**2-X(3)*X(4)*X(6))-2.0D 0*X(3)/WDET)+
     &        (X(12)-X(2))**2*WRF*(X(5)*X(4)**2-X(3)*X(4)*X(6))
        GC(6)=(X(9)-X(1))**2*(WRD*(X(6)*X(3)**2-X(3)*X(4)*X(5))+
     &         2.0D 0*X(6)/WDET)+
     &        (X(9)-X(1))*(X(12)-X(2))*
     &        (WRE*(X(6)*X(3)**2-X(3)*X(4)*X(5))-2.0D 0*X(4)/WDET)+
     &        (X(12)-X(2))**2*WRF*(X(6)*X(3)**2-X(3)*X(4)*X(5))
        GC(9)=WRA*(X(9)-X(1))+WRB*(X(12)-X(2))
        GC(12)=WRB*(X(9)-X(1))+WRC*(X(12)-X(2))
      ENDIF
      RETURN
  280 IF (KC.EQ.1) THEN
        GC(7)=-1.0D 0
        GC(10)=-2.0D 0*X(10)
      ELSEIF (KC.EQ.2) THEN
        X(8)=1.0D 0
        X(11)=4.0D 0
      ELSEIF (KC.EQ.3) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRA=2.0D 0*(X(5)**2+X(6)**2)
        WRB=-2.0D 0*(X(3)*X(5)+X(4)*X(6))
        GC(1)=-WRA*X(13)
        GC(2)=-WRB*X(13)
        GC(3)=2.0D 0*(-X(13)*(X(10)-X(2))*X(5)+
     &                 X(3)*X(6)**2-X(4)*X(5)*X(6))
        GC(4)=2.0D 0*(-X(13)*(X(10)-X(2))*X(6)+
     &                 X(4)*X(5)**2-X(3)*X(5)*X(6))
        GC(5)=2.0D 0*(X(13)*((X(7)-X(1))*2.0D 0*X(5)-
     &        (X(10)-X(2))*X(3))+X(5)*X(4)**2-X(3)*X(4)*X(6))
        GC(6)=2.0D 0*(X(13)*((X(7)-X(1))*2.0D 0*X(6)-
     &        (X(10)-X(2))*X(4))+X(6)*X(3)**2-X(3)*X(4)*X(5))
        GC(7)=WRA*X(13)
        GC(10)=WRB*X(13)
        GC(13)=WRA*(X(7)-X(1))+WRB*(X(10)-X(2))
      ELSEIF (KC.EQ.4) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRB=-2.0D 0*(X(3)*X(5)+X(4)*X(6))
        WRC=2.0D 0*(X(3)**2+X(4)**2)
        GC(1)=-WRB*X(13)
        GC(2)=-WRC*X(13)
        GC(3)=2.0D 0*
     &        (X(13)*((X(10)-X(2))*2.0D 0*X(3)-(X(7)-X(1))*X(5))+
     &        2.0D 0*X(10)*(X(3)*X(6)**2-X(4)*X(5)*X(6)))
        GC(4)=2.0D 0*
     &        (X(13)*((X(10)-X(2))*2.0D 0*X(4)-(X(7)-X(1))*X(6))+
     &        2.0D 0*X(10)*(X(4)*X(5)**2-X(3)*X(5)*X(6)))
        GC(5)=2.0D 0*(-X(13)*(X(7)-X(1))*X(3)+
     &        2.0D 0*X(10)*(X(5)*X(4)**2-X(3)*X(4)*X(6)))
        GC(6)=2.0D 0*(-X(13)*(X(7)-X(1))*X(4)+
     &        2.0D 0*X(10)*(X(6)*X(3)**2-X(3)*X(4)*X(5)))
        GC(7)=WRB*X(13)
        GC(10)=WRC*X(13)+2.0D 0*WDET
        GC(13)=WRB*(X(7)-X(1))+WRC*(X(10)-X(2))
      ELSEIF (KC.EQ.5) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRA=2.0D 0*(X(5)**2+X(6)**2)
        WRB=-2.0D 0*(X(3)*X(5)+X(4)*X(6))
        GC(1)=-WRA*X(14)
        GC(2)=-WRB*X(14)
        GC(3)=2.0D 0*(-X(14)*(X(11)-X(2))*X(5)-
     &                 2.5D-1*(X(3)*X(6)**2-X(4)*X(5)*X(6)))
        GC(4)=2.0D 0*(-X(14)*(X(11)-X(2))*X(6)-
     &                 2.5D-1*(X(4)*X(5)**2-X(3)*X(5)*X(6)))
        GC(5)=2.0D 0*(X(14)*((X(8)-X(1))*2.0D 0*X(5)-
     &        (X(11)-X(2))*X(3))-2.5D-1*(X(5)*X(4)**2-X(3)*X(4)*X(6)))
        GC(6)=2.0D 0*(X(14)*((X(8)-X(1))*2.0D 0*X(6)-
     &        (X(11)-X(2))*X(4))-2.5D-1*(X(6)*X(3)**2-X(3)*X(4)*X(5)))
        GC(8)=WRA*X(14)
        GC(11)=WRB*X(14)
        GC(14)=WRA*(X(8)-X(1))+WRB*(X(11)-X(2))
      ELSEIF (KC.EQ.6) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRB=-2.0D 0*(X(3)*X(5)+X(4)*X(6))
        WRC=2.0D 0*(X(3)**2+X(4)**2)
        GC(1)=-WRB*X(14)
        GC(2)=-WRC*X(14)
        GC(3)=2.0D 0*
     &        (X(14)*((X(11)-X(2))*2.0D 0*X(3)-(X(8)-X(1))*X(5))-
     &        (X(3)*X(6)**2-X(4)*X(5)*X(6)))
        GC(4)=2.0D 0*
     &        (X(14)*((X(11)-X(2))*2.0D 0*X(4)-(X(8)-X(1))*X(6))-
     &        (X(4)*X(5)**2-X(3)*X(5)*X(6)))
        GC(5)=2.0D 0*(-X(14)*(X(8)-X(1))*X(3)-
     &        (X(5)*X(4)**2-X(3)*X(4)*X(6)))
        GC(6)=2.0D 0*(-X(14)*(X(8)-X(1))*X(4)-
     &        (X(6)*X(3)**2-X(3)*X(4)*X(5)))
        GC(8)=WRB*X(14)
        GC(11)=WRC*X(14)
        GC(14)=WRB*(X(8)-X(1))+WRC*(X(11)-X(2))
      ELSEIF (KC.EQ.7) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRA=2.0D 0*(X(5)**2+X(6)**2)
        WRB=-2.0D 0*(X(3)*X(5)+X(4)*X(6))
        GC(1)=-WRA*X(15)
        GC(2)=-WRB*X(15)
        GC(3)=2.0D 0*(-X(15)*(X(12)-X(2))*X(5))
        GC(4)=2.0D 0*(-X(15)*(X(12)-X(2))*X(6))
        GC(5)=2.0D 0*(X(15)*((X(9)-X(1))*2.0D 0*X(5)-
     &        (X(12)-X(2))*X(3)))
        GC(6)=2.0D 0*(X(15)*((X(9)-X(1))*2.0D 0*X(6)-
     &        (X(12)-X(2))*X(4)))
        GC(9)=WRA*X(15)
        GC(12)=WRB*X(15)
        GC(15)=WRA*(X(9)-X(1))+WRB*(X(12)-X(2))
      ELSEIF (KC.EQ.8) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRB=-2.0D 0*(X(3)*X(5)+X(4)*X(6))
        WRC=2.0D 0*(X(3)**2+X(4)**2)
        GC(1)=-WRB*X(15)
        GC(2)=-WRC*X(15)
        GC(3)=2.0D 0*
     &        (X(15)*((X(12)-X(2))*2.0D 0*X(3)-(X(9)-X(1))*X(5))+
     &        (X(3)*X(6)**2-X(4)*X(5)*X(6)))
        GC(4)=2.0D 0*
     &        (X(15)*((X(12)-X(2))*2.0D 0*X(4)-(X(9)-X(1))*X(6))+
     &        (X(4)*X(5)**2-X(3)*X(5)*X(6)))
        GC(5)=2.0D 0*(-X(15)*(X(9)-X(1))*X(3)+
     &        (X(5)*X(4)**2-X(3)*X(4)*X(6)))
        GC(6)=2.0D 0*(-X(15)*(X(9)-X(1))*X(4)+
     &        (X(6)*X(3)**2-X(3)*X(4)*X(5)))
        GC(9)=WRB*X(15)
        GC(12)=WRC*X(15)
        GC(15)=WRB*(X(9)-X(1))+WRC*(X(12)-X(2))
      ELSEIF (KC.EQ.9) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRA=2.0D 0*(X(5)**2+X(6)**2)
        WRB=-2.0D 0*(X(3)*X(5)+X(4)*X(6))
        WRC=2.0D 0*(X(3)**2+X(4)**2)
        GC(1)=-WRA*(X(7)-X(1))-WRB*(X(10)-X(2))
        GC(2)=-WRB*(X(7)-X(1))-WRC*(X(10)-X(2))
        GC(3)=2.0D 0*(X(10)-X(2))*(X(3)*(X(10)-X(2))-X(5)*(X(7)-X(1)))
     &       -2.0D 0*(X(3)*X(6)**2-X(4)*X(5)*X(6))
        GC(4)=2.0D 0*(X(10)-X(2))*(X(4)*(X(10)-X(2))-X(6)*(X(7)-X(1)))
     &       -2.0D 0*(X(4)*X(5)**2-X(3)*X(5)*X(6))
        GC(5)=2.0D 0*(X(7)-X(1))*(X(5)*(X(7)-X(1))-X(3)*(X(10)-X(2)))
     &       -2.0D 0*(X(5)*X(4)**2-X(3)*X(4)*X(6))
        GC(6)=2.0D 0*(X(7)-X(1))*(X(6)*(X(7)-X(1))-X(4)*(X(10)-X(2)))
     &       -2.0D 0*(X(6)*X(3)**2-X(3)*X(4)*X(5))
        GC(7)=WRA*(X(7)-X(1))+WRB*(X(10)-X(2))
        GC(10)=WRB*(X(7)-X(1))+WRC*(X(10)-X(2))
      ELSEIF (KC.EQ.10) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRA=2.0D 0*(X(5)**2+X(6)**2)
        WRB=-2.0D 0*(X(3)*X(5)+X(4)*X(6))
        WRC=2.0D 0*(X(3)**2+X(4)**2)
        GC(1)=-WRA*(X(8)-X(1))-WRB*(X(11)-X(2))
        GC(2)=-WRB*(X(8)-X(1))-WRC*(X(11)-X(2))
        GC(3)=2.0D 0*(X(11)-X(2))*(X(3)*(X(11)-X(2))-X(5)*(X(8)-X(1)))
     &       -2.0D 0*(X(3)*X(6)**2-X(4)*X(5)*X(6))
        GC(4)=2.0D 0*(X(11)-X(2))*(X(4)*(X(11)-X(2))-X(6)*(X(8)-X(1)))
     &       -2.0D 0*(X(4)*X(5)**2-X(3)*X(5)*X(6))
        GC(5)=2.0D 0*(X(8)-X(1))*(X(5)*(X(8)-X(1))-X(3)*(X(11)-X(2)))
     &       -2.0D 0*(X(5)*X(4)**2-X(3)*X(4)*X(6))
        GC(6)=2.0D 0*(X(8)-X(1))*(X(6)*(X(8)-X(1))-X(4)*(X(11)-X(2)))
     &       -2.0D 0*(X(6)*X(3)**2-X(3)*X(4)*X(5))
        GC(8)=WRA*(X(8)-X(1))+WRB*(X(11)-X(2))
        GC(11)=WRB*(X(8)-X(1))+WRC*(X(11)-X(2))
      ELSEIF (KC.EQ.11) THEN
        WDET=X(3)**2*X(6)**2+X(4)**2*X(5)**2-2*X(3)*X(5)*X(4)*X(6)
        WRA=2.0D 0*(X(5)**2+X(6)**2)
        WRB=-2.0D 0*(X(3)*X(5)+X(4)*X(6))
        WRC=2.0D 0*(X(3)**2+X(4)**2)
        GC(1)=-WRA*(X(9)-X(1))-WRB*(X(12)-X(2))
        GC(2)=-WRB*(X(9)-X(1))-WRC*(X(12)-X(2))
        GC(3)=2.0D 0*(X(12)-X(2))*(X(3)*(X(12)-X(2))-X(5)*(X(9)-X(1)))
     &       -2.0D 0*(X(3)*X(6)**2-X(4)*X(5)*X(6))
        GC(4)=2.0D 0*(X(12)-X(2))*(X(4)*(X(12)-X(2))-X(6)*(X(9)-X(1)))
     &       -2.0D 0*(X(4)*X(5)**2-X(3)*X(5)*X(6))
        GC(5)=2.0D 0*(X(9)-X(1))*(X(5)*(X(9)-X(1))-X(3)*(X(12)-X(2)))
     &       -2.0D 0*(X(5)*X(4)**2-X(3)*X(4)*X(6))
        GC(6)=2.0D 0*(X(9)-X(1))*(X(6)*(X(9)-X(1))-X(4)*(X(12)-X(2)))
     &       -2.0D 0*(X(6)*X(3)**2-X(3)*X(4)*X(5))
        GC(9)=WRA*(X(9)-X(1))+WRB*(X(12)-X(2))
        GC(12)=WRB*(X(9)-X(1))+WRC*(X(12)-X(2))
      ENDIF
      RETURN
  290 IF (KC.EQ.1) THEN
        GC(5)=-1.0D 0
        GC(8)=-2.0D 0*X(8)
      ELSEIF (KC.EQ.2) THEN
        GC(6)=1.0D 0
        GC(9)=4.0D 0
      ELSEIF (KC.EQ.3) THEN
        GC(11)=1.0D 0
        GC(17)=-1.0D 0
      ELSEIF (KC.EQ.4) THEN
        GC(8)=2.0D 0
        GC(14)=1.0D 0
        GC(20)=-1.0D 0
      ELSEIF (KC.EQ.5) THEN
        GC(12)=1.0D 0
        GC(18)=-1.0D 0
      ELSEIF (KC.EQ.6) THEN
        GC(15)=1.0D 0
        GC(21)=-1.0D 0
      ELSEIF (KC.EQ.7) THEN
        GC(13)=1.0D 0
        GC(19)=-1.0D 0
      ELSEIF (KC.EQ.8) THEN
        GC(16)=1.0D 0
        GC(22)=-1.0D 0
      ELSEIF (KC.LE.11) THEN
        GC(1)=-1.0D 0
        GC(KC-4)=1.0D 0
      ELSEIF (KC.LE.14) THEN
        GC(2)=-1.0D 0
        GC(KC-4)=1.0D 0
      ELSEIF (KC.LE.17) THEN
        GC(3)=1.0D 0
        GC(KC-10)=-1.0D 0
      ELSEIF (KC.LE.20) THEN
        GC(4)=1.0D 0
        GC(KC-10)=-1.0D 0
      ENDIF
      RETURN
      END
