* SUBROUTINE EEDU38             ALL SYSTEMS                 06/12/01
C PORTABILITY : ALL SYSTEMS
C 06/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF TEST FUNCTIONS FOR PARAMETER ESTIMATION OF DYNAMICAL
*  SYSTEMS. UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  NE  NUMBER OF DIFFERENTIAL EQUATIONS.
*  II  KE  INDEX OF THE DIFFERENTIAL EQUATION.
*  RI  YA(NE)  SOLUTION VECTOR.
*  RO  DE(NE)  GRADIENT OF THE RIGHT HAND SIDE FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EEDU38(NE,KE,YA,DE,NEXT)
      INTEGER NE,KE,NEXT
      REAL*8 YA(NE),DE(NE)
      REAL*8 W1,W2,W3,W4,W5,W6
C      REAL*8 UE,UB,UF,ALPHA,BETA,R0,R1,R2,R3,R4,R5,R6,R7,R8,R9
C      COMMON /EMPR38/ UE,UB,UF,ALPHA,BETA,R0,R1,R2,R3,R4,R5,R6,R7,R8,R9
      GOTO (10,20,30,40),NEXT
   10 W1=0.012277471D 0
      W2=1.0D 0-W1
      W3=(YA(1)+W1)**2+YA(2)**2
      W5=W3*SQRT(W3)
      W4=(YA(1)-W2)**2+YA(2)**2
      W6=W4*SQRT(W4)
      GO TO (11,12,13,14) KE
   11 DE(1)=0.0D 0
      DE(2)=0.0D 0
      DE(3)=1.0D 0
      DE(4)=0.0D 0
      RETURN
   12 DE(1)=0.0D 0
      DE(2)=0.0D 0
      DE(3)=0.0D 0
      DE(4)=1.0D 0
      RETURN
   13 DE(1)=1.0D 0-W2/W5+3.0D 0*W2*(YA(1)+W1)**2/(W3*W5)-W1/W6+3.0D 0*W1
     &    *(YA(1)-W2)**2/(W4*W6)
      DE(2)=3.0D 0*W2*(YA(1)+W1)*YA(2)/(W3*W5)+3.0D 0*W1*(YA(1)-W2)*YA(2
     &    )/(W4*W6)
      DE(3)=0.0D 0
      DE(4)=2.0D 0
      RETURN
   14 DE(1)=3.0D 0*W2*(YA(1)+W1)*YA(2)/(W3*W5)+3.0D 0*W1*(YA(1)-W2)*YA(2
     &    )/(W4*W6)
      DE(2)=1.0D 0-W2/W5+3.0D 0*W2*YA(2)**2/(W3*W5)-W1/W6+3.0D 0*W1*YA(2
     &    )**2/(W4*W6)
      DE(3)=-2.0D 0
      DE(4)=0.0D 0
      RETURN
   20 W1=1.0D 1
      W2=2.8D 1
      W3=8.0D 0/3.0D 0
      GO TO (21,22,23) KE
   21 DE(1)=-W1
      DE(2)= W1
      DE(3)=0.0D 0
      RETURN
   22 DE(1)=-YA(3)+W2
      DE(2)=-1.0D 0
      DE(3)=-YA(1)
      RETURN
   23 DE(1)=YA(2)
      DE(2)=YA(1)
      DE(3)=-W3
      RETURN
   30 W1=1.0D-6
      GO TO (31,32) KE
   31 DE(1)=0.0D 0
      DE(2)=1.0D 0
      RETURN
   32 DE(1)=(-2.0D 0*YA(1)*YA(2)-1.0D 0)/W1
      DE(2)=(1.0D 0-YA(1)**2)/W1
      RETURN
   40 GO TO (41,42,43) KE
   41 DE(1)=-4.0D-2
      DE(2)= 1.0D 4*YA(3)
      DE(3)= 1.0D 4*YA(2)
      RETURN
   42 DE(1)= 4.0D-2
      DE(2)=-1.0D 4*YA(3)-6.0D 7*YA(2)
      DE(3)=-1.0D 4*YA(2)
      RETURN
   43 DE(1)= 0.0D 0
      DE(2)= 6.0D 7*YA(2)
      DE(3)= 0.0D 0
      RETURN
      RETURN
C   50 W1=BETA*EXP((YA(4)-YA(3))/UF)/UF
C      W2=BETA*EXP((YA(7)-YA(6))/UF)/UF
C      GO TO (51,52,53,54,55,56,57,58) KE
C   51 CALL UXVSET(NE,0.0D 0,DE)
C      DE(4)=ALPHA*W1
C      DE(7)=ALPHA*W2
C      RETURN
C   52 CALL UXVSET(NE,0.0D 0,DE)
C      DE(3)=-ALPHA*W1
C      DE(4)=-W1
C      DE(6)=-ALPHA*W2
C      DE(7)=-W2
C      RETURN
C   53 CONTINUE
C      DE(1)=1.0D 0/R9
C      DE(2)=1.0D 0/R8
C      DE(3)=1.0D 0/R7+W1
C      DE(4)=1.0D 0/R5+1.0D 0/R6+(1.0D 0-ALPHA)*W1
C      DE(5)=1.0D 0/R4
C      DE(6)=1.0D 0/R3+W2
C      DE(7)=1.0D 0/R1+1.0D 0/R2+(1.0D 0-ALPHA)*W2
C      DE(8)=1.0D 0/R0
C      RETURN
C   54 CALL UXVSET(NE,0.0D 0,DE)
C      DE(6)=-(1.0D 0-ALPHA)*W2
C      DE(3)=-(1.0D 0-ALPHA)*W1
C      RETURN
      END
