* SUBROUTINE EEFU38             ALL SYSTEMS                 06/12/01
C PORTABILITY : ALL SYSTEMS
C 06/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF TEST FUNCTIONS FOR PARAMETER ESTIMATION OF DYNAMICAL
*  SYSTEMS. UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  NE  NUMBER OF DIFFERENTIAL EQUATIONS.
*  II  KE  INDEX OF THE DIFFERENTIAL EQUATION.
*  RI  YA(NE)  SOLUTION VECTOR.
*  RO  FE  VALUE OF THE RIGHT HAND SIDE FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EEFU38(NE,KE,YA,FE,NEXT)
      INTEGER NE,KE,NEXT
      REAL*8 YA(NE),FE
      REAL*8 W1,W2,W3,W4
C      REAL*8 UE,UB,UF,ALPHA,BETA,R0,R1,R2,R3,R4,R5,R6,R7,R8,R9
C      COMMON /EMPR38/ UE,UB,UF,ALPHA,BETA,R0,R1,R2,R3,R4,R5,R6,R7,R8,R9
      GO TO (10,20,30,40),NEXT
   10 W1=0.012277471D 0
      W2=1.0D 0-W1
      W3=(YA(1)+W1)**2+YA(2)**2
      W3=W3*SQRT(W3)
      W4=(YA(1)-W2)**2+YA(2)**2
      W4=W4*SQRT(W4)
      GO TO (11,12,13,14) KE
   11 FE=YA(3)
      RETURN
   12 FE=YA(4)
      RETURN
   13 FE=YA(1)+2*YA(4)-W2*(YA(1)+W1)/W3-W1*(YA(1)-W2)/W4
      RETURN
   14 FE=YA(2)-2*YA(3)-W2*YA(2)/W3-W1*YA(2)/W4
      RETURN
   20 W1=1.0D 1
      W2=2.8D 1
      W3=8.0D 0/3.0D 0
      GO TO (21,22,23) KE
   21 FE=-W1*YA(1)+W1*YA(2)
      RETURN
   22 FE=-YA(1)*YA(3)+W2*YA(1)-YA(2)
      RETURN
   23 FE=YA(1)*YA(2)-W3*YA(3)
      RETURN
   30 W1=1.0D-6
      GO TO (31,32) KE
   31 FE=YA(2)
      RETURN
   32 FE=((1.0D 0-YA(1)**2)*YA(2)-YA(1))/W1
      RETURN
   40 GO TO (41,42,43) KE
   41 FE=-4.0D-2*YA(1)+1.0D 4*YA(2)*YA(3)
      RETURN
   42 FE= 4.0D-2*YA(1)-1.0D 4*YA(2)*YA(3)-3.0D 7*YA(2)**2
      RETURN
   43 FE=3.0D 7*YA(2)**2
      RETURN
C   50 W1=2.0D 0*3.141592654D 0*100.0D 0
C      W2=UE*DSIN(W1*TA)
C      W3=BETA*(DEXP((YA(4)-YA(3))/UF)-1.0D 0)
C      W4=BETA*(DEXP((YA(7)-YA(6))/UF)-1.0D 0)
C      GO TO (51,52,53,54,55,56,57,58) KE
C   51 FE=YA(1)/R9
C      RETURN
C   52 FE=(YA(2)-UB)/R8+ALPHA*W3
C      RETURN
C   53 FE=YA(3)/R7-W3
C      RETURN
C   54 FE=YA(4)/R5+(YA(4)-UB)/R6+(1.0D 0-ALPHA)*W3
C      RETURN
C   55 FE=(YA(5)-UB)/R4+ALPHA*W4
C      RETURN
C   56 FE=YA(6)/R3-W4
C      RETURN
C   57 FE=YA(7)/R1+(YA(7)-UB)/R2+(1.0D 0-ALPHA)*W4
C      RETURN
C   58 FE=(YA(8)-W2)/R0
C      RETURN
      END
