* SUBROUTINE EFFU10                ALL SYSTEMS                90/12/01
C PORTABILITY : ALL SYSTEMS
C 90/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF MODEL FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  SPARSE VERSION - LU VERSION WITH MODIFIED TESTS NO 7-10,12.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  F  VALUE OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EFFU10(N,X,F,NEXT)
      INTEGER N,NEXT
      REAL*8 X(N),F
      REAL*8 A,B,C,D,P,Q,R,U,V
      INTEGER I,J
      F=0.0D 0
      GOTO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150), NEXT
   10 DO 11 J=2,N
        A=X(J-1)**2-X(J)
        B=X(J-1)-1.0D 0
        F=F+1.0D 2*A**2+B**2
   11 CONTINUE
      RETURN
   20 DO 21 J=2,N-2,2
        A=X(J-1)**2-X(J)
        B=X(J-1)-1.0D 0
        C=X(J+1)**2-X(J+2)
        D=X(J+1)-1.0D 0
        U=X(J)+X(J+2)-2.0D 0
        V=X(J)-X(J+2)
        F=F+1.0D 2*A**2+B**2+9.0D 1*C**2+D**2+
     &    1.0D 1*U**2+0.1D 0*V**2
   21 CONTINUE
      RETURN
   30 DO 31 J=2,N-2,2
        A=X(J-1)+1.0D 1*X(J)
        B=X(J+1)-X(J+2)
        C=X(J)-2.0D 0*X(J+1)
        D=X(J-1)-X(J+2)
        F=F+A**2+5.0D 0*B**2+C**4+1.0D 1*D**4
   31 CONTINUE
      RETURN
   40 DO 41 J=2,N-2,2
        A=EXP(X(J-1))
        B=A-X(J)
        D=X(J)-X(J+1)
        P=X(J+1)-X(J+2)
        Q=SIN(P)/COS(P)
        U=X(J-1)
        V=X(J+2)-1.0D 0
        F=F+B**4+1.0D 2*D**6+Q**4+U**8+V**2
   41 CONTINUE
      RETURN
   50 P=7.0D 0/3.0D 0
      DO 51 J=1,N
        A=(3.0D 0-2.0D 0*X(J))*X(J)+1.0D 0
        IF (J.GT.1) A=A-X(J-1)
        IF (J.LT.N) A=A-X(J+1)
        F=F+ABS(A)**P
   51 CONTINUE
      RETURN
   60 P=7.0D 0/3.0D 0
      DO 62 J=1,N
        A=(2.0D 0+5.0D 0*X(J)**2)*X(J)+1.0D 0
        DO 61 I=MAX(1,J-5),MIN(N,J+1)
          A=A+X(I)*(1.0D 0+X(I))
   61   CONTINUE
        F=F+ABS(A)**P
   62 CONTINUE
      RETURN
   70 P=7.0D 0/3.0D 0
      DO 71 J=1,N
        A=(3.0D 0-2.0D 0*X(J))*X(J)+1.0D 0
        IF (J.GT.1) A=A-X(J-1)
        IF (J.LT.N) A=A-X(J+1)
        F=F+ABS(A)**P
   71 CONTINUE
      RETURN
   80 DO 82 I=1,N
        P=0.0D 0
        DO 81 J=1,N
          A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(J,5))
          B=DBLE(I+J)/1.0D 1
          P=P+(A*SIN(X(J))+B*COS(X(J)))**2
   81   CONTINUE
        F=F+(DBLE(3*N+I)+P)
   82 CONTINUE
      RETURN
   90 DO 92 J=1,N
        A=N+J*(1-COS(X(J)))
        IF(J.LT.N) A=A-SIN(X(J+1))
        IF(J.GT.1) A=A+SIN(X(J-1))
        F=F+ABS(A)
   92 CONTINUE
      RETURN
  100 DO 101 J=1,N
      A=DBLE(J)
      F=F+(A*X(J)/(1.0D 0+X(J)))**2
  101 CONTINUE
      RETURN
  110 P=-0.2008D-2
      Q=-0.1900D-2
      R=-0.0261D-2
      DO 112 I=0,N-5,5
      A=1.0D 0
      B=0.0D 0
      DO 111 J=1,5
      A=A*X(I+J)
      B=B+X(I+J)**2
  111 CONTINUE
      A=EXP(A)
      B=B-1.0D 1-P
      C=X(I+2)*X(I+3)-5.0D 0*X(I+4)*X(I+5)-Q
      D=X(I+1)**3+X(I+2)**3+1.0D 0-R
      F=F+A+1.0D 1*(B**2+C**2+D**2)
  112 CONTINUE
      RETURN
  120 C=0.0D 0
      DO 121 J=2,N,2
      A=X(J-1)-3.0D 0
      B=X(J-1)-X(J)
      F=F+1.0D-4*A**2-B+EXP(2.0D 1*B)
  121 CONTINUE
      RETURN
  130 DO 131 J=2,N,2
      A=X(J)**2
      B=X(J-1)**2
      C=A+1.0D 0
      D=B+1.0D 0
      F=F+B**C+A**D
  131 CONTINUE
      RETURN
  140 P=1.0D 0/DBLE(N+1)
      Q=0.5D 0*P**2
      DO 141 J=1,N
      A=2.0D 0*X(J)+Q*(X(J)+DBLE(J)*P+1.0D 0)**3
      IF(J.GT.1) A=A-X(J-1)
      IF(J.LT.N) A=A-X(J+1)
      F=F+A**2
  141 CONTINUE
      RETURN
  150 P=1.0D 0/DBLE(N+1)
      Q=2.0D 0/P
      R=6.8D 0*P
      DO 151 J=2,N
      A=X(J-1)-X(J)
      F=F+Q*X(J-1)*A
      IF (ABS(A).LE.1.0D-6) THEN
      F=F-R*EXP(X(J))*(1.0D 0+A/2.0D 0*(1.0D 0+A/3.0D 0*(1.0D 0+
     *  A/4.0D 0)))
      ELSE
      B=EXP(X(J-1))-EXP(X(J))
      F=F-R*B/A
      ENDIF
  151 CONTINUE
      F=F+Q*X(N)**2-R*(EXP(X(1))-1.0D 0)/X(1)
     &             -R*(EXP(X(N))-1.0D 0)/X(N)
      RETURN
      END
