* SUBROUTINE EFFU19                ALL SYSTEMS                94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 RA : ORIGINAL VERSION
*
* PURPOSE :
*  VALUES OF MODEL FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  F  VALUE OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EFFU19(N,X,F,NEXT)
      INTEGER N,NEXT
      REAL*8 X(N),F
      REAL*8 AI,AJ,ETA9,F1,F2,F3,F4,T,Y(2700),Z
      INTEGER I,J,KK,LL,K
      COMMON /EMPR19/ Y
      PARAMETER (ETA9=1.0D 60)
      F=0.0D 0
      GO TO (10,20,30,40,50,60,70,80,90,180,100,110,230,240,170,120,
     & 210,220,130,140,150,160,190,200,250), NEXT
   10 F=100.0D 0*(X(2)-X(1)**2)**2+(1.0D 0-X(1))**2
      RETURN
   20 T=X(1)**2+(X(2)-1.0D 0)**2-1.0D 0
      F=X(2)+ABS(T)
      RETURN
   30 F1=X(1)**2+X(2)**4
      F2=(2.0D 0-X(1))**2+(2.0D 0-X(2))**2
      F3=2.0D 0*EXP(-X(1)+X(2))
      F=MAX(F1,F2,F3)
      RETURN
   40 F1=X(1)**4+X(2)**2
      F2=(2.0D 0-X(1))**2+(2.0D 0-X(2))**2
      F3=2.0D 0*EXP(-X(1)+X(2))
      F=MAX(F1,F2,F3)
      RETURN
   50 F1=5.0D 0*X(1)+X(2)
      F2=-5.0D 0*X(1)+X(2)
      F3=X(1)**2+X(2)**2+4.0D 0*X(2)
      F=MAX(F1,F2,F3)
      RETURN
   60 F1=X(1)**2+X(2)**2
      F2=F1+10.0D 0*(-4.0D 0*X(1)-X(2)+4.0D 0)
      F3=F1+10.0D 0*(-X(1)-2.0D 0*X(2)+6.0D 0)
      F=MAX(F1,F2,F3)
      RETURN
   70 F1=-X(1)-X(2)
      F2=F1+(X(1)**2+X(2)**2-1.0D 0)
      F=MAX(F1,F2)
      RETURN
   80 F1=X(1)**2+X(2)**2-1.0D 0
      F2=0.0D 0
      F=MAX(F1,F2)
      F=20.0D 0*F-X(1)
      RETURN
   90 F1=X(1)**2+X(2)**2-1.0D 0
      IF (F1.LT.0.0D 0) F1=-F1
      F=-X(1)+2.0D 0*(X(1)**2+X(2)**2-1.0D 0)+1.75D 0*F1
      RETURN
  180 IF (X(1).GT.ABS(X(2))) THEN
      F=5.0D 0*SQRT(9.0D 0*X(1)**2+16.0D 0*X(2)**2)
      ELSEIF ((X(1).GT.0.0D 0).AND.(X(1).LE.ABS(X(2)))) THEN
      F=9.0D 0*X(1)+16.0D 0*ABS(X(2))
      ELSEIF (X(1).LE.0.0D 0) THEN
      F=9.0D 0*X(1)+16.0D 0*ABS(X(2))-X(1)**9
      ENDIF
      RETURN
  100 F=X(1)**2+X(2)**2+X(3)**2
      F1=F+X(3)**2+X(4)**2-5.0D 0*(X(1)+X(2))-21.0D 0*X(3)+7.0D 0*X(4)
      F2=F+X(4)**2+X(1)-X(2)+X(3)-X(4)-8.0D 0
      F3=F+X(2)**2+2.0D 0*X(4)**2-X(1)-X(4)-10.0D 0
      F4=F+2.0D 0*X(1)-X(2)-X(4)-5.0D 0
      F=F1+10.0D 0*MAX(0.0D 0,F2,F3,F4)
      RETURN
  110 F=0.0D 0
      DO 111 J=1,5
      F=F+(X(J)-Y(J))**2
  111 CONTINUE
      F=F*Y(50+1)
      DO 112 I=2,10
      F1=0.0D 0
      DO 113 J=1,5
      F1=F1+(X(J)-Y(5*(I-1)+J))**2
  113 CONTINUE
      F1=F1*Y(50+I)
      F=MAX(F,F1)
  112 CONTINUE
      RETURN
  230 F=0.0D 0
      DO 231 I=1,10
      T=Y(50+I)
      DO 232 J=1,5
      T=T-Y(I+J*10-10)*X(J)
  232 CONTINUE
      F=MAX(F,T)
  231 CONTINUE
      F=F*5D 1
      DO 234 J=1,5
      T=0D 0
      DO 233 I=1,5
      T=T+Y(55+I+J*5)*X(I)
  233 CONTINUE
      F=F+Y(85+J)*X(J)**3+Y(90+J)*X(J)+T*X(J)
  234 CONTINUE
      RETURN
  240 F1=X(1)*X(2)*X(3)*X(4)*X(5)
      F2=ABS(X(1)**2+X(2)**2+X(3)**2+X(4)**2+X(5)**2-1.0D 1)
      F2=F2+ABS(X(2)*X(3)-5.0D 0*X(4)*X(5))
      F2=F2+ABS(X(1)**3+X(2)**3+1.0D 0)
      F=F1+1.0D 1*F2
      RETURN
  170 F=0.0D 0
      DO 171 I=1,51
      T=DBLE(I-1)/10.0D 0
      Z=0.5D 0*EXP(-T)-EXP(-T*2.0D 0)+0.5D 0*EXP(-T*3.0D 0)+
     & 1.5D 0*EXP(-T*1.5D 0)*SIN(7.0D 0*T)+
     & EXP(-T*2.5D 0)*SIN(5.0D 0*T)
      F1=EXP(-X(2)*T)
      F2=EXP(-X(6)*T)
      F3=COS(X(3)*T+X(4))
      F=F+ABS(X(1)*F1*F3+X(5)*F2-Z)
  171 CONTINUE
      RETURN
  120 F=0.0D 0
      K=1
      DO 121 I=1,N
      F=F-Y(100+I)*X(I)
      DO 122 J=1,N
      F=F+Y((I-1)*N+J)*X(I)*X(J)
  122 CONTINUE
  121 CONTINUE
      KK=110
      DO 123 K=2,5
      F1=0.0D 0
      DO 124 I=1,N
      F1=F1-Y(KK+100+I)*X(I)
      DO 125 J=1,N
      F1=F1+Y(KK+(I-1)*N+J)*X(I)*X(J)
  125 CONTINUE
  124 CONTINUE
      F=MAX(F,F1)
      KK=KK+110
  123 CONTINUE
      RETURN
  210 F1=0.0D 0
      DO 211 I=1,10
      F1=F1+X(I)**2
  211 CONTINUE
      F4=F1-0.25D 0
      F1=1.0D -3*F4*F4
      DO 212 I=1,10
      F1=F1+(X(I)-1.0D 0)**2
  212 CONTINUE
      F2=0.0D 0
      DO 215 I=2,30
      AI=DBLE(I-1)/29D 0
      F=0.0D 0
      DO 213 J=1,10
      F=F+X(J)*AI**(J-1)
  213 CONTINUE
      F=-F*F-1.0D 0
      DO 214 J=2,10
      AJ=DBLE(J-1)
      F=F+X(J)*AJ*AI**(J-2)
  214 CONTINUE
      F2=F2+F*F
  215 CONTINUE
      F2=F2+X(1)**2+(X(2)-X(1)**2-1.0D 0)**2
      F3=0.0D 0
      DO 216 I=2,10
      F3=F3+100.0D 0*(X(I)-X(I-1)**2)**2+(1.0D 0-X(I))**2
  216 CONTINUE
      F=MAX(F1,F2,F3)
      RETURN
  220 F=SQRT(X(1)**2+X(7)**2)+
     & SQRT((5.5D 0-X(6))**2+(1.0D 0+X(12))**2)
      DO 221 J=1,6
      F=F+Y(12+J)*SQRT((Y(J)-X(J))**2+(Y(6+J)-X(6+J))**2)
  221 CONTINUE
      DO 222 J=1,5
      F=F+Y(18+J)*SQRT((X(J)-X(J+1))**2+(X(J+6)-X(J+7))**2)
  222 CONTINUE
      RETURN
  130 F=X(1)**2
      DO 131 I=2,20
      F1=X(I)**2
      F=MAX(F,F1)
  131 CONTINUE
      RETURN
  140 F=ABS(X(1))
      DO 141 I=2,20
      F1=ABS(X(I))
      F=MAX(F,F1)
  141 CONTINUE
      RETURN
  150 N=48
      F=0.0D 0
      KK=N*N
      LL=N*N+N
      DO 151 I=1,N
      F=F+Y(LL+I)*X(I)
  151 CONTINUE
      DO 152 J=1,N
      Z=ETA9
      DO 153 I=1,N
      T=Y((I-1)*N+J)-X(I)
      IF (T.GE.Z) GO TO 153
      Z=T
      K=I
  153 CONTINUE
      F=F+Y(KK+J)*Z
  152 CONTINUE
      F=-F
      RETURN
  160 F1=0.0D 0
      F=-ETA9
      DO 161 I=1,50
      F2=X(I)
      F1=F1+F2
      F=MAX(F,F2)
  161 CONTINUE
      F=5.0D 1*F-F1
      RETURN
  190 F=0.0D 0
      DO 191 J=1,N
      F=F+X(J)/DBLE(1+J-1)
  191 CONTINUE
      F=ABS(F)
      DO 192 I=2,N
      F1=0.0D 0
      DO 193 J=1,N
      F1=F1+X(J)/DBLE(I+J-1)
  193 CONTINUE
      F1=ABS(F1)
      F=MAX(F1,F)
  192 CONTINUE
      RETURN
  200 F=0.0D 0
      DO 202 J=1,N
      F1=0.0D 0
      DO 203 I=1,N
      F1=F1+X(I)/DBLE(I+J-1)
  203 CONTINUE
      F1=ABS(F1)
      F=F+F1
  202 CONTINUE
      RETURN
  250 F1=0.0D 0
      DO 251 J=1,5
      F1=F1+Y(85+J)*X(J)**3
  251 CONTINUE
      F=ABS(F1+F1)
      DO 253 J=1,5
      T=0.0D 0
      DO 252 I=1,5
      T=T+Y(55+I+J*5)*X(I)
  252 CONTINUE
      F=F+T*X(J)
  253 CONTINUE
      DO 254 J=6,15
      F=F-Y(45+J)*X(J)
  254 CONTINUE
      DO 257 J=1,5
      T=-3.0D 0*Y(85+J)*X(J)*X(J)-Y(90+J)
      DO 255 I=1,15
      IF (I.LE.5) T=T-2.0D 0*Y(55+I+J*5)*X(I)
      IF (I.GT.5) T=T+Y(I+J*10-15)*X(I)
  255 CONTINUE
      IF (T.GT.0.0D 0) F=F+1.0D 2*T
  257 CONTINUE
      DO 258 I=1,15
      IF (X(I).LT.0.0D 0) F=F-1.0D 2*X(I)
  258 CONTINUE
      RETURN
      END
