* SUBROUTINE EFFU28                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENTS OF MODEL FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  F  VALUE OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EFFU28(N,X,F,NEXT)
      INTEGER N,NA,NEXT
      REAL*8 X(N),F
      REAL*8 FA
      REAL*8 A,B,C,D,E,P,Q,R,U,V,W,ALFA,A1,A2,A3,A4,EX,D1S,D2S,H,PI
      REAL*8 AL,AL1,AL2,BE,BE1,BE2,CA,CB,FF,GA,H2,S,
     & S1,S2,S3,T,T1
      INTEGER I,J,K,L,M,IA,IB,IC,I1,I2,J1,J2,KA,N1,ND,ALF,BET,GAM
      REAL*8 Y(20),PAR
      COMMON /EMPR28/ Y,PAR,NA,M
      PI=3.14159265358979323846D 0
      F=0.0D 0
      GO TO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     &  170,180,190,200,210,220,230,250,310,320,330,350,370,390,400,
     &  450,460,470,480,490,500,510,520,530,540,550,560,570,580,590,
     &  600,610,620,630,720,740,750,760,780,790,810,830,840,860,870,
     &  880,900,910,920,930,940,950,960,970,980,990,800,240,410,420,
     &  650,660,670,680,690,340,360,380,430,440,270,280,290,300,710,
     &  820),NEXT
   10 DO 11 J=2,N
      A=X(J-1)**2-X(J)
      B=X(J-1)-1.0D 0
      F=F+1.0D 2*A**2+B**2
   11 CONTINUE
      RETURN
   20 DO 21 J=2,N-2,2
      A=X(J-1)**2-X(J)
      B=X(J-1)-1.0D 0
      C=X(J+1)**2-X(J+2)
      D=X(J+1)-1.0D 0
      U=X(J)+X(J+2)-2.0D 0
      V=X(J)-X(J+2)
      F=F+1.0D 2*A**2+B**2+9.0D 1*C**2+D**2+
     &  1.0D 1*U**2+0.1D 0*V**2
   21 CONTINUE
      RETURN
   30 DO 31 J=2,N-2,2
      A=X(J-1)+1.0D 1*X(J)
      B=X(J+1)-X(J+2)
      C=X(J)-2.0D 0*X(J+1)
      D=X(J-1)-X(J+2)
      F=F+A**2+5.0D 0*B**2+C**4+1.0D 1*D**4
   31 CONTINUE
      RETURN
   40 DO 41 J=2,N-2,2
      A=EXP(X(J-1))
      B=A-X(J)
      D=X(J)-X(J+1)
      P=X(J+1)-X(J+2)
      Q=SIN(P)/COS(P)
      U=X(J-1)
      V=X(J+2)-1.0D 0
      F=F+B**4+1.0D 2*D**6+Q**4+U**8+V**2
   41 CONTINUE
      RETURN
   50 P=7.0D 0/3.0D 0
      DO 51 J=1,N
      A=(3.0D 0-2.0D 0*X(J))*X(J)+1.0D 0
      IF (J.GT.1) A=A-X(J-1)
      IF (J.LT.N) A=A-X(J+1)
      F=F+ABS(A)**P
   51 CONTINUE
      RETURN
   60 P=7.0D 0/3.0D 0
      DO 63 J=1,N
      A=(2.0D 0+5.0D 0*X(J)**2)*X(J)+1.0D 0
      DO 61 I=MAX(1,J-5),MIN(N,J+1)
      IF (I.NE.J) A=A+X(I)*(1.0D 0+X(I))
   61 CONTINUE
      F=F+ABS(A)**P
   63 CONTINUE
      RETURN
   70 P=7.0D 0/3.0D 0
      K=N/2
      DO 71 J=1,N
      A=(3.0D 0-2.0D 0*X(J))*X(J)+1.0D 0
      IF (J.GT.1) A=A-X(J-1)
      IF (J.LT.N) A=A-X(J+1)
      F=F+ABS(A)**P
      IF (J.LE.K) THEN
      A=X(J)+X(J+K)
      F=F+ABS(A)**P
      ENDIF
   71 CONTINUE
      RETURN
   80 K=N/2
      DO 83 J=1,N
      P=0.0D 0
      DO 81 I=J-2,J+2
      IF (I.LT.1.OR.I.GT.N) GO TO 81
      A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(J,5))
      B=DBLE(I+J)/1.0D 1
      P=P+A*SIN(X(I))+B*COS(X(I))
   81 CONTINUE
      IF (J.GT.K) THEN
      I=J-K
      A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(J,5))
      B=DBLE(I+J)/1.0D 1
      P=P+A*SIN(X(I))+B*COS(X(I))
      ELSE
      I=J+K
      A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(J,5))
      B=DBLE(I+J)/1.0D 1
      P=P+A*SIN(X(I))+B*COS(X(I))
      ENDIF
      F=F+(DBLE(N+J)-P)**2/DBLE(N)
   83 CONTINUE
      RETURN
   90 K=N/2
      Q=1.0D 0/DBLE(N)
      DO 92 J=1,N
      P=0.0D 0
      DO 91 I=J-2,J+2
      IF (I.LT.1.OR.I.GT.N) GO TO 91
      A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(J,5))
      B=DBLE(I+J)/1.0D 1
      P=P+A*SIN(X(I))+B*COS(X(I))
   91 CONTINUE
      IF (J.GT.K) THEN
      I=J-K
      A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(J,5))
      B=DBLE(I+J)/1.0D 1
      P=P+A*SIN(X(I))+B*COS(X(I))
      ELSE
      I=J+K
      A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(J,5))
      B=DBLE(I+J)/1.0D 1
      P=P+A*SIN(X(I))+B*COS(X(I))
      ENDIF
      F=F+(P+DBLE(J)*(1.0D 0-COS(X(J))))*Q
   92 CONTINUE
      RETURN
  100 K=N/2
      DO 102 J=1,N
      P=0.0D 0
      Q=1.0D 0+DBLE(J)/1.0D 1
      DO 101 I=J-2,J+2
      IF (I.LT.1.OR.I.GT.N) GO TO 101
      A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(J,5))
      B=1.0D 0+DBLE(I)/1.0D 1
      C=DBLE(I+J)/1.0D 1
      P=P+A*SIN(Q*X(J)+B*X(I)+C)
  101 CONTINUE
      IF (J.GT.K) THEN
      I=J-K
      A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(J,5))
      B=1.0D 0+DBLE(I)/1.0D 1
      C=DBLE(I+J)/1.0D 1
      P=P+A*SIN(Q*X(J)+B*X(I)+C)
      ELSE
      I=J+K
      A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(J,5))
      B=1.0D 0+DBLE(I)/1.0D 1
      C=DBLE(I+J)/1.0D 1
      P=P+A*SIN(Q*X(J)+B*X(I)+C)
      ENDIF
      F=F+P
  102 CONTINUE
      F=F/DBLE(N)
      RETURN
  110 P=-0.2008D-2
      Q=-0.1900D-2
      R=-0.0261D-2
      DO 112 I=0,N-5,5
      A=1.0D 0
      B=0.0D 0
      DO 111 J=1,5
      A=A*X(I+J)
      B=B+X(I+J)**2
  111 CONTINUE
      A=EXP(A)
      B=B-1.0D 1-P
      C=X(I+2)*X(I+3)-5.0D 0*X(I+4)*X(I+5)-Q
      D=X(I+1)**3+X(I+2)**3+1.0D 0-R
      F=F+A+1.0D 1*(B**2+C**2+D**2)
  112 CONTINUE
      RETURN
  120 C=0.0D 0
      DO 121 J=2,N,2
      A=X(J-1)-3.0D 0
      B=X(J-1)-X(J)
      C=C+A
      F=F+1.0D-4*A**2-B+EXP(2.0D 1*B)
  121 CONTINUE
      F=F+C**2
      RETURN
  130 DO 131 J=2,N,2
      A=X(J)**2
      IF (A.EQ.0.0D 0) A=1.0D-60
      B=X(J-1)**2
      IF (B.EQ.0.0D 0) B=1.0D-60
      C=A+1.0D 0
      D=B+1.0D 0
      F=F+B**C+A**D
  131 CONTINUE
      RETURN
  140 P=1.0D 0/DBLE(N+1)
      Q=0.5D 0*P**2
      DO 141 J=1,N
      A=2.0D 0*X(J)+Q*(X(J)+DBLE(J)*P+1.0D 0)**3
      IF(J.GT.1) A=A-X(J-1)
      IF(J.LT.N) A=A-X(J+1)
      F=F+A**2
  141 CONTINUE
      RETURN
  150 P=1.0D 0/DBLE(N+1)
      Q=2.0D 0/P
      R=2.0D 0*P
      DO 151 J=2,N
      A=X(J-1)-X(J)
      F=F+Q*X(J-1)*A
      IF (ABS(A).LE.1.0D-6) THEN
      F=F+R*EXP(X(J))*(1.0D 0+A/2.0D 0*(1.0D 0+A/3.0D 0*(1.0D 0+
     &  A/4.0D 0)))
      ELSE
      B=EXP(X(J-1))-EXP(X(J))
      F=F+R*B/A
      ENDIF
  151 CONTINUE
      F=F+Q*X(N)**2+R*(EXP(X(1))-1.0D 0)/X(1)
     &             +R*(EXP(X(N))-1.0D 0)/X(N)
      RETURN
  160 DO 161 J=1,N
      A=DBLE(J)*(1.0D 0-COS(X(J)))
      IF(J.GT.1) A=A+DBLE(J)*SIN(X(J-1))
      IF(J.LT.N) A=A-DBLE(J)*SIN(X(J+1))
      F=F+A
  161 CONTINUE
      RETURN
  170 P=1.0D 0/DBLE(N+1)
      DO 171 J=1,N
      IF (J.EQ.1) THEN
      F=F+0.25D 0*X(J)**2/P+1.25D-1*X(J+1)**2/P+
     & P*(EXP(X(J))-1.0D 0)
      ELSE IF (J.EQ.N) THEN
      F=F+0.25D 0*X(J)**2/P+1.25D-1*X(J-1)**2/P+
     & P*(EXP(X(J))-1.0D 0)
      ELSE
      F=F+1.25D-1*(X(J+1)-X(J-1))**2/P+P*(EXP(X(J))-1.0D 0)
      ENDIF
  171 CONTINUE
      RETURN
  180 P=1.0D 0/DBLE(N+1)
      DO 181 J=1,N
      Q=DBLE(J)*P
      IF (J.EQ.1) THEN
      F=F+0.5D 0*X(J)**2/P+0.25D 0*X(J+1)**2/P-
     & P*(X(J)**2+2.0D 0*X(J)*Q)
      ELSE IF (J.EQ.N) THEN
      F=F+0.5D 0*X(J)**2/P+0.25D 0*X(J-1)**2/P-
     & P*(X(J)**2+2.0D 0*X(J)*Q)
      ELSE
      F=F+2.5D-1*(X(J+1)-X(J-1))**2/P-P*(X(J)**2+
     & 2.0D 0*X(J)*Q)
      ENDIF
  181 CONTINUE
      RETURN
  190 P=1.0D 0/DBLE(N+1)
      DO 191 J=1,N
      Q=EXP(2.0D 0*DBLE(J)*P)
      IF (J.EQ.1) THEN
      R=1.0D 0/3.0D 0
      F=F+0.5D 0*(X(J)-R)**2/P+7.0D 0*R**2+
     & 2.5D-1*(X(J+1)-R)**2/P+P*(X(J)**2+2.0D 0*X(J)*Q)
      ELSE IF (J.EQ.N) THEN
      R=EXP(2.0D 0)/3.0D 0
      F=F+0.5D 0*(X(J)-R)**2/P+7.0D 0*R**2+
     & 2.5D-1*(X(J-1)-R)**2/P+P*(X(J)**2+2.0D 0*X(J)*Q)
      ELSE
      F=F+2.5D-1*(X(J+1)-X(J-1))**2/P+P*(X(J)**2+
     & 2.0D 0*X(J)*Q)
      ENDIF
  191 CONTINUE
      RETURN
  200 P=1.0D 0/DBLE(N+1)
      DO 201 J=1,N
      A=EXP(-2.0D 0*X(J)**2)
      IF (J.EQ.1) THEN
      F=F+(0.5D 0*X(J)**2/P-P)+
     & (2.5D-1*X(J+1)**2/P-P)*A
      ELSE IF (J.EQ.N) THEN
      F=F+(0.5D 0*X(J)**2/P-P)*EXP(-2.0D 0)+
     & (2.5D-1*X(J-1)**2/P-P)*A
      ELSE
      F=F+(2.5D-1*(X(J+1)-X(J-1))**2/P-P)*A
      ENDIF
  201 CONTINUE
      RETURN
  210 P=1.0D 0/DBLE(N+1)
      DO 211 J=1,N
      IF (J.EQ.1) THEN
      A=0.5D 0*(X(J+1)-1.0D 0)/P
      B=(X(J)-1.0D 0)/P
      U=ATAN(A)
      V=ATAN(B)
      F=F+P*(X(J)**2+A*U-LOG(SQRT(1.0D 0+A**2)))+
     &   0.5D 0*P*(1.0D 0+B*V-LOG(SQRT(1.0D 0+B**2)))
      ELSE IF (J.EQ.N) THEN
      A=0.5D 0*(2.0D 0-X(J-1))/P
      B=(2.0D 0-X(J))/P
      U=ATAN(A)
      V=ATAN(B)
      F=F+P*(X(J)**2+A*U-LOG(SQRT(1.0D 0+A**2)))+
     &   0.5D 0*P*(4.0D 0+B*V-LOG(SQRT(1.0D 0+B**2)))
      ELSE
      A=0.5D 0*(X(J+1)-X(J-1))/P
      U=ATAN(A)
      F=F+P*(X(J)**2+A*U-LOG(SQRT(1.0D 0+A**2)))
      ENDIF
  211 CONTINUE
      RETURN
  220 P=1.0D 0/DBLE(N+1)
      DO 221 J=1,N
      IF (J.EQ.1) THEN
      A= 0.5D 0*X(J+1)/P
      B= X(J)/P
      F=F+P*(1.0D 2*(X(J)-A**2)**2+(1.0D 0-A)**2)+
     &   0.5D 0*P*(1.0D 2*B**4+(1.0D 0-B)**2)
      ELSE IF (J.EQ.N) THEN
      A=-0.5D 0*X(J-1)/P
      B=-X(J)/P
      F=F+P*(1.0D 2*(X(J)-A**2)**2+(1.0D 0-A)**2)+
     &   0.5D 0*P*(1.0D 2*B**4+(1.0D 0-B)**2)
      ELSE
      A=0.5D 0*(X(J+1)-X(J-1))/P
      F=F+P*(1.0D 2*(X(J)-A**2)**2+(1.0D 0-A)**2)
      ENDIF
  221 CONTINUE
      RETURN
  230 A1=-1.0D 0
      A2=0.0D 0
      A3=0.0D 0
      D1S=EXP(1.0D-2)
      D2S=1.0D 0
      DO 231 J=1,N
      A1=A1+DBLE(N-J+1)*X(J)**2
  231 CONTINUE
      A=4.0D 0*A1
      DO 232 J=1,N
      S1=EXP(X(J)/1.0D 2)
      IF (J.GT.1) THEN
      S3=S1+S2-D2S*(D1S-1.0D 0)
      A2=A2+S3**2
      A3=A3+(S1-1.0D 0/D1S)**2
      ENDIF
      S2=S1
      D2S=D1S*D2S
  232 CONTINUE
      F=1.0D-5*(A2+A3)+A1**2+(X(1)-2.0D-1)**2
      RETURN
  250 A=1.0D 0
      B=0.0D 0
      C=0.0D 0
      D=0.0D 0
      F=0.0D 0
      U=EXP(X(N))
      V=EXP(X(N-1))
      DO 251 J=1,N
      IF (J.LE.N/2) F=F+(X(J)-1.0D 0)**2
      IF (J.LE.N-2) THEN
      B=B+(X(J)+2.0D 0*X(J+1)+1.0D 1*X(J+2)-1.0D 0)**2
      C=C+(2.0D 0*X(J)+X(J+1)-3.0D 0)**2
      ENDIF
      D=D+X(J)**2-DBLE(N)
  251 CONTINUE
      F=F+A*(1.0D 0+U*B+B*C+V*C)+D**2
      RETURN
  310 DO 311 KA=1,NA
      IF(MOD(KA,2).EQ.1) THEN
      FA=1.0D 1*(X(KA+1)-X(KA)**2)
      ELSE
      FA=1.0D 0-X(KA-1)
      ENDIF
      F=F+FA**2
  311 CONTINUE
      F=0.5D 0*F
      RETURN
  320 DO 321 KA=1,NA
      IF(MOD(KA,4).EQ.1) THEN
      FA=X(KA)+1.0D 1*X(KA+1)
      ELSEIF(MOD(KA,4).EQ.2) THEN
      FA=2.23606797749979D 0*(X(KA+1)-X(KA+2))
      ELSEIF(MOD(KA,4).EQ.3) THEN
      A=X(KA-1)-2.0D 0*X(KA)
      FA=A**2
      ELSE
      FA=3.16227766016838D 0*(X(KA-3)-X(KA))**2
      ENDIF
      F=F+FA**2
  321 CONTINUE
      F=0.5D 0*F
      RETURN
  330 P=1.0D 0/SQRT(1.0D 5)
      DO 333 KA=1,NA
      IF(KA.LE.N) THEN
      FA=(X(KA)-1.0D 0)*P
      ELSE
      FA=-0.25D 0
      DO 331 J=1,N
      FA=FA+X(J)**2
  331 CONTINUE
      ENDIF
      F=F+FA**2
  333 CONTINUE
      F=0.5D 0*F
      RETURN
  350 DO 354 KA=1,NA
      IF(KA.LE.N) THEN
      FA=X(KA)-1.0D 0
      ELSE
      FA=0.0D 0
      DO 351 J=1,N
      FA=FA+DBLE(J)*(X(J)-1.0D 0)
  351 CONTINUE
      IF(KA.EQ.N+1) THEN
      ELSE IF(KA.EQ.N+2) THEN
      FA=FA**2
      ENDIF
      ENDIF
      F=F+FA**2
  354 CONTINUE
      F=0.5D 0*F
      RETURN
  370 DO 376 KA=1,NA
      IF(KA.LT.N) THEN
      A=0.0D 0
      DO 371 J=1,N
      A=A+X(J)
  371 CONTINUE
      FA=X(KA)+A-DBLE(N+1)
      ELSE
      A=1.0D 0
      DO 373 J=1,N
      A=A*X(J)
  373 CONTINUE
      FA=A-1.0D 0
      ENDIF
      F=F+FA**2
  376 CONTINUE
      F=0.5D 0*F
      RETURN
  390 DO 393 KA=1,NA
      U=1.0D 0/DBLE(N+1)
      V=DBLE(KA)*U
      A=0.0D 0
      B=0.0D 0
      DO 391 J=1,N
      W=DBLE(J)*U
      IF(J.LE.KA) THEN
      A=A+W*(X(J)+W+1.0D 0)**3
      ELSE
      B=B+(1.0D 0-W)*(X(J)+W+1.0D 0)**3
      ENDIF
  391 CONTINUE
      FA=X(KA)+U*((1.0D 0-V)*A+V*B)/2.0D 0
      F=F+FA**2
  393 CONTINUE
      F=0.5D 0*F
      RETURN
  400 DO 401 KA=1,NA
      FA=(3.0D 0-2.0D 0*X(KA))*X(KA)+1.0D 0
      IF(KA.GT.1) FA=FA-X(KA-1)
      IF(KA.LT.N) FA=FA-2.0D 0*X(KA+1)
      F=F+FA**2
  401 CONTINUE
      F=0.5D 0*F
      RETURN
  450 DO 451 KA=1,NA
      I=KA
      FA=(3.0D 0-2.0D 0*X(I))*X(I)+1.0D 0
      IF (I.GT.1) FA=FA-X(I-1)
      IF (I.LT.N) FA=FA-X(I+1)
      F=F+FA**2
  451 CONTINUE
      F=0.5D 0*F
      RETURN
  460 DO 463 KA=1,NA
      I=KA
      FA=(2.0D 0+5.0D 0*X(I)**2)*X(I)+1.0D 0
      DO 461 J=MAX(1,I-5),MIN(N,I+1)
      IF (I.NE.J) FA=FA+X(J)*(1.0D 0+X(J))
  461 CONTINUE
      F=F+FA**2
  463 CONTINUE
      F=0.5D 0*F
      RETURN
  470 DO 471 KA=1,NA
      I=(KA+1)/2
      IF (MOD(KA,2).EQ.1) THEN
      FA=X(I)+X(I+1)*((5.0D 0-X(I+1))*X(I+1)-2.0D 0)-1.3D 1
      ELSE
      FA=X(I)+X(I+1)*((1.0D 0+X(I+1))*X(I+1)-1.4D 1)-2.9D 1
      ENDIF
      F=F+FA**2
  471 CONTINUE
      F=0.5D 0*F
      RETURN
  480 DO 481 KA=1,NA
      I=MOD(KA,N/2)+1
      J=I+N/2
      M=5*N
      IF (KA.LE.M/2) THEN
      IA=1
      ELSE
      IA=2
      ENDIF
      IB=5-KA/(M/4)
      IC=MOD(KA,5)+1
      FA=(X(I)**IA-X(J)**IB)**IC
      F=F+FA**2
  481 CONTINUE
      F=0.5D 0*F
      RETURN
  490 DO 491 KA=1,NA
      I=2*((KA+5)/6)-1
      IF (MOD(KA,6).EQ.1) THEN
      FA=X(I)+3.0D 0*X(I+1)*(X(I+2)-1.0D 0)+X(I+3)**2-1.0D 0
      ELSEIF (MOD(KA,6).EQ.2) THEN
      FA=(X(I)+X(I+1))**2+(X(I+2)-1.0D 0)**2-X(I+3)-3.0D 0
      ELSEIF (MOD(KA,6).EQ.3) THEN
      FA=X(I)*X(I+1)-X(I+2)*X(I+3)
      ELSEIF (MOD(KA,6).EQ.4) THEN
      FA=2.0D 0*X(I)*X(I+2)+X(I+1)*X(I+3)-3.0D 0
      ELSEIF (MOD(KA,6).EQ.5) THEN
      FA=(X(I)+X(I+1)+X(I+2)+X(I+3))**2+(X(I)-1.0D 0)**2
      ELSE
      FA=X(I)*X(I+1)*X(I+2)*X(I+3)+(X(I+3)-1.0D 0)**2-1.0D 0
      ENDIF
      F=F+FA**2
  491 CONTINUE
      F=0.5D 0*F
      RETURN
  500 DO 501 KA=1,NA
      I=(KA+1)/2
      J=MOD(KA,2)
      IF (J.EQ.0) THEN
      FA=6.0D 0-EXP(2.0D 0*X(I))-EXP(2.0D 0*X(I+1))
      ELSEIF (I.EQ.1) THEN
      FA=4.0D 0-EXP(X(I))-EXP(X(I+1))
      ELSEIF (I.EQ.N) THEN
      FA=8.0D 0-EXP(3.0D 0*X(I-1))-EXP(3.0D 0*X(I))
      ELSE
      FA=8.0D 0-EXP(3.0D 0*X(I-1))-EXP(3.0D 0*X(I))+
     & 4.0D 0-EXP(X(I))-EXP(X(I+1))
      ENDIF
      F=F+FA**2
  501 CONTINUE
      F=0.5D 0*F
      RETURN
  510 DO 511 KA=1,NA
      I=(KA+1)/2
      IF (MOD(KA,2).EQ.1) THEN
      FA=1.0D 1*(2.0D 0*X(I)/(1.0D 0+X(I)**2)-X(I+1))
      ELSE
      FA=X(I)-1.0D 0
      ENDIF
      F=F+FA**2
  511 CONTINUE
      F=0.5D 0*F
      RETURN
  520 DO 521 KA=1,NA
      I=3*((KA+5)/6)-2
      IF (MOD(KA,6).EQ.1) THEN
      FA=1.0D 1*(X(I)**2-X(I+1))
      ELSEIF (MOD(KA,6).EQ.2) THEN
      FA=X(I+2)-1.0D 0
      ELSEIF (MOD(KA,6).EQ.3) THEN
      FA=(X(I+3)-1.0D 0)**2
      ELSEIF (MOD(KA,6).EQ.4) THEN
      FA=(X(I+4)-1.0D 0)**3
      ELSEIF (MOD(KA,6).EQ.5) THEN
      FA=X(I)**2*X(I+3)+SIN(X(I+3)-X(I+4))-1.0D 1
      ELSE
      FA=X(I+1)+(X(I+2)**2*X(I+3))**2-2.0D 1
      ENDIF
      F=F+FA**2
  521 CONTINUE
      F=0.5D 0*F
      RETURN
  530 DO 531 KA=1,NA
      I=3*((KA+6)/7)-2
      IF (MOD(KA,7).EQ.1) THEN
      FA=1.0D 1*(X(I)**2-X(I+1))
      ELSEIF (MOD(KA,7).EQ.2) THEN
      FA=1.0D 1*(X(I+1)**2-X(I+2))
      ELSEIF (MOD(KA,7).EQ.3) THEN
      FA=(X(I+2)-X(I+3))**2
      ELSEIF (MOD(KA,7).EQ.4) THEN
      FA=(X(I+3)-X(I+4))**2
      ELSEIF (MOD(KA,7).EQ.5) THEN
      FA=X(I)+X(I+1)**2+X(I+2)-3.0D 1
      ELSEIF (MOD(KA,7).EQ.6) THEN
      FA=X(I+1)-X(I+2)**2+X(I+3)-1.0D 1
      ELSE
      FA=X(I)*X(I+4)-1.0D 1
      ENDIF
      F=F+FA**2
  531 CONTINUE
      F=0.5D 0*F
      RETURN
  540 DO 546 KA=1,NA
      I=2*((KA+3)/4)-2
      L=MOD((KA-1),4)+1
      FA=-Y(L)
      DO 542 K=1,3
      A=DBLE(K*K)/DBLE(L)
      DO 541 J=1,4
      IF (X(I+J).EQ.0) X(I+J)=1.0D-16
      A=A*SIGN(1.0D 0,X(I+J))*ABS(X(I+J))**(DBLE(J)/DBLE(K*L))
  541 CONTINUE
      FA=FA+A
  542 CONTINUE
      F=F+FA**2
  546 CONTINUE
      F=0.5D 0*F
      RETURN
  550 DO 556 KA=1,NA
      I=2*((KA+3)/4)-2
      L=MOD((KA-1),4)+1
      FA=-Y(L)
      DO 552 K=1,3
      A=0.0D 0
      DO 551 J=1,4
      A=A+X(I+J)*(DBLE(J)/DBLE(K*L))
  551 CONTINUE
      FA=FA+EXP(A)*DBLE(K*K)/DBLE(L)
  552 CONTINUE
      F=F+FA**2
  556 CONTINUE
      F=0.5D 0*F
      RETURN
  560 DO 563 KA=1,NA
      I=2*((KA+3)/4)-2
      L=MOD((KA-1),4)+1
      FA=-Y(L)
      DO 561 J=1,4
      FA=FA+DBLE((1-2*MOD(J,2))*L*J*J)*SIN(X(I+J))+
     & DBLE(L*L*J)*COS(X(I+J))
  561 CONTINUE
      F=F+FA**2
  563 CONTINUE
      F=0.5D 0*F
      RETURN
  570 DO 571 KA=1,NA
      ALFA=0.5D 0
      IF (KA.EQ.1) THEN
      FA=ALFA-(1.0D 0-ALFA)*X(3)-X(1)*(1.0D 0+4.0D 0*X(2))
      ELSEIF(KA.EQ.2) THEN
      FA=-(2.0D 0-ALFA)*X(4)-X(2)*(1.0D 0+4.0D 0*X(1))
      ELSEIF(KA.EQ.N-1) THEN
      FA=ALFA*X(N-3)-X(N-1)*(1.0D 0+4.0D 0*X(N))
      ELSEIF (KA.EQ.N) THEN
      FA=ALFA*X(N-2)-(2.0D 0-ALFA)-X(N)*(1.0D 0+4.0D 0*X(N-1))
      ELSEIF (MOD(KA,2).EQ.1) THEN
      FA=ALFA*X(KA-2)-(1.0D 0-ALFA)*X(KA+2)-
     & X(KA)*(1.0D 0+4.0D 0*X(KA+1))
      ELSE
      FA=ALFA*X(KA-2)-(2.0D 0-ALFA)*X(KA+2)-
     & X(KA)*(1.0D 0+4.0D 0*X(KA-1))
      ENDIF
      F=F+FA**2
  571 CONTINUE
      F=0.5D 0*F
      RETURN
  580 DO 581 KA=1,NA
      IF (KA.LT.2) THEN
      FA=4.0D 0*(X(KA)-X(KA+1)**2)
      ELSEIF (KA.LT.N) THEN
      FA=8.0D 0*X(KA)*(X(KA)**2-X(KA-1))-2.0D 0*(1.0D 0-X(KA))+
     & 4.0D 0*(X(KA)-X(KA+1)**2)
      ELSE
      FA=8.0D 0*X(KA)*(X(KA)**2-X(KA-1))-2.0D 0*(1.0D 0-X(KA))
      ENDIF
      F=F+FA**2
  581 CONTINUE
      F=0.5D 0*F
      RETURN
  590 DO 591 KA=1,NA
      IF (KA.EQ.1) THEN
      FA=-2.0D 0*X(KA)**2+3.0D 0*X(KA)-2.0D 0*X(KA+1)+
     & 3.0D 0*X(N-4)-X(N-3)-X(N-2)+0.5D 0*X(N-1)-X(N)+1.0D 0
      ELSEIF (KA.LE.N-1) THEN
      FA=-2.0D 0*X(KA)**2+3.0D 0*X(KA)-X(KA-1)-2.0D 0*X(KA+1)+
     & 3.0D 0*X(N-4)-X(N-3)-X(N-2)+0.5D 0*X(N-1)-X(N)+1.0D 0
      ELSE
      FA=-2.0D 0*X(N)**2+3.0D 0*X(N)-X(N-1)+
     & 3.0D 0*X(N-4)-X(N-3)-X(N-2)+0.5D 0*X(N-1)-X(N)+1.0D 0
      ENDIF
      F=F+FA**2
  591 CONTINUE
      F=0.5D 0*F
      RETURN
  600 DO 601 KA=1,NA
      U=1.0D 0/DBLE(N+1)
      V=DBLE(KA)*U
      FA=2.0D 0*X(KA)+0.5D 0*U*U*(X(KA)+V+1.0D 0)**3+1.0D 0
      IF(KA.GT.1) FA=FA-X(KA-1)
      IF(KA.LT.N) FA=FA-X(KA+1)
      F=F+FA**2
  601 CONTINUE
      F=0.5D 0*F
      RETURN
  610 DO 611 KA=1,NA
      I=3*((KA+6)/7)-2
      IF (MOD(KA,7).EQ.1) THEN
      FA=1.0D 1*(X(I)**2-X(I+1))
      ELSEIF (MOD(KA,7).EQ.2) THEN
      FA=X(I+1)+X(I+2)-2.0D 0
      ELSEIF (MOD(KA,7).EQ.3) THEN
      FA=X(I+3)-1.0D 0
      ELSEIF (MOD(KA,7).EQ.4) THEN
      FA=X(I+4)-1.0D 0
      ELSEIF (MOD(KA,7).EQ.5) THEN
      FA=X(I)+3.0D 0*X(I+1)
      ELSEIF (MOD(KA,7).EQ.6) THEN
      FA=X(I+2)+X(I+3)-2.0D 0*X(I+4)
      ELSE
      FA=1.0D 1*(X(I+1)**2-X(I+4))
      ENDIF
      F=F+FA**2
  611 CONTINUE
      F=0.5D 0*F
      RETURN
  620 DO 621 KA=1,NA
      I=KA/2
      IF (KA.EQ.1) THEN
      FA=X(KA)-1.0D 0
      ELSE IF (MOD(KA,2).EQ.0) THEN
      FA=1.0D 1*(X(I)**2-X(I+1))
      ELSE
      A=2.0D 0*EXP(-(X(I)-X(I+1))**2)
      B=EXP(-2.0D 0*(X(I+1)-X(I+2))**2)
      FA=A+B
      ENDIF
      F=F+FA**2
  621 CONTINUE
      F=0.5D 0*F
      RETURN
  630 DO 633 KA=1,NA
      IA=MIN(MAX(MOD(KA,13)-2,1),7)
      IB=(KA+12)/13
      I=IA+IB-1
      IF (IA.EQ.7) THEN
      J=IB
      ELSE
      J=IA+IB
      ENDIF
      C=3.0D 0*DBLE(IA)/1.0D 1
      A=0.0D 0
      B=EXP(SIN(C)*X(J))
      D=X(J)-SIN(X(I))-1.0D 0+Y(1)
      E=1.0D 0+COS(C)
      DO 631 L=0,6
      IF (IB+L.NE.I.AND.IB+L.NE.J) A=A+SIN(X(IB+L))-Y(1)
  631 CONTINUE
      FA=E*D**2+5.0D 0*(X(I)-1.0D 0)*B+0.5D 0*A
      F=F+FA**2
  633 CONTINUE
      F=0.5D 0*F
      RETURN
  720 DO 721 KA=1,NA
      A1=0.414214D 0
      IF (KA.EQ.1) THEN
      FA=X(1)-(1.0D 0-X(1))*X(3)-A1*(1.0D 0+4.0D 0*X(2))
      ELSEIF (KA.EQ.2) THEN
      FA=-(1.0D 0-X(1))*X(4)-A1*(1.0D 0+4.0D 0*X(2))
      ELSEIF (KA.EQ.3) THEN
      FA=A1*X(1)-(1.0D 0-X(1))*X(5)-X(3)*(1.0D 0+4.0D 0*X(2))
      ELSEIF (KA.LE.N-2) THEN
      FA=X(1)*X(KA-2)-(1.0D 0-X(1))*X(KA+2)-
     & X(KA)*(1.0D 0+4.0D 0*X(KA-1))
      ELSEIF (KA.EQ.N-1) THEN
      FA=X(1)*X(N-3)-X(N-1)*(1.0D 0+4.0D 0*X(N-2))
      ELSE
      FA=X(1)*X(N-2)-(1.0D 0-X(1))-X(N)*(1.0D 0+4.0D 0*X(N-1))
      ENDIF
      F=F+FA**2
  721 CONTINUE
      F=0.5D 0*F
      RETURN
  740 DO 741 KA=1,NA
      IF (KA.LT.2) THEN
      FA=3.0D 0*X(KA)**3+2.0D 0*X(KA+1)-5.0D 0+
     & SIN(X(KA)-X(KA+1))*SIN(X(KA)+X(KA+1))
      ELSEIF (KA.LT.N) THEN
      FA=3.0D 0*X(KA)**3+2.0D 0*X(KA+1)-5.0D 0+
     & SIN(X(KA)-X(KA+1))*SIN(X(KA)+X(KA+1))+4.0D 0*X(KA)-
     & X(KA-1)*EXP(X(KA-1)-X(KA))-3.0D 0
      ELSE
      FA=4.0D 0*X(KA)-X(KA-1)*EXP(X(KA-1)-X(KA))-3.0D 0
      ENDIF
      F=F+FA**2
  741 CONTINUE
      F=0.5D 0*F
      RETURN
  750 DO 751 KA=1,NA
      IF (MOD(KA,2).EQ.1) THEN
      FA=0.0D 0
      IF (KA.NE.1) FA=FA-6.0D 0*(X(KA-2)-X(KA))**3+1.0D 1-
     & 4.0D 0*X(KA-1)-2.0D 0*SIN(X(KA-2)-X(KA-1)-X(KA))*
     & SIN(X(KA-2)+X(KA-1)-X(KA))
      IF (KA.NE.N) FA=FA+3.0D 0*(X(KA)-X(KA+2))**3-5.0D 0+
     & 2.0D 0*X(KA+1)+SIN(X(KA)-X(KA+1)-X(KA+2))*
     & SIN(X(KA)+X(KA+1)-X(KA+2))
      ELSE
      EX=EXP(X(KA-1)-X(KA)-X(KA+1))
      FA=4.0D 0*X(KA)-(X(KA-1)-X(KA+1))*EX-3.0D 0
      ENDIF
      F=F+FA**2
  751 CONTINUE
      F=0.5D 0*F
      RETURN
  760 DO 761 KA=1,NA
      H=2.0D 0
      IF (KA.EQ.1) THEN
      FA=((3.0D 0-H*X(1))*X(1)-2.0D 0*X(2)+1.0D 0)**2
      ELSEIF (KA.LE.N-1) THEN
      FA=((3.0D 0-H*X(KA))*X(KA)-X(KA-1)-2.0D 0*X(KA+1)+1.0D 0)**2
      ELSE
      FA=((3.0D 0-H*X(N))*X(N)-X(N-1)+1.0D 0)**2
      ENDIF
      F=F+FA**2
  761 CONTINUE
      F=0.5D 0*F
      RETURN
  780 DO 781 KA=1,NA
      IF (KA.LT.2) THEN
      FA=4.0D 0*(X(KA)-X(KA+1)**2)+X(KA+1)-X(KA+2)**2
      ELSEIF (KA.LT.3) THEN
      FA=8.0D 0*X(KA)*(X(KA)**2-X(KA-1))-2.0D 0*(1.0D 0-X(KA))+
     & 4.0D 0*(X(KA)-X(KA+1)**2)+X(KA+1)-X(KA+2)**2
      ELSEIF (KA.LT.N-1) THEN
      FA=8.0D 0*X(KA)*(X(KA)**2-X(KA-1))-2.0D 0*(1.0D 0-X(KA))+
     & 4.0D 0*(X(KA)-X(KA+1)**2)+X(KA-1)**2-X(KA-2)+X(KA+1)-
     & X(KA+2)**2
      ELSEIF (KA.LT.N) THEN
      FA=8.0D 0*X(KA)*(X(KA)**2-X(KA-1))-2.0D 0*(1.0D 0-X(KA))+
     & 4.0D 0*(X(KA)-X(KA+1)**2)+X(KA-1)**2-X(KA-2)
      ELSE
      FA=8.0D 0*X(KA)*(X(KA)**2-X(KA-1))-2.0D 0*(1.0D 0-X(KA))
     & +X(KA-1)**2-X(KA-2)
      ENDIF
      F=F+FA**2
  781 CONTINUE
      F=0.5D 0*F
      RETURN
  790 DO 791 KA=1,NA
      IF (KA.LT.2) THEN
      FA=4.0D 0*(X(KA)-X(KA+1)**2)+X(KA+1)-X(KA+2)**2+
     & X(KA+2)-X(KA+3)**2
      ELSEIF (KA.LT.3) THEN
      FA=8.0D 0*X(KA)*(X(KA)**2-X(KA-1))-2.0D 0*(1.0D 0-X(KA))+
     & 4.0D 0*(X(KA)-X(KA+1)**2)+X(KA-1)**2+X(KA+1)-X(KA+2)**2+
     & X(KA+2)-X(KA+3)**2
      ELSEIF (KA.LT.4) THEN
      FA=8.0D 0*X(KA)*(X(KA)**2-X(KA-1))-2.0D 0*(1.0D 0-X(KA))+
     & 4.0D 0*(X(KA)-X(KA+1)**2)+X(KA-1)**2-X(KA-2)+
     & X(KA+1)-X(KA+2)**2+X(KA-2)**2+X(KA+2)-X(KA+3)**2
      ELSEIF (KA.LT.N-2) THEN
      FA=8.0D 0*X(KA)*(X(KA)**2-X(KA-1))-2.0D 0*(1.0D 0-X(KA))+
     & 4.0D 0*(X(KA)-X(KA+1)**2)+X(KA-1)**2-X(KA-2)+
     & X(KA+1)-X(KA+2)**2+X(KA-2)**2-X(KA-3)+X(KA+2)-X(KA+3)**2
      ELSEIF (KA.LT.N-1) THEN
      FA=8.0D 0*X(KA)*(X(KA)**2-X(KA-1))-2.0D 0*(1.0D 0-X(KA))+
     & 4.0D 0*(X(KA)-X(KA+1)**2)+X(KA-1)**2-X(KA-2)+
     & X(KA+1)-X(KA+2)**2+X(KA-2)**2-X(KA-3)+X(KA+2)
      ELSEIF (KA.LT.N) THEN
      FA=8.0D 0*X(KA)*(X(KA)**2-X(KA-1))-2.0D 0*(1.0D 0-X(KA))+
     & 4.0D 0*(X(KA)-X(KA+1)**2)+X(KA-1)**2-X(KA-2)+
     & X(KA+1)+X(KA-2)**2-X(KA-3)
      ELSE
      FA=8.0D 0*X(KA)*(X(KA)**2-X(KA-1))-2.0D 0*(1.0D 0-X(KA))
     & +X(KA-1)**2-X(KA-2)+X(KA-2)**2-X(KA-3)
      ENDIF
      F=F+FA**2
  791 CONTINUE
      F=0.5D 0*F
      RETURN
  810 DO 811 KA=1,NA
      IF(MOD(KA,2).EQ.1) THEN
      FA=X(KA)+((5.0D 0-X(KA+1))*X(KA+1)-2.0D 0)*X(KA+1)-1.3D 1
      ELSE
      FA=X(KA-1)+((X(KA)+1.0D 0)*X(KA)-1.4D 1)*X(KA)-2.9D 1
      ENDIF
      F=F+FA**2
  811 CONTINUE
      F=0.5D 0*F
      RETURN
  830 DO 831 KA=1,NA
      IF(MOD(KA,4).EQ.1) THEN
      A=EXP(X(KA))-X(KA+1)
      FA=A**2
      ELSEIF (MOD(KA,4).EQ.2) THEN
      FA=1.0D 1*(X(KA)-X(KA+1))**3
      A=3.0D 1*(X(KA)-X(KA+1))**2*FA
      ELSEIF (MOD(KA,4).EQ.3) THEN
      A=X(KA)-X(KA+1)
      FA=(SIN(A)/COS(A))**2
      ELSE
      FA=X(KA)-1.0D 0
      ENDIF
      F=F+FA**2
  831 CONTINUE
      F=0.5D 0*F
      RETURN
  840 DO 841 KA=1,NA
      IF(KA.LT.2) THEN
      FA=X(KA)*(0.5D 0*X(KA)-3.0D 0)-1.0D 0+2.0D 0*X(KA+1)
      ELSEIF (KA.LT.N) THEN
      FA=X(KA-1)+X(KA)*(0.5D 0*X(KA)-3.0D 0)-1.0D 0+2.0D 0*X(KA+1)
      ELSE
      FA=X(KA-1)+X(KA)*(0.5D 0*X(KA)-3.0D 0)-1.0D 0
      ENDIF
      F=F+FA**2
  841 CONTINUE
      F=0.5D 0*F
      RETURN
  860 DO 861 KA=1,NA
      IF(MOD(KA,2).EQ.1) THEN
      FA=1.0D 4*X(KA)*X(KA+1)-1.0D 0
      ELSE
      FA=EXP(-X(KA-1))+EXP(-X(KA))-1.0001D 0
      ENDIF
      F=F+FA**2
  861 CONTINUE
      F=0.5D 0*F
      RETURN
  870 DO 871 KA=1,NA
      IF(MOD(KA,4).EQ.1) THEN
      FA=-2.0D 2*X(KA)*(X(KA+1)-X(KA)**2)-(1.0D 0-X(KA))
      ELSEIF(MOD(KA,4).EQ.2) THEN
      FA=2.0D 2*(X(KA)-X(KA-1)**2)+2.02D 1*(X(KA)-1.0D 0)+
     &  1.98D 1*(X(KA+2)-1.0D 0)
      ELSEIF(MOD(KA,4).EQ.3) THEN
      FA=-1.8D 2*X(KA)*(X(KA+1)-X(KA)**2)-(1.0D 0-X(KA))
      ELSE
      FA=1.8D 2*(X(KA)-X(KA-1)**2)+2.02D 1*(X(KA)-1.0D 0)+
     & 1.98D 1*(X(KA-2)-1.0D 0)
      ENDIF
      F=F+FA**2
  871 CONTINUE
      F=0.5D 0*F
      RETURN
  880 DO 881 KA=1,NA
      IF (KA.LT.2) THEN
      A=EXP(COS(DBLE(KA)*(X(KA)+X(KA+1))))
      B=A*DBLE(KA)*SIN(DBLE(KA)*(X(KA)+X(KA+1)))
      FA=X(KA)-A
      ELSEIF (KA.LT.N) THEN
      A=EXP(COS(DBLE(KA)*(X(KA-1)+X(KA)+X(KA+1))))
      B=A*SIN(DBLE(KA)*(X(KA-1)+X(KA)+X(KA+1)))*DBLE(KA)
      FA=X(KA)-A
      ELSE
      A=EXP(COS(DBLE(KA)*(X(KA-1)+X(KA))))
      B=A*SIN(DBLE(KA)*(X(KA-1)+X(KA)))*DBLE(KA)
      FA=X(KA)-A
      ENDIF
      F=F+FA**2
  881 CONTINUE
      F=0.5D 0*F
      RETURN
  900 DO 901 KA=1,NA
      IF(KA.EQ.1) THEN
      FA=3.0D 0*X(KA)*(X(KA+1)-2.0D 0*X(KA))+0.25D 0*X(KA+1)**2
      ELSEIF(KA.EQ.N) THEN
      FA=3.0D 0*X(KA)*(2.0D 1-2.0D 0*X(KA)+X(KA-1))+
     & 0.25D 0*(2.0D 1-X(KA-1))**2
      ELSE
      FA=3.0D 0*X(KA)*(X(KA+1)-2.0D 0*X(KA)+X(KA-1))+
     & 0.25D 0*(X(KA+1)-X(KA-1))**2
      ENDIF
      F=F+FA**2
  901 CONTINUE
      F=0.5D 0*F
      RETURN
  910 DO 911 KA=1,NA
      H=1.0D 0/DBLE(N+1)
      IF (KA.LT.2) THEN
      FA=2.0D 0*X(KA)+PAR*H**2*SINH(PAR*X(KA))-X(KA+1)
      ELSE IF (KA.LT.N) THEN
      FA=2.0D 0*X(KA)+PAR*H**2*SINH(PAR*X(KA))-X(KA-1)-X(KA+1)
      ELSE
      FA=2.0D 0*X(KA)+PAR*H**2*SINH(PAR*X(KA))-X(KA-1)-1.0D 0
      ENDIF
      F=F+FA**2
  911 CONTINUE
      F=0.5D 0*F
      RETURN
  920 DO 921 KA=1,NA
      FA=6.0D 0*X(KA)
      A1=0.0D 0
      A2=0.0D 0
      A3=0.0D 0
      IF (KA.GT.1) THEN
      FA=FA-4.0D 0*X(KA-1)
      A1=A1-X(KA-1)
      A2=A2+X(KA-1)
      A3=A3+2.0D 0*X(KA-1)
      ENDIF
      IF (KA.GT.2) THEN
      FA=FA+X(KA-2)
      A3=A3-X(KA-2)
      ENDIF
      IF (KA.LT.N-1) THEN
      FA=FA+X(KA+2)
      A3=A3+X(KA+2)
      ENDIF
      IF (KA.LT.N) THEN
      FA=FA-4.0D 0*X(KA+1)
      A1=A1+X(KA+1)
      A2=A2+X(KA+1)
      A3=A3-2.0D 0*X(KA+1)
      ENDIF
      IF (KA.GE.N-1) THEN
      FA=FA+1.0D 0
      A3=A3+1.0D 0
      ENDIF
      IF (KA.GE.N) THEN
      FA=FA-4.0D 0
      A1=A1+1.0D 0
      A2=A2+1.0D 0
      A3=A3-2.0D 0
      ENDIF
      FA=FA-0.5D 0*PAR*(A1*A2-X(KA)*A3)
      F=F+FA**2
  921 CONTINUE
      F=0.5D 0*F
      RETURN
  930 DO 931 KA=1,NA
      H=1.0D 0/DBLE(M+1)
      IF(KA.LE.M) THEN
      J=KA+M
      FA=6.0D 0*X(KA)
      A1=0.0D 0
      A2=0.0D 0
      IF (KA.EQ.1) THEN
      A1=A1+1.0D 0
      ENDIF
      IF (KA.GT.1) THEN
      FA=FA-4.0D 0*X(KA-1)
      A1=A1-X(J-1)
      A2=A2+2.0D 0*X(KA-1)
      ENDIF
      IF (KA.GT.2) THEN
      FA=FA+X(KA-2)
      A2=A2-X(KA-2)
      ENDIF
      IF (KA.LT.M-1) THEN
      FA=FA+X(KA+2)
      A2=A2+X(KA+2)
      ENDIF
      IF (KA.LT.M) THEN
      FA=FA-4.0D 0*X(KA+1)
      A1=A1+X(J+1)
      A2=A2-2.0D 0*X(KA+1)
      ENDIF
      IF (KA.EQ.M) THEN
      A1=A1+1.0D 0
      ENDIF
      FA=FA+0.5D 0*PAR*H*(X(KA)*A2+X(J)*A1*H**2)
      ELSE
      J=KA-M
      FA=-2.0D 0*X(KA)
      A1=0.0D 0
      A2=0.0D 0
      IF (J.EQ.1) THEN
      A2=A2+1.0D 0
      ENDIF
      IF (J.GT.1) THEN
      FA=FA+X(KA-1)
      A1=A1-X(J-1)
      A2=A2-X(KA-1)
      ENDIF
      IF (J.LT.M) THEN
      FA=FA+X(KA+1)
      A1=A1+X(J+1)
      A2=A2+X(KA+1)
      ENDIF
      IF (J.EQ.M) THEN
      A2=A2+1.0D 0
      ENDIF
      FA=FA+0.5D 0*PAR*H*(X(KA)*A1+X(J)*A2)
      ENDIF
      F=F+FA**2
  931 CONTINUE
      F=0.5D 0*F
      RETURN
  940 DO 941 KA=1,NA
      FA=4.0D 0*X(KA)-PAR*EXP(X(KA))
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      IF(I.GT.1) FA=FA-X(KA-1)
      IF(I.LT.M) FA=FA-X(KA+1)
      IF(J.GT.1) FA=FA-X(KA-M)
      IF(J.LT.M) FA=FA-X(KA+M)
      F=F+FA**2
  941 CONTINUE
      F=0.5D 0*F
      RETURN
  950 DO 951 KA=1,NA
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      FA=4.0D 0*X(KA)+PAR*X(KA)**3/(1.0D 0+PAR*DBLE(I)**2+
     & PAR*DBLE(J)**2)
      IF(I.EQ.1) FA=FA-1.0D 0
      IF(I.GT.1) FA=FA-X(KA-1)
      IF(I.LT.M) FA=FA-X(KA+1)
      IF(I.EQ.M) FA=FA-2.0D 0+EXP(DBLE(J)/DBLE(M+1))
      IF(J.EQ.1) FA=FA-1.0D 0
      IF(J.GT.1) FA=FA-X(KA-M)
      IF(J.LT.M) FA=FA-X(KA+M)
      IF(J.EQ.M) FA=FA-2.0D 0+EXP(DBLE(I)/DBLE(M+1))
      F=F+FA**2
  951 CONTINUE
      F=0.5D 0*F
      RETURN
  960 DO 961 KA=1,NA
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      A1=DBLE(I)/DBLE(M+1)
      A2=DBLE(J)/DBLE(M+1)
      FA=4.0D 0*X(KA)-PAR*SIN(2.0D 0*PI*X(KA))-
     & 1.0D 4*((A1-0.25D 0)**2+(A2-0.75D 0)**2)*PAR
      IF(I.EQ.1) FA=FA-X(KA+1)-PAR*SIN(PI*X(KA+1)*DBLE(M+1))
      IF(I.GT.1.AND.I.LT.M) FA=FA-X(KA+1)-X(KA-1)-
     & PAR*SIN(PI*(X(KA+1)-X(KA-1))*DBLE(M+1))
      IF(I.EQ.M) FA=FA-X(KA-1)+PAR*SIN(PI*X(KA-1)*DBLE(M+1))
      IF(J.EQ.1) FA=FA-X(KA+M)-PAR*SIN(PI*X(KA+M)*DBLE(M+1))
      IF(J.GT.1.AND.J.LT.M) FA=FA-X(KA+M)-X(KA-M)-
     & PAR*SIN(PI*(X(KA+M)-X(KA-M))*DBLE(M+1))
      IF(J.EQ.M) FA=FA-X(KA-M)+PAR*SIN(PI*X(KA-M)*DBLE(M+1))
      F=F+FA**2
  961 CONTINUE
      F=0.5D 0*F
      RETURN
  970 DO 971 KA=1,NA
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      FA=8.0D 0*X(KA)**2
      IF(I.EQ.1) FA=FA-2.0D 0*X(KA)*(X(KA+1)+1.0D 0)-
     & 0.5D 0*(X(KA+1)-1.0D 0)**2-
     & 1.5D 0*X(KA)**2*(X(KA+1)-1.0D 0)*PAR
      IF(I.GT.1.AND.I.LT.M) FA=FA-2.0D 0*X(KA)*(X(KA+1)+X(KA-1))-
     & 0.5D 0*(X(KA+1)-X(KA-1))**2-
     & 1.5D 0*X(KA)**2*(X(KA+1)-X(KA-1))*PAR
      IF(I.EQ.M) FA=FA-2.0D 0*X(KA)*X(KA-1)-
     & 0.5D 0*X(KA-1)**2+
     & 1.5D 0*X(KA)**2*X(KA-1)*PAR
      IF(J.EQ.1) FA=FA-2.0D 0*X(KA)*(X(KA+M)+1.0D 0)-
     & 0.5D 0*(X(KA+M)-1.0D 0)**2
      IF(J.GT.1.AND.J.LT.M) FA=FA-2.0D 0*X(KA)*(X(KA+M)+X(KA-M))-
     & 0.5D 0*(X(KA+M)-X(KA-M))**2
      IF(J.EQ.M) FA=FA-2.0D 0*X(KA)*X(KA-M)-
     & 0.5D 0*X(KA-M)**2
      IF (I.EQ.1.AND.J.EQ.1) FA=FA-PAR/DBLE(M+1)
      F=F+FA**2
  971 CONTINUE
      F=0.5D 0*F
      RETURN
  980 DO 981 KA=1,NA
      A3=0.0D 0
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      A1=PAR*DBLE(I)
      A2=PAR*DBLE(J)
      FA=4.0D 0*X(KA)-2.0D 3*A1*A2*(1.0D 0-A1)*(1.0D 0-A2)*PAR**2
      IF(I.GT.1) THEN
      FA=FA-X(KA-1)
      A3=A3-X(KA-1)
      ENDIF
      IF(I.LT.M) THEN
      FA=FA-X(KA+1)
      A3=A3+X(KA+1)
      ENDIF
      IF(J.GT.1) THEN
      FA=FA-X(KA-M)
      A3=A3-X(KA-M)
      ENDIF
      IF(J.LT.M) THEN
      FA=FA-X(KA+M)
      A3=A3+X(KA+M)
      ENDIF
      FA=FA+2.0D 1*PAR*A3*X(KA)
      F=F+FA**2
  981 CONTINUE
      F=0.5D 0*F
      RETURN
  990 DO 991 KA=1,NA
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      FA=2.0D 1*X(KA)-PAR*MAX(0.0D 0,X(KA))-
     & SIGN(PAR,(DBLE(I)/DBLE(M+2)-0.5D 0))
      IF (J.GT.2) THEN
        FA=FA+X(KA-M-M)
      ENDIF
      IF (J.GT.1) THEN
        IF (I.GT.1) THEN
          FA=FA+2.0D 0*X(KA-M-1)
        ENDIF
        FA=FA-8.0D 0*X(KA-M)
        IF (I.LT.M) THEN
          FA=FA+2.0D 0*X(KA-M+1)
        ENDIF
      ENDIF
      IF (I.GT.1) THEN
        IF (I.GT.2) THEN
          FA=FA+X(KA-2)
        ENDIF
        FA=FA-8.0D 0*X(KA-1)
      ENDIF
      IF (I.LT.M) THEN
        FA=FA-8.0D 0*X(KA+1)
        IF (I.LT.M-1) THEN
          FA=FA+X(KA+2)
        ENDIF
      ENDIF
      IF (J.LT.M) THEN
        IF (I.GT.1) THEN
          FA=FA+2.0D 0*X(KA+M-1)
        ENDIF
        FA=FA-8.0D 0*X(KA+M)
        IF (I.LT.M) THEN
          FA=FA+2.0D 0*X(KA+M+1)
        ENDIF
      ENDIF
      IF (J.LT.M-1) THEN
        FA=FA+X(KA+M+M)
      ENDIF
      F=F+FA**2
  991 CONTINUE
      F=0.5D 0*F
      RETURN
  800 DO 802 KA=1,NA
      H=0.5D 0/DBLE(M+2)
      J=(KA-1)/M+1
      I=KA-(J-1)*M
      FA=2.0D 1*X(KA)
      A1=0.0D 0
      A2=0.0D 0
      A3=0.0D 0
      A4=0.0D 0
      IF (J.GT.2) THEN
        FA=FA+X(KA-M-M)
        A4=A4+X(KA-M-M)
      ENDIF
      IF (J.GT.1) THEN
        IF (I.GT.1) THEN
          FA=FA+2.0D 0*X(KA-M-1)
          A3=A3+X(KA-M-1)
          A4=A4+X(KA-M-1)
        ENDIF
        FA=FA-8.0D 0*X(KA-M)
        A1=A1-X(KA-M)
        A4=A4-4.0D 0*X(KA-M)
        IF (I.LT.M) THEN
          FA=FA+2.0D 0*X(KA-M+1)
          A3=A3-X(KA-M+1)
          A4=A4+X(KA-M+1)
        ENDIF
      ENDIF
      IF (I.GT.1) THEN
        IF (I.GT.2) THEN
          FA=FA+X(KA-2)
          A3=A3+X(KA-2)
        ENDIF
        FA=FA-8.0D 0*X(KA-1)
        A2=A2-X(KA-1)
        A3=A3-4.0D 0*X(KA-1)
      ENDIF
      IF (I.LT.M) THEN
        FA=FA-8.0D 0*X(KA+1)
        A2=A2+X(KA+1)
        A3=A3+4.0D 0*X(KA+1)
        IF (I.LT.M-1) THEN
          FA=FA+X(KA+2)
          A3=A3-X(KA+2)
        ENDIF
      ENDIF
      IF (J.LT.M) THEN
        IF (I.GT.1) THEN
          FA=FA+2.0D 0*X(KA+M-1)
          A3=A3+X(KA+M-1)
          A4=A4-X(KA+M-1)
        ENDIF
        FA=FA-8.0D 0*X(KA+M)
        A1=A1+X(KA+M)
        A4=A4+4.0D 0*X(KA+M)
        IF (I.LT.M) THEN
          FA=FA+2.0D 0*X(KA+M+1)
          A3=A3-X(KA+M+1)
          A4=A4-X(KA+M+1)
        ENDIF
      ENDIF
      IF (J.LT.M-1) THEN
        FA=FA+X(KA+M+M)
        A4=A4-X(KA+M+M)
      ENDIF
      IF (J.EQ.M) THEN
        IF (I.GT.1) THEN
          FA=FA-H-H
          A3=A3-H
          A4=A4+H
        ENDIF
        FA=FA+8.0D 0*H
        A1=A1-H
        A4=A4-4.0D 0*H
        IF (I.LT.M) THEN
          FA=FA-2.0D 0*H
          A3=A3+H
          A4=A4+H
        ENDIF
        FA=FA+H
        A4=A4-H
      ENDIF
      IF (J.EQ.M-1) THEN
        FA=FA-H
        A4=A4+H
      ENDIF
      FA=FA+0.25D 0*PAR*(A1*A3-A2*A4)
      F=F+FA**2
  802 CONTINUE
      F=0.5D 0*F
      RETURN
  240 DO 243 KA=1,NA
      W=0.0D 0
      DO 241 I=1,N-1
      W=W+(DBLE(KA)/DBLE(KA+I))*X(I)
  241 CONTINUE
      FA=X(KA)-(1.0D 0+(0.4D 0/DBLE(N))*X(KA)*(0.5D 0+W+
     & 0.5D 0*(DBLE(KA)/DBLE(KA+N))*X(N)))
      F=F+FA**2
  243 CONTINUE
      F=0.5D 0*F
      RETURN
  410 DO 411 KA=1,NA
      IF(KA.EQ.1) THEN
        FA=1.0D 0-X(1)
      ELSE
        FA=10.0D 0*DBLE(KA-1)*(X(KA)-X(KA-1))**2
      ENDIF
      F=F+FA**2
  411 CONTINUE
      F=0.5D 0*F
      RETURN
  420 DO 421 KA=1,NA
      IF(KA.EQ.N) THEN
        FA=X(KA)-0.1D 0*X(1)**2
      ELSE
        FA=X(KA)-0.1D 0*X(KA+1)**2
      ENDIF
      F=F+FA**2
  421 CONTINUE
      F=0.5D 0*F
      RETURN
  650 DO 653 KA=1,NA
      S=0.0D 0
      DO 651 J=1,N
        S=S+X(J)**3
  651 CONTINUE
      FA=X(KA)-1.0D 0/DBLE(2*N)*(S+DBLE(KA))
      F=F+FA**2
  653 CONTINUE
      F=0.5D 0*F
      RETURN
  660 DO 661 KA=1,NA
      S=(1.0D 0/DBLE(N+1))**2*EXP(X(KA))
      IF(N.EQ.1) THEN
        FA=-2.0D 0*X(KA)-S
      ELSE IF(KA.EQ.1) THEN
        FA=-2.0D 0*X(KA)+X(KA+1)-S
      ELSE IF(KA.EQ.N) THEN
        FA=X(KA-1)-2.0D 0*X(KA)-S
      ELSE
        FA=X(KA-1)-2.0D 0*X(KA)+X(KA+1)-S
      ENDIF
      F=F+FA**2
  661 CONTINUE
      F=0.5D 0*F
      RETURN
  670 DO 671 KA=1,NA
      S=0.1D 0
      IF(N.EQ.1) THEN
        FA=(3.0D 0-S*X(KA))*X(KA)+1.0D 0
      ELSE IF(KA.EQ.1) THEN
        FA=(3.0D 0-S*X(KA))*X(KA)+1.0D 0-2.0D 0*X(KA+1)
      ELSE IF(KA.EQ.N) THEN
        FA=(3.0D 0-S*X(KA))*X(KA)+1.0D 0-X(KA-1)
      ELSE
        FA=(3.0D 0-S*X(KA))*X(KA)+1.0D 0-X(KA-1)-2.0D 0*X(KA+1)
      ENDIF
      F=F+FA**2
  671 CONTINUE
      F=0.5D 0*F
      RETURN
  680 DO 683 KA=1,NA
      S1=1.0D 0
      S2=1.0D 0
      S3=1.0D 0
      J1=3
      J2=3
      IF(KA-J1.GT.1) THEN
        I1=KA-J1
      ELSE
        I1=1
      ENDIF
      IF(KA+J2.LT.N) THEN
        I2=KA+J2
      ELSE
        I2=N
      ENDIF
      S=0.0D 0
      DO 681 J=I1,I2
        IF(J.NE.KA) S=S+X(J)+X(J)**2
  681 CONTINUE
      FA=(S1+S2*X(KA)**2)*X(KA)+1.D 0-S3*S
      F=F+FA**2
  683 CONTINUE
      F=0.5D 0*F
      RETURN
  690 DO 691 KA=1,NA
      IF(KA.EQ.1) THEN
        FA=X(1)**2-1.0D 0
      ELSE
        FA=X(KA-1)**2+LOG(X(KA))-1.0D 0
      ENDIF
      F=F+FA**2
  691 CONTINUE
      F=0.5D 0*F
      RETURN
  340 DO 341 KA=1,NA
      IF(KA.EQ.1) THEN
        FA=X(1)
      ELSE
        FA=COS(X(KA-1))+X(KA)-1.0D 0
      ENDIF
      F=F+FA**2
  341 CONTINUE
      F=0.5D 0*F
      RETURN
  360 DO 361 KA=1,NA
      S=(1.0D 0/DBLE(N+1))**2
      IF(N.EQ.1) THEN
        FA=2.0D 0*X(KA)-1.0D 0+S*(X(KA)+SIN(X(KA)))
      ELSE IF(KA.EQ.1) THEN
        FA=2.0D 0*X(KA)-X(KA+1)+S*(X(KA)+SIN(X(KA)))
      ELSE IF(KA.EQ.N) THEN
        FA=-X(KA-1)+2.0D 0*X(KA)-1.0D 0+S*(X(KA)+SIN(X(KA)))
      ELSE
        FA=-X(KA-1)+2.0D 0*X(KA)-X(KA+1)+S*(X(KA)+SIN(X(KA)))
      ENDIF
      F=F+FA**2
  361 CONTINUE
      F=0.5D 0*F
      RETURN
  380 DO 383 KA=1,NA
      IF(KA-5.GT.1) THEN
        I1=KA-5
      ELSE
        I1=1
      ENDIF
      IF(KA+1.LT.N) THEN
        I2=KA+1
      ELSE
        I2=N
      ENDIF
      S=0.0D 0
      DO 381 J=I1,I2
        IF(J.NE.KA) S=S+X(J)*(1.0D 0+X(J))
  381 CONTINUE
      FA=X(KA)*(2.0D 0+5.0D 0*X(KA)**2)+1.0D 0-S
      F=F+FA**2
  383 CONTINUE
      F=0.5D 0*F
      RETURN
  430 DO 433 KA=1,NA
      ALF=5
      BET=14
      GAM=3
      FA=DBLE(BET*N)*X(KA)+(DBLE(KA)-DBLE(N)/2.0D 0)**GAM
      DO 431 J=1,N
        IF(J.NE.KA) THEN
        T=SQRT(X(J)**2+DBLE(KA)/DBLE(J))
        S1=LOG(T)
        FA=FA+T*(SIN(S1)**ALF+COS(S1)**ALF)
      ENDIF
  431 CONTINUE
      F=F+FA**2
  433 CONTINUE
      F=0.5D 0*F
      RETURN
  440 DO 445 KA=1,NA
      C=0.5D 0
      H=1.0D 0/DBLE(N)
      FA=(1.0D 0-C*H/4.0D 0)
      DO 441 J=1,N
        S=C*H*DBLE(KA)/DBLE(2*(KA+J))
        IF(J.EQ.N) S=S/2.0D 0
        FA=FA-S*X(J)
  441 CONTINUE
      FA=-1.0D 0+X(KA)*FA
      F=F+FA**2
  445 CONTINUE
      F=0.5D 0*F
      RETURN
  270 DO 271 KA=1,NA
      H=1.0D 0/DBLE(N+1)
      T=2.0D 0*H**2
      IF(KA.EQ.1) THEN
      FA=2.0D 0*X(KA)-X(KA+1)-T*X(KA)**2-H*X(KA+1)
      ELSE IF(1.LT.KA.AND.KA.LT.N) THEN
      FA=-X(KA-1)+2.0D 0*X(KA)-X(KA+1)-T*X(KA)**2-H*(X(KA+1)-X(KA-1))
      ELSE IF(KA.EQ.N) THEN
      FA=-X(KA-1)+2.0D 0*X(KA)-0.5D 0-T*X(KA)**2-H*(0.5D 0-X(KA-1))
      ENDIF
      F=F+FA**2
  271 CONTINUE
      F=0.5D 0*F
      RETURN
  280 DO 288 KA=1,NA
      S=0.5D 0
      H=1.0D 0/DBLE(N+1)
      T=H**2/S
      T1=2.0D 0*H
      AL=0.0D 0
      BE=0.5D 0
      S1=0.0D 0
      DO 281 J=1,KA
        IF(J.EQ.1) THEN
           S1=S1+DBLE(J)*(X(J)**2+(X(J+1)-AL)/T1)
        ENDIF
        IF(1.LT.J.AND.J.LT.N) THEN
           S1=S1+DBLE(J)*(X(J)**2+(X(J+1)-X(J-1))/T1)
        ENDIF
        IF(J.EQ.N) THEN
           S1=S1+DBLE(J)*(X(J)**2+(BE-X(J-1))/T1)
        ENDIF
  281 CONTINUE
      S1=(1.0D 0-DBLE(KA)*H)*S1
      IF(KA.EQ.N) GO TO 283
      S2=0.0D 0
      DO 282 J=KA+1,N
        IF(J.LT.N) THEN
           S2=S2+(1.0D 0-DBLE(J)*H)*(X(J)**2+(X(J+1)-X(J-1))/T1)
        ELSE
           S2=S2+(1.0D 0-DBLE(J)*H)*(X(J)**2+(BE-X(J-1))/T1)
        ENDIF
  282 CONTINUE
      S1=S1+DBLE(KA)*S2
  283 FA=X(KA)-0.5D 0*DBLE(KA)*H-T*S1
      F=F+FA**2
  288 CONTINUE
      F=0.5D 0*F
      RETURN
  290 DO 291 KA=1,NA
      A=-9.0D-3
      B=1.0D-3
      AL=0.0D 0
      BE=25.0D 0
      GA=20.0D 0
      CA=0.3D 0
      CB=0.3D 0
      H=(B-A)/DBLE(N+1)
      T=A+DBLE(KA)*H
      H=H**2
      S=DBLE(KA)/DBLE(N+1)
      U=AL*(1.0D 0-S)+BE*S+X(KA)
      FF=CB*EXP(GA*(U-BE))-CA*EXP(GA*(AL-U))
      IF(T.LE.0) THEN
        FF=FF+CA
      ELSE
        FF=FF-CB
      ENDIF
      IF(N.EQ.1) THEN
        FA=-AL+2.0D 0*X(KA)-BE+H*FF
      ELSEIF(KA.EQ.1) THEN
        FA=-AL+2.0D 0*X(KA)-X(KA+1)+H*FF
      ELSEIF(KA.LT.N) THEN
        FA=-X(KA-1)+2.0D 0*X(KA)-X(KA+1)+H*FF
      ELSE
        FA=-X(KA-1)+2.0D 0*X(KA)-BE+H*FF
      ENDIF
      F=F+FA**2
  291 CONTINUE
      F=0.5D 0*F
      RETURN
  300 DO 301 KA=1,NA
      AL1=0.0D 0
      AL2=0.0D 0
      BE1=0.0D 0
      BE2=0.0D 0
      N1=N/2
      H=1.0D 0/DBLE(N1+1)
      T=DBLE(KA)*H
      IF(KA.EQ.1) THEN
        S1=2.0D 0*X(KA)-X(KA+1)
        B=AL1
      ELSE IF(KA.EQ.N1+1) THEN
        S1=2.0D 0*X(KA)-X(KA+1)
        B=AL2
      ELSE IF(KA.EQ.N1) THEN
        S1=-X(KA-1)+2.0D 0*X(KA)
        B=BE1
      ELSE IF(KA.EQ.N) THEN
        S1=-X(KA-1)+2.0D 0*X(KA)
        B=BE2
      ELSE
        S1=-X(KA-1)+2.0D 0*X(KA)-X(KA+1)
        B=0.0D 0
      ENDIF
      IF(KA.LE.N1) THEN
        S2=X(KA)**2+X(KA)+0.1D 0*X(N1+KA)**2-1.2D 0
      ELSE
        S2=0.2D 0*X(KA-N1)**2+X(KA)**2+2.0D 0*X(KA)-0.6D 0
      ENDIF
      FA=S1+H**2*S2-B
      F=F+FA**2
  301 CONTINUE
      F=0.5D 0*F
      RETURN
  710 DO 711 KA=1,NA
      ND=INT(SQRT(DBLE(N)))
      L=MOD(KA,ND)
      IF(L.EQ.0) THEN
         K=KA/ND
         L=ND
      ELSE
         K=INT(KA/ND)+1
      ENDIF
      A=1.0D 0
      H=1.0D 0/DBLE(ND+1)
      H2=A*H*H
      IF(L.EQ.1.AND.K.EQ.1) THEN
         FA=4.0D 0*X(1)-X(2)-X(ND+1)+H2*EXP(X(1))
      ENDIF
      IF(1.LT.L.AND.L.LT.ND.AND.K.EQ.1) THEN
         FA=4.0D 0*X(L)-X(L-1)-X(L+1)-X(L+ND)+H2*EXP(X(L))
      ENDIF
      IF(L.EQ.ND.AND.K.EQ.1) THEN
         FA=4.0D 0*X(ND)-X(ND-1)-X(ND+ND)+H2*EXP(X(ND))
      ENDIF
      IF(L.EQ.1.AND.1.LT.K.AND.K.LT.ND) THEN
         FA=4.0D 0*X(KA)-X(KA+1)-X(KA-ND)-X(KA+ND)+H2*EXP(X(KA))
      ENDIF
      IF(L.EQ.ND.AND.1.LT.K.AND.K.LT.ND) THEN
         FA=4.0D 0*X(KA)-X(KA-ND)-X(KA-1)-X(KA+ND)+H2*EXP(X(KA))
      ENDIF
      IF(L.EQ.1.AND.K.EQ.ND) THEN
         FA=4.0D 0*X(KA)-X(KA+1)-X(KA-ND)+H2*EXP(X(KA))
      ENDIF
      IF(1.LT.L.AND.L.LT.ND.AND.K.EQ.ND) THEN
         FA=4.0D 0*X(KA)-X(KA-1)-X(KA+1)-X(KA-ND)+H2*EXP(X(KA))
      ENDIF
      IF(L.EQ.ND.AND.K.EQ.ND) THEN
        FA=4.0D 0*X(KA)-X(KA-1)-X(KA-ND)+H2*EXP(X(KA))
      ENDIF
      IF(1.LT.L.AND.L.LT.ND.AND.1.LT.K.AND.K.LT.ND) THEN
      FA=4.0D 0*X(KA)-X(KA-1)-X(KA+1)-X(KA-ND)-X(KA+ND)+H2*EXP(X(KA))
      ENDIF
      F=F+FA**2
  711 CONTINUE
      F=0.5D 0*F
      RETURN
  820 DO 821 KA=1,NA
      ND=INT(SQRT(DBLE(N)))
      L=MOD(KA,ND)
      IF(L.EQ.0) THEN
         K=KA/ND
         L=ND
      ELSE
         K=INT(KA/ND)+1
      ENDIF
      H=1.0D 0/DBLE(ND+1)
      H2=H*H
      IF(L.EQ.1.AND.K.EQ.1) THEN
         FA=4.0D 0*X(1)-X(2)-X(ND+1)+H2*X(1)**2-24.0D 0/(H+1.0D 0)**2
      ENDIF
      IF(1.LT.L.AND.L.LT.ND.AND.K.EQ.1) THEN
         FA=4.0D 0*X(L)-X(L-1)-X(L+1)-X(L+ND)+H2*X(L)**2
     *-12.0D 0/(DBLE(L)*H+1.0D 0)**2
      ENDIF
      IF(L.EQ.ND.AND.K.EQ.1) THEN
         FA=4.0D 0*X(ND)-X(ND-1)-X(ND+ND)+H2*X(ND)**2
     *-12.0D 0/(DBLE(ND)*H+1.0D 0)**2-12.0D 0/(H+2.0D 0)**2
      ENDIF
      IF(L.EQ.1.AND.1.LT.K.AND.K.LT.ND) THEN
         FA=4.0D 0*X(KA)-X(KA+1)-X(KA-ND)-X(KA+ND)+H2*X(KA)**2
     *-12.0D 0/(DBLE(K)*H+1.0D 0)**2
      ENDIF
      IF(L.EQ.ND.AND.1.LT.K.AND.K.LT.ND) THEN
         FA=4.0D 0*X(KA)-X(KA-ND)-X(KA-1)-X(KA+ND)+H2*X(KA)**2
     *-12.0D 0/(DBLE(K)*H+2.0D 0)**2
      ENDIF
      IF(L.EQ.1.AND.K.EQ.ND) THEN
         FA=4.0D 0*X(KA)-X(KA+1)-X(KA-ND)+H2*X(KA)**2
     *-12.0D 0/(DBLE(ND)*H+1.0D 0)**2-12.0D 0/(H+2.0D 0)**2
      ENDIF
      IF(1.LT.L.AND.L.LT.ND.AND.K.EQ.ND) THEN
         FA=4.0D 0*X(KA)-X(KA-1)-X(KA+1)-X(KA-ND)+H2*X(KA)**2
     *-12.0D 0/(DBLE(L)*H+2.0D 0)**2
      ENDIF
      IF(L.EQ.ND.AND.K.EQ.ND) THEN
        FA=4.0D 0*X(KA)-X(KA-1)-X(KA-ND)+H2*X(KA)**2
     *-24.0D 0/(DBLE(ND)*H+2.0D 0)**2
      ENDIF
      IF(1.LT.L.AND.L.LT.ND.AND.1.LT.K.AND.K.LT.ND) THEN
         FA=4.0D 0*X(KA)-X(KA-1)-X(KA+1)-X(KA-ND)-X(KA+ND)+H2*X(KA)**2
      ENDIF
      F=F+FA**2
  821 CONTINUE
      F=0.5D 0*F
      RETURN
      END
