* SUBROUTINE EFGU01                ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENTS OF MODEL FUNCTIONS FOR UNCONSTRAINED MINIMIZATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  G(N)  GRADIENT OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EFGU01(N,X,G,NEXT)
      INTEGER N,NEXT
      REAL*8 X(N),G(N)
      REAL*8 A,B,C,D,P,Q,R,U,V,SX(1000),CX(1000)
      INTEGER I,J
      DO 1 I=1,N
      G(I)=0.0D 0
    1 CONTINUE
      GO TO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     &  170,180,190,200,210,220,230,240,250),NEXT
   10 DO 11 J=2,N
      A=X(J-1)**2-X(J)
      B=X(J-1)-1.0D 0
      G(J-1)=G(J-1)+4.0D 2*X(J-1)*A+2.0D 0*B
      G(J)=G(J)-2.0D 2*A
   11 CONTINUE
      RETURN
   20 DO 21 J=2,N-2,2
      A=X(J-1)**2-X(J)
      B=X(J-1)-1.0D 0
      C=X(J+1)**2-X(J+2)
      D=X(J+1)-1.0D 0
      U=X(J)+X(J+2)-2.0D 0
      V=X(J)-X(J+2)
      G(J-1)=G(J-1)+4.0D 2*X(J-1)*A+2.0D 0*B
      G(J)=G(J)-2.0D 2*A+2.0D 1*U+0.2D 0*V
      G(J+1)=G(J+1)+3.6D 2*X(J+1)*C+2.0D 0*D
      G(J+2)=G(J+2)-1.8D 2*C+2.0D 1*U-0.2D 0*V
   21 CONTINUE
      RETURN
   30 DO 31 J=2,N-2,2
      A=X(J-1)+1.0D 1*X(J)
      B=X(J+1)-X(J+2)
      C=X(J)-2.0D 0*X(J+1)
      D=X(J-1)-X(J+2)
      G(J-1)=G(J-1)+2.0D 0*A+4.0D 1*D**3
      G(J)=G(J)+2.0D 1*A+4.0D 0*C**3
      G(J+1)=G(J+1)-8.0D 0*C**3+1.0D 1*B
      G(J+2)=G(J+2)-4.0D 1*D**3-1.0D 1*B
   31 CONTINUE
      RETURN
   40 DO 41 J=2,N-2,2
      A=EXP(X(J-1))
      B=A-X(J)
      B=4.0D 0*B**3
      D=X(J)-X(J+1)
      D=6.0D 2*D**5
      P=X(J+1)-X(J+2)
      C=COS(P)
      Q=SIN(P)/COS(P)
      Q=4.0D 0*Q**3/C**2
      U=X(J-1)
      V=X(J+2)-1.0D 0
      G(J-1)=G(J-1)+A*B+8.0D 0*U**7
      G(J)=G(J)+D-B
      G(J+1)=G(J+1)+Q-D
      G(J+2)=G(J+2)+2.0D 0*V-Q
   41 CONTINUE
      RETURN
   50 P=7.0D 0/3.0D 0
      DO 51 J=1,N
      A=(3.0D 0-2.0D 0*X(J))*X(J)+1.0D 0
      IF (J.GT.1) A=A-X(J-1)
      IF (J.LT.N) A=A-X(J+1)
      B=P*ABS(A)**(P-1.0D 0)*SIGN(1.0D 0,A)
      G(J)=G(J)+B*(3.0D 0-4.0D 0*X(J))
      IF (J.GT.1) G(J-1)=G(J-1)-B
      IF (J.LT.N) G(J+1)=G(J+1)-B
   51 CONTINUE
      RETURN
   60 P=7.0D 0/3.0D 0
      DO 63 J=1,N
      A=(2.0D 0+5.0D 0*X(J)**2)*X(J)+1.0D 0
      DO 61 I=MAX(1,J-5),MIN(N,J+1)
      A=A+X(I)*(1.0D 0+X(I))
   61 CONTINUE
      B=P*ABS(A)**(P-1.0D 0)*SIGN(1.0D 0,A)
      G(J)=G(J)+B*(2.0D 0+1.5D 1*X(J)**2)
      DO 62 I=MAX(1,J-5),MIN(N,J+1)
      G(I)=G(I)+B*(1.0D 0+2.0D 0*X(I))
   62 CONTINUE
   63 CONTINUE
      RETURN
   70 P=7.0D 0/3.0D 0
      DO 71 J=1,N
      A=(3.0D 0-2.0D 0*X(J))*X(J)+1.0D 0
      IF (J.GT.1) A=A-X(J-1)
      IF (J.LT.N) A=A-X(J+1)
      B=P*ABS(A)**(P-1.0D 0)*SIGN(1.0D 0,A)
      G(J)=G(J)+B*(3.0D 0-4.0D 0*X(J))
      IF (J.GT.1) G(J-1)=G(J-1)-B
      IF (J.LT.N) G(J+1)=G(J+1)-B
   71 CONTINUE
      DO 72 J=1,N/2
      A=X(J)+X(J+N/2)
      B=P*ABS(A)**(P-1.0D 0)*SIGN(1.0D 0,A)
      G(J)=G(J)+B
      G(J+N/2)=G(J+N/2)+B
   72 CONTINUE
      RETURN
   80 DO 81 J=1,N
      SX(J)=SIN(X(J))
      CX(J)=COS(X(J))
   81 CONTINUE
      DO 84 I=1,N
      P=0.0D 0
      DO 82 J=1,N
      A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(J,5))
      B=DBLE(I+J)/1.0D 1
      P=P+A*SX(J)+B*CX(J)
   82 CONTINUE
      P=2.0D 0*(DBLE(N+I)-P)
      DO 83 J=1,N
      A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(J,5))
      B=DBLE(I+J)/1.0D 1
      G(J)=G(J)-P*(A*CX(J)-B*SX(J))
   83 CONTINUE
   84 CONTINUE
      RETURN
   90 DO 92 I=1,N
      DO 91 J=1,N
      IF (MOD(ABS(I-J),4).EQ.0) THEN
      A=5.0D 0*(1.0D 0+MOD(I,5)+MOD(J,5))
      B=DBLE(I+J)/1.0D 1
      C=1.0D 0+DBLE(I)/1.0D 1
      D=1.0D 0+DBLE(J)/1.0D 1
      P=A*COS(B+C*X(I)+D*X(J))
      G(I)=G(I)+P*C
      G(J)=G(J)+P*D
      ENDIF
   91 CONTINUE
   92 CONTINUE
      RETURN
  100 A=1.0D 0
      B=1.0D 0
      DO 101 J=1,N
      A=A-1.0D 0/X(J)
      B=B-DBLE(J)/X(J)
  101 CONTINUE
      DO 102 J=1,N
      G(J)=G(J)+SIGN(1.0D 0,X(J))+2.0D 3*(A+B*DBLE(J))/X(J)**2
  102 CONTINUE
      RETURN
  110 P=-0.2008D-2
      Q=-0.1900D-2
      R=-0.0261D-2
      DO 112 I=0,N-5,5
      A=1.0D 0
      B=0.0D 0
      DO 111 J=1,5
      A=A*X(I+J)
      B=B+X(I+J)**2
  111 CONTINUE
      A=A*EXP(A)
      B=B-1.0D 1-P
      C=X(I+2)*X(I+3)-5.0D 0*X(I+4)*X(I+5)-Q
      D=X(I+1)**3+X(I+2)**3+1.0D 0-R
      G(I+1)=G(I+1)+A/X(I+1)+2.0D 1*(2.0D 0*B*X(I+1)+
     &  3.0D 0*D*X(I+1)**2)
      G(I+2)=G(I+2)+A/X(I+2)+2.0D 1*(2.0D 0*B*X(I+2)+
     &  C*X(I+3)+3.0D 0*D*X(I+2)**2)
      G(I+3)=G(I+3)+A/X(I+3)+2.0D 1*(2.0D 0*B*X(I+3)+C*X(I+2))
      G(I+4)=G(I+4)+A/X(I+4)+2.0D 1*(2.0D 0*B*X(I+4)-
     &  5.0D 0*C*X(I+5))
      G(I+5)=G(I+5)+A/X(I+5)+2.0D 1*(2.0D 0*B*X(I+5)-5.0D 0*C*X(I+4))
  112 CONTINUE
      RETURN
  120 C=0.0D 0
      DO 121 J=2,N,2
      A=X(J-1)-3.0D 0
      B=X(J-1)-X(J)
      C=C+A
      G(J-1)=G(J-1)+2.0D-4*A-1.0D 0+2.0D 1*EXP(2.0D 1*B)
      G(J)=G(J)+1.0D 0-2.0D 1*EXP(2.0D 1*B)
  121 CONTINUE
      DO 122 J=2,N,2
      G(J-1)=G(J-1)+2.0D 0*C
  122 CONTINUE
      RETURN
  130 DO 131 J=2,N,2
      A=X(J)**2
      IF (A.EQ.0.0D 0) A=1.0D-60
      B=X(J-1)**2
      IF (B.EQ.0.0D 0) B=1.0D-60
      C=A+1.0D 0
      D=B+1.0D 0
      P=0.0D 0
      IF (A.GT.P) P=LOG(A)
      Q=0.0D 0
      IF (B.GT.Q) Q=LOG(B)
      G(J-1)=G(J-1)+2.0D 0*X(J-1)*(C*B**A+P*A**D)
      G(J)=G(J)+2.0D 0*X(J)*(D*A**B+Q*B**C)
  131 CONTINUE
      RETURN
  140 P=1.0D 0/DBLE(N+1)
      Q=0.5D 0*P**2
      DO 141 J=1,N
      A=2.0D 0*X(J)+Q*(X(J)+DBLE(J)*P+1.0D 0)**3
      IF(J.GT.1) A=A-X(J-1)
      IF(J.LT.N) A=A-X(J+1)
      G(J)=G(J)+A*(4.0D 0+6.0D 0*Q*(X(J)+DBLE(J)*P+1.0D 0)**2.0D 0)
      IF(J.GT.1) G(J-1)=G(J-1)-2.0D 0*A
      IF(J.LT.N) G(J+1)=G(J+1)-2.0D 0*A
  141 CONTINUE
      RETURN
  150 P=1.0D 0/DBLE(N+1)
      Q=2.0D 0/P
      R=2.0D 0*P
      DO 151 J=2,N
      A=X(J-1)-X(J)
      G(J-1)=G(J-1)+Q*(2.0D 0*X(J-1)-X(J))
      G(J)=G(J)-Q*X(J-1)
      IF (ABS(A).LE.1.0D-6) THEN
      G(J-1)=G(J-1)+R*EXP(X(J))*(1.0D 0/2.0D 0+A*(1.0D 0/3.0D 0+
     &  A/8.0D 0))
      G(J)=G(J)+R*EXP(X(J))*(1.0D 0/2.0D 0+A*(1.0D 0/6.0D 0+
     &  A/24.0D 0))
      ELSE
      B=EXP(X(J-1))-EXP(X(J))
      G(J-1)=G(J-1)+R*(EXP(X(J-1))*A-B)/A**2
      G(J)=G(J)-R*(EXP(X(J))*A-B)/A**2
      ENDIF
  151 CONTINUE
      G(1)=G(1)+R*(EXP(X(1))*(X(1)-1.0D 0)+1.0D 0)/X(1)**2
      G(N)=G(N)+2.0D 0*Q*X(N)
     &         +R*(EXP(X(N))*(X(N)-1.0D 0)+1.0D 0)/X(N)**2
      RETURN
  160 DO 161 J=1,N
      A=DBLE(J)*SIN(X(J))
      G(J)=G(J)+A
      IF(J.GT.1) G(J-1)=G(J-1)+DBLE(J)*COS(X(J-1))
      IF(J.LT.N) G(J+1)=G(J+1)-DBLE(J)*COS(X(J+1))
  161 CONTINUE
      RETURN
  170 P=1.0D 0/DBLE(N+1)
      DO 171 J=1,N
      IF (J.EQ.1) THEN
      G(J)=G(J)+0.5D 0*X(J)/P+P*EXP(X(J))
      G(J+1)=G(J+1)+0.25D 0*X(J+1)/P
      ELSE IF (J.EQ.N) THEN
      G(J)=G(J)+0.5D 0*X(J)/P+P*EXP(X(J))
      G(J-1)=G(J-1)+0.25D 0*X(J-1)/P
      ELSE
      A=0.25D 0*(X(J+1)-X(J-1))/P
      G(J)=G(J)+P*EXP(X(J))
      G(J-1)=G(J-1)-A
      G(J+1)=G(J+1)+A
      ENDIF
  171 CONTINUE
      RETURN
  180 P=1.0D 0/DBLE(N+1)
      DO 181 J=1,N
      Q=DBLE(J)*P
      IF (J.EQ.1) THEN
      G(J)=G(J)+X(J)/P-2.0D 0*P*(X(J)+Q)
      G(J+1)=G(J+1)+0.5D 0*X(J+1)/P
      ELSE IF (J.EQ.N) THEN
      G(J)=G(J)+X(J)/P-2.0D 0*P*(X(J)+Q)
      G(J-1)=G(J-1)+0.5D 0*X(J-1)/P
      ELSE
      A=0.5D 0*(X(J+1)-X(J-1))/P
      G(J)=G(J)-2.0D 0*P*(X(J)+Q)
      G(J-1)=G(J-1)-A
      G(J+1)=G(J+1)+A
      ENDIF
  181 CONTINUE
      RETURN
  190 P=1.0D 0/DBLE(N+1)
      DO 191 J=1,N
      Q=EXP(2.0D 0*DBLE(J)*P)
      IF (J.EQ.1) THEN
      R=1.0D 0/3.0D 0
      A=0.5D 0*(X(J+1)-R)/P
      G(J)=G(J)+2.0D 0*P*(X(J)+Q)+(X(J)-R)/P
      G(J+1)=G(J+1)+A
      ELSE IF (J.EQ.N) THEN
      R=EXP(2.0D 0)/3.0D 0
      A=0.5D 0*(X(J-1)-R)/P
      G(J)=G(J)+2.0D 0*P*(X(J)+Q)+(X(J)-R)/P
      G(J-1)=G(J-1)+A
      ELSE
      A=0.5D 0*(X(J+1)-X(J-1))/P
      G(J)=G(J)+2.0D 0*P*(X(J)+Q)
      G(J-1)=G(J-1)-A
      G(J+1)=G(J+1)+A
      ENDIF
  191 CONTINUE
      RETURN
  200 P=1.0D 0/DBLE(N+1)
      DO 201 J=1,N
      A=EXP(-2.0D 0*X(J)**2)
      IF (J.EQ.1) THEN
      B=0.5D 0*X(J+1)/P
      G(J)=G(J)+X(J)/P-4.0D 0*X(J)*A*P*(B**2-1.0D 0)
      G(J+1)=G(J+1)+A*B
      ELSE IF (J.EQ.N) THEN
      B=0.5D 0*X(J-1)/P
      G(J)=G(J)+X(J)/P*EXP(-2.0D 0)-4.0D 0*X(J)*A*P*(B**2-1.0D 0)
      G(J-1)=G(J-1)+A*B
      ELSE
      B=0.5D 0*(X(J+1)-X(J-1))/P
      G(J)=G(J)-4.0D 0*X(J)*A*P*(B**2-1.0D 0)
      G(J-1)=G(J-1)-A*B
      G(J+1)=G(J+1)+A*B
      ENDIF
  201 CONTINUE
      RETURN
  210 P=1.0D 0/DBLE(N+1)
      DO 211 J=1,N
      IF (J.EQ.1) THEN
      A=0.5D 0*(X(J+1)-1.0D 0)/P
      B=(X(J)-1.0D 0)/P
      U=0.5D 0*ATAN(A)
      V=0.5D 0*ATAN(B)
      G(J)=G(J)+2.0D 0*P*X(J)+V
      G(J+1)=G(J+1)+ U
      ELSE IF (J.EQ.N) THEN
      A=0.5D 0*(2.0D 0-X(J-1))/P
      B=(2.0D 0-X(J))/P
      U=0.5D 0*ATAN(A)
      V=0.5D 0*ATAN(B)
      G(J)=G(J)+2.0D 0*P*X(J)-V
      G(J-1)=G(J-1)-U
      ELSE
      A=0.5D 0*(X(J+1)-X(J-1))/P
      U=0.5D 0*ATAN(A)
      G(J)=G(J)+2.0D 0*P*X(J)
      G(J-1)=G(J-1)-U
      G(J+1)=G(J+1)+U
      ENDIF
  211 CONTINUE
      RETURN
  220 P=1.0D 0/DBLE(N+1)
      DO 221 J=1,N
      IF (J.EQ.1) THEN
      A= 0.5D 0*X(J+1)/P
      B= X(J)/P
      G(J)=G(J)+2.0D 2*P*(X(J)-A**2)+2.0D 2*B**3-(1.0D 0-B)
      G(J+1)=G(J+1)-2.0D 2*(X(J)-A**2)*A-(1.0D 0-A)
      ELSE IF (J.EQ.N) THEN
      A=-0.5D 0*X(J-1)/P
      B=-X(J)/P
      G(J)=G(J)+2.0D 2*P*(X(J)-A**2)-2.0D 2*B**3+(1.0D 0-B)
      G(J-1)=G(J-1)+2.0D 2*(X(J)-A**2)*A+(1.0D 0-A)
      ELSE
      A=0.5D 0*(X(J+1)-X(J-1))/P
      G(J)=G(J)+2.0D 2*P*(X(J)-A**2)
      G(J-1)=G(J-1)+2.0D 2*(X(J)-A**2)*A+(1.0D 0-A)
      G(J+1)=G(J+1)-2.0D 2*(X(J)-A**2)*A-(1.0D 0-A)
      ENDIF
  221 CONTINUE
      RETURN
  230 A=1.0D 0
      B=1.0D-3
      D=0.0D 0
      DO 231 J=1,N
      D=D+X(J)**2
  231 CONTINUE
      DO 232 J=1,N
      G(J)=2.0D 0*A*(X(J)-1.0D 0)+4.0D 0*B*(D-2.5D-1)*X(J)
  232 CONTINUE
      RETURN
  240 A=1.0D 0
      B=1.0D-3
      D=DBLE(N)*X(1)**2
      DO 241 J=2,N
      D=D+DBLE(N-J+1)*X(J)**2
  241 CONTINUE
      D=D-1.0D 0
      R=D**2+(X(1)-2.0D-1)**2
      G(1)=G(1)+4.0D 0*B*R*((X(1)-2.0D-1)+2.0D 0*D*DBLE(N)*X(1))
      DO 242 J=2,N
      P=EXP(1.0D-1*X(J))
      Q=EXP(1.0D-1*X(J-1))
      U=P-EXP( 1.0D-1*DBLE(J))+Q-EXP(1.0D-1*DBLE(J-1))
      V=P-EXP(-1.0D-1)
      G(J)=G(J)+2.0D-1*A*P*(U+V)+8.0D 0*B*D*R*DBLE(N-J+1)*X(J)
      G(J-1)=G(J-1)+2.0D-1*A*Q*U
  242 CONTINUE
      RETURN
  250 A=1.0D 0
      B=0.0D 0
      C=0.0D 0
      D=0.0D 0
      U=EXP(X(N))
      V=EXP(X(N-1))
      DO 251 J=1,N
      IF (J.LE.N-2) THEN
      B=B+(X(J)+2.0D 0*X(J+1)+1.0D 1*X(J+2)-1.0D 0)**2
      C=C+(2.0D 0*X(J)+X(J+1)-3.0D 0)**2
      ENDIF
      D=D+X(J)**2-DBLE(N)
  251 CONTINUE
      DO 252 J=1,N
      IF (J.LE.N/2) G(J)=G(J)+2.0D 0*(X(J)-1.0D 0)
      IF (J.LE.N-2) THEN
      P=A*(U+C)*(X(J)+2.0D 0*X(J+1)+1.0D 1*X(J+2)-1.0D 0)
      Q=A*(V+B)*(2.0D 0*X(J)+X(J+1)-3.0D 0)
      G(J)=G(J)+2.0D 0*P+4.0D 0*Q
      G(J+1)=G(J+1)+4.0D 0*P+2.0D 0*Q
      G(J+2)=G(J+2)+2.0D 1*P
      ENDIF
      G(J)=G(J)+4.0D 0*D*X(J)
  252 CONTINUE
      G(N-1)=G(N-1)+A*V*C
      G(N)=G(N)+A*U*B
      RETURN
      END
