* SUBROUTINE EFGU03                ALL SYSTEMS                92/11/01
C PORTABILITY : ALL SYSTEMS
C 92/11/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENTS OF MODEL FUNCTIONS FOR CONSTRAINED MINIMIZATION.
*  UNIVERSAL VERSION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  X(N)  VECTOR OF VARIABLES.
*  RO  G(N)  GRADIENT OF THE MODEL FUNCTION.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*
      SUBROUTINE EFGU03(N,X,G,NEXT)
      INTEGER N,NEXT
      REAL*8 X(N),G(N)
      REAL*8 A,B,C,D,E,F,PI,SOU,AEXP,BEXP,CEXP,HI,SQ,H,HK
      INTEGER I,J
      REAL*8 CC(5,5),EV(5),DV(5),CV(10),Y(235)
      REAL*8 AA(16,16)
      COMMON /EMPR03/ Y
      PI=3.1415926535897932D 0
      GO TO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150) NEXT
   10 A=PI
      B=A/1.2D 1
      C=A/1.6D 1
      G(1)=B*COS(B*X(1))*COS(C*X(2))
      G(2)=-C*SIN(B*X(1))*SIN(C*X(2))
      RETURN
   20 A=2.7D 1*SQRT(3.0D 0)
      G(1)=2.0D 0*(X(1)-3.0D 0)*X(2)**3/A
      G(2)=((X(1)-3.0D 0)**2-9.0D 0)*3.0D 0*X(2)**2/A
      RETURN
   30 A=X(3)+3.0D-2
      B=A+X(2)
      C=B+X(1)
      D=1.3D-1*X(3)+3.0D-2
      E=A+7.0D-2*X(2)
      F=B+9.0D-2*X(1)
      G(1)=-32.174D 0*255.0D 0*(F-9.0D-2*C)/(F*C)
      G(2)=-32.174D 0*(255.0D 0*(F-C)/(F*C)+
     10280.0D 0*(E-7.0D-2*B)/(E*B))
      G(3)=-32.174D 0*(255.0D 0*(F-C)/(F*C)+
     &  280.0D 0*(E-B)/(E*B)+290.0D 0*(D-1.3D-1*A)/(D*A))
      RETURN
   40 G(1)=-X(2)*X(3)
      G(2)=-X(1)*X(3)
      G(3)=-X(1)*X(2)
      RETURN
   50 G(4)=0.0D 0
      GO TO 40
   60 A=X(1)+1.0D 1*X(2)
      B=X(3)-X(4)
      C=(X(2)-2.0D 0*X(3))**3
      D=(X(1)-X(4))**3
      G(1)=2.0D 0*A+4.0D 1*D
      G(2)=2.0D 1*A+4.0D 0*C
      G(3)=1.0D 1*B-8.0D 0*C
      G(4)=-1.0D 1*B-4.0D 1*D
      RETURN
   70 A=2.0D 0*(X(1)-X(2))
      B=2.0D 0*(X(3)-1.0D 0)
      C=4.0D 0*(X(4)-1.0D 0)**3
      D=6.0D 0*(X(5)-1.0D 0)**5
      G(1)=A
      G(2)=-A
      G(3)=B
      G(4)=C
      G(5)=D
      RETURN
   80 A=2.0D 0*(X(1)-X(2))
      B=2.0D 0*(X(2)-X(3))
      C=4.0D 0*(X(3)-X(4))**3
      D=2.0D 0*(X(4)-X(5))
      G(1)=A
      G(2)=B-A
      G(3)=C-B
      G(4)=D-C
      G(5)=-D
      RETURN
   90 A=2.0D 0*(X(1)-X(2))
      B=2.0D 0*(X(2)+X(3)-2.0D 0)
      G(1)=A
      G(2)=-A+B
      G(3)=B
      G(4)=2.0D 0*(X(4)-1.0D 0)
      G(5)=2.0D 0*(X(5)-1.0D 0)
      RETURN
  100 EV(1)=-15.0D 0
      EV(2)=-27.0D 0
      EV(3)=-36.0D 0
      EV(4)=-18.0D 0
      EV(5)=-12.0D 0
      CC(1,1)=30.0D 0
      CC(1,2)=-20.0D 0
      CC(1,3)=-10.0D 0
      CC(1,4)=32.0D 0
      CC(1,5)=-10.0D 0
      CC(2,1)=-20.0D 0
      CC(2,2)=39.0D 0
      CC(2,3)=-6.0D 0
      CC(2,4)=-31.0D 0
      CC(2,5)=32.0D 0
      CC(3,1)=-10.0D 0
      CC(3,2)=-6.0D 0
      CC(3,3)=10.0D 0
      CC(3,4)=-6.0D 0
      CC(3,5)=-10.0D 0
      CC(4,1)=32.0D 0
      CC(4,2)=-31.0D 0
      CC(4,3)=-6.0D 0
      CC(4,4)=39.0D 0
      CC(4,5)=-20.0D 0
      CC(5,1)=-10.0D 0
      CC(5,2)=32.0D 0
      CC(5,3)=-10.0D 0
      CC(5,4)=-20.0D 0
      CC(5,5)=30.0D 0
      DV(1)=4.0D 0
      DV(2)=8.0D 0
      DV(3)=10.0D 0
      DV(4)=6.0D 0
      DV(5)=2.0D 0
      DO 105 J=1,5
      G(J)=0.0D 0
  105 CONTINUE
      DO 106 J=1,5
      DO 107 I=1,5
      G(J)=G(J)+(CC(I,J)+CC(J,I))*X(I)
  107 CONTINUE
      G(J)=G(J)+EV(J)+3.0D 0*DV(J)*X(J)**2
  106 CONTINUE
      RETURN
  110 HK=0.96D 0*4.9D 13
      H=((X(1)-1.0D 4)**2/6.4D 7+(X(1)-1.0D 4)*(X(2)-1.0D 0)/2.0D 4+
     &  (X(2)-1.0D 0)**2)*(X(3)-2.0D 6)**2/HK+
     &  (X(4)-10.0D 0)**2/2.5D 3+(X(5)-1.0D-3)**2/2.5D-3+
     &  (X(6)-1.0D 8)**2/2.5D 17
      D=EXP(-H/2.0D 0)/2.0D 0
      G(1)=D*(2.0D 0*(X(1)-1.0D 4)/6.4D 7+(X(2)-1.0D 0)/2.0D 4)*
     &     (X(3)-2.0D 6)**2/HK
      G(2)=D*((X(1)-1.0D 4)/2.0D 4+
     &     2.0D 0*(X(2)-1.0D 0))*(X(3)-2.0D 6)**2/HK
      G(3)=D*((X(1)-1.0D 4)**2/6.4D 7+
     &     (X(1)-1.0D 4)*(X(2)-1.0D 0)/2.0D 4+
     &     (X(2)-1.0D 0)**2)*2.0D 0*(X(3)-2.0D 6)/HK
      G(4)=D*2.0D 0*(X(4)-10.0D 0)/2.5D 3
      G(5)=D*2.0D 0*(X(5)-1.0D-3)/2.5D-3
      G(6)=D*2.0D 0*(X(6)-1.0D 8)/2.5D 17
      RETURN
  120 G(1)=1.0D 0+X(4)*EXP(X(1)*X(4))
      G(2)=2.0D 0
      G(3)=0.0D 0
      G(4)=X(1)*EXP(X(1)*X(4))
      G(5)=4.0D 0
      G(6)=0.0D 0
      RETURN
  130 DO 131 J=1,8
      G(J)=0.0D 0
  131 CONTINUE
      SQ=SQRT(2.0D 0*PI)
      DO 132 I=1,235
      AEXP=EXP(-(Y(I)-X(3))**2/(2.0D 0*X(6)**2))
      A=X(1)/X(6)*AEXP
      BEXP=EXP(-(Y(I)-X(4))**2/(2.0D 0*X(7)**2))
      B=X(2)/X(7)*BEXP
      CEXP=EXP(-(Y(I)-X(5))**2/(2.0D 0*X(8)**2))
      C=(1.0D 0-X(2)-X(1))/X(8)*CEXP
      HI=-SQ/(A+B+C)
      G(1)=G(1)+HI*(AEXP/X(6)-CEXP/X(8))
      G(2)=G(2)+HI*(BEXP/X(7)-CEXP/X(8))
      G(3)=G(3)+HI*X(1)/X(6)*AEXP*(Y(I)-X(3))/(X(6)**2)
      G(4)=G(4)+HI*X(2)/X(7)*BEXP*(Y(I)-X(4))/(X(7)**2)
      G(5)=G(5)+HI*(1.0D 0-X(2)-X(1))/X(8)*CEXP*(Y(I)-X(5))/(X(8)**2)
      G(6)=G(6)+HI*((-X(1)/(X(6)**2))*AEXP+
     &   X(1)/X(6)*AEXP*(Y(I)-X(3))**2/(X(6)**3))
      G(7)=G(7)+HI*((-X(2)/(X(7)**2))*BEXP+
     &   X(2)/X(7)*BEXP*(Y(I)-X(4))**2/(X(7)**3))
      G(8)=G(8)+HI*((X(1)+X(2)-1.0D 0)/(X(8)**2)*CEXP+
     &   (1.0D 0-X(2)-X(1))/X(8)*CEXP*(Y(I)-X(5))**2/(X(8)**3))
  132 CONTINUE
      RETURN
  140 CV(1)=-6.089D 0
      CV(2)=-17.164D 0
      CV(3)=-34.054D 0
      CV(4)=-5.914D 0
      CV(5)=-24.721D 0
      CV(6)=-14.986D 0
      CV(7)=-24.100D 0
      CV(8)=-10.708D 0
      CV(9)=-26.662D 0
      CV(10)=-22.179D 0
      SOU=0.0D 0
      DO 142 J=1,10
      SOU=SOU+X(J)
  142 CONTINUE
      DO 143 J=1,10
      G(J)=CV(J)+LOG(X(J)/SOU)
  143 CONTINUE
      RETURN
  150 DO 151 I=1,16
      DO 152 J=1,16
      AA(I,J)=0.0D 0
  152 CONTINUE
  151 CONTINUE
      DO 153 I=1,16
      AA(I,I)=1.0D 0
  153 CONTINUE
      AA(1,4)=1.0D 0
      AA(1,7)=1.0D 0
      AA(1,8)=1.0D 0
      AA(1,16)=1.0D 0
      AA(2,3)=1.0D 0
      AA(2,7)=1.0D 0
      AA(2,10)=1.0D 0
      AA(3,7)=1.0D 0
      AA(3,9)=1.0D 0
      AA(3,10)=1.0D 0
      AA(3,14)=1.0D 0
      AA(4,7)=1.0D 0
      AA(4,11)=1.0D 0
      AA(4,15)=1.0D 0
      AA(5,6)=1.0D 0
      AA(5,10)=1.0D 0
      AA(5,12)=1.0D 0
      AA(5,16)=1.0D 0
      AA(6,8)=1.0D 0
      AA(6,15)=1.0D 0
      AA(7,11)=1.0D 0
      AA(7,13)=1.0D 0
      AA(8,10)=1.0D 0
      AA(8,15)=1.0D 0
      AA(9,12)=1.0D 0
      AA(9,16)=1.0D 0
      AA(10,14)=1.0D 0
      AA(11,13)=1.0D 0
      AA(12,14)=1.0D 0
      AA(13,14)=1.0D 0
      DO 154 J=1,16
      G(J)=0.0D 0
  154 CONTINUE
      DO 155 J=1,16
      DO 156 I=1,16
      G(J)=G(J)+
     &  (AA(I,J)+AA(J,I))*(X(I)**2+X(I)+1.0D 0)*(2.0D 0*X(J)+1.0D 0)
  156 CONTINUE
  155 CONTINUE
      RETURN
      END
