* SUBROUTINE EIUD02             ALL SYSTEMS                 91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES FOR NONLINEAR APPROXIMATION.
*  UNCONSTRAINED AND DENSE VERSION.
*
* PARAMETERS :
*  IO  N  NUMBER OF VARIABLES.
*  IO  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  IO  NAL NUMBER OF LINEAR APPROXIMATED FUNCTIONS.
*  RO  X(N)  VECTOR OF VARIABLES.
*  RO  FMIN  LOWER BOUND FOR VALUE OF THE OBJECTIVE FUNCTION.
*  RO  XMAX  MAXIMUM STEPSIZE.
*  IO  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIUD02(N,NA,NAL,X,FMIN,XMAX,NEXT,IEXT,IERR)
      INTEGER I,N,NA,NAL,NEXT,IEXT,IERR
      REAL*8 X(N),FMIN,XMAX
      REAL*8 Y(65),W
      COMMON /EMPR02/ Y
      NAL=0
      FMIN=0.0D 0
      XMAX=1.0D 3
      IEXT=0
      IERR=0
      GOTO(10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     &    170,180,190,200,210,220,230,240,250,260,270,280,290,300),NEXT
   10 IF(N.GE.2.AND.NA.GE.2) THEN
      N=2
      NA=2
      X(1)=-1.2D 0
      X(2)=1.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   20 IF(N.GE.2.AND.NA.GE.2) THEN
      N=2
      NA=2
      X(1)=0.5D 0
      X(2)=-2.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   30 IF(N.GE.2.AND.NA.GE.2) THEN
      N=2
      NA=2
      X(1)=0.0D 0
      X(2)=1.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   40 IF(N.GE.2.AND.NA.GE.3) THEN
      N=2
      NA=3
      X(1)=1.0D 0
      X(2)=1.0D 0
      XMAX=1.0D 6
      ELSE
      IERR=1
      ENDIF
      RETURN
   50 IF(N.GE.2.AND.NA.GE.3) THEN
      N=2
      NA=3
      X(1)=1.0D 0
      X(2)=1.0D 0
      Y(1)=1.5D 0
      Y(2)=2.25D 0
      Y(3)=2.625D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   60 IF(N.GE.2.AND.NA.GE.2) THEN
      N=2
      NA=MIN(NA,10)
      X(1)=0.3D 0
      X(2)=0.4D 0
      XMAX=1.0D 1
      ELSE
      IERR=1
      ENDIF
      RETURN
   70 IF(N.GE.3.AND.NA.GE.3) THEN
      N=3
      NA=3
      X(1)=-1.0D 0
      X(2)=0.0D 0
      X(3)=0.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   80 IF(N.GE.3.AND.NA.GE.15) THEN
      N=3
      NA=15
      X(1)=1.0D 0
      X(2)=1.0D 0
      X(3)=1.0D 0
      Y(1)=0.14D 0
      Y(2)=0.18D 0
      Y(3)=0.22D 0
      Y(4)=0.25D 0
      Y(5)=0.29D 0
      Y(6)=0.32D 0
      Y(7)=0.35D 0
      Y(8)=0.39D 0
      Y(9)=0.37D 0
      Y(10)=0.58D 0
      Y(11)=0.73D 0
      Y(12)=0.96D 0
      Y(13)=1.34D 0
      Y(14)=2.10D 0
      Y(15)=4.39D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
   90 IF(N.GE.3.AND.NA.GE.15) THEN
      N=3
      NA=15
      X(1)=0.4D 0
      X(2)=1.0D 0
      X(3)=0.0D 0
      Y(1)=0.0009D 0
      Y(2)=0.0044D 0
      Y(3)=0.0175D 0
      Y(4)=0.0540D 0
      Y(5)=0.1295D 0
      Y(6)=0.2420D 0
      Y(7)=0.3521D 0
      Y(8)=0.3989D 0
      Y(9)=0.3521D 0
      Y(10)=0.2420D 0
      Y(11)=0.1295D 0
      Y(12)=0.0540D 0
      Y(13)=0.0175D 0
      Y(14)=0.0044D 0
      Y(15)=0.0009D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  100 IF(N.GE.3.AND.NA.GE.16) THEN
      N=3
      NA=16
      X(1)=0.02D 0
      X(2)=4.0D 3
      X(3)=2.5D 2
      Y(1)=3478D 1
      Y(2)=2861D 1
      Y(3)=2365D 1
      Y(4)=1963D 1
      Y(5)=1637D 1
      Y(6)=1372D 1
      Y(7)=1154D 1
      Y(8)=9744D 0
      Y(9)=8261D 0
      Y(10)=7030D 0
      Y(11)=6005D 0
      Y(12)=5147D 0
      Y(13)=4427D 0
      Y(14)=3820D 0
      Y(15)=3307D 0
      Y(16)=2872D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  110 IF(N.GE.3.AND.NA.GE.3) THEN
      N=3
      NA=MIN(NA,20)
      X(1)=5.0D 0
      X(2)=2.5D 0
      X(3)=0.15D 0
      DO 111 I=1,NA
      Y(I)=2.5D 1+(-5.0D 1*LOG(1.0D-2*DBLE(I)))**(2.0D 0/3.0D 0)
C     Y(I)=Y(I)*DBLE(NA*I)
  111 CONTINUE
      XMAX=1.0D 1
      ELSE
      IERR=1
      ENDIF
      RETURN
  120 IF(N.GE.3.AND.NA.GE.3) THEN
      N=3
      NA=MIN(NA,20)
      X(1)=0.0D 0
      X(2)=1.0D 1
      X(3)=2.0D 1
      ELSE
      IERR=1
      ENDIF
      RETURN
  130 IF(N.GE.4.AND.NA.GE.4) THEN
      N=4
      NA=4
      X(1)=3.0D 0
      X(2)=-1.0D 0
      X(3)=0.0D 0
      X(4)=1.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  140 IF(N.GE.4.AND.NA.GE.6) THEN
      N=4
      NA=6
      X(1)=-3.0D 0
      X(2)=-1.0D 0
      X(3)=-3.0D 0
      X(4)=-1.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  150 IF(N.GE.4.AND.NA.GE.11) THEN
      N=4
      NA=11
      X(1)=0.25D 0
      X(2)=0.39D 0
      X(3)=0.41D 0
      X(4)=0.39D 0
      Y(1)=4.00D 0
      Y(2)=2.00D 0
      Y(3)=1.00D 0
      Y(4)=0.50D 0
      Y(5)=0.250D 0
      Y(6)=0.167D 0
      Y(7)=0.125D 0
      Y(8)=0.100D 0
      Y(9)=0.833D-1
      Y(10)=0.714D-1
      Y(11)=0.625D-1
      Y(21)=0.1957D 0
      Y(22)=0.1947D 0
      Y(23)=0.1735D 0
      Y(24)=0.1600D 0
      Y(25)=0.0844D 0
      Y(26)=0.0627D 0
      Y(27)=0.0456D 0
      Y(28)=0.0342D 0
      Y(29)=0.0323D 0
      Y(30)=0.0235D 0
      Y(31)=0.0246D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  160 IF(N.GE.4.AND.NA.GE.N) THEN
      N=4
      NA=MIN(NA,20)
      X(1)=2.5D 1
      X(2)=5.0D 0
      X(3)=-5.0D 0
      X(4)=-1.0D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  170 IF(N.GE.5.AND.NA.GE.33) THEN
      N=5
      NA=33
      X(1)=0.5D 0
      X(2)=1.5D 0
      X(3)=-1.0D 0
      X(4)=0.1D-1
      X(5)=0.2D-1
      Y(1)=0.844D 0
      Y(2)=0.908D 0
      Y(3)=0.932D 0
      Y(4)=0.936D 0
      Y(5)=0.925D 0
      Y(6)=0.908D 0
      Y(7)=0.881D 0
      Y(8)=0.850D 0
      Y(9)=0.818D 0
      Y(10)=0.784D 0
      Y(11)=0.751D 0
      Y(12)=0.718D 0
      Y(13)=0.685D 0
      Y(14)=0.658D 0
      Y(15)=0.628D 0
      Y(16)=0.603D 0
      Y(17)=0.580D 0
      Y(18)=0.558D 0
      Y(19)=0.538D 0
      Y(20)=0.522D 0
      Y(21)=0.506D 0
      Y(22)=0.490D 0
      Y(23)=0.478D 0
      Y(24)=0.467D 0
      Y(25)=0.457D 0
      Y(26)=0.448D 0
      Y(27)=0.438D 0
      Y(28)=0.431D 0
      Y(29)=0.424D 0
      Y(30)=0.420D 0
      Y(31)=0.414D 0
      Y(32)=0.411D 0
      Y(33)=0.406D 0
      ELSE
      IERR=1
      ENDIF
      RETURN
  180 IF(N.GE.6.AND.NA.GE.13) THEN
      N=6
      NA=MIN(NA,13)
      DO 181 I=1,N
      X(I)=1.0D 0
  181 CONTINUE
      X(2)=2.0D 0
      DO 182 I=1,NA
      W=0.1D 0*DBLE(I)
      Y(I)=EXP(-W)-5.0D 0*EXP(-1.0D 1*W)+3.0D 0*EXP(-4.0D 0*W)
  182 CONTINUE
      XMAX=1.0D 2
      ELSE
      IERR=1
      ENDIF
      RETURN
  190 IF(N.GE.11.AND.NA.GE.65) THEN
      N=11
      NA=65
      X(1)=1.3D 0
      X(2)=0.65D 0
      X(3)=0.65D 0
      X(4)=0.7D 0
      X(5)=0.6D 0
      X(6)=3.0D 0
      X(7)=5.0D 0
      X(8)=7.0D 0
      X(9)=2.0D 0
      X(10)=4.5D 0
      X(11)=5.5D 0
      Y(1)=1.366D 0
      Y(2)=1.191D 0
      Y(3)=1.112D 0
      Y(4)=1.013D 0
      Y(5)=0.991D 0
      Y(6)=0.885D 0
      Y(7)=0.831D 0
      Y(8)=0.847D 0
      Y(9)=0.786D 0
      Y(10)=0.725D 0
      Y(11)=0.746D 0
      Y(12)=0.679D 0
      Y(13)=0.608D 0
      Y(14)=0.665D 0
      Y(15)=0.616D 0
      Y(16)=0.606D 0
      Y(17)=0.602D 0
      Y(18)=0.626D 0
      Y(19)=0.651D 0
      Y(20)=0.724D 0
      Y(21)=0.649D 0
      Y(22)=0.649D 0
      Y(23)=0.694D 0
      Y(24)=0.644D 0
      Y(25)=0.624D 0
      Y(26)=0.661D 0
      Y(27)=0.612D 0
      Y(28)=0.558D 0
      Y(29)=0.533D 0
      Y(30)=0.495D 0
      Y(31)=0.500D 0
      Y(32)=0.423D 0
      Y(33)=0.395D 0
      Y(34)=0.375D 0
      Y(35)=0.372D 0
      Y(36)=0.391D 0
      Y(37)=0.396D 0
      Y(38)=0.405D 0
      Y(39)=0.428D 0
      Y(40)=0.429D 0
      Y(41)=0.523D 0
      Y(42)=0.562D 0
      Y(43)=0.607D 0
      Y(44)=0.653D 0
      Y(45)=0.672D 0
      Y(46)=0.708D 0
      Y(47)=0.633D 0
      Y(48)=0.668D 0
      Y(49)=0.645D 0
      Y(50)=0.632D 0
      Y(51)=0.591D 0
      Y(52)=0.559D 0
      Y(53)=0.597D 0
      Y(54)=0.625D 0
      Y(55)=0.739D 0
      Y(56)=0.710D 0
      Y(57)=0.729D 0
      Y(58)=0.720D 0
      Y(59)=0.729D 0
      Y(60)=0.581D 0
      Y(61)=0.428D 0
      Y(62)=0.292D 0
      Y(63)=0.162D 0
      Y(64)=0.098D 0
      Y(65)=0.054D 0
      XMAX=1.0D 2
      ELSE
      IERR=1
      ENDIF
      RETURN
  200 IF(N.GE.2.AND.NA.GE.31) THEN
      N=MIN(N,31)
      NA=31
      DO 201 I=1,N
      X(I)=0.0D 0
  201 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  210 IF(N.GE.2.AND.NA.GE.N) THEN
      N=N-MOD(N,2)
      NA=N
      DO 211 I=1,N
      IF(MOD(I,2).EQ.1) THEN
      X(I)=-1.2D 0
      ELSE
      X(I)=1.0D 0
      ENDIF
  211 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  220 IF(N.GE.4.AND.NA.GE.N) THEN
      N=N-MOD(N,4)
      NA=N
      DO 221 I=1,N
      IF (MOD(I,4).EQ.1) THEN
      X(I)=3.0D 0
      ELSE IF(MOD(I,4).EQ.2) THEN
      X(I)=-1.0D 0
      ELSEIF(MOD(I,4).EQ.3) THEN
      X(I)=0.0D 0
      ELSE
      X(I)=1.0D 0
      ENDIF
  221 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  230 IF(N.GE.2.AND.NA.GE.N+1) THEN
      NA=N+1
      DO 231 I=1,N
      X(I)=DBLE(I)
  231 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  240 IF(N.GE.2.AND.NA.GE.2*N) THEN
      NA=2*N
      DO 241 I=1,N
      X(I)=0.5D 0
  241 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  250 IF(N.GE.2.AND.NA.GE.N+2) THEN
      NA=N+2
      DO 251 I=1,N
      X(I)=1.0D 0-DBLE(I)/DBLE(N)
  251 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  260 IF(N.GE.2.AND.NA.GE.N) THEN
      NA=N
      DO 261 I=1,N
      X(I)=1.0D 0/DBLE(N)
  261 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  270 IF(N.GE.2.AND.NA.GE.N) THEN
      NA=N
      DO 271 I=1,N
      X(I)=0.5D 0
  271 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  280 IF(N.GE.2.AND.NA.GE.N) THEN
      NA=N
      DO 281 I=1,N
      X(I)=DBLE(I)/DBLE(N+1)
      X(I)=X(I)*(X(I)-1.0D 0)
  281 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
  290 GOTO 280
  300 IF(N.GE.2.AND.NA.GE.N) THEN
      NA=N
      DO 301 I=1,N
      X(I)=-1.0D 0
  301 CONTINUE
      ELSE
      IERR=1
      ENDIF
      RETURN
      END
