* SUBROUTINE EIUD11                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF VARIABLES FOR DENSE UNCONSTRAINED MINIMIZATION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RO  X(N)  VECTOR OF VARIABLES.
*  RO  FMIN  LOWER BOUND FOR THE OBJECTIVE FUNCTION.
*  RO  XMAX  MAXIMUM STEPSIZE.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIUD11(N,X,FMIN,XMAX,NEXT,IEXT,IERR)
      INTEGER N,NEXT,IEXT,IERR
      REAL*8 X(N),FMIN,XMAX
      REAL*8 P
      INTEGER I,L,M
      REAL*8 RPAR(10000)
      INTEGER IPAR(10),MM
      COMMON /EMPR11/ RPAR,IPAR,MM
      REAL*8 ETA9
      PARAMETER (ETA9=1.0D 120)
      FMIN=0.0D 0
      XMAX=1.0D 3
      IEXT=0
      IERR=0
      GO TO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     &  170,180,190,200,210,220,230,240,250,260,270,280,290,300,310,
     &  320,330,340,350,360,370,380,390,400,410,420,430,440,450,460,
     &  470,480,490,500,510,520,530,540,550,560,570,580),NEXT
C
C     ARWHEAD
C
   10 IF (N.LT.2) GO TO 999
      DO 11 I=1,N
      X(I)=1.0D 0
   11 CONTINUE
      RETURN
C
C     BDQRTIC
C
   20 IF (N.LT.5) GO TO 999
      DO 21 I=1,N
      X(I)=1.0D 0
   21 CONTINUE
      RETURN
C
C     BROYDN7D
C
   30 IF (N.LT.4) GO TO 999
      DO 31 I=1,N
      X(I)=1.0D 0
   31 CONTINUE
      FMIN=-ETA9
      RETURN
C
C     BRYBND
C
   40 IF (N.LT.7) GO TO 999
      DO 41 I=1,N
      X(I)=-1.0D 0
   41 CONTINUE
      RETURN
C
C     CHAINWOO
C
   50 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      X(1)=-3.0D 0
      X(2)=-1.0D 0
      X(3)=-3.0D 0
      X(4)=-1.0D 0
      DO 51 I=5,N
      X(I)=-2.0D 0
   51 CONTINUE
      RETURN
C
C     COSINE
C
   60 IF (N.LT.2) GO TO 999
      DO 61 I=1,N
      X(I)=1.0D 0
   61 CONTINUE
      FMIN=-ETA9
      RETURN
C
C     CRAGGLVY
C
   70 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 71 I=1,N
      X(I)=2.0D 0
   71 CONTINUE
      X(1)=1.0D 0
      RETURN
C
C     CURLY10
C
   80 IF (N.LT.10) GO TO 999
      GO TO 101
C
C     CURLY20
C
   90 IF (N.LT.20) GO TO 999
      GO TO 101
C
C     CURLY30
C
  100 IF (N.LT.30) GO TO 999
  101 DO 102 I=1,N
      X(I)=1.0D-4/DBLE(N+1)
  102 CONTINUE
      FMIN=-ETA9
      RETURN
C
C     DIXMAANE
C
  110 IF (N.LT.6) GO TO 999
      IPAR(1)=1
      IPAR(2)=0
      IPAR(3)=0
      IPAR(4)=1
      RPAR(1)=1.0D 0
      RPAR(2)=0.0D 0
      RPAR(3)=1.25D-1
      RPAR(4)=1.25D-1
      GO TO 221
C
C     DIXMAANF
C
  120 IF (N.LT.6) GO TO 999
      IPAR(1)=1
      IPAR(2)=0
      IPAR(3)=0
      IPAR(4)=1
      RPAR(1)=1.0D 0
      RPAR(2)=6.25D-2
      RPAR(3)=6.25D-2
      RPAR(4)=6.25D-2
      GO TO 221
C
C     DIXMAANG
C
  130 IF (N.LT.6) GO TO 999
      IPAR(1)=1
      IPAR(2)=0
      IPAR(3)=0
      IPAR(4)=1
      RPAR(1)=1.0D 0
      RPAR(2)=1.25D-1
      RPAR(3)=1.25D-1
      RPAR(4)=1.25D-1
      GO TO 221
C
C     DIXMAANH
C
  140 IF (N.LT.6) GO TO 999
      IPAR(1)=1
      IPAR(2)=0
      IPAR(3)=0
      IPAR(4)=1
      RPAR(1)=1.0D 0
      RPAR(2)=2.6D-1
      RPAR(3)=2.6D-1
      RPAR(4)=2.6D-1
      GO TO 221
C
C     DIXMAANI
C
  150 IF (N.LT.6) GO TO 999
      IPAR(1)=2
      IPAR(2)=0
      IPAR(3)=0
      IPAR(4)=2
      RPAR(1)=1.0D 0
      RPAR(2)=0.0D 0
      RPAR(3)=1.25D-1
      RPAR(4)=1.25D-1
      GO TO 221
C
C     DIXMAANJ
C
  160 IF (N.LT.6) GO TO 999
      IPAR(1)=2
      IPAR(2)=0
      IPAR(3)=0
      IPAR(4)=2
      RPAR(1)=1.0D 0
      RPAR(2)=6.25D-2
      RPAR(3)=6.25D-2
      RPAR(4)=6.25D-2
      GO TO 221
C
C     DIXMAANK
C
  170 IF (N.LT.6) GO TO 999
      IPAR(1)=2
      IPAR(2)=0
      IPAR(3)=0
      IPAR(4)=2
      RPAR(1)=1.0D 0
      RPAR(2)=1.25D-1
      RPAR(3)=1.25D-1
      RPAR(4)=1.25D-1
      GO TO 221
C
C     DIXMAANL
C
  180 IF (N.LT.6) GO TO 999
      IPAR(1)=2
      IPAR(2)=0
      IPAR(3)=0
      IPAR(4)=2
      RPAR(1)=1.0D 0
      RPAR(2)=2.6D-1
      RPAR(3)=2.6D-1
      RPAR(4)=2.6D-1
      GO TO 221
C
C     DIXMAANM
C
  190 IF (N.LT.6) GO TO 999
      IPAR(1)=2
      IPAR(2)=1
      IPAR(3)=1
      IPAR(4)=2
      RPAR(1)=1.0D 0
      RPAR(2)=0.0D 0
      RPAR(3)=1.25D-1
      RPAR(4)=1.25D-1
      GO TO 221
C
C     DIXMAANN
C
  200 IF (N.LT.6) GO TO 999
      IPAR(1)=2
      IPAR(2)=1
      IPAR(3)=1
      IPAR(4)=2
      RPAR(1)=1.0D 0
      RPAR(2)=6.25D-2
      RPAR(3)=6.25D-2
      RPAR(4)=6.25D-2
      GO TO 221
C
C     DIXMAANO
C
  210 IF (N.LT.6) GO TO 999
      IPAR(1)=2
      IPAR(2)=1
      IPAR(3)=1
      IPAR(4)=2
      RPAR(1)=1.0D 0
      RPAR(2)=1.25D-1
      RPAR(3)=1.25D-1
      RPAR(4)=1.25D-1
      GO TO 221
C
C     DIXMAANP
C
  220 IF (N.LT.6) GO TO 999
      IPAR(1)=2
      IPAR(2)=1
      IPAR(3)=1
      IPAR(4)=2
      RPAR(1)=1.0D 0
      RPAR(2)=2.6D-1
      RPAR(3)=2.6D-1
      RPAR(4)=2.6D-1
  221 DO 222 I=1,N
      X(I)=2.0D 0
  222 CONTINUE
      FMIN=-ETA9
      RETURN
C
C     DQRTIC
C
  230 IF (N.LT.2) GO TO 999
      DO 231 I=1,N
      X(I)=2.0D 0
  231 CONTINUE
      RETURN
C
C     EDENSCH
C
  240 IF (N.LT.2) GO TO 999
      DO 241 I=1,N
      X(I)=0.0D 0
  241 CONTINUE
      RETURN
C
C     EG2
C
  250 IF (N.LT.2) GO TO 999
      DO 251 I=1,N
      X(I)=0.0D 0
  251 CONTINUE
      FMIN=-ETA9
      RETURN
C
C     ENGVAL1
C
  260 IF (N.LT.2) GO TO 999
      DO 261 I=1,N
      X(I)=2.0D 0
  261 CONTINUE
      RETURN
C
C     CHROSNB MODIFIED
C
  270 IF (N.LT.4) GO TO 999
      DO 271 I=1,N
      X(I)=-1.0D 0
  271 CONTINUE
      RETURN
C
C     ERRINROS MODIFIED
C
  280 IF (N.LT.4) GO TO 999
      DO 281 I=1,N
      X(I)=-1.0D 0
  281 CONTINUE
      RETURN
C
C     EXTROSNB
C
  290 IF (N.LT.2) GO TO 999
      DO 291 I=1,N
      X(I)=1.0D 0
  291 CONTINUE
      X(1)=-1.2D 0
      RETURN
C
C     FLETCBV3 MODIFIED
C
  300 IF (N.LT.2) GO TO 999
      RPAR(1)=1.0D 0
      RPAR(2)=1.0D 8
      GO TO 311
C
C     FLETCBV2
C
  310 IF (N.LT.2) GO TO 999
      RPAR(1)=1.0D 0
  311 P=1.0D 0/DBLE(N+1)
      DO 312 I=1,N
      X(I)=DBLE(I)*P
  312 CONTINUE
      FMIN=-ETA9
      RETURN
C
C     FLETCHCR
C
  320 IF (N.LT.2) GO TO 999
      DO 321 I=1,N
      X(I)=0.0D 0
  321 CONTINUE
      RETURN
C
C     FMINSRF2
C
  330 IF (N.LT.16) GO TO 999
      MM=INT(SQRT(DBLE(N)))
      IF (MOD(MM,2).EQ.0) MM=MM-1
      N=MM*MM
      DO 331 I=1,N
      X(I)=0.0D 0
  331 CONTINUE
      DO 332 I=1,MM
      X(I)=DBLE(I-1)*4.0D 0/DBLE(MM-1)+1.0D 0
      X((MM-1)*MM+I)=DBLE(I-1)*4.0D 0/DBLE(MM-1)+9.0D 0
  332 CONTINUE
      DO 333 I=2,MM-1
      X((I-1)*MM+MM)=DBLE(I-1)*8.0D 0/DBLE(MM-1)+1.0D 0
      X((I-1)*MM+1)=DBLE(I-1)*8.0D 0/DBLE(MM-1)+5.0D 0
  333 CONTINUE
      RETURN
C
C     FREUROTH
C
  340 IF (N.LT.2) GO TO 999
      DO 341 I=1,N
      X(I)=0.0D 0
  341 CONTINUE
      X(1)= 0.5D 0
      X(2)=-2.0D 0
      RETURN
C
C     GENHUMPS
C
  350 IF (N.LT.2) GO TO 999
      RPAR(1)=2.0D 1
      DO 351 I=1,N
      X(I)=-506.2D 0
  351 CONTINUE
      X(1)=-506.0D 0
      RETURN
C
C     GENROSE
C
  360 IF (N.LT.2) GO TO 999
      DO 361 I=1,N
      X(I)=DBLE(I)/DBLE(N+1)
  361 CONTINUE
      RETURN
C
C     INDEF MODIFIED
C
  370 IF (N.LT.2) GO TO 999
      RPAR(1)=0.5D 0
      DO 371 I=1,N
      X(I)=DBLE(I)/DBLE(N+1)
  371 CONTINUE
      FMIN=-ETA9
      RETURN
C
C     LIARWHD
C
  380 IF (N.LT.2) GO TO 999
      DO 381 I=1,N
      X(I)=4.0D 0
  381 CONTINUE
      RETURN
C
C     MOREBV DIFFERENT START POINT
C
  390 IF (N.LT.3) GO TO 999
      P=1.0D 0/DBLE(N+1)
      DO 391 I=1,N
      X(I)=0.5D 0
C      Q=P*DBLE(I)
C      X(I)=Q*(Q-1.0D 0)
  391 CONTINUE
      RETURN
C
C     NCB20 CORRECTED
C
  400 IF (N.LT.30) GO TO 999
      L=20
      M=10
      IPAR(1)=L
      IPAR(2)=M
      RPAR(1)=1.0D-4
      RPAR(2)=-4.0D 0/DBLE(L)
      DO 401 I=1,N-M
      X(I)=0.0D 0
  401 CONTINUE
      DO 402 I=N-M+1,N
      X(I)=1.0D 0
  402 CONTINUE
      FMIN=-ETA9
      RETURN
C
C     NCB20B CORRECTED
C
  410 IF (N.LT.20) GO TO 999
      L=20
      IPAR(1)=L
      RPAR(1)=1.0D 2
      RPAR(2)=-4.0D 0/DBLE(L)
      DO 411 I=1,N
      X(I)=0.0D 0
  411 CONTINUE
      FMIN=-ETA9
      RETURN
C
C     NONCVXUN
C
  420 CONTINUE
      IF (N.LT.12) GO TO 999
      DO 421 I=1,N
      X(I)=DBLE(I)
  421 CONTINUE
      RETURN
C
C     NONCVXU2
C
  430 CONTINUE
      IF (N.LT.12) GO TO 999
      DO 431 I=1,N
      X(I)=DBLE(I)
  431 CONTINUE
      RETURN
C
C     NONDIA
C
  440 CONTINUE
      IF (N.LT.2) GO TO 999
      DO 441 I=1,N
      X(I)=-1.0D 0
  441 CONTINUE
      RETURN
C
C     NONDQUAR
C
  450 CONTINUE
      IF (N.LT.2) GO TO 999
      DO 451 I=1,N
      IF (MOD(I,2).EQ.1) THEN
      X(I)= 1.0D 0
      ELSE
      X(I)=-1.0D 0
      ENDIF
  451 CONTINUE
      RETURN
C
C     PENALTY3
C
  460 IF (N.LT.3) GO TO 999
      P=1.0D 0/DBLE(N+1)
      DO 461 I=1,N
      X(I)=DBLE(I)*P
  461 CONTINUE
      RETURN
C
C     POWELLSG
C
  470 IF (N.LT.4) GO TO 999
      N=N-MOD(N,4)
      DO 471 I=1,N
      IF (MOD(I,4).EQ.1) THEN
      X(I)=3.0D 0
      ELSE IF (MOD(I,4).EQ.2) THEN
      X(I)=-1.0D 0
      ELSE IF (MOD(I,4).EQ.3) THEN
      X(I)=0.0D 0
      ELSE
      X(I)=1.0D 0
      ENDIF
  471 CONTINUE
      RETURN
C
C     SBRYBND
C
  480 IF (N.LT.7) GO TO 999
      DO 481 I=1,N
      RPAR(I)=EXP(6.0D 0*DBLE(I-1)/DBLE(N-1))
      X(I)=1.0D 0/RPAR(I)
  481 CONTINUE
      RETURN
C
C     SCHMVETT
C
  490 IF (N.LT.3) GO TO 999
      DO 491 I=1,N
      X(I)=3.0D 0
  491 CONTINUE
      FMIN=-ETA9
      RETURN
C
C     SCOSINE
C
  500 CONTINUE
      IF (N.LT.4) GO TO 999
      DO 501 I=1,N
      RPAR(I)=EXP(6.0D 0*DBLE(I-1)/DBLE(N-1))
      X(I)=1.0D 0/RPAR(I)
  501 CONTINUE
      FMIN=-ETA9
      RETURN
C
C     SINQUAD
C
  510 IF (N.LT.2) GO TO 999
      DO 511 I=1,N
      X(I)=1.0D-1
  511 CONTINUE
      RETURN
C
C     SPARSINE
C
  520 IF (N.LT.10) GO TO 999
      DO 521 I=1,N
      X(I)=0.5D 0
  521 CONTINUE
      RETURN
C
C     SPARSQUR
C
  530 IF (N.LT.10) GO TO 999
      DO 531 I=1,N
      X(I)=0.5D 0
  531 CONTINUE
      RETURN
C
C     SPMSRTLS
C
  540 IF (N.LT.7) GO TO 999
      N=N-MOD(N+2,3)
      DO 541 I=1,N
      RPAR(I)=SIN(DBLE(I)**2)
      X(I)=0.2D 0*RPAR(I)
  541 CONTINUE
      RETURN
C
C     SROSENBR
C
  550 IF (N.LT.2) GO TO 999
      N=N-MOD(N,2)
      DO 551 I=1,N
      IF (MOD(I,2).EQ.1) THEN
      X(I)=-1.2D 0
      ELSE
      X(I)= 1.0D 0
      ENDIF
  551 CONTINUE
      RETURN
C
C     TOINTGSS
C
  560 IF (N.LT.3) GO TO 999
      DO 561 I=1,N
      X(I)=3.0D 0
  561 CONTINUE
      RETURN
C
C     TQUARTIC MODIFIED
C
  570 IF (N.LT.2) GO TO 999
      DO 571 I=1,N
      X(I)=1.0D-1
  571 CONTINUE
C
C     WOODS
C
  580 IF (N.LT.4) GO TO 999
      DO 581 I=1,N
      IF (MOD(I,2).EQ.1) THEN
      X(I)=-3.0D 0
      ELSE
      X(I)=-1.0D 0
      ENDIF
  581 CONTINUE
      RETURN
  999 IERR=1
      RETURN
      END
