* SUBROUTINE EIUD12                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF VARIABLES FOR DENSE UNCONSTRAINED MINIMIZATION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RO  X(N)  VECTOR OF VARIABLES.
*  RO  FMIN  LOWER BOUND FOR THE OBJECTIVE FUNCTION.
*  RO  XMAX  MAXIMUM STEPSIZE.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIUD12(N,X,FMIN,XMAX,NEXT,IEXT,IERR)
      INTEGER N,NEXT,IEXT,IERR
      REAL*8 X(N),FMIN,XMAX
      INTEGER I
      FMIN=0.0D 0
      XMAX=1.0D 3
      IEXT=0
      IERR=0
*     THIS SUBROUTINE COMPUTES THE INITIAL POINT
      GO TO ( 1, 2, 3, 4, 5, 6, 7, 8, 9,10,
     *       11,12,13,14,15,16,17,18,19,20,
     *       21,22,23,24,25,26,27,28,29,30,
     *       31,32,33,34,35,36,37,38,39,40,
     *       41,42,43,44,45,46,47,48,49,50,
     *       51,52,53,54,55,56,57,58,59,60,
     *       61,62,63,64,65,66,67,68,69,70,
     *       71,72,73) NEXT
1     IF (N.LT.2) GO TO 99
      N=N-MOD(N,2)
*
*     FREUDENSTEIN & ROTH
*
        I=1
991     X(I)  =   0.5D 0
        X(I+1)=  -2.0D 0
        I=I+2
        IF (I.LT.N) GO TO 991
      RETURN
2     IF (N.LT.2) GO TO 99
*
*     TRIGONOMETRIC
*
      DO I=1,N
        X(I) = 0.2D 0
      END DO
      RETURN
3     IF (N.LT.2) GO TO 99
      N=N-MOD(N,2)
*
*     ROSENBROCK
*
        I=1
993     X(I)  =  -1.2D 0
        X(I+1)=   1.0D 0
        I=I+2
        IF (I.LT.N) GO TO 993
      RETURN
4     IF (N.LT.2) GO TO 99
      N=N-MOD(N,2)
*
*     WHITE & HOLST
*
        I=1
994     X(I)  =  -1.2D 0
        X(I+1)=   1.0D 0
        I=I+2
        IF (I.LT.N) GO TO 994
      RETURN
5     IF (N.LT.2) GO TO 99
      N=N-MOD(N,2)
*
*     BEALE
*
        I=1
995     X(I)  =   1.0D 0
        X(I+1)=   0.8D 0
        I=I+2
        IF (I.LT.N) GO TO 995
      RETURN
6     IF (N.LT.2) GO TO 99
*
*     PENALTY
*
      DO I=1,N
       X(I) = DBLE(I)
      END DO
      RETURN
7     IF (N.LT.2) GO TO 99
*
*     PERTURBED QUADRATIC
*
      DO I=1,N
        X(I) = 0.5D 0
      END DO
      RETURN
8     IF (N.LT.2) GO TO 99
*
*     RAYDAN 1
*
      DO I=1,N
        X(I) = 1.0D 0
      END DO
      RETURN
9     IF (N.LT.2) GO TO 99
*
*     RAYDAN 2
*
      DO I=1,N
        X(I) = 1.0D 0
      END DO
      RETURN
10    IF (N.LT.2) GO TO 99
*
*     DIAGONAL 1
*
      DO I=1,N
C        X(I) = 1.0D 0/DBLE(N)
        X(I) = 11.0D 0
      END DO
      RETURN
11    IF (N.LT.2) GO TO 99
*
*     DIAGONAL 2
*
      DO I=1,N
C        X(I) = 1.0D 0/DBLE(I)
        X(I)=0.09D 0
      END DO
      RETURN
12    IF (N.LT.2) GO TO 99
*
*     DIAGONAL 3
*
      DO I=1,N
        X(I) = 1.0D 0
      END DO
      RETURN
13    IF (N.LT.2) GO TO 99
*
*     HAGER
*
      DO I=1,N
        X(I) = 1.0D 0
      END DO
      RETURN
14    IF (N.LT.2) GO TO 99
*
*     GENERALIZED TRIDIAGONAL 1
*
      DO I=1,N
        X(I) = 2.0D 0
      END DO
      RETURN
15    IF (N.LT.2) GO TO 99
      N=N-MOD(N,2)
*
*     EXTENDED TRIDIAGONAL 1
*
      DO I=1,N
        X(I) = 2.0D 0
      END DO
      RETURN
16    IF (N.LT.2) GO TO 99
      N=N-MOD(N,2)
*
*     EXTENDED THREE EXPO TERMS
*
      DO I=1,N
        X(I) = 0.1D 0
      END DO
      RETURN
17    IF (N.LT.3) GO TO 99
*
*     GENERALIZED TRIDIAGONAL 2
*
      DO I=1,N
        X(I) = -1.0D 0
      END DO
      RETURN
18    IF (N.LT.2) GO TO 99
      N=N-MOD(N,2)
*
*     DIAGONAL 4
*
      DO I=1,N
        X(I) = 1.0D 0
      END DO
      RETURN
19    IF (N.LT.2) GO TO 99
*
*     DIAGONAL 5
*
      DO I=1,N
        X(I) = 1.1D 0
      END DO
      RETURN
20    IF (N.LT.2) GO TO 99
      N=N-MOD(N,2)
*
*     EXTENDED HIMMELBLAU
*
      DO I=1,N
        X(I) = 1.0D 0
      END DO
      RETURN
21    IF (N.LT.2) GO TO 99
*
*     GENERALIZED PSC1
*
        I=1
9921    X(I)  =  3.0D 0
        X(I+1)=  0.1D 0
        I=I+2
        IF (I.LT.N) GO TO 9921
      RETURN
22    IF (N.LT.2) GO TO 99
      N=N-MOD(N,2)
*
*     EXTENDED PSC1
*
        I=1
9922    X(I)  =  3.0D 0
        X(I+1)=  0.1D 0
        I=I+2
        IF (I.LT.N) GO TO 9922
      RETURN
23    IF (N.LT.4) GO TO 99
      N=N-MOD(N,4)
*
*     EXTENDED POWELL
*
        I=1
9923    X(I)  =  3.0D 0
        X(I+1)= -1.0D 0
        X(I+2)=  0.0D 0
        X(I+3)=  1.0D 0
        I=I+4
        IF (I.LT.N) GO TO 9923
      RETURN
24    IF (N.LT.2) GO TO 99
      N=N-MOD(N,2)
*
*     EXTENDED BD1
*
      DO I=1,N
        X(I) = 0.1D 0
      END DO
      RETURN
25    IF (N.LT.2) GO TO 99
      N=N-MOD(N,2)
*
*     EXTENDED MARATOS
*
        I=1
9925    X(I)  =  1.1D 0
        X(I+1)=  0.1D 0
        I=I+2
        IF (I.LT.N) GO TO 9925
      RETURN
26    IF (N.LT.2) GO TO 99
      N=N-MOD(N,2)
*
*     EXTENDED CLIFF
*
        I=1
9926    X(I)  =   0.0D 0
        X(I+1)=  -1.0D 0
        I=I+2
        IF (I.LT.N) GO TO 9926
      RETURN
27    IF (N.LT.2) GO TO 99
*
*     QUADRATIC DIAGONAL PERTURBED
*
      DO I=1,N
        X(I) = 0.5D 0
      END DO
      RETURN
28    IF (N.LT.4) GO TO 99
      N=N-MOD(N,4)
*
*     EXTENDED WOOD
*
        I=1
9928    X(I)  =  -3.0D 0
        X(I+1)=  -1.0D 0
        X(I+2)=  -3.0D 0
        X(I+3)=  -1.0D 0
        I=I+4
        IF (I.LT.N) GO TO 9928
      RETURN
29    IF (N.LT.2) GO TO 99
      N=N-MOD(N,2)
*
*     EXTENDED HIEBERT
*
      DO I=1,N
        X(I) = 0.0001D 0
      END DO
      RETURN
30    IF (N.LT.2) GO TO 99
*
*     QUADRATIC QF1
*
      DO I=1,N
        X(I) = 1.0D 0
      END DO
      RETURN
31    IF (N.LT.2) GO TO 99
*
*     EXTENDED QUADRATIC PENALTY QP1
*
      DO I=1,N
        X(I) = 1.0D 0
      END DO
      RETURN
32    IF (N.LT.2) GO TO 99
*
*     EXTENDED QUADRATIC PENALTY QP2
*
      DO I=1,N
        X(I) = 1.0D 0
      END DO
      RETURN
33    IF (N.LT.2) GO TO 99
*
*     QUADRATIC QF2
*
      DO I=1,N
        X(I) = 0.5D 0
      END DO
      RETURN
34    IF (N.LT.2) GO TO 99
      N=N-MOD(N,2)
*
*     EXTENDED EP1
*
      DO I=1,N
        X(I) = 1.5D 0
      END DO
      RETURN
35    IF (N.LT.2) GO TO 99
*
*     EXTENDED TRIDIAGONAL
*
      DO I=1,N
        X(I) = 1.0D 0
      END DO
      RETURN
36    IF (N.LT.5) GO TO 99
*
*     BDQRTIC (CUTE)
*
      DO I=1,N
        X(I) = 1.0D 0
      END DO
      RETURN
37    IF (N.LT.2) GO TO 99
*
*     TRIDIA (CUTE)
*
      DO I=1,N
        X(I) = 1.0D 0
      END DO
      RETURN
38    IF (N.LT.2) GO TO 99
*
*     ARWHEAD (CUTE)
*
      DO I=1,N
        X(I) = 1.0D 0
      END DO
      RETURN
39    IF (N.LT.2) GO TO 99
*
*     NONDIA (CUTE)
*
      DO I=1,N
        X(I) = -1.0D 0
      END DO
      RETURN
40    IF (N.LT.3) GO TO 99
*
*     NONDQUAR (CUTE)
*
        I=1
9940    X(I)  =   1.0D 0
        X(I+1)=  -1.0D 0
        I=I+2
        IF (I.LT.N) GO TO 9940
      RETURN
41    IF (N.LT.3) GO TO 99
*
*     DQDRTIC (CUTE)
*
      DO I=1,N
        X(I) = 3.0D 0
      END DO
      RETURN
42    IF (N.LT.2) GO TO 99
*
*     EG2 (CUTE)
*
      DO I=1,N
        X(I) = 1.0D 0
      END DO
      RETURN
43    IF (N.LT.3) GO TO 99
C      N=N-MOD(N,3)
*
*     DIXMAANA (CUTE)
*
      DO I=1,N
        X(I) = 2.0D 0
      END DO
      RETURN
44    IF (N.LT.3) GO TO 99
C      N=N-MOD(N,3)
*
*     DIXMAANB (CUTE)
*
      DO I=1,N
        X(I) = 2.0D 0
      END DO
      RETURN
45    IF (N.LT.3) GO TO 99
C      N=N-MOD(N,3)
*
*     DIXMAANC (CUTE)
*
      DO I=1,N
        X(I) = 2.0D 0
      END DO
      RETURN
46    IF (N.LT.3) GO TO 99
C      N=N-MOD(N,3)
*
*     DIXMAANE (CUTE)
*
      DO I=1,N
        X(I) = 2.0D 0
      END DO
      RETURN
47    IF (N.LT.3) GO TO 99
*
*     PARTIAL PERTURBED QUADRATIC
*
      DO I=1,N
        X(I) = 0.5D 0
      END DO
      RETURN
48    IF (N.LT.2) GO TO 99
*
*     BROYDEN TRIDIAGONAL
*
      DO I=1,N
        X(I) = -1.0D 0
      END DO
      RETURN
49    IF (N.LT.2) GO TO 99
*
*     ALMOST PERTURBED QUADRATIC
*
      DO I=1,N
        X(I) = 0.5D 0
      END DO
      RETURN
50    IF (N.LT.3) GO TO 99
*
*     TRIDIAGONAL PERTURBED QUADRATIC
*
      DO I=1,N
        X(I) = 0.5D 0
      END DO
      RETURN
51    IF (N.LT.2) GO TO 99
*
*     EDENSCH (CUTE)
*
      DO I=1,N
        X(I) = 0.0D 0
      END DO
      RETURN
52    IF (N.LT.2) GO TO 99
*
*     VARDIM (CUTE)
*
      DO I=1,N
        X(I) = 1.0D 0 - DBLE(I)/DBLE(N)
      END DO
      RETURN
53    IF (N.LT.2) GO TO 99
*
*     STAIRCASE S1
*
      DO I=1,N
        X(I) = 1.0D 0
      END DO
      RETURN
54    IF (N.LT.2) GO TO 99
*
*     LIARWHD (CUTE)
*
      DO I=1,N
        X(I) = 4.0D 0
      END DO
      RETURN
55    IF (N.LT.2) GO TO 99
*
*     DIAGONAL 6
*
      DO I=1,N
        X(I) = 1.0D 0
      END DO
      RETURN
56    IF (N.LT.2) GO TO 99
*
*     DIXON3DQ (CUTE)
*
      DO I=1,N
        X(I) = -1.0D 0
      END DO
      RETURN
57    IF (N.LT.3) GO TO 99
C      N=N-MOD(N,3)
*
*     DIXMAANF (CUTE)
*
      DO I=1,N
        X(I) = 2.0D 0
      END DO
      RETURN
58    IF (N.LT.3) GO TO 99
C      N=N-MOD(N,3)
*
*     DIXMAANG (CUTE)
*
      DO I=1,N
        X(I) = 2.0D 0
      END DO
      RETURN
59    IF (N.LT.3) GO TO 99
C      N=N-MOD(N,3)
*
*     DIXMAANH (CUTE)
*
      DO I=1,N
        X(I) = 2.0D 0
      END DO
      RETURN
60    IF (N.LT.3) GO TO 99
C      N=N-MOD(N,3)
*
*     DIXMAANI (CUTE)
*
      DO I=1,N
        X(I) = 2.0D 0
      END DO
      RETURN
61    IF (N.LT.3) GO TO 99
C      N=N-MOD(N,3)
*
*     DIXMAANJ (CUTE)
*
      DO I=1,N
        X(I) = 2.0D 0
      END DO
      RETURN
62    IF (N.LT.3) GO TO 99
C      N=N-MOD(N,3)
*
*     DIXMAANK (CUTE)
*
      DO I=1,N
        X(I) = 2.0D 0
      END DO
      RETURN
63    IF (N.LT.3) GO TO 99
C      N=N-MOD(N,3)
*
*     DIXMAANL (CUTE)
*
      DO I=1,N
        X(I) = 2.0D 0
      END DO
      RETURN
64    IF (N.LT.2) GO TO 99
*
*     ENGVAL1 (CUTE)
*
      DO I=1,N
        X(I) = 2.0D 0
      END DO
      RETURN
65    IF (N.LT.2) GO TO 99
*
*     FLETCHCR (CUTE)
*
      DO I=1,N
        X(I) = 0.0D 0
      END DO
      RETURN
66    IF (N.LT.2) GO TO 99
*
*     COSINE (CUTE)
*
      DO I=1,N
        X(I) = 1.0D 0
      END DO
      RETURN
67    IF (N.LT.2) GO TO 99
      N=N-MOD(N,2)
*
*     DENSCHNB (CUTE)
*
      DO I=1,N
        X(I) = 1.0D 0
      END DO
      RETURN
68    IF (N.LT.2) GO TO 99
      N=N-MOD(N,2)
*
*     DENSCHNF (CUTE)
*
        I=1
9968    X(I)  = 2.0D 0
        X(I+1)= 0.0D 0
        I=I+2
        IF (I.LT.N) GO TO 9968
      RETURN
69    IF (N.LT.3) GO TO 99
*
*     SINQUAD  (CUTE)
*
      DO I=1,N
        X(I) = 0.1D 0
      END DO
      RETURN
70    IF (N.LT.2) GO TO 99
*
*     BIGGSB1  (CUTE)
*
      DO I=1,N
        X(I) = 0.0D 0
      END DO
      RETURN
71    IF (N.LT.3) GO TO 99
*
*     PARTIAL PERTURBED QUADRATIC PPQ2
*
      DO I=1,N
        X(I) = 0.0D 0
      END DO
      RETURN
72    IF (N.LT.2) GO TO 99
*
*     SCALED QUADRATIC SQ1
*
      DO I=1,N
        X(I) = DBLE(I)
      END DO
      RETURN
73    IF (N.LT.2) GO TO 99
C      IF (N.LT.102) GO TO 99
*
*     SCALED QUADRATIC SQ2
*
      DO I=1,N
        X(I) = DBLE(I)
      END DO
      RETURN
99    IERR=1
      RETURN
      END
