* SUBROUTINE EIUD14                ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES AND STRUCTURE OF THE SPARSE HESSIAN
*  MATRIX FOR UNCONSTRAINED MINIMIZATION.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  NB  NUMBER OF APPROXIMATED FUNCTIONS.
*  RO  X(N)  VECTOR OF VARIABLES.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIUD14(N,NB,X,FMIN,XMAX,NEXT,IEXT,IERR)
      INTEGER N,NB,NEXT,IEXT,IERR
      REAL*8 X(N),FMIN,XMAX
      REAL*8 P,Q
      INTEGER I
      REAL*8 ETA9
      PARAMETER (ETA9=1.0D 60)
      FMIN=0.0D 0
      XMAX=1.0D 3
      IEXT=0
      IERR=0
      GO TO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,
     &  170,180,190,200,210,220),NEXT
   10 IF (N.LT.2) GO TO 999
      N=N-MOD(N,2)
      DO 11 I=1,N
        IF(MOD(I,2).EQ.1) THEN
          X(I)=-1.2D 0
        ELSE
          X(I)=1.0D 0
        ENDIF
   11 CONTINUE
      NB=N-1
      RETURN
   20 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 21 I=1,N
        IF(MOD(I,2).EQ.1) THEN
          X(I)=-2.0D 0
          IF(I.LE.4) X(I)=-3.0D 0
        ELSE
          X(I)=0.0D 0
          IF(I.LE.4) X(I)=-1.0D 0
        ENDIF
   21 CONTINUE
      NB=(N-2)/2
      RETURN
   30 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 31 I=1,N
        IF(MOD(I,4).EQ.1) THEN
          X(I)=3.0D 0
        ELSEIF(MOD(I,4).EQ.2) THEN
          X(I)=-1.0D 0
        ELSEIF(MOD(I,4).EQ.3) THEN
          X(I)=0.0D 0
        ELSE
          X(I)=1.0D 0
        ENDIF
   31 CONTINUE
      NB=(N-2)/2
      RETURN
   40 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 41 I=1,N
        X(I)=2.0D 0
   41 CONTINUE
      X(1)=1.0D 0
      NB=(N-2)/2
      RETURN
   50 IF (N.LT.3) GO TO 999
      DO 51 I=1,N
        X(I)=-1.0D 0
   51 CONTINUE
      NB=N
      RETURN
   60 IF (N.LT.7) GO TO 999
      DO 61 I=1,N
        X(I)=-1.0D 0
   61 CONTINUE
      NB=N
      RETURN
   70 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 71 I=1,N
        X(I)=-1.0D 0
   71 CONTINUE
      NB=N+N/2
      RETURN
   80 IF (N.LT.6) GO TO 999
      DO 81 I=1,N
        X(I)=1.0D 0/DBLE(N)
   81 CONTINUE
      NB=N
      RETURN
   90 IF (N.LT.6) GO TO 999
      DO 91 I=1,N
        X(I)=1.0D 0/DBLE(N)
   91 CONTINUE
      FMIN=-ETA9
      NB=N
      RETURN
  100 IF (N.LT.6) GO TO 999
      DO 101 I=1,N
        X(I)=1.0D 0
  101 CONTINUE
      FMIN=-ETA9
      NB=N
      RETURN
  110 IF (N.LT.5) GO TO 999
      N=N-MOD(N,5)
      DO 111 I=0,N-5,5
        X(I+1)=-1.0D 0
        X(I+2)=-1.0D 0
        X(I+3)=2.0D 0
        X(I+4)=-1.0D 0
        X(I+5)=-1.0D 0
  111 CONTINUE
      X(1)=-2.0D 0
      X(2)=2.0D 0
      XMAX=1.0D 0
      NB=N/5
      RETURN
  120 IF (N.LT.2) GO TO 999
      N=N-MOD(N,2)
      DO 121 I=2,N,2
        X(I-1)=0.0D 0
        X(I)=-1.0D 0
  121 CONTINUE
      XMAX=1.0D 0
      NB=N-1
      RETURN
  130 IF (N.LT.2) GO TO 999
      N=N-MOD(N,2)
      DO 131 I=2,N,2
        X(I-1)=-1.0D 0
        X(I)=1.0D 0
  131 CONTINUE
      XMAX=1.0D 0
      NB=N-1
      RETURN
  140 IF (N.LT.3) GO TO 999
      P=1.0D 0/DBLE(N+1)
      DO 141 I=1,N
        Q=P*DBLE(I)
        X(I)=Q*(Q-1.0D 0)
  141 CONTINUE
      NB=N
      RETURN
  150 IF (N.LT.3) GO TO 999
      P=1.0D 0/DBLE(N+1)
      DO 151 I=1,N
        X(I)=DBLE(I)*DBLE(N+1-I)*P**2
  151 CONTINUE
      FMIN=-ETA9
      XMAX=1.0D 1
      NB=N-1
      RETURN
  160 IF (N.LT.3) GO TO 999
      DO 161 I=1,N
        X(I)=1.0D 0
  161 CONTINUE
      FMIN=-ETA9
      NB=N
      RETURN
  170 IF (N.LT.3) GO TO 999
      P=1.0D 0/DBLE(N+1)
      DO 171 I=1,N
        X(I)=DBLE(I)*DBLE(N+1-I)*P**2
  171 CONTINUE
      FMIN=-ETA9
      NB=N
      RETURN
  180 IF (N.LT.3) GO TO 999
      P=1.0D 0/DBLE(N+1)
      DO 181 I=1,N
        X(I)=DBLE(I)*DBLE(N+1-I)*P**2
  181 CONTINUE
      FMIN=-ETA9
      NB=N
      RETURN
  190 IF (N.LT.3) GO TO 999
      P=EXP(2.0D 0)/DBLE(N+1)
      DO 191 I=1,N
        X(I)=(P*DBLE(I)+1.0D 0)/3.0D 0
  191 CONTINUE
      FMIN=-ETA9
      NB=N
      RETURN
  200 IF (N.LT.3) GO TO 999
      P=1.0D 0/DBLE(N+1)
      DO 201 I=1,N
        X(I)=P*DBLE(I)
  201 CONTINUE
      FMIN=-ETA9
      NB=N
      RETURN
  210 IF (N.LT.3) GO TO 999
      P=1.0D 0/DBLE(N+1)
      DO 211 I=1,N
        X(I)=P*DBLE(I)+1.0D 0
  211 CONTINUE
      FMIN=-ETA9
      NB=N
      RETURN
  220 IF (N.LT.3) GO TO 999
      P=1.0D 0/DBLE(N+1)
      DO 221 I=1,N
        X(I)=DBLE(I)*DBLE(N+1-I)*P**2
  221 CONTINUE
      FMIN=-ETA9
      NB=N
      RETURN
  999 IERR=1
      RETURN
      END
