* SUBROUTINE EIUD16             ALL SYSTEMS                 99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES FOR NONLINEAR EQUATIONS.
*  UNCONSTRAINED AND DENSE VERSION.
*
* PARAMETERS :
*  IO  N  NUMBER OF VARIABLES.
*  IO  NA  NUMBER OF EQUATIONS.
*  IO  NAL NUMBER OF LINEAR EQUATIONS.
*  RO  X(N)  VECTOR OF VARIABLES.
*  RO  FMIN  LOWER BOUND FOR VALUE OF THE OBJECTIVE FUNCTION.
*  RO  XMAX  MAXIMUM STEPSIZE.
*  IO  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIUD16(N,NA,NAL,X,FMIN,XMAX,NEXT,IEXT,IERR)
      INTEGER N,NA,NAL,NEXT,IEXT,IERR
      REAL*8 X(N),FMIN,XMAX
      REAL*8 Y(1000),F,S,T
      INTEGER I,N1,ALF,BET
      NA=N
      NAL=0
      FMIN=0.0D 0
      XMAX=1.0D 3
      IEXT=0
      IERR=0
      GOTO (201,202,203,204,205,206,207,208,209,210,211,212,213,214,
     & 215,216,217,218,219,220,221,222,223,224,225,226,227,228,
     & 229,230,231,231),NEXT
201   N1=N-1
      DO 3030 I=1,N1
        X(I)=-1.2D 0
3030  CONTINUE
      X(N)=-1.0D 0
      RETURN
202   DO 3040 I=1,N
        X(I)=2.0D 0
3040  CONTINUE
      RETURN
203   DO 3050 I=1,N
        X(I)=0.5D 0
3050  CONTINUE
      RETURN
204   N1=N-1
      DO 3060 I=1,N1,2
        X(I)=-1.2D 0
        X(I+1)=1.0D 0
3060  CONTINUE
      RETURN
205   DO 3070 I=1,N
        X(I)=1.5D 0
3070  CONTINUE
      RETURN
206   DO 3080 I=1,N
        X(I)=0.0D 0
3080  CONTINUE
      RETURN
207   DO 3090 I=1,N
        X(I)=-1.0D 0
3090  CONTINUE
      RETURN
208   DO 4000 I=1,N
        X(I)=-1.0D 0
4000  CONTINUE
      RETURN
209   DO 4010 I=1,N
        X(I)=0.5D 0
4010  CONTINUE
      RETURN
210   DO 4020 I=1,N
        X(I)=0.1D 0
4020  CONTINUE
      RETURN
211   DO 4030 I=1,N
        X(I)=0.1D 0
4030  CONTINUE
      RETURN
212   DO 4040 I=1,N
        X(I)=0.5D 0
4040  CONTINUE
      RETURN
213   DO 4050 I=1,N
        X(I)=1.0D 0
4050  CONTINUE
      RETURN
214   DO 4060 I=1,N
        X(I)=-1.0D 0
4060  CONTINUE
      RETURN
215   DO 4070 I=1,N
        X(I)=0.0D 0
4070  CONTINUE
      RETURN
216   DO 4080 I=1,N
         X(I)=DBLE(I)/DBLE(N+1)
4080  CONTINUE
      RETURN
217   DO 4090 I=1,N
        X(I)=10.0D 0
4090  CONTINUE
      RETURN
218   DO 5000 I=1,N
        T=DBLE(I)/DBLE(N+1)
        X(I)=T*(T-1.0D 0)
5000  CONTINUE
      RETURN
219   DO 5010 I=1,N
        T=DBLE(I)/DBLE(N+1)
        X(I)=T*(T-1.D 0)
5010  CONTINUE
      RETURN
220   DO 5020 I=1,N
        X(I)=1.0D 0/DBLE(N)
5020  CONTINUE
      RETURN
221   DO 5030 I=1,N
        X(I)=1.0D 0-DBLE(I)/DBLE(N)
5030  CONTINUE
      RETURN
222   DO 5040 I=1,N
        X(I)=-1.0D 0
5040  CONTINUE
      RETURN
223   ALF=5
      BET=14
      DO 5051 I=1,N
        X(I)=0.0D 0
5051  CONTINUE
      DO 5052 I=1,N
        CALL EAFU16(N,I,X,F,NEXT)
        Y(I)=-F
5052  CONTINUE
      S=DBLE(BET*N)/DBLE(BET**2*N**2-(ALF+1)**2*(N-1)**2)
      DO 5050 I=1,N
        X(I)=S*Y(I)
5050  CONTINUE
      RETURN
224   DO 5060 I=1,N
        X(I)=1.0D 0
5060  CONTINUE
      RETURN
225   DO 5070 I=1,N
        X(I)=0.0D 0
5070  CONTINUE
      RETURN
226   DO 5080 I=1,N
        X(I)=1.0D 0
5080   CONTINUE
      RETURN
227   DO 5090 I=1,N
        X(I)=1.0D 0
5090   CONTINUE
      RETURN
228   DO 6000 I=1,N
        X(I)=1.0D 0
6000   CONTINUE
      RETURN
229   DO 6010 I=1,N
        X(I)=1.0D 0
6010  CONTINUE
      RETURN
230   T=DBLE(2)/DBLE(N+2)
      N1=N/2
      DO 6020 I=1,N1
        S=DBLE(I)*T
        X(I)=S*(1.0D 0-S)
        X(N1+I)=X(I)
6020   CONTINUE
      RETURN
231   N1=INT(SQRT(DBLE(N)))
      N=N1*N1
      NA=N
      DO 6030 I=1,N
        X(I)=1.0D 0
6030  CONTINUE
      RETURN
      END
