* SUBROUTINE EIUS41                ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INITIAL VALUES OF THE VARIABLES AND STRUCTURE OF THE SPARSE HESSIAN
*  MATRIX FOR UNCONSTRAINED MINIMIZATION.
*  SPARSE VERSION WITH CHANGED TESTS 7-10, 12.
*  CHANGED FOR THE TESTS.
*
* PARAMETERS :
*  IU  N  NUMBER OF VARIABLES.
*  IU  M  NUMBER OF ELEMENTS OF THE SPARSE HESSIAN MATRIX.
*  RO  X(N)  VECTOR OF VARIABLES.
*  IO  IH(N+1)  POINTERS OF THE DIAGONAL ELEMENTS OF THE HESSIAN MATRIX.
*  IO  JH(M)  INDICES OF THE NONZERO ELEMENTS OF THE HESSIAN MATRIX IN
*             THE PACKED ROW.
*  RO  FMIN  LOWER BOUND FOR THE OBJECTIVE FUNCTION.
*  RO  XMAX  MAXIMUM STEPSIZE.
*  II  NEXT  NUMBER OF THE TEST PROBLEM.
*  IO  IEXT  TYPE OF EXTREMUM (IEXT=0 - MINIMUM, IEXT-1 - MAXIMUM)
*  IO  IERR  ERROR INDICATOR.
*
      SUBROUTINE EIUS41(N,M,X,IH,JH,FMIN,XMAX,NEXT,IEXT,IERR)
      INTEGER N,M,NEXT,IEXT,IERR
      INTEGER IH(N+1),JH(*)
      REAL*8 X(N),FMIN,XMAX
      INTEGER I
      FMIN=0.0D 0
      XMAX=1.0D 3
      IEXT=0
      IERR=0
      GO TO (10,20,30), NEXT
   10 IF (N.LT.4) GO TO 999
      N=N-MOD(N,2)
      DO 11 I=1,N
      X(I)=0.0D 0
   11 CONTINUE
      M=N
      DO 12 I=1,N
      IH(I)=I
      JH(I)=I
   12 CONTINUE
      IH(N+1)=N+1
      RETURN
   20 CONTINUE
      RETURN
   30 CONTINUE
      RETURN
  999 IERR=1
      RETURN
      END
