* SUBROUTINE UASDH1             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE DENSE HESSIAN MATRIX FROM THE SPARSE JACOBIAN
* MATRIX.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF ROWS OF THE SPARSE JACOBIAN MATRIX.
*  II  MA  NUMBER OF NONZERO ELEMENTS OF THE SPARSE JACOBIAN MATRIX.
*  RU  H(N*(N+1)/2)  ELEMENTS OF THE DENSE HESSIAN MATRIX.
*  II  IAG(NA+1)  POSITIONS OF THE FIRST ROWS ELEMENTS IN THE SPARSE
*         JACOBIAN STRUCTURE.
*  II  JAG(MA)  COLUMN INDICES OF ELEMENTS IN THE SPARSE JACOBIAN
*         STRUCTURE.
*  RI  GA(NF)  GRADIENT OF THE SELECTED FUNCTION.
*  II  KA  INDEX OF THE SELECTED FUNCTION (ROW OF THE SPARSE JACOBIAN
*         MATRIX).
*  RI  FACTOR  SCALING FACTOR.
*
      SUBROUTINE UASDH1(N,NA,MA,H,IAG,JAG,GA,KA,FACTOR)
      INTEGER N,NA,MA,IAG(NA+1),JAG(MA),KA
      REAL*8 H(N*(N+1)/2),GA(N),FACTOR
      REAL*8 TEMP
      INTEGER I,J,IJ,JA,K,LA,IND
      IND(I,J)=MAX(I,J)*(MAX(I,J)-1)/2+MIN(I,J)
      LA=IAG(KA+1)-1
      DO 6 K=IAG(KA),LA
      I=ABS(JAG(K))
      TEMP=FACTOR*GA(I)
      DO 5 JA=K,LA
      J=ABS(JAG(JA))
      IJ=IND(I,J)
      H(IJ)=H(IJ)+TEMP*GA(J)
    5 CONTINUE
    6 CONTINUE
      RETURN
      END
