      SUBROUTINE UASMBL( N , NG, MAXSEL, NSEMIB, LH    , LIH   , NNZH  ,
     *                   NFREE , IFREE , ISTADH, LSTADH, ICNA  , LICNA ,
     *                   ISTADA, LSTADA, INTVAR, LNTVAR, IELVAR, LELVAR,
     *                   IELING, LELING, ISTADG, LSTADG, ISTAEV, LSTAEV,
     *                   ISTAGV, LNSTGV, ISVGRP, LNVGRP, IRNH  , JH    ,
     *                   NXTROW, LNXTRW, IWK   , LIWK  , A , LA, GUVALS,
     *                   LNGUVL, HUVALS, LNHUVL, GVALS2, GVALS3, GSCALE,
     *                   ESCALE, LESCAL, IH, WK, LWK   , GXEQX , LGXEQX,
     *                   INTREP, LINTRE, RANGES, IPRINT, IOUT  , BAND  ,
     *                   MAXSBW, INFORM )
C
C  ********************************************************************
C
C  ASSEMBLE THE SECOND DERIVATIVE MATRIX OF A GROUPS PARTIALLY
C  SEPARABLE FUNCTION IN EITHER CO-ORDINATE OR BAND FORMAT.
C
C  NICK GOULD, FEBRUARY 20TH 1989.
C  FOR CGT PRODUCTIONS.
C
C  ********************************************************************
C
      INTEGER          N , NG, MAXSEL, NFREE , LNXTRW, NNZH
      INTEGER          LA, LH, IOUT  , INFORM, NSEMIB, IPRINT, LIH
      INTEGER          LSTADH, LICNA , LSTADA, LNTVAR, LELVAR, LELING
      INTEGER          LSTADG, LSTAEV, LNSTGV, LNVGRP, LIWK,   MAXSBW
      INTEGER          LNGUVL, LNHUVL, LESCAL, LWK,    LGXEQX, LINTRE
      LOGICAL          BAND
      INTEGER          IFREE(  N ),      ISTADH( LSTADH ), ICNA( LICNA )
      INTEGER          ISTADA( LSTADA ), INTVAR( LNTVAR ), JH(   LIH )
      INTEGER          IELVAR( LELVAR ), IELING( LELING ), IRNH( LIH )
      INTEGER          ISTADG( LSTADG ), ISTAEV( LSTAEV )
      INTEGER          ISTAGV( LNSTGV ), ISVGRP( LNVGRP ), IWK( LIWK )
      INTEGER          NXTROW( 2,   LNXTRW ), IH( N + 1 )
      LOGICAL          GXEQX( LGXEQX ),  INTREP( LINTRE )
      DOUBLE PRECISION A(     LA ),      GVALS2( NG ),     GVALS3( NG ),
     *                 GUVALS( LNGUVL ), HUVALS( LNHUVL ), GSCALE( NG ),
     *                 ESCALE( LESCAL ), WK(     LWK )
      EXTERNAL         RANGES, UKMFI1
C
C  LOCAL VARIABLES.
C
      INTEGER          I, II,  IG, J,  JJ, K,  L, IP,  NN,     NNN
      INTEGER          NEWPT,  NIN,    IELL,   IEL,    IHNEXT
      INTEGER          NVAREL, IG1,    LISTVS, LISTVE, IELH,   INFOR
      INTEGER          INEXT,  IJHESS, IROW,   JCOL,   JCOLST, ISTART
      DOUBLE PRECISION ONE,    ZERO,   WKI,    HESNEW, GDASH,  G2DASH,
     *                 SCALEE
      EXTERNAL         DSETVL, DSETVI
      INTRINSIC        ABS,    MAX,    MIN
C
C  SET CONSTANT REAL PARAMETERS.
C
      PARAMETER ( ZERO   = 0.0D+0, ONE    = 1.0D+0 )
      IF ( NFREE .GT. LNXTRW ) GO TO 620
C
C  RENUMBER THE FREE VARIABLES SO THAT THEY ARE VARIABLES 1 TO NFREE.
C
      DO 10 I     = 1, N
         IWK( I ) = 0
         IH(  I ) = I
         JH(  I ) = I
   10 CONTINUE
      IH( N + 1 ) = N + 1
      DO 20 I = 1, NFREE
         IWK( IFREE( I ) ) = I
C
C  INITIALIZE THE LINK LIST WHICH POINTS TO THE ROW NUMBERS WHICH
C  ARE USED IN THE COLUMNS OF THE ASSEMBLED HESSIAN.
C
C  NXTROW( 1, . ) GIVES THE LINK LIST. THE LIST FOR COLUMN J STARTS
C                 IN NXTROW( 1, J ) AND ENDS WHEN NXTROW( 1, K ) = - 1.
C  NXTROW( 2, . ) GIVES THE POSITION IN H OF THE CURRENT LINK.
C
         NXTROW( 1, I ) = - 1
   20 CONTINUE
      NNZH  = 0
      NEWPT = NFREE + 1
      IF ( NEWPT .GT. LNXTRW ) GO TO 620
C
C  ------------------------------------------------------
C  FORM THE RANK-ONE SECOND ORDER TERM FOR THE ITH GROUP.
C  ------------------------------------------------------
C
      DO 200 IG = 1, NG
         IF ( GXEQX( IG ) ) GO TO 200
CCCC         G2DASH = GSCALE( IG ) * GVALS3( IG )
CCCC         IF ( G2DASH .EQ. ZERO ) GO TO 200
         IG1    = IG + 1
         LISTVS = ISTAGV( IG )
         LISTVE = ISTAGV( IG1 ) - 1
C
C  FORM THE GRADIENT OF THE IG-TH GROUP.
C
CC         CALL DSETVI( LISTVE - LISTVS + 1, WK, ISVGRP( LISTVS ), ZERO )
C
C  CONSIDER ANY NONLINEAR ELEMENTS FOR THE GROUP.
C
CCC         DO 130 IELL = ISTADG( IG ), ISTADG( IG1 ) - 1
CCC            IEL      = IELING( IELL )
CCC            K        = INTVAR( IEL )
CCC            L        = ISTAEV( IEL )
CCC            NVAREL   = ISTAEV( IEL + 1 ) - L
CCC            SCALEE   = ESCALE( IELL )
CCC            IF ( INTREP( IEL ) ) THEN
C
C  THE IEL-TH ELEMENT HAS AN INTERNAL REPRESENTATION.
C
CCC               NIN = INTVAR( IEL + 1 ) - K
CCC               CALL RANGES( IEL, .TRUE., GUVALS( K ),
CCC     *                      WK( N + 1 ), NVAREL, NIN )
CCC               DO 110 I   = 1, NVAREL
CCC                  J       = IELVAR( L )
CCC                  WK( J ) = WK( J ) + SCALEE * WK( N + I )
CCC                  L       = L + 1
CCC  110          CONTINUE
CCC            ELSE
C
C  THE IEL-TH ELEMENT HAS NO INTERNAL REPRESENTATION.
C
CCC               DO 120 I   = 1, NVAREL
CCC                  J       = IELVAR( L )
CCC                  WK( J ) = WK( J ) + SCALEE * GUVALS( K )
CCC                  K       = K + 1
CCC                  L       = L + 1
CCC  120          CONTINUE
CCC            END IF
CCC  130    CONTINUE
C
C  INCLUDE THE CONTRIBUTION FROM THE LINEAR ELEMENT.
C
CCC         DO 140 K   = ISTADA( IG ), ISTADA( IG1 ) - 1
CCC            J       = ICNA( K )
CCC            WK( J ) = WK( J ) + A( K )
CCC  140    CONTINUE
C
C  THE GRADIENT IS COMPLETE. FORM THE J-TH COLUMN OF THE RANK-ONE MATRIX
C
         DO 190 L = LISTVS, LISTVE
            JJ    = ISVGRP( L )
            J     = IWK( JJ )
            IF ( J .EQ. 0 ) GO TO 190
C
C  FIND THE ENTRY IN ROW I OF THIS COLUMN.
C
            DO 180 K = LISTVS, LISTVE
               II    = ISVGRP( K )
               I     = IWK( II )
               IF ( I .EQ. 0 .OR. I .GT. J ) GO TO 180
C
C  SKIP ALL ELEMENTS WHICH LIE OUTSIDE A BAND OF WIDTH NSEMIB.
C
               IF ( J - I .GT. NSEMIB ) GO TO 180
C               HESNEW = WK( II ) * WK( JJ ) * G2DASH
C               IF ( HESNEW .EQ. ZERO ) GO TO 180
C
C  OBTAIN THE APPROPRIATE STORAGE LOCATION IN H FOR THE NEW ENTRY.
C
               ISTART = J
  150          CONTINUE
               INEXT = NXTROW( 1, ISTART )
               IF ( INEXT .EQ. - 1 ) THEN
                  IF ( NEWPT .GT. LNXTRW ) GO TO 620
C
C  THE (I,J)-TH LOCATION IS EMPTY. PLACE THE NEW ENTRY IN THIS LOCATION
C  AND ADD ANOTHER LINK TO THE LIST.
C
                  NNZH = NNZH + 1
                  IF ( NNZH .GT. LH .OR. NNZH .GT. LIH ) GO TO 610
                  CALL UKMFI1(N, LIH, IH, JH, HESNEW, 0, INFOR, I, J,
     *                        HESNEW)
                  IRNH( NNZH )        = I
C                  JCNH( NNZH )        = J
C                  H( NNZH )           = HESNEW
                  NXTROW( 1, ISTART ) = NEWPT
                  NXTROW( 2, ISTART ) = NNZH
                  NXTROW( 1, NEWPT )  = - 1
                  NEWPT               = NEWPT + 1
               ELSE
C
C  CONTINUE SEARCHING THE LINKED LIST FOR AN ENTRY IN ROW I, COLUMN J.
C
                  IF ( IRNH( NXTROW( 2, ISTART ) ) .EQ. I ) THEN
C                     IP = NXTROW( 2, ISTART )
C                     H( IP ) = H( IP ) + HESNEW
                  ELSE
                     ISTART = INEXT
                     GO TO 150
                  END IF
               END IF
  180       CONTINUE
  190    CONTINUE
  200 CONTINUE
C
C  RESET THE WORKSPACE ARRAY TO ZERO.
C
      CALL DSETVL( MAXSEL, WK, 1, ZERO )
C
C  --------------------------------------------------------
C  ADD ON THE LOW RANK FIRST ORDER TERMS FOR THE I-TH GROUP.
C  --------------------------------------------------------
C
      DO 300 IG = 1, NG
CCCC         IF ( GXEQX( IG ) ) THEN
CCCC            GDASH = GSCALE( IG )
CCCC         ELSE
CCCC            GDASH = GSCALE( IG ) * GVALS2( IG )
CCCC            IF ( GDASH .EQ. ZERO ) GO TO 300
CCCC         END IF
         IG1 = IG + 1
C
C  SEE IF THE GROUP HAS ANY NONLINEAR ELEMENTS.
C
         DO 290 IELL = ISTADG( IG ), ISTADG( IG1 ) - 1
            IEL      = IELING( IELL )
            LISTVS   = ISTAEV( IEL )
            LISTVE   = ISTAEV( IEL + 1 ) - 1
            NVAREL   = LISTVE - LISTVS + 1
            IELH     = ISTADH( IEL )
            IHNEXT   = IELH
CCCC            SCALEE   = ESCALE( IELL )
            DO 250 L = LISTVS, LISTVE
               J     = IWK( IELVAR( L ) )
               IF ( J .NE. 0 ) THEN
C
C  THE IEL-TH ELEMENT HAS AN INTERNAL REPRESENTATION.
C  COMPUTE THE J-TH COLUMN OF THE ELEMENT HESSIAN MATRIX.
C
CCCC                  IF ( INTREP( IEL ) ) THEN
C
C  COMPUTE THE J-TH COLUMN OF THE HESSIAN.
C
CCCC                     WK( L - LISTVS + 1 ) = ONE
C
C  FIND THE INTERNAL VARIABLES.
C
CCCC                     NIN = INTVAR( IEL + 1 ) - INTVAR( IEL )
CCCC                     CALL RANGES( IEL, .FALSE., WK( 1 ),
CCCC     *                            WK( MAXSEL + 1 ), NVAREL, NIN )
C
C  MULTIPLY THE INTERNAL VARIABLES BY THE ELEMENT HESSIAN.
C
CCCC                     NN = MAXSEL + NIN
CCCC                     CALL DSETVL( NIN, WK( NN + 1 ), 1, ZERO )
C
C  ONLY THE UPPER TRIANGLE OF THE ELEMENT HESSIAN IS STORED.
C
CCCC                     JCOLST = IELH - 1
CCCC                     DO 220 JCOL = 1, NIN
CCCC                        IJHESS   = JCOLST
CCCC                        JCOLST   = JCOLST + JCOL
CCCC                        WKI      = WK( MAXSEL + JCOL ) * GDASH
CCCC                        DO 210 IROW = 1, NIN
CCCC                           IF ( IROW .LE. JCOL ) THEN
CCCC                              IJHESS = IJHESS + 1
CCCC                           ELSE
CCCC                              IJHESS = IJHESS + IROW - 1
CCCC                           END IF
CCCC                           WK( NN + IROW ) = WK( NN + IROW ) +
CCCC     *                                       WKI * HUVALS( IJHESS )
CCCC  210                   CONTINUE
CCCC  220                CONTINUE
C
C  SCATTER THE PRODUCT BACK ONTO THE ELEMENTAL VARIABLES.
C
CCCC                     NNN = NN + NIN
CCCC                     CALL RANGES( IEL, .TRUE., WK( NN + 1 ),
CCCC     *                            WK( NNN + 1 ), NVAREL, NIN )
CCCC                     WK( L - LISTVS + 1 ) = ZERO
CCCC                  END IF
C
C  FIND THE ENTRY IN ROW I OF THIS COLUMN.
C
                  DO 240 K = LISTVS, L
                     I     = IWK( IELVAR( K ) )
C
C  SKIP ALL ELEMENTS WHICH LIE OUTSIDE A BAND OF WIDTH NSEMIB.
C
                     IF ( ABS( I - J ) .LE. NSEMIB .AND. I .NE. 0 ) THEN
C
C  ONLY THE UPPER TRIANGLE OF THE MATRIX IS STORED.
C
                        IF ( I .LE. J ) THEN
                           II = I
                           JJ = J
                        ELSE
                           II = J
                           JJ = I
                        END IF
C
C  OBTAIN THE APPROPRIATE STORAGE LOCATION IN H FOR THE NEW ENTRY.
C
CC                        IF ( INTREP( IEL ) ) THEN
CC                           HESNEW = SCALEE * WK( NNN + K - LISTVS + 1 )
CC                        ELSE
CC                           HESNEW = SCALEE * HUVALS( IHNEXT ) * GDASH
CC                        END IF
CC                        IF ( HESNEW .NE. ZERO ) THEN
                        IF ( .TRUE. ) THEN
                           ISTART = JJ
  230                      CONTINUE
                           INEXT = NXTROW( 1, ISTART )
                           IF ( INEXT .EQ. - 1 ) THEN
                              IF ( NEWPT .GT. LNXTRW ) GO TO 620
C
C  THE (I,J)-TH LOCATION IS EMPTY. PLACE THE NEW ENTRY IN THIS LOCATION
C  AND ADD ANOTHER LINK TO THE LIST.
C
                              NNZH = NNZH + 1
                              IF ( NNZH .GT. LH .OR.
     *                             NNZH .GT. LIH ) GO TO 610
                              CALL UKMFI1(N, LIH, IH, JH, HESNEW, 0,
     *                                    INFOR, II, JJ, HESNEW)
                              IRNH( NNZH )        = II
C                              JCNH( NNZH )        = JJ
C                              H( NNZH )           = HESNEW
C                              IF ( K .NE. L .AND. II .EQ. JJ )
C     *                           H( NNZH ) = HESNEW + HESNEW
                              NXTROW( 1, ISTART ) = NEWPT
                              NXTROW( 2, ISTART ) = NNZH
                              NXTROW( 1, NEWPT )  = - 1
                              NEWPT               = NEWPT + 1
                           ELSE
C
C  CONTINUE SEARCHING THE LINKED LIST FOR AN ENTRY IN ROW I, COLUMN J.
C
                              IF ( IRNH( NXTROW( 2, ISTART ) )
     *                             .EQ. II ) THEN
                              IP      = NXTROW( 2, ISTART )
C                              H( IP ) = H( IP ) + HESNEW
C                              IF ( K .NE. L .AND. II .EQ. JJ )
C     *                           H( IP ) = H( IP ) + HESNEW
                              ELSE
                                 ISTART = INEXT
                                 GO TO 230
                              END IF
                           END IF
                        END IF
                     END IF
                     IHNEXT = IHNEXT + 1
  240             CONTINUE
               ELSE
                  IHNEXT = IHNEXT + L - LISTVS + 1
               END IF
  250       CONTINUE
  290    CONTINUE
  300 CONTINUE
C
C  ----------------------------------------
C  FOR DEBUGGING, PRINT THE NONZERO VALUES.
C  ----------------------------------------
C
      INFORM = 0
      RETURN
C
C  UNSUCCESSFUL RETURNS.
C
  610 CONTINUE
      INFORM = 1
      IF ( LH .LE. LIH ) THEN
         WRITE( IOUT, 2010 ) LH
      ELSE
         WRITE( IOUT, 2030 ) LIH
      END IF
      RETURN
  620 CONTINUE
      INFORM = 2
      WRITE( IOUT, 2020 ) LNXTRW
      RETURN
C
C  NON-EXECUTABLE STATEMENTS
C
 2010 FORMAT( ' ** Array dimension LH =', I6, ' too small in ASMBL. ' )
 2020 FORMAT( ' ** Array dimension LNXTRW =',I8, ' too small in ASMBL.')
 2030 FORMAT( ' ** Array dimension LIH =', I6, ' too small in ASMBL.' )
C
C  END OF UASMBL.
C
      END
