* SUBROUTINE UATRL3             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INITIAL TRANSFORMATION OF THE LINEAR APPROXIMATED FUNCTIONS.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF LINEAR FUNCTIONS.
*  II  MA  NUMBER OF ELEMENTS IN THE FIELD AG.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RO  AG(MA)  SPARSE JACOBIAN MATRIX.
*  RI  IAG(NA+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE FIELD AG.
*  RI  JAG(MA)  COLUMN INDICES OF ELEMENTS IN THE FIELD AG.
*  II  ISNA  SAVING SPECIFICATION. ISNA=0-NO SAVING. ISNA=1-FUNCTION
*         VALUES ARE SAVED. ISNA=2-FUNCTION VALUES AND GRADIENTS ARE
*         SAVED.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*  II  JOB  TRANSFORMATION SPECIFICATION. IF JOB=1 THEN FORWARD
*         TRANSFORMATION IS PERFORMED. IF JOB=-1 THEN BACKWARD
*         TRANSFORMATION IS PERFORMED.
*
* SUBPROGRAMS USED :
*  S   UXVMUL  DIAGONAL PREMULTIPLICATION OF A VECTOR.
*
      SUBROUTINE UATRL3(NF,NA,MA,XN,AG,IAG,JAG,ISNA,NORMF,JOB)
      INTEGER NF,NA,MA,IAG(NA+1),JAG(MA),ISNA,NORMF,JOB
      REAL*8 XN(NF),AG(MA)
      INTEGER J,JP,K,L,KA
      IF (NORMF.LE.0) RETURN
      IF (ISNA.LE.2) RETURN
      IF (JOB.EQ.0) RETURN
      DO 3 KA=1,NA
      K=IAG(KA)
      L=IAG(KA+1)-K
      IF (JOB.GT.0) THEN
      DO 1 J=1,L
      JP=ABS(JAG(K))
      AG(K)=AG(K)*XN(JP)
      K=K+1
    1 CONTINUE
      ELSE
      DO 2 J=1,L
      JP=ABS(JAG(K))
      AG(K)=AG(K)/XN(JP)
      K=K+1
    2 CONTINUE
      ENDIF
    3 CONTINUE
      RETURN
      END
