* SUBROUTINE UCICMM             ALL SYSTEMS                 98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF THE ACTIVE CONSTRAINT MATRIX CG BY A VECTOR X.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  II  NCA  NUMBER OF ACTIVE CONSTRAINTS.
*  II  MC  NUMBER OF NONZERO ELEMENTS IN THE FIELD CG.
*  IO  ICA(NCA)  VECTOR CONTAINING INDICES OF ACTIVE CONSTRAINTS.
*  RI  CG(MC)  ELEMENTS OF THE CONSTRAINT JACOBIAN MATRIX.
*  II  ICG(NC+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE FIELD CG.
*  II  JCG(MC)  COLUMN INDICES OF ELEMENTS IN THE FIELD CG.
*  RI  X(NCA)  INPUT VECTOR.
*  RO  Y(NF)  OUTPUT VECTOR EQUAL TO CG*X.
*
*  SUBPROGRAMS USED :
*  S   UXVSET  INITIATION OF A VECTOR.
*  S   UXWDIR  VECTOR AUGMENTED BY THE SCALED VECTOR (PACKED CASE).
*
      SUBROUTINE UCICMM(NF,NC,NCA,MC,ICA,CG,ICG,JCG,X,Y)
      INTEGER NF,NC,NCA,MC,ICA(NCA),ICG(NC+1),JCG(MC)
      REAL*8 CG(MC),X(NCA),Y(NF)
      INTEGER I,K,KC,L
      CALL UXVSET(NF,0.0D 0,Y)
      DO 1 I=1,NCA
      KC=ICA(I)
      IF (KC.LT.0) THEN
      K=-KC
      Y(K)=Y(K)+X(I)
      ELSE
      K=ICG(KC)
      L=ICG(KC+1)-K
      CALL UXWDIR(L,NF,JCG(K),X(I),CG(K),Y,Y,1)
      ENDIF
    1 CONTINUE
      RETURN
      END
