* SUBROUTINE UKMCPR                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* GARBAGE COLLECTION
*
* PARAMETERS :
*  II  MROWS MAXIMUM NUMBER OF ROWS.
*  II  MCOLS MAXIMUM NUMBER OF COLUMNS.
*  II  NZ  LENGTH OF THE ARRAY CNR.
*  II  NAU  LENGTH OF THE ARRAY AU.
*  IU  PTR(MCOLS) POINTER VECTOR OF THE ROWS OF THE FACTOR U.
*  II  LENR(MCOLS) LENGTHS OF THE ROWS OF THE FACTOR U.
*  IU  CNR(NZ) CONTAINS THE INDICES OF THE  ROW SCHEME
*              OF THE PROCESSED FACTOR U AND OF THE FACTOR L.
*  RU  AU(NAU) ELEMENTS OF THE PROCESSED SPARSE MATRIX.
*  IO  JBEG BEGINNING OF THE ROW SCHEME IN CNR. THAT MEANS THAT
*           ELEMENTS OF THE FACTOR L ARE AT THE POSITIONS 1,...
*           IBEG-1 AND THE ELEMENTS OF THE FACTOR U ARE AT THE
*  IO  JENDLU END OF THE COLUMN SCHEME IN CNR.
*
      SUBROUTINE UKMCPR(MROWS,MCOLS,NZ,NAU,PTR,LENR,CNR,AU,JBEG,JENDLU)
      INTEGER MROWS,MCOLS,NZ,NAU,PTR(MROWS),LENR(MCOLS),CNR(NZ),JBEG,
     & JENDLU
      REAL*8  AU(NAU)
      REAL*8 AUI
      INTEGER I,K,L,IDIST,J,ISTRT
C
C     INITIALIZATION OF THE DISTANCE AND DIMENSION PARAMETERS.
C
      IDIST=0
C
C     MARK THE BEGINNINGS OF THE ROWS OF FACTOR U
C
      DO 100 I=1,MROWS
      K=PTR(I)
      IF(LENR(I).NE.0) THEN
                       L=CNR(K)
                       CNR(K)=-I
                       PTR(I)=L
                       ELSE
                       PTR(I)=JBEG
      END IF
100   CONTINUE
C
C     GARBAGE COLLECTION OF THE ROWS OF THE FACTOR U
C
      ISTRT=JBEG
      I=JBEG
300   K=CNR(I)
      IF(K.LT.0) THEN
                 AUI=AU(I)
                 DO 400 J=1,LENR(-K)-1
                 CNR(ISTRT+J)=CNR(I+J)
                 AU(ISTRT+J)=AU(I+J)
400              CONTINUE
                 AU(ISTRT)=AUI
                 CNR(ISTRT)=PTR(-K)
                 PTR(-K)=ISTRT
                 ISTRT=ISTRT+LENR(-K)+IDIST
                 I=I+LENR(-K)
                 ELSE
                 I=I+1
      END IF
      IF(I.LT.JENDLU) GO TO 300
      DO 450 I=ISTRT,JENDLU
      CNR(I)=0
450   CONTINUE
      JENDLU=ISTRT-1
      RETURN
      END
