* SUBROUTINE UKQGLS                 ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* DIAGONAL VARIABLE METRIC PRECONDITIONER IS COMPUTED.
*
* PARAMETERS :
*  II  M  NUMBER OF ROWS OF THE SPARSE MATRIX.
*  RU  PV(LINP-M) DIAGONAL PRECONDITIONER:
*               = VARIABLE METRIC IF PFL<>1.
*               = VECTOR COMPOSED OF ONES IF PFL=1.
*  RI  RCG(LINP-M) GRADIENT VECTOR FOR CG ITERATION
*  RI  FCG(LINP-M) DIRECTION VECTOR FOR CG ITERATION.
*  RI  QCG(LINP-M) RESIDUUM DIRECTION VECTOR FOR CG ITERATION.
*  II  PFL PARAMETER CONTROLLING PRECONDITIONING:
*          =1 IF NO PRECONDITIONING IS USED
*          <>1 OTHERWISE.
*  II  LINP NUMBER OF ELEMENTS OF SUPERBASICS.
*
      SUBROUTINE UKQGLS(M,MCOLS,PV,RCG,FCG,QCG,PFL,LINP)
      INTEGER M,MCOLS,PFL,LINP
      REAL*8 PV(MCOLS),RCG(MCOLS),FCG(MCOLS),QCG(MCOLS)
      REAL*8 BETA,GAMA,DELTA,OMEGA,FJ
      INTEGER I,J
C
C     IF PFL.EQ.1 - NO PRECONDITIONING
C
      IF(PFL.EQ.1) GO TO 300
C
C     INITIALIZE THE VARIABLES GAMA AND OMEGA
C
      GAMA=0.0D 0
      OMEGA=0.0D 0
C
C     COMPUTE GAMA,OMEGA
C
      DO 100 J=1,LINP-M
      FJ=FCG(J)
      GAMA=GAMA+FJ*RCG(J)
      OMEGA=OMEGA+FJ*QCG(J)
100   CONTINUE
C
C     CYCLE OF DIAGAONAL BFGS PRECONDITIONER
C
      DO 200 I=1,LINP-M
      BETA=RCG(I)*RCG(I)
      DELTA=QCG(I)*QCG(I)
C
C     PV(I)=PV(I)-BETA/GAMA+DELTA/OMEGA
C
      PV(I)=PV(I)-BETA/GAMA+DELTA/OMEGA
      PV(I)=MIN(PV(I),1.0D 7)
200   CONTINUE
C
C     JUMP LABEL
C
300   CONTINUE
      RETURN
      END
