* SUBROUTINE UKQGLU                 ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* UPDATE THE FACTORS WHEN COLUMNS ARE EXCHANGED,
* UPDATE THE DISTRIBUTION OF VARIABLES INTO BLOCKS.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  M  NUMBER OF ROWS.
*  II  MROWS NUMBER OF ROWS DECLARED.
*  II  MCOLS NUMBER OF VARIABLES DECLARED.
*  II  NZ SIZE OF THE INDEX ARRAY CNR
*  II  NZA SIZE OF THE INDEX ARRAY RNR
*  II  NAU SIZE OF THE ARRAY AU.
*  II  NUP SIZE OF THE ARRAYS LI,LJ,CM.
*  IU  NEL NUMBER OF L-UPDATES IN THE ARRAYS LI,LJ,CM.
*  IU  IBEG  BEGINNING OF THE FACTOR U IN CNR.
*  IU  IBGR  BEGINNING OF THE ROW INDICES OF THE FACTOR U IN CNR.
*  IU  IENDLU  END OF THE ROW INDICES OF THE FACTOR U IN CNR.
*  IU  PTR(MROWS)  POINTER VECTOR OF THE ROWS OF THE FACTOR U.
*  IU  LENR(MROWS) LENGTHS OF THE ROWS OF THE FACTOR U.
*  IU  CNR(NZ) CONTAINS THE INDICES OF THE COLUMN AND ROW SCHEME OF
*              THE FACTORS OF THE SPARSE MATRIX.
*  II  PRNR(MCOLS+1) POINTER VECTOR FOR RNR.
*  II  RNR(NZA) COLUMNS OF THE MATRIX OF CONSTRAINTS.
*  IU  ORDR(MROWS) PERMUTATION OF THE ROWS.
*  IU  ORDC(MROWS) PERMUTATION OF THE COLUMNS.
*  IU  BCOL(MCOLS) NUMBERS OF THE BASIC ,SUPERBASIC AND NONBASIC COLUMNS.
*  IU  PTL(MROWS) POINTER VECTOR OF THE COLUMNS OF THE FACTOR L.
*  IU  LENL(MROWS) LENGTHS OF THE COLUMNS OF THE FACTOR L.
*  IU  ORDL(MROWS) PERMUTATION OF THE ROWS AFTER THE LATEST REFACTORIZATION.
*  IA  WN01(MCOLS) AUXILIARY VECTOR
*  RA  WR01(MCOLS) AUXILIARY VECTOR
*  RA  WR02(MCOLS) AUXILIARY VECTOR.
*  IU  LI(NUP) ROW INDICES OF THE ELEMENTARY FACTORS.
*  IU  LJ(NUP) COLUMN INDICES OF THE ELEMENTARY FACTORS.
*  RU  CM(NUP) NUMERICAL VALUES OF THE NONDIAGONAL ELEMENTS
*              OF THE ELEMENTARY FACTORS.
*  IU  RIGHT(MROWS) AUXILIARY VECTOR FOR COLUMNS EXCHANGE.
*  RI  A(NZA) NUMERICAL VALUES OF THE MATRIX OF CONSTRAINTS.
*  RU  AU(NAU) NUMERICAL VALUES OF THE ELEMENTS OF THE FACTORIZED BASIS.
*  RI  STFL  STABILITY FLAG.
*  RI  LB(MCOLS) LOWER BOUNDS FOR SOLUTION.
*  RI  UB(MCOLS) UPPER BOUNDS FOR SOLUTION.
*  RI  X(MCOLS)  SOLUTION VECTOR.
*  II  TYPE(MCOLS) TYPES OF THE VARIABLES:
*                                    =1 FOR NONBASIC LOWER BOUNDED
*                                    =2 FOR NONBASIC UPPER BOUNDED
*                                    =3 FOR NONBASIC LOWER AND UPPER
*                     BOUNDED VARIABLE SET TO ITS LOWER BOUND
*                                    =4 FOR NONBASIC LOWER AND UPPER
*                     BOUNDED VARIABLE SET TO ITS UPPER BOUND
*                                    =5 FOR NONBASIC FIXED VARIABLE
*                                    =6 FOR NONBASIC FREE VARIABLE
*                                    =-1 FOR BASIC LOWER BOUNDED
*                                    =-2 FOR BASIC UPPER BOUNDED
*                                    =-3 FOR BASIC LOWER AND UPPER
*                     BOUNDED VARIABLE
*                                    =-6 FOR BASIC FREE VARIABLE.
*  IU  NSB  ON INPUT : NUMBER OF SUPERBASICS AND BASICS SHIFTED
*                      AT THE BOUND, WHEN STEP RMAX IS TAKEN.
*           ON OUTPUT: NOT USED.
*  IU  NBB  ON INPUT : NUMBER OF BASICS SHIFTED
*                      AT THE BOUND, WHEN STEP RMAX IS TAKEN.
*           ON OUTPUT: NOT USED.
*  IU  INBCOL(MCOLS) VECTOR WITH COMPONENTS :
*                INBCOL(K)=I WHEN EXISTS K=BCOL(I) AND I<=NS,
*                INBCOL(K)=0 OTHERWISE.
*  II  IDEB  =1 FOR LUSOL UPDATE - OTHERWISE USES PERMUTATION
*            OF THE BUMP.
*  IU  UP(MROWS) UPPERMOST POSITION OF THE COLUMN SPIKE IN BASIS.
*  RI  EPS7 DROPPING PARAMETER.
*  RO  EPS9  BOUND FOR NEGLECTING SMALL TOLERANCES.
*  RU  DMAX   MINIMUM ELEMENT OF THE U-DIAGONAL.
*  RU  GMAX  MAXIMUM MULTIPLIER FOUND.
*  RU  UMAX   MAXIMUM ELEMENT OF THE U-DIAGONAL.
*  RO  P  VALUE OF THE DIRECTIONAL DERIVATIVE.
*  IU  NREF  NUMBER OF REFACTORIZATIONS OF THE BASIS MATRIX.
*  II  INEW  WHEN COLUMN EXCHANGE IS TO BE DONE, THEN IT DENOTES
*           COLUMN ENTERING THE BASIS.
*  II  IOLD WHEN COLUMN EXCHANGE IS TO BE DONE, THEN IT DENOTES
*           COLUMN LEAVING THE BASIS.
*  IU  KOLD  NUMBER OF U-UPDATES SINCE LAST REFACTORIZATION.
*  II  LINP NUMBER OF SUPERBASICS AND BASICS.
*  IA  ITERQ INTERNAL INFORMATION:
*                              =0 FOR STANDARD OUTPUT
*                              FACTORIZATION OUTPUT:
*                              =1 IF NAU IS DECLARED TOO SMALL
*                              =2 IF NZ IS TO BE INCREASED
*                              =3 IF MATRIX IS TOO UNSTABLE
*                              =4 IF MATRIX IS SINGULAR
*                              =5 IF NZ IS TOO SMALL FOR THE FACTORS
*                              =6 IF NAU IS TOO SMALL FOR FACTORS
*                              =7 IF NZ IS SMALL FOR THE AFTER-F-MANIP.
*                              UPDATE OUTPUT:
*                              =11 IF NAU IS DECLARED TOO SMALL
*                              =12 IF MATRIX IS SINGULAR
*                              =13 IF FACTORS ARE BADLY CONDITIONED.
*                              =14 LITTLE SPACE FOR L-UPDATES.
*                              =15 MATRIX SINGULARITY IS FACED.
*                              ULSGLU OUTPUT:
*                              =17 BAD SCALING OF THE INPUT PROBLEM.
*  IO  ITERQ TYPE OF FEASIBLE POINT. ITERL=1-ARBITRARY FEASIBLE POINT-
*         PHASE 1 OUTPUT,
*         ITERL=2-OPTIMUM FEASIBLE POINT. ITERL=-1 FEASIBLE POINT DOES
*         NOT EXISTS. ITERL=-2 OPTIMUM FEASIBLE POINT DOES NOT EXISTS,
*         ITERL=-3 - SMALL NAU, ITERL=-4 - NZ IS SMALL, ITERL=-5 - BADLY
*         CONDITIONED PROBLEM, ITERL=-6 -  SMALL NUP
*
      SUBROUTINE UKQGLU(N,M,MROWS,MCOLS,NZ,NZA,NAU,NUP,NEL,IBEG,IBGR,
     & IENDLU,PTR,LENR,CNR,PRNR,RNR,ORDR,ORDC,BCOL,PTL,LENL,ORDL,WN01,
     & WR01,WR02,LI,LJ,CM,RIGHT,A,AU,STFL,LB,UB,X,TYPE,NSB,NBB,INBCOL,
     & IDEB,UP,EPS7,EPS9,DMAX,GMAX,UMAX,P,NREF,INEW,IOLD,KOLD,LINP,
     & ITERQ)
      INTEGER N,M,MROWS,MCOLS,NZ,NZA,NAU,NUP,NEL,IBEG,IBGR,IENDLU,
     & PTR(MROWS),LENR(MROWS),CNR(NZ),PRNR(MCOLS+1),RNR(NZA),
     & ORDR(MROWS),ORDC(MROWS),BCOL(MCOLS),PTL(MROWS),LENL(MROWS),
     & ORDL(MROWS),WN01(MCOLS),LI(NUP),LJ(NUP),RIGHT(MROWS),TYPE(MCOLS),
     & NSB,NBB,INBCOL(MCOLS),IDEB,UP(MROWS),NREF,INEW,IOLD,KOLD,LINP,
     & ITERQ
      REAL*8 WR01(MCOLS),WR02(MCOLS),CM(NUP),A(NZA),AU(NAU),STFL,
     & LB(MCOLS),UB(MCOLS),X(MCOLS),EPS7,EPS9,DMAX,GMAX,UMAX,P
      INTEGER LACK
      INTEGER FIFTY
      REAL*8 GRFL,GSFL
      REAL*8 ONETEN,EPS15,EPS19
      INTEGER I,J,K,L,II,JPIV,JOB,ICHG,L1,L2,IND,TYPV
      REAL*8 PIMAX,PIMX,DPIV,TEMP,INFF
      PARAMETER(ONETEN=1.0D-1,FIFTY=50)
      PARAMETER(GRFL=1.0D 1,GSFL=1.0D 16,INFF=1.0D 20)
      PARAMETER(EPS15=1.0D-6,EPS19=1.0D-9)
      L2=0
C
C     SET ICHG
C
      IF(NSB.EQ.0) THEN
                   ICHG=1
                   ELSE
                   ICHG=2
      END IF
C
C     TEST OF ICHG
C
      IF(ICHG.EQ.1) THEN
C
C     INEW AND IOLD ARE PUBLIC
C
      DO 50 I=LINP+1,N
      IF(BCOL(I).EQ.INEW) GO TO 60
50    CONTINUE
C
C WE EXCHANGE THE BASIC VARIABLE FOR THE SUPERBASIC ONE
C
      DO 51 I=M+1,LINP
      IF(BCOL(I).EQ.INEW) GO  TO 52
51    CONTINUE
52    CONTINUE
      BCOL(I)=BCOL(IOLD)
      L=INBCOL(INEW)
      INBCOL(INEW)=IOLD
      INBCOL(BCOL(IOLD))=L
      GO TO 62
60    CONTINUE
      BCOL(I)=BCOL(IOLD)
      INBCOL(BCOL(IOLD))=0
      INBCOL(INEW)=IOLD
62    CONTINUE
C
C     CHANGE TYPE OF OUT-COLUMN
C
C        PROCESS TYPE 1,2,3,4,6
C
      L=BCOL(I)
      IF(TYPE(L).EQ.-3) THEN
        IF(ABS(X(L)-LB(L)).LE.EPS9)  THEN
          TYPE(L)=3
        ELSE
          TYPE(L)=4
        END IF
      ELSEIF(TYPE(L).LT.0) THEN
        TYPE(L)=-TYPE(L)
      ENDIF
C
C     CHANGE TYPE OF THE IN-COLUMN
C
      IF(TYPE(INEW).LT.3.OR.TYPE(INEW).EQ.6) THEN
        TYPE(INEW)=-TYPE(INEW)
      ELSEIF(TYPE(INEW).EQ.3.OR.TYPE(INEW).EQ.4) THEN
        TYPE(INEW)=-3
      ENDIF
C
70    CALL UXSGUM(M,M,NZ,NZA,NAU,NEL,NUP,PTR,LENR,CNR,PRNR,RNR,
     *            ORDR,IDEB,ORDC,BCOL,PTL,LENL,ORDL,WR01,WR02,LI,LJ
     *            ,CM,RIGHT,UP,A,AU,STFL,GMAX,EPS7,UMAX,DMAX,INEW,IOLD
     *            ,IBGR,IENDLU,IBEG,ITERQ)
C
C     TEST UPDATE ITERQ : CAN BE 0,11-15.
C
      IF(ITERQ.EQ.0)THEN
         KOLD=KOLD+1
         IF(KOLD.LT.FIFTY) GO TO 250
C
C     CASE OF ITERQ<>0 OR ITERQ=0.AND.KOLD.EQ.FIFTY
C
      ELSE
      CALL UOERR1('UKQGLU',ITERQ+20)
      IF(ITERQ.EQ.11) THEN
        ITERQ=-3
        RETURN
      ELSE
        IF(KOLD.EQ.0) THEN
          IF(ITERQ.EQ.14) THEN
            ITERQ=-6
          ELSE
            ITERQ=-5
          ENDIF
          RETURN
        END IF
      ENDIF
      KOLD=0
      NREF=NREF+1
      P=0
C
C     INSTEAD OF FORMAL PARAMETERS PTC,LENC WE USE WN01,UP
C
         CALL UXSGFD(M,M,NZ,NZA,NAU,NEL,P,N,PTL,LENL,WN01,UP,PTR,
     *               LENR,CNR,ORDC,ORDR,ORDL,RNR,PRNR,BCOL,RIGHT,WR01,
     *               A,AU,STFL,GMAX,UMAX,DMAX,IBEG,IBGR,IENDLU,LACK,
     *               GSFL,EPS7,ITERQ,0)
        IF (ITERQ.NE.0) THEN
          CALL UOERR1('UKQGLU',ITERQ+20)
          IF(ITERQ.EQ.1.OR.ITERQ.EQ.6) THEN
            ITERQ=-3
          ELSEIF(ITERQ.EQ.2.OR.ITERQ.EQ.7) THEN
            ITERQ=-4
          ELSE
            ITERQ=-5
          ENDIF
          RETURN
        END IF
C
C     SET UP THE VECTOR UP
C
         DO 150 I=1,M
         UP(I)=WR01(I)
150      CONTINUE
         GO TO 70
      END IF
250   CONTINUE
C
C  FOR DEGENERATE EXCHANGE CLEAR THE SUPERBASIS
C
C
      IND=0
      DO 610 I=M+1,LINP
      J=BCOL(I)
      TEMP=X(J)
      TYPV=TYPE(J)
      IF((TYPV.EQ.1.OR.TYPV.EQ.3.OR.TYPV.EQ.5.OR.TYPV.EQ.3).AND.(
     * ABS(X(J)-LB(J)).LT.EPS15)) THEN
        IND=IND+1
        WN01(IND)=I
      ELSEIF((TYPV.EQ.2.OR.TYPV.EQ.4.OR.TYPV.EQ.3).AND.(ABS(
     * X(J)-UB(J)).LT.EPS15))  THEN
        IND=IND+1
        WN01(IND)=I
      ELSE
        GO TO 610
      END IF
610   CONTINUE
C
C     FIRST LEAVE ALL OUT FROM THE SUPERBASIS
C     ALL COLUMNS STORED IN WN01(1,...,IND) WILL BE SHIFTED.
C
      DO 530 I=1,IND
      J=WN01(I)
      K=BCOL(LINP)
      L=BCOL(J)
      BCOL(LINP)=L
      BCOL(J)=K
      INBCOL(K)=J
      INBCOL(L)=0
C
C CORRECTION OF THE TYPES 3,4
C
      IF(TYPE(L).EQ.4.OR.TYPE(L).EQ.3) THEN
        IF(ABS(X(L)-LB(L)).LE.EPS19)  THEN
          TYPE(L)=3
        ELSE
          TYPE(L)=4
        END IF
        IF(ABS(X(L)-LB(L)).GT.ABS(X(L)-UB(L))) TYPE(L)=4
      END IF
      LINP=LINP-1
530   CONTINUE
                    ELSE
C
C     FIRST LEAVE ALL OUT FROM THE SUPERBASIS
C     ALL COLUMNS STORED IN WN01(NBB+1,...,NSB) WILL BE SHIFTED.
C
      DO 100 I=NBB+1,NSB
      J=WN01(I)
      K=BCOL(LINP)
      L=BCOL(J)
      BCOL(LINP)=L
      BCOL(J)=K
      INBCOL(K)=J
      INBCOL(L)=0
C
C CORRECTION OF THE TYPES 3,4
C
      IF(TYPE(L).EQ.4.OR.TYPE(L).EQ.3) THEN
        IF(ABS(X(L)-LB(L)).LE.EPS9)  THEN
          TYPE(L)=3
        ELSE
          TYPE(L)=4
        END IF
        IF(ABS(X(L)-LB(L)).GT.ABS(X(L)-UB(L))) TYPE(L)=4
      END IF
      LINP=LINP-1
100   CONTINUE
C
C     SET NSB TO NBB
C
      NSB=NBB
C
C     PUSH EJ INTO WR01
C
      DO 500 I=1,NBB
      J=WN01(I)
      DO 200 K=1,M
      WR01(K)=0.0D 0
200   CONTINUE
      WR01(J)=1.0D 0
C
C     SOLVE TRANS(B)*PIP=EJ
C
      JOB=0
      CALL UXSGFT(M,NZ,NAU,NEL,NUP,PTL,LENL,CNR,PTR,LENR,ORDC,ORDR,
     *            ORDL,LI,LJ,CM,AU,WR01,WR02,JOB)
C
C     WR02(1,...,LINP-M)=TRANS(S)*PIP
C
      CALL UXSGMT(M,LINP-M,NZA,RNR,PRNR,ORDR,BCOL(M+1),A,WR01,WR02,JOB)
C
C     CHOOSE THE SUPERBASIC COLUMN FOR THE EXCHANGE
C     IF NO ONE SUCH EXIST, TRY EXCHANGE NEXT BASIC COLUMN.
C
C
C     FIND PIMAX
C
      PIMAX=0.0D 0
      DO 300 K=1,LINP-M
      PIMAX=MAX(PIMAX,ABS(WR02(K)))
300   CONTINUE
      IF(ABS(PIMAX).LE.EPS9.AND.L2.EQ.1) THEN
      J=WN01(I)
      DO 201 K=1,M
        WR01(K)=0.0D 0
201   CONTINUE
      WR01(J)=1.0D 0
C
C     SOLVE TRANS(B)*PIP=EJ
C
      JOB=0
      CALL UXSGFT(M,NZ,NAU,NEL,NUP,PTL,LENL,CNR,PTR,LENR,ORDC,ORDR,
     *            ORDL,LI,LJ,CM,AU,WR01,WR02,JOB)
C
C     WR02(1,...,N-LINP)=TRANS(S)*PIP
C
      CALL UXSGMT(M,N-LINP,NZA,RNR,PRNR,ORDR,BCOL(LINP+1),A,WR01,
     *            WR02,JOB)
C
C     CHOOSE THE SUPERBASIC COLUMN FOR THE EXCHANGE
C     IF NO ONE SUCH EXIST, TRY EXCHANGE NEXT BASIC COLUMN.
C
C
C     FIND PIMAX
C
      PIMAX=0.0D 0
      DO 301 K=1,N-LINP
      PIMAX=MAX(PIMAX,ABS(WR02(K)))
301   CONTINUE
      PIMAX=ONETEN*PIMAX
      DPIV=0.0D 0
      DO 401 K=LINP+1,N
      L=BCOL(K)
      PIMX=ABS(WR02(K-LINP))
C
C TYPE.EQ.5 CANNOT BE IN SUPERBASIS
C
      IF(TYPE(L).EQ.1) THEN
        TEMP=ABS(X(L)-LB(L))
      ELSEIF(TYPE(L).EQ.2) THEN
        TEMP=ABS(X(L)-UB(L))
      ELSEIF(TYPE(L).EQ.5) THEN
        TEMP=0
      ELSEIF(TYPE(L).EQ.6) THEN
        TEMP=INFF
      ELSE
        TEMP=MIN(ABS(X(L)-UB(L)),ABS(X(L)-LB(L)))
      END IF
      IF(PIMX.GT.PIMAX.AND.TEMP.GE.DPIV) THEN
        DPIV=TEMP
        JPIV=K
      END IF
401   CONTINUE
C
C THE BASIC VARIABLE BEING CHANGED FOR THE NONBASIC ONE FIRST
C THER WILL BE INCLUDED INTO SUPERBASIS
C
      L1=BCOL(LINP+1)
      BCOL(LINP+1)=L
      BCOL(K)=L1
      INBCOL(L)=LINP+1
      LINP=LINP+1
      JPIV=LINP
      ELSE
      PIMAX=ONETEN*PIMAX
      DPIV=0.0D 0
      DO 400 K=M+1,LINP
      L=BCOL(K)
      PIMX=ABS(WR02(K-M))
C
C TYPE.EQ.5 CANNOT BE IN SUPERBASIS
C
      IF(TYPE(L).EQ.1) THEN
        TEMP=ABS(X(L)-LB(L))
      ELSEIF(TYPE(L).EQ.2) THEN
        TEMP=ABS(X(L)-UB(L))
      ELSEIF(TYPE(L).EQ.5) THEN
        TEMP=0
      ELSEIF(TYPE(L).EQ.6) THEN
        TEMP=INFF
      ELSE
        TEMP=MIN(ABS(X(L)-UB(L)),ABS(X(L)-LB(L)))
      END IF
      IF(PIMX.GT.PIMAX.AND.TEMP.GE.DPIV) THEN
        DPIV=TEMP
        JPIV=K
      END IF
400   CONTINUE
      ENDIF
C
C     IF PIMAX IS NEARLY ZERO THEN WE FACE ERROR - REFACTORIZE
C
      IF(ABS(PIMAX).LE.EPS9) THEN
        GO TO 500
      END IF
C
C     PI UPDATE
C
C
C     COLUMN EXCHANGE
C
      INEW=BCOL(JPIV)
      IOLD=J
C
C     FINISH CHANGE IN BCOL.
C
      L=BCOL(J)
      BCOL(JPIV)=L
      K=INEW
      INBCOL(K)=J
      INBCOL(L)=JPIV
C
C     CHANGE TYPE OF OUT-COLUMN
C
C        PROCESS TYPE 1,2,3,4,6
C
      IF(TYPE(L).EQ.-3) THEN
        IF(ABS(X(L)-LB(L)).LE.EPS9)  THEN
          TYPE(L)=3
        ELSE
          TYPE(L)=4
        END IF
      ELSEIF(TYPE(L).LT.0) THEN
        TYPE(L)=-TYPE(L)
      ENDIF
C
C     CHANGE TYPE OF THE IN-COLUMN
C
      IF(TYPE(INEW).LT.3.OR.TYPE(INEW).EQ.6) THEN
        TYPE(INEW)=-TYPE(INEW)
      ELSEIF(TYPE(INEW).EQ.3.OR.TYPE(INEW).EQ.4) THEN
        TYPE(INEW)=-3
      ENDIF
C
700   CALL UXSGUM(M,M,NZ,NZA,NAU,NEL,NUP,PTR,LENR,CNR,PRNR,RNR,
     *            ORDR,IDEB,ORDC,BCOL,PTL,LENL,ORDL,WR01,WR02,LI,LJ,
     *            CM,RIGHT,UP,A,AU,STFL,GMAX,EPS7,UMAX,DMAX,INEW,IOLD,
     *            IBGR,IENDLU,IBEG,ITERQ)
      IF(ITERQ.EQ.0) THEN
         KOLD=KOLD+1
         IF(KOLD.LT.FIFTY) GO TO 800
      ELSEIF(ITERQ.NE.0) THEN
        CALL UOERR1('UKQGLU',ITERQ+20)
        IF(ITERQ.EQ.11) THEN
          ITERQ=-3
          RETURN
        ELSE
        IF(KOLD.EQ.0) THEN
          IF(ITERQ.EQ.14) THEN
            ITERQ=-6
          ELSE
            ITERQ=-5
          ENDIF
          RETURN
        END IF
      END IF
        KOLD=0
        NREF=NREF+1
        P=0
C
C     INSTEAD OF FORMAL PARAMETERS PTC,LENC WE USE WN01,UP
C
         CALL UXSGFD(M,M,NZ,NZA,NAU,NEL,P,N,PTL,LENL,WN01,UP,PTR,
     *               LENR,CNR,ORDC,ORDR,ORDL,RNR,PRNR,BCOL,RIGHT,WR01,
     *               A,AU,STFL,GMAX,UMAX,DMAX,IBEG,IBGR,IENDLU,LACK,
     *               GSFL,EPS7,ITERQ,0)
        IF (ITERQ.NE.0) THEN
          CALL UOERR1('UKQGLU',ITERQ+20)
          IF(ITERQ.EQ.1.OR.ITERQ.EQ.6) THEN
            ITERQ=-3
          ELSEIF(ITERQ.EQ.2.OR.ITERQ.EQ.7) THEN
            ITERQ=-4
          ELSE
            ITERQ=-5
          ENDIF
          RETURN
        END IF
C
C     SET UP THE VECTOR UP
C
         DO 750 II=1,M
         UP(II)=WR01(II)
750      CONTINUE
         GO TO 700
      END IF
800   CONTINUE
C
C     INCREMENT NSB, ADD ELEMENT INTO WN01
C
C
C     COLUMN STORED IN JPIV WILL BE SHIFTED.
C
      J=JPIV
      K=BCOL(LINP)
      L=BCOL(J)
      BCOL(LINP)=L
      BCOL(J)=K
      INBCOL(K)=J
      INBCOL(L)=0
      LINP=LINP-1
500   CONTINUE
      END IF
      RETURN
      END
