* SUBROUTINE UO1EU2                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF EXIT FROM INITIAL VALUE PROBLEM.
*
* PARAMETERS:
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  NE  NUMBER OF EQUATIONS.
*  RI  AT(NA)  MESH POINTS.
*  RO  AY(NA*NE)  FIELD OF SOLUTION VECTORS IN THE MESH POINTS.
*  IO  NACC  NUMBER OF ACCEPTED INTEGRATION STEPS.
*  IO  NREJ  NUMBER OF REJECTED INTEGRATION STEPS.
*  IO  IER  ERROR INDICATOR.
*
* COMMON DATA :
*  IO  NSTP  ACTUAL  NUMBER OF INTEGRATION STEPS.
*  II  IOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INITIAL VALUES
*         AND FINAL RESULTS. IOUT=0-NO PRINT. IOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF MATRIX CORRECTION.
*         KOUT=5-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=6-ADDITIONAL PRINT OF DEBUGGING.
*  II  MOUT  LEVEL OF PRINT ON THE TERMINAL DEVICE.
*         MOUT=0 - NO PRINT.
*         MOUT=1 - PRINT OF FINAL RESULTS.
*         MOUT=2 - ADDITIONAL PRINT OF ITERATIONS.
*
* OUTPUT VARIABLES :
* AT(NA),AY(NA*NE),ITERM,TEDX,NSTP,NACC,NREJ,NEV,NEG,NEH,
*
      SUBROUTINE UO1EU2(NA,NE,AT,AY,NACC,NREJ,IPRN,IER)
      INTEGER NS,ISB,ISP(20),ISD(20),KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI(7)
      COMMON /UMOPTI/ NS,ISB,ISP,ISD,KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI
      REAL*8 TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR(12)
      COMMON /UMOPTR/ TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR
      REAL*8 ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS(2)
      COMMON /UMCONS/ ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS
      CHARACTER*4 TSS(20)
      CHARACTER*8 TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,TUXX,
     & TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT(3)
      CHARACTER*80 TER
      COMMON /UMOPTT/ TSS,TER,TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,
     & TUXX,TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT
      CHARACTER*6 NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN
      CHARACTER*14 NAME
      COMMON /UMOPTN/ NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN,NAME
      INTEGER NA,NE,NACC,NREJ,IPRN,IER
      REAL*8 AT(NA),AY(NA*NE)
      INTEGER I,J
      LOGICAL LL
      LL=KOUT.EQ.0.AND.LOUT.GT.0
      IF(KOUT.EQ.0.AND.LOUT.LT.0) IPRN=0
      IF(ABS(MOUT).GT.0) THEN
      IF(KD.LE.0) THEN
      IF (ABS(LOUT).LE.1) THEN
      WRITE(ITR,16) NEXT,NSTP,NACC,NREJ,NEV
      IF(LL) WRITE(IWR,16) NEXT,NSTP,NACC,NREJ,NEV
      ELSE
      WRITE(ITR,18) NEXT,NSTP,NACC,NREJ,NEV
      IF(LL) WRITE(IWR,18) NEXT,NSTP,NACC,NREJ,NEV
      ENDIF
      ELSE
      IF (ABS(LOUT).LE.1) THEN
      WRITE(ITR,17) NEXT,NSTP,NACC,NREJ,NEV,NEG
      IF(LL) WRITE(IWR,17) NEXT,NSTP,NACC,NREJ,NEV,NEG
      ELSE
      WRITE(ITR,19) NEXT,NSTP,NACC,NREJ,NEV,NEG
      IF(LL) WRITE(IWR,19) NEXT,NSTP,NACC,NREJ,NEV,NEG
      ENDIF
      ENDIF
      ENDIF
      IF (ITERM.GE.0.AND.ITERM.LE.10.OR.ITERM.GE.20.OR.ITERM.EQ.-6) THEN
      ELSE
      WRITE (ITR,'(A80)') TER
      IF (LL) WRITE (IWR,'(A80)') TER
      ENDIF
      IF(NOUT.NE.0) THEN
      DO 11 J=1,NA
      WRITE ( ITR,20) J,AT(J),(AY((J-1)*NE+I),I=1,NE)
      IF(LL) WRITE ( IWR,20) J,AT(J),(AY((J-1)*NE+I),I=1,NE)
   11 CONTINUE
      ENDIF
      IF(IPRN.EQ.0.OR.IOUT.EQ.0.OR.KOUT.EQ.0) RETURN
      WRITE ( IWR, 1)
    1 FORMAT ( '0', 'FINAL RESULTS' / ' ', 13('-'))
      DO 12 J=1,NA
      WRITE ( IWR, 3) J,AT(J),(AY((J-1)*NE+I),I=1,NE)
   12 CONTINUE
    3 FORMAT ( ' ',I5,2X, 'AT=', D 18.10/8X,'AY=',4D 18.10:/
     & ( 11X, 4D 18.10))
      WRITE ( IWR, 7)  IER, TEDX
    7 FORMAT ( '0', 'TERMINATION :', 3X, 'ITERM = ', I3, 3X, A8)
      WRITE ( IWR, 9) NSTP, NACC, NREJ,
     *                NEV,  NEG,  NEH
    9 FORMAT ('0','STATISTICS'/' ',10('-')/
     *  ' ','NSTP =',I5,3X,'NACC =',I5,3X,'NREJ =',I5/
     *  ' ','NEV  =',I5,3X,'NEG  =',I5,3X,'NEH  =',I5)
   16 FORMAT(' ',I4,2X,'NSTP=',I6,2X,'NACC=',I6,2X,'NREJ=',I6,2X,
     *           'NEV =',I6)
   17 FORMAT(' ',I4,2X,'NSTP=',I6,2X,'NACC=',I6,2X,'NREJ=',I6,2X,
     *           'NEV =',I6,2X,'NEG =',I6)
   18 FORMAT(' ',I4,2X,'NSTP=',I6,2X,'NACC=',I6,2X,'NREJ=',I6,2X,
     *           'NEV =',I6,3X,A8)
   19 FORMAT(' ',I4,2X,'NSTP=',I6,2X,'NACC=',I6,2X,'NREJ=',I6,2X,
     *           'NEV =',I6,2X,'NEG =',I6,3X,A8)
   20 FORMAT ( ' ',I4,2X, 'AT=', D 17.9/7X,'AY=',4D 17.9:/
     & ( 10X, 4D 17.9))
      RETURN
      END
