* SUBROUTINE UODLS4                ALL SYSTEMS                01/12/01
C PORTABILITY : ALL SYSTEMS
C 01/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF ITERATIONS IN INTERIOR POINT METHOD.
*
* PARAMETERS:
*  II  NF  NUMBER OF VARIABLES.
*  II  NX  NUMBER OF BOX CONSTRAINTS.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  II  NCA  NUMBER OF ACTIVE CONSTRAINTS.
*  RI  D(NF+NCA) DIAGONAL SUBMATRICES.
*  RI  S(NCA)  STEP FOR LAGRANGE MULTIPLIERS CORRESPONDING TO
*         ACTIVE CONSTRAINTS.
*  RI  XO(NX+NC)  STEP FOR LAGRANGE MULTIPLIERS CORRESPONDING TO
*         INACTIVE LOWER CONSTRAINTS.
*  RI  GO(NX+NC)  STEP FOR LAGRANGE MULTIPLIERS CORRESPONDING TO
*         INACTIVE UPPER CONSTRAINTS.
*
* COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*  II  KBC  SPECIFICATION OF LINEAR CONSTRAINTS. KBC=0-NO LINEAR
*         CONSTRAINTS. KBC=1-ONE SIDED LINEAR CONSTRAINTS. KBC=2=TWO
*         SIDED LINEAR CONSTRAINTS.
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=5-ADDITIONAL PRINT OF DEBUGGING.
*  II  LOUT  LEVEL OF PRINT. LOUT=0-PRINT OF SCALAR VALUES.
*         LOUT=1-ADDITIONAL PRINT OF BASIC VECTORS.
*         LOUT=2-ADDITIONAL PRINT OF OTHER VECTORS.
*         LOUT=3-ADDITIONAL PRINT OF MATRICES.
*
      SUBROUTINE UODLS4(NF,NX,NC,NCA,D,S,XO,GO,XS,GS)
      INTEGER NS,ISB,ISP(20),ISD(20),KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI(7)
      COMMON /UMOPTI/ NS,ISB,ISP,ISD,KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI
      REAL*8 TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR(12)
      COMMON /UMOPTR/ TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR
      REAL*8 ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS(2)
      COMMON /UMCONS/ ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS
      CHARACTER*4 TSS(20)
      CHARACTER*8 TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,TUXX,
     & TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT(3)
      CHARACTER*80 TER
      COMMON /UMOPTT/ TSS,TER,TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,
     & TUXX,TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT
      CHARACTER*6 NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN
      CHARACTER*14 NAME
      COMMON /UMOPTN/ NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN,NAME
      INTEGER NF,NX,NC,NCA
      REAL*8 D(NF+NC),S(NCA),XO(NX+NC),GO(NX+NC),XS(NX+NC),GS(NX+NC)
      INTEGER I
      IF(JOUT.EQ.0) RETURN
      IF(ABS(KOUT).LE.3) RETURN
      IF (ABS(LOUT).GE.3) WRITE (IWR,1) (D(I),I=1,MIN(NF,25))
    1 FORMAT(' ','KX  =',5D 14.5:/(6X,5D 14.5))
      IF (ABS(LOUT).GE.3) WRITE (IWR,8) (D(NF+I),I=1,
     & MIN(NCA,25))
    8 FORMAT(' ','KU  =',5D 14.5:/(6X,5D 14.5))
      IF(ABS(LOUT).GE.2) WRITE(IWR,3) (S(I),I=1,MIN(NCA,25))
    3 FORMAT(' ','DZA =',5D 14.5:/(6X,5D 14.5))
      IF(ABS(LOUT).GE.3) THEN
      IF (KBF.GE.1) WRITE(IWR,4) (XO(I),I=1,MIN(NX,25))
      IF (KBF.GE.1) WRITE(IWR,5) (GO(I),I=1,MIN(NX,25))
      IF (KBC.GE.1) WRITE(IWR,6) (XO(NX+I),I=1,MIN(NC,25))
      IF (KBC.GE.1) WRITE(IWR,7) (GO(NX+I),I=1,MIN(NC,25))
    4 FORMAT(' ','DXZL=',5D 14.5:/(6X,5D 14.5))
    5 FORMAT(' ','DXZU=',5D 14.5:/(6X,5D 14.5))
    6 FORMAT(' ','DCZL=',5D 14.5:/(6X,5D 14.5))
    7 FORMAT(' ','DCZU=',5D 14.5:/(6X,5D 14.5))
      IF (KBF.GE.1) WRITE(IWR,14) (XS(I),I=1,MIN(NX,25))
      IF (KBF.GE.1) WRITE(IWR,15) (GS(I),I=1,MIN(NX,25))
      IF (KBC.GE.1) WRITE(IWR,16) (XS(NX+I),I=1,MIN(NC,25))
      IF (KBC.GE.1) WRITE(IWR,17) (GS(NX+I),I=1,MIN(NC,25))
   14 FORMAT(' ','DXSL=',5D 14.5:/(6X,5D 14.5))
   15 FORMAT(' ','DXSU=',5D 14.5:/(6X,5D 14.5))
   16 FORMAT(' ','DCSL=',5D 14.5:/(6X,5D 14.5))
   17 FORMAT(' ','DCSU=',5D 14.5:/(6X,5D 14.5))
      ENDIF
      RETURN
      END
