* SUBROUTINE UOTES6                ALL SYSTEMS                02/12/01
C PORTABILITY : ALL SYSTEMS
C 02/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF ENTRY TO UNCONSTRAINED MINIMIZATION.
*
* COMMON DATA :
*  II  IEXT  TYPE OF EXTREMUM. IEXT=0-MINIMIZATION. IEXT=1-MAXIMIZATION.
*  II  IOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INITIAL VALUES
*         AND FINAL RESULTS. IOUT=0-NO PRINT. IOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF MATRIX CORRECTION.
*         KOUT=5-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=6-ADDITIONAL PRINT OF DEBUGGING.
*
* OUTPUT VARIABLES :
*  MET,MET1,MET2,MET3,MET4,MET5,MOT,MOT1,MOT2,MOT3,MOT4,MOT5,
*  MES,MES1,MES2,MES3,MES4,MES5,MOS,MOS1,MOS2,MOS3,MOS4,MOS5,
*  MEP,MEP1,MEP2,MEP3,MEP4,MEP5,MOP,MOP1,MOP2,MOP3,MOP4,MOP5,
*  MED,MED1,MED2,MED3,MED4,MED5,MEX,MEX1,MEX2,MEX3,MEX4,MEX5,
*  MFP,MFP1,MFP2,MLC,MLC1,MLC2,MLP,MLP1,MLP2,MQP,MQP1,MQP2,
*  KTERS,INITD,INITS,INITH,IREM,IADD,MRED,MRED,IRES1,IRES2,
*  TOLX,TOLF,TOLG,TOLB,TOLC,
*  TOLA,TOLR,EPS0,EPS1,EPS2,EPS3,EPS4,EPS5,EPS6,EPS7,EPS8,EPS9,ETA0,
*  ETA1,ETA2,ETA3,ETA4,ETA5,ETA6,ETA7,ETA8,ETA9,ALF1,ALF2,ALF3,BET1,
*  BET2,BET3,GAM1,GAM2,GAM3,DEL1,DEL2,DEL3,XDEL,XMAX,XMIN,FMAX,FMIN,
*  RPF1,RPF2,RPF3,RPF4,RPF5
*
      SUBROUTINE UOTES6(NF,NA,NAL,NC,NCL,XDEL,XMAX,FMIN,FMAX,RPF1,
     & RPF2,RPF3,RPF4,RPF5,EPS0,EPS1,EPS2,EPS3,EPS4,EPS5,EPS6,EPS7,
     & EPS8,EPS9,ETA0,ETA1,ETA2,ETA3,ETA4,ETA5,ETA6,ETA7,ETA8,ETA9,
     & ALF1,ALF2,ALF3,BET1,BET2,BET3,GAM1,GAM2,GAM3,DEL1,DEL2,DEL3,
     & MET,MET1,MET2,MET3,MET4,MET5,MOT,MOT1,MOT2,MOT3,MOT4,MOT5,
     & MES,MES1,MES2,MES3,MES4,MES5,MOS,MOS1,MOS2,MOS3,MOS4,MOS5,
     & MEP,MEP1,MEP2,MEP3,MEP4,MEP5,MOP,MOP1,MOP2,MOP3,MOP4,MOP5,
     & MED,MED1,MED2,MED3,MED4,MED5,MEX,MEX1,MEX2,MEX3,MEX4,MEX5,
     & MFP,MFP1,MFP2,MLC,MLC1,MLC2,MLP,MLP1,MLP2,MQP,MQP1,MQP2,
     & KTERS,INITD,INITS,INITH,IREM,IADD,MRED,IRES1,IRES2,
     & MF,MA,MB,KSF,KCF,KSA,KCA,KSC,KCC)
      INTEGER NS,ISB,ISP(20),ISD(20),KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI(7)
      COMMON /UMOPTI/ NS,ISB,ISP,ISD,KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI
      REAL*8 TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR(12)
      COMMON /UMOPTR/ TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR
      REAL*8 ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS(2)
      COMMON /UMCONS/ ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS
      CHARACTER*4 TSS(20)
      CHARACTER*8 TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,TUXX,
     & TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT(3)
      CHARACTER*80 TER
      COMMON /UMOPTT/ TSS,TER,TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,
     & TUXX,TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT
      CHARACTER*6 NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN
      CHARACTER*14 NAME
      COMMON /UMOPTN/ NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN,NAME
      INTEGER NF,NA,NAL,NC,NCL,
     & MET,MET1,MET2,MET3,MET4,MET5,MOT,MOT1,MOT2,MOT3,MOT4,MOT5,
     & MES,MES1,MES2,MES3,MES4,MES5,MOS,MOS1,MOS2,MOS3,MOS4,MOS5,
     & MEP,MEP1,MEP2,MEP3,MEP4,MEP5,MOP,MOP1,MOP2,MOP3,MOP4,MOP5,
     & MED,MED1,MED2,MED3,MED4,MED5,MEX,MEX1,MEX2,MEX3,MEX4,MEX5,
     & MFP,MFP1,MFP2,MLC,MLC1,MLC2,MLP,MLP1,MLP2,MQP,MQP1,MQP2,
     & KTERS,INITD,INITS,INITH,IREM,IADD,MRED,IRES1,IRES2,
     & MF,MA,MB,KSF,KCF,KSA,KCA,KSC,KCC
      REAL*8 XDEL,XMAX,FMIN,FMAX,RPF1,RPF2,RPF3,RPF4,RPF5,EPS0,EPS1,
     & EPS2,EPS3,EPS4,EPS5,EPS6,EPS7,EPS8,EPS9,ETA0,ETA1,ETA2,ETA3,ETA4,
     & ETA5,ETA6,ETA7,ETA8,ETA9,ALF1,ALF2,ALF3,BET1,BET2,BET3,GAM1,GAM2,
     & GAM3,DEL1,DEL2,DEL3
      IF (KOUT.NE.0) RETURN
      WRITE ( IWR, 1)
    1 FORMAT(/' ','OPTIONS:')
      WRITE ( IWR, 4)  NF,        KDF,KSF,KCF,KBF,ISNF,NORMF,
     &                 NA,NAL,KDA,KSA,KCA,KBA,ISNA,NORMA,
     &                 NC,NCL,KDC,KSC,KCC,KBC,ISNC,NORMC
    4 FORMAT ( /' ','NF=',I7,15X,
     &          'KDF=',I3,1X,'KSF=',I3,1X,'KCF=',I3,1X,
     &          'KBF=',I3,1X,'ISNF=',I2,1X,'NORMF=',I2/
     &          ' ','NA=',I7,3X,'NAL=',I6,2X,
     &          'KDA=',I3,1X,'KSA=',I3,1X,'KCA=',I3,1X,
     &          'KBA=',I3,1X,'ISNA=',I2,1X,'NORMA=',I2/
     &          ' ','NC=',I7,3X,'NCL=',I6,2X,
     &          'KDC=',I3,1X,'KSC=',I3,1X,'KCC=',I3,1X,
     &          'KBC=',I3,1X,'ISNC=',I2,1X,'NORMC=',I2)
      WRITE ( IWR, 5)
     &  MET,  MET1, MET2, MET3, MET4, MET5,
     &  MOT,  MOT1, MOT2, MOT3, MOT4, MOT5,
     &  MES,  MES1, MES2, MES3, MES4, MES5,
     &  MOS,  MOS1, MOS2, MOS3, MOS4, MOS5,
     &  MEP,  MEP1, MEP2, MEP3, MEP4, MEP5,
     &  MOP,  MOP1, MOP2, MOP3, MOP4, MOP5,
     &  MED,  MED1, MED2, MED3, MED4, MED5,
     &  MEX,  MEX1, MEX2, MEX3, MEX4, MEX5
      WRITE ( IWR, 6)
     &  MFP,  MFP1, MFP2, MLC,  MLC1, MLC2,
     &  MLP,  MLP1, MLP2, MQP,  MQP1, MQP2,
     &  KTERS,INITD,INITS,INITH,IREM, IADD,
     &  MTESX,MTESF,IDECF,IDECA,IDECC,IEXT,
     &  MIT,  MIC,  MRED, MF,   MFV,  MCGR,
     &  IRES1,MA,   MFG , MSTP ,IRES2,MB
    5 FORMAT (/
     &  1X,'MET   =',I3,3X,'MET1  =',I3,2X,'MET2  =',I3,3X,'MET3  =',I3,
     &  2X,'MET4  =',I3,3X,'MET5  =',I3/
     &  1X,'MOT   =',I3,3X,'MOT1  =',I3,2X,'MOT2  =',I3,3X,'MOT3  =',I3,
     &  2X,'MOT4  =',I3,3X,'MOT5  =',I3/
     &  1X,'MES   =',I3,3X,'MES1  =',I3,2X,'MES2  =',I3,3X,'MES3  =',I3,
     &  2X,'MES4  =',I3,3X,'MES5  =',I3/
     &  1X,'MOS   =',I3,3X,'MOS1  =',I3,2X,'MOS2  =',I3,3X,'MOS3  =',I3,
     &  2X,'MOS4  =',I3,3X,'MOS5  =',I3/
     &  1X,'MEP   =',I3,3X,'MEP1  =',I3,2X,'MEP2  =',I3,3X,'MEP3  =',I3,
     &  2X,'MEP4  =',I3,3X,'MEP5  =',I3/
     &  1X,'MOP   =',I3,3X,'MOP1  =',I3,2X,'MOP2  =',I3,3X,'MOP3  =',I3,
     &  2X,'MOP4  =',I3,3X,'MOP5  =',I3/
     &  1X,'MED   =',I3,3X,'MED1  =',I3,2X,'MED2  =',I3,3X,'MED3  =',I3,
     &  2X,'MED4  =',I3,3X,'MED5  =',I3/
     &  1X,'MEX   =',I3,3X,'MEX1  =',I3,2X,'MEX2  =',I3,3X,'MEX3  =',I3,
     &  2X,'MEX4  =',I3,3X,'MEX5  =',I3)
    6 FORMAT (
     &  1X,'MFP   =',I3,3X,'MFP1  =',I3,2X,'MFP2  =',I3,3X,'MLC   =',I3,
     &  2X,'MLC1  =',I3,3X,'MLC2  =',I3/
     &  1X,'MLP   =',I3,3X,'MLP1  =',I3,2X,'MLP2  =',I3,3X,'MQP   =',I3,
     &  2X,'MQP1  =',I3,3X,'MQP2  =',I3/
     &  1X,'KTERS =',I3,3X,'INITD =',I3,2X,'INITS =',I3,3X,'INITH =',I3,
     &  2X,'IREM  =',I3,3X,'IADD  =',I3/
     &  1X,'MTESX =',I3,3X,'MTESF =',I3,2X,'IDECF =',I3,3X,'IDECA =',I3,
     &  2X,'IDECC =',I3,3X,'IEXT  =',I3//
     &  1X,'MIT   =',I8,5X,'MIC   =',I8,3X,'MRED  =',I8,5X,'MF    =',I8/
     &  1X,'MFV   =',I8,5X,'MCGR  =',I8,3X,'IRES1 =',I8,5X,'MA    =',I8/
     &  1X,'MFG   =',I8,5X,'MSTP  =',I8,3X,'IRES2 =',I8,5X,'MB    =',I8)
      WRITE ( IWR, 7)
     &  TOLX, EPS0, ETA0, ALF1,
     &  TOLF, EPS1, ETA1, ALF2,
     &  TOLG, EPS2, ETA2, ALF3,
     &  TOLB, EPS3, ETA3, BET1,
     &  TOLC, EPS4, ETA4, BET2,
     &  TOLA, EPS5, ETA5, BET3
      WRITE ( IWR, 8)
     &  TOLR, EPS6, ETA6, GAM1,
     &  RPF1, EPS7, ETA7, GAM2,
     &  RPF2, EPS8, ETA8, GAM3,
     &  RPF3, EPS9, ETA9, DEL1,
     &  RPF4, FMIN, FMAX, DEL2,
     &  RPF5, XDEL, XMAX, DEL3
    7 FORMAT (/
     &' ','TOLX =',D 10.3,3X,'EPS0 =',D 10.3,3X,'ETA0 =',D 10.3,3X,
     &'ALF1 =',D 10.3/
     &' ','TOLF =',D 10.3,3X,'EPS1 =',D 10.3,3X,'ETA1 =',D 10.3,3X,
     &'ALF2 =',D 10.3/
     &' ','TOLG =',D 10.3,3X,'EPS2 =',D 10.3,3X,'ETA2 =',D 10.3,3X,
     &'ALF3 =',D 10.3/
     &' ','TOLB =',D 10.3,3X,'EPS3 =',D 10.3,3X,'ETA3 =',D 10.3,3X,
     &'BET1 =',D 10.3/
     &' ','TOLC =',D 10.3,3X,'EPS4 =',D 10.3,3X,'ETA4 =',D 10.3,3X,
     &'BET2 =',D 10.3/
     &' ','TOLA =',D 10.3,3X,'EPS5 =',D 10.3,3X,'ETA5 =',D 10.3,3X,
     &'BET3 =',D 10.3)
    8 FORMAT (
     &' ','TOLR =',D 10.3,3X,'EPS6 =',D 10.3,3X,'ETA6 =',D 10.3,3X,
     &'GAM1 =',D 10.3/
     &' ','RPF1 =',D 10.3,3X,'EPS7 =',D 10.3,3X,'ETA7 =',D 10.3,3X,
     &'GAM2 =',D 10.3/
     &' ','RPF2 =',D 10.3,3X,'EPS8 =',D 10.3,3X,'ETA8 =',D 10.3,3X,
     &'GAM3 =',D 10.3/
     &' ','RPF3 =',D 10.3,3X,'EPS9 =',D 10.3,3X,'ETA9 =',D 10.3,3X,
     &'DEL1 =',D 10.3/
     &' ','RPF4 =',D 10.3,3X,'FMIN =',D 10.3,3X,'FMAX =',D 10.3,3X,
     &'DEL2 =',D 10.3/
     &' ','RPF5 =',D 10.3,3X,'XDEL =',D 10.3,3X,'XMAX =',D 10.3,3X,
     &'DEL3 =',D 10.3)
      RETURN
      END
