* SUBROUTINE UP0AF2             ALL SYSTEMS                 97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF VALUE OF THE AUGMENTED LAGRANGIAN FUNCTION.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NC  NUMBER OF CONSTRAINTS.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE SPARSE HESSIAN MATRIX.
*  RI  B(M)  NONZERO ELEMENTS OF THE SPARSE SCHUR COMPLEMENT.
*  IO  IB(NC+1)  POINTERS OF THE DIAGONAL ELEMENTS OF B.
*  IO  JB(M)  INDICES OF THE NONZERO ELEMENTS OF B.
*  RI  CF(NC+1)  VECTOR CONTAINING VALUES OF THE CONSTRAINTS.
*  RI  CZ(NC)  VECTOR OF LAGRANGE MULTIPLIERS.
*  RI  S(NF+NC)  DIRECTION VECTOR.
*  II  PSL(NF) POINTER VECTOR OF THE SPARSE TRIANGULAR FACTOR OF B.
*  II  PERM(NF) PERMUTATION VECTOR.
*  RA  CFO(NC)  AUXILIARY ARRAY.
*  RA  CFD(NC)  AUXILIARY ARRAY.
*  RI  RPF2  PENALTY COEFFICIENT.
*  RO  FC  VALUE OF THE PENALTY TERM.
*  RO  F  VALUE OF THE PENALTY FUNCTION.
*
      SUBROUTINE UP0AF2(NF,NC,M,B,IB,JB,CF,CZ,S,PSL,PERM,CFO,CFD,RPF2,
     & FC,F)
      INTEGER NF,NC,M,IB(NC+1),JB(M),PSL(NC+1),PERM(NC)
      REAL*8 B(M),CF(NC+1),CZ(NC),S(NF+NC),CFO(NC),CFD(NC),RPF2,FC,F
      INTEGER L,KC
      L=IB(NC+1)
      CALL UXVCOP(NC,CF,CFO)
      CALL UXVSFP(NC,PERM,CFO,CFD)
      CALL UXSPCB(NC,M,B(L),PSL,JB(L),CFO,0)
      CALL UXVSBP(NC,PERM,CFO,CFD)
      FC=0.0D 0
      DO 1 KC=1,NC
      FC=FC+(CZ(KC)+S(NF+KC)+0.5D 0*RPF2*CFO(KC))*CF(KC)
    1 CONTINUE
      F=CF(NC+1)+FC
      RETURN
      END
