* SUBROUTINE UP0BX1             ALL SYSTEMS                   07/12/01
C PORTABILITY : ALL SYSTEMS
C 07/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF VALUE OF THE AUGMENTED LAGRANGIAN FUNCTION.
*
* PARAMETERS :
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  RI  Z  MINIMAX SLACK VARIABLE.
*  RI  AF(NA)  VECTOR CONTAINING VALUES OF APPROXIMATED FUNCTIONS.
*  RO  F  VALUE OF THE BARRIERY FUNCTION.
*  RI  RPF3  BARRIER COEFFICIENT.
*  II  IEXT  KIND OF THE MINIMAX APPROXIMATION. IEXT=0-CHEBYSHEV
*         APPROXIMATION. IEXT=-1-MINIMAX. IEXT=+1-MAXIMIN.
*
      SUBROUTINE UP0BX1(NA,Z,AF,F,FF,PAR,RPF3,MEP,IEXT)
      INTEGER NA,MEP,IEXT
      REAL*8 Z,AF(NA),PAR,RPF3,F,FF
      REAL*8 FA
      INTEGER KA
      IF (Z.LE.FF) THEN
      F=1.0D120
      RETURN
      ENDIF
      F=Z
      GO TO (10,20,30,40,50),MEP
   10 DO 11 KA=1,NA
      FA=AF(KA)
      IF (IEXT.LE.0) THEN
      F=F-RPF3*LOG(Z-FA)
      ENDIF
      IF (IEXT.GE.0) THEN
      F=F-RPF3*LOG(Z+FA)
      ENDIF
   11 CONTINUE
      RETURN
   20 DO 21 KA=1,NA
      FA=AF(KA)
      IF (IEXT.LE.0) THEN
      IF (Z-FA.LE.PAR) THEN
      F=F-RPF3*LOG(Z-FA)
      ELSE
      F=F+(2.0D 0-0.5D 0*PAR/(Z-FA))*RPF3*PAR/(Z-FA)
      ENDIF
      ENDIF
      IF (IEXT.GE.0) THEN
      IF (Z+FA.LE.PAR) THEN
      F=F-RPF3*LOG(Z+FA)
      ELSE
      F=F+(2.0D 0-0.5D 0*PAR/(Z+FA))*RPF3*PAR/(Z+FA)
      ENDIF
      ENDIF
   21 CONTINUE
      RETURN
   30 DO 31 KA=1,NA
      FA=AF(KA)
      IF (IEXT.LE.0) THEN
      F=F+RPF3*LOG(1.0D 0/(Z-FA)+1.0D 0)
      ENDIF
      IF (IEXT.GE.0) THEN
      F=F+RPF3*LOG(1.0D 0/(Z+FA)+1.0D 0)
      ENDIF
   31 CONTINUE
      RETURN
   40 DO 41 KA=1,NA
      FA=AF(KA)
      IF (IEXT.LE.0) THEN
      F=F+RPF3*RPF3/(Z-FA)
      ENDIF
      IF (IEXT.GE.0) THEN
      F=F+RPF3*RPF3/(Z+FA)
      ENDIF
   41 CONTINUE
      RETURN
   50 DO 51 KA=1,NA
      FA=AF(KA)
      IF (IEXT.LE.0) THEN
      IF (Z-FA.LE.1.0D 0) THEN
      F=F-RPF3*LOG(Z-FA)
      ELSE
      F=F-RPF3*(1.0D 0/(Z-FA)-4.0D 0/SQRT(Z-FA)+3.0D 0)
      ENDIF
      ENDIF
      IF (IEXT.GE.0) THEN
      IF (Z+FA.LE.1.0D 0) THEN
      F=F-RPF3*LOG(Z+FA)
      ELSE
      F=F-RPF3*(1.0D 0/(Z+FA)-4.0D 0/SQRT(Z+FA)+3.0D 0)
      ENDIF
      ENDIF
   51 CONTINUE
      RETURN
      END
