* SUBROUTINE UP0CF1             ALL SYSTEMS                 97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF VALUE OF THE AUGMENTED LAGRANGIAN FUNCTION.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NC  NUMBER OF CONSTRAINTS.
*  II  MC  NUMBER OF NONZERO ELEMENTS OF THE SPARSE JACOBIAN MATRIX.
*  RI  G(NF)  GRADIENT OF THE LAGRANGIAN FUNCTION.
*  RO  S(NF+NC)  DIRECTION VECTOR.
*  RI  CG(MC)  SPARSE CONSTRAINT JACOBIAN MATRIX.
*  II  ICG(NC+1)  POSITION OF THE FIRST RORWS ELEMENTS IN THE FIELD CG.
*  II  JCG(MC) COLUMN INDICES OF ELEMENTS IN THE FIELD CG.
*  RI  CF(NC+1)  VECTOR CONTAINING CONSTRANT VALUES.
*  RI  CZ(NC)  VECTOR OF LAGRANGE MULTIPLIERS.
*  RA  GP(NC)  AUXILIARY VECTOR.
*  II  IX(NX)  VECTOR CONTAINING TYPES OF BOUNDS.
*  II  KBF  VARIABLE WHICH SPECIFIES SIMPLE BOUNDS.
*  RI  RPF2  PENALTY COEFFICIENT.
*  RI  RPF3  PENALTY COEFFICIENT.
*  RO  FC  VALUE OF THE PENALTY TERM.
*  RO  F  VALUE OF THE PENALTY FUNCTION.
*
* SUBPROGRAMS USED :
*  S   UXUDOT  DOT PRODUCT OF TWO VECTORS.
*
      SUBROUTINE UP0CF1(NF,NC,MC,G,S,CG,ICG,JCG,CF,CZ,GP,IX,KBF,RPF2,
     & RPF3,FC,F)
      INTEGER NF,NC,MC,ICG(NC+1),JCG(MC),IX(NF),KBF
      REAL*8 G(NF),S(NF+NC),CG(MC),CF(NC+1),CZ(NC),GP(NF+NC),RPF2,RPF3,
     & FC,F
      REAL*8 UXUDOT
      INTEGER KC
      FC=0.0D 0
      DO 1 KC=1,NC
      FC=FC+(CZ(KC)+S(NF+KC)+0.5D 0*RPF2*CF(KC))*CF(KC)
    1 CONTINUE
      CALL UXSCMD(NF,NC,MC,CG,ICG,JCG,S(NF+1),1.0D 0,G,GP)
      F=CF(NC+1)+FC+0.5D 0*RPF3*UXUDOT(NF,GP,GP,IX,KBF)
      RETURN
      END
