* SUBROUTINE UQCUTE                ALL SYSTEMS                98/12/01
* PORTABILITY : ALL SYSTEMS
* 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  SIF FILES DECODER.
*
* PARAMETERS :
*  TI  PRB  NAME OF THE SIF FILE.
*
      SUBROUTINE UQCUTE(PRB)
      CHARACTER * 10 PRB
      INTEGER        IINGPS, IOUTDA, IINFN , IOUTFN, IOUTRA, IINGR
      INTEGER        IOUTET, IOUTGR, IOUT  , IOUTEX, NEWL  , I
      INTEGER        IINEX , IPRINT, INFORM, IALGOR
      INTEGER        JOUT
      LOGICAL        NONAME
      EXTERNAL       SDUFO
C
C  ASSIGN THE STANDARD OUTPUT UNIT NUMBERS.
C
      PARAMETER   ( JOUT = 22 )
      CHARACTER * 24 PRBDAT, PRBFN , PRBRA , PRBOUT, PRBGR , PRBET
      CHARACTER * 24 PRBEX
C
C  ASSIGN THE REMAINING I/O UNIT NUMBERS.
C
      PARAMETER   ( IOUTDA = 55, IOUTET = 56, IINGPS = 61 )
      PARAMETER   ( IOUTFN = 52, IOUTRA = 53, IOUTGR = 54 )
      PARAMETER   ( IOUTEX = 57                           )
      PARAMETER   ( IINFN  = IINGPS,  IINGR = IINGPS, IINEX = IINGPS )
      PARAMETER   ( NONAME = .FALSE. )
      IOUT = 6
C
C  READ PROBLEM'S NAME, BUILD DEFAULT FILE NAMES AND ASSIGN
C  THE ACTUAL VALUES USED.
C
      OPEN ( JOUT, FILE = 'P.SIF', STATUS = 'UNKNOWN')
      WRITE( IOUT, 2000 ) PRB
      WRITE( JOUT, 2000 ) PRB
      DO 70 I = 1, 10
         IF ( PRB( I: I ) .EQ. ' ' ) THEN
           NEWL = I - 1
           GO TO 80
         END IF
   70 CONTINUE
      NEWL = 10
   80 CONTINUE
      PRBDAT = 'SIF\' // PRB( 1 : NEWL ) // '.SIF'
      PRBOUT = 'OUTSDIF.DAT'
      PRBFN  = 'ELFUNS.FOR'
      PRBRA  = 'RANGES.FOR'
      PRBGR  = 'GROUPS.FOR'
      PRBET  = 'SETTYP.FOR'
      PRBEX  = 'EXTERN.FOR'
C
C     OPEN THE RELEVANT FILES - WATCOM FORTRAN.
C
      OPEN ( IINGPS, FILE = PRBDAT, STATUS = 'UNKNOWN')
      OPEN ( IOUTDA, FILE = PRBOUT, STATUS = 'UNKNOWN')
      OPEN ( IOUTFN, FILE = PRBFN,  STATUS = 'UNKNOWN')
      OPEN ( IOUTRA, FILE = PRBRA,  STATUS = 'UNKNOWN')
      OPEN ( IOUTGR, FILE = PRBGR,  STATUS = 'UNKNOWN')
      OPEN ( IOUTET, FILE = PRBET,  STATUS = 'UNKNOWN')
      OPEN ( IOUTEX, FILE = PRBEX,  STATUS = 'UNKNOWN')
C
C  specify the method to be used (1=SBMIN,2=AUGLG,3=BARIA).
C
C      READ( 5, 1020 ) IALGOR
       IALGOR = 3
C
C  specify whether the problem should be described(<0=DEBUG,0=NO,>0=YES)
C
C      READ( 5, 1030 ) IPRINT
       IPRINT = 0
C
C     DO THE WORK
C
      CALL SDUFO( IINGPS, IOUTDA, IINFN , IOUTFN, IOUTRA, IINGR ,
     *             IOUTET, IOUTGR, IINEX , IOUTEX, IPRINT, IOUT  ,
     *             NONAME, IALGOR, INFORM )
C
C   CLOSE THE OPENED FILES
C
      CLOSE( IINGPS )
      IF ( INFORM .EQ. 0 ) THEN
         CLOSE( IOUTDA )
         CLOSE( IOUTFN )
         CLOSE( IOUTRA )
         CLOSE( IOUTGR )
         CLOSE( IOUTET )
         CLOSE( IOUTEX )
         OPEN ( IOUTEX, FILE = PRBEX, STATUS = 'UNKNOWN' )
         READ ( IOUTEX, *, END=1300 )
         CLOSE ( IOUTEX )
         GOTO 1301
 1300    CONTINUE
         CLOSE ( IOUTEX, STATUS = 'DELETE' )
 1301    CONTINUE
C
C  IF AN ERROR HAS BEEN DISCOVERED, DELETE THE OUTPUT FILES.
C
      ELSE
         CLOSE( IOUTDA, STATUS = 'DELETE' )
         CLOSE( IOUTFN, STATUS = 'DELETE' )
         CLOSE( IOUTRA, STATUS = 'DELETE' )
         CLOSE( IOUTGR, STATUS = 'DELETE' )
         CLOSE( IOUTET, STATUS = 'DELETE' )
         CLOSE( IOUTEX, STATUS = 'DELETE' )
      END IF
      CLOSE( JOUT )
 1000 FORMAT( A10 )
 1010 FORMAT( L2 )
 1020 FORMAT( I2 )
 1030 FORMAT( I6 )
 2000 FORMAT( /, ' Problem name: ', A10 )
 2010 FORMAT( I6 )
      END
