* SUBROUTINE UQSBST                ALL SYSTEMS                89/12/01
* PORTABILITY : ALL SYSTEMS
* 89/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  PERFORM DIRECTIVE SUBST('FILENAME')
*
* PARAMETERS :
*  TI  BUFFER(MLENB) - WORK BUFFER
*  II  MLENB - MAX. LENGTH OF THE BUFFER
*  II  LENB - ACTUAL LENGTH OF THE BUFFER
*  II  IPOS1 - POSITION OF THE FIRST CHARACTER OF LINE
*               IN THE BUFFER
*  II  IPOSD - POSITION OF THE FIRST CHARACTER OF DIRECTIVE
*               IN THE BUFFER
*  II  IPOS2 - POSITION OF THE LAST CHARACTER OF LINE
*               IN THE BUFFER
*  IU  NSUB - NUMBER OF SUBSTITUTIONS 'SUBST'
*  IU  NASUB - NUMBER OF ALL SUBSTITUTIONS 'SUBST'
*  II  MNSUB - MAX. NUMBER OF SUBSTITUTIONS 'SUBST'
*  IU  NLINES - NUMBER OF LINES
*  IU  IUNIT - THE INPUT UNIT NUMBER
*  II  INUNIT - THE INCLUDE UNIT NUMBER
*  II  OUNIT - THE OUTPUT UNIT NUMBER
*  II  IIUNIT - THE INPUT INTERACTIVE UNIT NUMBER
*  II  OIUNIT - THE OUTPUT INTERACTIVE UNIT NUMBER
*  II  IDIRN - NUMBER OF DIRECTIVE
*  II  LABEL1 - STARTING VALUE OF LABEL
*  II  LABEL2 - STEP OF LABEL AFTER 'SUBST'
*  IU  LEVLAB(MNSUB) - LEVELS OF LABELS
*  TI  FN1 - FILENAME PART 1 (E.G. LIBRARY)
*  TI  FN2 - FILENAME PART 2 (E.G. EXTENSION)
*  TU  FNAMES(MNSUB) - NAMES OF SUBSTITUTED FILES
*  IO  IER - ERROR INDICATOR
*
* SUBPROGRAMS USED :
*  S   UQSADR - SYNTAX ANALYSIS OF DIRECTIVE LINE
*  S   UQDELS - DELETE A SUBSTRING FROM A STRING ARRAY
*
      SUBROUTINE UQSBST(BUFFER,MLENB,LENB,IPOS1,IPOSD,IPOS2,NSUB,NASUB,
     *                  MNSUB,NLINES,IUNIT,INUNIT,OUNIT,IIUNIT,OIUNIT,
     *                  IDIRN,LABEL1,LABEL2,LEVLAB,FN1,FN2,FNAMES,IER)
      INTEGER MLENB,LENB,IPOS1,IPOSD,IPOS2,NSUB,NASUB,MNSUB,NLINES,
     *        IUNIT,INUNIT,OUNIT,IIUNIT,OIUNIT,IDIRN,IER
      INTEGER*4 LABEL1,LABEL2,LEVLAB(MNSUB)
      CHARACTER*50 FN1,FN2,FNAMES(MNSUB)
      CHARACTER*1 BUFFER(MLENB)
      INTEGER MNPAR
      PARAMETER(MNPAR=1)
      INTEGER NPAR,IPOSP(MNPAR,2),ITYPE(MNPAR),I,L,
     *        IPOS12(30),NLNES2(30),IUNIT2(30)
      CHARACTER*100 FNAME
      LOGICAL TECKA
      SAVE IPOS12,NLNES2,IUNIT2
C
C SUBST('FILENAME')
C
      IF(IDIRN.EQ.18) THEN
        CALL UQSADR(BUFFER,MLENB,IPOSD,IPOS2,IPOSP,MNPAR,NPAR,ITYPE,IER)
        IF(IER.NE.0) RETURN
        IF(NPAR.NE.1) GOTO 5
        IF(ITYPE(1).NE.6) GOTO 5
        NSUB=NSUB+1
        IF(NSUB.GT.MNSUB) GOTO 6
C
C CREATE FILE NAME
C
        L=1
        DO 1 I=1,50
          IF (FN1(I:I).NE.' ') THEN
            FNAME(L:L)=FN1(I:I)
            L=L+1
          ENDIF
    1   CONTINUE
        TECKA=.FALSE.
        DO 2 I=1,IPOSP(1,2)-IPOSP(1,1)+1
          FNAME(L:L)=BUFFER(I+IPOSP(1,1)-1)
          IF(FNAME(L:L).EQ.'.') TECKA=.TRUE.
          IF(FNAME(L:L).NE.' ' ) L=L+1
    2   CONTINUE
        IF(.NOT.TECKA) THEN
          DO 3 I=1,50
            IF (FN2(I:I).NE.' ') THEN
              FNAME(L:L)=FN2(I:I)
              L=L+1
            ENDIF
    3     CONTINUE
        ENDIF
        IF (L.GT.50) GOTO 5
        IPOS12(NSUB)=IPOS1
        NLNES2(NSUB)=NLINES
        IUNIT2(NSUB)=IUNIT
        FNAMES(NSUB)=FNAME(1:L-1)
        NLINES=0
C
C FIND FREE IUNIT
C
    4   IUNIT=IUNIT+1
        IF(IUNIT.EQ.OUNIT.OR.IUNIT.EQ.INUNIT.OR.IUNIT.EQ.IIUNIT
     *     .OR.IUNIT.EQ.OIUNIT) GOTO 4
C
C OPEN SUBSTITUTED FILE
C
        OPEN(IUNIT,FILE=FNAME(1:L-1),STATUS='OLD',ACCESS='SEQUENTIAL',
     *       ERR=7)
        CALL UQDELS(BUFFER,MLENB,LENB,IPOS1,IPOS2)
        IPOS1=LENB+1
        NASUB=NASUB+1
        LEVLAB(NSUB)=LABEL1+NASUB*LABEL2
      ELSE
C
C END OF SUBSTITUTION
C
        CLOSE(IUNIT,ERR=7)
        LENB=IPOS1-1
        IPOS1=IPOS12(NSUB)
        NLINES=NLNES2(NSUB)
        IUNIT=IUNIT2(NSUB)
        NSUB=NSUB-1
      ENDIF
      RETURN
C
C ERROR: SYNTAX ERROR
C
    5 IER=20
      RETURN
C
C ERROR: 'MNSUB' EXCEEDED - TOO MANY NESTED SUBST('FILE')
C
    6 IER=40
      RETURN
C
C ERROR: SUBTITUTED FILE DOES NOT EXIST OR I/O HARDWARE ERROR
C
    7 IER=41
      RETURN
      END
