* SUBROUTINE UUVLV8                ALL SYSTEMS                16/12/01
C PORTABILITY : ALL SYSTEMS
C 31/12/16 VL :                                       ORIGINAL VERSION
*
* PURPOSE :
* THE BLOCK BNS METHOD.
*
* PARAMETERS :
*  IU  M  NUMBER OF COLUMNS OF MATRICES XM, GM.
*  II  MM  MAXIMUM NUMBER OF COLUMNS OF MATRICES XM, GM.
*  RU  XR(MM,MM)  MATRIX  XM^T . GM .
*  RU  GR(M*(M+1)/2)  SYMMETRIC MATRIX  GM^T . GM  STORED COLUMNWISE.
*  RO  XRP(MM*MM)  AUXILIARY MATRIX.
*  RO  GRP(MM*MM)  MATRIX  E(~).
*  RO  HL(M*(M+1)/2)  LOWER TRIANGULAR MATRIX  L  STORED ROWWISE.
*  RO  HR(M*(M+1)/2)  UPPER TRIANGULAR MATRIX  R  STORED COLUMNWISE.
*  RO  HLB(MM*MM)  BLOCK LOWER TRIANGULAR MATRIX  L_D(~).
*  RO  HRB(MM*MM)  BLOCK UPPER TRIANGULAR MATRIX  U.
*  RO  DR(M)  AUXILIARY VECTOR.
*  IO  IND(MM)  AUXILIARY VECTOR.
*  IO  ITERH  UPDATE INDICATOR ITERH>0-UPDATE FAILED.
*
* SUBPROGRAMS USED :
*  S  UUVLVT  TEST OF POSITIVE DEFINITENESS USING  RDR^T  FACTORIZATION.
*  S  UXELVF  RL  MATRIX FACTORIZATION.
*  S  UXDPRB  MULTIPLICATION OF INVERSION OF UPPER TRIANGULAR MATRIX
*            STORED COLUMNWISE BY VECTOR.
*
* METHOD :
*
      SUBROUTINE UUVLV8(M,MM,XR,GR,XRP,GRP,HL,HR,HLB,HRB,DR,IND,ITERH)
      INTEGER I,IR,J,K,L,LD,LR,LU,M,ML,MM,NL,IND(MM),LS,ITERH
      REAL*8 DR(M),GRP(MM,MM),HR(M*(M+1)/2),XR(MM,MM),XRP(MM,MM)
      REAL*8 HL(M*(M+1)/2),HLB(M*M),HRB(MM*MM),GR(M*(M+1)/2),Q,W
c *** Kombinace  blokove BFGS + BNS + zkracene blokove BNS
      ITERH=0
      LS=1
      CALL UUVLVT(M,MM,XR,XRP,HR,GR,DR,IND,1.0D-2,1.0D-13,1d-1,NL,LS)
      ML=M
      GRP=0.0D 0
      HLB=0.0D 0
      IF(IND(1).LE.2)LS=0
      IF(IND(1).GE.2)THEN
        Q=XR(ML,ML-1)/XR(ML-1,ML-1)
        W=XR(ML-1,ML)/XR(ML-1,ML-1)
      END IF
      DO K=1,NL
        LD=IND(K)
        L=ML-LD
        XRP(:LD,:LD)=XR(L+1:ML,L+1:ML)
        IF(K.EQ.1.AND.LS.GE.2)XRP(LD,:LD-1)=Q*XRP(LD-1,:LD-1)
        IR=0
        CALL UXELVF(LD,MM,XRP,HL,HR,IR)
        IF(IR.LT.0)THEN
          ITERH=1
          RETURN
        ENDIF
C    vytvor.matic   (\tilde)U=HRB , (\tilde)L_D=HLB , (\tilde)E=GRP
        XRP=XR
        DO J=1,L
          CALL UXDPRB(LD,HL,XRP(J,L+1:ML),-1)
        END DO
        DO J=1,LD
          IF(K.GT.1)CALL UXDPRB(LD,HL,XRP(L+1:ML,L+J),-1)
          LU=(L+J)*(L+J-1)/2
          DO I=1,L
            HRB(LU+I)=XRP(I,L+J)
          END DO
          LR=J*(J-1)/2-L
          DO I=L+1,L+J
            HRB(LU+I)=HR(LR+I)
            HLB(LU+I)=HL(LR+I)
            GRP(L+J,I)=HR(LR+I)
          END DO
        END DO
        IF(K.EQ.1.AND.LS.GE.2)THEN
          GRP(L+1:ML-1,L+1:ML-1)=TRANSPOSE(XR(L+1:ML-1,L+1:ML-1))
          GRP(L+1:ML-1,ML)=W*GRP(L+1:ML-1,ML-1)
          GRP(ML,L+1:ML-1)=W*GRP(ML-1,L+1:ML-1)
          GRP(ML,ML)=XR(ML,ML)+(W-Q)*XR(ML-1,ML)
          DO J=1,LD
            CALL UXDPRB(LD,HL,GRP(L+1:ML,L+J),-1)
          END DO
        END IF
        IF(K.GT.1)GRP(L+1:ML,L+1:ML)=
     1   (GRP(L+1:ML,L+1:ML)+XRP(L+1:ML,L+1:ML))*0.5D 0
        ML=L
      END DO
      RETURN
      END
