* SUBROUTINE UXBSMC                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* COPYING OF A BLOCKED SYMMETRIC MATRIX.
*
* PARAMETERS :
*  II  NBLA  DIMENSION OF THE ARRAYS ABL,BBL.
*  II  NBLKS  NUMBER OF BLOCKS OF THE MATRIX.
*  II  NBLJ  DIMENSION OF THE ARRAYS JBLA,JBLB.
*  RI  ABL(NBLA)  VALUES OF THE NONZERO ELEMENTS OF THE MATRIX.
*  II  IBLBGA(NBLKS+1)  BEGINNINGS OF THE BLOCKS IN THE INPUT MATRIX.
*  II  JBLA(NBLJ)  INDICES OF THE INDIVIDUAL BLOCKS OF THE INPUT MATRIX.
*  RO  BBL(NBLA)  VALUES OF THE NONZERO ELEMENTS OF THE MATRIX.
*  IO  IBLBGB(NBLKS+1)  BEGINNINGS OF THE BLOCKS IN THE OUTPUT MATRIX.
*  IO  JBLB(NBLJ)  INDICES OF THE BLOCKS OF THE OUTPUT MATRIX.
*
      SUBROUTINE UXBSMC(NBLA,NBLKS,NBLJ,ABL,IBLBGA,JBLA,BBL,IBLBGB,JBLB)
      INTEGER NBLKS,NBLJ,NBLA,IBLBGA(NBLKS+1),JBLA(NBLJ)
      INTEGER IBLBGB(NBLKS+1),JBLB(NBLJ)
      REAL*8 ABL(NBLA),BBL(NBLA)
      INTEGER I
      DO 1 I=1,NBLKS+1
      IBLBGA(I)=IBLBGB(I)
  1   CONTINUE
      DO 2 I=1,NBLJ
      JBLA(I)=JBLB(I)
  2   CONTINUE
      DO 3 I=1,NBLA
      ABL(I)=BBL(I)
  3   CONTINUE
      RETURN
      END
