* SUBROUTINE UXBSMM                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF A BLOCKED SYMMETRIC MATRIX A BY A VECTOR X.
*
* PARAMETERS :
*  II  N  MATRIX DIMENSION.
*  II  NBLA  DIMENSION OF THE ARRAY ABL.
*  II  NBLKS  NUMBER OF BLOCKS OF THE MATRIX.
*  II  NBLJ  DIMENSION OF THE ARRAY JBL.
*  RI  ABL(NBLA)  VALUES OF THE NONZERO ELEMENTS OF THE MATRIX.
*  II  IBLBG(NBLKS+1)  BEGINNINGS OF THE BLOCKS IN THE MATRIX.
*  II  JBL(NBLJ)  INDICES OF THE INDIVIDUAL BLOCKS
*  RI  X(N)  INPUT VECTOR.
*  RO  Y(N)  OUTPUT VECTOR EQUAL TO  A*X.
*
      SUBROUTINE UXBSMM(N,NBLA,NBLKS,NBLJ,ABL,IBLBG,JBL,X,Y)
      INTEGER N,NBLKS,NBLJ,NBLA,IBLBG(NBLKS+1),JBL(NBLJ)
      REAL*8 ABL(NBLA),X(N),Y(N)
      INTEGER I,J,I1,J1,K,KBEG,KBEG1,KLEN,I2
      REAL*8 ZERO
      PARAMETER  (ZERO = 0.0D 0)
      DO 1 I=1,N
      Y(I)=ZERO
   1  CONTINUE
      K=0
      DO 4 I=1,NBLKS
         KBEG=IBLBG(I)
         KBEG1=KBEG-1
         KLEN=IBLBG(I+1)-KBEG
         DO 3 I2=1,KLEN
            I1=JBL(I2+KBEG1)
            DO 2 J=1,I2-1
               J1=JBL(J+KBEG1)
               K=K+1
               IF (I1.GT.0.AND.J1.GT.0) THEN
                 Y(I1)=Y(I1)+ABL(K)*X(J1)
                 Y(J1)=Y(J1)+ABL(K)*X(I1)
               ENDIF
    2       CONTINUE
            K=K+1
            IF (I1.GT.0) Y(I1)=Y(I1)+X(I1)*ABL(K)
    3    CONTINUE
    4 CONTINUE
      RETURN
      END
