* SUBROUTINE UXDCTF                ALL SYSTEMS               16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  TOTAL QR DECOMPOSITION USING HOUSEHOLDER TRANSFORMATIONS.
*
* PARAMETERS :
*  II  N  NUMBER OF COLUMNS OF THE MATRIX A.
*  II  M  NUMBER OF ROWS OF THE MATRIX A.
*  RU  A(M*N)  RECTANGULAR MATRIX STORED COLUMNWISE IN THE
*         ONE-DIMENSIONAL ARRAY.
*  IO  IA(N)  A PERMUTATION FIELD WHICH CONTAINS AN INFORMATION ABOUT
*         PERMUTATION MATRIX.
*  RO  D(N)  VECTOR CONTAINING INFORMATION ABOUT HOUSEHOLDER
*         TRANSFORMATIONS.
*  II  NP  PSEUDORANK OF THE MATRIX A.
*
      SUBROUTINE UXDCTF(N,M,A,IA,D,NP)
      INTEGER N,M,IA(N),NP
      REAL*8 A(M*N),D(N)
      REAL*8 ALF,POM
      INTEGER I,J,K,L,JP,KP
      REAL*8 ONE
      PARAMETER (ONE=1.0D 0)
      IF(NP.LT.N) THEN
      DO 8 K=NP,1,-1
      L=IA(K)
      KP=(L-1)*M
      POM=A(K+KP)**2
      DO 2 J=NP+1,N
      JP=(IA(J)-1)*M
      POM=POM+A(K+JP)**2
    2 CONTINUE
      POM=SIGN(SQRT(POM),A(K+KP))
      A(K+KP)=A(K+KP)/POM+ONE
      DO 3 J=NP+1,N
      JP=(IA(J)-1)*M
      A(K+JP)=A(K+JP)/POM
    3 CONTINUE
      DO 6 I=1,K-1
      ALF=A(K+KP)*A(I+KP)
      DO 4 J=NP+1,N
      JP=(IA(J)-1)*M
      ALF=ALF+A(K+JP)*A(I+JP)
    4 CONTINUE
      A(I+KP)=A(I+KP)-ALF
      ALF=ALF/A(K+KP)
      DO 5 J=NP+1,N
      JP=(IA(J)-1)*M
      A(I+JP)=A(I+JP)-ALF*A(K+JP)
    5 CONTINUE
    6 CONTINUE
      D(L)=A(K+KP)
      A(K+KP)=-POM
    8 CONTINUE
      ENDIF
      RETURN
      END
