* SUBROUTINE UXDGGB                ALL SYSTEMS                94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SOLUTION OF A SYSTEM OF LINEAR EQUATIONS WITH A DENSE UNSYMMETRIC
* MATRIX A USING THE FACTORIZATION A*P=L*U OBTAINED BY THE SUBROUTINE
* UXDGGB.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  RI  A(N*N)  THE FACTORIZATION A*P = L*U OBTAINED BY THE SUBROUTINE
*         UXDGGF
*  II  IA(N)  A PERMUTATION FIELD WHICH CONTAINS AN INFORMATION ABOUT
*         PERMUTATION MATRIX P.
*  RU  X(N)  ON INPUT THE RIGHT HAND SIDE OF A SYSTEM OF LINEAR
*         EQUATIONS. ON OUTPUT THE SOLUTION OF A SYSTEM OF LINEAR
*         EQUATIONS.
*  RA  Y(N)  AUXILIARY VECTOR.
*  II  JOB  OPTION. JOB=0 - SOLUTION WITH THE ORIGINAL MATRIX.
*         JOB=1 - SOLUTION WITH THE MATRIX TRSANSPOSE.
*
* METHOD :
* BACK SUBSTITUTION.
*
      SUBROUTINE UXDGGB(N,A,IA,X,Y,JOB)
      INTEGER N,IA(N),JOB
      REAL*8 A(N*N),X(N),Y(N)
      INTEGER J,K,KP
      IF (JOB.LE.0) THEN
      CALL UXVGFP(N,IA,X,Y)
      DO 2 K=1,N
      KP=IA(K)
      DO 1 J=1,K-1
      X(K)=X(K)-A(KP+J)*X(J)
    1 CONTINUE
    2 CONTINUE
      DO 4 K=N,1,-1
      KP=IA(K)
      DO 3 J=K+1,N
      X(K)=X(K)-A(KP+J)*X(J)
    3 CONTINUE
      X(K)=X(K)/A(KP+K)
    4 CONTINUE
      ELSE
      DO 6 K=1,N
      KP=IA(K)
      X(K)=X(K)/A(KP+K)
      DO 5 J=K+1,N
      X(J)=X(J)-A(KP+J)*X(K)
    5 CONTINUE
    6 CONTINUE
      DO 8 K=N,1,-1
      KP=IA(K)
      DO 7 J=1,K-1
      X(J)=X(J)-A(KP+J)*X(K)
    7 CONTINUE
    8 CONTINUE
      CALL UXVGBP(N,IA,X,Y)
      ENDIF
      RETURN
      END
