* SUBROUTINE UXDGGD                ALL SYSTEMS                16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF A GIVEN VECTOR X BY A DENSE UNSYMMETRIC
* MATRIX A USING THE FACTORIZATION A=P*L*U OBTAINED BY THE SUBROUTINE
* UXDGGM.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  RI  A(N*N)  ON INPUT A GIVEN DENSE GENERAL SQUARE MATRIX A STORED IN
*         THE PACKED FORM. ON OUTPUT THE COMPUTED FACTORIZATION A=P*L*U.
*  II  IA(N)  A PERMUTATION FIELD WHICH CONTAINS AN INFORMATION ABOUT
*         PERMUTATION MATRIX P.
*  RU  X(N)  INPUT VECTOR.
*  RI  ALF  INPUT PARAMETER
*  RO  Y(N)  INPUT VECTOR
*  RO  Z(N)  OUTPUT VECTOR
*  JOB  OPTION. JOB=0 - MULTIPLICATION BY THE ORIGINAL MATRIX.
*         JOB=1 - MULTIPLICATION BY THE MATRIX TRSANSPOSE.
*
      SUBROUTINE UXDGGD(N,A,IA,X,ALF,Y,JOB)
      INTEGER N,IA(N),JOB
      REAL*8 A(N*N),X(N),ALF,Y(N),Z(N)
      INTEGER J,JP,K,L
      REAL*8 ZERO
      PARAMETER (ZERO=0.0D 0)
      IF (JOB.LE.0) THEN
      L=0
      DO 2 K=1,N
      Z(K)=ALF*Y(K)
      DO 1 J=K,N
      JP=IA(J)
      Z(K)=Z(K)+A(L+JP)*X(JP)
    1 CONTINUE
      L=L+N
    2 CONTINUE
      L=N*N
      DO 4 K=N,1,-1
      L=L-N
      DO 3 J=1,K-1
      JP=IA(J)
      Z(K)=Z(K)+A(L+JP)*Z(J)
    3 CONTINUE
    4 CONTINUE
      ELSE
      L=0
      DO 7 K=1,N
      DO 6 J=1,K-1
      JP=IA(J)
      X(J)=X(J)+A(L+JP)*X(K)
    6 CONTINUE
      L=L+N
      Z(K)=ALF*Y(K)
    7 CONTINUE
      L=0
      DO 9 K=1,N
      DO 8 J=K,N
      JP=IA(J)
      Z(JP)=Z(JP)+A(L+JP)*X(K)
    8 CONTINUE
      L=L+N
    9 CONTINUE
      ENDIF
      RETURN
      END
