* SUBROUTINE UXDLBS                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
* SCALING OF A DENSE SYMMETRIC MATRIX A USING THE FACTORIZATION
* A=P*L*D*TRANS(L)*TRANS(P) OBTAINED BY THE SUBROUTINE UXDLBF.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  RU  A(N*(N+1)/2)  FACTORIZATION A=P*L*D*TRANS(L)*TRANS(P) OBTAINED
*         BY THE SUBROUTINE UXDLBF.
*  II  IA(N)  PERMUTATION FIELD OBTAINED BY THE SUBROUTINE UXDLBF.
*  RI  ALF SCALING FACTOR.
*
      SUBROUTINE UXDLBS(N,A,IA,ALF)
      INTEGER N,IA(N)
      REAL*8 A(N*(N+1)/2),ALF
      INTEGER K,KD,I,J
      K = N
   10 CONTINUE
      IF (K.LT.1) RETURN
      J = IA(K)
      IF (J.GT.0) THEN
          KD = J*(J+1)/2
          A(KD) = A(KD)*ALF
          K = K - 1
      ELSE
          J = -J
          KD = J*(J+1)/2
          A(KD) = A(KD)*ALF
          I = -IA(K-1)
          KD = I*(I+1)/2
          A(KD) = A(KD)*ALF
          KD = (J-1)*J/2+I
          A(KD) = A(KD)*ALF
          K = K - 2
      ENDIF
      GOTO 10
      END
