* SUBROUTINE UXDRRM                ALL SYSTEMS               16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  TRANSFORMATION OF SOLUTION OBTAINED FROM THE TOTAL QR DECOMPOSITION.
*
* PARAMETERS :
*  II  N  NUMBER OF COLUMNS OF THE MATRIX A.
*  II  M  NUMBER OF ROWS OF THE MATRIX A.
*  RU  A(M*N)  RECTANGULAR MATRIX STORED ROWWISE IN THE
*         ONE-DIMENSIONAL ARRAY.
*  IO  IA(N)  A PERMUTATION FIELD WHICH CONTAINS AN INFORMATION ABOUT
*         PERMUTATION MATRIX.
*  RU  B(M)  TRANSFORMED RIGHT HAND SIDE.
*  RU  X(N)  SOLUTION VECTOR.
*  II  NP  PSAUDORANK OF THE MATRIX A.
*  II  JOB  INDICATOR. IF JOB=0 OR JOB=1 THEN FULL QR FACTORIZATION
*         WAS NOT OR WAS USED RESPECTIVELY.
*
      SUBROUTINE UXDRRM(N,M,A,IA,X,B,NP,JOB)
      INTEGER N,M,IA(N),NP,JOB
      REAL*8 A(M*N),B(M),X(N)
      REAL*8 ZERO
      PARAMETER (ZERO=0.0D 0)
      INTEGER J,K,L,JP,KP
      DO 1 K=1,M
      B(K)=ZERO
    1 CONTINUE
      IF (JOB.LE.0) THEN
      L=0
      DO 3 K=1,NP
      DO 2 J=K,NP
      JP=IA(J)
      B(K)=B(K)+A(L+JP)*X(JP)
    2 CONTINUE
      L=L+N
    3 CONTINUE
      ELSE
      DO 5 K=1,NP
      KP=IA(K)
      L=0
      DO 4 J=1,NP
      B(KP)=B(KP)+A(L+KP)*X(J)
      L=L+N
    4 CONTINUE
    5 CONTINUE
      ENDIF
      RETURN
      END
