* SUBROUTINE UXDRUB                ALL SYSTEMS               16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  TRANSFORMATION OF SOLUTION OBTAINED FROM THE TOTAL QR DECOMPOSITION.
*
* PARAMETERS :
*  II  N  NUMBER OF COLUMNS OF THE MATRIX A.
*  II  M  NUMBER OF ROWS OF THE MATRIX A.
*  RU  A(M*N)  RECTANGULAR MATRIX STORED ROWWISE IN THE
*         ONE-DIMENSIONAL ARRAY.
*  IO  IA(N)  A PERMUTATION FIELD WHICH CONTAINS AN INFORMATION ABOUT
*         PERMUTATION MATRIX.
*  RU  B(M)  TRANSFORMED RIGHT HAND SIDE.
*  RU  X(N)  SOLUTION VECTOR.
*  II  NP  PSAUDORANK OF THE MATRIX A.
*
      SUBROUTINE UXDRUB(N,M,A,IA,B,X,NP,JOB)
      INTEGER N,M,IA(N),NP,JOB
      REAL*8 A(M*N),B(N),X(N)
      REAL*8 TEMP
      REAL*8 ZERO
      PARAMETER (ZERO=0.0D 0)
      INTEGER I,J,K,L,JP,KP
      IF (JOB.GE.0) THEN
      CALL UXVSET(N-NP,ZERO,X(NP+1))
      L=0
      DO 2 K=1,NP
      KP=IA(K)
      TEMP=B(KP)
      I=0
      DO 1 J=1,K-1
      TEMP=TEMP-A(KP+I)*X(J)
      I=I+N
    1 CONTINUE
      X(K)=TEMP/A(KP+L)
      L=L+N
    2 CONTINUE
      ENDIF
      IF (JOB.LE.ZERO) THEN
      DO 3 K=NP+1,N
      KP=IA(K)
      X(KP)=ZERO
    3 CONTINUE
      L=NP*N
      DO 5 K=NP,1,-1
      L=L-N
      KP=IA(K)
      TEMP=B(K)
      DO 4 J=K+1,NP
      JP=IA(J)
      TEMP=TEMP-A(L+JP)*X(JP)
    4 CONTINUE
      X(KP)=TEMP/A(L+KP)
    5 CONTINUE
      ENDIF
      RETURN
      END
