* SUBROUTINE UXDSGM                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF A GIVEN VECTOR X BY A DENSE SYMMETRIC
* POSITIVE DEFINITE MATRIX A+E USING THE FACTORIZATION
* A+E=P*L*D*TRANS(L)*TRANS(P) OBTAINED BY THE SUBROUTINE UXDSGF.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  RI  A(N*(N+1)/2) FACTORIZATION A+E=P*L*D*TRANS(L)*TRANS(P) OBTAINED
*         BY THE SUBROUTINE UXDSGF.
*  II  IA(N)  A PERMUTATION FIELD WHICH CONTAINS AN INFORMATION ABOUT
*         PERMUTATION MATRIX P.
*  RU  X(N)  ON INPUT THE GIVEN VECTOR. ON OUTPUT THE RESULT OF
*         MULTIPLICATION.
*  II  JOB  OPTION. IF JOB=0 THEN X:=(A+E)*X. IF JOB>0 THEN
*         X:=TRANS(L)*TRANS(P)*X. IF JOB<0 THEN X:=P*L*X.
*
      SUBROUTINE UXDSGM( N, A, IA, X, JOB)
      INTEGER N, IA(N), JOB
      REAL*8  A(N*(N+1)/2), X(N)
      INTEGER  I, J, IP, JP, II, IJ, IND
      IND(I,J)=MAX(I,J)*(MAX(I,J)-1)/2+MIN(I,J)
      IF (JOB .GE. 0)  THEN
C
C     PHASE 1 : X:=TRANS(L)*X
C
      DO 3  I = 1, N
      IP=IA(I)
      DO 2  J = I+1, N
      JP=IA(J)
      IJ=IND(IP,JP)
      X(IP) = X(IP) + A(IJ) * X(JP)
    2 CONTINUE
    3 CONTINUE
      ENDIF
      IF (JOB .EQ. 0)  THEN
C
C     PHASE 2 : X:=D*X
C
      DO 4  I = 1, N
      IP=IA(I)
      II=IND(IP,IP)
      X(IP) = X(IP) * A(II)
    4 CONTINUE
      ENDIF
      IF (JOB .LE. 0)  THEN
C
C     PHASE 3 : X:=L*X
C
      DO 6  I = N, 1, -1
      IP=IA(I)
      DO 5  J = I-1, 1, -1
      JP=IA(J)
      IJ=IND(IP,JP)
      X(IP) = X(IP) + A(IJ) * X(JP)
    5 CONTINUE
    6 CONTINUE
      ENDIF
      RETURN
      END
