* SUBROUTINE UXDSMG                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GERSHGORIN BOUNDS FOR EIGENVALUES OF A DENSE SYMMETRIC MATRIX.
*  AMIN .LE. ANY EIGENVALUE OF A .LE. AMAX.
*
* PARAMETERS :
*  II  N  DIMENSION OF THE MATRIX A.
*  RI  A(N*(N+1)/2)  DENSE SYMMETRIC MATRIX STORED IN THE PACKED FORM.
*  RO  AMIN  LOWER BOUND FOR EIGENVALUES OF A.
*  RO  AMAX  UPPER BOUND FOR EIGENVALUES OF A.
*
      SUBROUTINE UXDSMG(N,A,AMIN,AMAX)
      INTEGER  N
      REAL*8  A(N*(N+1)/2),AMIN,AMAX
      REAL*8 TEMP
      INTEGER I,J,K,L
      REAL*8 ZERO
      PARAMETER (ZERO=0.0D 0)
      AMAX=A(1)
      AMIN=A(1)
      K=0
      DO 3 I=1,N
      TEMP=ZERO
      L=K
      DO 1 J=1,I-1
      L=L+1
      TEMP=TEMP+ABS(A(L))
    1 CONTINUE
      L=L+1
      DO 2 J=I+1,N
      L=L+J-1
      TEMP=TEMP+ABS(A(L))
    2 CONTINUE
      K=K+I
      AMAX=MAX(AMAX,A(K)+TEMP)
      AMIN=MIN(AMIN,A(K)-TEMP)
    3 CONTINUE
      RETURN
      END
