* FUNCTION UXDSMQ                  ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* VALUE OF A QUADRATIC FORM WITH A DENSE SYMMETRIC MATRIX A.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  RI  A(N*(N+1)/2)  DENSE SYMMETRIC MATRIX STORED IN THE PACKED FORM.
*  RI  X(N)  GIVEN VECTOR.
*  RI  Y(N)  GIVEN VECTOR.
*  RR  UXDSMQ  VALUE OF THE QUADRATIC FORM UXDSMQ=TRANS(X)*A*Y.
*
      FUNCTION UXDSMQ(N,A,X,Y)
      INTEGER N
      REAL*8  A(N*(N+1)/2), X(N), Y(N), UXDSMQ
      REAL*8  TEMP, TEMP1, TEMP2
      INTEGER  I,J,K
      REAL*8 ZERO
      PARAMETER  (ZERO = 0.0D 0)
      TEMP = ZERO
      K=0
      DO  3  I = 1, N
      TEMP1 = ZERO
      TEMP2 = ZERO
      DO  1  J = 1, I-1
      K=K+1
      TEMP1 = TEMP1 + A(K) * X(J)
      TEMP2 = TEMP2 + A(K) * Y(J)
    1 CONTINUE
      K=K+1
      TEMP=TEMP+X(I)*(TEMP2+A(K)*Y(I))+Y(I)*TEMP1
    3 CONTINUE
      UXDSMQ = TEMP
      RETURN
      END
