* SUBROUTINE UXDSTV                ALL SYSTEMS                06/12/01
C PORTABILITY : ALL SYSTEMS
C 06/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SIMILARITY TRANSFORMATION OF A SYMMETRIC MATRIX TO THE TRIDIAGONAL
* FORM.
*
* PARAMETERS :
*  II  N  ORDER OF THE SYMMETRIC MATRIX A AND THE TRIDIAGONAL MATRIX T.
*  RI  A(N*(N+1)/2)  ELEMENTS OF THE SYMMETRIC MATRIX A.
*  RO  D(N)  DIAGONAL ELEMENTS OF THE TRIDIAGONAL MATRIX T.
*  RO  E(N)  SUBDIAGONAL ELEMENTS OF THE TRIDIAGONAL MATRIX T.
*
      SUBROUTINE UXDSTV(N,A,D,E)
      INTEGER N
      REAL*8 A(N*(N+1)/2),D(N),E(N)
      INTEGER I,IZ,J,JK,K,L
      REAL*8 F,G,H,HH,SCALE
      DO 300 I=N,1,-1
      L=I-1
      IZ=(I*L)/2
      H=0.0D0
      SCALE=0.0D0
      DO 120 K=1,L
      IZ=IZ+1
      D(K)=A(IZ)
      SCALE=SCALE+ABS(D(K))
  120 CONTINUE
      IF (SCALE.LE.0.0D 0) THEN
      E(I)=0.0D0
      GO TO 290
      ENDIF
      DO 150 K=1,L
      D(K)=D(K)/SCALE
      H=H+D(K)*D(K)
  150 CONTINUE
      F=D(L)
      G=-SIGN(SQRT(H),F)
      E(I)=SCALE*G
      H=H-F*G
      D(L)=F-G
      A(IZ)=SCALE*D(L)
      IF (L.LE.1) GO TO 290
      F=0.0D0
      DO 240 J=1,L
      G=0.0D0
      JK=(J*(J-1))/2
      DO 180 K=1,L
      JK=JK+1
      IF (K.GT.J) JK=JK+K-2
      G=G+A(JK)*D(K)
  180 CONTINUE
      E(J)=G/H
      F=F+E(J)*D(J)
  240 CONTINUE
      HH=F/(H+H)
      JK=0
      DO 260 J=1,L
      F=D(J)
      G=E(J)-HH*F
      E(J)=G
      DO 260 K=1,J
      JK=JK+1
      A(JK)=A(JK)-F*E(K)-G*D(K)
  260 CONTINUE
  290 D(I)=A(IZ+1)
      A(IZ+1)=SCALE*SQRT(H)
  300 CONTINUE
      RETURN
      END
