* SUBROUTINE UXECHM               ALL SYSTEMS                16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* VECTOR B IS PREMULTIPLIED BY THE ORTHOGONAL MATRIX TRANS(Q) AFTER QR
* DECOMPOSITION.
*
* PARAMETERS :
*  II  N  NUMBER OF COLUMNS OF THE MATRIX A.
*  II  M  NUMBER OF ROWS OF THE MATRIX A.
*  RI  A(M,N)  RECTANGULAR MATRIX STORED IN THE TWO-DIMENSIONAL ARRAY.
*  RU  B(M)  ON INPUT THE RIGHT HAND SIDE. ON OUTPUT THE TRANSFORMED
*         RIGHT HAND SIDE.
*  RO  D(N)  VECTOR CONTAINING INFORMATION ABOUT HOUSEHOLDER
*         TRANSFORMATIONS.
*  II  NM  NUMBER OF ELEMENTARY HOUSEHOLDER REFLECTORS.
*
      SUBROUTINE UXECHM(M,N,A,B,D,NM)
      INTEGER M,N,NM
      REAL*8 A(M,N),B(M),D(N)
      REAL*8 ONE
      PARAMETER (ONE=1.0D 0)
      INTEGER I
      REAL*8 AII,TEMP,UXVDOT
      DO 10 I=NM,1,-1
*
*     H(I) IS APPLIED TO B
*
        AII=A(I,I)
        A(I,I)=ONE
        TEMP=UXVDOT(M-I+1,A(I,I),B(I))
        CALL UXVDIR(M-I+1,-D(I)*TEMP,A(I,I),B(I),B(I))
        A(I,I)=AII
   10 CONTINUE
      RETURN
      END
