* SUBROUTINE UXEGGM                ALL SYSTEMS                16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF A GIVEN VECTOR X BY A DENSE GENERAL MATRIX A USING
* THE FACTORIZATION A*P=L*U OBTAINED BY THE SUBROUTINE UXEGGF.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  II  ND  DECLARED ORDER OF THE MATRIX A.
*  RI  A(ND,N)  A FACTORIZATION A=P*L*U OF A DENSE GENERAL MATRIX A
*         OBTAINED BY THE SUBROUTINE UXEGGF.
*  RU  X(N)  ON INPUT THE VECTOR APPERING IN THE PRODUCT. ON OUTPUT
*         THE RESULT OF THE PRODUCT.
*  II  IP(N)  A PERMUTATION FIELD WHICH CONTAINS AN INFORMATION ABOUT
*         THE PERMUTATION MATRIX P.
*  JOB  OPTION. JOB=0 - MULTIPLICATION BY THE ORIGINAL MATRIX.
*         JOB=1 - MULTIPLICATION BY THE MATRIX TRSANSPOSE.
*
* METHOD :
* C.B.MOLER, ALGORITHM 423, LINEAR EQUATION SOLVER, C.A.C.M. 15 (1972),
* P. 274.
*
      SUBROUTINE UXEGGM(N,ND,A,IP,X,JOB)
      INTEGER N,ND,IP(N),JOB,K,I
      REAL*8 A(ND,N),X(N),T,ZERO
      PARAMETER (ZERO=0.0D 0)
      IF (JOB .LE. 0) THEN
      DO 20 K = 1,N
      T = X(K)
      IF (T .NE. ZERO) THEN
      DO 10 I = 1,K-1
      X(I) = X(I) + A(I,K)*T
 10   CONTINUE
      X(K) = T*A(K,K)
      ENDIF
 20   CONTINUE
      DO 40 K = N,1,-1
      T = X(K)
      IF (T .NE. ZERO) THEN
      DO 30 I = N,K+1,-1
      X(I) = X(I) + A(I,K)*T
 30   CONTINUE
      ENDIF
 40   CONTINUE
      CALL UXVPER(N,IP,X,-1)
      ELSE
      CALL UXVPER(N,IP,X,1)
      DO 60 K = 1,N
      T = X(K)
      DO 50 I = K+1,N
      T = T + A(I,K)*X(I)
 50   CONTINUE
      X(K) = T
 60   CONTINUE
      DO 80 K = N,1,-1
      T = X(K)*A(K,K)
      DO 70 I = K-1,1,-1
      T = T + A(I,K)*X(I)
 70   CONTINUE
      X(K) = T
 80   CONTINUE
      ENDIF
      RETURN
      END
