* SUBROUTINE UXLIIM                ALL SYSTEMS                96/12/01
C PORTABILITY : ALL SYSTEMS
C 96/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* LIMITED STORAGE INVERSE COLUMN UPDATE METHODS.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  M  NUMBER OF QUASI-NEWTON STEPS.
*  RI  D(N) DIAGONAL OF A DECOMPOSED TRIDIAGONAL MATRIX.
*  RI  DL(N) SUBDIAGONAL OF A DECOMPOSED TRIDIAGONAL MATRIX.
*  RI  DU(N) SUPERDIAGONAL OF A DECOMPOSED TRIDIAGONAL MATRIX.
*  RI  DU2(N) SECOND SUPERDIAGONAL OF A DECOMPOSED TRIDIAGONAL MATRIX.
*  II  ID(N)  PERMUTATION VECTOR.
*  RI  XM(N*M)  SET OF VECTORS FOR INVERSE COLUMN UPDATE.
*  RI  GM(M)  AUXILIARY VECTOR.
*  II  IM(M)  VECTOR OF INDICES.
*  RI  U(N)  INPUT VECTOR.
*  RO  V(N)  OUTPUT VECTOR.
*
* SUBPROGRAMS USED :
*  S   UXTGGB  BACK SUBSTITUTION FOR A DECOMPOSED TRIDIAGONAL MATRIX.
*  S   UXVCOP  COPYING OF A VECTOR.
*  S   UXVDIR  VECTOR AUGMENTED BY THE SCALED VECTOR.
*
* METHOD :
* LIMITED STORAGE INVERSE COLUMN UPDATE METHODS.
*
      SUBROUTINE UXLIIM(N,MA,M,A,IA,JA,IP,ID,XM,GM,IM,U,V,S)
      INTEGER N,MA,M,IA(N+1),JA(MA),IP(N),ID(N),IM(M)
      REAL*8 A(MA),XM(N*M),GM(M),U(N),V(N),S(N)
      INTEGER I,L
      CALL UXVCOP(N,U,V)
      CALL UXSGIB(N,MA,A,IA,JA,IP,ID,V,S,0)
      L=1
      DO 1 I=1,M
      CALL UXVDIR(N,U(IM(I))/GM(I),XM(L),V,V)
      L=L+N
    1 CONTINUE
      RETURN
      END
