* SUBROUTINE UXSCME               ALL SYSTEMS                96/12/01
C PORTABILITY : ALL SYSTEMS
C 96/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF A DENSE RECTANGULAR MATRIX A BY A VECTOR WHOSE
*         ELEMENTS ARE UNITS.
*
* PARAMETERS :
*  II  N  NUMBER OF ROWS OF THE MATRIX A.
*  II  NA NUMBER OF COLUMNS OF THE MATRIX A.
*  II  MA  NUMBER OF ELEMENTS IN THE FIELD A.
*  RI  A(MA)  RECTANGULAR MATRIX STORED AS A TWO-DIMENSIONAL ARRAY.
*  II  IA(NA+1)  POSITION OF THE FIRST RORWS ELEMENTS IN THE FIELD A.
*  II  JA(MA) COLUMN INDICES OF ELEMENTS IN THE FIELD A.
*  RO  Y(N)  OUTPUT VECTOR EQUAL TO A*E.
*
* SUBPROGRAMS USED :
*  S   UXVDIR  VECTOR AUGMENTED BY THE SCALED VECTOR.
*  S   UXVSET  INITIATION OF A VECTOR.
*
      SUBROUTINE UXSCME(N,NA,MA,A,IA,JA,Y)
      INTEGER N,NA,MA,IA(NA+1),JA(MA)
      REAL*8 A(MA),Y(N)
      INTEGER I,J,K,L,JP
      REAL*8 ZERO
      PARAMETER (ZERO=0.0D 0)
      CALL UXVSET(N,ZERO,Y)
      DO 2 I=1,NA
      K=IA(I)
      L=IA(I+1)-K
      DO 1 J=1,L
      JP=JA(K)
      IF (JP.GT.0) Y(JP)=Y(JP)+A(K)
      K=K+1
    1 CONTINUE
    2 CONTINUE
      RETURN
      END
