* SUBROUTINE UXSIBC                 ALL SYSTEMS                95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* THIS SUBROUTINE CORRECTS THE FACTORISATION OF THE MATRIX IN A,IW TO
* PRESERVE A NONSINGULARITY.
*
* PARAMETERS :
*  RI  A(LA)  HOLD INFORMATION ON THE FACTORS AND MUST BE UNCHANGED
*         SINCE THE CALL TO UXSIBF. THEY ARE NOT ALTERED BY UXSIBC.
*  II  LA  MUST BE SET TO THE LENGTHS OF A. IT IS NOT ALTERED.
*  II  IW(MW)  HOLD INFORMATION ON THE FACTORS AND MUST BE UNCHANGED
*         SINCE THE CALL TO UXSIBF. THEY ARE NOT ALTERED BY UXSIBC.
*  II  MW  MUST BE SET TO THE LENGTHS OF IW. IT IS NOT ALTERED.
*
      SUBROUTINE UXSIBC(A, LA, IW, MW, PAR, INF)
      INTEGER LA, MW, IW(MW), INF
      DOUBLE PRECISION A(LA), PAR
      INTEGER J, K, IBLK, IPOS, APOS, ALEN, NBLK, NROWS, NCOLS
      DOUBLE PRECISION ALFA, BETA, GAMA, ZERO
      LOGICAL SINGLE
      PARAMETER (ZERO = 0.0D 0)
      INF = 0
      NBLK = ABS(IW(1))
      IPOS = 2
      APOS = 1
      DO 100 IBLK=1,NBLK
      NCOLS = IW(IPOS)
      IF (NCOLS.LT.0) THEN
      NROWS = 1
      NCOLS = -NCOLS
      ELSE
      IPOS = IPOS + 1
      NROWS = IW(IPOS)
      ENDIF
C
C     PROCEEDS THE DIAGONALS IN THIS BLOCK
C
      ALEN = NCOLS
      SINGLE = .TRUE.
      DO 50 K=IPOS+1,IPOS+NROWS
      IF (SINGLE) THEN
      ALFA = A(APOS)
      J = IW(K)
      SINGLE = J.GT.0
      IF (SINGLE) THEN
      IF (ABS(ALFA).LE.PAR) THEN
C
C     1x1 BLOCK
C
      INF = MAX(INF,1)
      ALFA = PAR
      A(APOS) = ALFA
      ENDIF
      ELSE
      BETA = A(APOS+1)
      GAMA = A(APOS+ALEN)
      IF (ABS(ALFA*GAMA-BETA**2).LE.PAR**2) THEN
C
C     2x2 BLOCK
C
      INF = MAX(INF,2)
      ALFA = MAX(ABS(ALFA),PAR)
      BETA = ZERO
      GAMA = MAX(ABS(GAMA),PAR)
      A(APOS) = ALFA
      A(APOS+1) = BETA
      A(APOS+ALEN) = GAMA
      ENDIF
      ENDIF
      ELSE
      SINGLE=.TRUE.
      ENDIF
      APOS = APOS + ALEN
      ALEN = ALEN - 1
   50 CONTINUE
      IPOS = IPOS + NCOLS + 1
  100 CONTINUE
      RETURN
      END
