* SUBROUTINE UXSPCH                 ALL SYSTEMS                14/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* REWRITE PERMUTED FACTORIZED COMPACT SCHEME INTO SYMMETRIC MATRIX.
*
* PARAMETERS:
*  II  N  SIZE OF THE SYSTEM SOLVED.
*  IU  MM NUMBER OF NONZEROS IN THE UPPER TRIANGLE OF THE ORIGINAL
*         MATRIX.
*  II  MMAX DECLARED LENGTH OF THE ARRAYS JA.
*  IU  IA(N+1) POINTERS OF THE DIAGONAL ELEMENTS OF THE HESSIAN MATRIX.
*  IU  JA(MMAX)  INDICES OF THE NONZERO ELEMENTS OF THE HESSIAN MATRIX IN
*         THE PACKED ROW FORM AT THE FIRST IA(N+1)-1 POSITIONS. COMPACT
*         STRUCTURE OF INDICES OF ITS TRIANGULAR FACTOR IS ROWWISE
*         STORED.
*  II  PSL(N+1)  POINTER VECTOR OF THE COMPACT FORM OF THE TRIANGULAR
*             FACTOR OF THE HESSIAN APPROXIMATION.
*
      SUBROUTINE UXSPCH(N,MM,MMAX,IA,JA,PSL,ITERM)
      INTEGER N,MM,MMAX,IA(N+1),JA(MMAX),PSL(N+1),ITERM
      INTEGER I,J,K,JSTRT,JSTOP,IND,LENGTH,MN,ML
      MM=IA(N+1)-1
      ML=JA(MM+N+1)+N
      DO 1 I=1,N+1
        IA(I)=PSL(I)+I-1
    1 CONTINUE
      MN=IA(N+1)-1
      K=MN-MM
      IF (MN+ML.GT.MMAX) THEN
        ITERM=-43
        CALL UOERR1('UXSPCH',43)
        RETURN
      END IF
      IF (K.LE.0) GO TO 3
      DO 2 I=MM+ML,MM+1,-1
      JA(I+K)=JA(I)
    2 CONTINUE
      MM=MN
    3 IND=0
      DO 5 I=1,N
      IND=IND+1
      JA(IND)=I
        LENGTH=PSL(I+1)-PSL(I)
        JSTRT=JA(MM+I)+N+1
        JSTOP=JSTRT+LENGTH-1
        DO 4 J=JSTRT,JSTOP
          K=JA(MM+J)
          IND=IND+1
          JA(IND)=K
    4   CONTINUE
    5 CONTINUE
      RETURN
      END
