* FUNCTION UXSPCP                  ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE NUMBER UXSPCP=TRANS(X)*D**(-1)*X WHERE D IS A
* DIAGONAL MATRIX IN THE FACTORIZATION A+E=L*D*TRANS(L) OBTAINED BY THE
* SUBROUTINE UXSPGN. THE FACTORS ARE STORED IN THE COMPACT FORM.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  II  MMAX  LENGTH OF THE PRINCIPAL MATRIX VECTORS (SL,A).
*  RI  A(MMAX)      FACTORIZATION A+E=L*D*TRANS(L) OBTAINED BY THE
*         SUBROUTINE UXSPGN.IT CONTAINS THE NUMERICAL VALUES OF THE
*         FACTORS STORED IN THE COMPACT FORM ACCORDING TO THE
*         INFORMATION IN THE VECTORS PSL,SL.
*  II  PSL(N+1)  POINTER VECTOR OF THE FACTORIZED MATRIX A.
*  RI  X(N)  INPUT VECTOR
*  RR  UXSPCP  COMPUTED NUMBER UXSPCP=TRANS(X)*D**(-1)*X
*
      FUNCTION UXSPCP(N,MMAX,A,PSL,X)
      INTEGER  N,MMAX
      REAL*8  A(MMAX), X(N), UXSPCP
      REAL*8  TEMP
      INTEGER  PSL(N+1),I
      REAL*8 ZERO
      PARAMETER (ZERO = 0.0D0)
      TEMP = ZERO
      DO  100 I=1,N
      TEMP = TEMP + X(I)*X(I)/A(PSL(I)+I-1)
100   CONTINUE
      UXSPCP = TEMP
      RETURN
      END
