* SUBROUTINE UXSPTZ                ALL SYSTEMS                03/12/01
C PORTABILITY : ALL SYSTEMS
C 03/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SOLUTION OF A SYSTEM OF LINEAR EQUATIONS WITH A SPARSE SYMMETRIC
* POSITIVE DEFINITE MATRIX A+E USING THE FACTORIZATION A+E=L*D*TRANS(L)
* STORED IN THE COMPACT SCHEME. THIS FACTORIZATION CAN BE OBTAINED
* USING THE SUBROUTINE UXSSFN.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  II  M NUMBER OF NONZERO ELEMENTS OF THE MATRIX A.
*  II  ND  NUMBER OF DENSE ROWS.
*  RI  A(M) INCOMPLETE FACTORIZATION A+E=L*D*TRANS(L) OBTAINED BY THE
*         SUBROUTINE UXSPTF.
*  II  IA(N+1)  POINTERS OF THE DIAGONAL ELEMENTS OF A.
*  II  JA(M)  INDICES OF THE NONZERO ELEMENTS OF A.
*  RI  U(N*ND)  DENSE ROWS.
*  RA  D(ND)  AUXILIARY ARRAY.
*  RO  B(ND*(ND+1)/2))  DECOMPOSITION OF THE UPDATED MATRIX.
*  RA  Y(N)  VECTOR MULTIPLIED BY THE INVERSE OF THE UPDATED MATRIX.
*  RA  Z(N)  AUXILIARY ARRAY.
*
* METHOD :
* BACK SUBSTITUTION
*
      SUBROUTINE UXSPTZ(N,M,ND,A,IA,JA,U,D,B,Y,Z)
      INTEGER N,M,ND
      REAL*8 A(M),U(N*ND),D(ND),B(ND*(ND+1)/2),Y(N),Z(N)
      INTEGER IA(N+1),JA(M)
      INTEGER I
      REAL*8 UXVDOT,ZERO
      PARAMETER (ZERO=0.0D 0)
      CALL UXVCOP(N,Y,Z)
      CALL UXSPTB(N,M,A,IA,JA,Y,0)
      IF (ND.LE.0) RETURN
      DO 1 I=1,ND
      D(I)=UXVDOT(N,U((I-1)*N+1),Y)
    1 CONTINUE
      CALL UXDPGB(ND,B,D,0)
      CALL UXVCOP(N,Z,Y)
      DO 2 I=1,ND
      CALL UXVDIR(N,-D(I),U((I-1)*N+1),Y,Y)
    2 CONTINUE
      CALL UXSPTB(N,M,A,IA,JA,Y,0)
      RETURN
      END
