* SUBROUTINE UXSRB3              ALL SYSTEMS               94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* REACHSET OF THE NODE IS COMPUTED LABELED WITH MARKER = 1 FOR THESE
* NODES. AS THE BY-PRODUCT ITS NEIGHBORHOOD IS COMPUTED.
*
*  PARAMETERS :
*  II  M NUMBER OF ROWS OF THE MATRIX.
*  II  NN NUMBER OF COLUMNS OF THE MATRIX.
*  II  NADJ MAXIMUM NUMBER OF NONZEROS IN ADJNCY.
*  II  ROOT  THE GIVEN NODE NOT IN THE SUBSET.
*  II  BJA1(NN) BEGINNINGS OF THE BLOCK COLUMNS IN A.
*  II  BJA2(NN) ENDING INDICES OF THE BLOCK COLUMNS IN A.
*  II  XADJ(NN+1) POINTER VECTOR TO THE SPARSE ADJACENCY MATRIX.
*  II  ADJNCY(NADJ)  INDICES OF THE SYMMETRIC ADJACENCY MATRIX.
*  II  DEG(NN) THE DEGREE VECTOR.  DEG(I) LT 0 MEANS THE NODE
*              BELONGS TO THE FINAL SUBSET.
*  IO  RCHSZE SIZE OF THE REACHABLE SET.
*  IO  RCHSET(NN) INDICES OF THE NODES IN REACHABLE SET.
*  IU  MARKER(NN) THE MARKER VECTOR FOR REACH AND NBRHD SETS.
*           INPUT:
*               =1 FOR THE NODES OF THE REACHSET OF THE NODE UNDER
*                  ELIMINATION.
*               =-1,0 OTHERWISE.
*  IO  NHDSZE SIZE OF THE NEIGHORHOOD.
*  IO  NBRHD(NN) VERTICES OF THE NEIGHBORHOOD.
*  II  MASK1(M) MASK FOR THE PARTS OF THE MATRIX NOT ACTIVE.
*
      SUBROUTINE UXSRB3(M,NN,NADJ,ROOT,BJA1,BJA2,XADJ,ADJNCY,DEG,MARKER,
     *                  RCHSZE,RCHSET,NHDSZE,NBRHD,MASK1)
C
      INTEGER M,NN,NADJ,ROOT
      INTEGER ADJNCY(NADJ),DEG(NN),MARKER(NN),BJA1(NN),BJA2(NN)
      INTEGER RCHSET(NN),NBRHD(NN)
      INTEGER XADJ(NN+1),I,ISTRT,ISTOP,J,JSTRT,JSTOP
      INTEGER NABOR,NHDSZE,NODE,RCHSZE
      INTEGER MASK1(M)
      INTEGER ISHIFT
      LOGICAL LDISJ
C
      NHDSZE = 0
      RCHSZE = 0
      ISTRT = XADJ(ROOT)
      ISTOP = XADJ(ROOT+1) - 1
      IF ( ISTOP .LT. ISTRT )  RETURN
      DO 600 I = ISTRT, ISTOP
        NABOR =  ADJNCY(I)
        IF ( NABOR .EQ. 0 ) RETURN
        IF ( MARKER(NABOR) .NE. 0 )  GO TO 600
        IF ( DEG(NABOR) .LT. 0 )     GO TO 200
        RCHSZE = RCHSZE + 1
        RCHSET(RCHSZE) = NABOR
        MARKER(NABOR) = 1
        GO TO 600
  200   MARKER(NABOR) = -1
        NHDSZE = NHDSZE +  1
        NBRHD(NHDSZE) = NABOR
  300   JSTRT = XADJ(NABOR)
        JSTOP = XADJ(NABOR+1) - 1
        DO 500 J = JSTRT, JSTOP
          NODE = ADJNCY(J)
          NABOR = - NODE
          IF (NODE.LT.0) GO TO 300
          IF (NODE.EQ.0) GO TO 600
          IF ( MARKER(NODE) .NE. 0 )  GO TO 500
          RCHSZE = RCHSZE + 1
          RCHSET(RCHSZE) = NODE
          MARKER(NODE) = 1
  500   CONTINUE
  600 CONTINUE
C
C TEST INTERSECTION
C
      ISHIFT=0
      DO 700 I=1,RCHSZE
        J=RCHSET(I)
        CALL UXSRB6(NN,M,ROOT,J,BJA1,BJA2,MASK1,LDISJ)
C
C IF INTERSECTION IS ZERO - SIGNALLED BY LDISJ - THEN
C J IS EXCLUDED FROM REACHABLE SET
C
        IF(LDISJ) THEN
          ISHIFT=ISHIFT+1
          MARKER(J)=0
        ELSE
          RCHSET(I-ISHIFT)=J
        ENDIF
 700  CONTINUE
      RCHSZE=RCHSZE-ISHIFT
      RETURN
      END
