* SUBROUTINE UXSRBO                ALL SYSTEMS               91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* FORMING OF THE SPARSE STRUCTURE OF TRANS(A)*A WHERE A IS THE COLUMN
* BLOCK MATRIX.
*
*  PARAMETERS :
*  II  NN  NUMBER OF BLOCK COLUMNS OF A.
*  II  M  NUMBER OF ROWS OF A.
*  II  NADJ LENGTH OF THE ARRAY FOR NONZEROS OF TRANS(A)*A.
*  II  NONZ NUMBER OF NONZEROS IN TRANS(A)*A.
*  II  BJA1(NN) BEGINNINGS OF THE BLOCK COLUMNS IN A.
*  II  BJA2(NN) ENDING INDICES OF THE BLOCK COLUMNS IN A.
*  IO  XADJ(NN+1) POINTERS TO THE BEGINNINGS OF THE ROWS(COLUMNS) IN
*        THE SPARSE STRUCTURE OF THE PRODUCT.
*  IO  ADJNCY(NADJ) ROW(COLUMN) INDICES OF THE SPARSE STRUCTURE OF
*        THE PRODUCT.
*  IA  WN01(NN) AUXILIARY VECTOR.
*
      SUBROUTINE UXSRBO(NN,NADJ,NONZ,BJA1,BJA2,XADJ,ADJNCY,WN01)
C
      INTEGER NN,NADJ,BJA1(NN),BJA2(NN),XADJ(NN+1),ADJNCY(NADJ)
      INTEGER NONZ,WN01(NN)
      INTEGER I,II,IB,IE,J,KK,L,JJ
C
C  INITIATE WN01
C
      DO 50 I=1,NN
        WN01(I)=0
 50   CONTINUE
C
C SET INITIAL INDEX IN ADJNCY
C
      II=1
C
C  MAIN CYCLE FOR THE UPPER TRIANGLE
C
      DO 1000 I=1,NN
        XADJ(I)=II
C
C  SET MARKERS
C
        II=II+WN01(I)
C
C SET BOUNDS
C
        IB=BJA1(I)
        IE=BJA2(I)
C
C CYCLE OF THE COLUMNS
C
        DO 100 J=I+1,NN
          IF(.NOT.(IE.LT.BJA1(J).OR.IB.GT.BJA2(J))) THEN
            ADJNCY(II)=J
            WN01(J)=WN01(J)+1
            II=II+1
          END IF
 100    CONTINUE
C
C SET MARKER FOR THE BEGINNINGS OF THE UPPER TRIANGLE
C
      WN01(I)=XADJ(I)
 1000 CONTINUE
C
C SET POINTER BEHIND ADJNCY
C
      XADJ(NN+1)=II
C
C NUMBER OF NONZEROS
C
      NONZ=II-1
C
C LOWER TRIANGLE
C
      DO 2000 I=1,NN
        KK=XADJ(I+1)-1
        JJ=WN01(I)
        DO 200 J=JJ,KK
          L=ADJNCY(J)
          ADJNCY(WN01(L))=I
          WN01(L)=WN01(L)+1
 200    CONTINUE
 2000 CONTINUE
C
C END
C
      RETURN
      END
