* FUNCTION  UXSRBU                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* EUCLIDEAN NORM OF PART OF THE K-TH COLUMN OF A DENSE RECTANGULAR
* MATRIX IS COMPUTED.
*
* PARAMETERS :
*  II  N  NUMBER OF ROWS OF THE MATRIX A.
*  II  M  NUMBER OF COLUMNS OF THE MATRIX A.
*  RI  BF(M*N)  RECTANGULAR MATRIX STORED AS A ONE-DIMENSIONAL ARRAY.
*  II  I  INDEX OF THE ROW WHOSE NORM IS COMPUTED.
*  II  J  INDEX OF THE FIRST ELEMENT FROM WHICH THE NORM IS COMPUTED.
*
      FUNCTION UXSRBU(N,M,BF,I,J)
      INTEGER N,M,I,J
      REAL*8 BF(N*M),UXSRBU
      REAL*8 POM,DEN
      INTEGER K,L
      REAL*8 ZERO
      PARAMETER (ZERO=0.0D 0)
      DEN=ZERO
      L=(J-1)*M
      DO 100 K=J,N
      DEN=MAX(DEN,ABS(BF(L+I)))
      L=L+M
 100  CONTINUE
      POM=ZERO
      IF (DEN.GT.ZERO) THEN
      L=(J-1)*M
      DO 2 K=J,N
      POM=POM+(BF(L+I)/DEN)**2
      L=L+M
    2 CONTINUE
      ENDIF
      UXSRBU=DEN*SQRT(POM)
      RETURN
      END
