* SUBROUTINE UXSRMD               ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF TRANSPOSE OF A SPARSE RECTANGULAR MATRIX A BY
* A VECTOR X AND ADDITION OF A SCALED VECTOR ALF*Y.
*
* PARAMETERS :
*  II  N  NUMBER OF ROWS OF THE MATRIX A.
*  II  NA NUMBER OF COLUMNS OF THE MATRIX A.
*  II  MA  NUMBER OF ELEMENTS IN THE FIELD A.
*  RI  A(MA)  RECTANGULAR MATRIX STORED AS A TWO-DIMENSIONAL ARRAY.
*  II  IA(NA+1)  POSITION OF THE FIRST RORWS ELEMENTS IN THE FIELD A.
*  II  JA(MA) COLUMN INDICES OF ELEMENTS IN THE FIELD A.
*  RI  X(N)  INPUT VECTOR.
*  RI  ALF  SCALING FACTOR.
*  RI  Y(NA)  INPUT VECTOR.
*  RO  Z(NA)  OUTPUT VECTOR EQUAL TO TRANS(A)*X+ALF*Y.
*
      SUBROUTINE UXSRMD(N,NA,MA,A,IA,JA,X,ALF,Y,Z)
      INTEGER N,NA,MA,IA(NA+1),JA(MA)
      REAL*8 A(MA),X(N),ALF,Y(NA),Z(NA)
      REAL*8 TEMP
      INTEGER I,J,K,L,JP
      DO 2 I=1,NA
      K=IA(I)
      L=IA(I+1)-K
      TEMP=ALF*Y(I)
      DO 1 J=1,L
      JP=JA(K)
      IF (JP.GT.0) TEMP=TEMP+A(K)*X(JP)
      K=K+1
    1 CONTINUE
      Z(I)=TEMP
    2 CONTINUE
      RETURN
      END
