* SUBROUTINE UXSRMM               ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF TRANSPOSE OF A SPARSE RECTANGULAR MATRIX A BY
* A VECTOR X.
*
* PARAMETERS :
*  II  N  NUMBER OF ROWS OF THE MATRIX A.
*  II  NA NUMBER OF COLUMNS OF THE MATRIX A.
*  II  MA  NUMBER OF ELEMENTS IN THE FIELD A.
*  RI  A(MA)  RECTANGULAR MATRIX STORED AS A TWO-DIMENSIONAL ARRAY.
*  II  IA(NA+1)  POSITION OF THE FIRST RORWS ELEMENTS IN THE FIELD A.
*  II  JA(MA) COLUMN INDICES OF ELEMENTS IN THE FIELD A.
*  RI  X(N)  INPUT VECTOR.
*  RO  Y(NA)  OUTPUT VECTOR EQUAL TO TRANS(A)*X.
*
      SUBROUTINE UXSRMM(N,NA,MA,A,IA,JA,X,Y)
      INTEGER N,NA,MA,IA(NA+1),JA(MA)
      REAL*8 A(MA),X(N),Y(NA)
      REAL*8 TEMP
      INTEGER I,J,K,L,JP
      REAL*8 ZERO
      PARAMETER (ZERO=0.0D 0)
      DO 2 I=1,NA
      K=IA(I)
      L=IA(I+1)-K
      TEMP=ZERO
      DO 1 J=1,L
      JP=JA(K)
      IF (JP.GT.0) TEMP=TEMP+A(K)*X(JP)
      K=K+1
    1 CONTINUE
      Y(I)=TEMP
    2 CONTINUE
      RETURN
      END
