* SUBROUTINE UXSRMU               ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* CORRECTION OF A SPARSE RECTANGULAR MATRIX A. THE CORRECTION IS DEFINED
* AS A:=A+ALF*Y*TRANS(X) WHERE ALF IS A GIVEN SCALING FACTOR AND X,Y ARE
* GIVEN VECTORS.
*
* PARAMETERS :
*  II  N  NUMBER OF ROWS OF THE MATRIX A.
*  II  NA NUMBER OF COLUMNS OF THE MATRIX A.
*  II  MA  NUMBER OF ELEMENTS IN THE FIELD A.
*  RI  A(MA)  RECTANGULAR MATRIX STORED AS A TWO-DIMENSIONAL ARRAY.
*  II  IA(NA+1)  POSITION OF THE FIRST RORWS ELEMENTS IN THE FIELD A.
*  II  JA(MA) COLUMN INDICES OF ELEMENTS IN THE FIELD A.
*  RI  ALF  SCALING PARAMETER.
*  RI  X(M)  INPUT VECTOR.
*  RO  Y(N)  INPUT VECTOR.
*
      SUBROUTINE UXSRMU(N,NA,MA,A,IA,JA,ALF,X,Y)
      INTEGER N,NA,MA,IA(NA+1),JA(MA)
      REAL*8 A(MA),ALF,X(NA),Y(N)
      INTEGER I,J,K,L,JP
      DO 2 I=1,NA
      K=IA(I)
      L=IA(I+1)-K
      DO 1 J=1,L
      JP=JA(K)
      IF (JP.GT.0) A(K)=A(K)+ALF*X(I)*Y(JP)
      K=K+1
    1 CONTINUE
    2 CONTINUE
      RETURN
      END
