* SUBROUTINE UXSRO7                ALL SYSTEMS               91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 TU : ORIGINAL VERSION
*
* PURPOSE : FIND BEGINNING AND END OF THE PART TO BE MASKED.
*
*  PARAMETERS :
*  II  M NUMBER OF ROWS OF THE MATRIX.
*  II  P WINDTH OF THE ACTUAL BLOCK COLUMN.
*  IU  IBMASK  ON INPUT: BEGINNING OF THE SECTION.
*              ON OUTPUT: BEGINNING OF THE PART TO BE MASKED.
*  IU  IEMASK  ON INPUT:END OF THE SECTION.
*              ON OUTPUT: END OF THE PART TO BE MASKED.
*  II  MASK1(M) MASK VECTOR.
*  IO  LEN LENGTH OF THE MASKED PART.
*
      SUBROUTINE UXSRO7(M,P,IBMASK,IEMASK,MASK1,LEN)
C
      INTEGER M,P,IBMASK,IEMASK,MASK1(M),LEN
      INTEGER J,K,ITEMP,IO,ILEN
C
      LEN=0
C
C BEGINNING OF THE MAXIMUM POSSIBLE SECTION
C
      K=IBMASK
      J=MASK1(K)
      IO=IEMASK
      IEMASK=IBMASK-1
C
C MAIN CYCLE
C
 100  IF(J.LT.0) THEN
        K=-J+1
        IF(LEN.EQ.0) THEN
          IBMASK=K
        END IF
        IF(K.LE.IO) THEN
          J=MASK1(K)
          GO TO 100
        ENDIF
        IF(K.GT.M) THEN
          GO TO 200
        END IF
      ELSE
        IF(J.EQ.M) THEN
          ITEMP=MIN(J-K+1,IO-K+1)
          ILEN=MIN(P-LEN,ITEMP)
          LEN=LEN+ILEN
          IEMASK=K+ILEN-1
          GO TO 200
        ENDIF
        ITEMP=MIN(J-K+1,IO-K+1)
        ILEN=MIN(P-LEN,ITEMP)
        LEN=LEN+ILEN
        IEMASK=K+ILEN-1
        K=IEMASK+1
        IF(LEN.LT.P.AND.K.LE.IO) THEN
          J=MASK1(K)
          GO TO 100
        END IF
      ENDIF
 200  CONTINUE
      RETURN
      END
