* SUBROUTINE UXSSMG                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  GERSHGORIN BOUNDS OF THE EIGENVALUAE OF A SPARSE SYMMETRIC MATRIX.
*  AMIN .LE. ANY EIGENVALUE OF A .LE. AMAX.
*
* PARAMETERS :
*  II  N  DIMENSION OF THE MATRIX A.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE MATRIX A.
*  RI  A(M) ELEMENTS OF THE SPARSE SYMMETRIC MATRIX STORED IN THE
*      PACKED FORM.
*  II  IA(N+1)  POINTERS OF THE DIAGONAL ELEMENTS OF A.
*  II  JA(M)  INDICES OF THE NONZERO ELEMENTS OF A.
*  RO  AMIN  LOWER BOUND OF THE EIGENVALUE OF A.
*  RO  AMAX  UPPER BOUND OF THE EIGENVALUE OF A.
*
      SUBROUTINE UXSSMG(N,M,A,IA,JA,AMIN,AMAX,X)
      INTEGER N,M,IA(N+1),JA(M)
      REAL*8  A(M),AMIN,AMAX,X(N)
      INTEGER I,J,K,JSTRT,JSTOP
      REAL*8 ZERO,CMAX
      PARAMETER (ZERO=0.0D 0,CMAX=1.0D120)
      DO 1 I=1,N
      X(I)=ZERO
    1 CONTINUE
      JSTOP=0
      DO 3 I=1,N
      JSTRT=JSTOP+1
      JSTOP=IA(I+1)-1
      IF (JA(JSTRT).GT.0) THEN
      DO 2 K=JSTRT+1,JSTOP
      J=JA(K)
      IF (J.GT.0) THEN
      X(I)=X(I)+ABS(A(K))
      X(J)=X(J)+ABS(A(K))
      ENDIF
    2 CONTINUE
      ENDIF
    3 CONTINUE
      AMIN= CMAX
      AMAX=-CMAX
      DO 4 I=1,N
      K=IA(I)
      IF (K.GT.0) THEN
      AMAX=MAX(AMAX,A(K)+X(I))
      AMIN=MIN(AMIN,A(K)-X(I))
      ENDIF
    4 CONTINUE
      RETURN
      END
