* SUBROUTINE UXSSMY                ALL SYSTEMS                93/12/01
C PORTABILITY : ALL SYSTEMS
C 93/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* CORRECTION OF A SPARSE SYMMETRIC MATRIX A. THE CORRECTION IS DEFINED
* AS A:=A+SUM OF (HALF*(X*TRANS(Y)+Y*TRANS(X)))(I)/SIGMA(I) WHERE
* SIGMA(I) IS A DOT PRODUCT TRANS(X)*X WHERE ONLY CONTRIBUTIONS
* CORRESPONDING TO NONZEROS IN ROW I ARE SUMMED UP, X AND Y ARE GIVEN
* VECTORS.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE MATRIX A.
*  RI  A(M) ELEMENTS OF THE SPARSE SYMMETRIC MATRIX STORED IN THE
*      PACKED FORM.
*  II  IA(N)  POINTERS OF THE DIAGONAL ELEMENTS OF A.
*  II  JA(M)  INDICES OF THE NONZERO ELEMENTS OF A.
*  RA  XS(N) AUXILIARY VECTOR - USED FOR SIGMA(I).
*  RI  X(N)  VECTOR IN THE CORRECTION TERM.
*  RI  Y(N)  VECTOR IN THE CORRECTION TERM.
*
      SUBROUTINE UXSSMY(N,M,A,IA,JA,XS,X,Y)
      INTEGER  N,M,IA(N+1),JA(M)
      REAL*8  A(M),X(N),Y(N),XS(N),SIGMA,TEMP,ZERO,HALF
      INTEGER I,J,K,JSTRT,JSTOP
      PARAMETER (ZERO=0.0D 0,HALF=0.5D 0)
      CALL UXVSET(N,ZERO,XS)
C
C  COMPUTE SIGMA(I)
C
      JSTOP=0
      DO 200 I=1,N
        JSTRT=JSTOP+1
        JSTOP=IA(I+1)-1
        IF (JA(JSTRT).GT.0) THEN
          SIGMA=ZERO
          DO 100 J=JSTRT,JSTOP
            K=JA(J)
            IF (K.GT.0) THEN
              SIGMA=SIGMA+Y(K)*Y(K)
              IF(K.NE.I) XS(K)=XS(K)+Y(I)*Y(I)
            ENDIF
100       CONTINUE
          XS(I)=XS(I)+SIGMA
        ENDIF
200   CONTINUE
C
C  UPDATE MATRIX
C
      JSTOP=0
      DO 400 I=1,N
        JSTRT=JSTOP+1
        JSTOP=IA(I+1)-1
        IF (JA(JSTRT).GT.0) THEN
          IF(XS(I).EQ.ZERO) THEN
            TEMP=ZERO
          ELSE
            TEMP=X(I)/XS(I)
          ENDIF
          DO 300 J=JSTRT,JSTOP
            K=JA(J)
            IF (K.GT.0) THEN
              IF(XS(K).EQ.ZERO) THEN
              A(J)=A(J)+HALF*TEMP*Y(K)
              ELSE
              A(J)=A(J)+HALF*(TEMP*Y(K)+Y(I)*X(K)/XS(K))
              ENDIF
            ENDIF
300       CONTINUE
        ENDIF
400   CONTINUE
      RETURN
      END
