* SUBROUTINE UXSTMM                ALL SYSTEMS                86/11/01
C PORTABILITY : ALL SYSTEMS
C 93/01/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* SPARSE TRIANGULAR MATRIX MULTIPLIES A VECTOR.
* TRIANGULAR MATRIX IS STORED ROWWISE.
*
* PARAMETERS :
*  II  N ROW ORDER OF THE MATRIX
*  II  NRHS NUMBER OF RIGHT-HAND SIDES.
*  II  NJA LENGTH OF THE VECTORS A,JA
*  II  JA(NJA) VECTOR OF THE ROW INDICES OF THE MATRIX AND OF THE
*         POINTERS - STORED ON OUTPUT OF THE MULTIFRONTAL SOLVER.
*  RI  A(N) NUMERICAL ELEMENTS OF THE MATRIX BEEING MULTIPLIED.
*  RI  X(N)  INPUT VECTOR
*  RO  Y(N)  OUTPUT VECTOR Y=P*A*Q*X.
*  RO  Z(N)  RESTORED RIGHT-HAND SIDE TRANS(q)*RHS FROM THE
*            MULTIFRONTAL OUTPUT.
*
      SUBROUTINE UXSTMM(N,NJA,JA,A,X,Y,Z)
      INTEGER N,NJA,ISTRT,ISTOP,JSTRT,JSTOP,KK
      INTEGER JA(NJA)
      REAL*8 A(NJA),X(N),Y(N),Z(N)
      REAL*8 ZERO
      INTEGER I,J,K,L
      PARAMETER (ZERO=0.0D 0)
C
C     OUTPUT VECTOR INITIALIZATION
C
      DO 100 I=1,N
      Y(I)=ZERO
      Z(I)=ZERO
100   CONTINUE
C
C     MAIN CYCLE
C
      KK=NJA+NJA+1
      ISTRT=JA(KK)
      ISTOP=JA(KK+1)-1
      JSTRT=ISTRT-NJA
      JSTOP=ISTOP-NJA
      KK=KK+1
      DO 400 I=1,N
        L=JSTRT
        DO 300 J=ISTRT,ISTOP
          K=JA(J)
C
C RH SIDES
C
          IF(K.GT.N) THEN
            Z(I)=A(L)
          ELSE
            Y(I)=Y(I)+A(L)*X(K)
          END IF
          L=L+1
 300    CONTINUE
        ISTRT=ISTOP+1
        JSTRT=JSTOP+1
        ISTOP=JA(KK+1)-1
        JSTOP=ISTOP-NJA
        KK=KK+1
 400  CONTINUE
      RETURN
      END
