* SUBROUTINE UXSTQB                ALL SYSTEMS                86/11/01
C PORTABILITY : ALL SYSTEMS
C 93/01/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* SOLVE TRANS(R)*Y=X OR R*Y=X OR TRANS(R)*R*Y=X
* USING SPARSE TRIANGULAR MATRIX
* WHICH IS STORED ROWWISE. MODE DETERMINED BY JOB.
*
* PARAMETERS :
*  II  N ROW ORDER OF THE MATRIX
*  II  NJA LENGTH OF THE VECTORS A,JA
*  II  JA(NJA) VECTOR OF THE ROW INDICES OF THE MATRIX AND OF THE
*         POINTERS - STORED ON OUTPUT OF THE MULTIFRONTAL SOLVER.
*  RI  A(N) NUMERICAL ELEMENTS OF THE MATRIX.
*  RU  X(N) ON INPUT: RIGHT-HAND SIDE, ON OUTPUT:
*           UPDATED SOLUTION VECTOR.
*  RI  TOL  INPUT TOLERANCE FOR THE DIAGONAL VALUES.
*  II  JOB  JOB: =1 FOR SOLUTION Y OF THE SYSTEM TRANS(R)*Y=X,
*           =-1 FOR THE SYSTEM R*Y=X, =0 FOR TRANS(R)*R*Y=X.
*
      SUBROUTINE UXSTQB(N,NJA,JA,A,X,TOL,JOB)
      INTEGER N,NJA,ISTRT,ISTOP,JSTRT,JSTOP,KK
      INTEGER JA(NJA),JOB
      REAL*8 A(NJA),X(N)
      REAL*8 ZERO,TEMP,TEMP1,TOL
      INTEGER I,J,K,L
      PARAMETER (ZERO=0.0D 0)
      IF(JOB.GE.0) THEN
        KK=NJA+NJA+1
        ISTRT=JA(KK)
        ISTOP=JA(KK+1)-1
        JSTRT=ISTRT-NJA
        JSTOP=ISTOP-NJA
        KK=KK+1
        DO 400 I=1,N
          L=JSTRT
          TEMP1=A(L)
          IF (TEMP1.EQ.ZERO) TEMP1=TOL
          X(I)=X(I)/TEMP1
          K=JA(ISTRT)
          ISTRT=ISTRT+1
          L=L+1
          DO 300 J=ISTRT,ISTOP
            K=JA(J)
            IF(K.GT.N) THEN
            ELSEIF(K.GT.I) THEN
              X(K)=X(K)-A(L)*X(I)
            END IF
            L=L+1
 300      CONTINUE
          ISTRT=ISTOP+1
          JSTRT=JSTOP+1
          ISTOP=JA(KK+1)-1
          JSTOP=ISTOP-NJA
          KK=KK+1
 400    CONTINUE
      END IF
C
      IF(JOB.LE.0) THEN
        KK=NJA+NJA+N
        ISTRT=JA(KK)
        ISTOP=JA(KK+1)-1
        JSTRT=ISTRT-NJA
        JSTOP=ISTOP-NJA
        KK=KK-1
        DO 500 I=N,1,-1
          TEMP=X(I)
          L=JSTRT
          DO 600 J=ISTRT,ISTOP
            K=JA(J)
            IF(K.GT.N) THEN
            ELSEIF(K.GT.I) THEN
              TEMP=TEMP-A(L)*X(K)
            ELSEIF(K.EQ.I) THEN
              TEMP1=A(L)
            END IF
            L=L+1
 600      CONTINUE
          IF (TEMP1.EQ.ZERO) TEMP1=TOL
          X(I)=TEMP/TEMP1
          ISTOP=ISTRT-1
          JSTOP=JSTRT-1
          ISTRT=JA(KK)
          JSTRT=ISTRT-NJA
          KK=KK-1
 500    CONTINUE
      END IF
      RETURN
      END
