* SUBROUTINE UXTSMD                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF A SYMMETRIC TRIDIAGONAL MATRIX A BY THE VECTOR X.
*
* PARAMETERS :
*  II  N  ORDER OF THE TRIDIAGONAL MATRIX T.
*  RI  D(N)  DIADONAL ELEMENTS OF THE MATRIX T.
*  RI  E(N)  SUBDIAGONAL ELEMENTS OF THE MATRIX T.
*  RI  X(N)  INPUT VECTOR.
*  RI  ALF  SCALING FACTOR.
*  RI  Y(N)  INPUT VECTOR.
*  RO  Z(N)  OUTPUT VECTOR EQUAL TO A*X+ALF*Y.
*
      SUBROUTINE UXTSMD(N,D,E,X,ALF,Y,Z)
      INTEGER N
      REAL*8  D(N),E(N),X(N),ALF,Y(N),Z(N)
      INTEGER I
      REAL*8 TEMP,TEMP1
      DO 1 I=1,N
      TEMP=X(I)
      IF (I.EQ.1) THEN
      Z(I)=D(I)*X(I)+E(I)*X(I+1)+ALF*Y(I)
      ELSE IF (I.EQ.N) THEN
      Z(I)=E(I-1)*TEMP1+D(I)*X(I)+ALF*Y(I)
      ELSE
      Z(I)=E(I-1)*TEMP1+D(I)*X(I)+E(I)*X(I+1)+ALF*Y(I)
      ENDIF
      TEMP1=TEMP
    1 CONTINUE
      RETURN
      END
