* SUBROUTINE UXTSMU                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* CHOLESKI DECOMPOSITION OF A TRIDIAGONAL MATRIX.
*
* PARAMETERS :
*  II  N  ORDER OF THE TRIDIAGONAL MATRIX T.
*  RU  D(N)  ON INPUT DIAGONAL ELEMENTS OF THE TRIDIAGONAL MATRIX T.
*         ON OUTPUT ELEMENTS OF THE DIAGONAL MATRIX D IN THE
*         DECOMPOSITION T=L*D*TRANS(L).
*  RU  E(N)  ON INPUT SUBDIAGONAL ELEMENTS OF THE TRIDIAGONAL MATRIX T.
*         ON OUTPUT SUBDIAGONAL ELEMENTS OF THE LOWER TRIANGULAR MATRIX L
*         IN THE DECOMPOSITION T=L*D*TRANS(L).
*  RI  ALF  SCALAR PARAMETER OF THE UPDATE.
*  RI  X(N)  VECTOR PARAMETER OF THE UPDATE.
*
      SUBROUTINE UXTSMU(N,D,E,ALF,X)
      INTEGER N
      REAL*8  D(N),E(N),ALF,X(N)
      INTEGER I
      REAL*8 TEMP
      DO 1 I=1,N
      TEMP=ALF*X(I)
      D(I)=D(I)+TEMP*X(I)
      IF (I.LE.N-1) E(I)=E(I)+TEMP*X(I+1)
    1 CONTINUE
      RETURN
      END
