* SUBROUTINE UXVHES                ALL SYSTEMS                95/02/24
C PORTABILITY : ALL SYSTEMS
C 95/02/24 RO : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE HOUSEHOLDER VECTOR WHICH ELIMINATES THE ALL THE
* COMPONENTS OF THE VECTOR X AFTER THE (I)-TH COMPONENT.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  II  I  INDEX OF THE (I)-TH COMPONENT.
*  RI  X(N)  INPUT VECTOR.
*  RO  Y(N-I) HOUSEHOLDER VECTOR. (I)-TH COMPONENT IS NOT STORED (=1).
*
* SUBPROGRAMS USED :
*  S   UXVNOR  NORM OF THE VECTOR.
*
      SUBROUTINE UXVHES(N,I,X,Y)
      INTEGER N,I
      REAL*8  X(N),Y(N-I)
      REAL*8 POM,UXVNOR
      INTEGER J
      REAL*8 ZERO,ONE
      PARAMETER (ZERO=0.0D 0,ONE=1.0D 0)
      IF (I .LT. N) THEN
        POM=UXVNOR(N-I+1,X(I))
        IF (X(I).LT.ZERO) POM=-POM
        IF (POM .NE. ZERO) THEN
           POM=POM+X(I)
           DO 11 J=1,N-I
             Y(J)=X(I+J)/POM
   11      CONTINUE
        END IF
      END IF
      RETURN
      END
