* SUBROUTINE UXVPGF                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COPYING ABSOLUTE VALUES OF A VECTOR.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RU  D(N)  ELEMENTS OF THE DIAGONAL MATRIX.
*  IO  INF  AN INFORMATION OBTAINED IN THE FACTORIZATION PROCESS. IF
*         INF=0 THEN A IS SUFFICIENTLY POSITIVE DEFINITE AND E=0. IF
*         INF<0 THEN A IS NOT SUFFICIENTLY POSITIVE DEFINITE AND E>0.
*         IF INF>0 THEN A IS INDEFINITE AND INF IS AN INDEX OF THE
*         MOST NEGATIVE DIAGONAL ELEMENT USED IN THE FACTORIZATION
*         PROCESS.
*  RU  ALF  ON INPUT A DESIRED TOLERANCE FOR POSITIVE DEFINITENESS.
*         ON OUTPUT THE MOST NEGATIVE DIAGONAL ELEMENT USED IN THE
*         FACTORIZATION PROCESS (IF INF>0).
*  RO  TAU  MAXIMUM DIAGONAL ELEMENT OF THE MATRIX E.
*
      SUBROUTINE UXVPGF(N,D,INF,ALF,TAU)
      INTEGER N,INF
      REAL*8  D(N),ALF,TAU
      REAL*8  DI,EI,BET,DEL,TOL
      INTEGER I,L
      REAL*8 ZERO,ONE,TWO
      PARAMETER (ZERO=0.0D 0,ONE=1.0D 0,TWO=2.0D 0)
      L=0
      INF=0
      TOL=ALF
C
C     ESTIMATION OF THE MATRIX NORM
C
      ALF=ZERO
      BET=ZERO
      TAU=ZERO
      DO 1 I=1,N
      BET=MAX(BET,ABS(D(I)))
    1 CONTINUE
      BET=MAX(TOL,TWO*BET)
      DEL=TOL*MAX(BET,ONE)
      DO 2 I=1,N
      EI=D(I)
      IF (ALF.GT.EI) THEN
      ALF=EI
      L=I
      ENDIF
      DI=MAX(ABS(EI),DEL)
      IF (TAU.LT.DI-EI) THEN
      TAU=DI-EI
      INF=-1
      ENDIF
C
C     GAUSSIAN ELIMINATION
C
      D(I)=DI
    2 CONTINUE
      IF (L.GT.0.AND.ABS(ALF).GT.DEL) INF = L
      RETURN
      END
