* SUBROUTINE UXVRTV               ALL SYSTEMS                16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PLANE ROTATION IS APPLIED TO TWO VECTORS.
*
* PARAMETERS :
*  II  N  DIMENSION OF VECTORS.
*  RU  XK(N)  FIRST VECTOR FOR PLANE ROTATION.
*  RU  XL(N)  SECOND VECTOR FOR PLANE ROTATION.
*  RI  CK  DIAGONAL ELEMENT OF THE ELEMENTARY ORTHOGONAL MATRIX.
*  RI  CL  OFF-DIAGONAL ELEMENT OF THE ELEMENTARY ORTHOGONAL MATRIX.
*  II  IER  INFORMATION ON THE TRANSFORMATION. IER=0-GENERAL PLANE
*         ROTATION. IER=1-PERMUTATION. IER=2-TRANSFORMATION SUPPRESSED.
*
      SUBROUTINE UXVRTV(N,XK,XL,CK,CL,IER)
      INTEGER N,IER
      REAL*8 XK(N),XL(N),CK,CL
      REAL*8 POM
      INTEGER I
      IF (IER.EQ.0) THEN
      DO 1 I=1,N
      POM=XK(I)
      XK(I)=CK*POM+CL*XL(I)
      XL(I)=CL*POM-CK*XL(I)
    1 CONTINUE
      ELSE IF (IER.EQ.1) THEN
      DO 2 I=1,N
      POM=XK(I)
      XK(I)=XL(I)
      XL(I)=POM
    2 CONTINUE
      ENDIF
      RETURN
      END
