* SUBROUTINE UXVSR1                ALL SYSTEMS                95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* GROUPING INDICES CORRESPONDING THE SAME INTEGER VALUE IN THE SORTED
* ARRAY AND, OPTIONALLY, SORTING THE ARRAY IN THE ASCENDING OR DESCENDING
* ORDER.
*
*
* PARAMETERS :
*  II  N  NUMBER OF INTEGER VALUES OF THE SORTED ARRAY.
*  II  NMAX  MAXIMUM INTEGER IN THE GROUPED AND SORTED SEQUENCE.
*  II  NUM(N)  VECTOR CONTAINING A SEQUENCE OF INTEGERS TO BE GROUPED
*         AND SORTED.
*  IO  INDEX(N)  PERMUTATION VECTOR CONTAINING SORTING PERMUTATIONS.
*  IO  LAST(NMAX+1)  LAST OCCURENCE VECTOR.
*  II  NEXT(N)  PREVIOUS OCCURENCE VECTOR.
*  II  MODE  OPTION. MODE=0 - SORT IS SUPPRESSED. MODE>0 - SORT IN
*         THE ASCENDING ORDER IS PERFORMED. MODE<0 - SORT IN DESCENDING
*         ORDER IF PERFORMED.
*
      SUBROUTINE UXVSR1(N,NMAX,NUM,INDEX,LAST,NEXT,MODE)
      INTEGER N,NMAX,MODE
      INTEGER NUM(N),INDEX(N),LAST(0:NMAX),NEXT(N)
      INTEGER I,J,JINC,JL,JU,K,L
C
C     DETERMINE THE ARRAYS NEXT AND LAST.
C
      DO 10 I = 0, NMAX
      LAST(I) = 0
   10 CONTINUE
      DO 20 K = 1, N
      L = NUM(K)
      NEXT(K) = LAST(L)
      LAST(L) = K
   20 CONTINUE
      IF (MODE .EQ. 0) RETURN
C
C     STORE THE POINTERS TO THE SORTED ARRAY IN INDEX.
C
      I = 1
      IF (MODE .GT. 0) THEN
      JL = 0
      JU = NMAX
      JINC = 1
      ELSE
      JL = NMAX
      JU = 0
      JINC = -1
      END IF
      DO 50 J = JL, JU, JINC
      K = LAST(J)
   30 CONTINUE
      IF (K .EQ. 0) GO TO 40
      INDEX(I) = K
      I = I + 1
      K = NEXT(K)
      GO TO 30
   40 CONTINUE
   50 CONTINUE
      RETURN
      END
