* SUBROUTINE UXWDIW                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* VECTOR AUGMENTED BY THE SCALED VECTOR IN THE PACKED CASE.
*
* PARAMETERS :
*  II  L  PACKED VECTOR DIMENSION.
*  II  N  VECTOR DIMENSION.
*  II  JBL(L)  INDICES OF PACKED VECTOR.
*  RI  A  SCALING FACTOR.
*  RI  X(N)  UNPACKED INPUT VECTOR.
*  RI  Y(N)  UNPACKED INPUT VECTOR.
*  RO  Z(N)  UNPACKED OR PACKED OUTPUT VECTOR WHERE Z:= Y + A*X.
*  II  JOB  FORM OF THE VECTOR Z. JOB=1-UNPACKED FORM. JOB=2-PACKED
*         FORM.
*
      SUBROUTINE UXWDIW(L,N,JBL,A,X,Y,Z,JOB)
      INTEGER L,N,JBL(L),JOB
      REAL*8  A, X(N), Y(N), Z(*)
      INTEGER I,IP
      IF (JOB.EQ.1) THEN
      DO 1 I=1,L
      IP=JBL(I)
      IF (IP.GT.0) Z(IP)=Y(IP)+A*X(IP)
    1 CONTINUE
      ELSE
      DO 2 I=1,L
      IP=JBL(I)
      IF (IP.GT.0) Z(I)=Y(IP)+A*X(IP)
    2 CONTINUE
      ENDIF
      RETURN
      END
