* SUBROUTINE UYADS3                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* NEW SIMPLE BOUNDS ARE ADDED TO THE ACTIVE SET. TRANSFORMED HESSIAN
* MATRIX APPROXIMATION IS UPDATED.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RI  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  RU  H(NF*(NF+1)/2)  GILL-MURRAY FACTORIZATION OF THE TRANSFORMED
*         HESSIAN MATRIX APPROXIMATION.
*  RI  EPS9  TOLERANCE FOR ACTIVE CONSTRAINTS.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*  IO  INEW  INDEX OF THE NEW ACTIVE CONSTRAINT.
*
* SUBPROGRAMS USED :
*  S   ULNEWS  IDENTIFICATION OF ACTIVE BOUNDS.
*
      SUBROUTINE UYADS3(NF,X,IX,XN,XL,XU,H,EPS9,NORMF,INEW)
      INTEGER NF,IX(NF),NORMF,INEW
      REAL*8 X(NF),XN(NF),XL(NF),XU(NF),H(NF*(NF+1)/2),EPS9
      INTEGER I,J,K,L
      INEW=0
      DO 1 I=1,NF
      CALL ULNEWS(NF,X,IX,XN,XL,XU,EPS9,NORMF,I,INEW)
    1 CONTINUE
      IF (INEW.EQ.0) RETURN
      K=0
      L=0
      DO 3 I=1,NF
      DO 2 J=1,I
      IF ( IX(I) .GE.  0 .AND. IX(J) .GE.  0) THEN
      K=K+1
      IF ( IX(I) .LE. 10 .AND. IX(J) .LE. 10) THEN
      L=L+1
      H(L)=H(K)
      ENDIF
      ENDIF
    2 CONTINUE
    3 CONTINUE
      DO 4 I=1,NF
      IF ( IX(I) .GT. 10) IX(I) = 10 - IX(I)
    4 CONTINUE
      RETURN
      END
