* SUBROUTINE UYCSER                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* GROUP OF THE SAME COLOUR FOR THE POWELL-TOINT ALGORITHM FOR SPARSE
* HESSIANS APPROXIMATIONS IS CREATED.
*
* PARAMETERS :
*  II  MCOLS DECLARED NUMBER OF VARIABLES.
*  II  M  NUMBER OF ELEMENTS IN THE ARRAY JH.
*  IU  IH(MCOLS+1) POINTER VECTOR OF SPARSE HESSIAN MATRIX.
*  IU  JH(M) INDEX VECTOR OF THE HESSIAN MATRIX.
*  IA  WN02(MCOLS) AUXILIARY VECTOR.
*  RA  WN03(MCOLS) AUXILIARY VECTOR.
*  RI  DEG(MCOLS) DEGREES OF THE ADJACENCY GRAPH.
*  IA  WN01(NF) AUXILIARY VECTOR USED FOR INDICES OF THE COLUMNS
*        THAT HAVE NOT BEEN COLOURED YET.
*  II  COL(NF) VECTOR DISCERNING GROUPS OF THE HESSIAN COLUMN OF THE
*              SAME COLOUR.
*  IU  NCOL  NUMBER OF COLOURS USED SO FAR.
*  IU  CNM  NUMBER OF COLUMNS THAT HACVE NOT BEEN COLOURED SO FAR.
*
      SUBROUTINE UYCSER(MCOLS,M,JH,IH,WN02,WN03,DEG,WN01,COL,NCOL,CNM)
      INTEGER NS,ISB,ISP(20),ISD(20),KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI(7)
      COMMON /UMOPTI/ NS,ISB,ISP,ISD,KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI
      REAL*8 TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR(12)
      COMMON /UMOPTR/ TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR
      REAL*8 ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS(2)
      COMMON /UMCONS/ ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS
      CHARACTER*4 TSS(20)
      CHARACTER*8 TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,TUXX,
     & TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT(3)
      CHARACTER*80 TER
      COMMON /UMOPTT/ TSS,TER,TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,
     & TUXX,TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT
      CHARACTER*6 NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN
      CHARACTER*14 NAME
      COMMON /UMOPTN/ NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN,NAME
      INTEGER MCOLS,M,JH(M),IH(MCOLS+1),COL(MCOLS)
      INTEGER WN01(MCOLS+1),WN02(MCOLS+1)
      REAL*8 WN03(MCOLS),DEG(MCOLS)
      INTEGER NCOL,CNM,I,J,K,L,IP
C
C     DEFINITION OF THE INCIDENCE ARRAY A
C
      L=WN01(1)
C
C     ELEMENT WAS MARKED THAT IT IS INSERTED
C
      DO 100 I=IH(L),IH(L+1)-1
      K=ABS(JH(I))
C
C     COLUMN OF THIS NUMBER HAS APPEARED IN ONE OF THE PREVIOUS GROUPS
C
      IF(COL(K).LT.NCOL) GO TO 100
      DEG(K)=DEG(K)-1
      WN02(K)=NCOL
100   CONTINUE
C
C     COLUMN IS INSERTED
C
      COL(L)=NCOL
C
C     THE CYCLE OF COMPARING COLUMN WITH THE ARRAY A
C     A2 IS AN HELP ARRAY CONTAINING COLUMNS THAT ARE
C     BEEING EXAMINED BUT THAT WERE NOT YET ACCEPTED
C     P IS ITS POINTER
C
      IF(CNM.EQ.1) GO TO 250
      DO 200 I=2,CNM
C
C     TRANSFORMATION OF THE EXAMINED COLUMN I IS
C
      IP=1
      L=WN01(I)
      DO 300 J=IH(L),IH(L+1)-1
        K=ABS(JH(J))
        IF(COL(K).LT.NCOL) GO TO 300
        IF(WN02(K).GE.NCOL) GO TO 200
C
        WN03(IP)=K
        IP=IP+1
300   CONTINUE
      IF(IP.NE.1) THEN
C
C COPY OF THE WN03 ARRAY INTO WN02 FOR THE COLUMN WAS ACCEPTED
C
      DO 400 K=1,IP-1
        WN02(INT(WN03(K)))=NCOL
        DEG(INT(WN03(K)))=DEG(INT(WN03(K)))-1
400   CONTINUE
      END IF
C
C     INSERT THE COLUMN INTO THE PROCESSED GROUP
C
      COL(L)=NCOL
C
C     END OF THE MAIN CYCLE
C
200   CONTINUE
C
C     JUMP LABEL
C
250   CONTINUE
C
C     INVP SHIFT
C
      K=1
      DO 500 I=1,CNM
        L=WN01(I)
        IF(COL(L).EQ.NCOL) THEN
      ELSE
        WN01(K)=L
        K=K+1
      END IF
500   CONTINUE
C
C     CNM UPDATE
C
      CNM=K-1
C
      RETURN
      END
