* SUBROUTINE UYPTSH                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* POWELL-TOINT COLORING ALGORITHM.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  MMAX  SIZE OF THE SPARSE HESSIAN ARRAY.
*  II  IH(NF+1) POINTER VECTOR OF SPARSE HESSIAN MATRIX.
*  II  JH(MMAX) INDEX VECTOR OF THE HESSIAN MATRIX.
*  IO  COL(NF) VECTOR DISCERNING GROUPS OF THE HESSIAN COLUMN OF THE
*              SAME COLOUR.
*  RA  DEG(NF) DEGREES OF THE ADJACENCY GRAPH.
*  RA  ORD(NF) AUXILIARY ARRAY.
*  RA  RADIX(NF+1) AUXILIARY ARRAY.
*  IA  WN11(NF) AUXILIARY VECTOR USED FOR INDICES OF THE COLUMNS
*        THAT HAVE NOT BEEN COLOURED YET.
*  IA  WN12(NF) AUXILIARY VECTOR.
*  RA  XS(NF) AUXILIARY VECTOR.
*
* COMMON DATA
*  IO  ITERM  TERMINATION INDICATOR.
*  TO  TDXX  TEXT INFORMATION ON THE CAUSE OF TERMINATION.
*
      SUBROUTINE UYPTSH(NF,MMAX,IH,JH,COL,DEG,ORD,RADIX,WN11,WN12,XS)
      INTEGER NS,ISB,ISP(20),ISD(20),KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI(7)
      COMMON /UMOPTI/ NS,ISB,ISP,ISD,KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI
      REAL*8 TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR(12)
      COMMON /UMOPTR/ TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR
      REAL*8 ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS(2)
      COMMON /UMCONS/ ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS
      CHARACTER*4 TSS(20)
      CHARACTER*8 TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,TUXX,
     & TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT(3)
      CHARACTER*80 TER
      COMMON /UMOPTT/ TSS,TER,TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,
     & TUXX,TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT
      CHARACTER*6 NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN
      CHARACTER*14 NAME
      COMMON /UMOPTN/ NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN,NAME
      INTEGER NF,MMAX,IH(NF+1),JH(MMAX),COL(NF)
      INTEGER WN11(NF+1),WN12(NF+1)
      REAL*8 RADIX(NF+1),ORD(NF)
      REAL*8 XS(NF),DEG(NF)
      INTEGER NCOL,CNM,I,ML,MM,J,L
C
C SAVE SYMBOLIC STRUCTURE OF FACTOR
C
      MM=IH(NF+1)-1
      IF(2*MM-NF+2.GE.MMAX) THEN
        ITERM=-44
        TDXX='LACK SPC'
        CALL UOERR1('UYPTSH',44)
        GO TO 1100
      END IF
C
C WIDTHEN THE STRUCTURE
C
      CALL UXSTG1(NF,ML,MMAX,IH,JH,WN12,WN11)
C
      DO 100 I=1,NF
      COL(I)=NF
      WN12(I)=0
      WN11(I)=I
100   CONTINUE
C
C     NUMBER OF THE FREE COLUMNS
C
      CNM=NF
C
C     NUMBER OF USED COLOURS
C
      NCOL=1
C
C     DEGREE RECOUNT
C
      CALL UYSDEG(NF,NF,IH,DEG)
C
C     COLUMN RESORT
C
200   CALL UXVSR2(NF,DEG,ORD,RADIX,WN11,CNM)
C
C     ORD REWRITE INTO THE ARRAY INVP
C
      DO 250 I=1,CNM
        WN11(I)=ORD(I)
250   CONTINUE
C
C     COLUMNS OF THE NEW COLOUR NCOL
C
      CALL UYCSER(NF,MMAX,JH,IH,WN12,XS,DEG,WN11,COL,NCOL,CNM)
C
C     STOP TEST
C
      IF(CNM.GE.1) THEN
        NCOL=NCOL+1
        GO TO 200
      END IF
C
C SHRINK THE STRUCTURE
C
      CALL UXSTL1(NF,ML,MMAX,IH,JH,WN12)
C
C INTO COL GIVE INDICES OF THE INDIVIDUAL GROUPS ONE AFTER ANOTHER,
C END OF THE GROUP IS MARKED BY THE NEGATIVE INDEX VALUE.
C
C
C READ COL
C
      DO 300 I=1,NF
        WN11(I)=0
 300  CONTINUE
      DO 400 I=1,NF
        J=COL(I)
        WN11(J)=WN11(J)+1
 400  CONTINUE
      WN12(1)=1
      L=1
      DO 500 I=2,NF
        L=L+WN11(I-1)
        WN12(I)=L
        IF(WN11(I).EQ.0) GO TO 550
 500  CONTINUE
 550  CONTINUE
C
C CHANGE COL
C
      DO 600 I=1,NF
        J=COL(I)
        WN11(I)=J
 600  CONTINUE
      DO 700 I=1,NF
        J=WN11(I)
        COL(WN12(J))=I
        WN12(J)=WN12(J)+1
 700  CONTINUE
      DO 800 I=1,NCOL
        L=WN12(I)-1
        IF(L.GT.NF) GO TO 900
        COL(L)=-COL(L)
 800  CONTINUE
 900  CONTINUE
 1100 CONTINUE
      RETURN
      END
