* SUBROUTINE UYSDGR                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF THE DEGREE SEQUENCE FOR THE INTERSECTION GRAPH
* OF THE COLUMNS OF A.
*
* PARAMETERS :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  MA  NUMBER OF NONZERO ELEMENTS OF THE JACOBIAN MATRIX.
*  II  IA(NA+1) ROW POINTERS OF THE SPARSE JACOBIAN MATRIX.
*  II  JA(MA) COLUMN INDICES OF THE SPARSE JACOBIAN MATRIX.
*  II  IB(NF+1) COLUMN POINTERS OF THE SPARSE JACOBIAN MATRIX.
*  II  JB(MA) ROW INDICES OF THE SPARSE JACOBIAN MATRIX.
*  IO  IDEG(NF) VECTOR SPECIFYING DEGREE SEQUENCE.
*  IA  IW(NF)  AUXILIARY VECTOR.
*
      SUBROUTINE UYSDGR(NF,NA,MA,IA,JA,IB,JB,IDEG,IW)
      INTEGER NF,NA,MA,IA(NA+1),JA(MA),IB(NF+1),JB(MA),IDEG(NF),IW(NF)
      INTEGER IC,IP,IR,JC,JP
C
C     INITIALIZATION BLOCK
C
      DO 10 JP = 1, NF
      IDEG(JP) = 0
      IW(JP) = 0
   10 CONTINUE
C
C     COMPUTE THE DEGREE SEQUENCE BY DETERMINING THE CONTRIBUTIONS
C     TO THE DEGREES FROM THE CURRENT(JC) COLUMN AND FURTHER
C     COLUMNS WHICH HAVE NOT YET BEEN CONSIDERED
C
      DO 40 JC = 2, NF
      IW(JC) = NF
C
C     DETERMINE ALL POSITIONS (IR,JC) WHICH CORRESPOND
C     TO NON-ZEROES IN THE MATRIX
C
      DO 30 JP = IB(JC), IB(JC+1)-1
      IR = JB(JP)
C
C     FOR EACH ROW IR, DETERMINE ALL POSITIONS (IR,IC)
C     WHICH CORRESPOND TO NON-ZEROES IN THE MATRIX
C
      DO 20 IP = IA(IR), IA(IR+1)-1
      IC = JA(IP)
C
C     ARRAY IW MARKS COLUMNS WHICH HAVE CONTRIBUTED TO
C     THE DEGREE COUNT OF COLUMN JC. UPDATE THE DEGREE
C     COUNTS OF THESE COLUMNS AS WELL AS COLUMN JC
C
      IF (IW(IC) .LT. JC) THEN
      IW(IC) = JC
      IDEG(IC) = IDEG(IC) + 1
      IDEG(JC) = IDEG(JC) + 1
      END IF
   20 CONTINUE
   30 CONTINUE
   40 CONTINUE
      RETURN
      END
