* SUBROUTINE UYTLUT                ALL SYSTEMS                02/12/01
C PORTABILITY : ALL SYSTEMS
C 02/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* LIMITED STORAGE REDUCED HESSIAN VARIABLE METRIC UPDATE.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  IU  N  CURRENT NUMBER OF VARIABLE METRIC STEPS.
*  II  MF  MAXIMUM NUMBER OF VARIABLE METRIC STEPS.
*  RU  XM(NF*(MF+1))  SET OF VECTOR OF VARIABLES DIFFERENCES.
*  RU  XR((MF+1)*(MF+2)/2)  CHOLESKI DECOMPOSITION OF THE REDUCED
*         HESSIAN MATRIX.
*  RU  HR((MF+1)*(MF+2)/2)  TRIANGULAR TRANFORMATION MATRIX.
*  RO  GR(MF+1) REDUCED GRADIENT VECTOR.
*  II  MOS  OPTION. MOS=1-INVERSION OF REDUCED HESSIAN MATRIX.
*         MOS=2-REDUCED INVERSION OF HESSIAN MATRIX.
*  II  MOT1  DELETION OF COLUMNS OR RESTART. MOT1=0-DELETION OF
*         COLUMNS. MOT1=1-RESTART.
*  CO  TEXT  TYPE OF DECOMPOSITION. TEXT='R'-RECURSIVE QR DECOMPOSITION
*         WITHOUT PERMUTATIONS. TEXT='I'-INVERSION.
*
* SUBPROGRAMS USED :
*  S   UXDPRH  TRANSFORMATION OF THE CHOLESKI FACTOR OF THE REDUCED
*         HESSIAN MATRIX AFTER DROPPING THE OLDEST DIRECTION VECTOR
*         FROM THE BASIS IN THE LIMITED MEMORY REDUCED HESSIAN
*         VARIABLE METRIC METHOD.
*  S   UXDSMH  TRANSFORMATION OF THE REDUCED HESSIAN MATRIX AFTER
*         DROPPING THE OLDEST DIRECTION VECTOR FROM THE BASIS IN THE
*         LIMITED MEMORY REDUCED HESSIAN VARIABLE METRIC METHOD.
*
      SUBROUTINE UYTLUT(NF,N,MF,XM,XR,HR,GR,MOS,MOT1,TEXT)
      INTEGER NF,N,MF,MOS,MOT1
      REAL*8 XM(NF*(MF+1)),XR((MF+1)*(MF+2)/2),HR((MF+1)*(MF+2)/2),
     & GR(MF+1)
      CHARACTER*1 TEXT
      INTEGER I,IER
      IF (N.EQ.MF+1) THEN
      IF (MOT1.GE.1) THEN
      CALL UYRES1('LARGE NN')
      RETURN
      ELSE IF (TEXT.EQ.'R') THEN
      CALL UXDPRH(N,XR,HR,GR,GR,GR,IER,1)
      ELSE
      CALL UXDSMH(N,XR,HR,GR,GR,GR,IER,MOS,1)
      ENDIF
      DO 1 I=1,NF*MF
      XM(I)=XM(I+NF)
    1 CONTINUE
      N=MF
      ENDIF
      RETURN
      END
