* SUBROUTINE UYTSSG             ALL SYSTEMS                   98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENT OF THE OBJECTIVE FUNCTION IS SCALED AND REDUCED. TEST VALUES
*  GMAX AND UMAX ARE COMPUTED FOR SPARSE LINEARLY CONSTRAINED
*  OPTIMIZATION.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  II  M  NUMBER OF ROWS OF THE PROCESSED CONSTRAINT MATRIX.
*  II  MCOLS DECLARED NUMBER OF VARIABLES.
*  IU  LINP NUMBER OF BASICS AND SUPERBASICS.
*  II  IX(MCOLS)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XL(MCOLS)  VECTOR OF LOWER BOUNDS.
*  RI  XU(MCOLS)  VECTOR OF UPPER BOUNDS.
*  RI  LAM(MCOLS) LAGRANGE MULTIPLIERS.
*  II  BCOL(MCOLS) BASIS MAPPING VECTOR.
*  RI  EPS9  TOLERANCE FOR ACTIVE CONSTRAINTS.
*  RO  UMAX  MAXIMUM ABSOLUTE VALUE OF THE NEGATIVE LAGRANGE MULTIPLIER.
*  RO  GMAX  NORM OF THE TRANSFORMED GRADIENT.
*
* COMMON DATA :
*  II  LIT  NUMBER OF THE FIRST ITERATION.
*  IU  NIT  ACTUAL NUMBER OF ITERATIONS.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
      SUBROUTINE UYTSSG(NF,N,M,MCOLS,LINP,IX,XL,XU,LAM,BCOL,XN,G,GN,
     & EPS9,UMAX,GMAX)
      INTEGER NS,ISB,ISP(20),ISD(20),KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI(7)
      COMMON /UMOPTI/ NS,ISB,ISP,ISD,KD,KDF,KDA,KDC,KDE,KDY,LD,LDA,LDC,
     & LDE,LDY,KBF,KBA,KBC,ISNF,ISNA,ISNC,NORMF,NORMA,NORMC,IDECF,IDECA,
     & IDECC,IDECE,NDECF,NDECA,NDECC,NDECE,MTESX,NTESX,MTESF,NTESF,LCS,
     & IEST,IEXT,NEXT,IDIR,ITRAN,IREST,ITERM,ITERS,ITERH,ITERD,ITERL,
     & ITERQ,MAXST,KIC,LIC,MIC,NIC,KIT,LIT,MIT,NIT,KFV,LFV,MFV,NFV,NAV,
     & NCV,NEV,NFG,NAG,NCG,NEG,NFH,NAH,NCH,NEH,NREM,NADD,NRES,NREF,NRED,
     & NCGR,NLNS,MSTP,NSTP,IRD,IWR,ITR,IOUT,JOUT,KOUT,KOUT1,KOUT2,KOUT3,
     & LOUT,MOUT,NOUT,NOUT1,NOUT2,NOUT3,LFG,MFG,NSCL,NUPD,NMAX,NTIME,
     & MCGR,NCYC,IMOPTI
      REAL*8 TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR(12)
      COMMON /UMOPTR/ TOLX,TOLF,TOLB,TOLG,TOLC,TOLA,TOLR,RAN,RMOPTR
      REAL*8 ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS(2)
      COMMON /UMCONS/ ZERO,HALF,ONE,TWO,THREE,FOUR,FIVE,TEN,RMCONS
      CHARACTER*4 TSS(20)
      CHARACTER*8 TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,TUXX,
     & TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT(3)
      CHARACTER*80 TER
      COMMON /UMOPTT/ TSS,TER,TGXN,TGXU,TXAN,TXAU,TXFN,TXFU,TDXX,TSXX,
     & TUXX,TRXX,TPFX,TGFX,TLPX,TQPX,TPXX,TEDX,TENX,TMOPTT
      CHARACTER*6 NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN
      CHARACTER*14 NAME
      COMMON /UMOPTN/ NGXN,NGXU,NXAN,NXAU,NXFN,NXFU,NGXX,NHXX,NDXX,NSXX,
     & NUXX,NFXX,NFGX,NFHX,NAXX,NAGX,NAHX,NCXX,NCGX,NCHX,NPXX,NGFX,NLPX,
     & NQPX,NSGX,NEDX,NEXX,NPFX,NBFX,TMOPTN,NAME
      INTEGER NF,N,M,MCOLS,LINP,IX(MCOLS),BCOL(MCOLS)
      REAL*8 XL(MCOLS),XU(MCOLS),LAM(MCOLS),XN(MCOLS),G(MCOLS),
     & GN(MCOLS),EPS9,UMAX,GMAX
      REAL*8 MULT,TEMP
      INTEGER I,J,TYPV
      GMAX = 0.0D 0
      UMAX = 0.0D 0
      DO 200 I=1,NF
        IF(NORMF.GT.0) THEN
          TEMP=G(I)*XN(I)
        ELSE
          TEMP=G(I)
        ENDIF
        GN(I)=TEMP
 200  CONTINUE
C
C NO TRANSFORMATION OF THE GRADIENT
C REDUCED COSTS ARE TAKEN FROM PRE-PROCESSED VECTOR LAM
C
      DO 300 I=M+1,LINP
      J=BCOL(I)
      MULT=LAM(I)
      TYPV=IX(J)
      IF(TYPV.EQ.5) THEN
        GO TO 300
      ELSEIF(TYPV.EQ.3.OR.TYPV.EQ.4.) THEN
        IF(ABS(XL(J)-XU(J)).LE.EPS9) THEN
          GO TO 300
        END IF
      END IF
C         IF(TYPV.EQ.2.OR.TYPV.EQ.4) THEN
C           MULT=MIN(0.0D 0,-MULT)
C         ELSEIF(TYPV.EQ.3.OR.TYPV.EQ.1) THEN
C           MULT=MAX(0.0D 0,-MULT)
C         ELSE
C           MULT=-MULT
C         END IF
C         MULT=ABS(MULT)
C         GMAX=MAX(GMAX,MULT)
C
C     OPRAVA 15.7.2000
C
      GMAX=MAX(GMAX,ABS(MULT))
C
300   CONTINUE
      DO 400 I=LINP+1,N
      J=BCOL(I)
      MULT=LAM(I)
      TYPV=IX(J)
      IF(TYPV.EQ.5) THEN
        GO TO 400
      ELSEIF(TYPV.EQ.3.OR.TYPV.EQ.4.) THEN
        IF(ABS(XL(J)-XU(J)).LE.EPS9) THEN
          GO TO 400
        END IF
      END IF
         IF(TYPV.EQ.2.OR.TYPV.EQ.4) THEN
           MULT=MIN(0.0D 0,-MULT)
         ELSEIF(TYPV.EQ.3.OR.TYPV.EQ.1) THEN
           MULT=MAX(0.0D 0,-MULT)
         ELSE
           MULT=-MULT
         END IF
         MULT=ABS(MULT)
         UMAX=MAX(UMAX,MULT)
400   CONTINUE
      IF(NIT.EQ.LIT) THEN
C
C FALSE SETTING TO FORCE JUMP INTO DIRECTION SEARCH ROUTINE
C
        UMAX=1.0D 0
        GMAX=1.0D 0
      ENDIF
      RETURN
      END
