* SUBROUTINE UQCHCK                                          98/12/01
* PORTABILITY : PC XT/AT/386
* 98/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  PERFORM DIRECTIVE 'HELP - CHECK' & USER INTERFACE IN A DIALOGUE MODE
*
* PARAMETERS :
*  TI  BUFFER(MLENB) - WORK BUFFER
*  II  MLENB - MAX. LENGTH OF THE BUFFER
*  II  LENB - ACTUAL LENGTH OF THE BUFFER
*  II  IPOS1 - POSITION OF THE FIRST CHARACTER OF LINE
*               IN THE BUFFER
*  II  IPOSD - POSITION OF THE FIRST CHARACTER OF DIRECTIVE
*               IN THE BUFFER
*  II  IPOS2 - POSITION OF THE LAST CHARACTER OF LINE
*               IN THE BUFFER
*  TU  SYMTAB(MLENST) - SYMBOL TABLE
*  II  MLENST - MAX. LENGTH OF THE SYMBOL TABLE
*  IU  IPOINT(MNP,6) - ARRAY OF POINTERS TO THE SYMBOL TABLE
*               1-LINK, 2-POSITION OF THE FIRST CHARACTER,
*               3-LENGTH OF NAME, 4-POSITION OF THE LAST CHARACTER,
*               5-POINTER OF LIST, 6-MODERW (1-RW, 2-RA, 3-RO)
*  II  MNP - MAX. NUMBER OF POINTERS
*  II  LP - LAST POINTER TO THE SYMBOL TABLE
*  IO  IPOSS0 - STARTING POSITION OF HELP
*  IO  IPOSS1 - STARTING POSITION OF TEXT OF HELP
*  II  IIUNIT - THE INPUT INTERACTIVE UNIT NUMBER
*  II  OIUNIT - THE OUTPUT INTERACTIVE UNIT NUMBER
*  IU  DIALOG - DIALOGUE MODE ? (0-NO DIALOGUE, 1-SHORT DIALOGUE,
*               2-FULL DIALOGUE)
*  II  IDIRN - NUMBER OF DIRECTIVE
*  TI  CHDS - THE DATA SEPARATOR MARKER
*  TI  CHEOL - THE END OF LINE MARKER
*  TI  CHCON - THE CONTINUATION MARKER
*  LI  LHELP - .TRUE. IN LINES OF HELP
*  IO  IER - ERROR INDICATOR
*
* SUBPROGRAMS USED :
*  S   UQCEOL - CHECK END OF LINE
*  S   UQSADR - SYNTAX ANALYSIS OF DIRECTIVE LINE
*  LF  UQSTRC - COMPARISON OF TWO SUBSTRINGS
*  S   UQINCS - INCLUDE A SUBSTRING IN STRING ARRAY
*  LF  UQINTM - IS IT AN INTEGER NUMBER ?
*  LF  UQREAM - IS IT A REAL NUMBER ?
*  S   UQFCHR - FIND NEXT POSITION OF CHARACTER 'CH'
*  S   UQRDLN - READ A LINE
*  S   UQNXTC - GIVE A NEXT CHARACTER
*  S   UQADDV - APPEND VALUE TO A MACRO
*  S   UQGVAL - GIVE VALUE OF A MACRO
*  S   UQSETV - SET A MACRO TO THE SYMBOL TABLE
*
* REMARK :
*  CHANGE GRAPHIC CHARACTERS (PARAMETERS CHV,CHH,CHLU,CHRU,CHLD,CHRD)
*  TO INSTALL THIS SUBROUTINE.
*
      SUBROUTINE UQCHCK(BUFFER,MLENB,LENB,IPOS1,IPOSD,IPOS2,SYMTAB,
     *                  MLENST,IPOINT,MNP,LP,IPOSS0,IPOSS1,IIUNIT,
     *                  OIUNIT,DIALOG,IDIRN,CHDS,CHEOL,CHCON,LHELP,IER)
      INTEGER MLENB,LENB,IPOS1,IPOSD,IPOS2,MLENST,MNP,LP,IPOINT(MNP,6),
     *        IPOSS0,IPOSS1,IIUNIT,OIUNIT,DIALOG,IDIRN,IER
      CHARACTER*1 BUFFER(MLENB),SYMTAB(MLENST),CHDS,CHEOL,CHCON
      LOGICAL LHELP,LSETV
      INTEGER MNPAR,ISET1,ISET2
      PARAMETER(MNPAR=9)
      INTEGER NPAR,IPOSP(MNPAR,2),ITYPE(MNPAR),I,J,K,L,M,IP,IP1,IP2,
     *        IP3,IP4,IP5,IP6,IPPRED,IOPT,LNLEN,DLEVEL,UQINTI,UQIARE
      LOGICAL LINIT,LSIGN,LNUM,UQSTRC,UQINTM,UQCOND,UQVDEF
      LOGICAL UQREAM
      CHARACTER*1 CHEOD,CHWC,CHV,CHH,CHLU,CHRU,CHLD,CHRD,
     *        WINT(3),WREAL(4),WSTR(3),WYES(3),WINIT(4)
C
C     FOR PC COMPUTERS:
C
      PARAMETER(CHEOD='!',CHWC='?',CHV='',CHH='',CHLU='',
     *          CHRU='',CHLD='',CHRD='',LNLEN=70)
C
C     FOR UNIX WORKSTATIONS:
C
C      PARAMETER(CHEOD='!',CHWC='?',CHV='+',CHH='+',CHLU='+',
C     *          CHRU='+',CHLD='+',CHRD='+',LNLEN=67)
C
      SAVE WINT,WREAL,WSTR,WYES,WINIT
      DATA WINT  /'I','N','T'/, WREAL /'R','E','A','L'/,
     *     WSTR  /'S','T','R'/, WYES  /'Y','E','S'/,
     *     WINIT /'I','N','I','T'/
C
C HELP
C
      LSETV=.FALSE.
      IF(IDIRN.EQ.23) THEN
        CALL UQCEOL(BUFFER,MLENB,IPOSD,IER)
        IF(IER.NE.0) RETURN
        LHELP=.TRUE.
        IPOSS0=IPOS1
        IPOSS1=IPOS2+1
C
C CHECK(MACRO,DEFAULT,STR\INT\REAL\LIST,NO\YES,NO\YES)
C             MAIN MACRO?
C             ADD  INIT ?
C
      ELSE
        CALL UQSADR(BUFFER,MLENB,IPOSD,IPOS2,IPOSP,MNPAR,NPAR,ITYPE,IER)
        IF(IER.NE.0) RETURN
        IF(NPAR.NE.9.AND.NPAR.NE.7.AND.NPAR.NE.5) RETURN
        IF(ITYPE(2).NE.4.OR.ITYPE(4).NE.4) GOTO 10
        IF(ITYPE(1).NE.5) GOTO 10
        IF(ITYPE(3).LT.5.OR.ITYPE(3).GT.9) GOTO 10
C
C LEVEL OF DIALOG (DEFAULT: 1)
C
        IF(NPAR.EQ.5) THEN
          DLEVEL=1
        ELSE
          IF(ITYPE(6).NE.4.OR.ITYPE(7).NE.7) GOTO 10
          DLEVEL=UQINTI(BUFFER,MLENB,IPOSP(7,1),IPOSP(7,2),IER)
          IF(IER.NE.0) RETURN
        ENDIF
C
C APPEND TO INIT ?  (DEFAULT: YES)
C
        IF(NPAR.LT.9) THEN
          LINIT=.TRUE.
        ELSE
          IF(ITYPE(8).NE.4.OR.ITYPE(9).NE.5) GOTO 10
          IF(UQSTRC(BUFFER,MLENB,IPOSP(9,1),IPOSP(9,2),WYES,3,1,3)) THEN
            LINIT=.TRUE.
          ELSE
            LINIT=.FALSE.
          ENDIF
        ENDIF
        IOPT=1
        CALL UQGVAL(BUFFER,MLENB,IPOSP(1,1),IPOSP(1,2),SYMTAB,
     *              MLENST,IP3,IP4,IPOINT,MNP,IER)
        IF(IER.EQ.9) THEN
          IER=0
          GOTO 3
        ENDIF
        IF(IER.NE.0) RETURN
        IP2=LENB
        IP1=LENB+1
        CALL UQINCS(BUFFER,MLENB,IP2,IP1,SYMTAB,MLENST,IP3,IP4,IER)
        IF(IER.NE.0) RETURN
    1   LSETV=.FALSE.
        IF(ITYPE(5).EQ.5) THEN
C
C STRING
C
          IF(UQSTRC(BUFFER,MLENB,IPOSP(5,1),IPOSP(5,2),WSTR,3,1,3))
     *      THEN
C
C INTEGER CONSTANT
C
          ELSEIF(UQSTRC(BUFFER,MLENB,IPOSP(5,1),IPOSP(5,2),WINT,3,1,
     *      3)) THEN
            IF(.NOT.UQINTM(BUFFER,MLENB,IP1,IP2,LSIGN,LNUM)) THEN
              I=UQIARE(BUFFER(IP1),IP2-IP1+1,IER)
              IF (IER.NE.0) THEN
                IER=0
                IF(.NOT.UQVDEF(BUFFER,MLENB,IP1,IP2,SYMTAB,MLENST,
     *             IPOINT,MNP,LP,IP,IPPRED)) GOTO 3
                ISET1=IPOINT(IP,2)+IPOINT(IP,3)
                ISET2=IPOINT(IP,4)
                IF(.NOT.UQINTM(SYMTAB,MLENST,ISET1,ISET2,LSIGN,
     *             LNUM)) THEN
                  I=UQIARE(SYMTAB(ISET1),ISET2-ISET1+1,IER)
                  IF (IER.NE.0) THEN
                    IER=0
                    GOTO 3
                  ENDIF
                ENDIF
                LSETV=.TRUE.
              ENDIF
            ENDIF
C
C REAL CONSTANT
C
          ELSEIF(UQSTRC(BUFFER,MLENB,IPOSP(5,1),IPOSP(5,2),WREAL,4,1,
     *      4)) THEN
            IF(.NOT.UQREAM(BUFFER,MLENB,IP1,IP2)) THEN
              I=UQIARE(BUFFER(IP1),IP2-IP1+1,IER)
              IF (IER.NE.0) THEN
                IER=0
                IF(.NOT.UQVDEF(BUFFER,MLENB,IP1,IP2,SYMTAB,MLENST,
     *             IPOINT,MNP,LP,IP,IPPRED)) GOTO 3
                ISET1=IPOINT(IP,2)+IPOINT(IP,3)
                ISET2=IPOINT(IP,4)
                IF(.NOT.UQREAM(SYMTAB,MLENST,ISET1,ISET2)) THEN
                  I=UQIARE(SYMTAB(ISET1),ISET2-ISET1+1,IER)
                  IF (IER.NE.0) THEN
                    IER=0
                    GOTO 3
                  ENDIF
                ENDIF
                LSETV=.TRUE.
              ENDIF
            ENDIF
          ELSE
            GOTO 10
          ENDIF
C
C LIST OF VALUES
C
        ELSEIF(ITYPE(5).EQ.6) THEN
          I=IPOSP(5,1)
   2      J=I
          CALL UQFCHR(BUFFER,MLENB,IPOSP(5,2),J,CHDS)
          IF(BUFFER(J).EQ.CHDS) J=J-1
          IF(.NOT.UQCOND(BUFFER,MLENB,I,J,BUFFER,MLENB,IP1,IP2)) THEN
            I=J+2
            IF(I.LE.IPOSP(5,2)) GOTO 2
            GOTO 3
          ENDIF
        ELSE
          GOTO 10
        ENDIF
        GOTO 6
   3    IF(DIALOG.GE.DLEVEL) THEN
C
C >>> SYSTEM DEPENDENT PART (USER INTERFACE) <<<<<<<<<<<<<<<<<<<<<<<<
C
C L IS LENGTH OF NAME + DEFAULT :   ' ? NAME (DEFAULT) ? '
C
          L=IPOSP(1,2)-IPOSP(1,1)+11
          IF(ITYPE(3).EQ.5) THEN
            CALL UQGVAL(BUFFER,MLENB,IPOSP(3,1),IPOSP(3,2),SYMTAB,
     *                  MLENST,IP5,IP6,IPOINT,MNP,IER)
            IF(IER.NE.0) RETURN
            L=L+IP6-IP5
          ELSE
            L=L+IPOSP(3,2)-IPOSP(3,1)
          ENDIF
          IF(LHELP.AND.L+10.LT.LNLEN) THEN
C
C SHOW HELP AND PAINT BOX
C
            J=(LNLEN-L)/2
            IF(ITYPE(3).EQ.5) THEN
             WRITE(OIUNIT,*) ' ',CHLU,(CHH,I=1,J),' ? ',
     *             (BUFFER(I),I=IPOSP(1,1),IPOSP(1,2)),' (',
     *             (SYMTAB(I),I=IP5,IP6),') ? ',
     *             (CHH,I=1,LNLEN-L-J),CHRU
      ELSE
              WRITE(OIUNIT,*) ' ',CHLU,(CHH,I=1,J),' ? ',
     *             (BUFFER(I),I=IPOSP(1,1),IPOSP(1,2)),' (',
     *             (BUFFER(I),I=IPOSP(3,1),IPOSP(3,2)),') ? ',
     *             (CHH,I=1,LNLEN-L-J),CHRU
      ENDIF
            WRITE(OIUNIT,*) ' ',CHV,(' ',I=1,LNLEN),CHV
            K=IPOSS1
            L=MAX(0,I-K)
            IF(L.GT.20) L=0
   4        J=K
            CALL UQFCHR(BUFFER,MLENB,IPOS1-1,J,CHEOL)
            IF(J.EQ.K) THEN
              WRITE(OIUNIT,*) ' ',CHV,(' ',I=1,LNLEN),CHV
           ELSE
              M=LNLEN-J+K+L-2
              WRITE(OIUNIT,*) ' ',CHV,'  ',(BUFFER(I),I=K+L,J-1),
     *             (' ',I=1,M),CHV
         ENDIF
            IF(J.LT.IPOS1-1) THEN
              K=J+1
              GOTO 4
            ENDIF
            WRITE(OIUNIT,*) ' ',CHV,(' ',I=1,LNLEN),CHV
            WRITE(OIUNIT,*) ' ',CHLD,(CHH,I=1,LNLEN),CHRD
          ELSE
            IF(ITYPE(3).EQ.5) THEN
              WRITE(OIUNIT,*) ' ',(BUFFER(I),I=IPOSP(1,1),IPOSP(1,2)),
     *                       ' (',(SYMTAB(I),I=IP5,IP6),') ?'
            ELSE
              WRITE(OIUNIT,*) ' ',(BUFFER(I),I=IPOSP(1,1),IPOSP(1,2)),
     *                       ' (',(BUFFER(I),I=IPOSP(3,1),IPOSP(3,2)),
     *                       ') ?'
            ENDIF
          ENDIF
C
C >>> END OF SYSTEM DEPENDENT PART <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
C
C
C READ VALUE
C
          IP2=LENB
          CALL UQRDLN(BUFFER,MLENB,IP2,I,250,IIUNIT,CHCON,CHEOL,IER)
          IF(IER.NE.0) RETURN
          IP2=IP2-1
          IF(IP2.EQ.LENB) GOTO 5
          CALL UQNXTC(BUFFER,MLENB,IP2,LENB+1,IP1)
C
C END OF DIALOGUE
C
          IF(IP1.EQ.IP2.AND.BUFFER(IP1).EQ.CHEOD) THEN
            WRITE(OIUNIT,20)
            DIALOG=0
            GOTO 5
          ELSEIF(BUFFER(IP1).EQ.CHWC.OR.BUFFER(IP2).EQ.CHWC) THEN
            GOTO 3
          ENDIF
          GOTO 1
        ENDIF
C
C DEFAULT VALUE
C
   5    IF(ITYPE(3).EQ.5) THEN
          IOPT=2
          CALL UQGVAL(BUFFER,MLENB,IPOSP(3,1),IPOSP(3,2),SYMTAB,
     *                MLENST,IP1,IP2,IPOINT,MNP,IER)
          IF(IER.NE.0) RETURN
        ELSE
          IP1=IPOSP(3,1)
          IP2=IPOSP(3,2)
        ENDIF
C
C SET VALUE TO SYMTAB
C
   6    IF(LSETV) THEN
          CALL UQSETV(BUFFER,MLENB,IPOSP(1,1),IPOSP(1,2),ISET1,ISET2,
     *                SYMTAB,MLENST,IPOINT,MNP,2,IER)
        ELSE
          CALL UQSETV(BUFFER,MLENB,IPOSP(1,1),IPOSP(1,2),IP1,IP2,
     *                SYMTAB,MLENST,IPOINT,MNP,IOPT,IER)
        ENDIF
        IF(IER.NE.0) RETURN
C
C APPEND 'VARIABLE=VALUE' TO INIT
C
        IF(LINIT) THEN
          IF(IOPT.EQ.1) THEN
            I=IP2
          ELSE
            I=LENB
          ENDIF
          J=I+1
          CALL UQINCS(BUFFER,MLENB,I,J,WINIT,4,1,4,IER)
          IF(IER.NE.0) RETURN
          BUFFER(IPOS2)=CHEOL
          CALL UQADDV(BUFFER,MLENB,J,I,IPOS2,IPOS2,
     *                SYMTAB,MLENST,IPOINT,MNP,1,IER)
          IF(IER.NE.0) RETURN
          CALL UQADDV(BUFFER,MLENB,J,I,IPOSP(1,1),IPOSP(1,2),
     *                SYMTAB,MLENST,IPOINT,MNP,1,IER)
          IF(IER.NE.0) RETURN
          BUFFER(IPOS2)='='
          CALL UQADDV(BUFFER,MLENB,J,I,IPOS2,IPOS2,
     *                SYMTAB,MLENST,IPOINT,MNP,1,IER)
          IF(IER.NE.0) RETURN
          IF(LSETV) THEN
          CALL UQADDV(BUFFER,MLENB,J,I,ISET1,ISET2,
     *                SYMTAB,MLENST,IPOINT,MNP,2,IER)
          ELSE
          CALL UQADDV(BUFFER,MLENB,J,I,IP1,IP2,
     *                SYMTAB,MLENST,IPOINT,MNP,IOPT,IER)
          ENDIF
          BUFFER(IPOS2)=CHEOL
        ENDIF
        IF(LHELP) IPOS1=IPOSS0
        LHELP=.FALSE.
      ENDIF
      RETURN
C
C ERROR: SYNTAX ERROR
C
   10 IER=20
      RETURN
   20 FORMAT(' '/' END OF DIALOGUE !')
      END
