$INTERFACE U0SDU1                                             99/12/01
$REM LU

  $N='N'
  $ADD(REAL,'\$AFO($NA)')
  $ADD(INTEGER,'\IMD\LDS\METS')
  $JARA='D'
  $GN=G
  $AGS=AG
  $AGH='AGH'
  $HELP
    TYPE OF METHOD:
      L - LINE SEARCH
      G - GENERAL TRUST REGION
  $CHECK(TYPE,'G','L\G',2,NO)
  $IF(NA=NF)
    $HELP
      MATRIX DECOMPOSITION:
        A - RECTANGULAR MATRIX
        Q - QR DECOMPOSITION
        E - LU DECOMPOSITION
    $CHECK(DECOMP,'Q','A\Q\E',2,NO)
  $ELSE
    $HELP
      MATRIX DECOMPOSITION:
        A - RECTANGULAR MATRIX
        Q - QR DECOMPOSITION
    $CHECK(DECOMP,'Q','A\Q',2,NO)
  $ENDIF
  $DEFAULT='R'
  $IF(DECOMP='A')
    $IF(NUMBER<3) $DEFAULT='C'
  $ENDIF  
  $IF(DECOMP='Q') $DEFAULT='C'
  $IF($DEF(JACA))
    $IF(JACA='D')
      $IF(NAL>0) $JASA='R'
      $HELP
        STORE OF JACOBIAN MATRIX FOR APPROXIMATED FUNCTIONS
          R - ROWWISE
          C - COLUMNWISE
      $CHECK(JASA,DEFAULT,'R\C',1,NO)
      $JASB='C'
      $POMA='$N,NA'
      $IF(JASA='C') 
        $JASB='R'
        $POMA='NA,$N'
      $ENDIF  
    $ENDIF
  $ENDIF
  $IF(TYPE='L')
    $IF(DECOMP='Q')
      $NUMBER=1
    $ELSEIF(DECOMP='A')
      $HELP
        METHOD
          1 - EXACT SOLUTION BY COMPLETE QR DECOMPOSITION
          3 - INEXACT SOLUTION BY CONJUGATE GRADIENT METHOD
          4 - INEXACT SOLUTION BY LSQR METHOD
      $CHECK(NUMBER,3,'1\3\4',2,NO)
    $ELSEIF(DECOMP='E')
      $HELP
        METHOD
          1 - EXACT SOLUTION BY COMPLETE LU DECOMPOSITION
          3 - INEXACT SOLUTION BY SMOOTHED CGS METHOD
          4 - INEXACT SOLUTION BY RESTARTED GMRES METHOD
          5 - INEXACT SOLUTION BY SMOOTHED BICGSTAB METHOD
      $CHECK(NUMBER,3,'1\3\4\5',2,NO)
    $ENDIF
  $ELSEIF(TYPE='G')
    $IF(DECOMP='Q')
      $HELP
        METHOD
          1 - SINGLE DOG-LEG STRATEGIES
          2 - MULTIPLE DOG-LEG STRATEGY
      $CHECK(NUMBER,1,'1\2',2,NO)
    $ELSEIF(DECOMP='A')
      $HELP
         METHOD
           1 - SPECIAL DOG-LEG STRATEGY
           3 - INEXACT SOLUTION BY CONJUGATE GRADIENT METHOD
           4 - INEXACT SOLUTION BY LSQR METHOD
           7 - OPTIMUM LOCALLY CONSTRAINED STEP
      $CHECK(NUMBER,3,'1\3\4\7',2,NO)
    $ELSEIF(DECOMP='E')
      $HELP
        METHOD
          1 - SPECIAL DOG-LEG STRATEGY
          2 - MULTIPLE DOG-LEG STRATEGY
          3 - INEXACT SOLUTION BY CONJUGATE GRADIENT METHOD
          4 - INEXACT SOLUTION BY RESTARTED GMRES METHOD
          5 - INEXACT SOLUTION BY SMOOTHED BICGSTAB METHOD
      $CHECK(NUMBER,3,'1\2\3\4\5',2,NO)
    $ENDIF
  $ENDIF
  $IF(TYPE='L')
    $KDS=0
    $HELP
      LINE SEARCH INTERPOLATION
        1 - BISECTION
        2 - TWO POINT QUADRATIC INTERPOLATION
        3 - THREE POINT QUADRATIC INTERPOLATION
        4 - THREE POINT CUBIC INTERPOLATION
        5 - SPECIAL BIQUADRATIC INTERPOLATION
    $CHECK(MES,4,'1\2\3\4\5',3)
    $IF(MES=5) $STEP=4
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
                0 - INITIAL STEPSIZE IS SPECIFIED IN THE CALLING PROGRAM
          -1 OR 1 - UNIT INITIAL STEPSIZE
          -2 OR 2 - COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
                    STEPSIZE (DAVIDON)
          -3 OR 3 - COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
                    STEPSIZE (STOREY )
          -4 OR 4 - QUADRATICALLY ESTIMATED INITIAL STEPSIZE
        INITS < 0 - THE PREVIOUS FUNCTION VALUE IS USED
        INITS > 0 - THE MINIMUM  FUNCTION VALUE IS USED 
    $CHECK(INITS,-2,'-4\-3\-2\-1\1\2\3\4',4)
    $HELP
      CONTROLLING OF THE INITIAL STEPSIZE:
        0-NO CONTROLLING OF THE INITIAL STEPSIZE
        1-CONTROLLING BASED ON THE FUNCTION DECREASE
        2-CONTROLLING BASED ON THE DIRECTION VECTOR
        3-CONTROLLING BASED ON THE NUMBER OF FUNCTIONS
    $CHECK(ISTEP,0,'0\1\2\3',4,NO)
    $HELP
      LOWER BOUND FOR STEPSIZE PARAMETER
    $CHECK(ALF1,'1.0$P-15',REAL,4)
  $ELSE
    $HELP
      MAXIMUM NUMBER OF ZERO STEPS IN ONE ITERATION
    $CHECK(MRED,5,INT,4)
    $ISTEP=0
    $HELP
      LINE SEARCH
        1 - FOR MINIMIZATION
        3 - FOR NONLINEAR EQUATIONS
    $CHECK(STEP,1,'1\3',4,NO)
    $HELP
      DECISION AFTER ZERO STEP
        0 - NEW DIRECTION DETERMINATION
        1 - CONTINUATION OF THE ITERATION
    $CHECK(MOT3,0,'0\1',4)
  $ENDIF
  $IF(DECOMP='E')
$REM  $IF(NUMBER<3)
    $HELP
      TYPE OF UPDATE
        A - ADJOINT BROYDEN'S UPDATE
        B - BROYDEN'S UPDATE
        N - NO UPDATE
    $CHECK(UPDATE,'B','A\B\NO\N',3,NO)
    $IF(UPDATE='N') $UPDATE='NO'
$REM  $ELSE
$REM    $UPDATE='NO'
$REM  $ENDIF    
  $ELSEIF(DECOMP='A')
    $HELP
      TYPE OF UPDATE
        B - BROYDEN'S UPDATE
        X - XU'S HYBRID UPDATE
        N - NO UPDATE
    $CHECK(UPDATE,'N','B\X\NO\N',3,NO)
    $IF(UPDATE='B') $UPDATE='NO'
  $ELSEIF(DECOMP='Q')
    $HELP
      TYPE OF UPDATE
        A - ADJOINT BROYDEN'S UPDATE
        B - BROYDEN'S UPDATE
        X - XU'S HYBRID UPDATE
        N - NO UPDATE
    $CHECK(UPDATE,'B','A\B\X\NO\N',3,NO)
    $IF(UPDATE='N') $UPDATE='NO'
  $ENDIF
  $IPOM2=0
  $IF(UPDATE='A')
    $HELP
      UPDATE OF THE JACOBIAN MATRIX:
        1 - BASIC RESIDUAL ADJOINT UPDATE
        2 - NEW BROYDEN'S UPDATE
        3 - SECANT RESIDUAL ADJOINT UPDATE
        4 - TWO-SIDED RESIDUAL ADJOINT UPDATE
    $CHECK(MET,2,'1\2\3\4',3)
    $GG='GG'
    $ADD(REAL,'\$GG($NF)')
    $ADD(INTEGER,'\KH')
    $IF(MET=4)
      $ADD(REAL,'\$GP($NF)')
      $TRANSJAC='YES'
    $ENDIF
    $IPOM2=1
  $ELSEIF(UPDATE='B')
    $IPOM2=1
    $IF(DECOMP='A')
      $HELP
        UPDATE OF THE JACOBIAN MATRIX:
          1 - GOOD BROYDEN'S UPDATE
          2 - COLUMN UPDATE
      $CHECK(MET,1,'1\2',3)
    $ELSE
      $HELP
        UPDATE OF THE JACOBIAN MATRIX:
          1 - GOOD BROYDEN'S UPDATE
          2 - COLUMN UPDATE
          3 - GREENSTADT'S UPDATE
          4 - FIRST TODD'S OPTIMAL UPDATE
          5 - SECOND TODD'S OPTIMAL UPDATE
      $CHECK(MET,1,'1\2\3\4\5',3)
    $ENDIF
    $HELP
      CHOICE OF THE INITIAL APPROXIMATION
        1 - UNIT INITIAL APPROXIMATION
        3 - JACOBIAN MATRIX
    $CHECK(INITH,3,'1\3',3)
  $ELSEIF(UPDATE='F')
    $IPOM2=2
    $HELP
      UPDATE OF THE HESSIAN MATRIX:
        1 - BFGS UPDATE
        2 - DFP  UPDATE
        3 - RANK-ONE UPDATE
    $CHECK(MET,1,'1\2\3',3)
  $ELSEIF(UPDATE='X')
    $IPOM2=3
    $IF(DECOMP='A')
      $HELP
        UPDATE OF THE JACOBIAN MATRIX:
          1 - GOOD BROYDEN'S UPDATE
          2 - COLUMN UPDATE
      $CHECK(MET,1,'1\2',3)
    $ELSE
      $HELP
        UPDATE OF THE JACOBIAN MATRIX:
          1 - GOOD BROYDEN'S UPDATE
          2 - COLUMN UPDATE
          3 - GREENSTADT'S UPDATE
          4 - FIRST TODD'S OPTIMAL UPDATE
          5 - SECOND TODD'S OPTIMAL UPDATE
      $CHECK(MET,1,'1\2\3\4\5',3)
    $ENDIF
$REM  $ELSEIF(UPDATE='S')
$REM    $HELP
$REM      UPDATE OF THE HESSIAN MATRIX:
$REM        1 - BFGS UPDATE
$REM        2 - DFP  UPDATE
$REM        3 - RANK-ONE UPDATE
$REM    $CHECK(MET,1,'1\2\3',3)
  $ENDIF
  $DOUBLE=UPDATE
  $IF(DECOMP='A')
    $IF(NUMBER<3)
    $ELSE
      $DOUBLE='NO'
    $ENDIF  
  $ELSEIF(DECOMP='E')
    $DOUBLE='NO'
  $ELSEIF(DECOMP='Q') 
    $DOUBLE='NO'
  $ENDIF  
  $HELP
    CHOICE OF THE SCALING MATRIX:
      0 - UNIT MATRIX (NO SCALING)
      1 - SQUARE OF THE MATRIX H DIAGONAL
  $CHECK(MOS1,0,'0\1',4)
  $ISNF=0
  $ISNA=3
  $ADD(INIT)
    ISNA=3
  $ENDADD
  NDECF=0
  IPOM2=$IPOM2
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $MAL=NA
   MAL=NA
  $JOB=1
  $IF(NORMA>0) $SUBST('UANRL1')
  $IF(NORMF>0) $SUBST('UATRL1')
  $IF(NCL>0)
    $MCL=NCL
     MCL=NCL
    $ISNC=3
    $ADD(INIT)
      ISNC=3
    $ENDADD
    $JOB=1
    $IF(NORMC>0) $SUBST('UCNRL1')
    $IF(NORMF>0) $SUBST('UCTRL1')
    $SUBST('UCLNF2')
  $ENDIF
  $IF(CONSTR<>'U') $SUBST('UYFP$(CONSTR)1')
*
*     -------------------
*     QUASI-NEWTON METHOD
*     TEMPLATE : U0SDU1
*     -------------------
*
  $LMD=$10
  ASSIGN $20 TO IMD
  CALL UYPRO1('UXFU',0)
  CALL UYPRO3(1)
  IF (INITH.EQ.1) THEN
  CALL UXDRMI(NF,NF,AG)
  IREST=0
  ENDIF
  MOT=0
  T=ZERO
  FO=FMIN
  IPOM1=0
  METS=MET
$L=$10 ; $LABEL
  $IF(UPDATE='NO')
  $ELSEIF(UPDATE='B')
  $ELSEIF(UPDATE='X')
  $ELSE
    $GH=G
    $G=GG
    KH=KD
    KD=1
  $ENDIF
  $KD=0
  $SUBST('UZMODL')
  $IF(UPDATE='NO')
  $ELSEIF(UPDATE='B')
  $ELSEIF(UPDATE='X')
  $ELSE
    $G=GH
    KD=KH
    LD=KD
    IF (KD.GT.0) CALL UXVCOP(NF,$GG,$G)
  $ENDIF 
  GO TO IMD
$L=$20 ; $LABEL
  N=NF
  $SUBST('UO2FU3')
  $SUBST('UYFUT1')
  IF(ITERM.NE.0) GOTO $90
  $IF(CONSTR<>'U') $SUBST('UYRM$(CONSTR)0')
  $IF(ISTEP=2)
    DMAX=R*SNORM
  $ENDIF
$L=$30 ; $LABEL
$REM  $IF(UPDATE='S')
$REM    $SUBST('UUDRD2')
$REM  $ELSE
  $SUBST('UUDRD1')
$REM  $ENDIF
  IF(ITERM.NE.0) GOTO $90
  $MAT='G'
  $IF(DECOMP='Q')
    $IF(NUMBER=2) $MAT='D'
    $IF(NUMBER=7) $MAT='D'
  $ENDIF
  $DEC=DECOMP
  $DECOMG=DEC
  $IF(NUMBER=1) $DECOMG='A'
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UD$(MAT)$(TYPE)$(DECOMG)$(NUMBER)
*     -----------------------
*
  $IF(DOUBLE='NO')
    $SUBST('UD$(MAT)$(TYPE)$(DECOMG)$(NUMBER)')
  $ELSE
    CALL UXVCOP(NA*NF,AG,BG)
    $AG='BG'
    $SUBST('UD$(MAT)$(TYPE)$(DECOMG)$(NUMBER)')
    $AG='AG'
    IDECA=0
  $ENDIF
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $IF(DECOMP<>'E')
    P=UXVDOT(N,S,G)
    $ADD(REAL,'\UXVDOT')
  $ENDIF
  $SUBST('UD1T$(TYPE)1')
  IF(ITERM.NE.0) GOTO $90
  IF(IREST.NE.0) GOTO $30
  LDS=LD
$L=$50 ; $LABEL
  $IF(ISTEP>0)
    CALL UYSET4(NF,NA,INITS,ISTEP,F,FO,SNORM,DMAX)
  $ENDIF
  $SUBST('UYTR$(CONSTR)S')
    CALL UXVCOP(NA,$AF,$AFO)
$L=$60 ; $LABEL
  ASSIGN $60 TO IMD
  $SUBST('UZLINS')
  GOTO ($64,$62) ISB+1
$L=$ 62 ; $LABEL
  CALL UXVDIR(NF,R,$S,$XO,$X)
  GOTO $10
$L=$ 64 ; $LABEL
  IF (ITERS.LE.0) THEN
  $SUBST('UYZER0')
  $IF(TYPE='L')
    CALL UXVCOP(NA,$AFO,$AF)
  $ELSE
    IF (MOT3.LE.0) CALL UXVCOP(NA,$AFO,$AF)
  $ENDIF
  IF(IDIR.EQ.0) THEN
  CALL UYRES1(TSXX)
  LD=LDS
  GO TO $30
  ELSE IF (MOT3.EQ.0) THEN
  LD=LDS
  GO TO $30
  ELSE
  ITERD=0
  ENDIF
  ENDIF
  IF (IPOM2.GT.0) THEN
  $SUBST('UUDRV1')
  ENDIF
  IF (IPOM1.EQ.1) KD=1
  IF(KD.GT.LD) THEN
  ASSIGN $80 TO IMD
  GO TO $10
  ENDIF
$L=$80 ; $LABEL
  KD=0
  TXFU = TUXX
$REM  $IF(UPDATE<>'NO')
$REM    $IHLP=1
$REM    $IF(MET>2) $IHLP=2
$REM  $ENDIF
  $IF(UPDATE='A')
    IF(IPOM1.EQ.2) THEN
    $SUBST('UYTR$(CONSTR)F')
    $SUBST('UUDBA2')
    ELSE
    $SUBST('UYTRUD')
    ENDIF
  $ELSEIF(UPDATE='B')
    IF(IPOM1.EQ.2) THEN
    $SUBST('UYTR$(CONSTR)F')
    $SUBST('UUDBA1')
    ELSE
    $SUBST('UYTRUD')
    ENDIF
  $ELSEIF(UPDATE='F')
    IF(IPOM1.EQ.1) THEN
    $SUBST('UYTR$(CONSTR)D')
    $SUBST('UUDGA1')
    ELSE
    $SUBST('UYTRUD')
    ENDIF
  $ELSEIF(UPDATE='X')
    $METS=MET
    IF(IPOM1.EQ.1) THEN
    $MET=1
    $SUBST('UYTR$(CONSTR)D')
    $SUBST('UUDGA1')
    ELSEIF(IPOM1.EQ.2) THEN
    $MET=METS
    $SUBST('UYTR$(CONSTR)F')
    $SUBST('UUDBA1')
    ELSE
    $SUBST('UYTRUD')
    ENDIF
$REM  $ELSEIF(UPDATE='S')
$REM    $SUBST('UYTR$(CONSTR)B')
$REM    $AG=AGH
$REM    $SUBST('UUDBA2')
$REM    $AG=AGS
  $ELSE
    IREST=1
    $SUBST('UYTRUD')
  $ENDIF
  $IF(CONSTR<>'U')
    IF (IDIR.EQ.0) THEN
    $SUBST('UYAD$(CONSTR)0')
    ENDIF
  $ENDIF
  MET=METS
  IF(IDIR.EQ.0) THEN
  IF(ITERH.NE.0) CALL UYRES1('UPDATE  ')
  GOTO $20
  ELSE
  GOTO $30
  ENDIF
$L=$90 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(0)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMA>0) $SUBST('UANRL1')
  $ENDIF
  $IF(NCL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UCTRL1')
    $IF(NORMC>0) $SUBST('UCNRL1')
  $ENDIF
  $SUBST('UO1FU2')
  $ADD(INIT)
    NXFU='U0SDU1'
  $ENDADD
  $EXIT
