$INTERFACE U1EDD1                                             94/12/01
$REM LU

  $N='N'
  $SCAN='NO'
$REM  $SCANING='0'
  $HELP
    TYPES OF ORDINARY DIFFERENTIAL EQUATIONS
      GENERAL  - GENERAL ODE
      NONSTIFF - NONSTIFF ODE
      STIFF    - STIFF ODE
  $CHECK(ODE,'GENERAL','GENERAL\NONSTIFF\STIFF',2,NO)
  $IF(ODE='GENERAL')
    $HELP
      TYPE OF METHOD
        DP5 - DORMAN PRINCE OF THE 5'TH ORDER
        DP8 - DORMAN PRINCE OF THE 8'TH ORDER
        EX1 - EXTRAPOLATION USING MIDPOINT RULE
        RD5 - RADAU OF THE 5'TH ORDER
        RS4 - ROSENBROCK OF THE 4'TH ORDER
    $CHECK(SOLVER,'DP8','DP5\DP8\EX1\RD5\RS4',2,NO)
  $ELSEIF(ODE='NONSTIFF')
    $HELP
      TYPE OF METHOD
        DP5 - DORMAN PRINCE OF THE 5'TH ORDER
        DP8 - DORMAN PRINCE OF THE 8'TH ORDER
        EX1 - EXTRAPOLATION USING MIDPOINT RULE
    $CHECK(SOLVER,'DP8','DP5\DP8\EX1',2,NO)
  $ELSE
    $HELP
      TYPE OF METHOD
        RD5 - RADAU OF THE 5'TH ORDER
        RS4 - ROSENBROCK OF THE 4'TH ORDER
    $CHECK(SOLVER,'RD5','RD5\RS4',2,NO)
  $ENDIF
  $CLASS='DE'
  $IF(SOLVER='DP5')
    $TYPE='D'
    $DECOMP='P'
    $NUMBER=5
  $ELSEIF(SOLVER='DP8')
    $TYPE='D'
    $DECOMP='P'
    $NUMBER=8
  $ELSEIF(SOLVER='EX1')
    $TYPE='E'
    $DECOMP='X'
    $NUMBER=1
  $ELSEIF(SOLVER='RD5')
    $TYPE='R'
    $DECOMP='D'
    $NUMBER=5
  $ELSEIF(SOLVER='RS4')
    $TYPE='R'
    $DECOMP='S'
    $NUMBER=4
  $ENDIF
  $POM='V'
  $IF(SOLVER='RD5') $POM='D'
  $IF(SOLVER='RS4') $POM='D'
  $HELP
    OUTPUT SPECIFICATION
      1 - OUTPUT IN ALL INTEGRATION STEPS
      2 - OUTPUT IN PRESCRIBED MESH POINTS
  $CHECK(MED,1,'1\2',4)
  $HELP
    STEP SELECTION
      1 - STEP SELECTION FROM LOCAL TRUNCATION ERROR
      2 - STEP SELECTION FROM PRESCRIBED MESH POINTS
  $CHECK(MED1,1,'1\2',4)
  $HELP
    NUMBER OF MESH POINTS
  $CHECK(NA,2,INT,1)
  $REPEAT
    $HELP
      NUMBER OF EQUATIONS
    $CHECK(NE,0,INT,1)
    $IF(NE<1)
      $IF(DIALOG>0)
        $ERASE(NE)
      $ELSE
        $ERROR: 'NE' - NUMBER OF EQUATIONS WAS NOT SPECIFIED
        $STOP
      $ENDIF
    $ENDIF
  $UNTIL($DEF(NE))
  $MEL=NE
  $MED2=0
  $ADD(SINID)
    MEL=NE
  $ENDADD
  $LET=$30
  $LEX=$20
  $LED=$10
  $LES=$00
  $ADD(REAL,'\$X($NX)')
  $SUBST('UO0FU1')
*     -----------------------
*     ODE INTEGRATION METHODS
*     TEMPLATE : U1EDD1
*     -----------------------
  CALL UYPRO1('UXFU',1)
$L=$00 ; $LABEL
*
*     -----------------
*     ODE SOLVER
*     TEMPLATE : UE$(POM)$SOLVER
*     -----------------
  $SUBST('UE$(POM)$SOLVER')
$L=$10 ; $LABEL
  $KD=0
  $SUBST('UE0F01')
  GOTO $00
  $IF(POM='D')
$L=$20 ; $LABEL
    $SUBST('UE1F01')
    GOTO $00
  $ENDIF
$L=$30 ; $LABEL
  IF (IER.LT.0) THEN
  ITERM=MAX(-96,-90+IER)
  CALL UOERR1('U1EDD1',-ITERM)
  ENDIF
  CALL UYEPI1(1)
  $IF(MED=1)
    NA=KA-1
  $ENDIF
  $SUBST('UO1EU2')
  $IF(MED=2)
    $ADD(SINID)
      CALL UESET1(NA,$AT,TA,TAMAX,HEMAX)
    $ENDADD
  $ELSEIF(MED1=2)
    $ADD(SINID)
      CALL UESET1(NA,$AT,TA,TAMAX,HEMAX)
    $ENDADD
  $ENDIF
  $IF(MED>0)
    $ADD(SINID)
      CALL UESET2(NA,NE,$AT,$AY,$YA,TA)
    $ENDADD
  $ENDIF
  $ADD(INIT)
    NXFU='U1EDD1'
  $ENDADD
  $EXIT
