$INTERFACE U1FSU2                                             97/12/01
$REM LU

$REM  $N='N'
  $N='NF'
  $HERF='V'
  $ADD(INTEGER,'\IMD')
  $ISNF=0
  $ITRG=1
  $IF(CONSTR='S')
    $CONSTR='C'
    $ADD(REAL,'\UXUDOT')
  $ELSE
    $ADD(REAL,'\UXVDOT')
  $ENDIF
  $ADD(INIT)
    MOT=1
  $ENDADD
  $UPDATE='NO'
  $HELP
    TYPE OF METHOD:
      L - LINE SEARCH
      G - GENERAL TRUST REGION
  $CHECK(TYPE,'L','L\G',2,NO)
  $DECOMP='M'
  $IF(TYPE='L')
    $HELP
      METHOD
        3 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
    $CHECK(NUMBER,3,'\3',2,NO)
    $IF(NUMBER=3)
      $HELP
        PRECONDITIONING TECHNIQUE:
          ABS(MOS2)=0 - PRECONDITIONING IS SUPPRESSED
          ABS(MOS2)=1 - PRECONDITIONING BY THE LM-VM VECTOR UPDATE
          ABS(MOS2)=2 - PRECONDITIONING BY THE LM-VM MATRIX UPDATE
          ABS(MOS2)=3 - DIAGONAL PRECONDITIONING
          ABS(MOS2)=4 - TRIDIAGONAL PRECONDITIONING
          ABS(MOS2)=5 - PENTADIAGONAL PRECONDITIONING
          ABS(MOS2)=6 - PRECONDITIONING BY THE LANCZOS METHOD
          MOS2 < 0 - PRECONDITIONED ITERATIVE PROCESS
          MOS2 > 0 - PRELIMINARY INEXACT SOLUTION FOLLOWED
                     BY THE PRECONDITIONED ITERATIVE PROCESS
      $CHECK(MOS2,0,'-5\-4\-3\-2\-1\0\1\2\3\4\5\6',2)
      $NOS2=MOS2
      $IF(MOS2=-1) $NOS2=1
      $IF(MOS2=-2) $NOS2=2
      $IF(MOS2=-3) $NOS2=3
      $IF(MOS2=-4) $NOS2=4
      $IF(MOS2=-5) $NOS2=5
      $IF(MOS2=-6) $NOS2=6
      $NOS3=0
      $IF(NOS2=6)
        $MOS1=0
        $HELP
          DIMENSION OF THE LANCZOS TRIDIAGONAL MATRIX
        $CHECK(MOS3,5,INT,3)
$REM        $MOS5=1
        $HELP
          TYPE OF PRECONDITIONING
            1 - PRECONDITIONING IN THE SAME ITERATION
            2 - PRECONDITIONING IN THE NEXT ITERATION
        $CHECK(MOS5,1,'\1\2',3)
      $ELSEIF(NOS2>2)
        $HELP
          THE USE OF PRECONDITIONING
            MOS1=0 - PERMANENT PRECONDITIONING
            MOS1>0 - UNPRECONDITIONED METHOD IS USED IF NRED<MOS1
        $CHECK(MOS1,0,INT,3,NO)
        $IF(MOS1<0)
          $MOS1=0
        $ELSEIF(MOS1=0)
        $ELSEIF(MOS1<5)
          $MOS1=10
        $ENDIF
        $IF(MOS1>0)
          $ADD(INTEGER,'\IPREC')
        $ENDIF
        $HELP
          TYPE OF THE BAND MATRIX DETERMINANTION
            -1 - ANALYTICAL DIFFERENTIATION
             1 - NUMERICAL  DIFFERENTIATION
             2 - INNER BFGS UPDATE
             3 - OUTER BFGS UPDATE
        $CHECK(MOS3,1,'-1\1\2\3',3)
        $NOS3=MOS3
        $IF(MOS3<0) $NOS3=1
        $IF(MOS3=2)
          $HELP
            NUMBER OF INNER BFGS UPDATES
            IF MET3=0 THEN THIS NUMBER IS INFINITY
          $CHECK(MET3,0,INT,3)
          $HELP
            METHOD OF UPDATE OF HESSIAN MATRIX:
              1 - BFGS UPDATE
              2 - DFP UPDATE
              3 - HOSHINO UPDATE
              4 - RANK-ONE UPDATE
          $CHECK(MET,1,'1\2\3\4',3)
        $ELSEIF(MOS3=3)
          $MET=1
          $ADD(INIT)
            MET=1
          $ENDADD
        $ENDIF
      $ELSEIF(NOS2>0)
        $ADD(INTEGER,'\MX')
        $MOS1=0
      $ENDIF
    $ELSE
      $MOS1=0
      $MOS2=0
      $NOS2=0
    $ENDIF
  $ELSE
    $HELP
       METHOD
         3 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
         4 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
             WITH THE LANCZOS STEPS
         5 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
             WITH THE LANCZOS STEPS
         6 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
             WITH THE LANCZOS STEPS
    $CHECK(NUMBER,3,'\3\4\5\6',2,NO)
    $IF(NUMBER=3)
      $HELP
        PRECONDITIONING TECHNIQUE:
          ABS(MOS2)=0 - PRECONDITIONING IS SUPPRESSED
          ABS(MOS2)=1 - PRECONDITIONING BY THE LM-VM VECTOR UPDATE
          ABS(MOS2)=2 - PRECONDITIONING BY THE LM-VM MATRIX UPDATE
          ABS(MOS2)=3 - DIAGONAL PRECONDITIONING
          ABS(MOS2)=4 - TRIDIAGONAL PRECONDITIONING
          ABS(MOS2)=5 - PENTADIAGONAL PRECONDITIONING
          ABS(MOS2)=6 - PRECONDITIONING BY THE LANCZOS METHOD
          MOS2 < 0 - PRECONDITIONED ITERATIVE PROCESS
          MOS2 > 0 - PRELIMINARY INEXACT SOLUTION FOLLOWED
                     BY THE PRECONDITIONED ITERATIVE PROCESS
      $CHECK(MOS2,0,'-5\-4\-3\-2\-1\0\1\2\3\4\5\6',2)
      $NOS2=MOS2
      $IF(MOS2=-1) $NOS2=1
      $IF(MOS2=-2) $NOS2=2
      $IF(MOS2=-3) $NOS2=3
      $IF(MOS2=-4) $NOS2=4
      $IF(MOS2=-5) $NOS2=5
      $IF(MOS2=-6) $NOS2=6
      $IF(NOS2=6)
        $HELP
          DIMENSION OF THE LANCZOS TRIDIAGONAL MATRIX
        $CHECK(MOS3,5,INT,3)
$REM        $MOS5=1
        $HELP
          TYPE OF PRECONDITIONING
            1 - PRECONDITIONING IN THE SAME ITERATION
            2 - PRECONDITIONING IN THE NEXT ITERATION
        $CHECK(MOS5,1,'\1\2',3)
      $ELSEIF(NOS2>2)
        $HELP
          THE USE OF PRECONDITIONING
            MOS1=0 - PERMANENT PRECONDITIONING
            MOS1>0 - UNPRECONDITIONED METHOD IS USED IF NRED<MOS1
        $CHECK(MOS1,0,INT,3,NO)
        $IF(MOS1<0)
          $MOS1=0
        $ELSEIF(MOS1=0)
        $ELSEIF(MOS1<5)
          $MOS1=10
        $ENDIF
        $IF(MOS1>0)
          $ADD(INTEGER,'\IPREC')
        $ENDIF
        $HELP
          TYPE OF THE BAND MATRIX DETERMINANTION
            -1 - ANALYTICAL DIFFERENTIATION
             1 - NUMERICAL  DIFFERENTIATION
             2 - INNER BFGS UPDATE
             3 - OUTER BFGS UPDATE
        $CHECK(MOS3,1,'-1\1\2\3',3)
        $NOS3=MOS3
        $IF(MOS3<0) $NOS3=1
        $IF(MOS3=2)
          $HELP
            NUMBER OF INNER BFGS UPDATES
            IF MET3=0 THEN THIS NUMBER IS INFINITY
          $CHECK(MET3,0,INT,3)
          $HELP
            METHOD OF UPDATE OF HESSIAN MATRIX:
              1 - BFGS UPDATE
              2 - DFP UPDATE
              3 - HOSHINO UPDATE
              4 - RANK-ONE UPDATE
          $CHECK(MET,1,'1\2\3\4',3)
        $ELSEIF(MOS3=3)
          $HELP
            NUMBER OF INNER BFGS UPDATES
            IF MET3=0 THEN THIS NUMBER IS ZERO
          $CHECK(MET3,0,INT,3)
          $MET=1
          $ADD(INIT)
            MET=1
          $ENDADD
        $ENDIF
      $ELSEIF(NOS2>0)
        $ADD(INTEGER,'\MX')
        $MOS1=0
      $ENDIF
    $ELSE
      $MOS1=0
      $MOS2=0
      $NOS2=0
    $ENDIF
  $ENDIF
  $ADD(INIT)
    MOS1=$MOS1
  $ENDADD
  $IF(NOS2=1)
    $XM='XM'
    $GM='GM'
    $HELP
      NUMBER OF BFGS CORRECTIONS
    $CHECK(MF,3,INT,2,NO)
    $ADD(INIT)
      MF=$MF
    $ENDADD
    $HELP
      REALIZATION OF THE L-BFGS UPDATE
        1 - BFGS UPDATE
        2 - HU STOREY UPDATE
        3 - MODIFIED BFGS UPDATE THAT USES THE PREVIOUS VECTORS
        4 - MODIFIED BFGS UPDATE THAT USES ORTHOGONAL VECTORS
    $CHECK(MOS3,1,'1\2\3\4',1)
    $ADD(REAL,'\A\B')
    $ADD(REAL,'\$XM($NF*$MF)\$GM($NF*$MF)')
    $IF(MOS3=1)
      $U1='U1'
      $U2='U2'
      $ADD(REAL,'\$U1($MF)\$U2($MF)')
    $ELSEIF(MOS3=2)
      $U1='U1'
      $U2='U2'
      $XP='XP'
      $GP='GP'
      $D='D'
      $ADD(REAL,'\$U1($MF)\$U2($MF)')
      $ADD(REAL,'\$XP($NF*$MF)\$GP($NF*$MF)\$D($NF)')
    $ELSE
      $XR='XR'
      $GR='GR'
      $ADD(REAL,'\$XR($MF)\$GR($MF)')
    $ENDIF
  $ELSEIF(NOS2=2)
    $XM='XM'
    $GM='GM'
    $U1='U1'
    $U2='U2'
    $U3='U3'
    $GR='GR'
    $HR='HR'
    $IHR='IHR'
    $HELP
      NUMBER OF BFGS CORRECTIONS
    $CHECK(MF,3,INT,2,NO)
    $ADD(INIT)
      MF=$MF
    $ENDADD
    $ADD(REAL,'\$XM($NF*$MF)\$GM($NF*$MF)\$U1($MF)\$U2($MF)')
    $ADD(REAL,'\$GR($MF*($MF+1)/2)\$HR($MF*($MF+1)/2)')
    $HELP
      REALIZATION OF THE L-BFGS UPDATE
        1 - EXPLICITLY DERIVED MATRICES
        2 - RECURSIVE DERIVED MATRICES
    $CHECK(MOS3,1,'1\2',1)
    $IF(MOS3=1)
      $HELP
        METHOD OF UPDATE OF HESSIAN MATRIX:
          1 - BFGS UPDATE
          4 - SAFEGUARDED RANK ONE UPDATE
      $CHECK(MET,1,'1\4',3)
    $ELSEIF(MOS3=2)
      $HELP
        METHOD OF UPDATE OF HESSIAN MATRIX:
          1 - BFGS UPDATE
          2 - DFP UPDATE
          3 - HOSHINO UPDATE
          4 - SAFEGUARDED RANK ONE UPDATE
          5 - OPTIMALLY CONDITIONED UPDATE
          6 - SIMPLE PRECONVEX UPDATE
          7 - VARIATIONALLY DERIVED PRECONVEX UPDATE
          8 - NEW COMBINED UPDATE
      $CHECK(MET,1,'1\2\3\4\5\6\7\8',3)
      $IF(MET=7)
        $HELP
          PARAMETER ETA FOR VARIABLE METRIC UPDATES
        $CHECK(ETA3,'1.0$P 0',REAL,3)
      $ENDIF
    $ENDIF
  $ELSEIF(NOS2=3)
    $D='D'
    $ADD(REAL,'\$D($NF)\$XS($NF)')
    $IF(MOS3>1)
      $DD='DD'
      $DDU=DD
      $DDV=DD
      $ADD(REAL,'\$DD($NF)')
    $ENDIF
  $ELSEIF(NOS2=4)
    $D='D'
    $DU='DU'
    $ADD(REAL,'\$D($NF)\$DU($NF)\$XS($NF)')
    $IF(MOS3>1)
      $DD='DD'
      $DDU='DDU'
      $DDV=DD
      $ADD(REAL,'\$DD($NF)\$DDU($NF)')
    $ENDIF
  $ELSEIF(NOS2=5)
    $D='D'
    $DU='DU'
    $DV='DV'
    $ADD(REAL,'\$D($NF)\$DU($NF)\$DV($NF)\$XS($NF)')
    $IF(MOS3>1)
      $DD='DD'
      $DDU='DDU'
      $DDV='DDV'
      $ADD(REAL,'\$DD($NF)\$DDU($NF)\$DDV($NF)')
    $ENDIF
  $ELSEIF(NOS2=6)
    $D='D'
    $DU='DU'
    $GM='GM'
$REM    $XM='XM'
$REM    $IF(MOS5=1)
$REM      $DD=D
$REM      $DDU=DU
$REM      $XM=GM
$REM    $ELSE
$REM      $DD='DD'
$REM      $DDU='DDU'
$REM      $ADD(REAL,'\$DD($MOS3)\$DDU($MOS3)')
$REM    $ENDIF
    $ADD(REAL,'\$GM($NF*$MOS3)\$D($MOS3)\$DU($MOS3)&
    \$XS($NF)')
  $ENDIF
  $IF(TYPE='L')
    $HELP
      TOLERANCE FOR DESCENT DIRECTION
    $CHECK(EPS0,'1.0$P-3',REAL,4)
    $DEFAULT=2
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
                0 - INITIAL STEPSIZE IS SPECIFIED IN THE CALLING PROGRAM
          -1 OR 1 - UNIT INITIAL STEPSIZE
          -2 OR 2 - COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
                    STEPSIZE (DAVIDON)
          -3 OR 3 - COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
                    STEPSIZE (STOREY )
          -4 OR 4 - QUADRATICALLY ESTIMATED INITIAL STEPSIZE
        INITS < 0 - THE PREVIOUS FUNCTION VALUE IS USED
        INITS > 0 - THE MINIMUM  FUNCTION VALUE IS USED
    $CHECK(INITS,DEFAULT,'-4\-3\-2\-1\0\1\2\3\4',4)
  $ENDIF
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $IF(NAL>0)
    $MAL=NAL
     MAL=NAL
    $JOB=1
    $IF(NORMA>0) $SUBST('UANRL1')
  $ENDIF
  $IF(NCL>0)
    $MCL=NCL
     MCL=NCL
    $ISNC=3
    $ADD(INIT)
      ISNC=3
    $ENDADD
    $JOB=1
    $IF(NORMC>0) $SUBST('UCNRL1')
    $IF(NORMF>0) $SUBST('UCTRL1')
    $SUBST('UCLNF2')
  $ENDIF
  $IF(CONSTR='C') $SUBST('UYFPC1')
*
*     -----------------------
*     TRUNCATED NEWTON METHOD
*     TEMPLATE : U1FSU2
*     -----------------------
*
  $LMD=$10
  ASSIGN $20 TO IMD
  CALL UYPRO1('UXFU',1)
$REM  $IF(NOS2=0)
  $IF(.FALSE.)
    CALL UYPRO3(0)
    FO=FMIN
  $ELSE
    CALL UYPRO2(FMIN,FO)
  $ENDIF
  $IF(NOS2=3)
    $IF(NOS3=1)
      $IF(MOS1=0)
        KD=2
      $ELSE
        IPREC=0
        KD=1
        IF (IPREC.EQ.1) KD=2
      $ENDIF
    $ELSE
      CALL UXVSET($N,ONE,$DD)
    $ENDIF
  $ELSEIF(NOS2=4)
    $IF(NOS3=1)
      $IF(MOS1=0)
        KD=2
      $ELSE
        IPREC=0
        KD=1
        IF (IPREC.EQ.1) KD=2
      $ENDIF
    $ELSE
      CALL UXVSET($N,ONE,$DD)
      CALL UXVSET($N,ZERO,$DDU)
    $ENDIF
  $ELSEIF(NOS2=5)
    $IF(NOS3=1)
      $IF(MOS1=0)
        KD=2
      $ELSE
        IPREC=0
        KD=1
        IF (IPREC.EQ.1) KD=2
      $ENDIF
    $ELSE
      CALL UXVSET($N,ONE,$DD)
      CALL UXVSET($N,ZERO,$DDU)
      CALL UXVSET($N,ZERO,$DDV)
    $ENDIF
  $ELSE
    MX=0
    NOS2=0
    IDECF=-1
    $ADD(INTEGER,'\NOS2')
  $ENDIF
$L=$10 ; $LABEL
  $KD=1
  $IF(MOS3<0) $KD=2
  $SUBST('UZMODN')
  KD=1
  $IF(KDS<1)
  $ELSEIF(CONSTR='C')
    IF (TSS(NS).EQ.'USXX') P=UXUDOT(NF,$G,$S,$IX,KBF)
  $ELSE
    IF (TSS(NS).EQ.'USXX') P=UXVDOT(NF,$G,$S)
  $ENDIF
  GO TO IMD
$L=$20 ; $LABEL
  $SUBST('UYTR$(CONSTR)G')
  $SUBST('UO2FU3')
  $SUBST('UYFUT1')
  IF (ITERM.NE.0) GO TO $80
  $IF(CONSTR='C')
    $SUBST('UYRM$(CONSTR)0')
$REM    IF (IOLD.NE.0) MX=0
  $ENDIF
$L=$30 ; $LABEL
  CALL UXVCOP(NF,$X,$XO)
  $IF(NOS2<3)
  $ELSEIF(NOS2=3)
    $IF(MOS3>1)
      CALL UXVCOP($N,$DD,$D)
      IDECF=0
    $ENDIF
  $ELSEIF(NOS2=4)
    $IF(MOS3>1)
      CALL UXVCOP($N,$DD,$D)
      CALL UXVCOP($N,$DDU,$DU)
      IDECF=0
    $ENDIF
  $ELSEIF(NOS2=5)
    $IF(MOS3>1)
      CALL UXVCOP($N,$DD,$D)
      CALL UXVCOP($N,$DDU,$DU)
      CALL UXVCOP($N,$DDV,$DV)
      IDECF=0
    $ENDIF
$REM  $ELSEIF(MOS5>1)
$REM    IF (IDECF.EQ.0) THEN
$REM    CALL UXVCOP(MX,$DD,$D)
$REM    CALL UXVCOP(MX,$DDU,$DU)
$REM    CALL UXVCOP($N*MX,$XM,$GM)
$REM    ENDIF
  $ENDIF
$L=$40 ; $LABEL
  $IF($DEF(MCG))
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYCP$(CON)S')
      $ENDIF
    $ENDIF
  $ENDIF
  $MAT='G'
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UD$(MAT)$(TYPE)$(DECOMP)$(NUMBER)
*     -----------------------
*
  $SUBST('UD$(MAT)$(TYPE)$(DECOMP)$(NUMBER)')
  TXFU=TDXX
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $IF($DEF(ETA1)) $ERASE(ETA1)
  CALL UXVCOP(NF,$XO,$X)
$REM  $IF(NOS2>0)
  CALL UXVCOP(NF,$GN,$G)
$REM  $ENDIF
  $SUBST('UD1T$(TYPE)1')
  CALL UYSET1
  IF(ITERM.NE.0) GOTO $80
  IF(IREST.NE.0) GOTO $40
  $SUBST('UYTR$(CONSTR)S')
  $IF(CONSTR='C')
    IF (RMAX.EQ.ZERO) GO TO $75
  $ENDIF
$L=$60 ; $LABEL
  ASSIGN $60 TO IMD
  $SUBST('UZLINS')
  GOTO ($64,$62) ISB+1
$L=$62 ; $LABEL
$REM  CALL UXVDIR(NF,R,$S,$XO,$X)
  $IF(CONSTR='C')
    $IF(TYPE='G')
      CALL UXVDIR(NF,R,$S,$XO,$X)
    $ELSE
      CALL UXUDIR(NF,R,$S,$XO,$X,$IX,KBF)
    $ENDIF
    $SUBST('UCBS04')
  $ELSE
    CALL UXVDIR(NF,R,$S,$XO,$X)
  $ENDIF
  GOTO $10
$L=$64 ; $LABEL
  TXFU=TSXX
  IF (ITERS.LE.0) THEN
  $IF(KDS<1)
    $SUBST('UYZER0')
  $ELSE
    $SUBST('UYZER1')
  $ENDIF
  IF (IDIR.EQ.0) CALL UYRES1(TSXX)
  CALL UYSET1
  GOTO $40
  ENDIF
  $IF(NOS2>2)
    $IF(NOS2<6)
      $IF(NOS3=1)
        $IF(MOS1=0)
          KD=2
        $ELSE
          KD=1
          IF (IPREC.EQ.1) KD=2
        $ENDIF
      $ENDIF
    $ENDIF
  $ENDIF
  IF(KD.GT.LD) THEN
  ASSIGN $70 TO IMD
  GO TO $10
  ENDIF
$L=$70 ; $LABEL
  TXFU=TUXX
  $IF($DEF(MCG))
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYUP$(CON)D')
      $ENDIF
    $ENDIF
  $ENDIF
  $IF(NOS2=0)
    $SUBST('UYTRED')
  $ELSEIF(NOS2=1)
    $SUBST('UYTR$(CONSTR)D')
    $IF(MOS3=1)
      MX=MIN(MX+1,MF)
      CALL UXDRSU($N,MX,$XM,$GM,$U1)
      CALL UXVCOP($N,$XO,$XM)
      CALL UXVCOP($N,$GO,$GM)
    $ELSEIF(MOS3=2)
      MX=MIN(MX+1,MF)
      CALL UXDRSU($N,MX,$XM,$GM,$U1)
      CALL UXVCOP($N,$XO,$XM)
      CALL UXVCOP($N,$GO,$GM)
    $ELSE
      $IF(MOS3=3) $IHLP=5
      $IF(MOS3=4) $IHLP=6
      $SUBST('UUVLV$IHLP')
$REM      IF (ITERH.NE.0) CALL UYRES1('UPDATE  ')
    $ENDIF
  $ELSEIF(NOS2=2)
    $SUBST('UYTR$(CONSTR)D')
    $IF(MOS3=1) $IHLP=1
    $IF(MOS3=2) $IHLP=3
    $SUBST('UULBI$IHLP')
  $ELSEIF(NOS2=6)
    $SUBST('UYTRED')
  $ELSE
    $IF(NOS3<3)
      $SUBST('UYTRED')
    $ELSE
      $SUBST('UYTR$(CONSTR)D')
      $SUBST('UUTBM1')
    $ENDIF
  $ENDIF
  $IF(CONSTR='C')
$L=$75 ; $LABEL
    $SUBST('UYADC0')
$REM    IF (INEW.NE.0) MX=0
  $ENDIF
  GOTO $20
$L=$80 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(1)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMA>0) $SUBST('UANRL1')
  $ENDIF
  $IF(NCL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UCTRL1')
    $IF(NORMC>0) $SUBST('UCNRL1')
  $ENDIF
  $SUBST('UO1FU2')
  $ADD(INIT)
    NXFU='U1FSU2'
  $ENDADD
  $EXIT
