$INTERFACE U1LSL2                                             97/12/01
$REM LU

  $D='D'
  $ADD(INTEGER,'\$IX($NF)\$IC($NC)')
  $ADD(REAL,'\$XL($NF)')
  $TYPE='L'
  $HELP
    METHOD
      1 - GILL-MURRAY DECOMPOSITION APPLIED TO THE SCHUR COMPLEMENT
      2 - BUNCH-PARLETT DECOMPOSITION OF THE KKT SYSTEM
      3 - CONJUGATE GRADIENT METHOD APPLIED TO THE SCHUR COMPLEMENT
  $CHECK(NUMBER,1,'1\2\3',1,NO)
  $HELP
    MAXIMUM NUMBER OF ITERATIONS
  $CHECK(MIT,500,INT,3)
  JOUT=1
  IF(ABS(KOUT).EQ.2) KOUT=SIGN(4,KOUT)
  IF(ABS(MOUT).EQ.2) MOUT=SIGN(4,MOUT)
  $SUBST('UO0FU1')
  $IF(NCL>0)
    $MCL=NCL
     MCL=NCL
    $JOB=1
    $IF(NORMC>0) $SUBST('UCNRL3')
    $IF(NORMF>0) $SUBST('UCTRL3')
  $ENDIF
*
*     --------------------------------
*     SPARSE INTERIOR POINT LP METHODS
*     TEMPLATE : U1LSL2
*     --------------------------------
*
  $IF(NUMBER=1)
    $PSR=PSL
    $PERC=PERM
    $SUBST('UCESS1')
    $SUBST('UYSFSB')
  $ELSEIF(NUMBER=2)
    CALL UXVINP(NF+1,$IH)
    CALL UXVINP(NF,$JH)
    $SUBST('UYSFIB')
  $ENDIF
  MRED=MIT
  NS=1
  $SUBST('ULLPI1')
  $IF(NCL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UCTRL3')
    $IF(NORMC>0) $SUBST('UCNRL3')
  $ENDIF
  NIT=NRED
  NFV=1
  $KD=1
  $SUBST('UZMODL')
  $IF(NCL>0) $SUBST('UCLNF4')
  KDC=0
  ISNC=1
  $SUBST('UO1FN2')
  $ADD(INIT)
    NXFU='U1LSL2'
  $ENDADD
$EXIT
