$INTERFACE U2ASU1                                             16/12/01
$REM LU

  $F='FF'
  $FO='FFO'
  $N='NF'
  $RDEL='ONE'
  $AS='AS'
  $AZ='AZ'
  $HF=H
  $HERF='S'
  $ADD(REAL,'\$X($NF)\$G($NF)\$S($NF)\$AF($NA)\$AFO($NA)\AS(NA)&
  \$AZ($NA)')
  $ADD(INTEGER,'\$IH($NF+1)\$JH($M)\IMD\KDS\ISNAS')
$REM  $ADD(REAL,'\UXUDOT')
  $ADD(REAL,'\UXVDOT')
  $ADD(REAL,'\FFO\TOLP')
  $CONSTR='U'
  $HELP
    TYPE OF THE METHOD:
      L - LINE SEARCH
      G - TRUST REGION
  $CHECK(TYPE,'L','L\G',2,NO)
  $IF(TYPE='L')
    $DECOMP='G'
  $ELSE
    $HELP
      MATRIX DECOMPOSITION:
      G - GILL-MURRAY DECOMPOSITION
      B - BUNCH-PARLETT DECOMPOSITION
    $CHECK(DECOMP,'G','M\G\B',2,NO)
  $ENDIF
  $ISNA=2
  $ADD(INIT)
    ISNA=2
  $ENDADD
  $HELP
    INITIAL BARRIER COEFFICIENT
  $CHECK(RPF3,'1.0$P 0',REAL,3)
  $KDS=0
$REM  $HELP
$REM    JACOBIAN MATRIX IN THE KKT SYSTEM
$REM      0 - ORIGINAL JACOBIAN MATRIX
$REM      1 - PERTURBED JACOBIAN MATRIX
$REM   $CHECK(MEP1,0,'0\1',2)
  $HELP
    UPDATE OF THE BARRIER PARAMETER
      1 - GEOMETRIC SEQUENCE
      2 - MONOTONE SEQUENCE
      3 - DELAYED MONOTONE SEQUENCE
      4 - DELAYED MONOTONE SEQUENCE WITH STAGNATIONS
  $CHECK(MEP3,4,'1\2\3\4',2)
  $HELP
    REDUCTION OF THE BARRIER PARAMETER
  $CHECK(ETA4,'8.5$P-1',REAL,4)
  $HELP
    MINIMUM VALUE OF THE BARRIER PARAMETER
  $CHECK(ETA5,'0.0$P 0',REAL,4)
  $HELP
    SWITCHING VALUE OF THE GRADIENT NORM
  $CHECK(ETA6,'1.0$P 0',REAL,4)
  $IF(TYPE='L')
    $NUMBER=1
    $STEP=1
    $HELP
      CHANGE OF INDEFINITE MATRIX
        1 - GILL-MURRAY DECOMPOSITIOM
        2 - RESTART
    $CHECK(MEP2,1,'1\2',2)
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
        1-UNIT INITIAL STEPSIZE
        2-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR VM METHODS
        3-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR CG METHODS
        4-QUADRATICALLY ESTIMATED INITIAL STEPSIZE
    $CHECK(INITS,1,'1\2\3\4',4)
    $HELP
      TOLERANCE FOR DESCENT DIRECTION
    $CHECK(EPS0,'1.0$P-8',REAL,4)
  $ELSE
    $IF(DECOMP='B') $NUMBER=1
    $HELP
      METHOD
        1 - EXACT SOLUTION BY THE CHOLESKI DECOMPOSION
        7 - OPTIMUM LOCALLY CONSTRAINED STEP
    $CHECK(NUMBER,1,'1\7',2,NO)
  $ENDIF
  $HELP
    COMPUTATION OF SECOND DERIVATIVES
      1 - SECOND DERIVATIVES OF APPROXIMATING AND CONSTRAINT
          FUNCTIONS ARE COMPUTED
      2 - COLEMAN-MORE GRAPH COLORING ALGORITHM IS USED
  $CHECK(NUMDER,1,'1\2',4,NO)
  $HELP
    CHOICE OF THE INITIAL APPROXIMATION OF THE HESSIAN
    MATRIX:
     -1 - STEEPEST DESCENT DIRECTION
      1 - UNIT INITIAL APPROXIMATION
      2 - RANDOM INITIAL APPROXIMATION
      3 - DIAGONAL INITIAL APPROXIMATION
      4 - DIAGONAL INITIAL APPROXIMATION FOR MINIMAX
  $CHECK(INITH,3,'-1\1\2\3\4',4)
$REM  $MCL=NC
$REM   MCL=NC
  $GN='GF'
  $SN='S'
  NDECF=0
  $SUBST('UFSET1')
$REM  $SUBST('UASET2')
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $IF(NAL>0)
    $MAL=NAL
     MAL=NAL
    $JOB=1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $IF(CONSTR='C') $SUBST('UYFPC1')
  $IF(KDA<2)
    $IF(NUMDER=2) $SUBST('UYPTSH')
  $ENDIF
  $IF(DECOMP='M')
    $SUBST('UYSFSH')
  $ELSEIF(DECOMP='G')
    $SUBST('UYSFSH')
  $ELSEIF(DECOMP='B')
    $SUBST('UYSFIH')
  $ENDIF
*
*     --------------------
*     SPARSE NEWTON METHOD
*     TEMPLATE : U2ASU1
*     --------------------
*
  $LMD=$10
  ASSIGN $30 TO IMD
  CALL UYPRO1('UXFU',2)
  CALL UYPRO3(0)
  $IF(KBF>0)
    CALL UXVINI(NF,$IX)
  $ENDIF
  R=ZERO
  FO=FMIN
  IF (ETA5.LE.ZERO) THEN
    TOLP=SQRT(ETA0)
    TOLP=1.0$P-8
  ELSE
    TOLP=ETA5
  ENDIF
  IF (ITERM.NE.0) GO TO $80
$L=$ 10 ; $LABEL
  KDS=KD
  KD=0
$L=$ 15 ; $LABEL
  $KD=1
  $SUBST('UP2SA3')
  IF (KD.LE.0) THEN
  $SUBST('UPLAG1')
  $SUBST('UP0BA1')
  ENDIF
  IF (KDS.GT.KD) THEN
  KD=KDS
  GO TO $15
  ENDIF
  ISNA=2
  GO TO IMD
$L=$ 30 ; $LABEL
  $SUBST('UYTR$(CONSTR)G')
  $SUBST('UO2FU3')
  $SUBST('UYFUT8')
  IF (ITERM.NE.0) GO TO $80
$L=$ 40 ; $LABEL
  $SUBST('UUSSD1')
  IF (ITERM.NE.0) GO TO $80
  $IF(KDF=0)
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYCP$(CON)S')
      $ENDIF
    $ENDIF
  $ENDIF
  $IF(KBF>0)
    CALL UXVINF(NF,M,$IX,$JH)
    CALL UXVINF(NF,MA,$IX,$JAG)
  $ENDIF
  $SUBST('UYTS$(CONSTR)H')
  $DEC=DECOMP
  $DECOMG='A'
  $DECOMD='A'
  $IF(DEC='M') $DEC='G'
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UDS$(TYPE)$(DECOMG)$(NUMBER)
*     -----------------------
*
  $SUBST('UDS$(TYPE)$(DECOMG)$(NUMBER)')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $SUBST('UD1T$(TYPE)1')
  IF (ITERM.NE.0) GO TO $80
  $IF(TYPE='L')
    $IF(MEP2=2)
      IF (INF.GT.0) CALL UYRES1('INDEF   ')
    $ENDIF
  $ENDIF
  IF (IREST.NE.0) GO TO $40
  IF (NIT.EQ.LIT+1) KIT=NIT
$L=$ 50 ; $LABEL
  $SUBST('UYTR$(CONSTR)S')
  FFO=FF
  CALL UXVCOP(NA,$AF,$AFO)
  ASSIGN $60 TO IMD
$L=$ 60 ; $LABEL
$REM  IF(FF.LT.FFO) THEN
$REM  TSXX='DECR. FF'
$REM  ITERS=7
$REM  ENDIF
  $SUBST('UZLINS')
  GO TO ($64,$62) ISB+1
$L=$ 62 ; $LABEL
  $IF(KBF>0)
    CALL UXUDIR(NF,R,$S,$XO,$X,$IX,-KBF)
  $ELSE
    CALL UXVDIR(NF,R,$S,$XO,$X)
  $ENDIF
  GO TO $10
$L=$ 64 ; $LABEL
  $IF(KDA=1) LD=0
  IF (ITERS.LE.0) THEN
  $IF(KDS<1)
    $SUBST('UYZER0')
  $ELSE
    $SUBST('UYZER1')
  $ENDIF
  $IF(TYPE='G')
    IF (ITERS.LT.0) THEN
    RPF3=TOLP
    CALL UYRES1(TSXX)
    CALL UYSET1
    GO TO $40
$REM    ITERM=-1
$REM    GOTO $80
    ENDIF
  $ENDIF
  FF=FFO
  CALL UXVCOP(NA,$AFO,$AF)
  IF (IDIR.EQ.0) CALL UYRES1(TSXX)
  CALL UYSET1
  GO TO $40
  ENDIF
$REM  CALL UODLA5(R,RMAX,RMAXP,RMAXD)
  $IF(TYPE='G')
    IF (ITERS.GE.2) THEN
  $ENDIF
  $IF(MEP3=1)
    RPF3=MIN(ETA4*RPF3,GNORM**2)
  $ELSEIF(MEP3=2)
    RPF3=MIN(MAX(ETA4*RPF3,RPF3/(1.0$P 2*RPF3+ONE)),MAX(GNORM**2&
,1.0D-2**(NIT-LIT)))
  $ELSEIF(MEP3=3)
    IF (GNORM.GE.ETA6) THEN
    ELSE
    RPF3=MIN(MAX(ETA4*RPF3,RPF3/(1.0$P 2*RPF3+ONE)),MAX(GNORM**2&
,1.0D-2**(NIT-LIT)))
    ENDIF
  $ELSEIF(MEP3=4)
    IF (GNORM.GE.ETA6) THEN
    ELSE
    IF (RPF3.GE.1.0$P 2*GNORM**2) RPF3=GNORM**2
    ENDIF
  $ENDIF
  RPF3=MAX(RPF3,TOLP)
  $IF(TYPE='G')
    ENDIF
  $ENDIF
  IF (KD.GT.LD) THEN
  ASSIGN $70 TO IMD
  GO TO $10
  ENDIF
$L=$ 70 ; $LABEL
  TXFU=TUXX
  TUXX='NEWTON  '
  $SUBST('UYTRED')
  GO TO $30
$L=$ 80 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(2)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  F=FF
  $SUBST('UO1FU2')
  $ADD(INIT)
    NXFU='U2ASU1'
  $ENDADD
  $ADD(SINIT)
$REM    $SUBST('UASET1')
  $ENDADD
  $EXIT
