$INTERFACE U2FSU1                                             97/12/01
$REM LU

  $N='NF'
  $HERF='S'
  $ADD(INTEGER,'\IMD')
  $IF(CONSTR='S')
    $CONSTR='C'
    $ADD(REAL,'\UXUDOT')
  $ELSE
    $ADD(REAL,'\UXVDOT')
  $ENDIF
  $HELP
    TYPE OF METHOD:
      L - LINE SEARCH
      G - GENERAL TRUST REGION
      R - CUBIC REGULARIZATION
  $CHECK(TYPE,'G','L\G\R',2,NO)
  $IF(TYPE='R') $DECOMP='M'
  $IF(CONSTR='U')
    $HELP
      MATRIX DECOMPOSITION
        M - NO DECOMPOSITION
        G - GILL-MURRAY DECOMPOSITION WITHOUT PERMUTATIONS
        B - BUNCH-PARLETT  DECOMPOSITION WITH PERMUTATIONS
    $CHECK(DECOMP,'M','M\G\B',2,NO)
  $ELSE
    $DECOMP='M'
  $ENDIF
  $IF(DECOMP='M')
    $IF(TYPE='L')
      $HELP
        METHOD
          1 - EXACT SOLUTION BY THE CHOLESKI DECOMPOSION
          3 - INEXACT ITERATIVE SOLUTION BY CONJUGATE
              GRADIENT METHOD
      $CHECK(NUMBER,3,'1\3',2,NO)
    $ELSEIF(TYPE='G')
      $HELP
        METHOD
          1 - SINGLE DOG-LEG STRATEGIES
          2 - MULTIPLE DOG-LEG STRATEGY
          3 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
          4 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
              WITH THE LANCZOS STEPS
          5 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
              WITH THE LANCZOS STEPS
          6 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
              WITH THE LANCZOS STEPS
          7 - OPTIMUM LOCALLY CONSTRAINED STEP
          8 - THE HAGER SSM METHOD
          9 - THE SORENSEN EIGENVALUE METHOD
      $CHECK(NUMBER,3,'1\2\3\4\5\6\7\8\9',2,NO)
    $ELSEIF(TYPE='R')
      $HELP
        METHOD
          7 - OPTIMUM LOCALLY CONSTRAINED STEP
      $CHECK(NUMBER,7,'7',2,NO)
    $ENDIF
  $ELSE
    $NUMBER=1
  $ENDIF
  $IF(TYPE='L')
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
        1-UNIT INITIAL STEPSIZE
        2-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR VM METHODS
        3-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR CG METHODS
        4-QUADRATICALLY ESTIMATED INITIAL STEPSIZE
    $CHECK(INITS,2,'1\2\3\4',4)
    $LCS=0
  $ELSE
    $LCS=1
  $ENDIF
  $ADD(INIT)
    LCS=$LCS
  $ENDADD
  $IF(MODEL='AQ')
    $HELP
      COMBINATION WITH THE GAUSS-NEWTON METHOD:
        1 - NEWTON'S METHOD
        2 - COMBINED METHOD
    $CHECK(MET,2,'1\2',3)
    $IF(MET=2)
      $NUMDER=1
      $HELP
        TOLERANCE FOR SWITCH TO THE NEWTON METHOD
      $CHECK(ETA5,'1.5$P-4',REAL,4)
    $ENDIF
  $ELSEIF(MODEL='AP')
    $HELP
      COMBINATION WITH THE GAUSS-NEWTON METHOD:
        1 - NEWTON'S METHOD
        2 - COMBINED METHOD
    $CHECK(MET,2,'1\2',3)
    $IF(MET=2)
      $NUMDER=1
      $HELP
        TOLERANCE FOR SWITCH TO THE NEWTON METHOD
      $CHECK(ETA5,'1.5$P-4',REAL,4)
    $ENDIF
  $ENDIF
  $IF(MODEL='A?')
    $HELP
      COMPUTATION OF DERIVATIVES
        1 - DERIVATIVES OF THE APPROXIMATING FUNCTIONS
            ARE COMPUTED
        2 - COLEMAN-MORE GRAPH COLORING ALGORITHM IS USED
    $CHECK(NUMDER,2,'1\2',4,NO)
  $ELSE
    $NUMDER=1
  $ENDIF
  $UPDATE='NO'
  NDECF=0
  $SUBST('UFSET1')
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $IF(NAL>0)
    $MAL='$NAL'
    $ADD(INIT)
      MAL=NAL
    $ENDADD
    $JOB=1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $IF(CONSTR='C') $SUBST('UYFPC1')
  $IF(KDF=1)
    $SUBST('UYPTSH')
  $ELSEIF(KDA=1)
    $IF(NUMDER=2) $SUBST('UYPTSH')
  $ENDIF
  $IF(NUMBER=3)
  $ELSEIF(NUMBER=4)
  $ELSEIF(NUMBER=5)
  $ELSEIF(NUMBER=6)
  $ELSEIF(NUMBER=8)
  $ELSEIF(DECOMP='M')
    $SUBST('UYSFSH')
  $ELSEIF(DECOMP='G')
    $SUBST('UYSFSH')
  $ELSEIF(DECOMP='B')
    $SUBST('UYSFIH')
  $ENDIF
  IF(ITERM.LT.0) GOTO $80
*
*     --------------------
*     SPARSE NEWTON METHOD
*     TEMPLATE : U2FSU1
*     --------------------
*
  $LMD=$10
  ASSIGN $20 TO IMD
  CALL UYPRO1('UXFU',2)
  CALL UYPRO3(0)
  MOT=0
  T=ZERO
  FO=FMIN
  IPOM1=0
$REM  RMAX=ETA9
$L=$10 ; $LABEL
  $KD=2
  $IF(NUMDER=1)
    $SUBST('UZMODL')
  $ELSE
    $SUBST('UZMODN')
  $ENDIF
  $IF(KDS<1)
  $ELSEIF(CONSTR='C')
    IF (TSS(NS).EQ.'USXX') P=UXUDOT(NF,$G,$S,$IX,KBF)
  $ELSE
    IF (TSS(NS).EQ.'USXX') P=UXVDOT(NF,$G,$S)
  $ENDIF
  GO TO IMD
$L=$20 ; $LABEL
  $SUBST('UYTR$(CONSTR)G')
  $SUBST('UO2FU3')
  $SUBST('UYFUT1')
  IF (ITERM.NE.0) GO TO $80
  $IF(CONSTR='C') $SUBST('UYRM$(CONSTR)0')
$L=$30 ; $LABEL
  $SUBST('UUSSD1')
  IF (ITERM.NE.0) GO TO $80
  $IF(KDF=0)
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYCP$(CON)S')
      $ENDIF
    $ENDIF
  $ENDIF
  $IF(CONSTR='C') CALL UXVINB(NF,M,$IX,$JH)
  $SUBST('UYTS$(CONSTR)H')
$REM  $IF(CONSTR='C')
  $IF(.FALSE.)
    $IF(TYPE='G')
      $GG='GG'
      $IXA='IXA'
      $ADD(REAL,'\$GG($NF)\XDELS')
      $ADD(INTEGER,'\$IXA($NX)')
      CALL UXVICP(NF,$IX,$IXA)
      CALL UXVCOP(NF,$G,$GG)
      $IXS=IX
      $IX=IXA
      $SUBST('UYGCC1')
      $IX=IXS
    $ENDIF
  $ENDIF
  $DEC=DECOMP
  $DECOMG=DEC
  $IF(NUMBER=1)
    $DECOMG='G'
    $IF(DEC='M') $DEC='G'
  $ENDIF
  $IF(NUMBER=2)
    $DECOMG='G'
    $IF(DEC='M') $DEC='G'
  $ENDIF
  $MAT='G'
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UD$(MAT)$(TYPE)$(DECOMG)$(NUMBER)
*     -----------------------
*
  $SUBST('UD$(MAT)$(TYPE)$(DECOMG)$(NUMBER)')
  TXFU=TDXX
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
$REM  $IF(CONSTR='C')
  $IF(.FALSE.)
    $IF(TYPE='G')
      CALL UXVCOP(NF,$GG,$G)
      XDEL=XDELS
    $ENDIF
  $ENDIF
  $SUBST('UD1T$(TYPE)1')
$REM  $IF(CONSTR='C') CALL UXVINE(M,$JH)
  IF (ITERM.NE.0) GOTO $80
  IF (IREST.NE.0) GOTO $30
  IF(NIT.EQ.LIT+1) KIT=NIT
$L=$40 ; $LABEL
$REM  $IF(TYPE='R') $TYPE='G' 
  $SUBST('UYTR$(CONSTR)S')
  $IF(CONSTR='C')
    IF (RMAX.EQ.ZERO) GO TO $75
  $ENDIF
$L=$50 ; $LABEL
  ASSIGN $50 TO IMD
  $SUBST('UZLINS')
  GOTO ($54,$52) ISB+1
$L=$52 ; $LABEL
  $IF(CONSTR='C')
    $IF(TYPE='G')
      CALL UXVDIR(NF,R,$S,$XO,$X)
    $ELSEIF(TYPE='R')
      CALL UXVDIR(NF,R,$S,$XO,$X)
    $ELSE
      CALL UXUDIR(NF,R,$S,$XO,$X,$IX,KBF)
    $ENDIF
    $SUBST('UCBS04')
  $ELSE
    CALL UXVDIR(NF,R,$S,$XO,$X)
  $ENDIF
  GOTO $10
$L=$54 ; $LABEL
  TXFU=TSXX
  $IF(KDA=1) LD=0
  IF (ITERS.LE.0) THEN
  $IF(KDS<1)
    $SUBST('UYZER0')
  $ELSE
    $SUBST('UYZER1')
  $ENDIF
$REM  $IF(TYPE='G')
$REM    IF (ITERS.LT.0) THEN
$REM    ITERM=-1
$REM    GOTO $80
$REM    ENDIF
$REM  $ENDIF
  IF (IDIR.EQ.0) CALL UYRES1(TSXX)
  CALL UYSET1
  GOTO $30
  ENDIF
  IF(KD.GT.LD) THEN
  IF(MET.GE.2.AND.FO-F.GE.ETA5*FO) IPOM1=1
  ASSIGN $70 TO IMD
  GO TO $10
  ENDIF
$L=$70 ; $LABEL
  IPOM1=0
  TUXX='NEWTON  '
  $SUBST('UYTRED')
  $IF(CONSTR='C')
$L=$75 ; $LABEL
    $SUBST('UYADC0')
  $ENDIF
  GOTO $20
$L=$80 ; $LABEL
  CALL UYEPI1(2)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $SUBST('UO1FU2')
  $ADD(INIT)
    NXFU='U2FSU1'
  $ENDADD
  $EXIT


