$INTERFACE U2RSI1                                             08/12/01
$REM LU

  $N='NF'
  $NN='NC+NCC'
  $ICC='ICC'
  $RDEL='ONE'
  $IF(KBF>0)
    $XSL='XSL'
    $XZL='XZL'
    $XSU='XSU'
    $XZU='XZU'
    $IF(KBF<2)
      $XU=XL
      $XSU=XSL
      $XZU=XZL
    $ENDIF
  $ELSE
    $XSL=X
    $XZL=X
    $XSU=X
    $XZU=X
  $ENDIF
  $IF(KBC>0)
    $CSL='CSL'
    $CZL='CZL'
    $CSU='CSU'
    $CZU='CZU'
    $IF(KBC<2)
      $CU=CL
      $CSU=CSL
      $CZU=CZL
    $ENDIF
  $ELSE
    $NC=1
    $CSL=CF
    $CZL=CF
    $CSU=CF
    $CZU=CF
  $ENDIF
  $IF(COMPL='R')
    $PEN=0
    $Z='RPF4'
  $ELSEIF(COMPL='M')
    $PEN=1
    $NF='$NF+1'
    $Z='X(NF+1)'
  $ENDIF
  $NC='$NC+$NCC'
  $NCA='($NX+$NC)'
  $HERF='S'
  $ADD(INTEGER,'\$IC($NC)')
  $ADD(REAL,'\$CF($NC+1)\$CU($NC)')
  $ADD(REAL,'\$CFO($NC+1)\$CFD($NC+1)\RMAXP\RMAXD')
  $ADD(INTEGER,'\IMD')
  $ADD(REAL,'\UXUDOT')
  $ADD(REAL,'\UXVDOT')
  $CONSTR='U'
  $MODP='FF'
  $ADD(INTEGER,'\ISNCS')
  $IF(MODEL='AF') $MODP=MODEL
  $IF(MODEL='AQ') $MODP=MODEL
  $IF(MODEL='AP') $MODP=MODEL
  $IF(MODEL='A?') $ADD(INTEGER,'\ISNAS')
  $TYPE='L'
  $DECOMP='I'
  $IF(MODELA='YES')
    $IF(ISNA<1) $ISNA=1
    $ADD(INIT)
      ISNA=$ISNA
    $ENDADD
  $ENDIF
  $ISNC=2
  $ADD(INIT)
    ISNC=2
  $ENDADD
  $KDS=0
$REM  $HELP
$REM    JACOBIAN MATRIX IN THE KKT SYSTEM
$REM      0 - ORIGINAL JACOBIAN MATRIX
$REM      1 - PERTURBED JACOBIAN MATRIX
$REM   $CHECK(MEP1,0,'0\1',2)
  $HELP
    STRATEGY FOR UPDATES OF BOX CONSTRAINTS AND SLACK VARIABLES
      -1 OR 1 - SLACK VARIABLES ARE DETERMINED BY LINE SEARCH
      -1 0R 2 - SLACK VARIABLES ARE DETERMINED FROM CONSTRAINTS
     MEP1 > 0 - BOX CONSTRAINTS ARE DETERMINED BY LINE SEARCH
     MEP1 < 0 - BOX CONSTRAINTS ARE ALWAYS FEASIBLE
  $CHECK(MEP1,0,'-2\-1\1\2',4)
  $HELP
    STRATEGY FOR PRIMAL AND DUAL STEPSIZES
      0      - UCISTP
     -1 OR 1 - R, MIN(R,RMAXP), MIN(R,RMAXD)
     -2 OR 2 - R, MIN(R,RMAXP), MIN(R,RMAXP,RMAXD)
     -3 OR 3 - R, MIN(R,RMAXP,RMAXD), MIN(R,RMAXP,RMAXD)
    MEP2 > 0 - R <= RMAX
    MEP2 < 0 - R <= MIN(RMAX, RMAXP)
  $CHECK(MEP2,0,'-3\-2\-1\0\1\2\3',4)
  $NEP2=MEP2
  $IF(NEP2=-1) $NEP2=1
  $IF(NEP2=-2) $NEP2=2
  $IF(NEP2=-3) $NEP2=3
  $HELP
    CHOICE OF THE BARRIER COEFFICIENT
      1 - VANERBEI AND SHANNO
      2 - EL-BAKRY
  $CHECK(MEP3,1,'1\2',4)
  $MOS5=2
$REM  $HELP
$REM    IP FORMULATION
$REM      1 - PRIMAL
$REM      2 - PRIMAL-DUAL
$REM  $CHECK(MOS5,2,'1\2',4)
  $HELP
     METHOD
       1 - EXACT SOLUTION WITH BUNCH PARLETT DECOMPOSITION
       3 - INEXACT SOLUTION BY SMOOTHED CONJUGATE GRADIENT
           METHOD
  $CHECK(NUMBER,3,'1\3',2,NO)
  $HELP
    CHOICE OF THE MERIT STRATEGY:
      P - PENALTY FUNCTION
      M - MARKOV FILTER
      F - FLETCHER-LEYFFER FILTER
      B - BARRIER FILTER
      S - NEW FILTER
  $CHECK(MERIT,'P','P\M\F\B\S',2,NO)
  $HELP
    BARRIER COEFFICIENT
  $CHECK(RPF3,'1.0$P 0',REAL,3)
  $HELP
    RELAXATION COEFFICIENT
  $CHECK(RPF4,'1.0$P 0',REAL,3)
  $IF(MERIT='P')
    $HELP
      MERIT FUNCTION
        0 - MERIT FUNCTION IS NOT USED
        1 - L2 AUGMENTED BARRIER FUNCTION
        2 - L2 AUGMENTED LAGRANGIAN FUNCTION
    $CHECK(MEP,1,'0\1\2',2)
    $IF(MEP=0) $KTERS=6
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'1.0$P-4',REAL,3)
    $STEP=1
  $ELSEIF(MERIT='M')
    $FS='FS'
    $ADD(REAL,'\$FS(2)')
    $MEP=-1
    $MEP2=1
    $STEP=8
  $ELSEIF(MERIT='B')
    $ADD(REAL,'\FB')
    $HELP
      MAXIMUM NUMBER OF FILTER SAMPLES
    $CHECK(MS,50,INT,3)
    $IF(MS<5) $MS=5
    $FS='FS'
    $ADD(REAL,'\$FS($MS,4)')
    $MEP=-1
    $MEP2=1
$REM    $STEP=9
    $STEP=7
  $ELSE
    $HELP
      MAXIMUM NUMBER OF FILTER SAMPLES
    $CHECK(MS,50,INT,3)
    $IF(MS<5) $MS=5
    $FS='FS'
    $ADD(REAL,'\$FS($MS,2)')
    $MEP=-1
    $MEP2=1
$REM    $STEP=9
    $STEP=7
    $IF(MERIT='S')
      $ADD(REAL,'\SWITCH')
      $STEP=10
    $ENDIF
  $ENDIF
  $HELP
    TYPE OF REGULARIZATION
      0 - NO REGULARIZATION
      1 - REGULARIZATION BY GILL-MURRAY DECOMPOSITION
  $CHECK(MEP4,0,'0\1',4)
  $IF(MEP4=0)
    $ED=S
  $ELSE
    $ED='ED'
    $ADD(REAL,'\$ED($NCA)')
    $HELP
      TOLERANCE FOR POSITIVE DEFINITENESS
    $CHECK(ETA2,'1.0$P-8',REAL,4)
  $ENDIF
  $IF(MERIT='P')
     $IF(MEP>0) $MES5=1
  $ENDIF
  $HELP
    RESTART IN THE CASE OF UNSUITABLE DIRECTION
      0 - RESTART SUPPRESED
      1 - UNIFORM DESCENT ASSURED
  $CHECK(MES5,0,'0\1',4)
  $IF(NUMBER=1) $MOS2=0
  $HELP
    PRECONDITIONING THE KARUSH-KUHN-TUCKER SYSTEM
           0 - PRECONDITIONING IS SUPPRESSED
     -1 OR 1 - INDEFIFITE PRECONDITIONING BASED ON A DIAGONAL
               APPROXIMATION OF THE HESSIAN MATRIX. NORMAL
               EQUATION APPROACH.
           2 - INDEFIFITE PRECONDITIONING BASED ON A DIAGONAL
               APPROXIMATION OF THE HESSIAN MATRIX. AUGMENTED
               SYSTEM APPROACH.
     -3 OR 3 - INDEFIFITE PRECONDITIONING BASED ON A DIAGONAL
               PERTURBATION OF THE SCHUR COMPLEMENT
    MOS2 > 0 - COMPLETE CHOLESKI DECOMPOSITION
    MOS2 < 0 - INCOMPLETE CHOLESKI DECOMPOSITION
  $CHECK(MOS2,1,'-3\-1\0\1\2\3',3)
  $NOS2=MOS2
  $IF(NOS2=-1) $NOS2=1
  $IF(NOS2=-3) $NOS2=3
  $HELP
    CHOICE OF THE INITIAL STEPSIZE:
      1-UNIT INITIAL STEPSIZE
      2-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
        STEPSIZE FOR VM METHODS
      3-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
        STEPSIZE FOR CG METHODS
      4-QUADRATICALLY ESTIMATED INITIAL STEPSIZE
  $CHECK(INITS,1,'1\2\3\4',4)
  $HELP
    MINIMUM VALUE OF THE BARRIER PARAMETER
  $CHECK(ETA5,ETA0,REAL,3)
  $DEFAULT='0.99$P 0'
  $IF(MEP=1) $DEFAULT='0.95$P 0'
  $HELP
    COEFFICIENT FOR COMPUTING PRIMAL AND DUAL MAXIMUM
    STEPSIZES
  $CHECK(ETA6,DEFAULT,REAL,3)
  $HELP
    MAXIMUM STEPSIZE FOR LAGRANGE MULTIPLIERS
  $CHECK(UMAX,'1.0$P 6',REAL,3)
  $HELP
    COMPUTATION OF SECOND DERIVATIVES
      1 - SECOND DERIVATIVES OF APPROXIMATING AND CONSTRAINT
          FUNCTIONS ARE COMPUTED
      2 - COLEMAN-MORE GRAPH COLORING ALGORITHM IS USED
  $CHECK(NUMDER,2,'1\2',4,NO)
  $HELP
    CHOICE OF THE INITIAL APPROXIMATION OF THE HESSIAN
    MATRIX:
      0 - INITIAL APPROXIMATION IS SPECIFIED IN THE CALLING
          PROGRAM
      1 - UNIT INITIAL APPROXIMATION
      2 - RANDOM INITIAL APPROXIMATION
      3 - DIAGONAL INITIAL APPROXIMATION
  $CHECK(INITH,3,'0\1\2\3',4)
  $MCL=NC
   MCL=NC
  $GN=GF
  $SN=S
  NDECF=0
$REM  $Z=RPF4
  CALL UXVINS(NCC,2,$IC(NC+1))
  CALL UXVSET(NCC,$Z,$CU(NC+1))
  $SUBST('UCCSS2')
  $SUBST('UFSET9')
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $IF(NAL>0)
    $MAL=NAL
     MAL=NAL
    $JOB=1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $IF(NCL>0)
    $JOB=1
    $IF(NORMC>0) $SUBST('UCNRL3')
    $IF(NORMF>0) $SUBST('UCTRL3')
  $ENDIF
  $IF(MODEL='FQ')
  $ELSEIF(MODELF='YES')
$REM    $NUM=5
    $IF(KDF<2) $SUBST('UYPTSH')
  $ELSE
$REM    $NUM=6
    $IF(KDC<2)
      $IF(KDA<2)
        $IF(NUMDER=2) $SUBST('UYPTSH')
      $ENDIF
    $ENDIF
  $ENDIF
  $IF($DEF(MOS2))
    $IF(MOS2=3)
      $SUBST('UYSFSH')
    $ENDIF
  $ENDIF
  $JOB=NUMBER
  $IF (MODEL<>'FQ') $HF=H
*
*     --------------------
*     SPARSE NEWTON METHOD
*     TEMPLATE : U2RSI1
*     --------------------
*
  $LMD=$10
  ASSIGN $20 TO IMD
  CALL UYPRO1('UXFU',2)
  CALL UYPRO3(0)
  $IF(KBF>0)
    CALL UXVINI(NF,$IX)
  $ENDIF
  FO=FMIN
  R=ZERO
  NCA=-1
  IF (ITERM.NE.0) GO TO $80
$L=$ 10 ; $LABEL
  $IF(MODEL='FQ')
    $KD=2
    $SUBST('UP2LQ6')
  $ELSE
    $KD=1
    $SUBST('UP2$(MODP)6')
    CF($NN+1)=FF
  $ENDIF
  IF (TSS(NS).EQ.'UUXX') THEN
  ELSE IF (TSS(NS).EQ.'UXFU') THEN
  ELSE
  $IF(TYPE='L')
    $IF(MERIT='M')
      $SUBST('UP0BF9')
      F=CF($NN+1)+RPF3*F
    $ELSEIF(MERIT='F')
      $SUBST('UP0BF9')
      F=CF($NN+1)
    $ELSEIF(MERIT='B')
      $SUBST('UP0BF9')
      FB=F
      F=CF($NN+1)+RPF3*F
    $ELSEIF(MERIT='S')
      $SUBST('UP0BF9')
      F=CF($NN+1)
    $ELSEIF(MEP=0)
      F=CF($NN+1)
    $ELSEIF(MEP=1)
      $IF(MEP2=0)
        $SUBST('UP0BF2')
      $ELSE
        $SUBST('UP0BF1')
      $ENDIF
    $ELSEIF(MEP=2)
      $IF(MEP2=0)
        $SUBST('UP0AF6')
      $ELSE
        $SUBST('UP0AF5')
      $ENDIF
    $ENDIF
  $ELSEIF(TYPE='G')
    $IF(MERIT='M')
      $SUBST('UP0BF9')
      F=CF($NN+1)+RPF3*F
    $ELSEIF(MERIT='F')
      $SUBST('UP0BF9')
      F=CF($NN+1)
    $ELSEIF(MERIT='B')
      $SUBST('UP0BF9')
      FB=F
      F=CF($NN+1)+RPF3*F
    $ELSEIF(MEP=0)
      F=CF($NN+1)
    $ELSEIF(MEP=1)
      $IF(MEP2=0)
        $SUBST('UP0BF2')
      $ELSE
        $SUBST('UP0BF1')
      $ENDIF
    $ELSEIF(MEP=2)
      $IF(MEP2=0)
        $SUBST('UP0BS2')
      $ELSE
        $SUBST('UP0BS1')
      $ENDIF
    $ENDIF
  $ENDIF
  $IF(KDS<1)
  $ELSE
    IF (TSS(NS).EQ.'USXX') P=UXUDOT($N,$G,$S,$IX,-KBF)
  $ENDIF
  ENDIF
  GO TO IMD
$L=$ 20 ; $LABEL
  $IF(MERIT='M')
  $ELSEIF(MERIT='F')
    $SUBST('UP0BF9')
    F=CF($NN+1)
    KS=1
    FS(1,1)=F
    FS(1,2)=FC
  $ELSEIF(MERIT='B')
    $SUBST('UP0BF9')
    FB=F
    F=CF($NN+1)+RPF3*F
    KS=1
    FS(1,1)=F
    FS(1,2)=FC
    FS(1,3)=FF
    FS(1,4)=FB
  $ELSEIF(MERIT='S')
    $SUBST('UP0BF9')
    F=CF($NN+1)
    KS=1
    FS(1,1)=F
    FS(1,2)=FC
    $IF(MEP3=1)
      KT=0
    $ENDIF
  $ENDIF
$L=$ 30 ; $LABEL
  $SUBST('UYTS$(CONSTR)G')
  $SUBST('UO2FN4')
  $SUBST('UYFUT2')
  IF (GMAX.LE.TOLG.AND.CMAX.LE.TOLC.AND.RPF3.LE.ETA5) THEN
  ITERM=4
  TXFU='GRAD TOL'
  ENDIF
$REM  IF (ITERM.EQ.1.AND.ABS(F).GE.1.0$P 10) THEN
  IF (.FALSE.) THEN
  CALL UOERR1('U2RSI1',88)
  ITERM=-88
  TDXX='LIN. DEP.'
  ENDIF
  IF (ITERM.NE.0) GO TO $80
  $IF(TYPE='G')
    RDEL=ONE
  $ENDIF
$L=$ 40 ; $LABEL
  $SUBST('UUSSD1')
  IF (ITERM.NE.0) GO TO $80
  $IF(KDF=0)
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYCP$(CON)S')
      $ENDIF
    $ENDIF
  $ENDIF
  $IF(KBF>0)
    CALL UXVINF(NF,M,$IX,$JH)
    CALL UXVINF(NF,MC,$IX,$JCG)
    $IF(MODELA='YES') CALL UXVINF(NF,MA,$IX,$JAG)
  $ENDIF
  $SUBST('UYTS$(CONSTR)H')
  $IF(COMPL='M') $N='NF+1'
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UDS$(TYPE)$(DECOMP)$(NUMBER)
*     -----------------------
*
  $SUBST('UDS$(TYPE)$(DECOMP)$(NUMBER)')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $IF(MERIT='S')
    SWITCH=UXSSMQ($N,M,HF,IH,JH,S,S)
  $ENDIF
  $IF(TYPE='L')
    $SUBST('UD1T$(TYPE)3')
  $ELSEIF(TYPE='G')
    $ADD(REAL,'\UXUNOR')
    CALL UD1TG3($N,$G,$S,P,PP,UXUNOR($N,G,IX,-KBF),UXUNOR($N,S,IX,-KBF)&
,RMAX,XMAX)
  $ENDIF
  $IF(MEP2=0)
  $ELSE
  CALL UCIMAX($N,NX,$NN,NCA,$X,$IX,$XL,$XU,$XSL,$XSU,$XZL,$XZU,$CFD,$IC&
,$CL,$CU,$CSL,$CSU,$CZL,$CZU,$ICA,$S,$GS($N+1),$XO($N+1),$GO($N+1),RMAX&
,RMAXP,RMAXD,ETA6)
    $IF(MEP2<0)
      RMAX=MIN(RMAX,RMAXP)
    $ENDIF
  $ENDIF
$REM  $IF(KBF>0)
$REM    CALL UXVINE(M,$JH)
$REM    CALL UXVINE(MC,$JCG)
$REM    $IF(MODELA='YES') CALL UXVINE(MA,$JAG)
$REM  $ENDIF
  $IF(TYPE='L')
    $IF(MERIT='M')
      $SUBST('UP0BF9')
      FS(1)=CF($NN+1)+RPF3*F
      FS(2)=FC
    $ELSEIF(MEP=0)
      F=CF($NN+1)
    $ELSEIF(MEP=1)
      $IF(MEP2=0)
        $SUBST('UP0BF2')
      $ELSE
        $SUBST('UP0BF1')
      $ENDIF
    $ELSEIF(MEP=2)
      $IF(MEP2=0)
        $SUBST('UP0AF6')
      $ELSE
        $SUBST('UP0AF5')
      $ENDIF
    $ENDIF
  $ELSEIF(TYPE='G')
    $IF(MERIT='M')
      $SUBST('UP0BF9')
    $ELSEIF(MEP=0)
      F=CF($NN+1)
    $ELSEIF(MEP=1)
      $IF(MEP2=0)
        $SUBST('UP0BF2')
      $ELSE
        $SUBST('UP0BF1')
      $ENDIF
    $ELSEIF(MEP=2)
      $IF(MEP2=0)
        $SUBST('UP0BS2')
      $ELSE
        $SUBST('UP0BS1')
      $ENDIF
    $ENDIF
  $ENDIF
  IF (ITERM.NE.0) GO TO $80
  IF (IREST.NE.0) GO TO $40
  IF (NIT.EQ.LIT+1) KIT=NIT
$L=$ 50 ; $LABEL
  $SUBST('UYTR$(CONSTR)S')
  CALL UXVCOP($NN+1,$CF,$CFO)
$L=$ 60 ; $LABEL
  ASSIGN $60 TO IMD
  $SUBST('UZLINS')
  GOTO ($64,$62) ISB+1
$L=$ 62 ; $LABEL
  $IF(MEP1<0)
    CALL UXUDIC($N,R,$S,$XO,$XL,$XU,$X,$IX)
  $ELSE
    CALL UXUDIR($N,R,$S,$XO,$X,$IX,-KBF)
  $ENDIF
  ISNC=1
  GOTO $10
$L=$ 64 ; $LABEL
  $IF(MERIT='B')
    FS(KS,3)=FF
    FS(KS,4)=FB
  $ENDIF
  ISNC=2
  $IF(KDA=1) LD=0
  $IF(KDC=1) LD=0
  IF (ITERS.LE.0) THEN
  $IF(KDS<1)
    $SUBST('UYZER0')
  $ELSE
    $SUBST('UYZER1')
  $ENDIF
  CALL UXVCOP($NN+1,$CFO,$CF)
  $IF(TYPE='G')
    RDEL=RDEL*XDEL/XDELO
  $ENDIF
  IF (IDIR.EQ.0) CALL UYRES1(TSXX)
  CALL UYSET1
  GOTO $40
  ENDIF
  $IF(MEP2=0)
    CALL UCISTP($N,NX,$NN,NCA,$XO,$IX,$XL,$XU,$XSL,$XSU,$XZL,$XZU,$CF&
,$CFD,$IC,$CL,$CU,$CSL,$CSU,$CZL,$CZU,$ICA,$S,$GS(NF+1),$XO(NF+1)&
,$GO(NF+1),R,ETA6,$MEP1)
  $ELSE
    RMAXP=MIN(R,RMAXP)
    RMAXD=MIN(R,RMAXD)
    $IF(NEP2=2)
      RMAXD=MIN(RMAXP,RMAXD)
    $ENDIF
    $IF(NEP2=3)
      RMAXD=MIN(RMAXP,RMAXD)
      RMAXP=RMAXD
    $ENDIF
    CALL UCIDIR($N,NX,$NN,NCA,$XO,$IX,$XL,$XU,$XSL,$XSU,$XZL,$XZU,$CF&
,$CFD,$IC,$CL,$CU,$CSL,$CSU,$CZL,$CZU,$ICA,$S,$GS(NF+1),$XO(NF+1)&
,$GO(NF+1),R,RMAXP,RMAXD,$RDEL,$MEP1)
  $ENDIF
  CALL UODLI5(R,RMAX,RMAXP,RMAXD)
  $BPAR=MEP3
  $SUBST('UPSEB$BPAR')
  RPF3=MAX(RPF3,ETA5)
  $IF(MERIT='B')
    CALL UPSETB(KS,$MS,$FS,RPF3)
  $ENDIF
  CALL UXVSET(NCC,$Z,$CU(NC+1))
  IF (KD.GT.LD) THEN
  ASSIGN $70 TO IMD
  GO TO $10
  ENDIF
$L=$ 70 ; $LABEL
  TXFU=TUXX
  TUXX='NEWTON  '
  $SUBST('UYTRED')
  GOTO $30
$L=$ 80 ; $LABEL
$REM  ISNC=2
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(2)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMA>0) $SUBST('UANRL3')
  $ENDIF
  $IF(NCL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UCTRL3')
    $IF(NORMC>0) $SUBST('UCNRL3')
  $ENDIF
  F=CF($NN+1)
  $SUBST('UCTRF3')
  $SUBST('UO1FC2')
  $ADD(INIT)
    NXFU='U2RSI1'
  $ENDADD
  $EXIT
