$INTERFACE UA0DQ1                                             98/12/01

  $IF(MODELY='YES') $SUBST('UZYSET')
  $EY='EY'
  $EW='EW'
  $IF(GRAPH='NO')
    $NA=1
    $MED=0
    $ADD(SINIT)
      NA=1
      MED=0
    $ENDADD
  $ELSE
    $HELP
      OUTPUT SPECIFICATION
        1 - OUTPUT IN ALL INTEGRATION STEPS
        2 - OUTPUT IN PRESCRIBED MESH POINTS
    $CHECK(MED,2,'1\2',4)
    $HELP
      NUMBER OF MESH POINTS
    $CHECK(NA,50,INT,1)
  $ENDIF
  $IF(MED=2)
    $ADD(SINID)
      CALL UESET1(NA,$AT,TA,TAMAX,HEMAX)
    $ENDADD
  $ENDIF
  $REPEAT
    $HELP
      INTEGRAL PART OF THE OBJECTIVE FUNCTION
        N - INTEGRAL PART EXCLUDED
        Y - INTEGRAL PART INCLUDED
    $CHECK(MODELA,'N','NO\N\YES\Y',1,NO)
    $IF(MODELA='N') $MODELA='NO'
    $IF(MODELA='Y') $MODELA='YES'
    $HELP
      TERMINAL PART OF THE OBJECTIVE FUNCTION
        N - TERMINAL PART EXCLUDED
        Y - TERMINAL PART INCLUDED
    $CHECK(MODELF,'N','NO\N\YES\Y',1,NO)
    $IF(MODELF='N') $MODELF='NO'
    $IF(MODELF='Y') $MODELF='YES'
    $IF(MODELA='NO')
      $IF(MODELF='NO')
        $IF(DIALOG>0)
          $ERASE(MODELA)
          $ERASE(MODELF)
        $ELSE
          $ERROR: OBJECTIVE FUNCTION WAS NOT SPECIFIED
          $STOP
        $ENDIF
      $ENDIF
    $ENDIF
  $UNTIL($DEF(MODELA))
  $IF(MODELA='YES')
    $KDA=0
    $ADD(SINIT)
      YE=ZERO
      WE=ONE
    $ENDADD
  $ENDIF
  $IF(MODELF='YES')
    $KDF=0
    $DIME=NE
    $ADD(SINIT)
      CALL UXVSET(NE,ZERO,$EY)
      CALL UXVSET(NE,ONE,$EW)
    $ENDADD
  $ELSE
    $DIME=1
  $ENDIF
  $ADD(INIT)
    KDA=$KDA
    KDF=$KDF
  $ENDADD
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'0.0$P 0',REAL,2)
  $HELP
    TYPE OF METHOD
      DP5 - DORMAN PRINCE OF THE 5'TH ORDER
      DP8 - DORMAN PRINCE OF THE 8'TH ORDER
  $CHECK(SOLVER,'DP8','DP5\DP8\EX1',2,NO)
  $IF(MODELA='YES')
    $MEL='($NE+1)'
  $ELSE
    $MEL='$NE'
  $ENDIF
  $ADD(REAL,'\$AT($NA)\$AY($NA*$NE)\$YA($MEL)\$EY($DIME)\$EW($DIME)')
      $ADD(SINID)
        CALL UESET2(NA,NE,$AT,$AY,$YA,TA)
      $ENDADD
      $IF(MODELY='YES')
        $SUBST('UE0Y01')
        CALL UXVCOP(NE,$YA,$AY)
      $ENDIF
 $00  CALL UA0DQ1(NA,NE,MEL,$AT,$AY,$YA,$EY,$EW,ETA9,F,TA,HE,MED,
     & MED1,MED2,IER)
      GOTO ($30,$10) ISB+1
 $10  CONTINUE
      $LET=$00
      $LED=$20
      $LES=$10
      $SUBST('UEV$SOLVER')
 $20  CONTINUE
      $SUBST('UE0DQ1')
      $GO TO $10
 $30  CONTINUE
      $ADD(INIT)
        MEL=$MEL
        NAXX='UA0DQ1'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UA0DQ1             ALL SYSTEMS                 98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE AND THE GRADIENT OF THE OBJECTIVE FUNCTION
* WHICH IS DEFINED AS A SUM OF SQUARES.
*
* PARAMETERS:
*  II  NA  NUMBER OF MESH POINTS.
*  II  NE  DECLARED NUMBER OF DIFFERENTIAL EQUATIONS.
*  II  MEL  ACTUAL NUMBER OF DIFFERENTIAL EQUATIONS.
*  RI  AT(NA)  MESH POINTS.
*  RO  AY(NA*NE)  FIELD OF SOLUTION VECTORS IN THE MESH POINTS.
*  RU  YA(MEL)  SOLUTION VECTOR.
*  RI  EY(NE)  REQUIRED TERMINAL SOLUTION VECTOR.
*  RI  EW(NE)  VECTOR WITH WEIGHT COEFFICIENTS.
*  RI  ETA9  MAXIMUM VALUE LESS THEN INFINITY.
*  RO  F  VALUE OF THE OBJECTIVE FUNCTION.
*  RU  TA  VALUE OF THE INTEGRATION PARAMETER.
*  RU  HE  ACTUAL STEPSIZE.
*  II  MED  NUMBER OF STEPS PRECEEDING TEST OF STIFTNESS.
*  II  MED1  CHOICE OF STEP SELECTION.
*  II  MED2  NUMBER OF RESETING SOLUTIONS.
*  IO  IER  ERROR INDICATOR.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERVATIVES.
*  II  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  II  KDF  DEGREE OF ANALYTICALLY COMPUTED DERVATIVES.
*  II  KDA  DEGREE OF ANALYTICALLY COMPUTED DERVATIVES.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S  UYPRO1  PROLOGUE.
*  S  UYEPI1  EPILOGUE.
*  S  UYSET0  STATUS DEFINITION.
*  S  UXVCOP  COPY OF A VECTOR.
*
      SUBROUTINE UA0DQ1(NA,NE,MEL,AT,AY,YA,EY,EW,ETA9,F,TA,HE,MED,
     & MED1,MED2,IER)
      $INCLUDE ('UMCOMM')
      INTEGER NA,NE,MEL,MED,MED1,MED2,IER
      $FLOAT AT(NA),AY(NA*NE),YA(MEL),EY(NE),EW(NE),ETA9,F,TA,HE
      INTEGER MEDS,KE
      SAVE MEDS
      IF (TSS(NS).NE.'UAXX') CALL UYPRO1('UAXX',-1)
      GO TO (1,2) ISP(NS)
    1 CONTINUE
      MEDS=MED
      IF (KD.LT.0) GO TO 4
      IF (LD.GE.0) GO TO 4
      IF (KDA.LT.0) THEN
      MEL=NE
      ELSE
      MEL=NE+1
      YA(MEL)=ZERO
      ENDIF
      MED=0
      MED1=1
      MED2=0
      TA=AT(1)
      IF (KDY.LT.0) CALL UXVCOP(NE,AY,YA)
      HE=ZERO
      CALL UYSET0(1,2)
      RETURN
    2 CONTINUE
      IF (IER.LT.0) THEN
      F=ETA9
      ITERM=MAX(-96,-90+IER)
      CALL UOERR1('UA0DQ1',-ITERM)
      TDXX=TEDX
      GO TO 4
      ENDIF
      IF (ITERM.LT.0) ITERM=0
      IF (KDA.LT.0) THEN
      F=ZERO
      ELSE
      F=YA(MEL)
      ENDIF
      IF (KDF.GE.0) THEN
      DO 3 KE=1,NE
      F=F+HALF*EW(KE)*(YA(KE)-EY(KE))**2
    3 CONTINUE
      ENDIF
    4 CALL UYEPI1(-1)
      MED=MEDS
      LD=KD
      RETURN
      END
