$INTERFACE UA0GS5                                             97/12/01

  $HELP
    PRECISION OF THE COMPUTED VALUES
  $CHECK(ETA1,ETA0,REAL,4)
  CALL UA0GS5(NF,KA,$X,$IX,$XN,$D,$DL,$DU,FA,$ETA1,$MOS2)
  $ADD(REAL,'\$X($NF)\$XN($NF)\$D($NF)\$DL($NF)\$DU($NF)')
$REM  $ADD(REAL,'\FA')
  $ADD(INTEGER,'\$IX($NX)')
$REM  $ADD(INTEGER,'\NF\KA')
  $ADD(INIT)
    NAGX='UA0GS5'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UA0GS5             ALL SYSTEMS                 97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* NUMERICAL COMPUTATION OF THE GRADIENT OF THE APPROXIMATED
* FUNCTION.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  KA  INDEX OF THE SELECTED FUNCTION.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RO  D(NF)  DIAGONAL OF THE JACOBIAN MATRIX.
*  RO  DL(NF)  SUBDIAGONAL OF THE JACOBIAN MATRIX.
*  RO  DU(NF)  SUPERDIAGONAL OF THE JACOBIAN MATRIX.
*  RI  FA  VALUE OF THE APPROXIMATED FUNCTION.
*  RI  ETA1  PRECISION OF THE COMPUTED VALUES.
*  II  MOS2  PRECONDITIONER USED. ABS(MOS2)=3-DIAGONAL PRECONDITIONER.
*         ABS(MOS2)=4-TRIDIAGONAL PRECONDITIONER.
*
* COMMON DATA :
*  II  KBF  TYPE OF BOUNDS. KBF=0-BOUNDS ARE NOT USED. KBF=1-ONE SIDED
*         BOUNDS. KBF=1-TWO SIDED BOUNDS.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S   UYPRO1  PROLOGUE.
*  S   UYEPI1  EPILOGUE.
*  S   UYSET0  STATUS DEFINITION.
*
      SUBROUTINE UA0GS5(NF,KA,X,IX,XN,D,DL,DU,FA,ETA1,MOS2)
      $INCLUDE('UMCOMM')
      INTEGER NF,KA,IX(NF),MOS2
      $FLOAT X(NF),XN(NF),D(NF),DL(NF),DU(NF),FA,ETA1
      $FLOAT XSTEP,XTEMP,FTEMP,ETA
      INTEGER IVAR,KVAR,LVAR
      SAVE XSTEP,XTEMP,FTEMP,ETA
      SAVE IVAR,LVAR
      IF (TSS(NS).NE.'UAGX') CALL UYPRO1('UAGX',-1)
      GO TO (1,3) ISP(NS)
    1 CONTINUE
      ETA=SQRT(ETA1)
      FTEMP=FA
      IF(ABS(MOS2).EQ.3) THEN
      KVAR=KA
      LVAR=KA
      ELSE
      KVAR=MAX(1,KA-1)
      LVAR=MIN(NF,KA+1)
      ENDIF 
      IVAR=KVAR-1
    2 CONTINUE
      IVAR=IVAR+1
      IF (IVAR.GT.LVAR) GO TO 4
      IF (KBF.GT.0) THEN
      IF (IX(IVAR).LE.-5) GO TO 2
      ENDIF
C
C     STEP SELECTION
C
      IF (NORMF.GT.0) THEN
      XSTEP=XN(IVAR)
      ELSE
      XSTEP=ONE
      ENDIF
      XSTEP=ETA*MAX(ABS(X(IVAR)),XSTEP)*SIGN(ONE,X(IVAR))
      XTEMP=X(IVAR)
      X(IVAR)=X(IVAR)+XSTEP
      XSTEP=X(IVAR)-XTEMP
      CALL UYSET0(1,2)
      RETURN
    3 CONTINUE
C
C     NUMERICAL DIFFERENTIATION
C
      FA=(FA-FTEMP)/XSTEP
      IF (IVAR.LT.KA) THEN
      DL(KA-1)=FA
      ELSE IF (IVAR.EQ.KA) THEN
      D(KA) =FA
      ELSE
      DU(KA)=FA
      ENDIF
      X(IVAR)=XTEMP
      GO TO 2
    4 FA=FTEMP
      CALL UYEPI1(-1)
      RETURN
      END

