$INTERFACE UA0SA1                                           04/12/01

      $HELP
        LOWER BOUND FOR FUNCTION VALUE
      $CHECK(FMIN,'0.0$P 0',REAL,2)
      $SUBST('UZASET')
$REM  $ADD(REAL,'\FA\F')
$REM  $ADD(INTEGER,'\NA\NAL\KA\KAP')
 $00  CALL UA0SA1(NA,NAL,KA,KAP,FA,F)
      GO TO ($20,$10) ISB+1
 $10  CONTINUE
      $IF(SAVA>-1)
        IF(LDA.GE.0) THEN
        FA=$AF(KA)
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NAL>0)
        IF(KA.LE.NAL) THEN
        $SUBST('UALNF1')
        $IF(KBA>0) $SUBST('UATRF1')
        $IF(ISNA>0)
          $SUBST('UASVF2')
        $ENDIF
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LAD<0)
        $IF(NAL<$NA)
          $MTYPE=FMODA
          $SUBST('UZAMOD')
          $IF(NORMA>0) $SUBST('UANRF1')
          $IF(KBA>0) $SUBST('UATRF1')
          $IF(ISNA>0)
            $SUBST('UASVF2')
          $ENDIF
          GO TO $00
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $20  CONTINUE
      $ADD(INIT)
        NAXX='UA0SA1'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UA0SA1             ALL SYSTEMS                 04/12/01
C PORTABILITY : ALL SYSTEMS
C 04/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE OF THE OBJECTIVE FUNCTION WHICH IS DEFINED
* AS A SUM OF FUNCTIONS.
*
* PARAMETERS:
*  II  NF  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  NAL  NUMBER OF LINEAR APPROXIMATED FUNCTIONS.
*  II  KA  INDEX OF THE APPROXIMATED FUNCTION.
*  II  KAP  SIGNUM OF THE SELECTED FUNCTION.
*  RI  FA  VALUE OF THE SELECTED FUNCTION.
*  RO  F  VALUE OF THE OBJECTIVE FUNCTION.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERVATIVES.
*  IO  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  IU  NAV  NUMBER OF APPROXIMATED FUNCTION VALUES COMPUTED.
*  IU  NFV  NUMBER OF OBJECTIVE FUNCTION VALUES COMPUTED.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S  UYPRO1  PROLOGUE.
*  S  UYEPI1  EPILOGUE.
*  S  UYSET0  STATUS DEFINITION.
*
      SUBROUTINE UA0SA1(NA,NAL,KA,KAP,FA,F)
      $INCLUDE ('UMCOMM')
      INTEGER NA,NAL,KA,KAP
      $FLOAT FA,F
      IF (TSS(NS).NE.'UAXX') CALL UYPRO1('UAXX',-1)
      GO TO (1,4) ISP(NS)
    1 CONTINUE
      IF (KD.LE.LD) GO TO 8
      IF (KD.GE.0.AND.LD.LT.0) F=ZERO
      KA=1
    2 IF (KA.GT.NA) GO TO 7
      IF  (KD.LT.0) GO TO 5
      CALL UYSET0(1,2)
      RETURN
    4 CONTINUE
      KAP=1
      IF (FA.LT.ZERO) KAP=-KAP
      IF (KAP.GT.0) THEN
      F=F+FA
      ELSE
      F=F-FA
      ENDIF
    5 KA=KA+1
      GO TO 2
    7 NFV=NAV/(NA-NAL)
      LD=KD
    8 CALL UYEPI1(-1)
      RETURN
      END
