$INTERFACE UA1DF1                                             98/12/01

  $IF(MODELY='YES') $SUBST('UZYSET')
  $IF(MODELF='NO')
    $GF='G'
    $DF='G'
  $ENDIF
  $MCG=0
  $IF(GRAPH='NO')
    $NA=1
    $MED=0
    $ADD(SINIT)
      NA=1
      MED=0
    $ENDADD
  $ELSE
    $HELP
      OUTPUT SPECIFICATION
        1 - OUTPUT IN ALL INTEGRATION STEPS
        2 - OUTPUT IN PRESCRIBED MESH POINTS
    $CHECK(MED,2,'1\2',4)
    $HELP
      NUMBER OF MESH POINTS
    $CHECK(NA,50,INT,1)
  $ENDIF
  $IF(MED=2)
    $ADD(SINID)
      CALL UESET1(NA,$AT,TA,TAMAX,HEMAX)
    $ENDADD
  $ENDIF
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'-$ETA9',REAL,2)
  $HELP
    TYPE OF METHOD
      DP5 - DORMAN PRINCE OF THE 5'TH ORDER
      DP8 - DORMAN PRINCE OF THE 8'TH ORDER
  $CHECK(SOLVER,'DP8','DP5\DP8\EX1',2,NO)
  $IF(MODELA='YES')
    $MEL='($NE*$NF+$NE+$NF+1)'
  $ELSE
    $MEL='($NE*$NF+$NE)'
  $ENDIF
  $ADD(REAL,'\$AT($NA)\$AY($NA*$NE)\$YA($MEL)\$G($NF)\$GE($NF)\$GF($NF)&
  \$DF($NE)')
      $ADD(SINIT)
        CALL UXVSET(NE,ZERO,YA)
      $ENDADD
      $ADD(SINID)
      CALL UESET2(NA,NE,$AT,$AY,$YA,TA)
      $ENDADD
      $LET=$00
      $LED=$30
      $LES=$20
 $00  CALL UA1DF1(NF,NA,NE,MEL,KE,$AT,$AY,$YA,$G,$GE,$GF,$DF,$ETA9,F,FF&
,FE,TA,HE,MED,MED1,MED2,IER)
      GOTO ($50,$10,$20,$40) ISB+1
 $10  CONTINUE
      $IF(MODELY='YES')
        $IF(LYD<0)
          $MTYPE=FMODY
          $SUBST('UZYMOD')
        $ELSE
          FE=$EF(KE)
          $EF(KE)=ZERO
        $ENDIF
        IF (KD.LE.0) GO TO $00
        $IF(LYD<1)
          $IF(GMODY='G')
            $MTYPE=GMODY
            $SUBST('UZYMOD')
          $ENDIF
        $ELSE
          CALL UXVCOP(NF,$EG((KE-1)*NF+1),$GE)
          CALL UXVSET(NF,ZERO,$EG((KE-1)*NF+1))
        $ENDIF
      $ENDIF
      $GO TO $00
 $20  CONTINUE
      $SUBST('UEV$SOLVER')
 $30  CONTINUE
      $SUBST('UE1DF1')
      $GO TO $20
 $40  CONTINUE
      $IF(MODELF='YES')
        $MTYPE=FMODF
        $SUBST('UZFMOD')
        IF (KD.LE.0) GO TO $00
        $IF(GMODF='G')
          $MTYPE=GMODF
          $SUBST('UZFMOD')
        $ENDIF
        $IF(DMODF='D')
          $MTYPE=DMODF
          $SUBST('UZFMOD')
        $ENDIF
        $IF(GMODF='GD')
          $MTYPE=GMODF
          $SUBST('UZFMOD')
        $ENDIF
      $ENDIF
      $GO TO $00
 $50  CONTINUE
      IF (ITERM.NE.0) CALL UXVSET(NF,ZERO,G)
      $ADD(INIT)
        NAXX='UA1DF1'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UA1DF1             ALL SYSTEMS                 98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE AND THE GRADIENT OF THE OBJECTIVE FUNCTION
* WHICH IS DEFINED AS A SUM OF SQUARES.
*
* PARAMETERS:
*  II  NF  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF MESH POINTS.
*  II  NE  DECLARED NUMBER OF DIFFERENTIAL EQUATIONS.
*  II  MEL  ACTUAL NUMBER OF DIFFERENTIAL EQUATIONS.
*  IU  KE  INDEX OF THE DIFFERENTIAL EQUATION.
*  RI  AT(NA)  MESH POINTS.
*  RO  AY(NA*NE)  FIELD OF SOLUTION VECTORS IN THE MESH POINTS.
*  RU  YA(MEL)  SOLUTION VECTOR.
*  RO  G(NF)  GRADIENT OF THE OBJECTIVE FUNCTION.
*  RI  GE(NF)  GRADIENT OF THE RIGHT HAND SIDE FUNCTION.
*  RI  GF(NF)  GRADIENT OF THE MODEL FUNCTION.
*  RI  DF(NF)  DERIVATIVES OF THE MODEL FUNCTION.
*  RI  ETA9  MAXIMUM VALUE LESS THEN INFINITY.
*  RO  F  VALUE OF THE OBJECTIVE FUNCTION.
*  RI  FF  OLD VALUE OF THE OBJECTIVE FUNCTION.
*  RI  FE  VALUE OF THE RIGHT HAND SIDE FUNCTION.
*  RU  TA  VALUE OF THE INTEGRATION PARAMETER.
*  RU  HE  ACTUAL STEPSIZE.
*  II  MED  NUMBER OF STEPS PRECEEDING TEST OF STIFTNESS.
*  II  MED1  CHOICE OF STEP SELECTION.
*  II  MED2  NUMBER OF RESETING SOLUTIONS.
*  IO  IER  ERROR INDICATOR.
*
* COMMON DATA :
*  II  KD  DEGREE OF REQUIRED DERVATIVES.
*  II  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  II  KDF  DEGREE OF ANALYTICALLY COMPUTED DERVATIVES.
*  II  KDA  DEGREE OF ANALYTICALLY COMPUTED DERVATIVES.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S  UYPRO1  PROLOGUE.
*  S  UYEPI1  EPILOGUE.
*  S  UYSET0  STATUS DEFINITION.
*  S  UXDCMD  MATRIX-VECTOR PRODUCT AUGMENTED BY A SCALED VECTOR.
*  S  UXDCMM  MATRIX-VECTOR PRODUCT.
*  S  UXVCOP  COPY OF A VECTOR.
*  S  UXVSET  INITIATION OF A VECTOR.
*  S  UXVSUM  SUM OF TWO VECTORS.
*
      SUBROUTINE UA1DF1(NF,NA,NE,MEL,KE,AT,AY,YA,G,GE,GF,DF,ETA9,F,FF,
     & FE,TA,HE,MED,MED1,MED2,IER)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NA,NE,MEL,KE,MED,MED1,MED2,IER
      $FLOAT AT(NA),AY(NA*NE),YA((NE+1)*(NF+1)),G(NF),GE(NF),GF(NF),
     & DF(NE),ETA9,F,FF,FE,TA,HE
      INTEGER N2,MEDS
      SAVE N2,MEDS
      IF (TSS(NS).NE.'UAXX') CALL UYPRO1('UAXX',-1)
      GO TO (1,3,6,7) ISP(NS)
    1 CONTINUE
      MEDS=MED
      IF (KD.LT.0) GO TO 9
      IF (KD.LE.LD) GO TO 9
      IF (KDY.LT.0) GO TO 5
      N2=NE+1
      KE=1
    2 IF (KE.GT.NE) GO TO 4
      CALL UYSET0(1,2)
      RETURN
    3 CONTINUE
      YA(KE)=FE
      IF (KD.GT.0.AND.KDY.GT.0) THEN
      CALL UXVCOP(NF,GE,YA(N2))
      N2=N2+NF
      ENDIF
      KE=KE+1
      GO TO 2
    4 CALL UXVCOP(NE,YA,AY)
    5 IF (KD.LE.0) THEN
      N2=NE
      IF (KDA.LT.0) THEN
      MEL=NE
      ELSE
      MEL=NE+1
      YA(MEL)=ZERO
      ENDIF
      ELSE
      N2=NE*(NF+1)
      IF (KDY.LE.0) CALL UXVSET(NE*NF,ZERO,YA(NE+1))
      IF (KDA.LT.0) THEN
      MEL=N2
      ELSE
      MEL=N2+NF+1
      YA(N2+1)=ZERO
      CALL UXVSET(NF,ZERO,YA(N2+2))
      ENDIF
      ENDIF
      MED=0
      MED1=1
      MED2=0
      TA=AT(1)
      IF (KDY.LT.0) CALL UXVCOP(NE,AY,YA)
      HE=ZERO
      CALL UYSET0(2,3)
      RETURN
    6 CONTINUE
      IF (IER.LT.0) THEN
      F=ETA9
      ITERM=MAX(-96,-90+IER)
      CALL UOERR1('UA1DF1',-ITERM)
      TDXX=TEDX
      GO TO 9
      ENDIF
      IF (ITERM.LT.0) ITERM=0
      IF (KDA.LT.0) THEN
      F=ZERO
      ELSE
      F=YA(N2+1)
      ENDIF
      IF (KDF.LT.0) GO TO 8
      CALL UYSET0(3,4)
      RETURN
    7 CONTINUE
      F=F+FF
    8 IF (KD.LE.0) GO TO 9
      IF (KDF.LT.0) THEN
      CALL UXVSET(NF,ZERO,G)
      ELSE IF (KDF.LE.0) THEN
      CALL UXDCMM(NF,NE,YA(NE+1),DF,G)
      ELSE
      CALL UXDCMD(NF,NE,YA(NE+1),DF,ONE,GF,G)
      ENDIF
      IF (KDA.GE.0) CALL UXVSUM(NF,G,YA(N2+2),G)
    9 CALL UYEPI1(-1)
      MED=MEDS
      LD=KD
      RETURN
      END
