$INTERFACE UANRH3                                             97/12/01

  CALL UANRH3(NA,NB,MHA,KA,$AW,$HA,$IAG,$NORMA)
  $ADD(REAL,'\$AW($NA)\$HA($MHA)')
  $ADD(,INTEGER,'\$IAG($NA+1)')
$REM  $ADD(INTEGER,'\NA\NB\MHA\KA')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UANRH3             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SCALING OF THE HESSIAN MATRIX OF THE APPROXIMATED FUNCTION.
*
* PARAMETERS :
*  II  NA  NUMBER OF FUNCTIONS.
*  II  NB  POINTER IN THE PARTITIONED STRUCTURE.
*  II  M  NUMBER OF ELEMENTS IN THE FIELD HA.
*  II  KA  INDEX OF THE SELECTED FUNCTION.
*  RI  AW(NA)  VECTOR CONTAINING SCALING PARAMETERS.
*  RU  HA(M)  HESSIAN MATRIX OF THE SELECTED FUNCTION.
*  RI  IAG(NA+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE FIELD AG.
*  II  NORMA  SCALING SPECIFICATION. NORMA=0-NO SCALING IS PERFORMED.
*         NORMA=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMA=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
* SUBPROGRAMS USED :
*  S   UXDSMS  SCALING OF A SYMMETRIC MATRIX.
*
      SUBROUTINE UANRH3(NA,NB,M,KA,AW,HA,IAG,NORMA)
      INTEGER NA,NB,M,KA,IAG(NA+1),NORMA
      $FLOAT AW(NA),HA(M)
      INTEGER K,L
      IF (NORMA.GT.0) THEN
      K=IAG(KA)
      L=IAG(KA+1)-K
      CALL UXDSMS(L,HA(NB+1),AW(KA))
      ENDIF
      RETURN
      END
