$INTERFACE UASVG3                                             97/12/01

  CALL UASVG3(NF,NA,MA,KA,$XN,$AG,$IAG,$JAG,$GA,IDECA,ISNA,LDA,NORMF)
  $ADD(REAL,'\$XN($NF)\$AG($MA)\$GA($NF)')
  $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)')
$REM  $ADD(INTEGER,'\NF\NA\MA\KA\IDECA\ISNA\LDA')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UASVG3             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE SPARSE JACOBIAN MATRIX FROM INDIVIDUAL GRADIENTS
* OF THE APPROXIMATED FUNCTIONS.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF FUNCTIONS.
*  II  MA  NUMBER OF ELEMENTS IN THE FIELD AG.
*  II  KA  INDEX OF THE SELECTED FUNCTION.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RO  AG(MA)  SPARSE JACOBIAN MATRIX.
*  RI  IAG(NA+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE FIELD AG.
*  RI  JAG(MA)  COLUMN INDICES OF ELEMENTS IN THE FIELD AG.
*  RI  GA(NF)  GRADIENT OF THE SELECTED FUNCTION.
*  IU  IDECA  DECOMPOSITION INDICATOR. IDECA=0-NO DECOMPOSITION.
*  II  ISNA  SAVING SPECIFICATION. ISNA=0-NO SAVING. ISNA=1-FUNCTION
*         VALUES ARE SAVED. ISNA=2-FUNCTION VALUES AND GRADIENTS ARE
*         SAVED.
*  IU  LDA  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
      SUBROUTINE UASVG3(NF,NA,MA,KA,XN,AG,IAG,JAG,GA,IDECA,ISNA,LDA,
     & NORMF)
      INTEGER NF,NA,MA,KA,IAG(NA+1),JAG(MA),IDECA,ISNA,LDA,NORMF
      $FLOAT XN(NF),AG(MA),GA(NF)
      INTEGER J,JP,K,L
      IF (ISNA.LT.2) RETURN
      K=IAG(KA)
      L=IAG(KA+1)-K
      IF (NORMF.GT.0.AND.ISNA.GT.2) THEN
      DO 1 J=1,L
      JP=ABS(JAG(K))
      AG(K)=GA(JP)*XN(JP)
      K=K+1
    1 CONTINUE
      ELSE
      DO 2 J=1,L
      JP=ABS(JAG(K))
      AG(K)=GA(JP)
      K=K+1
    2 CONTINUE
      ENDIF
      IF (KA.EQ.NA) LDA=MAX(LDA,1)
      IDECA=0
      RETURN
      END
