$INTERFACE UCBS04                                             98/12/01

    $HELP
      TOLERANCE FOR ACTIVE CONSTRAINTS
    $CHECK(EPS9,'1.0$P-8',REAL,4)
    CALL UCBS04(NF,$X,$IX,$XN,$XL,$XU,EPS9)
    $ADD(INTEGER,'\$IX($NX)')
    $ADD(REAL,'\$X($NF)\$XN($NF)\$XL($NF)\$XU($NF)')
$REM    $ADD(INTEGER,'\NF')
$REM    $ADD(REAL,'\EPS9')
    $EXIT

* IMPLEMENTATION

* SUBROUTINE UCBS04             ALL SYSTEMS                   98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INITIATION OF THE VECTOR CONTAINING TYPES OF CONSTRAINTS.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RI  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  RI  EPS9  TOLERANCE FOR ACTIVE CONSTRAINTS.
*
* COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
      SUBROUTINE UCBS04(NF,X,IX,XN,XL,XU,EPS9)
      $INCLUDE('UMCOMM')
      INTEGER NF,IX(NF)
      $FLOAT X(NF),XN(NF),XL(NF),XU(NF),EPS9
      $FLOAT TEMP
      INTEGER I,IXI
      IF (KBF.GT.0) THEN
      DO 1 I=1,NF
      TEMP=1.0$P 0
      IF (NORMF.GT.0) TEMP=XN(I)
      IXI=ABS(IX(I))
      IF ((IXI.EQ.1.OR.IXI.EQ.3.OR.IXI.EQ.4).AND.X(I).LE.XL(I)+
     & EPS9*MAX(ABS(XL(I)),TEMP)) X(I)=XL(I)
      IF ((IXI.EQ.2.OR.IXI.EQ.3.OR.IXI.EQ.4).AND.X(I).GE.XU(I)-
     & EPS9*MAX(ABS(XU(I)),TEMP)) X(I)=XU(I)
    1 CONTINUE
      ENDIF
      RETURN
      END




