* SUBROUTINE UCFMAX                ALL SYSTEMS                01/12/01
C PORTABILITY : ALL SYSTEMS
C 01/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETRMINATION OF THE MAXIMUM STEPSIZE.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NX  NUMBER OF BOX CONSTRAINTS.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  II  NCA  NUMBER OF ACTIVE CONSTRAINTS.
*  II  IX(NX)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XZL(NX)  VECTOR CONTAINING LOVER MULTIPLIERS FOR VARIABLES.
*  RI  XZU(NX)  VECTOR CONTAINING UPPER MULTIPLIERS FOR VARIABLES.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CZL(NC)  VECTOR CONTAINING LOVER MULTIPLIERS FOR CONSTRAINTS.
*  RI  CZU(NC)  VECTOR CONTAINING UPPER MULTIPLIERS FOR CONSTRAINTS.
*  II  ICA(NX+NC)  VECTOR CONTAINING INDICES OF ACTIVE CONSTRAINTS.
*  II  S(NF+NCA)  DIRECTION VECTOR.
*  RI  XO(NX+NC)  VECTOR CONTAINING INCREMENTS FOR LOWER INACTIVE
*         MULTIPLIERS.
*  RI  GO(NX+NC)  VECTOR CONTAINING INCREMENTS FOR UPPER INACTIVE
*         MULTIPLIERS.
*  RI  RMAX  MAXIMUM VALUE OF THE PRIMAL STEPSIZE PARAMETER.
*  RU  RMAXD  MAXIMUM VALUE OF THE DUAL STEPSIZE PARAMETER.
*
*  COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*  II  KBC  SPECIFICATION OF LINEAR CONSTRAINTS. KBC=0-NO LINEAR
*         CONSTRAINTS. KBC=1-ONE SIDED LINEAR CONSTRAINTS. KBC=2=TWO
*         SIDED LINEAR CONSTRAINTS.
*
      SUBROUTINE UCFMAX(NF,NX,NC,NCA,IX,XZL,XZU,IC,CZL,CZU,ICA,S,XO,GO,
     & RMAX,RMAXD)
      $INCLUDE('UMCOMM')
      INTEGER NF,NX,NC,NCA,IX(NX),IC(NC),ICA(NCA)
      $FLOAT XZL(NX),XZU(NX),CZL(NC),CZU(NC),S(NF+NCA),XO(NX+NC),
     & GO(NX+NC),RMAX,RMAXD
      INTEGER I,K,KK
      $FLOAT CON
      PARAMETER(CON=0.99$P 0)
      RMAXD=RMAX
      DO 1 I=1,NCA
      K=ICA(I)
      IF (K.LT.0) THEN
      K=-K
      KK=-IX(K)
      IF (KK.EQ.1.OR.KK.EQ.3) THEN
      IF (S(NF+I).LT.ZERO) RMAXD=MIN(RMAXD,-XZL(K)/S(NF+I))
      ELSE IF (KK.EQ.2.OR.KK.EQ.4) THEN
      IF (S(NF+I).LT.ZERO) RMAXD=MIN(RMAXD,-XZU(K)/S(NF+I))
      ENDIF
      ELSE
      KK=-IC(K)
      IF (KK.EQ.1.OR.KK.EQ.3) THEN
      IF (S(NF+I).LT.ZERO) RMAXD=MIN(RMAXD,-CZL(K)/S(NF+I))
      ELSE IF (KK.EQ.2.OR.KK.EQ.4) THEN
      IF (S(NF+I).LT.ZERO) RMAXD=MIN(RMAXD,-CZU(K)/S(NF+I))
      ENDIF
      ENDIF
    1 CONTINUE
      IF (KBF.GT.0) THEN
      DO 2 K=1,NX
      KK=IX(K)
      IF (KK.EQ.1.OR.KK.EQ.3.OR.ABS(KK).EQ.4) THEN
      IF (XO(K).LT.ZERO) RMAXD=MIN(RMAXD,-XZL(K)/XO(K))
      ENDIF
      IF (KK.EQ.2.OR.KK.EQ.4.OR.ABS(KK).EQ.3) THEN
      IF (GO(K).LT.ZERO) RMAXD=MIN(RMAXD,-XZU(K)/GO(K))
      ENDIF
    2 CONTINUE
      ENDIF
      IF (KBC.GT.0) THEN
      DO 3 K=1,NC
      KK=IC(K)
      IF (KK.EQ.1.OR.KK.EQ.3.OR.ABS(KK).EQ.4) THEN
      IF (XO(NX+K).LT.ZERO) RMAXD=MIN(RMAXD,-CZL(K)/XO(NX+K))
      ENDIF
      IF (KK.EQ.2.OR.KK.EQ.4.OR.ABS(KK).EQ.3) THEN
      IF (GO(NX+K).LT.ZERO) RMAXD=MIN(RMAXD,-CZU(K)/GO(NX+K))
      ENDIF
    3 CONTINUE
      ENDIF
      RMAXD=CON*RMAXD
      RETURN
      END
