* SUBROUTINE UCIACT             ALL SYSTEMS                 98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF ACTIVE CONSTRAINTS.
*
* PARAMETERS :
*  II  NX  NUMBER OF BOX CONSTRAINTS.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  II  NCA  NUMBER OF ACTIVE CONSTRAINTS.
*  II  IX(NX)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XSL(NX)  VECTOR CONTAINING LOVER SLACKS FOR VARIABLES.
*  RI  XSU(NX)  VECTOR CONTAINING UPPER SLACKS FOR VARIABLES.
*  RI  XZL(NX)  VECTOR CONTAINING LOVER MULTIPLIERS FOR VARIABLES.
*  RI  XZU(NX)  VECTOR CONTAINING UPPER MULTIPLIERS FOR VARIABLES.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CSL(NC)  VECTOR CONTAINING LOVER SLACKS FOR CONSTRAINTS.
*  RI  CSU(NC)  VECTOR CONTAINING UPPER SLACKS FOR CONSTRAINTS.
*  RI  CZL(NC)  VECTOR CONTAINING LOVER MULTIPLIERS FOR CONSTRAINTS.
*  RI  CZU(NC)  VECTOR CONTAINING UPPER MULTIPLIERS FOR CONSTRAINTS.
*  IO  ICA(NX+NC)  VECTOR CONTAINING INDICES OF ACTIVE CONSTRAINTS.
*  RI  EPS9  TOLERANCE FOR ACTIVITY OF CONSTRAINTS.
*  IO  INF  CHANGE OF ACTIVE CONSTRAINT INDICATOR. INF=0-NO CHANGE.
*         INF=1-CHANGE OF ACTIVE CONSTRAINTS.
*
*  COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*  II  KBC  SPECIFICATION OF LINEAR CONSTRAINTS. KBC=0-NO LINEAR
*         CONSTRAINTS. KBC=1-ONE SIDED LINEAR CONSTRAINTS. KBC=2=TWO
*         SIDED LINEAR CONSTRAINTS.
*
      SUBROUTINE UCIACT(NX,NC,NCA,IX,XSL,XSU,XZL,XZU,IC,CSL,CSU,
     & CZL,CZU,ICA,EPS9,INF)
      $INCLUDE ('UMCOMM')
      INTEGER NX,NC,NCA,IX(NX),IC(NC),ICA(NX+NC),INF
      $FLOAT XSL(NX),XSU(NX),XZL(NX),XZU(NX),CSL(NC),CSU(NC),
     & CZL(NC),CZU(NC),EPS9
      INTEGER I,KC,KCA
      INF=0
      KCA=NCA
      NCA=0
      IF (KBF.GT.0) THEN
      DO 1 I=1,NX
      IX(I)=ABS(IX(I))
      IF (IX(I).EQ.0) THEN
      ELSE IF (IX(I).EQ.1) THEN
      IF (XSL(I).LE.EPS9*ABS(XZL(I))) THEN
      IX(I)=-1
      NCA=NCA+1
      IF (NCA.GT.KCA) THEN
      ICA(NCA)=-I
      INF=1
      ELSE IF (ICA(NCA).NE.-I) THEN
      ICA(NCA)=-I
      INF=1
      ENDIF
      ENDIF
      ELSE IF (IX(I).EQ.2) THEN
      IF (XSU(I).LE.EPS9*ABS(XZU(I))) THEN
      IX(I)=-2
      NCA=NCA+1
      IF (NCA.GT.KCA) THEN
      ICA(NCA)=-I
      INF=1
      ELSE IF (ICA(NCA).NE.-I) THEN
      ICA(NCA)=-I
      INF=1
      ENDIF
      ENDIF
      ELSE IF (IX(I).EQ.3.OR.IX(I).EQ.4) THEN
      IF (ABS(XSL(I)*XZU(I)).LE.ABS(XSU(I)*XZL(I))) THEN
      IF (XSL(I).LE.EPS9*ABS(XZL(I))) THEN
      IX(I)=-3
      NCA=NCA+1
      IF (NCA.GT.KCA) THEN
      ICA(NCA)=-I
      INF=1
      ELSE IF (ICA(NCA).NE.-I) THEN
      ICA(NCA)=-I
      INF=1
      ENDIF
      ENDIF
      ELSE
      IF (XSU(I).LE.EPS9*ABS(XZU(I))) THEN
      IX(I)=-4
      NCA=NCA+1
      IF (NCA.GT.KCA) THEN
      ICA(NCA)=-I
      INF=1
      ELSE IF (ICA(NCA).NE.-I) THEN
      ICA(NCA)=-I
      INF=1
      ENDIF
      ENDIF
      ENDIF
      ELSE IF (IX(I).EQ.5) THEN
      IX(I)=-5
      ENDIF
    1 CONTINUE
      ENDIF
      IF (KBC.GT.0) THEN
      DO 2 KC=1,NC
      IC(KC)=ABS(IC(KC))
      IF (IC(KC).EQ.0) THEN
      ELSE IF (IC(KC).EQ.1) THEN
      IF (CSL(KC).LE.EPS9*ABS(CZL(KC))) THEN
      IC(KC)=-1
      NCA=NCA+1
      IF (NCA.GT.KCA) THEN
      ICA(NCA)=KC
      INF=1
      ELSE IF (ICA(NCA).NE.KC) THEN
      ICA(NCA)=KC
      INF=1
      ENDIF
      ENDIF
      ELSE IF (IC(KC).EQ.2) THEN
      IF (CSU(KC).LE.EPS9*ABS(CZU(KC))) THEN
      IC(KC)=-2
      NCA=NCA+1
      IF (NCA.GT.KCA) THEN
      ICA(NCA)=KC
      INF=1
      ELSE IF (ICA(NCA).NE.KC) THEN
      ICA(NCA)=KC
      INF=1
      ENDIF
      ENDIF
      ELSE IF (IC(KC).EQ.3.OR.IC(KC).EQ.4) THEN
      IF (ABS(CSL(KC)*CZU(KC)).LE.ABS(CSU(KC)*CZL(KC))) THEN
      IF (CSL(KC).LE.EPS9*ABS(CZL(KC))) THEN
      IC(KC)=-3
      NCA=NCA+1
      IF (NCA.GT.KCA) THEN
      ICA(NCA)=KC
      INF=1
      ELSE IF (ICA(NCA).NE.KC) THEN
      ICA(NCA)=KC
      INF=1
      ENDIF
      ENDIF
      ELSE
      IF (CSU(KC).LE.EPS9*ABS(CZU(KC))) THEN
      IC(KC)=-4
      NCA=NCA+1
      IF (NCA.GT.KCA) THEN
      ICA(NCA)=KC
      INF=1
      ELSE IF (ICA(NCA).NE.KC) THEN
      ICA(NCA)=KC
      INF=1
      ENDIF
      ENDIF
      ENDIF
      ELSE IF (IC(KC).EQ.5) THEN
      IC(KC)=-5
      NCA=NCA+1
      IF (NCA.GT.KCA) THEN
      ICA(NCA)=KC
      INF=1
      ELSE IF (ICA(NCA).NE.KC) THEN
      ICA(NCA)=KC
      INF=1
      ENDIF
      ENDIF
    2 CONTINUE
      ENDIF
      IF (NCA.NE.KCA) INF=1
      RETURN
      END
