$INTERFACE UCLNF4                                             97/12/01

  CALL UCLNF4(NF,NC,MC,$X,$XN,$CF,$CG,$ICG,$JCG,ISNC,$NORMF)
  $ADD(REAL,'\$X($NF)\$XN($NF)\$CF($NC)\$CG($MC)')
  $ADD(INTEGER,'\$ICG($NC+1)\$JCG($MC)')
$REM  $ADD(INTEGER,'\NF\NC\MC\ISNC')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UCLNF4             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE OF THE LINEAR APPROXIMATED FUNCTION.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NC  NUMBER OF FUNCTIONS.
*  II  MC  NUMBER OF ELEMENTS IN THE FIELD AG.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  XN(NF)  VECTOR OF SCALING PARAMETERS.
*  RO  CF(NC)  VECTOR CONTAINING VALUES OF THE CONSTRAINT FUNCTIONS.
*  RI  CG(MC)  SPARSE JACOBIAN MATRIX.
*  II  ICG(NC+1)  POSITION OF THE FIRST RORWS ELEMENTS IN THE FIELD CG.
*  II  JCG(MC) COLUMN INDICES OF ELEMENTS IN THE FIELD CG.
*  II  ISNC  SAVING SPECIFICATION. ISNC=0-NO SAVING. ISNC=1-FUNCTION
*         VALUES ARE SAVED. ISNC=2-FUNCTION VALUES AND GRADIENTS ARE
*         SAVED.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
      SUBROUTINE UCLNF4(NF,NC,MC,X,XN,CF,CG,ICG,JCG,ISNC,NORMF)
      INTEGER NF,NC,MC,ICG(NC+1),JCG(MC),ISNC,NORMF
      $FLOAT X(NF),XN(NF),CF(NC),CG(MC)
      $FLOAT FC
      INTEGER J,JP,K,L,KC
      DO 3 KC=1,NC
      FC=0.0$P 0
      K=ICG(KC)
      L=ICG(KC+1)-K
      IF (NORMF.GT.0.AND.ISNC.GT.2) THEN
      DO 1 J=1,L
      JP=ABS(JCG(K))
      FC=FC+CG(K)*X(JP)/XN(JP)
      K=K+1
    1 CONTINUE
      ELSE
      DO 2 J=1,L
      JP=ABS(JCG(K))
      FC=FC+CG(K)*X(JP)
      K=K+1
    2 CONTINUE
      ENDIF
      CF(KC)=FC
    3 CONTINUE
      RETURN
      END
