$INTERFACE UCNRL1                                             97/12/01

  CALL UCNRL1(NF,NCL,$CW,$CF,$CL,$CU,$CG,$KBC,$NORMC,$JOB)
  $ADD(REAL,'\$CW($NC)\$CF($NC)\$CL($NC)\$CU($NC)\$CG($NF*$NC)')
$REM  $ADD(INTEGER,'\NF\NCL')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UCNRL1             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INITIAL SCALING OF THE LINEAR FUNCTIONS.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NCL  NUMBER OF LINEAR FUNCTIONS.
*  RI  CW(NC)  VECTOR OF SCALING PARAMETERS.
*  RU  CF(NC)  VECTOR CONTAINING FUNCTION VALUES.
*  RU  CL(NC)  VECTOR CONTAINING LOWER BOUNDS.
*  RU  CU(NC)  VECTOR CONTAINING UPPER BOUNDS.
*  RU  CG(NF*NCL)  DENSE JACOBIAN MATRIX.
*         CONSTRAINT FUNCTIONS.
*  II  KBC  SPECIFICATION OF MEASURED VALUES. KBA=0-ZERO MEASURED
*         VALUES. KBA=1 MEASURED VALUES ARE GIVEN IN THE FIELD AM.
*  II  NORMC  SCALING SPECIFICATION. NORMC=0-NO SCALING IS PERFORMED.
*         NORMC=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMC=2-SCALING FACTORS ARE SUPPLIED BY USER.
*  II  JOB  SCALING SPECIFICATION. IF JOB=1 THEN FORWARD SCALING
*         IS PERFORMED. IF JOB=-1 THEN BACKWARD SCALING IS PERFORMED.
*
* SUBPROGRAMS USED :
*  S   UXVSCL  SCALING OF A VECTOR.
*
      SUBROUTINE UCNRL1(NF,NCL,CW,CF,CL,CU,CG,KBC,NORMC,JOB)
      INTEGER NF,NCL,KBC,NORMC,JOB
      $FLOAT CW(NCL),CF(NCL),CL(NCL),CU(NCL),CG(NF*NCL)
      $FLOAT POM
      INTEGER KC,JCG
      IF (NORMC.LE.0) RETURN
      IF (JOB.EQ.0) RETURN
      JCG=0
      DO 1 KC=1,NCL
      POM=CW(KC)
      IF (JOB.LT.0) POM=1.0$P 0/POM
      CALL UXVSCL(NF,POM,CG(JCG+1),CG(JCG+1))
      IF (KBC.GT.0) CL(KC)=POM*CL(KC)
      IF (KBC.GT.1) CU(KC)=POM*CU(KC)
      IF (JOB.LT.0) CF(KC)=POM*CF(KC)
      JCG=JCG+NF
    1 CONTINUE
      RETURN
      END
