$INTERFACE UDDTS7                                             97/12/01
$REM LU

  $HELP
    CHOICE OF THE SCALING MATRIX:
      0 - UNIT MATRIX (NO SCALING)
      1 - SQUARE OF THE MATRIX H DIAGONAL
  $CHECK(MOS1,0,'0\1',4)
  $HELP
     TYPE OF DECOMPOSITION
       1 - SCHNABEL-ESKOW DECOMPOSITION WITH NUMERICAL PERMUTATIONS
       2 - SCHNABEL-ESKOW DECOMPOSITION WITH TWO LEVEL INDICES
  $CHECK(MOS2,1,'1\2',2)
  $IF(MOS2=1) 
    $LET='L'
    $ART=',$IB)'
    $ADD(INTEGER,'\$IB($NF)')
  $ELSE  
    $LET='S'
    $ART=')'
  $ENDIF
  $HELP
    CHOICE OF THE WEIGHTING MATRIX:
      0 - UNIT MATRIX (NO WEIGHTING)
      1 - SQUARE OF THE MATRIX TRANS(L)*L DIAGONAL
  $CHECK(MOS3,0,'0\1',4)
  $IF(MOS1=0)
    $GSS=GS
    $GS=GO
  $ENDIF
  $IF(MOS3=0)
    $XSS=XS
    $XS=GO
  $ENDIF
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,'ETA0*1.0$P-3',REAL,4)
  $HELP
    LOWER PRECISION FOR OPTIMUM LOCALLY CONSTRAINED STEP
  $CHECK(DEL1,'0.9$P 0',REAL,4)
  $HELP
    UPPER PRECISION FOR OPTIMUM LOCALLY CONSTRAINED STEP
  $CHECK(DEL2,'1.1$P 0',REAL,4)
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XDEL,'0.0$P 0',REAL,3)
  $ADD(REAL,'\$H($M)\$GN($NF)\$SN($NF)\$GO($NF)\$XS($NF)\$GS($NF)')
  $ADD(INTEGER,'\$IH($NF)')
  $ADD(REAL,'\ALF\RHO1\RHO2\CON')
  $ADD(REAL,'\UXVDOT')
  $ADD(REAL,'\UXDSDL\UXDSDU\UXDSDP\UXDPGQ')
  $C1L='0.1$P 0'
  $C1U='0.9$P 0'
  $N='N'
  CALL UOD1D1
  IF (IDECF.LT.0) THEN
  CALL UXVINP($N,$IH)
  IDECF=4
  ENDIF
  IF (IDECF.EQ.0) THEN
  $IF(MOS1>0)
    CALL UXDSMX($N,$H,$GS)
  $ENDIF
*
*     SCHNABEL-ESKOW DECOMPOSITION
*
  RHO1=ETA2
  CALL UXD$(LET)GF($N,$H,$IH,$GO,INF,RHO1,RHO2$$ART
  $IF(MOS3>0)
    CALL UXD$(LET)GX($N,$H,$IH,$XS)
  $ENDIF
  NDECF=NDECF+1
  IDECF=4
  ELSE IF (IDECF.EQ.1) THEN
  CALL UXVINP($N,$IH)
  IDECF=4
  ELSE IF (IDECF.EQ.2) THEN
  CALL UXDPRT($N,$H)
  CALL UXVINP($N,$IH)
  IDECF=4
  ELSE IF (IDECF.EQ.4) THEN
  ELSE IF (IDECF.EQ.5) THEN
  CALL UXDSRT($N,$H,$IH)
  IDECF=4
  ELSE
  ITERD=-1
  TDXX='BAD DEC4'
  CALL UOERR1('UDDTS7',1)
  GOTO $50
  ENDIF
  CALL UXVCOP($N,$GN,$GO)
  $IF(MOS1>0)
    CALL UXVMUL($N,$GS,$GO,$GO,1)
  $ENDIF
  CALL UXD$(LET)GB($N,$H,$IH,$GO,1)
  $IF(MOS3>0)
    CALL UXVMUL($N,$XS,$GO,$GO,1)
  $ENDIF
  GNORM=SQRT(UXVDOT($N,$GO,$GO))
  INITD=MAX(ABS(INITD),1)
  NRED=0
  IF (IDIR.LE.0) THEN
  IF (XDEL.LE.ZERO) THEN
*
*     INITIAL TRUST REGION BOUND
*
  RHO1=UXDPGQ($N,$H,$GO,$GO)
  RHO2=GNORM*GNORM
  IF (RHO1.LE.ZERO) THEN
  XDEL=GNORM
  ELSE
  XDEL=(RHO2/RHO1)*GNORM
  ENDIF
  IF (IEST.EQ.1) XDEL=MIN(XDEL,FOUR*(F-FMIN)/GNORM)
  XDEL=MIN(XDEL,XMAX)
  ENDIF
*
*     INITIAL BOUNDS FOR THE PARAMETER T
*
  T=ZERO
  EU=UXDSDU($N,$H,INF)
  EL=UXDSDL($N,$H,INF)
  TL=GNORM/XDEL-EU
  TU=GNORM/XDEL-EL
  ELSE IF (IDIR.EQ.1) THEN
  T=T*XDELO/XDEL
  TL=MAX(TL,GNORM/XDEL-EU)
  TU=GNORM/XDEL-EL
  ELSE IF (IDIR.EQ.2) THEN
  T=T*XDELO/XDEL
  TL=GNORM/XDEL-EU
  TU=MIN(TU,GNORM/XDEL-EL)
  ENDIF
  TL=MAX(ZERO,TL)
  TU=MAX(TL,TU)
  T=MAX(T,TL)
  T=MIN(T,TU)
  TDXX='INITIAL '
$20 CONTINUE
  IF (T.LT.TL) THEN
*
*     THE PARAMETER T IS SHIFTED
*
  T=SQRT(TL*TU)
  T=MAX(T,TL+$C1L*(TU-TL))
  T=MIN(T,TL+$C1U*(TU-TL))
  TDXX='SHIFTED '
  ENDIF
  CALL UXVNEG($N,$GO,$SN)
  CALL UXDSDB($N,$H,T,$SN)
  SNORM=SQRT(UXVDOT($N,$SN,$SN))
  MODE=1
  CALL UOD1D3(T,TL,TU,E,SNORM,XDEL,MODE)
  IF (SNORM.GT.DEL2*XDEL) THEN
*
*     STEP IS TOO LARGE
*
  TL=MAX(TL,T)
  GO TO $30
  ELSE IF (SNORM.LT.DEL1*XDEL) THEN
  IF (T.NE.ZERO) THEN
*
*     STEP IS TOO SMALL
*
  TU=MIN(TU,T)
  ELSE
*
*     STEP IS ACCEPTABLE
*
  ITERD=1
  TDXX='OLC STEP'
  GO TO $40
  ENDIF
  ELSE
  ITERD=3
  TDXX='OLC MAX1'
  GO TO $40
  ENDIF
*
*     TRYING TO USE BOUNDARY STEP
*
  CALL UNSTEP(XDEL,SNORM,ABS(S(INF)),ONE,ALF)
  CON=(ONE-DEL1)*(ONE+DEL1)
  IF (ALF*ALF*(EL+T).LE.CON*(T*XDEL*XDEL-UXVDOT($N,$GO,$SN))) THEN
  IF (S(INF).LT.ZERO) ALF=-ALF
  S(INF)=S(INF)+ALF
  SNORM=XDEL
  ITERD=3
  TDXX='OLC MAX2'
  GO TO $40
  ENDIF
$30 CONTINUE
  IF (GNORM.LE.ZERO) THEN
  T=E
  ELSE
*
*     NEW T IS COMPUTED USING ONE STEP OF THE NEWTON METHOD FOR
*     NONLINEAR EQUATION
*
  ALF=UXDSDP($N,$H,T,$SN,$SN)
  T=T+(SNORM*SNORM/ALF)*(SNORM-XDEL)/XDEL
  TDXX='NEWTON  '
  ENDIF
  NRED=NRED+1
  GO TO $20
$40 CONTINUE
  PP=UXDPGQ($N,$H,$SN,$SN)*HALF
  $IF(MOS3>0)
    CALL UXVMUL($N,$XS,$SN,$SN,1)
  $ENDIF
  CALL UXD$(LET)GB($N,$H,$IH,$SN,-1)
  $IF(MOS1>0)
   CALL UXVMUL($N,$GS,$SN,$SN,1)
 $ENDIF
$50 CONTINUE
  CALL UOD1D2($N,$GN,$SN)
  $IF(MOS1=0) $GS=GSS
  $IF(MOS3=0) $XS=XSS
  $ADD(INIT)
    NDXX='UDDTS7'
  $ENDADD
  $EXIT
