$INTERFACE UDGGA7                                             97/12/01
$REM LU

  $C1L='0.1$P 0'
  $C1U='0.9$P 0'
  $CON1='1.0$P-8'
  $IW1='IW1'
  $IW2='IW2'
  $IDECA=0
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,'ETA0*1.0$P-3',REAL,4)
  $HELP
    LOWER PRECISION FOR OPTIMUM LOCALLY CONSTRAINED STEP
  $CHECK(DEL1,'0.9$P 0',REAL,4)
  $HELP
    UPPER PRECISION FOR OPTIMUM LOCALLY CONSTRAINED STEP
  $CHECK(DEL2,'1.1$P 0',REAL,4)
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XDEL,'0.0$P 0',REAL,3)
  $ADD(REAL,'\$GN($NF)\$SN($NF)\$XO($NF)\$AF($NA)\$AFO($NA+$NF)')
  $ADD(REAL,'\ALF\RHO\RHO1\RHO2')
  $ADD(REAL,'\UXVDOT')
  $ADD(INTEGER,'\NAA\MAA')
  $IF(JARA='D')
    $ADD(REAL,'\$AG($NF*$NA)\$AGO($NF*($NA+$NF))\$GO($NF)')
    $ADD(INTEGER,'\$IAG($NF)')
    $N='N'
    $IF(JASA='C')
      $HELP
        STORING PERMUTATIONS IN THE QR DECOMPOSITION:
          1 - CHANGES OF MATRIX ROWS 
          2 - TWO LEVEL INDICES
      $CHECK(MOS2,2,'1\2',3)
    $ELSE
      $MOS2=2
    $ENDIF  
    $HELP
      TYPE OF QR DECOMPOSITION:
        1 - PARTIAL QR DECOMPOSITION
        2 - TOTAL QR DECOMPOSITION
    $CHECK(MOS3,1,'1\2',3)
    $HELP
      PIVOTING IN THE HOUSEHOLDER QR DECOMPOSITION:
        1 - BASIC PIVOTING
        2 - BASIC PIVOTING WITH INCREMENTAL RANK DETERMINATION
        3 - INCREMENTAL RANK-REVEALING PIVOTING
    $CHECK(MOS4,1,'1\2\3',3)
  $ELSEIF(JARA='S')
    $ADD(REAL,'\$AG($MMAX)')
    $ADD(INTEGER,'\$IAG($NA+$NF+1)\$JAG($MMAX)')
    $ADD(INTEGER,'\$IH($NF+1)\$IW1(11*($NF+1))\$IW2(6*($NA+$NF+1))')
    $N='NF'
  $ENDIF
  CALL UOD1D1
  IF (IDECA.LT.0) IDECA=0
  IF (IDECA.NE.0) THEN
  ITERD=-1
  TDXX='$IDECA'
  CALL UOERR1('UD$(JARA)GA7',1)
  GO TO $50
  ENDIF
  $IF(JARA='D')
    IF (LD.LE.ZERO) CALL UXD$(JASB)MM($POMA,$AG,$AF,$GN)
  $ELSEIF(JARA='S')
    IF (LD.LE.ZERO) CALL UXSCMM($N,NA,MA,$AG,$IAG,$JAG,$AF,$GN)
  $ENDIF
  GNORM=SQRT(UXVDOT($N,$GN,$GN))
  IF (KD.LE.0) THEN
  IF (GNORM.LE.TOLG) THEN
  ITERM=4
  TXFU='GRAD TOL'
  GO TO $50
  ENDIF
  ENDIF
  INITD=MAX(ABS(INITD),1)
  IF (XDEL.LE.ZERO) THEN
*
*     INITIAL TRUST REGION BOUND
*
  $IF(JARA='D')
    CALL UXD$(JASA)MM($POMA,$AG,$GN,$AFO)
  $ELSE
    CALL UXSRMM($N,NA,MA,$AG,$IAG,$JAG,$GN,$AFO)
  $ENDIF
  RHO1=UXVDOT(NA,$AFO,$AFO)
  RHO2=GNORM*GNORM
  IF (RHO1.LE.ZERO) THEN
  XDEL=GNORM
  ELSE
  XDEL=(RHO2/RHO1)*GNORM
  ENDIF
  IF(IEST.EQ.1) XDEL=MIN(XDEL,FOUR*(F-FMIN)/GNORM)
  XDEL=MIN(XDEL,XMAX)
  ENDIF
*
*     INITIAL BOUNDS FOR THE PARAMETER T
*
  NRED=0
  IF (IDIR.LE.0) THEN
  T=ZERO
  TL=ZERO
  TU=GNORM/XDEL
  ELSE IF (IDIR.EQ.1) THEN
  T=T*XDELO/XDEL
  TL=MAX(TL,ZERO)
  TU=GNORM/XDEL
  ELSE IF (IDIR.EQ.2) THEN
  T=T*XDELO/XDEL
  TL=ZERO
  TU=MIN(TU,GNORM/XDEL)
  ENDIF
  TL=MAX(ZERO,TL)
  TU=MAX(TL,TU)
  T=MAX(T,TL)
  T=MIN(T,TU)
  TDXX='INITIAL '
$20 CONTINUE
  IF (T.NE.ZERO.AND.T.LE.TL) THEN
*
*     THE PARAMETER T IS SHIFTED
*
  T=SQRT(TL*TU)
  T=MAX(T,TL+$C1L*(TU-TL))
  T=MIN(T,TL+$C1U*(TU-TL))
  TDXX='SHIFTED '
  ENDIF
  INF=0
  ALF=ETA2
  $IF(JARA='D')
*
*     AUGMENTED MATRIX CONSTRUCTION
*
    CALL UXD$(JASA)MO($N,NA,NAA,SQRT(T),$AG,$AGO)
    CALL UXVNEG(NA,$AF,$AFO)
    CALL UXVSET($N,ZERO,$AFO(NA+1))
*
*     HOUSEHOLDER DECOMPOSITION
*
    $IF(MOS2=1)
      ALF=SQRT(ALF)
      CALL UXECHF(NAA,$N,$AGO,$IAG,$XO,$GO,$SN,INF)
      CALL UXECHP(NAA,$N,$AGO,ALF,$GO,$SN,INF,IER)
      CALL UXECTF(NAA,$N,$AGO,$GO,IER)
    $ELSE 
      $IF(MOS4=3)
        CALL UXD$(JASA)HC($N,NAA,$AGO,$IAG,ALF,$XO,$GO,$SN,INF,IER)
      $ELSE
        CALL UXD$(JASA)HF($N,NAA,$AGO,$IAG,$XO,$GO,INF)
      $ENDIF
      $IF(MOS4=2)
        CALL UXD$(JASA)HP($N,NAA,$AGO,$IAG,ALF,$GO,$SN,INF,IER)
      $ELSEIF(MOS4=1)
        CALL UXD$(JASA)HR($N,NAA,$AGO,$IAG,ALF,INF,IER)
      $ENDIF
      $IF(MOS3=2)
        CALL UXD$(JASA)TF($N,NAA,$AGO,$IAG,$GO,IER)
      $ENDIF
    $ENDIF  
    NDECA=NDECA+1
*
*     DIRECTION DETERMINATION
*
    $IF(MOS2=1)
      CALL UXECHB(NAA,$N,$AGO,$AFO,$XO,IER)
      CALL UXECRB(IER,NAA,$AGO,$AFO,-1)
      CALL UXECTB(NAA,$N,$AGO,$AFO,$GO,IER)
      CALL UXVSBP($N,$IAG,$AFO,$SN)
      CALL UXVCOP($N,$AFO,$SN)
    $ELSE 
      CALL UXD$(JASA)HB($N,NAA,$AGO,$IAG,$AFO,$XO,INF)
      CALL UXD$(JASA)UB($N,NAA,$AGO,$IAG,$AFO,$SN,IER,-1)
      $IF(MOS3=2)
        CALL UXD$(JASA)TB($N,NAA,$AGO,$IAG,$SN,$GO,IER)
      $ENDIF
    $ENDIF  
  $ELSEIF(JARA='S')
*
*     AUGMENTED MATRIX CONSTRUCTION
*
    NAA=NA+$N
    MAA=MA+$N
    CALL UXVSET($N,SQRT(T),$AG(MA+1))
    CALL UXVNEG(NA,$AF,$AFO)
    CALL UXVSET($N,ZERO,$AFO(NA+1))
*
*     SPARSE QR DECOMPOSITION
*
    CALL UXSRBF(NAA,$N,INF,MMAX,MMAX,MMAX,$IAG,$JAG,$IH&
,$IW1(9*$N+10),$IW1(10*$N+11),$IW2(2*NAA+3),$IW2(3*NAA+4)&
,$IW2(4*NAA+5),$IW2(5*NAA+6),$AG,$AFO)
    NDECA=NDECA+1
    IF (INF.GT.0) THEN
    ITERD=-INF
    TDXX='DEC ERR '
    GO TO $50
    ENDIF
*
*     DIRECTION DETERMINATION
*
    CALL UXSTMB($N,MAA,$JAG,$AG,$SN,$AFO,ALF)
    CALL UXVSBP($N,$IW1(10*$N+11),$SN,$AFO)
  $ENDIF
  SNORM=SQRT(UXVDOT($N,$SN,$SN))
  MODE=1
  CALL UOD1D3(T,TL,TU,E,SNORM,XDEL,MODE)
  IF (TU-TL.LE.$CON1) THEN
*
*     INTERVAL IS TOO SMALL
*
  IF (T.NE.ZERO) THEN
  ITERD=5
  TDXX='ZERO INT'
  ELSE
  ITERD=1
  TDXX='OLC STEP'
  ENDIF
  GO TO $40
  ELSE IF (NRED.GE.20) THEN
  ITERD=6
  TDXX='MAX RED '
  CALL UOERR1('UD$(JARA)GA7',3)
  GO TO $40
  ELSE IF (SNORM.GT.DEL2*XDEL) THEN
*
*     STEP IS TOO LARGE
*
  TL=MAX(TL,T)
  GO TO $30
  ELSE IF (SNORM.LT.DEL1*XDEL) THEN
  IF (T.NE.ZERO) THEN
*
*     STEP IS TOO SMALL
*
  TU=MIN(TU,T)
  ELSE
*
*     STEP IS ACCEPTABLE
*
  ITERD=1
  TDXX='OLC STEP'
  GO TO $40
  ENDIF
  ELSE
  ITERD=3
  TDXX='OLC MAX1'
  GO TO $40
  ENDIF
$30 CONTINUE  
  IF (GNORM.LE.ZERO) THEN
  T=TL
  ELSE
*
*     NEW T IS COMPUTED USING ONE STEP OF THE NEWTON METHOD FOR
*     NONLINEAR EQUATION
*
  CALL UXVCOP($N,$SN,$XO)
  $IF(JARA='D')
    $IF(MOS2=1)
      CALL UXVSFP($N,$IAG,$XO,$AFO) 
      CALL UXECTM(NAA,$N,$AGO,$XO,$GO,IER)
      CALL UXECRB(IER,NAA,$AGO,$XO,1)
    $ELSE 
      $IF(MOS3=2)
        CALL UXD$(JASA)TM($N,NAA,$AGO,$IAG,$XO,$GO,IER)
      $ENDIF
      CALL UXD$(JASA)UB($N,NAA,$AGO,$IAG,$XO,$AFO,IER,1)
    $ENDIF  
    T=T+(SNORM*SNORM/UXVDOT($N,$AFO,$AFO))*(SNORM-XDEL)/XDEL
  $ELSEIF(JARA='S')
    CALL UXVSFP($N,$IW1(10*$N+11),$XO,$AFO) 
    CALL UXSTQB($N,MAA,$JAG,$AG,$XO,ALF,1)
    T=T+(SNORM*SNORM/UXVDOT($N,$XO,$XO))*(SNORM-XDEL)/XDEL
  $ENDIF
  TDXX='NEWTON  '
  ENDIF
  NRED=NRED+1
  GO TO $20
$40 CONTINUE
  $IF(JARA='D')
    CALL UXD$(JASA)MM($POMA,$AG,$SN,$AFO)
  $ELSEIF(JARA='S')
    CALL UXSRMM($N,NA,MA,$AG,$IAG,$JAG,$SN,$AFO)
  $ENDIF
  PP=UXVDOT(NA,$AFO,$AFO)*HALF
$50 CONTINUE
  CALL UOD1D2($N,$GN,$SN)
  $ADD(INIT)
    NDXX='UD$(JARA)GA7'
  $ENDADD
  $EXIT

