$INTERFACE UDGGE2                                             97/12/01
$REM LU

  $IW1='IW1'
  $IW2='IW2'
  $CON1='1.0$P-2'
  $CON2='1.0$P-60'
  $CON3='2.0$P 0'
  $ICON1=0
  $ICON2=4
  $ICON3=32
  $ICON4=5
  $ICON5=8
  $IDECF=2
  $HELP
    NUMBER OF DOG-LEG STEPS
  $CHECK(MOS,3,INT,3)
  $HELP
    TYPE OF SMOOTHING
      0 - NO SMOOTHING
      1 - SINGLE SMMOTHING
      2 - DOUBLE SMOOTHING
  $CHECK(MOS3,2,'0\1\2',4)
  $HELP
    PARAMETER FOR INCOMPLETE LU PRECONDITIONER
  $CHECK(ETA2,'0.0$P 0',REAL,4)
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XDEL,'0.0$P 0',REAL,3)
  $HELP
    LOWER BOUND FOR GRADIENT
  $CHECK(TOLG,'1.0$P-8',REAL,3)
  $IF(JARA='D')
    $ADD(REAL,'\$AG($NF*$NF)\$GN($NF)\$SN($NF)\$XO($NF)\$GO($NF)&
    \$XS($NF)\$GS($NF)\$XP($NF)\$GP($NF)\$AF($NF)\$AFO($NF)\$AFD($NF)')
    $ADD(INTEGER,'\$IAG($NF)')
    $HELP
      STORING PERMUTATIONS IN THE LU DECOMPOSITION:
        1 - CHANGES OF MATRIX ROWS 
        2 - TWO LEVEL INDICES
    $CHECK(MOS2,1,'1\2',3)
    $IF(MOS2=2)
      $ADD(REAL,'\$SO($NF)')
    $ENDIF
  $ELSEIF(JARA='S')
    $BG='BG'
    $IBG='IBG'
    $JBG='JBG'
    $ADD(REAL,'\$BG($MMAX)\$AG($MA)\$AF($NA)\$GN($NF)\$SN($NF)&
    \$XO(2*$NF)\$GO($NF)\$XS($NF)\$GS($NF)\$XP($NF)\$GP($NF)\$AF($NA)&
    \$AFO($NA)\$AFD($NA)')
    $ADD(INTEGER,'\$IBG($MMAX+1)\$JB(15)\$IB(5)\$IAG($NA+1)&
    \$JAG($MA)\$JBG($MA)')
    $HELP
      PRELIMINARY PERMUTATION OF THE JACOBIAN MATRIX
        0 - NO PERMUTATION
        1 - PERMUTATION TO BLOCK TRIANGULAR FORM
    $CHECK(MOS1,0,'0\1',3)
    $HELP
      PREFERRENCE OF SYMMETRIC PIVOTS
        0 - SYMMETRIC PIVOTS ARE NOT PREFERRED
        1 - SYMMETRIC PIVOTS ARE PREFERRED
    $CHECK(MOS2,0,'0\1',3)
  $ENDIF
  $ADD(REAL,'\UXVDOT\UXVNOR')
  $ADD(REAL,'\ALF\BET\RHO\RHO1\RHO2\SIG\BTR(2)\BTB(3)\RMU\RNU')
  $AFS=AF
  $AFP=GA
  CALL UOD1D1
  $IF(JARA='D')
    $N='N'
  $ELSE
    $N='NF'
    IF (NIT-LIT.LE.1) IDEC=0
    IF (IDECA.LT.0) IDECA=0
    IF (IDECA.EQ.2) THEN
    ELSE IF (IDECA.NE.0) THEN
    ITERD=-1
    CALL UOERR1('UD$(JARA)GE2',1)
    TDXX='BAD DEC2'
    GO TO $75
    ENDIF
  $ENDIF
  $IF(.TRUE.)
    IF (LD.LE.0) THEN
    $IF(JARA='D')
      IF (IDECA.EQ.0) THEN
      CALL UXD$(JASB)MM($N,$N,$AG,$AF,$GN)
      ELSE
      CALL UXVCOP($N,$AF,$GN)
      $JOB=1
      $IF(LAPACK='YES')
        $IF (JASA='R') $JOB=0
        CALL UXDGLM($N,$AG,$IAG,$GN,$JOB)
      $ELSEIF(MOS2=1)  
        $IF (JASA='R') $JOB=0
        CALL UXEGGM($N,$N,$AG,$IAG,$GN,$JOB)
      $ELSE
        $IF (JASA='C') $JOB=0
        CALL UXDGGM($N,$AG,$IAG,$GN,$SO,$JOB)
      $ENDIF
      ENDIF
    $ELSEIF(JARA='S')
      CALL UXSCMM($N,$N,MA,$AG,$IAG,$JAG,$AF,$GN)
    $ENDIF
    ENDIF
  $ELSE
   CALL UXVCOP($N,$AF,$GN)
  $ENDIF
  GNORM=SQRT(UXVDOT($N,$GN,$GN))
  INITD=MAX(ABS(INITD),1)
  IF (XDEL.LE.ZERO) THEN
*
*     INITIAL TRUST REGION BOUND
*
  $IF(.TRUE.)
    $IF(JARA='D')
      IF (IDECA.EQ.0) THEN
      CALL UXD$(JASA)MM($N,$N,$AG,$G,$AFD)
      ELSE
      CALL UXVCOP($N,$G,$AFD)
      $JOB=0
      $IF(LAPACK='YES')
        $IF(JASA='R') $JOB=1
        CALL UXDGLM($N,$AG,$IAG,$AFD,$JOB)
      $ELSEIF(MOS2=1)  
        $IF(JASA='R') $JOB=1
        CALL UXEGGM($N,$N,$AG,$IAG,$AFD,$JOB)
      $ELSE
        $IF(JASA='C') $JOB=1
        CALL UXDGGM($N,$AG,$IAG,$AFD,$SO,$JOB)
      $ENDIF
      ENDIF
    $ELSEIF(JARA='S')
      CALL UXSRMM($N,$N,MA,$AG,$IAG,$JAG,$G,$AFD)
    $ENDIF
    RHO1=UXVDOT($N,$AFD,$AFD)
    RHO2=GNORM*GNORM
    IF (RHO1.LE.ZERO) THEN
    XDEL=GNORM
    ELSE
    XDEL=(RHO2/RHO1)*GNORM
    ENDIF
  $ELSE
    XDEL=GNORM
  $ENDIF
  IF(IEST.EQ.1) XDEL=MIN(XDEL,FOUR*(F-FMIN)/GNORM)
  XDEL=MIN(XDEL,XMAX)
  ENDIF
  RHO2=UXVDOT($N,$AF,$AF)
  ITERD=2
  SNORM = ZERO
  RHO=ONE
  CALL UXVNEG($N,$AFS,$AFO)
  CALL UXVNEG($N,$AFS,$AFD)
  CALL UXVSET($N,ZERO,$SN)
  CALL UXVSET($N,ZERO,$XO)
  CALL UXVSET($N,ZERO,$GO)
  CALL UXVSET($N,ZERO,$XS)
  SIG=UXVNOR($N,$AFD)
  NOS=MIN($MOS,$N)
  NRED=0
$20 CONTINUE
  NRED=NRED+1
  IF (NRED.GT.NOS) GO TO $50
  RHO1=RHO
  IF (RHO1.EQ.ZERO) THEN
  ITERD=-4
  TDXX='CG BREAK'
  CALL UOERR1('UD$(JARA)GE2',4)
  GO TO $75
  ENDIF
  RHO=UXVDOT($N,$GN,$AFD)
  BET=RHO/RHO1
  CALL UXVDIR($N,BET,$XS,$AFD,$GS)
  CALL UXVDIR($N,BET,$GO,$XS,$GO)
  CALL UXVDIR($N,BET,$GO,$GS,$GO)
  $IF(JARA='D')
    IF (IDECA.EQ.0) THEN
    CALL UXD$(JASA)MM($N,$N,$AG,$GO,$XP)
    ELSE
    CALL UXVCOP($N,$GO,$XP)
    $JOB=0
    $IF(LAPACK='YES')
      $IF(JASA='R') $JOB=1
      CALL UXDGLM($N,$AG,$IAG,$XP,$JOB)
    $ELSEIF(MOS2=1)  
      $IF(JASA='R') $JOB=1
      CALL UXEGGM($N,$N,$AG,$IAG,$XP,$JOB)
    $ELSE
      $IF(JASA='C') $JOB=1
      CALL UXDGGM($N,$AG,$IAG,$XP,$SO,$JOB)
    $ENDIF
    ENDIF
  $ELSEIF(JARA='S')
    CALL UXSRMM($N,$N,MA,$AG,$IAG,$JAG,$GO,$XP)
  $ENDIF
  SIG=UXVDOT($N,$GN,$XP)
  IF (SIG.EQ.ZERO) THEN
  ITERD=-5
  TDXX='CG BREAK'
  CALL UOERR1('UD$(JARA)GE2',5)
  GO TO $75
  ENDIF
  ALF=RHO/SIG
  CALL UXVDIR($N,-ALF,$XP,$GS,$XS)
  CALL UXVSUM($N,$GS,$XS,$GS)
  $IF(JARA='D')
    IF (IDECA.EQ.0) THEN
    CALL UXD$(JASA)MM($N,$N,$AG,$GS,$GP)
    ELSE
    CALL UXVCOP($N,$GS,$GP)
    $JOB=0
    $IF(LAPACK='YES')
      $IF(JASA='R') $JOB=1
      CALL UXDGLM($N,$AG,$IAG,$GP,$JOB)
    $ELSEIF(MOS2=1)  
      $IF(JASA='R') $JOB=1
      CALL UXEGGM($N,$N,$AG,$IAG,$GP,$JOB)
    $ELSE
      $IF(JASA='C') $JOB=1
      CALL UXDGGM($N,$AG,$IAG,$GP,$SO,$JOB)
    $ENDIF
    ENDIF
  $ELSEIF(JARA='S')
    CALL UXSRMM($N,$N,MA,$AG,$IAG,$JAG,$GS,$GP)
  $ENDIF
  CALL UXVDIR($N,-ALF,$GP,$AFD,$AFD)
  CALL UXVDIR($N,ALF,$GS,$XO,$XO)
*
*     CG SMOOTHING
*
  $IF(MOS3=0)
    CALL UXVCOP($N,$AFD,$AFO)
    CALL UXVCOP($N,$XO,$SN)
  $ELSE
    RMU=ETA0**2
    CALL UXVDIF($N,$AFO,$AFD,$GP)
    BTB(1)=UXVDOT($N,$GP,$GP)
    BTR(1)=UXVDOT($N,$GP,$AFD)
    $IF(MOS3=2)
      BTB(2)=UXVDOT($N,$GP,$XP)
      BTB(3)=UXVDOT($N,$XP,$XP)
      BTR(2)=UXVDOT($N,$XP,$AFD)
      CALL UXDPGF(2,BTB,INF,RMU,RNU)
      CALL UXDPGB(2,BTB,BTR,0)
      RMU=-BTR(1)
      RNU=-BTR(2)
    $ELSE
      RMU=-BTR(1)/MAX(BTB(1),RMU)
    $ENDIF
    CALL UXVDIR($N,RMU,$GP,$AFD,$AFO)
    CALL UXVDIF($N,$SN,$XO,$GP)
    CALL UXVDIR($N,RMU,$GP,$XO,$GS)
    $IF(MOS3=2)
      CALL UXVDIR($N,RNU,$XP,$AFO,$AFO)
      CALL UXVDIR($N,-RNU,$GO,$GS,$GS)
    $ENDIF
  $ENDIF
  TDXX='CGS MAX2'
  BET=UXVNOR($N,$GS)
  IF (BET.GE.XDEL) GO TO $55
  CALL UXVCOP($N,$GS,$SN)
  SNORM=BET
  ITERD=2
  TDXX='CGS STEP'
  RHO1=UXVDOT($N,$AFO,$AFO)
  CALL UOD1D4(RHO2,RHO1,PAR,SNORM,XDEL)
  IF (RHO1.LE.$CON1*ETA0*RHO2) GO TO $60
  GO TO $20
$50 CONTINUE
  TDXX='DOG MAX1'
  IF (IDECA.EQ.0) THEN
  $IF(JARA='D')
*
*     LU DECOMPOSITION
*
    ALF=ETA2
    $IF(LAPACK='YES')
      CALL UXDGLF($N,$AG,$IAG,INF,ALF)
    $ELSEIF(MOS2=1)
      CALL UXEGGF($N,$N,$AG,$IAG,INF,ALF)  
    $ELSE
      CALL UXDGGF($N,$AG,$IAG,INF,ALF)
    $ENDIF
    NDECA=NDECA+1
    IDECA=2
    ENDIF
    CALL UXVNEG($N,$AF,$GS)
    $JOB=0
    $IF(LAPACK='YES')
      $IF (JASA='R') $JOB=1
      CALL UXDGLB($N,$AG,$IAG,$GS,$JOB)
    $ELSEIF(MOS2=1)  
      $IF (JASA='R') $JOB=1
      CALL UXEGGB($N,$N,$AG,$IAG,$GS,$JOB)
    $ELSE
      $IF (JASA='C') $JOB=1
      CALL UXDGGB($N,$AG,$IAG,$GS,$SO,$JOB)
    $ENDIF
  $ELSEIF(JARA='S')
*
*     SPARSE LU DECOMPOSITION
*
    IF (IDEC.EQ.0) THEN
    IDEC=1
    DO $53 I=1,NA
    DO $52 KA=$IAG(I),$IAG(I+1)-1
    $JBG(KA)=I
$52 CONTINUE
$53 CONTINUE
    CALL UXIINI($JB,INF,1,MMAX+1,1,MMAX+1)
    CALL UXSGDS($BG,$IBG,$JB,$AG,$JAG,$JBG,NF,MA,$IB,INF,$CON1&
,$CON2,$CON3,$ICON1,$ICON2,$ICON3,$ICON4,$MOS1,$MOS2)
    ELSE
    CALL UXSGDF($BG,$IBG,$JB,$AG,$JAG,$JBG,NF,MA,$IB,INF,$CON2&
,$ICON3)
    ENDIF
    NDECA=NDECA+1
    IDECA=2
    IF (INF.NE.0) THEN
    ITERD=-7
    TDXX='DEC ERR '
    GO TO $75
    ENDIF
    ELSE IF (IDECA.EQ.2) THEN
    ELSE
    ITERD=-1
    TDXX='BAD DEC$IDECF'
    CALL UOERR1('UD$(JARA)GE2',1)
    GO TO $75
    ENDIF
    CALL UXVNEG($N,$AF,$GS)
    CALL UXSGDB($BG,$IBG,$JB,$N,$IB,INF,$GS,$GS,$XO,$CON2,$ICON5,0)
  $ENDIF
  ALF=SQRT(UXVDOT($N,$GS,$GS))
  IF (ALF.LE.XDEL) THEN
*
*     NEWTON DIRECTION IS ACCEPTED
*
  CALL UXVCOP($N,$GS,$SN)
  SNORM=ALF
  ITERD=1
  TDXX='DOG STEP'
  GO TO $60
  ENDIF
  SNORM=SQRT(UXVDOT($N,$SN,$SN))
$55 CONTINUE
*
*     BOUNDARY STEP IS COMPUTED
*
  CALL UXVDIF($N,$GS,$SN,$XO)
  RHO1=UXVDOT($N,$XO,$SN)
  RHO2=UXVDOT($N,$XO,$XO)
  CALL UNSTEP(XDEL,SNORM,RHO1,RHO2,ALF)
  CALL UXVDIR($N,ALF,$XO,$SN,$SN)
  SNORM=XDEL
  ITERD=3
  NRED=-NRED
$60 CONTINUE
  $IF(JARA='D')
    IF (IDECA.EQ.0) THEN
    CALL UXD$(JASA)MM($N,$N,$AG,$SN,$AFD)
    ELSE
    CALL UXVCOP($N,$SN,$AFD)
    $JOB=0
    $IF(LAPACK='YES')
      $IF(JASA='R') $JOB=1
      CALL UXDGLM($N,$AG,$IAG,$AFD,$JOB)
    $ELSEIF(MOS2=1)  
      $IF(JASA='R') $JOB=1
      CALL UXEGGM($N,$N,$AG,$IAG,$AFD,$JOB)
    $ELSE
      $IF(JASA='C') $JOB=1
      CALL UXDGGM($N,$AG,$IAG,$AFD,$SO,$JOB)
    $ENDIF
    ENDIF
  $ELSEIF(JARA='S')
    CALL UXSRMM($N,$N,MA,$AG,$IAG,$JAG,$SN,$AFD)
  $ENDIF
$70 CONTINUE
  $IF(.TRUE.)
    P=UXVDOT($N,$SN,$GN)
  $ELSE
    P=UXVDOT($N,$AF,$AFD)
  $ENDIF
  PP=UXVDOT($N,$AFD,$AFD)*HALF
$75 CONTINUE
  CALL UOD1D2($N,$GN,$SN)
  $ADD(INIT)
    NDXX='UD$(JARA)GE2'
  $ENDADD
  $EXIT

