$INTERFACE UDGGM5                                             03/12/01
$REM LU

  $C1L='0.1$P 0'
  $C1U='0.9$P 0'
  $CON1='1.0$P-3'
  $CON2='1.0$P 5'
  $CON3='7.5$P 1'
  $CON4='1.0$P-6'
  $CON5='1.0$P 2'
  $CON6='1.0$P-1'
  $CON7='1.0$P 1'
  $TDO='TDO'
  $TCO='TCO'
  $TD='TD'
  $TC='TC'
  $TS='TS'
  $IW='IW'
  $IF(HERF='V')
    $SNS=SN
    $GAS=GA
    $GA=G
  $ELSE
    $SOS=SO
    $GSS=GS
    $XSS=XS
    $SO=GS
    $GS=XS
    $XS=XO
  $ENDIF
  $LSIZE=10
  $HELP
    MAXIMUM NUMBER OF CG ITERATIONS
  $CHECK(MCGR,0,INT,3,NO)
  $HELP
    STRATEGY FOR PRECISION DETERMINATION:
      1 - SINGLE STRATEGY
      2 - GEOMETRIC DECREASING STRATEGY
      3 - HARMONIC  DECREASING STRATEGY
  $CHECK(MOS,3,'1\2\3',3)
  $HELP
    NUMBER OF LANCZOS STEPS
  $CHECK(MOS3,5,INT,3)
  $HELP
    LOWER PRECISION FOR OPTIMUM LOCALLY CONSTRAINED STEP
  $CHECK(DEL1,'0.9$P 0',REAL,4)
  $HELP
    UPPER PRECISION FOR OPTIMUM LOCALLY CONSTRAINED STEP
  $CHECK(DEL2,'1.1$P 0',REAL,4)
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XDEL,'0.0$P 0',REAL,3)
  $NOS2=0
  $ADD(INTEGER,'\MMX\K\L')
  $ADD(REAL,'\$GN($NF)\$SN($NF)\$XO($NF)\$GO($NF)\$XS($NF)&
  \$GS($NF)\$SO($NF*$MOS3)\$TDO($MOS3)\$TCO($MOS3)\$TD($MOS3)&
  \$TC($MOS3)\$TS($MOS3)')
  $IF(HERF='D')
    $ADD(REAL,'\$H($M)')
    $ADD(REAL,'\UX$(HERF)SMQ')
    $POM1='V'
    $POM2=')'
    $DEFAULT='0.4$P 0'
    $IF(MOS=1) $DEFAULT='0.1$P 0'
  $ELSEIF(HERF='V')
    $HELP
      RESTART SPECIFICATION. RESTART IS PERFORMED AFTER
      IRES1*N+IRES2 ITERATIONS.
    $CHECK(IRES1,100,INT,4)
    $HELP
      DIRECTION AFTER RESTART:
        0 - NEWTON DIRECTION AFTER RESTART
        1 - STEEPEST DESCENT DIRECTION AFTER RESTART
    $CHECK(MOT1,0,'0\1',2)
    $ADD(INTEGER,'\I')
    $ADD(INTEGER,'\NOS2')
    $ADD(INTEGER,'\$IX($NX)')
    $ADD(REAL,'\$X($NF)\$G($NF)')
    $POM1='U'
    $POM2=',$$IX,KBF)'
    $DEFAULT='0.45$P 0'
    $IF(MOS=1) $DEFAULT='0.25$P 0'
  $ELSEIF(HERF='S')
    $HELP
      PRECONDITIONING TECHNIQUE
        ABS(MOS2)=0 - PRECONDITIONING IS SUPPRESSED
        ABS(MOS2)=1 - INCOMPLETE GILL-MURRAY PRECONDITIONING
        ABS(MOS2)=2 - ILUT-TYPE  GILL-MURRAY PRECONDITIONING
        ABS(MOS2)=2 - ILUT-TYPE  GILL-MURRAY PRECONDITIONING
        ABS(MOS2)=2 - ILUT-TYPE  GILL-MURRAY PRECONDITIONING
        ABS(MOS2)=5 - INCOMPLETE GILL-MURRAY PRECONDITIONING
        ABS(MOS2)=6 - SSOR PRECONDITIONING
           MOS2 < 0 - PRECONDITIONED ITERATIVE PROCESS
           MOS2 > 0 - PRELIMINARY INEXACT SOLUTION FOLLOWED
                      BY PRECONDITIONED ITERATIVE PROCESS
    $CHECK(MOS2,0,'-6\-5\-4\-3\-2\-1\0\1\2\3\4\5\6',1)
    $IF(MOS2=6) $MOS2=-6
    $NOS2=MOS2
    $IF(MOS2=-1) $NOS2=1
    $IF(MOS2=-2) $NOS2=2
    $IF(MOS2=-3) $NOS2=3
    $IF(MOS2=-4) $NOS2=4
    $IF(MOS2=-5) $NOS2=5
    $IF(MOS2=-6) $NOS2=6
    $HELP
      PRECONDITIONING IN ILL-CONTITIONED AND INDEFINITE CASES
        0 - PRECONDITIONING IN BOTH THESE CASES IS SUPPRESSED
        1 - PRECONDITIONING IN ILL-CONDITIONED CASE IS SUPPRESSED
        2 - PRECONDITIONING IS ALWAYS USED
    $CHECK(MOS4,0,'0\1\2',1)
    $IF(NOS2=1)
      $HELP
        TYPE OF THE GILL-MURRAY STRATEGY
          1 - BASIC STRATEGY
          2 - MODIFIED STRATEGY THAT USE ARTIFICIAL SOLUTION VECTOR
      $CHECK(MOS5,1,'1\2',1)
    $ENDIF
    $IF(NOS2=0)
      $ADD(REAL,'\$H($M)')
      $ADD(INTEGER,'\$IH($NF+1)\$JH($M)')
    $ELSEIF(NOS2=1)
      $ADD(REAL,'\$H($MMAX)')
      $ADD(INTEGER,'\$IH($NF+1)\$JH($M)\IW($NF+1)')
      $HELP
        TOLERANCE FOR ILL CONDITIONED MATRICES
      $CHECK(ETA2,'1.0$P-8',REAL,4)
    $ELSEIF(NOS2=2)
      $ADD(REAL,'\$H($MMAX)\$WR01($NF)')
      $ADD(INTEGER,'\$IH(2*$NF+2)\$JH($MMAX)\IW(4*$NF+4)')
      $HELP
        TOLERANCE FOR ILL CONDITIONED MATRICES
      $CHECK(ETA2,'1.0$P-8',REAL,4)
    $ELSEIF(NOS2=3)
      $ADD(REAL,'\$H($MMAX)\$WR01($NF)')
      $ADD(INTEGER,'\$IH(2*$NF+2)\$JH($MMAX)\IW(4*$NF+4)')
      $HELP
        TOLERANCE FOR ILL CONDITIONED MATRICES
      $CHECK(ETA2,'1.0$P-8',REAL,4)
    $ELSEIF(NOS2=4)
      $ADD(REAL,'\$H($MMAX)\$WR01($NF)')
      $ADD(INTEGER,'\$IH(2*$NF+2)\$JH($MMAX)\IW(4*$NF+4)')
      $HELP
        TOLERANCE FOR ILL CONDITIONED MATRICES
      $CHECK(ETA2,'1.0$P-8',REAL,4)
    $ELSEIF(NOS2=5)
      $ADD(REAL,'\$H($MMAX)')
      $ADD(INTEGER,'\$IH($NF+1)\$JH($M)')
      $HELP
        TOLERANCE FOR ILL CONDITIONED MATRICES
      $CHECK(ETA2,'1.0$P-8',REAL,4)
    $ENDIF
    $ADD(INTEGER,'\NOS2')
    $ADD(INTEGER,'\$IX($NX)')
    $ADD(REAL,'\UX$(HERF)SMQ')
    $POM1='U'
    $POM2=',$$IX,KBF)'
    $DEFAULT='0.9$P 0'
    $IF(MOS=1) $DEFAULT='0.1$P 0'
  $ELSEIF(HERF='B')
    $ADD(REAL,'\$AH($MAH)')
    $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)\$IX($NX)')
    $ADD(REAL,'\UX$(HERF)SMQ')
    $POM1='U'
    $POM2=',$$IX,KBF)'
    $DEFAULT='0.4$P 0'
    $IF(MOS=1) $DEFAULT='0.2$P 0'
  $ELSEIF(HERF='L')
    $ADD(REAL,'\$XM($NF*$MF)\$GM($NF*$MF)\$XR($MF*($MF+1)/2)&
    \$GR($MF*($MF+1)/2)\$HR($MF*($MF+1)/2)\$DR($MF)')
    $ADD(INTEGER,'\NOS2\MX')
    $ADD(INTEGER,'\$IX($NX)')
    $ADD(REAL,'\UX$(HERF)SMQ')
    $POM1='U'
    $POM2=',$$IX,KBF)'
    $DEFAULT='0.4$P 0'
    $IF(MOS=1) $DEFAULT='0.2$P 0'
  $ENDIF
  $HELP
    MINIMUM PRECISION OF AN INEXACT SOLUTION
  $CHECK(EPS6,DEFAULT,REAL,4)
  $ADD(REAL,'\UX$(POM1)DOT\UX$(POM1)DEL\UXVVDP\UXTPDL')
  $ADD(REAL,'\TEMP\RHO\RHO1\RHO2\ALF\ALFO\BET\BETO\EPS\GNORMO')
  $ADD(LOGICAL,'\L1\L2\L3')
  CALL UOD1D1
  IF (NIT.LE.LIT+1) THEN
  GNORMO=$ETA9
  EPS=$EPS6
  ENDIF
  $IF(HERF='D')
    $N='N'
    IF (IDECF.LT.0) IDECF=0
    IF (IDECF.NE.0) THEN
  $ELSEIF(HERF='V')
    $N='NF'
    IF(IREST.NE.0) THEN
    CALL UYSET3
    IF (MOT1.GT.0) THEN
    CALL UXVNEG($N,$GN,$SN)
    GNORM=SQRT(UX$(POM1)DOT($N,$GN,$GN$POM2)
    SNORM=GNORM
    PP=HALF*GNORM
    TUXX='INITIAL '
    TDXX='ST DESC '
    GO TO $90
    ENDIF
    ENDIF
    IF (IDECF.LT.0) IDECF=0
    IF (IDECF.NE.0) THEN
  $ELSEIF(HERF='S')
    $N='NF'
    IF (IDECF.LT.0) IDECF=0
    IF (IDECF.NE.0.AND.IDECF.NE.1) THEN
  $ELSEIF(HERF='B')
    $N='NF'
    IF (IDECF.LT.0) IDECF=0
    IF (IDECF.NE.0) THEN
  $ELSEIF(HERF='L')
    $N='NF'
    IF (IDECF.LT.0) IDECF=0
    IF (IDECF.NE.0) THEN
  $ENDIF
  ITERD=-1
  CALL UOERR1('UD$(HERF)GM5',1)
  TDXX='BAD DEC1'
  GO TO $80
  $IF(NOS2=0)
  $ELSEIF(NOS2=6)
  $ELSE
    ELSE IF (IDECF.EQ.0) THEN
*
*     INCOMPLETE GILL-MURRAY DECOMPOSITION
*
    INF=0
    ALF=ETA2
    NOS2=ABS($MOS2)
    IF (2*M.GE.$MMAX) THEN
    CALL UOERR2('UD$(HERF)GM5',48,2*M,$MMAX)
    ITERM=-48
    TDXX='LACK SPC'
    GO TO $80
    ENDIF
    $IF(NOS2=1)
      CALL UXVCOP(M,$H,$H(M+1))
      $IF(MOS5=1)
        CALL UXSPTF($N,M,$H(M+1),$IH,$JH,$IW,INF,ALF,SIG)
      $ELSE
        CALL UXSPLF($N,M,$H(M+1),$IH,$JH,$IW,$GO,INF,ALF,SIG)
      $ENDIF
    $ELSEIF(NOS2=2)
      CALL UXSPT2($N,M,$MMAX-M,$H,$IH,$JH,$H(M+1),$IH($N+2),$JH(M+1)&
,$IW,$IW($N+2),$IW(2*$N+3),$IW(3*$N+4),$WR01,$CON6,$LTYPE,$LSIZE,INF&
,ALF,SIG)
    $ELSEIF(NOS2=3)
      CALL UXSPT3($N,M,$MMAX-M,$H,$IH,$JH,$H(M+1),$IH($N+2),$JH(M+1)&
,$IW,$IW($N+2),$IW(2*$N+3),$IW(3*$N+4),$WR01,$CON6,$LTYPE,INF,ALF,SIG)
    $ELSEIF(NOS2=4)
      CALL UXSPT4($N,M,$MMAX-M,$H,$IH,$JH,$H(M+1),$IH($N+2),$JH(M+1)&
,$IW,$IW($N+2),$IW(2*$N+3),$IW(3*$N+4),$WR01,$GO,$CON6,INF,ALF,SIG)
    $ELSEIF(NOS2=5)
      CALL UXVCOP(M,$H,$H(M+1))
      CALL UXSPIF($N,M,$H(M+1),$IH,$JH,INF,ALF,SIG,GO)
    $ENDIF
    IF (INF+10.LT.0) THEN
    CALL UOERR1('UD$(HERF)GM5',48)
    ITERM=-48
    TDXX='LACK SPC'
    GO TO $80
    ENDIF
    $IF(MOS4=0)
      IF (INF.NE.0) NOS2=0
    $ELSEIF(MOS4=1)
      IF (INF.LT.0) NOS2=0
    $ENDIF
    NDECF=NDECF+1
    IDECF=1
  $ENDIF
  ENDIF
  GNORM=SQRT(UX$(POM1)DOT($N,$GN,$GN$POM2)
  IF (GNORM.GE.$CON5*GNORMO) EPS=$CON4
  GNORMO=GNORM
  INITD=MAX(ABS(INITD),1)
$REM  RHO1=GNORM*GNORM
  RHO1=UX$(POM1)DOT($N,$GN,$GN$POM2
  IF(XDEL.LE.ZERO) THEN
*
*     INITIAL TRUST REGION BOUND
*
  $IF(HERF='V')
    XDEL=GNORM
  $ELSE
    $IF(HERF='D')
      RHO2=UXDSMQ($N,$H,$GN,$GN)
    $ELSEIF(HERF='S')
      RHO2=UXSSMQ($N,M,$H,$IH,$JH,$GN,$GN)
    $ELSEIF(HERF='B')
      RHO2=UXBSMQ($N,MAH,NA,MA,$AH,$IAG,$JAG,$GN,$GN)
    $ELSEIF(HERF='L')
      $IF(CONSTR='C')
        CALL UX$(POM1)COP($N,$GN,$SN$POM2
        CALL UXLSMM($N,MX,$XM,$GM,$GR,$HR,$DR,$U1,$U2,$U3,$SN,$GO,PAR3&
,$MET)
        RHO2=UXVDOT($N,$SN,$GO)
      $ELSE
        CALL UXLSMM($N,MX,$XM,$GM,$GR,$HR,$DR,$U1,$U2,$U3,$GN,$GO,PAR3&
,$MET)
        RHO2=UXVDOT($N,$GN,$GO)
      $ENDIF
    $ENDIF
    IF(RHO2.LE.ZERO) THEN
    XDEL=GNORM
    ELSE
    XDEL=(GNORM*GNORM/RHO2)*GNORM
    ENDIF
  $ENDIF
  IF(IEST.EQ.1) XDEL=MIN(XDEL,FOUR*(F-FMIN)/GNORM)
  XDEL=MIN(XDEL,XMAX)
  ENDIF
  PAR=MIN(EPS,SQRT(GNORM))
  IF (PAR.GT.TEN*$CON1) THEN
  $IF(MOS=1)
  $ELSEIF(MOS=2)
    PAR=MIN(PAR,ONE/$DBLE(NIT-LIT))
    IF (NIT-LIT.GE.$N) PAR=MIN(PAR,$CON4)
  $ELSEIF(MOS=3)
    PAR=MIN(PAR,ONE/$DBLE(NIT-LIT))
  $ENDIF
  ENDIF
  PAR=PAR*PAR
  $IF(HERF='S')
    $IF(MOS2>0)
*
*     PRELIMINARY INEXACT SOLUTION
*
      CALL UXVNEG($N,$GN,$XS)
      IF (NOS2.NE.0) THEN
      $IF(NOS2=5)
        CALL UXSPIB($N,M,$H(M+1),$IH,$JH,$XS,0)
      $ELSEIF(NOS2=1)
        CALL UXSPTB($N,$MMAX-M,$H(M+1),$IH,$JH,$XS,0)
      $ELSE
        CALL UXSPTB($N,$MMAX-M,$H(M+1),$IH($N+2),$JH(M+1),$XS,0)
      $ENDIF
      SNORM=SQRT(UX$(POM1)DOT($N,$XS,$XS$POM2)
      IF (SNORM.LE.XDEL*$CON2) THEN
      CALL UXVCOP($N,$XS,$SN)
      IF (SNORM.LE.XDEL) THEN
      ITERD=2
      TDXX='G-M REG '
      ELSE
      CALL UXVSCL($N,XDEL/SNORM,$SN,$SN)
      SNORM=XDEL
      ITERD=3
      TDXX='G-M MAX '
      ENDIF
      CALL UXSSMD($N,M,$H,$IH,$JH,$SN,ONE,$GN,$GO)
      IF (UX$(POM1)DOT($N,$GO,$GO$POM2.LE.1.0$P-2*PAR*RHO1) GO TO $80
      ENDIF
      ENDIF
    $ENDIF
  $ENDIF
*
*     CG INITIATION
*
  RHO=RHO1
  SNORM=ZERO
  CALL UXVSET($N,ZERO,$SN)
  CALL UXVNEG($N,$GN,$GS)
  $IF(NOS2=0)
    NOS2=0
    CALL UXVNEG($N,$GN,$XS)
  $ELSEIF(NOS2=6)
    CALL UXVNEG($N,$GN,$XS)
    CALL UXSPPB($N,M,$H,$IH,$JH,$XS)
    RHO=UX$(POM1)DOT($N,$GS,$XS$POM2
  $ELSEIF(MOS2>0)
    IF (NOS2.NE.0) THEN
    RHO=UX$(POM1)DOT($N,$GS,$XS$POM2
    ENDIF
  $ELSE
    CALL UXVNEG($N,$GN,$XS)
    IF (NOS2.NE.0) THEN
    $IF(NOS2=5)
      CALL UXSPIB($N,M,$H(M+1),$IH,$JH,$XS,0)
    $ELSEIF(NOS2=1)
      CALL UXSPTB($N,$MMAX-M,$H(M+1),$IH,$JH,$XS,0)
    $ELSE
      CALL UXSPTB($N,$MMAX-M,$H(M+1),$IH($N+2),$JH(M+1),$XS,0)
    $ENDIF
    RHO=UX$(POM1)DOT($N,$GS,$XS$POM2
    ENDIF
  $ENDIF
  TEMP=ONE
  ALFO=ONE
  BETO=ZERO
  CALL UXVSCL($N,ONE/SQRT(RHO),$XS,$SO)
  MMX=$N+3
  $IF(MCGR>0)
    MMX=MIN(MMX,$MCGR)
  $ENDIF
  L=1
  NRED=0
$20 CONTINUE
  NRED=NRED+1
  IF(NRED.GT.MMX) GO TO $40
  $IF(HERF='D')
    CALL UXDSMM($N,$H,$XS,$GO)
  $ELSEIF(HERF='V')
    FO=F
    PP=SQRT(ETA0/UXVDOT($N,$XS,$XS))
    LD=MIN(MAX(KDF,KDA)-1,0)
    $IF(MODEL='AF')
      LDA=LD
    $ELSE
      LDA=-1
    $ENDIF
    I=ISNA
    ISNA=0
    $SN=XS
    $SUBST('UYTR$(CONSTR)X')
    ASSIGN $30 TO IMD
    GO TO $LMD
$30 CONTINUE
    ISNA=I
    $SN=SNS
    $SUBST('UYTR$(CONSTR)A')
    CALL UXVDIF($N,$G,$GN,$GO)
    F=FO
    CALL UXVSCL($N,ONE/PP,$GO,$GO)
  $ELSEIF(HERF='S')
    CALL UXSSMM($N,M,$H,$IH,$JH,$XS,$GO)
  $ELSEIF(HERF='B')
    CALL UXBSMM($N,MAH,NA,MA,$AH,$IAG,$JAG,$XS,$GO)
  $ELSEIF(HERF='L')
    $IF(CONSTR='C') CALL UX$(POM1)COP($N,$XS,$XS$POM2
    CALL UXLSMM($N,MX,$XM,$GM,$GR,$HR,$DR,$U1,$U2,$U3,$XS,$GO,PAR3,$MET)
  $ENDIF
  ALF=UX$(POM1)DOT($N,$XS,$GO$POM2
  TDXX='CG  MAX1'
  IF (ALF.LE.ZERO.AND.NRED.GT.MOS3) GO TO $60
  ALF=RHO/ALF
  RHO2=SQRT(UX$(POM1)DEL($N,ALF,$XS,$SN$POM2)
  L1=RHO2.GE.XDEL
  L2=RHO2.GE.$CON7*XDEL
  TDXX='CG  MAX2'
  IF (RHO2.GE.$CON5*XDEL) GO TO $60
  IF (NRED.GT.MOS3.AND.L1) GO TO $60
*
*     CG STEP
*
  TDXX='CG  STEP'
  CALL UX$(POM1)DIR($N, ALF,$XS,$SN,$SN$POM2
  CALL UX$(POM1)DIR($N,-ALF,$GO,$GS,$GS$POM2
  SNORM=RHO2
  RHO2=UX$(POM1)DOT($N,$GS,$GS$POM2
  CALL UOD1D4(RHO1,RHO2,PAR,SNORM,XDEL)
  L3=RHO2.LE.PAR*RHO1
  IF (L1.AND.(NRED.EQ.MOS3.OR.L2.OR.L3)) THEN
  $TDO(NRED)=ONE/ALF+BETO/ALFO
  $TCO(NRED)=ZERO
  GO TO $70
  ELSE IF (L3) THEN
  GO TO $50
  ENDIF
  $IF(NOS2=0)
    BET=RHO2/RHO
    CALL UX$(POM1)DIR($N,BET,$XS,$GS,$XS$POM2
  $ELSEIF(NOS2=6)
    CALL UXVCOP($N,$GS,$GO)
    CALL UXSPPB($N,M,$H,$IH,$JH,$GO)
    RHO2=UX$(POM1)DOT($N,$GS,$GO$POM2
    BET=RHO2/RHO
    CALL UX$(POM1)DIR($N,BET,$XS,$GO,$XS$POM2
  $ELSE
    IF (NOS2.NE.0) THEN
    CALL UXVCOP($N,$GS,$GO)
    $IF(NOS2=5)
      CALL UXSPIB($N,M,$H(M+1),$IH,$JH,$GO,0)
    $ELSEIF(NOS2=1)
      CALL UXSPTB($N,$MMAX-M,$H(M+1),$IH,$JH,$GO,0)
    $ELSE
      CALL UXSPTB($N,$MMAX-M,$H(M+1),$IH($N+2),$JH(M+1),$GO,0)
    $ENDIF
    RHO2=UX$(POM1)DOT($N,$GS,$GO$POM2
    BET=RHO2/RHO
    CALL UX$(POM1)DIR($N,BET,$XS,$GO,$XS$POM2
    ELSE
    BET=RHO2/RHO
    CALL UX$(POM1)DIR($N,BET,$XS,$GS,$XS$POM2
    ENDIF
  $ENDIF
*
*     RECONSTRUCTION OF THE LANCZOS TRIDIAGONAL MATRIX
*
  IF (NRED.LT.MOS3) THEN
  $TDO(NRED)=ONE/ALF+BETO/ALFO
  $TCO(NRED)=SQRT(BET)/ALF
  L=L+NF
  TEMP=-TEMP*SIGN(ONE,ALF)
  IF (NOS2.NE.0) THEN
  CALL UXVSCL($N,TEMP/SQRT(RHO2),$GO,$SO(L))
  ELSE
  CALL UXVSCL($N,TEMP/SQRT(RHO2),$GS,$SO(L))
  ENDIF
  TDXX='CG  MAX3'
  ALFO=ALF
  BETO=BET
  ENDIF
  RHO=RHO2
  GO TO $20
$40 CONTINUE
  TDXX='MAX ITER'
*
*     AN INEXACT SOLUTION IS OBTAINED
*
$50 CONTINUE
  SNORM=SQRT(UX$(POM1)DOT($N,$SN,$SN$POM2)
  ITERD=2
  TDXX='CG  STEP'
  GO TO $80
*
*     BOUNDARY STEP IS COMPUTED
*
$60 CONTINUE
  RHO1=UX$(POM1)DOT($N,$XS,$SN$POM2
  RHO2=UX$(POM1)DOT($N,$XS,$XS$POM2
  CALL UNSTEP(XDEL,SNORM,RHO1,RHO2,ALF)
  CALL UX$(POM1)DIR($N,ALF,$XS,$SN,$SN$POM2
  SNORM=XDEL
  ITERD=3
  NRED=-NRED
  GO TO $80
*
*     SOLUTION OF THE TRIDIAGONAL TR SUBPROBLEM
*
$70 CONTINUE
  T=ZERO
  E=-UXTPDL(NRED,TDO,INF)
  CALL UXTPMG(NRED,TDO,TCO,EL,EU)
  TL=GNORM/XDEL-EU
  TU=GNORM/XDEL-EL
  TL=MAX(TL,ZERO,E)
  TU=MAX(TL,TU)
  T=MAX(T,TL)
  T=MIN(T,TU)
  TEMP=XDEL
  DO $71 K=1,10
  IF (K.NE.1) THEN
  TL=MAX(TL,E)
  IF (T.LE.E) THEN
*
*     THE PARAMETER T IS SHIFTED
*
  T=SQRT(TL*TU)
$REM  T=MAX(T,TL+$C1L*(TU-TL))
$REM  T=MIN(T,TL+$C1U*(TU-TL))
  ENDIF
  ENDIF
  ALF=ETA0
  CALL UXVSET(NRED,T,TD)
  CALL UXVSUM(NRED,TDO,TD,TD)
  CALL UXVCOP(NRED,TCO,TC)
  CALL UXTPGF(NRED,TD,TC,INF,ALF,RHO)
  IF (INF.GT.0) THEN
*
*     NEW ESTIMATION E IS COMPUTED (THE MATRIX IS NOT POSITIVE DEFINITE)
*
  CALL UXTPGD(NRED,TC,TS,INF)
  E=MAX(E,T-ALF/UXVDOT(NRED,TS,TS))
  GO TO $71
  ENDIF
  CALL UXVSET(NRED,ZERO,TS)
  TS(1)=GNORM
  CALL UXTPGB(NRED,TD,TC,TS,0)
  RHO=UXVDOT(NRED,TS,TS)
  IF (RHO.GT.(DEL2*XDEL)**2) THEN
  TL=MAX(TL,T)
  GO TO $75
  ELSE IF (RHO.LT.(DEL1*XDEL)**2) THEN
  IF (T.NE.ZERO) THEN
  TU=MIN(TU,T)
  ELSE
  GO TO $72
  ENDIF
  ELSE
  GO TO $72
  ENDIF
$75 CONTINUE
  IF (K.EQ.10) GO TO $72
  CALL UXTPGB(NRED,TD,TC,TS,1)
*
*     MARQUARDT PARAMETER T IS COMPUTED USING THE ONE-DIMENSIONAL
*     NEWTON METHOD
*
  T=T+(RHO/UXVVDP(NRED,TD,TS,TS))*((SQRT(RHO)-TEMP)/TEMP)
$71 CONTINUE
$72 CONTINUE
*
*     DIRECTION DETERMINATION USING THE SOLUTION OF THE TRIDIAGONAL
*     TR SUBPROBLEM
*
  CALL UXDCMM($N,NRED,$SO,$TS,$SN)
  ITERD=3
  NRED=-NRED
  SNORM=SQRT(RHO)
*
*     COMPUTATION OF THE TR MODEL
*
$80 CONTINUE
  $IF(HERF='D')
    PP=UXDSMQ($N,$H,$SN,$SN)*HALF
  $ELSEIF(HERF='V')
    FO=F
    PP=SQRT(ETA0/UX$(POM1)DOT($N,$SN,$SN$POM2)
    LD=MIN(MAX(KDF,KDA)-1,0)
    $IF(MODEL='AF')
      LDA=LD
    $ELSE
      LDA=-1
    $ENDIF
    I=ISNA
    ISNA=0
    $SUBST('UYTR$(CONSTR)X')
    ASSIGN $85 TO IMD
    GO TO $LMD
$85 CONTINUE
    ISNA=I
    $SUBST('UYTR$(CONSTR)A')
    CALL UX$(POM1)DIF($N,$G,$GN,$GO$POM2
    F=FO
    CALL UXVSCL($N,ONE/PP,$GO,$GO)
    PP=HALF*UX$(POM1)DOT($N,$SN,$GO$POM2
$90 CONTINUE
  $ELSEIF(HERF='S')
    PP=UXSSMQ($N,M,$H,$IH,$JH,$SN,$SN)*HALF
  $ELSEIF(HERF='B')
    PP=UXBSMQ($N,MAH,NA,MA,$AH,$IAG,$JAG,$SN,$SN)*HALF
  $ELSEIF(HERF='L')
    $IF(CONSTR='C') CALL UX$(POM1)COP($N,$SN,$SN$POM2
    CALL UXLSMM($N,MX,$XM,$GM,$GR,$HR,$DR,$U1,$U2,$U3,$SN,$GO,PAR3&
,$MET)
    PP=UXVDOT($N,$SN,$GO)*HALF
  $ENDIF
  CALL UOD1D2($N,$GN,$SN)
  $IF(HERF='V')
    $GA=GAS
  $ELSE
    $SO=SOS
    $GS=GSS
    $XS=XSS
  $ENDIF
  $ADD(INIT)
    NDXX='UD$(HERF)GM5'
  $ENDADD
  $EXIT
