$INTERFACE UDGGM7                                             97/12/01
$REM LU

  $C1L='0.1$P 0'
  $C1U='0.9$P 0'
  $CON1='1.0$P-8'
  $POM1='V'
  $POM2=')'
  $IF(CONSTR='C')
    $IF(HERF='S')
      $POM1='U'
      $POM2=',$$IX,KBF)'
    $ENDIF
  $ENDIF
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,'ETA0*1.0$P-3',REAL,4)
  $HELP
    LOWER PRECISION FOR THE OPTIMUM LOCALLY CONSTRAINED STEP
  $CHECK(DEL1,'0.9$P 0',REAL,4)
  $HELP
    UPPER PRECISION FOR THE OPTIMUM LOCALLY CONSTRAINED STEP
  $CHECK(DEL2,'1.1$P 0',REAL,4)
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XDEL,'0.0$P 0',REAL,3)
  $ADD(REAL,'\UX$(POM1)DOT')
  $ADD(REAL,'\ALF\RHO\RHO1\RHO2\CON')
  $IDECF=0
  CALL UOD1D1
  IF (IDECF.LT.0) IDECF=0
  IF (IDECF.NE.0) THEN
  ITERD=-1
  TDXX='BAD DEC$IDECF'
  CALL UOERR1('UD$(HERF)GM7',1)
  GO TO $50
  ENDIF
  $IF(HERF='D')
    $HELP
      CHOICE OF THE SCALING MATRIX:
        0 - UNIT MATRIX (NO SCALING)
        1 - SQUARE OF THE MATRIX H DIAGONAL
    $CHECK(MOS1,0,'0\1',4)
    $IF(MOS1=0)
      $GOS=GO
      $GO=GN
      $GSS=GS
      $GS=GN
    $ENDIF
    $ADD(REAL,'\$H($M)\$B($M)\$GN($NF)\$SN($NF)\$XO($NF)\$GS($NF)')
    $HELP
      TYPE OF DECOMPOSITION
        0 - GILL-MURRAY DECOMPOSITION
        1 - SCHNABEL-ESKOW DECOMPOSITION WITH NUMERICAL PERMUTATIONS
        2 - SCHNABEL-ESKOW DECOMPOSITION WITH TWO LEVEL INDICES
    $CHECK(MOS2,0,'0\1\2',2)
    $IF(MOS2=0)
    $ELSE
      $IF(MOS2=1) 
        $LET='L'
        $ART=',$IB)'
        $ADD(INTEGER,'\$IB($NF)')
      $ELSE  
        $LET='S'
        $ART=')'
      $ENDIF
      $ADD(INTEGER,'\$IH($NF)')
      CALL UXVINP($N,$IH)
    $ENDIF
    $ADD(REAL,'\UXDSDL\UXDPGP\UXDSMQ')
    $N='N'
    $IF(MOS1>0)
      IF (IDIR.EQ.0) CALL UXDSMX($N,$H,$GS)
      CALL UXVCOP($N,$GN,$GO)
      CALL UXVMUL($N,$GS,$GO,$GO,1)
    $ENDIF
  $ELSEIF(HERF='S')
    $GSS=GS
    $GS=GO
    $GOS=GO
    $GO=GN
    $ADD(REAL,'\$H($MMAX)\$GN($NF)\$SN($NF)\$XO($NF)\$GS($NF)')
    $ADD(INTEGER,'\$IH($NF+1)\$JH($MMAX)\$PSL($NF+1)\$WN11($NF+1)')
    $ADD(INTEGER,'\$WN12($NF+1)\$PERM($NF)\MM')
    $ADD(REAL,'\UXSSDL\UXSPCP\UXSSMQ')
    $N='NF'
    MM=$IH($N+1)-1
  $ENDIF
  GNORM=SQRT(UX$(POM1)DOT($N,$GO,$GO$POM2)
  INITD=MAX(ABS(INITD),1)
  IF (XDEL.LE.ZERO) THEN
*
*     INITIAL TRUST REGION BOUND
*
  $IF(HERF='D')
    RHO1=UXDSMQ($N,$H,$GO,$GO)
  $ELSEIF(HERF='S')
    RHO1=UXSSMQ($N,MM,$H,$IH,$JH,$GO,$GO)
  $ENDIF
  RHO2=GNORM*GNORM
  IF (RHO1.LE.ZERO) THEN
  XDEL=GNORM
  ELSE
  XDEL=(RHO2/RHO1)*GNORM
  ENDIF
  IF(IEST.EQ.1) XDEL=MIN(XDEL,FOUR*(F-FMIN)/GNORM)
  XDEL=MIN(XDEL,XMAX)
  ENDIF
*
*     INITIAL BOUNDS FOR THE PARAMETER T
*
  NRED=0
  IF (IDIR.LE.0) THEN
  T=ZERO
  $IF(HERF='D')
    E=-UXDSDL($N,$H,INF)
    CALL UXDSMG($N,$H,EL,EU)
  $ELSEIF(HERF='S')
    E=-UXSSDL($N,MMAX,$H,$IH,$JH,INF)
    CALL UXSSMG($N,MMAX,$H,$IH,$JH,EL,EU,$SN)
  $ENDIF
  TL=GNORM/XDEL-EU
  TU=GNORM/XDEL-EL
  ELSE IF (IDIR.EQ.1) THEN
  T=T*XDELO/XDEL
  TL=MAX(TL,GNORM/XDEL-EU)
  TU=GNORM/XDEL-EL
  ELSE IF (IDIR.EQ.2) THEN
  T=T*XDELO/XDEL
  TL=GNORM/XDEL-EU
  TU=MIN(TU,GNORM/XDEL-EL)
  ENDIF
  TL=MAX(TL,ZERO,E)
  TU=MAX(TL,TU)
  T=MAX(T,TL)
  T=MIN(T,TU)
  TDXX='INITIAL '
$20 CONTINUE
  TL=MAX(TL,E)
  IF (T.LE.E.AND.NRED.NE.0) THEN
*
*     THE PARAMETER T IS SHIFTED
*
  T=SQRT(TL*TU)
  T=MAX(T,TL+$C1L*(TU-TL))
  T=MIN(T,TL+$C1U*(TU-TL))
  TDXX='SHIFTED '
  ENDIF
  ALF=ETA2
  $IF(HERF='D')
    CALL UXDSMC($N,$H,$B)
    CALL UXDSDA($N,$B,T)
    $IF(MOS2=0)
*
*     GILL-MURRAY DECOMPOSITION
*
      CALL UXDPGF($N,$B,INF,ALF,RHO)
    $ELSE
*
*     SCHNABEL-ESKOW DECOMPOSITION
*
      CALL UXD$(LET)GF($N,$B,$IH,$SN,INF,ALF,RHO$ART
    $ENDIF
  $ELSEIF(HERF='S')
    CALL UXSPCT($N,MM,MH,MMAX,$H,$JH,$PSL,ITERM)
    IF (ITERM.NE.0) THEN
    TDXX='LACK SPC'
    GO TO $50
    ENDIF
*
*     SPARSE GILL-MURRAY DECOMPOSITION
*
    CALL UXSPCA($N,MM,MH,MMAX,$H,$IH,$JH,T)
    CALL UXSPCF($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$WN11,$WN12,$GS,INF&
,ALF,RHO)
  $ENDIF
  NDECF=NDECF+1
  IF (INF.GT.0) THEN
*
*     NEW ESTIMATION E IS COMPUTED (THE MATRIX IS NOT POSITIVE DEFINITE)
*
  IF (E.GE.TU) THEN
  ITERD=-2
  TDXX='ZERO INT'
  CALL UOERR1('UDGGM7',2)
  GO TO $50
  ELSE
  MODE=2
  CALL UOD1D3(T,TL,TU,E,SNORM,XDEL,MODE)
  $IF(HERF='D')
    $IF(MOS2=0)
      CALL UXDPGD($N,$B,$SN,INF)
    $ELSE
    CALL UXD$(LET)GD($N,$B,$IH,$SN,INF)
    $ENDIF
  $ELSEIF(HERF='S')
    CALL UXSPCD($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$SN,INF)
    CALL UXVSBP($N,$PERM,$SN,$GS)
  $ENDIF
  E=MAX(E,T-ALF/UX$(POM1)DOT($N,$SN,$SN$POM2)
  NRED=NRED+1
  GO TO $20
  ENDIF
  ELSE
*
*     STEP S IS COMPUTED
*
  CALL UX$(POM1)NEG($N,$GO,$SN$POM2
  $IF(HERF='D')
    $IF(MOS2=0)
      CALL UXDPGB($N,$B,$SN,0)
    $ELSE
      CALL UXD$(LET)GB($N,$B,$IH,$SN,0)
    $ENDIF
  $ELSEIF(HERF='S')
    CALL UXVSFP($N,$PERM,$SN,$GS)
    CALL UXSPCB($N,MMAX-MM,$H(MM+1),PSL,JH(MM+1),$SN,0)
    CALL UXVSBP($N,$PERM,$SN,$GS)
  $ENDIF
  SNORM=SQRT(UX$(POM1)DOT($N,$SN,$SN$POM2)
  MODE=1
  CALL UOD1D3(T,TL,TU,E,SNORM,XDEL,MODE)
  ENDIF
  IF (TU-TL.LE.$CON1) THEN
*
*     INTERVAL IS TOO SMALL
*
  IF (T.NE.ZERO) THEN
  ITERD=5
  TDXX='ZERO INT'
  ELSE
  ITERD=1
  TDXX='OLC STEP'
  ENDIF
  GO TO $40
  ELSE IF (NRED.GE.20) THEN
*
*     MAXIMUM NUMBER OF OLC REDUCTIONS
*
  ITERD=6
  TDXX='MAX NRED'
  GO TO $40
  ELSE IF (SNORM.GT.DEL2*XDEL) THEN
*
*     STEP IS TOO LARGE
*
  TL=MAX(TL,T)
  GO TO $30
  ELSE IF (SNORM.LT.DEL1*XDEL) THEN
  IF (T.NE.ZERO) THEN
*
*     STEP IS TOO SMALL
*
  TU=MIN(TU,T)
  ELSE
*
*     STEP IS ACCEPTABLE
*
  ITERD=1
  TDXX='OLC STEP'
  GO TO $40
  ENDIF
  ELSE
  ITERD=3
  TDXX='OLC MAX1'
  GO TO $40
  ENDIF
*
*     TRYING TO USE BOUNDARY STEP
*
  $IF(HERF='D')
    $IF(MOS2=0)
      CALL UXDPGN($N,$B,$XO,RHO,1)
    $ELSE
      CALL UXD$(LET)GN($N,$B,$IH,$XO,RHO,1)
    $ENDIF
  $ELSEIF(HERF='S')
    CALL UXSPCN($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$XO,RHO,1)
    CALL UXVSBP($N,$PERM,$XO,$GS)
  $ENDIF
  RHO1=UX$(POM1)DOT($N,$XO,$SN$POM2
  RHO2=UX$(POM1)DOT($N,$XO,$XO$POM2
  CALL UNSTEP(XDEL,SNORM,ABS(RHO1),RHO2,ALF)
  CON=(ONE-DEL1)*(ONE+DEL1)
  IF (ALF*ALF*RHO.LE.CON*(T*XDEL*XDEL-UX$(POM1)DOT($N,$GO,$SN$POM2))&
  THEN
  IF (RHO1.LT.ZERO) ALF=-ALF
  CALL UX$(POM1)DIR($N,ALF,$XO,$SN,$SN$POM2
  SNORM=XDEL
  ITERD=3
  TDXX='OLC MAX2'
  GO TO $40
  ELSE
  E=MAX(E,T-RHO)
  ENDIF
$30 CONTINUE
  IF (GNORM.LE.ZERO) THEN
  T=E
  ELSE
*
*     NEW T IS COMPUTED USING ONE STEP OF THE NEWTON METHOD FOR
*     NONLINEAR EQUATION
*
  CALL UX$(POM1)COP($N,$SN,$XO$POM2
  $IF(HERF='D')
    $IF(MOS2=0)
      CALL UXDPGB($N,$B,$XO,1)
      T=T+(SNORM*SNORM/UXDPGP($N,$B,$XO,$XO))*(SNORM-XDEL)/XDEL
    $ELSE
      CALL UXD$(LET)GB($N,$B,$IH,$XO,1)
      T=T+(SNORM*SNORM/UXDPGP($N,$B,$XO,$XO))*(SNORM-XDEL)/XDEL
    $ENDIF
  $ELSEIF(HERF='S')
    CALL UXVSFP($N,$PERM,$XO,$GS)
    CALL UXSPCB($N,MMAX-MM,$H(MM+1),$PSL,$JH(MM+1),$XO,1)
    T=T+(SNORM*SNORM/UXSPCP($N,MMAX-MM,$H(MM+1),$PSL,$XO))&
*(SNORM-XDEL)/XDEL
    CALL UXVSBP($N,$PERM,$XO,$GS)
  $ENDIF
  TDXX='NEWTON  '
  ENDIF
  NRED=NRED+1
  GO TO $20
$40 CONTINUE
  $IF(HERF='D')
    PP=UXDSMQ($N,$H,$SN,$SN)*HALF
    $IF(MOS1>0)
      CALL UXVMUL($N,$GS,$SN,$SN,1)
    $ENDIF
  $ELSEIF(HERF='S')
    IF (MOT2.EQ.0) THEN
    PP=UXSSMQ($N,MMAX,$H,$IH,$JH,$SN,$SN)*HALF
    ENDIF
  $ENDIF
$50 CONTINUE
  CALL UOD1D2($N,$GN,$SN)
  $IF(HERF='D')
    $IF(MOS1=0)
      $GO=GOS
      $GS=GSS
    $ENDIF
  $ELSEIF(HERF='S')
    $GO=GOS
    $GS=GSS
  $ENDIF
  $ADD(INIT)
    NDXX='UD$(HERF)GM7'
  $ENDADD
  $EXIT
