$INTERFACE UDGGM9                                             08/12/01
$REM MA

  $Z=XS
  $U1=XO
  $U2=GO
  $RES=GS
  $WV='WV'
  $WD='WD'
  $WL='WL'
  $HERF='S'
  $HELP
    NUMBER OF LANCZOS STEPS
  $CHECK(MOS3,100,INT,1)
  $IF(MOS3<10) $MOS3=10
  $IF(MOS3>NF) $MOS3=NF
  $HELP
    NUMBER OF ITERATIONS FOR COMPUTING EIGENVALUES
  $CHECK(MOS5,50,INT,1)
  $HELP
    PRECISION FOR OPTIMUM LOCALLY CONSTRAINED STEP
  $CHECK(DEL1,'1.0$P-2',REAL,4)
  $HELP
    TOLERANCE FOR CG ITERATIONS
  $CHECK(EPS6,'1.0$P-6',REAL,4)
  $HELP
    TOLERANCE FOR COMPUTING EIGENVALUES
  $CHECK(ETA4,'1.0$P 0',REAL,4)
  $HELP
    TOLERANCE FOR ALPHA
  $CHECK(ETA5,'1.0$P-8',REAL,4)
  $HELP
    TOLERANCE FOR NU
  $CHECK(ETA6,'1.0$P-6',REAL,4)
  $HELP
    TOLERANCE FOR THE QUASIOPTIMAL SOLUTION
  $CHECK(ETA7,'1.0$P-2',REAL,4)
  $HELP
    TOLERANCE FOR THE INTERIOR SOLUTION
  $CHECK(ETA8,'1.0$P-4',REAL,4)
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XDEL,'0.0$P 0',REAL,3)
  $IF(HERF='S')
    $ADD(REAL,'\$H($M)\UXSSDL\UXSSMQ')
    $ADD(INTEGER,'\$IH($NF+1)\$JH($M)\MM\NN')
  $ENDIF
  $ADD(REAL,'\$GN($NF)\$SN($NF)\$U1($NF)\$U2($NF)\$Z($NF)\$RES($NF+1)')
  $ADD(REAL,'\$WV(($NF+1)*$MOS3)\$WD(3*($NF+1))\$WL($MOS3*($MOS3+8))')
  $ADD(REAL,'\DELTAS\DELTAL\DELTAU\ALPHAL\ALPHAU\ALPHA\DELTAN')
  $ADD(REAL,'\AMBDA1\AMBDA2\RNU1\RNU2\U1NORM\U2NORM\FIA\FIB')
  $ADD(REAL,'\AMBDAA\AMBDAB\SNORMA\SNORMB\ALBARA\ALBARB\AMBAR')
  $ADD(REAL,'\OMEGA\OMEGAC\NUM\DEN\RHO1\RHO2\UXVDOT')
  $ADD(INTEGER,'\OPTS(4)\NMV\ITER\NCONV\STCOND\INFO')
  $ADD(LOGICAL,'\SELECT($MOS3)')
  $ADD(LOGICAL,'\ISZ')
  CALL UOD1D1
  $IF(HERF='S')
    IF (IDECF.LT.0) IDECF=0
    IF (IDECF.NE.0) THEN
  $ENDIF
  ITERD=-1
  TDXX='BAD DEC1'
  CALL UOERR1('UD$(HERF)GM9',1)
  GO TO $80
  ENDIF
  MM=$IH(NF+1)-1
  GNORM=SQRT(UXVDOT(NF,$GN,$GN))
  INITD=MAX(ABS(INITD),1)
  IF (XDEL.LE.ZERO) THEN
*
*     INITIAL TRUST REGION BOUND
*
  $IF(HERF='D')
    RHO1=UXDSMQ(NF,$H,$GN,$GN)
  $ELSEIF(HERF='S')
    RHO1=UXSSMQ(NF,MM,$H,$IH,$JH,$GN,$GN)
  $ENDIF
  RHO2=GNORM*GNORM
  IF (RHO1.LE.ZERO) THEN
  XDEL=GNORM
  ELSE
  XDEL=(RHO2/RHO1)*GNORM
  ENDIF
  IF(IEST.EQ.1) XDEL=MIN(XDEL,FOUR*(F-FMIN)/GNORM)
  XDEL=MIN(XDEL,XMAX)
  ENDIF
*
*     SORENSEN
*
*     DEFAULT VALUES
*
  OPTS(1)=2
  OPTS(2)=2
  OPTS(3)=1
  OPTS(4)=1
  NRED=0
  NMV=0
  NN=NF+1
  IF (GNORM.LE.EPS6) THEN
  CALL UYSORE(NF,MM,MOS3,$H,$IH,$JH,$GN,ALPHA,AMBDA1,AMBDA2,RNU1,RNU2&
,$U1,$U2,U1NORM,U2NORM,NCONV,NMV,$RES,$WV,$WD,$WL,SELECT,ETA4,1,INFO)
  IF (INFO.NE.0) THEN
  ITERD=-108
  TDXX='ARPACK  '
  CALL UOERR1('UD$(HERF)GM9',108)
  ELSE
  CALL UXVSCL(NF,XDEL,$WV(1),$SN)
  SNORM=XDEL
  STCOND=60
  ENDIF
  GO TO $80
  ENDIF
  DELTAS=XDEL**2+ONE
*
*     INITIAL DELTAU, ALPHAU, ALPHA
*
  IF (OPTS(1).EQ.1) THEN
  DELTAN=UXSSMQ(NF,MM,$H,$IH,$JH,$GN,$GN)
  NMV=NMV+1
  DELTAU=DELTAN/GNORM**2
  ELSE
  DELTAU=UXSSDL(NF,MM,$H,$IH,$JH,ITER)
  ENDIF
  ALPHAU=DELTAU+GNORM*XDEL
  IF (OPTS(2).EQ.1) THEN
  ALPHA=DMIN1(ZERO,ALPHAU)
  ELSE
  ALPHA=DELTAU
  ENDIF
*
*     EIGENPAIRS LAMBDA12,NU12,U12,U12NORM,NCONV
*
  CALL UYSORE(NN,MM,MOS3,$H,$IH,$JH,$GN,ALPHA,AMBDA1,AMBDA2,RNU1,RNU2&
,$U1,$U2,U1NORM,U2NORM,NCONV,NMV,$RES,$WV,$WD,$WL,SELECT,ETA4,2,INFO)
  IF (INFO.NE.0) THEN
  ITERD=-108
  TDXX='ARPACK  '
  CALL UOERR1('UD$(HERF)GM9',108)
  GO TO $80
  ENDIF
  IF (NCONV.EQ.0) THEN
  ITERD=-109
  TDXX='NO EIGEN'
  CALL UOERR1('UD$(HERF)GM9',109)
  GO TO $80
  ENDIF
  DELTAL=AMBDA1
  ALPHAL=DELTAL-GNORM/XDEL
  ISZ=.FALSE.
  DELTAN=AMBDA1-UXVDOT(NF,$GN,$U1)*RNU1/U1NORM
  DELTAU=DMIN1(DELTAU,DELTAN)
*
*     ADJUSTING ALPHA
*
  CALL UYSORA(NF,MM,MOS3,$H,$IH,$JH,$GN,GNORM,ALPHA,AMBDA1,AMBDA2,RNU1&
,RNU2,$U1,$U2,U1NORM,U2NORM,ALPHAL,ALPHAU,DELTAU,NCONV,NMV,ISZ,$Z,ETA4&
,ETA5,ETA6,ETA7,ITER,$RES,$WV,$WD,$WL,SELECT,INFO)
  IF (INFO.NE.0) THEN
  ITERD=-108
  TDXX='ARPACK  '
  CALL UOERR1('UD$(HERF)GM9',108)
  GO TO $80
  ENDIF
*
*     TEST ON CONVERGENCE
*
  CALL UYSORC(NF,MM,$H,$IH,$JH,$GN,GNORM,XDEL,$SN,SNORM,ALPHA,ALPHAL&
,ALPHAU,NMV,DELTAS,ITER,NCONV,ISZ,$Z,OPTS,AMBDA1,AMBDA2,RNU1,RNU2,$U1&
,$U2,U1NORM,U2NORM,DEL1,EPS6,ETA5,ETA7,ETA8,NRED,MOS5,$RES,STCOND)
  IF (STCOND.NE.0) GO TO $80
*
*     INTERPOLATION POINT
*
  CALL UYSORI(NF,$GN,$SN,SNORM,AMBDA1,AMBDA2,RNU1,RNU2,$U1,$U2,ITER&
,AMBDAA,AMBDAB,FIA,FIB,SNORMA,SNORMB,1)
*
*     BOUNDS FOR ALPHA
*
  CALL UYSORB(SNORM,XDEL,ITER,ALPHA,ALPHAL,ALPHAU)
*
*     1-POINT INTERPOLATION
*
  ALPHA=ALPHA+((ALPHA-AMBDAB)/SNORMB)*((XDEL-SNORMB)/XDEL)*&
  (XDEL+ONE/SNORMB)
*
*     SAFEGUARDING ALPHA
*
  IF (ALPHA.LT.ALPHAL.OR.ALPHA.GT.ALPHAU) THEN
  ALPHA=DELTAU+FIB+SNORMB**2*(DELTAU-AMBDAB)
  IF (ALPHA.LT.ALPHAL.OR.ALPHA.GT.ALPHAU) ALPHA=(ALPHAL+ALPHAU)/TWO
  ENDIF
*
*     ITERATE 1 FROM 1-POINT INTERPOLATION
*     EIGENPAIRS LAMBDA12,NU12,U12,U12NORM,NCONV
*
  CALL UYSORE(NN,MM,MOS3,$H,$IH,$JH,$GN,ALPHA,AMBDA1,AMBDA2,RNU1,RNU2&
,$U1,$U2,U1NORM,U2NORM,NCONV,NMV,$RES,$WV,$WD,$WL,SELECT,ETA4,2,INFO)
  IF (INFO.NE.0) THEN
  ITERD=-108
  TDXX='ARPACK  '
  CALL UOERR1('UD$(HERF)GM9',108)
  GO TO $80
  ENDIF
  IF (NCONV.GT.0) THEN
  DELTAN=AMBDA1-UXVDOT(NF,$GN,$U1)*RNU1/U1NORM
  DELTAU=DMIN1(DELTAU,DELTAN)
  ENDIF
*
*     ADJUSTING ALPHA
*
  CALL UYSORA(NF,MM,MOS3,$H,$IH,$JH,$GN,GNORM,ALPHA,AMBDA1,AMBDA2,RNU1&
,RNU2,$U1,$U2,U1NORM,U2NORM,ALPHAL,ALPHAU,DELTAU,NCONV,NMV,ISZ,$Z,ETA4&
,ETA5,ETA6,ETA7,ITER,$RES,$WV,$WD,$WL,SELECT,INFO)
  IF (INFO.NE.0) THEN
  ITERD=-108
  TDXX='ARPACK  '
  CALL UOERR1('UD$(HERF)GM9',108)
  GO TO $80
  ENDIF
  NRED = 1
*
$10 CONTINUE
*
*     TEST ON CONVERGENCE
*
  CALL UYSORC(NF,MM,$H,$IH,$JH,$GN,GNORM,XDEL,$SN,SNORM,ALPHA,ALPHAL&
,ALPHAU,NMV,DELTAS,ITER,NCONV,ISZ,$Z,OPTS,AMBDA1,AMBDA2,RNU1,RNU2,$U1&
,$U2,U1NORM,U2NORM,DEL1,EPS6,ETA5,ETA7,ETA8,NRED,MOS5,$RES,STCOND)
  IF (STCOND.NE.0) GO TO $80
*
*     INTERPOLATION POINT
*
  CALL UYSORI(NF,$GN,$SN,SNORM,AMBDA1,AMBDA2,RNU1,RNU2,$U1,$U2,ITER&
,AMBDAA,AMBDAB,FIA,FIB,SNORMA,SNORMB,2)
*
*     BOUNDS FOR ALPHA
*
  CALL UYSORB(SNORM,XDEL,ITER,ALPHA,ALPHAL,ALPHAU)
*
*     2-POINT INTERPOLATION
*
  IF (ABS(AMBDAB-AMBDAA).LE.ONE/ETA9) THEN
  ALPHA=(ALPHAL+ALPHAU)/TWO
  ELSE
  DEN=XDEL*(SNORMB-SNORMA)
  IF (ABS(DEN).LE.ONE/ETA9) THEN
  AMBAR=DELTAU
  ELSE
  AMBAR=(AMBDAA*SNORMA*(SNORMB-XDEL)+AMBDAB*SNORMB*(XDEL-SNORMA))/DEN
  IF (AMBAR.GT.DELTAU) AMBAR=DELTAU
  ENDIF
  OMEGA=(AMBDAB-AMBAR)/(AMBDAB-AMBDAA)
  OMEGAC=ONE-OMEGA
  NUM=SNORMA*SNORMB*(SNORMB-SNORMA)*(AMBDAA-AMBAR)*(AMBDAB-AMBAR)
  DEN=(OMEGA*SNORMB+OMEGAC*SNORMA)*(AMBDAB-AMBDAA)
  IF (ABS(DEN).LE.ONE/ETA9) THEN
  ALPHA=(ALPHAL+ALPHAU)/TWO
  ELSE
  ALBARA=AMBDAA+FIA
  ALBARB=AMBDAB+FIB
  ALPHA=OMEGA*ALBARA+OMEGAC*ALBARB+NUM/DEN
  ENDIF
  ENDIF
*
*     SAFEGUARDING ALPHA
*
  IF (ALPHA.LT.ALPHAL.OR.ALPHA.GT.ALPHAU) THEN
  IF (SNORMB.LT.SNORMA) THEN
  ALPHA=DELTAU+FIB+SNORMB**2*(DELTAU-AMBDAB)
  ELSE
  ALPHA=DELTAU+FIA+SNORMA**2*(DELTAU-AMBDAA)
  ENDIF
  IF (ALPHA.LT.ALPHAL.OR.ALPHA.GT.ALPHAU) ALPHA=(ALPHAL+ALPHAU)/TWO
  ENDIF
*
*     ITERATE K FROM 2-POINT INTERPOLATION
*     EIGENPAIRS LAMBDA12,NU12,U12,U12NORM,NCONV
*
  CALL UYSORE(NN,MM,MOS3,$H,$IH,$JH,$GN,ALPHA,AMBDA1,AMBDA2,RNU1,RNU2&
,$U1,$U2,U1NORM,U2NORM,NCONV,NMV,$RES,$WV,$WD,$WL,SELECT,ETA4,2,INFO)
  IF (INFO.NE.0) THEN
  ITERD=-108
  TDXX='ARPACK  '
  CALL UOERR1('UD$(HERF)GM9',108)
  GO TO $80
  ENDIF
  IF (NCONV.GT.0) THEN
  DELTAN=AMBDA1-UXVDOT(NF,$GN,$U1)*RNU1/U1NORM
  DELTAU=DMIN1(DELTAU,DELTAN)
  ENDIF
*
*     ADJUSTING ALPHA
*
  CALL UYSORA(NF,MM,MOS3,$H,$IH,$JH,$GN,GNORM,ALPHA,AMBDA1,AMBDA2,RNU1&
,RNU2,$U1,$U2,U1NORM,U2NORM,ALPHAL,ALPHAU,DELTAU,NCONV,NMV,ISZ,$Z,ETA4&
,ETA5,ETA6,ETA7,ITER,$RES,$WV,$WD,$WL,SELECT,INFO)
  IF (INFO.NE.0) THEN
  ITERD=-108
  TDXX='ARPACK  '
  CALL UOERR1('UD$(HERF)GM9',108)
  GO TO $80
  ENDIF
  NRED=NRED+1
  GO TO $10
$80 CONTINUE
  NCGR=NCGR+NRED
  $IF(HERF='S')
    PP=UXSSMQ(NF,MM,$H,$IH,$JH,$SN,$SN)*HALF
  $ENDIF
  CALL UOD1D2(NF,$GN,$SN)
  $ADD(INIT)
    NDXX='UD$(HERF)GM9'
  $ENDADD
  $EXIT
