$INTERFACE UDGLA1                                             17/12/01
$REM LU

  $CON1='1.0$P-2'
  $CON2='1.0$P-60'
  $CON3='2.0$P 0'
  $ICON1=0
  $ICON2=4
  $ICON3=32
  $ICON4=5
  $ICON5=8
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,'ETA0*1.0D-3',REAL,4)
  $HELP
    LOWER BOUND FOR GRADIENT
  $CHECK(TOLG,'1.0$P-8',REAL,3)
    $ADD(REAL,'\$GN($NF)\$SN($NF)\$AF($NA)')
  CALL UOD1D1
  IF (IDECA.LT.0) THEN
  $IF(JARA='D')
    $N='N'
    $ADD(REAL,'\$AG($NA*$NF)')
    $ADD(REAL,'\ALF')
    $IF(DEC='A')
      $ADD(REAL,'\$XO($NF)\$GO($NF)\$AFO($NA)')
      $ADD(INTEGER,'\$IAG($NF)')
      $IF(JASA='C')
        $HELP
          STORING PERMUTATIONS IN THE QR DECOMPOSITION:
            1 - CHANGES OF MATRIX ROWS 
            2 - TWO LEVEL INDICES
        $CHECK(MOS2,2,'1\2',3)
      $ELSE
        $MOS2=2
      $ENDIF  
      $HELP
        TYPE OF QR DECOMPOSITION:
          1 - PARTIAL QR DECOMPOSITION
          2 - TOTAL QR DECOMPOSITION
      $CHECK(MOS3,1,'1\2',3)
      $HELP
        PIVOTING IN THE HOUSEHOLDER QR DECOMPOSITION:
          1 - BASIC PIVOTING
          2 - BASIC PIVOTING WITH INCREMENTAL RANK DETERMINATION
          3 - INCREMENTAL RANK-REVEALING PIVOTING
      $CHECK(MOS4,1,'1\2\3',3)
      $IF(MOS3=2) 
        $IDECA=4
        IDECA=4
      $ELSE  
        $IDECA=3
        IDECA=3
      $ENDIF   
      INF=0
      ENDIF
      IF (IDECA.EQ.0) THEN
      IF (LD.LE.ZERO) CALL UXD$(JASB)MM($POMA,$AG,$AF,$GN)
*
*     HOUSEHOLDER DECOMPOSITION
*
      ALF=ETA2
      $IF(MOS2=1)
        CALL UXECHF(NA,$N,$AG,$IAG,$XO,$GO,$SN,INF)
        CALL UXECHP(NA,$N,$AG,ALF,$GO,$SN,INF,IER)
        CALL UXECTF(NA,$N,$AG,$GO,IER)
      $ELSE 
        $IF(MOS4=3)
          CALL UXD$(JASA)HC($N,NA,$AG,$IAG,ALF,$XO,$GO,$SN,INF,IER)
        $ELSE
          CALL UXD$(JASA)HF($N,NA,$AG,$IAG,$XO,$GO,INF)
        $ENDIF
        $IF(MOS4=2)
          CALL UXD$(JASA)HP($N,NA,$AG,$IAG,ALF,$GO,$SN,INF,IER)
        $ELSEIF(MOS4=1)
          CALL UXD$(JASA)HR($N,NA,$AG,$IAG,ALF,INF,IER)
        $ENDIF
        IDECA=3
        $IF(MOS3=2)
          CALL UXD$(JASA)TF($N,NA,$AG,$IAG,$GO,IER)
          IDECA=4
        $ENDIF
      $ENDIF
      NDECA=NDECA+1
      ELSE IF (IDECA.EQ.3) THEN
      ELSE IF (IDECA.EQ.4) THEN
    $ELSEIF(DEC='E')
      $ADD(REAL,'\$AFO($NA)')
      $ADD(INTEGER,'\$IAG($NF)')
      $HELP
        STORING PERMUTATIONS IN THE LU DECOMPOSITION:
          1 - CHANGES OF MATRIX ROWS 
          2 - TWO LEVEL INDICES
      $CHECK(MOS2,1,'1\2',3)
      $POM=2
      IDECA=2
      INF=0
      ENDIF
      IF (IDECA.EQ.0) THEN
      IF (LD.LE.ZERO) CALL UXD$(JASB)MM($POMA,$AG,$AF,$GN)
*
*     LU DECOMPOSITION
*
      ALF=ETA2
      $IF(LAPACK='YES')
        CALL UXDGLF($N,$AG,$IAG,INF,ALF)
      $ELSEIF(MOS2=1)
        CALL UXEGGF($N,$N,$AG,$IAG,INF,ALF)
      $ELSE
        CALL UXDGGF($N,$AG,$IAG,INF,ALF)
      $ENDIF
      NDECA=NDECA+1
      IDECA=2
      ELSE IF (IDECA.EQ.2) THEN
    $ELSEIF(DEC='Q')
      $ADD(REAL,'\$AFO($NA)')
      $IF(JASA='C')
        $HELP
          REPRESENTATION OF RECTANGULAR MATRICES:
            1 - TWO DIMENSIONAL ARRAY 
            2 - ONE DIMANSIONAL ARRAY
        $CHECK(MOS2,1,'1\2',3)
      $ELSE
        $MOS2=2
        $MOS3=2
      $ENDIF
      $IF(MOS2=1) $MOS3=1
      $HELP
        RECONSTRUCTION OF THE ORTHOGONAL MATRIX Q:
          1 - MATRIX Q IS NOT EXPLICITLY CONSTRUCTED
          2 - MATRIX Q IS EXPLICITLY CONSTRUCTED AND UPDATED
      $CHECK(MOS3,1,'1\2',3)
      $IF(MOS2=1)
        $POMD='E'
      $ELSE  
        $ADD(REAL,'\$H($NF*($NF+1)/2)')
        $POMD='D'
      $ENDIF  
      $IF(MOS3=1)
        $ADD(REAL,'\$H($NA*$NF)\$XS($NF)')
      $ELSE
        $ADD(REAL,'\$H($NF*($NF+1)/2)')
      $ENDIF
      $POM=1
      IDECA=1
      INF=0
      ENDIF
      IF (IDECA.EQ.0) THEN
*
*     QR DECOMPOSITION
*
      ALF=ETA2
      $IF(MOS3=1)
        CALL UX$(POMD)$(JASA)QF(N,NA,$AG,$H,$XO)
        CALL UX$(POMD)CRC(N,NA,$AG,INF,ALF)    
      $ELSE
        CALL UXD$(JASA)PF($N,NA,$AG,$H)
        CALL UXDPRC($N,$H,INF,ALF)
      $ENDIF  
      NDECA=NDECA+1
      IDECA=1
      ELSE IF (IDECA.EQ.1) THEN
    $ELSEIF(DEC='P')
      $POM=9
      IDECA=9
      INF=0
      ENDIF
      IF (IDECA.EQ.9) THEN
    $ENDIF
  $ELSEIF(JARA='S')
    $N='NF'
    $ADD(REAL,'\$AG($MA)\$AFO($NA)')
    $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)')
    $ADD(REAL,'\ALF')
    $IF(DEC='A')
      $IF(NUMBER=1)
        $IW1='IW1'
        $IW2='IW2'
        $ADD(REAL,'\$AG($MMAX)')
        $ADD(INTEGER,'\$JAG($MMAX)')
        $ADD(INTEGER,'\$IH($NF+1)\$IW1(11*($NF+1))\$IW2(6*($NA+1))')
        $POM=7
        IDECA=0
        ENDIF
        IF (IDECA.EQ.0) THEN
        IF (LD.LE.ZERO) CALL UXSCMM($N,NA,MA,$AG,$IAG,$JAG,$AF,$GN)
*
*     SPARSE QR DECOMPOSITION
*
        INF=0
        CALL UXVNEG(NA,$AF,$AFO)
        CALL UXSRBF(NA,$N,INF,MMAX,MMAX,MMAX,$IAG,$JAG,$IH&
,$IW1(9*$N+10),$IW1(10*$N+11),$IW2(2*NA+3),$IW2(3*NA+4),$IW2(4*NA+5)&
,$IW2(5*NA+6),$AG,$AFO)
        NDECA=NDECA+1
        IF (INF.GT.0) THEN
        ITERD=-INF
        TDXX='DEC ERR '
        GO TO $30
        ELSE
        IDECA=7
        ENDIF
        ELSE IF (IDECA.EQ.7) THEN
      $ELSE
        $BG='BG'
        $ADD(REAL,'\$BG($MMAX)\$AFO($NA+$NF)\$AFD($NA+$NF)')
        $POM=8
        IDECA=0
        ENDIF
        IF (IDECA.EQ.0) THEN
        IF (LD.LE.ZERO) CALL UXSCMM($N,NA,MA,$AG,$IAG,$JAG,$AF,$GN)
*
*     SPARSE BUNCH-PARLETT DECOMPOSITION
*
        INF=0
        CALL UXSMIN($N,NA,MA,$AG,$IAG,$JAG,$BG,$IBG)
        CALL UXSIBF(NA+$N,MA+NA+$N,$KBG,$JBG,$BG,MMAX,$IW,MMAX&
,$IW1,$IW2,NAU,NUP,INF)
        NDECA=NDECA+1
        IF (INF.LT.0) THEN
        ITERD=INF
        TDXX='DEC ERR '
        GO TO $30
        ELSE
        IDECA=8
        ENDIF
        ELSE IF (IDECA.EQ.7) THEN
      $ENDIF
    $ELSEIF(DEC='E')
      $BG='BG'
      $IBG='IBG'
      $JBG='JBG'
      $ADD(REAL,'\$BG($MMAX)\$AG($MA)\$AF($NA)\$GN($NF)\$SN($NF)&
      \$XO(2*$NF)')
      $ADD(INTEGER,'\$IBG($MMAX+1)\$JB(15)\$IB(5)\$IAG($NA+1)&
      \$JAG($MA)\$JBG($MA)')
      $HELP
        PRELIMINARY PERMUTATION OF THE JACOBIAN MATRIX
          0 - NO PERMUTATION
          1 - PERMUTATION TO BLOCK TRIANGULAR FORM
      $CHECK(MOS1,0,'0\1',3)
      $HELP
        PREFERRENCE OF SYMMETRIC PIVOTS
          0 - SYMMETRIC PIVOTS ARE NOT PREFERRED
          1 - SYMMETRIC PIVOTS ARE PREFERRED
      $CHECK(MOS2,0,'0\1',3)
      $POM=2
      IDECA=0
      ENDIF
      IF (LD.LE.ZERO) CALL UXSCMM($N,NA,MA,$AG,$IAG,$JAG,$AF,$GN)
      IF(IDECA.EQ.0) THEN
*
*     SPARSE LU DECOMPOSITION
*
      CALL UXSGMC($N,MA,$AG,$IAG,$JAG,ETA2)
      CALL UXVNEG($N,$AF,$SN)
      IF (NIT-LIT.LE.1) THEN
      DO $20 I=1,NA
      DO $10 KA=$IAG(I),$IAG(I+1)-1
      $JBG(KA)=I
$10 CONTINUE
$20 CONTINUE
      CALL UXIINI($JB,INF,1,MMAX+1,1,MMAX+1)
      CALL UXSGDS($BG,$IBG,$JB,$AG,$JAG,$JBG,$N,MA,IB,INF,$CON1&
,$CON2,$CON3,$ICON1,$ICON2,$ICON3,$ICON4,$MOS1,$MOS2)
      ELSE
      CALL UXSGDF($BG,$IBG,$JB,$AG,$JAG,$JBG,$N,MA,IB,INF,$CON2&
,$ICON3)
      ENDIF
      NDECA=NDECA+1
      IDECA=2
      IF (INF.NE.0) THEN
      ITERD=-7
      TDXX='DEC ERR '
      GOTO $30
      ENDIF
      ELSE IF (IDECA.EQ.2) THEN
    $ENDIF
  $ENDIF
  ELSE
  ITERD=-1
  TDXX='BAD DEC$POM'
  CALL UOERR1('UD$(JARA)L$(DEC)1',1)
  GOTO $30
  ENDIF
  $IF(DEC='Q')
    IF (LD.LE.ZERO) THEN
    $IF(MOS3=1)
      CALL UXVCOP(NA,$AF,$AFO)
      CALL UX$(POMD)CQB($N,NA,$AG,$AFO,$XO)
      CALL UXD$(JASB)MM($POMA,$H,$AFO,$GN)
    $ELSE  
      CALL UXD$(JASB)MM($POMA,$AG,$AF,$GN)
    $ENDIF   
    CALL UXVNEG($N,$GN,$SN)
    $IF(MOS3=1)
      CALL UX$(POMD)CRM(N,NA,$AG,$GN,-1)
    $ELSE
      CALL UXDPRM(N,$H,$GN,-1)
    $ENDIF
    ELSE
    CALL UXVNEG($N,$GN,$SN)
    ENDIF
  $ENDIF
  GNORM=SQRT(UXVDOT($N,$GN,$GN))
  IF (KD.LE.0) THEN
  IF (GNORM.LE.TOLG) THEN
  ITERM=4
  TXFU='GRAD TOL'
  GO TO $30
  ENDIF
  ENDIF
*
*     NEWTON LIKE STEP
*
  $IF(JARA='D')
    $IF(DEC='A')
      CALL UXVNEG(NA,$AF,$AFO)
      $IF(MOS2=1)
        CALL UXECHB(NA,$N,$AG,$AFO,$XO,IER)
        CALL UXECRB(IER,NA,$AG,$AFO,-1)
        CALL UXECTB(NA,$N,$AG,$AFO,$GO,IER)
        CALL UXVSBP($N,$IAG,$AFO,$SN)
        CALL UXVCOP($N,$AFO,$SN)
      $ELSE 
        CALL UXD$(JASA)HB($N,NA,$AG,$IAG,$AFO,$XO,INF)
        CALL UXD$(JASA)UB($N,NA,$AG,$IAG,$AFO,$SN,IER,-1)
        $IF(MOS3=2)
          CALL UXD$(JASA)TB($N,NA,$AG,$IAG,$SN,$GO,IER)
        $ENDIF
      $ENDIF
      TDXX='QR  REG '
      IF (INF.LT.N) TDXX='QR  SING'
    $ELSEIF(DEC='E')
      CALL UXVNEG($N,$AF,$SN)
      $JOB=0
      $IF(LAPACK='YES')
        $IF (JASA='R') $JOB=1
        CALL UXDGLB($N,$AG,$IAG,$SN,$JOB)
      $ELSEIF(MOS2=1)
        $IF (JASA='R') $JOB=1
        CALL UXEGGB($N,$N,$AG,$IAG,$SN,$JOB)
      $ELSE
        $IF (JASA='C') $JOB=1
        CALL UXDGGB($N,$AG,$IAG,$SN,$AFO,$JOB)
      $ENDIF
      TDXX='LU  REG '
      IF (INF.GT.N) TDXX='LU  SING'
      P=UXVDOT($N,$SN,$GN)
    $ELSEIF(DEC='Q')
      IF (LD.LE.ZERO) THEN
      $IF(MOS3=1)
        CALL UX$(POMD)CRB(N,NA,$AG,$SN,-1)
      ELSE
        CALL UX$(POMD)CRB(N,NA,$AG,$SN, 0)
      $ELSE
        CALL UXDPRB(N,$H,$SN,-1)
      ELSE
        CALL UXDPRB(N,$H,$SN, 0)
      $ENDIF  
      ENDIF
      IF(INF.EQ.0) THEN
      TDXX='QR  POS '
      ELSEIF(INF.LT.0) THEN
      TDXX='QR  ZER '
      ENDIF
    $ELSEIF(DEC='P')
      CALL UXD$(JASB)MM($POMA,$AG,$AF,$SN)
      CALL UXVNEG($N,$SN,$SN)
      TDXX='INV STEP'
    $ENDIF
  $ELSEIF(JARA='S')
    $IF(DEC='A')
      $IF(NUMBER=1)
        ALF=ETA2
        CALL UXSTMB($N,MA,$JAG,$AG,$SN,$AFO,ALF)
        CALL UXVSBP($N,$IW1(10*$N+11),$SN,$AFO)
        TDXX='QR  SOL '
      $ELSE
        CALL UXVNEG(NA,$AF,$AFO)
        CALL UXVSET($N,ZERO,$AFO(NA+1))
        CALL UXSIBB(NA+$N,$BG,MMAX,$IW,MMAX,$AFD,$AFO,$IW1,NAU,NUP)
        CALL UXVCOP($N,$AFO(NA+1),$SN)
        TDXX='BP  SOL '
      $ENDIF
    $ELSEIF(DEC='E')
      CALL UXSGDB($BG,$IBG,$JB,$N,IB,INF,$SN,$SN,$XO,$CON2,$ICON5&
,0)
      IF(INF.EQ.0) THEN
      ITERD = 1
      TDXX='LU  REG '
      ENDIF
      P=UXVDOT($N,$SN,$GN)
    $ENDIF
  $ENDIF
  INITD=MAX(ABS(INITD),1)
  ITERD=1
  NRED=INF
  SNORM=SQRT(UXVDOT($N,$SN,$SN))
  $IF(DEC='P')
  GNORM=SNORM
  $ENDIF
  CALL UOD1D5(ALF,ZERO,INF)
$30 CALL UOD1D2($N,$GN,$SN)
  $ADD(INIT)
    NDXX='UD$(JARA)L$(DEC)1'
  $ENDADD
  $EXIT

