$INTERFACE UDGTG1                                             97/12/01
$REM LU

  $POM1='V'
  $POM2=')'
  $IF(CONSTR='C')
    $IF(HERF='S')
      $POM1='U'
      $POM2=',$$IX,KBF)'
    $ENDIF
  $ENDIF
  $HELP
    METHOD SELECTION:
      1 - SINGLE  DOG-LEG STRATEGY
      2 - DOUBLE  DOG-LEG STRATEGY
      3 - OPTIMUM DOG-LEG STRATEGY
  $CHECK(MOS,1,'1\2\3',3)
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,'ETA0*1.0$P-3',REAL,4)
  $HELP
    UPPER BOUND FOR STEPSIZE PARAMETER
  $CHECK(ALF2,'1.0$P 6',REAL,4)
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XDEL,'0.0$P 0',REAL,3)
  $ADD(REAL,'\$H($M)\$GN($NF)\$SN($NF)\$XO($NF)\$GO($NF)')
  $ADD(REAL,'\UX$(POM1)DOT')
  $ADD(REAL,'\B1\B2\B3\D3\S1\S2')
  $IF(MOS=3)
    $ADD(REAL,'\D1\D2\G1\G2')
  $ENDIF
  CALL UOD1D1
  IF (IDECF.LT.0) THEN
  $IF(HERF='D')
    $ADD(REAL,'\UXDPGQ')
    $HELP
      CHOICE OF THE SCALING MATRIX:
        0 - UNIT MATRIX (NO SCALING)
        1 - SQUARE OF THE MATRIX H DIAGONAL
    $CHECK(MOS1,0,'0\1',4)
    $IF(MOS1=0)
      $XSS=XS
      $XS=XO
      $GSS=GS
      $GS=GO
    $ENDIF
    $ADD(REAL,'\$XS($NF)\$GS($NF)')
    $N='N'
    $IF(DEC='M')
      $ADD(REAL,'\$B($M)')
      $HELP
         TYPE OF DECOMPOSITION
           0 - GILL-MURRAY DECOMPOSITION
           1 - SCHNABEL-ESKOW DECOMPOSITION WITH NUMERICAL PERMUTATIONS
           2 - SCHNABEL-ESKOW DECOMPOSITION WITH TWO LEVEL INDICES
      $CHECK(MOS2,0,'0\1\2',2)
      $IF(MOS2=0)
      $ELSE
        $IF(MOS2=1) 
          $LET='L'
          $ART=',$IB)'
          $ADD(INTEGER,'\$IB($NF)')
        $ELSE  
          $LET='S'
          $ART=')'
        $ENDIF
        $ADD(INTEGER,'\$IH($NF)')
        CALL UXVINP($N,$IH)
      $ENDIF
      $IDECF=0
      IDECF=0
      INF=0
      ENDIF
      IF (IDECF.EQ.0) THEN
      CALL UXDSMC($N,$H,$B)
      $HS=H
      $H=B
      $IF(MOS1>0)
        CALL UXDSMX($N,$H,$GS)
        CALL UXVCOP($N,$GN,$XS)
        CALL UXVMUL($N,$GS,$GN,$GN,1)
      $ENDIF
      $IF(MOS2=0)
*
*     GILL-MURRAY DECOMPOSITION
*
        S1=ETA2
        CALL UXDPGF($N,$H,INF,S1,S2)
        NDECF=NDECF+1
      $ELSE
*
*     SCHNABEL-ESKOW DECOMPOSITION
*
        S1=ETA2
        CALL UXD$(LET)GF($N,$H,$IH,$GO,INF,S1,S2$ART
        NDECF=NDECF+1
      $ENDIF
    $ELSEIF(DEC='G')
      $IDECF=1
      IDECF=1
      INF=0
      ENDIF
      IF (IDECF.EQ.0) THEN
      $IF(MOS1>0)
        CALL UXDSMX($N,$H,$GS)
        CALL UXVCOP($N,$GN,$XS)
        CALL UXVMUL($N,$GS,$GN,$GN,1)
      $ENDIF
*
*     GILL-MURRAY DECOMPOSITION
*
      S1=ETA2
      CALL UXDPGF($N,$H,INF,S1,S2)
      NDECF=NDECF+1
      IDECF=1
      ELSE IF (IDECF.EQ.1) THEN
      ELSE IF (IDECF.EQ.2) THEN
      CALL UXDPRT($N,$H)
      IDECF=1
    $ELSEIF(DEC='S')
      $HELP
         TYPE OF DECOMPOSITION
           1 - SCHNABEL-ESKOW DECOMPOSITION WITH NUMERICAL PERMUTATIONS
           2 - SCHNABEL-ESKOW DECOMPOSITION WITH TWO LEVEL INDICES
      $CHECK(MOS2,1,'1\2',2)
      $IF(MOS2=1) 
        $LET='L'
        $ART=',$IB)'
        $ADD(INTEGER,'\$IB($NF)')
      $ELSE  
        $LET='S'
        $ART=')'
      $ENDIF
      $ADD(INTEGER,'\$IH($NF)')
      CALL UXVINP($N,$IH)
      $IDECF=4
      IDECF=4
      INF=0
      ENDIF
      IF (IDECF.EQ.0) THEN
      $IF(MOS1>0)
        CALL UXDSMX($N,$H,$GS)
        CALL UXVCOP($N,$GN,$XS)
        CALL UXVMUL($N,$GS,$GN,$GN,1)
      $ENDIF
*
*     SCHNABEL-ESKOW DECOMPOSITION
*
      S1=ETA2
      CALL UXD$(LET)GF($N,$H,$IH,$GO,INF,S1,S2$ART
      NDECF=NDECF+1
      IDECF=4
      ELSE IF (IDECF.EQ.1) THEN
      CALL UXVINP($N,$IH)
      IDECF=4
      ELSE IF (IDECF.EQ.2) THEN
      CALL UXDPRT($N,$H)
      CALL UXVINP($N,$IH)
      IDECF=4
      ELSE IF (IDECF.EQ.4) THEN
      ELSE IF (IDECF.EQ.5) THEN
      CALL UXDSRT($N,$H,$IH)
      IDECF=4
    $ENDIF
  $ELSEIF(HERF='S')
    $N='NF'
    $ADD(REAL,'\$XP($NF)')
    $ADD(INTEGER,'\$IH($NF+1)\$JH($MMAX)\$PSL($NF+1)\$PERM($NF)')
    $ADD(INTEGER,'\$WN11($NF+1)\$WN12($NF+1)')
    $ADD(REAL,'\UXSSMQ\UXSPCQ')
    $IDECF=1
    IDECF=0
    INF=0
    ENDIF
    MM=$IH($N+1)-1
    IF (IDECF.EQ.0) THEN
    CALL UXSPCT($N,MM,MH,MMAX,$H,$JH,$PSL,ITERM)
    IF (ITERM.NE.0) THEN
    TDXX='LACK SPC'
    GO TO $30
    ENDIF
*
*     SPARSE GILL-MURRAY DECOMPOSITION
*
    S1=ETA2
    CALL UXSPCF($N,MMAX,$H(MM+1),$PSL,$JH(MM+1),$WN11,$WN12,$XP,INF&
,S1,S2)
    NDECF=NDECF+1
    IDECF=1
    ELSE IF (IDECF.EQ.1) THEN
  $ENDIF
  ELSE
  ITERD=-1
  TDXX='BAD DEC$IDECF'
  CALL UOERR1('UD$(HERF)T$(DEC)1',1)
  GO TO $30
  ENDIF
$REM  B2=UX$(POM1)DOT($N,$GN,$GN$POM2
$REM  GNORM=SQRT(B2)
  GNORM=SQRT(UX$(POM1)DOT($N,$GN,$GN$POM2)
  B2=GNORM*GNORM
  INITD=MAX(ABS(INITD),1)
  $IF(HERF='D')
    CALL UXVCOP($N,$GN,$GO)
    $IF(DEC='M')
      $IF(MOS2=0)
        CALL UXDPGM($N,$H,$GO,1)
      $ELSE
        CALL UXD$(LET)GM($N,$H,$IH,$GO,1)
      $ENDIF
      B1=UXDPGQ($N,$H,$GO,$GO)
    $ELSEIF(DEC='G')
      CALL UXDPGM($N,$H,$GO,1)
      B1=UXDPGQ($N,$H,$GO,$GO)
    $ELSEIF(DEC='S')
      CALL UXD$(LET)GM($N,$H,$IH,$GO,1)
      B1=UXDPGQ($N,$H,$GO,$GO)
    $ENDIF
  $ELSEIF(HERF='S')
    CALL UX$(POM1)COP($N,$GN,$GO$POM2
    CALL UXVSFP($N,$PERM,$GO,$XP)
    CALL UXSPCM($N,MMAX,$H(MM+1),$PSL,$JH(MM+1),$GO,$XP,1)
    B1=UXSPCQ($N,MMAX,$H(MM+1),$PSL,$GO)
  $ENDIF
  IF (XDEL.LE.ZERO) THEN
*
*     INITIAL TRUST REGION BOUND
*
  IF (B1.LE.ZERO) THEN
  XDEL=GNORM
  ELSE
  XDEL=(B2/B1)*GNORM
  ENDIF
  IF(IEST.EQ.1) XDEL=MIN(XDEL,FOUR*(F-FMIN)/GNORM)
  XDEL=MIN(XDEL,XMAX)
  ENDIF
  CALL UXVNEG($N,$GN,$GO)
  $IF(HERF='D')
    $IF(DEC='M')
      $IF(MOS2=0)
        CALL UXDPGB($N,$H,$GO,0)
      $ELSE
        CALL UXD$(LET)GB($N,$H,$IH,$GO,0)
      $ENDIF
    $ELSEIF(DEC='G')
      CALL UXDPGB($N,$H,$GO,0)
    $ELSEIF(DEC='S')
      CALL UXD$(LET)GB($N,$H,$IH,$GO,0)
    $ENDIF
  $ELSEIF(HERF='S')
    CALL UXVSFP($N,$PERM,$GO,$XP)
    CALL UXSPCB($N,MMAX,$H(MM+1),$PSL,$JH(MM+1),$GO,0)
    CALL UXVSBP($N,$PERM,$GO,$XP)
  $ENDIF
  D3=UX$(POM1)DOT($N,$GO,$GO$POM2
  IF (D3.LE.XDEL**2) THEN
*
*     NEWTON DIRECTION IS ACCEPTED
*
  CALL UX$(POM1)COP($N,$GO,$SN$POM2
  SNORM=SQRT(D3)
  ITERD=1
  TDXX='DOG STEP'
  GO TO $20
  ENDIF
  $IF(MOS=3)
*
*     OPTIMUM DOG-LEG STRATEGY
*
    B3=UX$(POM1)DOT($N,$GN,$GO$POM2
    D1=B2
    D2=B3
    G1=B2
    G2=B3
    CALL UNLCS2(B1,B2,B3,D1,D2,D3,G1,G2,S1,S2,XDEL,IER)
    IF (IER.EQ.1) THEN
    CALL UXVSCL($N,S1,$GN,$SN)
    CALL UX$(POM1)DIR($N,S2,$GO,$SN,$SN$POM2
    SNORM=SQRT(UX$(POM1)DOT($N,$SN,$SN$POM2)
    ITERD=3
    TDXX='DOG MAX4'
    GO TO $20
    ELSE IF (IER.EQ.0) THEN
    CALL UX$(POM1)NEG($N,$GO,$SN$POM2
    SNORM=SQRT(D3)
    ITERD=1
    TDXX='DOG STEP'
    GO TO $20
    ELSE
    D3=SQRT(D3)
    ENDIF
  $ELSE
    D3=SQRT(D3)
  $ENDIF
*
*     COMPUTATION OF THE STEEPEST DESCENT DIRECTION
*
  B2=B2/B1
  SNORM=B2*GNORM
  IF (SNORM.GE.XDEL) THEN
  CALL UXVSCL($N,-XDEL/GNORM,$G,$S)
  SNORM=XDEL
  ITERD=3
  TDXX='SD  MAX '
  GO TO $20
  ENDIF
  CALL UXVSCL($N,-B2,$GN,$SN)
  CALL UX$(POM1)DIF($N,$GO,$SN,$XO$POM2
  B1=UX$(POM1)DOT($N,$SN,$XO$POM2
  B2=UX$(POM1)DOT($N,$XO,$XO$POM2
  $IF(MOS=1)
*
*     SINGLE DOGLEG STRATEGY
*
    CALL UNSTEP(XDEL,SNORM,B1,B2,B3)
    CALL UX$(POM1)DIR($N,B3,$XO,$SN,$SN$POM2
    SNORM=XDEL
    ITERD=3
    TDXX='DOG MAX1'
  $ELSE
*
*     DOUBLE DOGLEG STRATEGY
*
    D3=XDEL/D3
    B3=UX$(POM1)DOT($N,$SN,$GO$POM2
    D3=MAX(D3,SNORM*SNORM/B3)
    CALL UX$(POM1)DIR($N,-D3,$GO,$SN,$XO$POM2
    B1=SNORM*SNORM-D3*B3
    B2=UX$(POM1)DOT($N,$XO,$XO$POM2
    CALL UNSTEP(XDEL,SNORM,-B1,B2,B3)
    CALL UX$(POM1)DIR($N,-B3,$XO,$SN,$SN$POM2
    SNORM=XDEL
    ITERD=3
    TDXX='DOG MAX2'
  $ENDIF
$20 CONTINUE
  $IF(HERF='D')
    CALL UXVCOP($N,$SN,$GO)
    $IF(DEC='M')
      $IF(MOS2=0)
        CALL UXDPGM($N,$H,$GO,1)
        PP=UXDPGQ($N,$H,$GO,$GO)*HALF
      $ELSE
        CALL UXD$(LET)GM($N,$H,$IH,$GO,1)
        PP=UXDPGQ($N,$H,$GO,$GO)*HALF
      $ENDIF
      $H=HS
    $ELSEIF(DEC='G')
      CALL UXDPGM($N,$H,$GO,1)
      PP=UXDPGQ($N,$H,$GO,$GO)*HALF
    $ELSEIF(DEC='S')
      CALL UXD$(LET)GM($N,$H,$IH,$GO,1)
      PP=UXDPGQ($N,$H,$GO,$GO)*HALF
    $ENDIF
  $ELSEIF(HERF='S')
    CALL UX$(POM1)COP($N,$SN,$GO$POM2
    CALL UXVSFP($N,$PERM,$GO,$XP)
    CALL UXSPCM($N,MMAX,$H(MM+1),$PSL,$JH(MM+1),$GO,$XP,1)
    PP=UXSPCQ($N,MMAX,$H(MM+1),$PSL,$GO)*HALF
    IF (ITERD.EQ.1.AND.INF.NE.0) ITERD=2
  $ENDIF
$30 CALL UOD1D2($N,$GN,$SN)
  $IF(HERF='D')
    $IF(MOS1=0)
      $GS=GSS
      $XS=XSS
    $ENDIF
  $ENDIF
  $ADD(INIT)
    NDXX='UD$(HERF)T$(DEC)1'
  $ENDADD
  $EXIT
