$INTERFACE UDSGI4                                             03/12/01
$REM LU

  $NN='NC'
  $D='D'
  $XS='XS'
  $GS='GS'
  $XP='XP'
  $CON1='1.0$P-3'
  $CON3='0.8$P 0'
  $CON4='0.2$P 0'
  $CON5='1.0$P-3'
  $CON6='1.0$P 6'
  $POM1='U'
  $POM2=',$$IX,-KBF)'
$REM  $HELP
$REM    MAXIMUM NUMBER OF DENSE COLUMNS:
$REM  $CHECK(MD,10,INT,2)
$REM  $HELP
$REM    MINIMUM NUMBER OF NONZERO ELEMENTS IN DENSE ROWS:
$REM  $CHECK(MDE,50,INT,2)
  $HELP
    MAXIMUM NUMBER OF CG ITERATIONS
  $CHECK(MCGR,0,INT,3)
  $HELP
    STRATEGY FOR PRECISION DETERMINATION:
      1 - SINGLE STRATEGY
      2 - GEOMETRIC DECREASING STRATEGY
      3 - HARMONIC  DECREASING STRATEGY
  $CHECK(MOS,3,'1\2\3',3)
$REM  $MOS2=1
  $HELP
    PRECONDITIONING THE KARUSH-KUHN-TUCKER SYSTEM
     -1 OR 1 - INDEFIFITE PRECONDITIONING BASED ON A DIAGONAL
               APPROXIMATION OF THE HESSIAN MATRIX: COMPLETE
               CHOLESKI DECOMPOSITION
     -2 OR 2 - INDEFIFITE PRECONDITIONING BASED ON A DIAGONAL
               APPROXIMATION OF THE HESSIAN MATRIX: INCOMPLETE
               CHOLESKI DECOMPOSITION
    MOS2 > 0 - DIAGONAL PART OF THE HESSIAN MATRIX IS USED
    MOS2 < 0 - UNIT MATRIX IS USED
  $CHECK(MOS2,-1,'-2\-1\1\2',3)
  $NOS2=0
  $IF(MOS2= 1) $NOS2=1
  $IF(MOS2=-1) $NOS2=1
  $IF(MOS2= 2) $NOS2=2
  $IF(MOS2=-2) $NOS2=2
  $HELP
    DECISION AFTER NEGATIVE CURVATURE IS FOUND
      0 - INDEFINITE ITERATIONS
      1 - DETERMINATION OF THE BOUNDARY STEP
  $CHECK(MOS3,0,'0\1',4)
  $DEFAULT='0.9$P 0'
  $IF(MOS=1) $DEFAULT='0.1$P 0'
  $HELP
    MINIMUM PRECISION OF AN INEXACT SOLUTION
  $CHECK(EPS6,DEFAULT,REAL,4)
  $HELP
    TOLERANCE FOR ACTIVE CONSTRAINTS
  $CHECK(EPS9,'1.0$P-1',REAL,4)
  $DEFAULT='1.0D-6'
  $ORDER=1
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,DEFAULT,REAL,4)
  $ADD(REAL,'\$H($MMAX)\$CG($MC)\$CF($NC+1)\$GC($NF)\$G($NF)&
  \$S($NF+$NCA)\$XO($NF+$NCA)\$GO($NF+$NCA)\$XS($NF+$NCA)&
  \$GS($NF+$NCA)\$D($NF+$NCA)\$CP($NCA)')
  $ADD(REAL,'\$X($NF)\$XL($NX)\$XU($NX)\$XSL($NX)\$XSU($NX)\$XZL($NX)&
  \$XZU($NX)\$CL($NC)\$CU($NC)\$CSL($NC)\$CSU($NC)\$CZL($NC)\$CZU($NC)')
  $ADD(INTEGER,'\$IH($NF+1)\$JH($MMAX)\$ICG($NC+1)\$JCG($MC)&
  \$IX($NX)\$WN11($NF+1)\$WN12($NF+1)')
  $ADD(REAL,'\UXVDOT\UX$(POM1)DOT\UXWDOT\UCIDOS')
  $ADD(REAL,'\ALF\DEL\RHO\RHO1\RHO2\SIG')
  $ADD(INTEGER,'\I\K\L\MM\MMX\NCA\IPOM\KPOM\NOS\IFILL')
  $IF(NOS2=1)
    $ADD(REAL,'\$B($MMAX)')
    $ADD(INTEGER,'\$IB($NCA+1)\$JB($MMAX)\$PSR($NCA+1)&
    \$PERC($NCA)\$INVP($NCA)\$WN11($NCA+1)\$WN12($NCA+1)&
    \$WN13($NCA+1)\$WN14($NCA+1)')
    $ADD(INTEGER,'\MS')
  $ELSEIF(NOS2=2)
    $ADD(REAL,'\$B($MMAX)')
    $ADD(INTEGER,'\$IB($NCA+1)\$JB($MMAX)')
  $ENDIF
  CALL UOD1D1
  IPOM=0
  GNORM=SQRT(UX$(POM1)DOT(NF,$G,$G$POM2)
  CALL UXVNEG(NF,$G,$XS)
  IF(XDEL.LE.ZERO) THEN
*
*     INITIAL TRUST REGION BOUND
*
  XDEL=GNORM
  IF(IEST.EQ.1) XDEL=MIN(XDEL,FOUR*(F-FMIN)/GNORM)
  XDEL=MIN(XDEL,XMAX)
  IF (XDEL.LE.ZERO) XDEL=XMAX
  ENDIF
*
*     DETERMINATION OF ACTIVE CONSTRAINTS AND CONSTRUCTION OF THE
*     CORRESPONDING KARUSH-KUHN-TUCKER SYSTEM
*
  M=$IH(NF+1)-1
  CALL UCIACT(NX,NC,NCA,$IX,$XSL,$XSU,$XZL,$XZU,$IC&
,$CSL,$CSU,$CZL,$CZU,$ICA,EPS9,INF)
  CALL UCINAT(NF,NX,NC,MC,M,$X,$IX,$XL,$XU,$XSL,$XSU,$XZL,$XZU,$CF,$IC&
,$CL,$CU,$CSL,$CSU,$CZL,$CZU,$CG,$ICG,$JCG,$XS,$GO,$H,$IH,$JH,RPF3&
,MEP1)
  CALL UCISLC(NF,NX,NC,NCA,$X,$IX,$XL,$XU,$XSL,$XSU,$XZL,$XZU,$CF,$IC&
,$CL,$CU,$CSL,$CSU,$CZL,$CZU,$ICA,$S(NF+1),$XS(NF+1),$D(NF+1),RPF3,MEP1)
  CALL UODLI3(NF,NX,NC,NCA,$IX,$IC,$ICA,$XS,RPF2,RPF3,INF)
  MM=NF+NCA
*
*     CONSTRUCTION OF THE NORMAL MATRIX OF ACTIVE CONSTRAINTS
*
  NOS=$NOS2
  IF (IDECF.LT.0) IDECF=0
  IF (IDECC.LT.0) IDECC=0
  DO $20 I=1,NF
  IF (MOS2.GT.0) THEN
  ALF=ABS($H($IH(I)))
  IF (ABS(ALF).LE.$CON5) ALF=$CON5
  IF (ABS(ALF).GE.$CON6) ALF=$CON6
  $D(I)=ONE/ALF
  ELSE
  $D(I)=ONE
  ENDIF
  $IF(KBF>0)
    IF (IX(I).EQ.-5) $D(I)=ZERO
  $ENDIF
$20 CONTINUE
  IF (NCA.GT.0.AND.INF.GT.0) THEN
  $SUBST('UCISS1')
  IF (ITERM.NE.0) THEN
  TDXX='DENSE R '
  GO TO $90
  ENDIF
  $IF(MOS2=1)
    MS=0
  L=$IB(NCA+1)-1
  CALL UXSPCC(NCA,L,MS,$MMAX,$B,$IB,$JB,$PSR,$PERC&
,$INVP,$WN11,$WN12,$WN13,$WN14,$ORDER,IFILL,ITERM)
    IF (ITERM.LT.0) THEN
    TXFU='LACK SPC'
    ENDIF
  $ENDIF
  ENDIF
  IF (NCA.LE.0) THEN
  NOS=0
  ELSE
  $SUBST('UCINS1')
  L=$IB(NCA+1)-1
  IF (L.GE.$MMAX) THEN
  CALL UOERR2('UDSGI4',49,L,$MMAX)
  ITERM=-49
  TDXX='LACK SPC'
  GO TO $90
  ENDIF
  CALL UXSSMM(NCA,$IB(NCA+1)-1,$B,$IB,$JB,$S(NF+1),$GS(NF+1))
*
*     CONSTRUCTION OF THE CG PRECONDITIONER
*
  ALF=ETA2
  $IF(MOS2=1)
    CALL UXSPCT(NCA,L,MS,MMAX,$B,$JB,$PSR,ITERM)
    IF (ITERM.NE.0) THEN
    TDXX='LACK SPC'
    GO TO $90
    ENDIF
*
*     GILL-MURRAY DECOMPOSITION
*
    CALL UXSPCF(NCA,MMAX-L,$B(L+1),$PSR,$JB(L+1),$WN11,$WN12,$GO,INF&
,ALF,SIG)
    $IF(MD>0)
      IF (ND.GT.0) THEN
      CALL UXSPCX(NCA,MMAX-L,ND,$B(L+1),$PSR,$JB(L+1),$PERC,$CGD,$DD&
,$BD,$GO,$GO(NF+1))
      ENDIF
    $ENDIF
  $ELSEIF(NOS2=2)
    CALL UXSPIF(NCA,L,$B,$IB,$JB,INF,ALF,SIG,$GO)
    $IF(MD>0)
      IF (ND.GT.0) THEN
      CALL UXSPIX(NCA,L,ND,$B,$IB,$JB,$CGD,$DD,$BD,$S(NF+1))
      ENDIF
    $ENDIF
  $ENDIF
  NDECC=NDECC+1
  ENDIF
  DO $30 I=1,NCA
  $D(NF+I)=SQRT(ABS($D(NF+I)))
$30 CONTINUE
*
*     RANGE SPACE (VERTICAL) DIRECTION USING THE DOG-LEG STRATEGY
*
  DEL=$CON3*XDEL
  RHO1=UXVDOT(NCA,$S(NF+1),$GS(NF+1))
  RHO2=UXVDOT(NCA,$GS(NF+1),$GS(NF+1))
  IF (RHO1.LE.ZERO.OR.RHO2.LE.ZERO) THEN
  CALL UXVSET(NF,ZERO,$S)
  CALL UXVSET(NCA,ZERO,$GS(NF+1))
  SNORM=ZERO
  ELSE
  SNORM=RHO1**(THREE/TWO)/RHO2
  IF (SNORM.GE.DEL) THEN
  CALL UCICMM(NF,NC,NCA,MC,$ICA,$CG,$ICG,$JCG,$S(NF+1),$S)
  CALL UXVMUL(NCA,$D(NF+1),$S(NF+1),$GS(NF+1),1)
  CALL UXVSCL(NF,DEL/SQRT(RHO1),$S,$S)
  CALL UXVSCL(NCA,DEL/SQRT(RHO1),$GS(NF+1),$GS(NF+1))
  SNORM=DEL
  ELSE
  CALL UXVCOP(NCA,$S(NF+1),$GS(NF+1))
  $IF(MD>0)
    CALL UXSPCZ(NCA,MMAX-L,ND,$B(L+1),$PSR,$JB(L+1),$PERC,$CGD,$DD,$BD&
,$GO,$GS(NF+1),$CP)
  $ELSE
    CALL UXVSFP(NCA,$PERC,$GS(NF+1),$GO)
    CALL UXSPCB(NCA,MMAX-L,$B(L+1),$PSR,$JB(L+1),$GS(NF+1),0)
    CALL UXVSBP(NCA,$PERC,$GS(NF+1),$GO)
  $ENDIF
  RHO=SNORM
  SNORM=SQRT(UXVDOT(NCA,$S(NF+1),GS(NF+1)))
  IF (SNORM.LE.DEL) THEN
  CALL UCICMM(NF,NC,NCA,MC,$ICA,$CG,$ICG,$JCG,$GS(NF+1),$S)
  CALL UXVMUL(NCA,$D(NF+1),$GS(NF+1),$GS(NF+1),1)
  ELSE
  SIG=SNORM
  SNORM=RHO
  RHO=(RHO1/RHO2)*UXVDOT(NCA,$S(NF+1),$S(NF+1))
  CALL UXVSCL(NCA,RHO1/RHO2,$S(NF+1),$S(NF+1))
  CALL UXVDIF(NCA,$GS(NF+1),$S(NF+1),$GS(NF+1))
  RHO1=RHO-SNORM**2
  RHO2=SIG**2-RHO-RHO1
  CALL UNSTEP(DEL,SNORM,RHO1,RHO2,ALF)
  CALL UXVDIR(NCA,ALF,$GS(NF+1),$S(NF+1),$GS(NF+1))
  SNORM=DEL
  CALL UCICMM(NF,NC,NCA,MC,$ICA,$CG,$ICG,$JCG,$GS(NF+1),$S)
  CALL UXVMUL(NCA,$D(NF+1),$GS(NF+1),$GS(NF+1),1)
  ENDIF
  ENDIF
  ENDIF
*
*     NULL SPACE (HORIZONTAL) DIRECTION USING THE CG METHOD
*
*
*     CG INITIATION
*
  CALL UXSSMD(NF,M,$H,$IH,$JH,$S,-ONE,$XS,$GO)
  CALL UXVDIF(NCA,$GS(NF+1),$XS(NF+1),$GO(NF+1))
  CALL UXVNEG(MM,$GO,$XS)
*
*     CG PRECONDITIONING
*
  $IF(MOS2>0)
    CALL UXVMUL(NF,$D,$GO,$GO,1)
  $ENDIF
  CALL UXVMUL(NCA,$D(NF+1),$GO(NF+1),$S(NF+1),1)
  CALL UCIRMD(NF,NC,NCA,MC,$ICA,$CG,$ICG,$JCG,$GO,ONE,$S(NF+1)&
,$S(NF+1))
  $IF(MD>0)
    CALL UXSPCZ(NCA,MMAX-L,ND,$B(L+1),$PSR,$JB(L+1),$PERC,$CGD,$DD,$BD&
,$GO,$S(NF+1),$CP)
  $ELSE
    CALL UXVSFP(NCA,$PERC,$S(NF+1),$GO)
    CALL UXSPCB(NCA,MMAX-L,$B(L+1),$PSR,$JB(L+1),$S(NF+1),0)
    CALL UXVSBP(NCA,$PERC,$S(NF+1),$GO)
  $ENDIF
  CALL UCICMD(NF,NC,NCA,MC,$ICA,$CG,$ICG,$JCG,$S(NF+1),ONE,$XS,$GO)
  CALL UXVMUD(NCA,$D(NF+1),$S(NF+1),ONE,$XS(NF+1),$GO(NF+1),1)
  CALL UXVNEG(NCA,$S(NF+1),$S(NF+1))
  CALL UXVCOP(MM,$GO,$XO)
  RHO1=UX$(POM1)DOT(NF,$GO,$XS$POM2+UCIDOS(NX,NC,NCA,$IX,$IC,$ICA&
,$GO(NF+1),$XS(NF+1))
  RHO=RHO1
  PAR=MIN(EPS6,RHO1)
  IF (PAR.GT.TEN*$CON1) THEN
  $IF(MOS=1)
  $ELSEIF(MOS=2)
    PAR=MIN(PAR,$CON1**(DBLE(NIT-LIT)/DBLE(NF-NCA)))
  $ELSEIF(MOS=3)
    PAR=MIN(PAR,ONE/DBLE(NIT-LIT))
  $ENDIF
  ENDIF
  KPOM=0
  MMX=MIN(20,2*NF)
$REM  MMX=2*NF
*
*     CG ITERATIONS
*
  DO $50 NRED=1,MMX
  CALL UX$(POM1)COP(NF,$S,$GS$POM2
  CALL UXSSMM(NF,M,$H,$IH,$JH,$XO,$GO)
  CALL UXVCOP(NCA,$XO(NF+1),$GO(NF+1))
  ALF=UX$(POM1)DOT(NF,$XO,$GO$POM2+UCIDOS(NX,NC,NCA,$IX,$IC,$ICA&
,$XO(NF+1),$GO(NF+1))
  $IF(MOS3=0)
    IF (ALF.EQ.ZERO) THEN
    ITERD=-5
    TDXX='CG BREAK'
    CALL UOERR1('UDSGI4',5)
    GO TO $90
    ENDIF
  $ELSEIF(MOS3=1)
    IF (ALF.LE.ZERO) GO TO $70
  $ENDIF
  ALF=RHO/ALF
  CALL UX$(POM1)DIR(NF,ALF,$XO,$S,$S$POM2
  CALL UXVDIR(NCA,ALF,$XO(NF+1),$GS(NF+1),$S(NF+1))
  RHO2=SQRT(UX$(POM1)DOT(NF,$S,$S$POM2+UCIDOS(NX,NC,NCA,$IX,$IC,$ICA&
,$S(NF+1),$S(NF+1)))
  IF (RHO2.GE.XDEL) GO TO $70
  CALL UXVCOP(NCA,$S(NF+1),$GS(NF+1))
  SNORM=RHO2
*
*     CG STEP
*
  CALL UX$(POM1)DIR(NF,-ALF,$GO,$XS,$XS$POM2
  CALL UXVDIR(NCA,-ALF,$GO(NF+1),$XS(NF+1),$XS(NF+1))
  CALL UXVNEG(MM,$XS,$GO)
*
*     CG PRECONDITIONING
*
  CALL UXVMUL(NCA,$D(NF+1),$GO(NF+1),$S(NF+1),1)
  CALL UCIRMD(NF,NC,NCA,MC,$ICA,$CG,$ICG,$JCG,$GO,ONE,$S(NF+1)&
,$S(NF+1))
  $IF(MD>0)
    CALL UXSPCZ(NCA,MMAX-L,ND,$B(L+1),$PSR,$JB(L+1),$PERC,$CGD,$DD,$BD&
,$GO,$S(NF+1),$CP)
  $ELSE
    CALL UXVSFP(NCA,$PERC,$S(NF+1),$GO)
    CALL UXSPCB(NCA,MMAX-L,$B(L+1),$PSR,$JB(L+1),$S(NF+1),0)
    CALL UXVSBP(NCA,$PERC,$S(NF+1),$GO)
  $ENDIF
  CALL UCICMD(NF,NC,NCA,MC,$ICA,$CG,$ICG,$JCG,$S(NF+1),ONE,$XS,$GO)
  CALL UXVMUD(NCA,$D(NF+1),$S(NF+1),ONE,$XS(NF+1),$GO(NF+1),1)
  CALL UXVNEG(NCA,$S(NF+1),$S(NF+1))
  RHO2=UX$(POM1)DOT(NF,$GO,$XS$POM2+UCIDOS(NX,NC,NCA,$IX,$IC,$ICA&
,$GO(NF+1),$XS(NF+1))
  IF (RHO2.LE.PAR*RHO1) GO TO $60
  CALL UOD1D4(RHO1,RHO2,PAR,SNORM,XDEL)
  ALF=RHO2/RHO
  CALL UX$(POM1)DIR(NF,ALF,$XO,$GO,$XO$POM2
  CALL UXVDIR(NCA,ALF,$XO(NF+1),$GO(NF+1),$XO(NF+1))
  RHO=RHO2
$50 CONTINUE
  TDXX='MAX ITER'
$60 CONTINUE
*
*     AN INEXACT SOLUTION IS OBTAINED
*
  ITERD=2
  TDXX='CG  STEP'
  GO TO $80
*
*     BOUNDARY STEP IS COMPUTED
*
$70 CONTINUE
  ITERD=3
  TDXX='CG  MAX2'
  RHO1=UX$(POM1)DOT(NF,$GS,$XO$POM2+UCIDOS(NX,NC,NCA,$IX,$IC,$ICA&
,$GS(NF+1),$XO(NF+1))
  RHO2=UX$(POM1)DOT(NF,$XO,$XO$POM2+UCIDOS(NX,NC,NCA,$IX,$IC,$ICA&
,$XO(NF+1),$XO(NF+1))
  CALL UNSTEP(XDEL,SNORM,RHO1,RHO2,ALF)
  CALL UX$(POM1)DIR(NF,ALF,$XO,$GS,$S$POM2
  CALL UXVDIR(NCA,ALF,$XO(NF+1),$GS(NF+1),$GS(NF+1))
  SNORM=XDEL
  CALL UX$(POM1)DIR(NF,-ALF,$GO,$XS,$XS$POM2
  CALL UXVDIR(NCA,-ALF,$GO(NF+1),$XS(NF+1),$XS(NF+1))
  CALL UXVMUL(NCA,$D(NF+1),$XS(NF+1),$S(NF+1),1)
  CALL UCIRMD(NF,NC,NCA,MC,$ICA,$CG,$ICG,$JCG,$XS,ONE,$S(NF+1)&
,$S(NF+1))
  $IF(MD>0)
    CALL UXSPCZ(NCA,MMAX-L,ND,$B(L+1),$PSR,$JB(L+1),$PERC,$CGD,$DD,$BD&
,$GO,$S(NF+1),$CP)
  $ELSE
    CALL UXVSFP(NCA,$PERC,$S(NF+1),$GO)
    CALL UXSPCB(NCA,MMAX-L,$B(L+1),$PSR,$JB(L+1),$S(NF+1),0)
    CALL UXVSBP(NCA,$PERC,$S(NF+1),$GO)
  $ENDIF
  NRED=-NRED
$80 CONTINUE
  CALL UXVMUL(NCA,$D(NF+1),$GS(NF+1),$GS(NF+1),1)
  RPF2=RPF1
  $SUBST('UDSGID')
$90 CONTINUE
  CALL UOD1D2(NF,$G,$S)
  $ADD(INIT)
    NDXX='UDSGI4'
  $ENDADD
  $EXIT

