$INTERFACE UDSLC3                                             08/12/01
$REM LU

  $D='D'
  $XS='XS'
  $GS='GS'
  $XP='XP'
  $CON1='1.0$P-3'
  $CON2='5.0$P-1'
  $CON3='0.0$P 0'
  $CON4='1.0$P-1'
  $CON5='1.0$P-3'
  $CON6='1.0$P 6'
  $POM1='U'
  $POM2=',$$IX,-KBF)'
$REM  $POM1='V'
$REM  $POM2=')'
$REM  $HELP
$REM    MAXIMUM NUMBER OF DENSE COLUMNS:
$REM  $CHECK(MD,10,INT,2)
$REM  $HELP
$REM    MINIMUM NUMBER OF NONZERO ELEMENTS IN DENSE ROWS:
$REM  $CHECK(MDE,50,INT,2)
  $MD=0
  $HELP
    MAXIMUM NUMBER OF CG ITERATIONS
  $CHECK(MCGR,0,INT,3)
  $HELP
    STRATEGY FOR PRECISION DETERMINATION:
      1 - SINGLE STRATEGY
      2 - GEOMETRIC DECREASING STRATEGY
      3 - HARMONIC  DECREASING STRATEGY
  $CHECK(MOS,3,'1\2\3',3)
  $IF(MEP=0) $MOS1=0
  $HELP
    TERMINATION, MATRIX CORRECTION AND
    CHOICE OF THE PENALTY PARAMETER
      0 - CLASSIC TERMINATION
      1 - DESCENT TERMINATION
      2 - EXTENDED CHOICE OF THE PENALTY PARAMETER
  $CHECK(MOS1,0,'0\1\2',4)
  $HELP
    TYPE OF SMOOTHING
      0 - NO SMOOTHING
      1 - SINGLE SMOOTHING
  $CHECK(MOS3,0,'0\1',4)
  $HELP
    METHOD SELECTION:
      1 - BISECTION
      2 - TWO POINT QUADRATIC INTERPOLATION
      3 - THREE POINT QUADRATIC INTERPOLATION
      4 - THREE POINT CUBIC INTERPOLATION
  $CHECK(MES,1,'1\2\3\4',3)
  $IF(NOS2=3)
    $HELP
      PARAMETER FOR CONSTRUCTION OF PRECONDITIONER
    $CHECK(EPS5,'1.0$P-8',REAL,4)
  $ENDIF
  $DEFAULT='0.9$P 0'
  $IF (MOS=1) $DEFAULT='0.1$P 0'
  $HELP
    MINIMUM PRECISION OF AN INEXACT SOLUTION
  $CHECK(EPS6,DEFAULT,REAL,4)
  $HELP
    TOLERANCE FOR ACTIVE CONSTRAINTS
  $CHECK(EPS9,'1.0$P-1',REAL,4)
  $DEFAULT='ETA0*1.0$P-3'
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,DEFAULT,REAL,4)
  $HELP
    TOLERANCE FOR COMPUTING LOWER BOUDS FOR SLACKS
  $CHECK(ETA7,'0.0$P 0',REAL,4)
  $HELP
    UPPER BOUND FOR LAGRANGIAN FUNCTION
  $CHECK(TOLU,'1.0$P 30',REAL,4,NO)
  $IF(MOS3=0)
    $XS=GS
    $XP=S
  $ELSE
    CALL UXVCOP($N,$GS,$XS)
  $ENDIF
  $ADD(REAL,'\$CG($MC)\$CF($NC+1)\$CFD($NC+1)\$G($NF)\$S($NF+$NCA)&
  \$XO($NF+$NCA)\$GO($NF+$NCA)\$XS($NF+$NCA)\$GS($NF+$NCA)&
  \$XP($NF+$NCA)\$D($NF+2*$NCA)')
  $ADD(REAL,'\$X($NF)\$XL($NX)\$XU($NX)\$XSL($NX)\$XSU($NX)\$XZL($NX)&
  \$XZU($NX)\$CL($NC)\$CU($NC)\$CSL($NC)\$CSU($NC)\$CZL($NC)\$CZU($NC)')
  $ADD(INTEGER,'\$ID($NCA+1)\$JD(2*$NCA)\$ICG($NC+1)\$JCG($MC)\$IX($NX)&
  \$IC($NC)\$ICA($NCA)')
  $ADD(REAL,'\UXVDOT\UX$(POM1)DOT')
  $ADD(REAL,'\ALF\RHO\RHO1\RHO2\SIG\SIG1\SIG2\PTOL\STOL')
  $ADD(INTEGER,'\I\K\L\MM\MMX\NCA\IPOM\KPOM\NOS')
  $ADD(LOGICAL,'\L1')
$REM  $IF(MD>0)
$REM    $BD='BD'
$REM    $ADD(REAL,'\$BD($MD*($MD+1)/2)')
$REM  $ENDIF
  CALL UOD1D1
  $GRAD=G
  $IF(HERF='S')
    M=$IH($N+1)-1
  $ELSEIF(HERF='L')
    $ADD(INTEGER,'\MX')
    MX=MIN(NIT-KIT,MF)
  $ELSEIF(HERF='V')
    $GRAD=GN
    $SNS=SN
    $GAS=GA
    $XOS=XO
    $GCS=GC
    $GC=GP
  $ENDIF
  IPOM=0
  GNORM=SQRT(UX$(POM1)DOT($N,$G,$G$POM2)
  IF (GNORM.GT.$TOLU) THEN
  CALL UOERR1('UDSLC3',101)
  ITERM=-101
  TDXX='LARGE LF'
  GO TO $90
  ENDIF
  CALL UXVNEG($N,$G,$XS)
  CALL UCCSEC(NX,NC,NCA,$X,$IX,$XL,$XU,$XSL,$XSU,$XZL,$XZU,$CF,$IC&
,$CL,$CU,$CSL,$CSU,$CZL,$CZU,$ICA,$ICCA,$D($N+1),$ID,$JD,$GS($N+1)&
,RPF3,RPF4,SIG1)
  CALL UODLI3($N,NX,NC,NCA,$IX,$IC,$ICA,$XS,RPF2,RPF3,INF)
*
*     CONSTRUCTION OF THE CG PRECONDITIONER
*
  $LCI=$90
  $SUBST('UDSLCI')
  MM=$N+NCA
  RHO1=UX$(POM1)DOT($N,$XS,$XS$POM2
$REM  $IF (MOS4=1)
$REM    SIG1=UXVDOT(NCA,$XS($N+1),$XS($N+1))
$REM  $ELSEIF(MOS4=2)
  SIG1=MIN(SIG1,UXVDOT(NCA,$XS($N+1),$XS($N+1)))
$REM  $ENDIF
  INITD=MAX(ABS(INITD),1)
  PAR=MIN(EPS6,SQRT(RHO1+SIG1))
  IF (PAR.GT.TEN*$CON1) THEN
  $IF(MOS=1)
  $ELSEIF(MOS=2)
    PAR=MIN(PAR,$CON1**($DBLE(NIT-LIT)/$DBLE(MM)))
  $ELSEIF(MOS=3)
    PAR=MIN(PAR,ONE/$DBLE(NIT-LIT))
  $ENDIF
  ENDIF
  PAR=PAR*PAR
*
*     CG INITIATION
*
  CALL UXVSET(MM,ZERO,$S)
  $IF(MOS3=0)
  $ELSE
    CALL UXVSET(MM,ZERO,$XP)
    CALL UXVCOP(MM,$XS,$GS)
  $ENDIF
  $IF(NOS2=0)
    CALL UXVCOP(MM,$XS,$XO)
  $ENDIF
*
*     CG PRECONDITIONING
*
  $INPF=XS
  $OUTF=XO
  $SUBST('UDSLCP')
  RHO=UX$(POM1)DOT($N,$INPF,$OUTF$POM2
  SIG=UXVDOT(NCA,$INPF($N+1),$OUTF($N+1))
  KPOM=0
  MMX=MM+3
  IF(MCGR.GT.0) MMX=MIN(MMX,MCGR)
*
*     CG ITERATIONS
*
  DO $15 NRED=1,MMX
  IF (RHO+SIG.EQ.ZERO) THEN
  ITERD=-4
  TDXX='CG BREAK'
  CALL UOERR1('UDSLC3',4)
  GO TO $90
  ENDIF
  $IF(HERF='D')
    CALL UXDSMM($N,$H,$XO,$GO)
    CALL UCISMM($N,NX,NC,MC,$IX,$IC,$CG,$ICG,$JCG,$XO,$GO,$XSL,$XSU&
,$XZL,$XZU,$CSL,$CSU,$CZL,$CZU)
  $ELSEIF(HERF='S')
    CALL UXSSMM($N,M,$H,$IH,$JH,$XO,$GO)
  $ELSEIF(HERF='L')
    $IF(UPDATE='E')
      CALL UXLSMM($N,MX,$XM,$GM,$GR,$HR,$DR,$U1,$U2,$U3,$XO,$GO,PAR3&
,MET)
    $ELSE
      CALL UXLSMG($N,MX,$XM,$HR,$U1,$U3,$XO,$GO,PAR3,MET1)
    $ENDIF
    CALL UCISMM($N,NX,NC,MC,$IX,$IC,$CG,$ICG,$JCG,$XO,$GO,$XSL,$XSU&
,$XZL,$XZU,$CSL,$CSU,$CZL,$CZU)
  $ELSEIF(HERF='V')
    IF (IREST.NE.0) THEN
    CALL UXVCOP($N,$XO,$GO)
    GO TO $35
    ENDIF
    FO=F
    PP=SQRT(ETA0/UX$(POM1)DOT($N,$XO,$XO$POM2)
    $IF(MODP='FF')
      LD=MIN(KDF-1,0)
    $ELSE
      LD=MIN(KDA-1,0)
      $IF(MODEL='AF')
        LDA=LD
      $ELSE
        LDA=-1
      $ENDIF
      ISNAS=ISNA
      ISNA=0
    $ENDIF
    LDC=LD
    ISNCS=ISNC
    ISNC=0
    $SN=XO
    $XO=XV
    $SUBST('UYTR$(CONSTR)X')
    ASSIGN $30 TO IMD
    GO TO $LMD
$30 CONTINUE
    $IF(MODEL='AF')
      ISNA=ISNAS
    $ENDIF
    ISNC=ISNCS
    $XO=XOS
    $SN=SNS
    $GA=G
    $SUBST('UYTR$(CONSTR)A')
    CALL UXVDIF($N,$G,$GN,$GO)
    F=FO
    CALL UXVSCL($N,ONE/PP,$GO,$GO)
    $GA=GAS
$35 CONTINUE
    CALL UCISMM($N,NX,NC,MC,$IX,$IC,$CG,$ICG,$JCG,$XO,$GO,$XSL,$XSU&
,$XZL,$XZU,$CSL,$CSU,$CZL,$CZU)
  $ENDIF
  CALL UCICMD($N,NC,NCA,MC,$ICA,$CG,$ICG,$JCG,$XO($N+1),ONE,$GO,$GO)
$REM  CALL UXVMUL(NCA,$D($N+1),$XO($N+1),$GO($N+1),1)
  CALL UXSSMM(NCA,2*NCA,$D($N+1),$ID,$JD,$XO($N+1),$GO($N+1))
  CALL UCIRMD($N,NC,NCA,MC,$ICA,$CG,$ICG,$JCG,$XO,ONE,$GO($N+1)&
,$GO($N+1))
  ALF=UX$(POM1)DOT($N,$XO,$GO$POM2+UXVDOT(NCA,$XO($N+1),$GO($N+1))
  IF (ALF.EQ.ZERO) THEN
  ITERD=-5
  TDXX='CG BREAK'
  CALL UOERR1('UDSLC3',5)
  GO TO $90
  ENDIF
*
*     CG STEP
*
  ALF=(RHO+SIG)/ALF
  TDXX='CG  STEP'
  CALL UX$(POM1)DIR($N, ALF,$XO,$XP,$XP$POM2
  CALL UXVDIR(NCA, ALF,$XO($N+1),$XP($N+1),$XP($N+1))
  CALL UX$(POM1)DIR($N,-ALF,$GO,$XS,$XS$POM2
  CALL UXVDIR(NCA,-ALF,$GO($N+1),$XS($N+1),$XS($N+1))
*
*     CG SMOOTHING
*
  $IF(MOS3=0)
  $ELSE
    $ADD(REAL,'\BTR\BTB\RMU')
    RMU=ONE/ETA9
    CALL UX$(POM1)DIF($N,$GS,$XS,$GO$POM2
    CALL UXVDIF(NCA,$GS($N+1),$XS($N+1),$GO($N+1))
    BTB=UX$(POM1)DOT($N,$GO,$GO$POM2+UXVDOT(NCA,$GO($N+1),$GO($N+1))
    BTR=UX$(POM1)DOT($N,$GO,$XS$POM2+UXVDOT(NCA,$GO($N+1),$XS($N+1))
    RMU=-BTR/MAX(BTB,RMU)
    CALL UX$(POM1)DIR($N,RMU,$GO,$XS,$GS$POM2
    CALL UXVDIR(NCA,RMU,$GO($N+1),$XS($N+1),$GS($N+1))
    CALL UX$(POM1)DIF($N,$S,$XP,$GO$POM2
    CALL UXVDIF(NCA,$S($N+1),$XP($N+1),$GO($N+1))
    CALL UX$(POM1)DIR($N,RMU,$GO,$XP,$S$POM2
    CALL UXVDIR(NCA,RMU,$GO($N+1),$XP($N+1),$S($N+1))
  $ENDIF
  TDXX='CG  STEP'
*
*     TERMINATION CRITERION
*
  PTOL=PAR
  IF (NIT.EQ.KIT) PTOL=SQRT(ETA0)
  L1=NRED.GE.MMX
  IF (L1) TDXX='MAX ITER'
  SIG2=UXVDOT(NCA,$GS($N+1),$GS($N+1))
$REM  IF (SIG2.LE.PTOL*SIG1) THEN
  IF (SIG2.LE.PTOL*MAX(SIG1,PTOL)) THEN
  RHO2=UX$(POM1)DOT($N,$GS,$GS$POM2
$REM  IF (RHO2.LE.PTOL*RHO1) L1=.TRUE.
  IF (RHO2.LE.PTOL*MAX(RHO1,PTOL).AND.SIG2+RHO2.LE.PTOL*(RHO1+SIG1))&
  L1=.TRUE.
  ELSE IF (KOUT.GT.2) THEN
  RHO2=UX$(POM1)DOT($N,$GS,$GS$POM2
  ENDIF
*
*     TEST FOR DESCENT DIRECTION
*
  $LIT=$20
  $SUBST('UDSLIT')
*
*     CG PRECONDITIONING
*
  $INPF=XS
  $IF(MOS2=0)
    $OUTF=XS
  $ELSE
    $OUTF=GO
  $ENDIF
  $SUBST('UDSLCP')
  RHO2=UX$(POM1)DOT($N,$XS,$OUTF$POM2
  SIG2=UXVDOT(NCA,$XS($N+1),$OUTF($N+1))
  ALF=(RHO2+SIG2)/(RHO+SIG)
  CALL UX$(POM1)DIR($N,ALF,$XO,$OUTF,$XO$POM2
  CALL UXVDIR(NCA,ALF,$XO($N+1),$OUTF($N+1),$XO($N+1))
  RHO=RHO2
  SIG=SIG2
$15 CONTINUE
  TDXX='MAX ITER'
*
*     AN INEXACT SOLUTION IS OBTAINED
*
$20 CONTINUE
*
*     COMPUTATION OF THE DIRECTIONAL DERIVATIVE
*
  $SUBST('UDSLCD')
  CALL UODLI4($N,NX,NC,NCA,$D,$S($N+1),$XO($N+1),$GO($N+1),$GS($N+1))
$90 CONTINUE
  $IF(HERF='V')
    CALL UXVCOP($N,$XV,$X)
    CALL UXVCOP($N,$GN,$G)
    $GC=GCS
  $ENDIF
  R=ZERO
  CALL UXVSET(NX,ZERO,XO)
  CALL UOD1D2($N,$G,$S)
  $ADD(INIT)
    NDXX='UD$(HERF)LC3'
  $ENDADD
  $EXIT

