$INTERFACE UDSLK1                                             98/12/01
$REM LU

  $POM1='U'
  $POM2=',$$IX,KBF)'
  $HELP
    METHOD SELECTION:
      1 - BISECTION
      2 - TWO POINT QUADRATIC INTERPOLATION
      3 - THREE POINT QUADRATIC INTERPOLATION
      4 - THREE POINT CUBIC INTERPOLATION
  $CHECK(MES,1,'1\2\3\4',3)
  $IF(MEP=0)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'1.0$P-4',REAL,3)
  $ELSEIF(MEP=1)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'1.0$P 0',REAL,3)
    $ADD(SINIT)
      CALL UXVSET($NN,ZERO,$CP)
    $ENDADD
  $ELSEIF(MEP=2)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'1.0$P 0',REAL,3)
  $ELSEIF(MEP=3)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'1.0$P 0',REAL,3)
  $ELSEIF(MEP=4)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'1.0$P 0',REAL,3)
  $ELSEIF(MEP=5)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF1,'1.0$P 2',REAL,3)
  $ENDIF
  $ADD(REAL,'\$H($M)\$CG($MC)\$B($MMAX)\$CF($NC)\$G($NF)\$S($NF+$NC)&
  \$XO($NF+$NC)\$CZ($NC)')
  $ADD(INTEGER,'\$IH($NF+1)\$JH($M)\$ICG($NC+1)\$JCG($MC)\$KCG($MC)&
  \$IB($NF+$NC+1)\$JB($M+$MC+$NC)\$KB($M+$MC+$NC)\$IW($MMAX)&
  \$IW1(2*($NF+$NC))\$IW2(3*($NF+$NC))\$IX($NX)')
  $ADD(REAL,'\ALF\TEMP\UX$(POM1)DOT\UXWDOT')
  $ADD(INTEGER,'\K\L\NN\MM')
  $IF(MEP=1) $ADD(REAL,'\$CP($NC)')
  CALL UOD1D1
  CALL UXVCOP($N,$G,$GO)
  IF(IDECF.NE.0.AND.IDECF.NE.7) THEN
  ITERD=-1
  TDXX='BAD DEC7'
  CALL UOERR1('UDSLK1',1)
  GO TO $90
  ENDIF
  M=$IH($N+1)-1
  IF(IDECF.NE.7) THEN
  CALL UXSKIN($N,M,$H,$IH,$NN,MC,$CG,$JCG,$KCG,$B,$IB)
  NN=$N+$NN
  MM=IB(NN+1)-1
*
*     BUNCH-PARLETT DECOMPOSITION
*
  CALL UXSIBF(NN,MM,$KB,$JB,$B,MMAX,$IW,NZA,$IW1,$IW2,NAU,NUP,INF)
  IF (INF.LT.0) THEN
  TDXX='LACK SPC'
  ITERM=INF
  GO TO $90
  ENDIF
  NDECF=NDECF+1
  IDECF=7
  ENDIF
  CALL UXVNEG($N,$GO,$S)
  CALL UXVNEG($NN,$CF,$S($N+1))
  CALL UXSIBB(NN,$B,MMAX,$IW,NZA,$XO,$S,$IW1,NAU,NUP)
*
*     NEWTON LIKE STEP
*
  INITD=MAX(ABS(INITD),1)
  ITERD=1
  TDXX = 'B-P STEP'
  RPF2=RPF1
  GNORM=SQRT(UX$(POM1)DOT($N,$G,$G$POM2)
  SNORM=SQRT(UX$(POM1)DOT($N,$S,$S$POM2)
  P=UX$(POM1)DOT($N,$GO,$S$POM2
  $IF(MEP=0)
    DO $30 KC=1,$NN
    K=$ICG(KC)
    L=$ICG(KC+1)-K
    ALF=UXWDOT(L,$N,$JCG(K),$CG(K),$S,2)
    P=P+ALF*($S($N+KC)+RPF2*$CF(KC))
$30 CONTINUE
  $ELSEIF(MEP=1)
    TEMP=ZERO
    DO $30 KC=1,$NN
    $CP(KC)=$CZ(KC)+$S($N+KC)
    TEMP=TEMP+ABS($CF(KC)*$CP(KC))
    K=$ICG(KC)
    L=$ICG(KC+1)-K
    ALF=UXWDOT(L,$N,$JCG(K),$CG(K),$S,2)
    P=P-$CZ(KC)*ALF
$30 CONTINUE
    P=P-RPF2*TEMP
  $ELSEIF(MEP=2)
    DO $30 KC=1,$NN
    K=$ICG(KC)
    L=$ICG(KC+1)-K
    ALF=UXWDOT(L,$N,$JCG(K),$CG(K),$S,2)
    P=P+ALF*($S($N+KC)+RPF2*$CF(KC))
$30 CONTINUE
  $ELSEIF(MEP=3)
    TEMP=ZERO
    DO $30 KC=1,$NN
    TEMP=TEMP+ABS($CF(KC))
    K=$ICG(KC)
    L=$ICG(KC+1)-K
    ALF=UXWDOT(L,$N,$JCG(K),$CG(K),$S,2)
    P=P+$S($N+KC)*ALF
$30 CONTINUE
    P=P-RPF2*TEMP
  $ELSEIF(MEP=4)
    TEMP=ZERO
    DO $30 KC=1,$NN
    TEMP=TEMP+ABS($CF(KC))
    K=$ICG(KC)
    L=$ICG(KC+1)-K
    ALF=UXWDOT(L,$N,$JCG(K),$CG(K),$S,2)
    P=P-$CZ(KC)*ALF
$30 CONTINUE
    P=P-RPF2*TEMP
  $ELSEIF(MEP=5)
    DO $30 KC=1,$NN
    K=$ICG(KC)
    L=$ICG(KC+1)-K
    ALF=UXWDOT(L,$N,$JCG(K),$CG(K),$S,2)
    P=P-ALF*($S($N+KC)-RPF2*$CF(KC))
$30 CONTINUE
  $ENDIF
$90 CONTINUE
  CALL UOD1D2($N,$G,$S)
  $ADD(INIT)
    NDXX='UDSLK1'
  $ENDADD
  $EXIT
