$INTERFACE UDSLV3                                             97/12/01
$REM LU

  $CON0='1.0$P-8'
  $CON1='1.0$P-3'
  $CON2='0.85$P 0'
  $CON3='5.0$P-3'
  $CON4='0.5$P 0'
  $HELP
    STRATEGY FOR PRECISION DETERMINATION:
      1 - SINGLE STRATEGY
      2 - GEOMETRIC DECREASING STRATEGY
      3 - HARMONIC  DECREASING STRATEGY
  $CHECK(MOS,3,'1\2\3',3)
  $HELP
    SWITCH FOR THE HYBRID METHOD:
      1 - THE FLETCHER AND XU SWITCH
      2 - THE DENNIS AND WELSCH SWITCH
      3 - THE RAMSIN AND WEDIN SWITCH
  $CHECK(MOT2,1,'1\2\3',3)
  $HELP
    MINIMUM PRECISION OF AN INEXACT SOLUTION
  $CHECK(EPS6,'0.25$P 0',REAL,4)
  $ADD(REAL,'\$AG($MA)\$GN($NF)\$SN($NF)\$XO($NF)\$XS($NF)&
  \$GO($NF)\$GS($NF)\$AFO($NA)\$AFD($NA)')
  $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)\$IX($NX)')
  $ADD(REAL,'\UXVDOT')
  $ADD(REAL,'\RHO\RHO1\RHO2\SIG\ALF\PPJ\PPB')
  $ADD(INTEGER,'\IPOM\JPOM')
  $ADD(LOGICAL,'\L1')
  $POM1='U'
  $POM2=',$$IX,KBF)'
  $ADD(REAL,'\UX$(POM1)DOT')
  $N='NF'
  CALL UOD1D1
  IF (NIT.LE.LIT+1) THEN
  IPOM=0
  JPOM=0
  PPJ=ZERO
  PPB=ZERO
  ELSE
  $IF(MOT2=2)
    RHO=R*R
    PPJ=PPJ*RHO
    PPB=PPB*RHO
  $ENDIF
  ENDIF
*
*     DETERMINATION OF THE UPDATE VECTORS
*
  $IF(MOT2=3)
    L1=IPOM.EQ.1.OR.PPJ.LT.$CON3*FO.AND.PPJ.LT.$CON4*PPB
  $ELSEIF(MOT2=2)
    L1=.TRUE.
  $ELSE
    L1=FO-F.LE.ETA5*FO
  $ENDIF
  IPOM=0
  JPOM=0
  IF (ITERS.LE.0) GO TO $60
  IF (L1) THEN
  RHO1=UX$(POM1)DOT($N,$XO,$GO$POM2
  IF (RHO1.LE.ZERO) GO TO $60
  CALL UXSRMM($N,NA,MA,$AG,$IAG,$JAG,$XO,$AFD)
  RHO2=UXVDOT(NA,$AFD,$AFD)
  IF (RHO2.LE.ZERO) GO TO $60
  RHO1=SQRT(RHO1)
  RHO2=SQRT(RHO2)
  CALL UXVSCL(NA,ONE/RHO2,$AFD,$AFD)
  CALL UXSCMM($N,NA,MA,$AG,$IAG,$JAG,$AFD,$GS)
  CALL UX$(POM1)DIR($N,-ONE/RHO1,$GO,$GS,$GS$POM2
  CALL UXVNEG($N,$GS,$GS)
  $IF(MOT2=2)
    JPOM=1
    IF (PPB*PPJ.EQ.ZERO) GO TO $60
    IF (ABS((F-FO)/(PO+PPB)-ONE).LE.$CON2*ABS((F-FO)/(PO+PPJ)-ONE))&
    IPOM=1
  $ELSE
    IPOM=1
  $ENDIF
  ENDIF
$60 CONTINUE
  GNORM=SQRT(UX$(POM1)DOT($N,$GN,$GN$POM2)
  SNORM=ZERO
  INITD=MAX(ABS(INITD),1)
  PAR=MIN(EPS6,SQRT(GNORM))
  IF (PAR.GT.TEN*$CON1) THEN
  $IF(MOS=1)
  $ELSEIF(MOS=2)
    PAR=MIN(PAR,$CON1**(DBLE(NIT-LIT)/DBLE($N)))
  $ELSEIF(MOS=3)
    PAR=MIN(PAR,ONE/DBLE(NIT-LIT))
  $ENDIF
  ENDIF
  PAR=PAR*PAR
  CALL UXVSET($N,ZERO,$SN)
  CALL UXVNEG($N,$GN,$XS)
  CALL UXVNEG($N,$GN,$XO)
  RHO1=UX$(POM1)DOT($N,$XS,$XS$POM2
  RHO=RHO1
  SIG=RHO1
  DO $10 NRED=1,$N+3
  IF (IPOM.EQ.0) THEN
  CALL UXSRMM($N,NA,MA,$AG,$IAG,$JAG,$XO,$AFO)
  ELSE
  ALF=UX$(POM1)DOT($N,$GS,$XO$POM2
  CALL UXSRMD($N,NA,MA,$AG,$IAG,$JAG,$XO,ALF,$AFD,$AFO)
  ENDIF
  ALF=UXVDOT(NA,$AFO,$AFO)
  IF (ALF.LE.$CON0*SIG) THEN
*
*     CG FAILS (THE MATRIX IS NOT POSITIVE DEFINITE)
*
  CALL UOD1D5(ALF,SIG,INF)
  IF (NRED.EQ.1) THEN
  CALL UXVNEG($N,$GN,$SN)
  SNORM=GNORM
  ENDIF
  ITERD=0
  TDXX='CG  FAIL'
  GO TO $30
  ENDIF
*
*     CG STEP
*
  TDXX='CG  STEP'
  ALF=RHO/ALF
  CALL UX$(POM1)DIR($N,ALF,$XO,$SN,$SN$POM2
  IF (IPOM.EQ.0) THEN
  CALL UXSCMM($N,NA,MA,$AG,$IAG,$JAG,$AFO,$GO)
  ELSE
  RHO2=UXVDOT(NA,$AFD,$AFO)
  CALL UXSCMD($N,NA,MA,$AG,$IAG,$JAG,$AFO,RHO2,$GS,$GO)
  ENDIF
  CALL UX$(POM1)DIR($N,-ALF,$GO,$XS,$XS$POM2
  RHO2=UX$(POM1)DOT($N,$XS,$XS$POM2
  SNORM=SQRT(UX$(POM1)DOT($N,$SN,$SN$POM2)
  CALL UOD1D4(RHO1,RHO2,PAR,SNORM,XDEL)
  IF (RHO2 .LE. PAR*RHO1) GO TO $20
  ALF=RHO2/RHO
  CALL UX$(POM1)DIR($N,ALF,$XO,$XS,$XO$POM2
  RHO=RHO2
  SIG=RHO2+ALF*ALF*SIG
$10 CONTINUE
  TDXX='MAX ITER'
*
*     AN INEXACT SOLUTION IS OBTAINED
*
$20 CONTINUE
  ITERD=2
$30 CONTINUE
  $IF(MOT2>1)
    RHO=PPJ
    CALL UXSRMM($N,NA,MA,$AG,$IAG,$JAG,$SN,$AFO)
    PPJ=UXVDOT(NA,$AFO,$AFO)*HALF
    PPB=ZERO
  $ENDIF
  IF (JPOM.NE.0) THEN
  ALF=UX$(POM1)DOT($N,$GS,$SN$POM2
  CALL UXVDIR(NA,ALF,$AFD,$AFO,$AFO)
  PPB=UXVDOT(NA,$AFO,$AFO)*HALF
  ENDIF
  $IF(MOT2=3)
    PPB=RHO
  $ENDIF
  CALL UOD1D2($N,$GN,$SN)
  $ADD(INIT)
    NDXX='UDSLV3'
  $ENDADD
  $EXIT

