$INTERFACE UDVLC2                                             97/12/01
$REM LU

  $CON0='1.0$P-8'
  $CON1='0.59$P 0'
  $CON2='1.32$P 0'
  $CON3='4.8$P 0'
  $HELP
    MODIFICATION OF THE CG METHOD
      1 - BASIC CG METHOD
      2 - CG METHOD WITH POSITIVE PARAMETER
      3 - CG METHOD WITH BOUNDED POSITIVE PARAMETER
      4 - MODIFIED CG METHOD WITH AUTOMATIC RESTART
      5 - MODIFIED CG METHOD WITH BOUNDED PARAMETER
      6 - CG METHOD WITH POWELL'S RESTART
  $CHECK(MET1,4,'1\2\3\4\5\6',4)
  $HELP
    TERMINATION CRITERION:
      1-PERFECT LINE SEARCH
      2-GOLDSTEIN STEPSIZE
      3-WEAK WOLFE STEPSIZE
      4-STRONG WOLFE STEPSIZE
      5-ARMIJO STEPSIZE
  $CHECK(KTERS,4,'1\2\3\4\5',4)
  $DEFAULT=1
  $IF(MET1>3) $DEFAULT=12
  $HELP
    RESTART SPECIFICATION. RESTART IS PERFORMED AFTER
    IRES1*N+IRES2 ITERATIONS.
  $CHECK(IRES1,DEFAULT,INT,4)
  $DEFAULT=1
  $IF(MET1>3) $DEFAULT=0
  $HELP
    RESTART SPECIFICATION. RESTART IS PERFORMED AFTER
    IRES1*N+IRES2 ITERATIONS.
  $CHECK(IRES2,DEFAULT,INT,4)
  $HELP
    TERMINATION TOLERANCE FOR LINE SEARCH
    (IN TEST ON THE CHANGE OF THE DIRECTIONAL DERIVATIVE)
  $CHECK(EPS2,'1.0$P-1',REAL,4)
  $ADD(REAL,'\$X($NF)\$GN($NF)\$SN($NF)\$XO($NF)\$GO($NF)\$SO($NF)')
  $ADD(REAL,'\UXVDOT')
  $ADD(REAL,'\ALF\BET\GAM\DEL\POM')
$REM  $N='N'
  CALL UXVCOP(NF,$GN,$SO)
  IF (NIT-LIT.LE.1) POM=TEN**(-$CON3/$DBLE($N+1))
  CALL UOD0D1(R,GNORM)
  ALF=GNORM*GNORM
  BET=UXVDOT($N,$GN,$GN)
  GNORM=SQRT(BET)
  INITD=MAX(ABS(INITD),1)
  IF (IREST.NE.0) GO TO $50
*
*     CG STEP
*
  FO=F
  CALL UXVCOP($N,$X,$SN)
  CALL UXVDIR($N,-P/BET,$GN,$XO,$XO)
  DEL=SQRT(ETA0/UXVDOT($N,$XO,$XO))
  CALL UXVDIR($N,DEL,$XO,$X,$X)
  LD=0
  ASSIGN $30 TO IMD
  GO TO $LMD
$30 CONTINUE
  CALL UXVCOP($N,$SN,$X)
  $GNS=GN
  $GN=GO
  $SUBST('UYTR$(CONSTR)G')
  $GN=GNS
  FO=F
  DEL=-UXVDOT($N,$XO,$GO)
  CALL UXVDIF($N,$GN,$GO,$GO)
  GAM=UXVDOT($N,$GN,$GO)/DEL
  TUXX='STOREY  '
  $IF(MET1=1)
    TDXX='BASIC CG'
  $ELSEIF(MET1=2)
    TDXX='POSIT CG'
    IF (GAM.LE.ZERO) THEN
    CALL UYRES1('NEGAT P.')
    GO TO $50
    ENDIF
  $ELSEIF(MET1=3)
    TDXX='BOUND CG'
    IF (GAM.LT.ZERO) THEN
    CALL UYRES1('NEGAT P.')
    GO TO $50
    ENDIF
    BET=(BET/ALF)/R
    IF (GAM.GT.$CON2*BET) THEN
    CALL UYRES1('LARGE P.')
    GO TO $50
    ENDIF
  $ELSEIF(MET1=4)
    TDXX='MODIF CG'
    IF ($CON0*BET.GT.POM**(NIT-KIT)) THEN
    CALL UYRES1('STOREY  ')
    GO TO $50
    ENDIF
    IF (GAM.LT.ZERO) THEN
    CALL UYRES1('NEGAT P.')
    GO TO $50
    ENDIF
    BET=(BET/ALF)/R
    IF (GAM.GT.$CON2*BET) THEN
    CALL UYRES1('LARGE P.')
    GO TO $50
    ENDIF
  $ELSEIF(MET1=5)
    TDXX='REST1 CG'
    BET=(BET/ALF)/R
    IF (GAM.GT.$CON2*BET) THEN
    CALL UYRES1('LARGE P.')
    GO TO $50
    ENDIF
    IF (GAM.LT.$CON1*BET) THEN
    CALL UYRES1('SMALL P.')
    GO TO $50
    ENDIF
  $ELSEIF(MET1=6)
    TDXX='REST2 CG'
    BET=(BET/ALF)/R
    IF (FIVE*ABS(GAM-BET).GT.BET) THEN
    CALL UYRES1('POWELL  ')
    GO TO $50
    ENDIF
  $ENDIF
  CALL UXVDIR($N,-GAM,$XO,$GN,$SN)
  CALL UXVNEG($N,$SN,$SN)
  SNORM=DSQRT(UXVDOT($N,$SN,$SN))
$50 CONTINUE
  ITERD=0
  IF(IREST.NE.0) THEN
*
*     STEEPEST DESCENT DIRECTION
*
  CALL UXVNEG($N,$GN,$SN)
  SNORM=GNORM
  TUXX='INITIAL '
  TDXX='ST.DESC.'
  CALL UYSET3
  ENDIF
  CALL UOD1D2($N,$GN,$SN)
  CALL UXVCOP($N,$SO,$GN)
  $ADD(INIT)
    NDXX='UDVLC2'
  $ENDADD
  $EXIT
