$INTERFACE UE0DF1                                             98/12/01

      $SUBST('UZESET')
 $ADD(REAL,'\$EF($MEL)')
$REM $ADD(INTEGER,'\NE\MEL\KE')
$REM $ADD(REAL,'\FE\FA')
 $00  CALL UE0DF1(NE,MEL,KE,$EF,FE,FA)
      GO TO ($30,$10,$20) ISB+1
 $10  CONTINUE
      $IF(MODELA='YES')
        $MTYPE=FMODA
        $SUBST('UZAMOD')
      $ENDIF
      $GO TO $00
 $20  CONTINUE
      $IF(LED<0)
        $MTYPE=FMODE
        $SUBST('UZEMOD')
      $ELSE
        FE=$EF(KE)
      $ENDIF
      GOTO $00
 $30  CONTINUE
      $ADD(INIT)
        NEXX='UE0DF1'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UE0DF1             ALL SYSTEMS                 98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE AND THE GRADIENT OF THE OBJECTIVE FUNCTION
* WHICH IS DEFINED AS A SUM OF SQUARES.
*
* PARAMETERS:
*  II  NE  DECLARED NUMBER OF DIFFERENTIAL EQUATIONS.
*  II  MEL  ACTUAL NUMBER OF DIFFERENTIAL EQUATIONS.
*  IU  KE  INDEX OF THE DIFFERENTIAL EQUATION.
*  RO  EF(MEL)  RIGHT HAND SIDE VECTOR.
*  RI  FE  VALUE OF THE RIGHT HAND SIDE FUNCTION.
*
* COMMON DATA :
*  II  KDA  ORDER OF ANALYTICALLY COMPUTED DERIVATIVES.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S  UYPRO1  PROLOGUE.
*  S  UYEPI1  EPILOGUE.
*  S  UYSET0  STATUS DEFINITION.
*
      SUBROUTINE UE0DF1(NE,MEL,KE,EF,FE,FA)
      $INCLUDE ('UMCOMM')
      INTEGER NE,MEL,KE
      $FLOAT EF(MEL),FE,FA
      IF (TSS(NS).NE.'UEXX') CALL UYPRO1('UEXX',-1)
      GO TO (1,2,5) ISP(NS)
    1 CONTINUE
      IF (KDA.LT.0) GO TO 3
      CALL UYSET0(1,2)
      RETURN
    2 CONTINUE
      EF(NE+1)=FA
    3 KE=1
    4 IF (KE.GT.NE) GO TO 6
      CALL UYSET0(2,3)
      RETURN
    5 CONTINUE
      EF(KE)=FE
      KE=KE+1
      GO TO 4
    6 CALL UYEPI1(-1)
      RETURN
      END
