$INTERFACE UE1DF2                                             98/12/01

      $SUBST('UZESET')
 $ADD(REAL,'\$GA($NF)\$GE($NF)\$DA($NE)\$DE($NE)\$YA($MEL)\$EF($MEL)')
$REM $ADD(INTEGER,'\NF\NE\MEL\KE')
$REM $ADD(REAL,'\FE\FA')
 $00  CALL UE1DF2(NF,NE,MEL,KE,$GA,$GE,$DA,$DE,$YA,$EF,FE,FA)
      GO TO ($30,$10,$20) ISB+1
 $10  CONTINUE
      $IF(MODELA='YES')
        $MTYPE=FMODA
        $SUBST('UZAMOD')
        IF (KD.LE.0) GO TO $00
        $IF(GMODA='G')
          $MTYPE=GMODA
          $SUBST('UZAMOD')
        $ENDIF
        $IF(DMODA='D')
          $MTYPE=DMODA
          $SUBST('UZAMOD')
        $ENDIF
        $IF(GMODA='GD')
          $MTYPE=GMODA
          $SUBST('UZAMOD')
        $ENDIF
      $ENDIF
      $GO TO $00
 $20  CONTINUE
      $IF(LED<0)
        $MTYPE=FMODE
        $SUBST('UZEMOD')
      $ELSE
        FE=$EF(KE)
      $ENDIF
      IF (KD.LE.0) GO TO $00
      $IF(LED<1)
        $IF(GMODE='G')
          $MTYPE=GMODE
          $SUBST('UZEMOD')
        $ENDIF
        $IF(DMODE='D')
          $MTYPE=DMODE
          $SUBST('UZEMOD')
        $ENDIF
        $IF(GMODE='GD')
          $MTYPE=GMODE
          $SUBST('UZEMOD')
        $ENDIF
      $ELSE
        CALL UXVCOP(NF,$EG((KE-1)*NF+1),$GE)
        CALL UXVCOP(NE,$ED((KE-1)*NE+1),$DE)
      $ENDIF
      $GO TO $00
 $30  CONTINUE
      $ADD(INIT)
        NEXX='UE1DF2'
      $ENDADD
      $EXIT

* IMPLEMENTATION

* SUBROUTINE UE1DF2             ALL SYSTEMS                 98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE VALUE AND THE GRADIENT OF THE OBJECTIVE FUNCTION
* WHICH IS DEFINED AS A SUM OF SQUARES.
*
* PARAMETERS:
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  NE  DECLARED NUMBER OF DIFFERENTIAL EQUATIONS.
*  II  MEL  ACTUAL NUMBER OF DIFFERENTIAL EQUATIONS.
*  IU  KE  INDEX OF THE DIFFERENTIAL EQUATION.
*  RU  GA(NF)  GRADIENT OF THE APPROXIMATED FUNCTION.
*  RU  GE(NF)  GRADIENT OF THE RIGHT HAND SIDE FUNCTION.
*  RU  DA(NF)  DERIVATIVES OF THE APPROXIMATED FUNCTION.
*  RU  DE(NF)  DERIVATIVES OF THE RIGHT HAND SIDE FUNCTION.
*  RI  YA(MEL)  SOLUTION VECTOR.
*  RO  EF(MEL)  RIGHT HAND SIDE VECTOR.
*  RI  FE  VALUE OF THE RIGHT HAND SIDE FUNCTION.
*  RI  FA  VALUE OF THE APPROXIMATED.
*
* COMMON DATA :
*  II  KD  ORDER OF REQUIRED DERIVATIVES.
*  II  KDA  ORDER OF ANALYTICALLY COMPUTED DERIVATIVES.
*  II  KDE  ORDER OF ANALYTICALLY COMPUTED DERIVATIVES.
*
* STATUS VARIABLES :
*  NS,ISP,TSS
*
* SUBPROGRAMS USED :
*  S  UYPRO1  PROLOGUE.
*  S  UYEPI1  EPILOGUE.
*  S  UYSET0  STATUS DEFINITION.
*  S  UXVCOP  COPYING OF A VECTOR.
*  S  UXVDIR  VECTOR AUGMENTED BY THE SCALED VECTOR.
*  S  UXVSET  INITIATION OF A VECTOR.
*
      SUBROUTINE UE1DF2(NF,NE,MEL,KE,GA,GE,DA,DE,YA,EF,FE,FA)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NE,MEL,KE
      $FLOAT GA(NF),GE(NF),DA(NE),DE(NE),YA(MEL),EF(MEL),FE,FA
      IF (TSS(NS).NE.'UEXX') CALL UYPRO1('UEXX',-1)
      GO TO (1,2,5) ISP(NS)
    1 CONTINUE
      IF (KDA.LT.0) THEN
      CALL UXVSET(NE,ZERO,EF(NE+1))
      IF (KD.GT.0) CALL UXVSET(NF,ZERO,EF(2*NE+1))
      GO TO 3
      ENDIF
      CALL UYSET0(1,2)
      RETURN
    2 CONTINUE
      IF (KD.GT.0) THEN
      CALL UXVCOP(NE,DA,EF(NE+1))
      IF (KDA.LE.0) THEN
      CALL UXVSET(NF,ZERO,EF(2*NE+1))
      ELSE
      CALL UXVCOP(NF,GA,EF(2*NE+1))
      ENDIF
      ELSE
      EF(NE+1)=FA
      ENDIF
    3 KE=1
    4 IF (KE.GT.NE) GO TO 6
      CALL UYSET0(2,3)
      RETURN
    5 CONTINUE
      IF (KD.GT.0) THEN
      CALL UXVDIR(NE,-YA(NE+KE),DE,EF(NE+1),EF(NE+1))
      IF (KDE.GT.0) CALL UXVDIR(NE,-YA(NE+KE),GE,EF(2*NE+1),EF(2*NE+1))
      ENDIF
      EF(KE)=FE
      KE=KE+1
      GO TO 4
    6 CALL UYEPI1(-1)
      RETURN
      END
