* SUBROUTINE UKLART                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* ARTIFICIALS ARE ADDED.
* PART OF THE OBJECTIVE FUNCTION CORRESPONDING TO ARTIFICIALS IS SET UP.
*
* PARAMETERS :
*  II  MCOLS MAXIMUM NUMBER OF COLUMNS.
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  II  M  ACTUAL NUMBER OF CONSTRAINTS.
*  II  NZA  NUMBER OF NONZERO ELEMENTS OF THE MATRIX OF CONSTRAINTS A.
*  II  RNR(NZA) ROW INDICES OF CONSTRAINT MATRIX.
*  II  PRNR(MCOLS+1) POINTER VECTOR TO RNR.
*  RI  A(NZA) NUMERICAL VALUES OF THE CONSTRAINT MATRIX
*             CORRESPONDING TO RNR.
*  IA  WN01(N) AUXILIARY VECTOR.
*  RI  LB(N) LOWER BOUNDS ON VARIABLES.
*  RI  UB(N) LOWER BOUNDS ON VARIABLES.
*  IU  TYPE(N) TYPE OF THE VARIABLES:
*                                    =1 FOR NONBASIC LOWER BOUNDED
*                                    =2 FOR NONBASIC UPPER BOUNDED
*                                    =3 FOR NONBASIC LOWER AND UPPER
*                     BOUNDED VARIABLE SET TO ITS LOWER BOUND
*                                    =4 FOR NONBASIC LOWER AND UPPER
*                     BOUNDED VARIABLE SET TO ITS UPPER BOUND
*                                    =5 FOR NONBASIC FIXED VARIABLE
*                                    =6 FOR NONBASIC FREE VARIABLE
*                                    =-1 FOR BASIC LOWER BOUNDED
*                                    =-2 FOR BASIC UPPER BOUNDED
*                                    =-3 FOR BASIC LOWER AND UPPER
*                     BOUNDED VARIABLE
*                                    =-6 FOR BASIC FREE VARIABLE.
*  IU  BCOL(N) COLUMNS OF THE BASIS.
*  IO  C(N) OBJECTIVE FUNCTION.
*  II  MINP NUMBER OF SLACKS.
*  II  LINP NUMBER OF BASICS DETERMINED SO FAR.
*

      SUBROUTINE UKLART(MCOLS,NF,N,M,NZA,RNR,PRNR,A,WN01,LB,UB,TYPE,
     & BCOL,C,LINP,MINP)
      INTEGER MCOLS,NF,N,M,NZA,RNR(NZA),PRNR(MCOLS+1),WN01(MCOLS),
     & TYPE(MCOLS),BCOL(MCOLS),LINP,MINP
      $FLOAT A(NZA),LB(MCOLS),C(MCOLS),UB(MCOLS)
      INTEGER I,J,K
C
C ARTIFICIAL VARIABLES ARE INTRODUCED
C
      N=NF+MINP
      K=PRNR(N+1)
      DO 100 I=1,M
      J=WN01(I)
      IF(J.LE.0) THEN
         N=N+1
         A(K)=1.0$P 0
         RNR(K)=I
         K=K+1
         TYPE(N)=-3
         LB(N)=0.0$P 0
         UB(N)=0.0$P 0
         C(N)=1.0$P 0
         PRNR(N+1)=K
         LINP=LINP+1
         BCOL(LINP)=N
      ELSE
         TYPE(J)=-TYPE(J)
         IF(TYPE(J).EQ.-4) TYPE(J)=-3
      END IF
  100 CONTINUE
      RETURN
      END
