* SUBROUTINE UKLBAS                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* SET OF BASIC VARIABLES IS PARTIALLY DETERMINED
*
* PARAMETERS :
*  II  MCOLS MAXIMUM NUMBER OF COLUMNS.
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  M  ACTUAL NUMBER OF CONSTRAINTS.
*  II  NZA  NUMBER OF NONZERO ELEMENTS OF THE MATRIX OF CONSTRAINTS A.
*  II  RNR(NZA) ROW INDICES OF CONSTRAINT MATRIX.
*  II  PRNR(MCOLS+1) POINTER VECTOR TO RNR.
*  RI  A(NZA) NUMERICAL VALUES OF THE CONSTRAINT MATRIX
*             CORRESPONDING TO RNR.
*  IA  WN01(MCOLS) AUXILIARY VECTOR.
*  II  TYPE(MCOLS) TYPES OF THE VARIABLES:
*                                     =1 FOR LOWER BOUNDED VARIABLE.
*                                     =2 FOR UPPER BOUNDED VARIABLE.
*                                     =3 FOR LOWER AND UPPER BOUNDED
*                                        VARIABLE.
*                                     =6 FOR FREE VARIABLES.
*  IU  BCOL(MCOLS) VECTOR PARTIALLY FILLED BY THE INDICES OF THE INITIAL
*              BASIS.
*  RI  DEL1  MULTIPLIER BOUND FOR PIVOT LOOK-UP.
*  RI  DEL2  RELATIVE BOUND FOR NEGLECTING SMALL ELEMENTS WHEN
*            CONSTRUCTING INITIAL BASIS.
*  II  MLP PARAMETER CONTROLLING NUMBER OF COLUMNS TO BE TESTED
*             ON INPUT INTO THE INITIAL BASIS:
*             =2 WHEN BASIS IS TO INCLUDE ONLY SLACKS AND ARTIFICIALS,
*             =3 WHEN VARIABLES OF NONLINEAR CONSTRAINTS ARE TO BE
*             EXCLUDED, =4 WHEN VARIABLES NONLINER IN OBJECTIVE FUNCTION
*             ARE TO BE EXCLUDED.
*  IO  KINP NUMBER OF ARTIFICIALS.
*  IU  LINP NUMBER OF BASICS DETERMINED SO FAR.
*  II  MINP NUMBER OF SLACKS.
*
      SUBROUTINE UKLBAS(MCOLS,NF,M,NZA,RNR,PRNR,A,WN01,TYPE,BCOL,
     & DEL1,DEL2,MLP,KINP,LINP,MINP)
      INTEGER MCOLS,NF,M,NZA,RNR(NZA),PRNR(MCOLS+1),WN01(MCOLS),
     & TYPE(MCOLS),BCOL(MCOLS),MLP,KINP,LINP,MINP
      $FLOAT A(NZA),DEL1,DEL2
      INTEGER IR,JSTRT,JSTOP,ISTRT,IEND,I,J,K,KINR,IBSTM,IBSTNM
      INTEGER NCNFL,NNLC,NNLO
      $FLOAT AMAXM,AMAXNM,TEMP,BMAX,AGLOB
      LOGICAL LPASS2
C
      KINP=0
      DO 100 I=1,M
      WN01(I)=0
  100 CONTINUE
C
C SET BEGINNING AND END OF THE SECTION IN VECTOR OF VARIABLES
C
      IEND=NF+MINP
C
C MLP STATUS - VARIABLES NNLC, NNLO WILL BE USED IN NLP
C
      NNLC=-1
      NNLO=-1
      IF(MLP.EQ.2) THEN
         ISTRT=IEND+1
      ELSEIF(MLP.EQ.3) THEN
         ISTRT=NNLC+1
      ELSEIF(MLP.EQ.4) THEN
         ISTRT=NNLO+1
      ELSE
         ISTRT=1
      END IF
C
C BASE FILLED ( IN CASE MFP1 > 0 )
C
      IF(LINP.GE.M) GO TO 600
C
C INTRODUCE SLACKS FIRST
C
      DO 200 I=NF+1,IEND
      LINP=LINP+1
      BCOL(LINP)=I
      WN01(RNR(PRNR(I)))=I
  200 CONTINUE
C
C LOOK FOR THE FREE STRUCTURALS
C
      LPASS2=.FALSE.
  250 DO 500 I=ISTRT,NF
      IF(TYPE(I).EQ.5) GO TO 500
      IF(.NOT.LPASS2) THEN
         IF(TYPE(I).NE.6) GO TO 500
      END IF
      AMAXM=0
      AMAXNM=0
      TEMP=0
      IBSTM=0
      IBSTNM=0
      NCNFL=0
      BMAX=0
      JSTRT=PRNR(I)
      JSTOP=PRNR(I+1)-1
      DO 300 J=JSTRT,JSTOP
         TEMP=ABS(A(J))
         IR=RNR(J)
         IF(WN01(IR).GT.0) THEN
            BMAX=MAX(BMAX,TEMP)
            NCNFL=NCNFL+1
            GO TO 300
         ELSEIF(WN01(IR).LT.0) THEN
            IF(AMAXNM.LT.TEMP) THEN
               AMAXNM=TEMP
               IBSTNM=IR
            ENDIF
         ELSE
            IF(AMAXM.LT.TEMP) THEN
               AMAXM=TEMP
               IBSTM=IR
            END IF
         END IF
  300 CONTINUE
C
C INTERPRETE COLUMN
C
      IF(IBSTM.EQ.0) THEN
         IF(BMAX.GE.DEL1) GO TO 500
         IF(IBSTNM.EQ.0) GO TO 500
         WN01(IBSTNM)=I
         LINP=LINP+1
         BCOL(LINP)=I
      ELSE
         AGLOB=MAX(AMAXM,AMAXNM)
         IF(AMAXM.LT.DEL2*AGLOB) GO TO 500
         WN01(IBSTM)=I
         LINP=LINP+1
         BCOL(LINP)=I
      END IF
      DO 400 K=JSTRT,JSTOP
      KINR=RNR(K)
      IF(WN01(KINR).EQ.0) WN01(KINR)=-1
  400 CONTINUE
  500 CONTINUE
      IF(.NOT.LPASS2) THEN
         LPASS2=.TRUE.
         GO TO 250
      END IF
  600 CONTINUE
C
C SET NUMBER OF ARTIFICIAL VARIABLES
C
      KINP=M-LINP
      RETURN
      END
