* SUBROUTINE UKLTS3                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* INITIAL STRUCTURE SHRINKING PERMUTATION VECTORS ARE FOUND
*
* PARAMETERS :
*  IU  NF INPUT NUMBER OF COLUMNS.
*  IU  NC INPUT NUMBER OF CONSTRAINTS.
*  II  MROWS DECLARED NUMBER OF ROWS.
*  II  MCOLS DECLARED NUMBER OF COLUMNS.
*  II  NZ  SIZE OF ARRAYS INR/CNR.
*  II  NAU SIZE OF ARRAUS AI/AU.
*  II  LENR(MROWS) LENGTHS OF THE ROWS OF THE INPUT STRUCTURE INR/AI.
*  IU  TYPE(MCOLS) TYPES OF THE VARIABLES:
*                                     =1 FOR LOWER BOUNDED VARIABLE.
*                                     =2 FOR UPPER BOUNDED VARIABLE.
*                                     =3 FOR LOWER AND UPPER BOUNDED
*                                        VARIABLE.
*                                     =5 FOR FIXED VARIABLES.
*                                     =6 FOR FREE VARIABLES.
*  RU  LB(MCOLS) LOWER BOUNDS ON VARIABLES.
*  RU  UB(MCOLS) UPPER BOUNDS ON VARIABLES.
*  IU  TYPC(MROWS) TYPES OF THE MATRIX ROWS:
*                                     =1 FOR LOWER BOUNDED ROW.
*                                     =2 FOR UPPER BOUNDED ROW.
*                                     =3 FOR LOWER AND UPPER BOUNDED ROW
*                                        WITH NON-EQUAL BOUNDS.
*                                     =5 FOR LOWER AND UPPER BOUNDED ROW
*                                        WITH EQUAL BOUNDS.
*  RU  LBC(MROWS) LOWER BOUNDS ON MATRIX ROWS.
*  RU  UBC(MROWS) UPPER BOUNDS ON MATRIX ROWS.
*  II  PERMR(MROWS) INPUT ROW PERMUTATION VECTOR.
*  II  IPRMC(MCOLS) INPUT COLUMN INVERSE PERMUTATION VECTOR.
*  IO  IER OUTPUT ERROR FLAG
*
      SUBROUTINE UKLTS3(NF,NC,MROWS,MCOLS,LENR,TYPE,LB,UB,C,TYPC,LBC,
     & UBC,PERMR,IPRMC,IER)
      INTEGER NF,NC,MROWS,MCOLS,LENR(MROWS),
     & TYPE(MCOLS),TYPC(MROWS),PERMR(MROWS),
     & IPRMC(MCOLS),IER
      $FLOAT LB(MCOLS),UB(MCOLS),C(MCOLS),LBC(MROWS),UBC(MROWS)
      INTEGER I,K
      IER=0
C
C SET PERMR
C
      DO 160 I=1,NC
        PERMR(I)=0
  160 CONTINUE
C
      K=0
      DO 100 I=1,NC
C
C ROWS OF TYPE ZERO ARE NOT RECOGNIZED
C
         IF(TYPC(I).EQ.0) LENR(I)=0
C
C TYPC NOT DEFINED
C
         IF(LENR(I).NE.0) THEN
            IF(TYPC(I).LT.0.OR.TYPC(I).GT.5.OR.TYPC(I).EQ.3.AND
     *         .LBC(I).GT.UBC(I)) THEN
               IER=17
               RETURN
            END IF
            K=K+1
            PERMR(K)=I
            LBC(K)=LBC(I)
            UBC(K)=UBC(I)
            TYPC(K)=TYPC(I)
         END IF
         IF(TYPC(K).EQ.3.AND.LBC(K).EQ.UBC(K)) TYPC(K)=5
  100 CONTINUE
C
C SET NC
C
      NC=K
C
C CASE : NO ROWS SPECIFIED
C
      IF(NC.EQ.0) THEN
         IER=14
         RETURN
      END IF
C
C ZERO WN01
C
      DO 150 I=1,NF
      IPRMC(I)=0
C      PRMC(I)=0
  150 CONTINUE
C
C SET IPRMC
C
      K=0
      DO 400 I=1,NF
        K=K+1
        IPRMC(I)=K
C        PRMC(K)=I
        IF(TYPE(I).EQ.5) THEN
           TYPE(K)=5
           LB(K)=LB(I)
           UB(K)=LB(I)
           C(K)=C(I)
        ELSEIF(TYPE(I).EQ.0) THEN
C
C DEFAULT TYPE SETTING IS GIVEN BY UKLINM
C ZERO TYPE IS THE SECOND ALTERNATIVE FOR UNBOUNDED VARIABLES
C
           TYPE(K)=6
C
C NO TYPE SPECIFIED
C
        ELSEIF(TYPE(I).LT.0.OR.TYPE(I).GT.6) THEN
           IER=16
           RETURN
        ELSE
           TYPE(K)=TYPE(I)
           LB(K)=LB(I)
           UB(K)=UB(I)
           C(K)=C(I)
           IF(TYPE(K).EQ.3.AND.LB(K).EQ.UB(K)) TYPE(K)=5
        END IF
  400 CONTINUE
C
C SET NF
C
      NF=K
C
C CASE: NO COLUMNS WITH NONZEROS SPECIFIED
C
      IF(NF.EQ.0) THEN
         IER=15
         RETURN
      END IF
      RETURN
      END
