* SUBROUTINE UKMCI1                 ALL SYSTEMS                98/06/01
C PORTABILITY : ALL SYSTEMS
C 98/06/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  INPUT OF THE JACOBIAN MATRIX ELEMENT AG(KA,I)
*
* PARAMETERS :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  II  NC  NUMBER OF CONSTRAINTS.
*  IU  ICG(NC+1) VECTOR POINTING AT BEGINNINGS OF THE JACOBIAN MATRIX
*         ROWS.
*  IU  JCG(MC) JACOBIAN MATRIX COLUMN INDICES.
*  RU  CG(MC) JACOBIAN MATRIX VALUES.
*  II  JOB  OPTION. JOB=0-NUMERICAL VALUE IS NOT INSERTED.
*  IO  IER OUTPUT ERROR INFORMATION.
*  II  K  INPUT ROW INDEX.
*  II  I  INPUT COLUMN INDEX.
*  RI  VAL  INPUT NUMERICAL VALUE.
*
      SUBROUTINE UKMCI1(NF,NC,ICG,JCG,CG,JOB,IER,K,I,VAL)
      INTEGER NF,NC,ICG(NC+1),JCG(*),JOB,IER,K,I
      $FLOAT CG(*),VAL
      INTEGER J,L
      IER=0
      IF (I.LE.0.OR.I.GT.NF) IER=2
      IF (K.LE.0.OR.K.GT.NC) IER=3
      IF (IER.NE.0) RETURN
      L=ICG(K+1)
      DO 1 J=ICG(K),L-1
      IF (JCG(J).EQ.I) THEN
      IF (JOB.NE.0) CG(J)=VAL
      IER=1
      RETURN
      ELSE IF (JCG(J).GT.I) THEN
      L=J
      GO TO 2
      ENDIF
    1 CONTINUE
    2 DO 3 J=ICG(NC+1)-1,L,-1
      JCG(J+1)=JCG(J)
      IF (JOB.NE.0) CG(J+1)=CG(J)
    3 CONTINUE
      JCG(L)=I
      IF (JOB.NE.0) CG(L)=VAL
      DO 4 J=K+1,NC+1
      ICG(J)=ICG(J)+1
    4 CONTINUE
      RETURN
      END
