* SUBROUTINE UKQGLV                 ALL SYSTEMS                90/12/01
C PORTABILITY : ALL SYSTEMS
C 90/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTING LAM(1,...,LINP)=(TRANS(B)*LAM(1,..,M),
*                            TRANS(Z)*LAM(1,...,LINP)).
*
* PARAMETERS :
*  II  N  NUMBER OF COLUMNS OF THE SPARSE MATRIX
*  II  M  NUMBER OF ROWS OF THE SPARSE MATRIX.
*  II  MCOLS DECLARED NUMBER OF VARIABLES.
*  II  MROWS DECLARED NUMBER OF ROWS.
*  II  NZ SIZE OF THE INDEX ARRAY CNR
*  II  NZA SIZE OF THE INDEX ARRAY RNR.
*  II  NAU SIZE OF THE ARRAY THAT STORES THE NUMERICAL ELEMENTS OF
*          THE PROCESSED MATRIX.
*  II  NUP  LENGTH OF THE ARRAYS LI,LJ,CM.
*  II  NEL  NUMBER OF TRIPLES IN ARRAYS (LI,LJ,CM).
*  II  PTL(MROWS) POINTER VECTOR OF THE COLUMNS OF THE L-FACTOR.
*  II  LENL(MROWS) LENGTHS OF THE COLUMNS OF THE FACTOR L.
*  II  CNR(NZ) CONTAINS THE INDICES OF THE FACTORS.
*  II  PTR(MROWS) POINTER VECTOR OF THE ROWS OF THE FACTOR U.
*  II  LENR(MROWS) LENGTHS OF THE ROWS OF THE FACTOR U.
*  II  RNR(NZA) COLUMNS OF THE ORIGINAL MATRIX A.
*  II  PRNR(MCOLS+1) INDEX VECTOR FOR THE ARRAY RNR.
*  II  ORDC(MROWS) COLUMN PERMUTATION.
*  II  ORDR(MROWS) ROW PERMUTATION.
*  II  ORDL(MROWS) ROW PERMUTATION OF THE ORIGINAL FACTOR L.
*  II  LI(NUP) ROW INDICES OF THE L-UPDATES.
*  II  LJ(NUP) COLUMN INDICES OF THE L-UPDATES.
*  RI  CM(NUP) UPDATE MULTIPLIERS.
*  RI  AU(NZ) NUMERICAL VALUES OF THE FACTORS.
*  RI  A(NZA) NUMERICAL VALUES OF THE ELEMENTS OF THE CONSTRAINT
*             MATRIX.
*  RA  WR01(MCOLS) AUXILIARY ARRAY.
*  II  BCOL(MCOLS) PERMUTATION ARRAY: FIRST M COMPONENTS FORM BASIS,
*              NEXT LINP-M FORM SUPERBASIS AND REST CORRESPOND TO
*              THE NON-BASIC VARIABLES.
*  RU  LAM(MCOLS) VECTOR LAM(1,LINP)=(TRANS(B)*LAM(M),
*                                     TRANS(Z)*LAM(LINP)).
*  RI  C(MCOLS) GRADIENT VECTOR.
*  II  LINP NUMBER OF SUPERBASICS AND BASICS.
*
* COMMON DATA:
*
      SUBROUTINE UKQGLV(N,M,MROWS,MCOLS,NZ,NZA,NAU,NUP,NEL,PTL,LENL,CNR,
     & PTR,LENR,RNR,PRNR,ORDC,ORDR,ORDL,LI,LJ,CM,AU,A,WR01,BCOL,LAM,C,
     & LINP)
      INTEGER N,M,MROWS,MCOLS,NZ,NZA,NAU,NUP,NEL,PTL(MROWS),LENL(MROWS),
     & CNR(NZ),PTR(N),LENR(N),RNR(NZA),PRNR(N+1),ORDC(N),ORDR(N),
     & ORDL(N),LI(NUP),LJ(NUP),BCOL(N),LINP
      $FLOAT CM(NUP),AU(NAU),A(NZA),WR01(N),LAM(LINP),C(MCOLS)
      INTEGER I,JOB,J
C
C     BTRAN
C
      JOB=0
      CALL UXSGFT(M,NZ,NAU,NEL,NUP,PTL,LENL,CNR,PTR,LENR,ORDC,ORDR,
     *            ORDL,LI,LJ,CM,AU,LAM,WR01,JOB)
C
C     COMPUTE NEW REDUCED GRADIENT
C
C
C     FIRST: COMPUTE TRANS(S)*LAM(1,...,M)
C
      JOB=0
      CALL UXSGMT(M,LINP-M,NZA,RNR,PRNR,ORDR,BCOL(M+1),A,LAM,WR01,
     *            JOB)
C
C     COMPUTE LAM(M+1,...,LINP)=C(BCOL(M+1),..,BCOL(LINP))
C                               -WR01(1,...,LINP-M).
C
      DO 100 I=M+1,LINP
      J=BCOL(I)
      LAM(I)=C(J)-WR01(I-M)
100   CONTINUE
      RETURN
      END
