* SUBROUTINE UKQPMM                ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE:
* MULTIPLICATION OF A (NS X NS) SUBMATRIX OF A SYMMETRIX MATRIX H
* BY THE VECTOR WR01(1,...,NS). RESULT IS STORED IN WR02(1,...,NS).
* H HAS STORED ONLY ONE TRIANGLE ( COLUMNS OF LOWER TRIANGLE).
* SUBMATRIX CORRESPONDS TO THE FIRST NS COMPONENTS OF THE VECTOR
* BCOL(1,...,N).
* MATRIX IS FACTORIZED.
* UNOPTIMIZED VERSION FOR THE SAKE OF DEBUGGING.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX.
*  II  NHES SIZE OF THE PRINCIPAL MATRIX ARRAYS (SH,H).
*  II  NS SIZE OF THE SUBMATRIX THAT IS USED.
*  II  BCOL(N) VECTOR THAT DETERMINES THE SUBMATRIX.
*  II  SH(NHES) COLUMN INDICES OF THE INPUT MATRIX
*  RI  H(NHES) ELEMENTS OF THE LOWER HALF OF THE SYMMETRIC MATRIX.
*  RI  WR01(N) INPUT VECTOR THAT IS MULTIPLIED.
*  RO  WR02(N) OUTPUT VECTOR WHERE WR02(NS):= SUBM OF H * WR01(NS)
*  II  PERM(NF) PERMUTATION VECTOR.
*  II  PSL(NF+1) POINTER VECTOR TO THE COMPACT CHOLESKY FACTOR.
*
      SUBROUTINE UKQPMM(N,NHES,NS,BCOL,SH,H,WR01,WR02,
     *                  PERM,PSL)
      INTEGER N,NHES,NS
      INTEGER BCOL(N),SH(NHES)
      INTEGER PERM(N),PSL(N+1)
      $FLOAT H(NHES),WR01(N),WR02(N)
      INTEGER I,J
C
C     ZERO THE VECTOR WR02
C
      DO 100 I=1,NS
      WR02(I)=0.0$P 0
100   CONTINUE
C
C WIDTHEN WR01
C
      DO 150 I=1,NS
      WR02(BCOL(I))=WR01(I)
  150 CONTINUE
C
C FORWARD PERMUTATION
C
      CALL UXVSFP(N,PERM,WR02,WR01)
C
C MATRIX MULTIPLICATION
C
      CALL UXSPCM(N,NHES,H,PSL,SH,WR02,WR01,0)
C
C BACKWARD PERMUTATION
C
      CALL UXVSBP(N,PERM,WR02,WR01)
      DO 400 I=1,NS
      J=BCOL(I)
      WR01(I)=WR02(J)
  400 CONTINUE
      CALL UXVCOP(NS,WR01,WR02)
      RETURN
      END
