* SUBROUTINE ULMAXS               ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF THE MAXIMUM STEPSIZE USING THE SIMPLE BOUNDS
* FOR VARIABLES.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  RI  S(NF)  DIRECTION VECTOR.
*  RO  STEP  MAXIMUM STEPSIZE.
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*  II  KREM  INDICATION OF LINEARLY DEPENDENT GRADIENTS.
*  IO  INEW  INDEX OF THE NEW ACTIVE CONSTRAINT.
*
      SUBROUTINE ULMAXS(NF,X,IX,XL,XU,S,STEP,KBF,KREM,INEW)
      INTEGER NF,IX(NF),KBF,KREM,INEW
      $FLOAT X(NF),XL(NF),XU(NF),S(NF),STEP
      $FLOAT TEMP
      INTEGER I
      IF (KBF.GT.0) THEN
      DO 1 I=1,NF
      IF (KREM.GT.0.AND.IX(I).GT.10) IX(I)=IX(I)-10
      IF (IX(I).GT.0.AND.IX(I).LE.10) THEN
      IF (S(I).LT.0.0$P 0) THEN
      IF (IX(I).EQ.1.OR.IX(I).GE.3) THEN
      TEMP=(XL(I)-X(I))/S(I)
      IF (TEMP.LE.STEP) THEN
      INEW=-I
      STEP=TEMP
      ENDIF
      ENDIF
      ELSE IF (S(I).GT.0.0$P 0) THEN
      IF (IX(I).EQ.2.OR.IX(I).GE.3) THEN
      TEMP=(XU(I)-X(I))/S(I)
      IF (TEMP.LE.STEP) THEN
      INEW=-I
      STEP=TEMP
      ENDIF
      ENDIF
      ENDIF
      ENDIF
    1 CONTINUE
      ENDIF
      KREM=0
      RETURN
      END
