* SUBROUTINE ULMINA             ALL SYSTEMS                   06/12/01
C PORTABILITY : ALL SYSTEMS
C 06/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF THE NEW ACTIVE FUNCTION.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  NA  NUMBER OF DECLARED LINEAR APPROXIMATED FUNCTIONS.
*  II  NAD  NUMBER OF CURRENT LINEAR APPROXIMATED FUNCTIONS.
*  II  NC  NUMBER OF CURRENT LINEAR CONSTRAINTS.
*  RI  AF(NA)  VECTOR CONTAINING VALUES OF THE APPROXIMATED
*         FUNCTIONS.
*  RO  AFD(NA)  VECTOR CONTAINING INCREMENTS OF THE APPROXIMATED
*         FUNCTIONS.
*  II  IA(2*NA)  VECTOR CONTAINING TYPES OF DEVIATIONS.
*  RI  AG(NF*NA)  VECTOR CONTAINING SCALING PARAMETERS.
*  RI  S(NF)  DIRECTION VECTOR.
*  RI  EPS9  TOLERANCE FOR ACTIVE FUNCTIONS.
*  RO  XNORM  VALUE OF LINEARIZED MINIMAX FUNCTION.
*  RA  PAR  AUXILIARY VARIABLE.
*  IO  INEW  INDEX OF THE NEW ACTIVE FUNCTION.
*  IO  KNEW  SIGNUM OF THE NEW ACTIVE GRADIENT.
*
* SUBPROGRAMS USED :
*  RF  UXVDOT  DOT PRODUCT OF TWO VECTORS.
*
      SUBROUTINE ULMINA(NF,NA,NAD,NC,AF,AFD,IA,AG,S,EPS9,XNORM,PAR,
     & INEW,KNEW)
      INTEGER NF,NA,NAD,NC,IA(2*NA),INEW,KNEW
      $FLOAT AF(NA),AFD(NA),AG(NF*NA),S(NF),EPS9,XNORM,PAR
      $FLOAT TEMP,POM,UXVDOT
      INTEGER JAG,KA
      JAG=1
      DO 1 KA=1,NAD
      IF (IA(KA).GT.0) THEN
      IF (KA.LE.NA) THEN
      AFD(KA)=UXVDOT(NF,AG(JAG),S)
      TEMP=AF(KA)+AFD(KA)
      ELSE
      TEMP=AF(KA-NA)+AFD(KA-NA)
      ENDIF
      IF (IA(KA).EQ.1.OR.IA(KA).EQ.3) THEN
      POM=XNORM+TEMP
      IF (POM.LT.MIN(PAR,-EPS9*MAX(ABS(XNORM),1.0$P 0))) THEN
      INEW=KA+NC
      KNEW= 1
      PAR=POM
      ENDIF
      ENDIF
      IF (IA(KA).EQ.2.OR.IA(KA).EQ.4) THEN
      POM=XNORM-TEMP
      IF (POM.LT.MIN(PAR,-EPS9*MAX(ABS(XNORM),1.0$P 0))) THEN
      INEW=KA+NC
      KNEW=-1
      PAR=POM
      ENDIF
      ENDIF
      ENDIF
      JAG=JAG+NF
    1 CONTINUE
      RETURN
      END
