* SUBROUTINE ULNEWT             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* TEST ON ACTIVITY OF A TRUST REGION BOUND.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  IO  IXA(NF)  VECTOR CONTAINING INFORMATION ON TRUST REGION ACTIVITY.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RI  XO(NF)  SAVED VECTOR OF VARIABLES.
*  RU  XDEL  TRUST REGION BOUND.
*  RI  EPS9  TOLERANCE FOR ACTIVE CONSTRAINTS.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*  II  I  INDEX OF TESTED SIMPLE BOUND.
*  IO  INEW  INDEX OF THE NEW ACTIVE CONSTRAINT.
*
      SUBROUTINE ULNEWT(NF,X,IX,IXA,XN,XO,XDEL,EPS9,NORMF,I,INEW)
      INTEGER NF,IX(NF),IXA(NF),NORMF,I,INEW
      $FLOAT X(NF),XN(NF),XO(NF),XDEL,EPS9
      $FLOAT TEMP
      IF(IX(I).GE.0) THEN
      TEMP=1.0$P 0
      IF (NORMF.GT.0) TEMP=XN(I)
      IF (X(I).LE.XO(I)-XDEL*TEMP+EPS9*MAX(ABS(XO(I)),TEMP)) THEN
      IXA(I)=IX(I)
      IX(I)=13
      INEW=-I
      ENDIF
      IF (X(I).GE.XO(I)+XDEL*TEMP-EPS9*MAX(ABS(XO(I)),TEMP)) THEN
      IXA(I)=IX(I)
      IX(I)=14
      INEW=-I
      ENDIF
      ENDIF
      RETURN
      END
