* SUBROUTINE ULSETA             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF INITIAL VALUES OF THE CONSTRAINT FUNCTIONS.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF CURRENT LINEAR APPROXIMATED FUNCTIONS.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RO  XO(NF)  SAVED VECTOR OF VARIABLES.
*  RI  AF(2*NA)  VECTOR CONTAINING VALUES OF THE APPROXIMATED
*         FUNCTIONS.
*  II  IA(2*NA)  VECTOR CONTAINING TYPES OF DEVIATIONS.
*  RI  AG(NF*NA)  VECTOR CONTAINING SCALING PARAMETERS.
*  RA  S(NF)  AUXILIARY VECTOR.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
* SUBPROGRAMS USED :
*  S   UXVDIF  DIFFERENCE OF TWO VECTORS.
*  RF  UXVDOT  DOT PRODUCT OF TWO VECTORS.
*  S   UXVMUL  DIAGONAL PREMULTIPLICATION OF A VECTOR.
*
      SUBROUTINE ULSETA(NF,NA,X,XN,XO,AF,IA,AG,S,NORMF)
      INTEGER NF,NA,IA(2*NA),NORMF
      $FLOAT X(NF),XN(NF),XO(NF),AF(2*NA),AG(NF*NA),S(NF)
      $FLOAT UXVDOT
      INTEGER JAG,KA
      CALL UXVDIF(NF,X,XO,S)
      IF (NORMF.GT.0) CALL UXVMUL(NF,XN,S,S,-1)
      JAG=0
      DO 1 KA=1,NA
      IF (IA(KA).NE.0) THEN
      AF(KA)=AF(KA)+UXVDOT(NF,S,AG(JAG+1))
      AF(KA+NA)=AF(KA)
      ENDIF
      JAG=JAG+NF
    1 CONTINUE
      RETURN
      END


