* SUBROUTINE ULSOB1             ALL SYSTEMS                   97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* THE SOLUTION OF THE ORIGINAL QP PROBLEM IS DERIVED.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NC  NUMBER OF CONSTRAINTS.
*  RO  X(NF)  VECTOR OF VARIABLES.
*  RI  XO(NF)  SAVED VECTOR OF VARIABLES.
*  RI  CF(NC)  VECTOR CONTAINING VALUES OF THE CONSTRAINT FUNCTIONS.
*  RI  CG(NF*NC)  MATRIX WHOSE COLUMNS ARE NORMALS OF THE LINEAR
*         CONSTRAINTS.
*  RI  S(NF)  DIRECTION VECTOR.
*  II  KBC  SPECIFICATION OF LINEAR CONSTRAINTS. KBC=0-NO LINEAR
*         CONSTRAINTS. KBC=1-ONE SIDED LINEAR CONSTRAINTS. KBC=2=TWO
*         SIDED LINEAR CONSTRAINTS.
*
* SUBPROGRAMS USED :
*  RS  UXVDOT  DOT PRODUCT OF TWO VECTORS.
*  S   UXVSUM  SUM OF TWO VECTORS.
*
      SUBROUTINE ULSOB1(NF,NC,X,XO,CF,CG,S,KBC)
      INTEGER NF,NC,KBC
      $FLOAT X(NF),XO(NF),CF(NC),CG(NF*NC),S(NF)
      $FLOAT UXVDOT
      INTEGER JCG,KC
      IF (KBC.GT.0) THEN
      JCG=1
      DO 1 KC=1,NC
      CF(KC)=CF(KC)+UXVDOT(NF,CG(JCG),S)
      JCG=JCG+NF
    1 CONTINUE
      ENDIF
      CALL UXVSUM(NF,XO,S,X)
      RETURN
      END




