* SUBROUTINE UMRMB0             ALL SYSTEMS                   93/12/01
C PORTABILITY : ALL SYSTEMS
C 93/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* OPERATIONS AFTER CONSTRAINT DELETION.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  II  NC  NUMBER OF CURRENT LINEAR CONSTRAINTS.
*  II  MMAX  MAXIMUM NUMBER OF NONZERO ELEMENTS OF THE MATRIX CR.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  II  IXA(NF)  VECTOR CONTAINING INFORMATION ON TRUST REGION ACTIVITY.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  II  ICA(NF)  VECTOR CONTAINING INDICES OF ACTIVE FUNCTIONS.
*  RI  CR(MMAX)  TRIANGULAR DECOMPOSITION OF KERNEL OF THE
*         ORTHOGONAL PROJECTION.
*  II  ICR(NF+1)  POSITION OF THE FIRST RORWS ELEMENTS IN THE FIELD CR.
*  II  JCR(MMAX) COLUMN INDICES OF ELEMENTS IN THE FIELD CR.
*  RA  CK(NF)  AUXILIARY VECTOR.
*  RA  CL(NF)  AUXILIARY VECTOR.
*  II  IOLD  INDEX OF THE OLD ACTIVE CONSTRAINT.
*  IO  KREM  AUXILIARY VARIABLE.
*
* COMMON DATA :
*  II  LCS  VARIABLE WHICH SPECIFIES TRUST REGION BOUNDS.
*  IU  NREM NUMBER OF CONSTRAINT DELETION.
*  IO  ITERM  TERMINATION INDICATOR.
*  TO  TDXX  TEXT INFORMATION ON THE DIRECTION VECTOR OBTAINED.
*
* SUBPROGRAMS USED :
*  S   UMRMR0  CORRECTION OF KERNEL OF THE ORTHOGONAL PROJECTION
*         AFTER CONSTRAINT DELETION.
*
      SUBROUTINE UMRMB0(NF,N,NC,MMAX,IX,IXA,IC,ICA,CR,ICR,JCR,CK,CL,
     & IOLD,KREM)
      $INCLUDE ('UMCOMM')
      INTEGER NF,N,NC,MMAX,IX(NF),IXA(NF),IC(NC),ICA(NF),ICR(NF+1),
     & JCR(MMAX),IOLD,KREM
      $FLOAT CR(MMAX),CK(NF),CL(NF)
      INTEGER L
      CALL UMRMR0(NF,N,MMAX,ICA,CR,ICR,JCR,CK,CL,IOLD,KREM)
      N=N+1
      NREM=NREM+1
      L=ICA(NF-N+1)
      IF (L.GT.0) THEN
      IC(L)=-IC(L)
      ELSE
      L=-L
      IX(L)=-IX(L)
      IF (LCS.GT.0) THEN
      IF (IXA(L).GE.0) THEN
      IX(L)=IXA(L)
      IXA(L)=-1
      ENDIF
      ENDIF
      ENDIF
      RETURN
      END


