* SUBROUTINE UNDRS4                ALL SYSTEMS                94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INTERPOLATION IN MESH POINTS FOR THE SUBROUTINE UEVRK1.
*
* PARAMETERS :
*  II  NA  NUMBER OF MESH POINTS.
*  II  NAL  NUMBER OF MESH POINTS.
*  II  NE  DECLARED NUMBER OF EQUATIONS.
*  II  MEL  ACTUAL NUMBER OF EQUATIONS.
*  IU  KA  INDEX OF THE MESH POINT.
*  RI  AT(NA)  MESH POINTS.
*  RO  AY(NA*NE)  FIELD OF SOLUTION VECTORS IN THE MESH POINTS.
*  RA  ES(3*MEL)  AUXILIARY VECTOR.
*  RU  TA  VALUE OF THE INTEGRATION PARAMETER.
*  RU  TAO  OLD VALUE OF THE INTEGRATION PARAMETER.
*  RU  HE  ACTUAL STEPSIZE.
*  IO  IER  ERROR INDICATOR.
*  II  JOB  TYPE OF OUTPUT.
*
* SUBPROGRAMS USED :
*  S   UXVCOP  COPYING OF A VECTOR.
*
      SUBROUTINE UNDRS4(NA,NAL,NE,MEL,KA,AT,AY,ES,TA,TAO,HE,IER,JOB)
      $INCLUDE('UMCOMM')
      INTEGER NA,NAL,NE,MEL,KA,IER,JOB
      $FLOAT AT(*),AY(*),ES(*),TA,TAO,HE
      INTEGER NE1,NE2,NE3,I,K
      $FLOAT S
      SAVE NE1,NE2,NE3
      IF (JOB.LT.0) THEN
        KA=2
        IF (JOB.EQ.-2) THEN
          NE1=MEL
          NE2=2*MEL
          NE3=3*MEL
        END IF
      ELSE IF (JOB.EQ.1) THEN
        K=(KA-1)*NE
        IF (KA.LE.NAL) THEN
          AT(KA)=TA
          CALL UXVCOP(NE,ES,AY(K+1))
        ELSE
          IER=-11
          TEDX='LACK SP.'
          RETURN
        END IF
        KA=KA+1
      ELSE IF (JOB.EQ.2) THEN
 10     CONTINUE
        K=(KA-1)*NE
        IF (KA.LE.NA) THEN
        IF (HE*(TA-AT(KA)).GE.ZERO) THEN
          S=(AT(KA)-TAO)/HE
          DO 20 I=1,NE
          AY(K+I)=ES(I)*(ONE-S)+S*(ES(NE1+I)+(ONE-S)*(ES(NE2+I)+
     &           S*ES(NE3+I)))
 20       CONTINUE
          KA=KA+1
          GO TO 10
        END IF
        END IF
      END IF
      RETURN
      END
