* SUBROUTINE UNLCS2                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* OPTIMUM LOCALLY CONSTRAINED STEP IN A TWO DIMENSIONAL SUBSPACE.
*
* PARAMETERS :
*  RI  B1  INPUT MATRIX ELEMENT.
*  RI  B2  INPUT MATRIX ELEMENT.
*  RI  B3  INPUT MATRIX ELEMENT.
*  RI  D1  INPUT MATRIX ELEMENT.
*  RI  D2  INPUT MATRIX ELEMENT.
*  RI  D3  INPUT MATRIX ELEMENT.
*  RI  G1  RIGHT HAND SIDE ELEMENT.
*  RI  G2  RIGHT HAND SIDE ELEMENT.
*  RO  S1  SOLUTION ELEMENT.
*  RO  S2  SOLUTION ELEMENT.
*  RI  XDEL  CURRENT STEPSIZE BOUND.
*  IO  IER  ERROR INDICATOR. IF IER.LE.0 THEN OPTIMUM STEP WAS
*         NOT OBTAINED.
*
      SUBROUTINE UNLCS2(B1,B2,B3,D1,D2,D3,G1,G2,S1,S2,DEL,IER)
      INTEGER IER,NRED
      $FLOAT B1,B2,B3,D1,D2,D3,G1,G2,S1,S2,DEL
      $FLOAT C1,C2,C3,X1,X2,X3,E1,E2,T1,T2,T,POM
      $FLOAT ZERO,ONE,TWO,FOUR,CON,CON1,CON2,CON3
      PARAMETER (ZERO=0.0$P 0,ONE=1.0$P 0,TWO=2.0$P 0,FOUR=4.0$P 0,
     * CON=1.0$P-8,CON1=0.999$P 0,CON2=1.001$P 0,CON3=1.0$P-6)
      C1=B1/D2
      C2=B2/D2
      C3=B3/D2
      X1=D1/D2
      X3=D3/D2
      X2=X1*X3-ONE
      IF (X2.LE.CON3) THEN
      IER=-1
      RETURN
      ENDIF
      POM=(C1*X3+C3*X1-TWO*C2)/(TWO*X2)
      C2=POM*POM-(C1*C3-C2*C2)/X2
      IF (C2.LE.ZERO) THEN
      IER=-2
      RETURN
      ENDIF
      E1=POM-SQRT(C2)
      E2=POM+SQRT(C2)
      POM=(G1*(X3*G1-G2)+G2*(X1*G2-G1))/D2
      X2=SQRT(POM/X2)/DEL
      T1=MAX(ZERO,X2-E2)
      T2=MAX(T1,X2-E1)
      T=T1
      NRED=0
    1 NRED=NRED+1
      IF (NRED.GE.20) THEN
      IER=2
      RETURN
      ENDIF
      C1=B1+T*D1
      C2=B2+T*D2
      C3=B3+T*D3
      X3=C2/C1
      C3=C3-X3*C2
      C2=X3
      X1=-G1
      X2=-G2-C2*X1
      X2=X2/C3
      X1=X1/C1-C2*X2
      POM=X1*(D1*X1+D2*X2)+X2*(D2*X1+D3*X2)
      X3=SQRT(POM)/DEL
      IF (X3.GT.CON2) THEN
      T1=T
      S1=D1*X1+D2*X2
      S2=D2*X1+D3*X2-C2*S1
      T=T+(X3-ONE)*POM/(S1*S1/C1+S2*S2/C3)
      T=MAX(T,T1)
      T=MIN(T,T2)
      GO TO 1
      ELSE IF (X3.LT.CON1.AND.T.GT.ZERO) THEN
      T2=T
      S1=D1*X1+D2*X2
      S2=D2*X1+D3*X2-C2*S1
      T=T+(X3-ONE)*POM/(S1*S1/C1+S2*S2/C3)
      T=MAX(T,T1)
      GO TO 1
      ELSE
      S1=X1
      S2=X2
      IER=0
      IF (T.GT.ZERO) IER=1
      ENDIF
      RETURN
      END



