* SUBROUTINE UOD0S3                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  PRINT OF INDIVIDUAL STEPS IN LOCAL SEARCH.
*
* PARAMETERS :
*  RI  FO  INITIAL VALUE OF THE OBJECTIVE FUNCTION.
*  RO  FP  PREVIOUS VALUE OF THE OBJECTIVE FUNCTION.
*  RO  F  VALUE OF THE OBJECTIVE FUNCTION.
*  II  MODE  MODE OF THE LOCAL SEARCH.
*  II  IVAR  INDEX OF THE LOCAL VARIABLE.
*
* COMMON DATA :
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=5-ADDITIONAL PRINT OF DEBUGGING.
*
      SUBROUTINE UOD0S3(FO,FP,F,MODE,IVAR)
      $INCLUDE('UMCOMM')
      INTEGER MODE,IVAR
      $FLOAT FO,FP,F
      IF (JOUT.EQ.0) RETURN
      IF (ABS(KOUT).LE.1) RETURN
      IF (IVAR.LE.0) RETURN
      WRITE(IWR,1) MODE,IVAR,FO,FP,F
    1 FORMAT(' ',I3,3X,I3,3X,'FO =',$P 10.3,3X,
     &       'FP =',$P 10.3,3X,'F =',$P 10.3)
      RETURN
      END

