* SUBROUTINE UOFTH2                ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  PRINT OF EXIT FROM TRANSFORMATION OF THE HESSIAN MATRIX OR ITS
*  APPROXIMATION.
*
* PARAMETERS :
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE MATRIX H.
*  RO  H(M)  HESSIAN MATRIX OR ITS APPROXIMATION.
*
* COMMON DATA :
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=5-ADDITIONAL PRINT OF DEBUGGING.
*  II  LOUT  LEVEL OF PRINT. LOUT=0-PRINT OF SCALAR VALUES.
*         LOUT=1-ADDITIONAL PRINT OF BASIC VECTORS.
*         LOUT=2-ADDITIONAL PRINT OF OTHER VECTORS.
*         LOUT=3-ADDITIONAL PRINT OF MATRICES.
*
      SUBROUTINE UOFTH2(M,H)
      $INCLUDE('UMCOMM')
      INTEGER M
      $FLOAT H(M)
      INTEGER I
      IF(JOUT.EQ.0) RETURN
      IF(ABS(KOUT).LE.3) RETURN
      IF(ABS(LOUT).LE.2) RETURN
      WRITE(IWR,3) (H(I),I=1,MIN(M,30))
    3 FORMAT(' ','H   =',5$P 14.5:/(6X, 5$P 14.5))
      WRITE(IWR,4)
    4 FORMAT(' ','END OF TRANSFORMATION')
      RETURN
      END
