* SUBROUTINE UOKIT1                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  PRINT OF ENTRY TO INITIAL SPARSE TRANSFORMATION SUBROUTINE.
*
* PARAMETERS:
*  II  NF  DECLARED NUMBER OF INPUT VARIABLES.
*  II  NC  NUMBER OF INITIAL LINEAR CONSTRAINTS.
*  TI  TEXT SUBROUTINE USED TO INITIAL SPARSE TRANSFORMATION.
*  II  NFDUMM  NUMBER OF DUMMY VARIABLES IN THE INPUT STRUCTURE.
*  II  NCDUMM  NUMBER OF DUMMY CONSTRAINTS IN THE INPUT STRUCTURE.
*  II  NPINR  NUMBER OF NONZEROS OF THE INPUT STRUCTURE.
*                                    =1 FOR NONBASIC LOWER BOUNDED
*                                    =2 FOR NONBASIC UPPER BOUNDED
*                                    =3 FOR NONBASIC LOWER AND UPPER
*                     BOUNDED VARIABLE SET TO ITS LOWER BOUND
*                                    =4 FOR NONBASIC LOWER AND UPPER
*                     BOUNDED VARIABLE SET TO ITS UPPER BOUND
*                                    =5 FOR NONBASIC FIXED VARIABLE
*                                    =6 FOR NONBASIC FREE VARIABLE
*                                    =-1 FOR BASIC LOWER BOUNDED
*                                    =-2 FOR BASIC UPPER BOUNDED
*                                    =-3 FOR BASIC LOWER AND UPPER
*                     BOUNDED VARIABLE
*                                    =-6 FOR BASIC FREE VARIABLE.
*
* COMMON DATA :
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF MATRIX CORRECTION.
*         KOUT=5-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=6-ADDITIONAL PRINT OF DEBUGGING.
*  II  LOUT  PRINT OF ITERATIONS. LOUT=0-STANDARD PAPER SAVING PRINT.
*         LOUT=1-ADDITIONAL PRINT OF FINAL RESULTS OF SUBROUTINES.
*         LOUT=2-ADDITIONAL PRINT OF VARIABLES. LOUT=3-ADDITIONAL
*         PRINT OF THE GRADIENT. LOUT=4-ADDITIONAL PRINT OF THE HESSIAN
*         MATRIX.
*
      SUBROUTINE UOKIT1(NF,NC,TEXT,NFDUMM,NCDUMM,NPINR)
      $INCLUDE('UMCOMM')
      INTEGER NF,NC,NFDUMM,NCDUMM,NPINR
      CHARACTER*6 TEXT
      $FLOAT DENSI
C     INTEGER I
      IF(JOUT.EQ.0) RETURN
      IF(ABS(KOUT).LE.3) RETURN
      WRITE(IWR,1) TEXT
C
C COMPUTE INITIAL DENSITY
C
      IF(MIN(NF,NC).GT.1) THEN
        DENSI=NPINR
        DENSI=DENSI/(NF*NC)
      ELSE
        DENSI=0
      ENDIF
    1 FORMAT(' ','INITIAL SPARSE TRANSFORMATION USING',1X,A6)
      WRITE(IWR,2) NF,NC,NFDUMM,NCDUMM,NPINR,DENSI
    2 FORMAT(' ','NF =',I4,2X,'NCL =',I4,2X,
     *       'DUMMY VARS =',I4,2X,'DUMMY CONS =',I4/' ',
     *       'INIT NONZEROS =',I4,2X,'INIT DENSITY =',$P 9.3)
      RETURN
      END

