* SUBROUTINE UOKLP2                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  PRINT OF EXIT FROM LINEAR PROGRAMMING SUBROUTINE.
*
* PARAMETERS:
*  II  N NUMBER OF VARIABLES.
*  II  M NUMBER OF CONSTRAINTS.
*  II  MROWS DECLARED NUMBER OF ROWS.
*  II  MCOLS DECLARED NUMBER OF COLUMNS.
*  IO  NEL  NUMBER OF ELEMENTARY ELLIMINATION MATRICES STORED IN THE
*           TRIPLE: LI,LJ,CM.
*  RI  X(MCOLS) VECTOR OF SOLUTION.
*  RI  C(MCOLS) COST VECTOR.
*  II  TYPE(MCOLS) TYPES OF THE VARIABLES:
*                                    =1 FOR NONBASIC LOWER BOUNDED
*                                    =2 FOR NONBASIC UPPER BOUNDED
*                                    =3 FOR NONBASIC LOWER AND UPPER
*                     BOUNDED VARIABLE SET TO ITS LOWER BOUND
*                                    =4 FOR NONBASIC LOWER AND UPPER
*                     BOUNDED VARIABLE SET TO ITS UPPER BOUND
*                                    =5 FOR NONBASIC FIXED VARIABLE
*                                    =6 FOR NONBASIC FREE VARIABLE
*                                    =-1 FOR BASIC LOWER BOUNDED
*                                    =-2 FOR BASIC UPPER BOUNDED
*                                    =-3 FOR BASIC LOWER AND UPPER
*                     BOUNDED VARIABLE
*                                    =-6 FOR BASIC FREE VARIABLE.
*  II  BCOL(MCOLS) M FIRST ELEMENTS CONTAIN COLUMN INDICES OF BASIC
*              COLUMNS.
*  II  PHASE PHASE NUMBER.
*  II  NUMITR NUMBER OF THE PENDING ITERATION.
*  II  LENR(MCOLS) LENGTHS OF THE ROWS OF THE FACTOR U.
*  RO  FF  ORIGINAL FUNCTIONAL VALUE.
*  IA  KINP NUMBER OF ARTIFICIALS.
*
* COMMON DATA :
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF MATRIX CORRECTION.
*         KOUT=5-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=6-ADDITIONAL PRINT OF DEBUGGING.
*  II  LOUT  PRINT OF ITERATIONS. LOUT=0-STANDARD PAPER SAVING PRINT.
*         LOUT=1-ADDITIONAL PRINT OF FINAL RESULTS OF SUBROUTINES.
*         LOUT=2-ADDITIONAL PRINT OF VARIABLES. LOUT=3-ADDITIONAL
*         PRINT OF THE GRADIENT. LOUT=4-ADDITIONAL PRINT OF THE HESSIAN
*         MATRIX.
*  II  MOUT  LEVEL OF PRINT ON THE TERMINAL DEVICE.
*         ABS(MOUT)=0 - NO PRINT.
*         ABS(MOUT)=1 - PRINT OF FINAL RESULTS.
*         ABS(MOUT)=2 - ADDITIONAL PRINT OF ITERATIONS.
*
      SUBROUTINE UOKLP2(N,M,MROWS,MCOLS,NEL,PHASE,X,C,TYPE,BCOL,NUMITR,
     & LENR,FF,KINP)
      $INCLUDE('UMCOMM')
      INTEGER N,M,MROWS,MCOLS,NEL,PHASE,NUMITR,TYPE(MCOLS),BCOL(MCOLS),
     & LENR(MROWS),KINP
      $FLOAT X(MCOLS),C(MCOLS),FF
      $FLOAT FHERE
      INTEGER I,IU
      LOGICAL LL
      LL=KOUT.EQ.0.AND.LOUT.GT.0
C
C COMPUTE FHERE  *
C
      IF(PHASE.NE.1) THEN
        FHERE=FF
      ELSE
        FHERE=0.0$P 0
      ENDIF
      DO 50 I=1,N
        FHERE=FHERE+C(I)*X(I)
   50 CONTINUE
C
C COMPUTE IU
C
      IU=0
      DO 100 I=1,M
        IU=IU+LENR(I)
  100 CONTINUE
      IF(ABS(MOUT).GT.2) THEN
      WRITE(ITR,9) NUMITR,NEL,NREF,KINP,IU,FHERE,ITERL
      IF(LL) WRITE(IWR,9) NUMITR,NEL,NREF,KINP,IU,FHERE,ITERL
      ENDIF
    9 FORMAT(' ','NUMITR=',I5,1X,'NEL= ',I5,1X,'NREF=',I5,1X,
     *       'KINP=',I4,1X,'IU=',I5,2X,'F=',$P 9.3,2X,'ITERL=',I2)
      IF(JOUT.EQ.0) RETURN
      IF(ABS(KOUT).LE.3) RETURN
      IF(ABS(LOUT).GE.2) WRITE(IWR,5)(X(I),I=1,MIN(N,25))
    5 FORMAT(' ','X =  ',5$P 14.5:/(6X,5$P 14.5))
      IF(ABS(LOUT).GE.2) WRITE(IWR,8)(C(I),I=1,MIN(N,25))
    8 FORMAT(' ','GF=  ',5$P 14.5:/(6X,5$P 14.5))
      IF(ABS(LOUT).GE.1) WRITE(IWR,4)(BCOL(I),I=1,MIN(M,50))
    4 FORMAT(' ','BCOL=',10I7:/(6X,10I7))
      IF(ABS(LOUT).GE.1.AND.KBF.GT.0)WRITE(IWR,6)(TYPE(I),I=1,MIN(N,50))
    6 FORMAT(' ','IX  =',10I7:/(6X,10I7))
      WRITE(IWR,1) PHASE,ITERL,TLPX
    1 FORMAT(' ','END OF LINEAR PROGRAMMING PHASE NO.',I3,
     *       ' : ITERL = ',I3,2X,A8)
      RETURN
      END
