* SUBROUTINE UOMPW1                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  MATLAB AND SCILAB GRAPHICAL VISUALIZATION OF PATH WITH ISOLINES AND/OR MAP - PRINTING OF THE VALUES FOR PLOTTING.
*
* PARAMETERS :
*  II  IPAC  THE FIRST ITERATION POINT FOR PLOTTING THE PATH.
*  II  NPAC  THE LAST ITERATION POINT FOR PLOTTING THE PATH.
*  II  NGR  THE NUMBER OF NODES CORRESPONDING TO EVERY SELECTED VARIABLE
*  RI  XIGR  THE VALUE OF THE FIRST VARIABLE IN THE MINIMUM POINT
*  RI  XJGR  THE VALUE OF THE SECOND VARIABLE IN THE MINIMUM POINT
*  RI  XLIGR  THE MINIMUM VALUE OF THE FIRST VARIABLE OF THE SELECTED REGION
*  RI  XUIGR  THE MAXIMUM VALUE OF THE FIRST VARIABLE OF THE SELECTED REGION
*  RI  XLJGR  THE MINIMUM VALUE OF THE SECOND VARIABLE OF THE SELECTED REGION
*  RI  XUIGR  THE MAXIMUM VALUE OF THE SECOND VARIABLE OF THE SELECTED REGION
*  RI  XPA1(NPAC)  VALUES OF THE FIRST SELECTED VARIABLE.
*  RI  XPA2(NPAC)  VALUES OF THE SELECTED SELECTED VARIABLE.
*  RI  FL(NGR,NGR)  THE FIELD CONTAINING DRAWN FUNCTION VALUES
*  LU  VYPISF   THE SAME DRAWN FUNCTION VALUES CAN BE PUT INTO P.* ONLY ONCE
*  IU  SCALE  LINEAR OR LOGARITHMIC SCALE OF THE PLOT
*  LO  ENLX  IF THE PLOTTING BOX IN X-AXES IS SUFFICIENTLY LARGE
*  LO  ENLY  IF THE PLOTTING BOX IN Y-AXES IS SUFFICIENTLY LARGE
*  LO  CONSTF  IF THE DIFFERENCE BETWEEN MAX AND MIN OF THE PLOTTING VALUES IS SUFFICIENTLY LARGE
*
      SUBROUTINE UOMPW1(IPAC,NPAC,NGR,XIGR,XJGR,XLIGR,XUIGR,XLJGR,XUJGR,
     &   XPA1,XPA2,FL,VYPISF,SCALE,ENLX,ENLY,CONSTF)
      $OPTION(CHEOL='^')
      INTEGER IPAC,NPAC,NGR,SCALE,I,J,K,L
      REAL*4 XPA1(NPAC),XPA2(NPAC),FL(NGR,NGR),WF(10),MINIM,MAXIM,EPSS
      $FLOAT XIGR,XJGR,XLIGR,XUIGR,XLJGR,XUJGR,EPSD
      CHARACTER*160 RET
      LOGICAL VYPISF,ENLX,ENLY,CONSTF
C
      EPSD=1.0D-15
      EPSS=1.0E-6
      ENLX=.FALSE.
      ENLY=.FALSE.
      CONSTF=.FALSE.
      MINIM= 1.0E30
      MAXIM=-1.0E30
      IF ((XUIGR-XLIGR).LE.MAX(ABS(XUIGR+XLIGR),1.0D0)*EPSD) ENLX=.TRUE.
      IF ((XUJGR-XLJGR).LE.MAX(ABS(XUJGR+XLJGR),1.0D0)*EPSD) ENLY=.TRUE.
      DO I=1,NGR
        DO J=1,NGR
          MINIM=MIN(MINIM,FL(I,J))
          MAXIM=MAX(MAXIM,FL(I,J))
        ENDDO
      ENDDO
      IF ((MAXIM-MINIM).LE.MAX(ABS(MAXIM+MINIM),1.0E0)*EPSS)
     &  CONSTF=.TRUE.
      IF (MINIM.LE.0.0D0) SCALE=1   ! 1=LINEAR, 2=LOGARITHMIC
C
      IF (VYPISF) RETURN
      WRITE(RET,'(I15)') NGR
      RET=ADJUSTL(RET)
      WRITE(15,'(3A)') 'ngr=', TRIM(RET),';'
      WRITE(RET,'(D25.16)') XLIGR
      RET=ADJUSTL(RET)
      WRITE(15,'(3A)') 'xligr=', TRIM(RET),';'
      WRITE(RET,'(D25.16)') XUIGR
      RET=ADJUSTL(RET)
      WRITE(15,'(3A)') 'xuigr=', TRIM(RET),';'
      WRITE(RET,'(D25.16)') XLJGR
      RET=ADJUSTL(RET)
      WRITE(15,'(3A)') 'xljgr=', TRIM(RET),';'
      WRITE(RET,'(D25.16)') XUJGR
      RET=ADJUSTL(RET)
      WRITE(15,'(3A)') 'xujgr=', TRIM(RET),';'
      WRITE(15,'(A)') 'stx=(xuigr-xligr)/(ngr-1);'
      WRITE(15,'(A)') 'sty=(xujgr-xljgr)/(ngr-1);'
      WRITE(15,'(A)') 'x=xligr:stx:xuigr;'
      WRITE(15,'(A)') 'y=xljgr:sty:xujgr;'
C
      WRITE(15,'(A)') 'f=['
      DO J=1,NGR
        K=0
        DO I=1,NGR
          K=K+1
          WF(K)=FL(I,J)
          IF (K.EQ.10) THEN
            WRITE(RET,'(10E16.7)') (WF(L),L=1,K)
            WRITE(15,'(2A)') TRIM(RET),' ...'
            K=0
          ENDIF
        ENDDO
        IF (K.GT.0) THEN
          WRITE(RET,'(10E16.7)') (WF(L),L=1,K)
          WRITE(15,'(2A)') TRIM(RET),';'
        ELSE
          WRITE(15,'(A)') ';'
        ENDIF
      ENDDO
      WRITE(15,'(A)') '];'
      IF (SCALE.EQ.2) WRITE(15,'(A)') 'f=log10(f);';
C
      WRITE(15,'(A)') 'x1=['
      J=0
      DO I=IPAC,NPAC
        J=J+1
        WF(J)=XPA1(I)
        IF (J.EQ.10) THEN
          WRITE(RET,'(10E16.7)') (WF(K),K=1,J)
          WRITE(15,'(2A)') TRIM(RET),' ...'
          J=0
        ENDIF
      ENDDO
      IF (J.GT.0) THEN
        WRITE(RET,'(10E16.7)') (WF(K),K=1,J)
        WRITE(15,'(2A)') TRIM(RET),' ...'
      ENDIF
      WRITE(15,'(A)') '];'
C
      WRITE(15,'(A)') 'x2=['
      J=0
      DO I=IPAC,NPAC
        J=J+1
        WF(J)=XPA2(I)
        IF (J.EQ.10) THEN
          WRITE(RET,'(10E16.7)') (WF(K),K=1,J)
          WRITE(15,'(2A)') TRIM(RET),' ...'
          J=0
        ENDIF
      ENDDO
      IF (J.GT.0) THEN
        WRITE(RET,'(10E16.7)') (WF(K),K=1,J)
        WRITE(15,'(2A)') TRIM(RET),' ...'
      ENDIF
      WRITE(15,'(A)') '];'
C
      WRITE(RET,'(D25.16)') XIGR
      RET=ADJUSTL(RET)
      WRITE(15,'(3A)') 'xm=', TRIM(RET),';'
      WRITE(RET,'(D25.16)') XJGR
      RET=ADJUSTL(RET)
      WRITE(15,'(3A)') 'ym=', TRIM(RET),';'
      VYPISF=.TRUE.
      RETURN
      $OPTION(CHEOL=';')
      END
