* SUBROUTINE UOMTRA                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  MATLAB GRAPHICAL VISUALIZATION OF TRAJECTORY.
*
* PARAMETERS :
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  NE  NUMBER OF DIFFERENTIAL EQUATIONS.
*  RI  AT(NA)  VECTOR CONTAINING MESH POINTS.
*  RI  AY(*)  VECTOR CONTAINING COMPUTED SOLUTIONS OF DIFFERENTIAL EQUATIONS.
*  II  IG  INDEX OF THE 1-ST VISUALIZED DIFFERENTIAL EQUATION.
*  II  JG  INDEX OF THE 2-ND VISUALIZED DIFFERENTIAL EQUATION.
*  II  KG  INDEX OF THE 3-RD VISUALIZED DIFFERENTIAL EQUATION.
*  LI  VYPISF(3)  THE SAME DRAWN FUNCTION VALUES CAN BE PUT INTO P.m ONLY ONCE
*  CI  INFO  WHICH INDEXES [IG JG KG] OF GRAPH TO PRINT = [100] OR [010] OR [001] OR [110] OR [101] OR [011] OR [111]
*  II  CISLO  SERIAL NUMBER OF THE MATLAB SOURCE CODE
*  II  STA  START INDEX OF THE COMPUTED SOLUTION IN THE GRAPH
*  II  STO  STOP INDEX OF THE COMPUTED SOLUTION IN THE GRAPH
*  II  GFMT  GRAPHIC FORMAT
*
      SUBROUTINE UOMTRA
     & (NA,NE,AT,AY,IG,JG,KG,VYPISF,INFO,CISLO,STA,STO,GFMT)
      $OPTION(CHEOL='^')
      INTEGER NA,NE,IG,JG,KG,CISLO,STA,STO,GFMT
      $FLOAT AT(NA),AY(*),MINIM,MAXIM,TEMP,EPS
      CHARACTER*3 INFO
      CHARACTER*25 T1,T2,T3,T4
      LOGICAL VYPISF(3)
C
      CALL UOMOPN(14,GFMT)
      CALL UOMTRY(NA,NE,AT,AY,IG,JG,KG,VYPISF,INFO,STA,STO,MINIM,MAXIM)
C
      EPS=1.0D-15
      IF(INFO(1:1).EQ.'1'.AND.INFO(2:2).EQ.'0'.AND.INFO(3:3).EQ.'0'.OR.
     &   INFO(1:1).EQ.'0'.AND.INFO(2:2).EQ.'1'.AND.INFO(3:3).EQ.'0'.OR.
     &   INFO(1:1).EQ.'0'.AND.INFO(2:2).EQ.'0'.AND.INFO(3:3).EQ.'1')THEN
C       JEDNA TRAJEKTORIE
        IF (INFO(1:1).EQ.'1') THEN
          WRITE(T1,'(I10)')IG
          T1=ADJUSTL(T1)
          WRITE(14,'(A)')'h = plot(x,y1);'
        ELSEIF (INFO(2:2).EQ.'1') THEN
          WRITE(T1,'(I10)')JG
          T1=ADJUSTL(T1)
          WRITE(14,'(A)')'h = plot(x,y2);'
        ELSE
          WRITE(T1,'(I10)')KG
          T1=ADJUSTL(T1)
          WRITE(14,'(A)')'h = plot(x,y3);'
        ENDIF
        WRITE(14,'(A)')'set(h,{''LineWidth''},{2});'
        WRITE(14,'(A)')'set(h,{''LineStyle''},{''-''});'
        WRITE(14,'(A)')'set(h,{''Color''},{''b''});'
        WRITE(14,'(3A)')'tit=title(''Trajectory of {\color{blue}YA(',
     &   TRIM(T1),')}'');'
      ELSEIF
     &   (INFO(1:1).EQ.'0'.OR.INFO(2:2).EQ.'0'.OR.INFO(3:3).EQ.'0') THEN
C       DVE TRAJEKTORIE
        IF (INFO(3:3).EQ.'0') THEN
          WRITE(T1,'(I10)')IG
          T1=ADJUSTL(T1)
          WRITE(T2,'(I10)')JG
          T2=ADJUSTL(T2)
          WRITE(14,'(A)')'h = plot(x,y1,x,y2);'
        ELSEIF (INFO(2:2).EQ.'0') THEN
          WRITE(T1,'(I10)')IG
          T1=ADJUSTL(T1)
          WRITE(T2,'(I10)')KG
          T2=ADJUSTL(T2)
          WRITE(14,'(A)')'h = plot(x,y1,x,y3);'
        ELSE
          WRITE(T1,'(I10)')JG
          T1=ADJUSTL(T1)
          WRITE(T2,'(I10)')KG
          T2=ADJUSTL(T2)
          WRITE(14,'(A)')'h = plot(x,y2,x,y3);'
        ENDIF
        WRITE(14,'(A)')'set(h,{''LineWidth''},{2;2});'
        WRITE(14,'(A)')'set(h,{''LineStyle''},{''-'';''--''});'
        WRITE(14,'(A)')'set(h,{''Color''},{''b'';''r''});'
        WRITE(14,'(5A)')'tit=title(''Trajectories of {\color{blue}YA(',
     &   TRIM(T1), ')}, {\color{red}YA(', TRIM(T2), ')}'');'
      ELSE
C       TRI TRAJEKTORIE
        WRITE(T1,'(I10)')IG
        T1=ADJUSTL(T1)
        WRITE(T2,'(I10)')JG
        T2=ADJUSTL(T2)
        WRITE(T3,'(I10)')KG
        T3=ADJUSTL(T3)
        WRITE(14,'(A)')'h = plot(x,y1,x,y2,x,y3);'
        WRITE(14,'(A)')'set(h,{''LineWidth''},{2;2;2});'
        WRITE(14,'(A)')'set(h,{''LineStyle''},{''-'';''--'';''-.''});'
        WRITE(14,'(A)')'set(h,{''Color''},{''b'';''r'';[0 0.5 0]});'
        WRITE(14,'(7A)')'tit=title(''Trajectories of {\color{blue}YA(',
     &   TRIM(T1), ')}, {\color{red}YA(', TRIM(T2),
     &   ')}, {\color[rgb]{0 0.5 0}YA(', TRIM(T3), ')}'');'
      ENDIF
      WRITE(14,'(A)')'xl=xlabel(''Time'');'
      WRITE(14,'(A)')'yl=ylabel(''Values of YA'');'
      WRITE(14,'(A)')'set(gca,''FontSize'',20);'
      WRITE(14,'(A)')'set(tit,''FontSize'',25);'
      WRITE(14,'(A)')'set(xl,''FontSize'',20);'
      WRITE(14,'(A)')'set(yl,''FontSize'',20);'
      WRITE(T1,'(D25.16)')AT(STA)-(AT(STA+1)-AT(STA))
      T1=ADJUSTL(T1)
      WRITE(T2,'(D25.16)')AT(STO)+(AT(STO)-AT(STO-1))
      T2=ADJUSTL(T2)
      TEMP=(MAXIM-MINIM)*1.0D-1
      IF ((MAXIM-MINIM).LE.MAX(ABS(MAXIM+MINIM),1.0D0)*EPS) TEMP=EPS
      WRITE(T3,'(D25.16)') MINIM-TEMP
      T3=ADJUSTL(T3)
      WRITE(T4,'(D25.16)') MAXIM+TEMP
      T4=ADJUSTL(T4)
      WRITE(14,'(9A)')'axis([',
     & TRIM(T1), ' ', TRIM(T2), ' ', TRIM(T3), ' ', TRIM(T4), ']);'
      WRITE(14,'(A)')'grid on;'
      CALL UOMGRX(14,'PMTRA',CISLO,GFMT)
      RETURN
      $OPTION(CHEOL=';')
      END
