* SUBROUTINE UOS1L1              ALL SYSTEMS                 99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF ENTRY TO STEPSIZE SELECTION.
*
* PARAMETERS :
*  RI  RO  INITIAL VALUE OF THE STEPSIZE PARAMETER.
*  RI  FO  INITIAL VALUE OF THE OBJECTIVE FUNCTION.
*  RI  PO  INITIAL VALUE OF THE DIRECTIONAL DERIVATIVE.
*  RI  GNORM  NORM OF THE GRADIENT VECTOR.
*  RI  SNORM  NORM OF THE DIRECTION VECTOR.
*  RI  RMAX  UPPER BOUND FOR STEPSIZE PARAMETER.
*
* COMMON DATA :
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=5-ADDITIONAL PRINT OF DEBUGGING.
*  TI  NSXX  PRINTED TEXT.
*
      SUBROUTINE UOS1L1(RO,FO,PO,GNORM,SNORM,RMAX)
      $INCLUDE ('UMCOMM')
      $FLOAT RO,FO,PO,GNORM,SNORM,RMAX
      IF(JOUT.EQ.0) RETURN
      IF (ABS(KOUT).LE.1) RETURN
      IF (GNORM*SNORM.LE.0) THEN
      WRITE (IWR,1) NSXX
      ELSE
      WRITE (IWR,1) NSXX,PO/(GNORM*SNORM)
      ENDIF
    1 FORMAT (' ','STEPSIZE SELECTION USING',1X,A6:1X,' :
     & P/(G*S) = ',$P 9.3)
      WRITE (IWR,2) RO,SNORM,FO,PO,RMAX
    2 FORMAT (' ',7X,'R=',$P 9.3,1X,'S=',$P 9.3,1X,'F=',$P 18.12,1X,
     & 'P=',$P 9.3,1X,'B=',$P 9.3)
      RETURN
      END
