* SUBROUTINE UOSPW2                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 MA : ORIGINAL VERSION
*
* PURPOSE :
*  SCILAB GRAPHICAL VISUALIZATION OF PATH WITH ISOLINES AND/OR MAP - PRINTING OF THE PLOTTING INSTRUCTIONS.
*
* PARAMETERS :
*  II  POINTS  THE NUMBER OF PLOTTING POINTS
*  II  IGR  THE INDEX OF THE FIRST SELECTED VARIABLE
*  II  JGR  THE INDEX OF THE SECOND SELECTED VARIABLE
*  II  LEVEL  NUMBER OF CONTOUR LEVELS
*  II  SCALE  LINEAR OR LOGARITHMIC SCALE OF THE PLOT
*  LI  ENLX  IF THE PLOTTING BOX IN X-AXES IS SUFFICIENTLY LARGE
*  LI  ENLY  IF THE PLOTTING BOX IN Y-AXES IS SUFFICIENTLY LARGE
*  LI  CONSTF  IF THE DIFFERENCE BETWEEN MAX AND MIN OF THE PLOTTING VALUES IS SUFFICIENTLY LARGE
*  LI  INFO  INFORMATION ABOUT THE CASE: 'I' - PATH WITH ISOLINES, 'M' - PATH WITH MAP
*  II  CISLO  INDICATES THE PARAMETERS OF THE GRAPH
*
      SUBROUTINE UOSPW2
     &  (POINTS,IGR,JGR,LEVEL,SCALE,ENLX,ENLY,CONSTF,INFO,CISLO)
      $OPTION(CHEOL='^')
      INTEGER POINTS,IGR,JGR,LEVEL,SCALE,CISLO
      CHARACTER INFO
      CHARACTER*25 RET
      CHARACTER*10 ISOMAP
      LOGICAL ENLX,ENLY,CONSTF
C
      WRITE(RET,'(I15)') LEVEL
      RET=ADJUSTL(RET)
      WRITE(15,'(3A)')'level=',TRIM(RET),';'
      WRITE(15,'(A)') 'xset("fpf"," ");'
      WRITE(15,'(A)') 'ff=f'';'
      IF (INFO.EQ.'I') WRITE(15,'(A)') 'contour(x,y,ff,level);'
      IF (INFO.EQ.'M') WRITE(15,'(A)') 'Sgrayplot(x,y,ff);'
C
      WRITE(15,'(A)') 'plot(xm,ym);'
      WRITE(15,'(A)') 'p=get("hdl");'
      WRITE(15,'(A)') 'p.children.line_mode="off";'
      WRITE(15,'(A)') 'p.children.mark_mode="on";'
      WRITE(15,'(A)') 'p.children.mark_style=11;'
      WRITE(15,'(A)') 'p.children.mark_size=10;'
      IF (INFO.EQ.'I') THEN
        WRITE(15,'(A)') 'p.children.mark_foreground=-1;'
        WRITE(15,'(A)') 'p.children.mark_background=-1;'
      ENDIF
      IF (INFO.EQ.'M') THEN
        IF (CONSTF) THEN
          WRITE(15,'(A)') 'p.children.mark_foreground=-1;'
          WRITE(15,'(A)') 'p.children.mark_background=-1;'
        ELSE
          WRITE(15,'(A)') 'p.children.mark_foreground=-2;'
          WRITE(15,'(A)') 'p.children.mark_background=-2;'
        ENDIF
      ENDIF
C
      WRITE(15,'(A)') 'plot(x1,x2);'
      WRITE(15,'(A)') 'e=gce();'
      IF (MOD(CISLO,10).EQ.1) THEN
        WRITE(15,'(A)') 'e.children.line_mode="off";'
        WRITE(15,'(A)') 'e.children.mark_mode="on";'
      ELSEIF (MOD(CISLO,10).EQ.2) THEN
        WRITE(15,'(A)') 'e.children.line_mode="on";'
        WRITE(15,'(A)') 'e.children.mark_mode="off";'
      ELSEIF (MOD(CISLO,10).EQ.3) THEN
        WRITE(15,'(A)') 'e.children.line_mode="on";'
        WRITE(15,'(A)') 'e.children.mark_mode="on";'
      ENDIF
      IF (MOD(CISLO,10).EQ.2.OR.MOD(CISLO,10).EQ.3) THEN
        WRITE(15,'(A)') 'e.children.polyline_style=1;'
        WRITE(15,'(A)') 'e.children.line_style=1;'
        WRITE(15,'(A)') 'e.children.thickness=2;'
        IF (INFO.EQ.'I') WRITE(15,'(A)') 'e.children.foreground=-1;'
        IF (INFO.EQ.'M') THEN
          IF (CONSTF) THEN
            WRITE(15,'(A)') 'e.children.foreground=-1;'
          ELSE
            WRITE(15,'(A)') 'e.children.foreground=-2;'
          ENDIF
        ENDIF
      ENDIF
      IF (MOD(CISLO,10).EQ.1.OR.MOD(CISLO,10).EQ.3) THEN
        WRITE(15,'(A)') 'e.children.mark_style=9;'
        WRITE(15,'(A)') 'e.children.mark_size=4;'
        IF (INFO.EQ.'I') THEN
          WRITE(15,'(A)') 'e.children.mark_foreground=-1;'
          WRITE(15,'(A)') 'e.children.mark_background=-1;'
        ENDIF
        IF (INFO.EQ.'M') THEN
          IF (CONSTF) THEN
            WRITE(15,'(A)') 'e.children.mark_foreground=-1;'
            WRITE(15,'(A)') 'e.children.mark_background=-1;'
          ELSE
            WRITE(15,'(A)') 'e.children.mark_foreground=-2;'
            WRITE(15,'(A)') 'e.children.mark_background=-2;'
          ENDIF
        ENDIF
      ENDIF
C
      WRITE(15,'(A)') 'fw=gcf();'
      WRITE(15,'(A)') 'fw.color_map=jetcolormap(level);'
      WRITE(15,'(A)') 'mn=min(f);'
      WRITE(15,'(A)') 'mx=max(f);'
      IF (CONSTF) THEN
        WRITE(15,'(A)') 'eps=1.0d-6;'
        WRITE(15,'(A)') 'colorbar(mn-eps,mx+eps);'
      ELSE
        WRITE(15,'(A)') 'colorbar(mn,mx);'
      ENDIF
C
      WRITE(15,'(A)') 'a=gca();'
      WRITE(15,'(A)') 'a.font_size=3;'
      IF (INFO.EQ.'M') WRITE(15,'(A)') 'a.auto_ticks="on";'
      WRITE(15,'(A)') 'a.box="on";'
      IF (ENLX.OR.ENLY) THEN
        WRITE(15,'(A)') 'eps=1.0d-6;'
      ENDIF
      IF (ENLX.AND.ENLY) THEN
       WRITE(15,'(A)')
     &  'a.zoom_box=[xligr-eps, xljgr-eps, xuigr+eps, xujgr+eps];'
      ELSEIF (ENLX) THEN
       WRITE(15,'(A)')
     &  'a.zoom_box=[xligr-eps, xljgr, xuigr+eps, xujgr];'
      ELSEIF (ENLY) THEN
       WRITE(15,'(A)')
     &  'a.zoom_box=[xligr, xljgr-eps, xuigr, xujgr+eps];'
      ELSE
       WRITE(15,'(A)') 'a.zoom_box=[xligr, xljgr, xuigr, xujgr];'
      ENDIF
C
      WRITE(RET,'(I15)') POINTS
      RET=ADJUSTL(RET)
      IF (INFO.EQ.'I') ISOMAP='isolines'
      IF (INFO.EQ.'M') ISOMAP='map'
      IF (CONSTF) THEN
        IF (SCALE.EQ.2) THEN
          WRITE(15,'(5A)') 'title(''Path with ', TRIM(ISOMAP),
     &  ' (constant, log scale, ', TRIM(RET),
     &  ' points)'',''fontsize'',5);'
        ELSE
          WRITE(15,'(5A)') 'title(''Path with ', TRIM(ISOMAP),
     &  ' (constant, ', TRIM(RET), ' points)'',''fontsize'',5);'
        ENDIF
      ELSE
        IF (SCALE.EQ.2) THEN
          WRITE(15,'(5A)') 'title(''Path with ', TRIM(ISOMAP), 
     &  ' (log scale, ', TRIM(RET), ' points)'',''fontsize'',5);'
        ELSE
          WRITE(15,'(5A)') 'title(''Path with ', TRIM(ISOMAP), 
     &  ' (', TRIM(RET),' points)'',''fontsize'',5);'
        ENDIF
      ENDIF
      WRITE(RET,'(I15)') IGR
      RET=ADJUSTL(RET)
      WRITE(15,'(3A)') 'xlabel(''X(',TRIM(RET),
     & ')'',''fontsize'',4);'
      WRITE(RET,'(I15)') JGR
      RET=ADJUSTL(RET)
      WRITE(15,'(3A)') 'ylabel(''X(',TRIM(RET),
     & ')'',''fontsize'',4);'
      RETURN
      $OPTION(CHEOL=';')
      END
