* SUBROUTINE UOU1D1                ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF ENTRY TO VARIABLE METRIC UPDATE.
*
* PARAMETERS:
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  RI  XO(N)  VECTORS OF VARIABLES DIFFERENCE.
*  RI  GO(N)  GRADIENTS DIFFERENCE.
*
* COMMON DATA :
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=5-ADDITIONAL PRINT OF DEBUGGING.
*  II  LOUT  LEVEL OF PRINT. LOUT=0-PRINT OF SCALAR VALUES.
*         LOUT=1-ADDITIONAL PRINT OF BASIC VECTORS.
*         LOUT=2-ADDITIONAL PRINT OF OTHER VECTORS.
*         LOUT=3-ADDITIONAL PRINT OF MATRICES.
*  TI  NUXX  PRINTED TEXT.
*
      SUBROUTINE UOU1D1(N,XO,GO)
      $INCLUDE('UMCOMM')
      INTEGER N
      $FLOAT XO(N),GO(N)
      INTEGER I
      IF (JOUT.EQ.0) RETURN
      IF (ABS(KOUT).LE.2) RETURN
      WRITE (IWR,1) NUXX
    1 FORMAT (' ','VARIABLE METRIC UPDATE USING',1X,A6)
      IF(ABS(LOUT).LE.2) RETURN
      WRITE(IWR,2) (XO(I),I=1,MIN(N,25))
    2 FORMAT (' ','XO  =',5$P 14.5:/( 6X, 5$P 14.5))
      WRITE(IWR,3) (GO(I),I=1,MIN(N,25))
    3 FORMAT (' ','GO  =',5$P 14.5:/( 6X, 5$P 14.5))
      RETURN
      END
