* SUBROUTINE UOU1D3                ALL SYSTEMS                99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PRINT OF EXIT FROM VARIABLE METRIC UPDATE.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  H(N*(N+1)/2)  APPROXIMATION OF THE HESSIAN MATRIX.
*  RI  S(N)  AUXILIARY VECTOR.
*  RI  RHO  BIGGS'S PARAMETER.
*  RI  GAM  OREN'S PARAMETER.
*  RI  PAR  RATIO PAR=GAM/RHO.
*  RI  A  VALUE A=TRANS(GO)*H*GO.
*  RI  B  VALUE B=TRANS(GO)*XO.
*  RI  C  VALUE C=TRANS(XO)*B*XO.
*  RI  ETA  FREE PARAMETER FOR VARIABLE METRIC UPDATE.
*  RI  ETA9  MAXIMUM FOR REAL NUMBERS.
*
* COMMON DATA :
*  IO  ITERH  TERMINATION INDICATOR. ITERH<0-BAD DECOMPOSITION.
*         ITERH=0-SUCCESSFUL UPDATE. ITERH>0-NONPOSITIVE PARAMETERS.
*  II  IWR  NUMBER OF THE OUTPUT UNIT.
*  II  JOUT  SYSTEM VARIABLE WHICH SPECIFIES PRINT OF INFORMATION
*         DURING THE OPTIMIZATION PROCESS. JOUT=0-NO PRINT.
*         JOUT=1-PRINT IS REQUIRED.
*  II  KOUT  LEVEL OF PRINT. KOUT=0-NO PRINT. KOUT=1-PRINT OF INITIAL
*         VALUES AND FINAL RESULTS TOGETHER WITH PRINT OF ITERATIONS.
*         KOUT=2-ADDITIONAL PRINT OF STEPSIZE SELECTION.
*         KOUT=3-ADDITIONAL PRINT OF DIRECTION DETERMINATION.
*         KOUT=4-ADDITIONAL PRINT OF NUMERICAL DIFFERENTIATION.
*         KOUT=5-ADDITIONAL PRINT OF DEBUGGING.
*  II  LOUT  LEVEL OF PRINT. LOUT=0-PRINT OF SCALAR VALUES.
*         LOUT=1-ADDITIONAL PRINT OF BASIC VECTORS.
*         LOUT=2-ADDITIONAL PRINT OF OTHER VECTORS.
*         LOUT=3-ADDITIONAL PRINT OF MATRICES.
*  TI  TUXX  PRINTED TEXT.
*
      SUBROUTINE UOU1D3(N,H,S,RHO,GAM,PAR,A,B,C,ETA,ETA9)
      $INCLUDE ('UMCOMM')
      INTEGER N
      $FLOAT H(N*(N+1)/2),S(N),RHO,GAM,PAR,A,B,C,ETA,ETA9
      $FLOAT RAT,VAL,BET
      INTEGER I
      IF(JOUT.EQ.0) RETURN
      IF (ABS(KOUT).LE.2) RETURN
      IF (A*C.NE.ZERO) THEN
      RAT=(B/A)*(B/C)
      IF (RAT.NE.ONE) THEN
      VAL=-RAT/(ONE-RAT)
      ELSE
      VAL=-ETA9
      ENDIF
      BET=(ETA-ONE)*VAL/(ETA-VAL)
      WRITE (IWR,1) GAM,RHO,PAR,ETA,BET
    1 FORMAT (' ','GAM=',$P 9.3,1X,'RHO=',$P 9.3,1X,'PAR=',$P 9.3,1X,
     & 'ETA=',$P 9.3:1X,'BET=',$P 9.3)
      WRITE (IWR,2) A,B,C,RAT,VAL
    2 FORMAT (' ','A  =',$P 9.3,1X,'B  =',$P 9.3,1X,'C  =',$P 9.3:1X,
     & 'RAT=',$P 9.3,1X,'VAL=',$P 9.3)
      ELSE
      WRITE (IWR,1) GAM,RHO,PAR,ETA
      WRITE (IWR,2) A,B,C
      ENDIF
      WRITE (IWR,4) TUXX
    4 FORMAT (' ','END OF VARIABLE METRIC UPDATE : ',A8)
      IF (ABS(LOUT).LE.2) RETURN
      IF (ITERH.NE.0) RETURN
      WRITE (IWR,5) (S(I),I=1,MIN(N,25))
    5 FORMAT (' ','S   =',5$P 14.5:/( 6X, 5$P 14.5))
      WRITE (IWR,6) (H(I),I=1,MIN(N*(N+1)/2,30))
    6 FORMAT (' ','H   =',5$P 14.5:/( 6X, 5$P 14.5))
      RETURN
      END
