$INTERFACE UP0BS2                                             03/12/01

  CALL UP0BS2(NF,NX,NC,NCA,$X,$XO,$IX,$XL,$XU,$XSL,$XSU,$CF,$CFD,$IC&
,$CL,$CU,$CSL,$CSU,$ICA,$S,$GS(NF+1),R,RPF2,RPF3,FC,F,MEP)
  $ADD(REAL,'\$X($NF)\$XL($NX)\$XU($NX)\$XSL($NX)\$XSU($NX)\$XZL($NX)&
  \$XZU($NX)\$CF($NC+1)\$CFD($NC)\$CL($NC)\$CU($NC)\$CSL($NC)&
  \$CSU($NC)\$CZL($NC)\$CZU($NC)\S($NF+$NCA)\GS($NF+$NCA)')
  $ADD(INTEGER,'\$IX($NX)\$IC($NC)\$ICA($NCA)')
$REM  $ADD(REAL,'\R\RPF2\RPF3\FC\F')
$REM  $ADD(INTEGER,'\NF\NX\NC\NCA\MEP')
  $ADD(INIT)
    NBFX='UP0BS2'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UP0BS2             ALL SYSTEMS                 03/12/01
C PORTABILITY : ALL SYSTEMS
C 03/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF VALUE OF THE BARRIER FUNCTION.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NX  NUMBER OF BOX CONSTRAINTS.
*  II  NC  NUMBER OF GENERAL CONSTRAINTS.
*  II  NCA  NUMBER OF ACTIVE CONSTRAINTS.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  XP(NF)  PREVIOUS VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  RI  XSL(NX)  VECTOR CONTAINING LOVER SLACKS FOR VARIABLES.
*  RI  XSU(NX)  VECTOR CONTAINING UPPER SLACKS FOR VARIABLES.
*  RI  CF(NC+1)  VECTOR CONTAINING VALUES OF CONSTRAINT FUNCTIONS.
*  RI  CFD(NC)  VECTOR CONTAINING INCREMENTS OF CONSTRAINT FUNCTIONS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CSL(NC)  VECTOR CONTAINING LOVER SLACKS FOR CONSTRAINTS.
*  RI  CSU(NC)  VECTOR CONTAINING UPPER SLACKS FOR CONSTRAINTS.
*  II  ICA(NCA)  VECTOR CONTAINING INDICES OF ACTIVE CONSTRAINTS.
*  RI  S(NCA)  VECTOR CONTAINING NEWTON INCREMENTS.
*  RI  GS(NCA)  VECTOR CONTAINING ACTIVE SLACK INCREMENTS.
*  RI  R  STEPSIZE  PARAMETER.
*  RI  RPF2  PENALTY COEFFICIENT.
*  RI  RPF3  BARRIER COEFFICIENT.
*  RO  FC  VALUE OF THE PENALTY TERM.
*  RO  F  VALUE OF THE BARRIER FUNCTION.
*  II  MEP  CHOICE OF A MERIT FUNCTION. MEP=0-MERIT FUNCTION IS
*            NOT USED. MEP=1-L2 AUGMENTED BARRIER FUNCTION.
*            MEP=2-L2 AUGMENTED LAGRANGIAN FUNCTION.
*
*  COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*  II  KBC  SPECIFICATION OF LINEAR CONSTRAINTS. KBC=0-NO LINEAR
*         CONSTRAINTS. KBC=1-ONE SIDED LINEAR CONSTRAINTS. KBC=2=TWO
*         SIDED LINEAR CONSTRAINTS.
*
      SUBROUTINE UP0BS2(NF,NX,NC,NCA,X,XP,IX,XL,XU,XSL,XSU,CF,CFD,IC,
     & CL,CU,CSL,CSU,ICA,S,GS,R,RPF2,RPF3,FC,F,MEP)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NX,NC,NCA,IX(NX),IC(NC),ICA(NCA),MEP
      $FLOAT X(NF),XP(NF),XL(NX),XU(NX),XSL(NX),XSU(NX),CF(NC+1),
     & CFD(NC),CL(NC),CU(NC),CSL(NC),CSU(NC),S(*),GS(*),R,RPF2,RPF3,
     & FC,F
      INTEGER I,K,KK
      $FLOAT RP,TMP,TEMP,CON
      IF (MEP.EQ.1) THEN
      CON=0.95$P 0
      ELSE
      CON=0.99$P 0
      ENDIF
      F=CF(NC+1)
      FC=0.0$P 0
      DO 1 I=1,NCA
      RP=R
      K=ICA(I)
      IF (K.LT.0) THEN
      K=-K
      KK=-IX(K)
      IF (KK.EQ.1.OR.KK.EQ.3) THEN
      IF (GS(I).LT.ZERO) RP=MIN(RP,-CON*XSL(K)/GS(I))
      TMP=XSL(K)+RP*GS(I)
      TEMP=XL(K)-X(K)+TMP
      F=F-RPF3*LOG(TMP)
      FC=FC+TEMP**2
      ELSE IF (KK.EQ.2.OR.KK.EQ.4) THEN
      IF (GS(I).LT.ZERO) RP=MIN(RP,-CON*XSU(K)/GS(I))
      TMP=XSU(K)+RP*GS(I)
      TEMP=X(K)-XU(K)+TMP
      F=F-RPF3*LOG(TMP)
      FC=FC+TEMP**2
      ENDIF
      ELSE
      KK=-IC(K)
      IF (KK.EQ.1.OR.KK.EQ.3) THEN
      IF (GS(I).LT.ZERO) RP=MIN(RP,-CON*CSL(K)/GS(I))
      TMP=CSL(K)+RP*GS(I)
      TEMP=CL(K)-CF(K)+TMP
      F=F-RPF3*LOG(TMP)
      FC=FC+TEMP**2
      ELSE IF (KK.EQ.2.OR.KK.EQ.4) THEN
      IF (GS(I).LT.ZERO) RP=MIN(RP,-CON*CSU(K)/GS(I))
      TMP=CSU(K)+RP*GS(I)
      TEMP=CF(K)-CU(K)+TMP
      F=F-RPF3*LOG(TMP)
      FC=FC+TEMP**2
      ELSE IF (KK.EQ.5) THEN
      FC=FC+CF(K)**2
      ENDIF
      ENDIF
    1 CONTINUE
      IF (KBF.GT.0) THEN
      DO 2 K=1,NX
      RP=R
      KK=IX(K)
      IF (KK.EQ.1.OR.KK.EQ.3.OR.ABS(KK).EQ.4) THEN
      TMP=XP(K)+S(K)-XL(K)-XSL(K)
      IF (TMP.LT.ZERO) RP=MIN(RP,-CON*XSL(K)/TMP)
      TEMP=XL(K)-X(K)+XSL(K)+RP*TMP
      F=F-RPF3*LOG(TMP)
      FC=FC+TEMP**2
      ENDIF
      IF (KK.EQ.2.OR.KK.EQ.4.OR.ABS(KK).EQ.3) THEN
      TMP=XU(K)-XP(K)-S(K)-XSU(K)
      IF (TMP.LT.ZERO) RP=MIN(RP,-CON*XSU(K)/TMP)
      TEMP=X(K)-XU(K)+XSU(K)+RP*TMP
      F=F-RPF3*LOG(TMP)
      FC=FC+TEMP**2
      ENDIF
    2 CONTINUE
      ENDIF
      IF (KBC.GT.0) THEN
      DO 3 K=1,NC
      RP=R
      KK=IC(K)
      IF (KK.EQ.1.OR.KK.EQ.3.OR.ABS(KK).EQ.4) THEN
      TMP=CFD(K)-CL(K)-CSL(K)
      IF (TMP.LT.ZERO) RP=MIN(RP,-CON*CSL(K)/TMP)
      TEMP=CL(K)-CF(K)+CSL(K)+RP*TMP
      F=F-RPF3*LOG(TMP)
      FC=FC+TEMP**2
      ENDIF
      IF (KK.EQ.2.OR.KK.EQ.4.OR.ABS(KK).EQ.3) THEN
      TMP=CU(K)-CFD(K)-CSU(K)
      IF (TMP.LT.ZERO) RP=MIN(RP,-CON*CSU(K)/TMP)
      TEMP=CF(K)-CU(K)+CSU(K)+RP*TMP
      F=F-RPF3*LOG(TMP)
      FC=FC+TEMP**2
      ENDIF
    3 CONTINUE
      ENDIF
      F=F+RPF2*SQRT(FC)
      RETURN
      END
