$INTERFACE UP0BX1                                             07/12/01

  CALL UP0BX1(NA,$X(NF+1),$AF,F,FF,PAR,PARLOG,RPF3,MEP,IEXT)
  $ADD(REAL,'\$X($NF+1)\$AF($NA)')
  $ADD(REAL,'\PARLOG')
$REM  $ADD(REAL,'\F\FF\PAR\RPF3')
$REM  $ADD(INTEGER,'\NF\NA\MEP\IEXT')
  $ADD(INIT)
    NPFX='UP0BX1'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UP0BX1             ALL SYSTEMS                   07/12/01
C PORTABILITY : ALL SYSTEMS
C 07/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF VALUE OF THE AUGMENTED LAGRANGIAN FUNCTION.
*
* PARAMETERS :
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  RI  Z  MINIMAX SLACK VARIABLE.
*  RI  AF(NA)  VECTOR CONTAINING VALUES OF APPROXIMATED FUNCTIONS.
*  RO  F  VALUE OF THE BARRIERY FUNCTION.
*  RI  FF  VALUE OF THE MINIMAF FUNCTION.
*  RI  PAR  PARAMETER OF THE BOUNDED BARRIER.
*  RI  PARLOG  LOWER BOUND OF THE BOUNDED BARRIER.
*  RI  RPF3  BARRIER COEFFICIENT.
*  II  MEP  TYPE OF BARRIER USED.
*  II  IEXT  KIND OF THE MINIMAX APPROXIMATION. IEXT=0-CHEBYSHEV
*         APPROXIMATION. IEXT=-1-MINIMAX. IEXT=+1-MAXIMIN.
*
      SUBROUTINE UP0BX1(NA,Z,AF,F,FF,PAR,PARLOG,RPF3,MEP,IEXT)
      INTEGER NA,MEP,IEXT
      $FLOAT Z,AF(NA),PAR,PARLOG,RPF3,F,FF
      $FLOAT FA
      INTEGER KA
      IF (Z.LE.FF) THEN
      F=1.0$(P)120
      RETURN
      ENDIF
      F=Z
      GO TO (10,30,20,50,40),MEP
   10 DO 11 KA=1,NA
      FA=AF(KA)
      IF (IEXT.LE.0) THEN
      F=F-RPF3*LOG(Z-FA)
      ENDIF
      IF (IEXT.GE.0) THEN
      F=F-RPF3*LOG(Z+FA)
      ENDIF
   11 CONTINUE
      RETURN
   20 DO 21 KA=1,NA
      FA=AF(KA)
      IF (IEXT.LE.0) THEN
      IF (Z-FA.LE.PAR) THEN
      F=F-RPF3*LOG(Z-FA)
      ELSE
      F=F+RPF3*((2.0$P 0-0.5$P 0*PAR/(Z-FA))*PAR/(Z-FA)-PARLOG)
      ENDIF
      ENDIF
      IF (IEXT.GE.0) THEN
      IF (Z+FA.LE.PAR) THEN
      F=F-RPF3*LOG(Z+FA)
      ELSE
      F=F+RPF3*((2.0$P 0-0.5$P 0*PAR/(Z+FA))*PAR/(Z+FA)-PARLOG) 
      ENDIF
      ENDIF
   21 CONTINUE
      RETURN
   30 DO 31 KA=1,NA
      FA=AF(KA)
      IF (IEXT.LE.0) THEN
      F=F+RPF3*LOG(1.0$P 0/(Z-FA)+1.0$P 0/PAR)
      ENDIF
      IF (IEXT.GE.0) THEN
      F=F+RPF3*LOG(1.0$P 0/(Z+FA)+1.0$P 0/PAR)
      ENDIF
   31 CONTINUE
      RETURN
   40 DO 41 KA=1,NA
      FA=AF(KA)
      IF (IEXT.LE.0) THEN
      F=F+RPF3*RPF3/(Z-FA)
      ENDIF
      IF (IEXT.GE.0) THEN
      F=F+RPF3*RPF3/(Z+FA)
      ENDIF
   41 CONTINUE
      RETURN
   50 DO 51 KA=1,NA
      FA=AF(KA)
      IF (IEXT.LE.0) THEN
      IF (Z-FA.LE.PAR) THEN
      F=F-RPF3*LOG(Z-FA)
      ELSE
      F=F+RPF3*(4.0$P 0*SQRT(PAR/(Z-FA))-PAR/(Z-FA)-PARLOG)
      ENDIF
      ENDIF
      IF (IEXT.GE.0) THEN
      IF (Z+FA.LE.PAR) THEN
      F=F-RPF3*LOG(Z+FA)
      ELSE
      F=F+RPF3*(4.0$P 0*SQRT(PAR/(Z+FA))-PAR/(Z+FA)-PARLOG)
      ENDIF
      ENDIF
   51 CONTINUE
      RETURN
      END
