$INTERFACE UPPRE2                                             97/12/01

  CALL UPPRE2(NC,$CF,$IC,$CL,$CU,$CFD,$CP,FC,R,PP)
  $ADD(REAL,'\$CF($NC+1)\$CL($NC)\$CU($NC)\$CFD($NC+1)\$CP($NC)')
$REM  $ADD(REAL,'\FC\R\PP')
  $ADD(INTEGER,'\$IC($NC)')
$REM  $ADD(INTEGER,'\NC')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UPPRE2             ALL SYSTEMS                 97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF VALUE  OF THE L1 EXACT PENALTY FUNCTION.
*
* PARAMETERS :
*  II  NC  NUMBER OF CONSTRAINTS.
*  RI  CF(NC+1)  VECTOR CONTAINING VALUES OF THE CONSTRAINT
*         FUNCTIONS.
*  II  IC(NC)  VECTOR CONTAINING TYPES OF CONSTRAINTS.
*  RI  CL(NC)  VECTOR CONTAINING LOWER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CU(NC)  VECTOR CONTAINING UPPER BOUNDS FOR CONSTRAINT FUNCTIONS.
*  RI  CFD(NC+1) VECTOR CONTAINING INCREMENT OF THE CONSTRAINT
*         FUNCTIONS.
*  RI  CP(NC)  VECTOR CONTAINING PENALTY PARAMETERS.
*  RI  FC  VALUE OF THE PENALTY TERM.
*  RO  R  VALUE OF THE STEPSIZE PARAMETER.
*  RU  PP  PREDICTED VALUE.
*
      SUBROUTINE UPPRE2(NC,CF,IC,CL,CU,CFD,CP,FC,R,PP)
      INTEGER NC,IC(NC)
      $FLOAT CF(NC+1),CL(NC),CU(NC),CFD(NC+1),CP(NC),FC,R,PP
      $FLOAT POM,TEMP
      INTEGER KC
      PP=PP+R*CFD(NC+1)-FC
      DO 1 KC=1,NC
      IF (IC(KC).GT.0) THEN
      POM=0.0$P 0
      TEMP=CF(KC)+R*CFD(KC)
      IF (IC(KC).EQ.1.OR.IC(KC).GE.3) POM=MIN(POM,TEMP-CL(KC))
      IF (IC(KC).EQ.2.OR.IC(KC).GE.3) POM=MIN(POM,CU(KC)-TEMP)
      IF (POM.LT.0.0$P 0) THEN
      PP=PP-CP(KC)*POM
      ENDIF
      ENDIF
    1 CONTINUE
      RETURN
      END
