$INTERFACE UPSETG                                             05/12/01

  CALL UPSETG(NF,NA,MA,$AF,$AG,$IAG,$JAG,$AZL,$AZU,$XO,FF,RPF3,IEXT)
  $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)')
  $ADD(REAL,'\$AF($NA)\$AG($MA)\$AZL($NA)\$AZU($NA)\$XO($NF)')
$REM  $ADD(REAL,'\FF\RPF3\GNORM')
$REM  $ADD(INTEGER,'\NF\NA\MA\IEXT')
  $ADD(INIT)
    NPFX='UPSETG'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UPSETG             ALL SYSTEMS                 05/12/01
C PORTABILITY : ALL SYSTEMS
C 05/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF VALUE OF THE AUGMENTED LAGRANGIAN FUNCTION.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  RI  AF(NA)  VECTOR CONTAINING VALUES OF APPROXIMATED FUNCTIONS.
*  RI  RPF3  BARRIER COEFFICIENT.
*  II  IEXT  KIND OF THE MINIMAX APPROXIMATION. IEXT=0-CHEBYSHEV
*         APPROXIMATION. IEXT=-1-MINIMAX. IEXT=+1-MAXIMIN.
*
      SUBROUTINE UPSETG(NF,NA,MA,AF,AG,IAG,JAG,AZL,AZU,G,FF,RPF3,IEXT)
      INTEGER NF,NA,MA,IAG(NA+1),JAG(MA),IEXT
      $FLOAT AF(NA),AG(MA),AZL(NA),AZU(NA),G(NF),FF,RPF3
      $FLOAT FA,BET,TEMP
      INTEGER KA,J,JP,K,L
      TEMP=0.0$P 0
      DO 1 KA=1,NA
      FA=AF(KA)
      IF (IEXT.EQ.0) THEN
      TEMP=TEMP+EXP(-(FF-FA)/RPF3)+EXP(-(FF+FA)/RPF3)
      ELSE IF (IEXT.LT.0) THEN
      TEMP=TEMP+EXP(-(FF-FA)/RPF3)
      ELSE IF (IEXT.GT.0) THEN
      TEMP=TEMP+EXP(-(FF+FA)/RPF3)
      ENDIF
    1 CONTINUE
      DO 3 KA=1,NA
      FA=AF(KA)
      IF (IEXT.EQ.0) THEN
      AZL(KA)=EXP(-(FF+FA)/RPF3)/TEMP
      AZU(KA)=EXP(-(FF-FA)/RPF3)/TEMP
      BET= AZU(KA)-AZL(KA)
      ELSE IF (IEXT.LT.0) THEN
      AZU(KA)=EXP(-(FF-FA)/RPF3)/TEMP
      BET= AZU(KA)
      ELSE IF (IEXT.GT.0) THEN
      AZL(KA)=EXP(-(FF+FA)/RPF3)/TEMP
      BET=-AZL(KA)
      ENDIF
      K=IAG(KA)
      L=IAG(KA+1)-K
      DO 2 J=1,L
      JP=ABS(JAG(K))
      G(JP)=G(JP)+BET*AG(K)
      K=K+1
    2 CONTINUE
    3 CONTINUE
      RETURN
      END
