* SUBROUTINE UQADDV                ALL SYSTEMS                98/12/01
* PORTABILITY : ALL SYSTEMS
* 98/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  APPEND A VALUE TO A MACRO VARIABLE
*
* PARAMETERS :
*  TI  BUFFER(MLENB) - WORK BUFFER
*  II  MLENB - MAX. LENGTH OF THE BUFFER
*  II  IPOS11 - POSITION OF THE FIRST CHARACTER OF A MACRO NAME
*               IN THE BUFFER
*  II  IPOS12 - POSITION OF THE LAST CHARACTER OF A MACRO NAME
*               IN THE BUFFER
*  II  IPOS13 - POSITION OF THE FIRST CHARACTER OF A MACRO VALUE
*  II  IPOS14 - POSITION OF THE LAST CHARACTER OF A MACRO VALUE
*  TU  SYMTAB(MLENST) - SYMBOL TABLE
*  II  MLENST - MAX. LENGTH OF THE SYMBOL TABLE
*  IU  IPOINT(MNP,6) - ARRAY OF POINTERS TO THE SYMBOL TABLE
*               1-LINK, 2-POSITION OF THE FIRST CHARACTER,
*               3-LENGTH OF NAME, 4-POSITION OF THE LAST CHARACTER,
*               5-POINTER OF LIST, 6-MODERW (1-RW, 2-RA, 3-RO)
*  II  MNP - MAX. NUMBER OF POINTERS
*  II  IOPT - IOPT=1 - VALUE OF MACRO IS IN THE BUFFER
*             IOPT=2 - VALUE OF MACRO IS IN THE SYMBOL TABLE
*  IO  IER - ERROR INDICATOR
*
* COMMON DATA :
*  IU  LENST - ACTUAL LENGTH OF THE SYMBOL TABLE
*  IU  LP - LAST POINTER TO THE SYMBOL TABLE
*
* SUBPROGRAMS USED :
*  LF  UQVDEF - IS MACRO DEFINED IN THE SYMBOL TABLE ?
*  S   UQSETV - SET A MACRO TO THE SYMBOL TABLE
*
      SUBROUTINE UQADDV(BUFFER,MLENB,IPOS11,IPOS12,IPOS13,IPOS14,
     *                  SYMTAB,MLENST,IPOINT,MNP,IOPT,IER)
      INTEGER MLENB,IPOS11,IPOS12,IPOS13,IPOS14,MLENST,
     *                  MNP,IPOINT(MNP,6),IOPT,IER
      CHARACTER*1 BUFFER(MLENB),SYMTAB(MLENST)
C ----------------------------------------------------------------------
      INTEGER        LENB,LENST,LP,ILNLEN,OLNLEN,MODERW,DIALOG,IUNIT,
     *        OUNIT,INUNIT,IIUNIT,OIUNIT,NOPT,LENOPT(30),NSUB,MNSUB,
     *        NDIR,LENDIR(30),NMSG,MNIF,NIF1,NIF2,TABCH(0:255),ADF,
     *        ADA,ADC,ARD,CRD
      COMMON/UQINT2/ LENB,LENST,LP,ILNLEN,OLNLEN,MODERW,DIALOG,IUNIT,
     *        OUNIT,INUNIT,IIUNIT,OIUNIT,NOPT,LENOPT,NSUB,MNSUB,
     *        NDIR,LENDIR,NMSG,MNIF,NIF1,NIF2,TABCH,ADF,ADA,ADC,ARD,CRD
      INTEGER*4      LABEL1,LABEL2,MAXLAB,LEVLAB(20)
      COMMON/UQINT4/ LABEL1,LABEL2,MAXLAB,LEVLAB
      CHARACTER*1    CHCON,CHEOL,CHDS,CHDIR,WTRUE(6),WFALSE(7),
     *        ASCII(32:127),OPTNM(200),DIRNM(200)
      COMMON/UQCHR1/ CHCON,CHEOL,CHDS,CHDIR,WTRUE,WFALSE,
     *        ASCII,OPTNM,DIRNM
      CHARACTER*50   FN1,FN2,FNAMES(20),NAME,MSG(50)*70
      COMMON/UQCHRX/ FN1,FN2,FNAMES,NAME,MSG
      LOGICAL        LFORTO,LSMLET,LFRFMT,LSUBS,LOUT,LHELP,LIFDON(20),
     *        LELSE(20),CONDIF,CONDDO,LOOP,SIFDEC,DIALGR,LPERFD
      COMMON/UQLOGL/ LFORTO,LSMLET,LFRFMT,LSUBS,LOUT,LHELP,LIFDON,
     *        LELSE,CONDIF,CONDDO,LOOP,SIFDEC,DIALGR,LPERFD
C ----------------------------------------------------------------------
      INTEGER I,J,LEN,IP,IPPRED,IPOS
      LOGICAL UQVDEF
      INTEGER LENADD
      PARAMETER(LENADD=500)
C
C     FIND MACRO
C
      IF(.NOT.UQVDEF(BUFFER,MLENB,IPOS11,IPOS12,SYMTAB,
     *    MLENST,IPOINT,MNP,LP,IP,IPPRED)) GOTO 6
C
C     APPEND
C
      LEN=IPOS14-IPOS13+1
      IF(LEN.LE.0) RETURN
      IF(IPOINT(IP,6).GT.2) GOTO 5
      IF(IP.NE.LP.AND.IPOINT(IPPRED,2)-IPOINT(IP,4).GT.LEN) THEN
        IPOS=IPOINT(IP,4)+1
      ELSEIF(IP.EQ.LP.AND.IPOINT(IP,4)+LEN.LE.MLENST) THEN
        IPOS=IPOINT(IP,4)+1
        LENST=MIN(IPOINT(IP,4)+LEN+LENADD,MLENST)
      ELSE
        IF(IP.EQ.LP) THEN
          LP=IPOINT(IP,1)
          LENST=IPOINT(LP,4)
        ELSE
          IPOINT(IPPRED,1)=IPOINT(IP,1)
        ENDIF
        IPOINT(IP,1)=-1
        I=IPOINT(IP,2)+IPOINT(IP,3)
        J=IPOINT(IP,4)
        CALL UQSETV(BUFFER,MLENB,IPOS11,IPOS12,I,J,SYMTAB,MLENST,
     *              IPOINT,MNP,2,IER)
        IF(IER.NE.0) RETURN
        IF(LENST+LEN.GT.MLENST) GOTO 4
        IPOS=LENST+1
        LENST=MIN(LENST+LEN+LENADD,MLENST)
        IP=LP
      ENDIF
      IF(IOPT.EQ.1) THEN
        DO 2 I=0,LEN-1
          SYMTAB(IPOS+I)=BUFFER(IPOS13+I)
    2   CONTINUE
      ELSE
        DO 3 I=0,LEN-1
          SYMTAB(IPOS+I)=SYMTAB(IPOS13+I)
    3   CONTINUE
      ENDIF
      IPOINT(IP,4)=IPOINT(IP,4)+LEN
      RETURN
C
C ERROR: MAX. LENGTH OF SYMBOL TABLE EXCEEDED
C
    4 IER=4
      RETURN
C
C ERROR: ATTEMPT TO ADD TO RO VARIABLE
C
    5 IER=5
      RETURN
C
C ERROR: ATTEMPT TO ADD TO UNDEFINED VARIABLE
C
C   6 IER=6
    6 CALL UQSETV(BUFFER,MLENB,IPOS11,IPOS12,IPOS13,IPOS14,
     *            SYMTAB,MLENST,IPOINT,MNP,IOPT,IER)
      RETURN
      END

