* SUBROUTINE UQADI3               ALL SYSTEMS                16/12/01
* PORTABILITY : ALL SYSTEMS
* 16/12/01 HA : ORIGINAL VERSION
*
* PURPOSE :
*  AUTOMATICAL DIFFERENTIATION OF FMODELX - REVERSE AND FORWARD MODE
*  SECOND DERIVATIVES
*
* PARAMETERS :
*  TU  SYMTAB(MLENST) - SYMBOL TABLE
*  II  MLENST - MAX. LENGTH OF THE SYMBOL TABLE
*               IN THE SYMBOL TABLE
*  IU  IPOINT(MNP,6) - ARRAY OF POINTERS TO THE SYMBOL TABLE
*               1-LINK, 2-POSITION OF THE FIRST CHARACTER,
*               3-LENGTH OF NAME, 4-POSITION OF THE LAST CHARACTER,
*               5-POINTER OF LIST, 6-MODERW (1-RW, 2-RA, 3-RO)
*  II  MNP - MAX. NUMBER OF POINTERS
*  CI  CHX - TYPE OF A MODEL FUNCTION ('A'-APPROXIMATING,
*            'C'-CONSTRAINT, 'F'-OBJECTIVE).
*  IO  IER - ERROR INDICATOR
*
* COMMON DATA:
*  II  LP - LAST POINTER TO THE SYMBOL TABLE
*  II  LENOPT(NOPT) - LENGTHS OF OPTION PARAMETER NAMES
*  TI  OPTNM(*) - NAMES OF OPTION PARAMETERS
*  II  NOPT - NUMBER OF OPTIONS
*  II  LENST - ACTUAL LENGTH OF THE BUFFER
*  TI  WTRUE - STRING '.TRUE.'
*  TI  WFALSE - STRING '.FALSE.'
*  TU  CHDIR - THE DIRECTIVE CHARACTER
*  TU  CHEOL - THE END OF LINE MARKER
*  TU  CHCON - THE CONTINUATION MARKER
*  TU  CHDS - THE DATA SEPARATOR MARKER
*  TU  FN1 - FILENAME PART 1 (E.G. LIBRARY)
*  TU  FN2 - FILENAME PART 2 (E.G. EXTENSION)
*  IU  DIALOG - TYPE OF DIALOGUE (0-NO DIALOGUE, 1-SHORT DIALOGUE,
*               2-FULL DIALOGUE)
*  IU  MODERW - READ/WRITE MODE (1-READ/WRITE, 2-READ/APPEND,
*               3-READ ONLY)
*  IU  ILNLEN - THE NUMBER OF CHARACTERS PER LINE OF INPUT
*  IU  OLNLEN - THE NUMBER OF CHARACTERS PER LINE OF OUTPUT
*  IU  OUNIT - THE OUTPUT UNIT NUMBER
*  IU  IUNIT - THE INPUT UNIT NUMBER
*  IU  INUNIT - THE INCLUDE UNIT NUMBER
*  IU  IIUNIT - THE INPUT INTERACTIVE UNIT NUMBER
*  IU  OIUNIT - THE OUTPUT INTERACTIVE UNIT NUMBER
*  IU  LABEL1 - STARTING VALUE OF LABEL
*  IU  LABEL2 - STEP OF LABEL AFTER SUBST('FILENAME')
*  LU  LSUBS - PERFORM SUBSTITUTIONS ?
*  LU  LFORTO - IS IT A FORTRAN ?
*  LU  LOUT - OUTPUT FILE ?
*  LU  LSMLET - LOWER CASE LETTERS ALLOWED ?
*  LU  LFRFMT - IS IT A FORTRAN IN FREE FORMAT ?
*
* SUBPROGRAMS USED :
*  S   UQCUTE  SIF FILES DECODER.
*
      SUBROUTINE UQADI3(SYMTAB,MLENST,IPOINT,MNP,CHX,IER)
      $OPTION(CHEOL='^')
      INTEGER MLENST,MNP,IPOINT(MNP,6),IER
      CHARACTER*1 SYMTAB(MLENST),CHX
C ----------------------------------------------------------------------
      INTEGER        LENB,LENST,LP,ILNLEN,OLNLEN,MODERW,DIALOG,IUNIT,
     *        OUNIT,INUNIT,IIUNIT,OIUNIT,NOPT,LENOPT(30),NSUB,MNSUB,
     *        NDIR,LENDIR(30),NMSG,MNIF,NIF1,NIF2,TABCH(0:255),ADF,
     *        ADA,ADC,ARD,CRD
      COMMON/UQINT2/ LENB,LENST,LP,ILNLEN,OLNLEN,MODERW,DIALOG,IUNIT,
     *        OUNIT,INUNIT,IIUNIT,OIUNIT,NOPT,LENOPT,NSUB,MNSUB,
     *        NDIR,LENDIR,NMSG,MNIF,NIF1,NIF2,TABCH,ADF,ADA,ADC,ARD,CRD
      INTEGER*4      LABEL1,LABEL2,MAXLAB,LEVLAB(20)
      COMMON/UQINT4/ LABEL1,LABEL2,MAXLAB,LEVLAB
      CHARACTER*1    CHCON,CHEOL,CHDS,CHDIR,WTRUE(6),WFALSE(7),
     *        ASCII(32:127),OPTNM(200),DIRNM(200)
      COMMON/UQCHR1/ CHCON,CHEOL,CHDS,CHDIR,WTRUE,WFALSE,
     *        ASCII,OPTNM,DIRNM
      CHARACTER*50   FN1,FN2,FNAMES(20),MSG(50)*70
      COMMON/UQCHRX/ FN1,FN2,FNAMES,MSG
      LOGICAL        LFORTO,LSMLET,LFRFMT,LSUBS,LOUT,LHELP,LIFDON(20),
     *        LELSE(20),CONDIF,CONDDO,LOOP,SIFDEC,DIALGR,LPERFD
      COMMON/UQLOGL/ LFORTO,LSMLET,LFRFMT,LSUBS,LOUT,LHELP,LIFDON,
     *        LELSE,CONDIF,CONDDO,LOOP,SIFDEC,DIALGR,LPERFD
C ----------------------------------------------------------------------
      INTEGER IP,IPPRED,J,I,LENM,LENN,IPOS,K,L,M,N,N1,LEN1
C     FORMF je obsah promenne FMODELX, ktery budeme transformovat
C     (ZDE VSAK JAKO CHAR-RETEZEC)
      CHARACTER*5000 FORMF
C     ADFORMF je ztransformovany postup pro FGMODELX
C     (ZDE VSAK JAKO CHAR-RETEZEC)
       CHARACTER*10000 ADFORMF
C     LFORMF je delka FORMF
C     LADFORMF je delka ADFORMF
      INTEGER LFORMF,LADFORMF
C      ADVARIA je seznam promennych, ktere zavisi na X (nezav.prom.)
       CHARACTER*1001 ADVARIA
C     LADVARIA je akt.delka ADVARIA
      INTEGER LADVARIA
C     PADVARIA je pole ukazatelu na ADVARIA
       INTEGER PADVARIA(101)
C     KON_RA je posledni znak na radku, nepocitaje stredniky
      INTEGER IKON_RA,IZAC_RA
C     IKON_RAP je zaloha IKON_RA, potrebna v transformaci vyrazu
      INTEGER IKON_RAP
C     LCOMMA je indikator strdeniku na konci radku
      LOGICAL LCOMMA
      LOGICAL LTEMP   !POMOCNA
C     AVYRAZ JE 2D-POLE PRO ULOZENI INFORMACI PRI REKURZI PRI
C     TRANSFORMACI VYRAZU
C     1. PARAMETR: VRSTVA REKURZE, MAX. 50
C     2. PARAMETR: 1: LEVA  CAST TRANSFORMOVANEHO VYRAZU - ZACATEK
C                  2: LEVA  CAST TRANSFORMOVANEHO VYRAZU - KONEC
C                  3: PRAVA CAST TRANSFORMOVANEHO VYRAZU - ZACATEK
C                  4: PRAVA CAST TRANSFORMOVANEHO VYRAZU - KONEC
C                  5: ZPRACOVAVANA OPERACE (CISELNIK STEJNY JAKO VE
C                     RVRSWP()) 100 JE VOLANI NEJAKE FUNKCE(....)
C                  6: INFORMACE, NA KTERE MISTO SE VRATIT PRI SKOKU
C                     NA PREDCHEZJICI (SMEREM VEN) UROVEN REKURZE
C                     MOZNOSTI: DOPROSTRED - TJ. 1, VIZ LABEL=209
C                               NAKONEC    - TJ. 2, VIZ LABEL=210
C                  7: NEJAKY DLUH K ZAPSANI NAKONEC? (ZAVORKY PRI VOLANI
C                     FUNKCI ATP.) 1 JE UZAVIRACI ZAVORKA
      INTEGER AVYRAZ(50,7)
C     UROVEN JE AKTUALNI UROVEN V REKURZI (1 JE "ZAKLADNI", BEZ REKURZE)
      INTEGER UROVEN
C     ADFCTN JE POLE NAZVU FUNKCI,PREPSANYCH PRO POUZITI PRI
C     AUTOMATICKEM DERIVOVANI - STARY A NOVY NAZEV VZDY ZA SEBOU
C        NAPRIKLAD SIN A SING ATP.
      CHARACTER*1000 ADFCTN
C     LADFCTN JE POLE UKZATALU NA POLE ADFCTN
      INTEGER LADFCTN(101) ! 2*50+1
C     NADFCTN JE POCET TAKTO PREPSANYCH FUNKCI
      INTEGER NADFCTN
C     PRIOR1 AZ PRIOR3 JSOU PRO NALEZENI OPERACE S NEJNIZSI PRIORITOU
C     (VIZ ANALYZA VYRAZU)
C     PRIOR1 JE **, PRIOR2 JE * A /, PRIOR3 JE + A -
      INTEGER PRIOR1,PRIOR2,PRIOR3
C     ALBL1 JE POLE LABELU, POUZITYCH VE VYPOCTU
C     ALBL2 JE POLE LABELU, KTERE JE PRI VYPOCTU 2.DERIVACE NAHRADI
      CHARACTER*1000 ALBL1
      CHARACTER*1000 ALBL2
C     LALBL1 JE POLE UKZATALU NA POLE ALBL1
C     LALBL2 JE POLE UKZATALU NA POLE ALBL2
      INTEGER LALBL1(101), LALBL2(101)
C     NALBL JE POCET TAKTO PREPSANYCH LABELU
      INTEGER NALBL
C     ALABEL JE POMOCNA PROMENNA PRO NAHRAZOVANI LABELU
C     CLABEL JE KANDIDAT NA NOVY LABEL
       CHARACTER*5 ALABEL, CLABEL
C     ILABEL JE PRO NOVE CISLO LABELU,
C     LLABEL JE DELKA CLABEL
      INTEGER ILABEL, LLABEL
C ----------------------------------------------------------------------

      CALL UYLETC(MLENST,SYMTAB,1)

      WRITE(*,*) '--- ZACATEK UQADI3 ---'

C     FMODELX -> HMODELX

C     DEFINICE JMEN PREPSANYCH FUNKCI PRO POUZITI PRI AUTOMATICKEM
C     DERIVOVANI
       ADFCTN( 1: 3)='EXP'
       ADFCTN( 4: 8)='EXPG2'
      LADFCTN(    1)=1
      LADFCTN(    2)=4
       ADFCTN( 9:11)='LOG'
       ADFCTN(12:16)='LOGG2'
      LADFCTN(    3)=9
      LADFCTN(    4)=12
       ADFCTN(17:19)='SIN'
       ADFCTN(20:24)='SING2'
      LADFCTN(    5)=17
      LADFCTN(    6)=20
       ADFCTN(25:27)='COS'
       ADFCTN(28:32)='COSG2'
      LADFCTN(    7)=25
      LADFCTN(    8)=28
       ADFCTN(33:35)='ABS'
       ADFCTN(36:40)='ABSG2'
      LADFCTN(    9)=33
      LADFCTN(   10)=36
       ADFCTN(41:44)='SQRT'
       ADFCTN(45:50)='SQRTG2'
      LADFCTN(   11)=41
      LADFCTN(   12)=45
       ADFCTN(51:53)='TAN'
       ADFCTN(54:58)='TANG2'
      LADFCTN(   13)=51
      LADFCTN(   14)=54
       ADFCTN(59:62)='SINH'
       ADFCTN(63:68)='SINHG2'
      LADFCTN(   15)=59
      LADFCTN(   16)=63
       ADFCTN(69:72)='COSH'
       ADFCTN(73:78)='COSHG2'
      LADFCTN(   17)=69
      LADFCTN(   18)=73
       ADFCTN(79:82)='TANH'
       ADFCTN(83:88)='TANHG2'
      LADFCTN(   19)=79
      LADFCTN(   20)=83
       ADFCTN(89:92)='ACOS'
       ADFCTN(93:98)='ACOSG2'
      LADFCTN(   21)=89
      LADFCTN(   22)=93
       ADFCTN(99 :103)='ASIN'
       ADFCTN(104:109)='ASING2'
      LADFCTN(   23)=99
      LADFCTN(   24)=104
       ADFCTN(110:113)='ATAN'
       ADFCTN(114:119)='ATANG2'
      LADFCTN(   25)=110
      LADFCTN(   26)=114
       ADFCTN(120:124)='LOG10'
       ADFCTN(125:130)='LOG10H'
      LADFCTN(   27)=120
      LADFCTN(   28)=125
       NADFCTN       =14
      LADFCTN(   29)=131    ! "ZARAZKA"

C     VYCISTENI ALBL1 A ALBL2 ATD.
      DO 250, I=1,1000
        ALBL1(I:I)=' '
        ALBL2(I:I)=' '
  250 CONTINUE
      DO 251, I=1,100
        LALBL1(I)=0
        LALBL2(I)=0
  251 CONTINUE
       NALBL=0
      LALBL1(1)=1
      LALBL2(1)=1

C === NAJDEME FMODELX V SYMTAB
C     PREVZATO Z UQGVAL.F
      IP=LP
      IPPRED=LP
    1 IF(IPOINT(IP,3).EQ.7) THEN
        IF ((SYMTAB(IPOINT(IP,2)  ).EQ.'F').AND.
     *   (SYMTAB(IPOINT(IP,2)+1).EQ.'M').AND.
     *   (SYMTAB(IPOINT(IP,2)+2).EQ.'O').AND.
     *   (SYMTAB(IPOINT(IP,2)+3).EQ.'D').AND.
     *   (SYMTAB(IPOINT(IP,2)+4).EQ.'E').AND.
     *   (SYMTAB(IPOINT(IP,2)+5).EQ.'L').AND.
     *   (SYMTAB(IPOINT(IP,2)+6).EQ.CHX))
     *  THEN
C === FMODELX V SYMTAB NALEZENO
           GOTO 10
         ENDIF
      ENDIF
    3 IPPRED=IP
      IP=IPOINT(IP,1)
      IF(IP.GT.0) GOTO 1
C === CHYBA: NENALEZENO FMODELX,
       GOTO 99

   10 CONTINUE

C      WRITE(*,*) 'PRVNI   : ',IPOINT(IP,2)+IPOINT(IP,3)
C      WRITE(*,*) 'POSLEDNI: ',IPOINT(IP,4)
C      DO 11,J=IPOINT(IP,2)+IPOINT(IP,3),IPOINT(IP,4)
C        WRITE(*,*) SYMTAB(J)


C MAME NALEZENO FMODELX A JE POTREBA TO ZPRACOVAT...
C      RADKY JSOU ODDELENY STREDNIKEM
C      DLOUHE RADKY JSOU JIZ PREDZPRACOVANY A NELISI SE OD KRATKYCH

C     PREKOPIRUJEME TRANSFORMOVANY POSTUP DO SVOJI PROMENNE
       LFORMF=IPOINT(IP,4)-IPOINT(IP,2)-IPOINT(IP,3)+1
       IF(LFORMF.GT.5000) GOTO 99
       IF(LFORMF.LT.1)    GOTO 99
       DO 11,J=1,LFORMF
         FORMF(J:J)=SYMTAB(IPOINT(IP,2)+IPOINT(IP,3)+J-1)
   11 CONTINUE

C     A ZACNEME S TRANSFORMACI
C     -- VYCISTIME POLE
      DO 12, J=1,10000
         ADFORMF(J:J)=' '
   12 CONTINUE
       LADFORMF=1

C     -- DOSADIME CITAC PRO DOSAZOVANI HF
       ADFORMF(1:11)='   IADN1=0;'
       LADFORMF=11

C     -- DOSADIME CYKLUS PRES $$NF - DRUHE DERIVACE...
       IF(CHX.EQ.'A') THEN
       ADFORMF(12:32)='   DO 87 IADN=1,$$NF;'
       LADFORMF=32
C     -- DOSADIME INDARR=1
       ADFORMF(33:44)='   INDARR=1;'
       LADFORMF=44
C     -- PREDEFINOVANI NEZAVISLYCH PROMENNYCH:
       ADFORMF( 45: 69)='   DO 88 IADCOUNT=1,$$NF;'
       ADFORMF( 70: 98)='   IF(IADCOUNT.EQ.IADN) THEN;'
       ADFORMF( 99:144)='   IAD_X(IADCOUNT)=MKINDPH(X(IADCOUNT),1.0D0);'
       ADFORMF(145:152)='   ELSE;'
       ADFORMF(153:198)='   IAD_X(IADCOUNT)=MKINDPH(X(IADCOUNT),0.0D0);'
       ADFORMF(199:207)='   ENDIF;'
       ADFORMF(208:219)='88 CONTINUE;'
       ELSEIF(CHX.EQ.'C') THEN
       ADFORMF(12:32)='   DO 77 IADN=1,$$NF;'
       LADFORMF=32
C     -- DOSADIME INDARR=1
       ADFORMF(33:44)='   INDARR=1;'
       LADFORMF=44
C     -- PREDEFINOVANI NEZAVISLYCH PROMENNYCH:
       ADFORMF( 45: 69)='   DO 78 IADCOUNT=1,$$NF;'
       ADFORMF( 70: 98)='   IF(IADCOUNT.EQ.IADN) THEN;'
       ADFORMF( 99:144)='   IAD_X(IADCOUNT)=MKINDPH(X(IADCOUNT),1.0D0);'
       ADFORMF(145:152)='   ELSE;'
       ADFORMF(153:198)='   IAD_X(IADCOUNT)=MKINDPH(X(IADCOUNT),0.0D0);'
       ADFORMF(199:207)='   ENDIF;'
       ADFORMF(208:219)='78 CONTINUE;'
       ELSEIF(CHX.EQ.'F') THEN
       ADFORMF(12:32)='   DO 97 IADN=1,$$NF;'
       LADFORMF=32
C     -- DOSADIME INDARR=1
       ADFORMF(33:44)='   INDARR=1;'
       LADFORMF=44
C     -- PREDEFINOVANI NEZAVISLYCH PROMENNYCH:
       ADFORMF( 45: 69)='   DO 98 IADCOUNT=1,$$NF;'
       ADFORMF( 70: 98)='   IF(IADCOUNT.EQ.IADN) THEN;'
       ADFORMF( 99:144)='   IAD_X(IADCOUNT)=MKINDPH(X(IADCOUNT),1.0D0);'
       ADFORMF(145:152)='   ELSE;'
       ADFORMF(153:198)='   IAD_X(IADCOUNT)=MKINDPH(X(IADCOUNT),0.0D0);'
       ADFORMF(199:207)='   ENDIF;'
       ADFORMF(208:219)='98 CONTINUE;'
       ENDIF
       LADFORMF=219
C
C     PRUCHOD PO JEDNOTLIVYCH RADCICH A JEJICH TRANSFORMACE
C

C      ULOZISTE PRO JMENA TRANSFORMOVANYCH PROMENNYCH
       DO 40,J=1,1001
         ADVARIA(J:J)=' '
   40 CONTINUE
       DO 41,J=1,101
         PADVARIA(J)=-1
   41 CONTINUE
       LADVARIA = 0
C       A VLOZIME TAM ZAVISLOU PROMENNOU Y
      ADVARIA(1:1)='X'
       PADVARIA(1)=1
       PADVARIA(2)=2
       LADVARIA=1

C====================================
C     NEJDRIVE PROJDEME VSECHNY RADKY S PRIRAZENIM
C     A BUDEME HLEDAT, KTERE PROMENNE SE BUDOU TRANSFORMOVAT

C      CYKLUS PRES JEDNOTLIVE RADKY

      I=1
      IZAC_RA=1
  342 IF((FORMF(I:I).NE.';').AND.(I.LT.LFORMF)) THEN
        I=I+1
         GO TO 342
       ENDIF
       IF(FORMF(I:I).NE.';') THEN
         IKON_RA=I
         LCOMMA=.FALSE.
       ELSE
         IKON_RA=I-1
         LCOMMA=.TRUE.
       ENDIF

  343 IF(IZAC_RA.LE.LFORMF) THEN
        I=IZAC_RA

C       HLEDAME RADEK S PRIRAZENIM

        J=I
  350   IF(J.LT.IKON_RA) THEN
          IF(FORMF(J:J).EQ.'=') GOTO 352
           J=J+1
           GOTO 350
         ENDIF
C       TENTO RADEK NENI PRIRAZENI, SKOCIME TEDY NA DALSI RADEK
         GOTO 351

  352  CONTINUE
C       TENTO RADEK OBSAHUJE ROVNITKO, JE TO ASI PRIRAZENI (NEBO IF
C       NEBO DO CYKLUS) PROZKOUMAME PRAVOU STRANU, JESTLI ZAVISI NA X()

C       NEJDRIVE ZJISTIME, CO JE NALEVO OD ROVNITKA (JESTLI UZ TO V
C       ADVARIA NEMAME)
        K=J-1
C       UBEREME MEZERY
  353   IF(FORMF(K:K).EQ.' ') THEN
          K=K-1
           GOTO 353
         ENDIF
C       JESTLI JE INDEX POLE, IGNORUJEME HO
        IF(FORMF(K:K).EQ.')') THEN
          N=1  !POCET OTEVRENYCH ZAVOREK
  354     IF(N.NE.0) THEN
            K=K-1
             IF(FORMF(K:K).EQ.')') N=N+1
             IF(FORMF(K:K).EQ.'(') N=N-1
            GOTO 354
           ENDIF
           K=K-1
C        A JESTE UBEREME MEZERY
  355     IF(FORMF(K:K).EQ.' ') THEN
            K=K-1
             GOTO 355
           ENDIF
         ENDIF
C         ZJISTIM JMENO PROMENNE NA LEVE STRANE
        L=K
  356   IF(FORMF(L:L).NE.' ') THEN
          L=L-1
           GOTO 356
         ENDIF
        L=L+1
C       JE TOHLE JMENO PROMENNE UZ V TABULCE??
         M=1
        PADVARIA(101)=LADVARIA+1
  357   IF((PADVARIA(M).NE.-1).AND.(M.LE.100)) THEN
          IF(K-L+1.EQ.PADVARIA(M+1)-PADVARIA(M)) THEN
            N=0
  358       IF(N.LE.K-L) THEN
              IF(ADVARIA(PADVARIA(M)+N:PADVARIA(M)+N).NE.
     *        FORMF(L+N:L+N)) GOTO 359
               N=N+1
               GOTO 358
             ENDIF
C              NASLI JSME PROMENNOU SE ZMENENYM JMENEM
C              TAKZE NAS TENHLE RADEK UZ DAL NEZAJIMA
            GOTO 351
          ENDIF
  359     M=M+1
           GOTO 357
        ENDIF
C       PROMENNA ZATIM NENI V TABULCE
C       PROZKOUMAME PRAVOU STRANU, JESTLI JI MAME DAT DO TABULKY

        J=J+1

C     -- ODSTRANIME PREBYTECNE ZAVORKY ATP.
C  360    IF(((FORMF(J:J).LT.'A').OR.(FORMF(J:J).GT.'Z'))
C     *                          .AND.(J.LE.IKON_RA)) THEN
  360    IF(((FORMF(J:J).LT.'0').OR.
     *       ((FORMF(J:J).GT.'9').AND.(FORMF(J:J).LT.'A')).OR.
     *       (FORMF(J:J).GT.'Z')).AND.(J.LE.IKON_RA)) THEN
            J=J+1
            GOTO 360
         ENDIF
         IF(J.GT.IKON_RA) GOTO 351
         M=J
C     -- NACTAME CELE SLOVO
C  361    IF((FORMF(M:M).GE.'A').AND.(FORMF(M:M).LE.'Z')
C     *                         .AND.(M.LE.IKON_RA)) THEN
  361    IF((((FORMF(M:M).GE.'0').AND.(FORMF(M:M).LE.'9')).OR.
     *      (FORMF(M:M).GE.'A').AND.(FORMF(M:M).LE.'Z'))
     *                         .AND.(M.LE.IKON_RA)) THEN
            M=M+1
            GOTO 361
         ENDIF
C                -- HLEDAME V SEZNAMU POZMENENYCH PROMENNYCH
         N=1
        PADVARIA(101)=LADVARIA+1
  362   IF((PADVARIA(N).NE.-1).AND.(N.LE.100)) THEN
          IF(M-J.EQ.PADVARIA(N+1)-PADVARIA(N)) THEN
            N1=0
  363       IF(N1.LE.M-J-1) THEN
              IF(ADVARIA(PADVARIA(N)+N1:PADVARIA(N)+N1).NE.
     *        FORMF(J+N1:J+N1)) GOTO 364
               N1=N1+1
               GOTO 363
             ENDIF
C              NASLI JSME PROMENNOU SE ZMENENYM JMENEM
C              ZAPISEME DO TABULKY LEVOU STRANU
            K=K+1
            ADVARIA(LADVARIA+1:LADVARIA+K-L)=FORMF(L:K-1)
             LADVARIA=LADVARIA+K-L
            N=1
  365       IF(PADVARIA(N).NE.-1) THEN
               N=N+1
              IF(N.GT.100) GOTO 99
               GOTO 365
             ENDIF
             PADVARIA(N)=PADVARIA(N-1)+K-L  !V ADVARIA JE VZDY 'X'
C           A SKOCIME NA DALSI RADEK
            GOTO 351
          ENDIF
  364     N=N+1
           GOTO 362
        ENDIF
C       TUHLE PROMENNOU JSME V TABULCE NENASLI,
C       ZKUSIME Z PRAVE STRANY DALSI
        J=M
        GOTO 360
C
C     NALEZENI DALSIHO RADKU V FORMF
C
  351   IZAC_RA=IKON_RA+2
        IF(.NOT.(LCOMMA)) GOTO 345
      I=IZAC_RA
  344   IF((FORMF(I:I).NE.';').AND.(I.LT.LFORMF)) THEN
          I=I+1
           GO TO 344
         ENDIF
         IF(FORMF(I:I).NE.';') THEN
           IKON_RA=I
           LCOMMA=.FALSE.
         ELSE
           IKON_RA=I-1
           LCOMMA=.TRUE.
         ENDIF
  345   CONTINUE
        GOTO 343
      ENDIF



C      KONEC HLEDANI TRANSFORMOVANYCH PROMENNYCH
C====================================

C====================================
C     NAJDEME LABELY, KTERE POZDEJI ZAMENIME, ABY NEBYLY ZDVOJENE
C     (BUDOU UZ OBSAZENY V FGMODELX)
      I=1
  252 IF(I+4.LT.LFORMF) THEN
        IF((FORMF(I:I+3).EQ.'GOTO').OR.(FORMF(I:I+4).EQ.'GO TO')
     *    .OR.(FORMF(I:I+2).EQ.'DO ')) THEN
          IF(FORMF(I:I+2).EQ.'GO ') I=I+5
          IF(FORMF(I:I+2).EQ.'GOT') I=I+4
          IF(FORMF(I:I+2).EQ.'DO ') I=I+2
C     VYNECHAME MEZERY
          J=I
  253     IF(FORMF(J:J).EQ.' ') THEN
            J=J+1
                GOTO 253
           END IF
          I=J
C     ZJISTIME CISLO LABELU
  254     IF((FORMF(J:J).GE.'0').AND.(FORMF(J:J).LE.'9')) THEN
            J=J+1
            GOTO 254
          END IF
          IF(J.EQ.I) GOTO 256
          ALABEL(1:J-I)=FORMF(I:J-1)
C     ZJISTIME, EXISTUJE-LI UZ TENHLE LABEL ALABEL V ALBL1
          K=1
  255     IF(NALBL.GE.K) THEN
            IF(J-I.EQ.LALBL1(K+1)-LALBL1(K)) THEN
               IF(ALABEL(1:J-I).EQ.ALBL1(LALBL1(K):LALBL1(K+1)-1))THEN
C     TENHLE LABEL UZ V ALBL1 MAME, TAKZE HLEDAME DALSI GOTO
                 GOTO 256
               END IF
             END IF
             K=K+1
           END IF
C     TENHLE LABEL V ALBL1 NEMAME, ZAPISEME HO TAM
          IF(NALBL.EQ.100) GOTO 99 !NENI KAM PSAT
          NALBL = NALBL+1
              ALBL1(LALBL1(NALBL):LALBL1(NALBL)+J-I-1)=ALABEL(1:J-I)
           LALBL1(NALBL+1)=LALBL1(NALBL)+J-I
         END IF
C     HLEDAME DALSI GOTO
  256   I=I+1
        GOTO 252
      END IF

C------------------------------------------------
C     NALEZENI NOVYCH LABELU
C     (TJ. NAPLNENI POLE ALBL2)
C     OD JAKEHO LABELU ZACNEME PRIDELOVAT NOVE LABELY
      IF(CHX.EQ.'A') THEN
        ILABEL=830
      ELSEIF(CHX.EQ.'C') THEN
        ILABEL=860
      ELSEIF(CHX.EQ.'F') THEN
        ILABEL=800
      ENDIF
      I=1
  257 IF(I.LE.NALBL) THEN
C     VYMYSLIME NOVY LABEL PRO NALBL-TY PRVEK
  258   ILABEL=ILABEL+1
         WRITE(CLABEL,'(I3)') ILABEL  !KANDIDAT
        LLABEL = LEN_TRIM(CLABEL)
C     ZKONTROLUJEME, NENI-LI UZ V ALBL2
         J=1
  259   IF(J.LE.NALBL) THEN
          IF(LLABEL.EQ.LALBL1(J+1)-LALBL1(J)) THEN
             IF(CLABEL(1:LLABEL).EQ.
     *                  ALBL1(LALBL1(J):LALBL1(J+1)-1))THEN
C     TENHLE LABEL UZ V ALBL1 MAME, TAKZE HLEDAME DALSIHO KANDIDATA
               GOTO 258
             END IF
           END IF
           J=J+1
           GOTO 259
        END IF
C     NASLI JSME VHODNY NOVY LABEL CLABEL
C     ZAPISEME HO DO ALBL2
         LALBL2(I+1)=LALBL2(I)+LLABEL
         ALBL2(LALBL2(I):LALBL2(I+1)-1)=CLABEL(1:LLABEL)
        I=I+1
        GOTO 257
      END IF
C     KONEC PRIPRAVY ZMENY LABELU
C=====================================

C=====================================

C      VLASTNI TRANFORMACE PROGRAMU:
C      CYKLUS PRES JEDNOTLIVE RADKY

      I=1
      IZAC_RA=1
   42 IF((FORMF(I:I).NE.';').AND.(I.LT.LFORMF)) THEN
        I=I+1
         GO TO 42
       ENDIF
       IF(FORMF(I:I).NE.';') THEN
         IKON_RA=I
         LCOMMA=.FALSE.
       ELSE
         IKON_RA=I-1
         LCOMMA=.TRUE.
       ENDIF

   43 IF(IZAC_RA.LE.LFORMF) THEN

C      ****************************
C      ANALYZA A TRASNFORMACE RADKU
C      ****************************

C
C       -- NAVESTI A UVODNI MEZERY -->
C          -- NAHRADIME LABELY
C
        I=IZAC_RA
C       ODEBEREME MEZERY NA ZACATKU RADKU
   46   IF(FORMF(I:I).EQ.' ') THEN
             ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
             LADFORMF=LADFORMF+1
             I=I+1
             IF(I.GE.IKON_RA) GOTO 47
             GOTO 46
         ENDIF
C       EXISTUJE LABEL??
         J=I
  260   IF((FORMF(I:I).EQ.'1').OR.
     *     (FORMF(I:I).EQ.'2').OR.
     *     (FORMF(I:I).EQ.'3').OR.
     *     (FORMF(I:I).EQ.'4').OR.
     *     (FORMF(I:I).EQ.'5').OR.
     *     (FORMF(I:I).EQ.'6').OR.
     *     (FORMF(I:I).EQ.'7').OR.
     *     (FORMF(I:I).EQ.'8').OR.
     *     (FORMF(I:I).EQ.'9').OR.
     *     (FORMF(I:I).EQ.'0')) THEN
             I=I+1
             IF(I.GE.IKON_RA) GOTO 47
             GOTO 260
         ENDIF
          IF(I.NE.J) THEN
C      DOSADIME ZTRANSFORMOVANY LABEL
            K=1
  262      IF(K.LE.NALBL) THEN
             IF(LALBL1(K+1)-LALBL1(K).EQ.I-J) THEN
               IF(ALBL1(LALBL1(K):LALBL1(K+1)-1).EQ.FORMF(J:I-1))THEN
C                NASLI JSME AKTUALNI LABEL
C                DO VYSTUPU NAPISEME JEHO NAHRAZKU:
                 ADFORMF(LADFORMF+1:LADFORMF+LALBL2(K+1)-LALBL2(K)+1)=
     *             ALBL2(LALBL2(K):LALBL2(K+1)-1)
                 LADFORMF=LADFORMF+LALBL2(K+1)-LALBL2(K)
                 GOTO 261
                ENDIF
              ENDIF
             K=K+1
              GOTO 262
           ENDIF
         ENDIF
C       ODEBEREME DALSI MEZERY
  261   IF(FORMF(I:I).EQ.' ') THEN
             ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
             LADFORMF=LADFORMF+1
             I=I+1
             IF(I.GE.IKON_RA) GOTO 47
             GOTO 261
         ENDIF
C
C       -- CONTINUE --> JEN KOPIE -- OK
C
   85   IF(IKON_RA-I+1.GE.8) THEN
           IF(FORMF(I:I+7).EQ.'CONTINUE') THEN
              ADFORMF(LADFORMF+1:LADFORMF+8)=FORMF(I:I+7)
              LADFORMF=LADFORMF+8
             GOTO 47
           ENDIF
         ENDIF

C
C       -- GOTO --> NAHRAZENI LABELU
C
        IF(IKON_RA-I+1.GE.6) THEN
           IF(FORMF(I:I+3).EQ.'GOTO') THEN
              ADFORMF(LADFORMF+1:LADFORMF+4)=FORMF(I:I+3)
              LADFORMF=LADFORMF+4
               I=I+4
C       ODEBEREME MEZERY
  270         IF(FORMF(I:I).EQ.' ') THEN
                ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
                LADFORMF=LADFORMF+1
                I=I+1
C                IF(I.GE.IKON_RA) GOTO 47
                GOTO 270
               ENDIF
C       NACTEME LABEL
                J=I
  271          IF((FORMF(I:I).EQ.'1').OR.
     *            (FORMF(I:I).EQ.'2').OR.
     *            (FORMF(I:I).EQ.'3').OR.
     *            (FORMF(I:I).EQ.'4').OR.
     *            (FORMF(I:I).EQ.'5').OR.
     *            (FORMF(I:I).EQ.'6').OR.
     *            (FORMF(I:I).EQ.'7').OR.
     *            (FORMF(I:I).EQ.'8').OR.
     *            (FORMF(I:I).EQ.'9').OR.
     *            (FORMF(I:I).EQ.'0')) THEN
                 I=I+1
                 GOTO 271
               ENDIF
C      DOSADIME ZTRANSFORMOVANY LABEL
                K=1
  273          IF(K.LE.NALBL) THEN
                     IF(LALBL1(K+1)-LALBL1(K).EQ.I-J) THEN
                    IF(ALBL1(LALBL1(K):LALBL1(K+1)-1).EQ.FORMF(J:I-1))
     *                THEN
C                    NASLI JSME AKTUALNI LABEL
C                    DO VYSTUPU NAPISEME JEHO NAHRAZKU:
                     ADFORMF(LADFORMF+1:
     *                 LADFORMF+LALBL2(K+1)-LALBL2(K)+1)=
     *                 ALBL2(LALBL2(K):LALBL2(K+1)-1)
                     LADFORMF=LADFORMF+LALBL2(K+1)-LALBL2(K)
                     GOTO 272
                    ENDIF
                  ENDIF
                 K=K+1
                  GOTO 273
               ENDIF
C     A DOOPISEME KONEC RADKU
  272          ADFORMF(LADFORMF+1:LADFORMF+IKON_RA-I+1)=FORMF(I:IKON_RA)
               LADFORMF=LADFORMF+IKON_RA-I+1
             GOTO 47
           ENDIF
         ENDIF
C
C       -- DO CYKLUS --> JEN KOPIE -- OK
C
        IF(IKON_RA-I+1.GE.4) THEN
           IF(FORMF(I:I+2).EQ.'DO ') THEN
              ADFORMF(LADFORMF+1:LADFORMF+3)=FORMF(I:I+2)
              LADFORMF=LADFORMF+3
              I=I+3
C       ODEBEREME MEZERY
  280         IF(FORMF(I:I).EQ.' ') THEN
                ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
                LADFORMF=LADFORMF+1
                I=I+1
                IF(I.GE.IKON_RA) GOTO 47
                GOTO 280
               ENDIF
C       NACTEME LABEL
               J=I
  281          IF((FORMF(I:I).EQ.'1').OR.
     *            (FORMF(I:I).EQ.'2').OR.
     *            (FORMF(I:I).EQ.'3').OR.
     *            (FORMF(I:I).EQ.'4').OR.
     *            (FORMF(I:I).EQ.'5').OR.
     *            (FORMF(I:I).EQ.'6').OR.
     *            (FORMF(I:I).EQ.'7').OR.
     *            (FORMF(I:I).EQ.'8').OR.
     *            (FORMF(I:I).EQ.'9').OR.
     *            (FORMF(I:I).EQ.'0')) THEN
                 I=I+1
                 GOTO 281
               ENDIF
C      DOSADIME ZTRANSFORMOVANY LABEL
                K=1
  283          IF(K.LE.NALBL) THEN
                 IF(LALBL1(K+1)-LALBL1(K).EQ.I-J) THEN
                    IF(ALBL1(LALBL1(K):LALBL1(K+1)-1).EQ.FORMF(J:I-1))
     *                THEN
C                    NASLI JSME AKTUALNI LABEL
C                    DO VYSTUPU NAPISEME JEHO NAHRAZKU:
                     ADFORMF(LADFORMF+1:
     *                 LADFORMF+LALBL2(K+1)-LALBL2(K)+1)=
     *                 ALBL2(LALBL2(K):LALBL2(K+1)-1)
                     LADFORMF=LADFORMF+LALBL2(K+1)-LALBL2(K)
                     GOTO 282
                    ENDIF
                  ENDIF
                 K=K+1
                 GOTO 283
               ENDIF
C     A DOOPISEME KONEC RADKU
  282          ADFORMF(LADFORMF+1:LADFORMF+IKON_RA-I+1)=FORMF(I:IKON_RA)
               LADFORMF=LADFORMF+IKON_RA-I+1
             GOTO 47
           ENDIF
         ENDIF
C
C       -- OPEN --> JEN KOPIE -- OK
C
        IF(IKON_RA-I+1.GE.5) THEN
           IF(FORMF(I:I+4).EQ.'OPEN(') THEN
              ADFORMF(LADFORMF+1:LADFORMF+IKON_RA-I+1)=FORMF(I:IKON_RA)
              LADFORMF=LADFORMF+IKON_RA-I+1
             GOTO 47
              ENDIF
         ENDIF
C
C       -- CLOSE --> JEN KOPIE -- OK
C
        IF(IKON_RA-I+1.GE.6) THEN
           IF(FORMF(I:I+5).EQ.'CLOSE(') THEN
              ADFORMF(LADFORMF+1:LADFORMF+IKON_RA-I+1)=FORMF(I:IKON_RA)
              LADFORMF=LADFORMF+IKON_RA-I+1
             GOTO 47
              ENDIF
         ENDIF
C
C       -- FORMAT --> JEN KOPIE -- OK
C
        IF(IKON_RA-I+1.GE.7) THEN
           IF(FORMF(I:I+6).EQ.'FORMAT(') THEN
              ADFORMF(LADFORMF+1:LADFORMF+IKON_RA-I+1)=FORMF(I:IKON_RA)
              LADFORMF=LADFORMF+IKON_RA-I+1
             GOTO 47
              ENDIF
         ENDIF
C
C       -- WRITE --> MIRNE PREDELAT -- OK
C          OMEZENI: * NEPSAT MEZERY
C                   * ARGUMENTY FUNKCI A INDEXY POLI --
C                       -- NENAHRAZUJI SE PREPSANYMI PROMENNYMI
C                   * POTREBA OTESTOVAT PREPSANE PROMENNE
C
        IF(IKON_RA-I+1.GE.6) THEN
           IF(FORMF(I:I+5).EQ.'WRITE(') THEN
             ADFORMF(LADFORMF+1:LADFORMF+6)=FORMF(I:I+5)
             LADFORMF=LADFORMF+6
             I=I+6
C           HLEDAME ZAVIRACI ZAVORKU
C           PRITOM KONTROLUJEME TAKY OTVIRACI
            J=1 !POCET OTEVRENYCH ZAVOREK
   48       IF(J.GT.0) THEN
                     IF(FORMF(I:I).EQ.'(') J=J+1
                     IF(FORMF(I:I).EQ.')') J=J-1
               ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
               LADFORMF=LADFORMF+1
               I=I+1
                     GOTO 48
            ENDIF
C     PRIPADNE MEZERY VYIGNORUJEME
   49       IF(FORMF(I:I).EQ.' ') THEN
               ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
               LADFORMF=LADFORMF+1
               I=I+1
              GOTO 49
             ENDIF
C     ANALYZA VZORCE + HLEDAT V POLI
C     POZOR NA TEXTOVE RETEZCE
   50       IF(I.LE.IKON_RA) THEN
              IF((FORMF(I:I).EQ.'''').OR.(FORMF(I:I).EQ.'"')) THEN
C     TEXTOVY RETEZEC - JEN ZKOPIRUJEME
                 ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
                 LADFORMF=LADFORMF+1
                 I=I+1
   51           IF((FORMF(I:I).NE.'''').AND.(FORMF(I:I).NE.'"'))THEN
                   ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
                   LADFORMF=LADFORMF+1
                   I=I+1
                  GOTO 51
                 ENDIF
C     ZAPISEME UZAVIRACI UVOZOVKU
                 ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
                 LADFORMF=LADFORMF+1
                 I=I+1
C     DOPISEME NASLEDUJICI MEZERY NEBO CARKU
                IF(I.EQ.IKON_RA) GOTO 50
   52           IF((FORMF(I:I).EQ.' ').OR.(FORMF(I:I).EQ.',')) THEN
                   ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
                   LADFORMF=LADFORMF+1
                   I=I+1
                   IF(I.EQ.IKON_RA) GOTO 50
                  GOTO 52
                 ENDIF
              ELSE
C     PROMENNA - MOZNA BUDEME MUSET NAHRADIT
C      (MOZNA TAKY CISLO)
C     ODEBEREME POUZE OTEVIRACI ZAVORKY A UNARNI MINUS
   53           IF((FORMF(I:I).EQ.'-').OR.(FORMF(I:I).EQ.'(')) THEN
                   ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
                   LADFORMF=LADFORMF+1
                   I=I+1
                   GOTO 53
                 ENDIF
                LTEMP = .FALSE.
   64           IF((FORMF(I:I).EQ.'0').OR.
C     JE TO CISLO
     *             (FORMF(I:I).EQ.'1').OR.
     *             (FORMF(I:I).EQ.'2').OR.
     *             (FORMF(I:I).EQ.'3').OR.
     *             (FORMF(I:I).EQ.'4').OR.
     *             (FORMF(I:I).EQ.'5').OR.
     *             (FORMF(I:I).EQ.'6').OR.
     *             (FORMF(I:I).EQ.'7').OR.
     *             (FORMF(I:I).EQ.'8').OR.
     *             (FORMF(I:I).EQ.'9').OR.
     *             (FORMF(I:I).EQ.'D').OR.
     *             (FORMF(I:I).EQ.'E').OR.
     *             (FORMF(I:I).EQ.'F').OR.
     *             (FORMF(I:I).EQ.'.')) THEN
                      ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
                      LADFORMF=LADFORMF+1
                      I=I+1
                      LTEMP=.TRUE.
                   GOTO 64
                 ENDIF
                IF(LTEMP) GOTO 63
C     JE TO PROMENNA
C     TED ZPRACUJEME PROMENOU
   54            J=I
   55           IF((J.LT.IKON_RA).AND.
     *             (FORMF(J+1:J+1).NE.'(') .AND.
     *             (FORMF(J+1:J+1).NE.')') .AND.
     *                       (FORMF(J+1:J+1).NE.'+') .AND.
     *                (FORMF(J+1:J+1).NE.'-') .AND.
     *                (FORMF(J+1:J+1).NE.'*') .AND.
     *                (FORMF(J+1:J+1).NE.'/') .AND.
     *                (FORMF(J+1:J+1).NE.'''').AND.
     *             (FORMF(J+1:J+1).NE.',')) THEN
                   J=J+1
                   GOTO 55
                 ENDIF
C     HLEDAME V SEZNAMU PROMENNYCH,KTERE POZMENENY
                 K=1
                 PADVARIA(101)=LADVARIA+1
   56           IF((PADVARIA(K).NE.-1).AND.(K.LE.100)) THEN
                  IF(J-I+1.EQ.PADVARIA(K+1)-PADVARIA(K)) THEN
                    L=0
   58               IF(L.LE.J-I) THEN
                      IF(ADVARIA(PADVARIA(K)+L:PADVARIA(K)+L).NE.
     *                    FORMF(I+L:I+L)) GOTO 57
                       L=L+1
                       GOTO 58
                     ENDIF

C     NASLI JSME PROMENNOU SE ZMENENYM JMENEM
                    ADFORMF(LADFORMF+1:LADFORMF+6)='V(IAD_'
                     LADFORMF=LADFORMF+6
                     ADFORMF(LADFORMF+1:LADFORMF+J-I+1)=FORMF(I:J)
                     LADFORMF=LADFORMF+J-I+1
                    I=J+1
C                POLE??
                    IF(FORMF(I:I).EQ.'(') THEN
                   ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
                       LADFORMF=LADFORMF+1
                       I=I+1
                      L=1         !POCET OTEVRENYCH ZAVOREK
   71                 IF(L.GT.0) THEN
                         IF(FORMF(I:I).EQ.')') L=L-1
                         IF(FORMF(I:I).EQ.'(') L=L+1
                     ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
                         LADFORMF=LADFORMF+1
                         I=I+1
                        GOTO 71
                       ENDIF
                     ENDIF
                     ADFORMF(LADFORMF+1:LADFORMF+1)=')'
                     LADFORMF=LADFORMF+1
                     GOTO 59
                   ENDIF
   57             K=K+1
                  GOTO 56
                 ENDIF
C     PROMENNA NEBYLA ZMENENA, JEN KOPIE STARE
                 ADFORMF(LADFORMF+1:LADFORMF+J-I+1)=FORMF(I:J)
                 LADFORMF=LADFORMF+J-I+1
                 I=J+1
C     ZKOUMANI MOZNYCH NASLEDUJICICH VECI:POLE\OPERACE\KONEC RADKU\CARKA
                IF(I.GT.IKON_RA) GOTO 50
C     POLE
                IF(FORMF(I:I).EQ.'(') THEN
               ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
                   LADFORMF=LADFORMF+1
                   I=I+1
                  K=1
   60             IF(K.GT.0) THEN
                     IF(FORMF(I:I).EQ.')') K=K-1
                     IF(FORMF(I:I).EQ.'(') K=K+1
                 ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
                     LADFORMF=LADFORMF+1
                     I=I+1
                    GOTO 60
                   ENDIF
                 ENDIF
C     UZAVIRACI ZAVORKY
   63           IF(I.GT.IKON_RA) GOTO 50
   61           IF(FORMF(I:I).EQ.')') THEN
               ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
                   LADFORMF=LADFORMF+1
                   I=I+1
                  IF(I.GT.IKON_RA) GOTO 50
                  GOTO 61
                 ENDIF
C     NEJAKA DALSI OPERACE??
                IF(I.GE.IKON_RA) GOTO 50
                IF((FORMF(I:I).EQ.'+').OR.
     *                     (FORMF(I:I).EQ.'-').OR.
     *                     (FORMF(I:I).EQ.'*').OR.
     *                     (FORMF(I:I).EQ.'/')) THEN
               ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
                   LADFORMF=LADFORMF+1
                   I=I+1
                  IF(FORMF(I:I).EQ.'*') THEN  ! MOCNINA **
                        ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
                     LADFORMF=LADFORMF+1
                     I=I+1
                   ENDIF
                   GOTO 53
                 ENDIF
C     CARKA
                IF(I.GE.IKON_RA) GOTO 50
                IF(FORMF(I:I).EQ.',') THEN
               ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
                   LADFORMF=LADFORMF+1
                   I=I+1
                   GOTO 50
                 ENDIF
   59           CONTINUE
               ENDIF
               GOTO 50
             ENDIF
            GOTO 47
              ENDIF
         ENDIF

C
C       -- IF --> MIRNE PREDELAT -- OK
C          (DVE VARIANTY -- VCETNE "THEN" A BEZ "THEN")
C
C       TATO CAST KODU SE POUZIVA TAKE PRO ELSEIF A ELSE IF
C
C     OMEZENI: * BEZ MEZER V PODMINCE
C              * POUZE POROVNANI CISEL (NE ZNAKY, LOGICKE HODNOTY  ATD.)
C              * ZADNE VYRAZY V PODMINKACH, POUZE CISLA A CISTE PROMENNE
C              * INDEXY POLI A ARGUMENTY FUNKCI SE NETRANSFORMUJI
C                (JEN KOPIE)
C
         IF(IKON_RA-I+1.GE.3) THEN
            IF(FORMF(I:I+2).EQ.'IF(') THEN
               ADFORMF(LADFORMF+1:LADFORMF+3)=FORMF(I:I+2)
               LADFORMF=LADFORMF+3
               I=I+3
C     -- SEM SKOCIME TAKY V PRIPADE ELSEIF A ELSE IF --
C     ANALYZA VYRAZU VLEVO:
               CALL UQADIF(FORMF,ADFORMF,LADFORMF,ADVARIA,LADVARIA,
     &                     PADVARIA,I)
C     OPISEME MEZERY
   81          IF(FORMF(I:I).EQ.' ') THEN
                  ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
                  LADFORMF=LADFORMF+1
                  I=I+1
                  GOTO 81
               ENDIF
C      NALEZENO THEN -> ZAPISEME THEN
               IF(FORMF(I:I+3).EQ.'THEN')  THEN
                  ADFORMF(LADFORMF+1:LADFORMF+4)=FORMF(I:I+3)
                  LADFORMF=LADFORMF+4
                  I=I+4
                  GOTO 47          ! A JDEME NA NOVY RADEK
               ELSE
C     NALEZENO NECO JINEHO NEZ THEN ->
C     TJ.NOVY VYRAZ NEBO PRIKAZ NA STEJNEM RADKU
                  GOTO 85
               ENDIF
            ENDIF
         ENDIF
C
         IF(IKON_RA-I+1.GE.4) THEN
            IF(FORMF(I:I+3).EQ.'IF (') THEN
               ADFORMF(LADFORMF+1:LADFORMF+4)=FORMF(I:I+3)
               LADFORMF=LADFORMF+4
               I=I+4
C     -- SEM SKOCIME TAKY V PRIPADE ELSEIF A ELSE IF --
C     ANALYZA VYRAZU VLEVO:
               CALL UQADIF(FORMF,ADFORMF,LADFORMF,ADVARIA,LADVARIA,
     &                     PADVARIA,I)
C     OPISEME MEZERY
   82          IF(FORMF(I:I).EQ.' ') THEN
                  ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
                  LADFORMF=LADFORMF+1
                  I=I+1
                  GOTO 82
               ENDIF
C      NALEZENO THEN -> ZAPISEME THEN
               IF(FORMF(I:I+3).EQ.'THEN')  THEN
                  ADFORMF(LADFORMF+1:LADFORMF+4)=FORMF(I:I+3)
                  LADFORMF=LADFORMF+4
                  I=I+4
                  GOTO 47          ! A JDEME NA NOVY RADEK
               ELSE
C     NALEZENO NECO JINEHO NEZ THEN ->
C     TJ.NOVY VYRAZ NEBO PRIKAZ NA STEJNEM RADKU
                  GOTO 85
               ENDIF
            ENDIF
         ENDIF
C
C       -- ELSEIF --> MIRNE PREDELAT -- OK
C          (DVE VARIANTY -- VCETNE "THEN" A BEZ "THEN")
C
C     OMEZENI: * BEZ MEZER V PODMINCE
C              * POUZE POROVNANI CISEL (NE ZNAKY, LOGICKE HODNOTY  ATD.)
C              * ZADNE VYRAZY V PODMINKACH, POUZE CISLA A CISTE PROMENNE
C              * INDEXY POLI A ARGUMENTY FUNKCI SE NETRANSFORMUJI
C                (JEN KOPIE)
C
C        VYUZIJE SE CAST KODU PRO "IF", KAM SE ODSKOCI
C
        IF(IKON_RA-I+1.GE.7) THEN
           IF(FORMF(I:I+6).EQ.'ELSEIF(') THEN
             ADFORMF(LADFORMF+1:LADFORMF+7)=FORMF(I:I+6)
             LADFORMF=LADFORMF+7
             I=I+7
             CALL UQADIF(FORMF,ADFORMF,LADFORMF,ADVARIA,LADVARIA,
     &                   PADVARIA,I)
C     OPISEME MEZERY
   62          IF(FORMF(I:I).EQ.' ') THEN
                  ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
                  LADFORMF=LADFORMF+1
                  I=I+1
                  GOTO 62
               ENDIF
C      NALEZENO THEN -> ZAPISEME THEN
               IF(FORMF(I:I+3).EQ.'THEN')  THEN
                  ADFORMF(LADFORMF+1:LADFORMF+4)=FORMF(I:I+3)
                  LADFORMF=LADFORMF+4
                  I=I+4
                  GOTO 47          ! A JDEME NA NOVY RADEK
               ELSE
C     NALEZENO NECO JINEHO NEZ THEN ->
C     TJ.NOVY VYRAZ NEBO PRIKAZ NA STEJNEM RADKU
                  GOTO 85
               ENDIF
           ENDIF
        ENDIF
C
        IF(IKON_RA-I+1.GE.8) THEN
           IF(FORMF(I:I+7).EQ.'ELSEIF (') THEN
             ADFORMF(LADFORMF+1:LADFORMF+8)=FORMF(I:I+7)
             LADFORMF=LADFORMF+8
             I=I+8
             CALL UQADIF(FORMF,ADFORMF,LADFORMF,ADVARIA,LADVARIA,
     &                   PADVARIA,I)
C     OPISEME MEZERY
   65          IF(FORMF(I:I).EQ.' ') THEN
                  ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
                  LADFORMF=LADFORMF+1
                  I=I+1
                  GOTO 65
               ENDIF
C      NALEZENO THEN -> ZAPISEME THEN
               IF(FORMF(I:I+3).EQ.'THEN')  THEN
                  ADFORMF(LADFORMF+1:LADFORMF+4)=FORMF(I:I+3)
                  LADFORMF=LADFORMF+4
                  I=I+4
                  GOTO 47          ! A JDEME NA NOVY RADEK
               ELSE
C     NALEZENO NECO JINEHO NEZ THEN ->
C     TJ.NOVY VYRAZ NEBO PRIKAZ NA STEJNEM RADKU
                  GOTO 85
               ENDIF
            ENDIF
         ENDIF
C
C       -- ELSE IF --> MIRNE PREDELAT -- OK
C          (DVE VARIANTY -- VCETNE "THEN" A BEZ "THEN")
C
C     OMEZENI: * BEZ MEZER V PODMINCE
C              * POUZE POROVNANI CISEL (NE ZNAKY, LOGICKE HODNOTY  ATD.)
C              * ZADNE VYRAZY V PODMINKACH, POUZE CISLA A CISTE PROMENNE
C              * INDEXY POLI A ARGUMENTY FUNKCI SE NETRANSFORMUJI
C                (JEN KOPIE)
C
C        VYUZIJE SE CAST KODU PRO "IF", KAM SE ODSKOCI
C
        IF(IKON_RA-I+1.GE.8) THEN
           IF(FORMF(I:I+7).EQ.'ELSE IF(') THEN
             ADFORMF(LADFORMF+1:LADFORMF+8)=FORMF(I:I+7)
             LADFORMF=LADFORMF+8
             I=I+8
             CALL UQADIF(FORMF,ADFORMF,LADFORMF,ADVARIA,LADVARIA,
     &                   PADVARIA,I)
C     OPISEME MEZERY
   72          IF(FORMF(I:I).EQ.' ') THEN
                  ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
                  LADFORMF=LADFORMF+1
                  I=I+1
                  GOTO 72
               ENDIF
C      NALEZENO THEN -> ZAPISEME THEN
               IF(FORMF(I:I+3).EQ.'THEN')  THEN
                  ADFORMF(LADFORMF+1:LADFORMF+4)=FORMF(I:I+3)
                  LADFORMF=LADFORMF+4
                  I=I+4
                  GOTO 47          ! A JDEME NA NOVY RADEK
               ELSE
C     NALEZENO NECO JINEHO NEZ THEN ->
C     TJ.NOVY VYRAZ NEBO PRIKAZ NA STEJNEM RADKU
                  GOTO 85
               ENDIF
            ENDIF
         ENDIF
C
        IF(IKON_RA-I+1.GE.9) THEN
           IF(FORMF(I:I+8).EQ.'ELSE IF (') THEN
             ADFORMF(LADFORMF+1:LADFORMF+9)=FORMF(I:I+8)
             LADFORMF=LADFORMF+9
             I=I+9
             CALL UQADIF(FORMF,ADFORMF,LADFORMF,ADVARIA,LADVARIA,
     &                   PADVARIA,I)
C     OPISEME MEZERY
   73          IF(FORMF(I:I).EQ.' ') THEN
                  ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
                  LADFORMF=LADFORMF+1
                  I=I+1
                  GOTO 73
               ENDIF
C      NALEZENO THEN -> ZAPISEME THEN
               IF(FORMF(I:I+3).EQ.'THEN')  THEN
                  ADFORMF(LADFORMF+1:LADFORMF+4)=FORMF(I:I+3)
                  LADFORMF=LADFORMF+4
                  I=I+4
                  GOTO 47          ! A JDEME NA NOVY RADEK
               ELSE
C     NALEZENO NECO JINEHO NEZ THEN ->
C     TJ.NOVY VYRAZ NEBO PRIKAZ NA STEJNEM RADKU
                  GOTO 85
               ENDIF
            ENDIF
         ENDIF
C
C       -- ELSE --> JEN KOPIE -- OK
C
        IF(IKON_RA-I+1.EQ.4) THEN
           IF(FORMF(I:I+3).EQ.'ELSE') THEN
              ADFORMF(LADFORMF+1:LADFORMF+IKON_RA-I+1)=FORMF(I:IKON_RA)
              LADFORMF=LADFORMF+IKON_RA-I+1
             GOTO 47
              ENDIF
         ENDIF
C
C       -- ENDIF --> JEN KOPIE -- OK
C
        IF(IKON_RA-I+1.EQ.5) THEN
           IF(FORMF(I:I+4).EQ.'ENDIF') THEN
              ADFORMF(LADFORMF+1:LADFORMF+IKON_RA-I+1)=FORMF(I:IKON_RA)
              LADFORMF=LADFORMF+IKON_RA-I+1
             GOTO 47
              ENDIF
         ENDIF
C
C       -- END IF --> JEN KOPIE -- OK
C
        IF(IKON_RA-I+1.EQ.6) THEN
           IF(FORMF(I:I+5).EQ.'END IF') THEN
              ADFORMF(LADFORMF+1:LADFORMF+IKON_RA-I+1)=FORMF(I:IKON_RA)
              LADFORMF=LADFORMF+IKON_RA-I+1
             GOTO 47
              ENDIF
         ENDIF
C
C       -- PRIRAZENI -- PREDELAT
C
C       1. MOZNOST: V PRAVE STRANE JSOU SAME "KONSTANTY"
C           (TJ. NEJSOU OVLIVNENY X(*))
C           ... JEN KOPIE
C       2. MOZNOST: PRAVA STRANA JE ZAVISLA NA X(*)
C           ... PRETRANSFORMUJEME
C
C       OMEZENI: * UNARNI MINUS SE NEPOUZIVA
C                   (V PRIPADE POTREBY POUZIT (-1)*......)
C                * ITERACNI PRIRAZENI ZATIM ZAKAZANO
C                * NELZE CISLO VE JMENU PROMENNE
C                * MEZERY MOHOU BYT VE VYRAZU OBSAZENY
C

C       ZJISTIME, JESTLI JDE O PRIRAZENI (TJ. OBSAHUJE-LI ROVNITKO)
        J=I
   92   IF(J.LT.IKON_RA) THEN
          IF(FORMF(J:J).EQ.'=') GOTO 93
           J=J+1
           GOTO 92
         ENDIF
C       NENI TO VYRAZ (NEOBSAHUJE ROVNITKO),
C        TAKZE PRESKOCIME TRANSFORMACI PRIRAZENI
        GOTO 83

C       JE TO VYRAZ, TED HO ZPRACUJEME
   93   CONTINUE

C       ROZLISENI NA 1. RESP. 2. MOZNOST
C           --  NEOBASHUJE X ??
C        J=I
C   94   IF(J.LE.IKON_RA) THEN
C          IF(FORMF(J:J).EQ.'X') GOTO 96
C          J=J+1
C          GOTO 94
C        ENDIF
C           --  NEOBASHUJE POZMENENOU PROMENNOU?
C               -- JDEME ZA ROVNITKO
        J=I
  105   IF(J.LT.IKON_RA) THEN
          IF(FORMF(J:J).EQ.'=') GOTO 106
           J=J+1
           GOTO 105
         ENDIF

  106   CONTINUE

C        J=J+1
C
CC    -- ODSTRANIME PREBYTECNE ZAVORKY ATP.
CC  360    IF(((FORMF(J:J).LT.'A').OR.(FORMF(J:J).GT.'Z'))
CC     *                          .AND.(J.LE.IKON_RA)) THEN
C   97    IF(((FORMF(J:J).LT.'0').OR.
C     *       ((FORMF(J:J).GT.'9').AND.(FORMF(J:J).LT.'A')).OR.
C     *       (FORMF(J:J).GT.'Z')).AND.(J.LE.IKON_RA)) THEN
C            J=J+1
C            GOTO 97
C         ENDIF
C         IF(J.GT.IKON_RA) GOTO 95
C         K=J
CC     -- NACTAME CELE SLOVO
CC   98    IF((FORMF(K:K).GE.'A').AND.(FORMF(K:K).LE.'Z')
CC     *                         .AND.(K.LE.IKON_RA)) THEN
C   98    IF((((FORMF(K:K).GE.'0').AND.(FORMF(K:K).LE.'9')).OR.
C     *      (FORMF(K:K).GE.'A').AND.(FORMF(K:K).LE.'Z'))
C     *                         .AND.(K.LE.IKON_RA)) THEN
C            K=K+1
C            GOTO 98
C         ENDIF
CC    -- HLEDAME V SEZNAMU POZMENENYCH PROMENNYCH
C        M=1
C        PADVARIA(101)=LADVARIA+1
C  101   IF((PADVARIA(M).NE.-1).AND.(M.LE.100)) THEN
C          IF(K-J.EQ.PADVARIA(M+1)-PADVARIA(M)) THEN
C            L=0
C  109       IF(L.LE.K-J-1) THEN
C              IF(ADVARIA(PADVARIA(M)+L:PADVARIA(M)+L).NE.
C     *        FORMF(J+L:J+L)) GOTO 100
C              L=L+1
C              GOTO 109
C            ENDIF
CC    -- NASLI JSME PROMENNOU SE ZMENENYM JMENEM
C            GOTO 96
C          ENDIF
C  100     M=M+1
C          GOTO 101
C        ENDIF
C        J=K
C        GOTO 97

C     JE LEVA STRANA V TABULCE?

        K=J-1
C     UBEREME MEZERY
  370   IF(FORMF(K:K).EQ.' ') THEN
          K=K-1
           GOTO 370
         ENDIF
C     JESTLI JE INDEX POLE, IGNORUJEME HO
        IF(FORMF(K:K).EQ.')') THEN
          N=1  !POCET OTEVRENYCH ZAVOREK
  371     IF(N.NE.0) THEN
            K=K-1
             IF(FORMF(K:K).EQ.')') N=N+1
             IF(FORMF(K:K).EQ.'(') N=N-1
            GOTO 371
           ENDIF
           K=K-1
C     A JESTE UBEREME MEZERY
  372     IF(FORMF(K:K).EQ.' ') THEN
            K=K-1
             GOTO 372
           ENDIF
         ENDIF
C     ZJISTIM JMENO PROMENNE NA LEVE STRANE
        L=K
  373   IF(FORMF(L:L).NE.' ') THEN
          L=L-1
           GOTO 373
         ENDIF
        L=L+1
C     JE TOHLE JMENO PROMENNE V TABULCE??
         M=1
        PADVARIA(101)=LADVARIA+1
  374   IF((PADVARIA(M).NE.-1).AND.(M.LE.100)) THEN
          IF(K-L+1.EQ.PADVARIA(M+1)-PADVARIA(M)) THEN
            N=0
  375       IF(N.LE.K-L) THEN
              IF(ADVARIA(PADVARIA(M)+N:PADVARIA(M)+N).NE.
     *        FORMF(L+N:L+N)) GOTO 376
               N=N+1
               GOTO 375
             ENDIF
C              NASLI JSME PROMENNOU SE ZMENENYM JMENEM
C              TAKZE TENHLE RADEK BUDEME TRANSFORMOVAT
            GOTO 96
          ENDIF
  376     M=M+1
           GOTO 374
        ENDIF
C     PROMENNA NENI V TABULCE
C     TENHLE RADEK NEBUDEME TRANSFORMOVAT
        GOTO 95

C     NASTALA 1. MOZMOST -> KOPIE -- OK
   95   CONTINUE
         ADFORMF(LADFORMF+1:LADFORMF+IKON_RA-I+1)=FORMF(I:IKON_RA)
         LADFORMF=LADFORMF+IKON_RA-I+1
        GOTO 47

C     NASTALA  2. MOZNOST -> TRANSFORMACE -- OK
   96   CONTINUE
C     VYPUSTIME MEZERY (CISTIRNA -- PRO PORADEK A JEDNODUSSI NASLEDNE
C     ZPRACOVANI)
        K=I
        DO 110 J=I,IKON_RA
          IF(FORMF(J:J).NE.' ') THEN
             FORMF(K:K)=FORMF(J:J)
            K=K+1
           ENDIF
  110   CONTINUE
C     A NA KONEC RADKU DOPISEME MEZERY, KTERE JSME SEBRALI
        DO 111 J=K,IKON_RA
          FORMF(J:J)=' '
  111   CONTINUE
C       ZAZALOHUJEME IKON_RA, PROTOZE JSME RADEK ZKRATILI
        IKON_RAP=IKON_RA
        IKON_RA =K-1
C
C     VLASTNI TRANSFORMACE VYRAZU
C

C     LEVA STRANA
C        - KOPIE DO VYSTUPU VCETNE "IAD_'
         ADFORMF(LADFORMF+1:LADFORMF+4)='IAD_'
         LADFORMF=LADFORMF+4
         J=I
  112   IF((FORMF(J:J).NE.'(').AND.(FORMF(J:J).NE.'=')) THEN
          J=J+1
           GOTO 112
         ENDIF
         ADFORMF(LADFORMF+1:LADFORMF+J-I)=FORMF(I:J-1)
         LADFORMF=LADFORMF+J-I
C        - ZAPSAT DO POMOCNE PREVODNI TABULKY PROMENNYCH
        ADVARIA(LADVARIA+1:LADVARIA+J-I)=FORMF(I:J-1)
         LADVARIA=LADVARIA+J-I
        K=1
  114   IF(PADVARIA(K).NE.-1) THEN
           K=K+1
          IF(K.GT.100) GOTO 99
           GOTO 114
         ENDIF
         PADVARIA(K)=PADVARIA(K-1)+J-I  !V ADVARIA JE VZDY 'X'
        I=J
C       POKUD JE NA LEVE STRANE POLE, DOKOPIRUJEME JEHO INDEX
  113   IF(FORMF(J:J).NE.'=') THEN
          J=J+1
           GOTO 113
         ENDIF
         ADFORMF(LADFORMF+1:LADFORMF+J-I)=FORMF(I:J-1)
         LADFORMF=LADFORMF+J-I
        I=J

C     ROVNITKO (PRIRAZENI)

         ADFORMF(LADFORMF+1:LADFORMF+1)=FORMF(I:I)
         LADFORMF=LADFORMF+1
        I=I+1

C     PRAVA STRANA

C     ZNAMENKO PRO MOCNENI (**) NAHRADIME JINYM (#) -- JEDNODUSSIM
        K=0 !KOLIKRAT UZ OBSAZENY **
         J=I
  207   IF(J.LE.IKON_RA-1) THEN
          IF(FORMF(J:J+1).EQ.'**') THEN
              FORMF(J:J)='#'
             DO 208 L=J+1,IKON_RA-K-1
                FORMF(L:L)=FORMF(L+1:L+1)
  208        CONTINUE
              FORMF(IKON_RA-K:IKON_RA-K)=' '
             K=K+1
          ENDIF
           J=J+1
           GOTO 207
         ENDIF
C       RADEK SE ZKRATIL O K
        IKON_RA=IKON_RA-K

C      TRANSFORMCE VYRAZU POMOCI "REKURZE":
C       NAJDE SE OPERACE S NEJNIZSI PRIORITOU VNE ZAVOREK CO NEJVICE
C       VPRAVO, A NA CAST VLEVO A VPRAVO SE SPUSTI TOTEZ
C       ZDROJ: T.TOPFER: ALGORITMY A PROGRAMOVACI TECHNIKY

C     INICIALIZACE PROMENNYCH (PRO REKURZI)
        DO 121 J=1,50
          DO 122 K=1,7
             AVYRAZ(J,K)=-1
  122     CONTINUE
  121   CONTINUE

        UROVEN=0
        AVYRAZ(1,1)=I
        AVYRAZ(1,2)=IKON_RA

C      VLASTNI REKURZE

  200   UROVEN=UROVEN+1

        IF(AVYRAZ(UROVEN,2)-AVYRAZ(UROVEN,1).LE.1) GOTO 202
C       URCITE BEZ OPERACE

C       ODZAVORKUJEME, POKUD TO JDE
  205   IF((FORMF(AVYRAZ(UROVEN,1):AVYRAZ(UROVEN,1)).EQ.'(').AND.
     *     (FORMF(AVYRAZ(UROVEN,2):AVYRAZ(UROVEN,2)).EQ.')')) THEN
           K=1 ! POCET ZAVOREK
          DO 201 J=AVYRAZ(UROVEN,1)+1,AVYRAZ(UROVEN,2)-1
                IF(FORMF(J:J).EQ.'(') K=K+1
                IF(FORMF(J:J).EQ.')') K=K-1
            IF(K.LE.0) GOTO 204
  201     CONTINUE
C       MUZEME ODZAVORKOVAT, TAK TO UDELEJME
           AVYRAZ(UROVEN,1)=AVYRAZ(UROVEN,1)+1
          AVYRAZ(UROVEN,2)=AVYRAZ(UROVEN,2)-1
          GOTO 205  ! A ZKOUSIME ODZAVORKOVAVAT DAL
        ENDIF

C       UZ NENI MOZNE ODZAVOROVAVAT

  204   CONTINUE

C       TEST PRITOMNOSTI BINARNI OPERACE

        DO 206 J=AVYRAZ(UROVEN,1),AVYRAZ(UROVEN,2)
          IF((FORMF(J:J).EQ.'+').OR.
     *       (FORMF(J:J).EQ.'*').OR.
     *       (FORMF(J:J).EQ.'-').OR.
     *       (FORMF(J:J).EQ.'/').OR.
     *       (FORMF(J:J).EQ.'#')) GOTO 203
  206   CONTINUE
C
C       JE TO POUZE CISLO NEBO PROMENNA NEBO FUNKCE -> "KOPIE" A V
C       REKURZI SKOCIT ZPET
C
  202   CONTINUE

C       JE TO CISLO?

        IF(((FORMF(AVYRAZ(UROVEN,1):AVYRAZ(UROVEN,1)).GE.'0').AND.
     *      (FORMF(AVYRAZ(UROVEN,1):AVYRAZ(UROVEN,1)).LE.'9')).OR.
     *      (FORMF(AVYRAZ(UROVEN,1):AVYRAZ(UROVEN,1)).EQ.'-') .OR.
     *      (FORMF(AVYRAZ(UROVEN,1):AVYRAZ(UROVEN,1)).EQ.'+')) THEN
C       JE TO CISLO, JEN HO OKOPIRUJEME JAKO mkcnsth(cislo)
          ADFORMF(LADFORMF+1:LADFORMF+13)='MKCNSTH(DBLE('
           LADFORMF=LADFORMF+13
           IF(AVYRAZ(UROVEN,1).GT.AVYRAZ(UROVEN,2)) THEN
C           JE TU UNARNI MINUS
             ADFORMF(LADFORMF+1:LADFORMF+1)='0'
             LADFORMF=LADFORMF+1
              ELSE
C           NENI TU UNARNI MINUS
            ADFORMF(LADFORMF+1:
     *              LADFORMF+AVYRAZ(UROVEN,2)-AVYRAZ(UROVEN,1)+1)=
     *                       FORMF(AVYRAZ(UROVEN,1):AVYRAZ(UROVEN,2))
             LADFORMF=LADFORMF+AVYRAZ(UROVEN,2)-AVYRAZ(UROVEN,1)+1
           ENDIF
          ADFORMF(LADFORMF+1:LADFORMF+2)='))'
          LADFORMF=LADFORMF+2
          GOTO 211
         ENDIF

C       JE TO FUNKCE?
  224   CONTINUE
C       POKUSIME SE NAJIT ZAVORKU-TJ. ARGUMENT FUNKCE NEBO INDEX POLE
        DO 213, J=AVYRAZ(UROVEN,1),AVYRAZ(UROVEN,2)
          IF(FORMF(J:J).EQ.'(') GOTO 214
  213   CONTINUE
C       NENASLI JSME ZAVORKU, JE TO JEN "OBYCEJNA PROMENNA"
        GOTO 215

C       NASLI JSME ZAVORKU (
C       BUDEME HLEDAT V SEZNAMU PREDEFINOVANYCH FUNKCI
  214    K=1
  216   IF(K.LE.NADFCTN) THEN
          IF(LADFCTN(2*K)-LADFCTN(2*K-1).EQ.J-AVYRAZ(UROVEN,1)) THEN
            L=1
  249       IF(L.LE.J-AVYRAZ(UROVEN,1)) THEN
              IF(ADFCTN(LADFCTN(2*K-1)+L-1:LADFCTN(2*K-1)+L-1)
     *         .NE. FORMF(AVYRAZ(UROVEN,1)+L-1:AVYRAZ(UROVEN,1)+L-1))
     *         GOTO 219
               L=L+1
               GOTO 249
             ENDIF
C           MAME FUNKCI, KTERA JE PREDEFINOVANA
C           NAHRADIME JEJI JMENO
            ADFORMF(LADFORMF+1:LADFORMF+LADFCTN(2*K+1)-LADFCTN(2*K))=
     *        ADFCTN(LADFCTN(2*K):LADFCTN(2*K+1)-1)
             LADFORMF=LADFORMF+LADFCTN(2*K+1)-LADFCTN(2*K)
C         OTEVIRACI ZAVORKA
            ADFORMF(LADFORMF+1:LADFORMF+1)='('
             LADFORMF=LADFORMF+1
C         A REKURZE...
            AVYRAZ(UROVEN,5)=100
            AVYRAZ(UROVEN,6)=2
             AVYRAZ(UROVEN,7)=1
            IF(UROVEN.GE.50) GOTO 99
            AVYRAZ(UROVEN+1,1)=J+1
             AVYRAZ(UROVEN+1,2)=AVYRAZ(UROVEN,2)-1
            GOTO 200
          ENDIF
  219     K=K+1
           GOTO 216
        ENDIF
C       NENI TO FUNKCE, KTERE MAME PREDEFINOVANE
C       POVAZUJEME TO TEDA ZA PROMENNOU
C       VE SKUTECNOSTI TO JE - PROMENNA NEBO
C                            - FUNKCE, KTEROU BUDEME POVAZOVAT ZA CISLO
C                              BEZ TRANSFORMOVANI

C       JE TO TEDY PROMENNA (EVENT. POLE(S INDEXEM))
  215   CONTINUE
C       JE TO PROMENNA SE ZMENENYM JMENEM?
         K=1
        PADVARIA(101)=LADVARIA+1
  220   IF((PADVARIA(K).NE.-1).AND.(K.LE.100)) THEN
          IF(J-AVYRAZ(UROVEN,1).EQ.PADVARIA(K+1)-PADVARIA(K)) THEN
            L=0
  221       IF(L.LE.J-AVYRAZ(UROVEN,1)-1) THEN
              IF(ADVARIA(PADVARIA(K)+L:PADVARIA(K)+L).NE.
     *          FORMF(AVYRAZ(UROVEN,1)+L:AVYRAZ(UROVEN,1)+L)) GOTO 222
               L=L+1
               GOTO 221
             ENDIF
C          NASLI JSME PROMENNOU SE ZMENENYM JMENEM
            ADFORMF(LADFORMF+1:LADFORMF+4)='IAD_'
            LADFORMF=LADFORMF+4
            ADFORMF(LADFORMF+1:
     *              LADFORMF+AVYRAZ(UROVEN,2)-AVYRAZ(UROVEN,1)+1)=
     *        FORMF(AVYRAZ(UROVEN,1):AVYRAZ(UROVEN,2))
             LADFORMF=LADFORMF+AVYRAZ(UROVEN,2)-AVYRAZ(UROVEN,1)+1
             GOTO 211
          ENDIF
  222     K=K+1
          GOTO 220
         ENDIF
C       NENI TO TEDY PROMENNA SE ZMENENYM JMENEM,
C        JEN JI OPISEME JAKO KONSTANTU
        ADFORMF(LADFORMF+1:LADFORMF+13)='MKCNSTH(DBLE('
         LADFORMF=LADFORMF+13
        ADFORMF(LADFORMF+1:
     *            LADFORMF+AVYRAZ(UROVEN,2)-AVYRAZ(UROVEN,1)+1)=
     *                     FORMF(AVYRAZ(UROVEN,1):AVYRAZ(UROVEN,2))
         LADFORMF=LADFORMF+AVYRAZ(UROVEN,2)-AVYRAZ(UROVEN,1)+1
        ADFORMF(LADFORMF+1:LADFORMF+2)='))'
         LADFORMF=LADFORMF+2
        GOTO 211

C
C         VE VYRAZU JSOU OPERACE -->
C                       - NAJIT OPERACI S NEJMENSI PRIORITOU VNE ZAVORKY
C                       - ROZDELIT NA LEVOU A PRAVOU CAST A ZPRACOVAT
C                       (- MOCNENI **  NAHRAZENO #)

  203   CONTINUE
C        NALEZENI OPERACE VENKU ZE ZAVOREK (EXISTUJE-LI)
        PRIOR1=-1
        PRIOR2=-1
        PRIOR3=-1
         K=0 !POCET OTEVRENYCH ZAVOREK
        DO 223 J=AVYRAZ(UROVEN,1),AVYRAZ(UROVEN,2)
          IF(FORMF(J:J).EQ.'(') K=K+1
          IF(FORMF(J:J).EQ.')') K=K-1
          IF((K.EQ.0).AND.
     *       ((FORMF(J:J).EQ.'+').OR.(FORMF(J:J).EQ.'-'))) THEN
               PRIOR3=J
           ENDIF
          IF((K.EQ.0).AND.
     *       ((FORMF(J:J).EQ.'*').OR.(FORMF(J:J).EQ.'/'))) THEN
               PRIOR2=J
           ENDIF
          IF((K.EQ.0).AND.(FORMF(J:J).EQ.'#')) THEN
               PRIOR1=J
           ENDIF
  223   CONTINUE
        IF(K.NE.0) GOTO 99 !NEKDE NEJAKA CHYBA
C       HLEDAME OPERACI VNE ZAVORKY S NEJMENSI PRIORITOU CO NEJVIC
C       VPRAVO
        IF    (PRIOR3.NE.-1) THEN
           J=PRIOR3
         ELSEIF(PRIOR2.NE.-1) THEN
           J=PRIOR2
         ELSEIF(PRIOR1.NE.-1) THEN
           J=PRIOR1
        ELSE
C          NEEXISTUJE OPERACE VNE ZAVOREK
C         ALE JEN UVNITR NEODTRANITELNYCH ZAVOREK
C         TJ. BUD V ARGUMENTU FUNKCE NEBO INDEXU POLE
C         ZPRACUJEME TO TEDY JAKO VYSE...
          GOTO 224
         ENDIF
C       NASLI JSME OPERACI VNE ZAVOREK
C       A ROZDELIME VYRAZ NA LEVOU A PRAVOU CAST A KAZDOU ZPRACUJEME
C       SAMOSTATNE (REKURZE...)

C        ZPRACOVANUI LEVE CASTI VYRAZU

        IF(FORMF(J:J).EQ.'+') THEN
           ADFORMF(LADFORMF+1:LADFORMF+7)='BPLUSH('
           LADFORMF=LADFORMF+7
           AVYRAZ(UROVEN,5)=10
         ENDIF
        IF(FORMF(J:J).EQ.'-') THEN
           ADFORMF(LADFORMF+1:LADFORMF+7)='BMINUH('
           LADFORMF=LADFORMF+7
           AVYRAZ(UROVEN,5)=20
         ENDIF
        IF(FORMF(J:J).EQ.'*') THEN
           ADFORMF(LADFORMF+1:LADFORMF+7)='BMULTH('
           LADFORMF=LADFORMF+7
           AVYRAZ(UROVEN,5)=30
         ENDIF
        IF(FORMF(J:J).EQ.'/') THEN
           ADFORMF(LADFORMF+1:LADFORMF+6)='BDIVH('
           LADFORMF=LADFORMF+6
           AVYRAZ(UROVEN,5)=40
         ENDIF
        IF(FORMF(J:J).EQ.'#') THEN
           ADFORMF(LADFORMF+1:LADFORMF+7)='BEXPG2('
           LADFORMF=LADFORMF+7
           AVYRAZ(UROVEN,5)=52
         ENDIF
        AVYRAZ(UROVEN,1)=AVYRAZ(UROVEN,1)
         AVYRAZ(UROVEN,4)=AVYRAZ(UROVEN,2)  !POZOR NA PORADI
        AVYRAZ(UROVEN,2)=J-1
        AVYRAZ(UROVEN,3)=J+1
        AVYRAZ(UROVEN,6)=1
         AVYRAZ(UROVEN,7)=1
        IF(UROVEN.GE.50) GOTO 99
        AVYRAZ(UROVEN+1,1)=AVYRAZ(UROVEN,1)
         AVYRAZ(UROVEN+1,2)=J-1
        GOTO 200

C        SEM SE SKOCI PRI NAVRATU Z REKURZE "DOPROSTRED"
C        TJ. POKUD AVYRAZ(*,6)=1
  209   CONTINUE
C        VLOZIME CARKU JAKO ODDELENI PARAMETRU
         ADFORMF(LADFORMF+1:LADFORMF+1)=','
         LADFORMF=LADFORMF+1
C        ZPRACOVANI PRAVE CASTI VYRAZU
        AVYRAZ(UROVEN,6)=2
         AVYRAZ(UROVEN,7)=1
        IF(UROVEN.GE.50) GOTO 99
        AVYRAZ(UROVEN+1,1)=AVYRAZ(UROVEN,3)
         AVYRAZ(UROVEN+1,2)=AVYRAZ(UROVEN,4)
        GOTO 200
C        SEM SE SKOCI PRI NAVRATU Z REKURZE "NAKONEC"
C        TJ. POKUD AVYRAZ(*,6)=2
  210   CONTINUE
C        NASLEDUJE NAVRAT DO HORNEJSI VRSTVY REKURZE
C        (POKUD UROVEN>1)
        IF(AVYRAZ(UROVEN,7).EQ.1) THEN
          ADFORMF(LADFORMF+1:LADFORMF+1)=')'
           LADFORMF=LADFORMF+1
         ENDIF
C        NAVRAT DO HORNEJSI VRSTVY REKURZE
  211   CONTINUE
        IF(UROVEN.EQ.1) GOTO 212
         AVYRAZ(UROVEN,1)=-1
         AVYRAZ(UROVEN,2)=-1
         AVYRAZ(UROVEN,3)=-1
         AVYRAZ(UROVEN,4)=-1
         AVYRAZ(UROVEN,5)=-1
         AVYRAZ(UROVEN,6)=-1
         AVYRAZ(UROVEN,7)=-1
        UROVEN=UROVEN-1
         IF(AVYRAZ(UROVEN,6).EQ.1) GOTO 209
         IF(AVYRAZ(UROVEN,6).EQ.2) GOTO 210
         GOTO 99

C       KONEC TRANSFORMACE VYRAZU
  212   CONTINUE
C==================================
C       IKON_RA VRATIME ZASE ZPET, ABY NAM VSE FUNGOVALO
        IKON_RA=IKON_RAP
        GOTO 47

C       --- KONEC TRANSFORMACE VYRAZU ---

   83   CONTINUE

C
C     COKOLIV JINEHO - VYPOUSTIME (DO VYSTUPU SE NEPRENESE)
C     (TJ. NEROZPOZNANY PRIKAZ)
C

C    **************************
C       KONEC TRANSFORMACE
C    **************************

   47   CONTINUE

C
C     JESTE ZAPSAT STREDNIK, BYL-LI PUVODNE
C
        IF(LCOMMA) THEN
           ADFORMF(LADFORMF+1:LADFORMF+1)=';'
           LADFORMF=LADFORMF+1
         ENDIF

C
C     NALEZENI DALSIHO RADKU V FORMF
C
        IZAC_RA=IKON_RA+2
        IF(.NOT.(LCOMMA)) GOTO 45
      I=IZAC_RA
   44   IF((FORMF(I:I).NE.';').AND.(I.LT.LFORMF)) THEN
          I=I+1
           GO TO 44
         ENDIF
         IF(FORMF(I:I).NE.';') THEN
           IKON_RA=I
           LCOMMA=.FALSE.
         ELSE
           IKON_RA=I-1
           LCOMMA=.TRUE.
         ENDIF
   45   CONTINUE
        GOTO 43
      ENDIF

C     NAKONEC JESTE STREDNIK JAKO PRECHOD NA NOVY RADEK
      ADFORMF(LADFORMF+1:LADFORMF+1)=';'
         LADFORMF=LADFORMF+1

C====================================

C     -- DOSADIME VBAR(IAD_Y(1))=1
C     VBAR(IAD_Y)=1.0D0
      IF(CHX.EQ.'A') THEN
        ADFORMF(LADFORMF+1:LADFORMF+22)='   VBAR(IAD_FA)=1.0D0;'
      ELSEIF(CHX.EQ.'C') THEN
        ADFORMF(LADFORMF+1:LADFORMF+22)='   VBAR(IAD_FC)=1.0D0;'
      ELSEIF(CHX.EQ.'F') THEN
        ADFORMF(LADFORMF+1:LADFORMF+22)='   VBAR(IAD_FF)=1.0D0;'
      ENDIF
      LADFORMF=LADFORMF+22

C     -- DOSADIME VBARDT(IAD_Y(1))=0.0D0
C     VBARDT(IAD_Y)=0.0D0
      IF(CHX.EQ.'A') THEN
        ADFORMF(LADFORMF+1:LADFORMF+24)='   VBARDT(IAD_FA)=0.0D0;'
      ELSEIF(CHX.EQ.'C') THEN
        ADFORMF(LADFORMF+1:LADFORMF+24)='   VBARDT(IAD_FC)=0.0D0;'
      ELSEIF(CHX.EQ.'F') THEN
        ADFORMF(LADFORMF+1:LADFORMF+24)='   VBARDT(IAD_FF)=0.0D0;'
      ENDIF
      LADFORMF=LADFORMF+24

C     -- ZAVOLANI RVRSWP()
C     CALL RVRSWP()
         ADFORMF(LADFORMF+1:LADFORMF+18)='   CALL RVRSWPH();'
         LADFORMF=LADFORMF+18

C     -- VYSTUP HODNOT DERIVACI (HF=...)
      IF(CHX.EQ.'A') THEN
        ADFORMF(LADFORMF+1 :LADFORMF+25)='   DO 89 IADCOUNT=1,IADN;'
        ADFORMF(LADFORMF+26:LADFORMF+71)=
     *       '   HA(IADN1+IADCOUNT)=VBARDT(IAD_X(IADCOUNT));'
        ADFORMF(LADFORMF+72:LADFORMF+83)='89 CONTINUE;'
        ADFORMF(LADFORMF+84:LADFORMF+100)='IADN1=IADN1+IADN;'
        LADFORMF=LADFORMF+100
C       UZAVRETI CYKLU (DRUHE DERIVACE...)
        ADFORMF(LADFORMF+1 :LADFORMF+12)='87 CONTINUE;'
      ELSEIF(CHX.EQ.'C') THEN
        ADFORMF(LADFORMF+1 :LADFORMF+25)='   DO 79 IADCOUNT=1,IADN;'
        ADFORMF(LADFORMF+26:LADFORMF+71)=
     *       '   HC(IADN1+IADCOUNT)=VBARDT(IAD_X(IADCOUNT));'
        ADFORMF(LADFORMF+72:LADFORMF+83)='79 CONTINUE;'
        ADFORMF(LADFORMF+84:LADFORMF+100)='IADN1=IADN1+IADN;'
        LADFORMF=LADFORMF+100
C       UZAVRETI CYKLU (DRUHE DERIVACE...)
        ADFORMF(LADFORMF+1 :LADFORMF+12)='77 CONTINUE;'
      ELSEIF(CHX.EQ.'F') THEN
        ADFORMF(LADFORMF+1 :LADFORMF+25)='   DO 99 IADCOUNT=1,IADN;'
        ADFORMF(LADFORMF+26:LADFORMF+71)=
     *       '   HF(IADN1+IADCOUNT)=VBARDT(IAD_X(IADCOUNT));'
        ADFORMF(LADFORMF+72:LADFORMF+83)='99 CONTINUE;'
        ADFORMF(LADFORMF+84:LADFORMF+100)='IADN1=IADN1+IADN;'
        LADFORMF=LADFORMF+100
C       UZAVRETI CYKLU (DRUHE DERIVACE...)
        ADFORMF(LADFORMF+1 :LADFORMF+12)='97 CONTINUE;'
      ENDIF
      LADFORMF=LADFORMF+12
C
C   ZAPIS ZTRANSFORMOVANEHO VYPOCTU DO SYMTAB
C   (PREVZATO Z UQSETV.F)
      LENN=7                ! DELKA JMENA   HMODELX
      LENM=LADFORMF         ! DELKA HODNOTY HMODELX
      LEN1=LENN+LENM
C
C TRY TO FIND MACRO
C
      IF(LP.NE.0) THEN
        IP=LP
   21   IF(IPOINT(IP,3).EQ.7) THEN
          IF(('H'.NE.SYMTAB(IPOINT(IP,2)  )).OR.
     *       ('M'.NE.SYMTAB(IPOINT(IP,2)+1)).OR.
     *       ('O'.NE.SYMTAB(IPOINT(IP,2)+2)).OR.
     *       ('D'.NE.SYMTAB(IPOINT(IP,2)+3)).OR.
     *       ('E'.NE.SYMTAB(IPOINT(IP,2)+4)).OR.
     *       ('L'.NE.SYMTAB(IPOINT(IP,2)+5)).OR.
     *       (CHX.NE.SYMTAB(IPOINT(IP,2)+6))) GOTO 23
C
C MACRO FOUND
C
          IF(IPOINT(IP,6).GT.1) GOTO 99
          IF(IP.EQ.LP) THEN
            IF(IPOINT(IP,2)+LEN1.LE.MLENST) THEN
              LENST=IPOINT(IP,2)+LEN1-1
              GOTO 29
            ELSE
              LENST=IPOINT(IPOINT(IP,1),4)
              GOTO 27
            ENDIF
          ELSEIF(IPOINT(IPPRED,2)-IPOINT(IP,2).GE.LEN1) THEN
            GOTO 29
          ELSE
            IPOINT(IPPRED,1)=IPOINT(IP,1)
            GOTO 26
          ENDIF
        ENDIF
   23   IPPRED=IP
        IP=IPOINT(IP,1)
        IF(IP.GT.0) GOTO 21
      ENDIF
C
C MACRO NOT FOUND, FIND FREE POINTER
C
      DO 24 IP=LP+1,MNP
        IF(IPOINT(IP,1).EQ.-1) GOTO 26
   24 CONTINUE
      DO 25 IP=LP-1,1,-1
        IF(IPOINT(IP,1).EQ.-1) GOTO 26
   25 CONTINUE
      GOTO 99
C
C CREATE NEW POINTER AND LINK IT
C
   26 IPOINT(IP,1)=LP
      LP=IP
      IPOINT(IP,3)=LENN
   27 IF(LEN1+LENST.GE.MLENST) GOTO 99
      IPOINT(IP,2)=LENST+1
      LENST=LENST+LEN1
C
C SET MACRO NAME TO SYMTAB
C
      SYMTAB(IPOINT(IP,2)  )='H'
      SYMTAB(IPOINT(IP,2)+1)='M'
      SYMTAB(IPOINT(IP,2)+2)='O'
      SYMTAB(IPOINT(IP,2)+3)='D'
      SYMTAB(IPOINT(IP,2)+4)='E'
      SYMTAB(IPOINT(IP,2)+5)='L'
      SYMTAB(IPOINT(IP,2)+6)=CHX
C
C SET MACRO VALUE TO SYMTAB
C
   29 IPOINT(IP,4)=IPOINT(IP,2)+LEN1-1
      IPOINT(IP,5)=1
      IPOINT(IP,6)=1   ! MODERW
      IF(LENM.EQ.0) RETURN
      IPOS=IPOINT(IP,2)+LENN
      DO 31 I=0,LENM-1
        SYMTAB(IPOS+I)=ADFORMF(I+1:I+1)
   31 CONTINUE

      WRITE(*,*) '--- KONEC   UQADI3 ---'

      RETURN

C
C ERROR: SOME AUTOMATICAL DIFFERENTIATION ERROR
C
   99 IER=48
      RETURN
      $OPTION(CHEOL=';')
      END
