* SUBROUTINE UQDOED                ALL SYSTEMS                89/12/01
* PORTABILITY : ALL SYSTEMS
* 89/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  PERFORM DIRECTIVE  DO(I=IND1,IND2,IND3) - ENDDO
*
* PARAMETERS :
*  TU  BUFFER(MLENB) - WORK BUFFER
*  II  MLENB - MAX. LENGTH OF THE BUFFER
*  IU  LENB - ACTUAL LENGTH OF THE BUFFER
*  IU  IPOS1 - POSITION OF THE FIRST CHARACTER OF LINE
*               IN THE BUFFER
*  II  IPOSD - POSITION OF THE FIRST CHARACTER OF DIRECTIVE
*               IN THE BUFFER
*  IU  IPOS2 - POSITION OF THE LAST CHARACTER OF LINE
*               IN THE BUFFER
*  TU  SYMTAB(MLENST) - SYMBOL TABLE
*  II  MLENST - MAX. LENGTH OF THE SYMBOL TABLE
*  IU  IPOINT(MNP,6) - ARRAY OF POINTERS TO THE SYMBOL TABLE
*               1-LINK, 2-POSITION OF THE FIRST CHARACTER,
*               3-LENGTH OF NAME, 4-POSITION OF THE LAST CHARACTER,
*               5-POINTER OF LIST, 6-MODERW (1-RW, 2-RA, 3-RO)
*  II  MNP - MAX. NUMBER OF POINTERS
*  IU  NDO - NUMBER OF NESTED DO-ENDDO
*  IU  NLINES - NUMBER OF LINES
*  II  IUNIT - THE INPUT UNIT NUMBER
*  II  IDIRN - NUMBER OF DIRECTIVE
*  II  ILNLEN - THE INPUT LINE LENGTH
*  LU  CONDDO - IF CONDDO=.TRUE. THEN LOOP WILL BE PERFORMED
*  TI  CHCON - THE CONTINUATION MARKER
*  TI  CHEOL - THE END OF LINE MARKER
*  IO  IER - ERROR INDICATOR
*
* SUBPROGRAMS USED :
*  S   UQSADR - SYNTAX ANALYSIS OF DIRECTIVE LINE
*  S   UQDELV - DELETE A MACRO FROM SYMBOL TABLE
*  S   UQSETV - SET A MACRO TO SYMBOL TABLE
*  IF  UQINTI - CONVERT A SUBSTRING TO AN INTEGER NUMBER
*  S   UQSTRI - CONVERT AN INTEGER NUMBER TO STRING
*  S   UQCEOL - CHECK END OF LINE
*  S   UQRDLN - READ A LINE
*  S   UQSUBS - PERFORM SUBSTITUTIONS
*  S   UQDELS - DELETE A SUBSTRING FROM A STRING ARRAY
*
      SUBROUTINE UQDOED(BUFFER,MLENB,LENB,IPOS1,IPOSD,IPOS2,SYMTAB,
     *                  MLENST,IPOINT,MNP,NDO,NLINES,IUNIT,IDIRN,
     *                  ILNLEN,CONDDO,CHCON,CHEOL,IER)
      INTEGER MLENB,LENB,IPOS1,IPOSD,IPOS2,MLENST,MNP,IPOINT(MNP,6),
     *        NDO,NLINES,IUNIT,IDIRN,ILNLEN,IER
      CHARACTER*1 BUFFER(MLENB),SYMTAB(MLENST),CHCON,CHEOL
      LOGICAL CONDDO
      INTEGER MNPAR,MNPAR2,MNDO
      PARAMETER(MNPAR=7,MNPAR2=1,MNDO=20)
      INTEGER NPAR,IPOSP(MNPAR,2),ITYPE(MNPAR),IDOLN(MNDO),I,K,IPOSM1,
     *        IPOSM2,LENB2
      INTEGER*4 UQINTI,INDEX1(MNDO),INDEX3(MNDO),ITCDO(MNDO),IND2
      SAVE INDEX1,INDEX3,ITCDO,IDOLN

C
C DO(I=IND1,IND2,IND3)
C
      IF(IDIRN.EQ.15) THEN
        NDO=NDO+1
        IF(NDO.GT.MNDO) GOTO 14
        IF(.NOT.CONDDO) RETURN
        CALL UQSADR(BUFFER,MLENB,IPOSD,IPOS2,IPOSP,MNPAR,NPAR,ITYPE,IER)
        IF(IER.NE.0) RETURN
        IF(NPAR.NE.5.AND.NPAR.NE.7) GOTO 8
        IF(ITYPE(1).NE.5) GOTO 8
        IF(ITYPE(2).NE.3) GOTO 9
        IF(ITYPE(4).NE.4) GOTO 10
        IF(ITYPE(3).EQ.7) THEN
          INDEX1(NDO)=UQINTI(BUFFER,MLENB,IPOSP(3,1),IPOSP(3,2),IER)
        ELSEIF(ITYPE(3).EQ.5) THEN
          CALL UQGVAL(BUFFER,MLENB,IPOSP(3,1),IPOSP(3,2),SYMTAB,
     *                MLENST,IPOSP(3,1),IPOSP(3,2),IPOINT,MNP,IER)
          IF(IER.NE.0) RETURN
          INDEX1(NDO)=UQINTI(SYMTAB,MLENST,IPOSP(3,1),IPOSP(3,2),IER)
        ELSE
          GOTO 11
        ENDIF
        IF(IER.NE.0) RETURN
        IF(ITYPE(5).EQ.7) THEN
          IND2=UQINTI(BUFFER,MLENB,IPOSP(5,1),IPOSP(5,2),IER)
        ELSEIF(ITYPE(5).EQ.5) THEN
          CALL UQGVAL(BUFFER,MLENB,IPOSP(5,1),IPOSP(5,2),SYMTAB,
     *                MLENST,IPOSP(5,1),IPOSP(5,2),IPOINT,MNP,IER)
          IF(IER.NE.0) RETURN
          IND2=UQINTI(SYMTAB,MLENST,IPOSP(5,1),IPOSP(5,2),IER)
        ELSE
          GOTO 11
        ENDIF
        IF(IER.NE.0) RETURN
        IF(NPAR.EQ.5) THEN
          INDEX3(NDO)=1
        ELSE
          IF(ITYPE(6).NE.4) GOTO 10
          IF(ITYPE(7).EQ.7) THEN
            INDEX3(NDO)=UQINTI(BUFFER,MLENB,IPOSP(7,1),IPOSP(7,2),IER)
          ELSEIF(ITYPE(7).EQ.5) THEN
            CALL UQGVAL(BUFFER,MLENB,IPOSP(7,1),IPOSP(7,2),SYMTAB,
     *                  MLENST,IPOSP(7,1),IPOSP(7,2),IPOINT,MNP,IER)
            IF(IER.NE.0) RETURN
            INDEX3(NDO)=UQINTI(SYMTAB,MLENST,IPOSP(7,1),IPOSP(7,2),
     *                         IER)
          ELSE
            GOTO 11
          ENDIF
        ENDIF
        IF(IER.NE.0) RETURN
        IF(INDEX3(NDO).EQ.0) GOTO 12
        ITCDO(NDO)=(IND2-INDEX1(NDO)+INDEX3(NDO))/INDEX3(NDO)
        IF(ITCDO(NDO).LE.0) THEN
          CONDDO=.FALSE.
        ELSE
          IDOLN(NDO)=NLINES
          GOTO 5
        ENDIF
C
C ENDDO
C
      ELSE
        CALL UQCEOL(BUFFER,MLENB,IPOSD,IER)
        IF(IER.NE.0) RETURN
        CONDDO=.TRUE.
        IF(NDO.EQ.0) GOTO 13
        ITCDO(NDO)=ITCDO(NDO)-1
        IF(ITCDO(NDO).GT.0) THEN
    1     DO 2 NLINES=NLINES,IDOLN(NDO),-1
            BACKSPACE IUNIT
    2     CONTINUE
          LENB=IPOS1-1
          I=1
          K=1
    3     IF(NDO-K.LE.0) THEN
          ELSEIF(IDOLN(NDO-K).EQ.IDOLN(NDO)) THEN
            K=K+1
            GOTO 3
          ENDIF
          CALL UQRDLN(BUFFER,MLENB,LENB,NLINES,ILNLEN,IUNIT,
     *                CHCON,CHEOL,IER)
          IF(IER.NE.0) RETURN
    4     CALL UQSUBS(BUFFER,MLENB,IPOS1,IPOS2,SYMTAB,MLENST,
     *                IPOINT,MNP,IDIRN,IPOSD,IPOSM1,IPOSM2,IER)
          IF(IER.NE.0) RETURN
          IF(IDIRN.EQ.15) THEN
            IF(I.EQ.K) THEN
              INDEX1(NDO)=INDEX1(NDO)+INDEX3(NDO)
              GOTO 5
            ENDIF
            I=I+1
          ENDIF
          CALL UQDELS(BUFFER,MLENB,LENB,IPOS1,IPOS2)
          IF(IPOS1.GE.LENB) THEN
            BACKSPACE IUNIT
            GOTO 1
          ENDIF
          GOTO 4
        ELSE
          NDO=NDO-1
          IF(NDO.GT.0) THEN
            IF(ITCDO(NDO).LE.0) CONDDO=.FALSE.
          ENDIF
        ENDIF
      ENDIF
      RETURN
    5 LENB2=LENB
      CALL UQSTRI(INDEX1(NDO),BUFFER,MLENB,LENB,LENB+1,IER)
      IF(IER.NE.0) RETURN
      CALL UQSADR(BUFFER,MLENB,IPOSD,IPOS2,IPOSP,MNPAR2,NPAR,ITYPE,IER)
      IER=0
      CALL UQSETV(BUFFER,MLENB,IPOSP(1,1),IPOSP(1,2),LENB2+1,LENB,
     *            SYMTAB,MLENST,IPOINT,MNP,1,IER)
      IF(IER.NE.0) RETURN
      LENB=LENB2
      RETURN
C
C ERROR: SYNTAX ERROR
C
    8 IER=20
      RETURN
C
C ERROR: '=' EXPECTED
C
    9 IER=29
      RETURN
C
C ERROR: ',' EXPECTED
C
   10 IER=31
      RETURN
C
C ERROR: INTEGER NUMBER EXPECTED
C
   11 IER=26
      RETURN
C
C ERROR: IN 'DO(I=IND1,IND2,IND3)  IS  IND3=0
C
   12 IER=44
      RETURN
C
C ERROR: UNEXPECTED 'ENDDO'
C
   13 IER=45
      RETURN
C
C ERROR: 'MNDO' EXCEEDED - TOO MANY NESTED DO-ENDDO
C
   14 IER=46
      RETURN
      END


