* SUBROUTINE UQIFDR                ALL SYSTEMS                89/12/01
* PORTABILITY : ALL SYSTEMS
* 89/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  PERFORM DIRECTIVE 'IF' (BLOCK AND SIMPLE)
*
* PARAMETERS :
*  TI  BUFFER(MLENB) - WORK BUFFER
*  II  MLENB - MAX. LENGTH OF THE BUFFER
*  IU  LENB - ACTUAL LENGTH OF THE BUFFER
*  II  IPOS1 - POSITION OF THE FIRST CHARACTER OF LINE
*               IN THE BUFFER
*  II  IPOSD - POSITION OF THE FIRST CHARACTER OF DIRECTIVE
*               IN THE BUFFER
*  IU  IPOS2 - POSITION OF THE LAST CHARACTER OF LINE
*               IN THE BUFFER
*  TI  SYMTAB(MLENST) - SYMBOL TABLE
*  II  MLENST - MAX. LENGTH OF THE SYMBOL TABLE
*  II  IPOINT(MNP,6) - ARRAY OF POINTERS TO THE SYMBOL TABLE
*               1-LINK, 2-POSITION OF THE FIRST CHARACTER,
*               3-LENGTH OF NAME, 4-POSITION OF THE LAST CHARACTER,
*               5-POINTER OF LIST, 6-MODERW (1-RW, 2-RA, 3-RO)
*  II  MNP - MAX. NUMBER OF POINTERS
*  II  IDIRN - NUMBER OF DIRECTIVE
*  IU  NIF1 - NUMBER OF NESTED IF-ENDIF WITH CONDIF=.TRUE.
*  IU  NIF2 - NUMBER OF ALL NESTED IF-ENDIF
*  II  MNIF - MAX. NUMBER OF NESTED IF-ENDIF
*  LU  LELSE(MNIF) - WORK ARRAY
*  LU  LIFDON(MNIF) - WORK ARRAY
*  LU  CONDIF - CONDITION OF LAST IF-ENDIF
*  LO  COND - CONDITION OF SIMPLE 'IF'
*  IO  IER - ERROR INDICATOR
*
* SUBPROGRAMS USED :
*  LF  UQLEXP - EVALUATION OF LOGICAL EXPRESSION
*  S   UQDELS - DELETE A SUBSTRING FROM A STRING ARRAY
*
      SUBROUTINE UQIFDR(BUFFER,MLENB,LENB,IPOS1,IPOSD,IPOS2,SYMTAB,
     *                  MLENST,IPOINT,MNP,IDIRN,NIF1,NIF2,MNIF,LELSE,
     *                  LIFDON,CONDIF,COND,IER)
      INTEGER MLENB,LENB,IPOS1,IPOSD,IPOS2,MLENST,MNP,IPOINT(MNP,6),
     *        IDIRN,NIF1,NIF2,MNIF,IER
      CHARACTER*1 BUFFER(MLENB),SYMTAB(MLENST)
      LOGICAL LELSE(MNIF),LIFDON(MNIF),CONDIF,COND
      LOGICAL UQLEXP
      IF(IDIRN.EQ.116.AND..NOT.CONDIF) RETURN
      COND=UQLEXP(BUFFER,MLENB,IPOSD,IPOS2,SYMTAB,MLENST,
     *            IPOINT,MNP,IDIRN,IER)
      IF(IER.NE.0) RETURN
      IF(.NOT.CONDIF) THEN
        IF(IDIRN.EQ.16) NIF2=NIF2+1
        RETURN
      ENDIF
C
C SIMPLE IF
C
      IF(IDIRN.EQ.116) THEN
        IF(.NOT.COND) RETURN
        CALL UQDELS(BUFFER,MLENB,LENB,IPOS1,IPOSD)
C
C BLOCK IF
C
      ELSE
        NIF1=NIF1+1
        IF(NIF1.GT.MNIF) GOTO 1
        LELSE(NIF1)=.FALSE.
        LIFDON(NIF1)=COND
        CONDIF=COND
        NIF2=NIF1
      ENDIF
      RETURN
C
C ERROR: 'MNIF' EXCEEDED - TOO MANY NESTED IF-ENDIF
C
    1 IER=38
      RETURN
      END


