* SUBROUTINE UQINCL                ALL SYSTEMS                89/12/01
* PORTABILITY : ALL SYSTEMS
* 89/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  PERFORM DIRECTIVE 'INCLUDE'
*
* PARAMETERS :
*  TI  BUFFER(MLENB) - WORK BUFFER
*  II  MLENB - MAX. LENGTH OF THE BUFFER
*  II  IPOSD - POSITION OF THE FIRST CHARACTER OF DIRECTIVE
*               IN THE BUFFER
*  II  IPOS2 - POSITION OF THE LAST CHARACTER OF LINE
*               IN THE BUFFER
*  TU  SYMTAB(MLENST) - SYMBOL TABLE
*  II  MLENST - MAX. LENGTH OF THE SYMBOL TABLE
*  IU  IPOINT(MNP,6) - ARRAY OF POINTERS TO THE SYMBOL TABLE
*               1-LINK, 2-POSITION OF THE FIRST CHARACTER,
*               3-LENGTH OF NAME, 4-POSITION OF THE LAST CHARACTER,
*               5-POINTER OF LIST, 6-MODERW (1-RW, 2-RA, 3-RO)
*  II  MNP - MAX. NUMBER OF POINTERS
*  II  LENB - ACTUAL LENGTH OF THE BUFFER
*  II  ILNLEN - THE NUMBER OF CHARACTERS PER LINE OF INPUT
*  II  OLNLEN - THE NUMBER OF CHARACTERS PER LINE OF OUTPUT
*  II  INUNIT - THE INCLUDE UNIT NUMBER
*  II  OUNIT - THE OUTPUT UNIT NUMBER
*  LI  LOUT - PERFORM OUTPUT ?
*  LI  LFORTO - IS IT A FORTRAN ?
*  LI  LFRFMT - IS IT A FORTRAN IN FREE FORMAT ?
*  TI  CHCON - THE CONTINUATION MARKER
*  TI  CHEOL - THE END OF LINE MARKER
*  TI  FN1 - FILENAME PART 1 (E.G. LIBRARY)
*  TI  FN2 - FILENAME PART 2 (E.G. EXTENSION)
*  IO  IER - ERROR INDICATOR
*
* SUBPROGRAMS USED :
*  S   UQSADR - SYNTAX ANALYSIS OF DIRECTIVE LINE
*  S   UQGVAL - GIVE A VALUE OF A MACRO VARIABLE
*  S   UQWRLN - WRITE A LINE
*
      SUBROUTINE UQINCL(BUFFER,MLENB,IPOSD,IPOS2,SYMTAB,MLENST,
     *                  IPOINT,MNP,LENB,ILNLEN,OLNLEN,INUNIT,OUNIT,
     *                  LOUT,LFORTO,LFRFMT,CHCON,CHEOL,FN1,FN2,IER)
      INTEGER MLENB,IPOSD,IPOS2,MLENST,MNP,IPOINT(MNP,6),LENB,
     *        ILNLEN,OLNLEN,INUNIT,OUNIT,IER
      LOGICAL LOUT,LFORTO,LFRFMT
      CHARACTER*1 CHCON,CHEOL
      CHARACTER*50 FN1,FN2
      CHARACTER*1 BUFFER(MLENB),SYMTAB(MLENST)
      INTEGER MNPAR
      PARAMETER(MNPAR=1)
      INTEGER NPAR,IPOSP(MNPAR,2),ITYPE(MNPAR),I,L
      CHARACTER*100 FNAME
      LOGICAL TECKA
      CALL UQSADR(BUFFER,MLENB,IPOSD,IPOS2,IPOSP,MNPAR,NPAR,ITYPE,IER)
      IF(IER.NE.0) RETURN
      IF(NPAR.NE.1) GOTO 10
      IF(.NOT.LOUT) RETURN
C
C INCLUDE(MACRO)
C
      IF(ITYPE(1).EQ.5) THEN
        CALL UQGVAL(BUFFER,MLENB,IPOSP(1,1),IPOSP(1,2),SYMTAB,
     *              MLENST,IPOSP(1,1),IPOSP(1,2),IPOINT,MNP,IER)
        IF(IER.NE.0) RETURN
        I=IPOSP(1,1)
    1   IF(I.LE.IPOSP(1,2)) THEN
          IF(SYMTAB(I).EQ.CHEOL) THEN
            CALL UQWRLN(SYMTAB,MLENST,IPOSP(1,1),I-1,OLNLEN,OUNIT,
     *                  LFORTO,LFRFMT,CHCON,IER)
            IF(IER.NE.0) RETURN
            IPOSP(1,1)=I+1
          ELSEIF(I.EQ.IPOSP(1,2)) THEN
            CALL UQWRLN(SYMTAB,MLENST,IPOSP(1,1),I,OLNLEN,OUNIT,
     *                  LFORTO,LFRFMT,CHCON,IER)
            RETURN
          ENDIF
          I=I+1
          GOTO 1
        ENDIF
C
C INCLUDE('FILE')
C
      ELSEIF(ITYPE(1).EQ.6) THEN
        L=1
        DO 2 I=1,50
          IF (FN1(I:I).NE.' ') THEN
            FNAME(L:L)=FN1(I:I)
            L=L+1
          ENDIF
    2   CONTINUE
        TECKA = .FALSE.
        DO 3 I=1,IPOSP(1,2)-IPOSP(1,1)+1
          FNAME(L:L)=BUFFER(I+IPOSP(1,1)-1)
          IF(FNAME(L:L).EQ.'.') TECKA=.TRUE.
          IF(FNAME(L:L).NE.' ') L=L+1
    3   CONTINUE
        IF (.NOT.TECKA) THEN
          DO 4 I=1,50
            IF (FN2(I:I).NE.' ') THEN
              FNAME(L:L)=FN2(I:I)
              L=L+1
            ENDIF
    4     CONTINUE
        ENDIF
        OPEN(INUNIT,FILE=FNAME(1:L-1),STATUS='OLD',ACCESS='SEQUENTIAL',
     *       ERR=12)
        IF(LENB+ILNLEN.GT.MLENB) GOTO 11
    5   L=LENB+ILNLEN
        READ(INUNIT,'(255A1)',ERR=12,END=7) (BUFFER(I),I=LENB+1,L)
    6   IF(BUFFER(L).EQ.' '.AND.L.GT.LENB) THEN
          L=L-1
          GOTO 6
        ENDIF
        CALL UQWRLN(BUFFER,MLENB,LENB+1,L,OLNLEN,OUNIT,.FALSE.,
     *              LFRFMT,CHCON,IER)
        IF(IER.NE.0) RETURN
        GOTO 5
    7   CLOSE(INUNIT,ERR=12)
      ELSE
        GOTO 10
      ENDIF
      RETURN
C
C ERROR: SYNTAX ERROR
C
   10 IER=20
      RETURN
C
C ERROR: MAX. LENGTH OF BUFFER EXCEEDED
C
   11 IER=2
      RETURN
C
C ERROR: INCLUDED FILE DOES NOT EXIST OR I/O HARDWARE ERROR
C
   12 IER=28
      RETURN
      END


