* LOGICAL FUNCTION UQLEXP         ALL SYSTEMS                98/12/01
* PORTABILITY : ALL SYSTEMS
* 98/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*  EVALUATE LOGICAL EXPRESSION
*
* PARAMETERS :
*  TI  BUFFER(MLENB) - WORK BUFFER
*  II  MLENB - MAX. LENGTH OF THE BUFFER
*  II  IPOSD - POSITION OF THE FIRST CHARACTER OF DIRECTIVE
*               IN THE BUFFER
*  II  IPOS2 - POSITION OF THE LAST CHARACTER OF LINE
*               IN THE BUFFER
*  TI  SYMTAB(MLENST) - SYMBOL TABLE
*  II  MLENST - MAX. LENGTH OF THE SYMBOL TABLE
*  II  IPOINT(MNP,6) - ARRAY OF POINTERS TO THE SYMBOL TABLE
*               1-LINK, 2-POSITION OF THE FIRST CHARACTER,
*               3-LENGTH OF NAME, 4-POSITION OF THE LAST CHARACTER,
*               5-POINTER OF LIST, 6-MODERW (1-RW, 2-RA, 3-RO)
*  II  MNP - MAX. NUMBER OF POINTERS
*  IU  IDIRN - NUMBER OF DIRECTIVE
*  LI  CONDIF - CONDITION OF IF-ENDIF
*  IO  IER - ERROR INDICATOR
*
* COMMON DATA :
*  TI  WTRUE - WORD '.TRUE.'
*
* SUBPROGRAMS USED:
*  S   UQSADR - SYNTAX ANALYSIS OF DIRECTIVE LINE
*  S   UQGVAL - GIVE VALUE OF A MACRO
*  LF  UQCOND - COMPARISON OF TWO SUBSTRINGS
*  IF  UQINTI - CONVERT A STRING TO AN INTEGER NUMBER
*
      LOGICAL FUNCTION UQLEXP(BUFFER,MLENB,IPOSD,IPOS2,SYMTAB,MLENST,
     *                  IPOINT,MNP,IDIRN,IER)
      INTEGER MLENB,IPOSD,IPOS2,MLENST,MNP,IPOINT(MNP,6),IDIRN,IER
      CHARACTER*1 BUFFER(MLENB),SYMTAB(MLENST)
C ----------------------------------------------------------------------
      INTEGER        LENB,LENST,LP,ILNLEN,OLNLEN,MODERW,DIALOG,IUNIT,
     *        OUNIT,INUNIT,IIUNIT,OIUNIT,NOPT,LENOPT(30),NSUB,MNSUB,
     *        NDIR,LENDIR(30),NMSG,MNIF,NIF1,NIF2,TABCH(0:255),ADF,
     *        ADA,ADC,ARD,CRD
      COMMON/UQINT2/ LENB,LENST,LP,ILNLEN,OLNLEN,MODERW,DIALOG,IUNIT,
     *        OUNIT,INUNIT,IIUNIT,OIUNIT,NOPT,LENOPT,NSUB,MNSUB,
     *        NDIR,LENDIR,NMSG,MNIF,NIF1,NIF2,TABCH,ADF,ADA,ADC,ARD,CRD
      INTEGER*4      LABEL1,LABEL2,MAXLAB,LEVLAB(20)
      COMMON/UQINT4/ LABEL1,LABEL2,MAXLAB,LEVLAB
      CHARACTER*1    CHCON,CHEOL,CHDS,CHDIR,WTRUE(6),WFALSE(7),
     *        ASCII(32:127),OPTNM(200),DIRNM(200)
      COMMON/UQCHR1/ CHCON,CHEOL,CHDS,CHDIR,WTRUE,WFALSE,
     *        ASCII,OPTNM,DIRNM
      CHARACTER*50   FN1,FN2,FNAMES(20),NAME,MSG(50)*70
      COMMON/UQCHRX/ FN1,FN2,FNAMES,NAME,MSG
      LOGICAL        LFORTO,LSMLET,LFRFMT,LSUBS,LOUT,LHELP,LIFDON(20),
     *        LELSE(20),CONDIF,CONDDO,LOOP,SIFDEC,DIALGR,LPERFD
      COMMON/UQLOGL/ LFORTO,LSMLET,LFRFMT,LSUBS,LOUT,LHELP,LIFDON,
     *        LELSE,CONDIF,CONDDO,LOOP,SIFDEC,DIALGR,LPERFD
C ----------------------------------------------------------------------
      INTEGER MNPAR
      PARAMETER(MNPAR=3)
      INTEGER NPAR,IPOSP(MNPAR,2),ITYPE(MNPAR)
      INTEGER*4 UQINTI,I1,I2
      LOGICAL UQCOND,COND
      UQLEXP=.FALSE.
      CALL UQSADR(BUFFER,MLENB,IPOSD,IPOS2,IPOSP,MNPAR,NPAR,ITYPE,IER)
      IF(IER.NE.0) THEN
C
C 116 IS SIMPLE 'IF'
C
        IF(IER.EQ.25.AND.(IDIRN.EQ.16.OR.IDIRN.EQ.116)) THEN
          IDIRN=116
          IER=0
        ENDIF
      ELSEIF(IDIRN.EQ.16.AND..NOT.CONDIF) THEN
        RETURN
      ENDIF
      IF(IER.NE.0) RETURN
      IF(NPAR.NE.1.AND.NPAR.NE.3) GOTO 1
      IF(ITYPE(1).LT.5.OR.ITYPE(1).GT.9) GOTO 2
      IF(ITYPE(1).EQ.5) THEN
        CALL UQGVAL(BUFFER,MLENB,IPOSP(1,1),IPOSP(1,2),SYMTAB,
     *              MLENST,IPOSP(1,1),IPOSP(1,2),IPOINT,MNP,IER)
        IF(IER.NE.0) RETURN
      ENDIF
C
C ONE PARAMETER:  .TRUE. OR .FALSE.
C
      IF(NPAR.EQ.1) THEN
        IF(ITYPE(1).EQ.8) THEN
          COND=.TRUE.
        ELSEIF(ITYPE(1).EQ.5) THEN
          COND=UQCOND(SYMTAB,MLENST,IPOSP(1,1),IPOSP(1,2),
     *                WTRUE,6,1,6)
        ELSE
          COND=.FALSE.
        ENDIF
C
C THREE PARAMETERS:  PAR1 = / <> / > / < / >= / <= PAR2
C
      ELSE
        IF(ITYPE(3).LT.5.OR.ITYPE(3).GT.9) GOTO 2
        IF(ITYPE(3).EQ.5.) THEN
          CALL UQGVAL(BUFFER,MLENB,IPOSP(3,1),IPOSP(3,2),SYMTAB,
     *                MLENST,IPOSP(3,1),IPOSP(3,2),IPOINT,MNP,IER)
          IF(IER.NE.0) RETURN
        ENDIF
C
C PAR1  = / <>  PAR2
C
        IF(ITYPE(2).EQ.3.OR.ITYPE(2).EQ.10) THEN
          IF(ITYPE(1).NE.5.AND.ITYPE(3).NE.5) THEN
            COND=UQCOND(BUFFER,MLENB,IPOSP(1,1),IPOSP(1,2),
     *                  BUFFER,MLENB,IPOSP(3,1),IPOSP(3,2))
          ELSEIF(ITYPE(1).EQ.5.AND.ITYPE(3).EQ.5) THEN
            COND=UQCOND(SYMTAB,MLENST,IPOSP(1,1),IPOSP(1,2),
     *                  SYMTAB,MLENST,IPOSP(3,1),IPOSP(3,2))
          ELSEIF(ITYPE(1).EQ.5) THEN
            COND=UQCOND(SYMTAB,MLENST,IPOSP(1,1),IPOSP(1,2),
     *                  BUFFER,MLENB,IPOSP(3,1),IPOSP(3,2))
          ELSE
            COND=UQCOND(BUFFER,MLENB,IPOSP(1,1),IPOSP(1,2),
     *                  SYMTAB,MLENST,IPOSP(3,1),IPOSP(3,2))
          ENDIF
          IF(ITYPE(2).EQ.10) COND=.NOT.COND
C
C PAR1  > / < / >= / <=  PAR2
C
        ELSEIF(ITYPE(2).GE.11.AND.ITYPE(2).LE.14) THEN
          IF(ITYPE(1).EQ.7) THEN
            I1=UQINTI(BUFFER,MLENB,IPOSP(1,1),IPOSP(1,2),IER)
          ELSEIF(ITYPE(1).EQ.5) THEN
            I1=UQINTI(SYMTAB,MLENST,IPOSP(1,1),IPOSP(1,2),IER)
          ELSE
            GOTO 1
          ENDIF
          IF(IER.NE.0) RETURN
          IF(ITYPE(3).EQ.7) THEN
            I2=UQINTI(BUFFER,MLENB,IPOSP(3,1),IPOSP(3,2),IER)
          ELSEIF(ITYPE(3).EQ.5) THEN
            I2=UQINTI(SYMTAB,MLENST,IPOSP(3,1),IPOSP(3,2),IER)
          ELSE
            GOTO 1
          ENDIF
          IF(IER.NE.0) RETURN
          IF(ITYPE(2).EQ.11) THEN
            COND=I1.GE.I2
          ELSEIF(ITYPE(2).EQ.12) THEN
            COND=I1.LE.I2
          ELSEIF(ITYPE(2).EQ.13) THEN
            COND=I1.GT.I2
          ELSE
            COND=I1.LT.I2
          ENDIF
        ELSE
          GOTO 1
        ENDIF
      ENDIF
      UQLEXP=COND
      RETURN
C
C ERROR: SYNTAX ERROR
C
    1 IER=20
      RETURN
C
C ERROR: IDENTIFIER, STRING, INTEGER OR LOGICAL CONSTANT EXPECTED
C
    2 IER=30
      RETURN
      END
