* SUBROUTINE UQNEXT                ALL SYSTEMS                98/12/01
* PORTABILITY : ALL SYSTEMS
* 98/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*   GIVE A NEXT WORD FROM THE BUFFER (LEX. PARSER)
*
* PARAMETERS :
*  TI  BUFFER(MLENB) - WORK BUFFER
*  II  MLENB - MAX. LENGTH OF THE BUFFER
*  II  IPOS - POSITION IN THE BUFFER
*  IO  IPOS1 - POSITION OF THE FIRST CHARACTER OF A WORD IN THE BUFFER
*  IO  IPOS2 - POSITION OF THE LAST CHARACTER OF A WORD IN THE BUFFER
*  IU  IPOSB2 - POSITION OF THE LAST CHARACTER OF A LINE IN THE BUFFER
*  IO  ITYP - TYPE OF WORD:
*             ITYP=1 - (
*             ITYP=2 - )
*             ITYP=3 - =
*             ITYP=4 - ,
*             ITYP=5 - IDENTIFIER
*             ITYP=6 - STRING
*             ITYP=7 - INTEGER CONSTANT
*             ITYP=8 - .TRUE.
*             ITYP=9 - .FALSE.
*             ITYP=10 - <> OR ><
*             ITYP=11 - >= OR =>
*             ITYP=12 - <= OR =<
*             ITYP=13 - >
*             ITYP=14 - <
*  IO  IER - ERROR INDICATOR
*
* COMMON DATA :
*  II  LENB - ACTUAL LENGTH OF THE BUFFER
*  TI  WTRUE - STRING '.TRUE.'
*  TI  WFALSE - STRING '.FALSE.'
*
* SUBPROGRAMS USED :
*  S   UQNXTC - GIVE A NEXT CHARACTER FROM THE BUFFER
*  LF  UQSTRC - COMPARISON OF TWO SUBSTRINGS
*  LF  UQCHAZ - IS CHARACTER A LETTER ?
*  LF  UQCHFG - IS CHARACTER A FIGURE ?
*  S   UQDELS - DELETE A SUBSTRING FROM A STRING ARRAY
*
* REMARK :
*  PARAMETER 'LENINT' IS MAX. LENGTH OF INTEGER NUMBER
*
      SUBROUTINE UQNEXT(BUFFER,MLENB,IPOS,IPOS1,IPOS2,IPOSB2,ITYP,IER)
      INTEGER MLENB,IPOS,IPOS1,IPOS2,IPOSB2,ITYP,IER
      CHARACTER*1 BUFFER(MLENB)
C ----------------------------------------------------------------------
      INTEGER        LENB,LENST,LP,ILNLEN,OLNLEN,MODERW,DIALOG,IUNIT,
     *        OUNIT,INUNIT,IIUNIT,OIUNIT,NOPT,LENOPT(30),NSUB,MNSUB,
     *        NDIR,LENDIR(30),NMSG,MNIF,NIF1,NIF2,TABCH(0:255),ADF,
     *        ADA,ADC,ARD,CRD
      COMMON/UQINT2/ LENB,LENST,LP,ILNLEN,OLNLEN,MODERW,DIALOG,IUNIT,
     *        OUNIT,INUNIT,IIUNIT,OIUNIT,NOPT,LENOPT,NSUB,MNSUB,
     *        NDIR,LENDIR,NMSG,MNIF,NIF1,NIF2,TABCH,ADF,ADA,ADC,ARD,CRD
      INTEGER*4      LABEL1,LABEL2,MAXLAB,LEVLAB(20)
      COMMON/UQINT4/ LABEL1,LABEL2,MAXLAB,LEVLAB
      CHARACTER*1    CHCON,CHEOL,CHDS,CHDIR,WTRUE(6),WFALSE(7),
     *        ASCII(32:127),OPTNM(200),DIRNM(200)
      COMMON/UQCHR1/ CHCON,CHEOL,CHDS,CHDIR,WTRUE,WFALSE,
     *        ASCII,OPTNM,DIRNM
      CHARACTER*50   FN1,FN2,FNAMES(20),NAME,MSG(50)*70
      COMMON/UQCHRX/ FN1,FN2,FNAMES,NAME,MSG
      LOGICAL        LFORTO,LSMLET,LFRFMT,LSUBS,LOUT,LHELP,LIFDON(20),
     *        LELSE(20),CONDIF,CONDDO,LOOP,SIFDEC,DIALGR,LPERFD
      COMMON/UQLOGL/ LFORTO,LSMLET,LFRFMT,LSUBS,LOUT,LHELP,LIFDON,
     *        LELSE,CONDIF,CONDDO,LOOP,SIFDEC,DIALGR,LPERFD
C ----------------------------------------------------------------------
      INTEGER J,K,LENINT
      LOGICAL UQSTRC,UQCHAZ,UQCHFG
      CHARACTER*1 CH
      PARAMETER(LENINT=20)
      ITYP=0
C
C     GIVE A NEXT CHARACTER
C
      CALL UQNXTC(BUFFER,MLENB,LENB,IPOS,IPOS1)
      CH=BUFFER(IPOS1)
      IPOS2=IPOS1
      IF(CH.EQ.'(') THEN
        ITYP=1
      ELSEIF(CH.EQ.')') THEN
        ITYP=2
      ELSEIF(CH.EQ.'=') THEN
        ITYP=3
        IF(BUFFER(IPOS1+1).EQ.'<') THEN
          ITYP=12
          IPOS2=IPOS1+1
        ELSEIF(BUFFER(IPOS1+1).EQ.'>') THEN
          ITYP=11
          IPOS2=IPOS1+1
        ENDIF
      ELSEIF(CH.EQ.',') THEN
        ITYP=4
C
C     IDENTIFIER
C
      ELSEIF(UQCHAZ(BUFFER(IPOS1))) THEN
        ITYP=5
        K=IPOS1+1
    1   IF(UQCHAZ(BUFFER(K)).OR.UQCHFG(BUFFER(K))) THEN
          K=K+1
          GOTO 1
        ENDIF
        IPOS2=K-1
C
C     STRING
C
      ELSEIF(CH.EQ.'''') THEN
        ITYP=6
        IPOS1=IPOS1+1
        J=IPOS1
    2   IF(BUFFER(J).NE.'''') THEN
          J=J+1
          IF(J.GE.LENB) GOTO 4
          GOTO 2
        ENDIF
        CALL UQNXTC(BUFFER,MLENB,LENB,J+1,K)
        IF(BUFFER(K).EQ.'''') THEN
          J=K
          CALL UQDELS(BUFFER,MLENB,LENB,K,K)
          IPOSB2=IPOSB2-1
          GOTO 2
        ENDIF
        IPOS2=J-1
C
C     INTEGER CONSTANT
C
      ELSEIF(UQCHFG(CH).OR.CH.EQ.'-'.OR.CH.EQ.'+') THEN
        ITYP=7
        K=IPOS1+1
    3   IF(UQCHFG(BUFFER(K))) THEN
          K=K+1
          GOTO 3
        ENDIF
        IPOS2=K-1
        IF(IPOS2.EQ.IPOS1) THEN
          IF(CH.EQ.'-'.OR.CH.EQ.'+') GOTO 5
        ENDIF
        IF(IPOS2-IPOS1.GT.LENINT) GOTO 5
      ELSEIF(CH.EQ.'.') THEN
        IF(IPOS1+6.GT.LENB) GOTO 5
C
C     .TRUE.
C
        IF(UQSTRC(BUFFER,MLENB,IPOS1,IPOS1+5,WTRUE,6,1,6)) THEN
          ITYP=8
          IPOS2=IPOS1+5
C
C     .FALSE.
C
        ELSEIF(UQSTRC(BUFFER,MLENB,IPOS1,IPOS1+6,WFALSE,7,1,7)) THEN
          ITYP=9
          IPOS2=IPOS1+6
        ELSE
          GOTO 5
        ENDIF
      ELSEIF(CH.EQ.'<') THEN
        ITYP=14
        IF(BUFFER(IPOS1+1).EQ.'>') THEN
          ITYP=10
          IPOS2=IPOS1+1
        ELSEIF(BUFFER(IPOS1+1).EQ.'=') THEN
          ITYP=12
          IPOS2=IPOS1+1
        ENDIF
      ELSEIF(CH.EQ.'>') THEN
        ITYP=13
        IF(BUFFER(IPOS1+1).EQ.'<') THEN
          ITYP=10
          IPOS2=IPOS1+1
        ELSEIF(BUFFER(IPOS1+1).EQ.'=') THEN
          ITYP=11
          IPOS2=IPOS1+1
        ENDIF
      ENDIF
      RETURN
C
C ERROR: APOSTROPH EXPECTED
C
    4 IER=24
      RETURN
C
C ERROR: SYNTAX ERROR
C
    5 IER=20
      RETURN
      END
