* SUBROUTINE UQWRLN                ALL SYSTEMS                89/12/01
* PORTABILITY : ALL SYSTEMS
* 89/12/01 SI : ORIGINAL VERSION
*
* PURPOSE :
*   WRITE A LINE TO OUTPUT FILE
*
* PARAMETERS :
*  TU  BUFFER(MLENB) - WORK BUFFER
*  II  MLENB - MAX. LENGTH OF THE BUFFER
*  II  IPOS1 - POSITION OF THE FIRST CHARACTER OF A LINE IN THE BUFFER
*  II  IPOS2 - POSITION OF THE LAST CHARACTER OF A LINE IN THE BUFFER
*  II  OLNLEN - THE NUMBER OF CHARACTERS PER LINE OF OUTPUT
*  II  OUNIT - THE OUTPUT UNIT NUMBER
*  LI  LFORTO - IS IT A FORTRAN ?
*  LI  LFRFMT - IS IT A FORTRAN IN FREE FORMAT ?
*  TI  CHCON - THE CONTINUATION MARKER
*  IO  IER - ERROR INDICATOR
*
* SUBPROGRAMS USED :
*  S   UQNXTC - GIVE A NEXT CHARACTER FROM THE BUFFER
*  S   UQNEXT - GIVE A NEXT WORD FROM THE BUFFER
*  IF  UQINTI - CONVERT A SUBSTRING TO AN INTEGER NUMBER
*  TF  UQUCHR - CONVERTS A CHARACTER TO UPPERCASE
*
      SUBROUTINE UQWRLN(BUFFER,MLENB,IPOS1,IPOS2,OLNLEN,OUNIT,
     *                  LFORTO,LFRFMT,CHCON,IER)
      INTEGER IPOS1,IPOS2,MLENB,OLNLEN,OUNIT,IER
      CHARACTER*1 BUFFER(MLENB),CHCON
      LOGICAL LFORTO,LFRFMT
      INTEGER I,J,K,L,ITYP,LNLEN
      INTEGER*4 UQINTI,LAB
      LOGICAL LINTLN,LCOMLN,LLABEL,EOL
      CHARACTER*1 CHCOM,UQUCHR
      PARAMETER(CHCOM='*')
      EOL=.FALSE.
      IF(IPOS1.LE.IPOS2) THEN
        CALL UQNXTC(BUFFER,MLENB,IPOS2+1,IPOS1,I)
      ELSE
        I=IPOS2+1
      ENDIF
      IF(I.GT.IPOS2) THEN
C
C EMPTY LINE
C
C        IF(.NOT.LFORTO) WRITE(OUNIT,4,ERR=8)
      ELSEIF(ICHAR(BUFFER(I)).LT.32.OR.
     &  ICHAR(BUFFER(I)).GT.127) THEN
C
C CORRECTION FROM JYVASKYLA
C
C        IF(.NOT.LFORTO) WRITE(OUNIT,4,ERR=8)
      ELSEIF(LFORTO) THEN
        LINTLN=.TRUE.
        LCOMLN=.FALSE.
        LLABEL=.FALSE.
        IF(LFRFMT.AND.BUFFER(I).EQ.CHCOM) THEN
          LCOMLN=.TRUE.
        ELSEIF(.NOT.LFRFMT.AND.I.EQ.IPOS1) THEN
          IF(BUFFER(I).EQ.CHCOM.OR.UQUCHR(BUFFER(I)).EQ.'C')
     *       LCOMLN=.TRUE.
        ENDIF
        IF(.NOT.LCOMLN.AND.LFRFMT) THEN
          IF(BUFFER(I).EQ.CHCON) THEN
            LINTLN=.FALSE.
            CALL UQNXTC(BUFFER,MLENB,IPOS2+1,I+1,I)
            IF(I.GT.IPOS2) GOTO 9
          ELSE
            CALL UQNEXT(BUFFER,MLENB,I,J,K,L,ITYP,IER)
            IF(IER.NE.0) GOTO 9
            IF(ITYP.EQ.5) THEN
            ELSEIF(ITYP.EQ.7) THEN
              LAB=UQINTI(BUFFER,MLENB,J,K,IER)
              IF(IER.NE.0) GOTO 9
              IF(LAB.GT.99999.OR.LAB.LT.1) GOTO 9
              LLABEL=.TRUE.
              CALL UQNXTC(BUFFER,MLENB,IPOS2+1,K+1,I)
              IF(I.GT.IPOS2) GOTO 9
            ELSE
              GOTO 9
            ENDIF
          ENDIF
        ENDIF
        IF(LCOMLN) THEN
C
C COMMENT LINE
C
          J=MIN(I+79,IPOS2)
          WRITE(OUNIT,3,ERR=8) (BUFFER(K),K=I,J)
        ELSE
          LNLEN=72
          IF(LFRFMT) LNLEN=66
    1     IF(.NOT.LINTLN) LNLEN=62
          IF (.NOT.LFRFMT.AND.LINTLN) I=IPOS1
          IF(IPOS2-I+1.GT.LNLEN) THEN
            J=I+LNLEN-1
          ELSE
            J=IPOS2
            EOL=.TRUE.
          ENDIF
          IF(LINTLN) THEN
            LINTLN=.FALSE.
C
C FORTRAN OUTPUT
C
            IF(LFRFMT) THEN
              IF(LLABEL) THEN
                WRITE(OUNIT,6,ERR=8) LAB,(BUFFER(K),K=I,J)
              ELSE
                WRITE(OUNIT,7,ERR=8) (BUFFER(K),K=I,J)
              ENDIF
            ELSE
              WRITE(OUNIT,3,ERR=8) (BUFFER(K),K=IPOS1,J)
            ENDIF
          ELSE
            WRITE(OUNIT,5,ERR=8) CHCON,(BUFFER(K),K=I,J)
          ENDIF
          I=J+1
          IF(.NOT.EOL) GOTO 1
        ENDIF
      ELSE
        I=IPOS1
    2   IF(IPOS2-I+1.GT.OLNLEN) THEN
          J=I+OLNLEN-1
        ELSE
          J=IPOS2
          EOL=.TRUE.
        ENDIF
C
C NORMAL OUTPUT
C
        WRITE(OUNIT,3,ERR=8) (BUFFER(K),K=I,J)
        I=J+1
        IF(.NOT.EOL) GOTO 2
      ENDIF
      RETURN
    3 FORMAT(255A1)
    4 FORMAT(' ')
    5 FORMAT(5X,A1,4X,80A1)
    6 FORMAT(I5,' ',80A1)
    7 FORMAT(6X,80A1)
C
C ERROR: OUTPUT HARDWARE ERROR
C
    8 IER=10
      RETURN
C
C ERROR: WRONG FORMAT OF FORTRAN LINE
C
    9 IER=11
      RETURN
      END
