$INTERFACE UUDBG1                                             16/12/01
$REM LU

  $CON0='0.1$P 0'
  $CON1='1.0$P-4'
  $CON2='4.0$P 0'
  $CON3='0.2$P 0'
  $CON4='1.0$P-2'
  $CON5='3.0$P-8'
  $CON6='1.0$P-4'
  $IF(DEC='M')
    $HELP
      METHOD OF UPDATE OF HESSIAN MATRIX:
        1 - BFGS UPDATE
        2 - DFP UPDATE
        3 - HOSHINO UPDATE
        4 - RANK-ONE UPDATE
    $CHECK(MET,1,'1\2\3\4',3)
  $ELSE
    $HELP
      METHOD OF UPDATE OF HESSIAN MATRIX:
        1 - BFGS UPDATE
        2 - DFP UPDATE
        3 - HOSHINO UPDATE
        4 - SAFEGUARDED RANK ONE UPDATE
        5 - OPTIMALLY CONDITIONED UPDATE
        6 - SIMPLE PRECONVEX UPDATE
        7 - VARIATIONALLY DERIVED PRECONVEX UPDATE
        8 - NEW COMBINED UPDATE
        9 - PRECONVEX UPDATE DERIVED FROM MATRIX FACTORIZATION
       10 - ANGLE MINIMIZING UPDATE
       11 - NORM MINIMIZING UPDATE
       12 - LPD UPDATE
    $CHECK(MET,1,'1\2\3\4\5\6\7\8\9\10\11\12',3)
  $ENDIF
  $HELP
    SELECTION OF SELF SCALING:
      1 - SELF SCALING SUPPRESSED
      2 - INITIAL SELF SCALING
      3 - CONTROLLED SELF SCALING
      4 - SIMPLIFIED CONTROLLED SELF SCALING
      5 - SELF SCALING IN EACH ITERATION
  $CHECK(MET1,3,'1\2\3\4\5',4)
  $HELP
    SELECTION OF THE LINE SEARCH MODEL:
      1 - QUADRATIC MODEL
      2 - BACKWARD TAYLOR EXPANSION (3 TERMS)
      3 - BACKWARD TAYLOR EXPANSION (4 TERMS)
      4 - HOMOGENEOUS MODEL
  $CHECK(MET2,4,'1\2\3\4',4)
  $HELP
    METHOD CORRECTION:
      1 - NO CORRECTION - STRONG UPDATE ELIMINATION
      2 - NO CORRECTION - WEAK UPDATE ELIMINATION
      3 - POWELL'S CORRECTION
  $CHECK(MET3,1,'1\2\3',4)
$REM  $ERASE(MET4)
  $IF(MET= 1) $DEFAULT=3
  $IF(MET= 2) $DEFAULT=2
  $IF(MET= 3) $DEFAULT=3
  $IF(MET= 4) $DEFAULT=3
  $IF(MET= 5) $DEFAULT=3
  $IF(MET= 6) $DEFAULT=3
  $IF(MET= 7) $DEFAULT=3
  $IF(MET= 8) $DEFAULT=3
  $IF(MET= 9) $DEFAULT=3
  $IF(MET=10) $DEFAULT=3
  $IF(MET=11) $DEFAULT=3
  $IF(MET=12) $DEFAULT=3
  $IF(MET=13) $DEFAULT=3
  $HELP
    METHOD CORRECTION:
      1 - BFGS SCALING
      2 - DFP SCALING
      3 - GEOMETRIC MEAN
      4 - HARMONIC MEAN
      5 - ARITHMETIC MEAN
  $CHECK(MET4,DEFAULT,'1\2\3\4\5',4)
$REM  $HELP
$REM    TOLERANCE FOR POSITIVE DEFINITENESS
$REM  $CHECK(ETA2,ETA0,REAL,4)
  $N='N'
  $IF(CLASS='VR') $N='NN'
  $ADD(REAL,'\$H($NF*($NF+1)/2)\$GN($NF)\$SN($NF)\$XO($NF)\$GO($NF)')
  $ADD(REAL,'\GAM')
$REM  $ADD(REAL,'\PAR1\PAR2')
  $IF(DEC='M')
    $POM1='UXDSMU(N,H'
    $POM2=')'
    $POM3='$$N,$$H'
    $POM5='N,H'
  $ELSEIF(DEC='G')
    $POM1='UXDPGU(N,H'
    $POM2=',XO)'
    $POM3='$$N,$$H'
    $POM5='N,H'
  $ELSEIF(DEC='R')
    $POM1='UXDPRU(N,H'
    $POM2=',XO)'
    $POM3='$$N,$$H'
    $POM5='N,H'
  $ELSEIF(DEC='S')
    $POM1='UXD$(LET)GU(N,H,IH'
    $POM2=',XO)'
    $POM3='$$N,$$H,$$IH'
    $POM5='N,H,IH'
    $ADD(INTEGER,'\$IH($NF)')
  $ELSEIF(DEC='B')
      $HELP
         TYPE OF DECOMPOSITION
           1 - BUNCH-PARLETT DECOMPOSITION WITH NUMERICAL PERMUTATIONS
           2 - BUNCH-KAUFMAN DECOMPOSITION WITH NUMERICAL PERMUTATIONS
           3 - BUNCH PARLETT DECOMPOSITION WITH TWO LEVEL INDICES
      $CHECK(MOS2,1,'1\2\3',2)
    $IF(MOS2<3)
      $IQ='IQ'
      $POM1='UXDLBU(N,H,IH'
      $POM2=',XO,IQ)'
      $POM3='$$N,$$H,$$IH,$$IQ'
      $POM5='N,H,IH,IQ'
      $ADD(INTEGER,'\$IH($NF)\$IQ($NF)')
    $ELSE
      $POM1='UXDSBU(N,H,IH'
      $POM2=',XO)'
      $POM3='$$N,$$H,$$IH'
      $POM5='N,H,IH'
      $ADD(INTEGER,'\$IH($NF)')
    $ENDIF
  $ENDIF
  $POM4='R,PO,'
  $POM6='R,PO,'
  $IF(MET2<>1)
    $ADD(POM4,'F,FO,P,')
    $ADD(POM6,'F,FO,P,')
  $ENDIF
  $IF (MET=12)
    $ADD(POM4,'$XS,$GS,')
    $ADD(POM6,'XS,GS,')
    $ADD(REAL,'\$XS($NF)\$GS($NF)')
  $ENDIF
  $IF (MET1=3)
    $ADD(POM4,'PAR1,PAR2,')
    $ADD(POM6,'PAR1,PAR2,')
  $ENDIF
  $IF (DEC<>'M')
    $ADD(POM4,'ETA2,')
    $ADD(POM6,'ETA2,')
  $ENDIF
  $ADD(POM4,'$ETA9,GAM,MET')
  $ADD(POM6,'ETA9,GAM,MET')
  $IF(DEC='B')
    $IF(MOS2<3)
      $ADD(POM4,',MOS2')
      $ADD(POM6,',MOS2')
    $ENDIF
  $ENDIF
  $NUMSUB=''
  $IF(NMET>1) $NUMSUB='_$NMET'
  CALL UUDB$(DEC)1$(NUMSUB)($POM3,$GN,$S,$XO,$GO,$POM4)
  $ADD(SUBROUTINES)
*     ----------------------------------------
*     BROYDEN CLASS OF VARIABLE METRIC UPDATES
*     TEMPLATE : UUDBG1
*     ----------------------------------------
  SUBROUTINE UUDB$(DEC)1$(NUMSUB)($POM5,G,S,XO,GO,$POM6)
  $$INCLUDE('UMCOMM')
  INTEGER N,MET
  $$IF(DEC='B')
    $$IF(MOS2<3)
      INTEGER IQ(N),MOS2
    $$ENDIF
  $$ENDIF
  $$IF(DEC='S') INTEGER IH(N)
  $$IF(DEC='B') INTEGER IH(N)
  $$FLOAT H(N*(N+1)/2),G(N),S(N),XO(N),GO(N),R,PO,ETA9
  $$IF (DEC<>'M') $$FLOAT ETA2
  $$IF ($MET=12) $$FLOAT XS(N),GS(N)
  $$IF ($MET1=3) $$FLOAT PAR1,PAR2
  $$IF ($MET2<>1) $$FLOAT F,FO,P
  $$FLOAT AA,CC
  COMMON /UMFUN1/ AA,CC
  $$FLOAT UXVDOT,UNFUN1
  $$IF (DEC='G') $$FLOAT UXDPGP
  $$IF (DEC='S') $$FLOAT UXDPGP
  $$IF (DEC='B')
    $$IF(MOS2<3)
      $$FLOAT UXDLBP
    $$ELSE
      $$FLOAT UXDSBP
    $$ENDIF
  $$ENDIF
  $$FLOAT POM,POM3,POM4,A,B,C,GAM,RHO,PAR
  $$IF (DEC<>'M') $$FLOAT DEN
  $$IF (DEC='G') $$FLOAT DIS
  $$IF (DEC='R') $$FLOAT DIS
  $$IF (DEC='S') $$FLOAT DIS
  LOGICAL L1,L3
  $$IF($MET1=3) LOGICAL L2
  $$IF($MET>8)
    $$FLOAT POM1,POM2
  $$ELSEIF($MET2>2)
    $$FLOAT POM1,POM2
  $$ENDIF
  $$IF(DEC<>'M')
    INTEGER INF
  $$ENDIF
  EXTERNAL UNFUN1
  IF (MET.LE.0) GO TO 22
  CALL UOU1D1(N,XO,GO)
  $$IF(DEC='M')
    $$I=0
    IF (IDECF.NE.0) THEN
  $$ELSEIF(DEC='G')
    $$I=1
    IF (IDECF.EQ.0) THEN
    DEN=ETA2
    CALL UXDPGF(N,H,INF,DEN,DIS)
    NDECF=NDECF+1
    IDECF=$$I
    ELSE IF (IDECF.NE.$$I) THEN
  $$ELSEIF(DEC='R')
    $$I=2
$REM    IF (IDECF.EQ.0) THEN
$REM    DEN=ETA2
$REM    CALL UXDPGF(N,H,INF,DEN,DIS)
$REM    CALL UXDPGT(N,H)
$REM    NDECF=NDECF+1
$REM    IDECF=$$I
$REM    ELSE IF (IDECF.NE.$$I) THEN
    IF (IDECF.NE.$$I) THEN
  $$ELSEIF(DEC='S')
    $$I=4
    IF (IDECF.EQ.0) THEN
    DEN=ETA2
    CALL UXD$$(LET)GF(N,H,IH,S,INF,DEN,DIS$$ART
    NDECF=NDECF+1
    IDECF=$$I
    ELSE IF (IDECF.NE.$$I) THEN
  $$ELSEIF(DEC='B')
    $$I=3
    IF (IDECF.EQ.0) THEN
    DEN=ETA2
    $$IF(MOS2<3)
      CALL UXDLBF(N,H,IH,INF,DEN,MOS2)
    $$ELSE
      CALL UXDSBF(N,H,IH,INF,DEN)
    $$ENDIF
    NDECF=NDECF+1
    IDECF=$$I
    ELSE IF (IDECF.NE.$$I) THEN
  $$ENDIF
  ITERH=-1
  TUXX='BAD DEC$$I'
  CALL UOERR1('UUDB$(DEC)1',1)
  GO TO 22
  ENDIF
  L1=$MET1.GE.3.OR.$MET1.EQ.2.AND.NIT.EQ.KIT
  L3=.NOT.L1
*
*     DETERMINATION OF THE PARAMETERS A, B, C
*
  B=UXVDOT(N,XO,GO)
  $$IF($MET3<2)
    IF (B.LE.ZERO) THEN
    ITERH=2
    TUXX='B - NEG.'
    GO TO 22
    ENDIF
  $$ENDIF
  A=ZERO
  $$IF(DEC='M')
  $$ELSE
    IF (MET.GE.4.OR.L1) THEN
    CALL UXVCOP(N,GO,S)
    $$IF(DEC='G')
      CALL UXDPGB(N,H,S,1)
      A=UXDPGP(N,H,S,S)
    $$ELSEIF(DEC='R')
      CALL UXDPRB(N,H,S,1)
      A=UXVDOT(N,S,S)
    $$ELSEIF(DEC='S')
      CALL UXD$$(LET)GB(N,H,IH,S,1)
      A=UXDPGP(N,H,S,S)
    $$ELSEIF(DEC='B')
      $$IF(MOS2<3)
        CALL UXDLBB(N,H,IH,S,1)
        A=UXDLBP(N,H,IH,S)
      $$ELSE
        CALL UXDSBB(N,H,IH,S,1)
        A=UXDSBP(N,H,IH,S,S)
      $$ENDIF  
    $$ENDIF
    IF (A.LE.ZERO) THEN
    ITERH=1
    TUXX='A - NEG.'
    GO TO 22
    ENDIF
    ENDIF
  $$ENDIF
  IF (ITERD.NE.1) THEN
  $$IF(DEC='M')
    CALL UXDSMM(N,H,XO,S)
  $$ELSEIF(DEC='G')
    CALL UXVCOP(N,XO,S)
    CALL UXDPGM(N,H,S,0)
  $$ELSEIF(DEC='R')
    CALL UXVCOP(N,XO,S)
    CALL UXDPRM(N,H,S,0)
  $$ELSEIF(DEC='S')
    CALL UXVCOP(N,XO,S)
    CALL UXD$$(LET)GM(N,H,IH,S,0)
  $$ELSEIF(DEC='B')
    CALL UXVCOP(N,XO,S)
    $$IF(MOS2<3)
      CALL UXDLBM(N,H,IH,S,0)
    $$ELSE
      CALL UXDSBM(N,H,IH,S,0)
    $$ENDIF  
  $$ENDIF
  C=UXVDOT(N,XO,S)
  ELSE
  IF (ITRAN.EQ.0) THEN
  CALL UXVDIF(N,GO,G,S)
  ELSE
  CALL UXVNEG(N,G,S)
  ENDIF
  CALL UXVSCL(N,R,S,S)
  C=-R*PO
  ENDIF
  IF (C.LE.ZERO) THEN
  ITERH=3
  TUXX='C - NEG.'
  GO TO 22
  ENDIF
  $$IF($MET3=3)
    IF (B.LE.$CON1*C) THEN
*
*     POWELL'S CORRECTION
*
    DIS=(ONE-$CON0)*C/(C-B)
    CALL UXVDIF(N,GO,S,GO)
    CALL UXVDIR(N,DIS,GO,S,GO)
    B=C+DIS*(B-C)
    IF (MET.GE.4.OR.L1) A=C+TWO*(ONE-DIS)*(B-C)+DIS*DIS*(A-C)
    ENDIF
  $$ELSEIF($MET3=2)
    IF (B.LE.$CON1*C) THEN
    ITERH=2
    TUXX='B - ZER.'
    GO TO 22
    ENDIF
  $$ENDIF
*
*     DETERMINATION OF THE PARAMETER RHO (NONQUADRATIC PROPERTIES)
*
  $$IF($MET2=1)
    RHO=ONE
  $$ELSEIF($MET2=2)
    IF (FO-F+P.EQ.0) THEN
    RHO=ONE
    ELSE
    RHO=HALF*B/(FO-F+P)
    ENDIF
  $$ELSE
    IF (PO.EQ.ZERO) THEN
    RHO=ONE
    ELSE
    POM1=(F-FO)/PO
    POM2=P/PO
    $$IF($MET2=3)
      IF (TWO*(POM2-ONE)-THREE*(POM1-ONE).EQ.ZERO) THEN
      RHO=ONE
      ELSE
      RHO=HALF*(POM2-ONE)/(TWO*(POM2-ONE)-THREE*(POM1-ONE))
      ENDIF
    $$ELSEIF($MET2=4)
      IF (POM1.EQ.ONE.OR.POM2.EQ.POM1) THEN
      RHO=ONE
      ELSE
      RHO=(POM1-ONE)/(POM2-POM1)
      ENDIF
    $$ENDIF
    ENDIF
  $$ENDIF
  IF(RHO.LE.$CON4) RHO=ONE
  IF(RHO*$CON4.GE.ONE) RHO=ONE
  AA=A/B
  CC=C/B
  IF (L1) THEN
*
*     DETERMINATION OF THE PARAMETER GAM (SELF SCALING)
*
  IF (A.LE.ZERO) THEN
  PAR=C/B
  POM3=0.6$P 0
  POM4=4.0$P 0
  ELSE
  $$IF(CLASS='VR')
    PAR=SQRT(C/A)
    POM3=0.5$P 0
    POM4=3.0$P 0
  $$ELSEIF(DEC='M')
    PAR=C/B
    POM3=0.6$P 0
    POM4=4.0$P 0
  $$ELSEIF(MET4=1)
    PAR=B/A
    POM3=0.8$P 0
    POM4=8.0$P 0
  $$ELSEIF(MET4=2)
    PAR=C/B
    POM3=0.6$P 0
    POM4=4.0$P 0
  $$ELSEIF(MET4=3)
    PAR=SQRT(C/A)
    POM3=0.7$P 0
    POM4=6.0$P 0
  $$ELSEIF(MET4=4)
    PAR=TWO*(C/A)/(B/A+C/B)
    POM3=0.7$P 0
    POM4=6.0$P 0
  $$ELSEIF(MET4=5)
    PAR=HALF*(B/A+C/B)
    POM3=0.7$P 0
    POM4=6.0$P 0
  $$ENDIF
  ENDIF
  GAM=PAR*RHO
  $$IF($MET1=3)
    IF (NIT.NE.KIT) THEN
    L2=PAR2.LE.ZERO
    L3=L2.AND.ABS(PAR1).LE.$CON3
    L3=L3.OR.(.NOT.L2.AND.GAM.GT.ONE)
    L3=L3.OR.(L2.AND.PAR1.LT.ZERO.AND.GAM.GT.ONE)
    L3=L3.OR.(L2.AND.PAR1.GT.ZERO.AND.GAM.LT.ONE)
    L3=L3.OR.GAM.LT.POM3
    L3=L3.OR.GAM.GT.POM4
    ENDIF
  $$ELSEIF($MET1=4)
    IF (NIT.NE.KIT) THEN
    L3=GAM.LT.POM3.OR.GAM.GT.POM4
    ENDIF
  $$ENDIF
  ENDIF
  IF (L3) THEN
  GAM=ONE
  PAR=GAM/RHO
  ENDIF
  $$U17=0
  $$U18=0
  $$U19=0
  $$U20=0
  $$IF($MET=1)
    $$U17=1
    NUPD=NUPD+1
  $$ELSEIF($MET=2)
*
*     DFP UPDATE
*
    $$U20=1
    POM=ONE
    TUXX='DFP     '
    NUPD=NUPD+1
  $$ELSEIF($MET=3)
*
*     HOSHINO UPDATE
*
    DEN=PAR*B+C
    DIS=HALF*B
    POM=PAR*B/DEN
    CALL UXVDIR(N,PAR,GO,S,S)
    CALL $POM1,PAR/DIS,GO$POM2
    CALL $POM1,-ONE/DEN,S$POM2
    TUXX='HOSHINO '
    NUPD=NUPD+1
  $$ELSEIF($MET=4)
    $$IF(DEC='M')
*
*     RANK ONE UPDATE
*
      DEN=PAR*B-C
      IF (ABS(DEN).GE.$CON6*C) THEN
      POM=PAR*B/DEN
      CALL UXVDIR(N,-PAR,GO,S,GO)
      CALL $POM1,ONE/DEN,GO$POM2
      TUXX='RANK ONE'
      NUPD=NUPD+1
      ELSE
      TUXX='SKIPPED '
      ENDIF
      GO TO 21
    $$ELSE
*
*     SAFEGUARDED RANK ONE UPDATE
*
      $$U17=1
      $$U18=1
      DIS=PAR*A-B
      DEN=PAR*B-C
      IF (DIS.LT.ZERO.AND.DEN.NE.ZERO) GO TO 18
    $$ENDIF
  $$ELSEIF($MET=5)
*
*     OPTIMALLY CONDITIONED UPDATE
*
    $$U17=1
    $$U18=1
    $$U19=1
    $$U20=1
    DEN=PAR*B-C
    DIS=PAR*A-B
    IF (PAR*A*DEN.LE.C*DIS) GO TO 19
    IF (DEN.NE.ZERO) GO TO 18
  $$ELSEIF($MET=6)
*
*     SIMPLE PRECONVEX UPDATE
*
    $$U20=1
    POM=ONE-ONE/SQRT(MAX(ONE/$ETA9,ONE-ONE/(AA*CC)))
    TUXX='LUKSAN 1'
    NUPD=NUPD+1
  $$ELSEIF($MET=7)
*
*     VARIATIONALLY DERIVED PRECONVEX UPDATE
*
    $$U20=1
    POM=-ONE/(TWO*AA*CC-ONE)
    TUXX='LUKSAN 2'
    NUPD=NUPD+1
  $$ELSEIF($MET=8)
*
*     NEW UPDATE
*
    $$U17=1
    $$U20=1
    POM=ONE/(AA*CC)
    IF (POM.LT.ONE) THEN
    POM=MIN(ONE,POM*(SQRT(A/C)-ONE))
$REM    DEN=MAX(POM+$ETA0,(C/A)**0.20D0)
$REM    POM=POM*(ONE/DEN-ONE)/MAX(ONE/$ETA9,ONE-POM)
    TUXX='NEW     '
    NUPD=NUPD+1
    GO TO 20
    ENDIF
  $$ELSEIF($MET=9)
*
*     TEWARSON-1 UPDATE
*
    $$U20=1
    POM1=SQRT(ONE/CC)
    POM2=SQRT(AA)
    CALL UNNEQ3(POM1,POM2,POM,DEN,UNFUN1,$CON5,$ETA0,NRED,MODE)
    POM=-(ONE/CC)/(POM+ONE)**2
    TUXX='TEWARS 1'
    NUPD=NUPD+1
  $$ELSEIF($MET=10)
*
*     TEWARSON-2 UPDATE
*
    $$U20=1
    DEN=(R*SNORM)**2
    DIS=UXVDOT(N,XO,S)
    POM1=ONE-ONE/(R*AA)
    POM2=ONE-CC/R
    DEN=POM1*DEN-POM2*DIS/AA
    DIS=POM1*DIS-POM2*UXVDOT(N,S,S)/AA
    POM1=DEN-DIS/AA
    DIS=AA*CC
    IF (POM1.EQ.ZERO) THEN
    POM=TWO*DIS
    ELSE
    POM=POM2/POM1
    IF (POM.GT.ZERO) THEN
    POM=R*PAR*DEN*POM
    POM=MAX(DIS,MIN(TWO*DIS,POM))
    ELSE
    POM=TWO*DIS
    ENDIF
    ENDIF
    POM=(POM-ONE)/MAX(ONE/$ETA9,DIS-ONE)
    POM=(ONE-POM)/(ONE+POM*(AA*CC-ONE))
    TUXX='TEWARS 2'
    NUPD=NUPD+1
  $$ELSEIF($MET=11)
*
*     TEWARSON-3 UPDATE
*
    $$U20=1
    DEN=(R*SNORM)**2
    DIS=UXVDOT(N,XO,S)
    POM2=ONE-CC/R
    DEN=DEN-DIS/AA
    DIS=DIS-UXVDOT(N,S,S)/AA
    POM1=DEN-DIS/AA
    DIS=AA*CC
    IF (POM1.EQ.ZERO) THEN
    POM=TWO*DIS
    ELSE
    POM=POM2/POM1
    POM=R*PAR*DEN*POM
    POM=MAX(DIS,MIN(TWO*DIS,POM))
    ENDIF
    POM=(POM-ONE)/MAX(ONE/$ETA9,DIS-ONE)
    POM=(ONE-POM)/(ONE+POM*(AA*CC-ONE))
    TUXX='TEWARS 3'
    NUPD=NUPD+1
  $$ELSEIF($MET=12)
*
*     LPD UPDATE
*
    $$U17=1
    $$U20=1
    IF (NIT.GT.KIT) THEN
    POM=UXVDOT(N,GO,XS)/UXVDOT(N,XO,GS)
    DEN=ONE-CC*POM
    IF (DEN.GT.ZERO) THEN
    POM=ONE/DEN
    TUXX='LPD     '
    NUPD=NUPD+1
    GO TO 20
    ENDIF
    ENDIF
  $$ENDIF
  $$IF(U17>0)
17 CONTINUE
*
*     BFGS UPDATE
*
    POM=ZERO
    CALL $POM1,PAR/B,GO$POM2
    CALL $POM1,-ONE/C,S$POM2
    TUXX='BFGS    '
    GO TO 21
  $$ENDIF
  $$IF(U18>0)
18 CONTINUE
*
*     RANK ONE UPDATE
*
    POM=PAR*B/DEN
    CALL UXVDIR(N,-PAR,GO,S,GO)
    CALL $POM1,ONE/DEN,GO$POM2
    TUXX='RANK ONE'
    NUPD=NUPD+1
    GO TO 21
  $$ENDIF
  $$IF(U19>0)
19 CONTINUE
*
*     DAVIDON'S UPDATE
*
    DEN=AA*CC-ONE
    IF (DEN.LE.ZERO) GO TO 17
    POM=(PAR*AA-ONE)/DEN
    TUXX='DAVIDON '
    NUPD=NUPD+1
  $$ENDIF
  $$IF(U20>0)
20 CONTINUE
*
*     GENERAL UPDATE
*
    CALL $POM1,PAR/B,GO$POM2
    CALL $POM1,-ONE/C,S$POM2
    CALL UXVDIR(N,-C/B,GO,S,GO)
    CALL $POM1,POM/C,GO$POM2
  $$ENDIF
21 CONTINUE
  IDECA=0
  ITERH=0
  IF (GAM.EQ.ONE) GO TO 22
*
*     SCALING
*
  $$IF(DEC='M')
    CALL UXDSMS(N,H,ONE/GAM)
  $$ELSEIF(DEC='G')
    CALL UXDPGS(N,H,ONE/GAM)
  $$ELSEIF(DEC='R')
    CALL UXDSMS(N,H,ONE/SQRT(GAM))
  $$ELSEIF(DEC='S')
    CALL UXDPGS(N,H,ONE/GAM)
  $$ELSEIF(DEC='B')
    $$IF(MOS2<3)
      CALL UXDLBS(N,H,IH,ONE/GAM)
    $$ELSE
      CALL UXDSBS(N,H,IH,ONE/GAM)
    $$ENDIF
  $$ENDIF
  NSCL=NSCL+1
22 CONTINUE
  CALL UOU1D2(N,H,S,RHO,GAM,PAR,A,B,C,POM,ETA9)
  $$IF($MET=12)
    CALL UXVCOP(N,XO,XS)
    CALL UXVCOP(N,GO,GS)
  $$ENDIF
  RETURN
  END
  $ENDADD
  $ADD(INIT)
    NUXX='UUDB$(DEC)1'
  $ENDADD
  $EXIT
