$INTERFACE UUDDI1                                             12/12/01
$REM LU

  $CON0='0.1$P 0'
  $CON1='1.0$P-3'
  $CON2='2.0$P 0'
  $CON3='0.2$P 0'
  $CON4='1.0$P-2'
  $CON5='5.0$P-8'
  $CON6='1.0$P-4'
  $CON7='1.0$P-6'
  $GAML='1.0$P 0'
  $GAMU='6.0$P 0'
  $IF($DEF(MOS5))
  $ELSE
    $MOS5=0
  $ENDIF
  $HELP
    METHOD OF UPDATE OF HESSIAN MATRIX:
      1 - BFGS UPDATE
      2 - DFP UPDATE
      3 - HOSHINO UPDATE
      4 - SAFEGUARDED RANK ONE UPDATE
      5 - OPTIMALLY CONDITIONED UPDATE
      6 - SIMPLE PRECONVEX UPDATE
      7 - VARIATIONALLY DERIVED PRECONVEX UPDATE
      8 - NEW COMBINED UPDATE
      9 - PRECONVEX UPDATE DERIVED FROM MATRIX FACTORIZATION
     10 - ANGLE MINIMIZING UPDATE
     11 - NORM MINIMIZING UPDATE
  $CHECK(MET,1,'1\2\3\4\5\6\7\8\9\10\11',3)
  $HELP
    SELECTION OF SELF SCALING:
      ABS(MET1)=1 - SELF SCALING SUPPRESSED
      ABS(MET1)=2 - INITIAL SELF SCALING
      ABS(MET1)=3 - CONTROLLED SELF SCALING
      ABS(MET1)=4 - SIMPLIFIED CONTROLLED SELF SCALING
      ABS(MET1)=5 - SELF SCALING IN EACH ITERATION
           MET1>0 - BASIC INITIAL SELF SCALING
           MET1<0 - MODIFIED INITIAL SELF SCALING
  $CHECK(MET1,3,'-5\-4\-3\-2\-1\1\2\3\4\5',4)
  $NET1=MET1
  $IF(NET1=-1) $NET1=1
  $IF(NET1=-2) $NET1=2
  $IF(NET1=-3) $NET1=3
  $IF(NET1=-4) $NET1=4
  $IF(NET1=-5) $NET1=5
  $IF(NET1= 3) $GAML='0.6$P 0'
  $HELP
    COMPUTATION OF A - C:
      1 - USING SCALAR VALUES
      2 - USING VECTOR VALUES
  $CHECK(MET3,1,'1\2',4)
  $HELP
    METHOD CORRECTION:
      1 - BFGS SCALING
      2 - DFP SCALING
      3 - GEOMETRIC MEAN
  $CHECK(MET4,3,'1\2\3',4)
  $SNORM=0
  $N='N'
  $GS='GS'
  $ADD(REAL,'\$H($NF*($NF+1)/2)\$GN($NF)\$SN($NF)\$XO($NF)\$GO($NF)&
  \$XP($NF)\$GP($NF)\$XS($NF)\$GS($NF)')
  $POM4='($N,$H,$GN,$S,$XO,$GO,$XP,$GP,$XS,$GS,R,PO'
  $POM6='(N,H,G,S,XO,GO,XP,GP,XS,GS,R,PO'
  $IF(NET1=3)
    $ADD(POM4,',PAR1,PAR2')
    $ADD(POM6,',PAR1,PAR2')
  $ENDIF
  $ADD(POM4,',$MET)')
  $ADD(POM6,',MET)')
  $NUMSUB=''
  $IF(NMET>1) $NUMSUB='_$NMET'
  CALL UUDDI1$(NUMSUB)$POM4
  $ADD(SUBROUTINES)
*     ----------------------------------------
*     BROYDEN CLASS OF VARIABLE METRIC UPDATES
*     TEMPLATE : UUDDI1
*     ----------------------------------------
  SUBROUTINE UUDDI1$(NUMSUB)$POM6
  $$INCLUDE('UMCOMM')
  INTEGER N,MET
  $$FLOAT H(N*(N+1)/2),G(N),S(N),XO(N),GO(N),XP(N),GP(N),XS(N),GS(N)&
  ,R,PO
  $$IF($NET1=3) $$FLOAT PAR1,PAR2
  $$IF($SNORM=1) $$FLOAT SNORM
  $$FLOAT AA,CC
  COMMON /UMFUN1/ AA,CC
  $$FLOAT UXVDOT,UNFUN1
  $$FLOAT ETA,A,B,C,D,BB,DD,ALF,BET,GAM,DEL,EPS,SIG,TAU,DIS
  $$IF($MET>2) $$FLOAT DEN
  LOGICAL L1,L3
  $$IF ($NET1=3) LOGICAL L2
  $$IF($MET>8)
    $$FLOAT POM1,POM2
  $$ENDIF
  EXTERNAL UNFUN1
  IF (MET.LE.0) GO TO 23
  CALL UOU1D1(N,XO,GO)
  IF (IDECF.NE.9) THEN
  ITERH=-1
  TUXX='BAD DEC9'
  CALL UOERR1('UUDDI1',1)
  GO TO 23
  ENDIF
  IF (NIT.EQ.KIT) THEN
  CALL UXVCOP(N,GO,XP)
  CALL UXVNEG(N,GO,GP)
  ENDIF
  L1=ABS($MET1).GE.3.OR.ABS($MET1).EQ.2.AND.NIT.EQ.KIT
  L3=.NOT.L1
*
*     DETERMINATION OF THE PARAMETERS A, B, C
*
  B=UXVDOT(N,XO,GO)
  IF (B.LE.ZERO) THEN
  ITERH=2
  TUXX='B - NEG.'
  GO TO 23
  ENDIF
  CALL UXDSMM(N,H,GO,S)
  A=UXVDOT(N,GO,S)
  IF (A.LE.ZERO) THEN
  ITERH=1
  TUXX='A - NEG.'
  GO TO 23
  ENDIF
  IF (ITERD.NE.1) THEN
  C=ZERO
  ELSE
  IF (ITRAN.EQ.0) THEN
  CALL UXVDIF(N,GO,G,GS)
  ELSE
  CALL UXVNEG(N,G,GS)
  ENDIF
  CALL UXVSCL(N,R,GS,GS)
  C=-R*PO
  ENDIF
  IF (C.LE.ZERO) THEN
  ITERH=3
  TUXX='C - NEG.'
  GO TO 23
  ENDIF
  IF (L1) THEN
*
*     DETERMINATION OF THE PARAMETER GAM (SELF SCALING)
*
  $$IF(MET4=1)
    GAM=B/A
  $$ELSEIF(MET4=2)
    GAM=C/B
  $$ELSEIF(MET4=3)
    GAM=SQRT(C/A)
  $$ENDIF
  $$IF($MET1<0)
    IF (NIT.EQ.KIT) THEN
    GAM=MAX(GAM,$CON6)
    GAM=MIN(GAM,ONE/$CON6)
    ENDIF
  $$ENDIF
  $$IF($NET1=3)
    IF (NIT.NE.KIT) THEN
    L2=PAR2.LE.ZERO
    L3=L2.AND.ABS(PAR1).LE.$CON3
    L3=L3.OR.(.NOT.L2.AND.GAM.GT.ONE)
    L3=L3.OR.(L2.AND.PAR1.LT.ZERO.AND.GAM.GT.ONE)
    L3=L3.OR.(L2.AND.PAR1.GT.ZERO.AND.GAM.LT.ONE)
    L3=L3.OR.GAM.LT.$GAML
    L3=L3.OR.GAM.GT.$GAMU
    ENDIF
  $$ELSEIF($NET1=4)
    IF (NIT.NE.KIT) THEN
    L3=GAM.LT.$GAML.OR.GAM.GT.$GAMU
    ENDIF
  $$ENDIF
  ENDIF
  IF (L3) GAM=ONE
  IF (GAM.NE.ONE) THEN
*
*     SCALING
*
  CALL UXDSMS(N,H,GAM)
  CALL UXVSCL(N,GAM,S,S)
  CALL UXVSCL(N,ONE/GAM,GP,GP)
  CALL UXVSCL(N,ONE/GAM,GS,GS)
  A=A*GAM 
  C=C/GAM
  NSCL=NSCL+1
  ENDIF
*
*     DETERMINATION OF THE PARAMETERS ALF, BET, GAM, DEL, EPS, SIG, TAU
*
  TAU=A-TWO*B+C
  IF (TAU.LE.ZERO) THEN
  ITERH=5
  TUXX='TAU-NEG.'
  GO TO 23
  ENDIF
  EPS=-UXVDOT(N,XP,GP)
  IF (EPS.LE.ZERO) THEN
  ITERH=7
  TUXX='EPS-NEG.'
  GO TO 23
  ENDIF
  SIG=SQRT(TAU/EPS)
  CALL UXVSCL(N,SIG,XP,XP)
  CALL UXVSCL(N,SIG,GP,GP)
  ALF=UXVDOT(N,GO,XP)
  BET=B-A
  GAM=UXVDOT(N,XP,GS)
  DEL=C-B
  SIG=GAM-ALF
  ETA=BET*TAU-ALF*SIG
  DIS=ALF*TAU-BET*SIG
  D=TAU**2-SIG**2
  DD=DIS**2
  AA=BET*BET*D+DD
  BB=BET*DEL*D+DD
  CC=DEL*DEL*D+DD
  IF (D.LE.ZERO.OR.BB.LE.ZERO) GO TO 22
*
*     COMPUTATION OF PROJECTIONS
*
  CALL UXVDIF(N,XO,S ,XS)
  CALL UXVLIN(N,ETA/D,XS,DIS/D,XP,S)
  CALL UXVSUM(N,XS,S,XO)
*
*     DETERMINATION OF NEW PARAMETERS A, B, C
*
  IF ($MET3.EQ.1) THEN 
  A=AA/(TAU*D)
  B=BB/(TAU*D)
  C=CC/(TAU*D)
  ELSE
  A=UXVDOT(N,GO,S)
  B=UXVDOT(N,XO,GO)
  C=UXVDOT(N,XO,GS)
  ENDIF
  AA=A/B
  CC=C/B
*
*     DETERMINATION OF THE NEW VECTORS XP, GP
*
  CALL UXVDIF(N,GO,GS,GS)
  CALL UXVLIN(N,BET,XP,-ALF,XS,XP)
  CALL UXVLIN(N,DEL,GP,-GAM,GS,GP)
  $$U17=0
  $$U18=0
  $$U19=0
  $$U20=0
  $$IF($MET=1)
    $$U17=1
    NUPD=NUPD+1
  $$ELSEIF($MET=2)
*
*     DFP UPDATE
*
    ETA=ZERO
    CALL UXDSMU(N,H, ONE/B,XO)
    CALL UXDSMU(N,H,-ONE/A,S)
    TUXX='D - DFP '
    NUPD=NUPD+1
  $$ELSEIF($MET=3)
*
*     HOSHINO UPDATE
*
    DEN=B+A
    DIS=HALF*B
    ETA=B/DEN
    CALL UXVSUM(N,XO,S,GO)
    CALL UXDSMU(N,H, ONE/DIS,XO)
    CALL UXDSMU(N,H,-ONE/DEN,GO)
    TUXX='D - HOSH'
    NUPD=NUPD+1
  $$ELSEIF($MET=4)
*
*     SAFEGUARDED RANK ONE UPDATE
*
    $$U17=1
    $$U18=1
    IF (C.LE.ZERO) GO TO 17
    DEN=B-A
    DIS=C-B
    IF (DEN.LE.1.0$P-8*A) GO TO 17
    IF (DEN.GT.ZERO.OR.DIS.LT.ZERO) GO TO 18
  $$ELSEIF($MET=5)
*
*     OPTIMALLY CONDITIONED UPDATE
*
    $$U17=1
    $$U18=1
    $$U19=1
    $$U20=1
    IF (C.LE.ZERO) GO TO 17
    DEN=B-A
    DIS=C-B
    IF (C*DEN.LE.A*DIS) GO TO 19
    IF (DEN.NE.ZERO) GO TO 18
  $$ELSEIF($MET=6)
*
*     SIMPLE PRECONVEX UPDATE
*
    $$U17=1
    $$U20=1
    IF (C.LE.ZERO) GO TO 17
    ETA=ONE+ONE/SQRT(MAX(ONE/$ETA9,ONE-ONE/(AA*CC)))
    TUXX='D - LUK1'
    NUPD=NUPD+1
    GO TO 20
  $$ELSEIF($MET=7)
*
*     VARIATIONALLY DERIVED PRECONVEX UPDATE
*
    $$U20=1
    ETA=ETA3
    IF (ETA.NE.TWO) GO TO 20
    DIS=TWO*AA
    CALL UXVDIR(N,-DIS,XO,S,GO)
    CALL UXDSMU(N,H,ONE/A,GO)
    CALL UXDSMU(N,H,(ONE-DIS)/B,XO)
    TUXX='D - LUK2'
    NUPD=NUPD+1
    GO TO 21
  $$ELSEIF($MET=8)
*
*     NEW UPDATE
*
    $$U17=1
    $$U20=1
    IF (C.LE.ZERO) GO TO 17
    ETA=ONE/(AA*CC)
    IF (ETA.LT.ONE) THEN
    ETA=MAX(1.0$P-15,(SQRT(C/A)-ETA)/(ONE-ETA))
$REM    DEN=MAX(ETA+$ETA0,SQRT(C/A))
$REM    ETA=(DEN-ETA)/(ONE-ETA)
$REM    ETA=(DEN-ETA)/MAX(ONE/$ETA9,ONE-ETA)
$REM    ETA=MAX(ZERO,SQRT(C/A)-ETA)/MAX(ONE/$ETA9,ONE-ETA)
    TUXX='D - NEW '
    NUPD=NUPD+1
    GO TO 20
    ENDIF
  $$ELSEIF($MET=9)
*
*     TEWARSON-1 UPDATE
*
    $$U17=1
    $$U20=1
    IF (C.LE.ZERO) GO TO 17
    POM1=SQRT(ONE/CC)
    POM2=SQRT(AA)
    NRED=20
    CALL UNNEQ1(POM1,POM2,DIS,DEN,UNFUN1,$CON5,$ETA0,NRED,MODE)
    IF (MODE.GE.0) THEN
    ETA=ONE/(AA*CC)
    DEN=MAX(ETA+$ETA0,CC*DIS**2)
    ETA=(DEN-ETA)/MAX(ONE/$ETA9,ONE-ETA)
    TUXX='D - TEW1'
    NUPD=NUPD+1
    GO TO 20
    ENDIF
  $$ELSEIF($MET=10)
*
*     TEWARSON-2 UPDATE
*
    $$U17=1
    $$U20=1
    IF (C.LE.ZERO) GO TO 17
    DEN=(R*SNORM)**2
    DIS=UXVDOT(N,XO,S)
    POM1=ONE-ONE/(R*AA)
    POM2=ONE-CC/R
    DEN=POM1*DEN-POM2*DIS/AA
    DIS=POM1*DIS-POM2*UXVDOT(N,S,S)/AA
    POM1=DEN-DIS/AA
    DIS=AA*CC
    IF (POM1.EQ.ZERO) THEN
    ETA=TWO*DIS
    ELSE
    ETA=POM2/POM1
    IF(ETA.GT.ZERO) THEN
    ETA=R*DEN*ETA
    ETA=MAX(DIS,MIN(TWO*DIS,ETA))
    ELSE
    ETA=TWO*DIS
    ENDIF
    ENDIF
    ETA=(ETA-ONE)/MAX(ONE/$ETA9,DIS-ONE)
    TUXX='D - TEW2'
    NUPD=NUPD+1
    GO TO 20
  $$ELSEIF($MET=11)
*
*     TEWARSON-3 UPDATE
*
    $$U17=1
    $$U20=1
    IF (C.LE.ZERO) GO TO 17
    DEN=(R*SNORM)**2
    DIS=UXVDOT(N,XO,S)
    POM2=ONE-CC/R
    DEN=DEN-DIS/AA
    DIS=DIS-UXVDOT(N,S,S)/AA
    POM1=DEN-DIS/AA
    DIS=AA*CC
    IF (POM1.EQ.ZERO) THEN
    ETA=TWO*DIS
    ELSE
    ETA=POM2/POM1
    ETA=R*DEN*ETA
    ETA=MAX(DIS,MIN(TWO*DIS,ETA))
    ENDIF
    ETA=(ETA-ONE)/MAX(ONE/$ETA9,DIS-ONE)
    TUXX='D - TEW3'
    NUPD=NUPD+1
    GO TO 20
  $$ELSE
    $$U20=1
    ETA=1.0$P 0
    NUPD=NUPD+1
  $$ENDIF
  $$IF(U17>0)
17 CONTINUE
*
*     BFGS UPDATE
*
    ETA=ONE
    DIS=ONE+AA
    CALL UXVDIR(N,-DIS,XO,S,GO)
    DIS=ONE/(B*DIS)
    CALL UXDSMU(N,H,DIS,GO)
    CALL UXDSMU(N,H,-DIS,S)
    TUXX='D - BFGS'
    GO TO 21
  $$ENDIF
  $$IF(U18>0)
18 CONTINUE
*
*     RANK ONE UPDATE
*
    ETA=B/DEN
    CALL UXVDIF(N,XO,S,XO,GO)
    CALL UXDSMU(N,H,ONE/DEN,GO)
    TUXX='D - R1  '
    NUPD=NUPD+1
    GO TO 21
  $$ENDIF
  $$IF(U19>0)
19 CONTINUE
*
*     DAVIDON'S UPDATE
*
    DEN=AA*CC-ONE
    IF (DEN.EQ.ZERO) GO TO 17
    ETA=(CC-ONE)/DEN
    IF (ETA.LE.ZERO) GO TO 17
    TUXX='D - OLC '
    NUPD=NUPD+1
  $$ENDIF
  $$IF(U20>0)
20 CONTINUE
*
*     GENERAL UPDATE
*
    DEN=ONE+ETA*AA
    DIS=ETA/DEN
    CALL UXDSMU(N,H,(DIS-ONE)/A,S)
    CALL UXVDIR(N,-DIS,S,XO,GO)
    CALL UXDSMU(N,H,DEN/B,GO)
  $$ENDIF
21 CONTINUE  
  ITERH=0
  D=ETA*C/B+(ONE-ETA)*B/A
  CALL UXVSCL(N,ONE/D,GP,GP)
  GO TO 23
22 CONTINUE
*
*     BFGS UPDATE
*
  CALL UXVDIR(N,-ALF/B,GO,GP,GP)
  CALL UXVDIR(N, GAM/C,GS,GP,GP)
  ETA=ONE
  DIS=ONE+A/B
  CALL UXVDIR(N,-DIS,XO,S,GO)
  DIS=ONE/(B*DIS)
  CALL UXDSMU(N,H,DIS,GO)
  CALL UXDSMU(N,H,-DIS,S)
  TUXX='BFGS    '
  ITERH=0
23 CONTINUE
  CALL UOU1D2(N,H,S,ONE,GAM,ONE,A,B,C,ETA,ETA9)
  RETURN
  END
  $ENDADD
  $ADD(INIT)
    NUXX='UUDDI1'
  $ENDADD
  $EXIT

