$INTERFACE UUDFG1                                             97/12/01

  $IF(DEC='M')
    $HELP
      METHOD OF UPDATE OF HESSIAN MATRIX:
        1 - BFGS UPDATE
        2 - DFP UPDATE
        3 - HOSHINO UPDATE
        4 - RANK-ONE UPDATE
    $CHECK(MET,1,'1\2\3\4',3)
  $ELSE
    $HELP
      METHOD OF UPDATE OF HESSIAN MATRIX:
        1 - BFGS UPDATE
        2 - DFP UPDATE
        3 - HOSHINO UPDATE
        4 - SAFEGUARDED RANK ONE UPDATE
        5 - OPTIMALLY CONDITIONED UPDATE
        6 - SIMPLE PRECONVEX UPDATE
        7 - VARIATIONALLY DERIVED PRECONVEX UPDATE
        8 - NEW COMBINED UPDATE
    $CHECK(MET,1,'1\2\3\4\5\6\7\8',3)
  $ENDIF
  $HELP
    SELECTION OF SELF SCALING:
      1 - SELF SCALING SUPPRESSED
      2 - SELF SCALING IN THE FIRST ITERATION AFTER RESTART
      3 - SELF SCALING IN EACH ITERATION
  $CHECK(MET1,2,'1\2\3',4)
  $DEFAULT=1
  $IF(DEC='G') $DEFAULT=2
  $IF(DEC='S') $DEFAULT=2
  $HELP
    SELECTED VERSION OF THE HYBRID METHOD:
      1 - FLETCHER-XU METHOD 
      2 - COMBINATION OF FLETCHER-XU AND DENNIS-WELSCH METHOD
  $CHECK(MOT2,DEFAULT,'1\2',4)
$REM  $HELP
$REM    TOLERANCE FOR POSITIVE DEFINITENESS
$REM  $CHECK(ETA2,ETA0,REAL,4)
  $DEFAULT='1.0D-3'
  $IF(TYPE='L') $DEFAULT='2.0D-2'
  $HELP
    TOLERANCE FOR APPLICATION OF THE BFGS METHOD
  $CHECK(ETA5,DEFAULT,REAL,4)
  $IF(DEC='M')
    $POM1='UXDSMU(N,B'
    $POM2=')'
    $POM3='$$N,$$H,$$HH'
    $POM5='N,H,B'
  $ELSEIF(DEC='G')
    $POM1='UXDPGU(N,B'
    $POM2=',XO)'
    $POM3='$$N,$$H,$$HH'
    $POM5='N,H,B'
  $ELSEIF(DEC='R')
    $POM1='UXDPRU(N,B'
    $POM2=',XO)'
    $POM3='$$N,$$H,$$HH'
    $POM5='N,H,B'
  $ELSEIF(DEC='S')
    $POM1='UXD$(LET)GU(N,B,IH'
    $POM2=',XO)'
    $POM3='$$N,$$H,$$HH,$$IH'
    $POM5='N,H,B,IH'
    $ADD(INTEGER,'\$IH($NF)')
  $ELSEIF(DEC='B')
    $HELP
      TYPE OF DECOMPOSITION
        1 - BUNCH-PARLETT DECOMPOSITION WITH NUMERICAL PERMUTATIONS
        2 - BUNCH-KAUFMAN DECOMPOSITION WITH NUMERICAL PERMUTATIONS
        3 - BUNCH PARLETT DECOMPOSITION WITH TWO LEVEL INDICES
    $CHECK(MOS2,1,'1\2\3',2)
    $IF(MOS2<3)
      $IQ='IQ'
      $POM1='UXDLBU(N,B,IH'
      $POM2=',XO,IQ)'
      $POM3='$$N,$$H,$$HH,$$IH'
      $POM5='N,H,B,IH'
      $ADD(INTEGER,'\$IH($NF)\$IQ($NF)')
    $ELSE
      $POM1='UXDSBU(N,B,IH'
      $POM2=',XO)'
      $POM3='$$N,$$H,$$HH,$$IH'
      $POM5='N,H,B,IH'
      $ADD(INTEGER,'\$IH($NF)')
    $ENDIF
  $ENDIF
  $POM4='F,FO,'
  $POM6='F,FO,'
$REM  $IF (MET1=3)
  $ADD(POM4,'PAR1,PAR2,')
  $ADD(POM6,'PAR1,PAR2,')
$REM  $ENDIF
  $IF (DEC<>'M')
    $ADD(POM4,'ETA2,')
    $ADD(POM6,'ETA2,')
  $ENDIF
  $ADD(POM4,'ETA5,$ETA9,IPOM1,IPOM2,MET,MET1,MOT2')
  $ADD(POM6,'ETA5,ETA9,IPOM1,IPOM2,MET,MET1,MOT2')
  $IF(DEC='B')
    $IF(MOS2<3)
      $ADD(POM4,',MOS2')
      $ADD(POM6,',MOS2')
    $ENDIF
  $ENDIF
  $NUMSUB=''
  $IF(NMET>1) $NUMSUB='_$NMET'
  CALL UUDF$(DEC)1$(NUMSUB)($POM3,$S,$XO,$GO,$POM4)
  $ADD(SUBROUTINES)
*     ----------------------------------------
*     BROYDEN CLASS OF VARIABLE METRIC UPDATES
*     TEMPLATE : UUDFG1
*     ----------------------------------------
  SUBROUTINE UUDF$(DEC)1$(NUMSUB)($POM5,S,XO,GO,$POM6)
  $$INCLUDE('UMCOMM')
  INTEGER N,IPOM1,IPOM2,MET,MET1,MOT2
  $$IF(DEC='B')
    $$IF(MOS2<3)
      INTEGER IQ(N),MOS2
    $$ENDIF
  $$ENDIF
  $$IF(DEC='S') INTEGER IH(N)
  $$IF(DEC='B') INTEGER IH(N)
  $$FLOAT H(N*(N+1)/2),B(N*(N+1)/2),S(N),XO(N),GO(N),F,FO,ETA5,ETA9
  $$IF (DEC<>'M') $$FLOAT ETA2
  $$FLOAT PAR1,PAR2
  $$FLOAT AA,CC
  $$FLOAT UXVDOT
  $$IF (DEC='G') $$FLOAT UXDPGP
  $$IF (DEC='S') $$FLOAT UXDPGP
  $$IF (DEC='B')
    $$IF(MOS2<3)
      $$FLOAT UXDSBP
    $$ELSE
      $$FLOAT UXDLBP
    $$ENDIF
  $$ENDIF
  $$FLOAT AH,BH,CH,DH,AB,BB,CB,DB,GAM,PAR
  $$IF (DEC<>'M') $$FLOAT DEN
  $$IF (DEC='G') $$FLOAT DIS
  $$IF (DEC='R') $$FLOAT DIS
  $$IF (DEC='S') $$FLOAT DIS
  $$IF(DEC<>'M')
    INTEGER INF
  $$ENDIF
  LOGICAL L1,L2
$REM  $$IF($MET1=3) LOGICAL L2
  $$FLOAT CON,CON3,CON5,CON6
  PARAMETER (CON=1.0$P 6,CON3=0.1$P 0,CON5=1.0$P 6,CON6=0.4$P 0)
  IF (MET.LE.0) GO TO 22
  CALL UOU1D1(N,XO,GO)
  $$IF(DEC='M')
    $$I=0
    IF (IDECF.NE.0) THEN
  $$ELSEIF(DEC='G')
    $$I=1
    IF (IDECF.EQ.0) THEN
*
*     GILL-MURRAY DECOMPOSITION
*
    BH=ETA2
    CALL UXDPGF(N,H,INF,BH,DH)
    NDECF=NDECF+1
    IDECF=$$I
    ELSE IF (IDECF.NE.$$I) THEN
$REM  $$ELSEIF(DEC='R')
$REM    $$I=2
$REM    IF (IDECF.EQ.0) THEN
$REM    BH=ETA2
$REM    CALL UXDPGF(N,H,INF,BH,DH)
$REM    CALL UXDPGT(N,H)
$REM    NDECF=NDECF+1
$REM    IDECF=$$I
$REM    ELSE IF (IDECF.NE.$$I) THEN
  $$ELSEIF(DEC='S')
    $$I=4
    IF (IDECF.EQ.0) THEN
*
*     SCHNABEL-ESKOW DECOMPOSITION
*
    BH=ETA2
    CALL UXVINP(N,IH)
    CALL UXD$$(LET)GF(N,H,IH,S,INF,BH,DH$$ART
    NDECF=NDECF+1
    IDECF=$$I
    ELSE IF (IDECF.NE.$$I) THEN
  $$ELSEIF(DEC='B')
    $$I=3
    IF (IDECF.EQ.0) THEN
*
*     BUNCH-PARLETT DECOMPOSITION
*
    BH=ETA2
    CALL UXVINP(N,IH)
    CALL UXD$$(LET)LBF(N,H,IH,INF,BH$$ART
    NDECF=NDECF+1
    IDECF=$$I
    ELSE IF (IDECF.NE.$$I) THEN
  $$ELSEIF(DEC='R')
    $$I=2
    IF (IDECF.NE.$$I) THEN
  $$ENDIF
  ITERH=-1
  TUXX='BAD DEC$$I'
  CALL UOERR1('UUDB$(DEC)1',1)
  GO TO 22
  ENDIF
  PAR=ZERO
*
*     DETERMINATION OF THE PARAMETERS A,B,C
*
  BH=UXVDOT(N,XO,GO)
  IF(BH.LE.ZERO) THEN
  ITERH=2
  TUXX='B - NEG.'
  IPOM1=0
  GO TO 22
  ENDIF
  BB=BH
  L1=MET1.EQ.4.OR.MET1.EQ.3.AND.IPOM2.GE.1.OR.MET1.EQ.2.AND.IPOM2.EQ.1
  L2=ABS(PAR1).LE.CON3.AND.PAR2.LE.ZERO
  IF (MOT2.GT.1.AND..NOT.L2) THEN
  $$IF(DEC='M')
    AH=ZERO
    CALL UXDSMM(N,H,XO,S)
  $$ELSEIF(DEC='G')
    CALL UXVCOP(N,GO,S)
    CALL UXDPGB(N,H,S,1)
    AH=UXDPGP(N,H,S,S)
    CALL UXVCOP(N,XO,S)
    CALL UXDPGM(N,H,S,0)
  $$ELSEIF(DEC='R')
    CALL UXVCOP(N,GO,S)
    CALL UXDPRB(N,H,S,1)
    AH=UXVDOT(N,S,S)
    CALL UXVCOP(N,XO,S)
    CALL UXDPRM(N,H,S,0)
  $$ELSEIF(DEC='S')
    CALL UXVCOP(N,GO,S)
    CALL UXD$$(LET)GB(N,H,IH,S,1)
    AH=UXDPGP(N,H,S,S)
    CALL UXVCOP(N,XO,S)
    CALL UXD$$(LET)GM(N,H,IH,S,0)
  $$ELSEIF(DEC='B')
    CALL UXVCOP(N,GO,S)
    $$IF(MOS2<3)
      CALL UXDLBB(N,H,IH,S,1)
    $$ELSE
      CALL UXDSBB(N,H,IH,S,1)
    $$ENDIF
    $$IF(MOS2<3)
      AH=UXDLBP(N,H,IH,S)
    $$ELSE
      AH=UXDSBP(N,H,IH,S,S)
    $$ENDIF
    CALL UXVCOP(N,XO,S)
    $$IF(MOS2<3)
      CALL UXDLBM(N,H,IH,S,0)
    $$ELSE
      CALL UXDSBM(N,H,IH,S,0)
    $$ENDIF
  $$ENDIF
  CH=UXVDOT(N,XO,S)
  IF (CH.LE.ZERO) THEN
  DH=ETA9
  ELSE
  DH=(AH/BH)**2-TWO*(BH/CH)+ONE
  ENDIF
  ENDIF
  $$IF(DEC='M')
    AB=ZERO
    CALL UXDSMM(N,B,XO,S)
  $$ELSEIF(DEC='G')
    CALL UXVCOP(N,GO,S)
    CALL UXDPGB(N,B,S,1)
    AB=UXDPGP(N,B,S,S)
    CALL UXVCOP(N,XO,S)
    CALL UXDPGM(N,B,S,0)
  $$ELSEIF(DEC='R')
    CALL UXVCOP(N,GO,S)
    CALL UXDPRB(N,B,S,1)
    AB=UXVDOT(N,S,S)
    CALL UXVCOP(N,XO,S)
    CALL UXDPRM(N,B,S,0)
  $$ELSEIF(DEC='S')
    CALL UXVCOP(N,GO,S)
    CALL UXD$$(LET)GB(N,B,IH,S,1)
    AB=UXDPGP(N,H,S,S)
    CALL UXVCOP(N,XO,S)
    CALL UXD$$(LET)GM(N,B,IH,S,0)
  $$ELSEIF(DEC='B')
    CALL UXVCOP(N,GO,S)
    $$IF(MOS2<3)
      CALL UXDLBB(N,B,IH,S,1)
      AB=UXDLBP(N,B,IH,S)
    $$ELSE
      CALL UXDSBB(N,B,IH,S,1)
      AB=UXDSBP(N,B,IH,S,S)
    $$ENDIF
    CALL UXVCOP(N,XO,S)
    $$IF(MOS2<3)
      CALL UXDLBM(N,B,IH,S,0)
    $$ELSE
      CALL UXDSBM(N,B,IH,S,0)
    $$ENDIF
  $$ENDIF
  CB=UXVDOT(N,XO,S)
  IF (CB.LE.ZERO) THEN
  DB=ETA9
  ELSE
  DB=(AB/BB)**2-TWO*(BB/CB)+ONE
  ENDIF
  IF (L2) THEN
  ELSE IF (MOT2.EQ.1) THEN
  IF (FO-F.GE.ETA5*FO) THEN
  IPOM1=0
  ELSE
  IPOM1=1
  ENDIF
  ELSE
  IF (FO-F.GE.ETA5*FO.AND.DH.LE.CON5*DB.OR.DH.LE.MIN(CON6*DB,CON)) THEN
  IPOM1=0
  ELSE
  IPOM1=1
  ENDIF
  ENDIF
  IF(L1) THEN
*
*     DETERMINATION OF THE PARAMETER GAM (SELF SCALING)
*
  GAM=CB/BB
  ELSE
  GAM=ONE
  ENDIF
*
*     BFGS UPDATE
*
  CALL $POM1,GAM/BB,GO$POM2
  CALL $POM1,-ONE/CB,S$POM2
  TUXX='BFGS    '
  NUPD=NUPD+1
  ITERH=0
  IDECA=0
  IPOM2=0
  IF(L1) THEN
  $$IF(DEC='M')
    CALL UXDSMS(N,B,ONE/GAM)
  $$ELSEIF(DEC='G')
    CALL UXDPGS(N,B,ONE/GAM)
  $$ELSEIF(DEC='R')
    CALL UXDSMS(N,B,ONE/SQRT(GAM))
  $$ELSEIF(DEC='S')
    CALL UXDPGS(N,B,ONE/GAM)
  $$ELSEIF(DEC='B')
    $$IF(MOS2<3)
      CALL UXDLBS(N,B,IH,ONE/GAM)
    $$ELSE  
      CALL UXDSBS(N,B,IH,ONE/GAM)
    $$ENDIF  
  $$ENDIF
  NSCL=NSCL+1
  ENDIF
22 CONTINUE
  CALL UOU1D2(N,B,S,DB,GAM,PAR,AB,BB,CB,DH,ETA9)
  RETURN
  END
  $ENDADD
  $ADD(INIT)
    NUXX='UUDFG1'
  $ENDADD
  $EXIT
      
