$INTERFACE UUDLG1                                             16/12/01
$REM LU

  $CON0='0.1$P 0'
  $CON1='0.618034$P 0'
  $CON2='4.0$P 0'
  $CON3='0.2$P 0'
  $CON4='1.0$P 3'
  $CON5='3.0$P-8'
  $CON6='0.5$P 0'
  $CON7='3.0$P 0'
  $HELP
    METHOD OF UPDATE OF HESSIAN MATRIX:
      1 - BFGS UPDATE
      2 - DFP UPDATE
      3 - HOSHINO UPDATE
      4 - SAFEGUARDED RANK ONE UPDATE
      5 - OPTIMALLY CONDITIONED UPDATE
      6 - OREN UPDATE
  $CHECK(MET,1,'1\2\3\4\5\6',3)
  $IF(MET=2)
    $MET1=5
    $ADD(INIT)
      MET1=$MET1
    $ENDADD
  $ELSE
    $HELP
      SELECTION OF SELF SCALING:
        1 - SELF SCALING SUPPRESSED
        2 - INITIAL SELF SCALING
        3 - CONTROLLED SELF SCALING
        4 - SIMPLIFIED CONTROLLED SELF SCALING
        5 - SELF SCALING IN EACH ITERATION
    $CHECK(MET1,3,'1\2\3\4\5',4)
  $ENDIF
  $HELP
    SELECTION OF THE DAVIDON VECTOR
      1 - FROM CONJUGACY CONDITIONS
      2 - FROM QUASI NEWTON CONDITIONS
  $CHECK(MET3,1,'1\2',4)
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,ETA0,REAL,4)
  $N='N'
  $ADD(REAL,'\$H($NF*($NF+1)/2)\$SN($NF)\$XO($NF)\$GO($NF)&
  \$XS($NF)\$GS($NF)\$XP($NF)\$GP($NF)\$SO($NF)')
$REM  $ADD(REAL,'\PAR1\PAR2')
  $IF(DEC='G')
    $POM1='UXDPGU(N,H'
    $POM2=')'
    $POM3='$N,$H'
    $POM5='N,H'
  $ELSEIF(DEC='S')
    $POM1='UXD$(LET)GU(N,H,IH'
    $POM2=')'
    $POM3='$N,$H,$IH'
    $POM5='N,H,IH'
    $ADD(INTEGER,'\$IH($NF)')
  $ELSEIF(DEC='B')
    $HELP
      TYPE OF DECOMPOSITION
        1 - BUNCH-PARLETT DECOMPOSITION WITH NUMERICAL PERMUTATIONS
        2 - BUNCH-KAUFMAN DECOMPOSITION WITH NUMERICAL PERMUTATIONS
        3 - BUNCH PARLETT DECOMPOSITION WITH TWO LEVEL INDICES
    $CHECK(MOS2,1,'1\2\3',2)
    $IF(MOS2<3)
      $IQ='IQ'
      $POM1='UXDLBU(N,H,IH'
      $POM2=',IQ)'
      $POM3='$N,$H,$IH'
      $POM5='N,H,IH'
      $ADD(INTEGER,'\$IH($NF)\$IQ($NF)')
    $ELSE
      $POM1='UXDSBU(N,H,IH'
      $POM2=')'
      $POM3='$N,$H,$IH'
      $POM5='N,H,IH'
      $ADD(INTEGER,'\$IH($NF)')
    $ENDIF
 $ENDIF
  $ADD(POM3,',$S,$XO,$GO,$XS,$GS,$XP,$GP,$SO')
  $ADD(POM5,',S,XO,GO,XS,GS,XP,GP,SO')
  $IF(MET1=3)
    $ADD(POM3,',PAR1,PAR2')
    $ADD(POM5,',PAR1,PAR2')
  $ENDIF
  $ADD(POM3,',ETA2,ETA9,MET')
  $ADD(POM5,',ETA2,ETA9,MET')
  $IF(DEC='B')
    $IF(MOS2<3)
      $ADD(POM3,',MOS2')
      $ADD(POM5,',MOS2')
    $ENDIF
  $ENDIF
  $NUMSUB=''
  $IF(NMET>1) $NUMSUB='_$NMET'
  CALL UUDL$(DEC)1$(NUMSUB)($POM3)
  $ADD(SUBROUTINES)
*     ----------------------------------------
*     GENERAL CLASS OF VARIABLE METRIC UPDATES
*     TEMPLATE : UUDLG1
*     ----------------------------------------
  SUBROUTINE UUDL$(DEC)1$(NUMSUB)($POM5)
  $$INCLUDE('UMCOMM')
  INTEGER N,MET
  $$IF(DEC='B')
    $$IF(MOS2<3)
      INTEGER IQ(N),MOS2
    $$ENDIF
  $$ENDIF
  $$IF(DEC='S') INTEGER IH(N)
  $$IF(DEC='B') INTEGER IH(N)
  $$FLOAT H(N*(N+1)/2),S(N),XO(N),GO(N),XS(N),GS(N),XP(N),GP(N)&
,SO(N),ETA2,ETA9
  $$IF($MET1=3) $$FLOAT PAR1,PAR2
  $$FLOAT BB,CC
  $$FLOAT UXVDOT
  $$IF (DEC='G') $$FLOAT UXDPGP
  $$IF (DEC='S') $$FLOAT UXDPGP
  $$IF (DEC='B')
    $$IF(MOS2<3)
      $$FLOAT UXDLBP
    $$ELSE
      $$FLOAT UXDSBP
    $$ENDIF
  $$ENDIF
  $$FLOAT DEN,POM,A,B,C,GAM,DEL,TAU,SIG,EPS
  $$IF(DEC<>'B') $$FLOAT DIS
  $$IF($MET>8)
    $$FLOAT POM1,POM2
  $$ENDIF
  INTEGER INSW
  LOGICAL L1,L3
  $$IF($MET1=3) LOGICAL L2
  SAVE AA
  SAVE INSW
  EXTERNAL UNFUN1
  IF (MET.LE.0) GO TO 22
  CALL UOU1D1(N,XO,GO)
  $$IF(DEC='G')
    $$I=1
    IF (IDECF.EQ.0) THEN
    DEN=ETA2
    CALL UXDPGF(N,H,INF,DEN,DIS)
  $$ELSEIF(DEC='S')
    $$I=4
    IF (IDECF.EQ.0) THEN
    DEN=ETA2
    CALL UXD$$(LET)GF(N,H,IH,S,INF,DEN,DIS$$ART
  $$ELSEIF(DEC='B')
    $$I=3
    IF (IDECF.EQ.0) THEN
    DEN=ETA2
    $$IF(MOS2<3)
      CALL UXDLBF(N,H,IH,INF,DEN,MOS2)
    $$ELSE
      CALL UXDSBF(N,H,IH,INF,DEN)
    $$ENDIF
  $$ENDIF
  NDECF=NDECF+1
  IDECF=$$I
  ELSE IF (IDECF.NE.$$I) THEN
  ITERH=-1
  TUXX='BAD DEC$$I'
  CALL UOERR1('UUDB$(DEC)1',1)
  GO TO 22
  ENDIF
  L1=$MET1.GE.3.OR.$MET1.EQ.2.AND.NIT.EQ.KIT
  L3=.NOT.L1
*
*    COMPUTATION OF THE PARAMETERS A, B, C
*
  IF (L1) THEN
  CALL UXVCOP(N,GO,S)
  $$IF(DEC='G')
    CALL UXDPGB(N,H,S,1)
    A=UXDPGP(N,H,S,S)
  $$ELSEIF(DEC='S')
    CALL UXD$$(LET)GB(N,H,IH,S,1)
    A=UXDPGP(N,H,S,S)
  $$ELSEIF(DEC='B')
    $$IF(MOS2<3)
      CALL UXDLBB(N,H,IH,S,1)
      A=UXDLBP(N,H,IH,S)
    $$ELSE
      CALL UXDSBB(N,H,IH,S,1)
      A=UXDSBP(N,H,IH,S,S)
    $$ENDIF  
  $$ENDIF
  IF (A.LE.ZERO) THEN
  ITERH=1
  TUXX='A - NEG.'
  GO TO 22
  ENDIF
  B=UXVDOT(N,XO,GO)
  IF (B.LE.ZERO) THEN
  ITERH=2
  TUXX='B - NEG.'
  GO TO 22
  ENDIF
  CALL UXVCOP(N,XO,S)
  $$IF(DEC='G')
    CALL UXDPGM(N,H,S,0)
  $$ELSEIF(DEC='S')
    CALL UXD$$(LET)GM(N,H,IH,S,0)
  $$ELSEIF(DEC='B')
    $$IF(MOS2<3)
      CALL UXDLBM(N,H,IH,S,0)
    $$ELSE
      CALL UXDSBM(N,H,IH,S,0)
    $$ENDIF
  $$ENDIF
  C=UXVDOT(N,XO,S)
  IF (C.LE.ZERO) THEN
  ITERH=3
  TUXX='C - NEG.'
  GO TO 22
  ENDIF
  BB=B
  CC=C
*
*     DETERMINATION OF THE PARAMETER GAM (SELF SCALING)
*
  GAM=SQRT(C/A)
  $$IF($MET1=3)
    IF (NIT.NE.KIT) THEN
    L2=PAR2.LE.ZERO
    L3=L2.AND.ABS(PAR1).LE.$CON3
    L3=L3.OR.(.NOT.L2.AND.GAM.GT.ONE)
    L3=L3.OR.(L2.AND.PAR1.LT.ZERO.AND.GAM.GT.ONE)
    L3=L3.OR.(L2.AND.PAR1.GT.ZERO.AND.GAM.LT.ONE)
    L3=L3.OR.GAM.LT.$CON6
    L3=L3.OR.GAM.GT.$CON7
    ENDIF
  $$ELSEIF($MET1=4)
    IF (NIT.NE.KIT) THEN
    L3=GAM.LT.$CON6.OR.GAM.GT.$CON2
    ENDIF
  $$ENDIF
  IF (L3) GAM=ONE
  IF (GAM.NE.ONE) THEN
  $$IF(DEC='G')
    CALL UXDPGS(N,H,ONE/GAM)
  $$ELSEIF(DEC='S')
    CALL UXDPGS(N,H,ONE/GAM)
  $$ELSEIF(DEC='B')
    $$IF(MOS2<3)
      CALL UXDLBS(N,H,IH,ONE/GAM)
    $$ELSE
      CALL UXDSBS(N,H,IH,ONE/GAM)
    $$ENDIF
  $$ENDIF
  NSCL=NSCL+1
  ENDIF
  ENDIF
*
*     DETERMINATION OF THE PARAMETERS GAM, DEL, TAU, SIG, EPS
*
  CALL UXVCOP(N,XO,S)
  $$IF(DEC='G')
    CALL UXDPGM(N,H,S,0)
  $$ELSEIF(DEC='S')
    CALL UXD$$(LET)GM(N,H,IH,S,0)
  $$ELSEIF(DEC='B')
    $$IF(MOS2<3)
      CALL UXDLBM(N,H,IH,S,0)
    $$ELSE
      CALL UXDSBM(N,H,IH,S,0)
    $$ENDIF
  $$ENDIF
  IF (NIT.EQ.KIT) THEN
  INSW=0
  MODE=0
  CALL UXVCOP(N,S,XP)
  ELSE
  $$IF($MET3>1)
    MODE=1
    TAU=-UXVDOT(N,XO,SO)
    CALL UXVLIN(N,AA,GO,TAU,SO,XP)
  $$ENDIF
  ENDIF
  CALL UXVDIF(N,GO,S,GP)
  CALL UXVCOP(N,GP,GS)
  $$IF(DEC='G')
    CALL UXDPGB(N,H,GS,1)
    TAU=UXDPGP(N,H,GS,GS)
  $$ELSEIF(DEC='S')
    CALL UXD$$(LET)GB(N,H,IH,GS,1)
    TAU=UXDPGP(N,H,GS,GS)
  $$ELSEIF(DEC='B')
    $$IF(MOS2<3)
      CALL UXDLBB(N,H,IH,GS,1)
      TAU=UXDLBP(N,H,IH,GS)
    $$ELSE
      CALL UXDSBB(N,H,IH,GS,1)
      TAU=UXDSBP(N,H,IH,GS,GS)
    $$ENDIF  
  $$ENDIF
  IF (TAU.LE.ZERO) THEN
  ITERH=5
  TUXX='TAU-NEG.'
  GO TO 22
  ENDIF
10 CONTINUE
  CALL UXVCOP(N,XP,XS)
  $$IF(DEC='G')
    CALL UXDPGB(N,H,XS,1)
    EPS=UXDPGP(N,H,XS,XS)
  $$ELSEIF(DEC='S')
    CALL UXD$$(LET)GB(N,H,IH,XS,1)
    EPS=UXDPGP(N,H,XS,XS)
  $$ELSEIF(DEC='B')
    $$IF(MOS2<3)
      CALL UXDLBB(N,H,IH,XS,1)
      EPS=UXDLBP(N,H,IH,XS)
    $$ELSE
      CALL UXDSBB(N,H,IH,XS,1)
      EPS=UXDSBP(N,H,IH,XS,XS)
    $$ENDIF  
  $$ENDIF
  IF (EPS.LE.ZERO) THEN
  ITERH=7
  TUXX='EPS-NEG.'
  GO TO 22
  ENDIF
  SIG=SQRT(TAU/EPS)
  CALL UXVSCL(N,SIG,XP,XP)
  EPS=TAU
  GAM=UXVDOT(N,XP,XO)
  DEL=UXVDOT(N,GP,XO)
  IF (DEL.EQ.ZERO) GO TO 21
  SIG=SIG*UXDPGP(N,H,XS,GS)
  GAM=GAM/TAU
  DEL=DEL/TAU
  SIG=SIG/TAU
  BET=DEL+ONE
  DEN=ONE-SIG**2
  IF (DEN.LE.$CON5) THEN
  IF (INSW.EQ.0) THEN
  INSW=1
  GO TO 22
  ELSE
  INSW=0
  GO TO 21
  ENDIF
  ELSE
  INSW=0
  ENDIF
  DEN=DEL*DEN
  B=BET*DEN
  C=DEL*DEN
  D=(DEL*SIG-GAM)**2
  DEN=D-B
  B=B+D
  C=C+D
  IF (B.LE.ZERO) GO TO 21
  $$U17=0
  $$IF($MET=1)
    $$U17=1
    NUPD=NUPD+1
  $$ELSEIF($MET=2)
*
*     DFP UPDATE
*
    POM=D/(B*B)
    TUXX='DFP     '
    NUPD=NUPD+1
  $$ELSEIF($MET=3)
*
*     HOSHINO UPDATE
*
    POM=TWO*D/(B*(B+C))
    TUXX='HOSHINO '
    NUPD=NUPD+1
  $$ELSEIF($MET=4)
*
*     SAFEGUARDED RANK ONE UPDATE
*
    $$U17=1
    IF (BET*DEL.GT.ZERO) THEN
    POM=ZERO
    TUXX='RANK ONE'
    NUPD=NUPD+1
    GO TO 18
    ENDIF
  $$ELSEIF($MET=5)
*
*     OPTIMALLY CONDITIONED UPDATE
*
    POM=MAX(ZERO,DEN/(B*C))
    TUXX='DAVIDON '
    NUPD=NUPD+1
  $$ELSEIF($MET=6)
*
*     OREN UPDATE
*
    POM=ONE/B
    TUXX='OREN    '
    NUPD=NUPD+1
  $$ENDIF
  $$IF(U17>0)
17 CONTINUE
*
*     BFGS UPDATE
*
    POM=D/(B*C)
    TUXX='BFGS    '
  $$ENDIF
18 CONTINUE
*
*     GENERAL UPDATE
*
  IF (POM.LT.ZERO.OR.POM.GT.$CON4) THEN
  IF (BET*DEL.GT.ZERO) THEN
  POM=ZERO
  ELSE IF (MODE.EQ.0) THEN
  GO TO 21
  ELSE
  MODE=0
  CALL UXVCOP(N,S,XP)
  GO TO 10
  ENDIF
  ENDIF
  MODE=1
  CALL UXVSCL(N,DEL,XP,XP)
  CALL UXVDIR(N,-GAM,GP,XP,XP)
  DEL=DEL*TAU
  IF (DEL.EQ.ZERO) THEN
  GO TO 21
  ELSE IF (DEL.GT.ZERO) THEN
  CALL $POM1, ONE/DEL,GP,XS$POM2
  CALL $POM1,-POM/DEL,XP,XS$POM2
  ELSE
  CALL $POM1,-POM/DEL,XP,XS$POM2
  CALL $POM1, ONE/DEL,GP,XS$POM2
  ENDIF
  ITERH=0
  GO TO 22
21 CONTINUE
  C=CC
  B=BB
  IF (B.LE.$CON5*C) THEN
  ITERH=2
  TUXX='B - ZER.'
  GO TO 22
  ENDIF
*
*     BFGS UPDATE
*
  POM=ZERO
  CALL $POM1,ONE/B,GO,XO$POM2
  CALL $POM1,-ONE/C,S,XO$POM2
  TUXX='BFGS VM '
  ITERH=0
22 CONTINUE
   AA=B
   CALL UXVCOP(N,GO,SO)
   CALL UOU1D2(N,H,S,BET,DEL,PAR,TAU,SIG,EPS,POM,ETA9)
  RETURN
  END
  $ENDADD
  $ADD(INIT)
    NUXX='UUDL$(DEC)1'
  $ENDADD
  $EXIT
