$INTERFACE UUDLI1                                             12/12/01
$REM LU

  $CON0='0.1$P 0'
  $CON1='1.0$P-3'
  $CON2='2.0$P 0'
  $CON3='0.2$P 0'
  $CON4='1.0$P-2'
  $CON5='5.0$P-8'
  $CON6='1.0$P-4'
  $CON7='1.0$P-6'
  $GAML='1.0$P 0'
  $GAMU='6.0$P 0'
  $IF($DEF(MOS5))
  $ELSE
    $MOS5=0
  $ENDIF
  $HELP
    METHOD OF UPDATE OF HESSIAN MATRIX:
      1 - BFGS UPDATE
      2 - DFP UPDATE
      3 - HOSHINO UPDATE
      4 - SAFEGUARDED RANK ONE UPDATE
      5 - OPTIMALLY CONDITIONED UPDATE
      6 - OREN UPDATE
  $CHECK(MET,1,'1\2\3\4\5\6',3)
  $HELP
    SELECTION OF SELF SCALING:
      ABS(MET1)=1 - SELF SCALING SUPPRESSED
      ABS(MET1)=2 - INITIAL SELF SCALING
      ABS(MET1)=3 - CONTROLLED SELF SCALING
      ABS(MET1)=4 - SIMPLIFIED CONTROLLED SELF SCALING
      ABS(MET1)=5 - SELF SCALING IN EACH ITERATION
           MET1>0 - BASIC INITIAL SELF SCALING
           MET1<0 - MODIFIED INITIAL SELF SCALING
  $CHECK(MET1,3,'-5\-4\-3\-2\-1\1\2\3\4\5',4)
  $NET1=MET1
  $IF(NET1=-1) $NET1=1
  $IF(NET1=-2) $NET1=2
  $IF(NET1=-3) $NET1=3
  $IF(NET1=-4) $NET1=4
  $IF(NET1=-5) $NET1=5
  $IF(NET1= 3) $GAML='0.6$P 0'
  $HELP
    METHOD CORRECTION:
      1 - BFGS SCALING
      2 - DFP SCALING
      3 - GEOMETRIC MEAN
  $CHECK(MET4,3,'1\2\3',4)
  $SNORM=0
  $N='N'
  $GS='GS'
  $ADD(REAL,'\$H($NF*($NF+1)/2)\$GN($NF)\$SN($NF)\$XO($NF)\$GO($NF)&
  \$XP($NF)\$GP($NF)\$XS($NF)\$GS($NF)')
  $POM4='($N,$H,$GN,$S,$XO,$GO,$XP,$GP,$XS,$GS,R,PO'
  $POM6='(N,H,G,S,XO,GO,XP,GP,XS,GS,R,PO'
  $IF(NET1=3)
    $ADD(POM4,',PAR1,PAR2')
    $ADD(POM6,',PAR1,PAR2')
  $ENDIF
  $IF(MOS5=0)
    $ADD(POM4,',$MET)')
    $ADD(POM6,',MET)')
  $ELSE
    $ADD(REAL,'\BET\GAM\ETA')
    $ADD(POM4,',MET,BET,GAM,ETA)')
    $ADD(POM6,',MET,BET,PAR,ETA)')
  $ENDIF
  $NUMSUB=''
  $IF(NMET>1) $NUMSUB='_$NMET'
  CALL UUDLI1$(NUMSUB)$POM4
  $ADD(SUBROUTINES)
*     ----------------------------------------
*     BROYDEN CLASS OF VARIABLE METRIC UPDATES
*     TEMPLATE : UUDLI1
*     ----------------------------------------
  SUBROUTINE UUDLI1$(NUMSUB)$POM6
  $$INCLUDE('UMCOMM')
  INTEGER N,MET
  $$FLOAT H(N*(N+1)/2),G(N),S(N),XO(N),GO(N),XP(N),GP(N),XS(N),GS(N)&
  ,R,PO
  $$IF($NET1=3) $$FLOAT PAR1,PAR2
  $$IF($SNORM=1) $$FLOAT SNORM
  $$FLOAT UXVDOT
  $$FLOAT PAR,ETA,A,B,C,D,AA,BB,CC,DD,ALF,BET,GAM,DEL,EPS,SIG,TAU,DIS
  LOGICAL L1,L3
  $$IF ($NET1=3) LOGICAL L2
  IF (MET.LE.0) GO TO 22
  CALL UOU1D1(N,XO,GO)
  IF (IDECF.NE.9) THEN
  ITERH=-1
  TUXX='BAD DEC9'
  CALL UOERR1('UUDLI1',1)
  GO TO 22
  ENDIF
  IF (NIT.EQ.KIT) THEN
  CALL UXVCOP(N,GO,XP)
  CALL UXVNEG(N,GO,GP)
  ENDIF
  L1=ABS($MET1).GE.3.OR.ABS($MET1).EQ.2.AND.NIT.EQ.KIT
  L3=.NOT.L1
*
*     DETERMINATION OF THE PARAMETERS A, B, C
*
  B=UXVDOT(N,XO,GO)
  IF (B.LE.ZERO) THEN
  ITERH=2
  TUXX='B - NEG.'
  GO TO 22
  ENDIF
  CALL UXDSMM(N,H,GO,S)
  A=UXVDOT(N,GO,S)
  IF (A.LE.ZERO) THEN
  ITERH=1
  TUXX='A - NEG.'
  GO TO 22
  ENDIF
  IF (ITERD.NE.1) THEN
  C=ZERO
  ELSE
  IF (ITRAN.EQ.0) THEN
  CALL UXVDIF(N,GO,G,GS)
  ELSE
  CALL UXVNEG(N,G,GS)
  ENDIF
  CALL UXVSCL(N,R,GS,GS)
  C=-R*PO
  ENDIF
  IF (C.LE.ZERO) THEN
  ITERH=3
  TUXX='C - NEG.'
  GO TO 22
  ENDIF
  IF (L1) THEN
*
*     DETERMINATION OF THE PARAMETER GAM (SELF SCALING)
*
  $$IF(MET4=1)
    PAR=B/A
  $$ELSEIF(MET4=2)
    PAR=C/B
  $$ELSEIF(MET4=3)
    PAR=SQRT(C/A)
  $$ENDIF
  $$IF($MET1<0)
    IF (NIT.EQ.KIT) THEN
    PAR=MAX(PAR,$CON6)
    PAR=MIN(PAR,ONE/$CON6)
    ENDIF
  $$ENDIF
  $$IF($NET1=3)
    IF (NIT.NE.KIT) THEN
    L2=PAR2.LE.ZERO
    L3=L2.AND.ABS(PAR1).LE.$CON3
    L3=L3.OR.(.NOT.L2.AND.PAR.GT.ONE)
    L3=L3.OR.(L2.AND.PAR1.LT.ZERO.AND.PAR.GT.ONE)
    L3=L3.OR.(L2.AND.PAR1.GT.ZERO.AND.PAR.LT.ONE)
    L3=L3.OR.PAR.LT.$GAML
    L3=L3.OR.PAR.GT.$GAMU
    ENDIF
  $$ELSEIF($NET1=4)
    IF (NIT.NE.KIT) THEN
    L3=PAR.LT.$GAML.OR.PAR.GT.$GAMU
    ENDIF
  $$ENDIF
  ENDIF
  IF (L3) PAR=ONE
  IF (PAR.NE.ONE) THEN
*
*     SCALING
*
  CALL UXDSMS(N,H,PAR)
  CALL UXVSCL(N,PAR,S,S)
  CALL UXVSCL(N,ONE/PAR,GP,GP)
  CALL UXVSCL(N,ONE/PAR,GS,GS)
  A=A*PAR 
  C=C/PAR
  NSCL=NSCL+1
  ENDIF
*
*     DETERMINATION OF THE PARAMETERS ALF, BET, GAM, DEL, EPS, SIG, TAU
*
  TAU=A-TWO*B+C
  IF (TAU.LE.ZERO) THEN
  ITERH=5
  TUXX='TAU-NEG.'
  GO TO 22
  ENDIF
  EPS=-UXVDOT(N,XP,GP)
  IF (EPS.LE.ZERO) THEN
  ITERH=7
  TUXX='EPS-NEG.'
  GO TO 22
  ENDIF
  SIG=SQRT(TAU/EPS)
  CALL UXVSCL(N,SIG,XP,XP)
  CALL UXVSCL(N,SIG,GP,GP)
  ALF=UXVDOT(N,GO,XP)
  BET=B-A
  GAM=UXVDOT(N,XP,GS)
  DEL=C-B
  IF (BET.EQ.ZERO) GO TO 21
  SIG=GAM-ALF
  D=TAU**2-SIG**2
  DD=(BET*SIG-ALF*TAU)**2
  BB=BET*DEL*D+DD
  IF (BB.LE.ZERO) GO TO 21
  $$IF($MET=1)
*
*     DAVIDON BFGS UPDATE
*
    CC=DEL*DEL*D+DD
    D=CC/BB
    ETA=TAU*TAU*DD/BB**2
    TUXX='D - BFGS'
  $$ELSEIF($MET=2)
*
*     DAVIDON DFP UPDATE
*     
    AA=BET*BET*D+DD
    D=BB/AA
    ETA=TAU*TAU*DD/(AA*BB)
    TUXX='D - DFP '
  $$ELSEIF($MET=3)
*
*     DAVIDON HOSHINO UPDATE
*
    AA=BET*BET*D+DD
    CC=DEL*DEL*D+DD
    D=(BB+CC)/(AA+BB)
    ETA=TWO*TAU*TAU*DD/((AA+BB)*BB)
    TUXX='D - HOSH'
  $$ELSEIF($MET=4)
*
*     DAVIDON RANK ONE UPDATE
*
    IF (DEL*BET.LE.ZERO) THEN
    CC=DEL*DEL*D+DD
    D=CC/BB
    ETA=TAU*TAU*DD/BB**2
    TUXX='D - BFGS'
    ELSE
    D=DEL/BET
    ETA=ZERO
    TUXX='D - R1  '
    ENDIF
  $$ELSEIF($MET=5)
*
*     DAVIDON OLC UPDATE
*
    AA=BET*BET*D+DD
    CC=DEL*DEL*D+DD
    D=CC/AA
    ETA=TAU*TAU*(TWO*DD-BB)/(AA*BB)
    TUXX='D - OLC '
    IF (D.LE.ZERO) THEN
    D=CC/BB
    ETA=TAU*TAU*DD/BB**2
    TUXX='D - BFGS'
    ENDIF
  $$ELSEIF($MET=6)
*
*     DAVIDON OREN UPDATE
*
    D=ONE
    ETA=TAU*TAU/BB 
    TUXX='D - OREN'
  $$ENDIF
*
*     DETERMINATION OF THE NEW VECTORS XP, GP
*
  CALL UXVDIF(N,XO,S ,XS)
  CALL UXVDIF(N,GO,GS,GS)
  CALL UXVLIN(N,BET,XP,-ALF,XS,XP)
  CALL UXVLIN(N,DEL,GP,-GAM,GS,GP)
  CALL UXVSCL(N,ONE/D,GP,GP)
*
*     DAVIDON GENERAL UPDATE
*
  CALL UXDSMU(N,H,ONE/BET,XS)
  CALL UXDSMU(N,H,-ETA/BET,XP)
  ITERH=0
  NUPD=NUPD+1
  GO TO 22
21 CONTINUE 
*
*     BFGS UPDATE
*
  CALL UXVDIR(N,-ALF/B,GO,GP,GP)
  CALL UXVDIR(N, GAM/C,GS,GP,GP)
  ETA=ONE
  DIS=ONE+A/B
  CALL UXVDIR(N,-DIS,XO,S,GO)
  DIS=ONE/(B*DIS)
  CALL UXDSMU(N,H,DIS,GO)
  CALL UXDSMU(N,H,-DIS,S)
  TUXX='BFGS    '
  ITERH=0
22 CONTINUE
  CALL UOU1D2(N,H,S,ONE,GAM,ONE,A,B,C,ETA,ETA9)
  RETURN
  END
  $ENDADD
  $ADD(INIT)
    NUXX='UUDLI1'
  $ENDADD
  $EXIT

