$INTERFACE UUDRD2                                             97/12/01

  $N='N'
  $HELP
    SELECTION OF STRUCTURED UPDATE:
      1 - STANDARD STRUCTURED UPDATE
      2 - TOTALLY STRUCTURED UPDATE
  $CHECK(MET3,1,'1\2',4)
  $DEFAULT='1.0D-4'
  $IF(TYPE='L') $DEFAULT='2.0D-2'
  $HELP
    TOLERANCE FOR APPLICATION OF THE BFGS METHOD
  $CHECK(ETA5,DEFAULT,REAL,4)
  $ADD(REAL,'\$AG($NF*$NA)\$AGO($NF*$NA)')
$REM  $ADD(REAL\F\FO\ETA5')
$REM  $ADD(INTEGER,'\$N\NA')
  CALL UUDRD2($N,NA,$AG,$AGO,F,FO,ETA5,$MET3)
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UUDRD2                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INITIATION OF A DENSE RECTANGULAR MATRIX.
*
* PARAMETERS :
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  RU  AG(N*NA)  JACOBIAN MATRIX.
*  RU  BG(N*NA)  CORRECTION OF THE JACOBIAN MATRIX.
*  RI  F  CURRENT VALUE OF THE OBJECTIVE FUNCTION.
*  RI  FO  PREVIOUS VALUE OF THE OBJECTIVE FUNCTION.
*  RI  ETA5  TOLERANCE FOR A HYBRID METHOD.
*  II  MET3  TYPE OF STRUCTURED UPDATE. MET3=1-STANDARD STRUCTURED
*         UPDATE. MET3=2-TOTALLY STRUCTURED UPDATE.
*
* COMMON DATA :
*  II  IDECA  DECOMPOSITION INDICATOR. IDECA=0-NO DECOMPOSITION.
*  II  IREST  RESTART SPECIFICATION. IF IREST=0 DOES NOT HOLD THEN A
*         RESTART IS PERFORMED.
*  II  IDIR INDICATOR OF DIRECTION DETERMINATION. IDIR=0-BASIC
*         DETERMINATION. IDIR=1-DETERMINATION AFTER STEPSIZE
*         REDUCTION. IDIR=2-DETERMINATION AFTER STEPSIZE EXPANSION.
*  IU  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  TO  TUXX   TEXT INFORMATION ON THE RESTART USED.
*
* SUBPROGRAMS USED :
*  S   UXVDIR  VECTOR AUGMENTED BY THE SCALED VECTOR.
*  S   UXVSET  INITIATION OF A VECTOR.
*  S   UYSET3  DEFINITION OF THE RESTART VARIABLES.
*
      SUBROUTINE UUDRD2(N,NA,AG,BG,F,FO,ETA5,MET3)
      $INCLUDE('UMCOMM')
      INTEGER N,NA,MET3
      $FLOAT AG(N*NA),BG(N*NA),F,FO,ETA5
      INTEGER IUDSD
      SAVE IUDSD
      IF (IREST.LT.0) THEN
      CALL UXVSET(N*NA,ZERO,BG)
      TUXX='NEWTON  '
      IUDSD=1
      ELSE IF (IREST.EQ.0) THEN
      IF (IDIR.LE.0) THEN
      IF (FO-F.LE.ETA5*FO) THEN
      IF  (MET3.EQ.2) THEN
      CALL UXVDIR(N*NA,SQRT(F),BG,AG,AG)
      ELSE
      CALL UXVDIR(N*NA,ONE,BG,AG,AG)
      ENDIF
      LD=MIN(LD,1)
      IUDSD=0
      ENDIF
      ENDIF
      ELSEIF(IUDSD.EQ.0) THEN
      IF  (MET3.EQ.2) THEN
      CALL UXVDIR(N*NA,-SQRT(F),BG,AG,AG)
      ELSE
      CALL UXVDIR(N*NA,-ONE,BG,AG,AG)
      ENDIF
      CALL UXVSET(N*NA,ZERO,BG)
      TUXX='NEWTON  '
      IUDSD=1
      ELSE
      CALL UYSET3
      ENDIF
      IDECA=0
      RETURN
      END
