$INTERFACE UUDRQ1                                             97/12/01

  $HELP
    CHOICE OF THE INITIAL APPROXIMATION OF THE JACOBIAN
    MATRIX QR DECOMPOSITION:
      1 - UNIT INITIAL APPROXIMATION
      2 - RANDOM INITIAL APPROXIMATION
      3 - NUMERICAL INITIAL APPROXIMATION
  $CHECK(INITH,1,'1\2\3',4)
  $N='N'
  $IF(INITH>2)
    IF (IREST.LE.0) GO TO $20
    CALL UYPRO1('UUXX',1)
    ASSIGN $10 TO IMD
    $GO TO $LMD
$10 CONTINUE
    TUXX='NEWTON  '
    IDECA=0
    CALL UYSET3
    CALL UYEPI1(1)
$20 CONTINUE
  $ELSE
    $N='N'
    $ADD(REAL,'\$N\NA\$AG($NF*NA)\$H($M)')
$REM    $ADD(INTEGER,'\$N\NA')
    CALL UUDRQ1($N,NA,$AG,$H,$INITH)
  $ENDIF
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UUDRQ1                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INITIATION OF A DENSE ORTHOGONAL DECOMPOSITION.
*
* PARAMETERS :
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  RU  AG(NF*NA)  ORTHOGONAL MATRIX IN THE QR DECOMPOSITION.
*  RU  H(N*(N+1)/2)  UPPER TRIANGULAR MATRIX IN THE QR DECOMPOSITION.
*  II  INITH  CHOICE OF THE INITIAL APPROXIMATION OF THE HESSIAN
*         MATRIX. INITH=1-UNIT INITIAL APPROXIMATION.
*         INITH=2-RANDOM INITIAL APPROXIMATION.
*
* COMMON DATA :
*  RU  RAN  RANDOM NUMBER.
*  II  IDECA  DECOMPOSITION INDICATOR. IDECA=0-NO DECOMPOSITION.
*  II  IREST  RESTART SPECIFICATION. IF IREST=0 DOES NOT HOLD THEN A
*         RESTART IS PERFORMED.
*  IU  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  TO  TUXX   TEXT INFORMATION ON THE RESTART USED.
*
* SUBPROGRAMS USED :
*  S   UXDSMI  GENERATION OF THE UNIT UPPER TRIANGULAR MATRIX.
*  S   UXDRMI  GENERATION OF THE BLOCK UNIT RECTANGULAR MATRIX.
*  RF  UNRAN1  RANDOM NUMBER GENERATOR.
*  S   UYSET3  DEFINITION OF THE RESTART VARIABLES.
*
      SUBROUTINE UUDRQ1(N,NA,AG,H,INITH)
      $INCLUDE('UMCOMM')
      INTEGER N,NA,INITH
      $FLOAT AG(N*NA),H(N*(N+1)/2)
      INTEGER K
      $FLOAT POM,UNRAN1
      $FLOAT CON
      PARAMETER (CON=1.0$P 1)
      IF(IREST.LE.0) RETURN
      IF(INITH.LE.0) RETURN
      GOTO (1,2) INITH
    1 CALL UXDSMI(N,H)
      CALL UXDRMI(N,NA,AG)
      TUXX='UNIT    '
      GOTO 6
    2 POM=CON
      DO 7 K=1,N*NA
      AG(K)=POM*(TWO*UNRAN1(RAN)-ONE)
    7 CONTINUE
      TUXX='RANDOM  '
    6 IDECA=0
      IF (INITH.EQ.1) IDECA=-1
      CALL UYSET3
      RETURN
      END
