$INTERFACE UUDRV1                                             97/12/01

$REM  $ADD(REAL,'\R\FO\F\PO')
$REM  $ADD(INTEGER,'\IPOM1\IPOM2')
  CALL UUDRV1(R,FO,F,PO,IPOM1,IPOM2)
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UUDRV1                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DRIVER FOR HYBRID QUASI-NEWTON UPDATES.
*
* PARAMETERS:
*  RI  R  VALUE OF THE STEPSIZE PARAMETER.
*  RI  FO  PREVIOUS VALUE OF THE OBJECTIVE FUNCTION.
*  RI  F  CURRENT VALUE OF THE OBJECTIVE FUNCTION.
*  RI  PO  PREVIOUS VALUE OF THE DIRECTIONAL DERIVATIVE.
*  II  IPOM1  UPDATE SELECTION.
*  II  IPOM2  METHOD SELECTION.
*
* COMMON DATA :
*  II  IREST  RESTART SPECIFICATION. IF IREST=0 DOES NOT HOLD THEN A
*         RESTART IS PERFORMED.
*
      SUBROUTINE UUDRV1(R,FO,F,PO,IPOM1,IPOM2)
      $INCLUDE('UMCOMM')
      INTEGER IPOM1,IPOM2
      $FLOAT R,FO,F,PO
      $FLOAT POM
      $FLOAT CON1,CON2
      PARAMETER(CON1=1.0$P-1,CON2=1.0$P-2)
      POM=(FO-F)/FO
      GO TO (1,2,3,4) IPOM2
    1 IREST=1
      IF (NRED.LE.0) THEN
      IPOM1=2
      IREST=0
      ELSE
      IPOM1=0
      ENDIF
      GO TO 5
    2 IREST=1
      IF(POM.GE.CON2) THEN
      IPOM1=0
      ELSE IF (F-FO.LE.R*PO) THEN
      IPOM1=0
      ELSE
      IPOM1=1
      IREST=0
      ENDIF
      GO TO 5
    3 IREST=1
      IF (NRED.LE.0) THEN
      IF (IPOM1.NE.1) THEN
      IPOM1=2
      IREST=0
      ELSE
      IPOM1=0
      ENDIF
      ELSE IF (POM.GE.CON2) THEN
      IPOM1=0
      ELSE IF (IPOM1.NE.2) THEN
      IPOM1=1
      IREST=0
      ELSE
      IPOM1=0
      ENDIF
      GO TO 5
    4 IREST=1
      IPOM1=0
    5 CONTINUE
      RETURN
      END
