$INTERFACE UUDSD2                                             97/12/01

  $N='N'
  $HELP
    SELECTION OF STRUCTURED UPDATE:
      1 - STANDARD STRUCTURED UPDATE
      2 - TOTALLY STRUCTURED UPDATE
  $CHECK(MET3,1,'1\2',4)
  $DEFAULT='1.0D-4'
  $IF(TYPE='L') $DEFAULT='2.0D-2'
  $HELP
    TOLERANCE FOR APPLICATION OF THE BFGS METHOD
  $CHECK(ETA5,DEFAULT,REAL,4)
  $ADD(REAL,'\$H($NF*($NF+1)/2)\$HH($NF*($NF+1)/2)')
$REM  $ADD(REAL\F\FO\ETA5')
$REM  $ADD(INTEGER\$N)')
  CALL UUDSD2($N,$H,$HH,F,FO,ETA5,$MET3)
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UUDSD2                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INITIATION OF A DENSE SYMMETRIC POSITIVE DEFINITE MATRIX
*
* PARAMETERS :
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  RU  H(N*(N+1)/2)  POSITIVE DEFINITE APPROXIMATION OF THE HESSIAN
*         MATRIX
*  RU  B(N*(N+1)/2)  POSITIVE DEFINITE APPROXIMATION OF THE HESSIAN
*         MATRIX
*  RI  F  CURRENT VALUE OF THE OBJECTIVE FUNCTION.
*  RI  FO  PREVIOUS VALUE OF THE OBJECTIVE FUNCTION.
*  RI  ETA5  TOLERANCE FOR A HYBRID METHOD.
*  II  MET3  TYPE OF STRUCTURED UPDATE. MET3=1-STANDARD STRUCTURED
*         UPDATE. MET3=2-TOTALLY STRUCTURED UPDATE.
*
* COMMON DATA :
*  II  IDECF  DECOMPOSITION INDICATOR. IDECF=0-NO DECOMPOSITION.
*  II  IREST  RESTART SPECIFICATION. IF IREST=0 DOES NOT HOLD THEN A
*         RESTART IS PERFORMED.
*  II  IDIR INDICATOR OF DIRECTION DETERMINATION. IDIR=0-BASIC
*         DETERMINATION. IDIR=1-DETERMINATION AFTER STEPSIZE
*         REDUCTION. IDIR=2-DETERMINATION AFTER STEPSIZE EXPANSION.
*  IU  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  TO  TUXX   TEXT INFORMATION ON THE RESTART USED.
*
* SUBPROGRAMS USED :
*  S   UXDSMI  GENERATION OF THE UNIT MATRIX.
*  S   UXDSMA  DENSE SYMMETRIC MATRIX AUGMENTED
*              BY THE SCALED DENSE SYMMETRIC MATRIX.
*  S   UXDSMS  SCALING OF A DENSE SYMMETRIC MATRIX.
*  S   UYSET3  DEFINITION OF THE RESTART VARIABLES.
*
      SUBROUTINE UUDSD2(N,H,B,F,FO,ETA5,MET3)
      $INCLUDE('UMCOMM')
      INTEGER N,MET3
      $FLOAT H(N*(N+1)/2),B(N*(N+1)/2),F,FO,ETA5
      INTEGER IUDSD
      $FLOAT CON
      PARAMETER (CON=1.0$P 1)
      SAVE IUDSD
      IF (IREST.LT.0) THEN
      CALL UXDSMI(N,B)
*      IF (F.LT.ONE) CALL UXDSMS(N,B,SQRT(F))
      TUXX='NEWTON  '
      IUDSD=1
      ELSE IF (IREST.EQ.0) THEN
      IF (IDIR.LE.0) THEN
      IF (FO-F.LE.ETA5*FO) THEN
      IF (MET3.EQ.2) THEN
      CALL UXDSMA(N,SQRT(F),B,H,H)
      ELSE
      CALL UXDSMA(N,ONE,B,H,H)
      ENDIF
      LD=MIN(LD,1)
      IUDSD=0
      ENDIF
      ENDIF
      ELSEIF(IUDSD.EQ.0) THEN
      IF (MET3.EQ.2) THEN
      CALL UXDSMA(N,-SQRT(F),B,H,H)
      ELSE
      CALL UXDSMA(N,-ONE,B,H,H)
      ENDIF
      CALL UXDSMI(N,B)
*      IF (F.LT.ONE) CALL UXDSMS(N,B,SQRT(F))
      TUXX='NEWTON  '
      IUDSD=1
      ELSE
      CALL UYSET3
      ENDIF
      IDECF=0
      RETURN
      END
