$INTERFACE UUDSD3                                             97/12/01

  $HELP
    CHOICE OF THE INITIAL APPROXIMATION OF THE HESSIAN
    MATRIX:
      1 - UNIT INITIAL APPROXIMATION
      2 - RANDOM INITIAL APPROXIMATION
  $CHECK(INITH,1,'1\2',4)
  $N='N'
  $ADD(REAL,'\$H($NF*($NF+1)/2)\$HH($NF*($NF+1)/2)')
$REM  $ADD(INTEGER\$N\IPOM1\IPOM2)')
  CALL UUDSD3($N,$H,$HH,IPOM1,IPOM2,$INITH)
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UUDSD3                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INITIATION OF A DENSE SYMMETRIC POSITIVE DEFINITE MATRIX
*
* PARAMETERS :
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  RU  H(N*(N+1)/2)  FACTORIZATION H=L*D*TRANS(L) OF A POSITIVE
*         SEMIDEFINITE HESSIAN MATRIX.
*  RU  B(N*(N+1)/2)  FACTORIZATION B=L*D*TRANS(L) OF A POSITIVE
*         DEFINITE APPROXIMATION OF THE HESSIAN MATRIX.
*  IU  IPOM1  METHOD INDICATOR.
*  IU  IPOM2  INDICATOR FOR SCALING.
*  II  INITH  CHOICE OF THE INITIAL APPROXIMATION OF THE HESSIAN
*         MATRIX. INITH=1-UNIT INITIAL APPROXIMATION.
*         INITH=2-RANDOM INITIAL APPROXIMATION.
*
* COMMON DATA :
*  RU  RAN  RANDOM NUMBER.
*  II  IDECF  DECOMPOSITION INDICATOR. IDECF=0-NO DECOMPOSITION.
*  II  IREST  RESTART SPECIFICATION. IF IREST=0 DOES NOT HOLD THEN A
*         RESTART IS PERFORMED.
*  II  ITERS  TERMINATION INDICATOR. ITERS=0-ZERO STEP.
*  IU  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*  TO  TUXX   TEXT INFORMATION ON THE RESTART USED.
*
* SUBPROGRAMS USED :
*  S   UXDSMI  GENERATION OF THE UNIT MATRIX.
*  S   UXDSDO  INITIATION OF A DIAGONAL MATRIX.
*  S   UUDSMC  COPYING OF A DENSE SYMMETRIC MATRIX.
*  RF  UNRAN1  RANDOM NUMBER GENERATOR.
*  S   UYSET3  DEFINITION OF THE RESTART VARIABLES.
*
      SUBROUTINE UUDSD3(N,H,B,IPOM1,IPOM2,INITH)
      $INCLUDE('UMCOMM')
      INTEGER N,IPOM1,IPOM2,INITH
      $FLOAT H(N*(N+1)/2),B(N*(N+1)/2)
      INTEGER K,KDECF
      $FLOAT POM,UNRAN1
      $FLOAT CON
      PARAMETER (CON=1.0$P 1)
      IF(IREST.EQ.0.OR.IREST.GT.0.AND.IPOM1.EQ.0) THEN
      ELSEIF(INITH.EQ.1) THEN
      CALL UXDSMI(N,B)
      TUXX='UNIT    '
      IPOM2= 1
      KDECF=-1
      ELSEIF(INITH.EQ.2) THEN
      POM=(CON-ONE)/(CON+ONE)
      POM=POM/$DBLE(N+1)
      DO 1 K=1,N*(N+1)/2
      B(K)=POM*(TWO*UNRAN1(RAN)-ONE)
    1 CONTINUE
      CALL UXDSDO(N,ONE,B)
      TUXX='RANDOM  '
      IPOM2= 1
      KDECF= 0
      ENDIF
      IF (IPOM1.EQ.1) THEN
      IF (ITERS.GT.0.OR.IREST.GT.0) THEN
      CALL UXDSMC(N,B,H)
      LD=MIN(LD,1)
      IF(IPOM2.EQ.1) IDECF=KDECF
      IF(IREST.GT.0) CALL UYSET3
      ENDIF
      ELSE
      IF(IREST.LE.0) THEN
      TUXX='NEWTON  '
      ELSE
      IPOM1= 1
      CALL UXDSMC(N,B,H)
      LD=MIN(LD,1)
      IF(IPOM2.EQ.1) IDECF=KDECF
      ENDIF
      ENDIF
      RETURN
      END
