$INTERFACE UULBI1                                             98/12/01

  $HELP
    SELECTION OF SELF SCALING:
      1 - SELF SCALING SUPPRESSED
      2 - INITIAL SELF SCALING
  $CHECK(MET1,2,'1\2',4)
  $HELP
    REALIZATION FORM:
      1 - STRATEGY THAT USES 6*MF*NF OPERATIONS
      2 - STRATEGY THAT USES 4*MF*NF OPERATIONS
  $CHECK(MET5,2,'1\2',4)
  $V1='V1'
  $V2='V2'
  $IF(MET5=1)
    $V1=U1
    $V2=U2
  $ENDIF
  $ADD(INTEGER,'\IHR($MF)')
  $ADD(REAL,'\$XM($NF*$MF)\$GM($NF*$MF)\$XR($MF*($MF+1)/2)&
  \$GR($MF*($MF+1)/2)\$HR($MF*($MF+1)/2)\$XO($NF)\$GO($NF)\$U1($MF)&
  \$U2($MF)\$V1($MF)\$V2($MF)')
$REM  $ADD(REAL,'\PAR3')
$REM  $ADD(INTEGER,'\NF\MF\INF')
  CALL UULBI1(NF,MF,MX,$XM,$GM,$XR,$GR,$HR,$IHR,$XO,$G,$GO,$U1,$U2,$V1&
,$V2,PAR3,ETA0,INF,MET,MET1,MET5)
  $ADD(INIT)
    NUXX='UULBI1'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UULBI1                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* LIMITED STORAGE VARIABLE METRIC UPDATE.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  MF  MAXIMUM NUMBER OF VARIABLE METRIC STEPS.
*  IU  MM  ACTUAL NUMBER OF VARIABLE METRIC STEPS.
*  RU  XM(NF*MF)  SET OF VECTOR OF VARIABLES DIFFERENCES.
*  RU  GM(NF*MF)  SET OF GRADIENT DIFFERENCES.
*  RU  XR(MF*(MF+1)/2)  MATRIX TRANS(XM)*XM STORED IN PACKED FORM.
*  RU  GR(MF*(MF+1)/2)  MATRIX TRANS(GM)*XM STORED IN PACKED FORM.
*  RO  HR(MF*(MF+1)/2)  MATRIX IN UPDATE REPRESENTATION.
*  RA  IHR(MF*(MF+1)/2)  AUXILIARY ARRAY.
*  RU  XO(NF)  VECTOR OF VARIABLES DIFFERENCE.
*  RI  GO(NF)  GRADIENT DIFFERENCE.
*  RO  PAR3  SCALING PARAMETER.
*  RI  ETA0  MACHINE PRECISION.
*  IU  INF  DECOMPOSITION INDICATOR. INF=0 IF THE MATRIX IS POSITIVE
*         DEFINITE.
*  II  MET  METHOD SELECTION. MET=1-BFGS UPDATE. MET=4-RANK ONE UPDATE.
*  II  MET1  SCALING OPTION. MET1=1-NO SCALING. MET1=2-PRELIMINARY
*         SCALING.
*
* COMMON DATA :
*  IO  ITERH  TERMINATION INDICATOR. ITERH<0-BAD DECOMPOSITION.
*         ITERH=0-SUCCESSFUL UPDATE. ITERH>0-NONPOSITIVE PARAMETERS.
*  II  NIT  ACTUAL NUMBER OF ITERATIONS.
*  II  KIT  NUMBER OF THE ITERATION AFTER LAST RESTART.
*  TO  TUXX  TEXT INFORMATION ON THE CORRECTION USED.
*
* SUBPROGRAMS USED :
*  S   UXDPGT  TRANSFORMATION OF THE GILL-MURRAY DECOMPOSITION.
*  S   UXDSDP  GENERALIZED DOT PRODUCT OF TWO VECTORS.
*  RF  UXVDOT  DOT PRODUCT OF VECTORS.
*  S   UXVSCL  SCALING OF A VECTOR.
*  S   UOERR1  ERROR MESAGES.
*
* METHOD :
* LIMITED STORAGE VARIABLE METRIC METHODS.
*
      SUBROUTINE UULBI1(NF,MF,MM,XM,GM,XR,GR,HR,IHR,XO,G,GO,U1,U2,V1,
     & V2,PAR3,ETA0,INF,MET,MET1,MET5)
      $INCLUDE('UMCOMM')
      INTEGER NF,MF,MM,IHR(MF),INF,MET,MET1,MET5
      $FLOAT XM(NF*MF),GM(NF*MF),XR(MF*(MF+1)/2),GR(MF*(MF+1)/2),
     & HR(MF*(MF+1)/2),XO(NF),GO(NF),G(NF),U1(MF),U2(MF),V1(MF),V2(MF),
     & PAR3,ETA0
      INTEGER I,II,I1,I2,J1,J2
      $FLOAT UXVDOT
      $FLOAT A,B,ALF
      ITERH=0
      A=UXVDOT(NF,GO,GO)
      B=UXVDOT(NF,XO,GO)
      IF (MET1.EQ.1) THEN
      PAR3=ONE
      ELSE
      PAR3=B/A
      ENDIF
      IF (B.LE.ZERO) THEN
      ITERH=2
      TUXX='B - NEG.'
      CALL UOERR1('UULBI1',1)
      GO TO 6
      ENDIF
C      MM=MIN(NIT-KIT,MF)
      IF (MM.GE.MF) THEN
      I1=1
      J1=1
      DO 1 II=1,MM-1
      I2=I1+NF
      J2=J1+II
      CALL UXVCOP(NF,XM(I2),XM(I1))
      CALL UXVCOP(NF,GM(I2),GM(I1))
      CALL UXVCOP(II,XR(J2+1),XR(J1))
      CALL UXVCOP(II,GR(J2+1),GR(J1))
      I1=I2
      J1=J2
      IF (MET5.NE.1) THEN
      V1(II)=V1(II+1)
      V2(II)=V2(II+1)
      ENDIF
    1 CONTINUE
      J1=J1-1
      ELSE
      I1=MM*NF+1
      J1=MM*(MM+1)/2
      MM=MM+1
      ENDIF
      CALL UXVCOP(NF,XO,XM(I1))
      CALL UXVCOP(NF,GO,GM(I1))
      IF (MET5.EQ.1) THEN
      CALL UXDRMM(NF,MM-1,XM,GO,XR(J1+1))
      CALL UXDRMM(NF,MM-1,GM,GO,GR(J1+1))
      ELSE
      CALL UXDRMM(NF,MM,XM,G,U1)
      CALL UXDRMM(NF,MM,GM,G,U2)
      CALL UXVDIF(MM-1,U1,V1,XR(J1+1))
      CALL UXVDIF(MM-1,U2,V2,GR(J1+1))
      ENDIF
      XR(J1+MM)=B
      GR(J1+MM)=A
      IF (MET.EQ.1) THEN
      CALL UXVSCL(J1+MM,PAR3,GR,HR)
      II=0
      DO 3 I=1,MM
      II=II+I
      HR(II)=HR(II)+XR(II)
    3 CONTINUE
      TUXX='BFGS    '
      ELSE
      CALL UXVDIR(J1+MM,-PAR3,GR,XR,HR)
      ALF=ETA0
      CALL UXDSBF(MM,HR,IHR,INF,ALF)
      TUXX='RANK ONE'
      ENDIF
      IF (MET5.NE.1) THEN
      CALL UXVCOP(MM,U1,V1)
      CALL UXVCOP(MM,U2,V2)
      ENDIF
      NUPD=NUPD+1
    6 CONTINUE
      RETURN
      END
