$INTERFACE UULCI1                                             97/12/01

  $BG='BG'
  $IBG='IBG'
  $JBG='JBG'
  CALL UULCI1(NF,MF,MMAX,$BG,$IBG,$JB,$IB,$XM,$GM,$IH,$XO,$AFO,$S)
  $ADD(REAL,'\$BG($MMAX)\$XM($NF*$MF)\$GM($MF)&
  \$XO($NF)\$AFO($NA)\$S(2*$NF)')
  $ADD(INTEGER,'\$IBG($MMAX+1)\$JB(15)\$IB(5)\$IH($MF)')
$REM  $ADD(INTEGER,'\NF\MF\MMAX')
  $ADD(INIT)
    NUXX='UULCI1'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UULCI1                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* LIMITED STORAGE INVERSE COLUMN UPDATE METHOD.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  MF  MAXIMUM NUMBER OF VARIABLE METRIC STEPS.
*  II  MMAX  SIZE OF AUXILIARY ARRAYS FOR COMPLETE LU DECOMPOSITION.
*  RA  XMEM(MMAX)  REAL AUXILIARY ARRAY FOR COMPLETE LU DECOMPOSITION.
*  IA  IMEM(MMAX)  INTEGER AUXILIARY ARRAY FOR COMPLETE LU DECOMPOSITION.
*  IO  PMEM(7,2)  STATUS OF AUXILIARY ARRAYS.
*  IO  LU(2,2)  POINTERS OF LU FACTOR IN AUXILIARY ARRAYS.
*  RU  XM(NF*MF)  SET OF VECTOR OF VARIABLES DIFFERENCES.
*  RU  GM(MF)  SET OF GRADIENT DIFFERENCES.
*  IU  IM(MF)  VECTOR OF INDICES.
*  RI  XO(NF)  VECTOR OF VARIABLES DIFFERENCE.
*  RI  AFO(NF)  GRADIENTS DIFFERENCE.
*  RA  S(NF)  AUXILIARY.
*
* COMMON DATA :
*  IU  IREST  RESTART INDICATOR.
*  IO  ITERH  TERMINATION INDICATOR. ITERH<0-BAD DECOMPOSITION.
*         ITERH=0-SUCCESSFUL UPDATE. ITERH>0-NONPOSITIVE PARAMETERS.
*  II  NIT  ACTUAL NUMBER OF ITERATIONS.
*  II  KIT  NUMBER OF THE ITERATION AFTER LAST RESTART.
*  TO  TUXX  TEXT INFORMATION ON THE CORRECTION USED.
*
* SUBPROGRAMS USED :
*  S   UXLIDM  MATRIX MULTIPLICATION FOR LIMITED STORAGE INVERSE
*         COLUMN UPDATE METHOD. COMPLETE LU DECOMPOSITION VARIANT.
*  S   UXVDIR  VECTOR AUGMENTED BY THE SCALED VECTOR.
*  RF  UXVMX1  L-INFINITY NORM OF A VECTOR.
*
* METHOD :
* INVERSE COLUMN UPDATE LIMITED STORAGE VARIABLE METRIC METHOD.
*
      SUBROUTINE UULCI1(NF,MF,MMAX,XMEM,IMEM,JMEM,LU,XM,GM,IM,XO,AFO,S)
      $INCLUDE('UMCOMM')
      INTEGER NF,MF,MMAX,IMEM(MMAX),JMEM(7,2),LU(2,2),IM(MF)
      $FLOAT XMEM(MMAX),XM(NF*MF),GM(MF),XO(NF),AFO(NF),S(2*NF)
      INTEGER II,MM
      $FLOAT TEMP,UXVMX1
      MM=MIN(NIT-KIT,MF)
      IF (MM.GE.MF) THEN
      IREST=1
      ELSE
      II=NF*MM+1
      CALL UXLIDM(NF,MM,MMAX,XMEM,IMEM,JMEM,LU,XM,GM,IM,AFO,XM(II),S)
      CALL UXVDIR(NF,-ONE,XM(II),XO,XM(II))
      MM=MM+1
      TEMP=UXVMX1(NF,AFO,II)
      IF (TEMP.LE.ZERO) THEN
      ITERH=2
      TUXX='ZERO DEN'
      CALL UOERR1('UULCI1',1)
      ELSE
      IM(MM)=II
      GM(MM)=AFO(II)
      TUXX='INV COL '
      NUPD=NUPD+1
      ITERH=0
      ENDIF
      ENDIF
      RETURN
      END
