$INTERFACE UULSP3                                             06/12/01

  $HR='HR'
  $ADD(REAL,'\$XM($NF*$MF)\$HR($MF)\$XO($NF)\$GO($NF)')
$REM  $ADD(INTEGER,'\NF\NN\MF')
$REM  $ADD(REAL,'\RHO\AP\B')
  CALL UULSP3(NF,NN,MF,$XM,$HR,$XO,$GO,RHO,AP,B)
  $ADD(INIT)
    NUXX='UULSP3'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UULSP3                ALL SYSTEMS                06/12/01
C PORTABILITY : ALL SYSTEMS
C 06/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* LIMITED STORAGE VARIABLE METRIC UPDATE.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES (NUMBER OF ROWS OF THE MATRIX XM).
*  IU  M  NUMBER OF COLUMNS OF THE MATRIX XM.
*  II  MF MAXIMUM NUMBER OF VARIABLE METRIC STEPS.
*  RU  XM(N*M)  RECTANGULAR MATRIX FOR THE PRODUCT FORM VM
*         METHOD (STORED COLUMNWISE): BAR(H)=XM*TRANS(XM).
*  RA  GR(M)  MATRIX TRANS(XM)*GO.
*  RU  XO(N)  VECTOR OF VARIABLES DIFFERENCE.
*  RU  GO(N)  GRADIENT DIFFERENCE.
*  RI  RHO  CORRECTION PARAMETER.
*  RO  A  OUTPUT PARAMETER BAR(A)=TRANS(GO)*BAR(H)*GO.
*  RO  B  OUTPUT PARAMETER B=TRANS(GO)*XO.
*
* SUBPROGRAMS USED :
*  S   UXDRMM  MULTIPLICATION OF A ROWWISE STORED DENSE RECTANGULAR
*         MATRIX BY A VECTOR.
*  S   UXDCMU  UPDATE OF A COLUMNWISE STORED DENSE RECTANGULAR MATRIX.
*         WITH CONTROLLING OF POSITIVE DEFINITENESS.
*  RF  UXVDOT  DOT PRODUCT OF VECTORS.
*  S   UXVSCL  SCALING OF A VECTOR.
*
* METHOD :
* SHIFTED BFGS METHOD IN THE PRODUCT FORM.
*
      SUBROUTINE UULSP3(N,M,MF,XM,GR,XO,GO,RHO,A,B)
      $INCLUDE('UMCOMM')
      INTEGER N,M,MF
      $FLOAT XM(N*MF),GR(MF),XO(N),GO(N),RHO,A,B
      $FLOAT GAM,PAR,UXVDOT
      IF (M.GE.MF) RETURN
      CALL UOU1D1(N,XO,GO)
      GAM=ONE
      PAR=RHO/GAM
      CALL UXDRMM(N,M,XM,GO,GR)
      A=UXVDOT(M,GR,GR)
C
C     BFGS-BASED SHIFTED BFGS UPDATE
C
      CALL UXDCMU(N,M,XM,-ONE/B,XO,GR)
      CALL UXVSCL(N,SQRT(PAR/B),XO,XM(N*M+1))
      TUXX='BFGS    '
      M=M+1
      IF (GAM.EQ.ONE) GO TO 2
C
C     SCALING
C
      CALL UXVSCL(N*M,SQRT(GAM),XM,XM)
      NSCL=NSCL+1
    2 CONTINUE
      NUPD=NUPD+1
      ITERH=0
C      CALL UOU1D3(N,H,S,RHO,GAM,PAR,A,B,C,POM,ETA9)
      RETURN
      END
