$INTERFACE UULVP5                                             08/12/01

  $XR='XR'
  $GR='GR'
  $ADD(REAL,'\$XM($NF*$MF)\$GM($NF*$MF)\$XR(3*$MF)\$GR(3*$MF)\$XO($NF)&
  \$GO($NF)\$XS($NF)\$GS(3*$NF)')
  $ADD(REAL,'\RHO')
$REM  $ADD(INTEGER,'\NF\NN\MF')
  CALL UULVP5(NF,NN,$XM,$GM,$XR,$GR,$XO,$GO,$S,$XS,$GS,R,PAR,ETA4)
  $ADD(INIT)
    NUXX='UULVP5'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UULVP5                ALL SYSTEMS                08/12/01
C PORTABILITY : ALL SYSTEMS
C 08/12/01 VL : ORIGINAL VERSION
*
* PURPOSE :
* LIMITED-STORAGE VARIABLE-METRIC PROJECTIVE BROYDEN CLASS UPDATE.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES (NUMBER OF ROWS OF XM, GM).
*  II  M  NUMBER OF COLUMNS OF XM, GM.
*  RU  XM(N*M)  RECTANGULAR VM MATRIX STORED COLUMNWISE,
*         H=DZETA*I-GM*TRANS(GM)+XM*TRANS(XM).
*  RU  GM(N*M)  RECTANGULAR VM MATRIX STORED COLUMNWISE.
*  RU  XR(M*3)  AUXILIARY VECTORS TRANS(XM)*GO, TRANS(XM)*H**(-1)*XO.
*  RU  GR(M*3)  AUXILIARY VECTORS TRANS(GM)*GO, TRANS(GM)*H**(-1)*XO.
*  RI  XO(N)  VECTOR OF VARIABLES DIFFERENCE.
*  RI  GO(N)  VECTOR OF GRADIENT DIFFERENCE.
*  RI  S(N)  AUXILIARY VECTOR.
*  RO  XS(N)  AUXILIARY VECTOR.
*  RO  GS(N*3)  AUXILIARY MATRIX.
*  RI  R  STEPSIZE PARAMETER.
*  RI  ZET  INPUT PARAMETER.
*  RI  ETA  BROYDEN PARAMETER.
*
* SUBPROGRAMS USED :
*  S   UXDCMM  RECTANGULAR MATRIX BY VECTOR MULTIPLICATION.
*
* METHOD :
*
      SUBROUTINE UULVP5(N,M,XM,GM,XR,GR,XO,GO,S,XS,GS,R,ZET,ETA)
      $INCLUDE('UMCOMM')
      INTEGER M,N,I,J,L
      REAL*8 XM(N*M),GM(N*M),XR(M*3),GR(M*3),XO(N),GO(N),S(N),XS(N),
     & GS(N*3),R,ZET,ETA
      REAL*8 A,AH,AP,ACP,AR,B,BP,BR,CP,CR,D,ALF,GAM,OM,P1,P2,P3,Q1,Q2,
     & RHO,W,W1,W2,UXVDOT
C
C     LM projection BC update: H=ZET*I+XM*TRANS(XM)-GM*TRANS(GM)
C
      B=UXVDOT(N,XO,GO)
      IF (B.LE.ZERO) THEN
      ITERH=2
      TUXX='B - NEG.'
      RETURN
      ENDIF
      AH=UXVDOT(N,GO,GO)
      CALL UXVSCL(N,R,S,S)
      CALL UXDRMM(N,M,XM,GO,XR)
      CALL UXDRMM(N,M,XM,S,XR(M+1))
      AP=UXVDOT(M,XR,XR)
      BP=UXVDOT(M,XR,XR(M+1))
      CP=UXVDOT(M,XR(M+1),XR(M+1))
      CALL UXDRMM(N,M,GM,GO,GR)
      CALL UXDRMM(N,M,GM,S,GR(M+1))
      CALL UXDCMM(N,M,GM,GR,XS)
      AR=UXVDOT(M,GR,GR)
      BR=UXVDOT(M,GR,GR(M+1))
      CR=UXVDOT(M,GR(M+1),GR(M+1))
      A=MAX(1.0D-10*ZET*AH,AP+ZET*AH-AR)
      ALF=-SQRT(CP/A)
      IF (AP+CP.GT.0.0$P 0) ALF=(-CP*(BP/AP)-AP*SQRT(CP/A))/(AP+CP)
      Q1=0.0$P 0
      Q2=0.0$P 0
      W1=0.0$P 0
      W2=0.0$P 0
      DO 2 J=1,M
        W=XR(J+M)+XR(J)*ALF
        Q1=Q1+W*W
        W1=W1+XR(J)*W
        XR(J+M+M)=W
C        W=GR(J+M)*(T*AR-BR)-GR(J)*(T*BR-CR)
        W=GR(J+M)*BR-GR(J)*CR
        Q2=Q2+W*W
        W2=W2+GR(J)*W
        GR(J+M+M)=W
    2 CONTINUE
      ACP=MAX(1.0D-10*ZET*AH,ZET*AH-AR+W2*W2/Q2)
      A=ACP+AP-W1*W1/Q1
      GAM=B/SQRT(ACP*MAX(A,ACP+CP))
      IF (GAM.LT.1D-3) GAM=B/ACP
      RHO=SQRT(ACP/(ZET*AH)*(1.0$P 0+SQRT(ZET)))
      CALL UXDCMM(N,M,XM,XR(M+M+1),GS)
      CALL UXDCMM(N,M,GM,GR(M+M+1),GS(N+1))
C
C     UPDATE  GM, XM, ZET
C
      DO 3 I=1,N
        XS(I)=ZET*GO(I)-XS(I)+GS(N+I)*W2/Q2
        GS(N+N+I)=XO(I)
    3 CONTINUE
      D=1.0$P 0
      OM=RHO/GAM+ACP/B
      IF (ETA+RHO/GAM*B/A*(1.0$P 0-ETA).GT.0.0$P 0.AND.
     &    ABS(ETA-1.0$P 0).GT.1.0$P-12) THEN
        D=ETA+RHO/GAM*B/A*(1.0$P 0-ETA)
        ALF=B/A*(ETA-1.0$P 0)/(ETA+SQRT(D))
        OM=RHO/GAM*ETA+ACP/B*D
        CALL UXDCMM(N,M,XM,XR,GO)
        DO 4 I=1,N
          GS(N+N+I)=XO(I)-ALF*(GO(I)-GS(I)*W1/Q1)
    4   CONTINUE
      ENDIF
      DO 6 I=1,N
        P1=XS(I)*SQRT(D/(OM*B*Q2))-GS(N+I)/Q2
        P2=GS(N+N+I)/B*SQRT(D)
        P3=(OM*GS(N+N+I)-XS(I)*SQRT(D))/SQRT(OM*B*Q1)-(GS(I)-W1*P2)/Q1
        L=I
        DO 5 J=1,M
          GM(L)=SQRT(GAM)*(GM(L)+P1*GR(J+M+M))
          XM(L)=SQRT(GAM)*(XM(L)-P2*XR(J)+P3*XR(J+M+M))
          L=L+N
    5   CONTINUE
    6 CONTINUE
      ZET=ZET*GAM
      TUXX='PROJ-2  '
      NUPD=NUPD+1
      NSCL=NSCL+1
      ITERH=0
      RETURN
      END

