* SUBROUTINE UUPOM1                ALL SYSTEMS                02/12/01
C PORTABILITY : ALL SYSTEMS
C 02/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF THE BROYDEN PARAMETER.
*
* PARAMETERS :
*  RI  A  INPUT PARAMETER.
*  RI  B  INPUT PARAMETER.
*  RI  PAR  NUMBER RHO/GAM.
*  RO  POM  BROYDEN PARAMETER.
*
* COMMON DATA :
*  II  NIT  ACTUAL NUMBER OF ITERATIONS.
*  II  KIT  NUMBER OF THE ITERATION AFTER LAST RESTART.
*  IU  NUPD  NUMBER OF UPDATES.
*  TO  TUXX  TEXT INFORMATION ON THE CORRECTION USED.
*
      SUBROUTINE UUPOM1(A,B,PAR,POM,MET)
      $INCLUDE('UMCOMM')
      INTEGER MET
      $FLOAT A,B,PAR,POM
      $FLOAT DEN,DIS
C
C     DETERMINATION OF THE BROYDEN PARAMETER POM=ETA
C
      GO TO (1,2,3,4,5) MET
C
C     BFGS UPDATE
C
    1 POM=ONE
      TUXX='BFGS    '
      NUPD=NUPD+1
      GO TO 20
C
C     DFP UPDATE
C
    2 POM=ZERO
      TUXX='DFP     '
      NUPD=NUPD+1
      GO TO 20
C
C     HOSHINO UPDATE
C
    3 DEN=PAR*B+A
      DIS=HALF*B
      POM=PAR*B/DEN
      TUXX='HOSHINO '
      NUPD=NUPD+1
      GO TO 20
C
C     SAFEGUARDED RANK ONE UPDATE
C
    4 DEN=PAR*B-A
      IF (DEN.LE.ZERO) THEN
      POM=ONE
      TUXX='BFGS    '
      GO TO 20
      ELSE
      POM=PAR*B/DEN
      TUXX='RANK ONE'
      NUPD=NUPD+1
      GO TO 20
      ENDIF
C
C     VARIATIONALLY DERIVED PRECONVEX UPDATE
C
    5 POM=TWO
      TUXX='VAR-2   '
   20 CONTINUE
      RETURN
      END
