* SUBROUTINE UURHO1                ALL SYSTEMS                02/12/01
C PORTABILITY : ALL SYSTEMS
C 02/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF THE NONQUADRATIC CORRECTION PARAMETER.
*
* PARAMETERS :
*  RI  F  NEW FUNCTION VALUE.
*  RI  FO  OLD FUNCTION VALUE.
*  RI  P  NEW DIRECTIONAL DERIVATIVE (MULTIPLIED BY R)
*  RI  PO  OLD DIRECTIONAL DERIVATIVE (MULTIPLIED BY R)
*  RI  B  INPUT PARAMETER.
*  RO  RHO  NONQUADRATIC CORRECTION PARAMETER.
*  II  MET2  CORRECTION OPTION. MET1=1-NO CORRECTION.
*
      SUBROUTINE UURHO1(F,FO,P,PO,B,RHO,MET2)
      $INCLUDE('UMCOMM')
      INTEGER MET2
      $FLOAT F,FO,P,PO,B,RHO
      $FLOAT POM1,POM2
      $FLOAT CON4
      PARAMETER(CON4=1.0$P-2)
C
C     DETERMINATION OF THE PARAMETER RHO (NONQUADRATIC PROPERTIES)
C
      IF (ABS(MET2).LE.1) THEN
      RHO=ONE
      ELSE IF (ABS(MET2).EQ.2) THEN
      IF (FO-F+P.EQ.ZERO) THEN
      RHO=ONE
      ELSE
      RHO=HALF*B/(FO-F+P)
      ENDIF
      IF(RHO.LE.CON4) RHO=ONE
      IF(RHO*CON4.GE.ONE) RHO=ONE
      ELSE
      POM1=(F-FO)/PO
      POM2=P/PO
      IF (POM2-POM1.EQ.ZERO) THEN
      RHO=ONE
      ELSE
      IF (ABS(MET2).EQ.3) RHO=HALF*(POM2-ONE)/(POM2-POM1)
      IF (ABS(MET2).EQ.4) RHO=(POM1-ONE)/(POM2-POM1)
      IF (ABS(MET2).EQ.5) RHO=HALF*(POM2-ONE)/(TWO*(POM2-ONE)-
     & THREE*(POM1-ONE))
      IF(RHO.LE.CON4) RHO=ONE
      IF(RHO*CON4.GE.ONE) RHO=ONE
      ENDIF
      ENDIF
      RETURN
      END
