$INTERFACE UUSBA3                                             97/12/01

  CALL UUSBA3(NF,NA,MA,$AG,$IAG,$JAG,$XO,$AFO,$COLA,IVAR,$MET)
  $ADD(REAL,'\$AG($MA)\$XO($NF)\$AFO($NA)')
  $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)\$COLA($NF)')
$REM  $ADD(INTEGER,'\NF\NA\MA\IVAR')
  $ADD(INIT)
    NUXX='UUSBA3'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UUSBA3                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* BROYDEN-LIKE UPDATES OF A SPARSE RECTANGULAR MATRIX.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  MA  NUMBER OF NONZERO ELEMENTS OF THE MATRIX.
*  RI  AG(MA)  SPARSE JACOBIAN MATRIX.
*  II  IAG(NA+1)  POSITION OF THE FIRST RORWS ELEMENTS IN THE FIELD AG.
*  II  JAG(MA) COLUMN INDICES OF ELEMENTS IN THE FIELD AG.
*  RU  XO(NF)  VECTOR OF VARIABLES DIFFERENCE.
*  RI  AFO(NA)  VECTOR OF RIGHT HAND SIDES DIFFERENCE.
*  IO  IG(NF) VECTOR DEFINING GROUPS FOR THE JACOBIAN COLUMNS.
*  II  IVAR  INDEX OF GROUP CONTAINING JACOBIAN COLUMNS.
*  II  MET  METHOD SELECTION. MET=0-NO UPDATE. MET=1-SCHUBERT UPDATE.
*         MET=2-BOGLE-PERKINS UPDATE.
*
* COMMON DATA :
*  IO  ITERH  TERMINATION INDICATOR. ITERH<0-BAD DECOMPOSITION.
*         ITERH=0-SUCCESSFUL UPDATE. ITERH>0-NONPOSITIVE PARAMETERS.
*  II  IDECA  DECOMPOSITION INDICATOR. IDECA=0-NO DECOMPOSITION.
*  TO  TUXX  TEXT INFORMATION ON THE CORRECTION USED.
*
* SUBPROGRAMS USED :
*  S   UOERR1  ERROR MESAGES.
*  S   UOU1D1  PRINT OF ENTRY TO VARIABLE METRIC UPDATE.
*  S   UOU1D2  PRINT OF EXIT FROM VARIABLE METRIC UPDATE.
*
      SUBROUTINE UUSBA3(NF,NA,MA,AG,IAG,JAG,XO,AFO,IG,IVAR,MET)
      $INCLUDE('UMCOMM')
      INTEGER NF,NA,MA,IAG(NA+1),JAG(MA),IG(NF),IVAR,MET
      $FLOAT AG(MA),XO(NF),AFO(NA)
      INTEGER I,J,K,L,IP,JP
      $FLOAT DEN,POM
      IF (MET.LE.0) RETURN
C      CALL UOU1D1(N,XO,GO)
      IF(IDECA.NE.0) THEN
      ITERH=-1
      TUXX='BAD DEC0'
      CALL UOERR1('UUSBA3',1)
      GO TO 5
      ENDIF
C
C     THE FIRST BROYDEN UPDATE
C
      IF (MET.LE.1) THEN
      TUXX='SCHUBERT'
      ELSE IF (MET.LE.2) THEN
      TUXX='BOGLE P.'
      ELSE
      TUXX='COLUMN  '
      ENDIF
      DO 4 I=1,NA
      K=IAG(I)
      L=IAG(I+1)-1
      DEN=ZERO
      POM=AFO(I)
      DO 1 J=K,L
      JP=JAG(J)
      IF (JP.LE.0) GO TO 1
      POM=POM-AG(J)*XO(JP)
      IF (IG(JP).EQ.IVAR) GO TO 1
      IF (MET.LE.1) THEN
      DEN=DEN+XO(JP)**2
      ELSE IF (MET.LE.2) THEN
      DEN=DEN+(AG(J)*XO(JP))**2
      ELSE IF (DEN.LT.ABS(XO(JP))) THEN
      DEN=ABS(XO(JP))
      IP=JP
      ENDIF
    1 CONTINUE
      IF (DEN.LE.ZERO) GO TO 4
      DEN=POM/DEN
      DO 3 J=K,L
      JP=JAG(J)
      IF (JP.LE.0.OR.IG(JP).EQ.IVAR) GO TO 3
      IF (MET.LE.1) THEN
      AG(J)=AG(J)+DEN*XO(JP)
      ELSE IF (MET.LE.2) THEN
      AG(J)=AG(J)+DEN*XO(JP)*AG(J)**2
      ELSE IF (JP.EQ.IP) THEN
      AG(J)=AG(J)+DEN*SIGN(ONE,XO(JP))
      GO TO 4
      ENDIF
    3 CONTINUE
    4 CONTINUE
      ITERH=0
    5 CONTINUE
C      CALL UOU1D2(N,H,S,RHO,GAM,PAR,A,B,C,POM,ETA9)
      RETURN
      END
