$INTERFACE UUSSA1                                             97/12/01

  CALL UUSSA1(NF,MA,$AG,$IAG,$JAG,$D,$XO,$AFO,$SN,F)
  $ADD(REAL,'\$AG($MA)\$D($NF)\$XO($NF)\$AFO($NF)\$SN($NF)')
$REM  $ADD(REAL,'\F')
  $ADD(INTEGER,'\$IAG($NF+1)\$JAG($MA)')
$REM  $ADD(INTEGER,'\NF\MA')
  $ADD(INIT)
    NUXX='UUSSA1'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UUSSA1                ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* THE MARTINEZ ROW SCALING UPDATE OF THE LU DECOMPOSITION.
*
* PARAMETERS :
*  II  NF  NUMBER OF VARIABLES AND EQUATIONS.
*  II  MA  NUMBER OF NONZERO ELEMENTS OF THE JACOBIAN MATRIX.
*  RI  AG(MA)  SPARSE JACOBIAN MATRIX.
*  II  IAG(NF+1)  POSITION OF THE FIRST RORWS ELEMENTS IN THE FIELD AG.
*  II  JAG(MA) COLUMN INDICES OF ELEMENTS IN THE FIELD AG.
*  RU  D(NF)  DIAGONAL SCALING MATRIX.
*  RU  XO(NF)  VECTOR OF VARIABLES DIFFERENCE.
*  RI  AFO(NF)  VECTOR OF RIGHT HAND SIDES DIFFERENCE.
*  RO  F  CURRENT VALUE OF THE OBJECTIVE FUNCTION.
*
* COMMON DATA :
*  IO  ITERH  TERMINATION INDICATOR. ITERH<0-BAD DECOMPOSITION.
*         ITERH=0-SUCCESSFUL UPDATE. ITERH>0-NONPOSITIVE PARAMETERS.
*  II  IDECA  DECOMPOSITION INDICATOR. IDECA=0-NO DECOMPOSITION.
*  TO  TUXX  TEXT INFORMATION ON THE CORRECTION USED.
*
* SUBPROGRAMS USED :
*  S   UXSRMM  ROWWISE ORDERED SPARSE RECTANGULAR MATRIX-VECTOR PRODUCT.
*  S   UOERR1  ERROR MESAGES.
*  S   UOU1D1  PRINT OF ENTRY TO VARIABLE METRIC UPDATE.
*  S   UOU1D2  PRINT OF EXIT FROM VARIABLE METRIC UPDATE.
*
* METHOD :
* BASIC VARIABLE METRIC METHODS.
*
      SUBROUTINE UUSSA1(NF,MA,AG,IAG,JAG,D,XO,AFO,S,F)
      $INCLUDE('UMCOMM')
      INTEGER NF,MA,IAG(NF+1),JAG(MA)
      $FLOAT AG(MA),D(NF),XO(NF),AFO(NF),S(NF),F
      INTEGER I
      $FLOAT TEMP,TEMP1
      $FLOAT CON1,CON2
      PARAMETER (CON1=2.0$P-4,CON2=2.0$P 3)
C      CALL UOU1D1(XO,GO)
      IF(IDECA.NE.2) THEN
      ITERH=-1
      TUXX='BAD DEC2'
      CALL UOERR1('UUSSA1',1)
      GOTO 5
      ENDIF
C
C     THE MARTINEZ ROW SCALING UPDATE FOR LU DECOMPOSITION
C
      CALL UXSRMM(NF,NF,MA,AG,IAG,JAG,XO,S)
      DO 1 I=1,NF
      TEMP=SQRT(F)
      IF (AFO(I).EQ.ZERO) GO TO 1
      TEMP1=S(I)/AFO(I)
      IF (TEMP1.LT.CON1*TEMP) GO TO 1
      IF (TEMP1*TEMP.GT.CON2) GO TO 1
      D(I)=TEMP1
    1 CONTINUE
      TUXX='ROW SCAL'
      ITERH=0
    5 CONTINUE
C      CALL UOU1D2(H,S,RHO,GAM,A,B,C,POM)
      RETURN
      END
