* SUBROUTINE UXBSMY                ALL SYSTEMS                94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* BLOCKS OF THE SYMMETRIC BLOCKED MATRIX ARE SET TO ITS INVERSES.
*
* PARAMETERS :
*  II  N  DIMENSION OF THE ARRAY X.
*  II  NBLA  DIMENSION OF THE ARRAY ABL.
*  II  NBLKS  NUMBER OF BLOCKS OF THE MATRIX.
*  RI  ABL(NBLA)  VALUES OF THE NONZERO ELEMENTS OF THE MATRIX.
*  RI  BBL(NBLA)  VALUES OF THE NONZERO ELEMENTS OF THE MATRIX.
*  II  IBLBG(NBLKS+1)  BEGINNINGS OF THE BLOCKS IN THE MATRIX.
*  RA  X(N)  AUXILIARY VECTOR.
*
* SUBROUTINES USED :
*  UXDSMI  DENSE SYMMETRIC MATRIX IS SET TO THE UNIT MATRIX.
*
      SUBROUTINE UXBSMY(N,NBLA,NBLKS,NBLJ,ABL,BBL,IBLBG,JBL,X)
      INTEGER N,NBLKS,NBLA,NBLJ,IBLBG(NBLKS+1),JBL(NBLJ)
      $FLOAT ABL(NBLA),BBL(NBLA),X(N)
      INTEGER I,J,K,L,M,KBEG,KLEN
      $FLOAT ZERO
      PARAMETER (ZERO=0.0$P 0)
      DO 1 I=1,N
      X(I)=ZERO
    1 CONTINUE
      K=1
      DO 3 I=1,NBLKS
      KBEG=IBLBG(I)
      KLEN=IBLBG(I+1)-KBEG
      M=K-1
      DO 2 L=1,KLEN
      M=M+L
      J=JBL(KBEG)
      X(J)=X(J)+ABL(M)
      KBEG=KBEG+1
    2 CONTINUE
      CALL UXDSMC(KLEN,ABL(K),BBL(K))
      K=K+KLEN*(KLEN+1)/2
    3 CONTINUE
      K=1
      DO 5 I=1,NBLKS
      KBEG=IBLBG(I)
      KLEN=IBLBG(I+1)-KBEG
      M=K-1
      DO 4 L=1,KLEN
      M=M+L
      J=JBL(KBEG)
      BBL(M)=X(J)
      KBEG=KBEG+1
    4 CONTINUE
      K=K+KLEN*(KLEN+1)/2
    5 CONTINUE
      RETURN
      END
