* SUBROUTINE UXDCMS               ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF A COLUMNWISE STORED DENSE RECTANGULAR MATRIX A
* BY A VECTOR X AND ADDITION OF THE VECTOR Y.
*
* PARAMETERS :
*  II  N  NUMBER OF ROWS OF THE MATRIX A.
*  II  M  NUMBER OF COLUMNS OF THE MATRIX A.
*  RI  A(N*M)  RECTANGULAR MATRIX STORED COLUMNWISE IN THE
*         ONE-DIMENSIONAL ARRAY.
*  RI  X(M)  INPUT VECTOR.
*  RU  Y(N)  UPDATED VECTOR Y = A*X + Y. 
*
* SUBPROGRAMS USED :
*  S   UXVDIR  VECTOR AUGMENTED BY THE SCALED VECTOR.
*  S   UXVSCL  SCALING OF A VECTOR.
*
      SUBROUTINE UXDCMS(N,M,A,X,Y)
      INTEGER N,M
      $FLOAT A(N*M),X(M),Y(N)
      INTEGER J,K
      K=1
      DO 1 J=1,M
      IF (X(J).NE.0.0$P 0) CALL UXVDIR(N,X(J),A(K),Y,Y)
      K=K+N
    1 CONTINUE
      RETURN
      END
