* SUBROUTINE UXDCRB                ALL SYSTEMS                16/12/01
C PORTABILITY : ALL SYSTEMS
C 16/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SOLUTION OF A SYSTEM OF LINEAR EQUATIONS WITH A DENSE SYMMETRIC
* POSITIVE DEFINITE MATRIX A USING THE FACTORIZATION A=TRANS(R)*R.
*
* PARAMETERS :
*  II  N  NUMBER OF COLUMNS OF THE MATRIX A.
*  II  M  NUMBER OF ROWS OF THE MATRIX A.
*  RI  A(M,N) UPPER TRIANGULAR MATRIX IN THE DECOMPOSITION A = Q R
*         STORED COLUMNWISE IN THE TWO DIMENSIONAL ARRAY A.
*  RU  X(N)  ON INPUT THE RIGHT HAND SIDE OF A SYSTEM OF LINEAR
*         EQUATIONS. ON OUTPUT THE SOLUTION OF A SYSTEM OF LINEAR
*         EQUATIONS.
*  II  JOB  OPTION. IF JOB=0 THEN X:=A**(-1)*X. IF JOB>0 THEN
*         X:=TRANS(R)**(-1)*X. IF JOB<0 THEN X:=R**(-1)*X.
*
* METHOD :
* BACK SUBSTITUTION
*
      SUBROUTINE UXDCRB(N,M,A,X,JOB)
      INTEGER N,M,JOB
      $FLOAT A(N*M),X(N)
      INTEGER I,J,L
      $FLOAT TEMP
      $FLOAT ZERO
      PARAMETER (ZERO=0.0$P 0)
      IF (JOB.GE.0) THEN
C
C     PHASE 1 : X:=TRANS(R)**(-1)*X
C
      L=0
      DO 3 I=1,N
      TEMP=X(I)
      DO 2 J=1,I-1
      TEMP=TEMP-A(J+L)*X(J)
    2 CONTINUE
      X(I)=TEMP/A(I+L)
      L=L+M
    3 CONTINUE
      ENDIF
      IF (JOB.LE.0) THEN
C
C     PHASE 2 : X:=R**(-1)*X
C
      L=N*M
      DO 6 I=N,1,-1
      L=L-M
      IF (X(I).NE.ZERO) THEN
      X(I)=X(I)/A(I+L)
      DO 5 J=1,I-1
      X(J)=X(J)-A(J+L)*X(I)
    5 CONTINUE
      ENDIF
    6 CONTINUE
      ENDIF
      RETURN
      END
