* SUBROUTINE UXDGLM                ALL SYSTEMS                00/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF A GIVEN VECTOR X BY A DENSE GENERAL MATRIX A USING 
* THE FACTORIZATION P*A=L*U OBTAINED BY THE SUBROUTINE UXDGLB.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  RI  A(N*N)  THE FACTORIZATION P*A=L*U OBTAINED BY THE SUBROUTINE
*         UXDGLF.
*  IO  IA(N)  A PERMUTATION FIELD WHICH CONTAINS AN INFORMATION ABOUT
*         PERMUTATION MATRIX P.
*  RU  X(N)  ON INPUT THE VECTOR APPERING IN THE PRODUCT. ON OUTPUT
*         THE RESULT OF THE PRODUCT.
*  JOB  OPTION. JOB=0 - MULTIPLICATION BY THE ORIGINAL MATRIX.
*         JOB=1 - MULTIPLICATION BY THE MATRIX TRSANSPOSE.
*
* METHOD :
* BACK SUBSTITUTION.
*
      SUBROUTINE UXDGLM(N,A,IPIV,B,JOB)
      INTEGER N,IPIV(N),JOB
      $FLOAT A(N*N),B(N)
      $FLOAT ONE
      PARAMETER (ONE=1.0$P 0)
*
*     Quick return if possible
*
      IF(N.EQ.0) RETURN
      IF(JOB.EQ.0) THEN
*
*        Compute A * X = Y.
*
*        Compute U*X = Y, overwriting X with Y.
*
         CALL DTRMV('U','N','N',N,A,N,B,1)
*
*        Compute L*Y = X, overwriting Y with X.
*
         CALL DTRMV('L','N','U',N,A,N,B,1)
*
*        Apply row interchanges to the right hand sides.
*
C         CALL DLASWP(1,B,N,1,N,IPIV,-1)
         CALL UXVPER(N,IPIV,B,-1)
      ELSE
*
*        Compute A' * X = Y.
*
*        Apply row interchanges to the solution vectors.
*
C         CALL DLASWP(1,B,N,1,N,IPIV,1)
         CALL UXVPER(N,IPIV,B,1)
*
*        Compute L'*X = Y, overwriting X with Y.
*
         CALL DTRMV('L','T','U',N,A,N,B,1)
*
*        Compute U'*Y = X, overwriting Y with X.
*
         CALL DTRMV('U','T','N',N,A,N,B,1)
      END IF
      RETURN
      END
