* SUBROUTINE UXDPGM                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF A GIVEN VECTOR X BY A DENSE SYMMETRIC POSITIVE
* DEFINITE MATRIX A+E USING THE FACTORIZATION A+E=L*D*TRANS(L) OBTAINED
* BY THE SUBROUTINE UXDPGF.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  RI  A(N*(N+1)/2) FACTORIZATION A+E=L*D*TRANS(L) OBTAINED BY THE
*         SUBROUTINE UXDPGF.
*  RU  X(N)  ON INPUT THE GIVEN VECTOR. ON OUTPUT THE RESULT OF
*         MULTIPLICATION.
*  II  JOB  OPTION. IF JOB=0 THEN X:=(A+E)*X. IF JOB>0 THEN
*         X:=TRANS(L)*X. IF JOB<0 THEN X:=L*X.
*
      SUBROUTINE UXDPGM( N, A, X, JOB)
      INTEGER N, JOB
      $FLOAT  A(N*(N+1)/2), X(N)
      INTEGER  I, J, II, IJ
      IF (JOB .GE. 0)  THEN
C
C     PHASE 1 : X:=TRANS(L)*X
C
      II = 0
      DO 3  I = 1, N
      II = II + I
      IJ = II
      DO 2  J = I+1, N
      IJ = IJ + J - 1
      X(I) = X(I) + A(IJ) * X(J)
    2 CONTINUE
    3 CONTINUE
      ENDIF
      IF (JOB .EQ. 0)  THEN
C
C     PHASE 2 : X:=D*X
C
      II = 0
      DO 4  I = 1, N
      II = II + I
      X(I) = X(I) * A(II)
    4 CONTINUE
      ENDIF
      IF (JOB .LE. 0)  THEN
C
C     PHASE 3 : X:=L*X
C
      IJ = N*(N+1)/2
      DO 6  I = N, 1, -1
      DO 5  J = I-1, 1, -1
      IJ = IJ - 1
      X(I) = X(I) + A(IJ) * X(J)
    5 CONTINUE
      IJ = IJ - 1
    6 CONTINUE
      ENDIF
      RETURN
      END
