* SUBROUTINE UXDPGX                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SCALING FACTORS FOR A DENSE SYMMETRIC POSITIVE DEFINITE MATRIX A+E
* IN THE FACTORED FORM A+E=P*L*D*TRANS(L)*TRANS(P) OBTAINED BY THE
* SUBROUTINE UXDPGF.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  RU  A(N*(N+1)/2) FACTORIZATION A+E=L*D*TRANS(L) OBTAINED BY THE
*         SUBROUTINE UXDPGF.
*  RO  X(N)  VECTOR OF SCALING FACTORS.
*
*
      SUBROUTINE UXDPGX( N, A, X)
      INTEGER N
      $FLOAT  A(N*(N+1)/2), X(N)
      $FLOAT  TEMP
      INTEGER  I, J, II, IJ
      $FLOAT ONE,CON1,CON2
      PARAMETER (ONE=1.0D 0,CON1=2.0D-5,CON2=1.0D 5)
      II = 0
      DO 2  I = 1, N
      II = II + I
      IJ = II
      TEMP=ONE
      DO 1  J = I+1, N
      IJ = IJ + J - 1
      TEMP=TEMP+A(IJ)**2
    1 CONTINUE
      X(I)=SQRT(TEMP)
      IF (X(I).LE.CON1) X(I)=CON1
      IF (X(I).GE.CON2) X(I)=CON2
    2 CONTINUE
      II = 0
      DO  3  I = 1, N
      II = II + I
      A(II)=A(II)*X(I)**2
    3 CONTINUE
      RETURN
      END
