* SUBROUTINE UXDRFS               ALL SYSTEMS                97/12/01
C PORTABILITY : ALL SYSTEMS
C 97/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* NEGATIVE PROJECTED GRADIENT IS DETERMINED USING LAGRANGE MULTIPLIERS.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  II  NC  NUMBER OF LINEARIZED CONSTRAINTS.
*  II  ICA(NF+1)  VECTOR CONTAINING INDICES OF ACTIVE FUNCTIONS.
*  RI  CG(NF*NC)  MATRIX WHOSE COLUMNS ARE NORMALS OF THE LINEAR
*         CONSTRAINTS.
*  RO  CZ(NF+1)  VECTOR OF LAGRANGE MULTIPLIERS.
*  RO  S(NF)  NEGATIVE PROJECTED GRADIENT OF THE QUADRATIC FUNCTION.
*  RI  EPS7  TOLERANCE FOR LINEAR AND QUADRATIC PROGRAMMING.
*  RO  GMAX  NORM OF THE TRANSFORMED GRADIENT.
*
* SUBPROGRAMS USED :
*  S   UXVDIR  VECTOR AUGMENTED BY THE SCALED VECTOR.
*  RF  UXVMAX  L-INFINITY NORM OF A VECTOR.
*
      SUBROUTINE UXDRFS(NF,N,NC,ICA,CG,CZ,S,EPS7,GMAX)
      INTEGER NF,N,NC,ICA(NF+1)
      $FLOAT CG(NF*NC),CZ(NF+1),S(NF),EPS7,GMAX
      $FLOAT UXVMAX
      INTEGER NCA,J,L
      NCA=NF-N
      DO 3 J=1,NCA
      L=ICA(J)
      CALL UXVDIR(NF,CZ(J),CG((L-1)*NF+1),S,S)
    3 CONTINUE
      GMAX=UXVMAX(NF,S)
      IF (GMAX.LE.EPS7) GMAX=0.0$P 0
      RETURN
      END
