* SUBROUTINE UXDRGR               ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PLANE ROTATION IS APPLIED TO A ROWWISE STORED DENSE RECTANGULAR
* MATRIX A.
*
* PARAMETERS :
*  II  N  NUMBER OF COLUMNS OF THE MATRIX A.
*  II  M  NUMBER OF ROWS OF THE MATRIX A.
*  RU  A(M*N)  RECTANGULAR MATRIX STORED ROWWISE IN THE
*         ONE-DIMENSIONAL ARRAY.
*  II  K  FIRST INDEX OF THE PLANE ROTATION.
*  II  L  SECOND INDEX OF THE PLANE ROTATION.
*  RI  CK  DIAGONAL ELEMENT OF THE ELEMENTARY ORTHOGONAL MATRIX.
*  RI  CL  OFF-DIAGONAL ELEMENT OF THE ELEMENTARY ORTHOGONAL MATRIX.
*  II  IER  TYPE OF THE PLANE ROTATION. IER=0-GENERAL PLANE ROTATION.
*         IER=1-PERMUTATION. IER=2-TRANSFORMATION SUPPRESSED.
*
* SUBPROGRAMS USED :
*  S   UXVROT  PLANE ROTATION APPLIED TO TWO ELEMENTS.
*
      SUBROUTINE UXDRGR(N,M,A,K,L,CK,CL,IER)
      INTEGER N,M,K,L,IER
      $FLOAT A(M*N),CK,CL
      INTEGER I,IK,IL
      IF (IER.NE.0.AND.IER.NE.1) RETURN
      IK=(K-1)*N
      IL=(L-1)*N
      DO 1 I=1,N
      IK=IK+1
      IL=IL+1
      CALL UXVROT(A(IK),A(IL),CK,CL,IER)
    1 CONTINUE
      RETURN
      END
