* SUBROUTINE UXDRHR               ALL SYSTEMS                93/12/01
C PORTABILITY : ALL SYSTEMS
C 93/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* PSEUDORANK DETERMINATION AFTER QR DECOMPOSITION USING RIGHT HAND
* SIDE VECTOR.
*
* PARAMETERS :
*  II  N  NUMBER OF COLUMNS OF THE MATRIX A.
*  II  M  NUMBER OF ROWS OF THE MATRIX A.
*  RI  A(M*N)  RECTANGULAR MATRIX STORED ROWWISE IN THE
*         ONE-DIMENSIONAL ARRAY.
*  II  IA(N)  A PERMUTATION FIELD WHICH CONTAINS AN INFORMATION ABOUT
*         PERMUTATION MATRIX.
*  RI  TOL  TOLERANCE FOR PSEUDORANK DETERMINATION.
*  IO  NM  ASSUMED RANK OF THE MATRIX A. 
*  IO  NP  PSEUDORANK OF THE MATRIX A.
*
      SUBROUTINE UXDRHR(N,M,A,IA,TOL,NM,NP)
      INTEGER N,M,IA(N),NM,NP
      $FLOAT A(M*N),TOL
      $FLOAT POM,TEMP,TOL1
      INTEGER K,L,KP
      TOL1=SQRT(TOL)
      TEMP=TOL1
      L=0
      NP=0
      DO 1 K=1,NM
      KP=IA(K)
      POM=ABS(A(L+KP))
      IF (K.EQ.1) TEMP=TOL1*MAX(TEMP,POM)
      IF (POM.LE.TEMP) RETURN
      NP=K
      L=L+N
    1 CONTINUE
      RETURN
      END
