* SUBROUTINE UXDRMW               ALL SYSTEMS                14/12/01
C PORTABILITY : ALL SYSTEMS
C 14/12/01 VL : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF ROWWISE STORED DENSE RECTANGULAR MATRIX A1, A2 BY
* VECTORS X1, X2.
*
* PARAMETERS :
*  II  N  NUMBER OF COLUMNS OF THE MATRIX A.
*  II  M  NUMBER OF ROWS OF THE MATRIX A.
*  RI  A1(M*N)  RECTANGULAR MATRIX STORED ROWWISE IN THE
*         ONE-DIMENSIONAL ARRAY.
*  RI  A2(M*N)  RECTANGULAR MATRIX STORED ROWWISE IN THE
*         ONE-DIMENSIONAL ARRAY.
*  RI  X1(N)  INPUT VECTOR.
*  RI  X2(N)  INPUT VECTOR.
*  RO  Y1(M)  OUTPUT VECTOR EQUAL TO A1*X1.
*  RO  Y2(M)  OUTPUT VECTOR EQUAL TO A2*X2.
*
      SUBROUTINE UXDRMW(N,M,A1,A2,X1,X2,Y1,Y2)
      INTEGER M,N
      $FLOAT A1(N*M),A2(N*M),X1(N),X2(N),Y1(M),Y2(M)
      INTEGER I,J,L
      $FLOAT Q1,Q2
      L=0
      DO I=1,M
        Q1=0D0
        Q2=0D0
        DO J=1,N
          Q1=Q1+A1(L+J)*X1(J)
          Q2=Q2+A2(L+J)*X2(J)
        ENDDO
        L=L+N
        Y1(I)=Q1
        Y2(I)=Q2
      ENDDO
      RETURN
      END
