* SUBROUTINE UXDRMX                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SCALING FACTORS FOR A ROWWISE STORED DENSE RECTANGULAR MATRIX.
* THESE SCALING FACTORS ARE NORMS OF THE CORRESPONDING COLUMNS.
*
* PARAMETERS :
*  II  N  NUMBER OF COLUMNS OF THE MATRIX A.
*  II  M  NUMBER OF ROWS OF THE MATRIX A.
*  RI  A(M*N)  RECTANGULAR MATRIX STORED ROWWISE IN THE
*         ONE-DIMENSIONAL ARRAY.
*  RO  X(N)  VECTOR OF SCALING FACTORS.
*
      SUBROUTINE UXDRMX(N,M,A,X)
      INTEGER N,M
      $FLOAT A(M*N),X(N)
      INTEGER I,J,K
      $FLOAT TEMP
      $FLOAT ZERO,ONE,CON,CON1,CON2
      PARAMETER (ZERO=0.0$P 0,ONE=1.0$P 0,CON=1.0$P-60,CON1=2.0$P-5,
     & CON2=1.0$P 5)
      DO 3 I=1,N
      K=I
      TEMP=ZERO
      DO 1 J=1,M
      TEMP=TEMP+A(K)*A(K)
      K=K+N
    1 CONTINUE
      TEMP=ONE/SQRT(MAX(TEMP,CON))
      IF (TEMP.LE.CON1) TEMP=CON1
      IF (TEMP.GE.CON2) TEMP=CON2
      X(I)=TEMP
      K=I
      DO 2 J=1,M
      A(K)=A(K)*TEMP
      K=K+N
    2 CONTINUE
    3 CONTINUE
      RETURN
      END
