* SUBROUTINE UXDRSU               ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SHIFT OF COLUMNS OF THE RECTANGULAR MATRICES A AND B. SHIFT OF
* ELEMENTS OF THE VECTOR U. THESE SHIFTS ARE USED IN THE LIMITED
* MEMORY BFGS METHOD.
*
* PARAMETERS :
*  II  N  NUMBER OF ROWS OF THE MATRIX A AND B.
*  II  M  NUMBER OF COLUMNS OF THE MATRIX A AND B.
*  RU  A(N*M)  RECTANGULAR MATRIX STORED AS A ONE-DIMENSIONAL ARRAY.
*  RU  B(N*M)  RECTANGULAR MATRIX STORED AS A ONE-DIMENSIONAL ARRAY.
*  RU  U(M)  VECTOR.
*
      SUBROUTINE UXDRSU(N,M,A,B,U)
      INTEGER N,M
      $FLOAT A(N*M),B(N*M),U(M)
      INTEGER I,K,L
      K=(M-1)*N+1
      DO 1 I=M-1,1,-1
      L=K-N
      CALL UXVCOP(N,A(L),A(K))
      CALL UXVCOP(N,B(L),B(K))
      U(I+1)=U(I)
      K=L
    1 CONTINUE
      RETURN
      END
