* FUNCTION UXDSM1                  ALL SYSTEMS                89/12/01
C PORTABILITY : ALL SYSTEMS
C 89/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* L1 NORM OF A DENSE SYMMETRIC MATRIX.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  RI  A(N*(N+1)/2)  DENSE SYMMETRIC MATRIX STORED IN THE PACKED FORM.
*  RR  UXDSM1  L1 NORM OF THE MATRIX A.
*
      FUNCTION UXDSM1(N,A)
      INTEGER N
      $FLOAT  A(N*(N+1)/2), UXDSM1
      $FLOAT  TEMP1, TEMP2
      INTEGER  I,J,K,L
      $FLOAT ZERO
      PARAMETER  (ZERO = 0.0$P 0)
      TEMP1 = ZERO
      K=0
      DO  3  I = 1, N
      TEMP2 = ZERO
      L=K
      DO  1  J = 1, I
      L=L+1
      TEMP2 = TEMP2 + ABS(A(L))
    1 CONTINUE
      DO  2  J = I+1, N
      L=L+J-1
      TEMP2 = TEMP2 + ABS(A(L))
    2 CONTINUE
      TEMP1 = MAX(TEMP1, TEMP2)
      K=K+I
    3 CONTINUE
      UXDSM1 = TEMP1
      RETURN
      END
