* SUBROUTINE UXDSMB                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* UPPER BOUNDS FOR EUCLIDEAN NORM OF A DENSE SYMMETRIC POSITIVE
* DEFINITE MATRIX.
*
* PARAMETERS :
*  II  N  DIMENSION OF THE MATRIX A.
*  RI  A(N*(N+1)/2)  DENSE SYMMETRIC POSITIVE DEFINITE MATRIX STORED IN
*         THE PACKED FORM.
*  RO  B1  FIRST UPPER BOUND (TRACE OF THE MATRIX A).
*  RO  B2  SECOND UPPER BOUND (INFINITY NORM OF THE MATRIX A).
*
      SUBROUTINE UXDSMB(N,A,B1,B2)
      INTEGER  N
      $FLOAT  A(N*(N+1)/2),B1,B2
      $FLOAT TEMP
      INTEGER I,J,K,L
      $FLOAT ZERO
      PARAMETER (ZERO=0.0$P 0)
      B1=ZERO
      B2=ZERO
      K=0
      DO 3 I=1,N
      TEMP=ZERO
      L=K
      DO 1 J=1,I
      L=L+1
      TEMP=TEMP+ABS(A(L))
    1 CONTINUE
      DO 2 J=I+1,N
      L=L+J-1
      TEMP=TEMP+ABS(A(L))
    2 CONTINUE
      IF (B2.LT.TEMP) B2=TEMP
      K=K+I
      B1=B1+A(K)
    3 CONTINUE
      RETURN
      END

