* SUBROUTINE UXDSMX                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SCALING FACTORS FOR A DENSE SYMMETRIC MATRIX A.
*
* PARAMETERS :
*  II  N ORDER OF THE MATRIX A.
*  RU  A(N*(N+1)/2)  DENSE SYMMETRIC MATRIX STORED IN THE PACKED FORM.
*  RO  X(N)  VECTOR OF SCALING FACTORS.
*
      SUBROUTINE UXDSMX(N,A,X)
      INTEGER N
      $FLOAT A(N*(N+1)/2),X(N)
      INTEGER I,J,K
      $FLOAT ONE,CON,CON1,CON2
      PARAMETER (ONE=1.0$P 0,CON=1.0$P-60,CON1=2.0$P-5,CON2=1.0$P 5)
      K=0
      DO 1 I=1,N
      K=K+I
      X(I)=MAX(ABS(A(K)),CON)
      X(I)=ONE/SQRT(X(I))
      IF (X(I).LE.CON1) X(I)=CON1
      IF (X(I).GE.CON2) X(I)=CON2
    1 CONTINUE
      K=0
      DO 3 I=1,N
      DO 2 J=1,I
      K=K+1
      A(K)=A(K)*X(I)*X(J)
    2 CONTINUE
    3 CONTINUE
      RETURN
      END
