* SUBROUTINE UXDSMZ                ALL SYSTEMS                04/12/01
C PORTABILITY : ALL SYSTEMS
C 04/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* UPDATE OF A DENSE SYMMETRIC MATRIX A. THIS UPDATE IS DEFINED AS
* A:=A+ALF*(X*TRANS(Y)+Y*TRANS(X)) WHERE ALF IS A GIVEN SCALING FACTOR
* AND X, Y ARE GIVEN VECTORS.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  RU  A(N*(N+1)/2)  DENSE SYMMETRIC MATRIX STORED IN THE PACKED FORM.
*  RI  ALF  SCALING FACTOR IN THE CORRECTION TERM.
*  RI  X(N)  VECTOR IN THE CORRECTION TERM.
*  RI  Y(N)  VECTOR IN THE CORRECTION TERM.
*
      SUBROUTINE UXDSMZ( N, A, ALF, X, Y)
      INTEGER N
      $FLOAT  A(N*(N+1)/2), X(N), Y(N), ALF
      $FLOAT TEMP1,TEMP2
      INTEGER  I, J, K
      K = 0
      DO 2  I = 1, N
      TEMP1 = ALF * X(I)
      TEMP2 = ALF * Y(I)
      DO 1  J = 1, I
      K = K + 1
      A(K) = A(K) + TEMP1 * Y(J) + TEMP2 * X(J)
    1 CONTINUE
    2 CONTINUE
      RETURN
      END
