* SUBROUTINE UXDSTB                ALL SYSTEMS                06/12/01
C PORTABILITY : ALL SYSTEMS
C 06/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* BACK TRANSFORMATION OF EIGENVECTORS OF THE TRIDIAGONAL MATRIX T
* OBTAINED BY UXDSTV.
*
* PARAMETERS :
*  II  N  ORDER OF THE THE TRIDIAGONAL MATRIX T.
*  II  M  NUMBER OF TRANSFORMED EIGENVECTORS.
*  RI  A(N*(N+1)/2)  TRANSFORMATION MATRIX OBTAINED BY UXDSTV.
*  RO  Z(N*M)  TRANSFORMED EIGENVECTORS STORED COLUMNWISE.
*
      SUBROUTINE UXDSTB(N,M,A,Z)
      INTEGER N,M
      $FLOAT A(N*(N+1)/2),Z(N*M)
      INTEGER I,IK,IZ,J,JJ,K,L
      $FLOAT H,S
      IF (M.EQ.0) RETURN
      IF (N.EQ.1) RETURN
      DO 140 I=2,N
      L=I-1
      IZ=(I*L)/2
      IK=IZ+I
      H=A(IK)
      IF (H.EQ.0.0$P 0) GO TO 140
      JJ=0
      DO 130 J=1,M
      S=0.0$P 0
      IK=IZ
      DO 110 K=1,L
      IK=IK+1
      S=S+A(IK)*Z(K+JJ)
  110 CONTINUE
      S=(S/H)/H
      IK=IZ
      DO 120 K=1,L
      IK=IK+1
      Z(K+JJ)=Z(K+JJ)-S*A(IK)
  120 CONTINUE
      JJ=JJ+N
  130 CONTINUE
  140 CONTINUE
      RETURN
      END
