* SUBROUTINE UXDSTP                ALL SYSTEMS                06/12/01
C PORTABILITY : ALL SYSTEMS
C 06/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* REDUCTION OF A REAL SYMMETRIC MATRIX TO A SYMMETRIC TRIDIAGONAL MATRIX
* USING AND ACCUMULATING ORTHOGONAL SIMILARITY TRANSFORMATIONS.
*
* PARAMETERS :
*  II  N  ORDER OF THE SYMMETRIC MATRIX A AND THE TRIDIAGONAL MATRIX T.
*  RI  C(N*N)  ELEMENTS OF THE SYMMETRIC MATRIX A.
*  RO  D(N)  DIAGONAL ELEMENTS OF THE TRIDIAGONAL MATRIX T.
*  RO  E(N)  SUBDIAGONAL ELEMENTS OF THE TRIDIAGONAL MATRIX T.
*
      SUBROUTINE UXDSTP(N,C,D,E)
      INTEGER N
      $FLOAT D(N),E(N),C(N*N)
      INTEGER I,II,J,JJ,K,L
      $FLOAT F,G,H,HH,SCALE
      DO 300 II=2,N
      I=N+2-II
      L=I-1
      H=0.0$P 0
      SCALE=0.0$P 0
       IF (L.LT.2) GOTO 130
      DO 120 K=1,L
      SCALE=SCALE+ABS(C((K-1)*N+I))
  120 CONTINUE
      IF (SCALE.NE.0.0$P 0) GOTO 140
  130 E(I)=C((L-1)*N+I)
      GOTO 290
  140 DO 150 K=1,L
      C((K-1)*N+I)=C((K-1)*N+I)/SCALE
      H=H+C((K-1)*N+I)**2
  150 CONTINUE
      F=C((L-1)*N+I)
       G=-SIGN(SQRT(H),F)
      E(I)=SCALE*G
      H=H-F*G
      C((L-1)*N+I)=F-G
       F=0.0$P 0
      DO 240 J=1,L
       C((I-1)*N+J)=C((J-1)*N+I)/H
      G=0.0$P 0
      DO 180 K=1,J
      G=G+C((K-1)*N+J)*C((K-1)*N+I)
  180 CONTINUE
      JJ=J+1
       IF (L.LT.JJ) GOTO 220
      DO 200 K=JJ,L
       G=G+C((J-1)*N+K)*C((K-1)*N+I)
  200  CONTINUE
  220 E(J)=G/H
      F=F+E(J)*C((J-1)*N+I)
  240 CONTINUE
      HH=F/(H+H)
      DO 260 J=1,L
      F=C((J-1)*N+I)
      G=E(J)-HH*F
      E(J)=G
      DO 260 K=1,J
      C((K-1)*N+J)=C((K-1)*N+J)-F*E(K)-G*C((K-1)*N+I)
  260 CONTINUE
  290 D(I)=H
  300 CONTINUE
      D(1)=0.0$P 0
      E(1)=0.0$P 0
      DO 500 I=1,N
       L=I-1
       IF (D(I).EQ.0.0$P 0) GOTO 380
       DO 360 J=1,L
       G=0.0$P 0
       DO 340 K=1,L
       G=G+C((K-1)*N+I)*C((J-1)*N+K)
  340 CONTINUE
      DO 360 K=1,L
       C((J-1)*N+K)=C((J-1)*N+K)-G*C((I-1)*N+K)
  360 CONTINUE
  380 D(I)=C((I-1)*N+I)
      C((I-1)*N+I)=1.0$P 0
       IF (L.LT.1) GOTO 500
       DO 400 J=1,L
      C((J-1)*N+I)=0.0$P 0
       C((I-1)*N+J)=0.0$P 0
  400 CONTINUE
  500 CONTINUE
      RETURN
      END
