* SUBROUTINE UXELVI                ALL SYSTEMS                31/12/16
C PORTABILITY : ALL SYSTEMS
C 31/12/16 VL :                                       ORIGINAL VERSION
*
* PURPOSE :
* STEPWISE INVERSION OF NONSYMMETRIC MATRIX.
*
* PARAMETERS :
*  II  M  NUMBER OF COLUMNS OF MATRICES XM, GM.
*  II  MM  MAXIMUM NUMBER OF COLUMNS OF MATRICES XM, GM.
*  II  L  STOPPING INDICATOR.
*  RI  AA(MM,MM)  INVERTED MATRIX.
*  RO  WW(MM+MM)  AUXILIARY VECTOR.
*  RO  AUXILIARY  VARIABLE.
*  IO  IR  INVERSION SUCCESS INDICATOR.
*
* SUBPROGRAMS USED :
*  S  UXECMM  MULTIPLICATION OF TWO-DIMENSIONAL RECTANGULAR MATRIX BY VECTOR.
*  S  UXERMM  MULTIPLICATION OF TRANSPOSED TWO-DIMENSIONAL RECTANGULAR
*             MATRIX BY VECTOR.
*
      SUBROUTINE UXELVI(N,MM,L,AA,WW,W,IR)
      INTEGER I,IR,J,L,MM,N
      $FLOAT AA(MM,MM),WW(MM+MM),W
C  ***  postup.vytvar.inverze (pd)nesym.matice:  (AA_^-1,a,b^T,alf)^-1 --> AA
      IR=0
      IF(N.LE.1)RETURN
      CALL UXECMM(N-1,N-1,MM,AA,AA(:,N),WW)
      W=AA(N,N)-DOT_PRODUCT(WW(:N-1),AA(N,:N-1))
      IR=1
      IF(W.EQ.0.0$P 0)IR=-1
      IF(W.EQ.0.0$P 0.OR.L.LE.0)RETURN
      AA(N,N)=1.0$P 0/W
      CALL UXERMM(N-1,N-1,MM,AA,AA(N,:),WW(MM+1))
      DO I=1,N-1
        AA(I,N)=-WW(I)/W
        AA(N,I)=-WW(MM+I)/W
        DO J=1,N-1
          AA(I,J)=AA(I,J)+WW(I)*WW(MM+J)/W
        END DO
      END DO
      RETURN
      END
