* SUBROUTINE UXLIDM                ALL SYSTEMS                96/12/01
C PORTABILITY : ALL SYSTEMS
C 96/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* LIMITED STORAGE INVERSE COLUMN UPDATE METHODS.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  II  M  NUMBER OF QUASI-NEWTON STEPS.
*  RI  D(N) DIAGONAL OF A DECOMPOSED TRIDIAGONAL MATRIX.
*  RI  DL(N) SUBDIAGONAL OF A DECOMPOSED TRIDIAGONAL MATRIX.
*  RI  DU(N) SUPERDIAGONAL OF A DECOMPOSED TRIDIAGONAL MATRIX.
*  RI  DU2(N) SECOND SUPERDIAGONAL OF A DECOMPOSED TRIDIAGONAL MATRIX.
*  II  ID(N)  PERMUTATION VECTOR.
*  RI  XM(N*M)  SET OF VECTORS FOR INVERSE COLUMN UPDATE.
*  RI  GM(M)  AUXILIARY VECTOR.
*  II  IM(M)  VECTOR OF INDICES.
*  RI  U(N)  INPUT VECTOR.
*  RO  V(N)  OUTPUT VECTOR.
*
* SUBPROGRAMS USED :
*  S   UXTGGB  BACK SUBSTITUTION FOR A DECOMPOSED TRIDIAGONAL MATRIX.
*  S   UXVCOP  COPYING OF A VECTOR.
*  S   UXVDIR  VECTOR AUGMENTED BY THE SCALED VECTOR.
*
* METHOD :
* LIMITED STORAGE INVERSE COLUMN UPDATE METHODS.
*
      SUBROUTINE UXLIDM(N,M,MMAX,XMEM,IMEM,JMEM,LU,XM,GM,IM,U,V,S)
      INTEGER N,M,MMAX,IMEM(MMAX),JMEM(7,2),LU(2,2),IM(M)
      $FLOAT XMEM(MMAX),XM(N*M),GM(M),U(N),V(N),S(2*N)
      INTEGER I,L,INF
      INTEGER ICON5
      $FLOAT CON2
      PARAMETER (CON2=1.0$P-60)
      PARAMETER (ICON5=8)
      CALL UXVCOP(N,U,V)
      CALL UXSGDB(XMEM,IMEM,JMEM,N,LU,INF,V,V,S,CON2,ICON5,0)
      L=1
      DO 1 I=1,M
      CALL UXVDIR(N,U(IM(I))/GM(I),XM(L),V,V)
      L=L+N
    1 CONTINUE
      RETURN
      END
