* SUBROUTINE UXSGFE                 ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* EPILOGUE OF THE FACTORIZATION P A Q = L*U.
*
* PARAMETERS :
*  II  N  NUMBER OF ROWS OF THE SPARSE MATRIX
*  II  M  NUMBER OF PROCESSED COLUMNS THAT FORM THE COLUMNS OF THE MATRI
*         THAT DESCRIBES THE ACTIVE SET. M <= N.
*  II  NAU SIZE OF THE ARRAY THAT STORES THE NUMERICAL ELEMENTS OF
*          THE PROCESSED MATRIX.
*  II  PTR(N) POINTER VECTOR OF THE ROWS OF THE U-FACTOR.
*  RI  AU(NAU) ELEMENTS OF THE PROCESSED SPARSE MATRIX.
*  RI  MXU  MAXIMUM ELEMENT OF THE DIAGONAL OF THE FACTOR U.
*  RI  MNU  MINIMUM ELEMENT OF THE DIAGONAL OF THE FACTOR U.
*
      SUBROUTINE UXSGFE(N,M,NAU,PTR,AU,MXU,MNU)
      INTEGER N,M,NAU
      INTEGER PTR(N)
      $FLOAT AU(NAU)
      $FLOAT MXU,MNU
      INTEGER I,K
      IF(M.LT.N) THEN
                 I=1
                 ELSE
                 I=ABS(AU(PTR(1)))
      END IF
      K=ABS(AU(PTR(1)))
      MXU=MAX(K,I)
      MNU=MIN(K,I)
      DO 100 I=1,M
      K=ABS(AU(PTR(I)))
      MXU=MAX($DBLE(K),MXU)
      MNU=MIN($DBLE(K),MNU)
100   CONTINUE
      RETURN
      END
