* SUBROUTINE UXSGID                ALL SYSTEMS                96/12/01
C PORTABILITY : ALL SYSTEMS
C 96/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* DETERMINATION OF POINTERS OF THE DIAGONAL ELEMENTS.
*
* PARAMETERS :
*  II  N  MATRIX DIMENSION.
*  II  M  NUMBER OF MATRIX NONZERO ELEMENTS.
*  RU  A(M)  NONZERO ELEMENTS OF THE MATRIX A.
*  II  IA(N+1)  ROW POINTERS OF THE MATRIX A.
*  II  JA(M)  COLUMN INDICES OF THE MATRIX A.
*  IO  IP(N)  PERMUTATION VECTOR.
*  IO  ID(N)  DIAGONAL POINTERS OF THE MATRIX A.
*  IO  INF  INFORMATION.
*
      SUBROUTINE UXSGID(N,M,IA,JA,IP,ID,INF)
      INTEGER N,M,IA(N+1),JA(M),IP(N),ID(N),INF
      INTEGER I,J,K,JJ,KSTRT,KSTOP
      $FLOAT ZERO,ONE
      PARAMETER (ZERO=0.0$P 0,ONE=1.0$P 0)
      INF=0
      DO 11 I=1,N
      IF (IP(I).LE.0.OR.IP(I).GT.N) THEN
      CALL UXVINP(N,IP)
      GO TO 12
      ENDIF
   11 CONTINUE
   12 DO 5 K=1,N
      KSTRT=IA(K)
      KSTOP=IA(K+1)-1
      ID(K)=0
      DO 1 JJ=KSTRT,KSTOP
      J=JA(JJ)
      IF (IP(J).EQ.K) ID(K)=JJ
    1 CONTINUE
      IF (ID(K).EQ.0) THEN
      INF=-45
      CALL UOERR1('UXSGID',45)
      RETURN
      ENDIF
    5 CONTINUE
      RETURN
      END
