* SUBROUTINE UXSGIM                ALL SYSTEMS                95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF A GIVEN VECTOR X BY A SPARSE UNSYMMETRIC MATRIX
* A USING INCOMPLETE FACTORIZATION OBTAINED BY THE SUBROUTINE UXSGIF.
*
* PARAMETERS :
*  II  N  MATRIX DIMENSION.
*  II  M  NUMBER OF MATRIX NONZERO ELEMENTS.
*  RU  A(M)  NONZERO ELEMENTS OF THE MATRIX A.
*  II  IA(N+1)  ROW POINTERS OF THE MATRIX A.
*  II  JA(M)  COLUMN INDICES OF THE MATRIX A.
*  IO  IP(N)  PERMUTATION VECTOR.
*  RU  X(N)  INPUT AND OUTPUT VECTOR.
*  RA  Y(N)  AUXILIARY.VECTOR
*  JOB  OPTION. JOB=0 - MULTIPLICATION BY THE ORIGINAL MATRIX.
*         JOB=1 - MULTIPLICATION BY THE MATRIX TRSANSPOSE.
*
      SUBROUTINE UXSGIM(N,M,A,IA,JA,IP,X,Y,JOB)
      INTEGER N,M,IA(N+1),JA(M),IP(N),JOB
      $FLOAT A(M),X(N),Y(N)
      INTEGER J,K,JJ,JP,KSTRT,KSTOP
      $FLOAT ZERO
      PARAMETER (ZERO=0.0$P 0)
      IF (JOB.LE.0) THEN
      DO 2 K=1,N
      Y(K)=ZERO
      KSTRT=IA(K)
      KSTOP=IA(K+1)-1
      DO 1 JJ=KSTRT,KSTOP
      J=JA(JJ)
      IF (IP(J).GE.K) Y(K)=Y(K)+A(JJ)*X(J)
    1 CONTINUE
    2 CONTINUE
      DO 4 K=N,1,-1
      KSTRT=IA(K)
      KSTOP=IA(K+1)-1
      DO 3 JJ=KSTRT,KSTOP
      J=JA(JJ)
      JP=IP(J)
      IF (JP.LT.K) Y(K)=Y(K)+A(JJ)*Y(JP)
    3 CONTINUE
    4 CONTINUE
      IF (JOB.EQ.0) CALL UXVCOP(N,Y,X)
      ELSE
      CALL UXVCOP(N,X,Y)
      DO 7 K=1,N
      KSTRT=IA(K)
      KSTOP=IA(K+1)-1
      DO 6 JJ=KSTRT,KSTOP
      J=JA(JJ)
      JP=IP(J)
      IF (JP.LT.K) Y(JP)=Y(JP)+A(JJ)*X(K)
    6 CONTINUE
      X(K)=ZERO
    7 CONTINUE
      DO 9 K=1,N
      KSTRT=IA(K)
      KSTOP=IA(K+1)-1
      DO 8 JJ=KSTRT,KSTOP
      J=JA(JJ)
      IF (IP(J).GE.K) X(J)=X(J)+A(JJ)*Y(K)
    8 CONTINUE
    9 CONTINUE
      ENDIF
      RETURN
      END
