* SUBROUTINE UXSGMM                ALL SYSTEMS                90/12/01
C PORTABILITY : ALL SYSTEMS
C 90/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* MATRIX VECTOR MULTIPLYING Y=A*X OR Y=(A/I)*X
* THIS FURTHER CASE USES ROW PERMUTATION VECTOR ORDL
* FOR DETERMINING THE IDENTITY MATRIX POSITIONS
*
* PARAMETERS :
*  II  N ROW ORDER OF THE MATRIX
*  II  M COLUMN ORDER OF THE MATRIX
*  II  NZA LENGTH OF THE VECTORS RNR,A
*  II  RNR(NZA) VECTOR OF THE ROW INDICES OF THE MATRIX
*  II  PRNR(N+1) POINTER VECTOR OF THE COLUMNS OF THE MATRIX
*  II  ORDL(N) ROW PERMUTATION VECTOR
*  II  BCOL(N) VECTOR WHICH GIVES THE INFORMATION ABOUT
*              THE COLUMN SELECTION. COLUMNS THAT ARE SELECTED
*              ARE GIVEN BY THE POSITIONS BCOL(1), ..., BCOL(M).
*  RI  A(N) NUMERICAL ELEMENTS OF THE MATRIX BEEING MULTIPLIED.
*  RI  X(N)  INPUT VECTOR
*  RO  Y(N)  OUTPUT VECTOR Y=A*X  OR  Y=(A/I)*X
*  II  JOB  SPECIFIES THE TYPE OF THE MULTIPLICATION.
*           IF (JOB < 0 ) THEN WE USE THE AUGMENTED MULTIPLICATION
*           IF (JOB >= 0 ) THEN Y=A*X
*
      SUBROUTINE UXSGMM(N,M,NZA,RNR,PRNR,ORDL,BCOL,A,X,Y,JOB)
      INTEGER N,M,NZA,JOB
      INTEGER RNR(NZA),PRNR(*),ORDL(N),BCOL(M)
      $FLOAT A(NZA),X(*),Y(*)
      $FLOAT ZERO
      INTEGER I,J,K,L
      PARAMETER (ZERO=0.0D0)
C
C     OUTPUT VECTOR INITIALIZATION
C
      DO 100 I=1,MAX(M,N)
      Y(I)=ZERO
100   CONTINUE
C
C     MODIFIED MULTIPLYING
C
      IF(JOB.LT.0) THEN
                   DO 200 I=M+1,N
                   J=ORDL(I)
                   Y(J)=Y(J)+X(I)
200   CONTINUE
      END IF
C
C     MAIN CYCLE
C
      DO 400 I=1,M
      J=BCOL(I)
         DO 300 K=PRNR(J),PRNR(J+1)-1
         L=RNR(K)
         Y(L)=Y(L)+X(I)*A(K)
300      CONTINUE
400   CONTINUE
      RETURN
      END
