* SUBROUTINE UXSRB6               ALL SYSTEMS               91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* TEST OF THE ZERO INTERSECTION OF TWO COLUMNS.
*
*  PARAMETERS :
*  II  NN NUMBER OF VERTICES.
*  II  M NUMBER OF ROWS.
*  II  I FIRST VERTEX.
*  II  J SECOND VERTEX.
*  II  BJA1(NN) BEGINNINGS OF THE BLOCK COLUMNS IN A.
*  II  BJA2(NN) ENDING INDICES OF THE BLOCK COLUMNS IN A.
*  II  MASK1(M) MASKING OF THE NON-ACTIVE PARTS OF THE MATRIX.
*  LO  LDISJ LOGICAL VALUE : .TRUE. FOR THE COLUMNS WITH ZERO
*            INTERSECTION, .FALSE. OTHERWISE.
*
      SUBROUTINE UXSRB6(NN,M,I,J,BJA1,BJA2,MASK1,LDISJ)
C
      INTEGER M,I,J,NN,BJA1(NN),BJA2(NN),MASK1(*)
      INTEGER ISTRT,ISTOP,LEN
      LOGICAL LDISJ
C
C INTERSECTION
C
      ISTRT=MAX(BJA1(I),BJA1(J))
      ISTOP=MIN(BJA2(I),BJA2(J))
C
C COMPUTE REDUCED LENGTH OF THE INTERSECTION
C
      CALL UXSRB2(ISTRT,ISTOP,MASK1,LEN)
C
C SET LDISJ
C
      IF(LEN.EQ.0) THEN
        LDISJ=.TRUE.
      ELSE
        LDISJ=.FALSE.
      ENDIF
      RETURN
      END
