* SUBROUTINE UXSRB8                 ALL SYSTEMS               94/12/01
C PORTABILITY : ALL SYSTEMS
C 94/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* CYCLE OF THE DEGREE UPDATE FOR THE NODES OF RCHSET.
*
*  PARAMETERS :
*  II  NN NUMBER OF VERTICES.
*  IU  BJA1(NN) BEGINNINGS OF THE BLOCK COLUMNS IN A.
*  IU  BJA2(NN) ENDING INDICES OF THE BLOCK COLUMNS IN A.
*  II  RCHSZE SIZE OF THE REACHSET.
*  II  P(NN) WIDTHS OF THE COLUMNS.
*  II  RCHSET(NN) NODES OF THE REACHSET OF NODE.
*
      SUBROUTINE UXSRB8(NN,M,NADJ,BJA1,BJA2,RCHSZE,P,RCHSET,MASK1,
     &                 RCHSZ2,RCHST2,DEG,MARKER,XADJ,ADJNCY,NODE)
C
      INTEGER NN,M,NADJ,NODE,P(NN)
      INTEGER BJA1(NN),BJA2(NN),RCHSZE,RCHSET(NN)
      INTEGER NABOR,ISHIFT
      INTEGER MARKER(NN),RCHSZ2,RCHST2(NN),DEG(NN)
      INTEGER MASK1(NN),XADJ(NN+1)
      INTEGER ADJNCY(NADJ)
      INTEGER I,J,K,LEN,ISTRT,ISTOP,JSTRT,JSTOP,IRCH
      LOGICAL LDISJ
C
C BEG AND END OF THE VERTEX NODE
C
      JSTRT=BJA1(NODE)
      JSTOP=BJA2(NODE)
C
C MAIN CYCLE OF DEGREE CHANGE
C
      DO 10 I=1,RCHSZE
        J=RCHSET(I)
        ISTRT=BJA1(J)
        ISTOP=BJA2(J)
        CALL UXSRB5(M,ISTRT,ISTOP,JSTRT,JSTOP,MASK1,LEN)
        DEG(J)=DEG(J)-LEN*P(NODE)
 10   CONTINUE
      DO 1000 I=1,RCHSZE
        J=RCHSET(I)
C
C FIND REACHSET OF J
C
      RCHSZ2=0
      CALL  UXSRB4(NN,NADJ,J,XADJ,ADJNCY,DEG,MARKER,
     1             RCHSZ2,RCHST2)
C
C TEST INTERSECTION AND EXCLUDE USELESS NODES
C
        ISHIFT=0
        DO 700 K=1,RCHSZ2
          NABOR=RCHST2(K)
          CALL UXSRB6(NN,M,J,NABOR,BJA1,BJA2,MASK1,LDISJ)
C
C IF INTERSECTION IS ZERO - SIGNALLED BY LDISJ - THEN
C NABOR IS EXCLUDED FROM REACHABLE SET
C
          IF(LDISJ) THEN
            ISHIFT=ISHIFT+1
            MARKER(NABOR)=MARKER(NABOR)-2
          ELSE
            RCHST2(K-ISHIFT)=NABOR
          ENDIF
 700    CONTINUE
        RCHSZ2=RCHSZ2-ISHIFT
C
C CYCLE OF THE NODES OF THE REACHABLE SET OF J WHERE DEGREE IS
C UPDATED.
C
        DO 600 IRCH=1,RCHSZ2
          K=RCHST2(IRCH)
          IF(K.EQ.NODE) GO TO 600
          IF(MARKER(K).EQ.3) THEN
            ISTRT=BJA1(J)
            ISTOP=BJA2(J)
            JSTRT=BJA1(K)
            JSTOP=BJA2(K)
            CALL UXSRB5(M,ISTRT,ISTOP,JSTRT,JSTOP,MASK1,LEN)
            DEG(J)=DEG(J)-LEN*P(K)
            MARKER(K)=1
            GO TO 600
          ELSE
            ISTRT=BJA1(J)
            ISTOP=BJA2(J)
            JSTRT=BJA1(K)
            JSTOP=BJA2(K)
            CALL UXSRB5(M,ISTRT,ISTOP,JSTRT,JSTOP,MASK1,LEN)
            DEG(J)=DEG(J)-LEN*P(K)
            ISTRT=BJA1(J)
            ISTOP=BJA2(J)
            JSTRT=BJA1(K)
            JSTOP=BJA2(K)
            CALL UXSRB5(M,JSTRT,JSTOP,ISTRT,ISTOP,MASK1,LEN)
            DEG(K)=DEG(K)-LEN*P(J)
            MARKER(K)=0
          END IF
 600    CONTINUE
 1000 CONTINUE
      RETURN
      END
