* SUBROUTINE UXSRO2                ALL SYSTEMS               91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* UPDATE MASKING VECTOR.
*
*  PARAMETERS :
*  II  M NUMBER OF ROWS OF THE MATRIX.
*  II  BEG(M) ROW INDICES WITH BEGINNINGS OF THE COLUMNS.
*  II  IBEG  FIRST COLUMN BEG OF THE MATRIX.
*  II  MASK1(M) MASK VECTOR.
*  II  IEMASK END OF THE PART TO BE MASKED.
*  II  IBMASK BEGINNING OF THE PART TO BE MASKED.
*
      SUBROUTINE UXSRO2(M,BEG,IBEG,MASK1,IBMASK,IEMASK)
C
      INTEGER M,IBMASK,IEMASK,MASK1(M)
      INTEGER BEG(M),IBEG
      INTEGER I,J,IBOUND,II,IEND,K1
C
C * UPRAVA POLE MASK1 PRI VZNIKU NOVEHO NEAKTIVNIHO BLOKU.
C    IBMASK - ZACATEK NEAKT.BLOKU
C    IEMASK - KONEC NEAKT.BLOKU
C
C IBOUND IS TO BE END OF THE LAST MASKED BLOCK BEFORE IBMASK +1
C
      IBOUND=1
C
      I=IBEG
      II=I
      IF(II.GT.IEMASK) GO TO 100
 50   J=MASK1(I)
      IF(I.LT.IBOUND) GO TO 60
 80   IF(J.GE.IEMASK) THEN
        IEND=-IEMASK
        IF(IEMASK.LT.M) THEN
          IF(J.GT.IEMASK) THEN
            MASK1(IEMASK+1)=J
          ELSE
            IEND=MASK1(J+1)
          END IF
        END IF
        IF(I.LT.IBMASK) THEN
          MASK1(I)=IBMASK-1
          MASK1(IBMASK)=IEND
        ELSEIF(I.GT.IBMASK) THEN
          MASK1(I)=IEND
        ELSE
          MASK1(I)=IEND
        END IF
      ELSEIF(J.LT.IEMASK.AND.J.GE.IBMASK) THEN
C
C THROUGH THE BLOCK
C
 70     J=J+1
        K1=MASK1(J)
        K1=-K1+1
C
C K1 IS ALWAYS BETWEEN IBMASK AND IEMASK
C
        J=MASK1(K1)
        IF(J.LT.IEMASK) GO TO 70
C
        GO TO 80
      ELSEIF(J.LT.IBMASK.AND.J.GT.0) THEN
        I=J+1
        GO TO 50
      ELSEIF(J.LT.0) THEN
        IF(-J+1.GE.IBMASK.AND.-J+1.LE.IEMASK) THEN
C
C THROUGH
C
 90       J=-J+1
          K1=MASK1(J)
          IF(K1.LT.IEMASK) THEN
            J=K1+1
            J=MASK1(J)
            GO TO 90
          ELSEIF(K1.GT.IEMASK) THEN
            MASK1(I)=-IEMASK
            IF(IEMASK.LT.M) THEN
              MASK1(IEMASK+1)=K1
            END IF
          ELSEIF(K1.EQ.IEMASK) THEN
            MASK1(I)=MASK1(K1+1)
          ENDIF
C
        ELSEIF(-J+1.LT.IBMASK) THEN
          I=-J+1
          IBOUND=I
          GO TO 50
        END IF
      END IF
 60   I=BEG(II)
      II=I
      IF(II.GT.IEMASK) GO TO 100
      IF(I.EQ.IBEG) GO TO 100
      GO TO 50
 100  CONTINUE
      RETURN
      END
