* SUBROUTINE  UXSRO4            ALL SYSTEMS               24/03/92
C PORTABILITY : ALL SYSTEMS
C 09/03/92 TU : ORIGINAL VERSION
*
* PURPOSE :  FINDING OF A SEPARATOR. DERIVED FROM SPARSPAK.
*
*  PARAMETERS :
*  II  ROOT THE NODE DETERMINING THE MASKED COMPONENT.
*  II  XADJ(N+1) POINTER VECTOR FOR THE ADJACENCY STRUCTURE.
*  II  ADJNCY(*) ADJACENCY STRUCTURE OF THE INPUT GRAPH.
*  IO  NSEP  NUMBER OF VARIABLES IN THE SEPARATOR.
*  IO  SEP(N)  VECTOR CONTAINING THE SEPARATOR NODES.
*  IU  MASK(N)  NODES IN A SEPARATOR HAVE MASK VALUES SET TO 0.
*        NODES WITH MASK(I)=0 ARE IGNORED.
*  IA  XLS(N+1) POINTER VECTOR FOR THE ROOTED LEVEL STRUCTURE.
*  IA  LS(N) INDICES OF THE ROOTED LEVEL STRUCTURE.
*
      SUBROUTINE UXSRO4(ROOT, XADJ, ADJNCY, MASK, NSEP, SEP,
     *                     XLS , LS , MIDLVL , NLVL)
         INTEGER  ADJNCY(*), LS(*), MASK(*), SEP(*),
     *            XLS(*)   , XADJ(*)
         INTEGER  I     , J     , JSTOP , JSTRT , MIDBEG,
     *            MIDEND, MIDLVL, MP1BEG, MP1END, NBR,
     *            NLVL  , NODE  , NSEP  , ROOT
C
         CALL  UXSRB7 ( ROOT, XADJ, ADJNCY, MASK, NLVL,
     1                  XLS, LS )
C
C IF THE NUMBER OF LEVELS IS LESS THAN 3, RETURN
C THE WHOLE COMPONENT AS THE SEPARATOR.
C
         IF  ( NLVL .GE. 5 )  GO TO 200
             NSEP = XLS(NLVL+1) - 1
             DO  100  I = 1, NSEP
                 NODE = LS(I)
                 SEP(I) = NODE
                 MASK(NODE) = 0
  100        CONTINUE
             MIDLVL = 1
             RETURN
C
  200    CONTINUE
C
C FIND THE MIDDLE LEVEL OF THE ROOTED LEVEL STRUCTURE.
C
         MIDLVL = (NLVL + 2)/2
         MIDBEG = XLS(MIDLVL)
         MP1BEG = XLS(MIDLVL+1)
         MIDEND = MP1BEG - 1
         MP1END = XLS(MIDLVL+2) - 1
C
C THE SEPARATOR IS OBTAINED BY INCLUDING ONLY THOSE
C MIDDLE-LEVEL NODES WITH NEIGHBORS IN THE MIDDLE+1
C LEVEL. XADJ IS USED TEMPORARILY TO MARK THOSE
C NODES IN THE MIDDLE+1 LEVEL.
C
         DO  300  I = MP1BEG, MP1END
             NODE = LS(I)
             XADJ(NODE) = - XADJ(NODE)
  300    CONTINUE
         NSEP = 0
         DO  500  I = MIDBEG, MIDEND
             NODE = LS(I)
             JSTRT = XADJ(NODE)
             JSTOP = IABS(XADJ(NODE+1)) - 1
             DO  400  J = JSTRT, JSTOP
                 NBR = ADJNCY(J)
                 IF  ( XADJ(NBR) .GT. 0 )  GO TO 400
                     NSEP = NSEP + 1
                     SEP(NSEP) = NODE
                     MASK(NODE) = 0
                     GO TO 500
  400        CONTINUE
  500    CONTINUE
C
C RESET XADJ TO ITS CORRECT SIGN.
C
         DO  600  I = MP1BEG, MP1END
             NODE = LS(I)
             XADJ(NODE) = - XADJ(NODE)
  600    CONTINUE
         RETURN
      END
