* SUBROUTINE  UXSRQC               ALL SYSTEMS               92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :  CREATE COLUMN STRUCTURE OF THE MATRIX.
*
*  PARAMETERS :
*  II  M NUMBER OF ROWS OF THE MATRIX.
*  II  N NUMBER OF COLUMNS OF THE MATRIX.
*  II  NJA NUMBER OF NONZEROS MEMBERS IN THE MATRIX.
*  II  IA INDICES OF THE FIRST MEMBERS IN COLUMNS OF THE MATRIX.
*  IU  JA INDICES OF MEMBERS OF THE MATRIX.
*  IU  A VALUES OF NENZEROS MEMBERS.
*  IO  IB INDICES OF THE FIRST MEMBERS IN ROWS OF THE MATRIX.
*  IA  WN01(M) AUXILIARY VECTOR.
*
      SUBROUTINE UXSRQC(M,N,NJA,IA,JA,IB,WN01)
      INTEGER M,N,NJA,IA(N+1),JA(2*NJA),IB(M+1)
      INTEGER WN01(M),I,J,NUM
C   -------------
C   INITIATE WN01
C   -------------
      DO 50 I=1,N
        WN01(I) = 0
   50 CONTINUE
C   --------------------------------------
C   NUMBER OF NONZEROS MEMBERS ON THE ROWS
C   --------------------------------------
      DO 100 I=1, NJA
        WN01(JA(I))=WN01(JA(I)) + 1
  100 CONTINUE
C   --------------------------
C   FIND INDICES TO ARRAY IA
C   --------------------------
      IA(1)=1
      DO 200 I=1,N
        IA(I+1)=IA(I) + WN01(I)
        WN01(I) = 0
  200 CONTINUE
C   --------------------------------------------------------
C   FIND POSITIONS OF NONZEROS MEMBERS ON THE ARRAY JB AND
C   ORDERING OF VALUES ON THE ARRAY B BY ARRAY A.
C   --------------------------------------------------------
      DO 250 I=1,N
        WN01(I)=IA(I) - 1
  250 CONTINUE
      DO 300 I=1,M
        NUM=0
        DO 400 J=IB(I), IB(I+1)-1
          WN01(JA(J)) = WN01(JA(J)) + 1
          JA(NJA+WN01(JA(J))) = I
          NUM = NUM + 1
  400   CONTINUE
  300 CONTINUE
      RETURN
      END
