* SUBROUTINE UXSSMA             ALL SYSTEMS                 88/12/01
C PORTABILITY : ALL SYSTEMS
C 88/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* SPARSE SYMMETRIC MATRIX AUGMENTED BY THE SCALED SPARSE SYMMETRIC
* MATRIX WITH THE SAME STRUCTURE OF NONZERO ELEMENTS.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRICES.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE MATRICES.
*  RI  ALF  SCALING FACTOR.
*  RI  A(M)  NUMERICAL VALUES OF THE INPUT MATRIX.
*  RI  B(M)  NUMERICAL VALUES OF THE INPUT MATRIX.
*  RO  C(M)  NUMERICAL VALUES OF THE OUTPUT MATRIX WHERE C:=B+ALF*A.
*
      SUBROUTINE UXSSMA(N,M,ALF,A,B,C)
      INTEGER N,M
      $FLOAT ALF,A(M),B(M),C(M)
      INTEGER I,J
      J=N
      DO 100 I=1,M
      C(I)=B(I)+ALF*A(I)
100   CONTINUE
      RETURN
      END
