* SUBROUTINE UXSSMD                ALL SYSTEMS                93/12/01
C PORTABILITY : ALL SYSTEMS
C 93/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF A SPARSE SYMMETRIC MATRIX A BY A VECTOR X
* AND ADDITION OF A SCALED VECTOR ALF*Y.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE MATRIX A.
*  RI  A(M) ELEMENTS OF THE SPARSE SYMMETRIC MATRIX STORED IN THE
*      PACKED FORM.
*  II  IA(N)  POINTERS OF THE DIAGONAL ELEMENTS OF A.
*  II  JA(M)  INDICES OF THE NONZERO ELEMENTS OF A.
*  RI  X(N)  INPUT VECTOR.
*  RI  ALF  SCALING FACTOR.
*  RI  Y(N)  INPUT VECTOR.
*  RO  Z(N)  OUTPUT VECTOR EQUAL TO A*X+ALF*Y.
*
      SUBROUTINE UXSSMD(N,M,A,IA,JA,X,ALF,Y,Z)
      INTEGER N,M,IA(N+1),JA(M)
      $FLOAT  A(M),X(N),ALF,Y(N),Z(N)
      $FLOAT ZERO
      INTEGER I,J,K,JSTRT,JSTOP
      PARAMETER   (ZERO = 0.0$P 0)
      DO 100 I=1,N
      Z(I)=ALF*Y(I)
100   CONTINUE
      JSTOP=0
      DO 300 I=1,N
        JSTRT=JSTOP+1
        JSTOP=IA(I+1)-1
        IF (JA(JSTRT).GT.0) THEN
          DO 200 J=JSTRT,JSTOP
            K=JA(J)
            IF(J.EQ.JSTRT) THEN
              Z(I)=Z(I)+A(J)*X(I)
            ELSE IF (K.GT.0) THEN
              Z(K)=Z(K)+A(J)*X(I)
              Z(I)=Z(I)+A(J)*X(K)
            ENDIF
200       CONTINUE
        ENDIF
300   CONTINUE
      RETURN
      END
