* FUNCTION UXSSMQ                  ALL SYSTEMS                92/12/01
C PORTABILITY : ALL SYSTEMS
C 92/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* VALUE OF A QUADRATIC FORM WITH A SPARSE SYMMETRIC MATRIX A.
*
* PARAMETERS :
*  II  N  ORDER OF THE MATRIX A.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE MATRIX A.
*  RI  A(M) ELEMENTS OF THE SPARSE SYMMETRIC MATRIX STORED IN THE
*      PACKED FORM.
*  II  IA(N+1)  POINTERS OF THE DIAGONAL ELEMENTS OF A.
*  II  JA(M)  INDICES OF THE NONZERO ELEMENTS OF A.
*  RI  X(N)  INPUT VECTOR.
*  RI  Y(N)  INPUT VECTOR.
*  RR  UXSSMQ  VALUE OF THE QUADRATIC FORM UXSSMQ=TRANS(Y)*A*X.
*
      FUNCTION UXSSMQ(N,M,A,IA,JA,X,Y)
      INTEGER  N,M,IA(N+1),JA(M)
      $FLOAT  A(M), X(N), Y(N), UXSSMQ
      $FLOAT  TEMP,TEMP1,TEMP2
      INTEGER  I,J,K,JSTRT,JSTOP
      $FLOAT ZERO
      PARAMETER  (ZERO = 0.0$P 0)
      JSTOP=0
      TEMP=ZERO
      DO 300 I=1,N
        JSTRT=JSTOP+1
        JSTOP=IA(I+1)-1
        IF (JA(JSTRT).GT.0) THEN
          TEMP1=ZERO
          TEMP2=ZERO
          DO 200 J=JSTRT,JSTOP
            K=JA(J)
            IF(J.EQ.JSTRT) THEN
              TEMP=TEMP+A(J)*X(I)*Y(I)
            ELSE IF (K.GT.0) THEN
              TEMP1=TEMP1+X(K)*A(J)
              TEMP2=TEMP2+Y(K)*A(J)
            ENDIF
200       CONTINUE
          TEMP=TEMP+Y(I)*TEMP1+X(I)*TEMP2
        ENDIF
300   CONTINUE
      UXSSMQ=TEMP
      RETURN
      END
