* SUBROUTINE UXSTMB                ALL SYSTEMS                86/11/01
C PORTABILITY : ALL SYSTEMS
C 93/01/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* BACKSOLVE WITH THE SPARSE TRIANGULAR MATRIX AND PERMUTED RIGHT-HAND
* SIDE. TRIANGULAR MATRIX IS STORED ROWWISE.
*
* PARAMETERS :
*  II  N ROW ORDER OF THE MATRIX
*  II  NJA LENGTH OF THE VECTORS A,JA
*  II  JA(NJA) VECTOR OF THE ROW INDICES OF THE MATRIX AND OF THE
*         POINTERS - STORED ON OUTPUT OF THE MULTIFRONTAL SOLVER.
*  RI  A(NJA) NUMERICAL ELEMENTS OF THE DECOMPOSED MATRIX.
*  RO  Y(N)  SOLUTION VECTOR.
*  RO  Z(N)  RESTORED RIGHT-HAND SIDE TRANS(Q)*RHS FROM THE
*            MULTIFRONTAL OUTPUT.
*
      SUBROUTINE UXSTMB(N,NJA,JA,A,Y,Z,TOL)
      INTEGER N,NJA,ISTRT,ISTOP,JSTRT,JSTOP,KK
      INTEGER JA(NJA)
      $FLOAT A(NJA),Y(N),Z(N)
      $FLOAT ZERO,TEMP,TEMP1,TOL
      INTEGER I,J,K,L
      PARAMETER (ZERO=0.0$P 0)
C
C     OUTPUT VECTORS INITIATION
C
      DO 100 I=1,N
      Y(I)=ZERO
      Z(I)=ZERO
100   CONTINUE
C
C     MAIN CYCLE
C
      KK=NJA+NJA+N
      ISTRT=JA(KK)
      ISTOP=JA(KK+1)-1
      JSTRT=ISTRT-NJA
      JSTOP=ISTOP-NJA
      KK=KK-1
      DO 400 I=N,1,-1
        TEMP=ZERO
        L=JSTRT
        DO 300 J=ISTRT,ISTOP
          K=JA(J)
C
C     RH SIDE RESTORATION
C
          IF(K.GT.N) THEN
            Z(I)=A(L)
            TEMP=TEMP+A(L)
          ELSEIF(K.GT.I) THEN
            TEMP=TEMP-A(L)*Y(K)
          ELSEIF(K.EQ.I) THEN
            TEMP1=A(L)
          END IF
          L=L+1
 300    CONTINUE
C
C     SOLUTION VECTOR COMPUTATION
C
        IF (TEMP1.EQ.ZERO) TEMP1=TOL
        Y(I)=TEMP/TEMP1
        ISTOP=ISTRT-1
        JSTOP=JSTRT-1
        ISTRT=JA(KK)
        JSTRT=ISTRT-NJA
        KK=KK-1
 400  CONTINUE
      RETURN
      END
