* SUBROUTINE UXTGGB                ALL SYSTEMS                95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* BACK SUBSTITUTION FOR DECOMPOSED TRIDIAGONAL MATRIX.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  D(N) DIAGONAL OF A DECOMPOSED TRIDIAGONAL MATRIX.
*  RI  DL(N) SUBDIAGONAL OF A DECOMPOSED TRIDIAGONAL MATRIX.
*  RI  DU(N) SUPERDIAGONAL OF A DECOMPOSED TRIDIAGONAL MATRIX.
*  RI  DU2(N) SECOND SUPERDIAGONAL OF A DECOMPOSED TRIDIAGONAL MATRIX.
*  II  ID(N)  PERMUTATION VECTOR.
*  RO  B(N) SOLUTION VECTOR.
*
      SUBROUTINE UXTGGB(N,D,DL,DU,DU2,ID,B,JOB)
      INTEGER N,JOB
      INTEGER ID(N)
      $FLOAT B(N),D(N),DL(N),DU(N),DU2(N)
      INTEGER I
      $FLOAT TEMP
      IF (JOB.LE.0) THEN
      DO 1 I=1,N-1
      IF(ID(I).EQ.I) THEN
      B(I+1)=B(I+1)-DL(I)*B(I)
      ELSE
      TEMP=B(I)
      B(I)=B(I+1)
      B(I+1)=TEMP-DL(I)*B(I)
      END IF
    1 CONTINUE
      B(N)=B(N)/D(N)
      IF(N.GT.1) B(N-1)=(B(N-1)-DU(N-1)*B(N))/D(N-1)
      DO 2 I=N-2,1,-1
      B(I)=(B(I)-DU(I)*B(I+1)-DU2(I)*B(I+2))/D(I)
    2 CONTINUE
      ELSE
      B(1)=B(1)/D(1)
      IF (N.GT.1) B(2)=(B(2)-DU(1)*B(1))/D(2)
      DO 3 I=3,N
      B(I)=(B(I)-DU(I-1)*B(I-1)-DU2(I-2)*B(I-2))/D(I)
    3 CONTINUE
      DO 4 I=N-1,1,-1
      IF (ID(I).EQ.I) THEN
      B(I)=B(I)-DL(I)*B(I+1)
      ELSE
      TEMP=B(I+1)
      B(I+1)=B(I)-DL(I)*TEMP
      B(I)=TEMP
      END IF
    4 CONTINUE
      END IF
      RETURN
      END
