* SUBROUTINE UXTGGM                ALL SYSTEMS                95/12/01
C PORTABILITY : ALL SYSTEMS
C 95/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF A GIVEN VECTOR BY A DECOMPOSED TRIDIAGONAL MATRIX.
*
* PARAMETERS :
*  II  N  NUMBER OF VARIABLES.
*  RI  D(N) DIAGONAL OF A DECOMPOSED TRIDIAGONAL MATRIX.
*  RI  DL(N) SUBDIAGONAL OF A DECOMPOSED TRIDIAGONAL MATRIX.
*  RI  DU(N) SUPERDIAGONAL OF A DECOMPOSED TRIDIAGONAL MATRIX.
*  RI  DU2(N) SECOND SUPERDIAGONAL OF A DECOMPOSED TRIDIAGONAL MATRIX.
*  II  ID(N)  PERMUTATION VECTOR.
*  RO  B(N) SOLUTION VECTOR.
*  JOB  OPTION. JOB=0 - MULTIPLICATION BY THE ORIGINAL MATRIX.
*         JOB=1 - MULTIPLICATION BY THE MATRIX TRSANSPOSE.
*
      SUBROUTINE UXTGGM(N,D,DL,DU,DU2,ID,B,JOB)
      INTEGER N,JOB
      INTEGER ID(N)
      $FLOAT B(N),D(N),DL(N),DU(N),DU2(N)
      INTEGER I
      $FLOAT TEMP
      IF (JOB.LE.0) THEN
      DO 1 I=1,N-2
      B(I)=D(I)*B(I)+DU(I)*B(I+1)+DU2(I)*B(I+2)
    1 CONTINUE
      IF(N.GT.1) B(N-1)=D(N-1)*B(N-1)+DU(N-1)*B(N)
      B(N)=D(N)*B(N)
      DO 2 I=N,2,-1
      B(I)=B(I)+DL(I-1)*B(I-1)
    2 CONTINUE
      DO 3 I=1,N-1
      IF(ID(I).NE.I) THEN
      TEMP=B(I)
      B(I)=B(I+1)
      B(I+1)=TEMP
      END IF
    3 CONTINUE
      ELSE
      DO 4 I=1,N-1
      IF(ID(I).EQ.I) THEN
      B(I)=B(I)+DL(I)*B(I+1)
      ELSE
      TEMP=B(I)
      B(I)=B(I+1)+DL(I)*TEMP
      B(I+1)=TEMP
      END IF
    4 CONTINUE
      DO 5 I=N,3,-1
      B(I)=D(I)*B(I)+DU(I-1)*B(I-1)+DU2(I-2)*B(I-2)
    5 CONTINUE
      IF(N.GT.1) B(2)=D(2)*B(2)+DU(1)*B(1)
      B(1)=D(1)*B(1)
      ENDIF
      RETURN
      END
