* SUBROUTINE UXTQEV                ALL SYSTEMS                06/12/01
C PORTABILITY : ALL SYSTEMS
C 06/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COMPUTATION OF THE EIGENVALUES OF A SYMMETRIC TRIDIAGONAL MATRIX
* BY THE QL METHOD.
*
* PARAMETERS :
*  II  N  ORDER OF THE TRIDIAGONAL MATRIX T.
*  RU  D(N)  ON INPUT DIAGONAL ELEMENTS OF THE TRIDIAGONAL MATRIX T.
*         ON OUTPUT EIGENVALUES OF THE TRIDIAGONAL MATRIX T.
*  RU  E(N)  ON INPUT SUBDIAGONAL ELEMENTS OF THE TRIDIAGONAL MATRIX T
*         ON POSITIONS FROM 2 TO N (E(1) IS ARBITRARY).
*  RO  IER  ERROR INDICATOR.
*
      SUBROUTINE UXTQEV(N,D,E,IER)
      INTEGER N,IER
      $FLOAT D(N),E(N)
      INTEGER I,II,J,L,L1,M,MML
      $FLOAT B,C,F,G,H,P,R,S,PARM
      IER=0
      PARM=1.0$P-16
      IF (N.LE.1) RETURN
      DO 102 I=2,N
      E(I-1)=E(I)
  102 CONTINUE
      F=0.0$P 0
      B=0.0$P 0
      E(N)=0.0$P 0
      DO 290 L=1,N
      J=0
      H=PARM*(ABS(D(L))+ABS(E(L)))
      IF (B.LT.H) B=H
      DO 110 M=L,N
      IF (ABS(E(M)).LE.B) GO TO 120
  110 CONTINUE
  120 IF (M.LE.L) GO TO 210
  130 IF (J.GE.30) THEN
      IER=L
      RETURN
      ENDIF
      J=J+1
      L1=L+1
      G=D(L)
      P=(D(L1)-G)/(2.0$P 0*E(L))
      R=SQRT(1.0$P 0+P*P)
      D(L)=E(L)/(P+SIGN(R,P))
      H=G-D(L)
      DO 140 I=L1,N
      D(I)=D(I)-H
  140 CONTINUE
      F=F+H
      P=D(M)
      C=1.0$P 0
      S=0.0$P 0
      MML=M-L
      DO 200 II=1,MML
      I=M-II
      G=C*E(I)
      H=C*P
      IF (ABS(P).GE.ABS(E(I))) THEN
      C=E(I)/P
      R=SQRT(1.0$P 0+C*C)
      E(I+1)=S*P*R
      S=C/R
      C=1.0$P 0/R
      ELSE
      C=P/E(I)
      R=SQRT(1.0$P 0+C*C)
      E(I+1)=S*E(I)*R
      S=1.0$P 0/R
      C=C*S
      ENDIF
      P=C*D(I)-S*G
      D(I+1)=H+S*(C*G+S*D(I))
  200 CONTINUE
      E(L)=S*P
      D(L)=C*P
      IF (ABS(E(L)).GT.B) GO TO 130
  210 P=D(L)+F
      DO 230 II=2,L
      I=L+2-II
      IF (P.GE.D(I-1)) GO TO 270
      D(I)=D(I-1)
  230 CONTINUE
      I=1
  270 D(I)=P
  290 CONTINUE
      RETURN
      END
