* SUBROUTINE UXTSMM                ALL SYSTEMS                10/12/01
C PORTABILITY : ALL SYSTEMS
C 10/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* MULTIPLICATION OF A SYMMETRIC TRIDIAGONAL MATRIX A BY THE VECTOR X.
*
* PARAMETERS :
*  II  N  ORDER OF THE TRIDIAGONAL MATRIX T.
*  RI  D(N)  DIADONAL ELEMENTS OF THE MATRIX T.
*  RI  E(N)  SUBDIAGONAL ELEMENTS OF THE MATRIX T.
*  RI  X(N)  INPUT VECTOR.
*  RO  Z(N)  OUTPUT VECTOR EQUAL TO T*X.
*
      SUBROUTINE UXTSMM(N,D,E,X,Z)
      INTEGER N
      $FLOAT  D(N),E(N),X(N),Z(N)
      INTEGER I
      $FLOAT TEMP,TEMP1
      DO 1 I=1,N
      TEMP=X(I)
      IF (I.EQ.1) THEN
      Z(I)=D(I)*X(I)+E(I)*X(I+1)
      ELSE IF (I.EQ.N) THEN
      Z(I)=E(I-1)*TEMP1+D(I)*X(I)
      ELSE
      Z(I)=E(I-1)*TEMP1+D(I)*X(I)+E(I)*X(I+1)
      ENDIF
      TEMP1=TEMP
    1 CONTINUE
      RETURN
      END
