* SUBROUTINE UXUMUL             ALL SYSTEMS                   99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* VECTOR IS PREMULTIPLIED BY THE POWER OF A DIAGONAL MATRIX IN A BOUND
* CONSTRAINED CASE.
*
* PARAMETERS :
*  II  N  VECTOR DIMENSION.
*  RI  D(N)  DIAGONAL MATRIX STORED AS A VECTOR WITH N ELEMENTS.
*  RI  X(N)  INPUT VECTOR.
*  RO  Y(N)  OUTPUT VECTOR WHERE Y:=(D**K)*X.
*  II  IX(N)  VECTOR CONTAINING TYPES OF BOUNDS.
*  II  JOB  OPTION. IF JOB.GT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).LE.-1. IF JOB.LT.0 THEN INDEX I IS NOT USED WHENEVER
*         IX(I).EQ.-5.
*
      SUBROUTINE UXUMUL(N,D,X,Y,IX,JOB)
      INTEGER N,IX(N),JOB
      $FLOAT D(N),X(N),Y(N)
      INTEGER I
      IF (JOB.EQ.0) THEN
      DO 1 I=1,N
      Y(I)=X(I)*D(I)
    1 CONTINUE
      ELSE IF (JOB.GT.0) THEN
      DO 2 I=1,N
      IF (IX(I).GE. 0) Y(I)=X(I)*D(I)
    2 CONTINUE
      ELSE
      DO 3 I=1,N
      IF (IX(I).NE.-5) Y(I)=X(I)*D(I)
    3 CONTINUE
      ENDIF
      RETURN
      END
