* SUBROUTINE UXVCOL                ALL SYSTEMS                91/12/01
C PORTABILITY : ALL SYSTEMS
C 91/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* SEQUENTIAL GRAPH COLORING.
*
* PARAMETERS :
*  II  MCOLS NUMBER OF INTEGER VALUES OF THE SORTED ARRAY.
*  II  JH(1)  INDICES OF NONZERO ELEMENTS OF A SPARSE
*         SYMMETRIC MATRIX.
*  II  IH(MCOLS+1)  POINTERS OF DIAGONAL ELEMENTS OF A SPARSE
*         SYMMETRIC MATRIX.
*  RI  DEG(MCOLS) VALUES OF THE SORTED ARRAY.
*  RO  ORD(MCOLS) SORTED OUTPUT.
*  RU  RADIX(MCOLS) AUXILIARY ARRAY.
*  IO  COL VECTOR OF COLORS.
*  IA  WN01(MCOLS+1) AUXILIARY VECTOR.
*  II  NCOL NUMBER OF COLORS USED.
*
      SUBROUTINE UXVCOL(MCOLS,JH,IH,DEG,ORD,COL,WN01,NCOL)
      INTEGER MCOLS,IH(MCOLS+1),JH(1),WN01(MCOLS+1)
      INTEGER COL(MCOLS)
      $FLOAT DEG(MCOLS),ORD(MCOLS)
      INTEGER I,L,L1,L2,NCOL,J,JSTRT,JSTOP
C
C COLOR ARRAY INITIALIZE
C
      DO 100 I=1,MCOLS
      COL(I)=0
100   CONTINUE
C
C     FIRST VERTEX COLOURED
C
      NCOL=1
      COL(INT(ORD(1)))=1
C
C     ALL THE REMNANTS ARE COLOURED
C
      DO 200 I=2,MCOLS
      L=ORD(I)
      L1=DEG(L)+1
      IF(I.LT.L1) L1=I
      DO 300 J=1,L1
        WN01(J)=0
300   CONTINUE
C
C     LOOP OF THE COLOUR SEARCH FOR THE VERTEX I
C
      JSTRT=IH(L)
      JSTOP=IH(L+1)-1
      IF(JSTRT.GT.JSTOP) GO TO 450
          DO 400 J=JSTRT,JSTOP
          L2=COL(JH(J))
          IF(L2.NE.0) WN01(L2)=1
400       CONTINUE
450   CONTINUE
C
C THE LEAST POSSIBLE COLOR IS TO BE FOUND
C
      L2=1
500   IF(WN01(L2).NE.0) THEN
      L2=L2+1
      GO TO 500
      END IF
      COL(L)=L2
      IF(NCOL.LT.L2) NCOL=L2
200   CONTINUE
      RETURN
      END
