* SUBROUTINE UXVJOR             ALL SYSTEMS                 02/04/05
C PORTABILITY : ALL SYSTEMS
C 02/04/05 VL : ORIGINAL VERSION
*
* PURPOSE :
*   VECTOR ORTHONORMALIZATION BY JACOBI METHOD FOR 3 VECTORS.
*
* PARAMETERS :
*  II  N  SIZE OF THE VECTORS IN ZZ.
*  RU  ZZ(N*3)  ON INPUT:  ANY 3 NONZERO VECTORS ARRAY.
*               ON OUTPUT: K ORTHONORMAL VECTORS ARRAY.
*  RO  AQ(15)  WORKSPACE ARRAY.
*  IO  K  NUMBER OF INDEPENDENT VECTORS (1-3).
*
* SUBPROGRAMS USED :
*  S   UXVJAC  JACOBI METHOD FOR 3*3 SYMMETRIC MATRICES.
*
      SUBROUTINE UXVJOR(N,ZZ,AQ,K)
      INTEGER N,K,I,J,JN,L,LN,M
      $FLOAT ZZ(N*3),AQ(15),Q,W,Z
      DO 1 I=1,6
      AQ(I)=0.0$P 0
  1   CONTINUE
      DO 2 I=1,N
      Q=ZZ(I)
      W=ZZ(N+I)
      Z=ZZ(N+N+I)
      AQ(1)=AQ(1)+Q*Q
      AQ(2)=AQ(2)+W*W
      AQ(3)=AQ(3)+Z*Z
      AQ(4)=AQ(4)+Q*W
      AQ(5)=AQ(5)+Q*Z
      AQ(6)=AQ(6)+W*Z
  2   CONTINUE
      K=50
      CALL UXVJAC(3,AQ,K)
      DO 3 I=1,N
      Q=ZZ(I)*AQ(7)+ZZ(N+I)*AQ(8)+ZZ(N+N+I)*AQ(9)
      W=ZZ(I)*AQ(10)+ZZ(N+I)*AQ(11)+ZZ(N+N+I)*AQ(12)
      ZZ(N+N+I)=ZZ(I)*AQ(13)+ZZ(N+I)*AQ(14)+ZZ(N+N+I)*AQ(15)
      ZZ(N+I)=W
      ZZ(I)=Q
  3   CONTINUE
      Q=MAX(AQ(1),AQ(2),AQ(3))
      K=0
      M=1
      DO 4 I=1,3
      IF (AQ(I).GT.1.0D-13*Q) K=K+1
      IF (AQ(I).LE.1.0D-13*Q) M=M+2**(3-I)
  4   CONTINUE
      DO 6 J=0,K-1
      L=(M+J+J)**2/(24+J)
      JN=J*N
      LN=JN+L*N
      Q=SQRT(AQ(L+J+1))
      DO 5 I=1,N
      ZZ(JN+I)=ZZ(LN+I)/Q
  5   CONTINUE
C      AQ(J+7)=AQ(L+J+7)*Q
C      AQ(J+10)=AQ(L+J+10)*Q
C      AQ(J+13)=AQ(L+J+13)*Q
  6   CONTINUE
      RETURN
      END
