$INTERFACE UYADC0                                             98/12/01

  CALL UYADC0(NF,N,$X,$IX,$XL,$XU,MOT,INEW)
  $ADD(REAL,'\$X($NF)\$XL($NF)\$XU($NF)')
  $ADD(INTEGER,'\$IX($NX)')
$REM  $ADD(INTEGER,'\NF\N\MOT\INEW')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYADC0                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* NEW SIMPLE BOUNDS ARE ADDED TO THE ACTIVE SET.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  II  MOT  SPECIFICATION OF RESTART AFTER CHANGE OF ACTIVE
*         CONSTRAINTS. MOT=1-RESTART AFTER EACH CHANGE OF ACTIVE
*         CONSTRAINTS. MOT=2-NO RESTART.
*  IO  INEW  NUMBER OF ACTIVE CONSTRAINTS.
*
* SUBPROGRAMS USED :
*  S   UYRES1  DEFINITION OF THE RESTART VARIABLES.
*
      SUBROUTINE UYADC0(NF,N,X,IX,XL,XU,MOT,INEW)
      INTEGER NF,N,IX(NF),MOT,INEW
      $FLOAT  X(NF),XL(NF),XU(NF)
      INTEGER I,II,IXI
      N=NF
      INEW=0
      DO 1 I=1,NF
      II=IX(I)
      IXI=ABS(II)
      IF (IXI.GE.5) THEN
      IX(I)=-IXI
      ELSE IF ((IXI.EQ.1.OR.IXI.EQ.3.OR.IXI.EQ.4).AND.X(I).LE.XL(I))
     & THEN
      X(I)=XL(I)
      IF (IXI.EQ.4) THEN
      IX(I)=-3
      ELSE
      IX(I)=-IXI
      ENDIF
      N=N-1
      IF (II.GT.0) INEW=INEW+1
      ELSE IF ((IXI.EQ.2.OR.IXI.EQ.3.OR.IXI.EQ.4).AND.X(I).GE.XU(I))
     & THEN
      X(I)=XU(I)
      IF (IXI.EQ.3) THEN
      IX(I)=-4
      ELSE
      IX(I)=-IXI
      ENDIF
      N=N-1
      IF (II.GT.0) INEW=INEW+1
      ENDIF
    1 CONTINUE
      IF (INEW.GT.0) THEN
      CALL UOYAD1(0,'UYADC0')
      CALL UOYAD3(NF,N,IX,INEW,0)
      IF (MOT.EQ.1) CALL UYRES1('ADD CONS')
      ENDIF
      RETURN
      END
