$INTERFACE UYCMSA                                             98/12/01

  $IBG='IBG'
  $JBG='JBG'
  $IW='IW'
  CALL UYCMSA(NF,NA,MA,$IAG,$JAG,$IBG,$JBG,$COLA,$IW,JVAR)
  $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)\$COLA($NF)\$IW(6*($NF))')
  $ADD(INTEGER,'\$IBG($NF+1)\$JBG($MA)')
$REM  $ADD(INTEGER,'\NF\NA\MA\JVAR')
  $ADD(INIT)
    NFHX='UYCMSA'
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYCMSA                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* COLEMAN-MORE COLORING ALGORITHM.
*
* PARAMETERS :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  II  NA  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  MA  NUMBER OF NONZERO ELEMENTS OF THE JACOBIAN MATRIX.
*  II  IA(NA+1) ROW POINTERS OF THE SPARSE JACOBIAN MATRIX.
*  II  JA(MA) COLUMN INDICES OF THE SPARSE JACOBIAN MATRIX.
*  II  IB(NF+1) COLUMN POINTERS OF THE SPARSE JACOBIAN MATRIX.
*  II  JB(MA) ROW INDICES OF THE SPARSE JACOBIAN MATRIX.
*  IO  IG(NF) VECTOR DEFINING GROUPS FOR THE JACOBIAN COLUMNS.
*  IA  IW(6*NF)  AUXILIARY VECTOR.
*  IO  JVAR  NUMBER OF GROUPS.
*
      SUBROUTINE UYCMSA(NF,NA,MA,IA,JA,IB,JB,IG,IW,JVAR)
      INTEGER NF,NA,MA,IA(NA+1),JA(MA),IB(NF+1),JB(MA),IG(NF),IW(6*NF),
     & JVAR
      INTEGER I,J,MING,NUMG,MAXG,MAXC
C
C     EXTEND THE DATA STRUCTURE TO ROWS
C
      CALL UXSRSC(NF,NA,MA,IA,JA,IB,JB,IW)
C
C     DETERMINE A LOWER BOUND FOR THE NUMBER OF GROUPS
C
      MING = 0
      DO 50 I = 1, NF
      MING = MAX(MING,IA(I+1)-IA(I))
   50 CONTINUE
C
C     DETERMINE THE DEGREE SEQUENCE FOR THE INTERSECTION
C     GRAPH OF THE COLUMNS OF A
C
      CALL UYSDGR(NF,NA,MA,IA,JA,IB,JB,IW(5*NF+1),IW(NF+1))
C
C     COLOR THE INTERSECTION GRAPH OF THE COLUMNS OF A
C     WITH THE SMALLEST-LAST (SL) ORDERING
C
      CALL UYSSLO(NF,NA,MA,IA,JA,IB,JB,IW(5*NF+1),IW(4*NF+1),IW(1),
     & IW(NF+1),IW(2*NF+1),IW(3*NF+1),MAXC)
      CALL UYSSEQ(NF,NA,MA,IA,JA,IB,JB,IW(4*NF+1),IG,IW(NF+1),MAXG)
      MING = MAX(MING,MAXC)
C
C     EXIT IF THE SMALLEST-LAST ORDERING IS OPTIMAL
C
      IF (MAXG .EQ. MING) GO TO 80
C
C     COLOR THE INTERSECTION GRAPH OF THE COLUMNS OF A
C     WITH THE INCIDENCE-DEGREE (ID) ORDERING
C
      CALL UYSIDO(NF,NA,MA,IA,JA,IB,JB,IW(5*NF+1),IW(4*NF+1),IW(1),
     & IW(NF+1),IW(2*NF+1),IW(3*NF+1),MAXC)
      CALL UYSSEQ(NF,NA,MA,IA,JA,IB,JB,IW(4*NF+1),IW(1),IW(NF+1),NUMG)
      MING = MAX(MING,MAXC)
C
C     RETAIN THE BETTER OF THE TWO ORDERINGS SO FAR
C
      IF (NUMG .LT. MAXG) THEN
      MAXG = NUMG
      DO 60 J = 1, NF
      IG(J) = IW(J)
   60 CONTINUE
C
C     EXIT IF THE INCIDENCE-DEGREE ORDERING IS OPTIMAL
C
      IF (MAXG .EQ. MING) GO TO 80
      END IF
C
C     COLOR THE INTERSECTION GRAPH OF THE COLUMNS OF A
C     WITH THE LARGEST-FIRST (LF) ORDERING
C
      CALL UXVSR1(NF,NF-1,IW(5*NF+1),IW(4*NF+1),IW(2*NF+1),IW(NF+1),-1)
      CALL UYSSEQ(NF,NA,MA,IA,JA,IB,JB,IW(4*NF+1),IW(1),IW(NF+1),NUMG)
C
C     RETAIN THE BEST OF THE THREE ORDERINGS AND EXIT
C
      IF (NUMG .LT. MAXG) THEN
      MAXG = NUMG
      DO 70 J = 1, NF
      IG(J) = IW(J)
   70 CONTINUE
      END IF
   80 JVAR=0
      DO 90 I=1,NF
      JVAR=MAX(JVAR,IG(I))
   90 CONTINUE
      RETURN
      END
