$INTERFACE UYFPS2                                             98/12/01

  $HELP
    TOLERANCE FOR ACTIVE CONSTRAINTS
  $CHECK(EPS9,'1.0$P-8',REAL,4)
  CALL UYFPS2(NF,$X,$IX,$XN,$XL,$XU,$EPS9,INEW)
  $ADD(REAL,'\$X($NF)\$XN($NF)\$XL($NF)\$XU($NF)')
  $ADD(INTEGER,'\$IX($NX)')
$REM  $ADD(INTEGER,'\NF\INEW')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYFPS2                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/01/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* INITIAL POINT IS CHECKED AND SHIFTED TO A FEASIBLE REGION DEFINED
* BY THE SIMPLE BOUNDS FOR VARIABLES.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RI  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  RI  EPS9  TOLERANCE FOR ACTIVE CONSTRAINTS.
*  IO  INEW  INDEX OF THE NEW ACTIVE CONSTRAINT.
*
* COMMON DATA :
*  II  KBF  SPECIFICATION OF SIMPLE BOUNDS. KBF=0-NO SIMPLE BOUNDS.
*         KBF=1-ONE SIDED SIMPLE BOUNDS. KBF=2=TWO SIDED SIMPLE BOUNDS.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
* SUBPROGRAMS USED :
*  S   ULNEWS  IDENTIFICATION OF ACTIVE BOUNDS.
*
      SUBROUTINE UYFPS2(NF,X,IX,XN,XL,XU,EPS9,INEW)
      $INCLUDE('UMCOMM')
      INTEGER NF,IX(NF),INEW
      $FLOAT X(NF),XN(NF),XL(NF),XU(NF),EPS9
      INTEGER I
      IF (KBF.GT.0) THEN
      DO 1 I=1,NF
      IF (IX(I).GE.5) IX(I)=-IX(I)
      IF (IX(I).LE.0) THEN
      ELSEIF ((IX(I).EQ.1.OR.IX(I).EQ.3).AND. X(I).LE.XL(I)+TWO*EPS9)
     & THEN
        X(I)=XL(I)+TWO*EPS9
      ELSEIF ((IX(I).EQ.2.OR.IX(I).EQ.3).AND. X(I).GE.XU(I)-TWO*EPS9)
     & THEN
        X(I)=XU(I)-TWO*EPS9
      ENDIF
      CALL ULNEWS(NF,X,IX,XN,XL,XU,EPS9,NORMF,I,INEW)
      IF (IX(I).GT.10) IX(I)=10-IX(I)
    1 CONTINUE
      ENDIF
      RETURN
      END
