$INTERFACE UYRMC1                                             98/12/01

  $HELP
    TOLERANCE FOR CONSTRAINTS TO BE REMOVED
  $CHECK(EPS8,'1.0$P-3',REAL,4)
  CALL UYRMC1(NF,$X,$IX,$XN,$XL,$XU,$G,$GN,EPS8,UMAX,GMAX,MOT,IOLD)
  $ADD(INTEGER,'\$IX($NX)')
  $ADD(REAL,'\$X($NF)\$XN($NF)\$XL($NF)\$XU($NF)\$G($NF)\$GN($NF)')
  $HELP
    TOLERANCE FOR CONSTRAINTS TO BE REMOVED
  $CHECK(EPS8,'1.0$P-3',REAL,4)
$REM  $ADD(INTEGER,'\NF\MOT\IOLD')
$REM  $ADD(REAL,'\UMAX\GMAX')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYRMC1                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* OLD SIMPLE BOUND IS REMOVED FROM THE ACTIVE SET. TRANSFORMED
* GRADIENT OF THE OBJECTIVE FUNCTION IS UPDATED.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RI  XL(NF)  VECTOR CONTAINING LOWER BOUNDS FOR VARIABLES.
*  RI  XU(NF)  VECTOR CONTAINING UPPER BOUNDS FOR VARIABLES.
*  RI  G(NF)  GRADIENT OF THE OBJECTIVE FUNCTION.
*  RU  GN(NF)  TRANSFORMED GRADIENT OF THE OBJECTIVE FUNCTION.
*  RI  EPS8  TOLERANCE FOR CONSTRAINT TO BE REMOVED.
*  RI  GMAX  NORM OF THE TRANSFORMED GRADIENT.
*  RI  UMAX  MAXIMUN ABSOLUTE VALUE OF THE NEGATIVE LAGRANGE MULTIPLIER.
*  II  MOT  SPECIFICATION OF RESTART AFTER CHANGE OF ACTIVE
*         CONSTRAINTS. MOT=1-RESTART AFTER EACH CHANGE OF ACTIVE
*         CONSTRAINTS. MOT=2-NO RESTART.
*  II  IOLD  NUMBER OF REMOVED CONSTRAINTS.
*
* COMMON DATA :
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
* SUBPROGRAMS USED :
*  S   UYRES1  DEFINITION OF THE RESTART VARIABLES.
*
      SUBROUTINE UYRMC1(NF,X,IX,XN,XL,XU,G,GN,EPS8,UMAX,GMAX,MOT,IOLD)
      $INCLUDE ('UMCOMM')
      INTEGER NF,IX(NF),MOT,IOLD
      $FLOAT X(NF),XN(NF),XL(NF),XU(NF),G(NF),GN(NF),EPS8,UMAX,GMAX
      INTEGER I
      $FLOAT CON
      PARAMETER (CON=1.0D-3)
      IF (UMAX.GE.EPS8*GMAX)  THEN
      CALL UOYRM1(NF,GMAX,UMAX,IOLD,'UYRMC1')
      IOLD=0
      DO 1 I=1,NF
      IF (IX(I).GE.0) THEN
      ELSE IF (IX(I).LE.-5) THEN
      ELSE IF ((IX(I).EQ.-1.OR.IX(I).EQ.-3).AND.X(I).GT.XL(I)+CON*G(I))
     & THEN
      ELSE IF ((IX(I).EQ.-2.OR.IX(I).EQ.-4).AND.X(I).LT.XU(I)+CON*G(I))
     & THEN
      ELSE
      IOLD=IOLD+1
      IX(I)=MIN(ABS(IX(I)),3)
      IF (NORMF.GT.0) THEN
      GN(I)=G(I)*XN(I)
      ELSE
      GN(I)=G(I)
      ENDIF
      ENDIF
    1 CONTINUE
      CALL UOYRM3(NF,NF,IX,0)
      IF(IOLD.GT.1.OR.MOT.EQ.1) CALL UYRES1('REM CONS')
      ENDIF
      RETURN
      END
