$INTERFACE UYTCAB                                             06/12/01

  $SUBST('UYTAUD')
  CALL UYTCAB(NF,NC,MC,$XN,$CG,$CGO,$ICG,$JCG,$CZ,MET5)
  $ADD(REAL,'\$XN($NF)\$CG($MC)\$CGO($MC)\$CZ($NC)')
  $ADD(INTEGER,'\$ICG($NC+1)\$JCG($MC)')
$REM  $ADD(INTEGER,'\NF\NC\MC')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYTCAB             ALL SYSTEMS                   06/12/01
C PORTABILITY : ALL SYSTEMS
C 06/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* VECTORS OF VARIABLES DIFFERENCE AND GRADIENTS DIFFERENCE ARE COMPUTED
* AND SCALED. TEST VALUE DMAX IS DETERMINED.
*
* PARAMETERS :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  II  NC  NUMBER OF APPROXIMATED FUNCTIONS.
*  II  MC  NUMBER OF NONZERO ELEMENTS IN THE FIELD CG.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RI  CG(MC)  JACOBIAN MATRIX OF THE APPROXIMATED FUNCTIONS.
*  RO  CGO(MC)  SAVED JACOBIAN MATRIX OF THE APPROXIMATED FUNCTIONS.
*  RI  ICG(NC+1)  POSITION OF THE FIRST ROWS ELEMENTS IN THE FIELD CG.
*  RI  JCG(MC)  COLUMN INDICES OF ELEMENTS IN THE FIELD CG.
*  RI  CZ(NC)  VECTOR CONTAINING LAGRANGE MULTIPLIERS FOR CONSTRAINTS.
*  II  JOB  SUBJECTS OF UPDATES. JOB=0-CONSTRAINT FUNCTIONS.
*         JOB=1-CONSTRAINT FUNCTIONS MULTIPLIED BY SIGNS OF THE
*         LAGRANGIAN MULTIPLIERS. JOB-2-TERMS OF THE LAGRANGIAN
*         FUNCTION.
*
* COMMON DATA :
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*  II  ITERS  TERMINATION INDICATOR FOR STEPLENGTH DETERMINATION.
*         ITERS=0 FOR ZERO STEP.
*
* SUBPROGRAMS USED :
*  S   UYSET1  DEGREE DEFINITION OF THE COMPUTED DERIVATIVES.
*  S   UXVDIF  DIFFERENCE OF TWO VECTORS.
*  S   UXVSAV  DIFFERENCE OF TWO VECTORS WITH COPYING AND SAVING THE
*         SUBSTRACTED ONE.
*
      SUBROUTINE UYTCAB(NF,NC,MC,XN,CG,CGO,ICG,JCG,CZ,JOB)
      $INCLUDE ('UMCOMM')
      INTEGER NF,NC,MC,ICG(NC+1),JCG(MC),JOB
      $FLOAT XN(NF),CG(MC),CGO(MC),CZ(NC)
      INTEGER J,K,KC,L,M,JP
      $FLOAT TEMP
      IF (ITERS.GT.0) THEN
      CALL UXVDIF(MC,CG,CGO,CGO)
      ELSE
      CALL UXVSAV(MC,CG,CGO)
      ENDIF
      DO 4 KC=1,NC
      M=ICG(KC)
      L=ICG(KC+1)-M
      IF (JOB.GT.0) THEN
      TEMP=CZ(KC)
      IF (JOB.EQ.1) TEMP=SIGN(ONE,TEMP)
      K=M
      DO 2 J=1,L
      CGO(K)=CGO(K)*TEMP
      K=K+1
    2 CONTINUE
      ENDIF
      IF (NORMF.GT.0) THEN
      K=M
      DO 3 J=1,L
      JP=JCG(K)
      CGO(K)=CGO(K)*XN(JP)
      K=K+1
    3 CONTINUE
      ENDIF
    4 CONTINUE
      RETURN
      END
