$INTERFACE UYTRSH                                             98/12/01

  CALL UYTRSH(NF,N,$IX,$XN,$H)
  $ADD(INTEGER,'\$IX($NX)')
  $ADD(REAL,'\$XN($NF)\$H($NF*($NF+1)/2)')
$REM  $ADD(INTEGER,'\NF\N')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYTRSH             ALL SYSTEMS                   98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* HESSIAN MATRIX OF THE OBJECTIVE FUNCTION OR ITS APPROXIMATION
* IS SCALED AND REDUCED.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  II  IX(NF)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RU  H(NF*(NF+1)/2)  HESSIAN MATRIX OR ITS APPROXIMATION.
*
* COMMON DATA :
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*  II  ITERS  TERMINATION INDICATOR FOR STEPLENGTH DETERMINATION.
*         ITERS=0 FOR ZERO STEP.
*  II  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*
* SUBPROGRAMS USED :
*  S   UOFTH1  PRINT OF ENTRY TO TRANSFORMATION OF THE HESSIAN MATRIX
*         OR ITS APPROXIMATION.
*  S   UOFTH2  PRINT OF EXIT FROM TRANSFORMATION OF THE HESSIAN MATRIX
*         OR ITS APPROXIMATION.
*
      SUBROUTINE UYTRSH(NF,N,IX,XN,H)
      $INCLUDE ('UMCOMM')
      INTEGER NF,N,IX(NF)
      $FLOAT XN(NF),H(NF*(NF+1)/2)
      INTEGER I, J, K, L
      IF ( LD.NE.2.OR.ITERS.EQ.0) RETURN
      CALL UOFTH1(NF,NF*(NF+1)/2,H,XN)
      K=0
      L=0
      DO 2 I=1,NF
      DO 1 J=1,I
      K=K+1
      IF(IX(I).LT.0.OR.IX(J).LT.0) GO TO 1
      L=L+1
      IF (NORMF.GT.0) THEN
      H(L)=H(K)*XN(I)*XN(J)
      ELSE
      H(L)=H(K)
      ENDIF
    1 CONTINUE
    2 CONTINUE
      CALL UOFTH2(N*(N+1)/2,H)
      RETURN
      END
