$INTERFACE UYTRUS                                             98/12/01

  CALL UYTRUS(NF,$X,$XN,$XO,$G,$GO,$SN,$S,RO,FP,FO,F,PO,P,CMAX,CMAXO)
  $ADD(REAL,'\$X($NF)\$XN($NF)\$XO($NF)\$G($NF)\$GO($NF)\$SN($NF)&
  \$S($NF)')
$REM  $ADD(REAL,'\RO\FP\FO\F\PO\P\CMAX\CMAXO')
$REM  $ADD(INTEGER,'\NF')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYTRUS                ALL SYSTEMS                98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
* SCALED DIRECTION VECTOR IS BACK TRANSFORMED. VECTORS X,G AND
* VALUES F,P ARE SAVED.
*
* PARAMETERS :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  RI  X(NF)  VECTOR OF VARIABLES.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RO  XO(NF)  SAVED VECTOR OF VARIABLES.
*  RI  G(NF)  GRADIENT OF THE OBJECTIVE FUNCTION.
*  RO  GO(NF)  SAVED GRADIENT OF THE OBJECTIVE FUNCTION.
*  RI  SN(NF)  TRANSFORMED DIRECTION VECTOR.
*  RO  S(NF)  DIRECTION VECTOR.
*  RO  RO  SAVED VALUE OF THE STEPSIZE PARAMETER.
*  RO  FP  PREVIOUS VALUE OF THE OBJECTIVE FUNCTION.
*  RU  FO  SAVED VALUE OF THE OBJECTIVE FUNCTION.
*  RI  F  VALUE OF THE OBJECTIVE FUNCTION.
*  RO  PO  SAVED VALUE OF THE DIRECTIONAL DERIVATIVE.
*  RI  P  VALUE OF THE DIRECTIONAL DERIVATIVE.
*  RO  CMAXO  SAVED VALUE OF THE CONSTRAINT VIOLATION.
*  RI  CMAX  VALUE OF THE CONSTRAINT VIOLATION.
*
* COMMON DATA :
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
* SUBPROGRAMS USED :
*  S   UXVCOP  COPYING OF A VECTOR.
*  S   UXVMUL  DIAGONAL PREMULTIPLICATION OF A VECTOR.
*
      SUBROUTINE UYTRUS(NF,X,XN,XO,G,GO,SN,S,RO,FP,FO,F,PO,P,CMAX,CMAXO)
      $INCLUDE ('UMCOMM')
      INTEGER NF
      $FLOAT X(NF),XN(NF),XO(NF),G(NF),GO(NF),SN(NF),S(NF),RO,FP,FO,F,
     & PO,P,CMAXO,CMAX
      FP = FO
      RO = 0.0$P 0
      FO = F
      PO = P
      CMAXO = CMAX
      CALL UXVCOP(NF,X,XO)
      CALL UXVCOP(NF,G,GO)
      IF (NORMF.GT.0) CALL UXVMUL(NF,XN,SN,S,1)
      RETURN
      END
