$INTERFACE UYTSSG                                             98/12/01

  $HELP
    TOLERANCE FOR ACTIVE CONSTRAINTS
  $CHECK(EPS9,'1.0$P-9',REAL,4)
  $IF(NORMF=0) $GN=G
  CALL UYTSSG(NF,N,M,MCOLS,LINP,$IX,$XL,$XU,$LAM,$BCOL,$XN,$G,$GN,$EPS9&
,UMAX,GMAX)
  $ADD(REAL,'\$XL($MCOLS)\$XU($MCOLS)\$XN($MCOLS)\$G($MCOLS)')
  $ADD(INTEGER,'\$IX($MCOLS)\$BCOL($MCOLS)')
  $ADD(REAL,'\$LAM($MCOLS)\$GN($MCOLS)')
$REM  $ADD(INTEGER,'\NF\N\M\MCOLS\LINP')
$REM  $ADD(REAL,'\UMAX\GMAX')
  $ADD(INIT)
    ITRAN=2
  $ENDADD
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYTSSG             ALL SYSTEMS                   98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
*  GRADIENT OF THE OBJECTIVE FUNCTION IS SCALED AND REDUCED. TEST VALUES
*  GMAX AND UMAX ARE COMPUTED FOR SPARSE LINEARLY CONSTRAINED
*  OPTIMIZATION.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  II  N  ACTUAL NUMBER OF VARIABLES.
*  II  M  NUMBER OF ROWS OF THE PROCESSED CONSTRAINT MATRIX.
*  II  MCOLS DECLARED NUMBER OF VARIABLES.
*  IU  LINP NUMBER OF BASICS AND SUPERBASICS.
*  II  IX(MCOLS)  VECTOR CONTAINING TYPES OF BOUNDS.
*  RI  XL(MCOLS)  VECTOR OF LOWER BOUNDS.
*  RI  XU(MCOLS)  VECTOR OF UPPER BOUNDS.
*  RI  LAM(MCOLS) LAGRANGE MULTIPLIERS.
*  II  BCOL(MCOLS) BASIS MAPPING VECTOR.
*  RI  EPS9  TOLERANCE FOR ACTIVE CONSTRAINTS.
*  RO  UMAX  MAXIMUM ABSOLUTE VALUE OF THE NEGATIVE LAGRANGE MULTIPLIER.
*  RO  GMAX  NORM OF THE TRANSFORMED GRADIENT.
*
* COMMON DATA :
*  II  LIT  NUMBER OF THE FIRST ITERATION.
*  IU  NIT  ACTUAL NUMBER OF ITERATIONS.
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*
      SUBROUTINE UYTSSG(NF,N,M,MCOLS,LINP,IX,XL,XU,LAM,BCOL,XN,G,GN,
     & EPS9,UMAX,GMAX)
      $INCLUDE('UMCOMM')
      INTEGER NF,N,M,MCOLS,LINP,IX(MCOLS),BCOL(MCOLS)
      $FLOAT XL(MCOLS),XU(MCOLS),LAM(MCOLS),XN(MCOLS),G(MCOLS),
     & GN(MCOLS),EPS9,UMAX,GMAX
      $FLOAT MULT,TEMP
      INTEGER I,J,TYPV
      GMAX = 0.0$P 0
      UMAX = 0.0$P 0
      DO 200 I=1,NF
        IF(NORMF.GT.0) THEN
          TEMP=G(I)*XN(I)
        ELSE
          TEMP=G(I)
        ENDIF
        GN(I)=TEMP
 200  CONTINUE
C
C NO TRANSFORMATION OF THE GRADIENT
C REDUCED COSTS ARE TAKEN FROM PRE-PROCESSED VECTOR LAM
C
      DO 300 I=M+1,LINP
      J=BCOL(I)
      MULT=LAM(I)
      TYPV=IX(J)
      IF(TYPV.EQ.5) THEN
        GO TO 300
      ELSEIF(TYPV.EQ.3.OR.TYPV.EQ.4.) THEN
        IF(ABS(XL(J)-XU(J)).LE.EPS9) THEN
          GO TO 300
        END IF
      END IF
C         IF(TYPV.EQ.2.OR.TYPV.EQ.4) THEN
C           MULT=MIN(0.0$P 0,-MULT)
C         ELSEIF(TYPV.EQ.3.OR.TYPV.EQ.1) THEN
C           MULT=MAX(0.0$P 0,-MULT)
C         ELSE
C           MULT=-MULT
C         END IF
C         MULT=ABS(MULT)
C         GMAX=MAX(GMAX,MULT)
C
C     OPRAVA 15.7.2000
C
      GMAX=MAX(GMAX,ABS(MULT))
C
300   CONTINUE
      DO 400 I=LINP+1,N
      J=BCOL(I)
      MULT=LAM(I)
      TYPV=IX(J)
      IF(TYPV.EQ.5) THEN
        GO TO 400
      ELSEIF(TYPV.EQ.3.OR.TYPV.EQ.4.) THEN
        IF(ABS(XL(J)-XU(J)).LE.EPS9) THEN
          GO TO 400
        END IF
      END IF
         IF(TYPV.EQ.2.OR.TYPV.EQ.4) THEN
           MULT=MIN(0.0$P 0,-MULT)
         ELSEIF(TYPV.EQ.3.OR.TYPV.EQ.1) THEN
           MULT=MAX(0.0$P 0,-MULT)
         ELSE
           MULT=-MULT
         END IF
         MULT=ABS(MULT)
         UMAX=MAX(UMAX,MULT)
400   CONTINUE
      IF(NIT.EQ.LIT) THEN
C
C FALSE SETTING TO FORCE JUMP INTO DIRECTION SEARCH ROUTINE
C
        UMAX=1.0$P 0
        GMAX=1.0$P 0
      ENDIF
      RETURN
      END
