$INTERFACE UYTSUH                                             99/12/01

  CALL UYTSUH(NF,$IH(NF+1)-1,$XN,$H,$IH,$JH)
  $ADD(REAL,'\$XN($NF)\$H($M)')
  $ADD(INTEGER,'\$IH($NF+1)\$JH($M)')
$REM  $ADD(INTEGER,'\NF')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYTSUH             ALL SYSTEMS                   99/12/01
C PORTABILITY : ALL SYSTEMS
C 99/12/01 TU : ORIGINAL VERSION
*
* PURPOSE :
* HESSIAN MATRIX OF THE OBJECTIVE FUNCTION OR ITS APPROXIMATION
* IS SCALED.
*
* PARAMETERS :
*  II  NF DECLARED NUMBER OF VARIABLES.
*  II  M  NUMBER OF NONZERO ELEMENTS OF THE MATRIX.
*  RI  XN(NF)  VECTOR OF SCALING FACTORS.
*  RU  H(M)  HESSIAN MATRIX OR ITS APPROXIMATION.
*  II  IH(N+1)  POINTERS OF THE DIAGONAL ELEMENTS OF A.
*  II  JH(M)  INDICES OF THE NONZERO ELEMENTS OF A.
*
* COMMON DATA :
*  II  NORMF  SCALING SPECIFICATION. NORMF=0-NO SCALING IS PERFORMED.
*         NORMF=1-SCALING FACTORS ARE DETERMINED AUTOMATICALLY.
*         NORMF=2-SCALING FACTORS ARE SUPPLIED BY USER.
*  II  ITERS  TERMINATION INDICATOR FOR STEPLENGTH DETERMINATION.
*         ITERS=0 FOR ZERO STEP.
*  II  LD  DEGREE OF PREVIOUSLY COMPUTED DERIVATIVES.
*
* SUBPROGRAMS USED :
*  S   UOFTH1  PRINT OF ENTRY TO TRANSFORMATION OF THE HESSIAN MATRIX
*         OR ITS APPROXIMATION.
*  S   UOFTH2  PRINT OF EXIT FROM TRANSFORMATION OF THE HESSIAN MATRIX
*         OR ITS APPROXIMATION.
*
      SUBROUTINE UYTSUH(NF,M,XN,H,IH,JH)
      $INCLUDE ('UMCOMM')
      INTEGER NF,M,IH(NF+1),JH(M)
      $FLOAT XN(NF),H(M)
      LOGICAL LNORM
      INTEGER I,J,K,JSTRT,JSTOP
      LNORM=NORMF.GT.0.AND.LD.EQ.2.AND.ITERS.NE.0
      IF (.NOT.LNORM.AND.KBF.EQ.0) RETURN
      CALL UOFTH1(NF,M,H,XN)
      JSTOP=0
      DO 300 I=1,NF
        JSTRT=JSTOP+1
        JSTOP=IH(I+1)-1
        IF (JH(JSTRT).GT.0) THEN
          DO 100 J=JSTRT,JSTOP
            K=JH(J)
            IF (K.LT.0) THEN
              H(J)=0.0$P 0
            ELSE IF (LNORM) THEN
              H(J)=H(J)*XN(I)*XN(K)
            ENDIF
100       CONTINUE
        ELSE
          H(JSTRT)=1.0$P 0
           IF (LNORM) H(JSTRT)=XN(I)**2
           DO 200 J=JSTRT+1,JSTOP
             H(J)=0.0$P 0
200        CONTINUE
        ENDIF
300   CONTINUE
      CALL UOFTH2(M,H)
      RETURN
      END
