$INTERFACE UYZER1                                             98/12/01

  CALL UYZER1(NF,$X,$XO,$G,$GO,R,F,FO,P,PO,MOT3)
  $ADD(REAL,'\$X($NF)\$XO($NF)\$G($NF)\$GO($NF)')
$REM  $ADD(REAL,'\R\FO\F\PO\P')
$REM  $ADD(INTEGER,'\NF\MOT3')
  $EXIT

* IMPLEMENTATION

* SUBROUTINE UYZER1             ALL SYSTEMS                   98/12/01
C PORTABILITY : ALL SYSTEMS
C 98/12/01 LU : ORIGINAL VERSION
*
* PURPOSE :
*  BACK SUBSTITUTION AFTER ZERO STEP.
*
* PARAMETERS :
*  II  NF  DECLARED NUMBER OF VARIABLES.
*  RI  X(NF)  NEW VECTOR OF VARIABLES.
*  RI  XO(NF)  OLD VECTOR OF VARIABLES.
*  RI  G(NF)  NEW GRADIENT OF THE OBJECTIVE FUNCTION.
*  RI  GO(NF)  OLD GRADIENT OF THE OBJECTIVE FUNCTION.
*  RO  R  VALUE OF THE STEPSIZE PARAMETER.
*  RO  F  NEW VALUE OF THE OBJECTIVE FUNCTION.
*  RI  FO  OLD VALUE OF THE OBJECTIVE FUNCTION.
*  RO  P  NEW VALUE OF THE DIRECTIONAL DERIVATIVE.
*  RI  PO  OLD VALUE OF THE DIRECTIONAL DERIVATIVE.
*  II  MOT3  CHOICE OF THE VARIABLE METRIC UPDATE AFTER ZERO STEP.
*            MOT3=0-NO UPDATE. MOT3=1-NORMAL UPDATE.
*
* COMMON DATA :
*  IU  IDIR  TRUST REGION INDICATOR. IDIR=0 FOR DESCENT METHODS.
*
* SUBPROGRAMS USED :
*  S   UXVCOP  COPYING OF A VECTOR.
*
      SUBROUTINE UYZER1(NF,X,XO,G,GO,R,F,FO,P,PO,MOT3)
      $INCLUDE('UMCOMM')
      INTEGER NF,MOT3
      $FLOAT X(NF),XO(NF),G(NF),GO(NF),R,F,FO,P,PO
      IF (IDIR.EQ.0.OR.MOT3.LE.0) THEN
      R=0.0$P 0
      F=FO
      P=PO
      CALL UXVCOP(NF,XO,X)
      CALL UXVCOP(NF,GO,G)
      ENDIF
      RETURN
      END
